/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the X86 target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 150;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(X86InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(X86InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static X86InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static X86InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(1),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s80,
  GILLT_s128,
  GILLT_v2s1,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s16,
  GILLT_v8s32,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
  GILLT_v16s16,
  GILLT_v16s32,
  GILLT_v32s1,
  GILLT_v32s8,
  GILLT_v32s16,
  GILLT_v64s1,
  GILLT_v64s8,
};
const static size_t NumTypeObjects = 25;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(80),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 32),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(16), 16),
  LLT::vector(ElementCount::getFixed(16), 32),
  LLT::vector(ElementCount::getFixed(32), 1),
  LLT::vector(ElementCount::getFixed(32), 8),
  LLT::vector(ElementCount::getFixed(32), 16),
  LLT::vector(ElementCount::getFixed(64), 1),
  LLT::vector(ElementCount::getFixed(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_TruePredicateBit = 61,
  Feature_HasEGPRBit = 5,
  Feature_NoEGPRBit = 4,
  Feature_HasNDDBit = 6,
  Feature_NoNDDBit = 27,
  Feature_HasZUBit = 149,
  Feature_HasCFBit = 30,
  Feature_HasCMOVBit = 29,
  Feature_NoCMOVBit = 135,
  Feature_HasMMXBit = 107,
  Feature_HasSSE1Bit = 47,
  Feature_UseSSE1Bit = 54,
  Feature_HasSSE2Bit = 46,
  Feature_UseSSE2Bit = 55,
  Feature_HasSSE3Bit = 38,
  Feature_UseSSE3Bit = 64,
  Feature_HasSSSE3Bit = 108,
  Feature_UseSSSE3Bit = 65,
  Feature_UseSSE41Bit = 62,
  Feature_UseSSE42Bit = 69,
  Feature_HasSSE4ABit = 79,
  Feature_NoAVXBit = 75,
  Feature_HasAVXBit = 56,
  Feature_HasAVX2Bit = 50,
  Feature_HasAVX1OnlyBit = 48,
  Feature_HasEVEX512Bit = 142,
  Feature_HasAVX10_2Bit = 106,
  Feature_HasAVX10_2_512Bit = 105,
  Feature_NoAVX10_2Bit = 68,
  Feature_HasAVX512Bit = 92,
  Feature_UseAVXBit = 52,
  Feature_NoAVX512Bit = 43,
  Feature_HasCDIBit = 96,
  Feature_HasVPOPCNTDQBit = 100,
  Feature_HasDQIBit = 94,
  Feature_NoDQIBit = 66,
  Feature_HasBWIBit = 95,
  Feature_NoBWIBit = 63,
  Feature_HasVLXBit = 93,
  Feature_NoVLXBit = 42,
  Feature_NoVLX_Or_NoBWIBit = 60,
  Feature_HasVNNIBit = 102,
  Feature_HasVP2INTERSECTBit = 104,
  Feature_HasFP16Bit = 98,
  Feature_HasAVXVNNIINT16Bit = 91,
  Feature_HasAVXVNNIINT8Bit = 86,
  Feature_HasAVXVNNIBit = 80,
  Feature_NoVLX_Or_NoVNNIBit = 81,
  Feature_HasBITALGBit = 103,
  Feature_HasPOPCNTBit = 67,
  Feature_HasAESBit = 72,
  Feature_HasVAESBit = 74,
  Feature_NoVLX_Or_NoVAESBit = 73,
  Feature_HasFXSRBit = 39,
  Feature_HasX87Bit = 37,
  Feature_HasXSAVEBit = 124,
  Feature_HasXSAVEOPTBit = 125,
  Feature_HasXSAVECBit = 126,
  Feature_HasXSAVESBit = 127,
  Feature_HasPCLMULBit = 76,
  Feature_NoVLX_Or_NoVPCLMULQDQBit = 77,
  Feature_HasVPCLMULQDQBit = 78,
  Feature_HasGFNIBit = 83,
  Feature_HasFMABit = 40,
  Feature_HasFMA4Bit = 44,
  Feature_NoFMA4Bit = 41,
  Feature_HasXOPBit = 45,
  Feature_HasTBMBit = 26,
  Feature_NoTBMBit = 140,
  Feature_HasLWPBit = 12,
  Feature_HasMOVBEBit = 3,
  Feature_NoNDD_Or_NoMOVBEBit = 2,
  Feature_HasRDRANDBit = 7,
  Feature_HasF16CBit = 82,
  Feature_HasFSGSBaseBit = 128,
  Feature_HasLZCNTBit = 9,
  Feature_HasBMIBit = 10,
  Feature_HasBMI2Bit = 11,
  Feature_NoBMI2Bit = 139,
  Feature_HasVBMIBit = 97,
  Feature_HasVBMI2Bit = 101,
  Feature_HasIFMABit = 99,
  Feature_HasAVXIFMABit = 84,
  Feature_NoVLX_Or_NoIFMABit = 85,
  Feature_HasRTMBit = 110,
  Feature_HasSHABit = 71,
  Feature_HasSHA512Bit = 88,
  Feature_HasSM3Bit = 89,
  Feature_HasRDSEEDBit = 8,
  Feature_HasSSEPrefetchBit = 57,
  Feature_HasPREFETCHIBit = 20,
  Feature_HasPrefetchWBit = 109,
  Feature_HasMWAITXBit = 138,
  Feature_HasCLDEMOTEBit = 24,
  Feature_HasMOVDIRIBit = 14,
  Feature_HasMOVDIR64BBit = 15,
  Feature_HasMOVRSBit = 25,
  Feature_HasPTWRITEBit = 131,
  Feature_FPStackf32Bit = 35,
  Feature_FPStackf64Bit = 36,
  Feature_HasSM4Bit = 90,
  Feature_HasCLFLUSHBit = 58,
  Feature_HasCLFLUSHOPTBit = 22,
  Feature_HasCLWBBit = 23,
  Feature_HasWBNOINVDBit = 123,
  Feature_HasRDPIDBit = 130,
  Feature_HasWAITPKGBit = 13,
  Feature_HasINVPCIDBit = 129,
  Feature_HasCX8Bit = 136,
  Feature_HasCX16Bit = 137,
  Feature_HasENQCMDBit = 16,
  Feature_HasAMXFP16Bit = 115,
  Feature_HasCMPCCXADDBit = 21,
  Feature_HasAVXNECONVERTBit = 87,
  Feature_HasKLBit = 111,
  Feature_HasRAOINTBit = 121,
  Feature_HasSERIALIZEBit = 17,
  Feature_HasTSXLDTRKBit = 18,
  Feature_HasAMXTILEBit = 112,
  Feature_HasAMXBF16Bit = 114,
  Feature_HasAMXINT8Bit = 113,
  Feature_HasAMXCOMPLEXBit = 116,
  Feature_HasAMXFP8Bit = 117,
  Feature_HasAMXTRANSPOSEBit = 118,
  Feature_HasAMXAVX512Bit = 119,
  Feature_HasAMXTF32Bit = 120,
  Feature_HasUINTRBit = 19,
  Feature_HasUSERMSRBit = 122,
  Feature_HasCRC32Bit = 70,
  Feature_Not64BitModeBit = 0,
  Feature_In64BitModeBit = 1,
  Feature_IsLP64Bit = 133,
  Feature_NotLP64Bit = 132,
  Feature_NotWin64WithoutFPBit = 134,
  Feature_IsPSBit = 144,
  Feature_NotPSBit = 143,
  Feature_KernelCodeBit = 145,
  Feature_NearDataBit = 147,
  Feature_IsNotPICBit = 146,
  Feature_OptForSizeBit = 51,
  Feature_OptForMinSizeBit = 49,
  Feature_OptForSpeedBit = 141,
  Feature_UseIncDecBit = 28,
  Feature_NoSSE41_Or_OptForSizeBit = 53,
  Feature_CallImmAddrBit = 148,
  Feature_FavorMemIndirectCallBit = 31,
  Feature_HasFastSHLDRotateBit = 34,
  Feature_HasMFenceBit = 59,
  Feature_UseIndirectThunkCallsBit = 33,
  Feature_NotUseIndirectThunkCallsBit = 32,
};

PredicateBitset X86InstructionSelector::
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (true)
    Features.set(Feature_TruePredicateBit);
  if (Subtarget->hasEGPR())
    Features.set(Feature_HasEGPRBit);
  if (!Subtarget->hasEGPR())
    Features.set(Feature_NoEGPRBit);
  if (Subtarget->hasNDD())
    Features.set(Feature_HasNDDBit);
  if (!Subtarget->hasNDD())
    Features.set(Feature_NoNDDBit);
  if (Subtarget->hasZU())
    Features.set(Feature_HasZUBit);
  if (Subtarget->hasCF())
    Features.set(Feature_HasCFBit);
  if (Subtarget->canUseCMOV())
    Features.set(Feature_HasCMOVBit);
  if (!Subtarget->canUseCMOV())
    Features.set(Feature_NoCMOVBit);
  if (Subtarget->hasMMX())
    Features.set(Feature_HasMMXBit);
  if (Subtarget->hasSSE1())
    Features.set(Feature_HasSSE1Bit);
  if (Subtarget->hasSSE1() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE1Bit);
  if (Subtarget->hasSSE2())
    Features.set(Feature_HasSSE2Bit);
  if (Subtarget->hasSSE2() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE2Bit);
  if (Subtarget->hasSSE3())
    Features.set(Feature_HasSSE3Bit);
  if (Subtarget->hasSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE3Bit);
  if (Subtarget->hasSSSE3())
    Features.set(Feature_HasSSSE3Bit);
  if (Subtarget->hasSSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSSE3Bit);
  if (Subtarget->hasSSE41() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE41Bit);
  if (Subtarget->hasSSE42() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE42Bit);
  if (Subtarget->hasSSE4A())
    Features.set(Feature_HasSSE4ABit);
  if (!Subtarget->hasAVX())
    Features.set(Feature_NoAVXBit);
  if (Subtarget->hasAVX())
    Features.set(Feature_HasAVXBit);
  if (Subtarget->hasAVX2())
    Features.set(Feature_HasAVX2Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX2())
    Features.set(Feature_HasAVX1OnlyBit);
  if (Subtarget->hasEVEX512())
    Features.set(Feature_HasEVEX512Bit);
  if (Subtarget->hasAVX10_2())
    Features.set(Feature_HasAVX10_2Bit);
  if (Subtarget->hasAVX10_2_512())
    Features.set(Feature_HasAVX10_2_512Bit);
  if (!Subtarget->hasAVX10_2())
    Features.set(Feature_NoAVX10_2Bit);
  if (Subtarget->hasAVX512())
    Features.set(Feature_HasAVX512Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX512())
    Features.set(Feature_UseAVXBit);
  if (!Subtarget->hasAVX512())
    Features.set(Feature_NoAVX512Bit);
  if (Subtarget->hasCDI())
    Features.set(Feature_HasCDIBit);
  if (Subtarget->hasVPOPCNTDQ())
    Features.set(Feature_HasVPOPCNTDQBit);
  if (Subtarget->hasDQI())
    Features.set(Feature_HasDQIBit);
  if (!Subtarget->hasDQI())
    Features.set(Feature_NoDQIBit);
  if (Subtarget->hasBWI())
    Features.set(Feature_HasBWIBit);
  if (!Subtarget->hasBWI())
    Features.set(Feature_NoBWIBit);
  if (Subtarget->hasVLX())
    Features.set(Feature_HasVLXBit);
  if (!Subtarget->hasVLX())
    Features.set(Feature_NoVLXBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasBWI())
    Features.set(Feature_NoVLX_Or_NoBWIBit);
  if (Subtarget->hasVNNI())
    Features.set(Feature_HasVNNIBit);
  if (Subtarget->hasVP2INTERSECT())
    Features.set(Feature_HasVP2INTERSECTBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasAVXVNNIINT16())
    Features.set(Feature_HasAVXVNNIINT16Bit);
  if (Subtarget->hasAVXVNNIINT8())
    Features.set(Feature_HasAVXVNNIINT8Bit);
  if (Subtarget->hasAVXVNNI())
    Features.set(Feature_HasAVXVNNIBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVNNI())
    Features.set(Feature_NoVLX_Or_NoVNNIBit);
  if (Subtarget->hasBITALG())
    Features.set(Feature_HasBITALGBit);
  if (Subtarget->hasPOPCNT())
    Features.set(Feature_HasPOPCNTBit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasVAES())
    Features.set(Feature_HasVAESBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVAES())
    Features.set(Feature_NoVLX_Or_NoVAESBit);
  if (Subtarget->hasFXSR())
    Features.set(Feature_HasFXSRBit);
  if (Subtarget->hasX87())
    Features.set(Feature_HasX87Bit);
  if (Subtarget->hasXSAVE())
    Features.set(Feature_HasXSAVEBit);
  if (Subtarget->hasXSAVEOPT())
    Features.set(Feature_HasXSAVEOPTBit);
  if (Subtarget->hasXSAVEC())
    Features.set(Feature_HasXSAVECBit);
  if (Subtarget->hasXSAVES())
    Features.set(Feature_HasXSAVESBit);
  if (Subtarget->hasPCLMUL())
    Features.set(Feature_HasPCLMULBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_NoVLX_Or_NoVPCLMULQDQBit);
  if (Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_HasVPCLMULQDQBit);
  if (Subtarget->hasGFNI())
    Features.set(Feature_HasGFNIBit);
  if (Subtarget->hasFMA())
    Features.set(Feature_HasFMABit);
  if (Subtarget->hasFMA4())
    Features.set(Feature_HasFMA4Bit);
  if (!Subtarget->hasFMA4())
    Features.set(Feature_NoFMA4Bit);
  if (Subtarget->hasXOP())
    Features.set(Feature_HasXOPBit);
  if (Subtarget->hasTBM())
    Features.set(Feature_HasTBMBit);
  if (!Subtarget->hasTBM())
    Features.set(Feature_NoTBMBit);
  if (Subtarget->hasLWP())
    Features.set(Feature_HasLWPBit);
  if (Subtarget->hasMOVBE())
    Features.set(Feature_HasMOVBEBit);
  if (!Subtarget->hasNDD() || !Subtarget->hasMOVBE())
    Features.set(Feature_NoNDD_Or_NoMOVBEBit);
  if (Subtarget->hasRDRAND())
    Features.set(Feature_HasRDRANDBit);
  if (Subtarget->hasF16C())
    Features.set(Feature_HasF16CBit);
  if (Subtarget->hasFSGSBase())
    Features.set(Feature_HasFSGSBaseBit);
  if (Subtarget->hasLZCNT())
    Features.set(Feature_HasLZCNTBit);
  if (Subtarget->hasBMI())
    Features.set(Feature_HasBMIBit);
  if (Subtarget->hasBMI2())
    Features.set(Feature_HasBMI2Bit);
  if (!Subtarget->hasBMI2())
    Features.set(Feature_NoBMI2Bit);
  if (Subtarget->hasVBMI())
    Features.set(Feature_HasVBMIBit);
  if (Subtarget->hasVBMI2())
    Features.set(Feature_HasVBMI2Bit);
  if (Subtarget->hasIFMA())
    Features.set(Feature_HasIFMABit);
  if (Subtarget->hasAVXIFMA())
    Features.set(Feature_HasAVXIFMABit);
  if (!Subtarget->hasVLX() || !Subtarget->hasIFMA())
    Features.set(Feature_NoVLX_Or_NoIFMABit);
  if (Subtarget->hasRTM())
    Features.set(Feature_HasRTMBit);
  if (Subtarget->hasSHA())
    Features.set(Feature_HasSHABit);
  if (Subtarget->hasSHA512())
    Features.set(Feature_HasSHA512Bit);
  if (Subtarget->hasSM3())
    Features.set(Feature_HasSM3Bit);
  if (Subtarget->hasRDSEED())
    Features.set(Feature_HasRDSEEDBit);
  if (Subtarget->hasSSEPrefetch())
    Features.set(Feature_HasSSEPrefetchBit);
  if (Subtarget->hasPREFETCHI())
    Features.set(Feature_HasPREFETCHIBit);
  if (Subtarget->hasPrefetchW())
    Features.set(Feature_HasPrefetchWBit);
  if (Subtarget->hasMWAITX())
    Features.set(Feature_HasMWAITXBit);
  if (Subtarget->hasCLDEMOTE())
    Features.set(Feature_HasCLDEMOTEBit);
  if (Subtarget->hasMOVDIRI())
    Features.set(Feature_HasMOVDIRIBit);
  if (Subtarget->hasMOVDIR64B())
    Features.set(Feature_HasMOVDIR64BBit);
  if (Subtarget->hasMOVRS())
    Features.set(Feature_HasMOVRSBit);
  if (Subtarget->hasPTWRITE())
    Features.set(Feature_HasPTWRITEBit);
  if (!Subtarget->hasSSE1())
    Features.set(Feature_FPStackf32Bit);
  if (!Subtarget->hasSSE2())
    Features.set(Feature_FPStackf64Bit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasCLFLUSH())
    Features.set(Feature_HasCLFLUSHBit);
  if (Subtarget->hasCLFLUSHOPT())
    Features.set(Feature_HasCLFLUSHOPTBit);
  if (Subtarget->hasCLWB())
    Features.set(Feature_HasCLWBBit);
  if (Subtarget->hasWBNOINVD())
    Features.set(Feature_HasWBNOINVDBit);
  if (Subtarget->hasRDPID())
    Features.set(Feature_HasRDPIDBit);
  if (Subtarget->hasWAITPKG())
    Features.set(Feature_HasWAITPKGBit);
  if (Subtarget->hasINVPCID())
    Features.set(Feature_HasINVPCIDBit);
  if (Subtarget->hasCX8())
    Features.set(Feature_HasCX8Bit);
  if (Subtarget->hasCX16())
    Features.set(Feature_HasCX16Bit);
  if (Subtarget->hasENQCMD())
    Features.set(Feature_HasENQCMDBit);
  if (Subtarget->hasAMXFP16())
    Features.set(Feature_HasAMXFP16Bit);
  if (Subtarget->hasCMPCCXADD())
    Features.set(Feature_HasCMPCCXADDBit);
  if (Subtarget->hasAVXNECONVERT())
    Features.set(Feature_HasAVXNECONVERTBit);
  if (Subtarget->hasKL())
    Features.set(Feature_HasKLBit);
  if (Subtarget->hasRAOINT())
    Features.set(Feature_HasRAOINTBit);
  if (Subtarget->hasSERIALIZE())
    Features.set(Feature_HasSERIALIZEBit);
  if (Subtarget->hasTSXLDTRK())
    Features.set(Feature_HasTSXLDTRKBit);
  if (Subtarget->hasAMXTILE())
    Features.set(Feature_HasAMXTILEBit);
  if (Subtarget->hasAMXBF16())
    Features.set(Feature_HasAMXBF16Bit);
  if (Subtarget->hasAMXINT8())
    Features.set(Feature_HasAMXINT8Bit);
  if (Subtarget->hasAMXCOMPLEX())
    Features.set(Feature_HasAMXCOMPLEXBit);
  if (Subtarget->hasAMXFP8())
    Features.set(Feature_HasAMXFP8Bit);
  if (Subtarget->hasAMXTRANSPOSE())
    Features.set(Feature_HasAMXTRANSPOSEBit);
  if (Subtarget->hasAMXAVX512())
    Features.set(Feature_HasAMXAVX512Bit);
  if (Subtarget->hasAMXTF32())
    Features.set(Feature_HasAMXTF32Bit);
  if (Subtarget->hasUINTR())
    Features.set(Feature_HasUINTRBit);
  if (Subtarget->hasUSERMSR())
    Features.set(Feature_HasUSERMSRBit);
  if (Subtarget->hasCRC32())
    Features.set(Feature_HasCRC32Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_Not64BitModeBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->isTarget64BitLP64())
    Features.set(Feature_IsLP64Bit);
  if (!Subtarget->isTarget64BitLP64())
    Features.set(Feature_NotLP64Bit);
  if (Subtarget->isTargetPS())
    Features.set(Feature_IsPSBit);
  if (!Subtarget->isTargetPS())
    Features.set(Feature_NotPSBit);
  if (TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_KernelCodeBit);
  if (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_NearDataBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->isLegalToCallImmediateAddr())
    Features.set(Feature_CallImmAddrBit);
  if (!Subtarget->slowTwoMemOps())
    Features.set(Feature_FavorMemIndirectCallBit);
  if (Subtarget->hasFastSHLDRotate())
    Features.set(Feature_HasFastSHLDRotateBit);
  if (Subtarget->hasMFence())
    Features.set(Feature_HasMFenceBit);
  if (Subtarget->useIndirectThunkCalls())
    Features.set(Feature_UseIndirectThunkCallsBit);
  if (!Subtarget->useIndirectThunkCalls())
    Features.set(Feature_NotUseIndirectThunkCallsBit);
  return Features;
}

void X86InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const X86Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset X86InstructionSelector::
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!Subtarget->isTargetWin64() ||Subtarget->getFrameLowering()->hasFP(*MF))
    Features.set(Feature_NotWin64WithoutFPBit);
  if (shouldOptForSize(MF))
    Features.set(Feature_OptForSizeBit);
  if (MF->getFunction().hasMinSize())
    Features.set(Feature_OptForMinSizeBit);
  if (!shouldOptForSize(MF))
    Features.set(Feature_OptForSpeedBit);
  if (!Subtarget->slowIncDec() || shouldOptForSize(MF))
    Features.set(Feature_UseIncDecBit);
  if (shouldOptForSize(MF) || !Subtarget->hasSSE41())
    Features.set(Feature_NoSSE41_Or_OptForSizeBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_FPStackf32,
  GIFBS_FPStackf64,
  GIFBS_HasAVX,
  GIFBS_HasAVX1Only,
  GIFBS_HasAVX2,
  GIFBS_HasAVX512,
  GIFBS_HasAVXNECONVERT,
  GIFBS_HasBITALG,
  GIFBS_HasBMI,
  GIFBS_HasBWI,
  GIFBS_HasCDI,
  GIFBS_HasCLDEMOTE,
  GIFBS_HasCLFLUSH,
  GIFBS_HasCLFLUSHOPT,
  GIFBS_HasCLWB,
  GIFBS_HasDQI,
  GIFBS_HasFP16,
  GIFBS_HasFXSR,
  GIFBS_HasFastSHLDRotate,
  GIFBS_HasKL,
  GIFBS_HasLWP,
  GIFBS_HasLZCNT,
  GIFBS_HasMFence,
  GIFBS_HasMMX,
  GIFBS_HasMOVBE,
  GIFBS_HasMOVRS,
  GIFBS_HasMWAITX,
  GIFBS_HasNDD,
  GIFBS_HasPOPCNT,
  GIFBS_HasPTWRITE,
  GIFBS_HasPrefetchW,
  GIFBS_HasRTM,
  GIFBS_HasSERIALIZE,
  GIFBS_HasSHA,
  GIFBS_HasSHA512,
  GIFBS_HasSM3,
  GIFBS_HasSM4,
  GIFBS_HasSSE1,
  GIFBS_HasSSE2,
  GIFBS_HasSSE3,
  GIFBS_HasSSE4A,
  GIFBS_HasSSEPrefetch,
  GIFBS_HasTBM,
  GIFBS_HasTSXLDTRK,
  GIFBS_HasVBMI2,
  GIFBS_HasVLX,
  GIFBS_HasVPOPCNTDQ,
  GIFBS_HasWAITPKG,
  GIFBS_HasWBNOINVD,
  GIFBS_HasX87,
  GIFBS_HasXOP,
  GIFBS_HasXSAVE,
  GIFBS_HasXSAVEC,
  GIFBS_HasXSAVEOPT,
  GIFBS_HasXSAVES,
  GIFBS_HasZU,
  GIFBS_In64BitMode,
  GIFBS_IsPS,
  GIFBS_NoAVX,
  GIFBS_NoDQI,
  GIFBS_NoEGPR,
  GIFBS_NoNDD,
  GIFBS_NoNDD_Or_NoMOVBE,
  GIFBS_Not64BitMode,
  GIFBS_NotPS,
  GIFBS_UseAVX,
  GIFBS_UseIncDec,
  GIFBS_UseSSE1,
  GIFBS_UseSSE2,
  GIFBS_UseSSE3,
  GIFBS_UseSSE41,
  GIFBS_UseSSSE3,
  GIFBS_HasAES_HasAVX,
  GIFBS_HasAES_NoAVX,
  GIFBS_HasAMXBF16_In64BitMode,
  GIFBS_HasAMXCOMPLEX_In64BitMode,
  GIFBS_HasAMXFP16_In64BitMode,
  GIFBS_HasAMXFP8_In64BitMode,
  GIFBS_HasAMXINT8_In64BitMode,
  GIFBS_HasAMXTF32_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode,
  GIFBS_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAVX_In64BitMode,
  GIFBS_HasAVX_NoBWI,
  GIFBS_HasAVX_NoVLX,
  GIFBS_HasAVX_NoVLX_Or_NoBWI,
  GIFBS_HasAVX10_2_HasSM4,
  GIFBS_HasAVX10_2_512_HasSM4,
  GIFBS_HasAVX2_NoVLX,
  GIFBS_HasAVX2_NoVLX_Or_NoBWI,
  GIFBS_HasAVX512_HasVAES,
  GIFBS_HasAVX512_HasVLX,
  GIFBS_HasAVX512_HasVPCLMULQDQ,
  GIFBS_HasAVX512_NoBWI,
  GIFBS_HasAVX512_NoDQI,
  GIFBS_HasAVX512_NoEGPR,
  GIFBS_HasAVX512_OptForSize,
  GIFBS_HasBITALG_HasVLX,
  GIFBS_HasBMI_HasEGPR,
  GIFBS_HasBMI_NoEGPR,
  GIFBS_HasBMI2_HasEGPR,
  GIFBS_HasBMI2_NoEGPR,
  GIFBS_HasBWI_HasVLX,
  GIFBS_HasBWI_NoEGPR,
  GIFBS_HasCDI_HasVLX,
  GIFBS_HasCRC32_NoEGPR,
  GIFBS_HasDQI_HasVLX,
  GIFBS_HasDQI_NoBWI,
  GIFBS_HasDQI_NoEGPR,
  GIFBS_HasEGPR_HasINVPCID,
  GIFBS_HasEGPR_In64BitMode,
  GIFBS_HasEVEX512_NoVLX,
  GIFBS_HasFMA4_NoAVX512,
  GIFBS_HasFMA4_NoVLX,
  GIFBS_HasFP16_HasVLX,
  GIFBS_HasFP16_In64BitMode,
  GIFBS_HasFP16_OptForSize,
  GIFBS_HasFSGSBase_In64BitMode,
  GIFBS_HasFXSR_In64BitMode,
  GIFBS_HasINVPCID_NoEGPR,
  GIFBS_HasINVPCID_Not64BitMode,
  GIFBS_HasMOVBE_NoEGPR,
  GIFBS_HasMOVDIR64B_NoEGPR,
  GIFBS_HasMOVDIRI_NoEGPR,
  GIFBS_HasNDD_In64BitMode,
  GIFBS_HasNDD_UseIncDec,
  GIFBS_HasPCLMUL_NoAVX,
  GIFBS_HasPREFETCHI_In64BitMode,
  GIFBS_HasPTWRITE_In64BitMode,
  GIFBS_HasRDPID_In64BitMode,
  GIFBS_HasRDPID_Not64BitMode,
  GIFBS_HasUINTR_In64BitMode,
  GIFBS_HasUSERMSR_NoEGPR,
  GIFBS_HasVAES_HasVLX,
  GIFBS_HasVAES_NoVLX,
  GIFBS_HasVBMI2_HasVLX,
  GIFBS_HasVLX_HasVPCLMULQDQ,
  GIFBS_HasVLX_HasVPOPCNTDQ,
  GIFBS_HasVPCLMULQDQ_NoVLX,
  GIFBS_HasWAITPKG_In64BitMode,
  GIFBS_HasWAITPKG_Not64BitMode,
  GIFBS_HasXSAVE_In64BitMode,
  GIFBS_HasXSAVEC_In64BitMode,
  GIFBS_HasXSAVEOPT_In64BitMode,
  GIFBS_HasXSAVES_In64BitMode,
  GIFBS_In64BitMode_UseIncDec,
  GIFBS_In64BitMode_UseSSE2,
  GIFBS_NoNDD_UseIncDec,
  GIFBS_Not64BitMode_OptForSize,
  GIFBS_NotWin64WithoutFP_OptForMinSize,
  GIFBS_OptForSize_UseAVX,
  GIFBS_OptForSize_UseSSE1,
  GIFBS_OptForSize_UseSSE2,
  GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES,
  GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode,
  GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTILE_HasEGPR_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode_NoEGPR,
  GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ,
  GIFBS_HasAVX10_2_HasMOVRS_In64BitMode,
  GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode,
  GIFBS_HasAVX512_HasEGPR_In64BitMode,
  GIFBS_HasAVX512_HasEVEX512_NoVLX,
  GIFBS_HasBITALG_HasEVEX512_NoVLX,
  GIFBS_HasBWI_HasEGPR_In64BitMode,
  GIFBS_HasBWI_HasEVEX512_NoVLX,
  GIFBS_HasCDI_HasEVEX512_NoVLX,
  GIFBS_HasCRC32_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEVEX512_NoVLX,
  GIFBS_HasDQI_HasVLX_NoBWI,
  GIFBS_HasEGPR_HasMOVBE_In64BitMode,
  GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode,
  GIFBS_HasEGPR_HasMOVDIRI_In64BitMode,
  GIFBS_HasEGPR_HasMOVRS_In64BitMode,
  GIFBS_HasEGPR_HasUSERMSR_In64BitMode,
  GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX,
  GIFBS_HasFMA_NoAVX512_NoFMA4,
  GIFBS_HasFMA_NoFMA4_NoVLX,
  GIFBS_HasMOVBE_HasNDD_In64BitMode,
  GIFBS_HasMOVDIR64B_In64BitMode_NoEGPR,
  GIFBS_HasMOVDIRI_In64BitMode_NoEGPR,
  GIFBS_HasMOVRS_In64BitMode_NoEGPR,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_FPStackf32Bit, },
  {Feature_FPStackf64Bit, },
  {Feature_HasAVXBit, },
  {Feature_HasAVX1OnlyBit, },
  {Feature_HasAVX2Bit, },
  {Feature_HasAVX512Bit, },
  {Feature_HasAVXNECONVERTBit, },
  {Feature_HasBITALGBit, },
  {Feature_HasBMIBit, },
  {Feature_HasBWIBit, },
  {Feature_HasCDIBit, },
  {Feature_HasCLDEMOTEBit, },
  {Feature_HasCLFLUSHBit, },
  {Feature_HasCLFLUSHOPTBit, },
  {Feature_HasCLWBBit, },
  {Feature_HasDQIBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFXSRBit, },
  {Feature_HasFastSHLDRotateBit, },
  {Feature_HasKLBit, },
  {Feature_HasLWPBit, },
  {Feature_HasLZCNTBit, },
  {Feature_HasMFenceBit, },
  {Feature_HasMMXBit, },
  {Feature_HasMOVBEBit, },
  {Feature_HasMOVRSBit, },
  {Feature_HasMWAITXBit, },
  {Feature_HasNDDBit, },
  {Feature_HasPOPCNTBit, },
  {Feature_HasPTWRITEBit, },
  {Feature_HasPrefetchWBit, },
  {Feature_HasRTMBit, },
  {Feature_HasSERIALIZEBit, },
  {Feature_HasSHABit, },
  {Feature_HasSHA512Bit, },
  {Feature_HasSM3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSSE1Bit, },
  {Feature_HasSSE2Bit, },
  {Feature_HasSSE3Bit, },
  {Feature_HasSSE4ABit, },
  {Feature_HasSSEPrefetchBit, },
  {Feature_HasTBMBit, },
  {Feature_HasTSXLDTRKBit, },
  {Feature_HasVBMI2Bit, },
  {Feature_HasVLXBit, },
  {Feature_HasVPOPCNTDQBit, },
  {Feature_HasWAITPKGBit, },
  {Feature_HasWBNOINVDBit, },
  {Feature_HasX87Bit, },
  {Feature_HasXOPBit, },
  {Feature_HasXSAVEBit, },
  {Feature_HasXSAVECBit, },
  {Feature_HasXSAVEOPTBit, },
  {Feature_HasXSAVESBit, },
  {Feature_HasZUBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsPSBit, },
  {Feature_NoAVXBit, },
  {Feature_NoDQIBit, },
  {Feature_NoEGPRBit, },
  {Feature_NoNDDBit, },
  {Feature_NoNDD_Or_NoMOVBEBit, },
  {Feature_Not64BitModeBit, },
  {Feature_NotPSBit, },
  {Feature_UseAVXBit, },
  {Feature_UseIncDecBit, },
  {Feature_UseSSE1Bit, },
  {Feature_UseSSE2Bit, },
  {Feature_UseSSE3Bit, },
  {Feature_UseSSE41Bit, },
  {Feature_UseSSSE3Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, },
  {Feature_HasAESBit, Feature_NoAVXBit, },
  {Feature_HasAMXBF16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXINT8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_NoBWIBit, },
  {Feature_HasAVXBit, Feature_NoVLXBit, },
  {Feature_HasAVXBit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX10_2Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX2Bit, Feature_NoVLXBit, },
  {Feature_HasAVX2Bit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_HasVAESBit, },
  {Feature_HasAVX512Bit, Feature_HasVLXBit, },
  {Feature_HasAVX512Bit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasAVX512Bit, Feature_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_NoDQIBit, },
  {Feature_HasAVX512Bit, Feature_NoEGPRBit, },
  {Feature_HasAVX512Bit, Feature_OptForSizeBit, },
  {Feature_HasBITALGBit, Feature_HasVLXBit, },
  {Feature_HasBMIBit, Feature_HasEGPRBit, },
  {Feature_HasBMIBit, Feature_NoEGPRBit, },
  {Feature_HasBMI2Bit, Feature_HasEGPRBit, },
  {Feature_HasBMI2Bit, Feature_NoEGPRBit, },
  {Feature_HasBWIBit, Feature_HasVLXBit, },
  {Feature_HasBWIBit, Feature_NoEGPRBit, },
  {Feature_HasCDIBit, Feature_HasVLXBit, },
  {Feature_HasCRC32Bit, Feature_NoEGPRBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, },
  {Feature_HasDQIBit, Feature_NoBWIBit, },
  {Feature_HasDQIBit, Feature_NoEGPRBit, },
  {Feature_HasEGPRBit, Feature_HasINVPCIDBit, },
  {Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasFMA4Bit, Feature_NoAVX512Bit, },
  {Feature_HasFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasFP16Bit, Feature_HasVLXBit, },
  {Feature_HasFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasFP16Bit, Feature_OptForSizeBit, },
  {Feature_HasFSGSBaseBit, Feature_In64BitModeBit, },
  {Feature_HasFXSRBit, Feature_In64BitModeBit, },
  {Feature_HasINVPCIDBit, Feature_NoEGPRBit, },
  {Feature_HasINVPCIDBit, Feature_Not64BitModeBit, },
  {Feature_HasMOVBEBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIR64BBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIRIBit, Feature_NoEGPRBit, },
  {Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasNDDBit, Feature_UseIncDecBit, },
  {Feature_HasPCLMULBit, Feature_NoAVXBit, },
  {Feature_HasPREFETCHIBit, Feature_In64BitModeBit, },
  {Feature_HasPTWRITEBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_Not64BitModeBit, },
  {Feature_HasUINTRBit, Feature_In64BitModeBit, },
  {Feature_HasUSERMSRBit, Feature_NoEGPRBit, },
  {Feature_HasVAESBit, Feature_HasVLXBit, },
  {Feature_HasVAESBit, Feature_NoVLXBit, },
  {Feature_HasVBMI2Bit, Feature_HasVLXBit, },
  {Feature_HasVLXBit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasVLXBit, Feature_HasVPOPCNTDQBit, },
  {Feature_HasVPCLMULQDQBit, Feature_NoVLXBit, },
  {Feature_HasWAITPKGBit, Feature_In64BitModeBit, },
  {Feature_HasWAITPKGBit, Feature_Not64BitModeBit, },
  {Feature_HasXSAVEBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVECBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVEOPTBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVESBit, Feature_In64BitModeBit, },
  {Feature_In64BitModeBit, Feature_UseIncDecBit, },
  {Feature_In64BitModeBit, Feature_UseSSE2Bit, },
  {Feature_NoNDDBit, Feature_UseIncDecBit, },
  {Feature_Not64BitModeBit, Feature_OptForSizeBit, },
  {Feature_NotWin64WithoutFPBit, Feature_OptForMinSizeBit, },
  {Feature_OptForSizeBit, Feature_UseAVXBit, },
  {Feature_OptForSizeBit, Feature_UseSSE1Bit, },
  {Feature_OptForSizeBit, Feature_UseSSE2Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, Feature_NoVLX_Or_NoVAESBit, },
  {Feature_HasAMXAVX512Bit, Feature_HasAVX10_2_512Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXBF16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasAVXBit, Feature_HasPCLMULBit, Feature_NoVLX_Or_NoVPCLMULQDQBit, },
  {Feature_HasAVX10_2Bit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasAVX512Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasAVX512Bit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBITALGBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBWIBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasBWIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCDIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCRC32Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, Feature_NoBWIBit, },
  {Feature_HasEGPRBit, Feature_HasMOVBEBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVDIR64BBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVDIRIBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasUSERMSRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_HasVPOPCNTDQBit, Feature_NoVLXBit, },
  {Feature_HasFMABit, Feature_NoAVX512Bit, Feature_NoFMA4Bit, },
  {Feature_HasFMABit, Feature_NoFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasMOVBEBit, Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasMOVDIR64BBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIRIBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasMOVRSBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addr,
};
// See constructor for table contents

X86InstructionSelector::ComplexMatcherMemFn
X86InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &X86InstructionSelector::selectAddr, // gi_addr
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_alignedload = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_alignedstore,
  GICXXPred_MI_Predicate_imm_su,
  GICXXPred_MI_Predicate_loadi8,
  GICXXPred_MI_Predicate_loadi16,
  GICXXPred_MI_Predicate_loadi32,
};
bool X86InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_alignedload: {
    
        auto &LdSt = cast<GLoadStore>(MI);
        return LdSt.getAlign() >= LdSt.getMemSize().getValue();
      
    llvm_unreachable("alignedload should have returned");
  }
  case GICXXPred_MI_Predicate_alignedstore: {
    
        auto &LdSt = cast<GLoadStore>(MI);
        return LdSt.getAlign() >= LdSt.getMemSize().getValue();
      
    llvm_unreachable("alignedstore should have returned");
  }
  case GICXXPred_MI_Predicate_imm_su: {
     return true; 
  }
  case GICXXPred_MI_Predicate_loadi8: {
     return isa<GLoad>(MI); 
  }
  case GICXXPred_MI_Predicate_loadi16: {
    
        auto &Load = cast<GLoad>(MI);
        LLT Ty = MRI.getType(Load.getDstReg());
        // Non extending load has MMO and destination types of the same size
        if (Load.getMemSizeInBits() == Ty.getSizeInBits())
           return true;
        return Load.getAlign() >= 2 && Load.isSimple();
      
    llvm_unreachable("loadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_loadi32: {
    
        auto &Load = cast<GLoad>(MI);
        LLT Ty = MRI.getType(Load.getDstReg());
        // Non extending load has MMO and destination types of the same size
        if (Load.getMemSizeInBits() == Ty.getSizeInBits())
           return true;
        return Load.getAlign() >= 4 && Load.isSimple();
      
    llvm_unreachable("loadi32 should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AndMask64 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BTCBTSMask64,
  GICXXPred_I64_Predicate_BTRMask64,
  GICXXPred_I64_Predicate_i16immSExt8,
  GICXXPred_I64_Predicate_i32immSExt8,
  GICXXPred_I64_Predicate_i64immSExt8,
  GICXXPred_I64_Predicate_i64immSExt32,
  GICXXPred_I64_Predicate_i64immZExt32,
  GICXXPred_I64_Predicate_i64immZExt32SExt8,
  GICXXPred_I64_Predicate_i64timmSExt32,
  GICXXPred_I64_Predicate_immff00_ffff,
};
bool X86InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AndMask64: {
    
      return isMask_64(Imm) && !isUInt<32>(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTCBTSMask64: {
    
      return !isInt<32>(Imm) && isPowerOf2_64(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTRMask64: {
    
      return !isUInt<32>(Imm) && !isInt<32>(Imm) && isPowerOf2_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_i16immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32: {
     return isUInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32SExt8: {
    
      return isUInt<32>(Imm) && isInt<8>(static_cast<int32_t>(Imm));
    
  }
  case GICXXPred_I64_Predicate_i64timmSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_immff00_ffff: {
    
      return Imm >= 0xff00 && Imm <= 0xffff;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm1,
  GICXXPred_APFloat_Predicate_fpimmneg0,
  GICXXPred_APFloat_Predicate_fpimmneg1,
};
bool X86InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm1: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg1: {
    
      return Imm.isExactlyValue(-1.0);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool X86InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool X86InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("X86InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
X86InstructionSelector::CustomRendererFn
X86InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool X86InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool X86InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("X86InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *X86InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(289), /*)*//*default:*//*Label 77*/ GIMT_Encode4(229156),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(954),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(7187),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(10723), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(14506),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(25098),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(33502), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 6*/ GIMT_Encode4(46203), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 7*/ GIMT_Encode4(46370), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 8*/ GIMT_Encode4(48660),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 9*/ GIMT_Encode4(51838), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 10*/ GIMT_Encode4(53058),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 11*/ GIMT_Encode4(59283),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 12*/ GIMT_Encode4(59616), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 13*/ GIMT_Encode4(60271), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 14*/ GIMT_Encode4(85734),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 15*/ GIMT_Encode4(85970), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    298 */ /*TargetOpcode::G_PREFETCH*//*Label 16*/ GIMT_Encode4(86218), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 17*/ GIMT_Encode4(86537),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 18*/ GIMT_Encode4(100363), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 19*/ GIMT_Encode4(109438),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 20*/ GIMT_Encode4(109873),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 21*/ GIMT_Encode4(110962),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 22*/ GIMT_Encode4(111568), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 23*/ GIMT_Encode4(112021),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 24*/ GIMT_Encode4(113693),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 25*/ GIMT_Encode4(113935),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 26*/ GIMT_Encode4(115919),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 27*/ GIMT_Encode4(118203),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 28*/ GIMT_Encode4(120247),
     /*    378 */ /*TargetOpcode::G_FSHL*//*Label 29*/ GIMT_Encode4(122291),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 30*/ GIMT_Encode4(123019),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 31*/ GIMT_Encode4(123707),
     /*    390 */ /*TargetOpcode::G_ROTL*//*Label 32*/ GIMT_Encode4(127205),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 33*/ GIMT_Encode4(130925), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 34*/ GIMT_Encode4(132582), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 35*/ GIMT_Encode4(140248),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 36*/ GIMT_Encode4(141113),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 37*/ GIMT_Encode4(141978),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 38*/ GIMT_Encode4(143664),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 39*/ GIMT_Encode4(145350),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 40*/ GIMT_Encode4(146416), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 41*/ GIMT_Encode4(147482),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 42*/ GIMT_Encode4(152632),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 43*/ GIMT_Encode4(156050),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 44*/ GIMT_Encode4(161200), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 45*/ GIMT_Encode4(167188), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 46*/ GIMT_Encode4(170606),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 47*/ GIMT_Encode4(170729),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 48*/ GIMT_Encode4(171661),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 49*/ GIMT_Encode4(172047),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 50*/ GIMT_Encode4(173428),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 51*/ GIMT_Encode4(173984),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 52*/ GIMT_Encode4(177360), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 53*/ GIMT_Encode4(179607), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    694 */ /*TargetOpcode::G_SMIN*//*Label 54*/ GIMT_Encode4(179730),
     /*    698 */ /*TargetOpcode::G_SMAX*//*Label 55*/ GIMT_Encode4(183051),
     /*    702 */ /*TargetOpcode::G_UMIN*//*Label 56*/ GIMT_Encode4(186372),
     /*    706 */ /*TargetOpcode::G_UMAX*//*Label 57*/ GIMT_Encode4(189693),
     /*    710 */ /*TargetOpcode::G_ABS*//*Label 58*/ GIMT_Encode4(193014), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    722 */ /*TargetOpcode::G_BR*//*Label 59*/ GIMT_Encode4(194895), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    738 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 60*/ GIMT_Encode4(194911), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_VECTOR_COMPRESS*//*Label 61*/ GIMT_Encode4(197840),
     /*    766 */ /*TargetOpcode::G_CTTZ*//*Label 62*/ GIMT_Encode4(199822),
     /*    770 */ /*TargetOpcode::G_CTTZ_ZERO_UNDEF*//*Label 63*/ GIMT_Encode4(200128),
     /*    774 */ /*TargetOpcode::G_CTLZ*//*Label 64*/ GIMT_Encode4(200515), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTPOP*//*Label 65*/ GIMT_Encode4(201819),
     /*    786 */ /*TargetOpcode::G_BSWAP*//*Label 66*/ GIMT_Encode4(204081), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    842 */ /*TargetOpcode::G_FSQRT*//*Label 67*/ GIMT_Encode4(204581), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    882 */ /*TargetOpcode::G_STRICT_FADD*//*Label 68*/ GIMT_Encode4(206750),
     /*    886 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 69*/ GIMT_Encode4(210916),
     /*    890 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 70*/ GIMT_Encode4(213842),
     /*    894 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 71*/ GIMT_Encode4(218008), GIMT_Encode4(0),
     /*    902 */ /*TargetOpcode::G_STRICT_FMA*//*Label 72*/ GIMT_Encode4(220934),
     /*    906 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 73*/ GIMT_Encode4(226922), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    942 */ /*TargetOpcode::G_TRAP*//*Label 74*/ GIMT_Encode4(229091),
     /*    946 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 75*/ GIMT_Encode4(229104),
     /*    950 */ /*TargetOpcode::G_UBSANTRAP*//*Label 76*/ GIMT_Encode4(229140),
     /*    954 */ // Label 0: @954
     /*    954 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 94*/ GIMT_Encode4(7186),
     /*    965 */ /*GILLT_s8*//*Label 78*/ GIMT_Encode4(1061),
     /*    969 */ /*GILLT_s16*//*Label 79*/ GIMT_Encode4(1566),
     /*    973 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(2216),
     /*    977 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(2866), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    993 */ /*GILLT_v2s64*//*Label 82*/ GIMT_Encode4(3690), GIMT_Encode4(0),
     /*   1001 */ /*GILLT_v4s32*//*Label 83*/ GIMT_Encode4(4032),
     /*   1005 */ /*GILLT_v4s64*//*Label 84*/ GIMT_Encode4(4496), GIMT_Encode4(0),
     /*   1013 */ /*GILLT_v8s16*//*Label 85*/ GIMT_Encode4(4811),
     /*   1017 */ /*GILLT_v8s32*//*Label 86*/ GIMT_Encode4(5275),
     /*   1021 */ /*GILLT_v8s64*//*Label 87*/ GIMT_Encode4(5590), GIMT_Encode4(0),
     /*   1029 */ /*GILLT_v16s8*//*Label 88*/ GIMT_Encode4(5746),
     /*   1033 */ /*GILLT_v16s16*//*Label 89*/ GIMT_Encode4(6088),
     /*   1037 */ /*GILLT_v16s32*//*Label 90*/ GIMT_Encode4(6403), GIMT_Encode4(0),
     /*   1045 */ /*GILLT_v32s8*//*Label 91*/ GIMT_Encode4(6559),
     /*   1049 */ /*GILLT_v32s16*//*Label 92*/ GIMT_Encode4(6874), GIMT_Encode4(0),
     /*   1057 */ /*GILLT_v64s8*//*Label 93*/ GIMT_Encode4(7030),
     /*   1061 */ // Label 78: @1061
     /*   1061 */ GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1565),
     /*   1066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*   1069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*   1072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1076 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1137), // Rule ID 26051 //
     /*   1081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1092 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1095 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1099 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1116 */     // (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (ADD8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm),
     /*   1119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1121 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1123 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1135 */     GIR_RootConstrainSelectedInstOperands,
     /*   1136 */     // GIR_Coverage, 26051,
     /*   1136 */     GIR_EraseRootFromParent_Done,
     /*   1137 */   // Label 96: @1137
     /*   1137 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1198), // Rule ID 26070 //
     /*   1142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1153 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1156 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1160 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1177 */     // (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (ADD8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm_ND),
     /*   1180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1182 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1196 */     GIR_RootConstrainSelectedInstOperands,
     /*   1197 */     // GIR_Coverage, 26070,
     /*   1197 */     GIR_EraseRootFromParent_Done,
     /*   1198 */   // Label 97: @1198
     /*   1198 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1259), // Rule ID 22793 //
     /*   1203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1218 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1221 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1225 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1238 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (ADD8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm),
     /*   1241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1257 */     GIR_RootConstrainSelectedInstOperands,
     /*   1258 */     // GIR_Coverage, 22793,
     /*   1258 */     GIR_EraseRootFromParent_Done,
     /*   1259 */   // Label 98: @1259
     /*   1259 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1320), // Rule ID 22883 //
     /*   1264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1279 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1282 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1286 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1299 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (ADD8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm_ND),
     /*   1302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1304 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1310 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1318 */     GIR_RootConstrainSelectedInstOperands,
     /*   1319 */     // GIR_Coverage, 22883,
     /*   1319 */     GIR_EraseRootFromParent_Done,
     /*   1320 */   // Label 99: @1320
     /*   1320 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1348), // Rule ID 22859 //
     /*   1325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1336 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r),
     /*   1339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1341 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1346 */     GIR_RootConstrainSelectedInstOperands,
     /*   1347 */     // GIR_Coverage, 22859,
     /*   1347 */     GIR_EraseRootFromParent_Done,
     /*   1348 */   // Label 100: @1348
     /*   1348 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1376), // Rule ID 22863 //
     /*   1353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   1364 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r),
     /*   1367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1369 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1374 */     GIR_RootConstrainSelectedInstOperands,
     /*   1375 */     // GIR_Coverage, 22863,
     /*   1375 */     GIR_EraseRootFromParent_Done,
     /*   1376 */   // Label 101: @1376
     /*   1376 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1404), // Rule ID 22949 //
     /*   1381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   1384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1392 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r_ND),
     /*   1395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1397 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1402 */     GIR_RootConstrainSelectedInstOperands,
     /*   1403 */     // GIR_Coverage, 22949,
     /*   1403 */     GIR_EraseRootFromParent_Done,
     /*   1404 */   // Label 102: @1404
     /*   1404 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1432), // Rule ID 22953 //
     /*   1409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   1412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   1420 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r_ND),
     /*   1423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1425 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1430 */     GIR_RootConstrainSelectedInstOperands,
     /*   1431 */     // GIR_Coverage, 22953,
     /*   1431 */     GIR_EraseRootFromParent_Done,
     /*   1432 */   // Label 103: @1432
     /*   1432 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1469), // Rule ID 22797 //
     /*   1437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1452 */     // MIs[1] Operand 1
     /*   1452 */     // No operand predicates
     /*   1452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1454 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   1454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*   1457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   1464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1467 */     GIR_RootConstrainSelectedInstOperands,
     /*   1468 */     // GIR_Coverage, 22797,
     /*   1468 */     GIR_EraseRootFromParent_Done,
     /*   1469 */   // Label 104: @1469
     /*   1469 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1506), // Rule ID 22887 //
     /*   1474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1489 */     // MIs[1] Operand 1
     /*   1489 */     // No operand predicates
     /*   1489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1491 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   1491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri_ND),
     /*   1494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1496 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   1501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1504 */     GIR_RootConstrainSelectedInstOperands,
     /*   1505 */     // GIR_Coverage, 22887,
     /*   1505 */     GIR_EraseRootFromParent_Done,
     /*   1506 */   // Label 105: @1506
     /*   1506 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1535), // Rule ID 22789 //
     /*   1511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1522 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   1522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /*   1527 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   1533 */     GIR_RootConstrainSelectedInstOperands,
     /*   1534 */     // GIR_Coverage, 22789,
     /*   1534 */     GIR_Done,
     /*   1535 */   // Label 106: @1535
     /*   1535 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1564), // Rule ID 22879 //
     /*   1540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1551 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   1551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /*   1556 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   1562 */     GIR_RootConstrainSelectedInstOperands,
     /*   1563 */     // GIR_Coverage, 22879,
     /*   1563 */     GIR_Done,
     /*   1564 */   // Label 107: @1564
     /*   1564 */   GIM_Reject,
     /*   1565 */ // Label 95: @1565
     /*   1565 */ GIM_Reject,
     /*   1566 */ // Label 79: @1566
     /*   1566 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2215),
     /*   1571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   1574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*   1577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1581 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1650), // Rule ID 22614 //
     /*   1586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1597 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1600 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1604 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1608 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   1619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1628 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:{ *:[i16] })  =>  (SUB16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i16] })
     /*   1628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi_ND),
     /*   1631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   1637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   1640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1648 */     GIR_RootConstrainSelectedInstOperands,
     /*   1649 */     // GIR_Coverage, 22614,
     /*   1649 */     GIR_EraseRootFromParent_Done,
     /*   1650 */   // Label 109: @1650
     /*   1650 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1711), // Rule ID 26052 //
     /*   1655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1669 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1673 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1690 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (ADD16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm),
     /*   1693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1709 */     GIR_RootConstrainSelectedInstOperands,
     /*   1710 */     // GIR_Coverage, 26052,
     /*   1710 */     GIR_EraseRootFromParent_Done,
     /*   1711 */   // Label 110: @1711
     /*   1711 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1772), // Rule ID 26071 //
     /*   1716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1727 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1730 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1734 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1751 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (ADD16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm_ND),
     /*   1754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1756 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1758 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1770 */     GIR_RootConstrainSelectedInstOperands,
     /*   1771 */     // GIR_Coverage, 26071,
     /*   1771 */     GIR_EraseRootFromParent_Done,
     /*   1772 */   // Label 111: @1772
     /*   1772 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1833), // Rule ID 22794 //
     /*   1777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1795 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1799 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1812 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (ADD16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm),
     /*   1815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1831 */     GIR_RootConstrainSelectedInstOperands,
     /*   1832 */     // GIR_Coverage, 22794,
     /*   1832 */     GIR_EraseRootFromParent_Done,
     /*   1833 */   // Label 112: @1833
     /*   1833 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1894), // Rule ID 22884 //
     /*   1838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1853 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1860 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1873 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (ADD16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm_ND),
     /*   1876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1878 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1880 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1892 */     GIR_RootConstrainSelectedInstOperands,
     /*   1893 */     // GIR_Coverage, 22884,
     /*   1893 */     GIR_EraseRootFromParent_Done,
     /*   1894 */   // Label 113: @1894
     /*   1894 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1932), // Rule ID 22599 //
     /*   1899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1906 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   1917 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*   1917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*   1920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   1927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1930 */     GIR_RootConstrainSelectedInstOperands,
     /*   1931 */     // GIR_Coverage, 22599,
     /*   1931 */     GIR_EraseRootFromParent_Done,
     /*   1932 */   // Label 114: @1932
     /*   1932 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1970), // Rule ID 22605 //
     /*   1937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1944 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   1955 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*   1955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*   1958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1960 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   1965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1968 */     GIR_RootConstrainSelectedInstOperands,
     /*   1969 */     // GIR_Coverage, 22605,
     /*   1969 */     GIR_EraseRootFromParent_Done,
     /*   1970 */   // Label 115: @1970
     /*   1970 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1998), // Rule ID 22860 //
     /*   1975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1986 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   1986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r),
     /*   1989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1991 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1996 */     GIR_RootConstrainSelectedInstOperands,
     /*   1997 */     // GIR_Coverage, 22860,
     /*   1997 */     GIR_EraseRootFromParent_Done,
     /*   1998 */   // Label 116: @1998
     /*   1998 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2026), // Rule ID 22864 //
     /*   2003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2014 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r),
     /*   2017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2019 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2024 */     GIR_RootConstrainSelectedInstOperands,
     /*   2025 */     // GIR_Coverage, 22864,
     /*   2025 */     GIR_EraseRootFromParent_Done,
     /*   2026 */   // Label 117: @2026
     /*   2026 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2054), // Rule ID 22950 //
     /*   2031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2042 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r_ND),
     /*   2045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2047 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2052 */     GIR_RootConstrainSelectedInstOperands,
     /*   2053 */     // GIR_Coverage, 22950,
     /*   2053 */     GIR_EraseRootFromParent_Done,
     /*   2054 */   // Label 118: @2054
     /*   2054 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2082), // Rule ID 22954 //
     /*   2059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2066 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2070 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r_ND),
     /*   2073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2075 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2080 */     GIR_RootConstrainSelectedInstOperands,
     /*   2081 */     // GIR_Coverage, 22954,
     /*   2081 */     GIR_EraseRootFromParent_Done,
     /*   2082 */   // Label 119: @2082
     /*   2082 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2119), // Rule ID 22798 //
     /*   2087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2102 */     // MIs[1] Operand 1
     /*   2102 */     // No operand predicates
     /*   2102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2104 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   2104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*   2107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2109 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2117 */     GIR_RootConstrainSelectedInstOperands,
     /*   2118 */     // GIR_Coverage, 22798,
     /*   2118 */     GIR_EraseRootFromParent_Done,
     /*   2119 */   // Label 120: @2119
     /*   2119 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2156), // Rule ID 22888 //
     /*   2124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2139 */     // MIs[1] Operand 1
     /*   2139 */     // No operand predicates
     /*   2139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2141 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   2141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri_ND),
     /*   2144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2146 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2154 */     GIR_RootConstrainSelectedInstOperands,
     /*   2155 */     // GIR_Coverage, 22888,
     /*   2155 */     GIR_EraseRootFromParent_Done,
     /*   2156 */   // Label 121: @2156
     /*   2156 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2185), // Rule ID 22790 //
     /*   2161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2172 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   2172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /*   2177 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2183 */     GIR_RootConstrainSelectedInstOperands,
     /*   2184 */     // GIR_Coverage, 22790,
     /*   2184 */     GIR_Done,
     /*   2185 */   // Label 122: @2185
     /*   2185 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2214), // Rule ID 22880 //
     /*   2190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2201 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   2201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /*   2206 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2212 */     GIR_RootConstrainSelectedInstOperands,
     /*   2213 */     // GIR_Coverage, 22880,
     /*   2213 */     GIR_Done,
     /*   2214 */   // Label 123: @2214
     /*   2214 */   GIM_Reject,
     /*   2215 */ // Label 108: @2215
     /*   2215 */ GIM_Reject,
     /*   2216 */ // Label 80: @2216
     /*   2216 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(2865),
     /*   2221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2231 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(2300), // Rule ID 22615 //
     /*   2236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2247 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2250 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2254 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2258 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2278 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:{ *:[i32] })  =>  (SUB32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i32] })
     /*   2278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi_ND),
     /*   2281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   2287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2298 */     GIR_RootConstrainSelectedInstOperands,
     /*   2299 */     // GIR_Coverage, 22615,
     /*   2299 */     GIR_EraseRootFromParent_Done,
     /*   2300 */   // Label 125: @2300
     /*   2300 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(2361), // Rule ID 26053 //
     /*   2305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2316 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2319 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2323 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2340 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (ADD32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm),
     /*   2343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2345 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   2347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2359 */     GIR_RootConstrainSelectedInstOperands,
     /*   2360 */     // GIR_Coverage, 26053,
     /*   2360 */     GIR_EraseRootFromParent_Done,
     /*   2361 */   // Label 126: @2361
     /*   2361 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(2422), // Rule ID 26072 //
     /*   2366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2377 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2380 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2384 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2401 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (ADD32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm_ND),
     /*   2404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2406 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   2408 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2420 */     GIR_RootConstrainSelectedInstOperands,
     /*   2421 */     // GIR_Coverage, 26072,
     /*   2421 */     GIR_EraseRootFromParent_Done,
     /*   2422 */   // Label 127: @2422
     /*   2422 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(2483), // Rule ID 22795 //
     /*   2427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2442 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2445 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2449 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2462 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ADD32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm),
     /*   2465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2481 */     GIR_RootConstrainSelectedInstOperands,
     /*   2482 */     // GIR_Coverage, 22795,
     /*   2482 */     GIR_EraseRootFromParent_Done,
     /*   2483 */   // Label 128: @2483
     /*   2483 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(2544), // Rule ID 22885 //
     /*   2488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2503 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2506 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2510 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2523 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ADD32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm_ND),
     /*   2526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2528 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2542 */     GIR_RootConstrainSelectedInstOperands,
     /*   2543 */     // GIR_Coverage, 22885,
     /*   2543 */     GIR_EraseRootFromParent_Done,
     /*   2544 */   // Label 129: @2544
     /*   2544 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(2582), // Rule ID 22600 //
     /*   2549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2556 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2567 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*   2567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*   2570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2572 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2580 */     GIR_RootConstrainSelectedInstOperands,
     /*   2581 */     // GIR_Coverage, 22600,
     /*   2581 */     GIR_EraseRootFromParent_Done,
     /*   2582 */   // Label 130: @2582
     /*   2582 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(2620), // Rule ID 22606 //
     /*   2587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2594 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2605 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*   2605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*   2608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2610 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2618 */     GIR_RootConstrainSelectedInstOperands,
     /*   2619 */     // GIR_Coverage, 22606,
     /*   2619 */     GIR_EraseRootFromParent_Done,
     /*   2620 */   // Label 131: @2620
     /*   2620 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2648), // Rule ID 22861 //
     /*   2625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2636 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r),
     /*   2639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2641 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2646 */     GIR_RootConstrainSelectedInstOperands,
     /*   2647 */     // GIR_Coverage, 22861,
     /*   2647 */     GIR_EraseRootFromParent_Done,
     /*   2648 */   // Label 132: @2648
     /*   2648 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2676), // Rule ID 22865 //
     /*   2653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2664 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r),
     /*   2667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2674 */     GIR_RootConstrainSelectedInstOperands,
     /*   2675 */     // GIR_Coverage, 22865,
     /*   2675 */     GIR_EraseRootFromParent_Done,
     /*   2676 */   // Label 133: @2676
     /*   2676 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2704), // Rule ID 22951 //
     /*   2681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2692 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r_ND),
     /*   2695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2697 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2702 */     GIR_RootConstrainSelectedInstOperands,
     /*   2703 */     // GIR_Coverage, 22951,
     /*   2703 */     GIR_EraseRootFromParent_Done,
     /*   2704 */   // Label 134: @2704
     /*   2704 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2732), // Rule ID 22955 //
     /*   2709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2720 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r_ND),
     /*   2723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2725 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2730 */     GIR_RootConstrainSelectedInstOperands,
     /*   2731 */     // GIR_Coverage, 22955,
     /*   2731 */     GIR_EraseRootFromParent_Done,
     /*   2732 */   // Label 135: @2732
     /*   2732 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2769), // Rule ID 22799 //
     /*   2737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2752 */     // MIs[1] Operand 1
     /*   2752 */     // No operand predicates
     /*   2752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2754 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   2754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*   2757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2759 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2767 */     GIR_RootConstrainSelectedInstOperands,
     /*   2768 */     // GIR_Coverage, 22799,
     /*   2768 */     GIR_EraseRootFromParent_Done,
     /*   2769 */   // Label 136: @2769
     /*   2769 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2806), // Rule ID 22889 //
     /*   2774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2789 */     // MIs[1] Operand 1
     /*   2789 */     // No operand predicates
     /*   2789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2791 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   2791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri_ND),
     /*   2794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2796 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2804 */     GIR_RootConstrainSelectedInstOperands,
     /*   2805 */     // GIR_Coverage, 22889,
     /*   2805 */     GIR_EraseRootFromParent_Done,
     /*   2806 */   // Label 137: @2806
     /*   2806 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2835), // Rule ID 22791 //
     /*   2811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2822 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   2822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /*   2827 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2833 */     GIR_RootConstrainSelectedInstOperands,
     /*   2834 */     // GIR_Coverage, 22791,
     /*   2834 */     GIR_Done,
     /*   2835 */   // Label 138: @2835
     /*   2835 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2864), // Rule ID 22881 //
     /*   2840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2851 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   2851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /*   2856 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2862 */     GIR_RootConstrainSelectedInstOperands,
     /*   2863 */     // GIR_Coverage, 22881,
     /*   2863 */     GIR_Done,
     /*   2864 */   // Label 139: @2864
     /*   2864 */   GIM_Reject,
     /*   2865 */ // Label 124: @2865
     /*   2865 */ GIM_Reject,
     /*   2866 */ // Label 81: @2866
     /*   2866 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(3689),
     /*   2871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   2881 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2950), // Rule ID 22616 //
     /*   2886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2897 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   2904 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2908 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2928 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 128:{ *:[i64] })  =>  (SUB64mi32_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i64] })
     /*   2928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32_ND),
     /*   2931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2933 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   2937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2948 */     GIR_RootConstrainSelectedInstOperands,
     /*   2949 */     // GIR_Coverage, 22616,
     /*   2949 */     GIR_EraseRootFromParent_Done,
     /*   2950 */   // Label 141: @2950
     /*   2950 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(3026), // Rule ID 22622 //
     /*   2955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2966 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2969 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   2973 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2977 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   2988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2997 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 2147483648:{ *:[i64] })  =>  (SUB64mi32_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -2147483648:{ *:[i64] })
     /*   2997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32_ND),
     /*   3000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   3006 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3024 */     GIR_RootConstrainSelectedInstOperands,
     /*   3025 */     // GIR_Coverage, 22622,
     /*   3025 */     GIR_EraseRootFromParent_Done,
     /*   3026 */   // Label 142: @3026
     /*   3026 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(3087), // Rule ID 26054 //
     /*   3031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3042 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3045 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3049 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3059 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3066 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (ADD64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm),
     /*   3069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3071 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3085 */     GIR_RootConstrainSelectedInstOperands,
     /*   3086 */     // GIR_Coverage, 26054,
     /*   3086 */     GIR_EraseRootFromParent_Done,
     /*   3087 */   // Label 143: @3087
     /*   3087 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(3148), // Rule ID 26073 //
     /*   3092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3103 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3106 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3110 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3127 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (ADD64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm_ND),
     /*   3130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3132 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3146 */     GIR_RootConstrainSelectedInstOperands,
     /*   3147 */     // GIR_Coverage, 26073,
     /*   3147 */     GIR_EraseRootFromParent_Done,
     /*   3148 */   // Label 144: @3148
     /*   3148 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(3209), // Rule ID 22796 //
     /*   3153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3168 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3171 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3175 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3188 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm),
     /*   3191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3193 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3207 */     GIR_RootConstrainSelectedInstOperands,
     /*   3208 */     // GIR_Coverage, 22796,
     /*   3208 */     GIR_EraseRootFromParent_Done,
     /*   3209 */   // Label 145: @3209
     /*   3209 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(3270), // Rule ID 22886 //
     /*   3214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3229 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3232 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3236 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3249 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm_ND),
     /*   3252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3254 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3268 */     GIR_RootConstrainSelectedInstOperands,
     /*   3269 */     // GIR_Coverage, 22886,
     /*   3269 */     GIR_EraseRootFromParent_Done,
     /*   3270 */   // Label 146: @3270
     /*   3270 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(3308), // Rule ID 22601 //
     /*   3275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3282 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3293 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*   3293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   3296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3298 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3306 */     GIR_RootConstrainSelectedInstOperands,
     /*   3307 */     // GIR_Coverage, 22601,
     /*   3307 */     GIR_EraseRootFromParent_Done,
     /*   3308 */   // Label 147: @3308
     /*   3308 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(3346), // Rule ID 22607 //
     /*   3313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3320 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3331 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*   3331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   3334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3336 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3344 */     GIR_RootConstrainSelectedInstOperands,
     /*   3345 */     // GIR_Coverage, 22607,
     /*   3345 */     GIR_EraseRootFromParent_Done,
     /*   3346 */   // Label 148: @3346
     /*   3346 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(3391), // Rule ID 22617 //
     /*   3351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3358 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3369 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*   3369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   3372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3374 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3376 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3389 */     GIR_RootConstrainSelectedInstOperands,
     /*   3390 */     // GIR_Coverage, 22617,
     /*   3390 */     GIR_EraseRootFromParent_Done,
     /*   3391 */   // Label 149: @3391
     /*   3391 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(3436), // Rule ID 22619 //
     /*   3396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3403 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3414 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*   3414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   3417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3421 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3434 */     GIR_RootConstrainSelectedInstOperands,
     /*   3435 */     // GIR_Coverage, 22619,
     /*   3435 */     GIR_EraseRootFromParent_Done,
     /*   3436 */   // Label 150: @3436
     /*   3436 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(3464), // Rule ID 22862 //
     /*   3441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   3444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   3452 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r),
     /*   3455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3462 */     GIR_RootConstrainSelectedInstOperands,
     /*   3463 */     // GIR_Coverage, 22862,
     /*   3463 */     GIR_EraseRootFromParent_Done,
     /*   3464 */   // Label 151: @3464
     /*   3464 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(3492), // Rule ID 22866 //
     /*   3469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   3472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   3480 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r),
     /*   3483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3485 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3490 */     GIR_RootConstrainSelectedInstOperands,
     /*   3491 */     // GIR_Coverage, 22866,
     /*   3491 */     GIR_EraseRootFromParent_Done,
     /*   3492 */   // Label 152: @3492
     /*   3492 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(3520), // Rule ID 22952 //
     /*   3497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   3500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   3508 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r_ND),
     /*   3511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3513 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3518 */     GIR_RootConstrainSelectedInstOperands,
     /*   3519 */     // GIR_Coverage, 22952,
     /*   3519 */     GIR_EraseRootFromParent_Done,
     /*   3520 */   // Label 153: @3520
     /*   3520 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(3548), // Rule ID 22956 //
     /*   3525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   3528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   3536 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r_ND),
     /*   3539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3541 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3546 */     GIR_RootConstrainSelectedInstOperands,
     /*   3547 */     // GIR_Coverage, 22956,
     /*   3547 */     GIR_EraseRootFromParent_Done,
     /*   3548 */   // Label 154: @3548
     /*   3548 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(3589), // Rule ID 22800 //
     /*   3553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   3572 */     // MIs[1] Operand 1
     /*   3572 */     // No operand predicates
     /*   3572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3574 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   3574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32),
     /*   3577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3579 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3587 */     GIR_RootConstrainSelectedInstOperands,
     /*   3588 */     // GIR_Coverage, 22800,
     /*   3588 */     GIR_EraseRootFromParent_Done,
     /*   3589 */   // Label 155: @3589
     /*   3589 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(3630), // Rule ID 22890 //
     /*   3594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   3613 */     // MIs[1] Operand 1
     /*   3613 */     // No operand predicates
     /*   3613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3615 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   3615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32_ND),
     /*   3618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3620 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3628 */     GIR_RootConstrainSelectedInstOperands,
     /*   3629 */     // GIR_Coverage, 22890,
     /*   3629 */     GIR_EraseRootFromParent_Done,
     /*   3630 */   // Label 156: @3630
     /*   3630 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(3659), // Rule ID 22792 //
     /*   3635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3646 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   3646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /*   3651 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3657 */     GIR_RootConstrainSelectedInstOperands,
     /*   3658 */     // GIR_Coverage, 22792,
     /*   3658 */     GIR_Done,
     /*   3659 */   // Label 157: @3659
     /*   3659 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(3688), // Rule ID 22882 //
     /*   3664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3675 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   3675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /*   3680 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3686 */     GIR_RootConstrainSelectedInstOperands,
     /*   3687 */     // GIR_Coverage, 22882,
     /*   3687 */     GIR_Done,
     /*   3688 */   // Label 158: @3688
     /*   3688 */   GIM_Reject,
     /*   3689 */ // Label 140: @3689
     /*   3689 */ GIM_Reject,
     /*   3690 */ // Label 82: @3690
     /*   3690 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(4031),
     /*   3695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   3698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   3701 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(3763), // Rule ID 23435 //
     /*   3706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   3709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3721 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3724 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3728 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3745 */     // (add:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPADDQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQrm),
     /*   3748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3750 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3761 */     GIR_RootConstrainSelectedInstOperands,
     /*   3762 */     // GIR_Coverage, 23435,
     /*   3762 */     GIR_EraseRootFromParent_Done,
     /*   3763 */   // Label 160: @3763
     /*   3763 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(3825), // Rule ID 23705 //
     /*   3768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   3771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3783 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3786 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3790 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3807 */     // (add:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPADDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rm),
     /*   3810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3812 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3814 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3823 */     GIR_RootConstrainSelectedInstOperands,
     /*   3824 */     // GIR_Coverage, 23705,
     /*   3824 */     GIR_EraseRootFromParent_Done,
     /*   3825 */   // Label 161: @3825
     /*   3825 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(3887), // Rule ID 2540 //
     /*   3830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   3833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3849 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3869 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQrm),
     /*   3872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3874 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3885 */     GIR_RootConstrainSelectedInstOperands,
     /*   3886 */     // GIR_Coverage, 2540,
     /*   3886 */     GIR_EraseRootFromParent_Done,
     /*   3887 */   // Label 162: @3887
     /*   3887 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(3949), // Rule ID 4653 //
     /*   3892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   3895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3911 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3914 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3918 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3931 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rm),
     /*   3934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3936 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3938 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3947 */     GIR_RootConstrainSelectedInstOperands,
     /*   3948 */     // GIR_Coverage, 4653,
     /*   3948 */     GIR_EraseRootFromParent_Done,
     /*   3949 */   // Label 163: @3949
     /*   3949 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(3976), // Rule ID 2539 //
     /*   3954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   3957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3969 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   3969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQrr),
     /*   3974 */     GIR_RootConstrainSelectedInstOperands,
     /*   3975 */     // GIR_Coverage, 2539,
     /*   3975 */     GIR_Done,
     /*   3976 */   // Label 164: @3976
     /*   3976 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(4003), // Rule ID 2541 //
     /*   3981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   3984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3996 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   3996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDQrr),
     /*   4001 */     GIR_RootConstrainSelectedInstOperands,
     /*   4002 */     // GIR_Coverage, 2541,
     /*   4002 */     GIR_Done,
     /*   4003 */   // Label 165: @4003
     /*   4003 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(4030), // Rule ID 4650 //
     /*   4008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4023 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPADDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*   4023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rr),
     /*   4028 */     GIR_RootConstrainSelectedInstOperands,
     /*   4029 */     // GIR_Coverage, 4650,
     /*   4029 */     GIR_Done,
     /*   4030 */   // Label 166: @4030
     /*   4030 */   GIM_Reject,
     /*   4031 */ // Label 159: @4031
     /*   4031 */ GIM_Reject,
     /*   4032 */ // Label 83: @4032
     /*   4032 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(4495),
     /*   4037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4043 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(4105), // Rule ID 23432 //
     /*   4048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4063 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4066 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4070 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4087 */     // (add:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPADDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDrm),
     /*   4090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4092 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4103 */     GIR_RootConstrainSelectedInstOperands,
     /*   4104 */     // GIR_Coverage, 23432,
     /*   4104 */     GIR_EraseRootFromParent_Done,
     /*   4105 */   // Label 168: @4105
     /*   4105 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(4167), // Rule ID 23723 //
     /*   4110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4125 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4128 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4132 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4149 */     // (add:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPADDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rm),
     /*   4152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4154 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4156 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4165 */     GIR_RootConstrainSelectedInstOperands,
     /*   4166 */     // GIR_Coverage, 23723,
     /*   4166 */     GIR_EraseRootFromParent_Done,
     /*   4167 */   // Label 169: @4167
     /*   4167 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(4229), // Rule ID 2534 //
     /*   4172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4191 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4198 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4211 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDrm),
     /*   4214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4216 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4218 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4227 */     GIR_RootConstrainSelectedInstOperands,
     /*   4228 */     // GIR_Coverage, 2534,
     /*   4228 */     GIR_EraseRootFromParent_Done,
     /*   4229 */   // Label 170: @4229
     /*   4229 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(4291), // Rule ID 4680 //
     /*   4234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4253 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4273 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rm),
     /*   4276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4278 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4289 */     GIR_RootConstrainSelectedInstOperands,
     /*   4290 */     // GIR_Coverage, 4680,
     /*   4290 */     GIR_EraseRootFromParent_Done,
     /*   4291 */   // Label 171: @4291
     /*   4291 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(4352), // Rule ID 17866 //
     /*   4296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   4299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4335 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2), VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*   4335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*   4338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   4344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   4348 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4350 */     GIR_RootConstrainSelectedInstOperands,
     /*   4351 */     // GIR_Coverage, 17866,
     /*   4351 */     GIR_EraseRootFromParent_Done,
     /*   4352 */   // Label 172: @4352
     /*   4352 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4413), // Rule ID 25187 //
     /*   4357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   4360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4396 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src3, (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2))  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*   4396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*   4399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   4405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   4409 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4411 */     GIR_RootConstrainSelectedInstOperands,
     /*   4412 */     // GIR_Coverage, 25187,
     /*   4412 */     GIR_EraseRootFromParent_Done,
     /*   4413 */   // Label 173: @4413
     /*   4413 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4440), // Rule ID 2533 //
     /*   4418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4433 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   4433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDrr),
     /*   4438 */     GIR_RootConstrainSelectedInstOperands,
     /*   4439 */     // GIR_Coverage, 2533,
     /*   4439 */     GIR_Done,
     /*   4440 */   // Label 174: @4440
     /*   4440 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4467), // Rule ID 2535 //
     /*   4445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   4448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4460 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   4460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDDrr),
     /*   4465 */     GIR_RootConstrainSelectedInstOperands,
     /*   4466 */     // GIR_Coverage, 2535,
     /*   4466 */     GIR_Done,
     /*   4467 */   // Label 175: @4467
     /*   4467 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4494), // Rule ID 4677 //
     /*   4472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4487 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPADDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*   4487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rr),
     /*   4492 */     GIR_RootConstrainSelectedInstOperands,
     /*   4493 */     // GIR_Coverage, 4677,
     /*   4493 */     GIR_Done,
     /*   4494 */   // Label 176: @4494
     /*   4494 */   GIM_Reject,
     /*   4495 */ // Label 167: @4495
     /*   4495 */ GIM_Reject,
     /*   4496 */ // Label 84: @4496
     /*   4496 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4810),
     /*   4501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*   4504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*   4507 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4569), // Rule ID 23437 //
     /*   4512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4527 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4530 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4534 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4551 */     // (add:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPADDQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQYrm),
     /*   4554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4567 */     GIR_RootConstrainSelectedInstOperands,
     /*   4568 */     // GIR_Coverage, 23437,
     /*   4568 */     GIR_EraseRootFromParent_Done,
     /*   4569 */   // Label 178: @4569
     /*   4569 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4631), // Rule ID 23699 //
     /*   4574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4589 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4592 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4596 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4613 */     // (add:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPADDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rm),
     /*   4616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4618 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4620 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4629 */     GIR_RootConstrainSelectedInstOperands,
     /*   4630 */     // GIR_Coverage, 23699,
     /*   4630 */     GIR_EraseRootFromParent_Done,
     /*   4631 */   // Label 179: @4631
     /*   4631 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4693), // Rule ID 2544 //
     /*   4636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4655 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4658 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4662 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4675 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQYrm),
     /*   4678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4680 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4682 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4691 */     GIR_RootConstrainSelectedInstOperands,
     /*   4692 */     // GIR_Coverage, 2544,
     /*   4692 */     GIR_EraseRootFromParent_Done,
     /*   4693 */   // Label 180: @4693
     /*   4693 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4755), // Rule ID 4644 //
     /*   4698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4717 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4720 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4724 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4737 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rm),
     /*   4740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4742 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4744 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4753 */     GIR_RootConstrainSelectedInstOperands,
     /*   4754 */     // GIR_Coverage, 4644,
     /*   4754 */     GIR_EraseRootFromParent_Done,
     /*   4755 */   // Label 181: @4755
     /*   4755 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4782), // Rule ID 2543 //
     /*   4760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4775 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPADDQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*   4775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQYrr),
     /*   4780 */     GIR_RootConstrainSelectedInstOperands,
     /*   4781 */     // GIR_Coverage, 2543,
     /*   4781 */     GIR_Done,
     /*   4782 */   // Label 182: @4782
     /*   4782 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4809), // Rule ID 4641 //
     /*   4787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4802 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPADDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*   4802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rr),
     /*   4807 */     GIR_RootConstrainSelectedInstOperands,
     /*   4808 */     // GIR_Coverage, 4641,
     /*   4808 */     GIR_Done,
     /*   4809 */   // Label 183: @4809
     /*   4809 */   GIM_Reject,
     /*   4810 */ // Label 177: @4810
     /*   4810 */ GIM_Reject,
     /*   4811 */ // Label 85: @4811
     /*   4811 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5274),
     /*   4816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4822 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(4884), // Rule ID 23429 //
     /*   4827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   4830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4842 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4845 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4849 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4866 */     // (add:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWrm),
     /*   4869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4871 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4882 */     GIR_RootConstrainSelectedInstOperands,
     /*   4883 */     // GIR_Coverage, 23429,
     /*   4883 */     GIR_EraseRootFromParent_Done,
     /*   4884 */   // Label 185: @4884
     /*   4884 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(4946), // Rule ID 23735 //
     /*   4889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   4892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4904 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4907 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4911 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4928 */     // (add:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rm),
     /*   4931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4933 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4935 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4944 */     GIR_RootConstrainSelectedInstOperands,
     /*   4945 */     // GIR_Coverage, 23735,
     /*   4945 */     GIR_EraseRootFromParent_Done,
     /*   4946 */   // Label 186: @4946
     /*   4946 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(5008), // Rule ID 2528 //
     /*   4951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   4954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4970 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4973 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4977 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4990 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWrm),
     /*   4993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4995 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4997 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5006 */     GIR_RootConstrainSelectedInstOperands,
     /*   5007 */     // GIR_Coverage, 2528,
     /*   5007 */     GIR_EraseRootFromParent_Done,
     /*   5008 */   // Label 187: @5008
     /*   5008 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(5070), // Rule ID 4701 //
     /*   5013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5035 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5039 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5052 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rm),
     /*   5055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5059 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5068 */     GIR_RootConstrainSelectedInstOperands,
     /*   5069 */     // GIR_Coverage, 4701,
     /*   5069 */     GIR_EraseRootFromParent_Done,
     /*   5070 */   // Label 188: @5070
     /*   5070 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5131), // Rule ID 17865 //
     /*   5075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   5078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5114 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2), VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*   5114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*   5117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   5123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   5127 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   5129 */     GIR_RootConstrainSelectedInstOperands,
     /*   5130 */     // GIR_Coverage, 17865,
     /*   5130 */     GIR_EraseRootFromParent_Done,
     /*   5131 */   // Label 189: @5131
     /*   5131 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(5192), // Rule ID 25186 //
     /*   5136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   5139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5175 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src3, (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2))  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*   5175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*   5178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   5184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   5188 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   5190 */     GIR_RootConstrainSelectedInstOperands,
     /*   5191 */     // GIR_Coverage, 25186,
     /*   5191 */     GIR_EraseRootFromParent_Done,
     /*   5192 */   // Label 190: @5192
     /*   5192 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(5219), // Rule ID 2527 //
     /*   5197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5212 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   5212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWrr),
     /*   5217 */     GIR_RootConstrainSelectedInstOperands,
     /*   5218 */     // GIR_Coverage, 2527,
     /*   5218 */     GIR_Done,
     /*   5219 */   // Label 191: @5219
     /*   5219 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(5246), // Rule ID 2529 //
     /*   5224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   5227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5239 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   5239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDWrr),
     /*   5244 */     GIR_RootConstrainSelectedInstOperands,
     /*   5245 */     // GIR_Coverage, 2529,
     /*   5245 */     GIR_Done,
     /*   5246 */   // Label 192: @5246
     /*   5246 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(5273), // Rule ID 4698 //
     /*   5251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5266 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*   5266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rr),
     /*   5271 */     GIR_RootConstrainSelectedInstOperands,
     /*   5272 */     // GIR_Coverage, 4698,
     /*   5272 */     GIR_Done,
     /*   5273 */   // Label 193: @5273
     /*   5273 */   GIM_Reject,
     /*   5274 */ // Label 184: @5274
     /*   5274 */ GIM_Reject,
     /*   5275 */ // Label 86: @5275
     /*   5275 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(5589),
     /*   5280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*   5283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*   5286 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(5348), // Rule ID 23434 //
     /*   5291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5330 */     // (add:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPADDDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDYrm),
     /*   5333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5335 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5337 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5346 */     GIR_RootConstrainSelectedInstOperands,
     /*   5347 */     // GIR_Coverage, 23434,
     /*   5347 */     GIR_EraseRootFromParent_Done,
     /*   5348 */   // Label 195: @5348
     /*   5348 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(5410), // Rule ID 23717 //
     /*   5353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5368 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5375 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5392 */     // (add:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPADDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rm),
     /*   5395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5397 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5399 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5408 */     GIR_RootConstrainSelectedInstOperands,
     /*   5409 */     // GIR_Coverage, 23717,
     /*   5409 */     GIR_EraseRootFromParent_Done,
     /*   5410 */   // Label 196: @5410
     /*   5410 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(5472), // Rule ID 2538 //
     /*   5415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5434 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5437 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5441 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5454 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDYrm),
     /*   5457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5470 */     GIR_RootConstrainSelectedInstOperands,
     /*   5471 */     // GIR_Coverage, 2538,
     /*   5471 */     GIR_EraseRootFromParent_Done,
     /*   5472 */   // Label 197: @5472
     /*   5472 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(5534), // Rule ID 4671 //
     /*   5477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5496 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5516 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rm),
     /*   5519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5521 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5532 */     GIR_RootConstrainSelectedInstOperands,
     /*   5533 */     // GIR_Coverage, 4671,
     /*   5533 */     GIR_EraseRootFromParent_Done,
     /*   5534 */   // Label 198: @5534
     /*   5534 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(5561), // Rule ID 2537 //
     /*   5539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5554 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPADDDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*   5554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDYrr),
     /*   5559 */     GIR_RootConstrainSelectedInstOperands,
     /*   5560 */     // GIR_Coverage, 2537,
     /*   5560 */     GIR_Done,
     /*   5561 */   // Label 199: @5561
     /*   5561 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(5588), // Rule ID 4668 //
     /*   5566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5581 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPADDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*   5581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rr),
     /*   5586 */     GIR_RootConstrainSelectedInstOperands,
     /*   5587 */     // GIR_Coverage, 4668,
     /*   5587 */     GIR_Done,
     /*   5588 */   // Label 200: @5588
     /*   5588 */   GIM_Reject,
     /*   5589 */ // Label 194: @5589
     /*   5589 */ GIM_Reject,
     /*   5590 */ // Label 87: @5590
     /*   5590 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(5745),
     /*   5595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*   5598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*   5601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5605 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(5663), // Rule ID 23693 //
     /*   5610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5621 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5624 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5628 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5645 */     // (add:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPADDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZrm),
     /*   5648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5650 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5652 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5661 */     GIR_RootConstrainSelectedInstOperands,
     /*   5662 */     // GIR_Coverage, 23693,
     /*   5662 */     GIR_EraseRootFromParent_Done,
     /*   5663 */   // Label 202: @5663
     /*   5663 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(5721), // Rule ID 4635 //
     /*   5668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5683 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5686 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5690 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5696 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5703 */     // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZrm),
     /*   5706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5708 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5710 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5719 */     GIR_RootConstrainSelectedInstOperands,
     /*   5720 */     // GIR_Coverage, 4635,
     /*   5720 */     GIR_EraseRootFromParent_Done,
     /*   5721 */   // Label 203: @5721
     /*   5721 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(5744), // Rule ID 4632 //
     /*   5726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5737 */     // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPADDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*   5737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZrr),
     /*   5742 */     GIR_RootConstrainSelectedInstOperands,
     /*   5743 */     // GIR_Coverage, 4632,
     /*   5743 */     GIR_Done,
     /*   5744 */   // Label 204: @5744
     /*   5744 */   GIM_Reject,
     /*   5745 */ // Label 201: @5745
     /*   5745 */ GIM_Reject,
     /*   5746 */ // Label 88: @5746
     /*   5746 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(6087),
     /*   5751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   5757 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(5819), // Rule ID 23426 //
     /*   5762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5777 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5784 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5801 */     // (add:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBrm),
     /*   5804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5806 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5808 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5817 */     GIR_RootConstrainSelectedInstOperands,
     /*   5818 */     // GIR_Coverage, 23426,
     /*   5818 */     GIR_EraseRootFromParent_Done,
     /*   5819 */   // Label 206: @5819
     /*   5819 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(5881), // Rule ID 23744 //
     /*   5824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5839 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5846 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5863 */     // (add:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rm),
     /*   5866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5868 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5870 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5879 */     GIR_RootConstrainSelectedInstOperands,
     /*   5880 */     // GIR_Coverage, 23744,
     /*   5880 */     GIR_EraseRootFromParent_Done,
     /*   5881 */   // Label 207: @5881
     /*   5881 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(5943), // Rule ID 2522 //
     /*   5886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5912 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5925 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBrm),
     /*   5928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5930 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5932 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5941 */     GIR_RootConstrainSelectedInstOperands,
     /*   5942 */     // GIR_Coverage, 2522,
     /*   5942 */     GIR_EraseRootFromParent_Done,
     /*   5943 */   // Label 208: @5943
     /*   5943 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(6005), // Rule ID 4719 //
     /*   5948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5967 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5974 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5987 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rm),
     /*   5990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5992 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6003 */     GIR_RootConstrainSelectedInstOperands,
     /*   6004 */     // GIR_Coverage, 4719,
     /*   6004 */     GIR_EraseRootFromParent_Done,
     /*   6005 */   // Label 209: @6005
     /*   6005 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(6032), // Rule ID 2521 //
     /*   6010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   6013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6025 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   6025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBrr),
     /*   6030 */     GIR_RootConstrainSelectedInstOperands,
     /*   6031 */     // GIR_Coverage, 2521,
     /*   6031 */     GIR_Done,
     /*   6032 */   // Label 210: @6032
     /*   6032 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(6059), // Rule ID 2523 //
     /*   6037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   6040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6052 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   6052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDBrr),
     /*   6057 */     GIR_RootConstrainSelectedInstOperands,
     /*   6058 */     // GIR_Coverage, 2523,
     /*   6058 */     GIR_Done,
     /*   6059 */   // Label 211: @6059
     /*   6059 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(6086), // Rule ID 4716 //
     /*   6064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6079 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*   6079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rr),
     /*   6084 */     GIR_RootConstrainSelectedInstOperands,
     /*   6085 */     // GIR_Coverage, 4716,
     /*   6085 */     GIR_Done,
     /*   6086 */   // Label 212: @6086
     /*   6086 */   GIM_Reject,
     /*   6087 */ // Label 205: @6087
     /*   6087 */ GIM_Reject,
     /*   6088 */ // Label 89: @6088
     /*   6088 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(6402),
     /*   6093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*   6096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*   6099 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(6161), // Rule ID 23431 //
     /*   6104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6122 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6126 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6143 */     // (add:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWYrm),
     /*   6146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6150 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6159 */     GIR_RootConstrainSelectedInstOperands,
     /*   6160 */     // GIR_Coverage, 23431,
     /*   6160 */     GIR_EraseRootFromParent_Done,
     /*   6161 */   // Label 214: @6161
     /*   6161 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(6223), // Rule ID 23732 //
     /*   6166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6205 */     // (add:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rm),
     /*   6208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6210 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6221 */     GIR_RootConstrainSelectedInstOperands,
     /*   6222 */     // GIR_Coverage, 23732,
     /*   6222 */     GIR_EraseRootFromParent_Done,
     /*   6223 */   // Label 215: @6223
     /*   6223 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(6285), // Rule ID 2532 //
     /*   6228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6247 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6250 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6254 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6267 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWYrm),
     /*   6270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6272 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6274 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6283 */     GIR_RootConstrainSelectedInstOperands,
     /*   6284 */     // GIR_Coverage, 2532,
     /*   6284 */     GIR_EraseRootFromParent_Done,
     /*   6285 */   // Label 216: @6285
     /*   6285 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(6347), // Rule ID 4695 //
     /*   6290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6309 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6312 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6316 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6329 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rm),
     /*   6332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6334 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6345 */     GIR_RootConstrainSelectedInstOperands,
     /*   6346 */     // GIR_Coverage, 4695,
     /*   6346 */     GIR_EraseRootFromParent_Done,
     /*   6347 */   // Label 217: @6347
     /*   6347 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(6374), // Rule ID 2531 //
     /*   6352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6367 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*   6367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWYrr),
     /*   6372 */     GIR_RootConstrainSelectedInstOperands,
     /*   6373 */     // GIR_Coverage, 2531,
     /*   6373 */     GIR_Done,
     /*   6374 */   // Label 218: @6374
     /*   6374 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(6401), // Rule ID 4692 //
     /*   6379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6394 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*   6394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rr),
     /*   6399 */     GIR_RootConstrainSelectedInstOperands,
     /*   6400 */     // GIR_Coverage, 4692,
     /*   6400 */     GIR_Done,
     /*   6401 */   // Label 219: @6401
     /*   6401 */   GIM_Reject,
     /*   6402 */ // Label 213: @6402
     /*   6402 */ GIM_Reject,
     /*   6403 */ // Label 90: @6403
     /*   6403 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(6558),
     /*   6408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*   6411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*   6414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6418 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(6476), // Rule ID 23711 //
     /*   6423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6434 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6437 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6441 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6458 */     // (add:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPADDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZrm),
     /*   6461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6465 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6474 */     GIR_RootConstrainSelectedInstOperands,
     /*   6475 */     // GIR_Coverage, 23711,
     /*   6475 */     GIR_EraseRootFromParent_Done,
     /*   6476 */   // Label 221: @6476
     /*   6476 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(6534), // Rule ID 4662 //
     /*   6481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6496 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6516 */     // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZrm),
     /*   6519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6521 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6532 */     GIR_RootConstrainSelectedInstOperands,
     /*   6533 */     // GIR_Coverage, 4662,
     /*   6533 */     GIR_EraseRootFromParent_Done,
     /*   6534 */   // Label 222: @6534
     /*   6534 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(6557), // Rule ID 4659 //
     /*   6539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6550 */     // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPADDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*   6550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZrr),
     /*   6555 */     GIR_RootConstrainSelectedInstOperands,
     /*   6556 */     // GIR_Coverage, 4659,
     /*   6556 */     GIR_Done,
     /*   6557 */   // Label 223: @6557
     /*   6557 */   GIM_Reject,
     /*   6558 */ // Label 220: @6558
     /*   6558 */ GIM_Reject,
     /*   6559 */ // Label 91: @6559
     /*   6559 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6873),
     /*   6564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*   6567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*   6570 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6632), // Rule ID 23428 //
     /*   6575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6614 */     // (add:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBYrm),
     /*   6617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6619 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6630 */     GIR_RootConstrainSelectedInstOperands,
     /*   6631 */     // GIR_Coverage, 23428,
     /*   6631 */     GIR_EraseRootFromParent_Done,
     /*   6632 */   // Label 225: @6632
     /*   6632 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6694), // Rule ID 23741 //
     /*   6637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6652 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6676 */     // (add:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rm),
     /*   6679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6681 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6692 */     GIR_RootConstrainSelectedInstOperands,
     /*   6693 */     // GIR_Coverage, 23741,
     /*   6693 */     GIR_EraseRootFromParent_Done,
     /*   6694 */   // Label 226: @6694
     /*   6694 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6756), // Rule ID 2526 //
     /*   6699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6718 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6725 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6738 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBYrm),
     /*   6741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6754 */     GIR_RootConstrainSelectedInstOperands,
     /*   6755 */     // GIR_Coverage, 2526,
     /*   6755 */     GIR_EraseRootFromParent_Done,
     /*   6756 */   // Label 227: @6756
     /*   6756 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6818), // Rule ID 4713 //
     /*   6761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6780 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6787 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6800 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rm),
     /*   6803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6805 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6807 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6816 */     GIR_RootConstrainSelectedInstOperands,
     /*   6817 */     // GIR_Coverage, 4713,
     /*   6817 */     GIR_EraseRootFromParent_Done,
     /*   6818 */   // Label 228: @6818
     /*   6818 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6845), // Rule ID 2525 //
     /*   6823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6838 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*   6838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBYrr),
     /*   6843 */     GIR_RootConstrainSelectedInstOperands,
     /*   6844 */     // GIR_Coverage, 2525,
     /*   6844 */     GIR_Done,
     /*   6845 */   // Label 229: @6845
     /*   6845 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6872), // Rule ID 4710 //
     /*   6850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6865 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*   6865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rr),
     /*   6870 */     GIR_RootConstrainSelectedInstOperands,
     /*   6871 */     // GIR_Coverage, 4710,
     /*   6871 */     GIR_Done,
     /*   6872 */   // Label 230: @6872
     /*   6872 */   GIM_Reject,
     /*   6873 */ // Label 224: @6873
     /*   6873 */ GIM_Reject,
     /*   6874 */ // Label 92: @6874
     /*   6874 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(7029),
     /*   6879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*   6882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*   6885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6889 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(6947), // Rule ID 23729 //
     /*   6894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   6897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6912 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6929 */     // (add:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZrm),
     /*   6932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6945 */     GIR_RootConstrainSelectedInstOperands,
     /*   6946 */     // GIR_Coverage, 23729,
     /*   6946 */     GIR_EraseRootFromParent_Done,
     /*   6947 */   // Label 232: @6947
     /*   6947 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(7005), // Rule ID 4689 //
     /*   6952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   6955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6967 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6974 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6987 */     // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZrm),
     /*   6990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6992 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7003 */     GIR_RootConstrainSelectedInstOperands,
     /*   7004 */     // GIR_Coverage, 4689,
     /*   7004 */     GIR_EraseRootFromParent_Done,
     /*   7005 */   // Label 233: @7005
     /*   7005 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(7028), // Rule ID 4686 //
     /*   7010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7021 */     // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*   7021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZrr),
     /*   7026 */     GIR_RootConstrainSelectedInstOperands,
     /*   7027 */     // GIR_Coverage, 4686,
     /*   7027 */     GIR_Done,
     /*   7028 */   // Label 234: @7028
     /*   7028 */   GIM_Reject,
     /*   7029 */ // Label 231: @7029
     /*   7029 */ GIM_Reject,
     /*   7030 */ // Label 93: @7030
     /*   7030 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(7185),
     /*   7035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*   7038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*   7041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7045 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(7103), // Rule ID 23738 //
     /*   7050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7061 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7064 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7068 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7085 */     // (add:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZrm),
     /*   7088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7090 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7092 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7101 */     GIR_RootConstrainSelectedInstOperands,
     /*   7102 */     // GIR_Coverage, 23738,
     /*   7102 */     GIR_EraseRootFromParent_Done,
     /*   7103 */   // Label 236: @7103
     /*   7103 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(7161), // Rule ID 4707 //
     /*   7108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7123 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7126 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7130 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7143 */     // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZrm),
     /*   7146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7148 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7150 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7159 */     GIR_RootConstrainSelectedInstOperands,
     /*   7160 */     // GIR_Coverage, 4707,
     /*   7160 */     GIR_EraseRootFromParent_Done,
     /*   7161 */   // Label 237: @7161
     /*   7161 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(7184), // Rule ID 4704 //
     /*   7166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7177 */     // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*   7177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZrr),
     /*   7182 */     GIR_RootConstrainSelectedInstOperands,
     /*   7183 */     // GIR_Coverage, 4704,
     /*   7183 */     GIR_Done,
     /*   7184 */   // Label 238: @7184
     /*   7184 */   GIM_Reject,
     /*   7185 */ // Label 235: @7185
     /*   7185 */ GIM_Reject,
     /*   7186 */ // Label 94: @7186
     /*   7186 */ GIM_Reject,
     /*   7187 */ // Label 1: @7187
     /*   7187 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 255*/ GIMT_Encode4(10722),
     /*   7198 */ /*GILLT_s8*//*Label 239*/ GIMT_Encode4(7294),
     /*   7202 */ /*GILLT_s16*//*Label 240*/ GIMT_Encode4(7646),
     /*   7206 */ /*GILLT_s32*//*Label 241*/ GIMT_Encode4(7998),
     /*   7210 */ /*GILLT_s64*//*Label 242*/ GIMT_Encode4(8350), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   7226 */ /*GILLT_v2s64*//*Label 243*/ GIMT_Encode4(8710), GIMT_Encode4(0),
     /*   7234 */ /*GILLT_v4s32*//*Label 244*/ GIMT_Encode4(8928),
     /*   7238 */ /*GILLT_v4s64*//*Label 245*/ GIMT_Encode4(9146), GIMT_Encode4(0),
     /*   7246 */ /*GILLT_v8s16*//*Label 246*/ GIMT_Encode4(9337),
     /*   7250 */ /*GILLT_v8s32*//*Label 247*/ GIMT_Encode4(9555),
     /*   7254 */ /*GILLT_v8s64*//*Label 248*/ GIMT_Encode4(9746), GIMT_Encode4(0),
     /*   7262 */ /*GILLT_v16s8*//*Label 249*/ GIMT_Encode4(9840),
     /*   7266 */ /*GILLT_v16s16*//*Label 250*/ GIMT_Encode4(10058),
     /*   7270 */ /*GILLT_v16s32*//*Label 251*/ GIMT_Encode4(10249), GIMT_Encode4(0),
     /*   7278 */ /*GILLT_v32s8*//*Label 252*/ GIMT_Encode4(10343),
     /*   7282 */ /*GILLT_v32s16*//*Label 253*/ GIMT_Encode4(10534), GIMT_Encode4(0),
     /*   7290 */ /*GILLT_v64s8*//*Label 254*/ GIMT_Encode4(10628),
     /*   7294 */ // Label 239: @7294
     /*   7294 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(7645),
     /*   7299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*   7302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*   7305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7309 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(7370), // Rule ID 22805 //
     /*   7314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7329 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7336 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   7340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7349 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (SUB8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8rm),
     /*   7352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7354 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7356 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7368 */     GIR_RootConstrainSelectedInstOperands,
     /*   7369 */     // GIR_Coverage, 22805,
     /*   7369 */     GIR_EraseRootFromParent_Done,
     /*   7370 */   // Label 257: @7370
     /*   7370 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(7431), // Rule ID 22895 //
     /*   7375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7390 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7397 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   7401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7410 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (SUB8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8rm_ND),
     /*   7413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7415 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7417 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7429 */     GIR_RootConstrainSelectedInstOperands,
     /*   7430 */     // GIR_Coverage, 22895,
     /*   7430 */     GIR_EraseRootFromParent_Done,
     /*   7431 */   // Label 258: @7431
     /*   7431 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(7459), // Rule ID 241 //
     /*   7436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7447 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*   7447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r),
     /*   7450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7457 */     GIR_RootConstrainSelectedInstOperands,
     /*   7458 */     // GIR_Coverage, 241,
     /*   7458 */     GIR_EraseRootFromParent_Done,
     /*   7459 */   // Label 259: @7459
     /*   7459 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(7487), // Rule ID 249 //
     /*   7464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7475 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*   7475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_ND),
     /*   7478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7480 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7485 */     GIR_RootConstrainSelectedInstOperands,
     /*   7486 */     // GIR_Coverage, 249,
     /*   7486 */     GIR_EraseRootFromParent_Done,
     /*   7487 */   // Label 260: @7487
     /*   7487 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(7512), // Rule ID 257 //
     /*   7492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7503 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_NF_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*   7503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_NF_ND),
     /*   7506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7510 */     GIR_RootConstrainSelectedInstOperands,
     /*   7511 */     // GIR_Coverage, 257,
     /*   7511 */     GIR_EraseRootFromParent_Done,
     /*   7512 */   // Label 261: @7512
     /*   7512 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(7549), // Rule ID 22809 //
     /*   7517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7532 */     // MIs[1] Operand 1
     /*   7532 */     // No operand predicates
     /*   7532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7534 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   7534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri),
     /*   7537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7547 */     GIR_RootConstrainSelectedInstOperands,
     /*   7548 */     // GIR_Coverage, 22809,
     /*   7548 */     GIR_EraseRootFromParent_Done,
     /*   7549 */   // Label 262: @7549
     /*   7549 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(7586), // Rule ID 22899 //
     /*   7554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7569 */     // MIs[1] Operand 1
     /*   7569 */     // No operand predicates
     /*   7569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7571 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   7571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri_ND),
     /*   7574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7576 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7584 */     GIR_RootConstrainSelectedInstOperands,
     /*   7585 */     // GIR_Coverage, 22899,
     /*   7585 */     GIR_EraseRootFromParent_Done,
     /*   7586 */   // Label 263: @7586
     /*   7586 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(7615), // Rule ID 22801 //
     /*   7591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7602 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   7602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr),
     /*   7607 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7613 */     GIR_RootConstrainSelectedInstOperands,
     /*   7614 */     // GIR_Coverage, 22801,
     /*   7614 */     GIR_Done,
     /*   7615 */   // Label 264: @7615
     /*   7615 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(7644), // Rule ID 22891 //
     /*   7620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7631 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   7631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr_ND),
     /*   7636 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7642 */     GIR_RootConstrainSelectedInstOperands,
     /*   7643 */     // GIR_Coverage, 22891,
     /*   7643 */     GIR_Done,
     /*   7644 */   // Label 265: @7644
     /*   7644 */   GIM_Reject,
     /*   7645 */ // Label 256: @7645
     /*   7645 */ GIM_Reject,
     /*   7646 */ // Label 240: @7646
     /*   7646 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(7997),
     /*   7651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   7654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*   7657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7661 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(7722), // Rule ID 22806 //
     /*   7666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7681 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7684 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7688 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   7692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7701 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (SUB16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16rm),
     /*   7704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7706 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7708 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7720 */     GIR_RootConstrainSelectedInstOperands,
     /*   7721 */     // GIR_Coverage, 22806,
     /*   7721 */     GIR_EraseRootFromParent_Done,
     /*   7722 */   // Label 267: @7722
     /*   7722 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(7783), // Rule ID 22896 //
     /*   7727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7742 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7749 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   7753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7762 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (SUB16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16rm_ND),
     /*   7765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7767 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7769 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7781 */     GIR_RootConstrainSelectedInstOperands,
     /*   7782 */     // GIR_Coverage, 22896,
     /*   7782 */     GIR_EraseRootFromParent_Done,
     /*   7783 */   // Label 268: @7783
     /*   7783 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(7811), // Rule ID 242 //
     /*   7788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7799 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*   7799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r),
     /*   7802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7804 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7809 */     GIR_RootConstrainSelectedInstOperands,
     /*   7810 */     // GIR_Coverage, 242,
     /*   7810 */     GIR_EraseRootFromParent_Done,
     /*   7811 */   // Label 269: @7811
     /*   7811 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(7839), // Rule ID 250 //
     /*   7816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7827 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*   7827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_ND),
     /*   7830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7832 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7834 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7837 */     GIR_RootConstrainSelectedInstOperands,
     /*   7838 */     // GIR_Coverage, 250,
     /*   7838 */     GIR_EraseRootFromParent_Done,
     /*   7839 */   // Label 270: @7839
     /*   7839 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(7864), // Rule ID 258 //
     /*   7844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7855 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_NF_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*   7855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_NF_ND),
     /*   7858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7862 */     GIR_RootConstrainSelectedInstOperands,
     /*   7863 */     // GIR_Coverage, 258,
     /*   7863 */     GIR_EraseRootFromParent_Done,
     /*   7864 */   // Label 271: @7864
     /*   7864 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(7901), // Rule ID 22810 //
     /*   7869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7884 */     // MIs[1] Operand 1
     /*   7884 */     // No operand predicates
     /*   7884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7886 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   7886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*   7889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7891 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7899 */     GIR_RootConstrainSelectedInstOperands,
     /*   7900 */     // GIR_Coverage, 22810,
     /*   7900 */     GIR_EraseRootFromParent_Done,
     /*   7901 */   // Label 272: @7901
     /*   7901 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(7938), // Rule ID 22900 //
     /*   7906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7921 */     // MIs[1] Operand 1
     /*   7921 */     // No operand predicates
     /*   7921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7923 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   7923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*   7926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7936 */     GIR_RootConstrainSelectedInstOperands,
     /*   7937 */     // GIR_Coverage, 22900,
     /*   7937 */     GIR_EraseRootFromParent_Done,
     /*   7938 */   // Label 273: @7938
     /*   7938 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(7967), // Rule ID 22802 //
     /*   7943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7954 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   7954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr),
     /*   7959 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7965 */     GIR_RootConstrainSelectedInstOperands,
     /*   7966 */     // GIR_Coverage, 22802,
     /*   7966 */     GIR_Done,
     /*   7967 */   // Label 274: @7967
     /*   7967 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(7996), // Rule ID 22892 //
     /*   7972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7983 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   7983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr_ND),
     /*   7988 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7994 */     GIR_RootConstrainSelectedInstOperands,
     /*   7995 */     // GIR_Coverage, 22892,
     /*   7995 */     GIR_Done,
     /*   7996 */   // Label 275: @7996
     /*   7996 */   GIM_Reject,
     /*   7997 */ // Label 266: @7997
     /*   7997 */ GIM_Reject,
     /*   7998 */ // Label 241: @7998
     /*   7998 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(8349),
     /*   8003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   8006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   8009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8013 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(8074), // Rule ID 22807 //
     /*   8018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8033 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8036 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8040 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   8044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8053 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (SUB32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32rm),
     /*   8056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8058 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8060 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8072 */     GIR_RootConstrainSelectedInstOperands,
     /*   8073 */     // GIR_Coverage, 22807,
     /*   8073 */     GIR_EraseRootFromParent_Done,
     /*   8074 */   // Label 277: @8074
     /*   8074 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(8135), // Rule ID 22897 //
     /*   8079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8094 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8101 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   8105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8114 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (SUB32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32rm_ND),
     /*   8117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8119 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8133 */     GIR_RootConstrainSelectedInstOperands,
     /*   8134 */     // GIR_Coverage, 22897,
     /*   8134 */     GIR_EraseRootFromParent_Done,
     /*   8135 */   // Label 278: @8135
     /*   8135 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(8163), // Rule ID 243 //
     /*   8140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8151 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r),
     /*   8154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8161 */     GIR_RootConstrainSelectedInstOperands,
     /*   8162 */     // GIR_Coverage, 243,
     /*   8162 */     GIR_EraseRootFromParent_Done,
     /*   8163 */   // Label 279: @8163
     /*   8163 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(8191), // Rule ID 251 //
     /*   8168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8179 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_ND),
     /*   8182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8184 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8189 */     GIR_RootConstrainSelectedInstOperands,
     /*   8190 */     // GIR_Coverage, 251,
     /*   8190 */     GIR_EraseRootFromParent_Done,
     /*   8191 */   // Label 280: @8191
     /*   8191 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(8216), // Rule ID 259 //
     /*   8196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8207 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_NF_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_NF_ND),
     /*   8210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8212 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8214 */     GIR_RootConstrainSelectedInstOperands,
     /*   8215 */     // GIR_Coverage, 259,
     /*   8215 */     GIR_EraseRootFromParent_Done,
     /*   8216 */   // Label 281: @8216
     /*   8216 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8253), // Rule ID 22811 //
     /*   8221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8236 */     // MIs[1] Operand 1
     /*   8236 */     // No operand predicates
     /*   8236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8238 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   8238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*   8241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8251 */     GIR_RootConstrainSelectedInstOperands,
     /*   8252 */     // GIR_Coverage, 22811,
     /*   8252 */     GIR_EraseRootFromParent_Done,
     /*   8253 */   // Label 282: @8253
     /*   8253 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(8290), // Rule ID 22901 //
     /*   8258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8273 */     // MIs[1] Operand 1
     /*   8273 */     // No operand predicates
     /*   8273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8275 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   8275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*   8278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8280 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8288 */     GIR_RootConstrainSelectedInstOperands,
     /*   8289 */     // GIR_Coverage, 22901,
     /*   8289 */     GIR_EraseRootFromParent_Done,
     /*   8290 */   // Label 283: @8290
     /*   8290 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(8319), // Rule ID 22803 //
     /*   8295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8306 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   8306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr),
     /*   8311 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8317 */     GIR_RootConstrainSelectedInstOperands,
     /*   8318 */     // GIR_Coverage, 22803,
     /*   8318 */     GIR_Done,
     /*   8319 */   // Label 284: @8319
     /*   8319 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(8348), // Rule ID 22893 //
     /*   8324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8335 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   8335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr_ND),
     /*   8340 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8346 */     GIR_RootConstrainSelectedInstOperands,
     /*   8347 */     // GIR_Coverage, 22893,
     /*   8347 */     GIR_Done,
     /*   8348 */   // Label 285: @8348
     /*   8348 */   GIM_Reject,
     /*   8349 */ // Label 276: @8349
     /*   8349 */ GIM_Reject,
     /*   8350 */ // Label 242: @8350
     /*   8350 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(8709),
     /*   8355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   8358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   8361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8365 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(8426), // Rule ID 22808 //
     /*   8370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8385 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8405 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64rm),
     /*   8408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8410 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8424 */     GIR_RootConstrainSelectedInstOperands,
     /*   8425 */     // GIR_Coverage, 22808,
     /*   8425 */     GIR_EraseRootFromParent_Done,
     /*   8426 */   // Label 287: @8426
     /*   8426 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(8487), // Rule ID 22898 //
     /*   8431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8446 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8466 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64rm_ND),
     /*   8469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8471 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8473 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8485 */     GIR_RootConstrainSelectedInstOperands,
     /*   8486 */     // GIR_Coverage, 22898,
     /*   8486 */     GIR_EraseRootFromParent_Done,
     /*   8487 */   // Label 288: @8487
     /*   8487 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(8515), // Rule ID 244 //
     /*   8492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8503 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*   8503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r),
     /*   8506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8513 */     GIR_RootConstrainSelectedInstOperands,
     /*   8514 */     // GIR_Coverage, 244,
     /*   8514 */     GIR_EraseRootFromParent_Done,
     /*   8515 */   // Label 289: @8515
     /*   8515 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(8543), // Rule ID 252 //
     /*   8520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8531 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*   8531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_ND),
     /*   8534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8536 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8541 */     GIR_RootConstrainSelectedInstOperands,
     /*   8542 */     // GIR_Coverage, 252,
     /*   8542 */     GIR_EraseRootFromParent_Done,
     /*   8543 */   // Label 290: @8543
     /*   8543 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(8568), // Rule ID 260 //
     /*   8548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8559 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_NF_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*   8559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_NF_ND),
     /*   8562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8566 */     GIR_RootConstrainSelectedInstOperands,
     /*   8567 */     // GIR_Coverage, 260,
     /*   8567 */     GIR_EraseRootFromParent_Done,
     /*   8568 */   // Label 291: @8568
     /*   8568 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(8609), // Rule ID 22812 //
     /*   8573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   8592 */     // MIs[1] Operand 1
     /*   8592 */     // No operand predicates
     /*   8592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8594 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   8594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   8597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8599 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8607 */     GIR_RootConstrainSelectedInstOperands,
     /*   8608 */     // GIR_Coverage, 22812,
     /*   8608 */     GIR_EraseRootFromParent_Done,
     /*   8609 */   // Label 292: @8609
     /*   8609 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(8650), // Rule ID 22902 //
     /*   8614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   8633 */     // MIs[1] Operand 1
     /*   8633 */     // No operand predicates
     /*   8633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8635 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   8635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   8638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8640 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8648 */     GIR_RootConstrainSelectedInstOperands,
     /*   8649 */     // GIR_Coverage, 22902,
     /*   8649 */     GIR_EraseRootFromParent_Done,
     /*   8650 */   // Label 293: @8650
     /*   8650 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(8679), // Rule ID 22804 //
     /*   8655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8666 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   8666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr),
     /*   8671 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8677 */     GIR_RootConstrainSelectedInstOperands,
     /*   8678 */     // GIR_Coverage, 22804,
     /*   8678 */     GIR_Done,
     /*   8679 */   // Label 294: @8679
     /*   8679 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(8708), // Rule ID 22894 //
     /*   8684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8695 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   8695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr_ND),
     /*   8700 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8706 */     GIR_RootConstrainSelectedInstOperands,
     /*   8707 */     // GIR_Coverage, 22894,
     /*   8707 */     GIR_Done,
     /*   8708 */   // Label 295: @8708
     /*   8708 */   GIM_Reject,
     /*   8709 */ // Label 286: @8709
     /*   8709 */ GIM_Reject,
     /*   8710 */ // Label 243: @8710
     /*   8710 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(8927),
     /*   8715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   8721 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(8783), // Rule ID 2606 //
     /*   8726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   8729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8745 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8748 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8752 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8765 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQrm),
     /*   8768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8770 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8772 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8781 */     GIR_RootConstrainSelectedInstOperands,
     /*   8782 */     // GIR_Coverage, 2606,
     /*   8782 */     GIR_EraseRootFromParent_Done,
     /*   8783 */   // Label 297: @8783
     /*   8783 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(8845), // Rule ID 4743 //
     /*   8788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   8791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8807 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8814 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8827 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rm),
     /*   8830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8832 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8843 */     GIR_RootConstrainSelectedInstOperands,
     /*   8844 */     // GIR_Coverage, 4743,
     /*   8844 */     GIR_EraseRootFromParent_Done,
     /*   8845 */   // Label 298: @8845
     /*   8845 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(8872), // Rule ID 2605 //
     /*   8850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   8853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8865 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   8865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQrr),
     /*   8870 */     GIR_RootConstrainSelectedInstOperands,
     /*   8871 */     // GIR_Coverage, 2605,
     /*   8871 */     GIR_Done,
     /*   8872 */   // Label 299: @8872
     /*   8872 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(8899), // Rule ID 2607 //
     /*   8877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   8880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8892 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   8892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBQrr),
     /*   8897 */     GIR_RootConstrainSelectedInstOperands,
     /*   8898 */     // GIR_Coverage, 2607,
     /*   8898 */     GIR_Done,
     /*   8899 */   // Label 300: @8899
     /*   8899 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(8926), // Rule ID 4740 //
     /*   8904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   8907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8919 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPSUBQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*   8919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rr),
     /*   8924 */     GIR_RootConstrainSelectedInstOperands,
     /*   8925 */     // GIR_Coverage, 4740,
     /*   8925 */     GIR_Done,
     /*   8926 */   // Label 301: @8926
     /*   8926 */   GIM_Reject,
     /*   8927 */ // Label 296: @8927
     /*   8927 */ GIM_Reject,
     /*   8928 */ // Label 244: @8928
     /*   8928 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(9145),
     /*   8933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8939 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(9001), // Rule ID 2600 //
     /*   8944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   8947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8963 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8966 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8970 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8983 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDrm),
     /*   8986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8988 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8990 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8999 */     GIR_RootConstrainSelectedInstOperands,
     /*   9000 */     // GIR_Coverage, 2600,
     /*   9000 */     GIR_EraseRootFromParent_Done,
     /*   9001 */   // Label 303: @9001
     /*   9001 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(9063), // Rule ID 4770 //
     /*   9006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9025 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9028 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9032 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9045 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rm),
     /*   9048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9061 */     GIR_RootConstrainSelectedInstOperands,
     /*   9062 */     // GIR_Coverage, 4770,
     /*   9062 */     GIR_EraseRootFromParent_Done,
     /*   9063 */   // Label 304: @9063
     /*   9063 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(9090), // Rule ID 2599 //
     /*   9068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   9071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9083 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   9083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDrr),
     /*   9088 */     GIR_RootConstrainSelectedInstOperands,
     /*   9089 */     // GIR_Coverage, 2599,
     /*   9089 */     GIR_Done,
     /*   9090 */   // Label 305: @9090
     /*   9090 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(9117), // Rule ID 2601 //
     /*   9095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9110 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   9110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBDrr),
     /*   9115 */     GIR_RootConstrainSelectedInstOperands,
     /*   9116 */     // GIR_Coverage, 2601,
     /*   9116 */     GIR_Done,
     /*   9117 */   // Label 306: @9117
     /*   9117 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(9144), // Rule ID 4767 //
     /*   9122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9137 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPSUBDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*   9137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rr),
     /*   9142 */     GIR_RootConstrainSelectedInstOperands,
     /*   9143 */     // GIR_Coverage, 4767,
     /*   9143 */     GIR_Done,
     /*   9144 */   // Label 307: @9144
     /*   9144 */   GIM_Reject,
     /*   9145 */ // Label 302: @9145
     /*   9145 */ GIM_Reject,
     /*   9146 */ // Label 245: @9146
     /*   9146 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(9336),
     /*   9151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*   9154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*   9157 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(9219), // Rule ID 2610 //
     /*   9162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9201 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrm),
     /*   9204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9206 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9217 */     GIR_RootConstrainSelectedInstOperands,
     /*   9218 */     // GIR_Coverage, 2610,
     /*   9218 */     GIR_EraseRootFromParent_Done,
     /*   9219 */   // Label 309: @9219
     /*   9219 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(9281), // Rule ID 4734 //
     /*   9224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9243 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9250 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9263 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rm),
     /*   9266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9268 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9279 */     GIR_RootConstrainSelectedInstOperands,
     /*   9280 */     // GIR_Coverage, 4734,
     /*   9280 */     GIR_EraseRootFromParent_Done,
     /*   9281 */   // Label 310: @9281
     /*   9281 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(9308), // Rule ID 2609 //
     /*   9286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9301 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPSUBQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*   9301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrr),
     /*   9306 */     GIR_RootConstrainSelectedInstOperands,
     /*   9307 */     // GIR_Coverage, 2609,
     /*   9307 */     GIR_Done,
     /*   9308 */   // Label 311: @9308
     /*   9308 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(9335), // Rule ID 4731 //
     /*   9313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9328 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPSUBQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*   9328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rr),
     /*   9333 */     GIR_RootConstrainSelectedInstOperands,
     /*   9334 */     // GIR_Coverage, 4731,
     /*   9334 */     GIR_Done,
     /*   9335 */   // Label 312: @9335
     /*   9335 */   GIM_Reject,
     /*   9336 */ // Label 308: @9336
     /*   9336 */ GIM_Reject,
     /*   9337 */ // Label 246: @9337
     /*   9337 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(9554),
     /*   9342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9348 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(9410), // Rule ID 2594 //
     /*   9353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9372 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9392 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWrm),
     /*   9395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9397 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9399 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9408 */     GIR_RootConstrainSelectedInstOperands,
     /*   9409 */     // GIR_Coverage, 2594,
     /*   9409 */     GIR_EraseRootFromParent_Done,
     /*   9410 */   // Label 314: @9410
     /*   9410 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(9472), // Rule ID 4791 //
     /*   9415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9434 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9437 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9441 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9454 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rm),
     /*   9457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9470 */     GIR_RootConstrainSelectedInstOperands,
     /*   9471 */     // GIR_Coverage, 4791,
     /*   9471 */     GIR_EraseRootFromParent_Done,
     /*   9472 */   // Label 315: @9472
     /*   9472 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(9499), // Rule ID 2593 //
     /*   9477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9492 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   9492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWrr),
     /*   9497 */     GIR_RootConstrainSelectedInstOperands,
     /*   9498 */     // GIR_Coverage, 2593,
     /*   9498 */     GIR_Done,
     /*   9499 */   // Label 316: @9499
     /*   9499 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(9526), // Rule ID 2595 //
     /*   9504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9519 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   9519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBWrr),
     /*   9524 */     GIR_RootConstrainSelectedInstOperands,
     /*   9525 */     // GIR_Coverage, 2595,
     /*   9525 */     GIR_Done,
     /*   9526 */   // Label 317: @9526
     /*   9526 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(9553), // Rule ID 4788 //
     /*   9531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9546 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*   9546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rr),
     /*   9551 */     GIR_RootConstrainSelectedInstOperands,
     /*   9552 */     // GIR_Coverage, 4788,
     /*   9552 */     GIR_Done,
     /*   9553 */   // Label 318: @9553
     /*   9553 */   GIM_Reject,
     /*   9554 */ // Label 313: @9554
     /*   9554 */ GIM_Reject,
     /*   9555 */ // Label 247: @9555
     /*   9555 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(9745),
     /*   9560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*   9563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*   9566 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(9628), // Rule ID 2604 //
     /*   9571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9610 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrm),
     /*   9613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9615 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9617 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9626 */     GIR_RootConstrainSelectedInstOperands,
     /*   9627 */     // GIR_Coverage, 2604,
     /*   9627 */     GIR_EraseRootFromParent_Done,
     /*   9628 */   // Label 320: @9628
     /*   9628 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(9690), // Rule ID 4761 //
     /*   9633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9652 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9672 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rm),
     /*   9675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9688 */     GIR_RootConstrainSelectedInstOperands,
     /*   9689 */     // GIR_Coverage, 4761,
     /*   9689 */     GIR_EraseRootFromParent_Done,
     /*   9690 */   // Label 321: @9690
     /*   9690 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(9717), // Rule ID 2603 //
     /*   9695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9710 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSUBDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*   9710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrr),
     /*   9715 */     GIR_RootConstrainSelectedInstOperands,
     /*   9716 */     // GIR_Coverage, 2603,
     /*   9716 */     GIR_Done,
     /*   9717 */   // Label 322: @9717
     /*   9717 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(9744), // Rule ID 4758 //
     /*   9722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9737 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPSUBDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*   9737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rr),
     /*   9742 */     GIR_RootConstrainSelectedInstOperands,
     /*   9743 */     // GIR_Coverage, 4758,
     /*   9743 */     GIR_Done,
     /*   9744 */   // Label 323: @9744
     /*   9744 */   GIM_Reject,
     /*   9745 */ // Label 319: @9745
     /*   9745 */ GIM_Reject,
     /*   9746 */ // Label 248: @9746
     /*   9746 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(9839),
     /*   9751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*   9754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*   9757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9765 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(9819), // Rule ID 4725 //
     /*   9770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   9773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9781 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9788 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9801 */     // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrm),
     /*   9804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9806 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9808 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9817 */     GIR_RootConstrainSelectedInstOperands,
     /*   9818 */     // GIR_Coverage, 4725,
     /*   9818 */     GIR_EraseRootFromParent_Done,
     /*   9819 */   // Label 325: @9819
     /*   9819 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(9838), // Rule ID 4722 //
     /*   9824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   9827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9831 */     // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPSUBQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*   9831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrr),
     /*   9836 */     GIR_RootConstrainSelectedInstOperands,
     /*   9837 */     // GIR_Coverage, 4722,
     /*   9837 */     GIR_Done,
     /*   9838 */   // Label 326: @9838
     /*   9838 */   GIM_Reject,
     /*   9839 */ // Label 324: @9839
     /*   9839 */ GIM_Reject,
     /*   9840 */ // Label 249: @9840
     /*   9840 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(10057),
     /*   9845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   9848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   9851 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(9913), // Rule ID 2588 //
     /*   9856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9875 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9878 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9882 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9895 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBrm),
     /*   9898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9900 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9911 */     GIR_RootConstrainSelectedInstOperands,
     /*   9912 */     // GIR_Coverage, 2588,
     /*   9912 */     GIR_EraseRootFromParent_Done,
     /*   9913 */   // Label 328: @9913
     /*   9913 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(9975), // Rule ID 4809 //
     /*   9918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9937 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9944 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9957 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rm),
     /*   9960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9973 */     GIR_RootConstrainSelectedInstOperands,
     /*   9974 */     // GIR_Coverage, 4809,
     /*   9974 */     GIR_EraseRootFromParent_Done,
     /*   9975 */   // Label 329: @9975
     /*   9975 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(10002), // Rule ID 2587 //
     /*   9980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9995 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   9995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBrr),
     /*  10000 */     GIR_RootConstrainSelectedInstOperands,
     /*  10001 */     // GIR_Coverage, 2587,
     /*  10001 */     GIR_Done,
     /*  10002 */   // Label 330: @10002
     /*  10002 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(10029), // Rule ID 2589 //
     /*  10007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  10010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10022 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  10022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBBrr),
     /*  10027 */     GIR_RootConstrainSelectedInstOperands,
     /*  10028 */     // GIR_Coverage, 2589,
     /*  10028 */     GIR_Done,
     /*  10029 */   // Label 331: @10029
     /*  10029 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(10056), // Rule ID 4806 //
     /*  10034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10049 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  10049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rr),
     /*  10054 */     GIR_RootConstrainSelectedInstOperands,
     /*  10055 */     // GIR_Coverage, 4806,
     /*  10055 */     GIR_Done,
     /*  10056 */   // Label 332: @10056
     /*  10056 */   GIM_Reject,
     /*  10057 */ // Label 327: @10057
     /*  10057 */ GIM_Reject,
     /*  10058 */ // Label 250: @10058
     /*  10058 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(10248),
     /*  10063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  10066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  10069 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(10131), // Rule ID 2598 //
     /*  10074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10093 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10096 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10100 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10113 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrm),
     /*  10116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10118 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10120 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10129 */     GIR_RootConstrainSelectedInstOperands,
     /*  10130 */     // GIR_Coverage, 2598,
     /*  10130 */     GIR_EraseRootFromParent_Done,
     /*  10131 */   // Label 334: @10131
     /*  10131 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(10193), // Rule ID 4785 //
     /*  10136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10155 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10158 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10162 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10175 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rm),
     /*  10178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10182 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10191 */     GIR_RootConstrainSelectedInstOperands,
     /*  10192 */     // GIR_Coverage, 4785,
     /*  10192 */     GIR_EraseRootFromParent_Done,
     /*  10193 */   // Label 335: @10193
     /*  10193 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(10220), // Rule ID 2597 //
     /*  10198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10213 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  10213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrr),
     /*  10218 */     GIR_RootConstrainSelectedInstOperands,
     /*  10219 */     // GIR_Coverage, 2597,
     /*  10219 */     GIR_Done,
     /*  10220 */   // Label 336: @10220
     /*  10220 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(10247), // Rule ID 4782 //
     /*  10225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10240 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  10240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rr),
     /*  10245 */     GIR_RootConstrainSelectedInstOperands,
     /*  10246 */     // GIR_Coverage, 4782,
     /*  10246 */     GIR_Done,
     /*  10247 */   // Label 337: @10247
     /*  10247 */   GIM_Reject,
     /*  10248 */ // Label 333: @10248
     /*  10248 */ GIM_Reject,
     /*  10249 */ // Label 251: @10249
     /*  10249 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(10342),
     /*  10254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  10257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  10260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10268 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(10322), // Rule ID 4752 //
     /*  10273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10284 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10287 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10291 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10304 */     // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrm),
     /*  10307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10309 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10311 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10320 */     GIR_RootConstrainSelectedInstOperands,
     /*  10321 */     // GIR_Coverage, 4752,
     /*  10321 */     GIR_EraseRootFromParent_Done,
     /*  10322 */   // Label 339: @10322
     /*  10322 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(10341), // Rule ID 4749 //
     /*  10327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10334 */     // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPSUBDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  10334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrr),
     /*  10339 */     GIR_RootConstrainSelectedInstOperands,
     /*  10340 */     // GIR_Coverage, 4749,
     /*  10340 */     GIR_Done,
     /*  10341 */   // Label 340: @10341
     /*  10341 */   GIM_Reject,
     /*  10342 */ // Label 338: @10342
     /*  10342 */ GIM_Reject,
     /*  10343 */ // Label 252: @10343
     /*  10343 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(10533),
     /*  10348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  10351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  10354 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(10416), // Rule ID 2592 //
     /*  10359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10385 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10398 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrm),
     /*  10401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10403 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10405 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10414 */     GIR_RootConstrainSelectedInstOperands,
     /*  10415 */     // GIR_Coverage, 2592,
     /*  10415 */     GIR_EraseRootFromParent_Done,
     /*  10416 */   // Label 342: @10416
     /*  10416 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(10478), // Rule ID 4803 //
     /*  10421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10447 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10460 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rm),
     /*  10463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10465 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10467 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10476 */     GIR_RootConstrainSelectedInstOperands,
     /*  10477 */     // GIR_Coverage, 4803,
     /*  10477 */     GIR_EraseRootFromParent_Done,
     /*  10478 */   // Label 343: @10478
     /*  10478 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(10505), // Rule ID 2591 //
     /*  10483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10498 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  10498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrr),
     /*  10503 */     GIR_RootConstrainSelectedInstOperands,
     /*  10504 */     // GIR_Coverage, 2591,
     /*  10504 */     GIR_Done,
     /*  10505 */   // Label 344: @10505
     /*  10505 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(10532), // Rule ID 4800 //
     /*  10510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10525 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  10525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rr),
     /*  10530 */     GIR_RootConstrainSelectedInstOperands,
     /*  10531 */     // GIR_Coverage, 4800,
     /*  10531 */     GIR_Done,
     /*  10532 */   // Label 345: @10532
     /*  10532 */   GIM_Reject,
     /*  10533 */ // Label 341: @10533
     /*  10533 */ GIM_Reject,
     /*  10534 */ // Label 253: @10534
     /*  10534 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(10627),
     /*  10539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  10542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  10545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10553 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(10607), // Rule ID 4779 //
     /*  10558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10569 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10572 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10576 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10589 */     // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrm),
     /*  10592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10594 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10596 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10605 */     GIR_RootConstrainSelectedInstOperands,
     /*  10606 */     // GIR_Coverage, 4779,
     /*  10606 */     GIR_EraseRootFromParent_Done,
     /*  10607 */   // Label 347: @10607
     /*  10607 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(10626), // Rule ID 4776 //
     /*  10612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10619 */     // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  10619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrr),
     /*  10624 */     GIR_RootConstrainSelectedInstOperands,
     /*  10625 */     // GIR_Coverage, 4776,
     /*  10625 */     GIR_Done,
     /*  10626 */   // Label 348: @10626
     /*  10626 */   GIM_Reject,
     /*  10627 */ // Label 346: @10627
     /*  10627 */ GIM_Reject,
     /*  10628 */ // Label 254: @10628
     /*  10628 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(10721),
     /*  10633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  10636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  10639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10647 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(10701), // Rule ID 4797 //
     /*  10652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10663 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10670 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10683 */     // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrm),
     /*  10686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10688 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10690 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10699 */     GIR_RootConstrainSelectedInstOperands,
     /*  10700 */     // GIR_Coverage, 4797,
     /*  10700 */     GIR_EraseRootFromParent_Done,
     /*  10701 */   // Label 350: @10701
     /*  10701 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(10720), // Rule ID 4794 //
     /*  10706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10713 */     // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  10713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrr),
     /*  10718 */     GIR_RootConstrainSelectedInstOperands,
     /*  10719 */     // GIR_Coverage, 4794,
     /*  10719 */     GIR_Done,
     /*  10720 */   // Label 351: @10720
     /*  10720 */   GIM_Reject,
     /*  10721 */ // Label 349: @10721
     /*  10721 */ GIM_Reject,
     /*  10722 */ // Label 255: @10722
     /*  10722 */ GIM_Reject,
     /*  10723 */ // Label 2: @10723
     /*  10723 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 364*/ GIMT_Encode4(14505),
     /*  10734 */ /*GILLT_s16*//*Label 352*/ GIMT_Encode4(10818),
     /*  10738 */ /*GILLT_s32*//*Label 353*/ GIMT_Encode4(11235),
     /*  10742 */ /*GILLT_s64*//*Label 354*/ GIMT_Encode4(11652), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10758 */ /*GILLT_v2s64*//*Label 355*/ GIMT_Encode4(12077), GIMT_Encode4(0),
     /*  10766 */ /*GILLT_v4s32*//*Label 356*/ GIMT_Encode4(12406),
     /*  10770 */ /*GILLT_v4s64*//*Label 357*/ GIMT_Encode4(12748), GIMT_Encode4(0),
     /*  10778 */ /*GILLT_v8s16*//*Label 358*/ GIMT_Encode4(13065),
     /*  10782 */ /*GILLT_v8s32*//*Label 359*/ GIMT_Encode4(13407),
     /*  10786 */ /*GILLT_v8s64*//*Label 360*/ GIMT_Encode4(13722), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10798 */ /*GILLT_v16s16*//*Label 361*/ GIMT_Encode4(13878),
     /*  10802 */ /*GILLT_v16s32*//*Label 362*/ GIMT_Encode4(14193), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10814 */ /*GILLT_v32s16*//*Label 363*/ GIMT_Encode4(14349),
     /*  10818 */ // Label 352: @10818
     /*  10818 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(11234),
     /*  10823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  10826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  10829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  10833 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(10897), // Rule ID 22976 //
     /*  10838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10849 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10853 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  10857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  10861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10865 */     // MIs[2] Operand 1
     /*  10865 */     // No operand predicates
     /*  10865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10874 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  10874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rmi),
     /*  10877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10879 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  10883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  10886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  10889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  10895 */     GIR_RootConstrainSelectedInstOperands,
     /*  10896 */     // GIR_Coverage, 22976,
     /*  10896 */     GIR_EraseRootFromParent_Done,
     /*  10897 */   // Label 366: @10897
     /*  10897 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(10958), // Rule ID 26055 //
     /*  10902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  10905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10916 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10920 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  10924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  10928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10937 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (IMUL16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm),
     /*  10940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10942 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10944 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  10951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10956 */     GIR_RootConstrainSelectedInstOperands,
     /*  10957 */     // GIR_Coverage, 26055,
     /*  10957 */     GIR_EraseRootFromParent_Done,
     /*  10958 */   // Label 367: @10958
     /*  10958 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(11019), // Rule ID 26074 //
     /*  10963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  10966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10977 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10981 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  10985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  10989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10991 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10998 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (IMUL16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm_ND),
     /*  11001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11003 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11017 */     GIR_RootConstrainSelectedInstOperands,
     /*  11018 */     // GIR_Coverage, 26074,
     /*  11018 */     GIR_EraseRootFromParent_Done,
     /*  11019 */   // Label 368: @11019
     /*  11019 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(11080), // Rule ID 22820 //
     /*  11024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11039 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11042 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11046 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11059 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (IMUL16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm),
     /*  11062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11064 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11066 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11078 */     GIR_RootConstrainSelectedInstOperands,
     /*  11079 */     // GIR_Coverage, 22820,
     /*  11079 */     GIR_EraseRootFromParent_Done,
     /*  11080 */   // Label 369: @11080
     /*  11080 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(11141), // Rule ID 22910 //
     /*  11085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11103 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11107 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11120 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (IMUL16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm_ND),
     /*  11123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11125 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11139 */     GIR_RootConstrainSelectedInstOperands,
     /*  11140 */     // GIR_Coverage, 22910,
     /*  11140 */     GIR_EraseRootFromParent_Done,
     /*  11141 */   // Label 370: @11141
     /*  11141 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(11175), // Rule ID 22973 //
     /*  11146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11158 */     // MIs[1] Operand 1
     /*  11158 */     // No operand predicates
     /*  11158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11160 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  11160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rri),
     /*  11163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  11170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11173 */     GIR_RootConstrainSelectedInstOperands,
     /*  11174 */     // GIR_Coverage, 22973,
     /*  11174 */     GIR_EraseRootFromParent_Done,
     /*  11175 */   // Label 371: @11175
     /*  11175 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(11204), // Rule ID 22817 //
     /*  11180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11191 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  11191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr),
     /*  11196 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11202 */     GIR_RootConstrainSelectedInstOperands,
     /*  11203 */     // GIR_Coverage, 22817,
     /*  11203 */     GIR_Done,
     /*  11204 */   // Label 372: @11204
     /*  11204 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(11233), // Rule ID 22907 //
     /*  11209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11220 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  11220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr_ND),
     /*  11225 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11231 */     GIR_RootConstrainSelectedInstOperands,
     /*  11232 */     // GIR_Coverage, 22907,
     /*  11232 */     GIR_Done,
     /*  11233 */   // Label 373: @11233
     /*  11233 */   GIM_Reject,
     /*  11234 */ // Label 365: @11234
     /*  11234 */ GIM_Reject,
     /*  11235 */ // Label 353: @11235
     /*  11235 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(11651),
     /*  11240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  11243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  11246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11250 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(11314), // Rule ID 22977 //
     /*  11255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11263 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11266 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11270 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11282 */     // MIs[2] Operand 1
     /*  11282 */     // No operand predicates
     /*  11282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11291 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rmi:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  11291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rmi),
     /*  11294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11312 */     GIR_RootConstrainSelectedInstOperands,
     /*  11313 */     // GIR_Coverage, 22977,
     /*  11313 */     GIR_EraseRootFromParent_Done,
     /*  11314 */   // Label 375: @11314
     /*  11314 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(11375), // Rule ID 26056 //
     /*  11319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11330 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11333 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11337 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11354 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (IMUL32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm),
     /*  11357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11359 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11361 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11373 */     GIR_RootConstrainSelectedInstOperands,
     /*  11374 */     // GIR_Coverage, 26056,
     /*  11374 */     GIR_EraseRootFromParent_Done,
     /*  11375 */   // Label 376: @11375
     /*  11375 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(11436), // Rule ID 26075 //
     /*  11380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11391 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11398 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11415 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (IMUL32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm_ND),
     /*  11418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11434 */     GIR_RootConstrainSelectedInstOperands,
     /*  11435 */     // GIR_Coverage, 26075,
     /*  11435 */     GIR_EraseRootFromParent_Done,
     /*  11436 */   // Label 377: @11436
     /*  11436 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(11497), // Rule ID 22821 //
     /*  11441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11456 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11463 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11476 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (IMUL32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm),
     /*  11479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11481 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11495 */     GIR_RootConstrainSelectedInstOperands,
     /*  11496 */     // GIR_Coverage, 22821,
     /*  11496 */     GIR_EraseRootFromParent_Done,
     /*  11497 */   // Label 378: @11497
     /*  11497 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(11558), // Rule ID 22911 //
     /*  11502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11517 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11520 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11524 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11537 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (IMUL32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm_ND),
     /*  11540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11542 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11544 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11556 */     GIR_RootConstrainSelectedInstOperands,
     /*  11557 */     // GIR_Coverage, 22911,
     /*  11557 */     GIR_EraseRootFromParent_Done,
     /*  11558 */   // Label 379: @11558
     /*  11558 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(11592), // Rule ID 22974 //
     /*  11563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11575 */     // MIs[1] Operand 1
     /*  11575 */     // No operand predicates
     /*  11575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11577 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  11577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rri),
     /*  11580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11582 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  11587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11590 */     GIR_RootConstrainSelectedInstOperands,
     /*  11591 */     // GIR_Coverage, 22974,
     /*  11591 */     GIR_EraseRootFromParent_Done,
     /*  11592 */   // Label 380: @11592
     /*  11592 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(11621), // Rule ID 22818 //
     /*  11597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11608 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  11608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr),
     /*  11613 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11619 */     GIR_RootConstrainSelectedInstOperands,
     /*  11620 */     // GIR_Coverage, 22818,
     /*  11620 */     GIR_Done,
     /*  11621 */   // Label 381: @11621
     /*  11621 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(11650), // Rule ID 22908 //
     /*  11626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11637 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  11637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr_ND),
     /*  11642 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11648 */     GIR_RootConstrainSelectedInstOperands,
     /*  11649 */     // GIR_Coverage, 22908,
     /*  11649 */     GIR_Done,
     /*  11650 */   // Label 382: @11650
     /*  11650 */   GIM_Reject,
     /*  11651 */ // Label 374: @11651
     /*  11651 */ GIM_Reject,
     /*  11652 */ // Label 354: @11652
     /*  11652 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(12076),
     /*  11657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11667 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(11735), // Rule ID 22978 //
     /*  11672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11680 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11687 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11699 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  11703 */     // MIs[2] Operand 1
     /*  11703 */     // No operand predicates
     /*  11703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11712 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rmi32:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  11712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rmi32),
     /*  11715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11717 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11733 */     GIR_RootConstrainSelectedInstOperands,
     /*  11734 */     // GIR_Coverage, 22978,
     /*  11734 */     GIR_EraseRootFromParent_Done,
     /*  11735 */   // Label 384: @11735
     /*  11735 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(11796), // Rule ID 26057 //
     /*  11740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11751 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11754 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11758 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11775 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (IMUL64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm),
     /*  11778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11780 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11782 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11794 */     GIR_RootConstrainSelectedInstOperands,
     /*  11795 */     // GIR_Coverage, 26057,
     /*  11795 */     GIR_EraseRootFromParent_Done,
     /*  11796 */   // Label 385: @11796
     /*  11796 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(11857), // Rule ID 26076 //
     /*  11801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11836 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (IMUL64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm_ND),
     /*  11839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11841 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11843 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11855 */     GIR_RootConstrainSelectedInstOperands,
     /*  11856 */     // GIR_Coverage, 26076,
     /*  11856 */     GIR_EraseRootFromParent_Done,
     /*  11857 */   // Label 386: @11857
     /*  11857 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(11918), // Rule ID 22822 //
     /*  11862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11877 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11880 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11884 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11897 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (IMUL64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm),
     /*  11900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11902 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11904 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11916 */     GIR_RootConstrainSelectedInstOperands,
     /*  11917 */     // GIR_Coverage, 22822,
     /*  11917 */     GIR_EraseRootFromParent_Done,
     /*  11918 */   // Label 387: @11918
     /*  11918 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(11979), // Rule ID 22912 //
     /*  11923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11938 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11941 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11945 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11958 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (IMUL64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm_ND),
     /*  11961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11963 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11977 */     GIR_RootConstrainSelectedInstOperands,
     /*  11978 */     // GIR_Coverage, 22912,
     /*  11978 */     GIR_EraseRootFromParent_Done,
     /*  11979 */   // Label 388: @11979
     /*  11979 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(12017), // Rule ID 22975 //
     /*  11984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  12000 */     // MIs[1] Operand 1
     /*  12000 */     // No operand predicates
     /*  12000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12002 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  12002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rri32),
     /*  12005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  12012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12015 */     GIR_RootConstrainSelectedInstOperands,
     /*  12016 */     // GIR_Coverage, 22975,
     /*  12016 */     GIR_EraseRootFromParent_Done,
     /*  12017 */   // Label 389: @12017
     /*  12017 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(12046), // Rule ID 22819 //
     /*  12022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  12025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12033 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  12033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr),
     /*  12038 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  12044 */     GIR_RootConstrainSelectedInstOperands,
     /*  12045 */     // GIR_Coverage, 22819,
     /*  12045 */     GIR_Done,
     /*  12046 */   // Label 390: @12046
     /*  12046 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(12075), // Rule ID 22909 //
     /*  12051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  12054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12062 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  12062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr_ND),
     /*  12067 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  12073 */     GIR_RootConstrainSelectedInstOperands,
     /*  12074 */     // GIR_Coverage, 22909,
     /*  12074 */     GIR_Done,
     /*  12075 */   // Label 391: @12075
     /*  12075 */   GIM_Reject,
     /*  12076 */ // Label 383: @12076
     /*  12076 */ GIM_Reject,
     /*  12077 */ // Label 355: @12077
     /*  12077 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(12405),
     /*  12082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  12085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  12088 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(12150), // Rule ID 23822 //
     /*  12093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12108 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12111 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12115 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12132 */     // (mul:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMULLQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rm),
     /*  12135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12137 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12139 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12148 */     GIR_RootConstrainSelectedInstOperands,
     /*  12149 */     // GIR_Coverage, 23822,
     /*  12149 */     GIR_EraseRootFromParent_Done,
     /*  12150 */   // Label 393: @12150
     /*  12150 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(12212), // Rule ID 5022 //
     /*  12155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12194 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rm),
     /*  12197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12201 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12210 */     GIR_RootConstrainSelectedInstOperands,
     /*  12211 */     // GIR_Coverage, 5022,
     /*  12211 */     GIR_EraseRootFromParent_Done,
     /*  12212 */   // Label 394: @12212
     /*  12212 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(12239), // Rule ID 5019 //
     /*  12217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12232 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMULLQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  12232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rr),
     /*  12237 */     GIR_RootConstrainSelectedInstOperands,
     /*  12238 */     // GIR_Coverage, 5019,
     /*  12238 */     GIR_Done,
     /*  12239 */   // Label 395: @12239
     /*  12239 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(12404), // Rule ID 19997 //
     /*  12244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  12247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  12251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12259 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /*  12259 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  12262 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12266 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  12273 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  12276 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12280 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12285 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  12288 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  12292 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  12295 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12300 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12305 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  12310 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  12313 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12317 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12324 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  12327 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12331 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12336 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  12343 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  12346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  12361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  12364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  12368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12376 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  12379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12386 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  12393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  12398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12403 */     // GIR_Coverage, 19997,
     /*  12403 */     GIR_EraseRootFromParent_Done,
     /*  12404 */   // Label 396: @12404
     /*  12404 */   GIM_Reject,
     /*  12405 */ // Label 392: @12405
     /*  12405 */ GIM_Reject,
     /*  12406 */ // Label 356: @12406
     /*  12406 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(12747),
     /*  12411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12417 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(12479), // Rule ID 23525 //
     /*  12422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12437 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12444 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12461 */     // (mul:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMULLDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDrm),
     /*  12464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12466 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12477 */     GIR_RootConstrainSelectedInstOperands,
     /*  12478 */     // GIR_Coverage, 23525,
     /*  12478 */     GIR_EraseRootFromParent_Done,
     /*  12479 */   // Label 398: @12479
     /*  12479 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(12541), // Rule ID 23795 //
     /*  12484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12499 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12502 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12506 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12523 */     // (mul:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMULLDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rm),
     /*  12526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12528 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12539 */     GIR_RootConstrainSelectedInstOperands,
     /*  12540 */     // GIR_Coverage, 23795,
     /*  12540 */     GIR_EraseRootFromParent_Done,
     /*  12541 */   // Label 399: @12541
     /*  12541 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(12603), // Rule ID 3239 //
     /*  12546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12565 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12568 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12572 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12585 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDrm),
     /*  12588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12590 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12592 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12601 */     GIR_RootConstrainSelectedInstOperands,
     /*  12602 */     // GIR_Coverage, 3239,
     /*  12602 */     GIR_EraseRootFromParent_Done,
     /*  12603 */   // Label 400: @12603
     /*  12603 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(12665), // Rule ID 4977 //
     /*  12608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12627 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12634 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12647 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rm),
     /*  12650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12652 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12654 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12663 */     GIR_RootConstrainSelectedInstOperands,
     /*  12664 */     // GIR_Coverage, 4977,
     /*  12664 */     GIR_EraseRootFromParent_Done,
     /*  12665 */   // Label 401: @12665
     /*  12665 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(12692), // Rule ID 3238 //
     /*  12670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12685 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  12685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDrr),
     /*  12690 */     GIR_RootConstrainSelectedInstOperands,
     /*  12691 */     // GIR_Coverage, 3238,
     /*  12691 */     GIR_Done,
     /*  12692 */   // Label 402: @12692
     /*  12692 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(12719), // Rule ID 3246 //
     /*  12697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  12700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12712 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  12712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLDrr),
     /*  12717 */     GIR_RootConstrainSelectedInstOperands,
     /*  12718 */     // GIR_Coverage, 3246,
     /*  12718 */     GIR_Done,
     /*  12719 */   // Label 403: @12719
     /*  12719 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(12746), // Rule ID 4974 //
     /*  12724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12739 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMULLDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  12739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rr),
     /*  12744 */     GIR_RootConstrainSelectedInstOperands,
     /*  12745 */     // GIR_Coverage, 4974,
     /*  12745 */     GIR_Done,
     /*  12746 */   // Label 404: @12746
     /*  12746 */   GIM_Reject,
     /*  12747 */ // Label 397: @12747
     /*  12747 */ GIM_Reject,
     /*  12748 */ // Label 357: @12748
     /*  12748 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(13064),
     /*  12753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  12756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  12759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12763 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(12821), // Rule ID 23816 //
     /*  12768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12779 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12782 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12786 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12803 */     // (mul:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMULLQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rm),
     /*  12806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12808 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12819 */     GIR_RootConstrainSelectedInstOperands,
     /*  12820 */     // GIR_Coverage, 23816,
     /*  12820 */     GIR_EraseRootFromParent_Done,
     /*  12821 */   // Label 406: @12821
     /*  12821 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(12879), // Rule ID 5013 //
     /*  12826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12841 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12861 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rm),
     /*  12864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12866 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12877 */     GIR_RootConstrainSelectedInstOperands,
     /*  12878 */     // GIR_Coverage, 5013,
     /*  12878 */     GIR_EraseRootFromParent_Done,
     /*  12879 */   // Label 407: @12879
     /*  12879 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(12902), // Rule ID 5010 //
     /*  12884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12895 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMULLQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  12895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rr),
     /*  12900 */     GIR_RootConstrainSelectedInstOperands,
     /*  12901 */     // GIR_Coverage, 5010,
     /*  12901 */     GIR_Done,
     /*  12902 */   // Label 408: @12902
     /*  12902 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(13063), // Rule ID 19995 //
     /*  12907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  12910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12918 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /*  12918 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  12921 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12925 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  12932 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  12935 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12939 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12944 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  12947 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  12951 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  12954 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12959 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12964 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  12969 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  12972 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12976 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  12986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12995 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12998 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  13002 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  13005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  13010 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  13023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  13027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13035 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  13038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13045 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  13052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13062 */     // GIR_Coverage, 19995,
     /*  13062 */     GIR_EraseRootFromParent_Done,
     /*  13063 */   // Label 409: @13063
     /*  13063 */   GIM_Reject,
     /*  13064 */ // Label 405: @13064
     /*  13064 */ GIM_Reject,
     /*  13065 */ // Label 358: @13065
     /*  13065 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(13406),
     /*  13070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13076 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(13138), // Rule ID 23450 //
     /*  13081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13096 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13099 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13103 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13120 */     // (mul:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULLWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWrm),
     /*  13123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13136 */     GIR_RootConstrainSelectedInstOperands,
     /*  13137 */     // GIR_Coverage, 23450,
     /*  13137 */     GIR_EraseRootFromParent_Done,
     /*  13138 */   // Label 411: @13138
     /*  13138 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(13200), // Rule ID 23807 //
     /*  13143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13158 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13165 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13182 */     // (mul:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULLWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rm),
     /*  13185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13187 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13189 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13198 */     GIR_RootConstrainSelectedInstOperands,
     /*  13199 */     // GIR_Coverage, 23807,
     /*  13199 */     GIR_EraseRootFromParent_Done,
     /*  13200 */   // Label 412: @13200
     /*  13200 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(13262), // Rule ID 2570 //
     /*  13205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13224 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13227 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13244 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWrm),
     /*  13247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13249 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13251 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13260 */     GIR_RootConstrainSelectedInstOperands,
     /*  13261 */     // GIR_Coverage, 2570,
     /*  13261 */     GIR_EraseRootFromParent_Done,
     /*  13262 */   // Label 413: @13262
     /*  13262 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(13324), // Rule ID 4998 //
     /*  13267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13306 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rm),
     /*  13309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13311 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13313 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13322 */     GIR_RootConstrainSelectedInstOperands,
     /*  13323 */     // GIR_Coverage, 4998,
     /*  13323 */     GIR_EraseRootFromParent_Done,
     /*  13324 */   // Label 414: @13324
     /*  13324 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(13351), // Rule ID 2569 //
     /*  13329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13344 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  13344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWrr),
     /*  13349 */     GIR_RootConstrainSelectedInstOperands,
     /*  13350 */     // GIR_Coverage, 2569,
     /*  13350 */     GIR_Done,
     /*  13351 */   // Label 415: @13351
     /*  13351 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(13378), // Rule ID 2571 //
     /*  13356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  13359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13371 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  13371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLWrr),
     /*  13376 */     GIR_RootConstrainSelectedInstOperands,
     /*  13377 */     // GIR_Coverage, 2571,
     /*  13377 */     GIR_Done,
     /*  13378 */   // Label 416: @13378
     /*  13378 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(13405), // Rule ID 4995 //
     /*  13383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13398 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULLWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  13398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rr),
     /*  13403 */     GIR_RootConstrainSelectedInstOperands,
     /*  13404 */     // GIR_Coverage, 4995,
     /*  13404 */     GIR_Done,
     /*  13405 */   // Label 417: @13405
     /*  13405 */   GIM_Reject,
     /*  13406 */ // Label 410: @13406
     /*  13406 */ GIM_Reject,
     /*  13407 */ // Label 359: @13407
     /*  13407 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(13721),
     /*  13412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  13415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  13418 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(13480), // Rule ID 23527 //
     /*  13423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13438 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13445 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13462 */     // (mul:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMULLDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrm),
     /*  13465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13467 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13478 */     GIR_RootConstrainSelectedInstOperands,
     /*  13479 */     // GIR_Coverage, 23527,
     /*  13479 */     GIR_EraseRootFromParent_Done,
     /*  13480 */   // Label 419: @13480
     /*  13480 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(13542), // Rule ID 23789 //
     /*  13485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13503 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13507 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13524 */     // (mul:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMULLDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rm),
     /*  13527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13540 */     GIR_RootConstrainSelectedInstOperands,
     /*  13541 */     // GIR_Coverage, 23789,
     /*  13541 */     GIR_EraseRootFromParent_Done,
     /*  13542 */   // Label 420: @13542
     /*  13542 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(13604), // Rule ID 3243 //
     /*  13547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13566 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13569 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13573 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13586 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrm),
     /*  13589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13591 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13593 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13602 */     GIR_RootConstrainSelectedInstOperands,
     /*  13603 */     // GIR_Coverage, 3243,
     /*  13603 */     GIR_EraseRootFromParent_Done,
     /*  13604 */   // Label 421: @13604
     /*  13604 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(13666), // Rule ID 4968 //
     /*  13609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13648 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rm),
     /*  13651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13655 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13664 */     GIR_RootConstrainSelectedInstOperands,
     /*  13665 */     // GIR_Coverage, 4968,
     /*  13665 */     GIR_EraseRootFromParent_Done,
     /*  13666 */   // Label 422: @13666
     /*  13666 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(13693), // Rule ID 3242 //
     /*  13671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13686 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMULLDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  13686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrr),
     /*  13691 */     GIR_RootConstrainSelectedInstOperands,
     /*  13692 */     // GIR_Coverage, 3242,
     /*  13692 */     GIR_Done,
     /*  13693 */   // Label 423: @13693
     /*  13693 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(13720), // Rule ID 4965 //
     /*  13698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13713 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMULLDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  13713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rr),
     /*  13718 */     GIR_RootConstrainSelectedInstOperands,
     /*  13719 */     // GIR_Coverage, 4965,
     /*  13719 */     GIR_Done,
     /*  13720 */   // Label 424: @13720
     /*  13720 */   GIM_Reject,
     /*  13721 */ // Label 418: @13721
     /*  13721 */ GIM_Reject,
     /*  13722 */ // Label 360: @13722
     /*  13722 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(13877),
     /*  13727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  13730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  13733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13737 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(13795), // Rule ID 23810 //
     /*  13742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  13745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13777 */     // (mul:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMULLQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrm),
     /*  13780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13782 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13793 */     GIR_RootConstrainSelectedInstOperands,
     /*  13794 */     // GIR_Coverage, 23810,
     /*  13794 */     GIR_EraseRootFromParent_Done,
     /*  13795 */   // Label 426: @13795
     /*  13795 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(13853), // Rule ID 5004 //
     /*  13800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  13803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13815 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13822 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13835 */     // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrm),
     /*  13838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13840 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13842 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13851 */     GIR_RootConstrainSelectedInstOperands,
     /*  13852 */     // GIR_Coverage, 5004,
     /*  13852 */     GIR_EraseRootFromParent_Done,
     /*  13853 */   // Label 427: @13853
     /*  13853 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(13876), // Rule ID 5001 //
     /*  13858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  13861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13869 */     // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMULLQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  13869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  13874 */     GIR_RootConstrainSelectedInstOperands,
     /*  13875 */     // GIR_Coverage, 5001,
     /*  13875 */     GIR_Done,
     /*  13876 */   // Label 428: @13876
     /*  13876 */   GIM_Reject,
     /*  13877 */ // Label 425: @13877
     /*  13877 */ GIM_Reject,
     /*  13878 */ // Label 361: @13878
     /*  13878 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(14192),
     /*  13883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  13886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  13889 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(13951), // Rule ID 23452 //
     /*  13894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  13897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13909 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13912 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13916 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13933 */     // (mul:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULLWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrm),
     /*  13936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13938 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13949 */     GIR_RootConstrainSelectedInstOperands,
     /*  13950 */     // GIR_Coverage, 23452,
     /*  13950 */     GIR_EraseRootFromParent_Done,
     /*  13951 */   // Label 430: @13951
     /*  13951 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(14013), // Rule ID 23804 //
     /*  13956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13971 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13974 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13978 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13995 */     // (mul:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULLWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rm),
     /*  13998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14011 */     GIR_RootConstrainSelectedInstOperands,
     /*  14012 */     // GIR_Coverage, 23804,
     /*  14012 */     GIR_EraseRootFromParent_Done,
     /*  14013 */   // Label 431: @14013
     /*  14013 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(14075), // Rule ID 2574 //
     /*  14018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14037 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14057 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrm),
     /*  14060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14064 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14073 */     GIR_RootConstrainSelectedInstOperands,
     /*  14074 */     // GIR_Coverage, 2574,
     /*  14074 */     GIR_EraseRootFromParent_Done,
     /*  14075 */   // Label 432: @14075
     /*  14075 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(14137), // Rule ID 4992 //
     /*  14080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14099 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14102 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14106 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14119 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rm),
     /*  14122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14124 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14135 */     GIR_RootConstrainSelectedInstOperands,
     /*  14136 */     // GIR_Coverage, 4992,
     /*  14136 */     GIR_EraseRootFromParent_Done,
     /*  14137 */   // Label 433: @14137
     /*  14137 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(14164), // Rule ID 2573 //
     /*  14142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14157 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULLWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  14157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrr),
     /*  14162 */     GIR_RootConstrainSelectedInstOperands,
     /*  14163 */     // GIR_Coverage, 2573,
     /*  14163 */     GIR_Done,
     /*  14164 */   // Label 434: @14164
     /*  14164 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(14191), // Rule ID 4989 //
     /*  14169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14184 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULLWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  14184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rr),
     /*  14189 */     GIR_RootConstrainSelectedInstOperands,
     /*  14190 */     // GIR_Coverage, 4989,
     /*  14190 */     GIR_Done,
     /*  14191 */   // Label 435: @14191
     /*  14191 */   GIM_Reject,
     /*  14192 */ // Label 429: @14192
     /*  14192 */ GIM_Reject,
     /*  14193 */ // Label 362: @14193
     /*  14193 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(14348),
     /*  14198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  14201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  14204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14208 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(14266), // Rule ID 23783 //
     /*  14213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14224 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14227 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14248 */     // (mul:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMULLDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrm),
     /*  14251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14255 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14264 */     GIR_RootConstrainSelectedInstOperands,
     /*  14265 */     // GIR_Coverage, 23783,
     /*  14265 */     GIR_EraseRootFromParent_Done,
     /*  14266 */   // Label 437: @14266
     /*  14266 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(14324), // Rule ID 4959 //
     /*  14271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14306 */     // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrm),
     /*  14309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14311 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14313 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14322 */     GIR_RootConstrainSelectedInstOperands,
     /*  14323 */     // GIR_Coverage, 4959,
     /*  14323 */     GIR_EraseRootFromParent_Done,
     /*  14324 */   // Label 438: @14324
     /*  14324 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(14347), // Rule ID 4956 //
     /*  14329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14340 */     // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMULLDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  14340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrr),
     /*  14345 */     GIR_RootConstrainSelectedInstOperands,
     /*  14346 */     // GIR_Coverage, 4956,
     /*  14346 */     GIR_Done,
     /*  14347 */   // Label 439: @14347
     /*  14347 */   GIM_Reject,
     /*  14348 */ // Label 436: @14348
     /*  14348 */ GIM_Reject,
     /*  14349 */ // Label 363: @14349
     /*  14349 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(14504),
     /*  14354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  14357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  14360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14364 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(14422), // Rule ID 23801 //
     /*  14369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14380 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14383 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14387 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14404 */     // (mul:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULLWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrm),
     /*  14407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14409 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14411 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14420 */     GIR_RootConstrainSelectedInstOperands,
     /*  14421 */     // GIR_Coverage, 23801,
     /*  14421 */     GIR_EraseRootFromParent_Done,
     /*  14422 */   // Label 441: @14422
     /*  14422 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(14480), // Rule ID 4986 //
     /*  14427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14442 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14445 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14449 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14462 */     // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrm),
     /*  14465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14478 */     GIR_RootConstrainSelectedInstOperands,
     /*  14479 */     // GIR_Coverage, 4986,
     /*  14479 */     GIR_EraseRootFromParent_Done,
     /*  14480 */   // Label 442: @14480
     /*  14480 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(14503), // Rule ID 4983 //
     /*  14485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14496 */     // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULLWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  14496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrr),
     /*  14501 */     GIR_RootConstrainSelectedInstOperands,
     /*  14502 */     // GIR_Coverage, 4983,
     /*  14502 */     GIR_Done,
     /*  14503 */   // Label 443: @14503
     /*  14503 */   GIM_Reject,
     /*  14504 */ // Label 440: @14504
     /*  14504 */ GIM_Reject,
     /*  14505 */ // Label 364: @14505
     /*  14505 */ GIM_Reject,
     /*  14506 */ // Label 3: @14506
     /*  14506 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 467*/ GIMT_Encode4(25097),
     /*  14517 */ /*GILLT_s1*//*Label 444*/ GIMT_Encode4(14617),
     /*  14521 */ /*GILLT_s8*//*Label 445*/ GIMT_Encode4(14963),
     /*  14525 */ /*GILLT_s16*//*Label 446*/ GIMT_Encode4(15356),
     /*  14529 */ /*GILLT_s32*//*Label 447*/ GIMT_Encode4(16041),
     /*  14533 */ /*GILLT_s64*//*Label 448*/ GIMT_Encode4(17867), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14545 */ /*GILLT_v2s1*//*Label 449*/ GIMT_Encode4(19571),
     /*  14549 */ /*GILLT_v2s64*//*Label 450*/ GIMT_Encode4(19917),
     /*  14553 */ /*GILLT_v4s1*//*Label 451*/ GIMT_Encode4(20259),
     /*  14557 */ /*GILLT_v4s32*//*Label 452*/ GIMT_Encode4(20605),
     /*  14561 */ /*GILLT_v4s64*//*Label 453*/ GIMT_Encode4(20947),
     /*  14565 */ /*GILLT_v8s1*//*Label 454*/ GIMT_Encode4(21413),
     /*  14569 */ /*GILLT_v8s16*//*Label 455*/ GIMT_Encode4(21911),
     /*  14573 */ /*GILLT_v8s32*//*Label 456*/ GIMT_Encode4(22253),
     /*  14577 */ /*GILLT_v8s64*//*Label 457*/ GIMT_Encode4(22719),
     /*  14581 */ /*GILLT_v16s1*//*Label 458*/ GIMT_Encode4(22875),
     /*  14585 */ /*GILLT_v16s8*//*Label 459*/ GIMT_Encode4(23035),
     /*  14589 */ /*GILLT_v16s16*//*Label 460*/ GIMT_Encode4(23377),
     /*  14593 */ /*GILLT_v16s32*//*Label 461*/ GIMT_Encode4(23843),
     /*  14597 */ /*GILLT_v32s1*//*Label 462*/ GIMT_Encode4(23999),
     /*  14601 */ /*GILLT_v32s8*//*Label 463*/ GIMT_Encode4(24159),
     /*  14605 */ /*GILLT_v32s16*//*Label 464*/ GIMT_Encode4(24625),
     /*  14609 */ /*GILLT_v64s1*//*Label 465*/ GIMT_Encode4(24781),
     /*  14613 */ /*GILLT_v64s8*//*Label 466*/ GIMT_Encode4(24941),
     /*  14617 */ // Label 444: @14617
     /*  14617 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(14962),
     /*  14622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  14625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  14628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14632 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(14752), // Rule ID 19487 //
     /*  14637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  14649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  14653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14662 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  14670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14676 */     // (and:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  14676 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  14679 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14683 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14688 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  14692 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  14700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14709 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  14721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  14725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14730 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14733 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  14736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  14751 */     // GIR_Coverage, 19487,
     /*  14751 */     GIR_EraseRootFromParent_Done,
     /*  14752 */   // Label 469: @14752
     /*  14752 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(14872), // Rule ID 25364 //
     /*  14757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  14773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  14777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14786 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14792 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  14794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14796 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  14796 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  14799 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14803 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14808 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  14812 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14817 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  14820 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14824 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14829 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14833 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  14841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  14845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14850 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14853 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  14856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  14871 */     // GIR_Coverage, 25364,
     /*  14871 */     GIR_EraseRootFromParent_Done,
     /*  14872 */   // Label 470: @14872
     /*  14872 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(14961), // Rule ID 19483 //
     /*  14877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14885 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  14885 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  14888 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14892 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14897 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  14901 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14906 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  14909 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14913 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14918 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  14922 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  14930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  14934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14939 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14942 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  14945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  14960 */     // GIR_Coverage, 19483,
     /*  14960 */     GIR_EraseRootFromParent_Done,
     /*  14961 */   // Label 471: @14961
     /*  14961 */   GIM_Reject,
     /*  14962 */ // Label 468: @14962
     /*  14962 */ GIM_Reject,
     /*  14963 */ // Label 445: @14963
     /*  14963 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(15355),
     /*  14968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  14971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  14974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  14978 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(15039), // Rule ID 26066 //
     /*  14983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  14986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14994 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14997 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15001 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15018 */     // (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (AND8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm),
     /*  15021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15023 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15037 */     GIR_RootConstrainSelectedInstOperands,
     /*  15038 */     // GIR_Coverage, 26066,
     /*  15038 */     GIR_EraseRootFromParent_Done,
     /*  15039 */   // Label 473: @15039
     /*  15039 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(15100), // Rule ID 26085 //
     /*  15044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15055 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15058 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15062 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15079 */     // (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (AND8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm_ND),
     /*  15082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15084 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15098 */     GIR_RootConstrainSelectedInstOperands,
     /*  15099 */     // GIR_Coverage, 26085,
     /*  15099 */     GIR_EraseRootFromParent_Done,
     /*  15100 */   // Label 474: @15100
     /*  15100 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(15161), // Rule ID 22851 //
     /*  15105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15120 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15123 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15127 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15140 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (AND8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm),
     /*  15143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15145 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15159 */     GIR_RootConstrainSelectedInstOperands,
     /*  15160 */     // GIR_Coverage, 22851,
     /*  15160 */     GIR_EraseRootFromParent_Done,
     /*  15161 */   // Label 475: @15161
     /*  15161 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(15222), // Rule ID 22941 //
     /*  15166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15184 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15188 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15201 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (AND8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm_ND),
     /*  15204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15206 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15220 */     GIR_RootConstrainSelectedInstOperands,
     /*  15221 */     // GIR_Coverage, 22941,
     /*  15221 */     GIR_EraseRootFromParent_Done,
     /*  15222 */   // Label 476: @15222
     /*  15222 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(15259), // Rule ID 22855 //
     /*  15227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15242 */     // MIs[1] Operand 1
     /*  15242 */     // No operand predicates
     /*  15242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15244 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  15244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri),
     /*  15247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15249 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15257 */     GIR_RootConstrainSelectedInstOperands,
     /*  15258 */     // GIR_Coverage, 22855,
     /*  15258 */     GIR_EraseRootFromParent_Done,
     /*  15259 */   // Label 477: @15259
     /*  15259 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(15296), // Rule ID 22945 //
     /*  15264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15279 */     // MIs[1] Operand 1
     /*  15279 */     // No operand predicates
     /*  15279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15281 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  15281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri_ND),
     /*  15284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15286 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15294 */     GIR_RootConstrainSelectedInstOperands,
     /*  15295 */     // GIR_Coverage, 22945,
     /*  15295 */     GIR_EraseRootFromParent_Done,
     /*  15296 */   // Label 478: @15296
     /*  15296 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(15325), // Rule ID 22847 //
     /*  15301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15312 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  15312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr),
     /*  15317 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  15323 */     GIR_RootConstrainSelectedInstOperands,
     /*  15324 */     // GIR_Coverage, 22847,
     /*  15324 */     GIR_Done,
     /*  15325 */   // Label 479: @15325
     /*  15325 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(15354), // Rule ID 22937 //
     /*  15330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15341 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  15341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr_ND),
     /*  15346 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  15352 */     GIR_RootConstrainSelectedInstOperands,
     /*  15353 */     // GIR_Coverage, 22937,
     /*  15353 */     GIR_Done,
     /*  15354 */   // Label 480: @15354
     /*  15354 */   GIM_Reject,
     /*  15355 */ // Label 472: @15355
     /*  15355 */ GIM_Reject,
     /*  15356 */ // Label 446: @15356
     /*  15356 */ GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(16040),
     /*  15361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  15364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  15367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15371 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(15432), // Rule ID 26067 //
     /*  15376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15387 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15390 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15394 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15411 */     // (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (AND16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm),
     /*  15414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15416 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15418 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15430 */     GIR_RootConstrainSelectedInstOperands,
     /*  15431 */     // GIR_Coverage, 26067,
     /*  15431 */     GIR_EraseRootFromParent_Done,
     /*  15432 */   // Label 482: @15432
     /*  15432 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(15493), // Rule ID 26086 //
     /*  15437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15455 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15472 */     // (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (AND16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm_ND),
     /*  15475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15477 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15491 */     GIR_RootConstrainSelectedInstOperands,
     /*  15492 */     // GIR_Coverage, 26086,
     /*  15492 */     GIR_EraseRootFromParent_Done,
     /*  15493 */   // Label 483: @15493
     /*  15493 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(15554), // Rule ID 22852 //
     /*  15498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15513 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15516 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15520 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15526 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15533 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (AND16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm),
     /*  15536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15538 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15540 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15552 */     GIR_RootConstrainSelectedInstOperands,
     /*  15553 */     // GIR_Coverage, 22852,
     /*  15553 */     GIR_EraseRootFromParent_Done,
     /*  15554 */   // Label 484: @15554
     /*  15554 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(15615), // Rule ID 22942 //
     /*  15559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15581 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15594 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (AND16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm_ND),
     /*  15597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15599 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15613 */     GIR_RootConstrainSelectedInstOperands,
     /*  15614 */     // GIR_Coverage, 22942,
     /*  15614 */     GIR_EraseRootFromParent_Done,
     /*  15615 */   // Label 485: @15615
     /*  15615 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(15717), // Rule ID 26033 //
     /*  15620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  15628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  15636 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  15640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15651 */     // (and:{ *:[i16] } (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  15651 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  15654 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15658 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  15665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  15668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  15672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15677 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  15684 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  15687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  15692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  15697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  15702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  15705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15707 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15715 */     GIR_RootConstrainSelectedInstOperands,
     /*  15716 */     // GIR_Coverage, 26033,
     /*  15716 */     GIR_EraseRootFromParent_Done,
     /*  15717 */   // Label 486: @15717
     /*  15717 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(15819), // Rule ID 22771 //
     /*  15722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  15734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  15742 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  15746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15753 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  15753 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  15756 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15760 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  15767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  15770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  15774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15779 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  15786 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  15789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  15794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  15799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  15804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  15807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15817 */     GIR_RootConstrainSelectedInstOperands,
     /*  15818 */     // GIR_Coverage, 22771,
     /*  15818 */     GIR_EraseRootFromParent_Done,
     /*  15819 */   // Label 487: @15819
     /*  15819 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(15907), // Rule ID 22631 //
     /*  15824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15828 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15839 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, 255:{ *:[i16] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src1, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  15839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /*  15842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15851 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  15857 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  15862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  15867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  15870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  15874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15879 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  15884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15889 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  15896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  15901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  15906 */     // GIR_Coverage, 22631,
     /*  15906 */     GIR_EraseRootFromParent_Done,
     /*  15907 */   // Label 488: @15907
     /*  15907 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(15944), // Rule ID 22856 //
     /*  15912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15927 */     // MIs[1] Operand 1
     /*  15927 */     // No operand predicates
     /*  15927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15929 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  15929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri),
     /*  15932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15934 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15942 */     GIR_RootConstrainSelectedInstOperands,
     /*  15943 */     // GIR_Coverage, 22856,
     /*  15943 */     GIR_EraseRootFromParent_Done,
     /*  15944 */   // Label 489: @15944
     /*  15944 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(15981), // Rule ID 22946 //
     /*  15949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15964 */     // MIs[1] Operand 1
     /*  15964 */     // No operand predicates
     /*  15964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15966 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  15966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri_ND),
     /*  15969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15971 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15979 */     GIR_RootConstrainSelectedInstOperands,
     /*  15980 */     // GIR_Coverage, 22946,
     /*  15980 */     GIR_EraseRootFromParent_Done,
     /*  15981 */   // Label 490: @15981
     /*  15981 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(16010), // Rule ID 22848 //
     /*  15986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15997 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  15997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr),
     /*  16002 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  16008 */     GIR_RootConstrainSelectedInstOperands,
     /*  16009 */     // GIR_Coverage, 22848,
     /*  16009 */     GIR_Done,
     /*  16010 */   // Label 491: @16010
     /*  16010 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(16039), // Rule ID 22938 //
     /*  16015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16026 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  16026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr_ND),
     /*  16031 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  16037 */     GIR_RootConstrainSelectedInstOperands,
     /*  16038 */     // GIR_Coverage, 22938,
     /*  16038 */     GIR_Done,
     /*  16039 */   // Label 492: @16039
     /*  16039 */   GIM_Reject,
     /*  16040 */ // Label 481: @16040
     /*  16040 */ GIM_Reject,
     /*  16041 */ // Label 447: @16041
     /*  16041 */ GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(17866),
     /*  16046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  16049 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(16141), // Rule ID 17545 //
     /*  16054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  16057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16085 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16097 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16100 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  16104 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16117 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ANDN32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm),
     /*  16120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  16126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16139 */     GIR_RootConstrainSelectedInstOperands,
     /*  16140 */     // GIR_Coverage, 17545,
     /*  16140 */     GIR_EraseRootFromParent_Done,
     /*  16141 */   // Label 494: @16141
     /*  16141 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(16233), // Rule ID 17549 //
     /*  16146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  16149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16177 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16189 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16192 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  16196 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16202 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16209 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ANDN32rm_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm_EVEX),
     /*  16212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  16218 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16231 */     GIR_RootConstrainSelectedInstOperands,
     /*  16232 */     // GIR_Coverage, 17549,
     /*  16232 */     GIR_EraseRootFromParent_Done,
     /*  16233 */   // Label 495: @16233
     /*  16233 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(16325), // Rule ID 25100 //
     /*  16238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  16241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16259 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16263 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16288 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16301 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm),
     /*  16304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  16310 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16323 */     GIR_RootConstrainSelectedInstOperands,
     /*  16324 */     // GIR_Coverage, 25100,
     /*  16324 */     GIR_EraseRootFromParent_Done,
     /*  16325 */   // Label 496: @16325
     /*  16325 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(16417), // Rule ID 25104 //
     /*  16330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  16333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16351 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16355 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16380 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16393 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rm_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm_EVEX),
     /*  16396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  16402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16415 */     GIR_RootConstrainSelectedInstOperands,
     /*  16416 */     // GIR_Coverage, 25104,
     /*  16416 */     GIR_EraseRootFromParent_Done,
     /*  16417 */   // Label 497: @16417
     /*  16417 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(16485), // Rule ID 26068 //
     /*  16422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16443 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16447 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16464 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (AND32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm),
     /*  16467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16469 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  16471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16483 */     GIR_RootConstrainSelectedInstOperands,
     /*  16484 */     // GIR_Coverage, 26068,
     /*  16484 */     GIR_EraseRootFromParent_Done,
     /*  16485 */   // Label 498: @16485
     /*  16485 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(16553), // Rule ID 26087 //
     /*  16490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16515 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16532 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (AND32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm_ND),
     /*  16535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  16539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16551 */     GIR_RootConstrainSelectedInstOperands,
     /*  16552 */     // GIR_Coverage, 26087,
     /*  16552 */     GIR_EraseRootFromParent_Done,
     /*  16553 */   // Label 499: @16553
     /*  16553 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(16621), // Rule ID 22853 //
     /*  16558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16587 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16600 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (AND32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm),
     /*  16603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16605 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16619 */     GIR_RootConstrainSelectedInstOperands,
     /*  16620 */     // GIR_Coverage, 22853,
     /*  16620 */     GIR_EraseRootFromParent_Done,
     /*  16621 */   // Label 500: @16621
     /*  16621 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(16689), // Rule ID 22943 //
     /*  16626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16648 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16655 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16668 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (AND32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm_ND),
     /*  16671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16673 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16687 */     GIR_RootConstrainSelectedInstOperands,
     /*  16688 */     // GIR_Coverage, 22943,
     /*  16688 */     GIR_EraseRootFromParent_Done,
     /*  16689 */   // Label 501: @16689
     /*  16689 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(16766), // Rule ID 24992 //
     /*  16694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16725 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  16729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16741 */     // MIs[2] src
     /*  16741 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16746 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16752 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  16755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16764 */     GIR_RootConstrainSelectedInstOperands,
     /*  16765 */     // GIR_Coverage, 24992,
     /*  16765 */     GIR_EraseRootFromParent_Done,
     /*  16766 */   // Label 502: @16766
     /*  16766 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(16843), // Rule ID 25004 //
     /*  16771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16802 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16818 */     // MIs[2] src
     /*  16818 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16823 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16829 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  16832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16841 */     GIR_RootConstrainSelectedInstOperands,
     /*  16842 */     // GIR_Coverage, 25004,
     /*  16842 */     GIR_EraseRootFromParent_Done,
     /*  16843 */   // Label 503: @16843
     /*  16843 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(16920), // Rule ID 17355 //
     /*  16848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16879 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16895 */     // MIs[2] src
     /*  16895 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16900 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  16904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16906 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  16909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16918 */     GIR_RootConstrainSelectedInstOperands,
     /*  16919 */     // GIR_Coverage, 17355,
     /*  16919 */     GIR_EraseRootFromParent_Done,
     /*  16920 */   // Label 504: @16920
     /*  16920 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(16997), // Rule ID 17367 //
     /*  16925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16956 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16972 */     // MIs[2] src
     /*  16972 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16977 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16983 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  16986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16995 */     GIR_RootConstrainSelectedInstOperands,
     /*  16996 */     // GIR_Coverage, 17367,
     /*  16996 */     GIR_EraseRootFromParent_Done,
     /*  16997 */   // Label 505: @16997
     /*  16997 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(17055), // Rule ID 24986 //
     /*  17002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17030 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  17034 */     // MIs[0] src
     /*  17034 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17041 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  17044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17053 */     GIR_RootConstrainSelectedInstOperands,
     /*  17054 */     // GIR_Coverage, 24986,
     /*  17054 */     GIR_EraseRootFromParent_Done,
     /*  17055 */   // Label 506: @17055
     /*  17055 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(17164), // Rule ID 26039 //
     /*  17060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  17075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  17083 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  17087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  17092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17098 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  17098 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17101 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17105 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  17112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  17119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17124 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  17131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  17134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  17149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  17152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17154 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  17156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17162 */     GIR_RootConstrainSelectedInstOperands,
     /*  17163 */     // GIR_Coverage, 26039,
     /*  17163 */     GIR_EraseRootFromParent_Done,
     /*  17164 */   // Label 507: @17164
     /*  17164 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(17218), // Rule ID 17349 //
     /*  17169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17195 */     // MIs[1] src
     /*  17195 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  17200 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  17204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17206 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  17209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17211 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17216 */     GIR_RootConstrainSelectedInstOperands,
     /*  17217 */     // GIR_Coverage, 17349,
     /*  17217 */     GIR_EraseRootFromParent_Done,
     /*  17218 */   // Label 508: @17218
     /*  17218 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(17327), // Rule ID 22777 //
     /*  17223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  17242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  17250 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  17254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  17259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17261 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  17261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  17275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  17282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  17294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  17297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  17312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  17315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17317 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17325 */     GIR_RootConstrainSelectedInstOperands,
     /*  17326 */     // GIR_Coverage, 22777,
     /*  17326 */     GIR_EraseRootFromParent_Done,
     /*  17327 */   // Label 509: @17327
     /*  17327 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(17392), // Rule ID 22629 //
     /*  17332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17343 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17354 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 65535:{ *:[i32] })  =>  (MOVZX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src1, sub_16bit:{ *:[i32] }))
     /*  17354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  17357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17366 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src1
     /*  17372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  17377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  17382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /*  17385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17390 */     GIR_RootConstrainSelectedInstOperands,
     /*  17391 */     // GIR_Coverage, 22629,
     /*  17391 */     GIR_EraseRootFromParent_Done,
     /*  17392 */   // Label 510: @17392
     /*  17392 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(17457), // Rule ID 22630 //
     /*  17397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17408 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17419 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 255:{ *:[i32] })  =>  (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src1, sub_8bit:{ *:[i32] }))
     /*  17419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /*  17422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17431 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  17437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  17442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  17447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  17450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17455 */     GIR_RootConstrainSelectedInstOperands,
     /*  17456 */     // GIR_Coverage, 22630,
     /*  17456 */     GIR_EraseRootFromParent_Done,
     /*  17457 */   // Label 511: @17457
     /*  17457 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(17501), // Rule ID 22857 //
     /*  17462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  17465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17484 */     // MIs[1] Operand 1
     /*  17484 */     // No operand predicates
     /*  17484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17486 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  17486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri),
     /*  17489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  17496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17499 */     GIR_RootConstrainSelectedInstOperands,
     /*  17500 */     // GIR_Coverage, 22857,
     /*  17500 */     GIR_EraseRootFromParent_Done,
     /*  17501 */   // Label 512: @17501
     /*  17501 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(17545), // Rule ID 22947 //
     /*  17506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  17509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17528 */     // MIs[1] Operand 1
     /*  17528 */     // No operand predicates
     /*  17528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17530 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  17530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri_ND),
     /*  17533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  17540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17543 */     GIR_RootConstrainSelectedInstOperands,
     /*  17544 */     // GIR_Coverage, 22947,
     /*  17544 */     GIR_EraseRootFromParent_Done,
     /*  17545 */   // Label 513: @17545
     /*  17545 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(17607), // Rule ID 17543 //
     /*  17550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17581 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17591 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  17594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17600 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  17602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17605 */     GIR_RootConstrainSelectedInstOperands,
     /*  17606 */     // GIR_Coverage, 17543,
     /*  17606 */     GIR_EraseRootFromParent_Done,
     /*  17607 */   // Label 514: @17607
     /*  17607 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(17669), // Rule ID 17547 //
     /*  17612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17643 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17653 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  17656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17662 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  17664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17667 */     GIR_RootConstrainSelectedInstOperands,
     /*  17668 */     // GIR_Coverage, 17547,
     /*  17668 */     GIR_EraseRootFromParent_Done,
     /*  17669 */   // Label 515: @17669
     /*  17669 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(17731), // Rule ID 25098 //
     /*  17674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17709 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17715 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  17718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17724 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  17726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17729 */     GIR_RootConstrainSelectedInstOperands,
     /*  17730 */     // GIR_Coverage, 25098,
     /*  17730 */     GIR_EraseRootFromParent_Done,
     /*  17731 */   // Label 516: @17731
     /*  17731 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(17793), // Rule ID 25102 //
     /*  17736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17771 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17777 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  17780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17786 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  17788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17791 */     GIR_RootConstrainSelectedInstOperands,
     /*  17792 */     // GIR_Coverage, 25102,
     /*  17792 */     GIR_EraseRootFromParent_Done,
     /*  17793 */   // Label 517: @17793
     /*  17793 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(17829), // Rule ID 22849 //
     /*  17798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  17801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17816 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr),
     /*  17821 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  17827 */     GIR_RootConstrainSelectedInstOperands,
     /*  17828 */     // GIR_Coverage, 22849,
     /*  17828 */     GIR_Done,
     /*  17829 */   // Label 518: @17829
     /*  17829 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(17865), // Rule ID 22939 //
     /*  17834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  17837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17852 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr_ND),
     /*  17857 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  17863 */     GIR_RootConstrainSelectedInstOperands,
     /*  17864 */     // GIR_Coverage, 22939,
     /*  17864 */     GIR_Done,
     /*  17865 */   // Label 519: @17865
     /*  17865 */   GIM_Reject,
     /*  17866 */ // Label 493: @17866
     /*  17866 */ GIM_Reject,
     /*  17867 */ // Label 448: @17867
     /*  17867 */ GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(19570),
     /*  17872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17875 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(17967), // Rule ID 17546 //
     /*  17880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  17890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  17902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  17906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  17911 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  17923 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  17926 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  17930 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  17934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  17943 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ANDN64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  17943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm),
     /*  17946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17952 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  17956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  17965 */     GIR_RootConstrainSelectedInstOperands,
     /*  17966 */     // GIR_Coverage, 17546,
     /*  17966 */     GIR_EraseRootFromParent_Done,
     /*  17967 */   // Label 521: @17967
     /*  17967 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(18059), // Rule ID 17550 //
     /*  17972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  17982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  17994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  17998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18003 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18015 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18018 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  18022 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  18026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18035 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ANDN64rm_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm_EVEX),
     /*  18038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  18044 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18057 */     GIR_RootConstrainSelectedInstOperands,
     /*  18058 */     // GIR_Coverage, 17550,
     /*  18058 */     GIR_EraseRootFromParent_Done,
     /*  18059 */   // Label 522: @18059
     /*  18059 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(18151), // Rule ID 25101 //
     /*  18064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  18067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  18105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18114 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18127 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm),
     /*  18130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  18136 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18149 */     GIR_RootConstrainSelectedInstOperands,
     /*  18150 */     // GIR_Coverage, 25101,
     /*  18150 */     GIR_EraseRootFromParent_Done,
     /*  18151 */   // Label 523: @18151
     /*  18151 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(18243), // Rule ID 25105 //
     /*  18156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  18159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  18197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18206 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18219 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rm_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm_EVEX),
     /*  18222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  18228 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18241 */     GIR_RootConstrainSelectedInstOperands,
     /*  18242 */     // GIR_Coverage, 25105,
     /*  18242 */     GIR_EraseRootFromParent_Done,
     /*  18243 */   // Label 524: @18243
     /*  18243 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(18311), // Rule ID 26069 //
     /*  18248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18266 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18273 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18290 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (AND64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm),
     /*  18293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18295 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18297 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18309 */     GIR_RootConstrainSelectedInstOperands,
     /*  18310 */     // GIR_Coverage, 26069,
     /*  18310 */     GIR_EraseRootFromParent_Done,
     /*  18311 */   // Label 525: @18311
     /*  18311 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(18379), // Rule ID 26088 //
     /*  18316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18334 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18337 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18341 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18358 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (AND64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm_ND),
     /*  18361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18377 */     GIR_RootConstrainSelectedInstOperands,
     /*  18378 */     // GIR_Coverage, 26088,
     /*  18378 */     GIR_EraseRootFromParent_Done,
     /*  18379 */   // Label 526: @18379
     /*  18379 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(18447), // Rule ID 22854 //
     /*  18384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18406 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18409 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18413 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18426 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (AND64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm),
     /*  18429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18431 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  18433 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18445 */     GIR_RootConstrainSelectedInstOperands,
     /*  18446 */     // GIR_Coverage, 22854,
     /*  18446 */     GIR_EraseRootFromParent_Done,
     /*  18447 */   // Label 527: @18447
     /*  18447 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(18515), // Rule ID 22944 //
     /*  18452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18494 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (AND64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm_ND),
     /*  18497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  18501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18513 */     GIR_RootConstrainSelectedInstOperands,
     /*  18514 */     // GIR_Coverage, 22944,
     /*  18514 */     GIR_EraseRootFromParent_Done,
     /*  18515 */   // Label 528: @18515
     /*  18515 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(18592), // Rule ID 24993 //
     /*  18520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18551 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  18555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18567 */     // MIs[2] src
     /*  18567 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18572 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18578 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  18581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18590 */     GIR_RootConstrainSelectedInstOperands,
     /*  18591 */     // GIR_Coverage, 24993,
     /*  18591 */     GIR_EraseRootFromParent_Done,
     /*  18592 */   // Label 529: @18592
     /*  18592 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(18669), // Rule ID 25005 //
     /*  18597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18628 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18644 */     // MIs[2] src
     /*  18644 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18649 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18655 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  18658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18667 */     GIR_RootConstrainSelectedInstOperands,
     /*  18668 */     // GIR_Coverage, 25005,
     /*  18668 */     GIR_EraseRootFromParent_Done,
     /*  18669 */   // Label 530: @18669
     /*  18669 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(18746), // Rule ID 17356 //
     /*  18674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18705 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18721 */     // MIs[2] src
     /*  18721 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18726 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  18730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18732 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  18735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18744 */     GIR_RootConstrainSelectedInstOperands,
     /*  18745 */     // GIR_Coverage, 17356,
     /*  18745 */     GIR_EraseRootFromParent_Done,
     /*  18746 */   // Label 531: @18746
     /*  18746 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(18823), // Rule ID 17368 //
     /*  18751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18782 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18798 */     // MIs[2] src
     /*  18798 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18803 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18809 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  18812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18821 */     GIR_RootConstrainSelectedInstOperands,
     /*  18822 */     // GIR_Coverage, 17368,
     /*  18822 */     GIR_EraseRootFromParent_Done,
     /*  18823 */   // Label 532: @18823
     /*  18823 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(18881), // Rule ID 24987 //
     /*  18828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18856 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  18860 */     // MIs[0] src
     /*  18860 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18867 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  18870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18879 */     GIR_RootConstrainSelectedInstOperands,
     /*  18880 */     // GIR_Coverage, 24987,
     /*  18880 */     GIR_EraseRootFromParent_Done,
     /*  18881 */   // Label 533: @18881
     /*  18881 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(18990), // Rule ID 26045 //
     /*  18886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  18901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  18909 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  18913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  18918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18924 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  18924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  18927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  18938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  18941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  18945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18950 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18953 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  18957 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  18960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  18965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  18970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  18975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  18978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18988 */     GIR_RootConstrainSelectedInstOperands,
     /*  18989 */     // GIR_Coverage, 26045,
     /*  18989 */     GIR_EraseRootFromParent_Done,
     /*  18990 */   // Label 534: @18990
     /*  18990 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(19044), // Rule ID 17350 //
     /*  18995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19021 */     // MIs[1] src
     /*  19021 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  19026 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  19030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19032 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  19032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  19035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  19039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19042 */     GIR_RootConstrainSelectedInstOperands,
     /*  19043 */     // GIR_Coverage, 17350,
     /*  19043 */     GIR_EraseRootFromParent_Done,
     /*  19044 */   // Label 535: @19044
     /*  19044 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(19153), // Rule ID 22783 //
     /*  19049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  19068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  19076 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  19080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  19085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19087 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  19087 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  19090 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  19094 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  19101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  19104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  19108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19113 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19116 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  19120 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  19123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  19138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  19141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19143 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19151 */     GIR_RootConstrainSelectedInstOperands,
     /*  19152 */     // GIR_Coverage, 22783,
     /*  19152 */     GIR_EraseRootFromParent_Done,
     /*  19153 */   // Label 536: @19153
     /*  19153 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(19201), // Rule ID 22858 //
     /*  19158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  19161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  19184 */     // MIs[1] Operand 1
     /*  19184 */     // No operand predicates
     /*  19184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19186 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  19186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32),
     /*  19189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  19196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19199 */     GIR_RootConstrainSelectedInstOperands,
     /*  19200 */     // GIR_Coverage, 22858,
     /*  19200 */     GIR_EraseRootFromParent_Done,
     /*  19201 */   // Label 537: @19201
     /*  19201 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(19249), // Rule ID 22948 //
     /*  19206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  19209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  19232 */     // MIs[1] Operand 1
     /*  19232 */     // No operand predicates
     /*  19232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19234 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  19234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32_ND),
     /*  19237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19239 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  19244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19247 */     GIR_RootConstrainSelectedInstOperands,
     /*  19248 */     // GIR_Coverage, 22948,
     /*  19248 */     GIR_EraseRootFromParent_Done,
     /*  19249 */   // Label 538: @19249
     /*  19249 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(19311), // Rule ID 17544 //
     /*  19254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  19257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19285 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19295 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  19298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19304 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  19306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19309 */     GIR_RootConstrainSelectedInstOperands,
     /*  19310 */     // GIR_Coverage, 17544,
     /*  19310 */     GIR_EraseRootFromParent_Done,
     /*  19311 */   // Label 539: @19311
     /*  19311 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(19373), // Rule ID 17548 //
     /*  19316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  19319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19347 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19357 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  19360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19366 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  19368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19371 */     GIR_RootConstrainSelectedInstOperands,
     /*  19372 */     // GIR_Coverage, 17548,
     /*  19372 */     GIR_EraseRootFromParent_Done,
     /*  19373 */   // Label 540: @19373
     /*  19373 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(19435), // Rule ID 25099 //
     /*  19378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  19381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19413 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19419 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  19422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  19430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19433 */     GIR_RootConstrainSelectedInstOperands,
     /*  19434 */     // GIR_Coverage, 25099,
     /*  19434 */     GIR_EraseRootFromParent_Done,
     /*  19435 */   // Label 541: @19435
     /*  19435 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(19497), // Rule ID 25103 //
     /*  19440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  19443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19475 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19481 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  19484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19490 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  19492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19495 */     GIR_RootConstrainSelectedInstOperands,
     /*  19496 */     // GIR_Coverage, 25103,
     /*  19496 */     GIR_EraseRootFromParent_Done,
     /*  19497 */   // Label 542: @19497
     /*  19497 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(19533), // Rule ID 22850 //
     /*  19502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  19505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19520 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr),
     /*  19525 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  19531 */     GIR_RootConstrainSelectedInstOperands,
     /*  19532 */     // GIR_Coverage, 22850,
     /*  19532 */     GIR_Done,
     /*  19533 */   // Label 543: @19533
     /*  19533 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(19569), // Rule ID 22940 //
     /*  19538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  19541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19556 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr_ND),
     /*  19561 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  19567 */     GIR_RootConstrainSelectedInstOperands,
     /*  19568 */     // GIR_Coverage, 22940,
     /*  19568 */     GIR_Done,
     /*  19569 */   // Label 544: @19569
     /*  19569 */   GIM_Reject,
     /*  19570 */ // Label 520: @19570
     /*  19570 */ GIM_Reject,
     /*  19571 */ // Label 449: @19571
     /*  19571 */ GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(19916),
     /*  19576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19586 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(19706), // Rule ID 19488 //
     /*  19591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19616 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19622 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  19624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19630 */     // (and:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19630 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19633 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19637 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19642 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  19646 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19651 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19654 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19658 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19663 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19667 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  19675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  19679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  19690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  19705 */     // GIR_Coverage, 19488,
     /*  19705 */     GIR_EraseRootFromParent_Done,
     /*  19706 */   // Label 546: @19706
     /*  19706 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(19826), // Rule ID 25365 //
     /*  19711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19740 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19746 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  19748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19750 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19750 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19753 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19757 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19762 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  19766 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19771 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19774 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19778 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19783 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19787 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  19795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  19799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19804 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19807 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  19810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  19825 */     // GIR_Coverage, 25365,
     /*  19825 */     GIR_EraseRootFromParent_Done,
     /*  19826 */   // Label 547: @19826
     /*  19826 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(19915), // Rule ID 19484 //
     /*  19831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19839 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19839 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19842 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19846 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19851 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  19855 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19872 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  19876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  19884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  19888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19896 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  19899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  19914 */     // GIR_Coverage, 19484,
     /*  19914 */     GIR_EraseRootFromParent_Done,
     /*  19915 */   // Label 548: @19915
     /*  19915 */   GIM_Reject,
     /*  19916 */ // Label 545: @19916
     /*  19916 */ GIM_Reject,
     /*  19917 */ // Label 450: @19917
     /*  19917 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(20258),
     /*  19922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19928 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(19990), // Rule ID 23357 //
     /*  19933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  19936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  19940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  19948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  19951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  19955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  19959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  19963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  19972 */     // (and:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPANDrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  19972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  19975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19977 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  19979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  19983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  19988 */     GIR_RootConstrainSelectedInstOperands,
     /*  19989 */     // GIR_Coverage, 23357,
     /*  19989 */     GIR_EraseRootFromParent_Done,
     /*  19990 */   // Label 550: @19990
     /*  19990 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(20052), // Rule ID 24146 //
     /*  19995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  19998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20010 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20017 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20034 */     // (and:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPANDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  20037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20039 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20050 */     GIR_RootConstrainSelectedInstOperands,
     /*  20051 */     // GIR_Coverage, 24146,
     /*  20051 */     GIR_EraseRootFromParent_Done,
     /*  20052 */   // Label 551: @20052
     /*  20052 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(20114), // Rule ID 2110 //
     /*  20057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20076 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20079 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20083 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20096 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20101 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20103 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20112 */     GIR_RootConstrainSelectedInstOperands,
     /*  20113 */     // GIR_Coverage, 2110,
     /*  20113 */     GIR_EraseRootFromParent_Done,
     /*  20114 */   // Label 552: @20114
     /*  20114 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(20176), // Rule ID 5706 //
     /*  20119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20138 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20141 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20145 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20158 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  20161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20163 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20174 */     GIR_RootConstrainSelectedInstOperands,
     /*  20175 */     // GIR_Coverage, 5706,
     /*  20175 */     GIR_EraseRootFromParent_Done,
     /*  20176 */   // Label 553: @20176
     /*  20176 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(20203), // Rule ID 2109 //
     /*  20181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20196 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  20196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  20201 */     GIR_RootConstrainSelectedInstOperands,
     /*  20202 */     // GIR_Coverage, 2109,
     /*  20202 */     GIR_Done,
     /*  20203 */   // Label 554: @20203
     /*  20203 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(20230), // Rule ID 2111 //
     /*  20208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  20211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20223 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  20223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  20228 */     GIR_RootConstrainSelectedInstOperands,
     /*  20229 */     // GIR_Coverage, 2111,
     /*  20229 */     GIR_Done,
     /*  20230 */   // Label 555: @20230
     /*  20230 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(20257), // Rule ID 5703 //
     /*  20235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20250 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPANDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  20250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  20255 */     GIR_RootConstrainSelectedInstOperands,
     /*  20256 */     // GIR_Coverage, 5703,
     /*  20256 */     GIR_Done,
     /*  20257 */   // Label 556: @20257
     /*  20257 */   GIM_Reject,
     /*  20258 */ // Label 549: @20258
     /*  20258 */ GIM_Reject,
     /*  20259 */ // Label 451: @20259
     /*  20259 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(20604),
     /*  20264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20274 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(20394), // Rule ID 19489 //
     /*  20279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20304 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20310 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  20312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20318 */     // (and:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20318 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20321 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20325 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20330 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20334 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20351 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20355 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20372 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20375 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20393 */     // GIR_Coverage, 19489,
     /*  20393 */     GIR_EraseRootFromParent_Done,
     /*  20394 */   // Label 558: @20394
     /*  20394 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(20514), // Rule ID 25366 //
     /*  20399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20428 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20434 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  20436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20438 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20438 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20441 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20445 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20450 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  20454 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20459 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20462 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20466 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20471 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20475 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20492 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20495 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20513 */     // GIR_Coverage, 25366,
     /*  20513 */     GIR_EraseRootFromParent_Done,
     /*  20514 */   // Label 559: @20514
     /*  20514 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(20603), // Rule ID 19485 //
     /*  20519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20527 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20527 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20530 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20534 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20539 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20543 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20548 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20551 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20555 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20560 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  20564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  20576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20581 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20584 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20602 */     // GIR_Coverage, 19485,
     /*  20602 */     GIR_EraseRootFromParent_Done,
     /*  20603 */   // Label 560: @20603
     /*  20603 */   GIM_Reject,
     /*  20604 */ // Label 557: @20604
     /*  20604 */ GIM_Reject,
     /*  20605 */ // Label 452: @20605
     /*  20605 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(20946),
     /*  20610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20616 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(20678), // Rule ID 24164 //
     /*  20621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20660 */     // (and:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPANDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rm),
     /*  20663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20665 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20667 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20676 */     GIR_RootConstrainSelectedInstOperands,
     /*  20677 */     // GIR_Coverage, 24164,
     /*  20677 */     GIR_EraseRootFromParent_Done,
     /*  20678 */   // Label 562: @20678
     /*  20678 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(20740), // Rule ID 25250 //
     /*  20683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20698 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20701 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20705 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20722 */     // (and:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPANDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20727 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20729 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20738 */     GIR_RootConstrainSelectedInstOperands,
     /*  20739 */     // GIR_Coverage, 25250,
     /*  20739 */     GIR_EraseRootFromParent_Done,
     /*  20740 */   // Label 563: @20740
     /*  20740 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(20802), // Rule ID 5733 //
     /*  20745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20764 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20771 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20784 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rm),
     /*  20787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20789 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20791 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20800 */     GIR_RootConstrainSelectedInstOperands,
     /*  20801 */     // GIR_Coverage, 5733,
     /*  20801 */     GIR_EraseRootFromParent_Done,
     /*  20802 */   // Label 564: @20802
     /*  20802 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(20864), // Rule ID 18159 //
     /*  20807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20826 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20829 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20833 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20846 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20851 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20862 */     GIR_RootConstrainSelectedInstOperands,
     /*  20863 */     // GIR_Coverage, 18159,
     /*  20863 */     GIR_EraseRootFromParent_Done,
     /*  20864 */   // Label 565: @20864
     /*  20864 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(20891), // Rule ID 5730 //
     /*  20869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20884 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPANDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  20884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rr),
     /*  20889 */     GIR_RootConstrainSelectedInstOperands,
     /*  20890 */     // GIR_Coverage, 5730,
     /*  20890 */     GIR_Done,
     /*  20891 */   // Label 566: @20891
     /*  20891 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(20918), // Rule ID 18147 //
     /*  20896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20911 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  20911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  20916 */     GIR_RootConstrainSelectedInstOperands,
     /*  20917 */     // GIR_Coverage, 18147,
     /*  20917 */     GIR_Done,
     /*  20918 */   // Label 567: @20918
     /*  20918 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(20945), // Rule ID 18171 //
     /*  20923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  20926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20938 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  20938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  20943 */     GIR_RootConstrainSelectedInstOperands,
     /*  20944 */     // GIR_Coverage, 18171,
     /*  20944 */     GIR_Done,
     /*  20945 */   // Label 568: @20945
     /*  20945 */   GIM_Reject,
     /*  20946 */ // Label 561: @20946
     /*  20946 */ GIM_Reject,
     /*  20947 */ // Label 453: @20947
     /*  20947 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(21412),
     /*  20952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  20955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  20958 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(21020), // Rule ID 23359 //
     /*  20963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  20966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  20970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20978 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20981 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20985 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  20993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21002 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPANDYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  21005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21007 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21018 */     GIR_RootConstrainSelectedInstOperands,
     /*  21019 */     // GIR_Coverage, 23359,
     /*  21019 */     GIR_EraseRootFromParent_Done,
     /*  21020 */   // Label 570: @21020
     /*  21020 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(21082), // Rule ID 24140 //
     /*  21025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21040 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21043 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21047 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21064 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPANDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  21067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21069 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21071 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21080 */     GIR_RootConstrainSelectedInstOperands,
     /*  21081 */     // GIR_Coverage, 24140,
     /*  21081 */     GIR_EraseRootFromParent_Done,
     /*  21082 */   // Label 571: @21082
     /*  21082 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(21144), // Rule ID 25239 //
     /*  21087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21102 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21105 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21109 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21126 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VANDPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  21129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21131 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21133 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21142 */     GIR_RootConstrainSelectedInstOperands,
     /*  21143 */     // GIR_Coverage, 25239,
     /*  21143 */     GIR_EraseRootFromParent_Done,
     /*  21144 */   // Label 572: @21144
     /*  21144 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(21206), // Rule ID 2114 //
     /*  21149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21168 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21171 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21175 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21188 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  21191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21193 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21204 */     GIR_RootConstrainSelectedInstOperands,
     /*  21205 */     // GIR_Coverage, 2114,
     /*  21205 */     GIR_EraseRootFromParent_Done,
     /*  21206 */   // Label 573: @21206
     /*  21206 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(21268), // Rule ID 5697 //
     /*  21211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21230 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21233 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21237 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21250 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  21253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21255 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21257 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21266 */     GIR_RootConstrainSelectedInstOperands,
     /*  21267 */     // GIR_Coverage, 5697,
     /*  21267 */     GIR_EraseRootFromParent_Done,
     /*  21268 */   // Label 574: @21268
     /*  21268 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(21330), // Rule ID 18132 //
     /*  21273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21292 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21312 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  21315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21317 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21328 */     GIR_RootConstrainSelectedInstOperands,
     /*  21329 */     // GIR_Coverage, 18132,
     /*  21329 */     GIR_EraseRootFromParent_Done,
     /*  21330 */   // Label 575: @21330
     /*  21330 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(21357), // Rule ID 2113 //
     /*  21335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21350 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPANDYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  21350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  21355 */     GIR_RootConstrainSelectedInstOperands,
     /*  21356 */     // GIR_Coverage, 2113,
     /*  21356 */     GIR_Done,
     /*  21357 */   // Label 576: @21357
     /*  21357 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(21384), // Rule ID 5694 //
     /*  21362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21377 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPANDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  21377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  21382 */     GIR_RootConstrainSelectedInstOperands,
     /*  21383 */     // GIR_Coverage, 5694,
     /*  21383 */     GIR_Done,
     /*  21384 */   // Label 577: @21384
     /*  21384 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(21411), // Rule ID 18116 //
     /*  21389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21404 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VANDPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  21404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  21409 */     GIR_RootConstrainSelectedInstOperands,
     /*  21410 */     // GIR_Coverage, 18116,
     /*  21410 */     GIR_Done,
     /*  21411 */   // Label 578: @21411
     /*  21411 */   GIM_Reject,
     /*  21412 */ // Label 569: @21412
     /*  21412 */ GIM_Reject,
     /*  21413 */ // Label 454: @21413
     /*  21413 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(21910),
     /*  21418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21428 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(21488), // Rule ID 4430 //
     /*  21433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21461 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21467 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21475 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /*  21478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21484 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  21486 */     GIR_RootConstrainSelectedInstOperands,
     /*  21487 */     // GIR_Coverage, 4430,
     /*  21487 */     GIR_EraseRootFromParent_Done,
     /*  21488 */   // Label 580: @21488
     /*  21488 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(21611), // Rule ID 19486 //
     /*  21493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21521 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21527 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21535 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21535 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21538 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21542 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21547 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  21551 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21556 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21559 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21563 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21568 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21572 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  21584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21589 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  21610 */     // GIR_Coverage, 19486,
     /*  21610 */     GIR_EraseRootFromParent_Done,
     /*  21611 */   // Label 581: @21611
     /*  21611 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(21671), // Rule ID 23689 //
     /*  21616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21648 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21654 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21658 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /*  21661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  21669 */     GIR_RootConstrainSelectedInstOperands,
     /*  21670 */     // GIR_Coverage, 23689,
     /*  21670 */     GIR_EraseRootFromParent_Done,
     /*  21671 */   // Label 582: @21671
     /*  21671 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(21794), // Rule ID 25363 //
     /*  21676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21708 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21714 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21718 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21718 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21721 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21725 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21730 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  21734 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21739 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21742 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21746 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21751 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21755 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  21767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21772 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21775 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  21793 */     // GIR_Coverage, 25363,
     /*  21793 */     GIR_EraseRootFromParent_Done,
     /*  21794 */   // Label 583: @21794
     /*  21794 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(21817), // Rule ID 4414 //
     /*  21799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21810 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KANDBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDBkk),
     /*  21815 */     GIR_RootConstrainSelectedInstOperands,
     /*  21816 */     // GIR_Coverage, 4414,
     /*  21816 */     GIR_Done,
     /*  21817 */   // Label 584: @21817
     /*  21817 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(21909), // Rule ID 19482 //
     /*  21822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21833 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21833 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21836 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21840 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21845 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  21849 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21866 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  21870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  21882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21887 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21890 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  21908 */     // GIR_Coverage, 19482,
     /*  21908 */     GIR_EraseRootFromParent_Done,
     /*  21909 */   // Label 585: @21909
     /*  21909 */   GIM_Reject,
     /*  21910 */ // Label 579: @21910
     /*  21910 */ GIM_Reject,
     /*  21911 */ // Label 455: @21911
     /*  21911 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(22252),
     /*  21916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21922 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(21984), // Rule ID 25249 //
     /*  21927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  21930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21942 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21966 */     // (and:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPANDrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  21969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21982 */     GIR_RootConstrainSelectedInstOperands,
     /*  21983 */     // GIR_Coverage, 25249,
     /*  21983 */     GIR_EraseRootFromParent_Done,
     /*  21984 */   // Label 587: @21984
     /*  21984 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(22046), // Rule ID 25430 //
     /*  21989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  21992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  21996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22004 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22011 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22028 */     // (and:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPANDQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  22031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22033 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22044 */     GIR_RootConstrainSelectedInstOperands,
     /*  22045 */     // GIR_Coverage, 25430,
     /*  22045 */     GIR_EraseRootFromParent_Done,
     /*  22046 */   // Label 588: @22046
     /*  22046 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(22108), // Rule ID 18158 //
     /*  22051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22070 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22090 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  22093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22095 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22097 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22106 */     GIR_RootConstrainSelectedInstOperands,
     /*  22107 */     // GIR_Coverage, 18158,
     /*  22107 */     GIR_EraseRootFromParent_Done,
     /*  22108 */   // Label 589: @22108
     /*  22108 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(22170), // Rule ID 20024 //
     /*  22113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22139 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22152 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  22155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22168 */     GIR_RootConstrainSelectedInstOperands,
     /*  22169 */     // GIR_Coverage, 20024,
     /*  22169 */     GIR_EraseRootFromParent_Done,
     /*  22170 */   // Label 590: @22170
     /*  22170 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(22197), // Rule ID 18146 //
     /*  22175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22190 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  22190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  22195 */     GIR_RootConstrainSelectedInstOperands,
     /*  22196 */     // GIR_Coverage, 18146,
     /*  22196 */     GIR_Done,
     /*  22197 */   // Label 591: @22197
     /*  22197 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(22224), // Rule ID 18170 //
     /*  22202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  22205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22217 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  22217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  22222 */     GIR_RootConstrainSelectedInstOperands,
     /*  22223 */     // GIR_Coverage, 18170,
     /*  22223 */     GIR_Done,
     /*  22224 */   // Label 592: @22224
     /*  22224 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(22251), // Rule ID 20016 //
     /*  22229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22244 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPANDQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  22244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  22249 */     GIR_RootConstrainSelectedInstOperands,
     /*  22250 */     // GIR_Coverage, 20016,
     /*  22250 */     GIR_Done,
     /*  22251 */   // Label 593: @22251
     /*  22251 */   GIM_Reject,
     /*  22252 */ // Label 586: @22252
     /*  22252 */ GIM_Reject,
     /*  22253 */ // Label 456: @22253
     /*  22253 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(22718),
     /*  22258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  22261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  22264 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(22326), // Rule ID 24158 //
     /*  22269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22284 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22287 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22291 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22308 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPANDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rm),
     /*  22311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22313 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22324 */     GIR_RootConstrainSelectedInstOperands,
     /*  22325 */     // GIR_Coverage, 24158,
     /*  22325 */     GIR_EraseRootFromParent_Done,
     /*  22326 */   // Label 595: @22326
     /*  22326 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(22388), // Rule ID 25229 //
     /*  22331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22346 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22353 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22370 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPANDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  22373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22375 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22377 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22386 */     GIR_RootConstrainSelectedInstOperands,
     /*  22387 */     // GIR_Coverage, 25229,
     /*  22387 */     GIR_EraseRootFromParent_Done,
     /*  22388 */   // Label 596: @22388
     /*  22388 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(22450), // Rule ID 25238 //
     /*  22393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22408 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22411 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22415 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22432 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VANDPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  22435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22437 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22448 */     GIR_RootConstrainSelectedInstOperands,
     /*  22449 */     // GIR_Coverage, 25238,
     /*  22449 */     GIR_EraseRootFromParent_Done,
     /*  22450 */   // Label 597: @22450
     /*  22450 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(22512), // Rule ID 5724 //
     /*  22455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22494 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rm),
     /*  22497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22510 */     GIR_RootConstrainSelectedInstOperands,
     /*  22511 */     // GIR_Coverage, 5724,
     /*  22511 */     GIR_EraseRootFromParent_Done,
     /*  22512 */   // Label 598: @22512
     /*  22512 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(22574), // Rule ID 18103 //
     /*  22517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22556 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  22559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22572 */     GIR_RootConstrainSelectedInstOperands,
     /*  22573 */     // GIR_Coverage, 18103,
     /*  22573 */     GIR_EraseRootFromParent_Done,
     /*  22574 */   // Label 599: @22574
     /*  22574 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(22636), // Rule ID 18131 //
     /*  22579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22618 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  22621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22634 */     GIR_RootConstrainSelectedInstOperands,
     /*  22635 */     // GIR_Coverage, 18131,
     /*  22635 */     GIR_EraseRootFromParent_Done,
     /*  22636 */   // Label 600: @22636
     /*  22636 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(22663), // Rule ID 5721 //
     /*  22641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22656 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPANDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  22656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rr),
     /*  22661 */     GIR_RootConstrainSelectedInstOperands,
     /*  22662 */     // GIR_Coverage, 5721,
     /*  22662 */     GIR_Done,
     /*  22663 */   // Label 601: @22663
     /*  22663 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(22690), // Rule ID 18091 //
     /*  22668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22683 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPANDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  22683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  22688 */     GIR_RootConstrainSelectedInstOperands,
     /*  22689 */     // GIR_Coverage, 18091,
     /*  22689 */     GIR_Done,
     /*  22690 */   // Label 602: @22690
     /*  22690 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(22717), // Rule ID 18115 //
     /*  22695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22710 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VANDPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  22710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  22715 */     GIR_RootConstrainSelectedInstOperands,
     /*  22716 */     // GIR_Coverage, 18115,
     /*  22716 */     GIR_Done,
     /*  22717 */   // Label 603: @22717
     /*  22717 */   GIM_Reject,
     /*  22718 */ // Label 594: @22718
     /*  22718 */ GIM_Reject,
     /*  22719 */ // Label 457: @22719
     /*  22719 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(22874),
     /*  22724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  22727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  22730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22734 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(22792), // Rule ID 24134 //
     /*  22739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22750 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22753 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22757 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22774 */     // (and:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPANDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  22777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22781 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22790 */     GIR_RootConstrainSelectedInstOperands,
     /*  22791 */     // GIR_Coverage, 24134,
     /*  22791 */     GIR_EraseRootFromParent_Done,
     /*  22792 */   // Label 605: @22792
     /*  22792 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(22850), // Rule ID 5688 //
     /*  22797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22832 */     // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  22835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22837 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22848 */     GIR_RootConstrainSelectedInstOperands,
     /*  22849 */     // GIR_Coverage, 5688,
     /*  22849 */     GIR_EraseRootFromParent_Done,
     /*  22850 */   // Label 606: @22850
     /*  22850 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(22873), // Rule ID 5685 //
     /*  22855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22866 */     // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPANDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  22866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  22871 */     GIR_RootConstrainSelectedInstOperands,
     /*  22872 */     // GIR_Coverage, 5685,
     /*  22872 */     GIR_Done,
     /*  22873 */   // Label 607: @22873
     /*  22873 */   GIM_Reject,
     /*  22874 */ // Label 604: @22874
     /*  22874 */ GIM_Reject,
     /*  22875 */ // Label 458: @22875
     /*  22875 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(23034),
     /*  22880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  22883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  22886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22890 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(22950), // Rule ID 4431 //
     /*  22895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  22910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  22914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22923 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22929 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  22931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22937 */     // (and:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  22937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  22940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  22946 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  22948 */     GIR_RootConstrainSelectedInstOperands,
     /*  22949 */     // GIR_Coverage, 4431,
     /*  22949 */     GIR_EraseRootFromParent_Done,
     /*  22950 */   // Label 609: @22950
     /*  22950 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(23010), // Rule ID 23690 //
     /*  22955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  22974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  22978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22987 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22993 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  22995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22997 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  22997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  23000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  23006 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  23008 */     GIR_RootConstrainSelectedInstOperands,
     /*  23009 */     // GIR_Coverage, 23690,
     /*  23009 */     GIR_EraseRootFromParent_Done,
     /*  23010 */   // Label 610: @23010
     /*  23010 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(23033), // Rule ID 4415 //
     /*  23015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23026 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KANDWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  23031 */     GIR_RootConstrainSelectedInstOperands,
     /*  23032 */     // GIR_Coverage, 4415,
     /*  23032 */     GIR_Done,
     /*  23033 */   // Label 611: @23033
     /*  23033 */   GIM_Reject,
     /*  23034 */ // Label 608: @23034
     /*  23034 */ GIM_Reject,
     /*  23035 */ // Label 459: @23035
     /*  23035 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(23376),
     /*  23040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  23043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  23046 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(23108), // Rule ID 25248 //
     /*  23051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23066 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23069 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23073 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23090 */     // (and:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPANDrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  23093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23095 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23097 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23106 */     GIR_RootConstrainSelectedInstOperands,
     /*  23107 */     // GIR_Coverage, 25248,
     /*  23107 */     GIR_EraseRootFromParent_Done,
     /*  23108 */   // Label 613: @23108
     /*  23108 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(23170), // Rule ID 25429 //
     /*  23113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23128 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23131 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23135 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23152 */     // (and:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPANDQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  23155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23157 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23168 */     GIR_RootConstrainSelectedInstOperands,
     /*  23169 */     // GIR_Coverage, 25429,
     /*  23169 */     GIR_EraseRootFromParent_Done,
     /*  23170 */   // Label 614: @23170
     /*  23170 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(23232), // Rule ID 18157 //
     /*  23175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23201 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23214 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  23217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23219 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23230 */     GIR_RootConstrainSelectedInstOperands,
     /*  23231 */     // GIR_Coverage, 18157,
     /*  23231 */     GIR_EraseRootFromParent_Done,
     /*  23232 */   // Label 615: @23232
     /*  23232 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(23294), // Rule ID 20023 //
     /*  23237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23263 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23276 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  23279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23281 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23292 */     GIR_RootConstrainSelectedInstOperands,
     /*  23293 */     // GIR_Coverage, 20023,
     /*  23293 */     GIR_EraseRootFromParent_Done,
     /*  23294 */   // Label 616: @23294
     /*  23294 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(23321), // Rule ID 18145 //
     /*  23299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23314 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  23314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  23319 */     GIR_RootConstrainSelectedInstOperands,
     /*  23320 */     // GIR_Coverage, 18145,
     /*  23320 */     GIR_Done,
     /*  23321 */   // Label 617: @23321
     /*  23321 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(23348), // Rule ID 18169 //
     /*  23326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  23329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23341 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  23341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  23346 */     GIR_RootConstrainSelectedInstOperands,
     /*  23347 */     // GIR_Coverage, 18169,
     /*  23347 */     GIR_Done,
     /*  23348 */   // Label 618: @23348
     /*  23348 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(23375), // Rule ID 20015 //
     /*  23353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23368 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPANDQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  23368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  23373 */     GIR_RootConstrainSelectedInstOperands,
     /*  23374 */     // GIR_Coverage, 20015,
     /*  23374 */     GIR_Done,
     /*  23375 */   // Label 619: @23375
     /*  23375 */   GIM_Reject,
     /*  23376 */ // Label 612: @23376
     /*  23376 */ GIM_Reject,
     /*  23377 */ // Label 460: @23377
     /*  23377 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(23842),
     /*  23382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  23385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  23388 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(23450), // Rule ID 25228 //
     /*  23393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23408 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23411 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23415 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23432 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPANDYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  23435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23437 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23448 */     GIR_RootConstrainSelectedInstOperands,
     /*  23449 */     // GIR_Coverage, 25228,
     /*  23449 */     GIR_EraseRootFromParent_Done,
     /*  23450 */   // Label 621: @23450
     /*  23450 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(23512), // Rule ID 25237 //
     /*  23455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23470 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23473 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23477 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23494 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VANDPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  23497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23499 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23510 */     GIR_RootConstrainSelectedInstOperands,
     /*  23511 */     // GIR_Coverage, 25237,
     /*  23511 */     GIR_EraseRootFromParent_Done,
     /*  23512 */   // Label 622: @23512
     /*  23512 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(23574), // Rule ID 25436 //
     /*  23517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23532 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23556 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPANDQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  23559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23561 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23572 */     GIR_RootConstrainSelectedInstOperands,
     /*  23573 */     // GIR_Coverage, 25436,
     /*  23573 */     GIR_EraseRootFromParent_Done,
     /*  23574 */   // Label 623: @23574
     /*  23574 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(23636), // Rule ID 18102 //
     /*  23579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23618 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  23621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23634 */     GIR_RootConstrainSelectedInstOperands,
     /*  23635 */     // GIR_Coverage, 18102,
     /*  23635 */     GIR_EraseRootFromParent_Done,
     /*  23636 */   // Label 624: @23636
     /*  23636 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(23698), // Rule ID 18130 //
     /*  23641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23660 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23667 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23680 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  23683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23685 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23696 */     GIR_RootConstrainSelectedInstOperands,
     /*  23697 */     // GIR_Coverage, 18130,
     /*  23697 */     GIR_EraseRootFromParent_Done,
     /*  23698 */   // Label 625: @23698
     /*  23698 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(23760), // Rule ID 20040 //
     /*  23703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23722 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23729 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23742 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  23745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23747 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23749 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23758 */     GIR_RootConstrainSelectedInstOperands,
     /*  23759 */     // GIR_Coverage, 20040,
     /*  23759 */     GIR_EraseRootFromParent_Done,
     /*  23760 */   // Label 626: @23760
     /*  23760 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(23787), // Rule ID 18090 //
     /*  23765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23780 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPANDYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  23780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  23785 */     GIR_RootConstrainSelectedInstOperands,
     /*  23786 */     // GIR_Coverage, 18090,
     /*  23786 */     GIR_Done,
     /*  23787 */   // Label 627: @23787
     /*  23787 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(23814), // Rule ID 18114 //
     /*  23792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23807 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VANDPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  23807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  23812 */     GIR_RootConstrainSelectedInstOperands,
     /*  23813 */     // GIR_Coverage, 18114,
     /*  23813 */     GIR_Done,
     /*  23814 */   // Label 628: @23814
     /*  23814 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(23841), // Rule ID 20032 //
     /*  23819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23834 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPANDQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  23834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  23839 */     GIR_RootConstrainSelectedInstOperands,
     /*  23840 */     // GIR_Coverage, 20032,
     /*  23840 */     GIR_Done,
     /*  23841 */   // Label 629: @23841
     /*  23841 */   GIM_Reject,
     /*  23842 */ // Label 620: @23842
     /*  23842 */ GIM_Reject,
     /*  23843 */ // Label 461: @23843
     /*  23843 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(23998),
     /*  23848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  23851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  23854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23858 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(23916), // Rule ID 24152 //
     /*  23863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23874 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23877 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23881 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23898 */     // (and:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPANDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZrm),
     /*  23901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23903 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23905 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23914 */     GIR_RootConstrainSelectedInstOperands,
     /*  23915 */     // GIR_Coverage, 24152,
     /*  23915 */     GIR_EraseRootFromParent_Done,
     /*  23916 */   // Label 631: @23916
     /*  23916 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(23974), // Rule ID 5715 //
     /*  23921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23936 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23939 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23943 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23956 */     // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZrm),
     /*  23959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23961 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23963 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23972 */     GIR_RootConstrainSelectedInstOperands,
     /*  23973 */     // GIR_Coverage, 5715,
     /*  23973 */     GIR_EraseRootFromParent_Done,
     /*  23974 */   // Label 632: @23974
     /*  23974 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(23997), // Rule ID 5712 //
     /*  23979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23990 */     // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPANDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  23990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZrr),
     /*  23995 */     GIR_RootConstrainSelectedInstOperands,
     /*  23996 */     // GIR_Coverage, 5712,
     /*  23996 */     GIR_Done,
     /*  23997 */   // Label 633: @23997
     /*  23997 */   GIM_Reject,
     /*  23998 */ // Label 630: @23998
     /*  23998 */ GIM_Reject,
     /*  23999 */ // Label 462: @23999
     /*  23999 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(24158),
     /*  24004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24014 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(24074), // Rule ID 4432 //
     /*  24019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24047 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24061 */     // (and:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /*  24064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24070 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  24072 */     GIR_RootConstrainSelectedInstOperands,
     /*  24073 */     // GIR_Coverage, 4432,
     /*  24073 */     GIR_EraseRootFromParent_Done,
     /*  24074 */   // Label 635: @24074
     /*  24074 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(24134), // Rule ID 23691 //
     /*  24079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24111 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24117 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24121 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /*  24124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24130 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  24132 */     GIR_RootConstrainSelectedInstOperands,
     /*  24133 */     // GIR_Coverage, 23691,
     /*  24133 */     GIR_EraseRootFromParent_Done,
     /*  24134 */   // Label 636: @24134
     /*  24134 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(24157), // Rule ID 4416 //
     /*  24139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24150 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KANDDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDDkk),
     /*  24155 */     GIR_RootConstrainSelectedInstOperands,
     /*  24156 */     // GIR_Coverage, 4416,
     /*  24156 */     GIR_Done,
     /*  24157 */   // Label 637: @24157
     /*  24157 */   GIM_Reject,
     /*  24158 */ // Label 634: @24158
     /*  24158 */ GIM_Reject,
     /*  24159 */ // Label 463: @24159
     /*  24159 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(24624),
     /*  24164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  24167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  24170 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(24232), // Rule ID 25227 //
     /*  24175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24190 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24193 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24197 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24214 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPANDYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  24217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24219 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24230 */     GIR_RootConstrainSelectedInstOperands,
     /*  24231 */     // GIR_Coverage, 25227,
     /*  24231 */     GIR_EraseRootFromParent_Done,
     /*  24232 */   // Label 639: @24232
     /*  24232 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(24294), // Rule ID 25236 //
     /*  24237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24259 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24276 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VANDPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  24279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24281 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24292 */     GIR_RootConstrainSelectedInstOperands,
     /*  24293 */     // GIR_Coverage, 25236,
     /*  24293 */     GIR_EraseRootFromParent_Done,
     /*  24294 */   // Label 640: @24294
     /*  24294 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(24356), // Rule ID 25435 //
     /*  24299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24314 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24317 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24321 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24338 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPANDQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  24341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24343 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24354 */     GIR_RootConstrainSelectedInstOperands,
     /*  24355 */     // GIR_Coverage, 25435,
     /*  24355 */     GIR_EraseRootFromParent_Done,
     /*  24356 */   // Label 641: @24356
     /*  24356 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(24418), // Rule ID 18101 //
     /*  24361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24380 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24383 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24387 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24400 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  24403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24405 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24407 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24416 */     GIR_RootConstrainSelectedInstOperands,
     /*  24417 */     // GIR_Coverage, 18101,
     /*  24417 */     GIR_EraseRootFromParent_Done,
     /*  24418 */   // Label 642: @24418
     /*  24418 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(24480), // Rule ID 18129 //
     /*  24423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24442 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24445 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24449 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24462 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  24465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24478 */     GIR_RootConstrainSelectedInstOperands,
     /*  24479 */     // GIR_Coverage, 18129,
     /*  24479 */     GIR_EraseRootFromParent_Done,
     /*  24480 */   // Label 643: @24480
     /*  24480 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(24542), // Rule ID 20039 //
     /*  24485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24524 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  24527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24529 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24540 */     GIR_RootConstrainSelectedInstOperands,
     /*  24541 */     // GIR_Coverage, 20039,
     /*  24541 */     GIR_EraseRootFromParent_Done,
     /*  24542 */   // Label 644: @24542
     /*  24542 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(24569), // Rule ID 18089 //
     /*  24547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24562 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPANDYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  24562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  24567 */     GIR_RootConstrainSelectedInstOperands,
     /*  24568 */     // GIR_Coverage, 18089,
     /*  24568 */     GIR_Done,
     /*  24569 */   // Label 645: @24569
     /*  24569 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(24596), // Rule ID 18113 //
     /*  24574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24589 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VANDPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  24589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  24594 */     GIR_RootConstrainSelectedInstOperands,
     /*  24595 */     // GIR_Coverage, 18113,
     /*  24595 */     GIR_Done,
     /*  24596 */   // Label 646: @24596
     /*  24596 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(24623), // Rule ID 20031 //
     /*  24601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24616 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPANDQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  24616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  24621 */     GIR_RootConstrainSelectedInstOperands,
     /*  24622 */     // GIR_Coverage, 20031,
     /*  24622 */     GIR_Done,
     /*  24623 */   // Label 647: @24623
     /*  24623 */   GIM_Reject,
     /*  24624 */ // Label 638: @24624
     /*  24624 */ GIM_Reject,
     /*  24625 */ // Label 464: @24625
     /*  24625 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(24780),
     /*  24630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  24633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  24636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24640 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(24698), // Rule ID 25442 //
     /*  24645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24663 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24680 */     // (and:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPANDQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24685 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24696 */     GIR_RootConstrainSelectedInstOperands,
     /*  24697 */     // GIR_Coverage, 25442,
     /*  24697 */     GIR_EraseRootFromParent_Done,
     /*  24698 */   // Label 649: @24698
     /*  24698 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(24756), // Rule ID 20056 //
     /*  24703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24718 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24725 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24738 */     // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24754 */     GIR_RootConstrainSelectedInstOperands,
     /*  24755 */     // GIR_Coverage, 20056,
     /*  24755 */     GIR_EraseRootFromParent_Done,
     /*  24756 */   // Label 650: @24756
     /*  24756 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(24779), // Rule ID 20048 //
     /*  24761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24772 */     // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPANDQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  24772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  24777 */     GIR_RootConstrainSelectedInstOperands,
     /*  24778 */     // GIR_Coverage, 20048,
     /*  24778 */     GIR_Done,
     /*  24779 */   // Label 651: @24779
     /*  24779 */   GIM_Reject,
     /*  24780 */ // Label 648: @24780
     /*  24780 */ GIM_Reject,
     /*  24781 */ // Label 465: @24781
     /*  24781 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(24940),
     /*  24786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  24789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  24792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24796 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(24856), // Rule ID 4433 //
     /*  24801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  24816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  24820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24829 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24835 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24843 */     // (and:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  24843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /*  24846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24852 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  24854 */     GIR_RootConstrainSelectedInstOperands,
     /*  24855 */     // GIR_Coverage, 4433,
     /*  24855 */     GIR_EraseRootFromParent_Done,
     /*  24856 */   // Label 653: @24856
     /*  24856 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(24916), // Rule ID 23692 //
     /*  24861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  24880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  24884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24893 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24903 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  24903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /*  24906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24912 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  24914 */     GIR_RootConstrainSelectedInstOperands,
     /*  24915 */     // GIR_Coverage, 23692,
     /*  24915 */     GIR_EraseRootFromParent_Done,
     /*  24916 */   // Label 654: @24916
     /*  24916 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(24939), // Rule ID 4417 //
     /*  24921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24932 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KANDQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  24932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDQkk),
     /*  24937 */     GIR_RootConstrainSelectedInstOperands,
     /*  24938 */     // GIR_Coverage, 4417,
     /*  24938 */     GIR_Done,
     /*  24939 */   // Label 655: @24939
     /*  24939 */   GIM_Reject,
     /*  24940 */ // Label 652: @24940
     /*  24940 */ GIM_Reject,
     /*  24941 */ // Label 466: @24941
     /*  24941 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(25096),
     /*  24946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  24949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  24952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24956 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(25014), // Rule ID 25441 //
     /*  24961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24996 */     // (and:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPANDQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25001 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25003 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25012 */     GIR_RootConstrainSelectedInstOperands,
     /*  25013 */     // GIR_Coverage, 25441,
     /*  25013 */     GIR_EraseRootFromParent_Done,
     /*  25014 */   // Label 657: @25014
     /*  25014 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(25072), // Rule ID 20055 //
     /*  25019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25034 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25037 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  25041 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25054 */     // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  25057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25059 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25061 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25070 */     GIR_RootConstrainSelectedInstOperands,
     /*  25071 */     // GIR_Coverage, 20055,
     /*  25071 */     GIR_EraseRootFromParent_Done,
     /*  25072 */   // Label 658: @25072
     /*  25072 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(25095), // Rule ID 20047 //
     /*  25077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25088 */     // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPANDQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  25088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  25093 */     GIR_RootConstrainSelectedInstOperands,
     /*  25094 */     // GIR_Coverage, 20047,
     /*  25094 */     GIR_Done,
     /*  25095 */   // Label 659: @25095
     /*  25095 */   GIM_Reject,
     /*  25096 */ // Label 656: @25096
     /*  25096 */ GIM_Reject,
     /*  25097 */ // Label 467: @25097
     /*  25097 */ GIM_Reject,
     /*  25098 */ // Label 4: @25098
     /*  25098 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 683*/ GIMT_Encode4(33501),
     /*  25109 */ /*GILLT_s1*//*Label 660*/ GIMT_Encode4(25209),
     /*  25113 */ /*GILLT_s8*//*Label 661*/ GIMT_Encode4(25309),
     /*  25117 */ /*GILLT_s16*//*Label 662*/ GIMT_Encode4(25702),
     /*  25121 */ /*GILLT_s32*//*Label 663*/ GIMT_Encode4(26299),
     /*  25125 */ /*GILLT_s64*//*Label 664*/ GIMT_Encode4(27755), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  25137 */ /*GILLT_v2s1*//*Label 665*/ GIMT_Encode4(29219),
     /*  25141 */ /*GILLT_v2s64*//*Label 666*/ GIMT_Encode4(29319),
     /*  25145 */ /*GILLT_v4s1*//*Label 667*/ GIMT_Encode4(29661),
     /*  25149 */ /*GILLT_v4s32*//*Label 668*/ GIMT_Encode4(29761),
     /*  25153 */ /*GILLT_v4s64*//*Label 669*/ GIMT_Encode4(30103),
     /*  25157 */ /*GILLT_v8s1*//*Label 670*/ GIMT_Encode4(30569),
     /*  25161 */ /*GILLT_v8s16*//*Label 671*/ GIMT_Encode4(30693),
     /*  25165 */ /*GILLT_v8s32*//*Label 672*/ GIMT_Encode4(31035),
     /*  25169 */ /*GILLT_v8s64*//*Label 673*/ GIMT_Encode4(31501),
     /*  25173 */ /*GILLT_v16s1*//*Label 674*/ GIMT_Encode4(31657),
     /*  25177 */ /*GILLT_v16s8*//*Label 675*/ GIMT_Encode4(31691),
     /*  25181 */ /*GILLT_v16s16*//*Label 676*/ GIMT_Encode4(32033),
     /*  25185 */ /*GILLT_v16s32*//*Label 677*/ GIMT_Encode4(32499),
     /*  25189 */ /*GILLT_v32s1*//*Label 678*/ GIMT_Encode4(32655),
     /*  25193 */ /*GILLT_v32s8*//*Label 679*/ GIMT_Encode4(32689),
     /*  25197 */ /*GILLT_v32s16*//*Label 680*/ GIMT_Encode4(33155),
     /*  25201 */ /*GILLT_v64s1*//*Label 681*/ GIMT_Encode4(33311),
     /*  25205 */ /*GILLT_v64s8*//*Label 682*/ GIMT_Encode4(33345),
     /*  25209 */ // Label 660: @25209
     /*  25209 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(25308), // Rule ID 19491 //
     /*  25214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  25217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  25220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25232 */   // (or:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  25232 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  25235 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25239 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25244 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  25248 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  25253 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  25256 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25260 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25265 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  25269 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  25274 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  25277 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  25281 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25286 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25289 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  25307 */   // GIR_Coverage, 19491,
     /*  25307 */   GIR_EraseRootFromParent_Done,
     /*  25308 */ // Label 684: @25308
     /*  25308 */ GIM_Reject,
     /*  25309 */ // Label 661: @25309
     /*  25309 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(25701),
     /*  25314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  25317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  25320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25324 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(25385), // Rule ID 26058 //
     /*  25329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25340 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25347 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25364 */     // (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (OR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm),
     /*  25367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25369 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25371 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25383 */     GIR_RootConstrainSelectedInstOperands,
     /*  25384 */     // GIR_Coverage, 26058,
     /*  25384 */     GIR_EraseRootFromParent_Done,
     /*  25385 */   // Label 686: @25385
     /*  25385 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(25446), // Rule ID 26077 //
     /*  25390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25401 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25404 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25408 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25425 */     // (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (OR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm_ND),
     /*  25428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25430 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25432 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25444 */     GIR_RootConstrainSelectedInstOperands,
     /*  25445 */     // GIR_Coverage, 26077,
     /*  25445 */     GIR_EraseRootFromParent_Done,
     /*  25446 */   // Label 687: @25446
     /*  25446 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(25507), // Rule ID 22827 //
     /*  25451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25469 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25473 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25486 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (OR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm),
     /*  25489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25505 */     GIR_RootConstrainSelectedInstOperands,
     /*  25506 */     // GIR_Coverage, 22827,
     /*  25506 */     GIR_EraseRootFromParent_Done,
     /*  25507 */   // Label 688: @25507
     /*  25507 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(25568), // Rule ID 22917 //
     /*  25512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25527 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25530 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25534 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25547 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (OR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm_ND),
     /*  25550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25552 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25554 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25566 */     GIR_RootConstrainSelectedInstOperands,
     /*  25567 */     // GIR_Coverage, 22917,
     /*  25567 */     GIR_EraseRootFromParent_Done,
     /*  25568 */   // Label 689: @25568
     /*  25568 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(25605), // Rule ID 22831 //
     /*  25573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25588 */     // MIs[1] Operand 1
     /*  25588 */     // No operand predicates
     /*  25588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25590 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  25590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri),
     /*  25593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25595 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  25600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25603 */     GIR_RootConstrainSelectedInstOperands,
     /*  25604 */     // GIR_Coverage, 22831,
     /*  25604 */     GIR_EraseRootFromParent_Done,
     /*  25605 */   // Label 690: @25605
     /*  25605 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(25642), // Rule ID 22921 //
     /*  25610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25625 */     // MIs[1] Operand 1
     /*  25625 */     // No operand predicates
     /*  25625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25627 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  25627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri_ND),
     /*  25630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25632 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  25637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25640 */     GIR_RootConstrainSelectedInstOperands,
     /*  25641 */     // GIR_Coverage, 22921,
     /*  25641 */     GIR_EraseRootFromParent_Done,
     /*  25642 */   // Label 691: @25642
     /*  25642 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(25671), // Rule ID 22823 //
     /*  25647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25658 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  25658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr),
     /*  25663 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  25669 */     GIR_RootConstrainSelectedInstOperands,
     /*  25670 */     // GIR_Coverage, 22823,
     /*  25670 */     GIR_Done,
     /*  25671 */   // Label 692: @25671
     /*  25671 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(25700), // Rule ID 22913 //
     /*  25676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25687 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  25687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr_ND),
     /*  25692 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  25698 */     GIR_RootConstrainSelectedInstOperands,
     /*  25699 */     // GIR_Coverage, 22913,
     /*  25699 */     GIR_Done,
     /*  25700 */   // Label 693: @25700
     /*  25700 */   GIM_Reject,
     /*  25701 */ // Label 685: @25701
     /*  25701 */ GIM_Reject,
     /*  25702 */ // Label 662: @25702
     /*  25702 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(26298),
     /*  25707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  25710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  25713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25717 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(25778), // Rule ID 26059 //
     /*  25722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25733 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25736 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25740 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25757 */     // (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (OR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm),
     /*  25760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25762 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25764 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25776 */     GIR_RootConstrainSelectedInstOperands,
     /*  25777 */     // GIR_Coverage, 26059,
     /*  25777 */     GIR_EraseRootFromParent_Done,
     /*  25778 */   // Label 695: @25778
     /*  25778 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(25839), // Rule ID 26078 //
     /*  25783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25801 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25818 */     // (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (OR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm_ND),
     /*  25821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25823 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25837 */     GIR_RootConstrainSelectedInstOperands,
     /*  25838 */     // GIR_Coverage, 26078,
     /*  25838 */     GIR_EraseRootFromParent_Done,
     /*  25839 */   // Label 696: @25839
     /*  25839 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(25900), // Rule ID 22828 //
     /*  25844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25859 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25862 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25866 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25879 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (OR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm),
     /*  25882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25884 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25886 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25898 */     GIR_RootConstrainSelectedInstOperands,
     /*  25899 */     // GIR_Coverage, 22828,
     /*  25899 */     GIR_EraseRootFromParent_Done,
     /*  25900 */   // Label 697: @25900
     /*  25900 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(25961), // Rule ID 22918 //
     /*  25905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25923 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25927 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25940 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (OR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm_ND),
     /*  25943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25959 */     GIR_RootConstrainSelectedInstOperands,
     /*  25960 */     // GIR_Coverage, 22918,
     /*  25960 */     GIR_EraseRootFromParent_Done,
     /*  25961 */   // Label 698: @25961
     /*  25961 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(26063), // Rule ID 26034 //
     /*  25966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  25974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  25978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  25982 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  25986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25997 */     // (or:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  25997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  26000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  26011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  26014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  26018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26023 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  26030 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  26033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  26038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  26043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  26048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /*  26051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26053 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26061 */     GIR_RootConstrainSelectedInstOperands,
     /*  26062 */     // GIR_Coverage, 26034,
     /*  26062 */     GIR_EraseRootFromParent_Done,
     /*  26063 */   // Label 699: @26063
     /*  26063 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(26165), // Rule ID 22772 //
     /*  26068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  26080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  26084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  26088 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  26092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  26097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26099 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  26099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  26102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  26113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  26116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  26120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26125 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  26132 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  26135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  26140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  26145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  26150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /*  26153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26155 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26163 */     GIR_RootConstrainSelectedInstOperands,
     /*  26164 */     // GIR_Coverage, 22772,
     /*  26164 */     GIR_EraseRootFromParent_Done,
     /*  26165 */   // Label 700: @26165
     /*  26165 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(26202), // Rule ID 22832 //
     /*  26170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26185 */     // MIs[1] Operand 1
     /*  26185 */     // No operand predicates
     /*  26185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26187 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  26187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri),
     /*  26190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26192 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  26197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26200 */     GIR_RootConstrainSelectedInstOperands,
     /*  26201 */     // GIR_Coverage, 22832,
     /*  26201 */     GIR_EraseRootFromParent_Done,
     /*  26202 */   // Label 701: @26202
     /*  26202 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(26239), // Rule ID 22922 //
     /*  26207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26222 */     // MIs[1] Operand 1
     /*  26222 */     // No operand predicates
     /*  26222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26224 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  26224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri_ND),
     /*  26227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26229 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  26234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26237 */     GIR_RootConstrainSelectedInstOperands,
     /*  26238 */     // GIR_Coverage, 22922,
     /*  26238 */     GIR_EraseRootFromParent_Done,
     /*  26239 */   // Label 702: @26239
     /*  26239 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(26268), // Rule ID 22824 //
     /*  26244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26255 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  26255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr),
     /*  26260 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  26266 */     GIR_RootConstrainSelectedInstOperands,
     /*  26267 */     // GIR_Coverage, 22824,
     /*  26267 */     GIR_Done,
     /*  26268 */   // Label 703: @26268
     /*  26268 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(26297), // Rule ID 22914 //
     /*  26273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26284 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  26284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr_ND),
     /*  26289 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  26295 */     GIR_RootConstrainSelectedInstOperands,
     /*  26296 */     // GIR_Coverage, 22914,
     /*  26296 */     GIR_Done,
     /*  26297 */   // Label 704: @26297
     /*  26297 */   GIM_Reject,
     /*  26298 */ // Label 694: @26298
     /*  26298 */ GIM_Reject,
     /*  26299 */ // Label 663: @26299
     /*  26299 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(27754),
     /*  26304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26307 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(26375), // Rule ID 26060 //
     /*  26312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26330 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26333 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26337 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26354 */     // (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (OR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm),
     /*  26357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26359 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26361 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26373 */     GIR_RootConstrainSelectedInstOperands,
     /*  26374 */     // GIR_Coverage, 26060,
     /*  26374 */     GIR_EraseRootFromParent_Done,
     /*  26375 */   // Label 706: @26375
     /*  26375 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(26443), // Rule ID 26079 //
     /*  26380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26398 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26401 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26405 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26422 */     // (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (OR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm_ND),
     /*  26425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26427 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26441 */     GIR_RootConstrainSelectedInstOperands,
     /*  26442 */     // GIR_Coverage, 26079,
     /*  26442 */     GIR_EraseRootFromParent_Done,
     /*  26443 */   // Label 707: @26443
     /*  26443 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(26511), // Rule ID 22829 //
     /*  26448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26470 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26477 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26490 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (OR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm),
     /*  26493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26495 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26509 */     GIR_RootConstrainSelectedInstOperands,
     /*  26510 */     // GIR_Coverage, 22829,
     /*  26510 */     GIR_EraseRootFromParent_Done,
     /*  26511 */   // Label 708: @26511
     /*  26511 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(26579), // Rule ID 22919 //
     /*  26516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26541 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26545 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26558 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (OR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm_ND),
     /*  26561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26563 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26565 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26577 */     GIR_RootConstrainSelectedInstOperands,
     /*  26578 */     // GIR_Coverage, 22919,
     /*  26578 */     GIR_EraseRootFromParent_Done,
     /*  26579 */   // Label 709: @26579
     /*  26579 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(26656), // Rule ID 25000 //
     /*  26584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26615 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26631 */     // MIs[2] src
     /*  26631 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26636 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26642 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /*  26645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26654 */     GIR_RootConstrainSelectedInstOperands,
     /*  26655 */     // GIR_Coverage, 25000,
     /*  26655 */     GIR_EraseRootFromParent_Done,
     /*  26656 */   // Label 710: @26656
     /*  26656 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(26733), // Rule ID 25002 //
     /*  26661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26692 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  26696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26708 */     // MIs[2] src
     /*  26708 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26719 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /*  26722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26731 */     GIR_RootConstrainSelectedInstOperands,
     /*  26732 */     // GIR_Coverage, 25002,
     /*  26732 */     GIR_EraseRootFromParent_Done,
     /*  26733 */   // Label 711: @26733
     /*  26733 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(26811), // Rule ID 24988 //
     /*  26738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  26773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26782 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  26786 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26790 */     // MIs[0] src
     /*  26790 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26797 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  26800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /*  26806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26809 */     GIR_RootConstrainSelectedInstOperands,
     /*  26810 */     // GIR_Coverage, 24988,
     /*  26810 */     GIR_EraseRootFromParent_Done,
     /*  26811 */   // Label 712: @26811
     /*  26811 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(26888), // Rule ID 17363 //
     /*  26816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26847 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26863 */     // MIs[2] src
     /*  26863 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26868 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26874 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /*  26877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26886 */     GIR_RootConstrainSelectedInstOperands,
     /*  26887 */     // GIR_Coverage, 17363,
     /*  26887 */     GIR_EraseRootFromParent_Done,
     /*  26888 */   // Label 713: @26888
     /*  26888 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(26965), // Rule ID 17365 //
     /*  26893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26924 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26940 */     // MIs[2] src
     /*  26940 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26945 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  26949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26951 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /*  26954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26963 */     GIR_RootConstrainSelectedInstOperands,
     /*  26964 */     // GIR_Coverage, 17365,
     /*  26964 */     GIR_EraseRootFromParent_Done,
     /*  26965 */   // Label 714: @26965
     /*  26965 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(27039), // Rule ID 17351 //
     /*  26970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27012 */     // MIs[2] src
     /*  27012 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27017 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  27021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27027 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27032 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27037 */     GIR_RootConstrainSelectedInstOperands,
     /*  27038 */     // GIR_Coverage, 17351,
     /*  27038 */     GIR_EraseRootFromParent_Done,
     /*  27039 */   // Label 715: @27039
     /*  27039 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(27097), // Rule ID 24996 //
     /*  27044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27072 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  27076 */     // MIs[0] src
     /*  27076 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27083 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /*  27086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27095 */     GIR_RootConstrainSelectedInstOperands,
     /*  27096 */     // GIR_Coverage, 24996,
     /*  27096 */     GIR_EraseRootFromParent_Done,
     /*  27097 */   // Label 716: @27097
     /*  27097 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(27155), // Rule ID 24998 //
     /*  27102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27130 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27134 */     // MIs[0] src
     /*  27134 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27141 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /*  27144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27153 */     GIR_RootConstrainSelectedInstOperands,
     /*  27154 */     // GIR_Coverage, 24998,
     /*  27154 */     GIR_EraseRootFromParent_Done,
     /*  27155 */   // Label 717: @27155
     /*  27155 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(27264), // Rule ID 26040 //
     /*  27160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  27175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  27183 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  27187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  27192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27198 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  27198 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  27201 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  27205 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  27212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  27215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  27219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27224 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  27227 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  27231 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  27234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  27249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /*  27252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27254 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  27256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  27259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27262 */     GIR_RootConstrainSelectedInstOperands,
     /*  27263 */     // GIR_Coverage, 26040,
     /*  27263 */     GIR_EraseRootFromParent_Done,
     /*  27264 */   // Label 718: @27264
     /*  27264 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(27322), // Rule ID 24990 //
     /*  27269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  27284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27292 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  27296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27301 */     // MIs[0] src
     /*  27301 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27308 */     // (or:{ *:[i32] } (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  27317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27320 */     GIR_RootConstrainSelectedInstOperands,
     /*  27321 */     // GIR_Coverage, 24990,
     /*  27321 */     GIR_EraseRootFromParent_Done,
     /*  27322 */   // Label 719: @27322
     /*  27322 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(27376), // Rule ID 17359 //
     /*  27327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27353 */     // MIs[1] src
     /*  27353 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27358 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  27362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27364 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /*  27367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27369 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27374 */     GIR_RootConstrainSelectedInstOperands,
     /*  27375 */     // GIR_Coverage, 17359,
     /*  27375 */     GIR_EraseRootFromParent_Done,
     /*  27376 */   // Label 720: @27376
     /*  27376 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(27430), // Rule ID 17361 //
     /*  27381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27407 */     // MIs[1] src
     /*  27407 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27412 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27418 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /*  27421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27428 */     GIR_RootConstrainSelectedInstOperands,
     /*  27429 */     // GIR_Coverage, 17361,
     /*  27429 */     GIR_EraseRootFromParent_Done,
     /*  27430 */   // Label 721: @27430
     /*  27430 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(27539), // Rule ID 22778 //
     /*  27435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  27454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  27462 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  27466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  27471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27473 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  27473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  27476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  27480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  27487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  27490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  27494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27499 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  27502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  27506 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  27509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  27524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /*  27527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27529 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  27534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27537 */     GIR_RootConstrainSelectedInstOperands,
     /*  27538 */     // GIR_Coverage, 22778,
     /*  27538 */     GIR_EraseRootFromParent_Done,
     /*  27539 */   // Label 722: @27539
     /*  27539 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(27593), // Rule ID 17353 //
     /*  27544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  27566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27570 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  27574 */     // MIs[1] src
     /*  27574 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27581 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27591 */     GIR_RootConstrainSelectedInstOperands,
     /*  27592 */     // GIR_Coverage, 17353,
     /*  27592 */     GIR_EraseRootFromParent_Done,
     /*  27593 */   // Label 723: @27593
     /*  27593 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(27637), // Rule ID 22833 //
     /*  27598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27620 */     // MIs[1] Operand 1
     /*  27620 */     // No operand predicates
     /*  27620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27622 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  27622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri),
     /*  27625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  27632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27635 */     GIR_RootConstrainSelectedInstOperands,
     /*  27636 */     // GIR_Coverage, 22833,
     /*  27636 */     GIR_EraseRootFromParent_Done,
     /*  27637 */   // Label 724: @27637
     /*  27637 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(27681), // Rule ID 22923 //
     /*  27642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27664 */     // MIs[1] Operand 1
     /*  27664 */     // No operand predicates
     /*  27664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27666 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  27666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri_ND),
     /*  27669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27671 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  27676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27679 */     GIR_RootConstrainSelectedInstOperands,
     /*  27680 */     // GIR_Coverage, 22923,
     /*  27680 */     GIR_EraseRootFromParent_Done,
     /*  27681 */   // Label 725: @27681
     /*  27681 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(27717), // Rule ID 22825 //
     /*  27686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27704 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  27704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr),
     /*  27709 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  27715 */     GIR_RootConstrainSelectedInstOperands,
     /*  27716 */     // GIR_Coverage, 22825,
     /*  27716 */     GIR_Done,
     /*  27717 */   // Label 726: @27717
     /*  27717 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(27753), // Rule ID 22915 //
     /*  27722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27740 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  27740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr_ND),
     /*  27745 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  27751 */     GIR_RootConstrainSelectedInstOperands,
     /*  27752 */     // GIR_Coverage, 22915,
     /*  27752 */     GIR_Done,
     /*  27753 */   // Label 727: @27753
     /*  27753 */   GIM_Reject,
     /*  27754 */ // Label 705: @27754
     /*  27754 */ GIM_Reject,
     /*  27755 */ // Label 664: @27755
     /*  27755 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(29218),
     /*  27760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27763 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(27831), // Rule ID 26061 //
     /*  27768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  27786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  27789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  27793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  27797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  27810 */     // (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (OR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  27810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm),
     /*  27813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  27817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  27821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  27829 */     GIR_RootConstrainSelectedInstOperands,
     /*  27830 */     // GIR_Coverage, 26061,
     /*  27830 */     GIR_EraseRootFromParent_Done,
     /*  27831 */   // Label 729: @27831
     /*  27831 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(27899), // Rule ID 26080 //
     /*  27836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  27854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  27857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  27861 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  27865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  27878 */     // (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (OR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  27878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm_ND),
     /*  27881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  27885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  27889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  27897 */     GIR_RootConstrainSelectedInstOperands,
     /*  27898 */     // GIR_Coverage, 26080,
     /*  27898 */     GIR_EraseRootFromParent_Done,
     /*  27899 */   // Label 730: @27899
     /*  27899 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(27967), // Rule ID 22830 //
     /*  27904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  27926 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  27929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  27933 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  27937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  27946 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (OR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  27946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm),
     /*  27949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27951 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  27957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  27965 */     GIR_RootConstrainSelectedInstOperands,
     /*  27966 */     // GIR_Coverage, 22830,
     /*  27966 */     GIR_EraseRootFromParent_Done,
     /*  27967 */   // Label 731: @27967
     /*  27967 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(28035), // Rule ID 22920 //
     /*  27972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  27994 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  27997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28001 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28014 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (OR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm_ND),
     /*  28017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28019 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  28021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28033 */     GIR_RootConstrainSelectedInstOperands,
     /*  28034 */     // GIR_Coverage, 22920,
     /*  28034 */     GIR_EraseRootFromParent_Done,
     /*  28035 */   // Label 732: @28035
     /*  28035 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(28112), // Rule ID 25001 //
     /*  28040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28071 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28087 */     // MIs[2] src
     /*  28087 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28092 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28098 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /*  28101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28110 */     GIR_RootConstrainSelectedInstOperands,
     /*  28111 */     // GIR_Coverage, 25001,
     /*  28111 */     GIR_EraseRootFromParent_Done,
     /*  28112 */   // Label 733: @28112
     /*  28112 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(28189), // Rule ID 25003 //
     /*  28117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28148 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28164 */     // MIs[2] src
     /*  28164 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28169 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28175 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /*  28178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28187 */     GIR_RootConstrainSelectedInstOperands,
     /*  28188 */     // GIR_Coverage, 25003,
     /*  28188 */     GIR_EraseRootFromParent_Done,
     /*  28189 */   // Label 734: @28189
     /*  28189 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(28267), // Rule ID 24989 //
     /*  28194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  28229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28233 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28238 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28242 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28246 */     // MIs[0] src
     /*  28246 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  28251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28253 */     // (or:{ *:[i64] } (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /*  28262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28265 */     GIR_RootConstrainSelectedInstOperands,
     /*  28266 */     // GIR_Coverage, 24989,
     /*  28266 */     GIR_EraseRootFromParent_Done,
     /*  28267 */   // Label 735: @28267
     /*  28267 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(28344), // Rule ID 17364 //
     /*  28272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28303 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28319 */     // MIs[2] src
     /*  28319 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28324 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28330 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /*  28333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28342 */     GIR_RootConstrainSelectedInstOperands,
     /*  28343 */     // GIR_Coverage, 17364,
     /*  28343 */     GIR_EraseRootFromParent_Done,
     /*  28344 */   // Label 736: @28344
     /*  28344 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(28421), // Rule ID 17366 //
     /*  28349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28380 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28396 */     // MIs[2] src
     /*  28396 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28401 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28407 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /*  28410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28419 */     GIR_RootConstrainSelectedInstOperands,
     /*  28420 */     // GIR_Coverage, 17366,
     /*  28420 */     GIR_EraseRootFromParent_Done,
     /*  28421 */   // Label 737: @28421
     /*  28421 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(28495), // Rule ID 17352 //
     /*  28426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28468 */     // MIs[2] src
     /*  28468 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  28473 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28477 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28483 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28493 */     GIR_RootConstrainSelectedInstOperands,
     /*  28494 */     // GIR_Coverage, 17352,
     /*  28494 */     GIR_EraseRootFromParent_Done,
     /*  28495 */   // Label 738: @28495
     /*  28495 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(28553), // Rule ID 24997 //
     /*  28500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28528 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28532 */     // MIs[0] src
     /*  28532 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28539 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /*  28542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28551 */     GIR_RootConstrainSelectedInstOperands,
     /*  28552 */     // GIR_Coverage, 24997,
     /*  28552 */     GIR_EraseRootFromParent_Done,
     /*  28553 */   // Label 739: @28553
     /*  28553 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(28611), // Rule ID 24999 //
     /*  28558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28586 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28590 */     // MIs[0] src
     /*  28590 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28597 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /*  28600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28609 */     GIR_RootConstrainSelectedInstOperands,
     /*  28610 */     // GIR_Coverage, 24999,
     /*  28610 */     GIR_EraseRootFromParent_Done,
     /*  28611 */   // Label 740: @28611
     /*  28611 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(28720), // Rule ID 26046 //
     /*  28616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  28631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  28639 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  28643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  28648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28654 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  28654 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  28657 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  28661 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  28668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  28671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  28675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28680 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  28683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  28687 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  28690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  28705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /*  28708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28710 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  28712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  28715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28718 */     GIR_RootConstrainSelectedInstOperands,
     /*  28719 */     // GIR_Coverage, 26046,
     /*  28719 */     GIR_EraseRootFromParent_Done,
     /*  28720 */   // Label 741: @28720
     /*  28720 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(28778), // Rule ID 24991 //
     /*  28725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  28740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28748 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  28752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28757 */     // MIs[0] src
     /*  28757 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  28762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28764 */     // (or:{ *:[i64] } (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  28773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28776 */     GIR_RootConstrainSelectedInstOperands,
     /*  28777 */     // GIR_Coverage, 24991,
     /*  28777 */     GIR_EraseRootFromParent_Done,
     /*  28778 */   // Label 742: @28778
     /*  28778 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(28832), // Rule ID 17360 //
     /*  28783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28809 */     // MIs[1] src
     /*  28809 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  28814 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28820 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /*  28823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28830 */     GIR_RootConstrainSelectedInstOperands,
     /*  28831 */     // GIR_Coverage, 17360,
     /*  28831 */     GIR_EraseRootFromParent_Done,
     /*  28832 */   // Label 743: @28832
     /*  28832 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(28886), // Rule ID 17362 //
     /*  28837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28863 */     // MIs[1] src
     /*  28863 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  28868 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28874 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /*  28877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28879 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28884 */     GIR_RootConstrainSelectedInstOperands,
     /*  28885 */     // GIR_Coverage, 17362,
     /*  28885 */     GIR_EraseRootFromParent_Done,
     /*  28886 */   // Label 744: @28886
     /*  28886 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(28995), // Rule ID 22784 //
     /*  28891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  28910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  28918 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  28922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  28927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28929 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  28929 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  28932 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  28936 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  28943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  28946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  28950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28955 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  28958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  28962 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  28965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  28980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /*  28983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28985 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  28987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  28990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28993 */     GIR_RootConstrainSelectedInstOperands,
     /*  28994 */     // GIR_Coverage, 22784,
     /*  28994 */     GIR_EraseRootFromParent_Done,
     /*  28995 */   // Label 745: @28995
     /*  28995 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(29049), // Rule ID 17354 //
     /*  29000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  29003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  29022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  29026 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  29030 */     // MIs[1] src
     /*  29030 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  29035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29037 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  29037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  29040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29042 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29047 */     GIR_RootConstrainSelectedInstOperands,
     /*  29048 */     // GIR_Coverage, 17354,
     /*  29048 */     GIR_EraseRootFromParent_Done,
     /*  29049 */   // Label 746: @29049
     /*  29049 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(29097), // Rule ID 22834 //
     /*  29054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  29057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  29080 */     // MIs[1] Operand 1
     /*  29080 */     // No operand predicates
     /*  29080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29082 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  29082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32),
     /*  29085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  29092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29095 */     GIR_RootConstrainSelectedInstOperands,
     /*  29096 */     // GIR_Coverage, 22834,
     /*  29096 */     GIR_EraseRootFromParent_Done,
     /*  29097 */   // Label 747: @29097
     /*  29097 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(29145), // Rule ID 22924 //
     /*  29102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  29105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  29128 */     // MIs[1] Operand 1
     /*  29128 */     // No operand predicates
     /*  29128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29130 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  29130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32_ND),
     /*  29133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29135 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  29140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29143 */     GIR_RootConstrainSelectedInstOperands,
     /*  29144 */     // GIR_Coverage, 22924,
     /*  29144 */     GIR_EraseRootFromParent_Done,
     /*  29145 */   // Label 748: @29145
     /*  29145 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(29181), // Rule ID 22826 //
     /*  29150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  29153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29168 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  29168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr),
     /*  29173 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  29179 */     GIR_RootConstrainSelectedInstOperands,
     /*  29180 */     // GIR_Coverage, 22826,
     /*  29180 */     GIR_Done,
     /*  29181 */   // Label 749: @29181
     /*  29181 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(29217), // Rule ID 22916 //
     /*  29186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  29189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29204 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  29204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr_ND),
     /*  29209 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  29215 */     GIR_RootConstrainSelectedInstOperands,
     /*  29216 */     // GIR_Coverage, 22916,
     /*  29216 */     GIR_Done,
     /*  29217 */   // Label 750: @29217
     /*  29217 */   GIM_Reject,
     /*  29218 */ // Label 728: @29218
     /*  29218 */ GIM_Reject,
     /*  29219 */ // Label 665: @29219
     /*  29219 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(29318), // Rule ID 19492 //
     /*  29224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  29227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  29230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29242 */   // (or:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  29242 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  29245 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29249 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29254 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  29258 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29263 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  29266 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29270 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29275 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  29279 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29284 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  29287 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  29291 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29296 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29299 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  29302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29312 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  29317 */   // GIR_Coverage, 19492,
     /*  29317 */   GIR_EraseRootFromParent_Done,
     /*  29318 */ // Label 751: @29318
     /*  29318 */ GIM_Reject,
     /*  29319 */ // Label 666: @29319
     /*  29319 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(29660),
     /*  29324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  29330 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(29392), // Rule ID 23360 //
     /*  29335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29350 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29353 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29357 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29374 */     // (or:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29379 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29390 */     GIR_RootConstrainSelectedInstOperands,
     /*  29391 */     // GIR_Coverage, 23360,
     /*  29391 */     GIR_EraseRootFromParent_Done,
     /*  29392 */   // Label 753: @29392
     /*  29392 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(29454), // Rule ID 24182 //
     /*  29397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29412 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29415 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29419 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29436 */     // (or:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  29439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29441 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29443 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29452 */     GIR_RootConstrainSelectedInstOperands,
     /*  29453 */     // GIR_Coverage, 24182,
     /*  29453 */     GIR_EraseRootFromParent_Done,
     /*  29454 */   // Label 754: @29454
     /*  29454 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(29516), // Rule ID 2116 //
     /*  29459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29478 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29481 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29498 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29503 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29514 */     GIR_RootConstrainSelectedInstOperands,
     /*  29515 */     // GIR_Coverage, 2116,
     /*  29515 */     GIR_EraseRootFromParent_Done,
     /*  29516 */   // Label 755: @29516
     /*  29516 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(29578), // Rule ID 5760 //
     /*  29521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29540 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29543 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29547 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29560 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  29563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29565 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29567 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29576 */     GIR_RootConstrainSelectedInstOperands,
     /*  29577 */     // GIR_Coverage, 5760,
     /*  29577 */     GIR_EraseRootFromParent_Done,
     /*  29578 */   // Label 756: @29578
     /*  29578 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(29605), // Rule ID 2115 //
     /*  29583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29598 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  29598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  29603 */     GIR_RootConstrainSelectedInstOperands,
     /*  29604 */     // GIR_Coverage, 2115,
     /*  29604 */     GIR_Done,
     /*  29605 */   // Label 757: @29605
     /*  29605 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(29632), // Rule ID 2117 //
     /*  29610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  29613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29625 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  29625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  29630 */     GIR_RootConstrainSelectedInstOperands,
     /*  29631 */     // GIR_Coverage, 2117,
     /*  29631 */     GIR_Done,
     /*  29632 */   // Label 758: @29632
     /*  29632 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(29659), // Rule ID 5757 //
     /*  29637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29652 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  29652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  29657 */     GIR_RootConstrainSelectedInstOperands,
     /*  29658 */     // GIR_Coverage, 5757,
     /*  29658 */     GIR_Done,
     /*  29659 */   // Label 759: @29659
     /*  29659 */   GIM_Reject,
     /*  29660 */ // Label 752: @29660
     /*  29660 */ GIM_Reject,
     /*  29661 */ // Label 667: @29661
     /*  29661 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(29760), // Rule ID 19493 //
     /*  29666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  29669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  29672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29684 */   // (or:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  29684 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  29687 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29691 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29696 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  29700 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29705 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  29708 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29712 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29717 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  29721 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  29729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  29733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29738 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29741 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  29744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29751 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29754 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  29759 */   // GIR_Coverage, 19493,
     /*  29759 */   GIR_EraseRootFromParent_Done,
     /*  29760 */ // Label 760: @29760
     /*  29760 */ GIM_Reject,
     /*  29761 */ // Label 668: @29761
     /*  29761 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(30102),
     /*  29766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29772 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(29834), // Rule ID 24200 //
     /*  29777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29816 */     // (or:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rm),
     /*  29819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29832 */     GIR_RootConstrainSelectedInstOperands,
     /*  29833 */     // GIR_Coverage, 24200,
     /*  29833 */     GIR_EraseRootFromParent_Done,
     /*  29834 */   // Label 762: @29834
     /*  29834 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(29896), // Rule ID 25253 //
     /*  29839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29861 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29878 */     // (or:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29894 */     GIR_RootConstrainSelectedInstOperands,
     /*  29895 */     // GIR_Coverage, 25253,
     /*  29895 */     GIR_EraseRootFromParent_Done,
     /*  29896 */   // Label 763: @29896
     /*  29896 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(29958), // Rule ID 5787 //
     /*  29901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29940 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rm),
     /*  29943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29956 */     GIR_RootConstrainSelectedInstOperands,
     /*  29957 */     // GIR_Coverage, 5787,
     /*  29957 */     GIR_EraseRootFromParent_Done,
     /*  29958 */   // Label 764: @29958
     /*  29958 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(30020), // Rule ID 18162 //
     /*  29963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29982 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29985 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29989 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30002 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30018 */     GIR_RootConstrainSelectedInstOperands,
     /*  30019 */     // GIR_Coverage, 18162,
     /*  30019 */     GIR_EraseRootFromParent_Done,
     /*  30020 */   // Label 765: @30020
     /*  30020 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(30047), // Rule ID 5784 //
     /*  30025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30040 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  30040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rr),
     /*  30045 */     GIR_RootConstrainSelectedInstOperands,
     /*  30046 */     // GIR_Coverage, 5784,
     /*  30046 */     GIR_Done,
     /*  30047 */   // Label 766: @30047
     /*  30047 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(30074), // Rule ID 18150 //
     /*  30052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30067 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  30067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  30072 */     GIR_RootConstrainSelectedInstOperands,
     /*  30073 */     // GIR_Coverage, 18150,
     /*  30073 */     GIR_Done,
     /*  30074 */   // Label 767: @30074
     /*  30074 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(30101), // Rule ID 18174 //
     /*  30079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  30082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30094 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  30094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  30099 */     GIR_RootConstrainSelectedInstOperands,
     /*  30100 */     // GIR_Coverage, 18174,
     /*  30100 */     GIR_Done,
     /*  30101 */   // Label 768: @30101
     /*  30101 */   GIM_Reject,
     /*  30102 */ // Label 761: @30102
     /*  30102 */ GIM_Reject,
     /*  30103 */ // Label 669: @30103
     /*  30103 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(30568),
     /*  30108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  30111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  30114 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(30176), // Rule ID 23362 //
     /*  30119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30158 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  30161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30163 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30174 */     GIR_RootConstrainSelectedInstOperands,
     /*  30175 */     // GIR_Coverage, 23362,
     /*  30175 */     GIR_EraseRootFromParent_Done,
     /*  30176 */   // Label 770: @30176
     /*  30176 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(30238), // Rule ID 24176 //
     /*  30181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30196 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30199 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30203 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30220 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  30223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30225 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30236 */     GIR_RootConstrainSelectedInstOperands,
     /*  30237 */     // GIR_Coverage, 24176,
     /*  30237 */     GIR_EraseRootFromParent_Done,
     /*  30238 */   // Label 771: @30238
     /*  30238 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(30300), // Rule ID 25243 //
     /*  30243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30258 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30261 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30265 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30282 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  30285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30287 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30298 */     GIR_RootConstrainSelectedInstOperands,
     /*  30299 */     // GIR_Coverage, 25243,
     /*  30299 */     GIR_EraseRootFromParent_Done,
     /*  30300 */   // Label 772: @30300
     /*  30300 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(30362), // Rule ID 2120 //
     /*  30305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30324 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30327 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30344 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  30347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30349 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30351 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30360 */     GIR_RootConstrainSelectedInstOperands,
     /*  30361 */     // GIR_Coverage, 2120,
     /*  30361 */     GIR_EraseRootFromParent_Done,
     /*  30362 */   // Label 773: @30362
     /*  30362 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(30424), // Rule ID 5751 //
     /*  30367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30386 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30389 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30406 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  30409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30411 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30413 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30422 */     GIR_RootConstrainSelectedInstOperands,
     /*  30423 */     // GIR_Coverage, 5751,
     /*  30423 */     GIR_EraseRootFromParent_Done,
     /*  30424 */   // Label 774: @30424
     /*  30424 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(30486), // Rule ID 18136 //
     /*  30429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30455 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30468 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  30471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30473 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30484 */     GIR_RootConstrainSelectedInstOperands,
     /*  30485 */     // GIR_Coverage, 18136,
     /*  30485 */     GIR_EraseRootFromParent_Done,
     /*  30486 */   // Label 775: @30486
     /*  30486 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(30513), // Rule ID 2119 //
     /*  30491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30506 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  30506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  30511 */     GIR_RootConstrainSelectedInstOperands,
     /*  30512 */     // GIR_Coverage, 2119,
     /*  30512 */     GIR_Done,
     /*  30513 */   // Label 776: @30513
     /*  30513 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(30540), // Rule ID 5748 //
     /*  30518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30533 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  30533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  30538 */     GIR_RootConstrainSelectedInstOperands,
     /*  30539 */     // GIR_Coverage, 5748,
     /*  30539 */     GIR_Done,
     /*  30540 */   // Label 777: @30540
     /*  30540 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(30567), // Rule ID 18120 //
     /*  30545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30560 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  30560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  30565 */     GIR_RootConstrainSelectedInstOperands,
     /*  30566 */     // GIR_Coverage, 18120,
     /*  30566 */     GIR_Done,
     /*  30567 */   // Label 778: @30567
     /*  30567 */   GIM_Reject,
     /*  30568 */ // Label 769: @30568
     /*  30568 */ GIM_Reject,
     /*  30569 */ // Label 670: @30569
     /*  30569 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(30692),
     /*  30574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  30577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  30580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30592 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(30607), // Rule ID 4418 //
     /*  30597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  30600 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  30600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORBkk),
     /*  30605 */     GIR_RootConstrainSelectedInstOperands,
     /*  30606 */     // GIR_Coverage, 4418,
     /*  30606 */     GIR_Done,
     /*  30607 */   // Label 780: @30607
     /*  30607 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(30691), // Rule ID 19490 //
     /*  30612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  30615 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  30615 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  30618 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30622 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30627 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  30631 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  30636 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  30639 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30643 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30648 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  30652 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  30657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  30660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  30664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30669 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  30672 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  30675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  30690 */     // GIR_Coverage, 19490,
     /*  30690 */     GIR_EraseRootFromParent_Done,
     /*  30691 */   // Label 781: @30691
     /*  30691 */   GIM_Reject,
     /*  30692 */ // Label 779: @30692
     /*  30692 */ GIM_Reject,
     /*  30693 */ // Label 671: @30693
     /*  30693 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(31034),
     /*  30698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  30704 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(30766), // Rule ID 25252 //
     /*  30709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30748 */     // (or:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30753 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30755 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30764 */     GIR_RootConstrainSelectedInstOperands,
     /*  30765 */     // GIR_Coverage, 25252,
     /*  30765 */     GIR_EraseRootFromParent_Done,
     /*  30766 */   // Label 783: @30766
     /*  30766 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(30828), // Rule ID 25432 //
     /*  30771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  30774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30810 */     // (or:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  30813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30826 */     GIR_RootConstrainSelectedInstOperands,
     /*  30827 */     // GIR_Coverage, 25432,
     /*  30827 */     GIR_EraseRootFromParent_Done,
     /*  30828 */   // Label 784: @30828
     /*  30828 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(30890), // Rule ID 18161 //
     /*  30833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30852 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30855 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30859 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30872 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30879 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30888 */     GIR_RootConstrainSelectedInstOperands,
     /*  30889 */     // GIR_Coverage, 18161,
     /*  30889 */     GIR_EraseRootFromParent_Done,
     /*  30890 */   // Label 785: @30890
     /*  30890 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(30952), // Rule ID 20026 //
     /*  30895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  30898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30914 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30917 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30921 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30934 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  30937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30939 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30950 */     GIR_RootConstrainSelectedInstOperands,
     /*  30951 */     // GIR_Coverage, 20026,
     /*  30951 */     GIR_EraseRootFromParent_Done,
     /*  30952 */   // Label 786: @30952
     /*  30952 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(30979), // Rule ID 18149 //
     /*  30957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30972 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  30972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  30977 */     GIR_RootConstrainSelectedInstOperands,
     /*  30978 */     // GIR_Coverage, 18149,
     /*  30978 */     GIR_Done,
     /*  30979 */   // Label 787: @30979
     /*  30979 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(31006), // Rule ID 18173 //
     /*  30984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  30987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30999 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  30999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  31004 */     GIR_RootConstrainSelectedInstOperands,
     /*  31005 */     // GIR_Coverage, 18173,
     /*  31005 */     GIR_Done,
     /*  31006 */   // Label 788: @31006
     /*  31006 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(31033), // Rule ID 20018 //
     /*  31011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31026 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  31026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  31031 */     GIR_RootConstrainSelectedInstOperands,
     /*  31032 */     // GIR_Coverage, 20018,
     /*  31032 */     GIR_Done,
     /*  31033 */   // Label 789: @31033
     /*  31033 */   GIM_Reject,
     /*  31034 */ // Label 782: @31034
     /*  31034 */ GIM_Reject,
     /*  31035 */ // Label 672: @31035
     /*  31035 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(31500),
     /*  31040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  31043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  31046 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(31108), // Rule ID 24194 //
     /*  31051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31066 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31069 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31073 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31090 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rm),
     /*  31093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31095 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31097 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31106 */     GIR_RootConstrainSelectedInstOperands,
     /*  31107 */     // GIR_Coverage, 24194,
     /*  31107 */     GIR_EraseRootFromParent_Done,
     /*  31108 */   // Label 791: @31108
     /*  31108 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(31170), // Rule ID 25232 //
     /*  31113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31128 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31131 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31135 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31152 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  31155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31157 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31168 */     GIR_RootConstrainSelectedInstOperands,
     /*  31169 */     // GIR_Coverage, 25232,
     /*  31169 */     GIR_EraseRootFromParent_Done,
     /*  31170 */   // Label 792: @31170
     /*  31170 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(31232), // Rule ID 25242 //
     /*  31175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31190 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31193 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31197 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31214 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  31217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31219 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31230 */     GIR_RootConstrainSelectedInstOperands,
     /*  31231 */     // GIR_Coverage, 25242,
     /*  31231 */     GIR_EraseRootFromParent_Done,
     /*  31232 */   // Label 793: @31232
     /*  31232 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(31294), // Rule ID 5778 //
     /*  31237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31263 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31276 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rm),
     /*  31279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31281 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31292 */     GIR_RootConstrainSelectedInstOperands,
     /*  31293 */     // GIR_Coverage, 5778,
     /*  31293 */     GIR_EraseRootFromParent_Done,
     /*  31294 */   // Label 794: @31294
     /*  31294 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(31356), // Rule ID 18106 //
     /*  31299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31318 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31338 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  31341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31343 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31354 */     GIR_RootConstrainSelectedInstOperands,
     /*  31355 */     // GIR_Coverage, 18106,
     /*  31355 */     GIR_EraseRootFromParent_Done,
     /*  31356 */   // Label 795: @31356
     /*  31356 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(31418), // Rule ID 18135 //
     /*  31361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31380 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31383 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31387 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31400 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  31403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31405 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31407 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31416 */     GIR_RootConstrainSelectedInstOperands,
     /*  31417 */     // GIR_Coverage, 18135,
     /*  31417 */     GIR_EraseRootFromParent_Done,
     /*  31418 */   // Label 796: @31418
     /*  31418 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(31445), // Rule ID 5775 //
     /*  31423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31438 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  31438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rr),
     /*  31443 */     GIR_RootConstrainSelectedInstOperands,
     /*  31444 */     // GIR_Coverage, 5775,
     /*  31444 */     GIR_Done,
     /*  31445 */   // Label 797: @31445
     /*  31445 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(31472), // Rule ID 18094 //
     /*  31450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31465 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  31465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  31470 */     GIR_RootConstrainSelectedInstOperands,
     /*  31471 */     // GIR_Coverage, 18094,
     /*  31471 */     GIR_Done,
     /*  31472 */   // Label 798: @31472
     /*  31472 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(31499), // Rule ID 18119 //
     /*  31477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31492 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  31492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  31497 */     GIR_RootConstrainSelectedInstOperands,
     /*  31498 */     // GIR_Coverage, 18119,
     /*  31498 */     GIR_Done,
     /*  31499 */   // Label 799: @31499
     /*  31499 */   GIM_Reject,
     /*  31500 */ // Label 790: @31500
     /*  31500 */ GIM_Reject,
     /*  31501 */ // Label 673: @31501
     /*  31501 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(31656),
     /*  31506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  31509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  31512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31516 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(31574), // Rule ID 24170 //
     /*  31521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31532 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31556 */     // (or:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  31559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31561 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31572 */     GIR_RootConstrainSelectedInstOperands,
     /*  31573 */     // GIR_Coverage, 24170,
     /*  31573 */     GIR_EraseRootFromParent_Done,
     /*  31574 */   // Label 801: @31574
     /*  31574 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(31632), // Rule ID 5742 //
     /*  31579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31594 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31597 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31601 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31614 */     // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  31617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31619 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31630 */     GIR_RootConstrainSelectedInstOperands,
     /*  31631 */     // GIR_Coverage, 5742,
     /*  31631 */     GIR_EraseRootFromParent_Done,
     /*  31632 */   // Label 802: @31632
     /*  31632 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(31655), // Rule ID 5739 //
     /*  31637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31648 */     // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  31648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  31653 */     GIR_RootConstrainSelectedInstOperands,
     /*  31654 */     // GIR_Coverage, 5739,
     /*  31654 */     GIR_Done,
     /*  31655 */   // Label 803: @31655
     /*  31655 */   GIM_Reject,
     /*  31656 */ // Label 800: @31656
     /*  31656 */ GIM_Reject,
     /*  31657 */ // Label 674: @31657
     /*  31657 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(31690), // Rule ID 4419 //
     /*  31662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  31668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  31671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31683 */   // (or:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  31683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  31688 */   GIR_RootConstrainSelectedInstOperands,
     /*  31689 */   // GIR_Coverage, 4419,
     /*  31689 */   GIR_Done,
     /*  31690 */ // Label 804: @31690
     /*  31690 */ GIM_Reject,
     /*  31691 */ // Label 675: @31691
     /*  31691 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(32032),
     /*  31696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31702 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(31764), // Rule ID 25251 //
     /*  31707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31722 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31729 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31746 */     // (or:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  31749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31751 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31762 */     GIR_RootConstrainSelectedInstOperands,
     /*  31763 */     // GIR_Coverage, 25251,
     /*  31763 */     GIR_EraseRootFromParent_Done,
     /*  31764 */   // Label 806: @31764
     /*  31764 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(31826), // Rule ID 25431 //
     /*  31769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31808 */     // (or:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  31811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31824 */     GIR_RootConstrainSelectedInstOperands,
     /*  31825 */     // GIR_Coverage, 25431,
     /*  31825 */     GIR_EraseRootFromParent_Done,
     /*  31826 */   // Label 807: @31826
     /*  31826 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(31888), // Rule ID 18160 //
     /*  31831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31850 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31853 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31857 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31870 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  31873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31875 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31886 */     GIR_RootConstrainSelectedInstOperands,
     /*  31887 */     // GIR_Coverage, 18160,
     /*  31887 */     GIR_EraseRootFromParent_Done,
     /*  31888 */   // Label 808: @31888
     /*  31888 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(31950), // Rule ID 20025 //
     /*  31893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31912 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31915 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31919 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31932 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  31935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31937 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31948 */     GIR_RootConstrainSelectedInstOperands,
     /*  31949 */     // GIR_Coverage, 20025,
     /*  31949 */     GIR_EraseRootFromParent_Done,
     /*  31950 */   // Label 809: @31950
     /*  31950 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(31977), // Rule ID 18148 //
     /*  31955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31970 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  31970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  31975 */     GIR_RootConstrainSelectedInstOperands,
     /*  31976 */     // GIR_Coverage, 18148,
     /*  31976 */     GIR_Done,
     /*  31977 */   // Label 810: @31977
     /*  31977 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(32004), // Rule ID 18172 //
     /*  31982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  31985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31997 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  31997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  32002 */     GIR_RootConstrainSelectedInstOperands,
     /*  32003 */     // GIR_Coverage, 18172,
     /*  32003 */     GIR_Done,
     /*  32004 */   // Label 811: @32004
     /*  32004 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(32031), // Rule ID 20017 //
     /*  32009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32024 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  32024 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  32029 */     GIR_RootConstrainSelectedInstOperands,
     /*  32030 */     // GIR_Coverage, 20017,
     /*  32030 */     GIR_Done,
     /*  32031 */   // Label 812: @32031
     /*  32031 */   GIM_Reject,
     /*  32032 */ // Label 805: @32032
     /*  32032 */ GIM_Reject,
     /*  32033 */ // Label 676: @32033
     /*  32033 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(32498),
     /*  32038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  32041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  32044 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(32106), // Rule ID 25231 //
     /*  32049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32064 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32071 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32088 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32093 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32095 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32104 */     GIR_RootConstrainSelectedInstOperands,
     /*  32105 */     // GIR_Coverage, 25231,
     /*  32105 */     GIR_EraseRootFromParent_Done,
     /*  32106 */   // Label 814: @32106
     /*  32106 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(32168), // Rule ID 25241 //
     /*  32111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32126 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32129 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32133 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32150 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32155 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32166 */     GIR_RootConstrainSelectedInstOperands,
     /*  32167 */     // GIR_Coverage, 25241,
     /*  32167 */     GIR_EraseRootFromParent_Done,
     /*  32168 */   // Label 815: @32168
     /*  32168 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(32230), // Rule ID 25438 //
     /*  32173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32188 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32212 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32228 */     GIR_RootConstrainSelectedInstOperands,
     /*  32229 */     // GIR_Coverage, 25438,
     /*  32229 */     GIR_EraseRootFromParent_Done,
     /*  32230 */   // Label 816: @32230
     /*  32230 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(32292), // Rule ID 18105 //
     /*  32235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32254 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32257 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32261 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32274 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32279 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32290 */     GIR_RootConstrainSelectedInstOperands,
     /*  32291 */     // GIR_Coverage, 18105,
     /*  32291 */     GIR_EraseRootFromParent_Done,
     /*  32292 */   // Label 817: @32292
     /*  32292 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(32354), // Rule ID 18134 //
     /*  32297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32316 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32319 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32323 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32336 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32341 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32343 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32352 */     GIR_RootConstrainSelectedInstOperands,
     /*  32353 */     // GIR_Coverage, 18134,
     /*  32353 */     GIR_EraseRootFromParent_Done,
     /*  32354 */   // Label 818: @32354
     /*  32354 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(32416), // Rule ID 20042 //
     /*  32359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32385 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32398 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32403 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32405 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32414 */     GIR_RootConstrainSelectedInstOperands,
     /*  32415 */     // GIR_Coverage, 20042,
     /*  32415 */     GIR_EraseRootFromParent_Done,
     /*  32416 */   // Label 819: @32416
     /*  32416 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(32443), // Rule ID 18093 //
     /*  32421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32436 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  32436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  32441 */     GIR_RootConstrainSelectedInstOperands,
     /*  32442 */     // GIR_Coverage, 18093,
     /*  32442 */     GIR_Done,
     /*  32443 */   // Label 820: @32443
     /*  32443 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(32470), // Rule ID 18118 //
     /*  32448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32463 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  32463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  32468 */     GIR_RootConstrainSelectedInstOperands,
     /*  32469 */     // GIR_Coverage, 18118,
     /*  32469 */     GIR_Done,
     /*  32470 */   // Label 821: @32470
     /*  32470 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(32497), // Rule ID 20034 //
     /*  32475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32490 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  32490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  32495 */     GIR_RootConstrainSelectedInstOperands,
     /*  32496 */     // GIR_Coverage, 20034,
     /*  32496 */     GIR_Done,
     /*  32497 */   // Label 822: @32497
     /*  32497 */   GIM_Reject,
     /*  32498 */ // Label 813: @32498
     /*  32498 */ GIM_Reject,
     /*  32499 */ // Label 677: @32499
     /*  32499 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(32654),
     /*  32504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  32507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  32510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32514 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(32572), // Rule ID 24188 //
     /*  32519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32530 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32533 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32537 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32554 */     // (or:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZrm),
     /*  32557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32559 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32561 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32570 */     GIR_RootConstrainSelectedInstOperands,
     /*  32571 */     // GIR_Coverage, 24188,
     /*  32571 */     GIR_EraseRootFromParent_Done,
     /*  32572 */   // Label 824: @32572
     /*  32572 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(32630), // Rule ID 5769 //
     /*  32577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32612 */     // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZrm),
     /*  32615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32628 */     GIR_RootConstrainSelectedInstOperands,
     /*  32629 */     // GIR_Coverage, 5769,
     /*  32629 */     GIR_EraseRootFromParent_Done,
     /*  32630 */   // Label 825: @32630
     /*  32630 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(32653), // Rule ID 5766 //
     /*  32635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32646 */     // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  32646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZrr),
     /*  32651 */     GIR_RootConstrainSelectedInstOperands,
     /*  32652 */     // GIR_Coverage, 5766,
     /*  32652 */     GIR_Done,
     /*  32653 */   // Label 826: @32653
     /*  32653 */   GIM_Reject,
     /*  32654 */ // Label 823: @32654
     /*  32654 */ GIM_Reject,
     /*  32655 */ // Label 678: @32655
     /*  32655 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(32688), // Rule ID 4420 //
     /*  32660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  32663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  32666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  32669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32681 */   // (or:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  32681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORDkk),
     /*  32686 */   GIR_RootConstrainSelectedInstOperands,
     /*  32687 */   // GIR_Coverage, 4420,
     /*  32687 */   GIR_Done,
     /*  32688 */ // Label 827: @32688
     /*  32688 */ GIM_Reject,
     /*  32689 */ // Label 679: @32689
     /*  32689 */ GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(33154),
     /*  32694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  32697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  32700 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(32762), // Rule ID 25230 //
     /*  32705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32720 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32727 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32744 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32749 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32760 */     GIR_RootConstrainSelectedInstOperands,
     /*  32761 */     // GIR_Coverage, 25230,
     /*  32761 */     GIR_EraseRootFromParent_Done,
     /*  32762 */   // Label 829: @32762
     /*  32762 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(32824), // Rule ID 25240 //
     /*  32767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32782 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32785 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32789 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32806 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32811 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32813 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32822 */     GIR_RootConstrainSelectedInstOperands,
     /*  32823 */     // GIR_Coverage, 25240,
     /*  32823 */     GIR_EraseRootFromParent_Done,
     /*  32824 */   // Label 830: @32824
     /*  32824 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(32886), // Rule ID 25437 //
     /*  32829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32844 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32847 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32851 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32868 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32873 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32875 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32884 */     GIR_RootConstrainSelectedInstOperands,
     /*  32885 */     // GIR_Coverage, 25437,
     /*  32885 */     GIR_EraseRootFromParent_Done,
     /*  32886 */   // Label 831: @32886
     /*  32886 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(32948), // Rule ID 18104 //
     /*  32891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32910 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32913 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32917 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32930 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32935 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32937 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32946 */     GIR_RootConstrainSelectedInstOperands,
     /*  32947 */     // GIR_Coverage, 18104,
     /*  32947 */     GIR_EraseRootFromParent_Done,
     /*  32948 */   // Label 832: @32948
     /*  32948 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(33010), // Rule ID 18133 //
     /*  32953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32992 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32997 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33008 */     GIR_RootConstrainSelectedInstOperands,
     /*  33009 */     // GIR_Coverage, 18133,
     /*  33009 */     GIR_EraseRootFromParent_Done,
     /*  33010 */   // Label 833: @33010
     /*  33010 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(33072), // Rule ID 20041 //
     /*  33015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33034 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33037 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33041 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33054 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  33057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33059 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33061 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33070 */     GIR_RootConstrainSelectedInstOperands,
     /*  33071 */     // GIR_Coverage, 20041,
     /*  33071 */     GIR_EraseRootFromParent_Done,
     /*  33072 */   // Label 834: @33072
     /*  33072 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(33099), // Rule ID 18092 //
     /*  33077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  33080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33092 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  33092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  33097 */     GIR_RootConstrainSelectedInstOperands,
     /*  33098 */     // GIR_Coverage, 18092,
     /*  33098 */     GIR_Done,
     /*  33099 */   // Label 835: @33099
     /*  33099 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(33126), // Rule ID 18117 //
     /*  33104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  33107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33119 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  33119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  33124 */     GIR_RootConstrainSelectedInstOperands,
     /*  33125 */     // GIR_Coverage, 18117,
     /*  33125 */     GIR_Done,
     /*  33126 */   // Label 836: @33126
     /*  33126 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(33153), // Rule ID 20033 //
     /*  33131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33146 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  33146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  33151 */     GIR_RootConstrainSelectedInstOperands,
     /*  33152 */     // GIR_Coverage, 20033,
     /*  33152 */     GIR_Done,
     /*  33153 */   // Label 837: @33153
     /*  33153 */   GIM_Reject,
     /*  33154 */ // Label 828: @33154
     /*  33154 */ GIM_Reject,
     /*  33155 */ // Label 680: @33155
     /*  33155 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(33310),
     /*  33160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  33163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  33166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33170 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(33228), // Rule ID 25444 //
     /*  33175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33193 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33210 */     // (or:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33215 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33226 */     GIR_RootConstrainSelectedInstOperands,
     /*  33227 */     // GIR_Coverage, 25444,
     /*  33227 */     GIR_EraseRootFromParent_Done,
     /*  33228 */   // Label 839: @33228
     /*  33228 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(33286), // Rule ID 20058 //
     /*  33233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33248 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33255 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33268 */     // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33284 */     GIR_RootConstrainSelectedInstOperands,
     /*  33285 */     // GIR_Coverage, 20058,
     /*  33285 */     GIR_EraseRootFromParent_Done,
     /*  33286 */   // Label 840: @33286
     /*  33286 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(33309), // Rule ID 20050 //
     /*  33291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33302 */     // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  33302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  33307 */     GIR_RootConstrainSelectedInstOperands,
     /*  33308 */     // GIR_Coverage, 20050,
     /*  33308 */     GIR_Done,
     /*  33309 */   // Label 841: @33309
     /*  33309 */   GIM_Reject,
     /*  33310 */ // Label 838: @33310
     /*  33310 */ GIM_Reject,
     /*  33311 */ // Label 681: @33311
     /*  33311 */ GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(33344), // Rule ID 4421 //
     /*  33316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  33319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  33322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  33325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33337 */   // (or:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  33337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORQkk),
     /*  33342 */   GIR_RootConstrainSelectedInstOperands,
     /*  33343 */   // GIR_Coverage, 4421,
     /*  33343 */   GIR_Done,
     /*  33344 */ // Label 842: @33344
     /*  33344 */ GIM_Reject,
     /*  33345 */ // Label 682: @33345
     /*  33345 */ GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(33500),
     /*  33350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  33353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  33356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33360 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(33418), // Rule ID 25443 //
     /*  33365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33376 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33379 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33383 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33400 */     // (or:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33405 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33407 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33416 */     GIR_RootConstrainSelectedInstOperands,
     /*  33417 */     // GIR_Coverage, 25443,
     /*  33417 */     GIR_EraseRootFromParent_Done,
     /*  33418 */   // Label 844: @33418
     /*  33418 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(33476), // Rule ID 20057 //
     /*  33423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33438 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33445 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33458 */     // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33463 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33465 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33474 */     GIR_RootConstrainSelectedInstOperands,
     /*  33475 */     // GIR_Coverage, 20057,
     /*  33475 */     GIR_EraseRootFromParent_Done,
     /*  33476 */   // Label 845: @33476
     /*  33476 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(33499), // Rule ID 20049 //
     /*  33481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33492 */     // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  33492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  33497 */     GIR_RootConstrainSelectedInstOperands,
     /*  33498 */     // GIR_Coverage, 20049,
     /*  33498 */     GIR_Done,
     /*  33499 */   // Label 846: @33499
     /*  33499 */   GIM_Reject,
     /*  33500 */ // Label 843: @33500
     /*  33500 */ GIM_Reject,
     /*  33501 */ // Label 683: @33501
     /*  33501 */ GIM_Reject,
     /*  33502 */ // Label 5: @33502
     /*  33502 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 870*/ GIMT_Encode4(46202),
     /*  33513 */ /*GILLT_s1*//*Label 847*/ GIMT_Encode4(33613),
     /*  33517 */ /*GILLT_s8*//*Label 848*/ GIMT_Encode4(34171),
     /*  33521 */ /*GILLT_s16*//*Label 849*/ GIMT_Encode4(34698),
     /*  33525 */ /*GILLT_s32*//*Label 850*/ GIMT_Encode4(35443),
     /*  33529 */ /*GILLT_s64*//*Label 851*/ GIMT_Encode4(36391), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  33541 */ /*GILLT_v2s1*//*Label 852*/ GIMT_Encode4(37298),
     /*  33545 */ /*GILLT_v2s64*//*Label 853*/ GIMT_Encode4(37840),
     /*  33549 */ /*GILLT_v4s1*//*Label 854*/ GIMT_Encode4(38460),
     /*  33553 */ /*GILLT_v4s32*//*Label 855*/ GIMT_Encode4(39002),
     /*  33557 */ /*GILLT_v4s64*//*Label 856*/ GIMT_Encode4(39622),
     /*  33561 */ /*GILLT_v8s1*//*Label 857*/ GIMT_Encode4(40366),
     /*  33565 */ /*GILLT_v8s16*//*Label 858*/ GIMT_Encode4(41164),
     /*  33569 */ /*GILLT_v8s32*//*Label 859*/ GIMT_Encode4(41784),
     /*  33573 */ /*GILLT_v8s64*//*Label 860*/ GIMT_Encode4(42528),
     /*  33577 */ /*GILLT_v16s1*//*Label 861*/ GIMT_Encode4(42726),
     /*  33581 */ /*GILLT_v16s8*//*Label 862*/ GIMT_Encode4(42984),
     /*  33585 */ /*GILLT_v16s16*//*Label 863*/ GIMT_Encode4(43604),
     /*  33589 */ /*GILLT_v16s32*//*Label 864*/ GIMT_Encode4(44348),
     /*  33593 */ /*GILLT_v32s1*//*Label 865*/ GIMT_Encode4(44546),
     /*  33597 */ /*GILLT_v32s8*//*Label 866*/ GIMT_Encode4(44804),
     /*  33601 */ /*GILLT_v32s16*//*Label 867*/ GIMT_Encode4(45548),
     /*  33605 */ /*GILLT_v64s1*//*Label 868*/ GIMT_Encode4(45746),
     /*  33609 */ /*GILLT_v64s8*//*Label 869*/ GIMT_Encode4(46004),
     /*  33613 */ // Label 847: @33613
     /*  33613 */ GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(34170),
     /*  33618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  33621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  33624 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(33748), // Rule ID 25369 //
     /*  33629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33658 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33664 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  33666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33672 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  33672 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  33675 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33679 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33684 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  33688 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33693 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  33696 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33700 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  33709 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  33717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  33721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33726 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  33729 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  33732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  33734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  33742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  33747 */     // GIR_Coverage, 25369,
     /*  33747 */     GIR_EraseRootFromParent_Done,
     /*  33748 */   // Label 872: @33748
     /*  33748 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(33873), // Rule ID 19495 //
     /*  33753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  33787 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33793 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  33795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33797 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2), immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  33797 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  33800 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33804 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33809 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  33813 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33818 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  33821 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33825 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33830 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  33834 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  33842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  33846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33851 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  33854 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  33857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  33859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  33867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  33872 */     // GIR_Coverage, 19495,
     /*  33872 */     GIR_EraseRootFromParent_Done,
     /*  33873 */   // Label 873: @33873
     /*  33873 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(33997), // Rule ID 25370 //
     /*  33878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33911 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33917 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  33919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33921 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  33921 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  33924 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33928 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33933 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  33937 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33942 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  33945 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33949 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33954 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  33958 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  33966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  33970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33975 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  33978 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  33981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  33983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  33991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  33996 */     // GIR_Coverage, 25370,
     /*  33996 */     GIR_EraseRootFromParent_Done,
     /*  33997 */   // Label 874: @33997
     /*  33997 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(34076), // Rule ID 19481 //
     /*  34002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  34006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34014 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  34022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34024 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src, immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  34024 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34027 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34031 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  34040 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  34052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  34075 */     // GIR_Coverage, 19481,
     /*  34075 */     GIR_EraseRootFromParent_Done,
     /*  34076 */   // Label 875: @34076
     /*  34076 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(34169), // Rule ID 19499 //
     /*  34081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34093 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  34093 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  34096 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34100 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34105 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  34109 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34114 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34117 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34121 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  34130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  34142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34147 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34150 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  34153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34168 */     // GIR_Coverage, 19499,
     /*  34168 */     GIR_EraseRootFromParent_Done,
     /*  34169 */   // Label 876: @34169
     /*  34169 */   GIM_Reject,
     /*  34170 */ // Label 871: @34170
     /*  34170 */ GIM_Reject,
     /*  34171 */ // Label 848: @34171
     /*  34171 */ GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(34697),
     /*  34176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  34179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  34182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34186 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(34242), // Rule ID 273 //
     /*  34191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34205 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34209 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34226 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] })  =>  (NOT8m_ND:{ *:[i8] } addr:{ *:[iPTR] }:$src1)
     /*  34226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m_ND),
     /*  34229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  34235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34240 */     GIR_RootConstrainSelectedInstOperands,
     /*  34241 */     // GIR_Coverage, 273,
     /*  34241 */     GIR_EraseRootFromParent_Done,
     /*  34242 */   // Label 878: @34242
     /*  34242 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(34303), // Rule ID 26062 //
     /*  34247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34258 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34261 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34265 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34282 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (XOR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm),
     /*  34285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34287 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34301 */     GIR_RootConstrainSelectedInstOperands,
     /*  34302 */     // GIR_Coverage, 26062,
     /*  34302 */     GIR_EraseRootFromParent_Done,
     /*  34303 */   // Label 879: @34303
     /*  34303 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(34364), // Rule ID 26081 //
     /*  34308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34319 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34322 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34326 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34343 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (XOR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm_ND),
     /*  34346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34348 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34350 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34362 */     GIR_RootConstrainSelectedInstOperands,
     /*  34363 */     // GIR_Coverage, 26081,
     /*  34363 */     GIR_EraseRootFromParent_Done,
     /*  34364 */   // Label 880: @34364
     /*  34364 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(34425), // Rule ID 22839 //
     /*  34369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34384 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34387 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34391 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34404 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (XOR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm),
     /*  34407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34409 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34411 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34423 */     GIR_RootConstrainSelectedInstOperands,
     /*  34424 */     // GIR_Coverage, 22839,
     /*  34424 */     GIR_EraseRootFromParent_Done,
     /*  34425 */   // Label 881: @34425
     /*  34425 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(34486), // Rule ID 22929 //
     /*  34430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34445 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34448 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34452 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34465 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (XOR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm_ND),
     /*  34468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34484 */     GIR_RootConstrainSelectedInstOperands,
     /*  34485 */     // GIR_Coverage, 22929,
     /*  34485 */     GIR_EraseRootFromParent_Done,
     /*  34486 */   // Label 882: @34486
     /*  34486 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(34514), // Rule ID 22596 //
     /*  34491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-128),
     /*  34499 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })
     /*  34499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*  34502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34504 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  34509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34512 */     GIR_RootConstrainSelectedInstOperands,
     /*  34513 */     // GIR_Coverage, 22596,
     /*  34513 */     GIR_EraseRootFromParent_Done,
     /*  34514 */   // Label 883: @34514
     /*  34514 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(34539), // Rule ID 245 //
     /*  34519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34530 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  34530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r),
     /*  34533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34537 */     GIR_RootConstrainSelectedInstOperands,
     /*  34538 */     // GIR_Coverage, 245,
     /*  34538 */     GIR_EraseRootFromParent_Done,
     /*  34539 */   // Label 884: @34539
     /*  34539 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(34564), // Rule ID 253 //
     /*  34544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34555 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  34555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r_ND),
     /*  34558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34560 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34562 */     GIR_RootConstrainSelectedInstOperands,
     /*  34563 */     // GIR_Coverage, 253,
     /*  34563 */     GIR_EraseRootFromParent_Done,
     /*  34564 */   // Label 885: @34564
     /*  34564 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(34601), // Rule ID 22843 //
     /*  34569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34584 */     // MIs[1] Operand 1
     /*  34584 */     // No operand predicates
     /*  34584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34586 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  34586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri),
     /*  34589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34591 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  34596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34599 */     GIR_RootConstrainSelectedInstOperands,
     /*  34600 */     // GIR_Coverage, 22843,
     /*  34600 */     GIR_EraseRootFromParent_Done,
     /*  34601 */   // Label 886: @34601
     /*  34601 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(34638), // Rule ID 22933 //
     /*  34606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34621 */     // MIs[1] Operand 1
     /*  34621 */     // No operand predicates
     /*  34621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34623 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  34623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri_ND),
     /*  34626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34628 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  34633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34636 */     GIR_RootConstrainSelectedInstOperands,
     /*  34637 */     // GIR_Coverage, 22933,
     /*  34637 */     GIR_EraseRootFromParent_Done,
     /*  34638 */   // Label 887: @34638
     /*  34638 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(34667), // Rule ID 22835 //
     /*  34643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34654 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  34654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr),
     /*  34659 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  34665 */     GIR_RootConstrainSelectedInstOperands,
     /*  34666 */     // GIR_Coverage, 22835,
     /*  34666 */     GIR_Done,
     /*  34667 */   // Label 888: @34667
     /*  34667 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(34696), // Rule ID 22925 //
     /*  34672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34683 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  34683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr_ND),
     /*  34688 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  34694 */     GIR_RootConstrainSelectedInstOperands,
     /*  34695 */     // GIR_Coverage, 22925,
     /*  34695 */     GIR_Done,
     /*  34696 */   // Label 889: @34696
     /*  34696 */   GIM_Reject,
     /*  34697 */ // Label 877: @34697
     /*  34697 */ GIM_Reject,
     /*  34698 */ // Label 849: @34698
     /*  34698 */ GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(35442),
     /*  34703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  34706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  34709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34713 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(34769), // Rule ID 274 //
     /*  34718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34729 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34732 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34736 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34753 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] })  =>  (NOT16m_ND:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /*  34753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m_ND),
     /*  34756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34758 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  34762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34767 */     GIR_RootConstrainSelectedInstOperands,
     /*  34768 */     // GIR_Coverage, 274,
     /*  34768 */     GIR_EraseRootFromParent_Done,
     /*  34769 */   // Label 891: @34769
     /*  34769 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(34830), // Rule ID 26063 //
     /*  34774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34788 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34792 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34809 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (XOR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm),
     /*  34812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34814 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34816 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34828 */     GIR_RootConstrainSelectedInstOperands,
     /*  34829 */     // GIR_Coverage, 26063,
     /*  34829 */     GIR_EraseRootFromParent_Done,
     /*  34830 */   // Label 892: @34830
     /*  34830 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(34891), // Rule ID 26082 //
     /*  34835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34849 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34853 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34870 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (XOR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm_ND),
     /*  34873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34875 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34889 */     GIR_RootConstrainSelectedInstOperands,
     /*  34890 */     // GIR_Coverage, 26082,
     /*  34890 */     GIR_EraseRootFromParent_Done,
     /*  34891 */   // Label 893: @34891
     /*  34891 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(34952), // Rule ID 22840 //
     /*  34896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34911 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34914 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34918 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34931 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (XOR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm),
     /*  34934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34936 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34938 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34950 */     GIR_RootConstrainSelectedInstOperands,
     /*  34951 */     // GIR_Coverage, 22840,
     /*  34951 */     GIR_EraseRootFromParent_Done,
     /*  34952 */   // Label 894: @34952
     /*  34952 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(35013), // Rule ID 22930 //
     /*  34957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34975 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34979 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34992 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (XOR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm_ND),
     /*  34995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34997 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35011 */     GIR_RootConstrainSelectedInstOperands,
     /*  35012 */     // GIR_Coverage, 22930,
     /*  35012 */     GIR_EraseRootFromParent_Done,
     /*  35013 */   // Label 895: @35013
     /*  35013 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(35055), // Rule ID 22597 //
     /*  35018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35022 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-32768),
     /*  35033 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })
     /*  35033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*  35036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35038 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35040 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-32768),
     /*  35050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35053 */     GIR_RootConstrainSelectedInstOperands,
     /*  35054 */     // GIR_Coverage, 22597,
     /*  35054 */     GIR_EraseRootFromParent_Done,
     /*  35055 */   // Label 896: @35055
     /*  35055 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(35157), // Rule ID 26035 //
     /*  35060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  35072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35076 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35091 */     // (xor:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  35094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  35108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35117 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35120 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35124 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  35132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  35137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /*  35145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35147 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35155 */     GIR_RootConstrainSelectedInstOperands,
     /*  35156 */     // GIR_Coverage, 26035,
     /*  35156 */     GIR_EraseRootFromParent_Done,
     /*  35157 */   // Label 897: @35157
     /*  35157 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(35259), // Rule ID 22773 //
     /*  35162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  35178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35182 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35193 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  35196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  35210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35219 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35226 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  35234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  35239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /*  35247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35249 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35257 */     GIR_RootConstrainSelectedInstOperands,
     /*  35258 */     // GIR_Coverage, 22773,
     /*  35258 */     GIR_EraseRootFromParent_Done,
     /*  35259 */   // Label 898: @35259
     /*  35259 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(35284), // Rule ID 246 //
     /*  35264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35275 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  35275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r),
     /*  35278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35280 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35282 */     GIR_RootConstrainSelectedInstOperands,
     /*  35283 */     // GIR_Coverage, 246,
     /*  35283 */     GIR_EraseRootFromParent_Done,
     /*  35284 */   // Label 899: @35284
     /*  35284 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(35309), // Rule ID 254 //
     /*  35289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  35292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35300 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  35300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r_ND),
     /*  35303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35305 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35307 */     GIR_RootConstrainSelectedInstOperands,
     /*  35308 */     // GIR_Coverage, 254,
     /*  35308 */     GIR_EraseRootFromParent_Done,
     /*  35309 */   // Label 900: @35309
     /*  35309 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(35346), // Rule ID 22844 //
     /*  35314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35329 */     // MIs[1] Operand 1
     /*  35329 */     // No operand predicates
     /*  35329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35331 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  35331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri),
     /*  35334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35336 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  35341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35344 */     GIR_RootConstrainSelectedInstOperands,
     /*  35345 */     // GIR_Coverage, 22844,
     /*  35345 */     GIR_EraseRootFromParent_Done,
     /*  35346 */   // Label 901: @35346
     /*  35346 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(35383), // Rule ID 22934 //
     /*  35351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35366 */     // MIs[1] Operand 1
     /*  35366 */     // No operand predicates
     /*  35366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35368 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  35368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri_ND),
     /*  35371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35373 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  35378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35381 */     GIR_RootConstrainSelectedInstOperands,
     /*  35382 */     // GIR_Coverage, 22934,
     /*  35382 */     GIR_EraseRootFromParent_Done,
     /*  35383 */   // Label 902: @35383
     /*  35383 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(35412), // Rule ID 22836 //
     /*  35388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35399 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  35399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr),
     /*  35404 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  35410 */     GIR_RootConstrainSelectedInstOperands,
     /*  35411 */     // GIR_Coverage, 22836,
     /*  35411 */     GIR_Done,
     /*  35412 */   // Label 903: @35412
     /*  35412 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(35441), // Rule ID 22926 //
     /*  35417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35428 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  35428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr_ND),
     /*  35433 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  35439 */     GIR_RootConstrainSelectedInstOperands,
     /*  35440 */     // GIR_Coverage, 22926,
     /*  35440 */     GIR_Done,
     /*  35441 */   // Label 904: @35441
     /*  35441 */   GIM_Reject,
     /*  35442 */ // Label 890: @35442
     /*  35442 */ GIM_Reject,
     /*  35443 */ // Label 850: @35443
     /*  35443 */ GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(36390),
     /*  35448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35451 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(35514), // Rule ID 275 //
     /*  35456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  35459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35477 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35481 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35498 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] })  =>  (NOT32m_ND:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  35498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m_ND),
     /*  35501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35503 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  35507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35512 */     GIR_RootConstrainSelectedInstOperands,
     /*  35513 */     // GIR_Coverage, 275,
     /*  35513 */     GIR_EraseRootFromParent_Done,
     /*  35514 */   // Label 906: @35514
     /*  35514 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(35582), // Rule ID 26064 //
     /*  35519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35537 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35540 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35544 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35561 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (XOR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm),
     /*  35564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35568 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35580 */     GIR_RootConstrainSelectedInstOperands,
     /*  35581 */     // GIR_Coverage, 26064,
     /*  35581 */     GIR_EraseRootFromParent_Done,
     /*  35582 */   // Label 907: @35582
     /*  35582 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(35650), // Rule ID 26083 //
     /*  35587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35605 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35608 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35612 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35629 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (XOR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm_ND),
     /*  35632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35634 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35636 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35648 */     GIR_RootConstrainSelectedInstOperands,
     /*  35649 */     // GIR_Coverage, 26083,
     /*  35649 */     GIR_EraseRootFromParent_Done,
     /*  35650 */   // Label 908: @35650
     /*  35650 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(35718), // Rule ID 22841 //
     /*  35655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35677 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35680 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35684 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35697 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (XOR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm),
     /*  35700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35702 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35704 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35716 */     GIR_RootConstrainSelectedInstOperands,
     /*  35717 */     // GIR_Coverage, 22841,
     /*  35717 */     GIR_EraseRootFromParent_Done,
     /*  35718 */   // Label 909: @35718
     /*  35718 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(35786), // Rule ID 22931 //
     /*  35723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35745 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35748 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35752 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35765 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (XOR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm_ND),
     /*  35768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35770 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35772 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35784 */     GIR_RootConstrainSelectedInstOperands,
     /*  35785 */     // GIR_Coverage, 22931,
     /*  35785 */     GIR_EraseRootFromParent_Done,
     /*  35786 */   // Label 910: @35786
     /*  35786 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(35835), // Rule ID 22598 //
     /*  35791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35802 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-2147483648),
     /*  35813 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })
     /*  35813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*  35816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35818 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35820 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  35830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35833 */     GIR_RootConstrainSelectedInstOperands,
     /*  35834 */     // GIR_Coverage, 22598,
     /*  35834 */     GIR_EraseRootFromParent_Done,
     /*  35835 */   // Label 911: @35835
     /*  35835 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(35893), // Rule ID 24994 //
     /*  35840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  35843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  35855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35868 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  35872 */     // MIs[0] src
     /*  35872 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35879 */     // (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  35879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /*  35882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  35888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35891 */     GIR_RootConstrainSelectedInstOperands,
     /*  35892 */     // GIR_Coverage, 24994,
     /*  35892 */     GIR_EraseRootFromParent_Done,
     /*  35893 */   // Label 912: @35893
     /*  35893 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(36002), // Rule ID 26041 //
     /*  35898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35921 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35936 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  35939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  35953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35962 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35965 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35969 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  35977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  35982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /*  35990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36000 */     GIR_RootConstrainSelectedInstOperands,
     /*  36001 */     // GIR_Coverage, 26041,
     /*  36001 */     GIR_EraseRootFromParent_Done,
     /*  36002 */   // Label 913: @36002
     /*  36002 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(36056), // Rule ID 17357 //
     /*  36007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36033 */     // MIs[1] src
     /*  36033 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  36038 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36044 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  36044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /*  36047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36049 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  36051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36054 */     GIR_RootConstrainSelectedInstOperands,
     /*  36055 */     // GIR_Coverage, 17357,
     /*  36055 */     GIR_EraseRootFromParent_Done,
     /*  36056 */   // Label 914: @36056
     /*  36056 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(36165), // Rule ID 22779 //
     /*  36061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36088 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36099 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36125 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  36132 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  36150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /*  36153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36155 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36163 */     GIR_RootConstrainSelectedInstOperands,
     /*  36164 */     // GIR_Coverage, 22779,
     /*  36164 */     GIR_EraseRootFromParent_Done,
     /*  36165 */   // Label 915: @36165
     /*  36165 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(36197), // Rule ID 247 //
     /*  36170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36188 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  36188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r),
     /*  36191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36193 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36195 */     GIR_RootConstrainSelectedInstOperands,
     /*  36196 */     // GIR_Coverage, 247,
     /*  36196 */     GIR_EraseRootFromParent_Done,
     /*  36197 */   // Label 916: @36197
     /*  36197 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(36229), // Rule ID 255 //
     /*  36202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  36205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36220 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  36220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r_ND),
     /*  36223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36225 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36227 */     GIR_RootConstrainSelectedInstOperands,
     /*  36228 */     // GIR_Coverage, 255,
     /*  36228 */     GIR_EraseRootFromParent_Done,
     /*  36229 */   // Label 917: @36229
     /*  36229 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(36273), // Rule ID 22845 //
     /*  36234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36256 */     // MIs[1] Operand 1
     /*  36256 */     // No operand predicates
     /*  36256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36258 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  36258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri),
     /*  36261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36263 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  36268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36271 */     GIR_RootConstrainSelectedInstOperands,
     /*  36272 */     // GIR_Coverage, 22845,
     /*  36272 */     GIR_EraseRootFromParent_Done,
     /*  36273 */   // Label 918: @36273
     /*  36273 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(36317), // Rule ID 22935 //
     /*  36278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36300 */     // MIs[1] Operand 1
     /*  36300 */     // No operand predicates
     /*  36300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36302 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  36302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri_ND),
     /*  36305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36307 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  36312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36315 */     GIR_RootConstrainSelectedInstOperands,
     /*  36316 */     // GIR_Coverage, 22935,
     /*  36316 */     GIR_EraseRootFromParent_Done,
     /*  36317 */   // Label 919: @36317
     /*  36317 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(36353), // Rule ID 22837 //
     /*  36322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36340 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  36340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr),
     /*  36345 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  36351 */     GIR_RootConstrainSelectedInstOperands,
     /*  36352 */     // GIR_Coverage, 22837,
     /*  36352 */     GIR_Done,
     /*  36353 */   // Label 920: @36353
     /*  36353 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(36389), // Rule ID 22927 //
     /*  36358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36376 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  36376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr_ND),
     /*  36381 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  36387 */     GIR_RootConstrainSelectedInstOperands,
     /*  36388 */     // GIR_Coverage, 22927,
     /*  36388 */     GIR_Done,
     /*  36389 */   // Label 921: @36389
     /*  36389 */   GIM_Reject,
     /*  36390 */ // Label 905: @36390
     /*  36390 */ GIM_Reject,
     /*  36391 */ // Label 851: @36391
     /*  36391 */ GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(37297),
     /*  36396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36399 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(36462), // Rule ID 276 //
     /*  36404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  36407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36422 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36429 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36446 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] })  =>  (NOT64m_ND:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /*  36446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m_ND),
     /*  36449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  36455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36460 */     GIR_RootConstrainSelectedInstOperands,
     /*  36461 */     // GIR_Coverage, 276,
     /*  36461 */     GIR_EraseRootFromParent_Done,
     /*  36462 */   // Label 923: @36462
     /*  36462 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(36530), // Rule ID 26065 //
     /*  36467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36485 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36492 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36509 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (XOR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm),
     /*  36512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36514 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36528 */     GIR_RootConstrainSelectedInstOperands,
     /*  36529 */     // GIR_Coverage, 26065,
     /*  36529 */     GIR_EraseRootFromParent_Done,
     /*  36530 */   // Label 924: @36530
     /*  36530 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(36598), // Rule ID 26084 //
     /*  36535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36553 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36556 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36560 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36577 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (XOR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm_ND),
     /*  36580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36582 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36584 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36596 */     GIR_RootConstrainSelectedInstOperands,
     /*  36597 */     // GIR_Coverage, 26084,
     /*  36597 */     GIR_EraseRootFromParent_Done,
     /*  36598 */   // Label 925: @36598
     /*  36598 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(36666), // Rule ID 22842 //
     /*  36603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36625 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36628 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36632 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36645 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (XOR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm),
     /*  36648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36650 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36652 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36664 */     GIR_RootConstrainSelectedInstOperands,
     /*  36665 */     // GIR_Coverage, 22842,
     /*  36665 */     GIR_EraseRootFromParent_Done,
     /*  36666 */   // Label 926: @36666
     /*  36666 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(36734), // Rule ID 22932 //
     /*  36671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36693 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36696 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36700 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36713 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (XOR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm_ND),
     /*  36716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36732 */     GIR_RootConstrainSelectedInstOperands,
     /*  36733 */     // GIR_Coverage, 22932,
     /*  36733 */     GIR_EraseRootFromParent_Done,
     /*  36734 */   // Label 927: @36734
     /*  36734 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(36792), // Rule ID 24995 //
     /*  36739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36767 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36771 */     // MIs[0] src
     /*  36771 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36778 */     // (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  36778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /*  36781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  36787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36790 */     GIR_RootConstrainSelectedInstOperands,
     /*  36791 */     // GIR_Coverage, 24995,
     /*  36791 */     GIR_EraseRootFromParent_Done,
     /*  36792 */   // Label 928: @36792
     /*  36792 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(36901), // Rule ID 26047 //
     /*  36797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36820 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36835 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36835 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36838 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36842 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36861 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  36868 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  36876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  36881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  36886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /*  36889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36891 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36899 */     GIR_RootConstrainSelectedInstOperands,
     /*  36900 */     // GIR_Coverage, 26047,
     /*  36900 */     GIR_EraseRootFromParent_Done,
     /*  36901 */   // Label 929: @36901
     /*  36901 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(36955), // Rule ID 17358 //
     /*  36906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36932 */     // MIs[1] src
     /*  36932 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  36937 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36943 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  36943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /*  36946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36948 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  36950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36953 */     GIR_RootConstrainSelectedInstOperands,
     /*  36954 */     // GIR_Coverage, 17358,
     /*  36954 */     GIR_EraseRootFromParent_Done,
     /*  36955 */   // Label 930: @36955
     /*  36955 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(37064), // Rule ID 22785 //
     /*  36960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36987 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36998 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36998 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37001 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37005 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  37012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37027 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37031 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  37049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /*  37052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37054 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37062 */     GIR_RootConstrainSelectedInstOperands,
     /*  37063 */     // GIR_Coverage, 22785,
     /*  37063 */     GIR_EraseRootFromParent_Done,
     /*  37064 */   // Label 931: @37064
     /*  37064 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(37096), // Rule ID 248 //
     /*  37069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37087 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  37087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r),
     /*  37090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37094 */     GIR_RootConstrainSelectedInstOperands,
     /*  37095 */     // GIR_Coverage, 248,
     /*  37095 */     GIR_EraseRootFromParent_Done,
     /*  37096 */   // Label 932: @37096
     /*  37096 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(37128), // Rule ID 256 //
     /*  37101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  37104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37115 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37119 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  37119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r_ND),
     /*  37122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37124 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37126 */     GIR_RootConstrainSelectedInstOperands,
     /*  37127 */     // GIR_Coverage, 256,
     /*  37127 */     GIR_EraseRootFromParent_Done,
     /*  37128 */   // Label 933: @37128
     /*  37128 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(37176), // Rule ID 22846 //
     /*  37133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  37159 */     // MIs[1] Operand 1
     /*  37159 */     // No operand predicates
     /*  37159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37161 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  37161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32),
     /*  37164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37166 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  37171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37174 */     GIR_RootConstrainSelectedInstOperands,
     /*  37175 */     // GIR_Coverage, 22846,
     /*  37175 */     GIR_EraseRootFromParent_Done,
     /*  37176 */   // Label 934: @37176
     /*  37176 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(37224), // Rule ID 22936 //
     /*  37181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  37184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  37207 */     // MIs[1] Operand 1
     /*  37207 */     // No operand predicates
     /*  37207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37209 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  37209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32_ND),
     /*  37212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  37219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37222 */     GIR_RootConstrainSelectedInstOperands,
     /*  37223 */     // GIR_Coverage, 22936,
     /*  37223 */     GIR_EraseRootFromParent_Done,
     /*  37224 */   // Label 935: @37224
     /*  37224 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(37260), // Rule ID 22838 //
     /*  37229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37247 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  37247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr),
     /*  37252 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  37258 */     GIR_RootConstrainSelectedInstOperands,
     /*  37259 */     // GIR_Coverage, 22838,
     /*  37259 */     GIR_Done,
     /*  37260 */   // Label 936: @37260
     /*  37260 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(37296), // Rule ID 22928 //
     /*  37265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  37268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37283 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  37283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr_ND),
     /*  37288 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  37294 */     GIR_RootConstrainSelectedInstOperands,
     /*  37295 */     // GIR_Coverage, 22928,
     /*  37295 */     GIR_Done,
     /*  37296 */   // Label 937: @37296
     /*  37296 */   GIM_Reject,
     /*  37297 */ // Label 922: @37297
     /*  37297 */ GIM_Reject,
     /*  37298 */ // Label 852: @37298
     /*  37298 */ GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(37839),
     /*  37303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37313 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(37433), // Rule ID 25371 //
     /*  37318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  37343 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37349 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37357 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37357 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37360 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37364 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37369 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  37373 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37378 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37381 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37385 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37390 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37394 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37411 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37414 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37432 */     // GIR_Coverage, 25371,
     /*  37432 */     GIR_EraseRootFromParent_Done,
     /*  37433 */   // Label 939: @37433
     /*  37433 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(37554), // Rule ID 19496 //
     /*  37438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  37468 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37474 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37478 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2), immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37478 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37481 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37485 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37490 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37494 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37511 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37515 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37532 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37535 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37553 */     // GIR_Coverage, 19496,
     /*  37553 */     GIR_EraseRootFromParent_Done,
     /*  37554 */   // Label 940: @37554
     /*  37554 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(37674), // Rule ID 25372 //
     /*  37559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  37588 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37594 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37598 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37598 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37601 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37605 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37610 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  37614 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37619 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37622 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37626 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37635 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37652 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37655 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37673 */     // GIR_Coverage, 25372,
     /*  37673 */     GIR_EraseRootFromParent_Done,
     /*  37674 */   // Label 941: @37674
     /*  37674 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(37749), // Rule ID 19480 //
     /*  37679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37687 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37693 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  37695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37697 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src, immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37709 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  37713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  37725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37730 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37748 */     // GIR_Coverage, 19480,
     /*  37748 */     GIR_EraseRootFromParent_Done,
     /*  37749 */   // Label 942: @37749
     /*  37749 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(37838), // Rule ID 19500 //
     /*  37754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37762 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37762 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37765 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37769 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37774 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  37778 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37795 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  37799 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  37811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37816 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37819 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37837 */     // GIR_Coverage, 19500,
     /*  37837 */     GIR_EraseRootFromParent_Done,
     /*  37838 */   // Label 943: @37838
     /*  37838 */   GIM_Reject,
     /*  37839 */ // Label 938: @37839
     /*  37839 */ GIM_Reject,
     /*  37840 */ // Label 853: @37840
     /*  37840 */ GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(38459),
     /*  37845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  37851 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(37913), // Rule ID 23363 //
     /*  37856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  37859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  37863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  37871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  37874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  37878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  37882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  37886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  37895 */     // (xor:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPXORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  37895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  37898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37900 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  37906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  37911 */     GIR_RootConstrainSelectedInstOperands,
     /*  37912 */     // GIR_Coverage, 23363,
     /*  37912 */     GIR_EraseRootFromParent_Done,
     /*  37913 */   // Label 945: @37913
     /*  37913 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(37975), // Rule ID 24218 //
     /*  37918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  37921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  37925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  37933 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  37936 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  37940 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  37944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  37948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  37957 */     // (xor:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPXORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  37957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  37960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37962 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  37968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  37973 */     GIR_RootConstrainSelectedInstOperands,
     /*  37974 */     // GIR_Coverage, 24218,
     /*  37974 */     GIR_EraseRootFromParent_Done,
     /*  37975 */   // Label 946: @37975
     /*  37975 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(38037), // Rule ID 2122 //
     /*  37980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  37983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  37987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  37991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  37999 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38002 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38006 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38019 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  38022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38026 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38035 */     GIR_RootConstrainSelectedInstOperands,
     /*  38036 */     // GIR_Coverage, 2122,
     /*  38036 */     GIR_EraseRootFromParent_Done,
     /*  38037 */   // Label 947: @38037
     /*  38037 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(38099), // Rule ID 5814 //
     /*  38042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38061 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38064 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38068 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38081 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  38084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38086 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38088 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38097 */     GIR_RootConstrainSelectedInstOperands,
     /*  38098 */     // GIR_Coverage, 5814,
     /*  38098 */     GIR_EraseRootFromParent_Done,
     /*  38099 */   // Label 948: @38099
     /*  38099 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(38331), // Rule ID 21945 //
     /*  38104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  38107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  38111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38119 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38125 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38129 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  38129 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  38132 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38136 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  38143 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  38146 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38150 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38155 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  38158 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38162 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  38165 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38170 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38175 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38180 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  38183 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38187 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  38194 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  38197 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38201 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38206 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  38209 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38213 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  38216 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38221 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38226 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38231 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  38234 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38238 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38245 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  38248 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38252 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38257 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38260 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38264 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  38267 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38272 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  38285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  38289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38294 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  38300 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  38303 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  38306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38313 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  38320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  38325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38330 */     // GIR_Coverage, 21945,
     /*  38330 */     GIR_EraseRootFromParent_Done,
     /*  38331 */   // Label 949: @38331
     /*  38331 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(38377), // Rule ID 21953 //
     /*  38336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  38339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38351 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38357 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38361 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (VPTERNLOGQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, 15:{ *:[i8] })
     /*  38361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  38364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38368 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38370 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  38375 */     GIR_RootConstrainSelectedInstOperands,
     /*  38376 */     // GIR_Coverage, 21953,
     /*  38376 */     GIR_EraseRootFromParent_Done,
     /*  38377 */   // Label 950: @38377
     /*  38377 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(38404), // Rule ID 2121 //
     /*  38382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  38385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38397 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  38397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  38402 */     GIR_RootConstrainSelectedInstOperands,
     /*  38403 */     // GIR_Coverage, 2121,
     /*  38403 */     GIR_Done,
     /*  38404 */   // Label 951: @38404
     /*  38404 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(38431), // Rule ID 2123 //
     /*  38409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  38412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38424 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  38424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  38429 */     GIR_RootConstrainSelectedInstOperands,
     /*  38430 */     // GIR_Coverage, 2123,
     /*  38430 */     GIR_Done,
     /*  38431 */   // Label 952: @38431
     /*  38431 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(38458), // Rule ID 5811 //
     /*  38436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38451 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPXORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  38451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  38456 */     GIR_RootConstrainSelectedInstOperands,
     /*  38457 */     // GIR_Coverage, 5811,
     /*  38457 */     GIR_Done,
     /*  38458 */   // Label 953: @38458
     /*  38458 */   GIM_Reject,
     /*  38459 */ // Label 944: @38459
     /*  38459 */ GIM_Reject,
     /*  38460 */ // Label 854: @38460
     /*  38460 */ GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(39001),
     /*  38465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38475 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(38595), // Rule ID 25373 //
     /*  38480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  38505 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38511 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38519 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38519 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38522 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38526 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38531 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  38535 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38540 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38543 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38547 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38573 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38576 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38594 */     // GIR_Coverage, 25373,
     /*  38594 */     GIR_EraseRootFromParent_Done,
     /*  38595 */   // Label 955: @38595
     /*  38595 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(38716), // Rule ID 19497 //
     /*  38600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  38630 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38640 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2), immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38640 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38643 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38647 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38652 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  38656 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38673 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38677 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38694 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38697 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38715 */     // GIR_Coverage, 19497,
     /*  38715 */     GIR_EraseRootFromParent_Done,
     /*  38716 */   // Label 956: @38716
     /*  38716 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(38836), // Rule ID 25374 //
     /*  38721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  38750 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38756 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38760 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38760 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38763 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38767 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38772 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  38776 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38781 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38784 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38788 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38793 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38797 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38814 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38817 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38830 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38835 */     // GIR_Coverage, 25374,
     /*  38835 */     GIR_EraseRootFromParent_Done,
     /*  38836 */   // Label 957: @38836
     /*  38836 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(38911), // Rule ID 19479 //
     /*  38841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38849 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38859 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src, immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38871 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  38887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38910 */     // GIR_Coverage, 19479,
     /*  38910 */     GIR_EraseRootFromParent_Done,
     /*  38911 */   // Label 958: @38911
     /*  38911 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(39000), // Rule ID 19501 //
     /*  38916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38924 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38924 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38927 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38931 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38936 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  38940 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38945 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38948 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38952 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38957 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  38961 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  38973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38978 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38981 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38999 */     // GIR_Coverage, 19501,
     /*  38999 */     GIR_EraseRootFromParent_Done,
     /*  39000 */   // Label 959: @39000
     /*  39000 */   GIM_Reject,
     /*  39001 */ // Label 954: @39001
     /*  39001 */ GIM_Reject,
     /*  39002 */ // Label 855: @39002
     /*  39002 */ GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(39621),
     /*  39007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39013 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(39075), // Rule ID 24236 //
     /*  39018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39033 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39036 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39040 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39057 */     // (xor:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPXORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rm),
     /*  39060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39062 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39064 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39073 */     GIR_RootConstrainSelectedInstOperands,
     /*  39074 */     // GIR_Coverage, 24236,
     /*  39074 */     GIR_EraseRootFromParent_Done,
     /*  39075 */   // Label 961: @39075
     /*  39075 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(39137), // Rule ID 25256 //
     /*  39080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39095 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39098 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39102 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39119 */     // (xor:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPXORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  39122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39124 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39135 */     GIR_RootConstrainSelectedInstOperands,
     /*  39136 */     // GIR_Coverage, 25256,
     /*  39136 */     GIR_EraseRootFromParent_Done,
     /*  39137 */   // Label 962: @39137
     /*  39137 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(39199), // Rule ID 5841 //
     /*  39142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39161 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39164 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39168 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39181 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rm),
     /*  39184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39186 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39197 */     GIR_RootConstrainSelectedInstOperands,
     /*  39198 */     // GIR_Coverage, 5841,
     /*  39198 */     GIR_EraseRootFromParent_Done,
     /*  39199 */   // Label 963: @39199
     /*  39199 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(39261), // Rule ID 18165 //
     /*  39204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39223 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39243 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  39246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39248 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39259 */     GIR_RootConstrainSelectedInstOperands,
     /*  39260 */     // GIR_Coverage, 18165,
     /*  39260 */     GIR_EraseRootFromParent_Done,
     /*  39261 */   // Label 964: @39261
     /*  39261 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(39493), // Rule ID 21944 //
     /*  39266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  39269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  39273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39281 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39287 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39291 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  39291 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  39294 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39298 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  39305 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  39308 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39312 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39317 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  39320 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39324 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  39327 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39332 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39337 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39342 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  39345 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39349 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  39356 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  39359 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39363 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39368 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  39371 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39375 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  39378 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39383 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39388 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39393 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  39396 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39400 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  39410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39419 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39422 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39426 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  39429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  39447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  39451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39456 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39459 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  39462 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  39465 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  39468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39475 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  39482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  39487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39492 */     // GIR_Coverage, 21944,
     /*  39492 */     GIR_EraseRootFromParent_Done,
     /*  39493 */   // Label 965: @39493
     /*  39493 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(39539), // Rule ID 21952 //
     /*  39498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  39501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39513 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39523 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (VPTERNLOGQZ128rri:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, 15:{ *:[i8] })
     /*  39523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  39526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39528 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39530 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39532 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  39537 */     GIR_RootConstrainSelectedInstOperands,
     /*  39538 */     // GIR_Coverage, 21952,
     /*  39538 */     GIR_EraseRootFromParent_Done,
     /*  39539 */   // Label 966: @39539
     /*  39539 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(39566), // Rule ID 5838 //
     /*  39544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39559 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPXORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  39559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rr),
     /*  39564 */     GIR_RootConstrainSelectedInstOperands,
     /*  39565 */     // GIR_Coverage, 5838,
     /*  39565 */     GIR_Done,
     /*  39566 */   // Label 967: @39566
     /*  39566 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(39593), // Rule ID 18153 //
     /*  39571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39586 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  39586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  39591 */     GIR_RootConstrainSelectedInstOperands,
     /*  39592 */     // GIR_Coverage, 18153,
     /*  39592 */     GIR_Done,
     /*  39593 */   // Label 968: @39593
     /*  39593 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(39620), // Rule ID 18177 //
     /*  39598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  39601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39613 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  39613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  39618 */     GIR_RootConstrainSelectedInstOperands,
     /*  39619 */     // GIR_Coverage, 18177,
     /*  39619 */     GIR_Done,
     /*  39620 */   // Label 969: @39620
     /*  39620 */   GIM_Reject,
     /*  39621 */ // Label 960: @39621
     /*  39621 */ GIM_Reject,
     /*  39622 */ // Label 856: @39622
     /*  39622 */ GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(40365),
     /*  39627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  39630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  39633 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(39695), // Rule ID 23365 //
     /*  39638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  39641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39653 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39656 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39660 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39677 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPXORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  39680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39682 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39684 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39693 */     GIR_RootConstrainSelectedInstOperands,
     /*  39694 */     // GIR_Coverage, 23365,
     /*  39694 */     GIR_EraseRootFromParent_Done,
     /*  39695 */   // Label 971: @39695
     /*  39695 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(39757), // Rule ID 24212 //
     /*  39700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39715 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39718 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39722 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39732 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39739 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPXORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  39742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39744 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39746 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39755 */     GIR_RootConstrainSelectedInstOperands,
     /*  39756 */     // GIR_Coverage, 24212,
     /*  39756 */     GIR_EraseRootFromParent_Done,
     /*  39757 */   // Label 972: @39757
     /*  39757 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(39819), // Rule ID 25247 //
     /*  39762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  39765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39777 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39784 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39801 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VXORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  39804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39806 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39808 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39817 */     GIR_RootConstrainSelectedInstOperands,
     /*  39818 */     // GIR_Coverage, 25247,
     /*  39818 */     GIR_EraseRootFromParent_Done,
     /*  39819 */   // Label 973: @39819
     /*  39819 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(39881), // Rule ID 2126 //
     /*  39824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  39827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39843 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39846 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39850 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39863 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  39866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39868 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39870 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39879 */     GIR_RootConstrainSelectedInstOperands,
     /*  39880 */     // GIR_Coverage, 2126,
     /*  39880 */     GIR_EraseRootFromParent_Done,
     /*  39881 */   // Label 974: @39881
     /*  39881 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(39943), // Rule ID 5805 //
     /*  39886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39912 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39925 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  39928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39930 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39932 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39941 */     GIR_RootConstrainSelectedInstOperands,
     /*  39942 */     // GIR_Coverage, 5805,
     /*  39942 */     GIR_EraseRootFromParent_Done,
     /*  39943 */   // Label 975: @39943
     /*  39943 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(40005), // Rule ID 18140 //
     /*  39948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  39951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39967 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39974 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39987 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  39990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39992 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40003 */     GIR_RootConstrainSelectedInstOperands,
     /*  40004 */     // GIR_Coverage, 18140,
     /*  40004 */     GIR_EraseRootFromParent_Done,
     /*  40005 */   // Label 976: @40005
     /*  40005 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(40237), // Rule ID 21949 //
     /*  40010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  40013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40025 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40031 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40035 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  40035 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  40038 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40042 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  40049 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  40052 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40056 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40061 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  40064 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40068 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  40071 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40076 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40081 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40086 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  40089 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40093 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  40100 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  40103 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40107 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40112 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  40115 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40119 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  40122 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40127 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40132 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40137 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  40140 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40144 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40151 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  40154 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40158 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40163 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40166 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40170 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  40173 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40178 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40183 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  40191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  40195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40200 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  40206 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  40209 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  40212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40219 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  40226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40236 */     // GIR_Coverage, 21949,
     /*  40236 */     GIR_EraseRootFromParent_Done,
     /*  40237 */   // Label 977: @40237
     /*  40237 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(40283), // Rule ID 21957 //
     /*  40242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  40245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40257 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40263 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40267 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (VPTERNLOGQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, 15:{ *:[i8] })
     /*  40267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  40270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40272 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40274 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40276 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  40281 */     GIR_RootConstrainSelectedInstOperands,
     /*  40282 */     // GIR_Coverage, 21957,
     /*  40282 */     GIR_EraseRootFromParent_Done,
     /*  40283 */   // Label 978: @40283
     /*  40283 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(40310), // Rule ID 2125 //
     /*  40288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  40291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40303 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPXORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  40303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  40308 */     GIR_RootConstrainSelectedInstOperands,
     /*  40309 */     // GIR_Coverage, 2125,
     /*  40309 */     GIR_Done,
     /*  40310 */   // Label 979: @40310
     /*  40310 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(40337), // Rule ID 5802 //
     /*  40315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  40318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40330 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPXORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  40330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  40335 */     GIR_RootConstrainSelectedInstOperands,
     /*  40336 */     // GIR_Coverage, 5802,
     /*  40336 */     GIR_Done,
     /*  40337 */   // Label 980: @40337
     /*  40337 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(40364), // Rule ID 18124 //
     /*  40342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  40345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40357 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VXORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  40357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  40362 */     GIR_RootConstrainSelectedInstOperands,
     /*  40363 */     // GIR_Coverage, 18124,
     /*  40363 */     GIR_Done,
     /*  40364 */   // Label 981: @40364
     /*  40364 */   GIM_Reject,
     /*  40365 */ // Label 970: @40365
     /*  40365 */ GIM_Reject,
     /*  40366 */ // Label 857: @40366
     /*  40366 */ GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(41163),
     /*  40371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40381 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(40441), // Rule ID 23681 //
     /*  40386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40414 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40420 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40428 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40437 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  40439 */     GIR_RootConstrainSelectedInstOperands,
     /*  40440 */     // GIR_Coverage, 23681,
     /*  40440 */     GIR_EraseRootFromParent_Done,
     /*  40441 */   // Label 983: @40441
     /*  40441 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(40564), // Rule ID 25367 //
     /*  40446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40474 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40480 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40488 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40488 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40491 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40495 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40500 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  40504 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40509 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40512 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40516 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40521 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40525 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40542 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40545 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40563 */     // GIR_Coverage, 25367,
     /*  40563 */     GIR_EraseRootFromParent_Done,
     /*  40564 */   // Label 984: @40564
     /*  40564 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(40627), // Rule ID 4422 //
     /*  40569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40602 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40608 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40612 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  40625 */     GIR_RootConstrainSelectedInstOperands,
     /*  40626 */     // GIR_Coverage, 4422,
     /*  40626 */     GIR_EraseRootFromParent_Done,
     /*  40627 */   // Label 985: @40627
     /*  40627 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(40751), // Rule ID 19494 //
     /*  40632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40665 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40671 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40675 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40675 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40678 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40682 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40687 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  40691 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40696 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40699 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40703 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40708 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40729 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40732 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40750 */     // GIR_Coverage, 19494,
     /*  40750 */     GIR_EraseRootFromParent_Done,
     /*  40751 */   // Label 986: @40751
     /*  40751 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(40811), // Rule ID 23682 //
     /*  40756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40788 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40794 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40798 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  40809 */     GIR_RootConstrainSelectedInstOperands,
     /*  40810 */     // GIR_Coverage, 23682,
     /*  40810 */     GIR_EraseRootFromParent_Done,
     /*  40811 */   // Label 987: @40811
     /*  40811 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(40934), // Rule ID 25368 //
     /*  40816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40848 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40854 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40858 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40858 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40861 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40865 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40870 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  40874 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40879 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40886 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40891 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40895 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40912 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40933 */     // GIR_Coverage, 25368,
     /*  40933 */     GIR_EraseRootFromParent_Done,
     /*  40934 */   // Label 988: @40934
     /*  40934 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(40969), // Rule ID 4410 //
     /*  40939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40950 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40956 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40960 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (KNOTBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src)
     /*  40960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTBkk),
     /*  40963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40967 */     GIR_RootConstrainSelectedInstOperands,
     /*  40968 */     // GIR_Coverage, 4410,
     /*  40968 */     GIR_EraseRootFromParent_Done,
     /*  40969 */   // Label 989: @40969
     /*  40969 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(41047), // Rule ID 19478 //
     /*  40974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoDQI),
     /*  40977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40985 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40991 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40995 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41007 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41011 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  41023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41028 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41046 */     // GIR_Coverage, 19478,
     /*  41046 */     GIR_EraseRootFromParent_Done,
     /*  41047 */   // Label 990: @41047
     /*  41047 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(41070), // Rule ID 4426 //
     /*  41052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  41055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41063 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KXORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  41063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORBkk),
     /*  41068 */     GIR_RootConstrainSelectedInstOperands,
     /*  41069 */     // GIR_Coverage, 4426,
     /*  41069 */     GIR_Done,
     /*  41070 */   // Label 991: @41070
     /*  41070 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(41162), // Rule ID 19498 //
     /*  41075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  41078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41086 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41086 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  41089 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41093 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41098 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  41102 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  41123 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  41135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41140 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41143 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  41146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41161 */     // GIR_Coverage, 19498,
     /*  41161 */     GIR_EraseRootFromParent_Done,
     /*  41162 */   // Label 992: @41162
     /*  41162 */   GIM_Reject,
     /*  41163 */ // Label 982: @41163
     /*  41163 */ GIM_Reject,
     /*  41164 */ // Label 858: @41164
     /*  41164 */ GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(41783),
     /*  41169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  41172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41175 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(41237), // Rule ID 25255 //
     /*  41180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41219 */     // (xor:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPXORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  41222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41235 */     GIR_RootConstrainSelectedInstOperands,
     /*  41236 */     // GIR_Coverage, 25255,
     /*  41236 */     GIR_EraseRootFromParent_Done,
     /*  41237 */   // Label 994: @41237
     /*  41237 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(41299), // Rule ID 25434 //
     /*  41242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41257 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41260 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41264 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41281 */     // (xor:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPXORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  41284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41286 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41288 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41297 */     GIR_RootConstrainSelectedInstOperands,
     /*  41298 */     // GIR_Coverage, 25434,
     /*  41298 */     GIR_EraseRootFromParent_Done,
     /*  41299 */   // Label 995: @41299
     /*  41299 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(41361), // Rule ID 18164 //
     /*  41304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41323 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41326 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41330 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41343 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  41346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41348 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  41350 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41359 */     GIR_RootConstrainSelectedInstOperands,
     /*  41360 */     // GIR_Coverage, 18164,
     /*  41360 */     GIR_EraseRootFromParent_Done,
     /*  41361 */   // Label 996: @41361
     /*  41361 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(41423), // Rule ID 20028 //
     /*  41366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41385 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41405 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  41408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41410 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  41412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41421 */     GIR_RootConstrainSelectedInstOperands,
     /*  41422 */     // GIR_Coverage, 20028,
     /*  41422 */     GIR_EraseRootFromParent_Done,
     /*  41423 */   // Label 997: @41423
     /*  41423 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(41655), // Rule ID 21943 //
     /*  41428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  41431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  41435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41443 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41453 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  41453 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  41456 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41460 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  41467 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  41470 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41474 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41479 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  41482 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41486 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  41489 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41494 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41499 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41504 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  41507 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41511 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  41518 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  41521 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41525 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41530 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  41533 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41537 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  41540 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41545 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41550 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41555 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  41558 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41562 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  41572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41581 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41584 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41588 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  41591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41596 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  41609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  41613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41621 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  41624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  41627 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  41630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41637 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  41644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  41649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41654 */     // GIR_Coverage, 21943,
     /*  41654 */     GIR_EraseRootFromParent_Done,
     /*  41655 */   // Label 998: @41655
     /*  41655 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(41701), // Rule ID 21951 //
     /*  41660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41675 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41681 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41685 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (VPTERNLOGQZ128rri:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, 15:{ *:[i8] })
     /*  41685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  41688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41690 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41692 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41694 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  41699 */     GIR_RootConstrainSelectedInstOperands,
     /*  41700 */     // GIR_Coverage, 21951,
     /*  41700 */     GIR_EraseRootFromParent_Done,
     /*  41701 */   // Label 999: @41701
     /*  41701 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(41728), // Rule ID 18152 //
     /*  41706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41721 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  41721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  41726 */     GIR_RootConstrainSelectedInstOperands,
     /*  41727 */     // GIR_Coverage, 18152,
     /*  41727 */     GIR_Done,
     /*  41728 */   // Label 1000: @41728
     /*  41728 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(41755), // Rule ID 18176 //
     /*  41733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  41736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41748 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  41748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  41753 */     GIR_RootConstrainSelectedInstOperands,
     /*  41754 */     // GIR_Coverage, 18176,
     /*  41754 */     GIR_Done,
     /*  41755 */   // Label 1001: @41755
     /*  41755 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(41782), // Rule ID 20020 //
     /*  41760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41775 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPXORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  41775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  41780 */     GIR_RootConstrainSelectedInstOperands,
     /*  41781 */     // GIR_Coverage, 20020,
     /*  41781 */     GIR_Done,
     /*  41782 */   // Label 1002: @41782
     /*  41782 */   GIM_Reject,
     /*  41783 */ // Label 993: @41783
     /*  41783 */ GIM_Reject,
     /*  41784 */ // Label 859: @41784
     /*  41784 */ GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(42527),
     /*  41789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  41792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  41795 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(41857), // Rule ID 24230 //
     /*  41800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  41803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  41807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41815 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41822 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  41830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41839 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPXORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rm),
     /*  41842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41844 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41846 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41855 */     GIR_RootConstrainSelectedInstOperands,
     /*  41856 */     // GIR_Coverage, 24230,
     /*  41856 */     GIR_EraseRootFromParent_Done,
     /*  41857 */   // Label 1004: @41857
     /*  41857 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(41919), // Rule ID 25235 //
     /*  41862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  41865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  41869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41877 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41880 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41884 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  41892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41901 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPXORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  41904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41906 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41908 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41917 */     GIR_RootConstrainSelectedInstOperands,
     /*  41918 */     // GIR_Coverage, 25235,
     /*  41918 */     GIR_EraseRootFromParent_Done,
     /*  41919 */   // Label 1005: @41919
     /*  41919 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(41981), // Rule ID 25246 //
     /*  41924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  41927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  41931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41939 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41946 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  41954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41963 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VXORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  41966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41968 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41979 */     GIR_RootConstrainSelectedInstOperands,
     /*  41980 */     // GIR_Coverage, 25246,
     /*  41980 */     GIR_EraseRootFromParent_Done,
     /*  41981 */   // Label 1006: @41981
     /*  41981 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(42043), // Rule ID 5832 //
     /*  41986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  41989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  41993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  41997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42005 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42012 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42025 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rm),
     /*  42028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42030 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42032 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42041 */     GIR_RootConstrainSelectedInstOperands,
     /*  42042 */     // GIR_Coverage, 5832,
     /*  42042 */     GIR_EraseRootFromParent_Done,
     /*  42043 */   // Label 1007: @42043
     /*  42043 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(42105), // Rule ID 18109 //
     /*  42048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42067 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42070 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42087 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  42090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42103 */     GIR_RootConstrainSelectedInstOperands,
     /*  42104 */     // GIR_Coverage, 18109,
     /*  42104 */     GIR_EraseRootFromParent_Done,
     /*  42105 */   // Label 1008: @42105
     /*  42105 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(42167), // Rule ID 18139 //
     /*  42110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42129 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42136 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42149 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  42152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42154 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42156 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42165 */     GIR_RootConstrainSelectedInstOperands,
     /*  42166 */     // GIR_Coverage, 18139,
     /*  42166 */     GIR_EraseRootFromParent_Done,
     /*  42167 */   // Label 1009: @42167
     /*  42167 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(42399), // Rule ID 21948 //
     /*  42172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  42175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42187 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42197 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  42197 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  42200 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42204 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  42211 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  42214 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42218 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42223 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  42226 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42230 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  42233 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42238 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42243 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42248 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  42251 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42255 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  42262 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  42265 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42269 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42274 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  42277 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42281 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  42284 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42289 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42294 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42299 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  42302 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42306 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42313 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  42316 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42320 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42325 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42328 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42332 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  42335 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42345 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  42353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  42357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42362 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  42368 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  42371 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  42374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42381 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  42388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42398 */     // GIR_Coverage, 21948,
     /*  42398 */     GIR_EraseRootFromParent_Done,
     /*  42399 */   // Label 1010: @42399
     /*  42399 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(42445), // Rule ID 21956 //
     /*  42404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  42407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42419 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42429 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (VPTERNLOGQZ256rri:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, 15:{ *:[i8] })
     /*  42429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  42432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42434 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42436 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42438 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  42443 */     GIR_RootConstrainSelectedInstOperands,
     /*  42444 */     // GIR_Coverage, 21956,
     /*  42444 */     GIR_EraseRootFromParent_Done,
     /*  42445 */   // Label 1011: @42445
     /*  42445 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(42472), // Rule ID 5829 //
     /*  42450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  42453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42465 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPXORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  42465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rr),
     /*  42470 */     GIR_RootConstrainSelectedInstOperands,
     /*  42471 */     // GIR_Coverage, 5829,
     /*  42471 */     GIR_Done,
     /*  42472 */   // Label 1012: @42472
     /*  42472 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(42499), // Rule ID 18097 //
     /*  42477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42492 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPXORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  42492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  42497 */     GIR_RootConstrainSelectedInstOperands,
     /*  42498 */     // GIR_Coverage, 18097,
     /*  42498 */     GIR_Done,
     /*  42499 */   // Label 1013: @42499
     /*  42499 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(42526), // Rule ID 18123 //
     /*  42504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42519 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VXORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  42519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  42524 */     GIR_RootConstrainSelectedInstOperands,
     /*  42525 */     // GIR_Coverage, 18123,
     /*  42525 */     GIR_Done,
     /*  42526 */   // Label 1014: @42526
     /*  42526 */   GIM_Reject,
     /*  42527 */ // Label 1003: @42527
     /*  42527 */ GIM_Reject,
     /*  42528 */ // Label 860: @42528
     /*  42528 */ GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(42725),
     /*  42533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  42536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  42539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42543 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(42601), // Rule ID 24206 //
     /*  42548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42559 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42562 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42566 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42576 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42583 */     // (xor:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPXORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  42586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42588 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42590 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42599 */     GIR_RootConstrainSelectedInstOperands,
     /*  42600 */     // GIR_Coverage, 24206,
     /*  42600 */     GIR_EraseRootFromParent_Done,
     /*  42601 */   // Label 1016: @42601
     /*  42601 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(42659), // Rule ID 5796 //
     /*  42606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42621 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42624 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42628 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42634 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42641 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  42644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42648 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42657 */     GIR_RootConstrainSelectedInstOperands,
     /*  42658 */     // GIR_Coverage, 5796,
     /*  42658 */     GIR_EraseRootFromParent_Done,
     /*  42659 */   // Label 1017: @42659
     /*  42659 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(42701), // Rule ID 21941 //
     /*  42664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42675 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42681 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42685 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, immAllOnesV:{ *:[v8i64] })  =>  (VPTERNLOGQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, 15:{ *:[i8] })
     /*  42685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  42688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42690 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42692 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42694 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  42699 */     GIR_RootConstrainSelectedInstOperands,
     /*  42700 */     // GIR_Coverage, 21941,
     /*  42700 */     GIR_EraseRootFromParent_Done,
     /*  42701 */   // Label 1018: @42701
     /*  42701 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(42724), // Rule ID 5793 //
     /*  42706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42717 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPXORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  42717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  42722 */     GIR_RootConstrainSelectedInstOperands,
     /*  42723 */     // GIR_Coverage, 5793,
     /*  42723 */     GIR_Done,
     /*  42724 */   // Label 1019: @42724
     /*  42724 */   GIM_Reject,
     /*  42725 */ // Label 1015: @42725
     /*  42725 */ GIM_Reject,
     /*  42726 */ // Label 861: @42726
     /*  42726 */ GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(42983),
     /*  42731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42741 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(42801), // Rule ID 23683 //
     /*  42746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42774 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  42782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42788 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  42791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  42797 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  42799 */     GIR_RootConstrainSelectedInstOperands,
     /*  42800 */     // GIR_Coverage, 23683,
     /*  42800 */     GIR_EraseRootFromParent_Done,
     /*  42801 */   // Label 1021: @42801
     /*  42801 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(42864), // Rule ID 4423 //
     /*  42806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42839 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42845 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  42847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42849 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2), immAllOnesV:{ *:[v16i1] })  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  42852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  42858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  42862 */     GIR_RootConstrainSelectedInstOperands,
     /*  42863 */     // GIR_Coverage, 4423,
     /*  42863 */     GIR_EraseRootFromParent_Done,
     /*  42864 */   // Label 1022: @42864
     /*  42864 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(42924), // Rule ID 23684 //
     /*  42869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42901 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  42909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42911 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  42914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  42920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  42922 */     GIR_RootConstrainSelectedInstOperands,
     /*  42923 */     // GIR_Coverage, 23684,
     /*  42923 */     GIR_EraseRootFromParent_Done,
     /*  42924 */   // Label 1023: @42924
     /*  42924 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(42959), // Rule ID 4411 //
     /*  42929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42940 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42946 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42950 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src, immAllOnesV:{ *:[v16i1] })  =>  (KNOTWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src)
     /*  42950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  42953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42955 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42957 */     GIR_RootConstrainSelectedInstOperands,
     /*  42958 */     // GIR_Coverage, 4411,
     /*  42958 */     GIR_EraseRootFromParent_Done,
     /*  42959 */   // Label 1024: @42959
     /*  42959 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(42982), // Rule ID 4427 //
     /*  42964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42975 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KXORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  42980 */     GIR_RootConstrainSelectedInstOperands,
     /*  42981 */     // GIR_Coverage, 4427,
     /*  42981 */     GIR_Done,
     /*  42982 */   // Label 1025: @42982
     /*  42982 */   GIM_Reject,
     /*  42983 */ // Label 1020: @42983
     /*  42983 */ GIM_Reject,
     /*  42984 */ // Label 862: @42984
     /*  42984 */ GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(43603),
     /*  42989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  42992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  42995 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(43057), // Rule ID 25254 //
     /*  43000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43015 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43018 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43022 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43039 */     // (xor:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPXORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  43042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43044 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43046 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43055 */     GIR_RootConstrainSelectedInstOperands,
     /*  43056 */     // GIR_Coverage, 25254,
     /*  43056 */     GIR_EraseRootFromParent_Done,
     /*  43057 */   // Label 1027: @43057
     /*  43057 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(43119), // Rule ID 25433 //
     /*  43062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43077 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43080 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43084 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43101 */     // (xor:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPXORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  43104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43106 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43108 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43117 */     GIR_RootConstrainSelectedInstOperands,
     /*  43118 */     // GIR_Coverage, 25433,
     /*  43118 */     GIR_EraseRootFromParent_Done,
     /*  43119 */   // Label 1028: @43119
     /*  43119 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(43181), // Rule ID 18163 //
     /*  43124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43143 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43146 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43150 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43163 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  43166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43168 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43170 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43179 */     GIR_RootConstrainSelectedInstOperands,
     /*  43180 */     // GIR_Coverage, 18163,
     /*  43180 */     GIR_EraseRootFromParent_Done,
     /*  43181 */   // Label 1029: @43181
     /*  43181 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(43243), // Rule ID 20027 //
     /*  43186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43205 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43208 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43212 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43225 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  43228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43230 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43232 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43241 */     GIR_RootConstrainSelectedInstOperands,
     /*  43242 */     // GIR_Coverage, 20027,
     /*  43242 */     GIR_EraseRootFromParent_Done,
     /*  43243 */   // Label 1030: @43243
     /*  43243 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(43475), // Rule ID 21942 //
     /*  43248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  43251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  43255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43263 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43273 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  43273 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  43276 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43280 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  43287 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  43290 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43294 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43299 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  43302 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43306 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  43309 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43314 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43319 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43324 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  43327 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43331 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  43338 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  43341 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43345 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43350 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  43353 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43357 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  43360 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43365 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43370 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43375 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  43378 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43382 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43389 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  43392 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43396 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43401 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43404 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43408 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  43411 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43416 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43421 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  43429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  43433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43438 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43441 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  43444 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  43447 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  43450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43457 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  43464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  43469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43474 */     // GIR_Coverage, 21942,
     /*  43474 */     GIR_EraseRootFromParent_Done,
     /*  43475 */   // Label 1031: @43475
     /*  43475 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(43521), // Rule ID 21950 //
     /*  43480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43495 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43501 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43505 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (VPTERNLOGQZ128rri:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, 15:{ *:[i8] })
     /*  43505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  43508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43510 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43512 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43514 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  43519 */     GIR_RootConstrainSelectedInstOperands,
     /*  43520 */     // GIR_Coverage, 21950,
     /*  43520 */     GIR_EraseRootFromParent_Done,
     /*  43521 */   // Label 1032: @43521
     /*  43521 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(43548), // Rule ID 18151 //
     /*  43526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43541 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  43541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  43546 */     GIR_RootConstrainSelectedInstOperands,
     /*  43547 */     // GIR_Coverage, 18151,
     /*  43547 */     GIR_Done,
     /*  43548 */   // Label 1033: @43548
     /*  43548 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(43575), // Rule ID 18175 //
     /*  43553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  43556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43568 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  43568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  43573 */     GIR_RootConstrainSelectedInstOperands,
     /*  43574 */     // GIR_Coverage, 18175,
     /*  43574 */     GIR_Done,
     /*  43575 */   // Label 1034: @43575
     /*  43575 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(43602), // Rule ID 20019 //
     /*  43580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43595 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPXORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  43595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  43600 */     GIR_RootConstrainSelectedInstOperands,
     /*  43601 */     // GIR_Coverage, 20019,
     /*  43601 */     GIR_Done,
     /*  43602 */   // Label 1035: @43602
     /*  43602 */   GIM_Reject,
     /*  43603 */ // Label 1026: @43603
     /*  43603 */ GIM_Reject,
     /*  43604 */ // Label 863: @43604
     /*  43604 */ GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(44347),
     /*  43609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  43612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  43615 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(43677), // Rule ID 25234 //
     /*  43620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  43623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43635 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43638 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43642 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43659 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPXORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  43662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43664 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43666 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43675 */     GIR_RootConstrainSelectedInstOperands,
     /*  43676 */     // GIR_Coverage, 25234,
     /*  43676 */     GIR_EraseRootFromParent_Done,
     /*  43677 */   // Label 1037: @43677
     /*  43677 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(43739), // Rule ID 25245 //
     /*  43682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  43685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43697 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43700 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43704 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43721 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VXORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  43724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43726 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43728 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43737 */     GIR_RootConstrainSelectedInstOperands,
     /*  43738 */     // GIR_Coverage, 25245,
     /*  43738 */     GIR_EraseRootFromParent_Done,
     /*  43739 */   // Label 1038: @43739
     /*  43739 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(43801), // Rule ID 25440 //
     /*  43744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43759 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43766 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43783 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPXORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  43786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43788 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43790 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43799 */     GIR_RootConstrainSelectedInstOperands,
     /*  43800 */     // GIR_Coverage, 25440,
     /*  43800 */     GIR_EraseRootFromParent_Done,
     /*  43801 */   // Label 1039: @43801
     /*  43801 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(43863), // Rule ID 18108 //
     /*  43806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  43809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43825 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43828 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43832 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43838 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43845 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  43848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43850 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43852 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43861 */     GIR_RootConstrainSelectedInstOperands,
     /*  43862 */     // GIR_Coverage, 18108,
     /*  43862 */     GIR_EraseRootFromParent_Done,
     /*  43863 */   // Label 1040: @43863
     /*  43863 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(43925), // Rule ID 18138 //
     /*  43868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  43871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43887 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43890 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43894 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43907 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  43910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43912 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43914 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43923 */     GIR_RootConstrainSelectedInstOperands,
     /*  43924 */     // GIR_Coverage, 18138,
     /*  43924 */     GIR_EraseRootFromParent_Done,
     /*  43925 */   // Label 1041: @43925
     /*  43925 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(43987), // Rule ID 20044 //
     /*  43930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43949 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43952 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43956 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43969 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  43972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43974 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43976 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43985 */     GIR_RootConstrainSelectedInstOperands,
     /*  43986 */     // GIR_Coverage, 20044,
     /*  43986 */     GIR_EraseRootFromParent_Done,
     /*  43987 */   // Label 1042: @43987
     /*  43987 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(44219), // Rule ID 21947 //
     /*  43992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  43995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44007 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44013 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44017 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  44017 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  44020 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44024 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  44031 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  44034 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44038 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44043 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  44046 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44050 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  44053 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44058 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44063 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44068 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  44071 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44075 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  44082 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  44085 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44089 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44094 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  44097 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44101 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  44104 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44109 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44114 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44119 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  44122 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44126 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  44133 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  44136 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44140 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44145 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  44148 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44152 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  44155 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44160 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  44173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  44177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44182 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44185 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  44188 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  44191 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  44194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44201 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  44208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44218 */     // GIR_Coverage, 21947,
     /*  44218 */     GIR_EraseRootFromParent_Done,
     /*  44219 */   // Label 1043: @44219
     /*  44219 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(44265), // Rule ID 21955 //
     /*  44224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44239 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44249 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (VPTERNLOGQZ256rri:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, 15:{ *:[i8] })
     /*  44249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  44252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44254 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44256 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44258 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  44263 */     GIR_RootConstrainSelectedInstOperands,
     /*  44264 */     // GIR_Coverage, 21955,
     /*  44264 */     GIR_EraseRootFromParent_Done,
     /*  44265 */   // Label 1044: @44265
     /*  44265 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(44292), // Rule ID 18096 //
     /*  44270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  44273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44285 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPXORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  44285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  44290 */     GIR_RootConstrainSelectedInstOperands,
     /*  44291 */     // GIR_Coverage, 18096,
     /*  44291 */     GIR_Done,
     /*  44292 */   // Label 1045: @44292
     /*  44292 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(44319), // Rule ID 18122 //
     /*  44297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  44300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44312 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VXORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  44312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  44317 */     GIR_RootConstrainSelectedInstOperands,
     /*  44318 */     // GIR_Coverage, 18122,
     /*  44318 */     GIR_Done,
     /*  44319 */   // Label 1046: @44319
     /*  44319 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(44346), // Rule ID 20036 //
     /*  44324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44339 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPXORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  44339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  44344 */     GIR_RootConstrainSelectedInstOperands,
     /*  44345 */     // GIR_Coverage, 20036,
     /*  44345 */     GIR_Done,
     /*  44346 */   // Label 1047: @44346
     /*  44346 */   GIM_Reject,
     /*  44347 */ // Label 1036: @44347
     /*  44347 */ GIM_Reject,
     /*  44348 */ // Label 864: @44348
     /*  44348 */ GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(44545),
     /*  44353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  44356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  44359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44363 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(44421), // Rule ID 24224 //
     /*  44368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44379 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44382 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44403 */     // (xor:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPXORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZrm),
     /*  44406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44408 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44419 */     GIR_RootConstrainSelectedInstOperands,
     /*  44420 */     // GIR_Coverage, 24224,
     /*  44420 */     GIR_EraseRootFromParent_Done,
     /*  44421 */   // Label 1049: @44421
     /*  44421 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(44479), // Rule ID 5823 //
     /*  44426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44441 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44444 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44448 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44461 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZrm),
     /*  44464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44466 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44477 */     GIR_RootConstrainSelectedInstOperands,
     /*  44478 */     // GIR_Coverage, 5823,
     /*  44478 */     GIR_EraseRootFromParent_Done,
     /*  44479 */   // Label 1050: @44479
     /*  44479 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(44521), // Rule ID 21940 //
     /*  44484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44495 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44501 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44505 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, immAllOnesV:{ *:[v16i32] })  =>  (VPTERNLOGQZrri:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, 15:{ *:[i8] })
     /*  44505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  44508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44510 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44512 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44514 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  44519 */     GIR_RootConstrainSelectedInstOperands,
     /*  44520 */     // GIR_Coverage, 21940,
     /*  44520 */     GIR_EraseRootFromParent_Done,
     /*  44521 */   // Label 1051: @44521
     /*  44521 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(44544), // Rule ID 5820 //
     /*  44526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44537 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPXORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  44537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZrr),
     /*  44542 */     GIR_RootConstrainSelectedInstOperands,
     /*  44543 */     // GIR_Coverage, 5820,
     /*  44543 */     GIR_Done,
     /*  44544 */   // Label 1052: @44544
     /*  44544 */   GIM_Reject,
     /*  44545 */ // Label 1048: @44545
     /*  44545 */ GIM_Reject,
     /*  44546 */ // Label 865: @44546
     /*  44546 */ GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(44803),
     /*  44551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44561 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(44621), // Rule ID 23685 //
     /*  44566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44594 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44600 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44608 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44617 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  44619 */     GIR_RootConstrainSelectedInstOperands,
     /*  44620 */     // GIR_Coverage, 23685,
     /*  44620 */     GIR_EraseRootFromParent_Done,
     /*  44621 */   // Label 1054: @44621
     /*  44621 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(44684), // Rule ID 4424 //
     /*  44626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44659 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44665 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44669 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2), immAllOnesV:{ *:[v32i1] })  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  44682 */     GIR_RootConstrainSelectedInstOperands,
     /*  44683 */     // GIR_Coverage, 4424,
     /*  44683 */     GIR_EraseRootFromParent_Done,
     /*  44684 */   // Label 1055: @44684
     /*  44684 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(44744), // Rule ID 23686 //
     /*  44689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44721 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44727 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44731 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44740 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  44742 */     GIR_RootConstrainSelectedInstOperands,
     /*  44743 */     // GIR_Coverage, 23686,
     /*  44743 */     GIR_EraseRootFromParent_Done,
     /*  44744 */   // Label 1056: @44744
     /*  44744 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(44779), // Rule ID 4412 //
     /*  44749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44760 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44766 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44770 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src, immAllOnesV:{ *:[v32i1] })  =>  (KNOTDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src)
     /*  44770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTDkk),
     /*  44773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44775 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44777 */     GIR_RootConstrainSelectedInstOperands,
     /*  44778 */     // GIR_Coverage, 4412,
     /*  44778 */     GIR_EraseRootFromParent_Done,
     /*  44779 */   // Label 1057: @44779
     /*  44779 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(44802), // Rule ID 4428 //
     /*  44784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44795 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KXORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORDkk),
     /*  44800 */     GIR_RootConstrainSelectedInstOperands,
     /*  44801 */     // GIR_Coverage, 4428,
     /*  44801 */     GIR_Done,
     /*  44802 */   // Label 1058: @44802
     /*  44802 */   GIM_Reject,
     /*  44803 */ // Label 1053: @44803
     /*  44803 */ GIM_Reject,
     /*  44804 */ // Label 866: @44804
     /*  44804 */ GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(45547),
     /*  44809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  44812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  44815 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(44877), // Rule ID 25233 //
     /*  44820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  44823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44835 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44842 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44859 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPXORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  44862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44864 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44875 */     GIR_RootConstrainSelectedInstOperands,
     /*  44876 */     // GIR_Coverage, 25233,
     /*  44876 */     GIR_EraseRootFromParent_Done,
     /*  44877 */   // Label 1060: @44877
     /*  44877 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(44939), // Rule ID 25244 //
     /*  44882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  44885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44897 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44904 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44921 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VXORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  44924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44926 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44937 */     GIR_RootConstrainSelectedInstOperands,
     /*  44938 */     // GIR_Coverage, 25244,
     /*  44938 */     GIR_EraseRootFromParent_Done,
     /*  44939 */   // Label 1061: @44939
     /*  44939 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(45001), // Rule ID 25439 //
     /*  44944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44983 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPXORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  44986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44988 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44990 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44999 */     GIR_RootConstrainSelectedInstOperands,
     /*  45000 */     // GIR_Coverage, 25439,
     /*  45000 */     GIR_EraseRootFromParent_Done,
     /*  45001 */   // Label 1062: @45001
     /*  45001 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(45063), // Rule ID 18107 //
     /*  45006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45025 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45028 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45032 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45045 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  45048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45061 */     GIR_RootConstrainSelectedInstOperands,
     /*  45062 */     // GIR_Coverage, 18107,
     /*  45062 */     GIR_EraseRootFromParent_Done,
     /*  45063 */   // Label 1063: @45063
     /*  45063 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(45125), // Rule ID 18137 //
     /*  45068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45094 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45107 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  45110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45123 */     GIR_RootConstrainSelectedInstOperands,
     /*  45124 */     // GIR_Coverage, 18137,
     /*  45124 */     GIR_EraseRootFromParent_Done,
     /*  45125 */   // Label 1064: @45125
     /*  45125 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(45187), // Rule ID 20043 //
     /*  45130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45149 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45152 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45156 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45169 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  45172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45174 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45185 */     GIR_RootConstrainSelectedInstOperands,
     /*  45186 */     // GIR_Coverage, 20043,
     /*  45186 */     GIR_EraseRootFromParent_Done,
     /*  45187 */   // Label 1065: @45187
     /*  45187 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(45419), // Rule ID 21946 //
     /*  45192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  45195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45207 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45213 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45217 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  45217 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  45220 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45224 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  45231 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  45234 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45238 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45243 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  45246 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45250 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  45253 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45258 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45263 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45268 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  45271 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45275 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  45282 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  45285 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45289 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45294 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  45297 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45301 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  45304 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45309 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45314 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45319 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  45322 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45326 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45333 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  45336 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45340 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45345 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45348 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45352 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  45355 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45365 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  45373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  45377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45382 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45385 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  45388 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  45391 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  45394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45401 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  45408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45418 */     // GIR_Coverage, 21946,
     /*  45418 */     GIR_EraseRootFromParent_Done,
     /*  45419 */   // Label 1066: @45419
     /*  45419 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(45465), // Rule ID 21954 //
     /*  45424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45439 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45445 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45449 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (VPTERNLOGQZ256rri:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, 15:{ *:[i8] })
     /*  45449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  45452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45454 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45456 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45458 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  45463 */     GIR_RootConstrainSelectedInstOperands,
     /*  45464 */     // GIR_Coverage, 21954,
     /*  45464 */     GIR_EraseRootFromParent_Done,
     /*  45465 */   // Label 1067: @45465
     /*  45465 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(45492), // Rule ID 18095 //
     /*  45470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45485 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPXORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  45485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  45490 */     GIR_RootConstrainSelectedInstOperands,
     /*  45491 */     // GIR_Coverage, 18095,
     /*  45491 */     GIR_Done,
     /*  45492 */   // Label 1068: @45492
     /*  45492 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(45519), // Rule ID 18121 //
     /*  45497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45512 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VXORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  45512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  45517 */     GIR_RootConstrainSelectedInstOperands,
     /*  45518 */     // GIR_Coverage, 18121,
     /*  45518 */     GIR_Done,
     /*  45519 */   // Label 1069: @45519
     /*  45519 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(45546), // Rule ID 20035 //
     /*  45524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45539 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPXORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  45539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  45544 */     GIR_RootConstrainSelectedInstOperands,
     /*  45545 */     // GIR_Coverage, 20035,
     /*  45545 */     GIR_Done,
     /*  45546 */   // Label 1070: @45546
     /*  45546 */   GIM_Reject,
     /*  45547 */ // Label 1059: @45547
     /*  45547 */ GIM_Reject,
     /*  45548 */ // Label 867: @45548
     /*  45548 */ GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(45745),
     /*  45553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  45556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  45559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45563 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(45621), // Rule ID 25446 //
     /*  45568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45579 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45582 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45586 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45603 */     // (xor:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPXORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  45606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45608 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45610 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45619 */     GIR_RootConstrainSelectedInstOperands,
     /*  45620 */     // GIR_Coverage, 25446,
     /*  45620 */     GIR_EraseRootFromParent_Done,
     /*  45621 */   // Label 1072: @45621
     /*  45621 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(45679), // Rule ID 20060 //
     /*  45626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45641 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45648 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45661 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  45664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45668 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45677 */     GIR_RootConstrainSelectedInstOperands,
     /*  45678 */     // GIR_Coverage, 20060,
     /*  45678 */     GIR_EraseRootFromParent_Done,
     /*  45679 */   // Label 1073: @45679
     /*  45679 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(45721), // Rule ID 21939 //
     /*  45684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45695 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45701 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45705 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, immAllOnesV:{ *:[v32i16] })  =>  (VPTERNLOGQZrri:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, 15:{ *:[i8] })
     /*  45705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  45708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45710 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45712 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45714 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  45719 */     GIR_RootConstrainSelectedInstOperands,
     /*  45720 */     // GIR_Coverage, 21939,
     /*  45720 */     GIR_EraseRootFromParent_Done,
     /*  45721 */   // Label 1074: @45721
     /*  45721 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(45744), // Rule ID 20052 //
     /*  45726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45737 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPXORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  45737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  45742 */     GIR_RootConstrainSelectedInstOperands,
     /*  45743 */     // GIR_Coverage, 20052,
     /*  45743 */     GIR_Done,
     /*  45744 */   // Label 1075: @45744
     /*  45744 */   GIM_Reject,
     /*  45745 */ // Label 1071: @45745
     /*  45745 */ GIM_Reject,
     /*  45746 */ // Label 868: @45746
     /*  45746 */ GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(46003),
     /*  45751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45761 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(45821), // Rule ID 23687 //
     /*  45766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45794 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  45802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45808 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  45808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  45811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45817 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  45819 */     GIR_RootConstrainSelectedInstOperands,
     /*  45820 */     // GIR_Coverage, 23687,
     /*  45820 */     GIR_EraseRootFromParent_Done,
     /*  45821 */   // Label 1077: @45821
     /*  45821 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(45884), // Rule ID 4425 //
     /*  45826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45859 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45865 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  45867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45869 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2), immAllOnesV:{ *:[v64i1] })  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  45869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  45872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  45882 */     GIR_RootConstrainSelectedInstOperands,
     /*  45883 */     // GIR_Coverage, 4425,
     /*  45883 */     GIR_EraseRootFromParent_Done,
     /*  45884 */   // Label 1078: @45884
     /*  45884 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(45944), // Rule ID 23688 //
     /*  45889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45921 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45927 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  45929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45931 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  45931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  45934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45940 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  45942 */     GIR_RootConstrainSelectedInstOperands,
     /*  45943 */     // GIR_Coverage, 23688,
     /*  45943 */     GIR_EraseRootFromParent_Done,
     /*  45944 */   // Label 1079: @45944
     /*  45944 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(45979), // Rule ID 4413 //
     /*  45949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45960 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45966 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45970 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src, immAllOnesV:{ *:[v64i1] })  =>  (KNOTQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src)
     /*  45970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTQkk),
     /*  45973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45975 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45977 */     GIR_RootConstrainSelectedInstOperands,
     /*  45978 */     // GIR_Coverage, 4413,
     /*  45978 */     GIR_EraseRootFromParent_Done,
     /*  45979 */   // Label 1080: @45979
     /*  45979 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(46002), // Rule ID 4429 //
     /*  45984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45995 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KXORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  45995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORQkk),
     /*  46000 */     GIR_RootConstrainSelectedInstOperands,
     /*  46001 */     // GIR_Coverage, 4429,
     /*  46001 */     GIR_Done,
     /*  46002 */   // Label 1081: @46002
     /*  46002 */   GIM_Reject,
     /*  46003 */ // Label 1076: @46003
     /*  46003 */ GIM_Reject,
     /*  46004 */ // Label 869: @46004
     /*  46004 */ GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(46201),
     /*  46009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  46012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  46015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46019 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(46077), // Rule ID 25445 //
     /*  46024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  46035 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  46038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  46042 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  46046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  46059 */     // (xor:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPXORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  46059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  46062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46064 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  46066 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  46070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  46075 */     GIR_RootConstrainSelectedInstOperands,
     /*  46076 */     // GIR_Coverage, 25445,
     /*  46076 */     GIR_EraseRootFromParent_Done,
     /*  46077 */   // Label 1083: @46077
     /*  46077 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(46135), // Rule ID 20059 //
     /*  46082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  46097 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  46100 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  46104 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  46108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  46117 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  46117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  46120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46124 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  46128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  46133 */     GIR_RootConstrainSelectedInstOperands,
     /*  46134 */     // GIR_Coverage, 20059,
     /*  46134 */     GIR_EraseRootFromParent_Done,
     /*  46135 */   // Label 1084: @46135
     /*  46135 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(46177), // Rule ID 21938 //
     /*  46140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46151 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46157 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  46159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46161 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, immAllOnesV:{ *:[v64i8] })  =>  (VPTERNLOGQZrri:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, 15:{ *:[i8] })
     /*  46161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  46164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46166 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46168 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46170 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  46175 */     GIR_RootConstrainSelectedInstOperands,
     /*  46176 */     // GIR_Coverage, 21938,
     /*  46176 */     GIR_EraseRootFromParent_Done,
     /*  46177 */   // Label 1085: @46177
     /*  46177 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(46200), // Rule ID 20051 //
     /*  46182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46193 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPXORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  46193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  46198 */     GIR_RootConstrainSelectedInstOperands,
     /*  46199 */     // GIR_Coverage, 20051,
     /*  46199 */     GIR_Done,
     /*  46200 */   // Label 1086: @46200
     /*  46200 */   GIM_Reject,
     /*  46201 */ // Label 1082: @46201
     /*  46201 */ GIM_Reject,
     /*  46202 */ // Label 870: @46202
     /*  46202 */ GIM_Reject,
     /*  46203 */ // Label 6: @46203
     /*  46203 */ GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(46369),
     /*  46208 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  46211 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(16), GIMT_Encode2(24), /*)*//*default:*//*Label 1091*/ GIMT_Encode4(46368),
     /*  46222 */   /*GILLT_v16s1*//*Label 1088*/ GIMT_Encode4(46254), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46238 */   /*GILLT_v32s1*//*Label 1089*/ GIMT_Encode4(46292), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46250 */   /*GILLT_v64s1*//*Label 1090*/ GIMT_Encode4(46330),
     /*  46254 */   // Label 1088: @46254
     /*  46254 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(46291), // Rule ID 19502 //
     /*  46259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46262 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  46265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  46268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46280 */     // (concat_vectors:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KUNPCKBWkk:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK8:{ *:[v8i1] }:$src1)
     /*  46280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKBWkk),
     /*  46283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46285 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46287 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46289 */     GIR_RootConstrainSelectedInstOperands,
     /*  46290 */     // GIR_Coverage, 19502,
     /*  46290 */     GIR_EraseRootFromParent_Done,
     /*  46291 */   // Label 1092: @46291
     /*  46291 */   GIM_Reject,
     /*  46292 */   // Label 1089: @46292
     /*  46292 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(46329), // Rule ID 19503 //
     /*  46297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46300 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  46303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  46306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46318 */     // (concat_vectors:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KUNPCKWDkk:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src2, VK16:{ *:[v16i1] }:$src1)
     /*  46318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKWDkk),
     /*  46321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46323 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46325 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46327 */     GIR_RootConstrainSelectedInstOperands,
     /*  46328 */     // GIR_Coverage, 19503,
     /*  46328 */     GIR_EraseRootFromParent_Done,
     /*  46329 */   // Label 1093: @46329
     /*  46329 */   GIM_Reject,
     /*  46330 */   // Label 1090: @46330
     /*  46330 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(46367), // Rule ID 19504 //
     /*  46335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46338 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  46341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  46344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46356 */     // (concat_vectors:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KUNPCKDQkk:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src2, VK32:{ *:[v32i1] }:$src1)
     /*  46356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKDQkk),
     /*  46359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46361 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46365 */     GIR_RootConstrainSelectedInstOperands,
     /*  46366 */     // GIR_Coverage, 19504,
     /*  46366 */     GIR_EraseRootFromParent_Done,
     /*  46367 */   // Label 1094: @46367
     /*  46367 */   GIM_Reject,
     /*  46368 */   // Label 1091: @46368
     /*  46368 */   GIM_Reject,
     /*  46369 */ // Label 1087: @46369
     /*  46369 */ GIM_Reject,
     /*  46370 */ // Label 7: @46370
     /*  46370 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(24), /*)*//*default:*//*Label 1103*/ GIMT_Encode4(48659),
     /*  46381 */ /*GILLT_s8*//*Label 1095*/ GIMT_Encode4(46473),
     /*  46385 */ /*GILLT_s16*//*Label 1096*/ GIMT_Encode4(46534),
     /*  46389 */ /*GILLT_s32*//*Label 1097*/ GIMT_Encode4(47364),
     /*  46393 */ /*GILLT_s64*//*Label 1098*/ GIMT_Encode4(47790), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46425 */ /*GILLT_v8s1*//*Label 1099*/ GIMT_Encode4(48216), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46441 */ /*GILLT_v16s1*//*Label 1100*/ GIMT_Encode4(48377), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46457 */ /*GILLT_v32s1*//*Label 1101*/ GIMT_Encode4(48517), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46469 */ /*GILLT_v64s1*//*Label 1102*/ GIMT_Encode4(48588),
     /*  46473 */ // Label 1095: @46473
     /*  46473 */ GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(46533), // Rule ID 19433 //
     /*  46478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  46481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  46485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46489 */   // (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /*  46489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46501 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46505 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  46510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46515 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /*  46522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  46527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46532 */   // GIR_Coverage, 19433,
     /*  46532 */   GIR_EraseRootFromParent_Done,
     /*  46533 */ // Label 1104: @46533
     /*  46533 */ GIM_Reject,
     /*  46534 */ // Label 1096: @46534
     /*  46534 */ GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(46594), // Rule ID 19430 //
     /*  46539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  46542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46550 */   // (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /*  46550 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46553 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46557 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46562 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46566 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  46571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46576 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46588 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46593 */   // GIR_Coverage, 19430,
     /*  46593 */   GIR_EraseRootFromParent_Done,
     /*  46594 */ // Label 1105: @46594
     /*  46594 */ GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(46695), // Rule ID 22139 //
     /*  46599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  46602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  46609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46613 */   // (bitconvert:{ *:[f16] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VMOVW2SHrr:{ *:[f128] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })), FR16X:{ *:[i32] })
     /*  46613 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46616 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46620 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46627 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46630 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46634 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46639 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46642 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46646 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/4,
     /*  46649 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46654 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46659 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  46664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  46667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVW2SHrr),
     /*  46671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46676 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46686 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46689 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  46694 */   // GIR_Coverage, 22139,
     /*  46694 */   GIR_EraseRootFromParent_Done,
     /*  46695 */ // Label 1106: @46695
     /*  46695 */ GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(46775), // Rule ID 22152 //
     /*  46700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  46703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  46714 */   // (bitconvert:{ *:[i16] } FR16X:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VMOVSH2Wrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f128] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  46714 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  46717 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46721 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46726 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46730 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /*  46735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSH2Wrr),
     /*  46742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46747 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46757 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46764 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46769 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46774 */   // GIR_Coverage, 22152,
     /*  46774 */   GIR_EraseRootFromParent_Done,
     /*  46775 */ // Label 1107: @46775
     /*  46775 */ GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(46854), // Rule ID 18339 //
     /*  46780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  46783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46790 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  46790 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46793 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46797 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46802 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46806 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  46811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWrri),
     /*  46818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46823 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46826 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  46829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46836 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46853 */   // GIR_Coverage, 18339,
     /*  46853 */   GIR_EraseRootFromParent_Done,
     /*  46854 */ // Label 1108: @46854
     /*  46854 */ GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(46971), // Rule ID 18340 //
     /*  46859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  46862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  46869 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  46869 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  46872 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46876 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  46883 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46886 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46890 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46895 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  46898 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46902 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  46905 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46910 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46915 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  46920 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46923 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46927 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  46934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  46937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrri),
     /*  46941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46946 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46949 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  46952 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  46955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  46970 */   // GIR_Coverage, 18340,
     /*  46970 */   GIR_EraseRootFromParent_Done,
     /*  46971 */ // Label 1109: @46971
     /*  46971 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(47050), // Rule ID 18336 //
     /*  46976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  46979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46986 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  46986 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46989 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46993 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46998 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47002 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  47007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /*  47014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47019 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47022 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47032 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47044 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47049 */   // GIR_Coverage, 18336,
     /*  47049 */   GIR_EraseRootFromParent_Done,
     /*  47050 */ // Label 1110: @47050
     /*  47050 */ GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(47167), // Rule ID 18337 //
     /*  47055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  47065 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  47065 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47068 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47072 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47079 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47082 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47086 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47091 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47094 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47098 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47101 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47106 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47111 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47116 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47119 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47123 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47128 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47130 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47133 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrri),
     /*  47137 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47142 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47145 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47148 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  47166 */   // GIR_Coverage, 18337,
     /*  47166 */   GIR_EraseRootFromParent_Done,
     /*  47167 */ // Label 1111: @47167
     /*  47167 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(47246), // Rule ID 21840 //
     /*  47172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  47175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  47182 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWZrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  47182 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47185 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47189 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47194 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47198 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /*  47203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZrri),
     /*  47210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47215 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47218 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47228 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47235 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47240 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47245 */   // GIR_Coverage, 21840,
     /*  47245 */   GIR_EraseRootFromParent_Done,
     /*  47246 */ // Label 1112: @47246
     /*  47246 */ GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(47363), // Rule ID 21841 //
     /*  47251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  47254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  47261 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /*  47261 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47264 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47268 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47275 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47278 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47282 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47287 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47290 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47294 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47297 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47302 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47307 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47312 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47315 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47319 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47326 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47329 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrri),
     /*  47333 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47338 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47341 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47344 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47357 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  47362 */   // GIR_Coverage, 21841,
     /*  47362 */   GIR_EraseRootFromParent_Done,
     /*  47363 */ // Label 1113: @47363
     /*  47363 */ GIM_Reject,
     /*  47364 */ // Label 1097: @47364
     /*  47364 */ GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(47430), // Rule ID 22524 //
     /*  47369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  47372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47379 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47383 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47387 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47390 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47394 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47401 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47407 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47414 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (MOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSrm_alt),
     /*  47417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47419 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47423 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47428 */   GIR_RootConstrainSelectedInstOperands,
     /*  47429 */   // GIR_Coverage, 22524,
     /*  47429 */   GIR_EraseRootFromParent_Done,
     /*  47430 */ // Label 1114: @47430
     /*  47430 */ GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(47496), // Rule ID 22525 //
     /*  47435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47445 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47449 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47453 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47456 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47460 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47467 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47471 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47473 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47480 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (VMOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSrm_alt),
     /*  47483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47485 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47494 */   GIR_RootConstrainSelectedInstOperands,
     /*  47495 */   // GIR_Coverage, 22525,
     /*  47495 */   GIR_EraseRootFromParent_Done,
     /*  47496 */ // Label 1115: @47496
     /*  47496 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(47562), // Rule ID 22526 //
     /*  47501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47511 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47515 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47519 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47522 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47526 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47533 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47537 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47539 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47546 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (VMOVSSZrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZrm_alt),
     /*  47549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47551 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47555 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47560 */   GIR_RootConstrainSelectedInstOperands,
     /*  47561 */   // GIR_Coverage, 22526,
     /*  47561 */   GIR_EraseRootFromParent_Done,
     /*  47562 */ // Label 1116: @47562
     /*  47562 */ GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(47588), // Rule ID 2914 //
     /*  47567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47581 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47581 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSrr),
     /*  47586 */   GIR_RootConstrainSelectedInstOperands,
     /*  47587 */   // GIR_Coverage, 2914,
     /*  47587 */   GIR_Done,
     /*  47588 */ // Label 1117: @47588
     /*  47588 */ GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(47614), // Rule ID 2915 //
     /*  47593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47607 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (MOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVDI2SSrr),
     /*  47612 */   GIR_RootConstrainSelectedInstOperands,
     /*  47613 */   // GIR_Coverage, 2915,
     /*  47613 */   GIR_Done,
     /*  47614 */ // Label 1118: @47614
     /*  47614 */ GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(47640), // Rule ID 2924 //
     /*  47619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47633 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VMOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  47633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIrr),
     /*  47638 */   GIR_RootConstrainSelectedInstOperands,
     /*  47639 */   // GIR_Coverage, 2924,
     /*  47639 */   GIR_Done,
     /*  47640 */ // Label 1119: @47640
     /*  47640 */ GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(47666), // Rule ID 2925 //
     /*  47645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47659 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (MOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  47659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSS2DIrr),
     /*  47664 */   GIR_RootConstrainSelectedInstOperands,
     /*  47665 */   // GIR_Coverage, 2925,
     /*  47665 */   GIR_Done,
     /*  47666 */ // Label 1120: @47666
     /*  47666 */ GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(47692), // Rule ID 4597 //
     /*  47671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47685 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /*  47690 */   GIR_RootConstrainSelectedInstOperands,
     /*  47691 */   // GIR_Coverage, 4597,
     /*  47691 */   GIR_Done,
     /*  47692 */ // Label 1121: @47692
     /*  47692 */ GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(47718), // Rule ID 4602 //
     /*  47697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47711 */   // (bitconvert:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /*  47711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /*  47716 */   GIR_RootConstrainSelectedInstOperands,
     /*  47717 */   // GIR_Coverage, 4602,
     /*  47717 */   GIR_Done,
     /*  47718 */ // Label 1122: @47718
     /*  47718 */ GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(47745), // Rule ID 19441 //
     /*  47723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  47726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  47734 */   // (bitconvert:{ *:[i32] } VK32:{ *:[v32i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK32:{ *:[v32i1] }:$src, GR32:{ *:[i32] })
     /*  47734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47739 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  47744 */   // GIR_Coverage, 19441,
     /*  47744 */   GIR_Done,
     /*  47745 */ // Label 1123: @47745
     /*  47745 */ GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(47789), // Rule ID 19875 //
     /*  47750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  47753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  47761 */   // (bitconvert:{ *:[f32] } VK32:{ *:[v32i1] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } (KMOVDrk:{ *:[i32] } VK32:{ *:[v32i1] }:$src))
     /*  47761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVDrk),
     /*  47768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47773 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /*  47782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47787 */   GIR_RootConstrainSelectedInstOperands,
     /*  47788 */   // GIR_Coverage, 19875,
     /*  47788 */   GIR_EraseRootFromParent_Done,
     /*  47789 */ // Label 1124: @47789
     /*  47789 */ GIM_Reject,
     /*  47790 */ // Label 1098: @47790
     /*  47790 */ GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(47856), // Rule ID 22527 //
     /*  47795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  47801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  47805 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47813 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47816 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47820 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  47827 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47831 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47833 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47840 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (MOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  47840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDrm_alt),
     /*  47843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47845 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47849 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47854 */   GIR_RootConstrainSelectedInstOperands,
     /*  47855 */   // GIR_Coverage, 22527,
     /*  47855 */   GIR_EraseRootFromParent_Done,
     /*  47856 */ // Label 1125: @47856
     /*  47856 */ GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(47922), // Rule ID 22528 //
     /*  47861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  47867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  47871 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47879 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47882 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47886 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  47893 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47897 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47899 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47906 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (VMOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  47906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDrm_alt),
     /*  47909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47911 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47920 */   GIR_RootConstrainSelectedInstOperands,
     /*  47921 */   // GIR_Coverage, 22528,
     /*  47921 */   GIR_EraseRootFromParent_Done,
     /*  47922 */ // Label 1126: @47922
     /*  47922 */ GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(47988), // Rule ID 22529 //
     /*  47927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  47933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  47937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47945 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47948 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47952 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  47959 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47963 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47965 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47972 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (VMOVSDZrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  47972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZrm_alt),
     /*  47975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47977 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47981 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47986 */   GIR_RootConstrainSelectedInstOperands,
     /*  47987 */   // GIR_Coverage, 22529,
     /*  47987 */   GIR_EraseRootFromParent_Done,
     /*  47988 */ // Label 1127: @47988
     /*  47988 */ GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(48014), // Rule ID 2909 //
     /*  47993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  47999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48007 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDrr),
     /*  48012 */   GIR_RootConstrainSelectedInstOperands,
     /*  48013 */   // GIR_Coverage, 2909,
     /*  48013 */   GIR_Done,
     /*  48014 */ // Label 1128: @48014
     /*  48014 */ GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(48040), // Rule ID 2913 //
     /*  48019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48033 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (MOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOV64toSDrr),
     /*  48038 */   GIR_RootConstrainSelectedInstOperands,
     /*  48039 */   // GIR_Coverage, 2913,
     /*  48039 */   GIR_Done,
     /*  48040 */ // Label 1129: @48040
     /*  48040 */ GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(48066), // Rule ID 2922 //
     /*  48045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48059 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VMOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  48059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64rr),
     /*  48064 */   GIR_RootConstrainSelectedInstOperands,
     /*  48065 */   // GIR_Coverage, 2922,
     /*  48065 */   GIR_Done,
     /*  48066 */ // Label 1130: @48066
     /*  48066 */ GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(48092), // Rule ID 2923 //
     /*  48071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48085 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (MOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  48085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSDto64rr),
     /*  48090 */   GIR_RootConstrainSelectedInstOperands,
     /*  48091 */   // GIR_Coverage, 2923,
     /*  48091 */   GIR_Done,
     /*  48092 */ // Label 1131: @48092
     /*  48092 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(48118), // Rule ID 4595 //
     /*  48097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48111 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /*  48116 */   GIR_RootConstrainSelectedInstOperands,
     /*  48117 */   // GIR_Coverage, 4595,
     /*  48117 */   GIR_Done,
     /*  48118 */ // Label 1132: @48118
     /*  48118 */ GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(48144), // Rule ID 4596 //
     /*  48123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48137 */   // (bitconvert:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /*  48137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /*  48142 */   GIR_RootConstrainSelectedInstOperands,
     /*  48143 */   // GIR_Coverage, 4596,
     /*  48143 */   GIR_Done,
     /*  48144 */ // Label 1133: @48144
     /*  48144 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(48171), // Rule ID 19443 //
     /*  48149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  48152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48160 */   // (bitconvert:{ *:[i64] } VK64:{ *:[v64i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i64] } VK64:{ *:[v64i1] }:$src, GR64:{ *:[i32] })
     /*  48160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  48170 */   // GIR_Coverage, 19443,
     /*  48170 */   GIR_Done,
     /*  48171 */ // Label 1134: @48171
     /*  48171 */ GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(48215), // Rule ID 19877 //
     /*  48176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  48179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48187 */   // (bitconvert:{ *:[f64] } VK64:{ *:[v64i1] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } (KMOVQrk:{ *:[i64] } VK64:{ *:[v64i1] }:$src))
     /*  48187 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  48190 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVQrk),
     /*  48194 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48199 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /*  48208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48213 */   GIR_RootConstrainSelectedInstOperands,
     /*  48214 */   // GIR_Coverage, 19877,
     /*  48214 */   GIR_EraseRootFromParent_Done,
     /*  48215 */ // Label 1135: @48215
     /*  48215 */ GIM_Reject,
     /*  48216 */ // Label 1099: @48216
     /*  48216 */ GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(48376),
     /*  48221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  48224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  48228 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(48301), // Rule ID 19447 //
     /*  48233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48244 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48247 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48251 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48264 */     // (bitconvert:{ *:[v8i1] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), VK8:{ *:[i32] })
     /*  48264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  48271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48276 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  48280 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  48300 */     // GIR_Coverage, 19447,
     /*  48300 */     GIR_EraseRootFromParent_Done,
     /*  48301 */   // Label 1137: @48301
     /*  48301 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(48375), // Rule ID 19432 //
     /*  48306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  48310 */     // (bitconvert:{ *:[v8i1] } GR8:{ *:[i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src, sub_8bit:{ *:[i32] }), VK8:{ *:[i32] })
     /*  48310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  48317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  48331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48336 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48339 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48343 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  48346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  48351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  48356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  48361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  48374 */     // GIR_Coverage, 19432,
     /*  48374 */     GIR_EraseRootFromParent_Done,
     /*  48375 */   // Label 1138: @48375
     /*  48375 */   GIM_Reject,
     /*  48376 */ // Label 1136: @48376
     /*  48376 */ GIM_Reject,
     /*  48377 */ // Label 1100: @48377
     /*  48377 */ GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(48516),
     /*  48382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  48385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  48389 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(48441), // Rule ID 19448 //
     /*  48394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48405 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48408 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48412 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  48416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48425 */     // (bitconvert:{ *:[v16i1] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (KMOVWkm:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  48425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm),
     /*  48428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48430 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48439 */     GIR_RootConstrainSelectedInstOperands,
     /*  48440 */     // GIR_Coverage, 19448,
     /*  48440 */     GIR_EraseRootFromParent_Done,
     /*  48441 */   // Label 1140: @48441
     /*  48441 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(48515), // Rule ID 19429 //
     /*  48446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  48450 */     // (bitconvert:{ *:[v16i1] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), VK16:{ *:[i32] })
     /*  48450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48453 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  48457 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  48471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48476 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48479 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48483 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/4,
     /*  48486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  48491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  48496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  48501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  48514 */     // GIR_Coverage, 19429,
     /*  48514 */     GIR_EraseRootFromParent_Done,
     /*  48515 */   // Label 1141: @48515
     /*  48515 */   GIM_Reject,
     /*  48516 */ // Label 1139: @48516
     /*  48516 */ GIM_Reject,
     /*  48517 */ // Label 1101: @48517
     /*  48517 */ GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(48587),
     /*  48522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  48529 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(48549), // Rule ID 19440 //
     /*  48534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48538 */     // (bitconvert:{ *:[v32i1] } GR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } GR32:{ *:[i32] }:$src, VK32:{ *:[i32] })
     /*  48538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /*  48548 */     // GIR_Coverage, 19440,
     /*  48548 */     GIR_Done,
     /*  48549 */   // Label 1143: @48549
     /*  48549 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(48586), // Rule ID 19874 //
     /*  48554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  48558 */     // (bitconvert:{ *:[v32i1] } FR32X:{ *:[f32] }:$src)  =>  (KMOVDkr:{ *:[v32i1] } (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src))
     /*  48558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /*  48565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkr),
     /*  48579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48584 */     GIR_RootConstrainSelectedInstOperands,
     /*  48585 */     // GIR_Coverage, 19874,
     /*  48585 */     GIR_EraseRootFromParent_Done,
     /*  48586 */   // Label 1144: @48586
     /*  48586 */   GIM_Reject,
     /*  48587 */ // Label 1142: @48587
     /*  48587 */ GIM_Reject,
     /*  48588 */ // Label 1102: @48588
     /*  48588 */ GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(48658),
     /*  48593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48600 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(48620), // Rule ID 19442 //
     /*  48605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48609 */     // (bitconvert:{ *:[v64i1] } GR64:{ *:[i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v64i1] } GR64:{ *:[i64] }:$src, VK64:{ *:[i32] })
     /*  48609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK64RegClassID),
     /*  48619 */     // GIR_Coverage, 19442,
     /*  48619 */     GIR_Done,
     /*  48620 */   // Label 1146: @48620
     /*  48620 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(48657), // Rule ID 19876 //
     /*  48625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48629 */     // (bitconvert:{ *:[v64i1] } FR64X:{ *:[f64] }:$src)  =>  (KMOVQkr:{ *:[v64i1] } (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src))
     /*  48629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  48632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /*  48636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48641 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkr),
     /*  48650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48655 */     GIR_RootConstrainSelectedInstOperands,
     /*  48656 */     // GIR_Coverage, 19876,
     /*  48656 */     GIR_EraseRootFromParent_Done,
     /*  48657 */   // Label 1147: @48657
     /*  48657 */   GIM_Reject,
     /*  48658 */ // Label 1145: @48658
     /*  48658 */ GIM_Reject,
     /*  48659 */ // Label 1103: @48659
     /*  48659 */ GIM_Reject,
     /*  48660 */ // Label 8: @48660
     /*  48660 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1160*/ GIMT_Encode4(51837),
     /*  48671 */ /*GILLT_s16*//*Label 1148*/ GIMT_Encode4(48755),
     /*  48675 */ /*GILLT_s32*//*Label 1149*/ GIMT_Encode4(48816),
     /*  48679 */ /*GILLT_s64*//*Label 1150*/ GIMT_Encode4(49440), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48695 */ /*GILLT_v2s64*//*Label 1151*/ GIMT_Encode4(50064), GIMT_Encode4(0),
     /*  48703 */ /*GILLT_v4s32*//*Label 1152*/ GIMT_Encode4(50153),
     /*  48707 */ /*GILLT_v4s64*//*Label 1153*/ GIMT_Encode4(50599), GIMT_Encode4(0),
     /*  48715 */ /*GILLT_v8s16*//*Label 1154*/ GIMT_Encode4(50778),
     /*  48719 */ /*GILLT_v8s32*//*Label 1155*/ GIMT_Encode4(50867),
     /*  48723 */ /*GILLT_v8s64*//*Label 1156*/ GIMT_Encode4(51218), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48735 */ /*GILLT_v16s16*//*Label 1157*/ GIMT_Encode4(51486),
     /*  48739 */ /*GILLT_v16s32*//*Label 1158*/ GIMT_Encode4(51575), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48751 */ /*GILLT_v32s16*//*Label 1159*/ GIMT_Encode4(51748),
     /*  48755 */ // Label 1148: @48755
     /*  48755 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(48815), // Rule ID 22168 //
     /*  48760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  48763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  48766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  48770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  48774 */   // (lrint:{ *:[i16] } FR16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src), sub_16bit:{ *:[i32] })
     /*  48774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /*  48781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48786 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48797 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  48804 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  48809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  48814 */   // GIR_Coverage, 22168,
     /*  48814 */   GIR_EraseRootFromParent_Done,
     /*  48815 */ // Label 1161: @48815
     /*  48815 */ GIM_Reject,
     /*  48816 */ // Label 1149: @48816
     /*  48816 */ GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(48875), // Rule ID 1755 //
     /*  48821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48831 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48835 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48839 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48842 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48846 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48852 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48859 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  48859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrm),
     /*  48862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48864 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48868 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48873 */   GIR_RootConstrainSelectedInstOperands,
     /*  48874 */   // GIR_Coverage, 1755,
     /*  48874 */   GIR_EraseRootFromParent_Done,
     /*  48875 */ // Label 1162: @48875
     /*  48875 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(48934), // Rule ID 1759 //
     /*  48880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48898 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48901 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48905 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48909 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48911 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48918 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  48918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrm),
     /*  48921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48923 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48927 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48932 */   GIR_RootConstrainSelectedInstOperands,
     /*  48933 */   // GIR_Coverage, 1759,
     /*  48933 */   GIR_EraseRootFromParent_Done,
     /*  48934 */ // Label 1163: @48934
     /*  48934 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(48993), // Rule ID 1779 //
     /*  48939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  48942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48949 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48953 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48957 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48960 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48964 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48970 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48977 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  48977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrm),
     /*  48980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48982 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48991 */   GIR_RootConstrainSelectedInstOperands,
     /*  48992 */   // GIR_Coverage, 1779,
     /*  48992 */   GIR_EraseRootFromParent_Done,
     /*  48993 */ // Label 1164: @48993
     /*  48993 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(49052), // Rule ID 1783 //
     /*  48998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49008 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49012 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49016 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49019 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49023 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49029 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49036 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrm),
     /*  49039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49041 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49045 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49050 */   GIR_RootConstrainSelectedInstOperands,
     /*  49051 */   // GIR_Coverage, 1783,
     /*  49051 */   GIR_EraseRootFromParent_Done,
     /*  49052 */ // Label 1165: @49052
     /*  49052 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(49111), // Rule ID 10352 //
     /*  49057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49067 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49075 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49078 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49082 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49086 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49088 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49095 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrm),
     /*  49098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49100 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49104 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49109 */   GIR_RootConstrainSelectedInstOperands,
     /*  49110 */   // GIR_Coverage, 10352,
     /*  49110 */   GIR_EraseRootFromParent_Done,
     /*  49111 */ // Label 1166: @49111
     /*  49111 */ GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(49170), // Rule ID 10356 //
     /*  49116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49126 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49130 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49134 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49137 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49141 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49145 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49147 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49154 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrm),
     /*  49157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49159 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49163 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49168 */   GIR_RootConstrainSelectedInstOperands,
     /*  49169 */   // GIR_Coverage, 10356,
     /*  49169 */   GIR_EraseRootFromParent_Done,
     /*  49170 */ // Label 1167: @49170
     /*  49170 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(49229), // Rule ID 22170 //
     /*  49175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  49178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49185 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49193 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49196 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49200 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49204 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49206 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49213 */   // (lrint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrm),
     /*  49216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49218 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49227 */   GIR_RootConstrainSelectedInstOperands,
     /*  49228 */   // GIR_Coverage, 22170,
     /*  49228 */   GIR_EraseRootFromParent_Done,
     /*  49229 */ // Label 1168: @49229
     /*  49229 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(49259), // Rule ID 1754 //
     /*  49234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49248 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  49248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrr),
     /*  49253 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49257 */   GIR_RootConstrainSelectedInstOperands,
     /*  49258 */   // GIR_Coverage, 1754,
     /*  49258 */   GIR_Done,
     /*  49259 */ // Label 1169: @49259
     /*  49259 */ GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(49289), // Rule ID 1758 //
     /*  49264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49278 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /*  49278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrr),
     /*  49283 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49287 */   GIR_RootConstrainSelectedInstOperands,
     /*  49288 */   // GIR_Coverage, 1758,
     /*  49288 */   GIR_Done,
     /*  49289 */ // Label 1170: @49289
     /*  49289 */ GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(49319), // Rule ID 1778 //
     /*  49294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49308 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  49308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrr),
     /*  49313 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49317 */   GIR_RootConstrainSelectedInstOperands,
     /*  49318 */   // GIR_Coverage, 1778,
     /*  49318 */   GIR_Done,
     /*  49319 */ // Label 1171: @49319
     /*  49319 */ GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(49349), // Rule ID 1782 //
     /*  49324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49338 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /*  49338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrr),
     /*  49343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49347 */   GIR_RootConstrainSelectedInstOperands,
     /*  49348 */   // GIR_Coverage, 1782,
     /*  49348 */   GIR_Done,
     /*  49349 */ // Label 1172: @49349
     /*  49349 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(49379), // Rule ID 10351 //
     /*  49354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  49368 */   // (lrint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /*  49368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrr),
     /*  49373 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49377 */   GIR_RootConstrainSelectedInstOperands,
     /*  49378 */   // GIR_Coverage, 10351,
     /*  49378 */   GIR_Done,
     /*  49379 */ // Label 1173: @49379
     /*  49379 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(49409), // Rule ID 10355 //
     /*  49384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  49398 */   // (lrint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /*  49398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrr),
     /*  49403 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49407 */   GIR_RootConstrainSelectedInstOperands,
     /*  49408 */   // GIR_Coverage, 10355,
     /*  49408 */   GIR_Done,
     /*  49409 */ // Label 1174: @49409
     /*  49409 */ GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(49439), // Rule ID 22169 //
     /*  49414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  49417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  49428 */   // (lrint:{ *:[i32] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src)
     /*  49428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /*  49433 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49437 */   GIR_RootConstrainSelectedInstOperands,
     /*  49438 */   // GIR_Coverage, 22169,
     /*  49438 */   GIR_Done,
     /*  49439 */ // Label 1175: @49439
     /*  49439 */ GIM_Reject,
     /*  49440 */ // Label 1150: @49440
     /*  49440 */ GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(49499), // Rule ID 17989 //
     /*  49445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49455 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49459 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49463 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49466 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49470 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49474 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49476 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49483 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rm),
     /*  49486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49488 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49497 */   GIR_RootConstrainSelectedInstOperands,
     /*  49498 */   // GIR_Coverage, 17989,
     /*  49498 */   GIR_EraseRootFromParent_Done,
     /*  49499 */ // Label 1176: @49499
     /*  49499 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(49558), // Rule ID 17991 //
     /*  49504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49514 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49518 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49522 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49525 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49529 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49533 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49535 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49542 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rm),
     /*  49545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49547 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49551 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49556 */   GIR_RootConstrainSelectedInstOperands,
     /*  49557 */   // GIR_Coverage, 17991,
     /*  49557 */   GIR_EraseRootFromParent_Done,
     /*  49558 */ // Label 1177: @49558
     /*  49558 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(49617), // Rule ID 17993 //
     /*  49563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49581 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49584 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49588 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49592 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49594 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49601 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rm),
     /*  49604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49606 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49610 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49615 */   GIR_RootConstrainSelectedInstOperands,
     /*  49616 */   // GIR_Coverage, 17993,
     /*  49616 */   GIR_EraseRootFromParent_Done,
     /*  49617 */ // Label 1178: @49617
     /*  49617 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(49676), // Rule ID 17995 //
     /*  49622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49632 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49636 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49640 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49643 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49647 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49651 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49653 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49660 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rm),
     /*  49663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49665 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49669 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49674 */   GIR_RootConstrainSelectedInstOperands,
     /*  49675 */   // GIR_Coverage, 17995,
     /*  49675 */   GIR_EraseRootFromParent_Done,
     /*  49676 */ // Label 1179: @49676
     /*  49676 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(49735), // Rule ID 21159 //
     /*  49681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49691 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49699 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49702 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49706 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49710 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49712 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49719 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrm),
     /*  49722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49724 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49728 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49733 */   GIR_RootConstrainSelectedInstOperands,
     /*  49734 */   // GIR_Coverage, 21159,
     /*  49734 */   GIR_EraseRootFromParent_Done,
     /*  49735 */ // Label 1180: @49735
     /*  49735 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(49794), // Rule ID 21161 //
     /*  49740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49758 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49761 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49765 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49769 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49771 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49778 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrm),
     /*  49781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49783 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49787 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49792 */   GIR_RootConstrainSelectedInstOperands,
     /*  49793 */   // GIR_Coverage, 21161,
     /*  49793 */   GIR_EraseRootFromParent_Done,
     /*  49794 */ // Label 1181: @49794
     /*  49794 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(49853), // Rule ID 22172 //
     /*  49799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  49802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49809 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49817 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49820 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49824 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49828 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49830 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49837 */   // (lrint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /*  49840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49842 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49851 */   GIR_RootConstrainSelectedInstOperands,
     /*  49852 */   // GIR_Coverage, 22172,
     /*  49852 */   GIR_EraseRootFromParent_Done,
     /*  49853 */ // Label 1182: @49853
     /*  49853 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(49883), // Rule ID 17988 //
     /*  49858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49872 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  49872 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /*  49877 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49881 */   GIR_RootConstrainSelectedInstOperands,
     /*  49882 */   // GIR_Coverage, 17988,
     /*  49882 */   GIR_Done,
     /*  49883 */ // Label 1183: @49883
     /*  49883 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(49913), // Rule ID 17990 //
     /*  49888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49902 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  49902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /*  49907 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49911 */   GIR_RootConstrainSelectedInstOperands,
     /*  49912 */   // GIR_Coverage, 17990,
     /*  49912 */   GIR_Done,
     /*  49913 */ // Label 1184: @49913
     /*  49913 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(49943), // Rule ID 17992 //
     /*  49918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49932 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  49932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /*  49937 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49941 */   GIR_RootConstrainSelectedInstOperands,
     /*  49942 */   // GIR_Coverage, 17992,
     /*  49942 */   GIR_Done,
     /*  49943 */ // Label 1185: @49943
     /*  49943 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(49973), // Rule ID 17994 //
     /*  49948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49962 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  49962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /*  49967 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49971 */   GIR_RootConstrainSelectedInstOperands,
     /*  49972 */   // GIR_Coverage, 17994,
     /*  49972 */   GIR_Done,
     /*  49973 */ // Label 1186: @49973
     /*  49973 */ GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(50003), // Rule ID 21158 //
     /*  49978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49992 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  49992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /*  49997 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50001 */   GIR_RootConstrainSelectedInstOperands,
     /*  50002 */   // GIR_Coverage, 21158,
     /*  50002 */   GIR_Done,
     /*  50003 */ // Label 1187: @50003
     /*  50003 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(50033), // Rule ID 21160 //
     /*  50008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  50011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  50022 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  50022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /*  50027 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50031 */   GIR_RootConstrainSelectedInstOperands,
     /*  50032 */   // GIR_Coverage, 21160,
     /*  50032 */   GIR_Done,
     /*  50033 */ // Label 1188: @50033
     /*  50033 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(50063), // Rule ID 22171 //
     /*  50038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  50041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  50044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  50052 */   // (lrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /*  50052 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /*  50057 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50061 */   GIR_RootConstrainSelectedInstOperands,
     /*  50062 */   // GIR_Coverage, 22171,
     /*  50062 */   GIR_Done,
     /*  50063 */ // Label 1189: @50063
     /*  50063 */ GIM_Reject,
     /*  50064 */ // Label 1151: @50064
     /*  50064 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(50152),
     /*  50069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  50072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50076 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(50128), // Rule ID 21384 //
     /*  50081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50092 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50095 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50099 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50112 */     // (lrint:{ *:[v2i64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  50112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rm),
     /*  50115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50117 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50126 */     GIR_RootConstrainSelectedInstOperands,
     /*  50127 */     // GIR_Coverage, 21384,
     /*  50127 */     GIR_EraseRootFromParent_Done,
     /*  50128 */   // Label 1191: @50128
     /*  50128 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(50151), // Rule ID 21383 //
     /*  50133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50140 */     // (lrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /*  50140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /*  50145 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50149 */     GIR_RootConstrainSelectedInstOperands,
     /*  50150 */     // GIR_Coverage, 21383,
     /*  50150 */     GIR_Done,
     /*  50151 */   // Label 1192: @50151
     /*  50151 */   GIM_Reject,
     /*  50152 */ // Label 1190: @50152
     /*  50152 */ GIM_Reject,
     /*  50153 */ // Label 1152: @50153
     /*  50153 */ GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(50212), // Rule ID 18043 //
     /*  50158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50168 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50172 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50176 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50179 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50183 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50187 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50189 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50196 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrm),
     /*  50199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50201 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50210 */   GIR_RootConstrainSelectedInstOperands,
     /*  50211 */   // GIR_Coverage, 18043,
     /*  50211 */   GIR_EraseRootFromParent_Done,
     /*  50212 */ // Label 1193: @50212
     /*  50212 */ GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(50271), // Rule ID 18047 //
     /*  50217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50227 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50235 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50242 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50246 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50248 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50255 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQYrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrm),
     /*  50258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50260 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50264 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50269 */   GIR_RootConstrainSelectedInstOperands,
     /*  50270 */   // GIR_Coverage, 18047,
     /*  50270 */   GIR_EraseRootFromParent_Done,
     /*  50271 */ // Label 1194: @50271
     /*  50271 */ GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(50330), // Rule ID 18049 //
     /*  50276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50286 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50290 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50294 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50297 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50301 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50305 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50307 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50314 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTPS2DQrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrm),
     /*  50317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50319 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50323 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50328 */   GIR_RootConstrainSelectedInstOperands,
     /*  50329 */   // GIR_Coverage, 18049,
     /*  50329 */   GIR_EraseRootFromParent_Done,
     /*  50330 */ // Label 1195: @50330
     /*  50330 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(50389), // Rule ID 21356 //
     /*  50335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50345 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50349 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50353 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50356 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50360 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50364 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50366 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50373 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rm),
     /*  50376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50378 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50382 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50387 */   GIR_RootConstrainSelectedInstOperands,
     /*  50388 */   // GIR_Coverage, 21356,
     /*  50388 */   GIR_EraseRootFromParent_Done,
     /*  50389 */ // Label 1196: @50389
     /*  50389 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(50448), // Rule ID 21360 //
     /*  50394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50404 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50408 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50412 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50415 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50419 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50423 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50425 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50432 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQZ256rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rm),
     /*  50435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50437 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50446 */   GIR_RootConstrainSelectedInstOperands,
     /*  50447 */   // GIR_Coverage, 21360,
     /*  50447 */   GIR_EraseRootFromParent_Done,
     /*  50448 */ // Label 1197: @50448
     /*  50448 */ GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(50478), // Rule ID 18042 //
     /*  50453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50467 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /*  50467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrr),
     /*  50472 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50476 */   GIR_RootConstrainSelectedInstOperands,
     /*  50477 */   // GIR_Coverage, 18042,
     /*  50477 */   GIR_Done,
     /*  50478 */ // Label 1198: @50478
     /*  50478 */ GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(50508), // Rule ID 18046 //
     /*  50483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  50497 */   // (lrint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /*  50497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrr),
     /*  50502 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50506 */   GIR_RootConstrainSelectedInstOperands,
     /*  50507 */   // GIR_Coverage, 18046,
     /*  50507 */   GIR_Done,
     /*  50508 */ // Label 1199: @50508
     /*  50508 */ GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(50538), // Rule ID 18048 //
     /*  50513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50527 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (CVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /*  50527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrr),
     /*  50532 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50536 */   GIR_RootConstrainSelectedInstOperands,
     /*  50537 */   // GIR_Coverage, 18048,
     /*  50537 */   GIR_Done,
     /*  50538 */ // Label 1200: @50538
     /*  50538 */ GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(50568), // Rule ID 21355 //
     /*  50543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50557 */   // (lrint:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQZ128rr:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)
     /*  50557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rr),
     /*  50562 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50566 */   GIR_RootConstrainSelectedInstOperands,
     /*  50567 */   // GIR_Coverage, 21355,
     /*  50567 */   GIR_Done,
     /*  50568 */ // Label 1201: @50568
     /*  50568 */ GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(50598), // Rule ID 21359 //
     /*  50573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50587 */   // (lrint:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQZ256rr:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)
     /*  50587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rr),
     /*  50592 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50596 */   GIR_RootConstrainSelectedInstOperands,
     /*  50597 */   // GIR_Coverage, 21359,
     /*  50597 */   GIR_Done,
     /*  50598 */ // Label 1202: @50598
     /*  50598 */ GIM_Reject,
     /*  50599 */ // Label 1153: @50599
     /*  50599 */ GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(50658), // Rule ID 21380 //
     /*  50604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50614 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50618 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50622 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50625 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50629 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50635 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50642 */   // (lrint:{ *:[v4i64] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  50642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rm),
     /*  50645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50647 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50656 */   GIR_RootConstrainSelectedInstOperands,
     /*  50657 */   // GIR_Coverage, 21380,
     /*  50657 */   GIR_EraseRootFromParent_Done,
     /*  50658 */ // Label 1203: @50658
     /*  50658 */ GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(50717), // Rule ID 21386 //
     /*  50663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50673 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50681 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50684 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50688 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50692 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50694 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50701 */   // (lrint:{ *:[v4i64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  50701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rm),
     /*  50704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50706 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50710 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50715 */   GIR_RootConstrainSelectedInstOperands,
     /*  50716 */   // GIR_Coverage, 21386,
     /*  50716 */   GIR_EraseRootFromParent_Done,
     /*  50717 */ // Label 1204: @50717
     /*  50717 */ GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(50747), // Rule ID 21379 //
     /*  50722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50736 */   // (lrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /*  50736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /*  50741 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50745 */   GIR_RootConstrainSelectedInstOperands,
     /*  50746 */   // GIR_Coverage, 21379,
     /*  50746 */   GIR_Done,
     /*  50747 */ // Label 1205: @50747
     /*  50747 */ GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(50777), // Rule ID 21385 //
     /*  50752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50766 */   // (lrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /*  50766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /*  50771 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50775 */   GIR_RootConstrainSelectedInstOperands,
     /*  50776 */   // GIR_Coverage, 21385,
     /*  50776 */   GIR_Done,
     /*  50777 */ // Label 1206: @50777
     /*  50777 */ GIM_Reject,
     /*  50778 */ // Label 1154: @50778
     /*  50778 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(50866),
     /*  50783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50790 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(50842), // Rule ID 22155 //
     /*  50795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  50798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50806 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50809 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50813 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50826 */     // (lrint:{ *:[v8i16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  50826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rm),
     /*  50829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50840 */     GIR_RootConstrainSelectedInstOperands,
     /*  50841 */     // GIR_Coverage, 22155,
     /*  50841 */     GIR_EraseRootFromParent_Done,
     /*  50842 */   // Label 1208: @50842
     /*  50842 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(50865), // Rule ID 22154 //
     /*  50847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  50850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50854 */     // (lrint:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2WZ128rr:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)
     /*  50854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rr),
     /*  50859 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50863 */     GIR_RootConstrainSelectedInstOperands,
     /*  50864 */     // GIR_Coverage, 22154,
     /*  50864 */     GIR_Done,
     /*  50865 */   // Label 1209: @50865
     /*  50865 */   GIM_Reject,
     /*  50866 */ // Label 1207: @50866
     /*  50866 */ GIM_Reject,
     /*  50867 */ // Label 1155: @50867
     /*  50867 */ GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(50926), // Rule ID 18045 //
     /*  50872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  50878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  50882 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50886 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50890 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50893 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50897 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50901 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50903 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50910 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  50910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrm),
     /*  50913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50915 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50919 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50924 */   GIR_RootConstrainSelectedInstOperands,
     /*  50925 */   // GIR_Coverage, 18045,
     /*  50925 */   GIR_EraseRootFromParent_Done,
     /*  50926 */ // Label 1210: @50926
     /*  50926 */ GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(50985), // Rule ID 21358 //
     /*  50931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  50937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50941 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50945 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50949 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50952 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50956 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50960 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50962 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50969 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  50969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rm),
     /*  50972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50974 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50978 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50983 */   GIR_RootConstrainSelectedInstOperands,
     /*  50984 */   // GIR_Coverage, 21358,
     /*  50984 */   GIR_EraseRootFromParent_Done,
     /*  50985 */ // Label 1211: @50985
     /*  50985 */ GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(51041), // Rule ID 21364 //
     /*  50990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  50993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50997 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51001 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51005 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51008 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51012 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51016 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51018 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51025 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQZrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrm),
     /*  51028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51030 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51039 */   GIR_RootConstrainSelectedInstOperands,
     /*  51040 */   // GIR_Coverage, 21364,
     /*  51040 */   GIR_EraseRootFromParent_Done,
     /*  51041 */ // Label 1212: @51041
     /*  51041 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(51100), // Rule ID 22159 //
     /*  51046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51064 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51067 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51071 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51075 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51077 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51084 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2DQZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rm),
     /*  51087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51089 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51093 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51098 */   GIR_RootConstrainSelectedInstOperands,
     /*  51099 */   // GIR_Coverage, 22159,
     /*  51099 */   GIR_EraseRootFromParent_Done,
     /*  51100 */ // Label 1213: @51100
     /*  51100 */ GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(51130), // Rule ID 18044 //
     /*  51105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  51108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51119 */   // (lrint:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQYrr:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)
     /*  51119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrr),
     /*  51124 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51128 */   GIR_RootConstrainSelectedInstOperands,
     /*  51129 */   // GIR_Coverage, 18044,
     /*  51129 */   GIR_Done,
     /*  51130 */ // Label 1214: @51130
     /*  51130 */ GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(51160), // Rule ID 21357 //
     /*  51135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  51138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51149 */   // (lrint:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQZ256rr:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)
     /*  51149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rr),
     /*  51154 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51158 */   GIR_RootConstrainSelectedInstOperands,
     /*  51159 */   // GIR_Coverage, 21357,
     /*  51159 */   GIR_Done,
     /*  51160 */ // Label 1215: @51160
     /*  51160 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(51187), // Rule ID 21363 //
     /*  51165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51176 */   // (lrint:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2DQZrr:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)
     /*  51176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrr),
     /*  51181 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51185 */   GIR_RootConstrainSelectedInstOperands,
     /*  51186 */   // GIR_Coverage, 21363,
     /*  51186 */   GIR_Done,
     /*  51187 */ // Label 1216: @51187
     /*  51187 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(51217), // Rule ID 22158 //
     /*  51192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51206 */   // (lrint:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2DQZ256rr:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)
     /*  51206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rr),
     /*  51211 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51215 */   GIR_RootConstrainSelectedInstOperands,
     /*  51216 */   // GIR_Coverage, 22158,
     /*  51216 */   GIR_Done,
     /*  51217 */ // Label 1217: @51217
     /*  51217 */ GIM_Reject,
     /*  51218 */ // Label 1156: @51218
     /*  51218 */ GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(51277), // Rule ID 21392 //
     /*  51223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51233 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51241 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51244 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51248 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51252 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51254 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51261 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrm),
     /*  51264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51266 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51275 */   GIR_RootConstrainSelectedInstOperands,
     /*  51276 */   // GIR_Coverage, 21392,
     /*  51276 */   GIR_EraseRootFromParent_Done,
     /*  51277 */ // Label 1218: @51277
     /*  51277 */ GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(51336), // Rule ID 21396 //
     /*  51282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51300 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51303 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51307 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51311 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51313 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51320 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrm),
     /*  51323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51325 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51329 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51334 */   GIR_RootConstrainSelectedInstOperands,
     /*  51335 */   // GIR_Coverage, 21396,
     /*  51335 */   GIR_EraseRootFromParent_Done,
     /*  51336 */ // Label 1219: @51336
     /*  51336 */ GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(51395), // Rule ID 22165 //
     /*  51341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51351 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51359 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51362 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51366 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51370 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51372 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51379 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrm),
     /*  51382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51384 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51388 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51393 */   GIR_RootConstrainSelectedInstOperands,
     /*  51394 */   // GIR_Coverage, 22165,
     /*  51394 */   GIR_EraseRootFromParent_Done,
     /*  51395 */ // Label 1220: @51395
     /*  51395 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(51425), // Rule ID 21391 //
     /*  51400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51414 */   // (lrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /*  51414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /*  51419 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51423 */   GIR_RootConstrainSelectedInstOperands,
     /*  51424 */   // GIR_Coverage, 21391,
     /*  51424 */   GIR_Done,
     /*  51425 */ // Label 1221: @51425
     /*  51425 */ GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(51455), // Rule ID 21395 //
     /*  51430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51444 */   // (lrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /*  51444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /*  51449 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51453 */   GIR_RootConstrainSelectedInstOperands,
     /*  51454 */   // GIR_Coverage, 21395,
     /*  51454 */   GIR_Done,
     /*  51455 */ // Label 1222: @51455
     /*  51455 */ GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(51485), // Rule ID 22164 //
     /*  51460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51474 */   // (lrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /*  51474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /*  51479 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51483 */   GIR_RootConstrainSelectedInstOperands,
     /*  51484 */   // GIR_Coverage, 22164,
     /*  51484 */   GIR_Done,
     /*  51485 */ // Label 1223: @51485
     /*  51485 */ GIM_Reject,
     /*  51486 */ // Label 1157: @51486
     /*  51486 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(51574),
     /*  51491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51498 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(51550), // Rule ID 22157 //
     /*  51503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51534 */     // (lrint:{ *:[v16i16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  51534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rm),
     /*  51537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51548 */     GIR_RootConstrainSelectedInstOperands,
     /*  51549 */     // GIR_Coverage, 22157,
     /*  51549 */     GIR_EraseRootFromParent_Done,
     /*  51550 */   // Label 1225: @51550
     /*  51550 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(51573), // Rule ID 22156 //
     /*  51555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51562 */     // (lrint:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2WZ256rr:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)
     /*  51562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rr),
     /*  51567 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51571 */     GIR_RootConstrainSelectedInstOperands,
     /*  51572 */     // GIR_Coverage, 22156,
     /*  51572 */     GIR_Done,
     /*  51573 */   // Label 1226: @51573
     /*  51573 */   GIM_Reject,
     /*  51574 */ // Label 1224: @51574
     /*  51574 */ GIM_Reject,
     /*  51575 */ // Label 1158: @51575
     /*  51575 */ GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(51631), // Rule ID 21362 //
     /*  51580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  51583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51587 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51591 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51595 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51598 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51602 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51606 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51608 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51615 */   // (lrint:{ *:[v16i32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  51615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrm),
     /*  51618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51620 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51629 */   GIR_RootConstrainSelectedInstOperands,
     /*  51630 */   // GIR_Coverage, 21362,
     /*  51630 */   GIR_EraseRootFromParent_Done,
     /*  51631 */ // Label 1227: @51631
     /*  51631 */ GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(51690), // Rule ID 22163 //
     /*  51636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51646 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51650 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51654 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51657 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51661 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51665 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51667 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51674 */   // (lrint:{ *:[v16i32] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2DQZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  51674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrm),
     /*  51677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51679 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51688 */   GIR_RootConstrainSelectedInstOperands,
     /*  51689 */   // GIR_Coverage, 22163,
     /*  51689 */   GIR_EraseRootFromParent_Done,
     /*  51690 */ // Label 1228: @51690
     /*  51690 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(51717), // Rule ID 21361 //
     /*  51695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  51698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51706 */   // (lrint:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)  =>  (VCVTPS2DQZrr:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)
     /*  51706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrr),
     /*  51711 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51715 */   GIR_RootConstrainSelectedInstOperands,
     /*  51716 */   // GIR_Coverage, 21361,
     /*  51716 */   GIR_Done,
     /*  51717 */ // Label 1229: @51717
     /*  51717 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(51747), // Rule ID 22162 //
     /*  51722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51736 */   // (lrint:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2DQZrr:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)
     /*  51736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrr),
     /*  51741 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51745 */   GIR_RootConstrainSelectedInstOperands,
     /*  51746 */   // GIR_Coverage, 22162,
     /*  51746 */   GIR_Done,
     /*  51747 */ // Label 1230: @51747
     /*  51747 */ GIM_Reject,
     /*  51748 */ // Label 1159: @51748
     /*  51748 */ GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(51836),
     /*  51753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  51756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51760 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(51812), // Rule ID 22161 //
     /*  51765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51776 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51796 */     // (lrint:{ *:[v32i16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  51796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrm),
     /*  51799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51801 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51810 */     GIR_RootConstrainSelectedInstOperands,
     /*  51811 */     // GIR_Coverage, 22161,
     /*  51811 */     GIR_EraseRootFromParent_Done,
     /*  51812 */   // Label 1232: @51812
     /*  51812 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(51835), // Rule ID 22160 //
     /*  51817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51824 */     // (lrint:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)  =>  (VCVTPH2WZrr:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)
     /*  51824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrr),
     /*  51829 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51833 */     GIR_RootConstrainSelectedInstOperands,
     /*  51834 */     // GIR_Coverage, 22160,
     /*  51834 */     GIR_Done,
     /*  51835 */   // Label 1233: @51835
     /*  51835 */   GIM_Reject,
     /*  51836 */ // Label 1231: @51836
     /*  51836 */ GIM_Reject,
     /*  51837 */ // Label 1160: @51837
     /*  51837 */ GIM_Reject,
     /*  51838 */ // Label 9: @51838
     /*  51838 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 1238*/ GIMT_Encode4(53057),
     /*  51849 */ /*GILLT_s64*//*Label 1234*/ GIMT_Encode4(51897), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  51865 */ /*GILLT_v2s64*//*Label 1235*/ GIMT_Encode4(52521), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  51877 */ /*GILLT_v4s64*//*Label 1236*/ GIMT_Encode4(52610), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  51893 */ /*GILLT_v8s64*//*Label 1237*/ GIMT_Encode4(52789),
     /*  51897 */ // Label 1234: @51897
     /*  51897 */ GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(51956), // Rule ID 1757 //
     /*  51902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  51905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  51908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  51912 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51916 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51920 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51923 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51927 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51933 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51940 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  51940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rm),
     /*  51943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51945 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51954 */   GIR_RootConstrainSelectedInstOperands,
     /*  51955 */   // GIR_Coverage, 1757,
     /*  51955 */   GIR_EraseRootFromParent_Done,
     /*  51956 */ // Label 1239: @51956
     /*  51956 */ GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(52015), // Rule ID 1761 //
     /*  51961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  51964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  51967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  51971 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51975 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51979 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51982 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51986 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51990 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51992 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51999 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  51999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rm),
     /*  52002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52004 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52008 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52013 */   GIR_RootConstrainSelectedInstOperands,
     /*  52014 */   // GIR_Coverage, 1761,
     /*  52014 */   GIR_EraseRootFromParent_Done,
     /*  52015 */ // Label 1240: @52015
     /*  52015 */ GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(52074), // Rule ID 1781 //
     /*  52020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  52023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52038 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52041 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52045 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52049 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52051 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52058 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rm),
     /*  52061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52063 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52067 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52072 */   GIR_RootConstrainSelectedInstOperands,
     /*  52073 */   // GIR_Coverage, 1781,
     /*  52073 */   GIR_EraseRootFromParent_Done,
     /*  52074 */ // Label 1241: @52074
     /*  52074 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(52133), // Rule ID 1785 //
     /*  52079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  52082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52089 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52093 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52097 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52100 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52104 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52108 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52110 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52117 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rm),
     /*  52120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52122 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52126 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52131 */   GIR_RootConstrainSelectedInstOperands,
     /*  52132 */   // GIR_Coverage, 1785,
     /*  52132 */   GIR_EraseRootFromParent_Done,
     /*  52133 */ // Label 1242: @52133
     /*  52133 */ GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(52192), // Rule ID 10354 //
     /*  52138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52156 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52159 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52163 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52167 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52169 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52176 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrm),
     /*  52179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52181 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52185 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52190 */   GIR_RootConstrainSelectedInstOperands,
     /*  52191 */   // GIR_Coverage, 10354,
     /*  52191 */   GIR_EraseRootFromParent_Done,
     /*  52192 */ // Label 1243: @52192
     /*  52192 */ GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(52251), // Rule ID 10358 //
     /*  52197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52207 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52211 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52215 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52218 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52222 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52226 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52228 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52235 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrm),
     /*  52238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52240 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52244 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52249 */   GIR_RootConstrainSelectedInstOperands,
     /*  52250 */   // GIR_Coverage, 10358,
     /*  52250 */   GIR_EraseRootFromParent_Done,
     /*  52251 */ // Label 1244: @52251
     /*  52251 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(52310), // Rule ID 22174 //
     /*  52256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  52259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  52262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52266 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52270 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52274 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52277 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52281 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52287 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52294 */   // (llrint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /*  52297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52299 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52303 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52308 */   GIR_RootConstrainSelectedInstOperands,
     /*  52309 */   // GIR_Coverage, 22174,
     /*  52309 */   GIR_EraseRootFromParent_Done,
     /*  52310 */ // Label 1245: @52310
     /*  52310 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(52340), // Rule ID 1756 //
     /*  52315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  52329 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  52329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /*  52334 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52338 */   GIR_RootConstrainSelectedInstOperands,
     /*  52339 */   // GIR_Coverage, 1756,
     /*  52339 */   GIR_Done,
     /*  52340 */ // Label 1246: @52340
     /*  52340 */ GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(52370), // Rule ID 1760 //
     /*  52345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  52359 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  52359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /*  52364 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52368 */   GIR_RootConstrainSelectedInstOperands,
     /*  52369 */   // GIR_Coverage, 1760,
     /*  52369 */   GIR_Done,
     /*  52370 */ // Label 1247: @52370
     /*  52370 */ GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(52400), // Rule ID 1780 //
     /*  52375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  52378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  52389 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  52389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /*  52394 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52398 */   GIR_RootConstrainSelectedInstOperands,
     /*  52399 */   // GIR_Coverage, 1780,
     /*  52399 */   GIR_Done,
     /*  52400 */ // Label 1248: @52400
     /*  52400 */ GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(52430), // Rule ID 1784 //
     /*  52405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  52408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  52419 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  52419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /*  52424 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52428 */   GIR_RootConstrainSelectedInstOperands,
     /*  52429 */   // GIR_Coverage, 1784,
     /*  52429 */   GIR_Done,
     /*  52430 */ // Label 1249: @52430
     /*  52430 */ GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(52460), // Rule ID 10353 //
     /*  52435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  52449 */   // (llrint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /*  52449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /*  52454 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52458 */   GIR_RootConstrainSelectedInstOperands,
     /*  52459 */   // GIR_Coverage, 10353,
     /*  52459 */   GIR_Done,
     /*  52460 */ // Label 1250: @52460
     /*  52460 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(52490), // Rule ID 10357 //
     /*  52465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  52479 */   // (llrint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /*  52479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /*  52484 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52488 */   GIR_RootConstrainSelectedInstOperands,
     /*  52489 */   // GIR_Coverage, 10357,
     /*  52489 */   GIR_Done,
     /*  52490 */ // Label 1251: @52490
     /*  52490 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(52520), // Rule ID 22173 //
     /*  52495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  52498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  52501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  52509 */   // (llrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /*  52509 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /*  52514 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52518 */   GIR_RootConstrainSelectedInstOperands,
     /*  52519 */   // GIR_Coverage, 22173,
     /*  52519 */   GIR_Done,
     /*  52520 */ // Label 1252: @52520
     /*  52520 */ GIM_Reject,
     /*  52521 */ // Label 1235: @52521
     /*  52521 */ GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(52609),
     /*  52526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52533 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(52585), // Rule ID 21388 //
     /*  52538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52549 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52552 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52556 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52569 */     // (llrint:{ *:[v2i64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  52569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rm),
     /*  52572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52574 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52583 */     GIR_RootConstrainSelectedInstOperands,
     /*  52584 */     // GIR_Coverage, 21388,
     /*  52584 */     GIR_EraseRootFromParent_Done,
     /*  52585 */   // Label 1254: @52585
     /*  52585 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(52608), // Rule ID 21387 //
     /*  52590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52597 */     // (llrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /*  52597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /*  52602 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52606 */     GIR_RootConstrainSelectedInstOperands,
     /*  52607 */     // GIR_Coverage, 21387,
     /*  52607 */     GIR_Done,
     /*  52608 */   // Label 1255: @52608
     /*  52608 */   GIM_Reject,
     /*  52609 */ // Label 1253: @52609
     /*  52609 */ GIM_Reject,
     /*  52610 */ // Label 1236: @52610
     /*  52610 */ GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(52669), // Rule ID 21382 //
     /*  52615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52633 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52636 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52640 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52646 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52653 */   // (llrint:{ *:[v4i64] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  52653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rm),
     /*  52656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52658 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52667 */   GIR_RootConstrainSelectedInstOperands,
     /*  52668 */   // GIR_Coverage, 21382,
     /*  52668 */   GIR_EraseRootFromParent_Done,
     /*  52669 */ // Label 1256: @52669
     /*  52669 */ GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(52728), // Rule ID 21390 //
     /*  52674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  52680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52684 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52692 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52695 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52699 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52703 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52705 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52712 */   // (llrint:{ *:[v4i64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  52712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rm),
     /*  52715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52717 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52726 */   GIR_RootConstrainSelectedInstOperands,
     /*  52727 */   // GIR_Coverage, 21390,
     /*  52727 */   GIR_EraseRootFromParent_Done,
     /*  52728 */ // Label 1257: @52728
     /*  52728 */ GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(52758), // Rule ID 21381 //
     /*  52733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52747 */   // (llrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /*  52747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /*  52752 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52756 */   GIR_RootConstrainSelectedInstOperands,
     /*  52757 */   // GIR_Coverage, 21381,
     /*  52757 */   GIR_Done,
     /*  52758 */ // Label 1258: @52758
     /*  52758 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(52788), // Rule ID 21389 //
     /*  52763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  52769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52777 */   // (llrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /*  52777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /*  52782 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52786 */   GIR_RootConstrainSelectedInstOperands,
     /*  52787 */   // GIR_Coverage, 21389,
     /*  52787 */   GIR_Done,
     /*  52788 */ // Label 1259: @52788
     /*  52788 */ GIM_Reject,
     /*  52789 */ // Label 1237: @52789
     /*  52789 */ GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(52848), // Rule ID 21394 //
     /*  52794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  52797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  52800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52804 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52812 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52815 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52819 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52823 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52825 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52832 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  52832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrm),
     /*  52835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52837 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52841 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52846 */   GIR_RootConstrainSelectedInstOperands,
     /*  52847 */   // GIR_Coverage, 21394,
     /*  52847 */   GIR_EraseRootFromParent_Done,
     /*  52848 */ // Label 1260: @52848
     /*  52848 */ GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(52907), // Rule ID 21398 //
     /*  52853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  52856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  52859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52863 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52867 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52871 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52874 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52878 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52882 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52884 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52891 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  52891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrm),
     /*  52894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52896 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52905 */   GIR_RootConstrainSelectedInstOperands,
     /*  52906 */   // GIR_Coverage, 21398,
     /*  52906 */   GIR_EraseRootFromParent_Done,
     /*  52907 */ // Label 1261: @52907
     /*  52907 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(52966), // Rule ID 22167 //
     /*  52912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  52915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52930 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52933 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52937 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52941 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52943 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52950 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  52950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrm),
     /*  52953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52955 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52959 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52964 */   GIR_RootConstrainSelectedInstOperands,
     /*  52965 */   // GIR_Coverage, 22167,
     /*  52965 */   GIR_EraseRootFromParent_Done,
     /*  52966 */ // Label 1262: @52966
     /*  52966 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(52996), // Rule ID 21393 //
     /*  52971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  52974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  52977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52985 */   // (llrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /*  52985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /*  52990 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52994 */   GIR_RootConstrainSelectedInstOperands,
     /*  52995 */   // GIR_Coverage, 21393,
     /*  52995 */   GIR_Done,
     /*  52996 */ // Label 1263: @52996
     /*  52996 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(53026), // Rule ID 21397 //
     /*  53001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  53007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53015 */   // (llrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /*  53015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /*  53020 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53024 */   GIR_RootConstrainSelectedInstOperands,
     /*  53025 */   // GIR_Coverage, 21397,
     /*  53025 */   GIR_Done,
     /*  53026 */ // Label 1264: @53026
     /*  53026 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(53056), // Rule ID 22166 //
     /*  53031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  53045 */   // (llrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /*  53045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /*  53050 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53054 */   GIR_RootConstrainSelectedInstOperands,
     /*  53055 */   // GIR_Coverage, 22166,
     /*  53055 */   GIR_Done,
     /*  53056 */ // Label 1265: @53056
     /*  53056 */ GIM_Reject,
     /*  53057 */ // Label 1238: @53057
     /*  53057 */ GIM_Reject,
     /*  53058 */ // Label 10: @53058
     /*  53058 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 1291*/ GIMT_Encode4(59282),
     /*  53069 */ /*GILLT_s1*//*Label 1266*/ GIMT_Encode4(53169),
     /*  53073 */ /*GILLT_s8*//*Label 1267*/ GIMT_Encode4(53236),
     /*  53077 */ /*GILLT_s16*//*Label 1268*/ GIMT_Encode4(53377),
     /*  53081 */ /*GILLT_s32*//*Label 1269*/ GIMT_Encode4(53930),
     /*  53085 */ /*GILLT_s64*//*Label 1270*/ GIMT_Encode4(54352),
     /*  53089 */ /*GILLT_s80*//*Label 1271*/ GIMT_Encode4(54925),
     /*  53093 */ /*GILLT_s128*//*Label 1272*/ GIMT_Encode4(55084),
     /*  53097 */ /*GILLT_v2s1*//*Label 1273*/ GIMT_Encode4(55212),
     /*  53101 */ /*GILLT_v2s64*//*Label 1274*/ GIMT_Encode4(55279),
     /*  53105 */ /*GILLT_v4s1*//*Label 1275*/ GIMT_Encode4(55773),
     /*  53109 */ /*GILLT_v4s32*//*Label 1276*/ GIMT_Encode4(55840),
     /*  53113 */ /*GILLT_v4s64*//*Label 1277*/ GIMT_Encode4(56334),
     /*  53117 */ /*GILLT_v8s1*//*Label 1278*/ GIMT_Encode4(56668),
     /*  53121 */ /*GILLT_v8s16*//*Label 1279*/ GIMT_Encode4(56750),
     /*  53125 */ /*GILLT_v8s32*//*Label 1280*/ GIMT_Encode4(57324),
     /*  53129 */ /*GILLT_v8s64*//*Label 1281*/ GIMT_Encode4(57658),
     /*  53133 */ /*GILLT_v16s1*//*Label 1282*/ GIMT_Encode4(57832),
     /*  53137 */ /*GILLT_v16s8*//*Label 1283*/ GIMT_Encode4(57914),
     /*  53141 */ /*GILLT_v16s16*//*Label 1284*/ GIMT_Encode4(58168),
     /*  53145 */ /*GILLT_v16s32*//*Label 1285*/ GIMT_Encode4(58502),
     /*  53149 */ /*GILLT_v32s1*//*Label 1286*/ GIMT_Encode4(58676),
     /*  53153 */ /*GILLT_v32s8*//*Label 1287*/ GIMT_Encode4(58758),
     /*  53157 */ /*GILLT_v32s16*//*Label 1288*/ GIMT_Encode4(58932),
     /*  53161 */ /*GILLT_v64s1*//*Label 1289*/ GIMT_Encode4(59106),
     /*  53165 */ /*GILLT_v64s8*//*Label 1290*/ GIMT_Encode4(59188),
     /*  53169 */ // Label 1266: @53169
     /*  53169 */ GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(53235), // Rule ID 19444 //
     /*  53174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53177 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53180 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  53188 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53192 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53199 */   // (ld:{ *:[v1i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK1:{ *:[i32] })
     /*  53199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  53202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  53206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53211 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53215 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53229 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  53234 */   // GIR_Coverage, 19444,
     /*  53234 */   GIR_EraseRootFromParent_Done,
     /*  53235 */ // Label 1292: @53235
     /*  53235 */ GIM_Reject,
     /*  53236 */ // Label 1267: @53236
     /*  53236 */ GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(53285), // Rule ID 22514 //
     /*  53241 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53244 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53263 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53270 */   // (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53275 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53279 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53283 */   GIR_RootConstrainSelectedInstOperands,
     /*  53284 */   // GIR_Coverage, 22514,
     /*  53284 */   GIR_EraseRootFromParent_Done,
     /*  53285 */ // Label 1293: @53285
     /*  53285 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(53334), // Rule ID 22577 //
     /*  53290 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53293 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53297 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53308 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53312 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53319 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53324 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53332 */   GIR_RootConstrainSelectedInstOperands,
     /*  53333 */   // GIR_Coverage, 22577,
     /*  53333 */   GIR_EraseRootFromParent_Done,
     /*  53334 */ // Label 1294: @53334
     /*  53334 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(53376), // Rule ID 28 //
     /*  53339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53346 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53350 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  53354 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53361 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53366 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53370 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53374 */   GIR_RootConstrainSelectedInstOperands,
     /*  53375 */   // GIR_Coverage, 28,
     /*  53375 */   GIR_EraseRootFromParent_Done,
     /*  53376 */ // Label 1295: @53376
     /*  53376 */ GIM_Reject,
     /*  53377 */ // Label 1268: @53377
     /*  53377 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(53422), // Rule ID 4620 //
     /*  53382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  53396 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53400 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53407 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSHZrm_alt:{ *:[f16] } addr:{ *:[iPTR] }:$src)
     /*  53407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSHZrm_alt),
     /*  53410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53412 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53416 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53420 */   GIR_RootConstrainSelectedInstOperands,
     /*  53421 */   // GIR_Coverage, 4620,
     /*  53421 */   GIR_EraseRootFromParent_Done,
     /*  53422 */ // Label 1296: @53422
     /*  53422 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(53471), // Rule ID 22515 //
     /*  53427 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53430 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53434 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  53441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53456 */   // (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (MOV16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16rm),
     /*  53459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53461 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53465 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53469 */   GIR_RootConstrainSelectedInstOperands,
     /*  53470 */   // GIR_Coverage, 22515,
     /*  53470 */   GIR_EraseRootFromParent_Done,
     /*  53471 */ // Label 1297: @53471
     /*  53471 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(53550), // Rule ID 22578 //
     /*  53476 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53479 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53483 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53494 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53498 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53505 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  53505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  53512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53517 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53521 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53532 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  53539 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  53544 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  53549 */   // GIR_Coverage, 22578,
     /*  53549 */   GIR_EraseRootFromParent_Done,
     /*  53550 */ // Label 1298: @53550
     /*  53550 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(53629), // Rule ID 22580 //
     /*  53555 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53558 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53562 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53573 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53577 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53584 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  53584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  53591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53596 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53600 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53611 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  53618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  53623 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  53628 */   // GIR_Coverage, 22580,
     /*  53628 */   GIR_EraseRootFromParent_Done,
     /*  53629 */ // Label 1299: @53629
     /*  53629 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(53715), // Rule ID 18338 //
     /*  53634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  53637 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  53648 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53652 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53659 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  53659 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53662 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  53666 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  53676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrmi),
     /*  53680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53685 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53688 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53692 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  53695 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  53714 */   // GIR_Coverage, 18338,
     /*  53714 */   GIR_EraseRootFromParent_Done,
     /*  53715 */ // Label 1300: @53715
     /*  53715 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(53757), // Rule ID 29 //
     /*  53720 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53727 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53731 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  53735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53742 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>  =>  (MOV16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16rm),
     /*  53745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53747 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53751 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53755 */   GIR_RootConstrainSelectedInstOperands,
     /*  53756 */   // GIR_Coverage, 29,
     /*  53756 */   GIR_EraseRootFromParent_Done,
     /*  53757 */ // Label 1301: @53757
     /*  53757 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(53843), // Rule ID 18334 //
     /*  53762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  53765 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53768 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  53776 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53780 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53787 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  53787 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53790 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  53794 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  53804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrmi),
     /*  53808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53813 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53816 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53820 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  53823 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  53842 */   // GIR_Coverage, 18334,
     /*  53842 */   GIR_EraseRootFromParent_Done,
     /*  53843 */ // Label 1302: @53843
     /*  53843 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(53929), // Rule ID 21838 //
     /*  53848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  53851 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53854 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  53862 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53866 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53873 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /*  53873 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53876 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  53880 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53887 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  53890 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrmi),
     /*  53894 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53899 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53902 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53906 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  53909 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53920 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53923 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  53928 */   // GIR_Coverage, 21838,
     /*  53928 */   GIR_EraseRootFromParent_Done,
     /*  53929 */ // Label 1303: @53929
     /*  53929 */ GIM_Reject,
     /*  53930 */ // Label 1269: @53930
     /*  53930 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(53978), // Rule ID 1079 //
     /*  53935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /*  53938 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53941 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /*  53949 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53953 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53960 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp32m:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m),
     /*  53963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53965 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53969 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  53972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53976 */   GIR_RootConstrainSelectedInstOperands,
     /*  53977 */   // GIR_Coverage, 1079,
     /*  53977 */   GIR_EraseRootFromParent_Done,
     /*  53978 */ // Label 1304: @53978
     /*  53978 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(54023), // Rule ID 1696 //
     /*  53983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  53986 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53989 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  53997 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54001 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54008 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSrm_alt),
     /*  54011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54013 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54017 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54021 */   GIR_RootConstrainSelectedInstOperands,
     /*  54022 */   // GIR_Coverage, 1696,
     /*  54022 */   GIR_EraseRootFromParent_Done,
     /*  54023 */ // Label 1305: @54023
     /*  54023 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(54068), // Rule ID 1697 //
     /*  54028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  54031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54034 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  54042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54046 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54053 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSrm_alt),
     /*  54056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54058 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54066 */   GIR_RootConstrainSelectedInstOperands,
     /*  54067 */   // GIR_Coverage, 1697,
     /*  54067 */   GIR_EraseRootFromParent_Done,
     /*  54068 */ // Label 1306: @54068
     /*  54068 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(54113), // Rule ID 4608 //
     /*  54073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  54076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54079 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  54087 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54091 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54098 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSSZrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZrm_alt),
     /*  54101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54103 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54107 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54111 */   GIR_RootConstrainSelectedInstOperands,
     /*  54112 */   // GIR_Coverage, 4608,
     /*  54112 */   GIR_EraseRootFromParent_Done,
     /*  54113 */ // Label 1307: @54113
     /*  54113 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(54162), // Rule ID 22516 //
     /*  54118 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  54121 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54125 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  54132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54136 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54140 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54147 */   // (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  54150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54152 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54156 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54160 */   GIR_RootConstrainSelectedInstOperands,
     /*  54161 */   // GIR_Coverage, 22516,
     /*  54161 */   GIR_EraseRootFromParent_Done,
     /*  54162 */ // Label 1308: @54162
     /*  54162 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(54211), // Rule ID 22579 //
     /*  54167 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54170 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54174 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54196 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54201 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54209 */   GIR_RootConstrainSelectedInstOperands,
     /*  54210 */   // GIR_Coverage, 22579,
     /*  54210 */   GIR_EraseRootFromParent_Done,
     /*  54211 */ // Label 1309: @54211
     /*  54211 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(54260), // Rule ID 22581 //
     /*  54216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54219 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54223 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54234 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54238 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54245 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54250 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54254 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54258 */   GIR_RootConstrainSelectedInstOperands,
     /*  54259 */   // GIR_Coverage, 22581,
     /*  54259 */   GIR_EraseRootFromParent_Done,
     /*  54260 */ // Label 1310: @54260
     /*  54260 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(54309), // Rule ID 22582 //
     /*  54265 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54268 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54272 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  54279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54283 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54287 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54294 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  54297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54299 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54303 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54307 */   GIR_RootConstrainSelectedInstOperands,
     /*  54308 */   // GIR_Coverage, 22582,
     /*  54308 */   GIR_EraseRootFromParent_Done,
     /*  54309 */ // Label 1311: @54309
     /*  54309 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(54351), // Rule ID 30 //
     /*  54314 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54325 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  54329 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54336 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>  =>  (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  54339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54341 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54345 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54349 */   GIR_RootConstrainSelectedInstOperands,
     /*  54350 */   // GIR_Coverage, 30,
     /*  54350 */   GIR_EraseRootFromParent_Done,
     /*  54351 */ // Label 1312: @54351
     /*  54351 */ GIM_Reject,
     /*  54352 */ // Label 1270: @54352
     /*  54352 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(54394), // Rule ID 31 //
     /*  54357 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54360 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54379 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOV64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  54379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64rm),
     /*  54382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54384 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54388 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54392 */   GIR_RootConstrainSelectedInstOperands,
     /*  54393 */   // GIR_Coverage, 31,
     /*  54393 */   GIR_EraseRootFromParent_Done,
     /*  54394 */ // Label 1313: @54394
     /*  54394 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(54442), // Rule ID 1080 //
     /*  54399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  54402 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54405 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  54413 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54417 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54424 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp64m:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp64m),
     /*  54427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54429 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54433 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54440 */   GIR_RootConstrainSelectedInstOperands,
     /*  54441 */   // GIR_Coverage, 1080,
     /*  54441 */   GIR_EraseRootFromParent_Done,
     /*  54442 */ // Label 1314: @54442
     /*  54442 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(54497), // Rule ID 1082 //
     /*  54447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  54450 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54453 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54457 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  54464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  54468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54479 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>  =>  (LD_Fp32m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m64),
     /*  54482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54484 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54488 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54491 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54495 */   GIR_RootConstrainSelectedInstOperands,
     /*  54496 */   // GIR_Coverage, 1082,
     /*  54496 */   GIR_EraseRootFromParent_Done,
     /*  54497 */ // Label 1315: @54497
     /*  54497 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(54542), // Rule ID 1700 //
     /*  54502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  54505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  54516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54520 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54527 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDrm_alt),
     /*  54530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54532 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54540 */   GIR_RootConstrainSelectedInstOperands,
     /*  54541 */   // GIR_Coverage, 1700,
     /*  54541 */   GIR_EraseRootFromParent_Done,
     /*  54542 */ // Label 1316: @54542
     /*  54542 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(54587), // Rule ID 1701 //
     /*  54547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  54550 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54553 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  54561 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54565 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54572 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDrm_alt),
     /*  54575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54577 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54581 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54585 */   GIR_RootConstrainSelectedInstOperands,
     /*  54586 */   // GIR_Coverage, 1701,
     /*  54586 */   GIR_EraseRootFromParent_Done,
     /*  54587 */ // Label 1317: @54587
     /*  54587 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(54632), // Rule ID 4614 //
     /*  54592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  54595 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54598 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  54606 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54610 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54617 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSDZrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZrm_alt),
     /*  54620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54622 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54626 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54630 */   GIR_RootConstrainSelectedInstOperands,
     /*  54631 */   // GIR_Coverage, 4614,
     /*  54631 */   GIR_EraseRootFromParent_Done,
     /*  54632 */ // Label 1318: @54632
     /*  54632 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(54681), // Rule ID 22517 //
     /*  54637 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  54640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54644 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  54651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54655 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54666 */   // (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>  =>  (MOV64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  54666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64rm),
     /*  54669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54671 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54675 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54679 */   GIR_RootConstrainSelectedInstOperands,
     /*  54680 */   // GIR_Coverage, 22517,
     /*  54680 */   GIR_EraseRootFromParent_Done,
     /*  54681 */ // Label 1319: @54681
     /*  54681 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(54762), // Rule ID 22584 //
     /*  54686 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54689 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54693 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54704 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54708 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54715 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54727 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54731 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54745 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  54756 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  54761 */   // GIR_Coverage, 22584,
     /*  54761 */   GIR_EraseRootFromParent_Done,
     /*  54762 */ // Label 1320: @54762
     /*  54762 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(54843), // Rule ID 22585 //
     /*  54767 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54770 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54774 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54785 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54789 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54796 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54808 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54812 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54826 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54832 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  54837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  54842 */   // GIR_Coverage, 22585,
     /*  54842 */   GIR_EraseRootFromParent_Done,
     /*  54843 */ // Label 1321: @54843
     /*  54843 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(54924), // Rule ID 22586 //
     /*  54848 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54851 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54855 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  54862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54866 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54870 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54877 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  54884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54889 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54893 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54913 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  54918 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  54923 */   // GIR_Coverage, 22586,
     /*  54923 */   GIR_EraseRootFromParent_Done,
     /*  54924 */ // Label 1322: @54924
     /*  54924 */ GIM_Reject,
     /*  54925 */ // Label 1271: @54925
     /*  54925 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(55083),
     /*  54930 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54933 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(54978), // Rule ID 1081 //
     /*  54938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  54941 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  54949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54960 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp80m:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp80m),
     /*  54963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54976 */     GIR_RootConstrainSelectedInstOperands,
     /*  54977 */     // GIR_Coverage, 1081,
     /*  54977 */     GIR_EraseRootFromParent_Done,
     /*  54978 */   // Label 1324: @54978
     /*  54978 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(55030), // Rule ID 1083 //
     /*  54983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  54986 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54990 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  54997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55012 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>  =>  (LD_Fp64m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp64m80),
     /*  55015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55028 */     GIR_RootConstrainSelectedInstOperands,
     /*  55029 */     // GIR_Coverage, 1083,
     /*  55029 */     GIR_EraseRootFromParent_Done,
     /*  55030 */   // Label 1325: @55030
     /*  55030 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(55082), // Rule ID 1084 //
     /*  55035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  55038 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55042 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  55049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55064 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>  =>  (LD_Fp32m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m80),
     /*  55067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55069 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55080 */     GIR_RootConstrainSelectedInstOperands,
     /*  55081 */     // GIR_Coverage, 1084,
     /*  55081 */     GIR_EraseRootFromParent_Done,
     /*  55082 */   // Label 1326: @55082
     /*  55082 */   GIM_Reject,
     /*  55083 */ // Label 1323: @55083
     /*  55083 */ GIM_Reject,
     /*  55084 */ // Label 1272: @55084
     /*  55084 */ GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(55211),
     /*  55089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55092 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55096 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(55134), // Rule ID 23142 //
     /*  55101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  55104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55119 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55124 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55132 */     GIR_RootConstrainSelectedInstOperands,
     /*  55133 */     // GIR_Coverage, 23142,
     /*  55133 */     GIR_EraseRootFromParent_Done,
     /*  55134 */   // Label 1328: @55134
     /*  55134 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(55172), // Rule ID 23146 //
     /*  55139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55157 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  55160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55170 */     GIR_RootConstrainSelectedInstOperands,
     /*  55171 */     // GIR_Coverage, 23146,
     /*  55171 */     GIR_EraseRootFromParent_Done,
     /*  55172 */   // Label 1329: @55172
     /*  55172 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(55210), // Rule ID 23150 //
     /*  55177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  55180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55195 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  55198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55208 */     GIR_RootConstrainSelectedInstOperands,
     /*  55209 */     // GIR_Coverage, 23150,
     /*  55209 */     GIR_EraseRootFromParent_Done,
     /*  55210 */   // Label 1330: @55210
     /*  55210 */   GIM_Reject,
     /*  55211 */ // Label 1327: @55211
     /*  55211 */ GIM_Reject,
     /*  55212 */ // Label 1273: @55212
     /*  55212 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(55278), // Rule ID 19445 //
     /*  55217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  55220 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55223 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  55231 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55235 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55242 */   // (ld:{ *:[v2i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK2:{ *:[i32] })
     /*  55242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  55245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  55249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55254 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55258 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55272 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  55277 */   // GIR_Coverage, 19445,
     /*  55277 */   GIR_EraseRootFromParent_Done,
     /*  55278 */ // Label 1331: @55278
     /*  55278 */ GIM_Reject,
     /*  55279 */ // Label 1274: @55279
     /*  55279 */ GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(55772),
     /*  55284 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55287 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55291 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(55333), // Rule ID 1703 //
     /*  55296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55307 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55318 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDrm),
     /*  55321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55331 */     GIR_RootConstrainSelectedInstOperands,
     /*  55332 */     // GIR_Coverage, 1703,
     /*  55332 */     GIR_EraseRootFromParent_Done,
     /*  55333 */   // Label 1333: @55333
     /*  55333 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(55371), // Rule ID 1705 //
     /*  55338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55356 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDrm),
     /*  55359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55361 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55369 */     GIR_RootConstrainSelectedInstOperands,
     /*  55370 */     // GIR_Coverage, 1705,
     /*  55370 */     GIR_EraseRootFromParent_Done,
     /*  55371 */   // Label 1334: @55371
     /*  55371 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(55413), // Rule ID 1712 //
     /*  55376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  55379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55398 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPDrm),
     /*  55401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55411 */     GIR_RootConstrainSelectedInstOperands,
     /*  55412 */     // GIR_Coverage, 1712,
     /*  55412 */     GIR_EraseRootFromParent_Done,
     /*  55413 */   // Label 1335: @55413
     /*  55413 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(55451), // Rule ID 1713 //
     /*  55418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  55421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55436 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPDrm),
     /*  55439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55449 */     GIR_RootConstrainSelectedInstOperands,
     /*  55450 */     // GIR_Coverage, 1713,
     /*  55450 */     GIR_EraseRootFromParent_Done,
     /*  55451 */   // Label 1336: @55451
     /*  55451 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(55493), // Rule ID 2517 //
     /*  55456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55467 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55478 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  55481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55491 */     GIR_RootConstrainSelectedInstOperands,
     /*  55492 */     // GIR_Coverage, 2517,
     /*  55492 */     GIR_EraseRootFromParent_Done,
     /*  55493 */   // Label 1337: @55493
     /*  55493 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(55531), // Rule ID 2518 //
     /*  55498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55516 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  55519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55529 */     GIR_RootConstrainSelectedInstOperands,
     /*  55530 */     // GIR_Coverage, 2518,
     /*  55530 */     GIR_EraseRootFromParent_Done,
     /*  55531 */   // Label 1338: @55531
     /*  55531 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(55573), // Rule ID 4489 //
     /*  55536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55558 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rm),
     /*  55561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55571 */     GIR_RootConstrainSelectedInstOperands,
     /*  55572 */     // GIR_Coverage, 4489,
     /*  55572 */     GIR_EraseRootFromParent_Done,
     /*  55573 */   // Label 1339: @55573
     /*  55573 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(55611), // Rule ID 4514 //
     /*  55578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55596 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ128rm),
     /*  55599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55609 */     GIR_RootConstrainSelectedInstOperands,
     /*  55610 */     // GIR_Coverage, 4514,
     /*  55610 */     GIR_EraseRootFromParent_Done,
     /*  55611 */   // Label 1340: @55611
     /*  55611 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(55653), // Rule ID 4543 //
     /*  55616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55627 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55638 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  55641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55643 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55651 */     GIR_RootConstrainSelectedInstOperands,
     /*  55652 */     // GIR_Coverage, 4543,
     /*  55652 */     GIR_EraseRootFromParent_Done,
     /*  55653 */   // Label 1341: @55653
     /*  55653 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(55691), // Rule ID 4586 //
     /*  55658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55676 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  55679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55689 */     GIR_RootConstrainSelectedInstOperands,
     /*  55690 */     // GIR_Coverage, 4586,
     /*  55690 */     GIR_EraseRootFromParent_Done,
     /*  55691 */   // Label 1342: @55691
     /*  55691 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(55733), // Rule ID 17938 //
     /*  55696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55718 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  55721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55723 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55731 */     GIR_RootConstrainSelectedInstOperands,
     /*  55732 */     // GIR_Coverage, 17938,
     /*  55732 */     GIR_EraseRootFromParent_Done,
     /*  55733 */   // Label 1343: @55733
     /*  55733 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(55771), // Rule ID 17942 //
     /*  55738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55756 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55761 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55769 */     GIR_RootConstrainSelectedInstOperands,
     /*  55770 */     // GIR_Coverage, 17942,
     /*  55770 */     GIR_EraseRootFromParent_Done,
     /*  55771 */   // Label 1344: @55771
     /*  55771 */   GIM_Reject,
     /*  55772 */ // Label 1332: @55772
     /*  55772 */ GIM_Reject,
     /*  55773 */ // Label 1275: @55773
     /*  55773 */ GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(55839), // Rule ID 19446 //
     /*  55778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  55781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55784 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  55792 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55796 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55803 */   // (ld:{ *:[v4i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK4:{ *:[i32] })
     /*  55803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  55806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  55810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55815 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55819 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55833 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  55838 */   // GIR_Coverage, 19446,
     /*  55838 */   GIR_EraseRootFromParent_Done,
     /*  55839 */ // Label 1345: @55839
     /*  55839 */ GIM_Reject,
     /*  55840 */ // Label 1276: @55840
     /*  55840 */ GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(56333),
     /*  55845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55852 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(55894), // Rule ID 1702 //
     /*  55857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55879 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  55879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSrm),
     /*  55882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55892 */     GIR_RootConstrainSelectedInstOperands,
     /*  55893 */     // GIR_Coverage, 1702,
     /*  55893 */     GIR_EraseRootFromParent_Done,
     /*  55894 */   // Label 1347: @55894
     /*  55894 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(55932), // Rule ID 1704 //
     /*  55899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55917 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  55917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  55920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55930 */     GIR_RootConstrainSelectedInstOperands,
     /*  55931 */     // GIR_Coverage, 1704,
     /*  55931 */     GIR_EraseRootFromParent_Done,
     /*  55932 */   // Label 1348: @55932
     /*  55932 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(55974), // Rule ID 1710 //
     /*  55937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55948 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55959 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  55959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  55962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55972 */     GIR_RootConstrainSelectedInstOperands,
     /*  55973 */     // GIR_Coverage, 1710,
     /*  55973 */     GIR_EraseRootFromParent_Done,
     /*  55974 */   // Label 1349: @55974
     /*  55974 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(56012), // Rule ID 1711 //
     /*  55979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55997 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  55997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56010 */     GIR_RootConstrainSelectedInstOperands,
     /*  56011 */     // GIR_Coverage, 1711,
     /*  56011 */     GIR_EraseRootFromParent_Done,
     /*  56012 */   // Label 1350: @56012
     /*  56012 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(56054), // Rule ID 4471 //
     /*  56017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56039 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rm),
     /*  56042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56044 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56052 */     GIR_RootConstrainSelectedInstOperands,
     /*  56053 */     // GIR_Coverage, 4471,
     /*  56053 */     GIR_EraseRootFromParent_Done,
     /*  56054 */   // Label 1351: @56054
     /*  56054 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(56092), // Rule ID 4502 //
     /*  56059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56077 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  56080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56082 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56090 */     GIR_RootConstrainSelectedInstOperands,
     /*  56091 */     // GIR_Coverage, 4502,
     /*  56091 */     GIR_EraseRootFromParent_Done,
     /*  56092 */   // Label 1352: @56092
     /*  56092 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(56134), // Rule ID 17939 //
     /*  56097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56119 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56124 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56132 */     GIR_RootConstrainSelectedInstOperands,
     /*  56133 */     // GIR_Coverage, 17939,
     /*  56133 */     GIR_EraseRootFromParent_Done,
     /*  56134 */   // Label 1353: @56134
     /*  56134 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(56172), // Rule ID 17943 //
     /*  56139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56157 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56170 */     GIR_RootConstrainSelectedInstOperands,
     /*  56171 */     // GIR_Coverage, 17943,
     /*  56171 */     GIR_EraseRootFromParent_Done,
     /*  56172 */   // Label 1354: @56172
     /*  56172 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(56214), // Rule ID 18318 //
     /*  56177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56199 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  56202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56212 */     GIR_RootConstrainSelectedInstOperands,
     /*  56213 */     // GIR_Coverage, 18318,
     /*  56213 */     GIR_EraseRootFromParent_Done,
     /*  56214 */   // Label 1355: @56214
     /*  56214 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(56252), // Rule ID 18322 //
     /*  56219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56237 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  56240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56242 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56250 */     GIR_RootConstrainSelectedInstOperands,
     /*  56251 */     // GIR_Coverage, 18322,
     /*  56251 */     GIR_EraseRootFromParent_Done,
     /*  56252 */   // Label 1356: @56252
     /*  56252 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(56294), // Rule ID 19811 //
     /*  56257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  56260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56279 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  56282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56292 */     GIR_RootConstrainSelectedInstOperands,
     /*  56293 */     // GIR_Coverage, 19811,
     /*  56293 */     GIR_EraseRootFromParent_Done,
     /*  56294 */   // Label 1357: @56294
     /*  56294 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(56332), // Rule ID 19815 //
     /*  56299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  56302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56317 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  56320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56330 */     GIR_RootConstrainSelectedInstOperands,
     /*  56331 */     // GIR_Coverage, 19815,
     /*  56331 */     GIR_EraseRootFromParent_Done,
     /*  56332 */   // Label 1358: @56332
     /*  56332 */   GIM_Reject,
     /*  56333 */ // Label 1346: @56333
     /*  56333 */ GIM_Reject,
     /*  56334 */ // Label 1277: @56334
     /*  56334 */ GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(56667),
     /*  56339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56346 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(56388), // Rule ID 1707 //
     /*  56351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56362 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56373 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDYrm),
     /*  56376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56378 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56386 */     GIR_RootConstrainSelectedInstOperands,
     /*  56387 */     // GIR_Coverage, 1707,
     /*  56387 */     GIR_EraseRootFromParent_Done,
     /*  56388 */   // Label 1360: @56388
     /*  56388 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(56426), // Rule ID 1709 //
     /*  56393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56411 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDYrm),
     /*  56414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56424 */     GIR_RootConstrainSelectedInstOperands,
     /*  56425 */     // GIR_Coverage, 1709,
     /*  56425 */     GIR_EraseRootFromParent_Done,
     /*  56426 */   // Label 1361: @56426
     /*  56426 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(56468), // Rule ID 4484 //
     /*  56431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56442 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56453 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rm),
     /*  56456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56458 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56466 */     GIR_RootConstrainSelectedInstOperands,
     /*  56467 */     // GIR_Coverage, 4484,
     /*  56467 */     GIR_EraseRootFromParent_Done,
     /*  56468 */   // Label 1362: @56468
     /*  56468 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(56506), // Rule ID 4511 //
     /*  56473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56491 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ256rm),
     /*  56494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56496 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56504 */     GIR_RootConstrainSelectedInstOperands,
     /*  56505 */     // GIR_Coverage, 4511,
     /*  56505 */     GIR_EraseRootFromParent_Done,
     /*  56506 */   // Label 1363: @56506
     /*  56506 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(56548), // Rule ID 4538 //
     /*  56511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56533 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  56536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56546 */     GIR_RootConstrainSelectedInstOperands,
     /*  56547 */     // GIR_Coverage, 4538,
     /*  56547 */     GIR_EraseRootFromParent_Done,
     /*  56548 */   // Label 1364: @56548
     /*  56548 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(56586), // Rule ID 4583 //
     /*  56553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56571 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  56574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56584 */     GIR_RootConstrainSelectedInstOperands,
     /*  56585 */     // GIR_Coverage, 4583,
     /*  56585 */     GIR_EraseRootFromParent_Done,
     /*  56586 */   // Label 1365: @56586
     /*  56586 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(56628), // Rule ID 17914 //
     /*  56591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56602 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56613 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  56616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56618 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56626 */     GIR_RootConstrainSelectedInstOperands,
     /*  56627 */     // GIR_Coverage, 17914,
     /*  56627 */     GIR_EraseRootFromParent_Done,
     /*  56628 */   // Label 1366: @56628
     /*  56628 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(56666), // Rule ID 17918 //
     /*  56633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56651 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  56654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56656 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56664 */     GIR_RootConstrainSelectedInstOperands,
     /*  56665 */     // GIR_Coverage, 17918,
     /*  56665 */     GIR_EraseRootFromParent_Done,
     /*  56666 */   // Label 1367: @56666
     /*  56666 */   GIM_Reject,
     /*  56667 */ // Label 1359: @56667
     /*  56667 */ GIM_Reject,
     /*  56668 */ // Label 1278: @56668
     /*  56668 */ GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(56749),
     /*  56673 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56676 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  56684 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56688 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(56718), // Rule ID 4394 //
     /*  56693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoEGPR),
     /*  56696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56703 */     // (ld:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)
     /*  56703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  56706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56708 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56716 */     GIR_RootConstrainSelectedInstOperands,
     /*  56717 */     // GIR_Coverage, 4394,
     /*  56717 */     GIR_EraseRootFromParent_Done,
     /*  56718 */   // Label 1369: @56718
     /*  56718 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(56748), // Rule ID 4396 //
     /*  56723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEGPR_In64BitMode),
     /*  56726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56733 */     // (ld:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVBkm_EVEX:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)
     /*  56733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBkm_EVEX),
     /*  56736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56746 */     GIR_RootConstrainSelectedInstOperands,
     /*  56747 */     // GIR_Coverage, 4396,
     /*  56747 */     GIR_EraseRootFromParent_Done,
     /*  56748 */   // Label 1370: @56748
     /*  56748 */   GIM_Reject,
     /*  56749 */ // Label 1368: @56749
     /*  56749 */ GIM_Reject,
     /*  56750 */ // Label 1279: @56750
     /*  56750 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(57323),
     /*  56755 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56758 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56762 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(56804), // Rule ID 17930 //
     /*  56767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56778 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56789 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSrm),
     /*  56792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56794 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56802 */     GIR_RootConstrainSelectedInstOperands,
     /*  56803 */     // GIR_Coverage, 17930,
     /*  56803 */     GIR_EraseRootFromParent_Done,
     /*  56804 */   // Label 1372: @56804
     /*  56804 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(56842), // Rule ID 17931 //
     /*  56809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56827 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  56830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56840 */     GIR_RootConstrainSelectedInstOperands,
     /*  56841 */     // GIR_Coverage, 17931,
     /*  56841 */     GIR_EraseRootFromParent_Done,
     /*  56842 */   // Label 1373: @56842
     /*  56842 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(56884), // Rule ID 17940 //
     /*  56847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56858 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56869 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  56869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56874 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56882 */     GIR_RootConstrainSelectedInstOperands,
     /*  56883 */     // GIR_Coverage, 17940,
     /*  56883 */     GIR_EraseRootFromParent_Done,
     /*  56884 */   // Label 1374: @56884
     /*  56884 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(56922), // Rule ID 17944 //
     /*  56889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56907 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  56907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56920 */     GIR_RootConstrainSelectedInstOperands,
     /*  56921 */     // GIR_Coverage, 17944,
     /*  56921 */     GIR_EraseRootFromParent_Done,
     /*  56922 */   // Label 1375: @56922
     /*  56922 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(56964), // Rule ID 17954 //
     /*  56927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  56930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56938 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56949 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56962 */     GIR_RootConstrainSelectedInstOperands,
     /*  56963 */     // GIR_Coverage, 17954,
     /*  56963 */     GIR_EraseRootFromParent_Done,
     /*  56964 */   // Label 1376: @56964
     /*  56964 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(57002), // Rule ID 17955 //
     /*  56969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  56972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56987 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57000 */     GIR_RootConstrainSelectedInstOperands,
     /*  57001 */     // GIR_Coverage, 17955,
     /*  57001 */     GIR_EraseRootFromParent_Done,
     /*  57002 */   // Label 1377: @57002
     /*  57002 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(57044), // Rule ID 18319 //
     /*  57007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57018 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57029 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  57032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57034 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57042 */     GIR_RootConstrainSelectedInstOperands,
     /*  57043 */     // GIR_Coverage, 18319,
     /*  57043 */     GIR_EraseRootFromParent_Done,
     /*  57044 */   // Label 1378: @57044
     /*  57044 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(57086), // Rule ID 18320 //
     /*  57049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57060 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57071 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  57074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57084 */     GIR_RootConstrainSelectedInstOperands,
     /*  57085 */     // GIR_Coverage, 18320,
     /*  57085 */     GIR_EraseRootFromParent_Done,
     /*  57086 */   // Label 1379: @57086
     /*  57086 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(57124), // Rule ID 18323 //
     /*  57091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57109 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  57112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57122 */     GIR_RootConstrainSelectedInstOperands,
     /*  57123 */     // GIR_Coverage, 18323,
     /*  57123 */     GIR_EraseRootFromParent_Done,
     /*  57124 */   // Label 1380: @57124
     /*  57124 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(57162), // Rule ID 18324 //
     /*  57129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57147 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  57150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57152 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57160 */     GIR_RootConstrainSelectedInstOperands,
     /*  57161 */     // GIR_Coverage, 18324,
     /*  57161 */     GIR_EraseRootFromParent_Done,
     /*  57162 */   // Label 1381: @57162
     /*  57162 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(57204), // Rule ID 19812 //
     /*  57167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57178 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57189 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  57192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57202 */     GIR_RootConstrainSelectedInstOperands,
     /*  57203 */     // GIR_Coverage, 19812,
     /*  57203 */     GIR_EraseRootFromParent_Done,
     /*  57204 */   // Label 1382: @57204
     /*  57204 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(57246), // Rule ID 19813 //
     /*  57209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57231 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rm),
     /*  57234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57236 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57244 */     GIR_RootConstrainSelectedInstOperands,
     /*  57245 */     // GIR_Coverage, 19813,
     /*  57245 */     GIR_EraseRootFromParent_Done,
     /*  57246 */   // Label 1383: @57246
     /*  57246 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(57284), // Rule ID 19816 //
     /*  57251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57269 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  57272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57274 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57282 */     GIR_RootConstrainSelectedInstOperands,
     /*  57283 */     // GIR_Coverage, 19816,
     /*  57283 */     GIR_EraseRootFromParent_Done,
     /*  57284 */   // Label 1384: @57284
     /*  57284 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(57322), // Rule ID 19817 //
     /*  57289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57307 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  57310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57312 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57320 */     GIR_RootConstrainSelectedInstOperands,
     /*  57321 */     // GIR_Coverage, 19817,
     /*  57321 */     GIR_EraseRootFromParent_Done,
     /*  57322 */   // Label 1385: @57322
     /*  57322 */   GIM_Reject,
     /*  57323 */ // Label 1371: @57323
     /*  57323 */ GIM_Reject,
     /*  57324 */ // Label 1280: @57324
     /*  57324 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(57657),
     /*  57329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57332 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57336 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(57378), // Rule ID 1706 //
     /*  57341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57352 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57363 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  57366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57368 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57376 */     GIR_RootConstrainSelectedInstOperands,
     /*  57377 */     // GIR_Coverage, 1706,
     /*  57377 */     GIR_EraseRootFromParent_Done,
     /*  57378 */   // Label 1387: @57378
     /*  57378 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(57416), // Rule ID 1708 //
     /*  57383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57401 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  57404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57406 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57414 */     GIR_RootConstrainSelectedInstOperands,
     /*  57415 */     // GIR_Coverage, 1708,
     /*  57415 */     GIR_EraseRootFromParent_Done,
     /*  57416 */   // Label 1388: @57416
     /*  57416 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(57458), // Rule ID 4466 //
     /*  57421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  57424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57443 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rm),
     /*  57446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57448 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57456 */     GIR_RootConstrainSelectedInstOperands,
     /*  57457 */     // GIR_Coverage, 4466,
     /*  57457 */     GIR_EraseRootFromParent_Done,
     /*  57458 */   // Label 1389: @57458
     /*  57458 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(57496), // Rule ID 4499 //
     /*  57463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  57466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57481 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256rm),
     /*  57484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57486 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57494 */     GIR_RootConstrainSelectedInstOperands,
     /*  57495 */     // GIR_Coverage, 4499,
     /*  57495 */     GIR_EraseRootFromParent_Done,
     /*  57496 */   // Label 1390: @57496
     /*  57496 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(57538), // Rule ID 17915 //
     /*  57501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57523 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  57526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57528 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57536 */     GIR_RootConstrainSelectedInstOperands,
     /*  57537 */     // GIR_Coverage, 17915,
     /*  57537 */     GIR_EraseRootFromParent_Done,
     /*  57538 */   // Label 1391: @57538
     /*  57538 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(57576), // Rule ID 17919 //
     /*  57543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57561 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  57564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57566 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57574 */     GIR_RootConstrainSelectedInstOperands,
     /*  57575 */     // GIR_Coverage, 17919,
     /*  57575 */     GIR_EraseRootFromParent_Done,
     /*  57576 */   // Label 1392: @57576
     /*  57576 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(57618), // Rule ID 19827 //
     /*  57581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57592 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57603 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  57606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57608 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57616 */     GIR_RootConstrainSelectedInstOperands,
     /*  57617 */     // GIR_Coverage, 19827,
     /*  57617 */     GIR_EraseRootFromParent_Done,
     /*  57618 */   // Label 1393: @57618
     /*  57618 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(57656), // Rule ID 19831 //
     /*  57623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57641 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  57644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57646 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57654 */     GIR_RootConstrainSelectedInstOperands,
     /*  57655 */     // GIR_Coverage, 19831,
     /*  57655 */     GIR_EraseRootFromParent_Done,
     /*  57656 */   // Label 1394: @57656
     /*  57656 */   GIM_Reject,
     /*  57657 */ // Label 1386: @57657
     /*  57657 */ GIM_Reject,
     /*  57658 */ // Label 1281: @57658
     /*  57658 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(57831),
     /*  57663 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57666 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57670 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(57712), // Rule ID 4479 //
     /*  57675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57686 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57697 */     // (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /*  57697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrm),
     /*  57700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57702 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57710 */     GIR_RootConstrainSelectedInstOperands,
     /*  57711 */     // GIR_Coverage, 4479,
     /*  57711 */     GIR_EraseRootFromParent_Done,
     /*  57712 */   // Label 1396: @57712
     /*  57712 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(57750), // Rule ID 4508 //
     /*  57717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57735 */     // (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /*  57735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZrm),
     /*  57738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57740 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57748 */     GIR_RootConstrainSelectedInstOperands,
     /*  57749 */     // GIR_Coverage, 4508,
     /*  57749 */     GIR_EraseRootFromParent_Done,
     /*  57750 */   // Label 1397: @57750
     /*  57750 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(57792), // Rule ID 4533 //
     /*  57755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57766 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57777 */     // (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  57777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  57780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57782 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57790 */     GIR_RootConstrainSelectedInstOperands,
     /*  57791 */     // GIR_Coverage, 4533,
     /*  57791 */     GIR_EraseRootFromParent_Done,
     /*  57792 */   // Label 1398: @57792
     /*  57792 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(57830), // Rule ID 4580 //
     /*  57797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57815 */     // (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  57815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  57818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57820 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57828 */     GIR_RootConstrainSelectedInstOperands,
     /*  57829 */     // GIR_Coverage, 4580,
     /*  57829 */     GIR_EraseRootFromParent_Done,
     /*  57830 */   // Label 1399: @57830
     /*  57830 */   GIM_Reject,
     /*  57831 */ // Label 1395: @57831
     /*  57831 */ GIM_Reject,
     /*  57832 */ // Label 1282: @57832
     /*  57832 */ GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(57913),
     /*  57837 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57840 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  57848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57852 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(57882), // Rule ID 4398 //
     /*  57857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoEGPR),
     /*  57860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57867 */     // (ld:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVWkm:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  57867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm),
     /*  57870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57880 */     GIR_RootConstrainSelectedInstOperands,
     /*  57881 */     // GIR_Coverage, 4398,
     /*  57881 */     GIR_EraseRootFromParent_Done,
     /*  57882 */   // Label 1401: @57882
     /*  57882 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(57912), // Rule ID 4400 //
     /*  57887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEGPR_In64BitMode),
     /*  57890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57897 */     // (ld:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVWkm_EVEX:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  57897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm_EVEX),
     /*  57900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57910 */     GIR_RootConstrainSelectedInstOperands,
     /*  57911 */     // GIR_Coverage, 4400,
     /*  57911 */     GIR_EraseRootFromParent_Done,
     /*  57912 */   // Label 1402: @57912
     /*  57912 */   GIM_Reject,
     /*  57913 */ // Label 1400: @57913
     /*  57913 */ GIM_Reject,
     /*  57914 */ // Label 1283: @57914
     /*  57914 */ GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(58167),
     /*  57919 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57922 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57926 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(57968), // Rule ID 17941 //
     /*  57931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  57934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57953 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  57953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  57956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57958 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57966 */     GIR_RootConstrainSelectedInstOperands,
     /*  57967 */     // GIR_Coverage, 17941,
     /*  57967 */     GIR_EraseRootFromParent_Done,
     /*  57968 */   // Label 1404: @57968
     /*  57968 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(58006), // Rule ID 17945 //
     /*  57973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  57976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57991 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  57991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  57994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57996 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58004 */     GIR_RootConstrainSelectedInstOperands,
     /*  58005 */     // GIR_Coverage, 17945,
     /*  58005 */     GIR_EraseRootFromParent_Done,
     /*  58006 */   // Label 1405: @58006
     /*  58006 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(58048), // Rule ID 18321 //
     /*  58011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58022 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58033 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  58036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58038 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58046 */     GIR_RootConstrainSelectedInstOperands,
     /*  58047 */     // GIR_Coverage, 18321,
     /*  58047 */     GIR_EraseRootFromParent_Done,
     /*  58048 */   // Label 1406: @58048
     /*  58048 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(58086), // Rule ID 18325 //
     /*  58053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58071 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  58074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58084 */     GIR_RootConstrainSelectedInstOperands,
     /*  58085 */     // GIR_Coverage, 18325,
     /*  58085 */     GIR_EraseRootFromParent_Done,
     /*  58086 */   // Label 1407: @58086
     /*  58086 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(58128), // Rule ID 19814 //
     /*  58091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  58098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58113 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  58116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58126 */     GIR_RootConstrainSelectedInstOperands,
     /*  58127 */     // GIR_Coverage, 19814,
     /*  58127 */     GIR_EraseRootFromParent_Done,
     /*  58128 */   // Label 1408: @58128
     /*  58128 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(58166), // Rule ID 19818 //
     /*  58133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  58140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58151 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  58154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58156 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58164 */     GIR_RootConstrainSelectedInstOperands,
     /*  58165 */     // GIR_Coverage, 19818,
     /*  58165 */     GIR_EraseRootFromParent_Done,
     /*  58166 */   // Label 1409: @58166
     /*  58166 */   GIM_Reject,
     /*  58167 */ // Label 1403: @58167
     /*  58167 */ GIM_Reject,
     /*  58168 */ // Label 1284: @58168
     /*  58168 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(58501),
     /*  58173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58176 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58180 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(58222), // Rule ID 17916 //
     /*  58185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58207 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58220 */     GIR_RootConstrainSelectedInstOperands,
     /*  58221 */     // GIR_Coverage, 17916,
     /*  58221 */     GIR_EraseRootFromParent_Done,
     /*  58222 */   // Label 1411: @58222
     /*  58222 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(58260), // Rule ID 17920 //
     /*  58227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58245 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58258 */     GIR_RootConstrainSelectedInstOperands,
     /*  58259 */     // GIR_Coverage, 17920,
     /*  58259 */     GIR_EraseRootFromParent_Done,
     /*  58260 */   // Label 1412: @58260
     /*  58260 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(58302), // Rule ID 17934 //
     /*  58265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58276 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58287 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58300 */     GIR_RootConstrainSelectedInstOperands,
     /*  58301 */     // GIR_Coverage, 17934,
     /*  58301 */     GIR_EraseRootFromParent_Done,
     /*  58302 */   // Label 1413: @58302
     /*  58302 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(58340), // Rule ID 17935 //
     /*  58307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58325 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58330 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58338 */     GIR_RootConstrainSelectedInstOperands,
     /*  58339 */     // GIR_Coverage, 17935,
     /*  58339 */     GIR_EraseRootFromParent_Done,
     /*  58340 */   // Label 1414: @58340
     /*  58340 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(58382), // Rule ID 19828 //
     /*  58345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58367 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  58370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58372 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58380 */     GIR_RootConstrainSelectedInstOperands,
     /*  58381 */     // GIR_Coverage, 19828,
     /*  58381 */     GIR_EraseRootFromParent_Done,
     /*  58382 */   // Label 1415: @58382
     /*  58382 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(58424), // Rule ID 19829 //
     /*  58387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58409 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rm),
     /*  58412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58422 */     GIR_RootConstrainSelectedInstOperands,
     /*  58423 */     // GIR_Coverage, 19829,
     /*  58423 */     GIR_EraseRootFromParent_Done,
     /*  58424 */   // Label 1416: @58424
     /*  58424 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(58462), // Rule ID 19832 //
     /*  58429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58447 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  58450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58452 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58460 */     GIR_RootConstrainSelectedInstOperands,
     /*  58461 */     // GIR_Coverage, 19832,
     /*  58461 */     GIR_EraseRootFromParent_Done,
     /*  58462 */   // Label 1417: @58462
     /*  58462 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(58500), // Rule ID 19833 //
     /*  58467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58485 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256rm),
     /*  58488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58490 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58498 */     GIR_RootConstrainSelectedInstOperands,
     /*  58499 */     // GIR_Coverage, 19833,
     /*  58499 */     GIR_EraseRootFromParent_Done,
     /*  58500 */   // Label 1418: @58500
     /*  58500 */   GIM_Reject,
     /*  58501 */ // Label 1410: @58501
     /*  58501 */ GIM_Reject,
     /*  58502 */ // Label 1285: @58502
     /*  58502 */ GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(58675),
     /*  58507 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58510 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58514 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(58556), // Rule ID 4461 //
     /*  58519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58541 */     // (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /*  58541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrm),
     /*  58544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58554 */     GIR_RootConstrainSelectedInstOperands,
     /*  58555 */     // GIR_Coverage, 4461,
     /*  58555 */     GIR_EraseRootFromParent_Done,
     /*  58556 */   // Label 1420: @58556
     /*  58556 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(58594), // Rule ID 4496 //
     /*  58561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58579 */     // (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /*  58579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZrm),
     /*  58582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58584 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58592 */     GIR_RootConstrainSelectedInstOperands,
     /*  58593 */     // GIR_Coverage, 4496,
     /*  58593 */     GIR_EraseRootFromParent_Done,
     /*  58594 */   // Label 1421: @58594
     /*  58594 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(58636), // Rule ID 19795 //
     /*  58599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58610 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58621 */     // (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  58621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  58624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58634 */     GIR_RootConstrainSelectedInstOperands,
     /*  58635 */     // GIR_Coverage, 19795,
     /*  58635 */     GIR_EraseRootFromParent_Done,
     /*  58636 */   // Label 1422: @58636
     /*  58636 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(58674), // Rule ID 19799 //
     /*  58641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58659 */     // (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  58659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  58662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58664 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58672 */     GIR_RootConstrainSelectedInstOperands,
     /*  58673 */     // GIR_Coverage, 19799,
     /*  58673 */     GIR_EraseRootFromParent_Done,
     /*  58674 */   // Label 1423: @58674
     /*  58674 */   GIM_Reject,
     /*  58675 */ // Label 1419: @58675
     /*  58675 */ GIM_Reject,
     /*  58676 */ // Label 1286: @58676
     /*  58676 */ GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(58757),
     /*  58681 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58684 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  58692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58696 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(58726), // Rule ID 4402 //
     /*  58701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  58704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58711 */     // (ld:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVDkm:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)
     /*  58711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkm),
     /*  58714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58716 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58724 */     GIR_RootConstrainSelectedInstOperands,
     /*  58725 */     // GIR_Coverage, 4402,
     /*  58725 */     GIR_EraseRootFromParent_Done,
     /*  58726 */   // Label 1425: @58726
     /*  58726 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(58756), // Rule ID 4406 //
     /*  58731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  58734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58741 */     // (ld:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVDkm_EVEX:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)
     /*  58741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkm_EVEX),
     /*  58744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58746 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58754 */     GIR_RootConstrainSelectedInstOperands,
     /*  58755 */     // GIR_Coverage, 4406,
     /*  58755 */     GIR_EraseRootFromParent_Done,
     /*  58756 */   // Label 1426: @58756
     /*  58756 */   GIM_Reject,
     /*  58757 */ // Label 1424: @58757
     /*  58757 */ GIM_Reject,
     /*  58758 */ // Label 1287: @58758
     /*  58758 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(58931),
     /*  58763 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58766 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58770 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(58812), // Rule ID 17917 //
     /*  58775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58797 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  58797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58802 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58810 */     GIR_RootConstrainSelectedInstOperands,
     /*  58811 */     // GIR_Coverage, 17917,
     /*  58811 */     GIR_EraseRootFromParent_Done,
     /*  58812 */   // Label 1428: @58812
     /*  58812 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(58850), // Rule ID 17921 //
     /*  58817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58835 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  58835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58848 */     GIR_RootConstrainSelectedInstOperands,
     /*  58849 */     // GIR_Coverage, 17921,
     /*  58849 */     GIR_EraseRootFromParent_Done,
     /*  58850 */   // Label 1429: @58850
     /*  58850 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(58892), // Rule ID 19830 //
     /*  58855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58877 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  58877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  58880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58890 */     GIR_RootConstrainSelectedInstOperands,
     /*  58891 */     // GIR_Coverage, 19830,
     /*  58891 */     GIR_EraseRootFromParent_Done,
     /*  58892 */   // Label 1430: @58892
     /*  58892 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(58930), // Rule ID 19834 //
     /*  58897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58915 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  58915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  58918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58928 */     GIR_RootConstrainSelectedInstOperands,
     /*  58929 */     // GIR_Coverage, 19834,
     /*  58929 */     GIR_EraseRootFromParent_Done,
     /*  58930 */   // Label 1431: @58930
     /*  58930 */   GIM_Reject,
     /*  58931 */ // Label 1427: @58931
     /*  58931 */ GIM_Reject,
     /*  58932 */ // Label 1288: @58932
     /*  58932 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(59105),
     /*  58937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58940 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58944 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(58986), // Rule ID 19796 //
     /*  58949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58971 */     // (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  58971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  58974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58976 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58984 */     GIR_RootConstrainSelectedInstOperands,
     /*  58985 */     // GIR_Coverage, 19796,
     /*  58985 */     GIR_EraseRootFromParent_Done,
     /*  58986 */   // Label 1433: @58986
     /*  58986 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(59028), // Rule ID 19797 //
     /*  58991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59013 */     // (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /*  59013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrm),
     /*  59016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59026 */     GIR_RootConstrainSelectedInstOperands,
     /*  59027 */     // GIR_Coverage, 19797,
     /*  59027 */     GIR_EraseRootFromParent_Done,
     /*  59028 */   // Label 1434: @59028
     /*  59028 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(59066), // Rule ID 19800 //
     /*  59033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59051 */     // (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  59051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  59054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59064 */     GIR_RootConstrainSelectedInstOperands,
     /*  59065 */     // GIR_Coverage, 19800,
     /*  59065 */     GIR_EraseRootFromParent_Done,
     /*  59066 */   // Label 1435: @59066
     /*  59066 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(59104), // Rule ID 19801 //
     /*  59071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59089 */     // (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /*  59089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZrm),
     /*  59092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59102 */     GIR_RootConstrainSelectedInstOperands,
     /*  59103 */     // GIR_Coverage, 19801,
     /*  59103 */     GIR_EraseRootFromParent_Done,
     /*  59104 */   // Label 1436: @59104
     /*  59104 */   GIM_Reject,
     /*  59105 */ // Label 1432: @59105
     /*  59105 */ GIM_Reject,
     /*  59106 */ // Label 1289: @59106
     /*  59106 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(59187),
     /*  59111 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59114 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  59122 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59126 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(59156), // Rule ID 4404 //
     /*  59131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  59134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59141 */     // (ld:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVQkm:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)
     /*  59141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkm),
     /*  59144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59154 */     GIR_RootConstrainSelectedInstOperands,
     /*  59155 */     // GIR_Coverage, 4404,
     /*  59155 */     GIR_EraseRootFromParent_Done,
     /*  59156 */   // Label 1438: @59156
     /*  59156 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(59186), // Rule ID 4408 //
     /*  59161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  59164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59171 */     // (ld:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVQkm_EVEX:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)
     /*  59171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkm_EVEX),
     /*  59174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59184 */     GIR_RootConstrainSelectedInstOperands,
     /*  59185 */     // GIR_Coverage, 4408,
     /*  59185 */     GIR_EraseRootFromParent_Done,
     /*  59186 */   // Label 1439: @59186
     /*  59186 */   GIM_Reject,
     /*  59187 */ // Label 1437: @59187
     /*  59187 */ GIM_Reject,
     /*  59188 */ // Label 1290: @59188
     /*  59188 */ GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(59281),
     /*  59193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59196 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59200 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(59242), // Rule ID 19798 //
     /*  59205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59216 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59227 */     // (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /*  59227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  59230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59232 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59240 */     GIR_RootConstrainSelectedInstOperands,
     /*  59241 */     // GIR_Coverage, 19798,
     /*  59241 */     GIR_EraseRootFromParent_Done,
     /*  59242 */   // Label 1441: @59242
     /*  59242 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(59280), // Rule ID 19802 //
     /*  59247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59265 */     // (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /*  59265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  59268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59278 */     GIR_RootConstrainSelectedInstOperands,
     /*  59279 */     // GIR_Coverage, 19802,
     /*  59279 */     GIR_EraseRootFromParent_Done,
     /*  59280 */   // Label 1442: @59280
     /*  59280 */   GIM_Reject,
     /*  59281 */ // Label 1440: @59281
     /*  59281 */ GIM_Reject,
     /*  59282 */ // Label 1291: @59282
     /*  59282 */ GIM_Reject,
     /*  59283 */ // Label 11: @59283
     /*  59283 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1446*/ GIMT_Encode4(59615),
     /*  59294 */ /*GILLT_s16*//*Label 1443*/ GIMT_Encode4(59306),
     /*  59298 */ /*GILLT_s32*//*Label 1444*/ GIMT_Encode4(59382),
     /*  59302 */ /*GILLT_s64*//*Label 1445*/ GIMT_Encode4(59476),
     /*  59306 */ // Label 1443: @59306
     /*  59306 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(59381), // Rule ID 22645 //
     /*  59311 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59314 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  59325 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59329 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59336 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm8),
     /*  59343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59348 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59352 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59363 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59380 */   // GIR_Coverage, 22645,
     /*  59380 */   GIR_EraseRootFromParent_Done,
     /*  59381 */ // Label 1447: @59381
     /*  59381 */ GIM_Reject,
     /*  59382 */ // Label 1444: @59382
     /*  59382 */ GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(59475),
     /*  59387 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59390 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(59432), // Rule ID 615 //
     /*  59395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59417 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (MOVSX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm8),
     /*  59420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59430 */     GIR_RootConstrainSelectedInstOperands,
     /*  59431 */     // GIR_Coverage, 615,
     /*  59431 */     GIR_EraseRootFromParent_Done,
     /*  59432 */   // Label 1449: @59432
     /*  59432 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(59474), // Rule ID 617 //
     /*  59437 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59459 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (MOVSX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm16),
     /*  59462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59464 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59472 */     GIR_RootConstrainSelectedInstOperands,
     /*  59473 */     // GIR_Coverage, 617,
     /*  59473 */     GIR_EraseRootFromParent_Done,
     /*  59474 */   // Label 1450: @59474
     /*  59474 */   GIM_Reject,
     /*  59475 */ // Label 1448: @59475
     /*  59475 */ GIM_Reject,
     /*  59476 */ // Label 1445: @59476
     /*  59476 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(59614),
     /*  59481 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59484 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(59526), // Rule ID 623 //
     /*  59489 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59511 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (MOVSX64rm8:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm8),
     /*  59514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59524 */     GIR_RootConstrainSelectedInstOperands,
     /*  59525 */     // GIR_Coverage, 623,
     /*  59525 */     GIR_EraseRootFromParent_Done,
     /*  59526 */   // Label 1452: @59526
     /*  59526 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(59568), // Rule ID 625 //
     /*  59531 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59553 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (MOVSX64rm16:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm16),
     /*  59556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59566 */     GIR_RootConstrainSelectedInstOperands,
     /*  59567 */     // GIR_Coverage, 625,
     /*  59567 */     GIR_EraseRootFromParent_Done,
     /*  59568 */   // Label 1453: @59568
     /*  59568 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(59613), // Rule ID 627 //
     /*  59573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  59576 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  59583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59598 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (MOVSX64rm32:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm32),
     /*  59601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59611 */     GIR_RootConstrainSelectedInstOperands,
     /*  59612 */     // GIR_Coverage, 627,
     /*  59612 */     GIR_EraseRootFromParent_Done,
     /*  59613 */   // Label 1454: @59613
     /*  59613 */   GIM_Reject,
     /*  59614 */ // Label 1451: @59614
     /*  59614 */ GIM_Reject,
     /*  59615 */ // Label 1446: @59615
     /*  59615 */ GIM_Reject,
     /*  59616 */ // Label 12: @59616
     /*  59616 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1459*/ GIMT_Encode4(60270),
     /*  59627 */ /*GILLT_s8*//*Label 1455*/ GIMT_Encode4(59643),
     /*  59631 */ /*GILLT_s16*//*Label 1456*/ GIMT_Encode4(59689),
     /*  59635 */ /*GILLT_s32*//*Label 1457*/ GIMT_Encode4(59828),
     /*  59639 */ /*GILLT_s64*//*Label 1458*/ GIMT_Encode4(59964),
     /*  59643 */ // Label 1455: @59643
     /*  59643 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(59688), // Rule ID 22573 //
     /*  59648 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59651 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  59662 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59666 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59673 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  59673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  59676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59678 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59682 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59686 */   GIR_RootConstrainSelectedInstOperands,
     /*  59687 */   // GIR_Coverage, 22573,
     /*  59687 */   GIR_EraseRootFromParent_Done,
     /*  59688 */ // Label 1460: @59688
     /*  59688 */ GIM_Reject,
     /*  59689 */ // Label 1456: @59689
     /*  59689 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(59827),
     /*  59694 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59697 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  59708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59712 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(59769), // Rule ID 22574 //
     /*  59717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59724 */     // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59736 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59740 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59751 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59768 */     // GIR_Coverage, 22574,
     /*  59768 */     GIR_EraseRootFromParent_Done,
     /*  59769 */   // Label 1462: @59769
     /*  59769 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(59826), // Rule ID 22647 //
     /*  59774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59781 */     // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59793 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59797 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59808 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59825 */     // GIR_Coverage, 22647,
     /*  59825 */     GIR_EraseRootFromParent_Done,
     /*  59826 */   // Label 1463: @59826
     /*  59826 */   GIM_Reject,
     /*  59827 */ // Label 1461: @59827
     /*  59827 */ GIM_Reject,
     /*  59828 */ // Label 1457: @59828
     /*  59828 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(59963),
     /*  59833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59836 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(59878), // Rule ID 619 //
     /*  59841 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59863 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59876 */     GIR_RootConstrainSelectedInstOperands,
     /*  59877 */     // GIR_Coverage, 619,
     /*  59877 */     GIR_EraseRootFromParent_Done,
     /*  59878 */   // Label 1465: @59878
     /*  59878 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(59920), // Rule ID 621 //
     /*  59883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59905 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  59908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59918 */     GIR_RootConstrainSelectedInstOperands,
     /*  59919 */     // GIR_Coverage, 621,
     /*  59919 */     GIR_EraseRootFromParent_Done,
     /*  59920 */   // Label 1466: @59920
     /*  59920 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(59962), // Rule ID 22575 //
     /*  59925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59947 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59952 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59960 */     GIR_RootConstrainSelectedInstOperands,
     /*  59961 */     // GIR_Coverage, 22575,
     /*  59961 */     GIR_EraseRootFromParent_Done,
     /*  59962 */   // Label 1467: @59962
     /*  59962 */   GIM_Reject,
     /*  59963 */ // Label 1464: @59963
     /*  59963 */ GIM_Reject,
     /*  59964 */ // Label 1458: @59964
     /*  59964 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(60269),
     /*  59969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59972 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(60046), // Rule ID 17590 //
     /*  59977 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59999 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  59999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60011 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60015 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60045 */     // GIR_Coverage, 17590,
     /*  60045 */     GIR_EraseRootFromParent_Done,
     /*  60046 */   // Label 1469: @60046
     /*  60046 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(60120), // Rule ID 17592 //
     /*  60051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  60058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60073 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  60080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60085 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60089 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60119 */     // GIR_Coverage, 17592,
     /*  60119 */     GIR_EraseRootFromParent_Done,
     /*  60120 */   // Label 1470: @60120
     /*  60120 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(60194), // Rule ID 17594 //
     /*  60125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  60132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60147 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  60154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60159 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60163 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60193 */     // GIR_Coverage, 17594,
     /*  60193 */     GIR_EraseRootFromParent_Done,
     /*  60194 */   // Label 1471: @60194
     /*  60194 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(60268), // Rule ID 22576 //
     /*  60199 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60221 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60233 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60237 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60267 */     // GIR_Coverage, 22576,
     /*  60267 */     GIR_EraseRootFromParent_Done,
     /*  60268 */   // Label 1472: @60268
     /*  60268 */   GIM_Reject,
     /*  60269 */ // Label 1468: @60269
     /*  60269 */ GIM_Reject,
     /*  60270 */ // Label 1459: @60270
     /*  60270 */ GIM_Reject,
     /*  60271 */ // Label 13: @60271
     /*  60271 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 1495*/ GIMT_Encode4(85733),
     /*  60282 */ /*GILLT_s8*//*Label 1473*/ GIMT_Encode4(60378),
     /*  60286 */ /*GILLT_s16*//*Label 1474*/ GIMT_Encode4(65048),
     /*  60290 */ /*GILLT_s32*//*Label 1475*/ GIMT_Encode4(70292),
     /*  60294 */ /*GILLT_s64*//*Label 1476*/ GIMT_Encode4(75992),
     /*  60298 */ /*GILLT_s80*//*Label 1477*/ GIMT_Encode4(81384),
     /*  60302 */ /*GILLT_s128*//*Label 1478*/ GIMT_Encode4(81543), GIMT_Encode4(0),
     /*  60310 */ /*GILLT_v2s64*//*Label 1479*/ GIMT_Encode4(81797), GIMT_Encode4(0),
     /*  60318 */ /*GILLT_v4s32*//*Label 1480*/ GIMT_Encode4(82291),
     /*  60322 */ /*GILLT_v4s64*//*Label 1481*/ GIMT_Encode4(82785),
     /*  60326 */ /*GILLT_v8s1*//*Label 1482*/ GIMT_Encode4(83119),
     /*  60330 */ /*GILLT_v8s16*//*Label 1483*/ GIMT_Encode4(83201),
     /*  60334 */ /*GILLT_v8s32*//*Label 1484*/ GIMT_Encode4(83775),
     /*  60338 */ /*GILLT_v8s64*//*Label 1485*/ GIMT_Encode4(84109),
     /*  60342 */ /*GILLT_v16s1*//*Label 1486*/ GIMT_Encode4(84283),
     /*  60346 */ /*GILLT_v16s8*//*Label 1487*/ GIMT_Encode4(84365),
     /*  60350 */ /*GILLT_v16s16*//*Label 1488*/ GIMT_Encode4(84619),
     /*  60354 */ /*GILLT_v16s32*//*Label 1489*/ GIMT_Encode4(84953),
     /*  60358 */ /*GILLT_v32s1*//*Label 1490*/ GIMT_Encode4(85127),
     /*  60362 */ /*GILLT_v32s8*//*Label 1491*/ GIMT_Encode4(85209),
     /*  60366 */ /*GILLT_v32s16*//*Label 1492*/ GIMT_Encode4(85383),
     /*  60370 */ /*GILLT_v64s1*//*Label 1493*/ GIMT_Encode4(85557),
     /*  60374 */ /*GILLT_v64s8*//*Label 1494*/ GIMT_Encode4(85639),
     /*  60378 */ // Label 1473: @60378
     /*  60378 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(60474), // Rule ID 22490 //
     /*  60383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60386 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60389 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60396 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60400 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60404 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60408 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60412 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60416 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60420 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60423 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60427 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60434 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60438 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  60442 */   // MIs[0] dst
     /*  60442 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60447 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60449 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60456 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, 1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (INC8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8m),
     /*  60459 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60463 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60466 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60472 */   GIR_RootConstrainSelectedInstOperands,
     /*  60473 */   // GIR_Coverage, 22490,
     /*  60473 */   GIR_EraseRootFromParent_Done,
     /*  60474 */ // Label 1496: @60474
     /*  60474 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(60570), // Rule ID 22494 //
     /*  60479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60482 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60485 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60492 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60496 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60500 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60504 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60508 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60512 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60516 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60519 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60523 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60530 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60534 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60538 */   // MIs[0] dst
     /*  60538 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60543 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60545 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60552 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (DEC8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8m),
     /*  60555 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60559 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60562 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60568 */   GIR_RootConstrainSelectedInstOperands,
     /*  60569 */   // GIR_Coverage, 22494,
     /*  60569 */   GIR_EraseRootFromParent_Done,
     /*  60570 */ // Label 1497: @60570
     /*  60570 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(60663), // Rule ID 22498 //
     /*  60575 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60578 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  60593 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60597 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60601 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  60605 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60609 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60613 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60620 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60627 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60631 */   // MIs[0] dst
     /*  60631 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60636 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60638 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60645 */   // (atomic_store (sub:{ *:[i8] } 0:{ *:[i8] }, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (NEG8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8m),
     /*  60648 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60652 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60661 */   GIR_RootConstrainSelectedInstOperands,
     /*  60662 */   // GIR_Coverage, 22498,
     /*  60662 */   GIR_EraseRootFromParent_Done,
     /*  60663 */ // Label 1498: @60663
     /*  60663 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(60753), // Rule ID 22502 //
     /*  60668 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60671 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60678 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60682 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60686 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60690 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60694 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60698 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60702 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60705 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60709 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60716 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60720 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60724 */   // MIs[0] dst
     /*  60724 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60729 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60731 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60738 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (NOT8m addr:{ *:[iPTR] }:$dst)
     /*  60738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m),
     /*  60741 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60751 */   GIR_RootConstrainSelectedInstOperands,
     /*  60752 */   // GIR_Coverage, 22502,
     /*  60752 */   GIR_EraseRootFromParent_Done,
     /*  60753 */ // Label 1499: @60753
     /*  60753 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(60839), // Rule ID 225 //
     /*  60758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60764 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60768 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60772 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60776 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60780 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60784 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60788 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60792 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60795 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60799 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  60803 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  60807 */   // MIs[0] src1
     /*  60807 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60812 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60814 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60821 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  60821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8m),
     /*  60824 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  60828 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60837 */   GIR_RootConstrainSelectedInstOperands,
     /*  60838 */   // GIR_Coverage, 225,
     /*  60838 */   GIR_EraseRootFromParent_Done,
     /*  60839 */ // Label 1500: @60839
     /*  60839 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(60925), // Rule ID 228 //
     /*  60844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60847 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60850 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60854 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60862 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60866 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60870 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60874 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60878 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60881 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60885 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  60889 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60893 */   // MIs[0] src1
     /*  60893 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60898 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60900 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60907 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  60907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8m),
     /*  60910 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  60914 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60917 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60923 */   GIR_RootConstrainSelectedInstOperands,
     /*  60924 */   // GIR_Coverage, 228,
     /*  60924 */   GIR_EraseRootFromParent_Done,
     /*  60925 */ // Label 1501: @60925
     /*  60925 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(61008), // Rule ID 17611 //
     /*  60930 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60933 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  60945 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60949 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60953 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60957 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60961 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60964 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60968 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  60972 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 7,
     /*  60976 */   // MIs[0] dst
     /*  60976 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60981 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60983 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60990 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8m1),
     /*  60993 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60997 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61006 */   GIR_RootConstrainSelectedInstOperands,
     /*  61007 */   // GIR_Coverage, 17611,
     /*  61007 */   GIR_EraseRootFromParent_Done,
     /*  61008 */ // Label 1502: @61008
     /*  61008 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(61091), // Rule ID 17615 //
     /*  61013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61016 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61020 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61024 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  61028 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61032 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61036 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61040 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61044 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61047 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61051 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61055 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 7,
     /*  61059 */   // MIs[0] dst
     /*  61059 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61064 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61066 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61073 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  61073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8m1),
     /*  61076 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61080 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61089 */   GIR_RootConstrainSelectedInstOperands,
     /*  61090 */   // GIR_Coverage, 17615,
     /*  61090 */   GIR_EraseRootFromParent_Done,
     /*  61091 */ // Label 1503: @61091
     /*  61091 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(61174), // Rule ID 261 //
     /*  61096 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61099 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61111 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61115 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61119 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  61123 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61127 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61131 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61134 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61138 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61142 */   // MIs[0] src1
     /*  61142 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61147 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61149 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61156 */   // (st (sub:{ *:[i8] } 0:{ *:[i8] }, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  61156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8m),
     /*  61159 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61163 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61166 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61172 */   GIR_RootConstrainSelectedInstOperands,
     /*  61173 */   // GIR_Coverage, 261,
     /*  61173 */   GIR_EraseRootFromParent_Done,
     /*  61174 */ // Label 1504: @61174
     /*  61174 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(61254), // Rule ID 269 //
     /*  61179 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61182 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61194 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61198 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61202 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61206 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61210 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61213 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61217 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61221 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61225 */   // MIs[0] src1
     /*  61225 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61230 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61232 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61239 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT8m addr:{ *:[iPTR] }:$src1)
     /*  61239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m),
     /*  61242 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61252 */   GIR_RootConstrainSelectedInstOperands,
     /*  61253 */   // GIR_Coverage, 269,
     /*  61253 */   GIR_EraseRootFromParent_Done,
     /*  61254 */ // Label 1505: @61254
     /*  61254 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(61349), // Rule ID 413 //
     /*  61259 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61262 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61266 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61270 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61274 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61278 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61282 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61286 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61290 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61293 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61297 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61301 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61305 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61309 */   // MIs[3] Operand 1
     /*  61309 */   // No operand predicates
     /*  61309 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61313 */   // MIs[0] src1
     /*  61313 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61318 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61320 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61327 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mi),
     /*  61330 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61334 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61337 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61340 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61347 */   GIR_RootConstrainSelectedInstOperands,
     /*  61348 */   // GIR_Coverage, 413,
     /*  61348 */   GIR_EraseRootFromParent_Done,
     /*  61349 */ // Label 1506: @61349
     /*  61349 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(61444), // Rule ID 305 //
     /*  61354 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61357 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61361 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61365 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61369 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61373 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61377 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61381 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61385 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61392 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61396 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61400 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61404 */   // MIs[3] Operand 1
     /*  61404 */   // No operand predicates
     /*  61404 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61408 */   // MIs[0] src1
     /*  61408 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61413 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61415 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61422 */   // (st (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mi),
     /*  61425 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61429 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61432 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61435 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61442 */   GIR_RootConstrainSelectedInstOperands,
     /*  61443 */   // GIR_Coverage, 305,
     /*  61443 */   GIR_EraseRootFromParent_Done,
     /*  61444 */ // Label 1507: @61444
     /*  61444 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(61539), // Rule ID 341 //
     /*  61449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61452 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61456 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61460 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  61464 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61468 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61472 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61476 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61480 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61483 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61487 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61491 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61495 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61499 */   // MIs[3] Operand 1
     /*  61499 */   // No operand predicates
     /*  61499 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61503 */   // MIs[0] src1
     /*  61503 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61508 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61510 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61517 */   // (st (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mi),
     /*  61520 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61524 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61527 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61530 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61537 */   GIR_RootConstrainSelectedInstOperands,
     /*  61538 */   // GIR_Coverage, 341,
     /*  61538 */   GIR_EraseRootFromParent_Done,
     /*  61539 */ // Label 1508: @61539
     /*  61539 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(61634), // Rule ID 453 //
     /*  61544 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61547 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61551 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61555 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61559 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61563 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61567 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61571 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61575 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61578 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61582 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61586 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61590 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61594 */   // MIs[3] Operand 1
     /*  61594 */   // No operand predicates
     /*  61594 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61598 */   // MIs[0] src1
     /*  61598 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61603 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61605 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61612 */   // (st (sub:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mi),
     /*  61615 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61619 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61622 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61632 */   GIR_RootConstrainSelectedInstOperands,
     /*  61633 */   // GIR_Coverage, 453,
     /*  61633 */   GIR_EraseRootFromParent_Done,
     /*  61634 */ // Label 1509: @61634
     /*  61634 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(61729), // Rule ID 377 //
     /*  61639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61642 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61646 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61650 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61654 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61658 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61662 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61666 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61670 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61673 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61677 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61681 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61685 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61689 */   // MIs[3] Operand 1
     /*  61689 */   // No operand predicates
     /*  61689 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61693 */   // MIs[0] src1
     /*  61693 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61698 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61700 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61707 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mi),
     /*  61710 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61714 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61717 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61720 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61727 */   GIR_RootConstrainSelectedInstOperands,
     /*  61728 */   // GIR_Coverage, 377,
     /*  61728 */   GIR_EraseRootFromParent_Done,
     /*  61729 */ // Label 1510: @61729
     /*  61729 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(61830), // Rule ID 22426 //
     /*  61734 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61737 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61744 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61748 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61752 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61756 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61760 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61764 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61768 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61771 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61775 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61782 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61786 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61790 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61794 */   // MIs[3] Operand 1
     /*  61794 */   // No operand predicates
     /*  61794 */   // MIs[0] dst
     /*  61794 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61799 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61801 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61808 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  61808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mi),
     /*  61811 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61815 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  61818 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61821 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61828 */   GIR_RootConstrainSelectedInstOperands,
     /*  61829 */   // GIR_Coverage, 22426,
     /*  61829 */   GIR_EraseRootFromParent_Done,
     /*  61830 */ // Label 1511: @61830
     /*  61830 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(61931), // Rule ID 22434 //
     /*  61835 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61838 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61845 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61849 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61853 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61857 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61861 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61865 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61869 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61872 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61876 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61883 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61887 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61891 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61895 */   // MIs[3] Operand 1
     /*  61895 */   // No operand predicates
     /*  61895 */   // MIs[0] dst
     /*  61895 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61900 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61902 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61909 */   // (atomic_store (and:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  61909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mi),
     /*  61912 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61916 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  61919 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61922 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61929 */   GIR_RootConstrainSelectedInstOperands,
     /*  61930 */   // GIR_Coverage, 22434,
     /*  61930 */   GIR_EraseRootFromParent_Done,
     /*  61931 */ // Label 1512: @61931
     /*  61931 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(62032), // Rule ID 22442 //
     /*  61936 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61946 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  61954 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61958 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61962 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61966 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61970 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61973 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61977 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61984 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61988 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61992 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61996 */   // MIs[3] Operand 1
     /*  61996 */   // No operand predicates
     /*  61996 */   // MIs[0] dst
     /*  61996 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62001 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62003 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62010 */   // (atomic_store (or:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mi),
     /*  62013 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62017 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62020 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62030 */   GIR_RootConstrainSelectedInstOperands,
     /*  62031 */   // GIR_Coverage, 22442,
     /*  62031 */   GIR_EraseRootFromParent_Done,
     /*  62032 */ // Label 1513: @62032
     /*  62032 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(62133), // Rule ID 22458 //
     /*  62037 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62040 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62047 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62051 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  62055 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62059 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62063 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62067 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62071 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62074 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62078 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62085 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62089 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62093 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62097 */   // MIs[3] Operand 1
     /*  62097 */   // No operand predicates
     /*  62097 */   // MIs[0] dst
     /*  62097 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62102 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62104 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62111 */   // (atomic_store (sub:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (SUB8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mi),
     /*  62114 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62118 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62121 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62124 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62131 */   GIR_RootConstrainSelectedInstOperands,
     /*  62132 */   // GIR_Coverage, 22458,
     /*  62132 */   GIR_EraseRootFromParent_Done,
     /*  62133 */ // Label 1514: @62133
     /*  62133 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(62234), // Rule ID 22450 //
     /*  62138 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62141 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62156 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62160 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62164 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62168 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62172 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62175 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62179 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62186 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62190 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62194 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62198 */   // MIs[3] Operand 1
     /*  62198 */   // No operand predicates
     /*  62198 */   // MIs[0] dst
     /*  62198 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62203 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62205 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62212 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mi),
     /*  62215 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62219 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62222 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62232 */   GIR_RootConstrainSelectedInstOperands,
     /*  62233 */   // GIR_Coverage, 22450,
     /*  62233 */   GIR_EraseRootFromParent_Done,
     /*  62234 */ // Label 1515: @62234
     /*  62234 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(62325), // Rule ID 732 //
     /*  62239 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62242 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62246 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62250 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  62254 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62258 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62262 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62266 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62270 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62273 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62277 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62281 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62285 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62289 */   // MIs[3] Operand 1
     /*  62289 */   // No operand predicates
     /*  62289 */   // MIs[0] src1
     /*  62289 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62294 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62296 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62303 */   // (st (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mi),
     /*  62306 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62310 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62313 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62323 */   GIR_RootConstrainSelectedInstOperands,
     /*  62324 */   // GIR_Coverage, 732,
     /*  62324 */   GIR_EraseRootFromParent_Done,
     /*  62325 */ // Label 1516: @62325
     /*  62325 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(62416), // Rule ID 700 //
     /*  62330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62333 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62337 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62341 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62345 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62349 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62353 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62357 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62361 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62364 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62368 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62372 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62376 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62380 */   // MIs[3] Operand 1
     /*  62380 */   // No operand predicates
     /*  62380 */   // MIs[0] src1
     /*  62380 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62385 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62387 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62394 */   // (st (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mi),
     /*  62397 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62401 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62404 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62407 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62414 */   GIR_RootConstrainSelectedInstOperands,
     /*  62415 */   // GIR_Coverage, 700,
     /*  62415 */   GIR_EraseRootFromParent_Done,
     /*  62416 */ // Label 1517: @62416
     /*  62416 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(62507), // Rule ID 764 //
     /*  62421 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62424 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62428 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  62436 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62440 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62444 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62448 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62452 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62455 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62459 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62463 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62467 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62471 */   // MIs[3] Operand 1
     /*  62471 */   // No operand predicates
     /*  62471 */   // MIs[0] src1
     /*  62471 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62476 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62478 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62485 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mi),
     /*  62488 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62492 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62495 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62498 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62505 */   GIR_RootConstrainSelectedInstOperands,
     /*  62506 */   // GIR_Coverage, 764,
     /*  62506 */   GIR_EraseRootFromParent_Done,
     /*  62507 */ // Label 1518: @62507
     /*  62507 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(62598), // Rule ID 796 //
     /*  62512 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62515 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62519 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62523 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  62527 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62531 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62535 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62539 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62543 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62546 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62550 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62554 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62558 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62562 */   // MIs[3] Operand 1
     /*  62562 */   // No operand predicates
     /*  62562 */   // MIs[0] src1
     /*  62562 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62567 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62569 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62576 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mi),
     /*  62579 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62583 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62586 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62596 */   GIR_RootConstrainSelectedInstOperands,
     /*  62597 */   // GIR_Coverage, 796,
     /*  62597 */   GIR_EraseRootFromParent_Done,
     /*  62598 */ // Label 1519: @62598
     /*  62598 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(62689), // Rule ID 668 //
     /*  62603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62606 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  62618 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62622 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62626 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62630 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62634 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62637 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62641 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62645 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62649 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62653 */   // MIs[3] Operand 1
     /*  62653 */   // No operand predicates
     /*  62653 */   // MIs[0] src1
     /*  62653 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62658 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62660 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62667 */   // (st (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mi),
     /*  62670 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62674 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62677 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62680 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62687 */   GIR_RootConstrainSelectedInstOperands,
     /*  62688 */   // GIR_Coverage, 668,
     /*  62688 */   GIR_EraseRootFromParent_Done,
     /*  62689 */ // Label 1520: @62689
     /*  62689 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(62787), // Rule ID 22430 //
     /*  62694 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62697 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  62712 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62716 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62720 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62724 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62728 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62731 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62735 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62742 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62746 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62751 */   // MIs[0] dst
     /*  62751 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62756 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62758 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62765 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  62768 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62772 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  62776 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62779 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  62785 */   GIR_RootConstrainSelectedInstOperands,
     /*  62786 */   // GIR_Coverage, 22430,
     /*  62786 */   GIR_EraseRootFromParent_Done,
     /*  62787 */ // Label 1521: @62787
     /*  62787 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(62885), // Rule ID 25999 //
     /*  62792 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62795 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62802 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62806 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  62810 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62814 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62818 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62823 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62827 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62831 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62838 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62845 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62849 */   // MIs[0] dst
     /*  62849 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62854 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62856 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62863 */   // (atomic_store (add:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  62866 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62870 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  62874 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  62883 */   GIR_RootConstrainSelectedInstOperands,
     /*  62884 */   // GIR_Coverage, 25999,
     /*  62884 */   GIR_EraseRootFromParent_Done,
     /*  62885 */ // Label 1522: @62885
     /*  62885 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(62983), // Rule ID 22438 //
     /*  62890 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62893 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62908 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62912 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62916 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62920 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62924 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62927 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62931 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62938 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62942 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62947 */   // MIs[0] dst
     /*  62947 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62952 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62954 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62961 */   // (atomic_store (and:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  62964 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62968 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  62972 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62975 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  62981 */   GIR_RootConstrainSelectedInstOperands,
     /*  62982 */   // GIR_Coverage, 22438,
     /*  62982 */   GIR_EraseRootFromParent_Done,
     /*  62983 */ // Label 1523: @62983
     /*  62983 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(63081), // Rule ID 26003 //
     /*  62988 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62991 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63006 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63010 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63014 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63019 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63023 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63027 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63030 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63034 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63041 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63045 */   // MIs[0] dst
     /*  63045 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63050 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63052 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63059 */   // (atomic_store (and:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63062 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63066 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63070 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63073 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63079 */   GIR_RootConstrainSelectedInstOperands,
     /*  63080 */   // GIR_Coverage, 26003,
     /*  63080 */   GIR_EraseRootFromParent_Done,
     /*  63081 */ // Label 1524: @63081
     /*  63081 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(63179), // Rule ID 22446 //
     /*  63086 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63089 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63096 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63100 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  63104 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63108 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63112 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63116 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63120 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63123 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63127 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63134 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63138 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63143 */   // MIs[0] dst
     /*  63143 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63148 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63150 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63157 */   // (atomic_store (or:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  63160 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63164 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63168 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63171 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63177 */   GIR_RootConstrainSelectedInstOperands,
     /*  63178 */   // GIR_Coverage, 22446,
     /*  63178 */   GIR_EraseRootFromParent_Done,
     /*  63179 */ // Label 1525: @63179
     /*  63179 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(63277), // Rule ID 26007 //
     /*  63184 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63187 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63194 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63198 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  63202 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63206 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63210 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63215 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63219 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63223 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63226 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63230 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63237 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63241 */   // MIs[0] dst
     /*  63241 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63246 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63248 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63255 */   // (atomic_store (or:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  63258 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63262 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63266 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63275 */   GIR_RootConstrainSelectedInstOperands,
     /*  63276 */   // GIR_Coverage, 26007,
     /*  63276 */   GIR_EraseRootFromParent_Done,
     /*  63277 */ // Label 1526: @63277
     /*  63277 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(63375), // Rule ID 22462 //
     /*  63282 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63285 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  63300 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63304 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63308 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63312 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63316 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63319 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63323 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63330 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63334 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63339 */   // MIs[0] dst
     /*  63339 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63344 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63346 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63353 */   // (atomic_store (sub:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (SUB8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mr),
     /*  63356 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63360 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63364 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63373 */   GIR_RootConstrainSelectedInstOperands,
     /*  63374 */   // GIR_Coverage, 22462,
     /*  63374 */   GIR_EraseRootFromParent_Done,
     /*  63375 */ // Label 1527: @63375
     /*  63375 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(63473), // Rule ID 22454 //
     /*  63380 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63383 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63398 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63402 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63406 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63410 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63414 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63417 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63421 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63428 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63432 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63437 */   // MIs[0] dst
     /*  63437 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63442 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63444 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63451 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  63454 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63458 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63462 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63465 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63471 */   GIR_RootConstrainSelectedInstOperands,
     /*  63472 */   // GIR_Coverage, 22454,
     /*  63472 */   GIR_EraseRootFromParent_Done,
     /*  63473 */ // Label 1528: @63473
     /*  63473 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(63571), // Rule ID 26011 //
     /*  63478 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63481 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63488 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63492 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63496 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63500 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63504 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63509 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63513 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63517 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63520 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63524 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63531 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63535 */   // MIs[0] dst
     /*  63535 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63540 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63542 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63549 */   // (atomic_store (xor:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  63552 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63556 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63560 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63563 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63569 */   GIR_RootConstrainSelectedInstOperands,
     /*  63570 */   // GIR_Coverage, 26011,
     /*  63570 */   GIR_EraseRootFromParent_Done,
     /*  63571 */ // Label 1529: @63571
     /*  63571 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(63659), // Rule ID 409 //
     /*  63576 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63579 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63591 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63595 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63599 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63603 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63607 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63610 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63614 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63618 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63623 */   // MIs[0] src1
     /*  63623 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63628 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63630 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63637 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63640 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63644 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  63648 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63657 */   GIR_RootConstrainSelectedInstOperands,
     /*  63658 */   // GIR_Coverage, 409,
     /*  63658 */   GIR_EraseRootFromParent_Done,
     /*  63659 */ // Label 1530: @63659
     /*  63659 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(63747), // Rule ID 23219 //
     /*  63664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63671 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63675 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63679 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63683 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63687 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63692 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63696 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63700 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63703 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63707 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63711 */   // MIs[0] src1
     /*  63711 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63716 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63718 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63725 */   // (st (add:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63728 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63732 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  63736 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63739 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63745 */   GIR_RootConstrainSelectedInstOperands,
     /*  63746 */   // GIR_Coverage, 23219,
     /*  63746 */   GIR_EraseRootFromParent_Done,
     /*  63747 */ // Label 1531: @63747
     /*  63747 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(63835), // Rule ID 301 //
     /*  63752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63755 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63759 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63767 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63771 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63775 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63779 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63783 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63786 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63790 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63794 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63799 */   // MIs[0] src1
     /*  63799 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63804 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63806 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63813 */   // (st (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63816 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63820 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  63824 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63827 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63833 */   GIR_RootConstrainSelectedInstOperands,
     /*  63834 */   // GIR_Coverage, 301,
     /*  63834 */   GIR_EraseRootFromParent_Done,
     /*  63835 */ // Label 1532: @63835
     /*  63835 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(63923), // Rule ID 23183 //
     /*  63840 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63843 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63847 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63855 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63859 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63863 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63868 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63872 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63876 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63879 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63883 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63887 */   // MIs[0] src1
     /*  63887 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63892 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63894 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63901 */   // (st (and:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63904 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63908 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  63912 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63921 */   GIR_RootConstrainSelectedInstOperands,
     /*  63922 */   // GIR_Coverage, 23183,
     /*  63922 */   GIR_EraseRootFromParent_Done,
     /*  63923 */ // Label 1533: @63923
     /*  63923 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(64021), // Rule ID 748 //
     /*  63928 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63931 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63935 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  63943 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63947 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63951 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63955 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63959 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63962 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63966 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  63970 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  63975 */   // MIs[0] src1
     /*  63975 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63980 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63982 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63989 */   // (st (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  63989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63993 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63999 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mCL),
     /*  64006 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64010 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64013 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64019 */   GIR_RootConstrainSelectedInstOperands,
     /*  64020 */   // GIR_Coverage, 748,
     /*  64020 */   GIR_EraseRootFromParent_Done,
     /*  64021 */ // Label 1534: @64021
     /*  64021 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(64119), // Rule ID 716 //
     /*  64026 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64029 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64033 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64037 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64041 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64045 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64049 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64053 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64057 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64060 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64064 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64068 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64073 */   // MIs[0] src1
     /*  64073 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64078 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64080 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64087 */   // (st (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64091 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64097 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mCL),
     /*  64104 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64108 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64117 */   GIR_RootConstrainSelectedInstOperands,
     /*  64118 */   // GIR_Coverage, 716,
     /*  64118 */   GIR_EraseRootFromParent_Done,
     /*  64119 */ // Label 1535: @64119
     /*  64119 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(64207), // Rule ID 337 //
     /*  64124 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64131 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64135 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  64139 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64143 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64147 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64151 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64155 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64158 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64162 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64166 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64171 */   // MIs[0] src1
     /*  64171 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64176 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64178 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64185 */   // (st (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  64188 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64192 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64196 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64199 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64205 */   GIR_RootConstrainSelectedInstOperands,
     /*  64206 */   // GIR_Coverage, 337,
     /*  64206 */   GIR_EraseRootFromParent_Done,
     /*  64207 */ // Label 1536: @64207
     /*  64207 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(64295), // Rule ID 23195 //
     /*  64212 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64215 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64219 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64223 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  64227 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64231 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64235 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64240 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64244 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64248 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64251 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64255 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64259 */   // MIs[0] src1
     /*  64259 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64264 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64266 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64273 */   // (st (or:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  64276 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64280 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  64284 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64293 */   GIR_RootConstrainSelectedInstOperands,
     /*  64294 */   // GIR_Coverage, 23195,
     /*  64294 */   GIR_EraseRootFromParent_Done,
     /*  64295 */ // Label 1537: @64295
     /*  64295 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(64393), // Rule ID 780 //
     /*  64300 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64303 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64307 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64311 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  64315 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64319 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64323 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64327 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64331 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64334 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64338 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64342 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64347 */   // MIs[0] src1
     /*  64347 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64352 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64354 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64361 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64361 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64365 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64371 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mCL),
     /*  64378 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64382 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64385 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64391 */   GIR_RootConstrainSelectedInstOperands,
     /*  64392 */   // GIR_Coverage, 780,
     /*  64392 */   GIR_EraseRootFromParent_Done,
     /*  64393 */ // Label 1538: @64393
     /*  64393 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(64491), // Rule ID 812 //
     /*  64398 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64401 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64405 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64409 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  64413 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64417 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64421 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64425 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64429 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64432 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64436 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64440 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64445 */   // MIs[0] src1
     /*  64445 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64450 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64452 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64459 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64459 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64463 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64469 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mCL),
     /*  64476 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64480 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64489 */   GIR_RootConstrainSelectedInstOperands,
     /*  64490 */   // GIR_Coverage, 812,
     /*  64490 */   GIR_EraseRootFromParent_Done,
     /*  64491 */ // Label 1539: @64491
     /*  64491 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(64589), // Rule ID 684 //
     /*  64496 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64499 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64503 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64507 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  64511 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64515 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64519 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64523 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64527 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64530 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64534 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64538 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64543 */   // MIs[0] src1
     /*  64543 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64548 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64550 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64557 */   // (st (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64557 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64561 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64567 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mCL),
     /*  64574 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64578 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64581 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64587 */   GIR_RootConstrainSelectedInstOperands,
     /*  64588 */   // GIR_Coverage, 684,
     /*  64588 */   GIR_EraseRootFromParent_Done,
     /*  64589 */ // Label 1540: @64589
     /*  64589 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(64677), // Rule ID 445 //
     /*  64594 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64597 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64601 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64605 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  64609 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64613 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64617 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64621 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64625 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64628 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64632 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64636 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64641 */   // MIs[0] src1
     /*  64641 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64646 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64648 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64655 */   // (st (sub:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mr),
     /*  64658 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64662 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64666 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64669 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64675 */   GIR_RootConstrainSelectedInstOperands,
     /*  64676 */   // GIR_Coverage, 445,
     /*  64676 */   GIR_EraseRootFromParent_Done,
     /*  64677 */ // Label 1541: @64677
     /*  64677 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(64765), // Rule ID 373 //
     /*  64682 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64685 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64697 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64701 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64705 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64709 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64713 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64716 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64720 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64724 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64729 */   // MIs[0] src1
     /*  64729 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64734 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64736 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64743 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  64746 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64750 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64754 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64757 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64763 */   GIR_RootConstrainSelectedInstOperands,
     /*  64764 */   // GIR_Coverage, 373,
     /*  64764 */   GIR_EraseRootFromParent_Done,
     /*  64765 */ // Label 1542: @64765
     /*  64765 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(64853), // Rule ID 23207 //
     /*  64770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64777 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64785 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64789 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64793 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64798 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64802 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64806 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64809 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64813 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64817 */   // MIs[0] src1
     /*  64817 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64822 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64824 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64831 */   // (st (xor:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  64834 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64838 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  64842 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64845 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64851 */   GIR_RootConstrainSelectedInstOperands,
     /*  64852 */   // GIR_Coverage, 23207,
     /*  64852 */   GIR_EraseRootFromParent_Done,
     /*  64853 */ // Label 1543: @64853
     /*  64853 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(64907), // Rule ID 24 //
     /*  64858 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64861 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64865 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64873 */   // MIs[1] Operand 1
     /*  64873 */   // No operand predicates
     /*  64873 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  64877 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  64881 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64883 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64890 */   // (st (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV8mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  64890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mi),
     /*  64893 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  64897 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  64900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  64905 */   GIR_RootConstrainSelectedInstOperands,
     /*  64906 */   // GIR_Coverage, 24,
     /*  64906 */   GIR_EraseRootFromParent_Done,
     /*  64907 */ // Label 1544: @64907
     /*  64907 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(64960), // Rule ID 22506 //
     /*  64912 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  64915 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  64922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64930 */   // MIs[1] Operand 1
     /*  64930 */   // No operand predicates
     /*  64930 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  64934 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64936 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64943 */   // (atomic_store (imm:{ *:[i8] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (MOV8mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  64943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mi),
     /*  64946 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  64950 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  64953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  64958 */   GIR_RootConstrainSelectedInstOperands,
     /*  64959 */   // GIR_Coverage, 22506,
     /*  64959 */   GIR_EraseRootFromParent_Done,
     /*  64960 */ // Label 1545: @64960
     /*  64960 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(65005), // Rule ID 22510 //
     /*  64965 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  64968 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  64975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64979 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  64983 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64990 */   // (atomic_store GR8:{ *:[i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (MOV8mr addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  64990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mr),
     /*  64993 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  64997 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  64999 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  65003 */   GIR_RootConstrainSelectedInstOperands,
     /*  65004 */   // GIR_Coverage, 22510,
     /*  65004 */   GIR_EraseRootFromParent_Done,
     /*  65005 */ // Label 1546: @65005
     /*  65005 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(65047), // Rule ID 32 //
     /*  65010 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65013 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  65021 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65025 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65032 */   // (st GR8:{ *:[i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV8mr addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  65032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mr),
     /*  65035 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65039 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  65041 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  65045 */   GIR_RootConstrainSelectedInstOperands,
     /*  65046 */   // GIR_Coverage, 32,
     /*  65046 */   GIR_EraseRootFromParent_Done,
     /*  65047 */ // Label 1547: @65047
     /*  65047 */ GIM_Reject,
     /*  65048 */ // Label 1474: @65048
     /*  65048 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(65144), // Rule ID 22491 //
     /*  65053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65056 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65059 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65066 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65070 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65074 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65078 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65082 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65086 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65090 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65093 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65097 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65104 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65108 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  65112 */   // MIs[0] dst
     /*  65112 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65117 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65119 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65126 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, 1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (INC16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16m),
     /*  65129 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65133 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65136 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65142 */   GIR_RootConstrainSelectedInstOperands,
     /*  65143 */   // GIR_Coverage, 22491,
     /*  65143 */   GIR_EraseRootFromParent_Done,
     /*  65144 */ // Label 1548: @65144
     /*  65144 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(65240), // Rule ID 22495 //
     /*  65149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65152 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65155 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65170 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65174 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65178 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65182 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65186 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65189 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65193 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65200 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65204 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65208 */   // MIs[0] dst
     /*  65208 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65213 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65215 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65222 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (DEC16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16m),
     /*  65225 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65229 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65238 */   GIR_RootConstrainSelectedInstOperands,
     /*  65239 */   // GIR_Coverage, 22495,
     /*  65239 */   GIR_EraseRootFromParent_Done,
     /*  65240 */ // Label 1549: @65240
     /*  65240 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(65333), // Rule ID 22499 //
     /*  65245 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65255 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65259 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  65263 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65267 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65271 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  65275 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65279 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65283 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65286 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65290 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65297 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65301 */   // MIs[0] dst
     /*  65301 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65306 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65308 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65315 */   // (atomic_store (sub:{ *:[i16] } 0:{ *:[i16] }, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (NEG16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16m),
     /*  65318 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65322 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65325 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65331 */   GIR_RootConstrainSelectedInstOperands,
     /*  65332 */   // GIR_Coverage, 22499,
     /*  65332 */   GIR_EraseRootFromParent_Done,
     /*  65333 */ // Label 1550: @65333
     /*  65333 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(65423), // Rule ID 22503 //
     /*  65338 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65341 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65348 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65352 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65356 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65360 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65364 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65368 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65372 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65375 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65379 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65386 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65390 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65394 */   // MIs[0] dst
     /*  65394 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65399 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65401 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65408 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (NOT16m addr:{ *:[iPTR] }:$dst)
     /*  65408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m),
     /*  65411 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65415 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65421 */   GIR_RootConstrainSelectedInstOperands,
     /*  65422 */   // GIR_Coverage, 22503,
     /*  65422 */   GIR_EraseRootFromParent_Done,
     /*  65423 */ // Label 1551: @65423
     /*  65423 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(65509), // Rule ID 226 //
     /*  65428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65431 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65434 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65438 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65442 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65446 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65450 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65454 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65458 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65462 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65465 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65469 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65473 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  65477 */   // MIs[0] src1
     /*  65477 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65482 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65484 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65491 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16m),
     /*  65494 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65498 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65501 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65507 */   GIR_RootConstrainSelectedInstOperands,
     /*  65508 */   // GIR_Coverage, 226,
     /*  65508 */   GIR_EraseRootFromParent_Done,
     /*  65509 */ // Label 1552: @65509
     /*  65509 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(65595), // Rule ID 229 //
     /*  65514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65520 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65524 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65528 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65532 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65536 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65540 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65544 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65548 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65551 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65555 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65559 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65563 */   // MIs[0] src1
     /*  65563 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65568 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65570 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65577 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16m),
     /*  65580 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65584 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65587 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65593 */   GIR_RootConstrainSelectedInstOperands,
     /*  65594 */   // GIR_Coverage, 229,
     /*  65594 */   GIR_EraseRootFromParent_Done,
     /*  65595 */ // Label 1553: @65595
     /*  65595 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(65688), // Rule ID 22611 //
     /*  65600 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65603 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65607 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65611 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65615 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65619 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65623 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65627 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65631 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65634 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65638 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65642 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  65653 */   // MIs[0] dst
     /*  65653 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65658 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65660 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65667 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i16] })
     /*  65667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  65670 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  65677 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65680 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65686 */   GIR_RootConstrainSelectedInstOperands,
     /*  65687 */   // GIR_Coverage, 22611,
     /*  65687 */   GIR_EraseRootFromParent_Done,
     /*  65688 */ // Label 1554: @65688
     /*  65688 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(65771), // Rule ID 17612 //
     /*  65693 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65696 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65700 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65704 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  65708 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65712 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  65716 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65720 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65724 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65727 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65731 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65735 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 15,
     /*  65739 */   // MIs[0] dst
     /*  65739 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65744 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65746 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65753 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16m1),
     /*  65756 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65760 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65763 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65769 */   GIR_RootConstrainSelectedInstOperands,
     /*  65770 */   // GIR_Coverage, 17612,
     /*  65770 */   GIR_EraseRootFromParent_Done,
     /*  65771 */ // Label 1555: @65771
     /*  65771 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(65854), // Rule ID 17616 //
     /*  65776 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65779 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65783 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65787 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  65791 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65795 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  65799 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65803 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65807 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65810 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65814 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65818 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 15,
     /*  65822 */   // MIs[0] dst
     /*  65822 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65827 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65829 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65836 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16m1),
     /*  65839 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65843 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65852 */   GIR_RootConstrainSelectedInstOperands,
     /*  65853 */   // GIR_Coverage, 17616,
     /*  65853 */   GIR_EraseRootFromParent_Done,
     /*  65854 */ // Label 1556: @65854
     /*  65854 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(65937), // Rule ID 262 //
     /*  65859 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65862 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65866 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  65874 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65878 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65882 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  65886 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65890 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65894 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65897 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65901 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65905 */   // MIs[0] src1
     /*  65905 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65910 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65912 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65919 */   // (st (sub:{ *:[i16] } 0:{ *:[i16] }, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16m),
     /*  65922 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65926 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65929 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65935 */   GIR_RootConstrainSelectedInstOperands,
     /*  65936 */   // GIR_Coverage, 262,
     /*  65936 */   GIR_EraseRootFromParent_Done,
     /*  65937 */ // Label 1557: @65937
     /*  65937 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(66017), // Rule ID 270 //
     /*  65942 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65945 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65949 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65953 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65957 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65961 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65965 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65969 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65973 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65976 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65980 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65984 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65988 */   // MIs[0] src1
     /*  65988 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65993 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65995 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66002 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT16m addr:{ *:[iPTR] }:$src1)
     /*  66002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m),
     /*  66005 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66009 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  66015 */   GIR_RootConstrainSelectedInstOperands,
     /*  66016 */   // GIR_Coverage, 270,
     /*  66016 */   GIR_EraseRootFromParent_Done,
     /*  66017 */ // Label 1558: @66017
     /*  66017 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(66112), // Rule ID 414 //
     /*  66022 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66025 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  66037 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66041 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66045 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66049 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66053 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66056 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66060 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66064 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66068 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66072 */   // MIs[3] Operand 1
     /*  66072 */   // No operand predicates
     /*  66072 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66076 */   // MIs[0] src1
     /*  66076 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66081 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66083 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66090 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mi),
     /*  66093 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66097 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66100 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66110 */   GIR_RootConstrainSelectedInstOperands,
     /*  66111 */   // GIR_Coverage, 414,
     /*  66111 */   GIR_EraseRootFromParent_Done,
     /*  66112 */ // Label 1559: @66112
     /*  66112 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(66207), // Rule ID 306 //
     /*  66117 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66120 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66124 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66128 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66132 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66136 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66140 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66144 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66148 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66151 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66155 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66159 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66163 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66167 */   // MIs[3] Operand 1
     /*  66167 */   // No operand predicates
     /*  66167 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66171 */   // MIs[0] src1
     /*  66171 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66176 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66178 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66185 */   // (st (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mi),
     /*  66188 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66192 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66195 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66198 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66205 */   GIR_RootConstrainSelectedInstOperands,
     /*  66206 */   // GIR_Coverage, 306,
     /*  66206 */   GIR_EraseRootFromParent_Done,
     /*  66207 */ // Label 1560: @66207
     /*  66207 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(66302), // Rule ID 342 //
     /*  66212 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66215 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66219 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66223 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  66227 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66231 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66235 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66239 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66243 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66246 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66250 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66254 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66258 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66262 */   // MIs[3] Operand 1
     /*  66262 */   // No operand predicates
     /*  66262 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66266 */   // MIs[0] src1
     /*  66266 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66271 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66273 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66280 */   // (st (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mi),
     /*  66283 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66287 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66290 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66300 */   GIR_RootConstrainSelectedInstOperands,
     /*  66301 */   // GIR_Coverage, 342,
     /*  66301 */   GIR_EraseRootFromParent_Done,
     /*  66302 */ // Label 1561: @66302
     /*  66302 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(66397), // Rule ID 454 //
     /*  66307 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66310 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66314 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66318 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  66322 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66326 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66330 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66334 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66338 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66341 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66345 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66349 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66353 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66357 */   // MIs[3] Operand 1
     /*  66357 */   // No operand predicates
     /*  66357 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66361 */   // MIs[0] src1
     /*  66361 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66366 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66368 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66375 */   // (st (sub:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  66378 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66382 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66385 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66388 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66395 */   GIR_RootConstrainSelectedInstOperands,
     /*  66396 */   // GIR_Coverage, 454,
     /*  66396 */   GIR_EraseRootFromParent_Done,
     /*  66397 */ // Label 1562: @66397
     /*  66397 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(66492), // Rule ID 378 //
     /*  66402 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66405 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66409 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66413 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66417 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66421 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66425 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66429 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66433 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66436 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66440 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66444 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66448 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66452 */   // MIs[3] Operand 1
     /*  66452 */   // No operand predicates
     /*  66452 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66456 */   // MIs[0] src1
     /*  66456 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66461 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66463 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66470 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mi),
     /*  66473 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66477 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66480 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66490 */   GIR_RootConstrainSelectedInstOperands,
     /*  66491 */   // GIR_Coverage, 378,
     /*  66491 */   GIR_EraseRootFromParent_Done,
     /*  66492 */ // Label 1563: @66492
     /*  66492 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(66593), // Rule ID 22427 //
     /*  66497 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66500 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  66515 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66519 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66523 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66527 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66531 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66534 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66538 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66545 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66549 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66553 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66557 */   // MIs[3] Operand 1
     /*  66557 */   // No operand predicates
     /*  66557 */   // MIs[0] dst
     /*  66557 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66562 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66564 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66571 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mi),
     /*  66574 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66578 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66581 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66584 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66591 */   GIR_RootConstrainSelectedInstOperands,
     /*  66592 */   // GIR_Coverage, 22427,
     /*  66592 */   GIR_EraseRootFromParent_Done,
     /*  66593 */ // Label 1564: @66593
     /*  66593 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(66694), // Rule ID 22435 //
     /*  66598 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66601 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66608 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66612 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66616 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66620 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66624 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66628 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66632 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66635 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66639 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66646 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66650 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66654 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66658 */   // MIs[3] Operand 1
     /*  66658 */   // No operand predicates
     /*  66658 */   // MIs[0] dst
     /*  66658 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66663 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66665 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66672 */   // (atomic_store (and:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mi),
     /*  66675 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66679 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66682 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66685 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66692 */   GIR_RootConstrainSelectedInstOperands,
     /*  66693 */   // GIR_Coverage, 22435,
     /*  66693 */   GIR_EraseRootFromParent_Done,
     /*  66694 */ // Label 1565: @66694
     /*  66694 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(66795), // Rule ID 22443 //
     /*  66699 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66702 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66709 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66713 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  66717 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66721 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66725 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66729 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66733 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66736 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66740 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66747 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66751 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66755 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66759 */   // MIs[3] Operand 1
     /*  66759 */   // No operand predicates
     /*  66759 */   // MIs[0] dst
     /*  66759 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66764 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66766 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66773 */   // (atomic_store (or:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mi),
     /*  66776 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66780 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66783 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66793 */   GIR_RootConstrainSelectedInstOperands,
     /*  66794 */   // GIR_Coverage, 22443,
     /*  66794 */   GIR_EraseRootFromParent_Done,
     /*  66795 */ // Label 1566: @66795
     /*  66795 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(66896), // Rule ID 22459 //
     /*  66800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66810 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  66818 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66822 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66826 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66830 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66834 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66837 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66841 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66848 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66852 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66856 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66860 */   // MIs[3] Operand 1
     /*  66860 */   // No operand predicates
     /*  66860 */   // MIs[0] dst
     /*  66860 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66865 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66867 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66874 */   // (atomic_store (sub:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  66877 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66881 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66884 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66894 */   GIR_RootConstrainSelectedInstOperands,
     /*  66895 */   // GIR_Coverage, 22459,
     /*  66895 */   GIR_EraseRootFromParent_Done,
     /*  66896 */ // Label 1567: @66896
     /*  66896 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(66997), // Rule ID 22451 //
     /*  66901 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66904 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66911 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66919 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66923 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66927 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66931 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66935 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66938 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66942 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66949 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66953 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66957 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66961 */   // MIs[3] Operand 1
     /*  66961 */   // No operand predicates
     /*  66961 */   // MIs[0] dst
     /*  66961 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66966 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66968 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66975 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mi),
     /*  66978 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66982 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66985 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66988 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66995 */   GIR_RootConstrainSelectedInstOperands,
     /*  66996 */   // GIR_Coverage, 22451,
     /*  66996 */   GIR_EraseRootFromParent_Done,
     /*  66997 */ // Label 1568: @66997
     /*  66997 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(67088), // Rule ID 733 //
     /*  67002 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67005 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67009 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  67017 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67021 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67025 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67029 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67033 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67036 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67040 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67044 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67048 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67052 */   // MIs[3] Operand 1
     /*  67052 */   // No operand predicates
     /*  67052 */   // MIs[0] src1
     /*  67052 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67057 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67059 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67066 */   // (st (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mi),
     /*  67069 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67073 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67076 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67086 */   GIR_RootConstrainSelectedInstOperands,
     /*  67087 */   // GIR_Coverage, 733,
     /*  67087 */   GIR_EraseRootFromParent_Done,
     /*  67088 */ // Label 1569: @67088
     /*  67088 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(67179), // Rule ID 701 //
     /*  67093 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67096 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67100 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67104 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  67108 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67112 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67116 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67120 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67124 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67127 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67131 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67135 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67139 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67143 */   // MIs[3] Operand 1
     /*  67143 */   // No operand predicates
     /*  67143 */   // MIs[0] src1
     /*  67143 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67148 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67150 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67157 */   // (st (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mi),
     /*  67160 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67164 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67167 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67170 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67177 */   GIR_RootConstrainSelectedInstOperands,
     /*  67178 */   // GIR_Coverage, 701,
     /*  67178 */   GIR_EraseRootFromParent_Done,
     /*  67179 */ // Label 1570: @67179
     /*  67179 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(67270), // Rule ID 765 //
     /*  67184 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67187 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67191 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67195 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  67199 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67203 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67207 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67211 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67215 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67218 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67222 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67226 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67230 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67234 */   // MIs[3] Operand 1
     /*  67234 */   // No operand predicates
     /*  67234 */   // MIs[0] src1
     /*  67234 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67239 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67241 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67248 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mi),
     /*  67251 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67255 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67258 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67261 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67268 */   GIR_RootConstrainSelectedInstOperands,
     /*  67269 */   // GIR_Coverage, 765,
     /*  67269 */   GIR_EraseRootFromParent_Done,
     /*  67270 */ // Label 1571: @67270
     /*  67270 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(67361), // Rule ID 797 //
     /*  67275 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67278 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67282 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67286 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  67290 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67294 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67298 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67302 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67306 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67309 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67313 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67317 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67321 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67325 */   // MIs[3] Operand 1
     /*  67325 */   // No operand predicates
     /*  67325 */   // MIs[0] src1
     /*  67325 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67330 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67332 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67339 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mi),
     /*  67342 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67346 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67349 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67352 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67359 */   GIR_RootConstrainSelectedInstOperands,
     /*  67360 */   // GIR_Coverage, 797,
     /*  67360 */   GIR_EraseRootFromParent_Done,
     /*  67361 */ // Label 1572: @67361
     /*  67361 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(67452), // Rule ID 669 //
     /*  67366 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67369 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67373 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67377 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  67381 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67385 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67389 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67393 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67397 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67400 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67404 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67408 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67412 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67416 */   // MIs[3] Operand 1
     /*  67416 */   // No operand predicates
     /*  67416 */   // MIs[0] src1
     /*  67416 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67421 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67423 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67430 */   // (st (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mi),
     /*  67433 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67437 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67440 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67450 */   GIR_RootConstrainSelectedInstOperands,
     /*  67451 */   // GIR_Coverage, 669,
     /*  67451 */   GIR_EraseRootFromParent_Done,
     /*  67452 */ // Label 1573: @67452
     /*  67452 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(67550), // Rule ID 22431 //
     /*  67457 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67460 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  67475 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67479 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67483 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67487 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67491 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67494 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67498 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67505 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67509 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67514 */   // MIs[0] dst
     /*  67514 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67519 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67521 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67528 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  67531 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67535 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67539 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67542 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67548 */   GIR_RootConstrainSelectedInstOperands,
     /*  67549 */   // GIR_Coverage, 22431,
     /*  67549 */   GIR_EraseRootFromParent_Done,
     /*  67550 */ // Label 1574: @67550
     /*  67550 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(67648), // Rule ID 26000 //
     /*  67555 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67558 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  67573 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67577 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67581 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67586 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67590 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67594 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67597 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67601 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67608 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67612 */   // MIs[0] dst
     /*  67612 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67617 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67619 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67626 */   // (atomic_store (add:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  67629 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67633 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  67637 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67640 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67646 */   GIR_RootConstrainSelectedInstOperands,
     /*  67647 */   // GIR_Coverage, 26000,
     /*  67647 */   GIR_EraseRootFromParent_Done,
     /*  67648 */ // Label 1575: @67648
     /*  67648 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(67746), // Rule ID 22439 //
     /*  67653 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67656 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67663 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67667 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67671 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67675 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67679 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67683 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67687 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67690 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67694 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67701 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67705 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67710 */   // MIs[0] dst
     /*  67710 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67715 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67717 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67724 */   // (atomic_store (and:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  67727 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67731 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67735 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67738 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67744 */   GIR_RootConstrainSelectedInstOperands,
     /*  67745 */   // GIR_Coverage, 22439,
     /*  67745 */   GIR_EraseRootFromParent_Done,
     /*  67746 */ // Label 1576: @67746
     /*  67746 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(67844), // Rule ID 26004 //
     /*  67751 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67754 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67761 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67765 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67769 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67773 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67777 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67782 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67786 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67790 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67793 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67797 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67804 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67808 */   // MIs[0] dst
     /*  67808 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67813 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67815 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67822 */   // (atomic_store (and:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  67825 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67829 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  67833 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67836 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67842 */   GIR_RootConstrainSelectedInstOperands,
     /*  67843 */   // GIR_Coverage, 26004,
     /*  67843 */   GIR_EraseRootFromParent_Done,
     /*  67844 */ // Label 1577: @67844
     /*  67844 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(67942), // Rule ID 22447 //
     /*  67849 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67852 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67859 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67863 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  67867 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67871 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67875 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67879 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67883 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67890 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67897 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67901 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67906 */   // MIs[0] dst
     /*  67906 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67911 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67913 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67920 */   // (atomic_store (or:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  67923 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67927 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67931 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67940 */   GIR_RootConstrainSelectedInstOperands,
     /*  67941 */   // GIR_Coverage, 22447,
     /*  67941 */   GIR_EraseRootFromParent_Done,
     /*  67942 */ // Label 1578: @67942
     /*  67942 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(68040), // Rule ID 26008 //
     /*  67947 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67950 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67957 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67961 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  67965 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67969 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67973 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67978 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67982 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67986 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67989 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67993 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68000 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68004 */   // MIs[0] dst
     /*  68004 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68009 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68011 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68018 */   // (atomic_store (or:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  68021 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68025 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68029 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68032 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68038 */   GIR_RootConstrainSelectedInstOperands,
     /*  68039 */   // GIR_Coverage, 26008,
     /*  68039 */   GIR_EraseRootFromParent_Done,
     /*  68040 */ // Label 1579: @68040
     /*  68040 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(68138), // Rule ID 22463 //
     /*  68045 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68048 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68055 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68059 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  68063 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68067 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68071 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68075 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68079 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68082 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68086 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68093 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68097 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68102 */   // MIs[0] dst
     /*  68102 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68107 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68109 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68116 */   // (atomic_store (sub:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (SUB16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mr),
     /*  68119 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68123 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68127 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68130 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68136 */   GIR_RootConstrainSelectedInstOperands,
     /*  68137 */   // GIR_Coverage, 22463,
     /*  68137 */   GIR_EraseRootFromParent_Done,
     /*  68138 */ // Label 1580: @68138
     /*  68138 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(68236), // Rule ID 22455 //
     /*  68143 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68146 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68153 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68157 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68161 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68165 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68169 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68173 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68177 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68180 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68184 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68191 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68195 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68200 */   // MIs[0] dst
     /*  68200 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68205 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68207 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68214 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  68217 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68221 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68225 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68228 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68234 */   GIR_RootConstrainSelectedInstOperands,
     /*  68235 */   // GIR_Coverage, 22455,
     /*  68235 */   GIR_EraseRootFromParent_Done,
     /*  68236 */ // Label 1581: @68236
     /*  68236 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(68334), // Rule ID 26012 //
     /*  68241 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68251 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68255 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68259 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68263 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68267 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68272 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68276 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68280 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68283 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68287 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68294 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68298 */   // MIs[0] dst
     /*  68298 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68303 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68305 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68312 */   // (atomic_store (xor:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  68315 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68319 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68323 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68332 */   GIR_RootConstrainSelectedInstOperands,
     /*  68333 */   // GIR_Coverage, 26012,
     /*  68333 */   GIR_EraseRootFromParent_Done,
     /*  68334 */ // Label 1582: @68334
     /*  68334 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(68422), // Rule ID 410 //
     /*  68339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  68354 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68358 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68362 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68366 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68370 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68373 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68377 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68381 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68386 */   // MIs[0] src1
     /*  68386 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68391 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68393 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68400 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  68403 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68407 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68411 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68420 */   GIR_RootConstrainSelectedInstOperands,
     /*  68421 */   // GIR_Coverage, 410,
     /*  68421 */   GIR_EraseRootFromParent_Done,
     /*  68422 */ // Label 1583: @68422
     /*  68422 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(68510), // Rule ID 23220 //
     /*  68427 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68430 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  68442 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68446 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68450 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68455 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68459 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68463 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68466 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68470 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68474 */   // MIs[0] src1
     /*  68474 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68479 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68481 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68488 */   // (st (add:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  68491 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68495 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68499 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68502 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68508 */   GIR_RootConstrainSelectedInstOperands,
     /*  68509 */   // GIR_Coverage, 23220,
     /*  68509 */   GIR_EraseRootFromParent_Done,
     /*  68510 */ // Label 1584: @68510
     /*  68510 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(68598), // Rule ID 302 //
     /*  68515 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68518 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68522 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68530 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68534 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68538 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68542 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68546 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68549 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68553 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68557 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68562 */   // MIs[0] src1
     /*  68562 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68567 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68569 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68576 */   // (st (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68579 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68583 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68587 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68590 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68596 */   GIR_RootConstrainSelectedInstOperands,
     /*  68597 */   // GIR_Coverage, 302,
     /*  68597 */   GIR_EraseRootFromParent_Done,
     /*  68598 */ // Label 1585: @68598
     /*  68598 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(68686), // Rule ID 23184 //
     /*  68603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68606 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68618 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68622 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68626 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68631 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68635 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68639 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68642 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68646 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68650 */   // MIs[0] src1
     /*  68650 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68655 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68657 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68664 */   // (st (and:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68667 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68671 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68675 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68684 */   GIR_RootConstrainSelectedInstOperands,
     /*  68685 */   // GIR_Coverage, 23184,
     /*  68685 */   GIR_EraseRootFromParent_Done,
     /*  68686 */ // Label 1586: @68686
     /*  68686 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(68784), // Rule ID 749 //
     /*  68691 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68694 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68698 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  68706 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68710 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  68714 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68718 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68722 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68725 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68729 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  68733 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  68738 */   // MIs[0] src1
     /*  68738 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68743 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68745 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68752 */   // (st (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  68752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68756 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68762 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  68766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mCL),
     /*  68769 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68773 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68776 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68782 */   GIR_RootConstrainSelectedInstOperands,
     /*  68783 */   // GIR_Coverage, 749,
     /*  68783 */   GIR_EraseRootFromParent_Done,
     /*  68784 */ // Label 1587: @68784
     /*  68784 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(68882), // Rule ID 717 //
     /*  68789 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68796 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  68804 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68808 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  68812 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68816 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68820 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68823 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68827 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  68831 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  68836 */   // MIs[0] src1
     /*  68836 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68841 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68843 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68850 */   // (st (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  68850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68854 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68860 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  68864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mCL),
     /*  68867 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68871 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68880 */   GIR_RootConstrainSelectedInstOperands,
     /*  68881 */   // GIR_Coverage, 717,
     /*  68881 */   GIR_EraseRootFromParent_Done,
     /*  68882 */ // Label 1588: @68882
     /*  68882 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(68970), // Rule ID 338 //
     /*  68887 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68890 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68894 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68898 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  68902 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68906 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68910 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68914 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68918 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68921 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68925 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68929 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68934 */   // MIs[0] src1
     /*  68934 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68939 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68941 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68948 */   // (st (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  68951 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68955 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68959 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68962 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68968 */   GIR_RootConstrainSelectedInstOperands,
     /*  68969 */   // GIR_Coverage, 338,
     /*  68969 */   GIR_EraseRootFromParent_Done,
     /*  68970 */ // Label 1589: @68970
     /*  68970 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(69058), // Rule ID 23196 //
     /*  68975 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68978 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68982 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68986 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  68990 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68994 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68998 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69003 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69007 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69011 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69014 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69018 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69022 */   // MIs[0] src1
     /*  69022 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69027 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69029 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69036 */   // (st (or:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  69039 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69043 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  69047 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69056 */   GIR_RootConstrainSelectedInstOperands,
     /*  69057 */   // GIR_Coverage, 23196,
     /*  69057 */   GIR_EraseRootFromParent_Done,
     /*  69058 */ // Label 1590: @69058
     /*  69058 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(69156), // Rule ID 781 //
     /*  69063 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69066 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69070 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69074 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  69078 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69082 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69086 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69090 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69094 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69097 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69101 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69105 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69110 */   // MIs[0] src1
     /*  69110 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69115 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69117 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69124 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69124 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69128 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69134 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mCL),
     /*  69141 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69145 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69148 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69154 */   GIR_RootConstrainSelectedInstOperands,
     /*  69155 */   // GIR_Coverage, 781,
     /*  69155 */   GIR_EraseRootFromParent_Done,
     /*  69156 */ // Label 1591: @69156
     /*  69156 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(69254), // Rule ID 813 //
     /*  69161 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69164 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69168 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69172 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  69176 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69180 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69184 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69188 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69192 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69195 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69199 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69208 */   // MIs[0] src1
     /*  69208 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69213 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69215 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69222 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69226 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69232 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mCL),
     /*  69239 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69243 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69252 */   GIR_RootConstrainSelectedInstOperands,
     /*  69253 */   // GIR_Coverage, 813,
     /*  69253 */   GIR_EraseRootFromParent_Done,
     /*  69254 */ // Label 1592: @69254
     /*  69254 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(69352), // Rule ID 685 //
     /*  69259 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69262 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69266 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69270 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  69274 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69278 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69282 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69286 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69290 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69293 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69297 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69301 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69306 */   // MIs[0] src1
     /*  69306 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69311 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69313 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69320 */   // (st (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69320 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69324 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69330 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mCL),
     /*  69337 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69341 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69350 */   GIR_RootConstrainSelectedInstOperands,
     /*  69351 */   // GIR_Coverage, 685,
     /*  69351 */   GIR_EraseRootFromParent_Done,
     /*  69352 */ // Label 1593: @69352
     /*  69352 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(69440), // Rule ID 446 //
     /*  69357 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69360 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69364 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69368 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  69372 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69376 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69380 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69384 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69388 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69391 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69395 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69399 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69404 */   // MIs[0] src1
     /*  69404 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69409 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69411 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69418 */   // (st (sub:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mr),
     /*  69421 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69425 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69429 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69432 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69438 */   GIR_RootConstrainSelectedInstOperands,
     /*  69439 */   // GIR_Coverage, 446,
     /*  69439 */   GIR_EraseRootFromParent_Done,
     /*  69440 */ // Label 1594: @69440
     /*  69440 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(69528), // Rule ID 374 //
     /*  69445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69448 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69452 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69456 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69460 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69464 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69468 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69472 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69476 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69479 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69483 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69487 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69492 */   // MIs[0] src1
     /*  69492 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69497 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69499 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69506 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  69509 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69513 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69517 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69520 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69526 */   GIR_RootConstrainSelectedInstOperands,
     /*  69527 */   // GIR_Coverage, 374,
     /*  69527 */   GIR_EraseRootFromParent_Done,
     /*  69528 */ // Label 1595: @69528
     /*  69528 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(69616), // Rule ID 23208 //
     /*  69533 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69536 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69540 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69544 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69548 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69552 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69556 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69561 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69565 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69569 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69572 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69576 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69580 */   // MIs[0] src1
     /*  69580 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69585 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69587 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69594 */   // (st (xor:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  69597 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69601 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  69605 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69614 */   GIR_RootConstrainSelectedInstOperands,
     /*  69615 */   // GIR_Coverage, 23208,
     /*  69615 */   GIR_EraseRootFromParent_Done,
     /*  69616 */ // Label 1596: @69616
     /*  69616 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(69670), // Rule ID 25 //
     /*  69621 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69624 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69628 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69632 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69636 */   // MIs[1] Operand 1
     /*  69636 */   // No operand predicates
     /*  69636 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  69640 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69646 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69653 */   // (st (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  69653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mi),
     /*  69656 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69660 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  69663 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69668 */   GIR_RootConstrainSelectedInstOperands,
     /*  69669 */   // GIR_Coverage, 25,
     /*  69669 */   GIR_EraseRootFromParent_Done,
     /*  69670 */ // Label 1597: @69670
     /*  69670 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(69723), // Rule ID 22507 //
     /*  69675 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  69678 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  69685 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69689 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69693 */   // MIs[1] Operand 1
     /*  69693 */   // No operand predicates
     /*  69693 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69697 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69706 */   // (atomic_store (imm:{ *:[i16] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (MOV16mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  69706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mi),
     /*  69709 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69713 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  69716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69721 */   GIR_RootConstrainSelectedInstOperands,
     /*  69722 */   // GIR_Coverage, 22507,
     /*  69722 */   GIR_EraseRootFromParent_Done,
     /*  69723 */ // Label 1598: @69723
     /*  69723 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(69786), // Rule ID 50 //
     /*  69728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  69731 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69734 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  69746 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69750 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69755 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69759 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69768 */   // (st (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src1)
     /*  69768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16mr),
     /*  69771 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69775 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  69779 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69784 */   GIR_RootConstrainSelectedInstOperands,
     /*  69785 */   // GIR_Coverage, 50,
     /*  69785 */   GIR_EraseRootFromParent_Done,
     /*  69786 */ // Label 1599: @69786
     /*  69786 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(69849), // Rule ID 56 //
     /*  69791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  69794 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69797 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69801 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69805 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  69809 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69813 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69818 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69822 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69831 */   // (st (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE16mr_EVEX addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src1)
     /*  69831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16mr_EVEX),
     /*  69834 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69838 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  69842 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69847 */   GIR_RootConstrainSelectedInstOperands,
     /*  69848 */   // GIR_Coverage, 56,
     /*  69848 */   GIR_EraseRootFromParent_Done,
     /*  69849 */ // Label 1600: @69849
     /*  69849 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(69894), // Rule ID 22511 //
     /*  69854 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  69857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  69864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69868 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69872 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69879 */   // (atomic_store GR16:{ *:[i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  69879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  69882 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69886 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  69888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  69892 */   GIR_RootConstrainSelectedInstOperands,
     /*  69893 */   // GIR_Coverage, 22511,
     /*  69893 */   GIR_EraseRootFromParent_Done,
     /*  69894 */ // Label 1601: @69894
     /*  69894 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(69936), // Rule ID 33 //
     /*  69899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69902 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69910 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69914 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69921 */   // (st GR16:{ *:[i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  69921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  69924 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69928 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  69930 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  69934 */   GIR_RootConstrainSelectedInstOperands,
     /*  69935 */   // GIR_Coverage, 33,
     /*  69935 */   GIR_EraseRootFromParent_Done,
     /*  69936 */ // Label 1602: @69936
     /*  69936 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(69981), // Rule ID 4621 //
     /*  69941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  69944 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69947 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  69955 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69959 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69966 */   // (st FR16X:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSHZmr addr:{ *:[iPTR] }:$dst, FR16X:{ *:[f16] }:$src)
     /*  69966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSHZmr),
     /*  69969 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69973 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  69975 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  69979 */   GIR_RootConstrainSelectedInstOperands,
     /*  69980 */   // GIR_Coverage, 4621,
     /*  69980 */   GIR_EraseRootFromParent_Done,
     /*  69981 */ // Label 1603: @69981
     /*  69981 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(70047), // Rule ID 18546 //
     /*  69986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  69989 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69992 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69996 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70000 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70007 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PEXTRWmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70019 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70023 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PEXTRWmri),
     /*  70031 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70041 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70045 */   GIR_RootConstrainSelectedInstOperands,
     /*  70046 */   // GIR_Coverage, 18546,
     /*  70046 */   GIR_EraseRootFromParent_Done,
     /*  70047 */ // Label 1604: @70047
     /*  70047 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(70113), // Rule ID 18547 //
     /*  70052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  70055 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70058 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70062 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70066 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70073 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VPEXTRWmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70073 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70076 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70080 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70085 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70089 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPEXTRWmri),
     /*  70097 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70101 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70107 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70111 */   GIR_RootConstrainSelectedInstOperands,
     /*  70112 */   // GIR_Coverage, 18547,
     /*  70112 */   GIR_EraseRootFromParent_Done,
     /*  70113 */ // Label 1605: @70113
     /*  70113 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(70225), // Rule ID 18335 //
     /*  70118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  70121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70124 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70128 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70132 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70139 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] }))
     /*  70139 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  70142 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70146 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70151 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70155 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70160 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  70163 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /*  70167 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70172 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  70175 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /*  70178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  70180 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  70183 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70187 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70192 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  70199 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  70204 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  70209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  70212 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70219 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70223 */   GIR_RootConstrainSelectedInstOperands,
     /*  70224 */   // GIR_Coverage, 18335,
     /*  70224 */   GIR_EraseRootFromParent_Done,
     /*  70225 */ // Label 1606: @70225
     /*  70225 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(70291), // Rule ID 21839 //
     /*  70230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  70233 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70236 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70240 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70251 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VPEXTRWZmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70263 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70267 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZmri),
     /*  70275 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70279 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70285 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70289 */   GIR_RootConstrainSelectedInstOperands,
     /*  70290 */   // GIR_Coverage, 21839,
     /*  70290 */   GIR_EraseRootFromParent_Done,
     /*  70291 */ // Label 1607: @70291
     /*  70291 */ GIM_Reject,
     /*  70292 */ // Label 1475: @70292
     /*  70292 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(70388), // Rule ID 22492 //
     /*  70297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70300 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70303 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70310 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70314 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70318 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70322 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70326 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70330 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70334 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70337 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70341 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70348 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70352 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  70356 */   // MIs[0] dst
     /*  70356 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70361 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70363 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70370 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, 1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (INC32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32m),
     /*  70373 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70377 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70380 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70386 */   GIR_RootConstrainSelectedInstOperands,
     /*  70387 */   // GIR_Coverage, 22492,
     /*  70387 */   GIR_EraseRootFromParent_Done,
     /*  70388 */ // Label 1608: @70388
     /*  70388 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(70484), // Rule ID 22496 //
     /*  70393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70396 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70399 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70406 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70410 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70414 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70418 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70422 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70426 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70430 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70433 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70437 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70444 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70448 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70452 */   // MIs[0] dst
     /*  70452 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70457 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70459 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70466 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (DEC32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32m),
     /*  70469 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70473 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70476 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70482 */   GIR_RootConstrainSelectedInstOperands,
     /*  70483 */   // GIR_Coverage, 22496,
     /*  70483 */   GIR_EraseRootFromParent_Done,
     /*  70484 */ // Label 1609: @70484
     /*  70484 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(70577), // Rule ID 22500 //
     /*  70489 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70492 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  70507 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70511 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70515 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  70519 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70523 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70527 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70530 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70534 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70541 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70545 */   // MIs[0] dst
     /*  70545 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70550 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70552 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70559 */   // (atomic_store (sub:{ *:[i32] } 0:{ *:[i32] }, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (NEG32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32m),
     /*  70562 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70566 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70569 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70575 */   GIR_RootConstrainSelectedInstOperands,
     /*  70576 */   // GIR_Coverage, 22500,
     /*  70576 */   GIR_EraseRootFromParent_Done,
     /*  70577 */ // Label 1610: @70577
     /*  70577 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(70667), // Rule ID 22504 //
     /*  70582 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70585 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70600 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70604 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70608 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70612 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70616 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70619 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70623 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70630 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70634 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70638 */   // MIs[0] dst
     /*  70638 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70643 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70645 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70652 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (NOT32m addr:{ *:[iPTR] }:$dst)
     /*  70652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m),
     /*  70655 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70665 */   GIR_RootConstrainSelectedInstOperands,
     /*  70666 */   // GIR_Coverage, 22504,
     /*  70666 */   GIR_EraseRootFromParent_Done,
     /*  70667 */ // Label 1611: @70667
     /*  70667 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(70753), // Rule ID 227 //
     /*  70672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70675 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70678 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70682 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70686 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70690 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70694 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70698 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70702 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70706 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70709 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70713 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70717 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  70721 */   // MIs[0] src1
     /*  70721 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70726 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70728 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70735 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  70735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32m),
     /*  70738 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  70742 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70751 */   GIR_RootConstrainSelectedInstOperands,
     /*  70752 */   // GIR_Coverage, 227,
     /*  70752 */   GIR_EraseRootFromParent_Done,
     /*  70753 */ // Label 1612: @70753
     /*  70753 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(70839), // Rule ID 230 //
     /*  70758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70764 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70768 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70772 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70776 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70780 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70784 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70788 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70792 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70795 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70799 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70803 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70807 */   // MIs[0] src1
     /*  70807 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70812 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70814 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70821 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  70821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32m),
     /*  70824 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  70828 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70837 */   GIR_RootConstrainSelectedInstOperands,
     /*  70838 */   // GIR_Coverage, 230,
     /*  70838 */   GIR_EraseRootFromParent_Done,
     /*  70839 */ // Label 1613: @70839
     /*  70839 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(70932), // Rule ID 22612 //
     /*  70844 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70847 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70851 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70855 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70859 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70863 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70867 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70871 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70875 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70878 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70882 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70886 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  70897 */   // MIs[0] dst
     /*  70897 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70902 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70904 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70911 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i32] })
     /*  70911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  70914 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  70921 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70924 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70930 */   GIR_RootConstrainSelectedInstOperands,
     /*  70931 */   // GIR_Coverage, 22612,
     /*  70931 */   GIR_EraseRootFromParent_Done,
     /*  70932 */ // Label 1614: @70932
     /*  70932 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(71015), // Rule ID 17613 //
     /*  70937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70940 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70944 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  70952 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70956 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  70960 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70964 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70968 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70971 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70975 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70979 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 31,
     /*  70983 */   // MIs[0] dst
     /*  70983 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70988 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70990 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70997 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32m1),
     /*  71000 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71004 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71007 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71013 */   GIR_RootConstrainSelectedInstOperands,
     /*  71014 */   // GIR_Coverage, 17613,
     /*  71014 */   GIR_EraseRootFromParent_Done,
     /*  71015 */ // Label 1615: @71015
     /*  71015 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(71098), // Rule ID 17617 //
     /*  71020 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71023 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71027 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71031 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  71035 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71039 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  71043 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71047 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71051 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71054 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71058 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71062 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 31,
     /*  71066 */   // MIs[0] dst
     /*  71066 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71071 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71073 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71080 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  71080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32m1),
     /*  71083 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71087 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71090 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71096 */   GIR_RootConstrainSelectedInstOperands,
     /*  71097 */   // GIR_Coverage, 17617,
     /*  71097 */   GIR_EraseRootFromParent_Done,
     /*  71098 */ // Label 1616: @71098
     /*  71098 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(71181), // Rule ID 263 //
     /*  71103 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71106 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71110 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71114 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  71118 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71122 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71126 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  71130 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71134 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71138 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71141 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71145 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71149 */   // MIs[0] src1
     /*  71149 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71154 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71156 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71163 */   // (st (sub:{ *:[i32] } 0:{ *:[i32] }, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  71163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32m),
     /*  71166 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71170 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71179 */   GIR_RootConstrainSelectedInstOperands,
     /*  71180 */   // GIR_Coverage, 263,
     /*  71180 */   GIR_EraseRootFromParent_Done,
     /*  71181 */ // Label 1617: @71181
     /*  71181 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(71261), // Rule ID 271 //
     /*  71186 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71189 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71193 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71197 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71201 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71205 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71209 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71213 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71217 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71220 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71224 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71228 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71232 */   // MIs[0] src1
     /*  71232 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71237 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71239 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71246 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT32m addr:{ *:[iPTR] }:$src1)
     /*  71246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m),
     /*  71249 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71253 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71259 */   GIR_RootConstrainSelectedInstOperands,
     /*  71260 */   // GIR_Coverage, 271,
     /*  71260 */   GIR_EraseRootFromParent_Done,
     /*  71261 */ // Label 1618: @71261
     /*  71261 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(71356), // Rule ID 415 //
     /*  71266 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71269 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71273 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71281 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71285 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71289 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71293 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71297 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71300 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71304 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71308 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71312 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71316 */   // MIs[3] Operand 1
     /*  71316 */   // No operand predicates
     /*  71316 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71320 */   // MIs[0] src1
     /*  71320 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71325 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71327 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71334 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mi),
     /*  71337 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71341 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71344 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71347 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71354 */   GIR_RootConstrainSelectedInstOperands,
     /*  71355 */   // GIR_Coverage, 415,
     /*  71355 */   GIR_EraseRootFromParent_Done,
     /*  71356 */ // Label 1619: @71356
     /*  71356 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(71451), // Rule ID 307 //
     /*  71361 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71364 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71368 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71372 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71376 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71380 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71384 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71388 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71392 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71395 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71399 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71403 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71407 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71411 */   // MIs[3] Operand 1
     /*  71411 */   // No operand predicates
     /*  71411 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71415 */   // MIs[0] src1
     /*  71415 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71420 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71422 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71429 */   // (st (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mi),
     /*  71432 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71436 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71439 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71449 */   GIR_RootConstrainSelectedInstOperands,
     /*  71450 */   // GIR_Coverage, 307,
     /*  71450 */   GIR_EraseRootFromParent_Done,
     /*  71451 */ // Label 1620: @71451
     /*  71451 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(71546), // Rule ID 343 //
     /*  71456 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71459 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71463 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  71471 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71479 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71483 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71487 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71490 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71494 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71498 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71502 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71506 */   // MIs[3] Operand 1
     /*  71506 */   // No operand predicates
     /*  71506 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71510 */   // MIs[0] src1
     /*  71510 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71515 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71517 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71524 */   // (st (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mi),
     /*  71527 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71531 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71534 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71544 */   GIR_RootConstrainSelectedInstOperands,
     /*  71545 */   // GIR_Coverage, 343,
     /*  71545 */   GIR_EraseRootFromParent_Done,
     /*  71546 */ // Label 1621: @71546
     /*  71546 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(71641), // Rule ID 455 //
     /*  71551 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71554 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71558 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71562 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  71566 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71570 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71574 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71578 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71582 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71585 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71589 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71593 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71597 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71601 */   // MIs[3] Operand 1
     /*  71601 */   // No operand predicates
     /*  71601 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71605 */   // MIs[0] src1
     /*  71605 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71610 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71612 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71619 */   // (st (sub:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  71622 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71626 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71629 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71632 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71639 */   GIR_RootConstrainSelectedInstOperands,
     /*  71640 */   // GIR_Coverage, 455,
     /*  71640 */   GIR_EraseRootFromParent_Done,
     /*  71641 */ // Label 1622: @71641
     /*  71641 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(71736), // Rule ID 379 //
     /*  71646 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71649 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71653 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71657 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71661 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71665 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71669 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71673 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71677 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71680 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71684 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71688 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71692 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71696 */   // MIs[3] Operand 1
     /*  71696 */   // No operand predicates
     /*  71696 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71700 */   // MIs[0] src1
     /*  71700 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71705 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71707 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71714 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mi),
     /*  71717 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71721 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71724 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71727 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71734 */   GIR_RootConstrainSelectedInstOperands,
     /*  71735 */   // GIR_Coverage, 379,
     /*  71735 */   GIR_EraseRootFromParent_Done,
     /*  71736 */ // Label 1623: @71736
     /*  71736 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(71837), // Rule ID 22428 //
     /*  71741 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71744 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71751 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71759 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71763 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71767 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71771 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71775 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71778 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71782 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71789 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71793 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71797 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71801 */   // MIs[3] Operand 1
     /*  71801 */   // No operand predicates
     /*  71801 */   // MIs[0] dst
     /*  71801 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71806 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71808 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71815 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  71815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mi),
     /*  71818 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71822 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  71825 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71828 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71835 */   GIR_RootConstrainSelectedInstOperands,
     /*  71836 */   // GIR_Coverage, 22428,
     /*  71836 */   GIR_EraseRootFromParent_Done,
     /*  71837 */ // Label 1624: @71837
     /*  71837 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(71938), // Rule ID 22436 //
     /*  71842 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71845 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71852 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71860 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71864 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71868 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71872 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71876 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71879 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71883 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71890 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71894 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71898 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71902 */   // MIs[3] Operand 1
     /*  71902 */   // No operand predicates
     /*  71902 */   // MIs[0] dst
     /*  71902 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71907 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71909 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71916 */   // (atomic_store (and:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  71916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mi),
     /*  71919 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71923 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  71926 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71929 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71936 */   GIR_RootConstrainSelectedInstOperands,
     /*  71937 */   // GIR_Coverage, 22436,
     /*  71937 */   GIR_EraseRootFromParent_Done,
     /*  71938 */ // Label 1625: @71938
     /*  71938 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(72039), // Rule ID 22444 //
     /*  71943 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71946 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71953 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71957 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  71961 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71965 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71969 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71973 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71977 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71980 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71984 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71991 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71995 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71999 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72003 */   // MIs[3] Operand 1
     /*  72003 */   // No operand predicates
     /*  72003 */   // MIs[0] dst
     /*  72003 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72008 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72010 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72017 */   // (atomic_store (or:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mi),
     /*  72020 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72024 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72027 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72030 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72037 */   GIR_RootConstrainSelectedInstOperands,
     /*  72038 */   // GIR_Coverage, 22444,
     /*  72038 */   GIR_EraseRootFromParent_Done,
     /*  72039 */ // Label 1626: @72039
     /*  72039 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(72140), // Rule ID 22460 //
     /*  72044 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72047 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72054 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72058 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  72062 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72066 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72070 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72074 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72078 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72081 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72085 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72092 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72096 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72100 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72104 */   // MIs[3] Operand 1
     /*  72104 */   // No operand predicates
     /*  72104 */   // MIs[0] dst
     /*  72104 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72109 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72111 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72118 */   // (atomic_store (sub:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  72121 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72125 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72128 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72131 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72138 */   GIR_RootConstrainSelectedInstOperands,
     /*  72139 */   // GIR_Coverage, 22460,
     /*  72139 */   GIR_EraseRootFromParent_Done,
     /*  72140 */ // Label 1627: @72140
     /*  72140 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(72241), // Rule ID 22452 //
     /*  72145 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72148 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72155 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72163 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72167 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72171 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72175 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72179 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72182 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72186 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72193 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72197 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72201 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72205 */   // MIs[3] Operand 1
     /*  72205 */   // No operand predicates
     /*  72205 */   // MIs[0] dst
     /*  72205 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72210 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72212 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72219 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mi),
     /*  72222 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72226 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72229 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72239 */   GIR_RootConstrainSelectedInstOperands,
     /*  72240 */   // GIR_Coverage, 22452,
     /*  72240 */   GIR_EraseRootFromParent_Done,
     /*  72241 */ // Label 1628: @72241
     /*  72241 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(72345), // Rule ID 833 //
     /*  72246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  72261 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72265 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72269 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  72273 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72277 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72281 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72284 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72288 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72292 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72297 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  72301 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72305 */   // MIs[3] Operand 1
     /*  72305 */   // No operand predicates
     /*  72305 */   // MIs[0] src1
     /*  72305 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72310 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72312 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72319 */   // (st (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD32mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  72319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mri8),
     /*  72322 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72326 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  72330 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  72333 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72336 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72343 */   GIR_RootConstrainSelectedInstOperands,
     /*  72344 */   // GIR_Coverage, 833,
     /*  72344 */   GIR_EraseRootFromParent_Done,
     /*  72345 */ // Label 1629: @72345
     /*  72345 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(72449), // Rule ID 857 //
     /*  72350 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72353 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  72365 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72369 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72373 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  72377 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72382 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72386 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72390 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72393 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72397 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72401 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  72405 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72409 */   // MIs[3] Operand 1
     /*  72409 */   // No operand predicates
     /*  72409 */   // MIs[0] src1
     /*  72409 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72414 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72416 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72423 */   // (st (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD32mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  72423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mri8),
     /*  72426 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72430 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  72434 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  72437 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72447 */   GIR_RootConstrainSelectedInstOperands,
     /*  72448 */   // GIR_Coverage, 857,
     /*  72448 */   GIR_EraseRootFromParent_Done,
     /*  72449 */ // Label 1630: @72449
     /*  72449 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(72540), // Rule ID 734 //
     /*  72454 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72457 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72461 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72465 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  72469 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72473 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72477 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72481 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72485 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72488 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72492 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72496 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72500 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72504 */   // MIs[3] Operand 1
     /*  72504 */   // No operand predicates
     /*  72504 */   // MIs[0] src1
     /*  72504 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72509 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72511 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72518 */   // (st (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mi),
     /*  72521 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72525 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72528 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72531 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72538 */   GIR_RootConstrainSelectedInstOperands,
     /*  72539 */   // GIR_Coverage, 734,
     /*  72539 */   GIR_EraseRootFromParent_Done,
     /*  72540 */ // Label 1631: @72540
     /*  72540 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(72631), // Rule ID 702 //
     /*  72545 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72548 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72552 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72556 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  72560 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72564 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72568 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72572 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72576 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72579 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72583 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72587 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72591 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72595 */   // MIs[3] Operand 1
     /*  72595 */   // No operand predicates
     /*  72595 */   // MIs[0] src1
     /*  72595 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72600 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72602 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72609 */   // (st (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mi),
     /*  72612 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72616 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72619 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72622 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72629 */   GIR_RootConstrainSelectedInstOperands,
     /*  72630 */   // GIR_Coverage, 702,
     /*  72630 */   GIR_EraseRootFromParent_Done,
     /*  72631 */ // Label 1632: @72631
     /*  72631 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(72722), // Rule ID 766 //
     /*  72636 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72639 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72643 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72647 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  72651 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72655 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72659 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72663 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72667 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72670 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72674 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72678 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72682 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72686 */   // MIs[3] Operand 1
     /*  72686 */   // No operand predicates
     /*  72686 */   // MIs[0] src1
     /*  72686 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72691 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72693 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72700 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mi),
     /*  72703 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72707 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72710 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72720 */   GIR_RootConstrainSelectedInstOperands,
     /*  72721 */   // GIR_Coverage, 766,
     /*  72721 */   GIR_EraseRootFromParent_Done,
     /*  72722 */ // Label 1633: @72722
     /*  72722 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(72813), // Rule ID 798 //
     /*  72727 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72734 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72738 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  72742 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72746 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72750 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72754 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72758 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72761 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72765 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72769 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72773 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72777 */   // MIs[3] Operand 1
     /*  72777 */   // No operand predicates
     /*  72777 */   // MIs[0] src1
     /*  72777 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72782 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72784 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72791 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mi),
     /*  72794 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72798 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72801 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72804 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72811 */   GIR_RootConstrainSelectedInstOperands,
     /*  72812 */   // GIR_Coverage, 798,
     /*  72812 */   GIR_EraseRootFromParent_Done,
     /*  72813 */ // Label 1634: @72813
     /*  72813 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(72904), // Rule ID 670 //
     /*  72818 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72821 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72825 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72829 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  72833 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72837 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72841 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72845 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72849 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72852 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72856 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72860 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72864 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72868 */   // MIs[3] Operand 1
     /*  72868 */   // No operand predicates
     /*  72868 */   // MIs[0] src1
     /*  72868 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72873 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72875 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72882 */   // (st (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mi),
     /*  72885 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72889 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72892 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72895 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72902 */   GIR_RootConstrainSelectedInstOperands,
     /*  72903 */   // GIR_Coverage, 670,
     /*  72903 */   GIR_EraseRootFromParent_Done,
     /*  72904 */ // Label 1635: @72904
     /*  72904 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(73002), // Rule ID 22432 //
     /*  72909 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72912 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  72927 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72931 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72935 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72939 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72943 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72946 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72950 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72957 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72961 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72966 */   // MIs[0] dst
     /*  72966 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72971 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72973 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72980 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  72980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  72983 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72987 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  72991 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72994 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73000 */   GIR_RootConstrainSelectedInstOperands,
     /*  73001 */   // GIR_Coverage, 22432,
     /*  73001 */   GIR_EraseRootFromParent_Done,
     /*  73002 */ // Label 1636: @73002
     /*  73002 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(73100), // Rule ID 26001 //
     /*  73007 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73010 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  73025 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73029 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73033 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73038 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73042 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73046 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73049 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73053 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73060 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73064 */   // MIs[0] dst
     /*  73064 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73069 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73071 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73078 */   // (atomic_store (add:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  73081 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73085 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73089 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73092 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73098 */   GIR_RootConstrainSelectedInstOperands,
     /*  73099 */   // GIR_Coverage, 26001,
     /*  73099 */   GIR_EraseRootFromParent_Done,
     /*  73100 */ // Label 1637: @73100
     /*  73100 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(73198), // Rule ID 22440 //
     /*  73105 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73108 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73115 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73119 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73123 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73127 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73131 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73135 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73139 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73142 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73146 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73153 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73157 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73162 */   // MIs[0] dst
     /*  73162 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73167 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73169 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73176 */   // (atomic_store (and:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  73179 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73183 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73187 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73196 */   GIR_RootConstrainSelectedInstOperands,
     /*  73197 */   // GIR_Coverage, 22440,
     /*  73197 */   GIR_EraseRootFromParent_Done,
     /*  73198 */ // Label 1638: @73198
     /*  73198 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(73296), // Rule ID 26005 //
     /*  73203 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73206 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73213 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73221 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73225 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73229 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73234 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73238 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73242 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73245 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73249 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73256 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73260 */   // MIs[0] dst
     /*  73260 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73265 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73267 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73274 */   // (atomic_store (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  73277 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73281 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73285 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73288 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73294 */   GIR_RootConstrainSelectedInstOperands,
     /*  73295 */   // GIR_Coverage, 26005,
     /*  73295 */   GIR_EraseRootFromParent_Done,
     /*  73296 */ // Label 1639: @73296
     /*  73296 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(73394), // Rule ID 22448 //
     /*  73301 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73304 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  73319 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73323 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73327 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73331 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73335 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73338 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73342 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73349 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73353 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73358 */   // MIs[0] dst
     /*  73358 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73363 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73365 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73372 */   // (atomic_store (or:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  73375 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73379 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73383 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73392 */   GIR_RootConstrainSelectedInstOperands,
     /*  73393 */   // GIR_Coverage, 22448,
     /*  73393 */   GIR_EraseRootFromParent_Done,
     /*  73394 */ // Label 1640: @73394
     /*  73394 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(73492), // Rule ID 26009 //
     /*  73399 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73402 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73409 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73413 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  73417 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73421 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73425 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73430 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73434 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73438 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73441 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73445 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73452 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73456 */   // MIs[0] dst
     /*  73456 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73461 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73463 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73470 */   // (atomic_store (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  73473 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73477 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73481 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73490 */   GIR_RootConstrainSelectedInstOperands,
     /*  73491 */   // GIR_Coverage, 26009,
     /*  73491 */   GIR_EraseRootFromParent_Done,
     /*  73492 */ // Label 1641: @73492
     /*  73492 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(73590), // Rule ID 22464 //
     /*  73497 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73500 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  73515 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73519 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73523 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73527 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73531 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73534 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73538 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73545 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73549 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73554 */   // MIs[0] dst
     /*  73554 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73559 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73561 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73568 */   // (atomic_store (sub:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (SUB32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mr),
     /*  73571 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73575 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73579 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73582 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73588 */   GIR_RootConstrainSelectedInstOperands,
     /*  73589 */   // GIR_Coverage, 22464,
     /*  73589 */   GIR_EraseRootFromParent_Done,
     /*  73590 */ // Label 1642: @73590
     /*  73590 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(73688), // Rule ID 22456 //
     /*  73595 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73598 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73605 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73609 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73613 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73617 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73621 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73625 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73629 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73632 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73636 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73643 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73647 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73652 */   // MIs[0] dst
     /*  73652 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73657 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73659 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73666 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  73669 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73673 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73677 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73680 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73686 */   GIR_RootConstrainSelectedInstOperands,
     /*  73687 */   // GIR_Coverage, 22456,
     /*  73687 */   GIR_EraseRootFromParent_Done,
     /*  73688 */ // Label 1643: @73688
     /*  73688 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(73786), // Rule ID 26013 //
     /*  73693 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73696 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73703 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73707 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73711 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73715 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73719 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73724 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73728 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73732 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73735 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73739 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73746 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73750 */   // MIs[0] dst
     /*  73750 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73755 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73757 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73764 */   // (atomic_store (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  73767 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73771 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73775 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73778 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73784 */   GIR_RootConstrainSelectedInstOperands,
     /*  73785 */   // GIR_Coverage, 26013,
     /*  73785 */   GIR_EraseRootFromParent_Done,
     /*  73786 */ // Label 1644: @73786
     /*  73786 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(73897), // Rule ID 836 //
     /*  73791 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73794 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73798 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73802 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  73806 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73810 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73814 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  73818 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73822 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73826 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73829 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73833 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  73837 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73842 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  73847 */   // MIs[0] src1
     /*  73847 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73852 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73854 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73861 */   // (st (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD32mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  73861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73865 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73871 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  73875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mrCL),
     /*  73878 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73882 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  73886 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73889 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73895 */   GIR_RootConstrainSelectedInstOperands,
     /*  73896 */   // GIR_Coverage, 836,
     /*  73896 */   GIR_EraseRootFromParent_Done,
     /*  73897 */ // Label 1645: @73897
     /*  73897 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(74008), // Rule ID 860 //
     /*  73902 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73905 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  73917 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73921 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73925 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  73929 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73934 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73938 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73942 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73945 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73949 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  73953 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  73958 */   // MIs[0] src1
     /*  73958 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73963 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73965 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73972 */   // (st (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD32mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  73972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73976 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73982 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  73986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mrCL),
     /*  73989 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73993 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  73997 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74006 */   GIR_RootConstrainSelectedInstOperands,
     /*  74007 */   // GIR_Coverage, 860,
     /*  74007 */   GIR_EraseRootFromParent_Done,
     /*  74008 */ // Label 1646: @74008
     /*  74008 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(74096), // Rule ID 411 //
     /*  74013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74016 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74020 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74024 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  74028 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74032 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74036 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74040 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74044 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74047 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74051 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74055 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74060 */   // MIs[0] src1
     /*  74060 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74065 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74067 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74074 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  74077 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74081 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74085 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74088 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74094 */   GIR_RootConstrainSelectedInstOperands,
     /*  74095 */   // GIR_Coverage, 411,
     /*  74095 */   GIR_EraseRootFromParent_Done,
     /*  74096 */ // Label 1647: @74096
     /*  74096 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(74184), // Rule ID 23221 //
     /*  74101 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74104 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74108 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74112 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  74116 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74120 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74124 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74129 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74133 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74137 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74140 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74144 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74148 */   // MIs[0] src1
     /*  74148 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74153 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74155 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74162 */   // (st (add:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  74165 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74169 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74173 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74176 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74182 */   GIR_RootConstrainSelectedInstOperands,
     /*  74183 */   // GIR_Coverage, 23221,
     /*  74183 */   GIR_EraseRootFromParent_Done,
     /*  74184 */ // Label 1648: @74184
     /*  74184 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(74272), // Rule ID 303 //
     /*  74189 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74192 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74196 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74200 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74204 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74208 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74212 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74216 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74220 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74223 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74227 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74231 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74236 */   // MIs[0] src1
     /*  74236 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74241 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74243 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74250 */   // (st (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  74253 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74257 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74261 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74264 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74270 */   GIR_RootConstrainSelectedInstOperands,
     /*  74271 */   // GIR_Coverage, 303,
     /*  74271 */   GIR_EraseRootFromParent_Done,
     /*  74272 */ // Label 1649: @74272
     /*  74272 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(74360), // Rule ID 23185 //
     /*  74277 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74280 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74284 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74288 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74292 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74296 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74300 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74305 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74309 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74313 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74316 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74320 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74324 */   // MIs[0] src1
     /*  74324 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74329 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74331 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74338 */   // (st (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  74341 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74345 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74349 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74352 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74358 */   GIR_RootConstrainSelectedInstOperands,
     /*  74359 */   // GIR_Coverage, 23185,
     /*  74359 */   GIR_EraseRootFromParent_Done,
     /*  74360 */ // Label 1650: @74360
     /*  74360 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(74458), // Rule ID 750 //
     /*  74365 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74368 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  74380 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74384 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74388 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74392 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74396 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74399 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74403 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74407 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74412 */   // MIs[0] src1
     /*  74412 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74417 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74419 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74426 */   // (st (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74430 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74436 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mCL),
     /*  74443 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74447 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74456 */   GIR_RootConstrainSelectedInstOperands,
     /*  74457 */   // GIR_Coverage, 750,
     /*  74457 */   GIR_EraseRootFromParent_Done,
     /*  74458 */ // Label 1651: @74458
     /*  74458 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(74556), // Rule ID 718 //
     /*  74463 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74466 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74470 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74474 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  74478 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74482 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74486 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74490 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74494 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74497 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74501 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74505 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74510 */   // MIs[0] src1
     /*  74510 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74515 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74517 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74524 */   // (st (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74524 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74528 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74534 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mCL),
     /*  74541 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74545 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74548 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74554 */   GIR_RootConstrainSelectedInstOperands,
     /*  74555 */   // GIR_Coverage, 718,
     /*  74555 */   GIR_EraseRootFromParent_Done,
     /*  74556 */ // Label 1652: @74556
     /*  74556 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(74644), // Rule ID 339 //
     /*  74561 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74564 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74568 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74572 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  74576 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74580 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74584 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74588 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74592 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74595 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74599 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74603 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74608 */   // MIs[0] src1
     /*  74608 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74613 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74615 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74622 */   // (st (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  74625 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74629 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74633 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74642 */   GIR_RootConstrainSelectedInstOperands,
     /*  74643 */   // GIR_Coverage, 339,
     /*  74643 */   GIR_EraseRootFromParent_Done,
     /*  74644 */ // Label 1653: @74644
     /*  74644 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(74732), // Rule ID 23197 //
     /*  74649 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74652 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  74664 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74668 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74672 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74677 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74681 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74685 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74688 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74692 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74696 */   // MIs[0] src1
     /*  74696 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74701 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74703 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74710 */   // (st (or:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  74713 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74717 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74721 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74730 */   GIR_RootConstrainSelectedInstOperands,
     /*  74731 */   // GIR_Coverage, 23197,
     /*  74731 */   GIR_EraseRootFromParent_Done,
     /*  74732 */ // Label 1654: @74732
     /*  74732 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(74830), // Rule ID 782 //
     /*  74737 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74740 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74744 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74748 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  74752 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74756 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74760 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74764 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74768 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74771 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74775 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74779 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74784 */   // MIs[0] src1
     /*  74784 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74789 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74791 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74798 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74802 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74808 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mCL),
     /*  74815 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74819 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74822 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74828 */   GIR_RootConstrainSelectedInstOperands,
     /*  74829 */   // GIR_Coverage, 782,
     /*  74829 */   GIR_EraseRootFromParent_Done,
     /*  74830 */ // Label 1655: @74830
     /*  74830 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(74928), // Rule ID 814 //
     /*  74835 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74838 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  74850 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74854 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74858 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74862 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74866 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74869 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74873 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74877 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74882 */   // MIs[0] src1
     /*  74882 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74887 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74889 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74896 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74900 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74906 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mCL),
     /*  74913 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74917 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74926 */   GIR_RootConstrainSelectedInstOperands,
     /*  74927 */   // GIR_Coverage, 814,
     /*  74927 */   GIR_EraseRootFromParent_Done,
     /*  74928 */ // Label 1656: @74928
     /*  74928 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(75026), // Rule ID 686 //
     /*  74933 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74936 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74940 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  74948 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74952 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74956 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74960 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74964 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74967 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74971 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74975 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74980 */   // MIs[0] src1
     /*  74980 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74985 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74987 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74994 */   // (st (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74998 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75004 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  75008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mCL),
     /*  75011 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75015 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75024 */   GIR_RootConstrainSelectedInstOperands,
     /*  75025 */   // GIR_Coverage, 686,
     /*  75025 */   GIR_EraseRootFromParent_Done,
     /*  75026 */ // Label 1657: @75026
     /*  75026 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(75114), // Rule ID 447 //
     /*  75031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75034 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75038 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75042 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  75046 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75050 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75054 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75058 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75062 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75065 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75069 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75073 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75078 */   // MIs[0] src1
     /*  75078 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75083 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75085 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75092 */   // (st (sub:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mr),
     /*  75095 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75099 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  75103 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75106 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75112 */   GIR_RootConstrainSelectedInstOperands,
     /*  75113 */   // GIR_Coverage, 447,
     /*  75113 */   GIR_EraseRootFromParent_Done,
     /*  75114 */ // Label 1658: @75114
     /*  75114 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(75202), // Rule ID 375 //
     /*  75119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75122 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75126 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75130 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75134 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75138 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75142 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75146 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75150 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75153 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75157 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75161 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75166 */   // MIs[0] src1
     /*  75166 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75171 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75173 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75180 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  75183 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75187 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  75191 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75200 */   GIR_RootConstrainSelectedInstOperands,
     /*  75201 */   // GIR_Coverage, 375,
     /*  75201 */   GIR_EraseRootFromParent_Done,
     /*  75202 */ // Label 1659: @75202
     /*  75202 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(75290), // Rule ID 23209 //
     /*  75207 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75210 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75214 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75218 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75222 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75226 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75230 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75235 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75239 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75243 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75246 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75250 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75254 */   // MIs[0] src1
     /*  75254 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75259 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75261 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75268 */   // (st (xor:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  75271 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75275 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  75279 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75288 */   GIR_RootConstrainSelectedInstOperands,
     /*  75289 */   // GIR_Coverage, 23209,
     /*  75289 */   GIR_EraseRootFromParent_Done,
     /*  75290 */ // Label 1660: @75290
     /*  75290 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(75344), // Rule ID 26 //
     /*  75295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75298 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75302 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75306 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75310 */   // MIs[1] Operand 1
     /*  75310 */   // No operand predicates
     /*  75310 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  75314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75320 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75327 */   // (st (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV32mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  75327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mi),
     /*  75330 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75334 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  75337 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75342 */   GIR_RootConstrainSelectedInstOperands,
     /*  75343 */   // GIR_Coverage, 26,
     /*  75343 */   GIR_EraseRootFromParent_Done,
     /*  75344 */ // Label 1661: @75344
     /*  75344 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(75410), // Rule ID 22518 //
     /*  75349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  75352 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75355 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75362 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75370 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75374 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75379 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75383 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75385 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75392 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSmr),
     /*  75395 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75399 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75403 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75408 */   GIR_RootConstrainSelectedInstOperands,
     /*  75409 */   // GIR_Coverage, 22518,
     /*  75409 */   GIR_EraseRootFromParent_Done,
     /*  75410 */ // Label 1662: @75410
     /*  75410 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(75476), // Rule ID 22519 //
     /*  75415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  75418 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75421 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75428 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75436 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75440 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75449 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75451 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75458 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (VMOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSmr),
     /*  75461 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75465 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75474 */   GIR_RootConstrainSelectedInstOperands,
     /*  75475 */   // GIR_Coverage, 22519,
     /*  75475 */   GIR_EraseRootFromParent_Done,
     /*  75476 */ // Label 1663: @75476
     /*  75476 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(75542), // Rule ID 22520 //
     /*  75481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  75484 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75487 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75494 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75498 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75502 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75506 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75511 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75517 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75524 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (VMOVSSZmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZmr),
     /*  75527 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75531 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75540 */   GIR_RootConstrainSelectedInstOperands,
     /*  75541 */   // GIR_Coverage, 22520,
     /*  75541 */   GIR_EraseRootFromParent_Done,
     /*  75542 */ // Label 1664: @75542
     /*  75542 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(75595), // Rule ID 22508 //
     /*  75547 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75550 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75557 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75561 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75565 */   // MIs[1] Operand 1
     /*  75565 */   // No operand predicates
     /*  75565 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75569 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75571 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75578 */   // (atomic_store (imm:{ *:[i32] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOV32mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  75578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mi),
     /*  75581 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75585 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  75588 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75593 */   GIR_RootConstrainSelectedInstOperands,
     /*  75594 */   // GIR_Coverage, 22508,
     /*  75594 */   GIR_EraseRootFromParent_Done,
     /*  75595 */ // Label 1665: @75595
     /*  75595 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(75658), // Rule ID 52 //
     /*  75600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  75603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75606 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  75618 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75622 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75631 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75633 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75640 */   // (st (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src1)
     /*  75640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32mr),
     /*  75643 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75647 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  75651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75656 */   GIR_RootConstrainSelectedInstOperands,
     /*  75657 */   // GIR_Coverage, 52,
     /*  75657 */   GIR_EraseRootFromParent_Done,
     /*  75658 */ // Label 1666: @75658
     /*  75658 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(75721), // Rule ID 58 //
     /*  75663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  75666 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75669 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75673 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  75681 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75685 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75690 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75694 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75703 */   // (st (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE32mr_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src1)
     /*  75703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32mr_EVEX),
     /*  75706 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75710 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  75714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75719 */   GIR_RootConstrainSelectedInstOperands,
     /*  75720 */   // GIR_Coverage, 58,
     /*  75720 */   GIR_EraseRootFromParent_Done,
     /*  75721 */ // Label 1667: @75721
     /*  75721 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(75766), // Rule ID 22512 //
     /*  75726 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75729 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75751 */   // (atomic_store GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOV32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  75751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mr),
     /*  75754 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75758 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75760 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75764 */   GIR_RootConstrainSelectedInstOperands,
     /*  75765 */   // GIR_Coverage, 22512,
     /*  75765 */   GIR_EraseRootFromParent_Done,
     /*  75766 */ // Label 1668: @75766
     /*  75766 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(75808), // Rule ID 34 //
     /*  75771 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75774 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75782 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75786 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75793 */   // (st GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  75793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mr),
     /*  75796 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75800 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75806 */   GIR_RootConstrainSelectedInstOperands,
     /*  75807 */   // GIR_Coverage, 34,
     /*  75807 */   GIR_EraseRootFromParent_Done,
     /*  75808 */ // Label 1669: @75808
     /*  75808 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(75856), // Rule ID 1094 //
     /*  75813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /*  75816 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75819 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /*  75827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75838 */   // (st RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_Fp32m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /*  75838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp32m),
     /*  75841 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  75845 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75847 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  75850 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75854 */   GIR_RootConstrainSelectedInstOperands,
     /*  75855 */   // GIR_Coverage, 1094,
     /*  75855 */   GIR_EraseRootFromParent_Done,
     /*  75856 */ // Label 1670: @75856
     /*  75856 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(75901), // Rule ID 1687 //
     /*  75861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  75864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75867 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75875 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75879 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75886 */   // (st FR32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSmr),
     /*  75889 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75893 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75895 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75899 */   GIR_RootConstrainSelectedInstOperands,
     /*  75900 */   // GIR_Coverage, 1687,
     /*  75900 */   GIR_EraseRootFromParent_Done,
     /*  75901 */ // Label 1671: @75901
     /*  75901 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(75946), // Rule ID 1689 //
     /*  75906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  75909 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75912 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75920 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75924 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75931 */   // (st FR32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSmr),
     /*  75934 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75938 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75940 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75944 */   GIR_RootConstrainSelectedInstOperands,
     /*  75945 */   // GIR_Coverage, 1689,
     /*  75945 */   GIR_EraseRootFromParent_Done,
     /*  75946 */ // Label 1672: @75946
     /*  75946 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(75991), // Rule ID 4609 //
     /*  75951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  75954 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75957 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  75965 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75969 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75976 */   // (st FR32X:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSSZmr addr:{ *:[iPTR] }:$dst, FR32X:{ *:[f32] }:$src)
     /*  75976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZmr),
     /*  75979 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75983 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75985 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75989 */   GIR_RootConstrainSelectedInstOperands,
     /*  75990 */   // GIR_Coverage, 4609,
     /*  75990 */   GIR_EraseRootFromParent_Done,
     /*  75991 */ // Label 1673: @75991
     /*  75991 */ GIM_Reject,
     /*  75992 */ // Label 1476: @75992
     /*  75992 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(76088), // Rule ID 22493 //
     /*  75997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  76000 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76003 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76018 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76022 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76026 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76030 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76034 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76037 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76041 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76048 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76052 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  76056 */   // MIs[0] dst
     /*  76056 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76061 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76063 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76070 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, 1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (INC64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64m),
     /*  76073 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76077 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76086 */   GIR_RootConstrainSelectedInstOperands,
     /*  76087 */   // GIR_Coverage, 22493,
     /*  76087 */   GIR_EraseRootFromParent_Done,
     /*  76088 */ // Label 1674: @76088
     /*  76088 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(76184), // Rule ID 22497 //
     /*  76093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  76096 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76099 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76106 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76110 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76114 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76118 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76122 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76126 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76130 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76133 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76137 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76144 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76148 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76152 */   // MIs[0] dst
     /*  76152 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76157 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76159 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76166 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (DEC64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64m),
     /*  76169 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76173 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76176 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76182 */   GIR_RootConstrainSelectedInstOperands,
     /*  76183 */   // GIR_Coverage, 22497,
     /*  76183 */   GIR_EraseRootFromParent_Done,
     /*  76184 */ // Label 1675: @76184
     /*  76184 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(76277), // Rule ID 22501 //
     /*  76189 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76192 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76199 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76203 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  76207 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76211 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76215 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  76219 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76223 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76227 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76230 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76234 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76241 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76245 */   // MIs[0] dst
     /*  76245 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76250 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76252 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76259 */   // (atomic_store (sub:{ *:[i64] } 0:{ *:[i64] }, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (NEG64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64m),
     /*  76262 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76266 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76275 */   GIR_RootConstrainSelectedInstOperands,
     /*  76276 */   // GIR_Coverage, 22501,
     /*  76276 */   GIR_EraseRootFromParent_Done,
     /*  76277 */ // Label 1676: @76277
     /*  76277 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(76367), // Rule ID 22505 //
     /*  76282 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76285 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76300 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76304 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76308 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76312 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76316 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76319 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76323 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76330 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76334 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76338 */   // MIs[0] dst
     /*  76338 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76343 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76345 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76352 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (NOT64m addr:{ *:[iPTR] }:$dst)
     /*  76352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m),
     /*  76355 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76365 */   GIR_RootConstrainSelectedInstOperands,
     /*  76366 */   // GIR_Coverage, 22505,
     /*  76366 */   GIR_EraseRootFromParent_Done,
     /*  76367 */ // Label 1677: @76367
     /*  76367 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(76453), // Rule ID 231 //
     /*  76372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseIncDec),
     /*  76375 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76378 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76390 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76394 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76398 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76402 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76406 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76409 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76413 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76417 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  76421 */   // MIs[0] src1
     /*  76421 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76426 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76428 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76435 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64m),
     /*  76438 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76442 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76445 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76451 */   GIR_RootConstrainSelectedInstOperands,
     /*  76452 */   // GIR_Coverage, 231,
     /*  76452 */   GIR_EraseRootFromParent_Done,
     /*  76453 */ // Label 1678: @76453
     /*  76453 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(76539), // Rule ID 232 //
     /*  76458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseIncDec),
     /*  76461 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76464 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76468 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76472 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76476 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76480 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76484 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76488 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76492 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76495 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76499 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76503 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76507 */   // MIs[0] src1
     /*  76507 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76512 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76514 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76521 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64m),
     /*  76524 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76528 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76531 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76537 */   GIR_RootConstrainSelectedInstOperands,
     /*  76538 */   // GIR_Coverage, 232,
     /*  76538 */   GIR_EraseRootFromParent_Done,
     /*  76539 */ // Label 1679: @76539
     /*  76539 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(76632), // Rule ID 22613 //
     /*  76544 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76547 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76551 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76555 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76559 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76563 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76567 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76571 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76575 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76578 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76582 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76586 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  76597 */   // MIs[0] dst
     /*  76597 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76602 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76604 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76611 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 128:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i64] })
     /*  76611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  76614 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  76621 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76630 */   GIR_RootConstrainSelectedInstOperands,
     /*  76631 */   // GIR_Coverage, 22613,
     /*  76631 */   GIR_EraseRootFromParent_Done,
     /*  76632 */ // Label 1680: @76632
     /*  76632 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(76732), // Rule ID 22621 //
     /*  76637 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76644 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76648 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76652 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76656 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76660 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76664 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76668 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76671 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76675 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76679 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2147483648),
     /*  76690 */   // MIs[0] dst
     /*  76690 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76695 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76697 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76704 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 2147483648:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -2147483648:{ *:[i64] })
     /*  76704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  76707 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76711 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  76721 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76730 */   GIR_RootConstrainSelectedInstOperands,
     /*  76731 */   // GIR_Coverage, 22621,
     /*  76731 */   GIR_EraseRootFromParent_Done,
     /*  76732 */ // Label 1681: @76732
     /*  76732 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(76818), // Rule ID 17614 //
     /*  76737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76740 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76743 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76747 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76751 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  76755 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76759 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  76763 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76767 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76771 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76774 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76778 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76782 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 63,
     /*  76786 */   // MIs[0] dst
     /*  76786 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76791 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76793 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76800 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64m1),
     /*  76803 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76807 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76810 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76816 */   GIR_RootConstrainSelectedInstOperands,
     /*  76817 */   // GIR_Coverage, 17614,
     /*  76817 */   GIR_EraseRootFromParent_Done,
     /*  76818 */ // Label 1682: @76818
     /*  76818 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(76904), // Rule ID 17618 //
     /*  76823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76826 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76829 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76833 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76837 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  76841 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76845 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  76849 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76853 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76857 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76864 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76868 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 63,
     /*  76872 */   // MIs[0] dst
     /*  76872 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76877 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76879 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76886 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64m1),
     /*  76889 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76893 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76896 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76902 */   GIR_RootConstrainSelectedInstOperands,
     /*  76903 */   // GIR_Coverage, 17618,
     /*  76903 */   GIR_EraseRootFromParent_Done,
     /*  76904 */ // Label 1683: @76904
     /*  76904 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(76990), // Rule ID 264 //
     /*  76909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76912 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76915 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  76927 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76931 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76935 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  76939 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76943 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76947 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76950 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76954 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76958 */   // MIs[0] src1
     /*  76958 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76963 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76965 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76972 */   // (st (sub:{ *:[i64] } 0:{ *:[i64] }, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64m),
     /*  76975 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76979 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76982 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76988 */   GIR_RootConstrainSelectedInstOperands,
     /*  76989 */   // GIR_Coverage, 264,
     /*  76989 */   GIR_EraseRootFromParent_Done,
     /*  76990 */ // Label 1684: @76990
     /*  76990 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(77073), // Rule ID 272 //
     /*  76995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77001 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77013 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77017 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77021 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77025 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77029 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77032 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77036 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77040 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  77044 */   // MIs[0] src1
     /*  77044 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77049 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77051 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77058 */   // (st (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT64m addr:{ *:[iPTR] }:$src1)
     /*  77058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m),
     /*  77061 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77065 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77071 */   GIR_RootConstrainSelectedInstOperands,
     /*  77072 */   // GIR_Coverage, 272,
     /*  77072 */   GIR_EraseRootFromParent_Done,
     /*  77073 */ // Label 1685: @77073
     /*  77073 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(77178), // Rule ID 22429 //
     /*  77078 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77081 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77088 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77092 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  77096 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77100 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77104 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77108 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77112 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77115 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77119 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77126 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77130 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77134 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77138 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77142 */   // MIs[3] Operand 1
     /*  77142 */   // No operand predicates
     /*  77142 */   // MIs[0] dst
     /*  77142 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77147 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77149 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77156 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mi32),
     /*  77159 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77163 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77166 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77169 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77176 */   GIR_RootConstrainSelectedInstOperands,
     /*  77177 */   // GIR_Coverage, 22429,
     /*  77177 */   GIR_EraseRootFromParent_Done,
     /*  77178 */ // Label 1686: @77178
     /*  77178 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(77283), // Rule ID 22437 //
     /*  77183 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77186 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77193 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77197 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77201 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77205 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77209 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77213 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77217 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77220 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77224 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77231 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77235 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77239 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77243 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77247 */   // MIs[3] Operand 1
     /*  77247 */   // No operand predicates
     /*  77247 */   // MIs[0] dst
     /*  77247 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77252 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77254 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77261 */   // (atomic_store (and:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mi32),
     /*  77264 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77268 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77271 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77274 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77281 */   GIR_RootConstrainSelectedInstOperands,
     /*  77282 */   // GIR_Coverage, 22437,
     /*  77282 */   GIR_EraseRootFromParent_Done,
     /*  77283 */ // Label 1687: @77283
     /*  77283 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(77388), // Rule ID 22445 //
     /*  77288 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77291 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77298 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77302 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77306 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77310 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77314 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77318 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77322 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77325 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77329 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77336 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77340 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77344 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77348 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77352 */   // MIs[3] Operand 1
     /*  77352 */   // No operand predicates
     /*  77352 */   // MIs[0] dst
     /*  77352 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77357 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77359 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77366 */   // (atomic_store (or:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mi32),
     /*  77369 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77373 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77376 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77379 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77386 */   GIR_RootConstrainSelectedInstOperands,
     /*  77387 */   // GIR_Coverage, 22445,
     /*  77387 */   GIR_EraseRootFromParent_Done,
     /*  77388 */ // Label 1688: @77388
     /*  77388 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(77493), // Rule ID 22461 //
     /*  77393 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77403 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77407 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  77411 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77415 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77419 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77423 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77427 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77430 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77434 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77441 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77445 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77449 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77453 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77457 */   // MIs[3] Operand 1
     /*  77457 */   // No operand predicates
     /*  77457 */   // MIs[0] dst
     /*  77457 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77462 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77464 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77471 */   // (atomic_store (sub:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  77474 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77478 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77481 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77491 */   GIR_RootConstrainSelectedInstOperands,
     /*  77492 */   // GIR_Coverage, 22461,
     /*  77492 */   GIR_EraseRootFromParent_Done,
     /*  77493 */ // Label 1689: @77493
     /*  77493 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(77598), // Rule ID 22453 //
     /*  77498 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77501 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77508 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77512 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77516 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77520 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77524 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77528 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77532 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77535 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77539 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77546 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77550 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77554 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77558 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77562 */   // MIs[3] Operand 1
     /*  77562 */   // No operand predicates
     /*  77562 */   // MIs[0] dst
     /*  77562 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77567 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77569 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77576 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mi32),
     /*  77579 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77583 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77586 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77596 */   GIR_RootConstrainSelectedInstOperands,
     /*  77597 */   // GIR_Coverage, 22453,
     /*  77597 */   GIR_EraseRootFromParent_Done,
     /*  77598 */ // Label 1690: @77598
     /*  77598 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(77702), // Rule ID 834 //
     /*  77603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77606 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  77618 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77622 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77626 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  77630 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77634 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77638 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77641 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77645 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77649 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  77654 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77658 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77662 */   // MIs[3] Operand 1
     /*  77662 */   // No operand predicates
     /*  77662 */   // MIs[0] src1
     /*  77662 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77667 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77669 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77676 */   // (st (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD64mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  77676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mri8),
     /*  77679 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77683 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  77687 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  77690 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77693 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77700 */   GIR_RootConstrainSelectedInstOperands,
     /*  77701 */   // GIR_Coverage, 834,
     /*  77701 */   GIR_EraseRootFromParent_Done,
     /*  77702 */ // Label 1691: @77702
     /*  77702 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(77806), // Rule ID 858 //
     /*  77707 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77710 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77714 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77718 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  77722 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77726 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77730 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  77734 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  77739 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77743 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77747 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77750 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77754 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77758 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77762 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77766 */   // MIs[3] Operand 1
     /*  77766 */   // No operand predicates
     /*  77766 */   // MIs[0] src1
     /*  77766 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77771 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77773 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77780 */   // (st (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD64mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  77780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mri8),
     /*  77783 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77787 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  77791 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  77794 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77804 */   GIR_RootConstrainSelectedInstOperands,
     /*  77805 */   // GIR_Coverage, 858,
     /*  77805 */   GIR_EraseRootFromParent_Done,
     /*  77806 */ // Label 1692: @77806
     /*  77806 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(77900), // Rule ID 735 //
     /*  77811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77814 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77821 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77825 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  77829 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77833 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  77837 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77841 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77845 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77852 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77856 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77860 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77864 */   // MIs[3] Operand 1
     /*  77864 */   // No operand predicates
     /*  77864 */   // MIs[0] src1
     /*  77864 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77869 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77871 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77878 */   // (st (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  77878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mi),
     /*  77881 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77885 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  77888 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77891 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77898 */   GIR_RootConstrainSelectedInstOperands,
     /*  77899 */   // GIR_Coverage, 735,
     /*  77899 */   GIR_EraseRootFromParent_Done,
     /*  77900 */ // Label 1693: @77900
     /*  77900 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(77994), // Rule ID 703 //
     /*  77905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77908 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77911 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77915 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  77923 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77927 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  77931 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77935 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77939 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77942 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77946 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77950 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77954 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77958 */   // MIs[3] Operand 1
     /*  77958 */   // No operand predicates
     /*  77958 */   // MIs[0] src1
     /*  77958 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77963 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77965 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77972 */   // (st (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  77972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mi),
     /*  77975 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77979 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  77982 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77985 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77992 */   GIR_RootConstrainSelectedInstOperands,
     /*  77993 */   // GIR_Coverage, 703,
     /*  77993 */   GIR_EraseRootFromParent_Done,
     /*  77994 */ // Label 1694: @77994
     /*  77994 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(78088), // Rule ID 767 //
     /*  77999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78002 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78005 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78009 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  78017 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78021 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78025 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78029 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78033 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78040 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78044 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78048 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78052 */   // MIs[3] Operand 1
     /*  78052 */   // No operand predicates
     /*  78052 */   // MIs[0] src1
     /*  78052 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78057 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78059 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78066 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mi),
     /*  78069 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78073 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78076 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78086 */   GIR_RootConstrainSelectedInstOperands,
     /*  78087 */   // GIR_Coverage, 767,
     /*  78087 */   GIR_EraseRootFromParent_Done,
     /*  78088 */ // Label 1695: @78088
     /*  78088 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(78182), // Rule ID 799 //
     /*  78093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78096 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78099 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  78111 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78115 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78119 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78123 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78127 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78130 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78134 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78138 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78142 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78146 */   // MIs[3] Operand 1
     /*  78146 */   // No operand predicates
     /*  78146 */   // MIs[0] src1
     /*  78146 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78151 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78153 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78160 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mi),
     /*  78163 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78167 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78170 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78180 */   GIR_RootConstrainSelectedInstOperands,
     /*  78181 */   // GIR_Coverage, 799,
     /*  78181 */   GIR_EraseRootFromParent_Done,
     /*  78182 */ // Label 1696: @78182
     /*  78182 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(78276), // Rule ID 671 //
     /*  78187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78190 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78193 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78197 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78201 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  78205 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78209 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78213 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78217 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78221 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78224 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78228 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78232 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78236 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78240 */   // MIs[3] Operand 1
     /*  78240 */   // No operand predicates
     /*  78240 */   // MIs[0] src1
     /*  78240 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78245 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78247 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78254 */   // (st (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mi),
     /*  78257 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78261 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78264 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78267 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78274 */   GIR_RootConstrainSelectedInstOperands,
     /*  78275 */   // GIR_Coverage, 671,
     /*  78275 */   GIR_EraseRootFromParent_Done,
     /*  78276 */ // Label 1697: @78276
     /*  78276 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(78374), // Rule ID 22433 //
     /*  78281 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78284 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78291 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78295 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78299 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78303 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78307 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78311 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78315 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78318 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78322 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78329 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78333 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78338 */   // MIs[0] dst
     /*  78338 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78343 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78345 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78352 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  78355 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78359 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78363 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78366 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78372 */   GIR_RootConstrainSelectedInstOperands,
     /*  78373 */   // GIR_Coverage, 22433,
     /*  78373 */   GIR_EraseRootFromParent_Done,
     /*  78374 */ // Label 1698: @78374
     /*  78374 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(78472), // Rule ID 26002 //
     /*  78379 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78382 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78389 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78397 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78401 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78405 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78410 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78414 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78418 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78425 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78432 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78436 */   // MIs[0] dst
     /*  78436 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78441 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78443 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78450 */   // (atomic_store (add:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  78453 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78457 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78461 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78470 */   GIR_RootConstrainSelectedInstOperands,
     /*  78471 */   // GIR_Coverage, 26002,
     /*  78471 */   GIR_EraseRootFromParent_Done,
     /*  78472 */ // Label 1699: @78472
     /*  78472 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(78570), // Rule ID 22441 //
     /*  78477 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78480 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78495 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78499 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78503 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78507 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78511 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78514 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78518 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78525 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78529 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78534 */   // MIs[0] dst
     /*  78534 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78539 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78541 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78548 */   // (atomic_store (and:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  78551 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78555 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78559 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78562 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78568 */   GIR_RootConstrainSelectedInstOperands,
     /*  78569 */   // GIR_Coverage, 22441,
     /*  78569 */   GIR_EraseRootFromParent_Done,
     /*  78570 */ // Label 1700: @78570
     /*  78570 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(78668), // Rule ID 26006 //
     /*  78575 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78578 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78593 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78597 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78601 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78606 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78610 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78614 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78617 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78621 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78628 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78632 */   // MIs[0] dst
     /*  78632 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78637 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78639 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78646 */   // (atomic_store (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  78649 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78653 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78657 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78666 */   GIR_RootConstrainSelectedInstOperands,
     /*  78667 */   // GIR_Coverage, 26006,
     /*  78667 */   GIR_EraseRootFromParent_Done,
     /*  78668 */ // Label 1701: @78668
     /*  78668 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(78766), // Rule ID 22449 //
     /*  78673 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78676 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78691 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78695 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78699 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78703 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78707 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78710 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78714 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78721 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78725 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78730 */   // MIs[0] dst
     /*  78730 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78735 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78737 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78744 */   // (atomic_store (or:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  78747 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78751 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78755 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78758 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78764 */   GIR_RootConstrainSelectedInstOperands,
     /*  78765 */   // GIR_Coverage, 22449,
     /*  78765 */   GIR_EraseRootFromParent_Done,
     /*  78766 */ // Label 1702: @78766
     /*  78766 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(78864), // Rule ID 26010 //
     /*  78771 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78774 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78789 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78793 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78797 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78802 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78806 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78810 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78813 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78817 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78824 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78828 */   // MIs[0] dst
     /*  78828 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78833 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78835 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78842 */   // (atomic_store (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  78845 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78849 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78853 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78856 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78862 */   GIR_RootConstrainSelectedInstOperands,
     /*  78863 */   // GIR_Coverage, 26010,
     /*  78863 */   GIR_EraseRootFromParent_Done,
     /*  78864 */ // Label 1703: @78864
     /*  78864 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(78962), // Rule ID 22465 //
     /*  78869 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78872 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78879 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78883 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  78887 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78891 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78895 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78899 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78903 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78906 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78910 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78917 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78921 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78926 */   // MIs[0] dst
     /*  78926 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78931 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78933 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78940 */   // (atomic_store (sub:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (SUB64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mr),
     /*  78943 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78947 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78951 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78960 */   GIR_RootConstrainSelectedInstOperands,
     /*  78961 */   // GIR_Coverage, 22465,
     /*  78961 */   GIR_EraseRootFromParent_Done,
     /*  78962 */ // Label 1704: @78962
     /*  78962 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(79060), // Rule ID 22457 //
     /*  78967 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78970 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78977 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78985 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78989 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78993 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78997 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79001 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79004 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79008 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79015 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79019 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79024 */   // MIs[0] dst
     /*  79024 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79029 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79031 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79038 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  79041 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79045 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  79049 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79052 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79058 */   GIR_RootConstrainSelectedInstOperands,
     /*  79059 */   // GIR_Coverage, 22457,
     /*  79059 */   GIR_EraseRootFromParent_Done,
     /*  79060 */ // Label 1705: @79060
     /*  79060 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(79158), // Rule ID 26014 //
     /*  79065 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79068 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79075 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79083 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79087 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79091 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79096 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79100 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79104 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79107 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79111 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79118 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79122 */   // MIs[0] dst
     /*  79122 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79127 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79129 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79136 */   // (atomic_store (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  79139 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79143 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  79147 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79156 */   GIR_RootConstrainSelectedInstOperands,
     /*  79157 */   // GIR_Coverage, 26014,
     /*  79157 */   GIR_EraseRootFromParent_Done,
     /*  79158 */ // Label 1706: @79158
     /*  79158 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(79269), // Rule ID 837 //
     /*  79163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79166 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  79178 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79182 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79186 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  79190 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79194 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79198 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79201 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79205 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79209 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79214 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79219 */   // MIs[0] src1
     /*  79219 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79224 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79226 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79233 */   // (st (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD64mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79237 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79243 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  79247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mrCL),
     /*  79250 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79254 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79258 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79261 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79267 */   GIR_RootConstrainSelectedInstOperands,
     /*  79268 */   // GIR_Coverage, 837,
     /*  79268 */   GIR_EraseRootFromParent_Done,
     /*  79269 */ // Label 1707: @79269
     /*  79269 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(79380), // Rule ID 861 //
     /*  79274 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79277 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79281 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79285 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  79289 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79293 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79297 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  79301 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79306 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79310 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79314 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79317 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79321 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79325 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79330 */   // MIs[0] src1
     /*  79330 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79335 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79337 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79344 */   // (st (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD64mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79348 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79354 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  79358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mrCL),
     /*  79361 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79365 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79369 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79372 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79378 */   GIR_RootConstrainSelectedInstOperands,
     /*  79379 */   // GIR_Coverage, 861,
     /*  79379 */   GIR_EraseRootFromParent_Done,
     /*  79380 */ // Label 1708: @79380
     /*  79380 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(79468), // Rule ID 412 //
     /*  79385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79392 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79396 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79400 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79404 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79408 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79412 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79416 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79419 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79423 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79427 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79432 */   // MIs[0] src1
     /*  79432 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79437 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79439 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79446 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  79449 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79453 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79457 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79460 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79466 */   GIR_RootConstrainSelectedInstOperands,
     /*  79467 */   // GIR_Coverage, 412,
     /*  79467 */   GIR_EraseRootFromParent_Done,
     /*  79468 */ // Label 1709: @79468
     /*  79468 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(79556), // Rule ID 23222 //
     /*  79473 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79476 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79480 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79484 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79488 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79492 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79496 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79501 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79505 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79509 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79512 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79516 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79520 */   // MIs[0] src1
     /*  79520 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79525 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79527 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79534 */   // (st (add:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  79537 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79541 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79545 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79548 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79554 */   GIR_RootConstrainSelectedInstOperands,
     /*  79555 */   // GIR_Coverage, 23222,
     /*  79555 */   GIR_EraseRootFromParent_Done,
     /*  79556 */ // Label 1710: @79556
     /*  79556 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(79644), // Rule ID 304 //
     /*  79561 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79564 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79568 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79572 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79576 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79580 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79584 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79588 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79592 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79595 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79599 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79603 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79608 */   // MIs[0] src1
     /*  79608 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79613 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79615 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79622 */   // (st (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  79625 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79629 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79633 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79642 */   GIR_RootConstrainSelectedInstOperands,
     /*  79643 */   // GIR_Coverage, 304,
     /*  79643 */   GIR_EraseRootFromParent_Done,
     /*  79644 */ // Label 1711: @79644
     /*  79644 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(79732), // Rule ID 23186 //
     /*  79649 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79652 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79664 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79668 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79672 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79677 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79681 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79685 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79688 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79692 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79696 */   // MIs[0] src1
     /*  79696 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79701 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79703 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79710 */   // (st (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  79713 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79717 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79721 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79730 */   GIR_RootConstrainSelectedInstOperands,
     /*  79731 */   // GIR_Coverage, 23186,
     /*  79731 */   GIR_EraseRootFromParent_Done,
     /*  79732 */ // Label 1712: @79732
     /*  79732 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(79833), // Rule ID 751 //
     /*  79737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  79740 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79743 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79747 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79751 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  79755 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79759 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  79763 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79767 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79771 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79774 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79778 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79782 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79787 */   // MIs[0] src1
     /*  79787 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79792 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79794 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79801 */   // (st (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  79801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79805 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79811 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  79815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mCL),
     /*  79818 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79822 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79825 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79831 */   GIR_RootConstrainSelectedInstOperands,
     /*  79832 */   // GIR_Coverage, 751,
     /*  79832 */   GIR_EraseRootFromParent_Done,
     /*  79833 */ // Label 1713: @79833
     /*  79833 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(79934), // Rule ID 719 //
     /*  79838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  79841 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79844 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79848 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  79856 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79860 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  79864 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79868 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79872 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79875 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79879 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79883 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79888 */   // MIs[0] src1
     /*  79888 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79893 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79895 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79902 */   // (st (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  79902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79906 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79912 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  79916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mCL),
     /*  79919 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79923 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79926 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79932 */   GIR_RootConstrainSelectedInstOperands,
     /*  79933 */   // GIR_Coverage, 719,
     /*  79933 */   GIR_EraseRootFromParent_Done,
     /*  79934 */ // Label 1714: @79934
     /*  79934 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(80022), // Rule ID 340 //
     /*  79939 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79942 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79946 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79954 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79958 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79962 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79966 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79970 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79973 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79977 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79981 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79986 */   // MIs[0] src1
     /*  79986 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79991 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79993 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80000 */   // (st (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  80003 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80007 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80011 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80020 */   GIR_RootConstrainSelectedInstOperands,
     /*  80021 */   // GIR_Coverage, 340,
     /*  80021 */   GIR_EraseRootFromParent_Done,
     /*  80022 */ // Label 1715: @80022
     /*  80022 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(80110), // Rule ID 23198 //
     /*  80027 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80030 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80034 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80042 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80046 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80050 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80055 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80059 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80063 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80066 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80070 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80074 */   // MIs[0] src1
     /*  80074 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80079 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80081 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80088 */   // (st (or:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  80091 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80095 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  80099 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80102 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80108 */   GIR_RootConstrainSelectedInstOperands,
     /*  80109 */   // GIR_Coverage, 23198,
     /*  80109 */   GIR_EraseRootFromParent_Done,
     /*  80110 */ // Label 1716: @80110
     /*  80110 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(80211), // Rule ID 783 //
     /*  80115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80118 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80121 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80125 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80129 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  80133 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80137 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80141 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80145 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80149 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80152 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80156 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80160 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80165 */   // MIs[0] src1
     /*  80165 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80170 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80172 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80179 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80183 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80189 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mCL),
     /*  80196 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80200 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80209 */   GIR_RootConstrainSelectedInstOperands,
     /*  80210 */   // GIR_Coverage, 783,
     /*  80210 */   GIR_EraseRootFromParent_Done,
     /*  80211 */ // Label 1717: @80211
     /*  80211 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(80312), // Rule ID 815 //
     /*  80216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80222 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80226 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80230 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  80234 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80238 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80242 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80246 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80250 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80257 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80261 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80266 */   // MIs[0] src1
     /*  80266 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80271 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80273 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80280 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80284 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80290 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mCL),
     /*  80297 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80301 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80304 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80310 */   GIR_RootConstrainSelectedInstOperands,
     /*  80311 */   // GIR_Coverage, 815,
     /*  80311 */   GIR_EraseRootFromParent_Done,
     /*  80312 */ // Label 1718: @80312
     /*  80312 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(80413), // Rule ID 687 //
     /*  80317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80320 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80323 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80327 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80331 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  80335 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80339 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80343 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80347 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80351 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80354 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80358 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80362 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80367 */   // MIs[0] src1
     /*  80367 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80372 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80374 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80381 */   // (st (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80385 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80391 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mCL),
     /*  80398 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80402 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80405 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80411 */   GIR_RootConstrainSelectedInstOperands,
     /*  80412 */   // GIR_Coverage, 687,
     /*  80412 */   GIR_EraseRootFromParent_Done,
     /*  80413 */ // Label 1719: @80413
     /*  80413 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(80501), // Rule ID 448 //
     /*  80418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80425 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80429 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80433 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80437 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80441 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80445 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80449 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80452 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80456 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80460 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80465 */   // MIs[0] src1
     /*  80465 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80470 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80472 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80479 */   // (st (sub:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mr),
     /*  80482 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80486 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80490 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80493 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80499 */   GIR_RootConstrainSelectedInstOperands,
     /*  80500 */   // GIR_Coverage, 448,
     /*  80500 */   GIR_EraseRootFromParent_Done,
     /*  80501 */ // Label 1720: @80501
     /*  80501 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(80589), // Rule ID 376 //
     /*  80506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80509 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80513 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80517 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80521 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80525 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80529 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80533 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80537 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80540 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80544 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80548 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80553 */   // MIs[0] src1
     /*  80553 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80558 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80560 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80567 */   // (st (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  80570 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80574 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80578 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80581 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80587 */   GIR_RootConstrainSelectedInstOperands,
     /*  80588 */   // GIR_Coverage, 376,
     /*  80588 */   GIR_EraseRootFromParent_Done,
     /*  80589 */ // Label 1721: @80589
     /*  80589 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(80677), // Rule ID 23210 //
     /*  80594 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80597 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80601 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80605 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80609 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80613 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80617 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80622 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80626 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80630 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80633 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80637 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80641 */   // MIs[0] src1
     /*  80641 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80646 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80648 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80655 */   // (st (xor:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  80658 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80662 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  80666 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80669 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80675 */   GIR_RootConstrainSelectedInstOperands,
     /*  80676 */   // GIR_Coverage, 23210,
     /*  80676 */   GIR_EraseRootFromParent_Done,
     /*  80677 */ // Label 1722: @80677
     /*  80677 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(80734), // Rule ID 22509 //
     /*  80682 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80685 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80700 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  80704 */   // MIs[1] Operand 1
     /*  80704 */   // No operand predicates
     /*  80704 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80708 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80710 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80717 */   // (atomic_store (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOV64mi32 addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  80717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mi32),
     /*  80720 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80724 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  80727 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80732 */   GIR_RootConstrainSelectedInstOperands,
     /*  80733 */   // GIR_Coverage, 22509,
     /*  80733 */   GIR_EraseRootFromParent_Done,
     /*  80734 */ // Label 1723: @80734
     /*  80734 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(80800), // Rule ID 22521 //
     /*  80739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  80742 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80745 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80752 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80756 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  80760 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80764 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80769 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80773 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80775 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80782 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  80782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDmr),
     /*  80785 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80789 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  80793 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80798 */   GIR_RootConstrainSelectedInstOperands,
     /*  80799 */   // GIR_Coverage, 22521,
     /*  80799 */   GIR_EraseRootFromParent_Done,
     /*  80800 */ // Label 1724: @80800
     /*  80800 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(80866), // Rule ID 22522 //
     /*  80805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  80808 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80811 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  80826 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80830 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80839 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80841 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80848 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  80848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  80851 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80855 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  80859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80864 */   GIR_RootConstrainSelectedInstOperands,
     /*  80865 */   // GIR_Coverage, 22522,
     /*  80865 */   GIR_EraseRootFromParent_Done,
     /*  80866 */ // Label 1725: @80866
     /*  80866 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(80932), // Rule ID 22523 //
     /*  80871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  80874 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80877 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80884 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80888 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  80892 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80896 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80901 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80914 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  80914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  80917 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80921 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  80925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80930 */   GIR_RootConstrainSelectedInstOperands,
     /*  80931 */   // GIR_Coverage, 22523,
     /*  80931 */   GIR_EraseRootFromParent_Done,
     /*  80932 */ // Label 1726: @80932
     /*  80932 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(80995), // Rule ID 54 //
     /*  80937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  80940 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80943 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80947 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80951 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  80955 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80959 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80977 */   // (st (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src1)
     /*  80977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64mr),
     /*  80980 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80984 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  80988 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80993 */   GIR_RootConstrainSelectedInstOperands,
     /*  80994 */   // GIR_Coverage, 54,
     /*  80994 */   GIR_EraseRootFromParent_Done,
     /*  80995 */ // Label 1727: @80995
     /*  80995 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(81058), // Rule ID 60 //
     /*  81000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  81003 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  81018 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81022 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81027 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81031 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81033 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81040 */   // (st (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE64mr_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src1)
     /*  81040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64mr_EVEX),
     /*  81043 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81047 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  81051 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81056 */   GIR_RootConstrainSelectedInstOperands,
     /*  81057 */   // GIR_Coverage, 60,
     /*  81057 */   GIR_EraseRootFromParent_Done,
     /*  81058 */ // Label 1728: @81058
     /*  81058 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(81103), // Rule ID 22513 //
     /*  81063 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  81066 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81077 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81081 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81088 */   // (atomic_store GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOV64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  81088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mr),
     /*  81091 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81095 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81097 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81101 */   GIR_RootConstrainSelectedInstOperands,
     /*  81102 */   // GIR_Coverage, 22513,
     /*  81102 */   GIR_EraseRootFromParent_Done,
     /*  81103 */ // Label 1729: @81103
     /*  81103 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(81145), // Rule ID 35 //
     /*  81108 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81111 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81119 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81123 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81130 */   // (st GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  81130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mr),
     /*  81133 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81137 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81139 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81143 */   GIR_RootConstrainSelectedInstOperands,
     /*  81144 */   // GIR_Coverage, 35,
     /*  81144 */   GIR_EraseRootFromParent_Done,
     /*  81145 */ // Label 1730: @81145
     /*  81145 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(81200), // Rule ID 1095 //
     /*  81150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  81153 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81156 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81160 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  81167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  81171 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81175 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81182 */   // (st RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref32>>  =>  (ST_Fp64m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /*  81182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp64m32),
     /*  81185 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81189 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81191 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81198 */   GIR_RootConstrainSelectedInstOperands,
     /*  81199 */   // GIR_Coverage, 1095,
     /*  81199 */   GIR_EraseRootFromParent_Done,
     /*  81200 */ // Label 1731: @81200
     /*  81200 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(81248), // Rule ID 1096 //
     /*  81205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  81208 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81211 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  81219 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81223 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81230 */   // (st RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_Fp64m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /*  81230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp64m),
     /*  81233 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81237 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81239 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81246 */   GIR_RootConstrainSelectedInstOperands,
     /*  81247 */   // GIR_Coverage, 1096,
     /*  81247 */   GIR_EraseRootFromParent_Done,
     /*  81248 */ // Label 1732: @81248
     /*  81248 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(81293), // Rule ID 1691 //
     /*  81253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  81256 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81259 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81267 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81271 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81278 */   // (st FR64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  81281 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81285 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81291 */   GIR_RootConstrainSelectedInstOperands,
     /*  81292 */   // GIR_Coverage, 1691,
     /*  81292 */   GIR_EraseRootFromParent_Done,
     /*  81293 */ // Label 1733: @81293
     /*  81293 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(81338), // Rule ID 1693 //
     /*  81298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  81301 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81304 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81316 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81323 */   // (st FR64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDmr),
     /*  81326 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81330 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81336 */   GIR_RootConstrainSelectedInstOperands,
     /*  81337 */   // GIR_Coverage, 1693,
     /*  81337 */   GIR_EraseRootFromParent_Done,
     /*  81338 */ // Label 1734: @81338
     /*  81338 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(81383), // Rule ID 4615 //
     /*  81343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  81346 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81349 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  81357 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81361 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81368 */   // (st FR64X:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSDZmr addr:{ *:[iPTR] }:$dst, FR64X:{ *:[f64] }:$src)
     /*  81368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZmr),
     /*  81371 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81375 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81377 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81381 */   GIR_RootConstrainSelectedInstOperands,
     /*  81382 */   // GIR_Coverage, 4615,
     /*  81382 */   GIR_EraseRootFromParent_Done,
     /*  81383 */ // Label 1735: @81383
     /*  81383 */ GIM_Reject,
     /*  81384 */ // Label 1477: @81384
     /*  81384 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(81542),
     /*  81389 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81392 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(81444), // Rule ID 1097 //
     /*  81397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81400 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81404 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  81411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81426 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref32>>  =>  (ST_Fp80m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp80m32),
     /*  81429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81433 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81442 */     GIR_RootConstrainSelectedInstOperands,
     /*  81443 */     // GIR_Coverage, 1097,
     /*  81443 */     GIR_EraseRootFromParent_Done,
     /*  81444 */   // Label 1737: @81444
     /*  81444 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(81496), // Rule ID 1098 //
     /*  81449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81452 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81456 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81478 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref64>>  =>  (ST_Fp80m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp80m64),
     /*  81481 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81485 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81494 */     GIR_RootConstrainSelectedInstOperands,
     /*  81495 */     // GIR_Coverage, 1098,
     /*  81495 */     GIR_EraseRootFromParent_Done,
     /*  81496 */   // Label 1738: @81496
     /*  81496 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(81541), // Rule ID 1099 //
     /*  81501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81504 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81523 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_FpP80m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_FpP80m),
     /*  81526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81530 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81539 */     GIR_RootConstrainSelectedInstOperands,
     /*  81540 */     // GIR_Coverage, 1099,
     /*  81540 */     GIR_EraseRootFromParent_Done,
     /*  81541 */   // Label 1739: @81541
     /*  81541 */   GIM_Reject,
     /*  81542 */ // Label 1736: @81542
     /*  81542 */ GIM_Reject,
     /*  81543 */ // Label 1478: @81543
     /*  81543 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(81796),
     /*  81548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81551 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81555 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(81597), // Rule ID 23139 //
     /*  81560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  81563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81582 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  81585 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81589 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81595 */     GIR_RootConstrainSelectedInstOperands,
     /*  81596 */     // GIR_Coverage, 23139,
     /*  81596 */     GIR_EraseRootFromParent_Done,
     /*  81597 */   // Label 1741: @81597
     /*  81597 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(81635), // Rule ID 23140 //
     /*  81602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  81605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81620 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  81623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81627 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81633 */     GIR_RootConstrainSelectedInstOperands,
     /*  81634 */     // GIR_Coverage, 23140,
     /*  81634 */     GIR_EraseRootFromParent_Done,
     /*  81635 */   // Label 1742: @81635
     /*  81635 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(81677), // Rule ID 23143 //
     /*  81640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81651 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81662 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  81665 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81669 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81675 */     GIR_RootConstrainSelectedInstOperands,
     /*  81676 */     // GIR_Coverage, 23143,
     /*  81676 */     GIR_EraseRootFromParent_Done,
     /*  81677 */   // Label 1743: @81677
     /*  81677 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(81715), // Rule ID 23144 //
     /*  81682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81700 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  81703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81707 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81713 */     GIR_RootConstrainSelectedInstOperands,
     /*  81714 */     // GIR_Coverage, 23144,
     /*  81714 */     GIR_EraseRootFromParent_Done,
     /*  81715 */   // Label 1744: @81715
     /*  81715 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(81757), // Rule ID 23147 //
     /*  81720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  81723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81742 */     // (st VR128X:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[f128] }:$src)
     /*  81742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  81745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81749 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81755 */     GIR_RootConstrainSelectedInstOperands,
     /*  81756 */     // GIR_Coverage, 23147,
     /*  81756 */     GIR_EraseRootFromParent_Done,
     /*  81757 */   // Label 1745: @81757
     /*  81757 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(81795), // Rule ID 23148 //
     /*  81762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  81765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81780 */     // (st VR128X:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[f128] }:$src)
     /*  81780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  81783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81787 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81793 */     GIR_RootConstrainSelectedInstOperands,
     /*  81794 */     // GIR_Coverage, 23148,
     /*  81794 */     GIR_EraseRootFromParent_Done,
     /*  81795 */   // Label 1746: @81795
     /*  81795 */   GIM_Reject,
     /*  81796 */ // Label 1740: @81796
     /*  81796 */ GIM_Reject,
     /*  81797 */ // Label 1479: @81797
     /*  81797 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(82290),
     /*  81802 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81805 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81809 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(81851), // Rule ID 1715 //
     /*  81814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81825 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81836 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  81836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDmr),
     /*  81839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81843 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81849 */     GIR_RootConstrainSelectedInstOperands,
     /*  81850 */     // GIR_Coverage, 1715,
     /*  81850 */     GIR_EraseRootFromParent_Done,
     /*  81851 */   // Label 1748: @81851
     /*  81851 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(81889), // Rule ID 1717 //
     /*  81856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81874 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  81874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDmr),
     /*  81877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81881 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81887 */     GIR_RootConstrainSelectedInstOperands,
     /*  81888 */     // GIR_Coverage, 1717,
     /*  81888 */     GIR_EraseRootFromParent_Done,
     /*  81889 */   // Label 1749: @81889
     /*  81889 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(81931), // Rule ID 1723 //
     /*  81894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  81897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81916 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  81916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPDmr),
     /*  81919 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81923 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81929 */     GIR_RootConstrainSelectedInstOperands,
     /*  81930 */     // GIR_Coverage, 1723,
     /*  81930 */     GIR_EraseRootFromParent_Done,
     /*  81931 */   // Label 1750: @81931
     /*  81931 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(81969), // Rule ID 1725 //
     /*  81936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  81939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81954 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  81954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPDmr),
     /*  81957 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81961 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81967 */     GIR_RootConstrainSelectedInstOperands,
     /*  81968 */     // GIR_Coverage, 1725,
     /*  81968 */     GIR_EraseRootFromParent_Done,
     /*  81969 */   // Label 1751: @81969
     /*  81969 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(82011), // Rule ID 2519 //
     /*  81974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81985 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81996 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  81996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  81999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82003 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82009 */     GIR_RootConstrainSelectedInstOperands,
     /*  82010 */     // GIR_Coverage, 2519,
     /*  82010 */     GIR_EraseRootFromParent_Done,
     /*  82011 */   // Label 1752: @82011
     /*  82011 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(82049), // Rule ID 2520 //
     /*  82016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82034 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  82037 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82041 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82047 */     GIR_RootConstrainSelectedInstOperands,
     /*  82048 */     // GIR_Coverage, 2520,
     /*  82048 */     GIR_EraseRootFromParent_Done,
     /*  82049 */   // Label 1753: @82049
     /*  82049 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(82091), // Rule ID 4495 //
     /*  82054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82076 */     // (st VR128X:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2f64] }:$src)
     /*  82076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128mr),
     /*  82079 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82083 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82089 */     GIR_RootConstrainSelectedInstOperands,
     /*  82090 */     // GIR_Coverage, 4495,
     /*  82090 */     GIR_EraseRootFromParent_Done,
     /*  82091 */   // Label 1754: @82091
     /*  82091 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(82129), // Rule ID 4519 //
     /*  82096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82114 */     // (st VR128X:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2f64] }:$src)
     /*  82114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ128mr),
     /*  82117 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82121 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82127 */     GIR_RootConstrainSelectedInstOperands,
     /*  82128 */     // GIR_Coverage, 4519,
     /*  82128 */     GIR_EraseRootFromParent_Done,
     /*  82129 */   // Label 1755: @82129
     /*  82129 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(82171), // Rule ID 4549 //
     /*  82134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82156 */     // (st VR128X:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2i64] }:$src)
     /*  82156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  82159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82163 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82169 */     GIR_RootConstrainSelectedInstOperands,
     /*  82170 */     // GIR_Coverage, 4549,
     /*  82170 */     GIR_EraseRootFromParent_Done,
     /*  82171 */   // Label 1756: @82171
     /*  82171 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(82209), // Rule ID 4591 //
     /*  82176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82194 */     // (st VR128X:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2i64] }:$src)
     /*  82194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  82197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82201 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82207 */     GIR_RootConstrainSelectedInstOperands,
     /*  82208 */     // GIR_Coverage, 4591,
     /*  82208 */     GIR_EraseRootFromParent_Done,
     /*  82209 */   // Label 1757: @82209
     /*  82209 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(82251), // Rule ID 17946 //
     /*  82214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82236 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82243 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82249 */     GIR_RootConstrainSelectedInstOperands,
     /*  82250 */     // GIR_Coverage, 17946,
     /*  82250 */     GIR_EraseRootFromParent_Done,
     /*  82251 */   // Label 1758: @82251
     /*  82251 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(82289), // Rule ID 17950 //
     /*  82256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82274 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82277 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82281 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82287 */     GIR_RootConstrainSelectedInstOperands,
     /*  82288 */     // GIR_Coverage, 17950,
     /*  82288 */     GIR_EraseRootFromParent_Done,
     /*  82289 */   // Label 1759: @82289
     /*  82289 */   GIM_Reject,
     /*  82290 */ // Label 1747: @82290
     /*  82290 */ GIM_Reject,
     /*  82291 */ // Label 1480: @82291
     /*  82291 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(82784),
     /*  82296 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82299 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82303 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(82345), // Rule ID 1714 //
     /*  82308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82319 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82330 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  82333 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82337 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82343 */     GIR_RootConstrainSelectedInstOperands,
     /*  82344 */     // GIR_Coverage, 1714,
     /*  82344 */     GIR_EraseRootFromParent_Done,
     /*  82345 */   // Label 1761: @82345
     /*  82345 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(82383), // Rule ID 1716 //
     /*  82350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82368 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  82371 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82375 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82381 */     GIR_RootConstrainSelectedInstOperands,
     /*  82382 */     // GIR_Coverage, 1716,
     /*  82382 */     GIR_EraseRootFromParent_Done,
     /*  82383 */   // Label 1762: @82383
     /*  82383 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(82425), // Rule ID 1722 //
     /*  82388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82410 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82413 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82417 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82423 */     GIR_RootConstrainSelectedInstOperands,
     /*  82424 */     // GIR_Coverage, 1722,
     /*  82424 */     GIR_EraseRootFromParent_Done,
     /*  82425 */   // Label 1763: @82425
     /*  82425 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(82463), // Rule ID 1724 //
     /*  82430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82448 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82455 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82461 */     GIR_RootConstrainSelectedInstOperands,
     /*  82462 */     // GIR_Coverage, 1724,
     /*  82462 */     GIR_EraseRootFromParent_Done,
     /*  82463 */   // Label 1764: @82463
     /*  82463 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(82505), // Rule ID 4477 //
     /*  82468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82490 */     // (st VR128X:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4f32] }:$src)
     /*  82490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  82493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82497 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82503 */     GIR_RootConstrainSelectedInstOperands,
     /*  82504 */     // GIR_Coverage, 4477,
     /*  82504 */     GIR_EraseRootFromParent_Done,
     /*  82505 */   // Label 1765: @82505
     /*  82505 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(82543), // Rule ID 4507 //
     /*  82510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82528 */     // (st VR128X:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4f32] }:$src)
     /*  82528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  82531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82535 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82541 */     GIR_RootConstrainSelectedInstOperands,
     /*  82542 */     // GIR_Coverage, 4507,
     /*  82542 */     GIR_EraseRootFromParent_Done,
     /*  82543 */   // Label 1766: @82543
     /*  82543 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(82585), // Rule ID 17947 //
     /*  82548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82570 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82577 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82583 */     GIR_RootConstrainSelectedInstOperands,
     /*  82584 */     // GIR_Coverage, 17947,
     /*  82584 */     GIR_EraseRootFromParent_Done,
     /*  82585 */   // Label 1767: @82585
     /*  82585 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(82623), // Rule ID 17951 //
     /*  82590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82608 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82615 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82621 */     GIR_RootConstrainSelectedInstOperands,
     /*  82622 */     // GIR_Coverage, 17951,
     /*  82622 */     GIR_EraseRootFromParent_Done,
     /*  82623 */   // Label 1768: @82623
     /*  82623 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(82665), // Rule ID 18326 //
     /*  82628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82650 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  82653 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82657 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82663 */     GIR_RootConstrainSelectedInstOperands,
     /*  82664 */     // GIR_Coverage, 18326,
     /*  82664 */     GIR_EraseRootFromParent_Done,
     /*  82665 */   // Label 1769: @82665
     /*  82665 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(82703), // Rule ID 18330 //
     /*  82670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82688 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  82691 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82695 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82701 */     GIR_RootConstrainSelectedInstOperands,
     /*  82702 */     // GIR_Coverage, 18330,
     /*  82702 */     GIR_EraseRootFromParent_Done,
     /*  82703 */   // Label 1770: @82703
     /*  82703 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(82745), // Rule ID 19819 //
     /*  82708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  82711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82730 */     // (st VR128X:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4i32] }:$src)
     /*  82730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  82733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82737 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82743 */     GIR_RootConstrainSelectedInstOperands,
     /*  82744 */     // GIR_Coverage, 19819,
     /*  82744 */     GIR_EraseRootFromParent_Done,
     /*  82745 */   // Label 1771: @82745
     /*  82745 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(82783), // Rule ID 19823 //
     /*  82750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  82753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82768 */     // (st VR128X:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4i32] }:$src)
     /*  82768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  82771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82775 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82781 */     GIR_RootConstrainSelectedInstOperands,
     /*  82782 */     // GIR_Coverage, 19823,
     /*  82782 */     GIR_EraseRootFromParent_Done,
     /*  82783 */   // Label 1772: @82783
     /*  82783 */   GIM_Reject,
     /*  82784 */ // Label 1760: @82784
     /*  82784 */ GIM_Reject,
     /*  82785 */ // Label 1481: @82785
     /*  82785 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(83118),
     /*  82790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82793 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82797 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(82839), // Rule ID 1719 //
     /*  82802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  82809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82824 */     // (st VR256:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4f64] }:$src)
     /*  82824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDYmr),
     /*  82827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82831 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82837 */     GIR_RootConstrainSelectedInstOperands,
     /*  82838 */     // GIR_Coverage, 1719,
     /*  82838 */     GIR_EraseRootFromParent_Done,
     /*  82839 */   // Label 1774: @82839
     /*  82839 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(82877), // Rule ID 1721 //
     /*  82844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  82851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82862 */     // (st VR256:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4f64] }:$src)
     /*  82862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDYmr),
     /*  82865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82869 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82875 */     GIR_RootConstrainSelectedInstOperands,
     /*  82876 */     // GIR_Coverage, 1721,
     /*  82876 */     GIR_EraseRootFromParent_Done,
     /*  82877 */   // Label 1775: @82877
     /*  82877 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(82919), // Rule ID 4494 //
     /*  82882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  82889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82893 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82904 */     // (st VR256X:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4f64] }:$src)
     /*  82904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256mr),
     /*  82907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82911 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82917 */     GIR_RootConstrainSelectedInstOperands,
     /*  82918 */     // GIR_Coverage, 4494,
     /*  82918 */     GIR_EraseRootFromParent_Done,
     /*  82919 */   // Label 1776: @82919
     /*  82919 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(82957), // Rule ID 4518 //
     /*  82924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  82931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82942 */     // (st VR256X:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4f64] }:$src)
     /*  82942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ256mr),
     /*  82945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82949 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82955 */     GIR_RootConstrainSelectedInstOperands,
     /*  82956 */     // GIR_Coverage, 4518,
     /*  82956 */     GIR_EraseRootFromParent_Done,
     /*  82957 */   // Label 1777: @82957
     /*  82957 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(82999), // Rule ID 4548 //
     /*  82962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  82969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82984 */     // (st VR256X:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4i64] }:$src)
     /*  82984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  82987 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82991 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82997 */     GIR_RootConstrainSelectedInstOperands,
     /*  82998 */     // GIR_Coverage, 4548,
     /*  82998 */     GIR_EraseRootFromParent_Done,
     /*  82999 */   // Label 1778: @82999
     /*  82999 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(83037), // Rule ID 4590 //
     /*  83004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83022 */     // (st VR256X:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4i64] }:$src)
     /*  83022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  83025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83029 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83035 */     GIR_RootConstrainSelectedInstOperands,
     /*  83036 */     // GIR_Coverage, 4590,
     /*  83036 */     GIR_EraseRootFromParent_Done,
     /*  83037 */   // Label 1779: @83037
     /*  83037 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(83079), // Rule ID 17922 //
     /*  83042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83053 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83064 */     // (st VR256:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src)
     /*  83064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  83067 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83071 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83077 */     GIR_RootConstrainSelectedInstOperands,
     /*  83078 */     // GIR_Coverage, 17922,
     /*  83078 */     GIR_EraseRootFromParent_Done,
     /*  83079 */   // Label 1780: @83079
     /*  83079 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(83117), // Rule ID 17926 //
     /*  83084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83102 */     // (st VR256:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src)
     /*  83102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  83105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83109 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83115 */     GIR_RootConstrainSelectedInstOperands,
     /*  83116 */     // GIR_Coverage, 17926,
     /*  83116 */     GIR_EraseRootFromParent_Done,
     /*  83117 */   // Label 1781: @83117
     /*  83117 */   GIM_Reject,
     /*  83118 */ // Label 1773: @83118
     /*  83118 */ GIM_Reject,
     /*  83119 */ // Label 1482: @83119
     /*  83119 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(83200),
     /*  83124 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  83135 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83139 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(83169), // Rule ID 4395 //
     /*  83144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoEGPR),
     /*  83147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83154 */     // (st VK8:{ *:[v8i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVBmk addr:{ *:[iPTR] }:$dst, VK8:{ *:[v8i1] }:$src)
     /*  83154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBmk),
     /*  83157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83161 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83167 */     GIR_RootConstrainSelectedInstOperands,
     /*  83168 */     // GIR_Coverage, 4395,
     /*  83168 */     GIR_EraseRootFromParent_Done,
     /*  83169 */   // Label 1783: @83169
     /*  83169 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(83199), // Rule ID 4397 //
     /*  83174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEGPR_In64BitMode),
     /*  83177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83184 */     // (st VK8:{ *:[v8i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVBmk_EVEX addr:{ *:[iPTR] }:$dst, VK8:{ *:[v8i1] }:$src)
     /*  83184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBmk_EVEX),
     /*  83187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83191 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83197 */     GIR_RootConstrainSelectedInstOperands,
     /*  83198 */     // GIR_Coverage, 4397,
     /*  83198 */     GIR_EraseRootFromParent_Done,
     /*  83199 */   // Label 1784: @83199
     /*  83199 */   GIM_Reject,
     /*  83200 */ // Label 1782: @83200
     /*  83200 */ GIM_Reject,
     /*  83201 */ // Label 1483: @83201
     /*  83201 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(83774),
     /*  83206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83213 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(83255), // Rule ID 17932 //
     /*  83218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83240 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  83243 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83247 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83253 */     GIR_RootConstrainSelectedInstOperands,
     /*  83254 */     // GIR_Coverage, 17932,
     /*  83254 */     GIR_EraseRootFromParent_Done,
     /*  83255 */   // Label 1786: @83255
     /*  83255 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(83293), // Rule ID 17933 //
     /*  83260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83278 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  83281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83285 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83291 */     GIR_RootConstrainSelectedInstOperands,
     /*  83292 */     // GIR_Coverage, 17933,
     /*  83292 */     GIR_EraseRootFromParent_Done,
     /*  83293 */   // Label 1787: @83293
     /*  83293 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(83335), // Rule ID 17948 //
     /*  83298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  83301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83320 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  83323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83327 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83333 */     GIR_RootConstrainSelectedInstOperands,
     /*  83334 */     // GIR_Coverage, 17948,
     /*  83334 */     GIR_EraseRootFromParent_Done,
     /*  83335 */   // Label 1788: @83335
     /*  83335 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(83373), // Rule ID 17952 //
     /*  83340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  83343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83358 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  83361 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83365 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83371 */     GIR_RootConstrainSelectedInstOperands,
     /*  83372 */     // GIR_Coverage, 17952,
     /*  83372 */     GIR_EraseRootFromParent_Done,
     /*  83373 */   // Label 1789: @83373
     /*  83373 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(83415), // Rule ID 17956 //
     /*  83378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  83381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83389 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83400 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  83403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83407 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83413 */     GIR_RootConstrainSelectedInstOperands,
     /*  83414 */     // GIR_Coverage, 17956,
     /*  83414 */     GIR_EraseRootFromParent_Done,
     /*  83415 */   // Label 1790: @83415
     /*  83415 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(83453), // Rule ID 17957 //
     /*  83420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  83423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83438 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  83441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83445 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83451 */     GIR_RootConstrainSelectedInstOperands,
     /*  83452 */     // GIR_Coverage, 17957,
     /*  83452 */     GIR_EraseRootFromParent_Done,
     /*  83453 */   // Label 1791: @83453
     /*  83453 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(83495), // Rule ID 18327 //
     /*  83458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83469 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83480 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  83483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83487 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83493 */     GIR_RootConstrainSelectedInstOperands,
     /*  83494 */     // GIR_Coverage, 18327,
     /*  83494 */     GIR_EraseRootFromParent_Done,
     /*  83495 */   // Label 1792: @83495
     /*  83495 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(83537), // Rule ID 18328 //
     /*  83500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83522 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  83525 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83529 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83535 */     GIR_RootConstrainSelectedInstOperands,
     /*  83536 */     // GIR_Coverage, 18328,
     /*  83536 */     GIR_EraseRootFromParent_Done,
     /*  83537 */   // Label 1793: @83537
     /*  83537 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(83575), // Rule ID 18331 //
     /*  83542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83560 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  83563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83567 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83573 */     GIR_RootConstrainSelectedInstOperands,
     /*  83574 */     // GIR_Coverage, 18331,
     /*  83574 */     GIR_EraseRootFromParent_Done,
     /*  83575 */   // Label 1794: @83575
     /*  83575 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(83613), // Rule ID 18332 //
     /*  83580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83598 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  83601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83605 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83611 */     GIR_RootConstrainSelectedInstOperands,
     /*  83612 */     // GIR_Coverage, 18332,
     /*  83612 */     GIR_EraseRootFromParent_Done,
     /*  83613 */   // Label 1795: @83613
     /*  83613 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(83655), // Rule ID 19820 //
     /*  83618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83640 */     // (st VR128X:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8i16] }:$src)
     /*  83640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  83643 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83647 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83653 */     GIR_RootConstrainSelectedInstOperands,
     /*  83654 */     // GIR_Coverage, 19820,
     /*  83654 */     GIR_EraseRootFromParent_Done,
     /*  83655 */   // Label 1796: @83655
     /*  83655 */   GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(83697), // Rule ID 19821 //
     /*  83660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83682 */     // (st VR128X:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8f16] }:$src)
     /*  83682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  83685 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83689 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83695 */     GIR_RootConstrainSelectedInstOperands,
     /*  83696 */     // GIR_Coverage, 19821,
     /*  83696 */     GIR_EraseRootFromParent_Done,
     /*  83697 */   // Label 1797: @83697
     /*  83697 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(83735), // Rule ID 19824 //
     /*  83702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83720 */     // (st VR128X:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8i16] }:$src)
     /*  83720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  83723 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83727 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83733 */     GIR_RootConstrainSelectedInstOperands,
     /*  83734 */     // GIR_Coverage, 19824,
     /*  83734 */     GIR_EraseRootFromParent_Done,
     /*  83735 */   // Label 1798: @83735
     /*  83735 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(83773), // Rule ID 19825 //
     /*  83740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83758 */     // (st VR128X:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8f16] }:$src)
     /*  83758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  83761 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83765 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83771 */     GIR_RootConstrainSelectedInstOperands,
     /*  83772 */     // GIR_Coverage, 19825,
     /*  83772 */     GIR_EraseRootFromParent_Done,
     /*  83773 */   // Label 1799: @83773
     /*  83773 */   GIM_Reject,
     /*  83774 */ // Label 1785: @83774
     /*  83774 */ GIM_Reject,
     /*  83775 */ // Label 1484: @83775
     /*  83775 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(84108),
     /*  83780 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83783 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83787 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(83829), // Rule ID 1718 //
     /*  83792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83803 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83814 */     // (st VR256:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8f32] }:$src)
     /*  83814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  83817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83821 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83827 */     GIR_RootConstrainSelectedInstOperands,
     /*  83828 */     // GIR_Coverage, 1718,
     /*  83828 */     GIR_EraseRootFromParent_Done,
     /*  83829 */   // Label 1801: @83829
     /*  83829 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(83867), // Rule ID 1720 //
     /*  83834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83852 */     // (st VR256:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8f32] }:$src)
     /*  83852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  83855 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83859 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83865 */     GIR_RootConstrainSelectedInstOperands,
     /*  83866 */     // GIR_Coverage, 1720,
     /*  83866 */     GIR_EraseRootFromParent_Done,
     /*  83867 */   // Label 1802: @83867
     /*  83867 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(83909), // Rule ID 4476 //
     /*  83872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83883 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83894 */     // (st VR256X:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8f32] }:$src)
     /*  83894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256mr),
     /*  83897 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83901 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83907 */     GIR_RootConstrainSelectedInstOperands,
     /*  83908 */     // GIR_Coverage, 4476,
     /*  83908 */     GIR_EraseRootFromParent_Done,
     /*  83909 */   // Label 1803: @83909
     /*  83909 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(83947), // Rule ID 4506 //
     /*  83914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83932 */     // (st VR256X:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8f32] }:$src)
     /*  83932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256mr),
     /*  83935 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83939 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83945 */     GIR_RootConstrainSelectedInstOperands,
     /*  83946 */     // GIR_Coverage, 4506,
     /*  83946 */     GIR_EraseRootFromParent_Done,
     /*  83947 */   // Label 1804: @83947
     /*  83947 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(83989), // Rule ID 17923 //
     /*  83952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83974 */     // (st VR256:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src)
     /*  83974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  83977 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83981 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83987 */     GIR_RootConstrainSelectedInstOperands,
     /*  83988 */     // GIR_Coverage, 17923,
     /*  83988 */     GIR_EraseRootFromParent_Done,
     /*  83989 */   // Label 1805: @83989
     /*  83989 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(84027), // Rule ID 17927 //
     /*  83994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84012 */     // (st VR256:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src)
     /*  84012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84015 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84019 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84025 */     GIR_RootConstrainSelectedInstOperands,
     /*  84026 */     // GIR_Coverage, 17927,
     /*  84026 */     GIR_EraseRootFromParent_Done,
     /*  84027 */   // Label 1806: @84027
     /*  84027 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(84069), // Rule ID 19835 //
     /*  84032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84043 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84054 */     // (st VR256X:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8i32] }:$src)
     /*  84054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  84057 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84061 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84067 */     GIR_RootConstrainSelectedInstOperands,
     /*  84068 */     // GIR_Coverage, 19835,
     /*  84068 */     GIR_EraseRootFromParent_Done,
     /*  84069 */   // Label 1807: @84069
     /*  84069 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(84107), // Rule ID 19839 //
     /*  84074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84092 */     // (st VR256X:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8i32] }:$src)
     /*  84092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  84095 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84099 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84105 */     GIR_RootConstrainSelectedInstOperands,
     /*  84106 */     // GIR_Coverage, 19839,
     /*  84106 */     GIR_EraseRootFromParent_Done,
     /*  84107 */   // Label 1808: @84107
     /*  84107 */   GIM_Reject,
     /*  84108 */ // Label 1800: @84108
     /*  84108 */ GIM_Reject,
     /*  84109 */ // Label 1485: @84109
     /*  84109 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(84282),
     /*  84114 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84117 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84121 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(84163), // Rule ID 4493 //
     /*  84126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84148 */     // (st VR512:{ *:[v8f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8f64] }:$src)
     /*  84148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZmr),
     /*  84151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84155 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84161 */     GIR_RootConstrainSelectedInstOperands,
     /*  84162 */     // GIR_Coverage, 4493,
     /*  84162 */     GIR_EraseRootFromParent_Done,
     /*  84163 */   // Label 1810: @84163
     /*  84163 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(84201), // Rule ID 4517 //
     /*  84168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84186 */     // (st VR512:{ *:[v8f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8f64] }:$src)
     /*  84186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZmr),
     /*  84189 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84193 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84199 */     GIR_RootConstrainSelectedInstOperands,
     /*  84200 */     // GIR_Coverage, 4517,
     /*  84200 */     GIR_EraseRootFromParent_Done,
     /*  84201 */   // Label 1811: @84201
     /*  84201 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(84243), // Rule ID 4547 //
     /*  84206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84217 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84228 */     // (st VR512:{ *:[v8i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8i64] }:$src)
     /*  84228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  84231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84235 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84241 */     GIR_RootConstrainSelectedInstOperands,
     /*  84242 */     // GIR_Coverage, 4547,
     /*  84242 */     GIR_EraseRootFromParent_Done,
     /*  84243 */   // Label 1812: @84243
     /*  84243 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(84281), // Rule ID 4589 //
     /*  84248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84266 */     // (st VR512:{ *:[v8i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8i64] }:$src)
     /*  84266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  84269 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84273 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84279 */     GIR_RootConstrainSelectedInstOperands,
     /*  84280 */     // GIR_Coverage, 4589,
     /*  84280 */     GIR_EraseRootFromParent_Done,
     /*  84281 */   // Label 1813: @84281
     /*  84281 */   GIM_Reject,
     /*  84282 */ // Label 1809: @84282
     /*  84282 */ GIM_Reject,
     /*  84283 */ // Label 1486: @84283
     /*  84283 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(84364),
     /*  84288 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84291 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  84299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84303 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(84333), // Rule ID 4399 //
     /*  84308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoEGPR),
     /*  84311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84318 */     // (st VK16:{ *:[v16i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVWmk addr:{ *:[iPTR] }:$dst, VK16:{ *:[v16i1] }:$src)
     /*  84318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWmk),
     /*  84321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84325 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84331 */     GIR_RootConstrainSelectedInstOperands,
     /*  84332 */     // GIR_Coverage, 4399,
     /*  84332 */     GIR_EraseRootFromParent_Done,
     /*  84333 */   // Label 1815: @84333
     /*  84333 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(84363), // Rule ID 4401 //
     /*  84338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEGPR_In64BitMode),
     /*  84341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84348 */     // (st VK16:{ *:[v16i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVWmk_EVEX addr:{ *:[iPTR] }:$dst, VK16:{ *:[v16i1] }:$src)
     /*  84348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWmk_EVEX),
     /*  84351 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84355 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84361 */     GIR_RootConstrainSelectedInstOperands,
     /*  84362 */     // GIR_Coverage, 4401,
     /*  84362 */     GIR_EraseRootFromParent_Done,
     /*  84363 */   // Label 1816: @84363
     /*  84363 */   GIM_Reject,
     /*  84364 */ // Label 1814: @84364
     /*  84364 */ GIM_Reject,
     /*  84365 */ // Label 1487: @84365
     /*  84365 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(84618),
     /*  84370 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84373 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84377 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(84419), // Rule ID 17949 //
     /*  84382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  84385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84404 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  84407 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84411 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84417 */     GIR_RootConstrainSelectedInstOperands,
     /*  84418 */     // GIR_Coverage, 17949,
     /*  84418 */     GIR_EraseRootFromParent_Done,
     /*  84419 */   // Label 1818: @84419
     /*  84419 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(84457), // Rule ID 17953 //
     /*  84424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  84427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84442 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  84445 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84449 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84455 */     GIR_RootConstrainSelectedInstOperands,
     /*  84456 */     // GIR_Coverage, 17953,
     /*  84456 */     GIR_EraseRootFromParent_Done,
     /*  84457 */   // Label 1819: @84457
     /*  84457 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(84499), // Rule ID 18329 //
     /*  84462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84473 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84484 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  84487 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84491 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84497 */     GIR_RootConstrainSelectedInstOperands,
     /*  84498 */     // GIR_Coverage, 18329,
     /*  84498 */     GIR_EraseRootFromParent_Done,
     /*  84499 */   // Label 1820: @84499
     /*  84499 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(84537), // Rule ID 18333 //
     /*  84504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84522 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  84525 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84529 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84535 */     GIR_RootConstrainSelectedInstOperands,
     /*  84536 */     // GIR_Coverage, 18333,
     /*  84536 */     GIR_EraseRootFromParent_Done,
     /*  84537 */   // Label 1821: @84537
     /*  84537 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(84579), // Rule ID 19822 //
     /*  84542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  84549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84553 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84564 */     // (st VR128X:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v16i8] }:$src)
     /*  84564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  84567 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84571 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84577 */     GIR_RootConstrainSelectedInstOperands,
     /*  84578 */     // GIR_Coverage, 19822,
     /*  84578 */     GIR_EraseRootFromParent_Done,
     /*  84579 */   // Label 1822: @84579
     /*  84579 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(84617), // Rule ID 19826 //
     /*  84584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  84591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84602 */     // (st VR128X:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v16i8] }:$src)
     /*  84602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  84605 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84609 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84615 */     GIR_RootConstrainSelectedInstOperands,
     /*  84616 */     // GIR_Coverage, 19826,
     /*  84616 */     GIR_EraseRootFromParent_Done,
     /*  84617 */   // Label 1823: @84617
     /*  84617 */   GIM_Reject,
     /*  84618 */ // Label 1817: @84618
     /*  84618 */ GIM_Reject,
     /*  84619 */ // Label 1488: @84619
     /*  84619 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(84952),
     /*  84624 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84627 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84631 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(84673), // Rule ID 17924 //
     /*  84636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84658 */     // (st VR256:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16i16] }:$src)
     /*  84658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84665 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84671 */     GIR_RootConstrainSelectedInstOperands,
     /*  84672 */     // GIR_Coverage, 17924,
     /*  84672 */     GIR_EraseRootFromParent_Done,
     /*  84673 */   // Label 1825: @84673
     /*  84673 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(84711), // Rule ID 17928 //
     /*  84678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84696 */     // (st VR256:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16i16] }:$src)
     /*  84696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84703 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84709 */     GIR_RootConstrainSelectedInstOperands,
     /*  84710 */     // GIR_Coverage, 17928,
     /*  84710 */     GIR_EraseRootFromParent_Done,
     /*  84711 */   // Label 1826: @84711
     /*  84711 */   GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(84753), // Rule ID 17936 //
     /*  84716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84727 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84738 */     // (st VR256:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16f16] }:$src)
     /*  84738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84741 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84745 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84751 */     GIR_RootConstrainSelectedInstOperands,
     /*  84752 */     // GIR_Coverage, 17936,
     /*  84752 */     GIR_EraseRootFromParent_Done,
     /*  84753 */   // Label 1827: @84753
     /*  84753 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(84791), // Rule ID 17937 //
     /*  84758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84776 */     // (st VR256:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16f16] }:$src)
     /*  84776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84779 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84783 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84789 */     GIR_RootConstrainSelectedInstOperands,
     /*  84790 */     // GIR_Coverage, 17937,
     /*  84790 */     GIR_EraseRootFromParent_Done,
     /*  84791 */   // Label 1828: @84791
     /*  84791 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(84833), // Rule ID 19836 //
     /*  84796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84807 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84818 */     // (st VR256X:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16i16] }:$src)
     /*  84818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  84821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84825 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84831 */     GIR_RootConstrainSelectedInstOperands,
     /*  84832 */     // GIR_Coverage, 19836,
     /*  84832 */     GIR_EraseRootFromParent_Done,
     /*  84833 */   // Label 1829: @84833
     /*  84833 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(84875), // Rule ID 19837 //
     /*  84838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84860 */     // (st VR256X:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16f16] }:$src)
     /*  84860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256mr),
     /*  84863 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84867 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84873 */     GIR_RootConstrainSelectedInstOperands,
     /*  84874 */     // GIR_Coverage, 19837,
     /*  84874 */     GIR_EraseRootFromParent_Done,
     /*  84875 */   // Label 1830: @84875
     /*  84875 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(84913), // Rule ID 19840 //
     /*  84880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84898 */     // (st VR256X:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16i16] }:$src)
     /*  84898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  84901 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84905 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84911 */     GIR_RootConstrainSelectedInstOperands,
     /*  84912 */     // GIR_Coverage, 19840,
     /*  84912 */     GIR_EraseRootFromParent_Done,
     /*  84913 */   // Label 1831: @84913
     /*  84913 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(84951), // Rule ID 19841 //
     /*  84918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84936 */     // (st VR256X:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16f16] }:$src)
     /*  84936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256mr),
     /*  84939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84943 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84949 */     GIR_RootConstrainSelectedInstOperands,
     /*  84950 */     // GIR_Coverage, 19841,
     /*  84950 */     GIR_EraseRootFromParent_Done,
     /*  84951 */   // Label 1832: @84951
     /*  84951 */   GIM_Reject,
     /*  84952 */ // Label 1824: @84952
     /*  84952 */ GIM_Reject,
     /*  84953 */ // Label 1489: @84953
     /*  84953 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(85126),
     /*  84958 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84961 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84965 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(85007), // Rule ID 4475 //
     /*  84970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84992 */     // (st VR512:{ *:[v16f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16f32] }:$src)
     /*  84992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZmr),
     /*  84995 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84999 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85005 */     GIR_RootConstrainSelectedInstOperands,
     /*  85006 */     // GIR_Coverage, 4475,
     /*  85006 */     GIR_EraseRootFromParent_Done,
     /*  85007 */   // Label 1834: @85007
     /*  85007 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(85045), // Rule ID 4505 //
     /*  85012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85030 */     // (st VR512:{ *:[v16f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16f32] }:$src)
     /*  85030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZmr),
     /*  85033 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85037 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85043 */     GIR_RootConstrainSelectedInstOperands,
     /*  85044 */     // GIR_Coverage, 4505,
     /*  85044 */     GIR_EraseRootFromParent_Done,
     /*  85045 */   // Label 1835: @85045
     /*  85045 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(85087), // Rule ID 19803 //
     /*  85050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85072 */     // (st VR512:{ *:[v16i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16i32] }:$src)
     /*  85072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85075 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85079 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85085 */     GIR_RootConstrainSelectedInstOperands,
     /*  85086 */     // GIR_Coverage, 19803,
     /*  85086 */     GIR_EraseRootFromParent_Done,
     /*  85087 */   // Label 1836: @85087
     /*  85087 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(85125), // Rule ID 19807 //
     /*  85092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85110 */     // (st VR512:{ *:[v16i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16i32] }:$src)
     /*  85110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85117 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85123 */     GIR_RootConstrainSelectedInstOperands,
     /*  85124 */     // GIR_Coverage, 19807,
     /*  85124 */     GIR_EraseRootFromParent_Done,
     /*  85125 */   // Label 1837: @85125
     /*  85125 */   GIM_Reject,
     /*  85126 */ // Label 1833: @85126
     /*  85126 */ GIM_Reject,
     /*  85127 */ // Label 1490: @85127
     /*  85127 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(85208),
     /*  85132 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85135 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  85143 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85147 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(85177), // Rule ID 4403 //
     /*  85152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  85155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85162 */     // (st VK32:{ *:[v32i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVDmk addr:{ *:[iPTR] }:$dst, VK32:{ *:[v32i1] }:$src)
     /*  85162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDmk),
     /*  85165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85169 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85175 */     GIR_RootConstrainSelectedInstOperands,
     /*  85176 */     // GIR_Coverage, 4403,
     /*  85176 */     GIR_EraseRootFromParent_Done,
     /*  85177 */   // Label 1839: @85177
     /*  85177 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(85207), // Rule ID 4407 //
     /*  85182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  85185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85192 */     // (st VK32:{ *:[v32i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVDmk_EVEX addr:{ *:[iPTR] }:$dst, VK32:{ *:[v32i1] }:$src)
     /*  85192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDmk_EVEX),
     /*  85195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85199 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85205 */     GIR_RootConstrainSelectedInstOperands,
     /*  85206 */     // GIR_Coverage, 4407,
     /*  85206 */     GIR_EraseRootFromParent_Done,
     /*  85207 */   // Label 1840: @85207
     /*  85207 */   GIM_Reject,
     /*  85208 */ // Label 1838: @85208
     /*  85208 */ GIM_Reject,
     /*  85209 */ // Label 1491: @85209
     /*  85209 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(85382),
     /*  85214 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85217 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85221 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(85263), // Rule ID 17925 //
     /*  85226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  85229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  85233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85237 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85248 */     // (st VR256:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v32i8] }:$src)
     /*  85248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  85251 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85255 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85261 */     GIR_RootConstrainSelectedInstOperands,
     /*  85262 */     // GIR_Coverage, 17925,
     /*  85262 */     GIR_EraseRootFromParent_Done,
     /*  85263 */   // Label 1842: @85263
     /*  85263 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(85301), // Rule ID 17929 //
     /*  85268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  85271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  85275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85286 */     // (st VR256:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v32i8] }:$src)
     /*  85286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  85289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85293 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85299 */     GIR_RootConstrainSelectedInstOperands,
     /*  85300 */     // GIR_Coverage, 17929,
     /*  85300 */     GIR_EraseRootFromParent_Done,
     /*  85301 */   // Label 1843: @85301
     /*  85301 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(85343), // Rule ID 19838 //
     /*  85306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85317 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85328 */     // (st VR256X:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v32i8] }:$src)
     /*  85328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  85331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85335 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85341 */     GIR_RootConstrainSelectedInstOperands,
     /*  85342 */     // GIR_Coverage, 19838,
     /*  85342 */     GIR_EraseRootFromParent_Done,
     /*  85343 */   // Label 1844: @85343
     /*  85343 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(85381), // Rule ID 19842 //
     /*  85348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85366 */     // (st VR256X:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v32i8] }:$src)
     /*  85366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  85369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85373 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85379 */     GIR_RootConstrainSelectedInstOperands,
     /*  85380 */     // GIR_Coverage, 19842,
     /*  85380 */     GIR_EraseRootFromParent_Done,
     /*  85381 */   // Label 1845: @85381
     /*  85381 */   GIM_Reject,
     /*  85382 */ // Label 1841: @85382
     /*  85382 */ GIM_Reject,
     /*  85383 */ // Label 1492: @85383
     /*  85383 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(85556),
     /*  85388 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85391 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85395 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(85437), // Rule ID 19804 //
     /*  85400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85422 */     // (st VR512:{ *:[v32i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32i16] }:$src)
     /*  85422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85425 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85429 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85435 */     GIR_RootConstrainSelectedInstOperands,
     /*  85436 */     // GIR_Coverage, 19804,
     /*  85436 */     GIR_EraseRootFromParent_Done,
     /*  85437 */   // Label 1847: @85437
     /*  85437 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(85479), // Rule ID 19805 //
     /*  85442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85453 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85464 */     // (st VR512:{ *:[v32f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32f16] }:$src)
     /*  85464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZmr),
     /*  85467 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85471 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85477 */     GIR_RootConstrainSelectedInstOperands,
     /*  85478 */     // GIR_Coverage, 19805,
     /*  85478 */     GIR_EraseRootFromParent_Done,
     /*  85479 */   // Label 1848: @85479
     /*  85479 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(85517), // Rule ID 19808 //
     /*  85484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85502 */     // (st VR512:{ *:[v32i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32i16] }:$src)
     /*  85502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85509 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85515 */     GIR_RootConstrainSelectedInstOperands,
     /*  85516 */     // GIR_Coverage, 19808,
     /*  85516 */     GIR_EraseRootFromParent_Done,
     /*  85517 */   // Label 1849: @85517
     /*  85517 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(85555), // Rule ID 19809 //
     /*  85522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85540 */     // (st VR512:{ *:[v32f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32f16] }:$src)
     /*  85540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZmr),
     /*  85543 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85547 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85553 */     GIR_RootConstrainSelectedInstOperands,
     /*  85554 */     // GIR_Coverage, 19809,
     /*  85554 */     GIR_EraseRootFromParent_Done,
     /*  85555 */   // Label 1850: @85555
     /*  85555 */   GIM_Reject,
     /*  85556 */ // Label 1846: @85556
     /*  85556 */ GIM_Reject,
     /*  85557 */ // Label 1493: @85557
     /*  85557 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(85638),
     /*  85562 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85565 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  85573 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85577 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(85607), // Rule ID 4405 //
     /*  85582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  85585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85592 */     // (st VK64:{ *:[v64i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVQmk addr:{ *:[iPTR] }:$dst, VK64:{ *:[v64i1] }:$src)
     /*  85592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQmk),
     /*  85595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85599 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85605 */     GIR_RootConstrainSelectedInstOperands,
     /*  85606 */     // GIR_Coverage, 4405,
     /*  85606 */     GIR_EraseRootFromParent_Done,
     /*  85607 */   // Label 1852: @85607
     /*  85607 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(85637), // Rule ID 4409 //
     /*  85612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  85615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85622 */     // (st VK64:{ *:[v64i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVQmk_EVEX addr:{ *:[iPTR] }:$dst, VK64:{ *:[v64i1] }:$src)
     /*  85622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQmk_EVEX),
     /*  85625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85629 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85635 */     GIR_RootConstrainSelectedInstOperands,
     /*  85636 */     // GIR_Coverage, 4409,
     /*  85636 */     GIR_EraseRootFromParent_Done,
     /*  85637 */   // Label 1853: @85637
     /*  85637 */   GIM_Reject,
     /*  85638 */ // Label 1851: @85638
     /*  85638 */ GIM_Reject,
     /*  85639 */ // Label 1494: @85639
     /*  85639 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(85732),
     /*  85644 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85647 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85651 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(85693), // Rule ID 19806 //
     /*  85656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85667 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85678 */     // (st VR512:{ *:[v64i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v64i8] }:$src)
     /*  85678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85685 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85691 */     GIR_RootConstrainSelectedInstOperands,
     /*  85692 */     // GIR_Coverage, 19806,
     /*  85692 */     GIR_EraseRootFromParent_Done,
     /*  85693 */   // Label 1855: @85693
     /*  85693 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(85731), // Rule ID 19810 //
     /*  85698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85716 */     // (st VR512:{ *:[v64i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v64i8] }:$src)
     /*  85716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85719 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85723 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85729 */     GIR_RootConstrainSelectedInstOperands,
     /*  85730 */     // GIR_Coverage, 19810,
     /*  85730 */     GIR_EraseRootFromParent_Done,
     /*  85731 */   // Label 1856: @85731
     /*  85731 */   GIM_Reject,
     /*  85732 */ // Label 1854: @85732
     /*  85732 */ GIM_Reject,
     /*  85733 */ // Label 1495: @85733
     /*  85733 */ GIM_Reject,
     /*  85734 */ // Label 14: @85734
     /*  85734 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1861*/ GIMT_Encode4(85969),
     /*  85745 */ /*GILLT_s8*//*Label 1857*/ GIMT_Encode4(85761),
     /*  85749 */ /*GILLT_s16*//*Label 1858*/ GIMT_Encode4(85813),
     /*  85753 */ /*GILLT_s32*//*Label 1859*/ GIMT_Encode4(85865),
     /*  85757 */ /*GILLT_s64*//*Label 1860*/ GIMT_Encode4(85917),
     /*  85761 */ // Label 1857: @85761
     /*  85761 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(85812), // Rule ID 45 //
     /*  85766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  85769 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  85780 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  85788 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85795 */   // (atomic_swap:{ *:[i8] } addr:{ *:[iPTR] }:$ptr, GR8:{ *:[i8] }:$val)<<P:Predicate_atomic_swap_i8>>  =>  (XCHG8rm:{ *:[i8] } GR8:{ *:[i8] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG8rm),
     /*  85798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85800 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85802 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85806 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85810 */   GIR_RootConstrainSelectedInstOperands,
     /*  85811 */   // GIR_Coverage, 45,
     /*  85811 */   GIR_EraseRootFromParent_Done,
     /*  85812 */ // Label 1862: @85812
     /*  85812 */ GIM_Reject,
     /*  85813 */ // Label 1858: @85813
     /*  85813 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(85864), // Rule ID 46 //
     /*  85818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  85821 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  85828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  85832 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  85840 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85847 */   // (atomic_swap:{ *:[i16] } addr:{ *:[iPTR] }:$ptr, GR16:{ *:[i16] }:$val)<<P:Predicate_atomic_swap_i16>>  =>  (XCHG16rm:{ *:[i16] } GR16:{ *:[i16] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG16rm),
     /*  85850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85852 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85854 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85858 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85862 */   GIR_RootConstrainSelectedInstOperands,
     /*  85863 */   // GIR_Coverage, 46,
     /*  85863 */   GIR_EraseRootFromParent_Done,
     /*  85864 */ // Label 1863: @85864
     /*  85864 */ GIM_Reject,
     /*  85865 */ // Label 1859: @85865
     /*  85865 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(85916), // Rule ID 47 //
     /*  85870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  85873 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  85880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  85884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  85892 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85899 */   // (atomic_swap:{ *:[i32] } addr:{ *:[iPTR] }:$ptr, GR32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>>  =>  (XCHG32rm:{ *:[i32] } GR32:{ *:[i32] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG32rm),
     /*  85902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85904 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85906 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85914 */   GIR_RootConstrainSelectedInstOperands,
     /*  85915 */   // GIR_Coverage, 47,
     /*  85915 */   GIR_EraseRootFromParent_Done,
     /*  85916 */ // Label 1864: @85916
     /*  85916 */ GIM_Reject,
     /*  85917 */ // Label 1860: @85917
     /*  85917 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(85968), // Rule ID 48 //
     /*  85922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  85925 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  85932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  85936 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  85944 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85951 */   // (atomic_swap:{ *:[i64] } addr:{ *:[iPTR] }:$ptr, GR64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>>  =>  (XCHG64rm:{ *:[i64] } GR64:{ *:[i64] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG64rm),
     /*  85954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85956 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85958 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85962 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85966 */   GIR_RootConstrainSelectedInstOperands,
     /*  85967 */   // GIR_Coverage, 48,
     /*  85967 */   GIR_EraseRootFromParent_Done,
     /*  85968 */ // Label 1865: @85968
     /*  85968 */ GIM_Reject,
     /*  85969 */ // Label 1861: @85969
     /*  85969 */ GIM_Reject,
     /*  85970 */ // Label 15: @85970
     /*  85970 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1870*/ GIMT_Encode4(86217),
     /*  85981 */ /*GILLT_s8*//*Label 1866*/ GIMT_Encode4(85997),
     /*  85985 */ /*GILLT_s16*//*Label 1867*/ GIMT_Encode4(86052),
     /*  85989 */ /*GILLT_s32*//*Label 1868*/ GIMT_Encode4(86107),
     /*  85993 */ /*GILLT_s64*//*Label 1869*/ GIMT_Encode4(86162),
     /*  85997 */ // Label 1866: @85997
     /*  85997 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(86051), // Rule ID 17297 //
     /*  86002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  86005 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86016 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86024 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86031 */   // (atomic_load_add:{ *:[i8] } addr:{ *:[iPTR] }:$ptr, GR8:{ *:[i8] }:$val)<<P:Predicate_atomic_load_add_i8>>  =>  (LXADD8:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD8),
     /*  86034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86036 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86038 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86042 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86045 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86049 */   GIR_RootConstrainSelectedInstOperands,
     /*  86050 */   // GIR_Coverage, 17297,
     /*  86050 */   GIR_EraseRootFromParent_Done,
     /*  86051 */ // Label 1871: @86051
     /*  86051 */ GIM_Reject,
     /*  86052 */ // Label 1867: @86052
     /*  86052 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(86106), // Rule ID 17298 //
     /*  86057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  86060 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  86067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86071 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86079 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86086 */   // (atomic_load_add:{ *:[i16] } addr:{ *:[iPTR] }:$ptr, GR16:{ *:[i16] }:$val)<<P:Predicate_atomic_load_add_i16>>  =>  (LXADD16:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD16),
     /*  86089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86091 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86093 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86097 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86100 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86104 */   GIR_RootConstrainSelectedInstOperands,
     /*  86105 */   // GIR_Coverage, 17298,
     /*  86105 */   GIR_EraseRootFromParent_Done,
     /*  86106 */ // Label 1872: @86106
     /*  86106 */ GIM_Reject,
     /*  86107 */ // Label 1868: @86107
     /*  86107 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(86161), // Rule ID 17299 //
     /*  86112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86115 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86126 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86134 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86141 */   // (atomic_load_add:{ *:[i32] } addr:{ *:[iPTR] }:$ptr, GR32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>>  =>  (LXADD32:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD32),
     /*  86144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86146 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86148 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86152 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86155 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86159 */   GIR_RootConstrainSelectedInstOperands,
     /*  86160 */   // GIR_Coverage, 17299,
     /*  86160 */   GIR_EraseRootFromParent_Done,
     /*  86161 */ // Label 1873: @86161
     /*  86161 */ GIM_Reject,
     /*  86162 */ // Label 1869: @86162
     /*  86162 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(86216), // Rule ID 17300 //
     /*  86167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  86170 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  86177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86181 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86196 */   // (atomic_load_add:{ *:[i64] } addr:{ *:[iPTR] }:$ptr, GR64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>>  =>  (LXADD64:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD64),
     /*  86199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86201 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86203 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86207 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86210 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86214 */   GIR_RootConstrainSelectedInstOperands,
     /*  86215 */   // GIR_Coverage, 17300,
     /*  86215 */   GIR_EraseRootFromParent_Done,
     /*  86216 */ // Label 1874: @86216
     /*  86216 */ GIM_Reject,
     /*  86217 */ // Label 1870: @86217
     /*  86217 */ GIM_Reject,
     /*  86218 */ // Label 16: @86218
     /*  86218 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(86373),
     /*  86223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86226 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(86276), // Rule ID 156 //
     /*  86231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPREFETCHI_In64BitMode),
     /*  86234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  86248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 3,
     /*  86252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  86256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86263 */     // (prefetch addr:{ *:[iPTR] }:$src, 0:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (PREFETCHIT0 addr:{ *:[iPTR] }:$src)
     /*  86263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHIT0),
     /*  86266 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86274 */     GIR_RootConstrainSelectedInstOperands,
     /*  86275 */     // GIR_Coverage, 156,
     /*  86275 */     GIR_EraseRootFromParent_Done,
     /*  86276 */   // Label 1876: @86276
     /*  86276 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(86326), // Rule ID 157 //
     /*  86281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPREFETCHI_In64BitMode),
     /*  86284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  86298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 2,
     /*  86302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  86306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86313 */     // (prefetch addr:{ *:[iPTR] }:$src, 0:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (PREFETCHIT1 addr:{ *:[iPTR] }:$src)
     /*  86313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHIT1),
     /*  86316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86324 */     GIR_RootConstrainSelectedInstOperands,
     /*  86325 */     // GIR_Coverage, 157,
     /*  86325 */     GIR_EraseRootFromParent_Done,
     /*  86326 */   // Label 1877: @86326
     /*  86326 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(86372), // Rule ID 16982 //
     /*  86331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPrefetchW),
     /*  86334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /*  86345 */     // MIs[0] Operand 2
     /*  86345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  86348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86359 */     // (prefetch addr:{ *:[iPTR] }:$addr, 1:{ *:[i32] }, (timm:{ *:[i32] })<<P:Predicate_PrefetchWLevel>>, 1:{ *:[i32] })  =>  (PREFETCHW addr:{ *:[iPTR] }:$addr)
     /*  86359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHW),
     /*  86362 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // addr
     /*  86366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86370 */     GIR_RootConstrainSelectedInstOperands,
     /*  86371 */     // GIR_Coverage, 16982,
     /*  86371 */     GIR_EraseRootFromParent_Done,
     /*  86372 */   // Label 1878: @86372
     /*  86372 */   GIM_Reject,
     /*  86373 */ // Label 1875: @86373
     /*  86373 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(86536),
     /*  86378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86381 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86384 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86388 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  86391 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(86427), // Rule ID 2504 //
     /*  86396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 3,
     /*  86403 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86414 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT0 addr:{ *:[iPTR] }:$src)
     /*  86414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT0),
     /*  86417 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86425 */     GIR_RootConstrainSelectedInstOperands,
     /*  86426 */     // GIR_Coverage, 2504,
     /*  86426 */     GIR_EraseRootFromParent_Done,
     /*  86427 */   // Label 1880: @86427
     /*  86427 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(86463), // Rule ID 2505 //
     /*  86432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 2,
     /*  86439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86450 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT1 addr:{ *:[iPTR] }:$src)
     /*  86450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT1),
     /*  86453 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86461 */     GIR_RootConstrainSelectedInstOperands,
     /*  86462 */     // GIR_Coverage, 2505,
     /*  86462 */     GIR_EraseRootFromParent_Done,
     /*  86463 */   // Label 1881: @86463
     /*  86463 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(86499), // Rule ID 2506 //
     /*  86468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  86475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86486 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT2 addr:{ *:[iPTR] }:$src)
     /*  86486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT2),
     /*  86489 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86497 */     GIR_RootConstrainSelectedInstOperands,
     /*  86498 */     // GIR_Coverage, 2506,
     /*  86498 */     GIR_EraseRootFromParent_Done,
     /*  86499 */   // Label 1882: @86499
     /*  86499 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(86535), // Rule ID 2507 //
     /*  86504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  86511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86522 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHNTA addr:{ *:[iPTR] }:$src)
     /*  86522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHNTA),
     /*  86525 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86533 */     GIR_RootConstrainSelectedInstOperands,
     /*  86534 */     // GIR_Coverage, 2507,
     /*  86534 */     GIR_EraseRootFromParent_Done,
     /*  86535 */   // Label 1883: @86535
     /*  86535 */   GIM_Reject,
     /*  86536 */ // Label 1879: @86536
     /*  86536 */ GIM_Reject,
     /*  86537 */ // Label 17: @86537
     /*  86537 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(88866),
     /*  86542 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  86545 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(86612), // Rule ID 1529 //
     /*  86550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /*  86558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86596 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14959:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  86596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrm),
     /*  86599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86610 */     GIR_RootConstrainSelectedInstOperands,
     /*  86611 */     // GIR_Coverage, 1529,
     /*  86611 */     GIR_EraseRootFromParent_Done,
     /*  86612 */   // Label 1885: @86612
     /*  86612 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(86679), // Rule ID 1531 //
     /*  86617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /*  86625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86643 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86650 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86663 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14958:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrm),
     /*  86666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86668 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86677 */     GIR_RootConstrainSelectedInstOperands,
     /*  86678 */     // GIR_Coverage, 1531,
     /*  86678 */     GIR_EraseRootFromParent_Done,
     /*  86679 */   // Label 1886: @86679
     /*  86679 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(86746), // Rule ID 1533 //
     /*  86684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /*  86692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86710 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86713 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86717 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86730 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14957:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  86730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrm),
     /*  86733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86735 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86744 */     GIR_RootConstrainSelectedInstOperands,
     /*  86745 */     // GIR_Coverage, 1533,
     /*  86745 */     GIR_EraseRootFromParent_Done,
     /*  86746 */   // Label 1887: @86746
     /*  86746 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(86813), // Rule ID 1535 //
     /*  86751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /*  86759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86777 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86784 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86797 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14956:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDWQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrm),
     /*  86800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86802 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86811 */     GIR_RootConstrainSelectedInstOperands,
     /*  86812 */     // GIR_Coverage, 1535,
     /*  86812 */     GIR_EraseRootFromParent_Done,
     /*  86813 */   // Label 1888: @86813
     /*  86813 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(86880), // Rule ID 1537 //
     /*  86818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /*  86826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86844 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86847 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86851 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86864 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14955:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  86864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrm),
     /*  86867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86869 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86878 */     GIR_RootConstrainSelectedInstOperands,
     /*  86879 */     // GIR_Coverage, 1537,
     /*  86879 */     GIR_EraseRootFromParent_Done,
     /*  86880 */   // Label 1889: @86880
     /*  86880 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(86947), // Rule ID 1539 //
     /*  86885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /*  86893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86911 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86914 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86918 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86931 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14954:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUWQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrm),
     /*  86934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86945 */     GIR_RootConstrainSelectedInstOperands,
     /*  86946 */     // GIR_Coverage, 1539,
     /*  86946 */     GIR_EraseRootFromParent_Done,
     /*  86947 */   // Label 1890: @86947
     /*  86947 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(87014), // Rule ID 1541 //
     /*  86952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /*  86960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86978 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86981 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86985 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86991 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86998 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14953:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  86998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrm),
     /*  87001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87003 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87012 */     GIR_RootConstrainSelectedInstOperands,
     /*  87013 */     // GIR_Coverage, 1541,
     /*  87013 */     GIR_EraseRootFromParent_Done,
     /*  87014 */   // Label 1891: @87014
     /*  87014 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(87081), // Rule ID 1543 //
     /*  87019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /*  87027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87065 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14952:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrm),
     /*  87068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87070 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87079 */     GIR_RootConstrainSelectedInstOperands,
     /*  87080 */     // GIR_Coverage, 1543,
     /*  87080 */     GIR_EraseRootFromParent_Done,
     /*  87081 */   // Label 1892: @87081
     /*  87081 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(87148), // Rule ID 1545 //
     /*  87086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /*  87094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87132 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14951:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  87132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrm),
     /*  87135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87137 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87146 */     GIR_RootConstrainSelectedInstOperands,
     /*  87147 */     // GIR_Coverage, 1545,
     /*  87147 */     GIR_EraseRootFromParent_Done,
     /*  87148 */   // Label 1893: @87148
     /*  87148 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(87215), // Rule ID 1547 //
     /*  87153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /*  87161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87179 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87182 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87186 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87199 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14950:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrm),
     /*  87202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87213 */     GIR_RootConstrainSelectedInstOperands,
     /*  87214 */     // GIR_Coverage, 1547,
     /*  87214 */     GIR_EraseRootFromParent_Done,
     /*  87215 */   // Label 1894: @87215
     /*  87215 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(87282), // Rule ID 1549 //
     /*  87220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /*  87228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87246 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87253 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87266 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14949:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrm),
     /*  87269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87280 */     GIR_RootConstrainSelectedInstOperands,
     /*  87281 */     // GIR_Coverage, 1549,
     /*  87281 */     GIR_EraseRootFromParent_Done,
     /*  87282 */   // Label 1895: @87282
     /*  87282 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(87349), // Rule ID 1551 //
     /*  87287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /*  87295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87313 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87316 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87320 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87333 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14948:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrm),
     /*  87336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87338 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87347 */     GIR_RootConstrainSelectedInstOperands,
     /*  87348 */     // GIR_Coverage, 1551,
     /*  87348 */     GIR_EraseRootFromParent_Done,
     /*  87349 */   // Label 1896: @87349
     /*  87349 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(87416), // Rule ID 1553 //
     /*  87354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /*  87362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87380 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87383 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87387 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87400 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14947:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  87400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrm),
     /*  87403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87405 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87414 */     GIR_RootConstrainSelectedInstOperands,
     /*  87415 */     // GIR_Coverage, 1553,
     /*  87415 */     GIR_EraseRootFromParent_Done,
     /*  87416 */   // Label 1897: @87416
     /*  87416 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(87483), // Rule ID 1555 //
     /*  87421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /*  87429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87447 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87450 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87454 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87467 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14946:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrm),
     /*  87470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87481 */     GIR_RootConstrainSelectedInstOperands,
     /*  87482 */     // GIR_Coverage, 1555,
     /*  87482 */     GIR_EraseRootFromParent_Done,
     /*  87483 */   // Label 1898: @87483
     /*  87483 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(87550), // Rule ID 1557 //
     /*  87488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /*  87496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87534 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14945:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrm),
     /*  87537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87548 */     GIR_RootConstrainSelectedInstOperands,
     /*  87549 */     // GIR_Coverage, 1557,
     /*  87549 */     GIR_EraseRootFromParent_Done,
     /*  87550 */   // Label 1899: @87550
     /*  87550 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(87617), // Rule ID 1563 //
     /*  87555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /*  87563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87581 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87584 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87588 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87601 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14937:{ *:[iPTR] }, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  87601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrm),
     /*  87604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87606 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87615 */     GIR_RootConstrainSelectedInstOperands,
     /*  87616 */     // GIR_Coverage, 1563,
     /*  87616 */     GIR_EraseRootFromParent_Done,
     /*  87617 */   // Label 1900: @87617
     /*  87617 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(87684), // Rule ID 1565 //
     /*  87622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /*  87630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  87633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  87636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  87640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87648 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87651 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87655 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87668 */     // (intrinsic_wo_chain:{ *:[v8f32] } 14938:{ *:[iPTR] }, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  87668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrm),
     /*  87671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87682 */     GIR_RootConstrainSelectedInstOperands,
     /*  87683 */     // GIR_Coverage, 1565,
     /*  87683 */     GIR_EraseRootFromParent_Done,
     /*  87684 */   // Label 1901: @87684
     /*  87684 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(87751), // Rule ID 1571 //
     /*  87689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /*  87697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  87703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87715 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87718 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87722 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87735 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14935:{ *:[iPTR] }, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  87735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrm),
     /*  87738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87740 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87749 */     GIR_RootConstrainSelectedInstOperands,
     /*  87750 */     // GIR_Coverage, 1571,
     /*  87750 */     GIR_EraseRootFromParent_Done,
     /*  87751 */   // Label 1902: @87751
     /*  87751 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(87818), // Rule ID 1573 //
     /*  87756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /*  87764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  87767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  87770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  87774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87782 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87785 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87789 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87802 */     // (intrinsic_wo_chain:{ *:[v4f64] } 14936:{ *:[iPTR] }, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  87802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrm),
     /*  87805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87807 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87816 */     GIR_RootConstrainSelectedInstOperands,
     /*  87817 */     // GIR_Coverage, 1573,
     /*  87817 */     GIR_EraseRootFromParent_Done,
     /*  87818 */   // Label 1903: @87818
     /*  87818 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(87885), // Rule ID 3363 //
     /*  87823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  87826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  87831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  87837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87849 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87869 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13310:{ *:[iPTR] }, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESIMCrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /*  87869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrm),
     /*  87872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87874 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  87878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87883 */     GIR_RootConstrainSelectedInstOperands,
     /*  87884 */     // GIR_Coverage, 3363,
     /*  87884 */     GIR_EraseRootFromParent_Done,
     /*  87885 */   // Label 1904: @87885
     /*  87885 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(87921), // Rule ID 1528 //
     /*  87890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /*  87898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87912 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14959:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHSUBWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  87912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrr),
     /*  87915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87917 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87919 */     GIR_RootConstrainSelectedInstOperands,
     /*  87920 */     // GIR_Coverage, 1528,
     /*  87920 */     GIR_EraseRootFromParent_Done,
     /*  87921 */   // Label 1905: @87921
     /*  87921 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(87957), // Rule ID 1530 //
     /*  87926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /*  87934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87948 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14958:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHSUBDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  87948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrr),
     /*  87951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87955 */     GIR_RootConstrainSelectedInstOperands,
     /*  87956 */     // GIR_Coverage, 1530,
     /*  87956 */     GIR_EraseRootFromParent_Done,
     /*  87957 */   // Label 1906: @87957
     /*  87957 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(87993), // Rule ID 1532 //
     /*  87962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /*  87970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87984 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14957:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHSUBBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  87984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrr),
     /*  87987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87989 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87991 */     GIR_RootConstrainSelectedInstOperands,
     /*  87992 */     // GIR_Coverage, 1532,
     /*  87992 */     GIR_EraseRootFromParent_Done,
     /*  87993 */   // Label 1907: @87993
     /*  87993 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(88029), // Rule ID 1534 //
     /*  87998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /*  88006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88020 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14956:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /*  88020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrr),
     /*  88023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88025 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88027 */     GIR_RootConstrainSelectedInstOperands,
     /*  88028 */     // GIR_Coverage, 1534,
     /*  88028 */     GIR_EraseRootFromParent_Done,
     /*  88029 */   // Label 1908: @88029
     /*  88029 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(88065), // Rule ID 1536 //
     /*  88034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /*  88042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88056 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14955:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrr),
     /*  88059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88061 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88063 */     GIR_RootConstrainSelectedInstOperands,
     /*  88064 */     // GIR_Coverage, 1536,
     /*  88064 */     GIR_EraseRootFromParent_Done,
     /*  88065 */   // Label 1909: @88065
     /*  88065 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(88101), // Rule ID 1538 //
     /*  88070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /*  88078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88092 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14954:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /*  88092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrr),
     /*  88095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88097 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88099 */     GIR_RootConstrainSelectedInstOperands,
     /*  88100 */     // GIR_Coverage, 1538,
     /*  88100 */     GIR_EraseRootFromParent_Done,
     /*  88101 */   // Label 1910: @88101
     /*  88101 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(88137), // Rule ID 1540 //
     /*  88106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /*  88114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88128 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14953:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrr),
     /*  88131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88135 */     GIR_RootConstrainSelectedInstOperands,
     /*  88136 */     // GIR_Coverage, 1540,
     /*  88136 */     GIR_EraseRootFromParent_Done,
     /*  88137 */   // Label 1911: @88137
     /*  88137 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(88173), // Rule ID 1542 //
     /*  88142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /*  88150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88164 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14952:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDUDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrr),
     /*  88167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88171 */     GIR_RootConstrainSelectedInstOperands,
     /*  88172 */     // GIR_Coverage, 1542,
     /*  88172 */     GIR_EraseRootFromParent_Done,
     /*  88173 */   // Label 1912: @88173
     /*  88173 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(88209), // Rule ID 1544 //
     /*  88178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /*  88186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88200 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14951:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrr),
     /*  88203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88205 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88207 */     GIR_RootConstrainSelectedInstOperands,
     /*  88208 */     // GIR_Coverage, 1544,
     /*  88208 */     GIR_EraseRootFromParent_Done,
     /*  88209 */   // Label 1913: @88209
     /*  88209 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(88245), // Rule ID 1546 //
     /*  88214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /*  88222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88236 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14950:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /*  88236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrr),
     /*  88239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88241 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88243 */     GIR_RootConstrainSelectedInstOperands,
     /*  88244 */     // GIR_Coverage, 1546,
     /*  88244 */     GIR_EraseRootFromParent_Done,
     /*  88245 */   // Label 1914: @88245
     /*  88245 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(88281), // Rule ID 1548 //
     /*  88250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /*  88258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88272 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14949:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /*  88272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrr),
     /*  88275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88277 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88279 */     GIR_RootConstrainSelectedInstOperands,
     /*  88280 */     // GIR_Coverage, 1548,
     /*  88280 */     GIR_EraseRootFromParent_Done,
     /*  88281 */   // Label 1915: @88281
     /*  88281 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(88317), // Rule ID 1550 //
     /*  88286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /*  88294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88308 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14948:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrr),
     /*  88311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88313 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88315 */     GIR_RootConstrainSelectedInstOperands,
     /*  88316 */     // GIR_Coverage, 1550,
     /*  88316 */     GIR_EraseRootFromParent_Done,
     /*  88317 */   // Label 1916: @88317
     /*  88317 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(88353), // Rule ID 1552 //
     /*  88322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /*  88330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88344 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14947:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrr),
     /*  88347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88349 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88351 */     GIR_RootConstrainSelectedInstOperands,
     /*  88352 */     // GIR_Coverage, 1552,
     /*  88352 */     GIR_EraseRootFromParent_Done,
     /*  88353 */   // Label 1917: @88353
     /*  88353 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(88389), // Rule ID 1554 //
     /*  88358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /*  88366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88380 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14946:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /*  88380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrr),
     /*  88383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88387 */     GIR_RootConstrainSelectedInstOperands,
     /*  88388 */     // GIR_Coverage, 1554,
     /*  88388 */     GIR_EraseRootFromParent_Done,
     /*  88389 */   // Label 1918: @88389
     /*  88389 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(88425), // Rule ID 1556 //
     /*  88394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /*  88402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88416 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14945:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /*  88416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrr),
     /*  88419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88421 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88423 */     GIR_RootConstrainSelectedInstOperands,
     /*  88424 */     // GIR_Coverage, 1556,
     /*  88424 */     GIR_EraseRootFromParent_Done,
     /*  88425 */   // Label 1919: @88425
     /*  88425 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(88461), // Rule ID 1558 //
     /*  88430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ss),
     /*  88438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88452 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14940:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZSSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /*  88452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSSrr),
     /*  88455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88457 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88459 */     GIR_RootConstrainSelectedInstOperands,
     /*  88460 */     // GIR_Coverage, 1558,
     /*  88460 */     GIR_EraseRootFromParent_Done,
     /*  88461 */   // Label 1920: @88461
     /*  88461 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(88497), // Rule ID 1562 //
     /*  88466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /*  88474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88488 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14937:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /*  88488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrr),
     /*  88491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88493 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88495 */     GIR_RootConstrainSelectedInstOperands,
     /*  88496 */     // GIR_Coverage, 1562,
     /*  88496 */     GIR_EraseRootFromParent_Done,
     /*  88497 */   // Label 1921: @88497
     /*  88497 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(88533), // Rule ID 1564 //
     /*  88502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /*  88510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  88513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  88516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88524 */     // (intrinsic_wo_chain:{ *:[v8f32] } 14938:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src)  =>  (VFRCZPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /*  88524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrr),
     /*  88527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88531 */     GIR_RootConstrainSelectedInstOperands,
     /*  88532 */     // GIR_Coverage, 1564,
     /*  88532 */     GIR_EraseRootFromParent_Done,
     /*  88533 */   // Label 1922: @88533
     /*  88533 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(88569), // Rule ID 1566 //
     /*  88538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_sd),
     /*  88546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88560 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14939:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZSDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /*  88560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSDrr),
     /*  88563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88565 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88567 */     GIR_RootConstrainSelectedInstOperands,
     /*  88568 */     // GIR_Coverage, 1566,
     /*  88568 */     GIR_EraseRootFromParent_Done,
     /*  88569 */   // Label 1923: @88569
     /*  88569 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(88605), // Rule ID 1570 //
     /*  88574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /*  88582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88596 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14935:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /*  88596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrr),
     /*  88599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88601 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88603 */     GIR_RootConstrainSelectedInstOperands,
     /*  88604 */     // GIR_Coverage, 1570,
     /*  88604 */     GIR_EraseRootFromParent_Done,
     /*  88605 */   // Label 1924: @88605
     /*  88605 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(88641), // Rule ID 1572 //
     /*  88610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /*  88618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  88621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  88624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88632 */     // (intrinsic_wo_chain:{ *:[v4f64] } 14936:{ *:[iPTR] }, VR256:{ *:[v4f64] }:$src)  =>  (VFRCZPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /*  88632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrr),
     /*  88635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88637 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88639 */     GIR_RootConstrainSelectedInstOperands,
     /*  88640 */     // GIR_Coverage, 1572,
     /*  88640 */     GIR_EraseRootFromParent_Done,
     /*  88641 */   // Label 1925: @88641
     /*  88641 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(88677), // Rule ID 3362 //
     /*  88646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  88649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88668 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13310:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (VAESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /*  88668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrr),
     /*  88671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88673 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88675 */     GIR_RootConstrainSelectedInstOperands,
     /*  88676 */     // GIR_Coverage, 3362,
     /*  88676 */     GIR_EraseRootFromParent_Done,
     /*  88677 */   // Label 1926: @88677
     /*  88677 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(88713), // Rule ID 3364 //
     /*  88682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  88685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88704 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13310:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (AESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /*  88704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESIMCrr),
     /*  88707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88709 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88711 */     GIR_RootConstrainSelectedInstOperands,
     /*  88712 */     // GIR_Coverage, 3364,
     /*  88712 */     GIR_EraseRootFromParent_Done,
     /*  88713 */   // Label 1927: @88713
     /*  88713 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(88751), // Rule ID 18265 //
     /*  88718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  88721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /*  88726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88740 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14645:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSQRTSSr_Int),
     /*  88743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88745 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88749 */     GIR_RootConstrainSelectedInstOperands,
     /*  88750 */     // GIR_Coverage, 18265,
     /*  88750 */     GIR_EraseRootFromParent_Done,
     /*  88751 */   // Label 1928: @88751
     /*  88751 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(88789), // Rule ID 18269 //
     /*  88756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /*  88764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88778 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14645:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRSQRTSSr_Int),
     /*  88781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88783 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88785 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88787 */     GIR_RootConstrainSelectedInstOperands,
     /*  88788 */     // GIR_Coverage, 18269,
     /*  88788 */     GIR_EraseRootFromParent_Done,
     /*  88789 */   // Label 1929: @88789
     /*  88789 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(88827), // Rule ID 18285 //
     /*  88794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  88797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /*  88802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88816 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14643:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RCPSSr_Int),
     /*  88819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88823 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88825 */     GIR_RootConstrainSelectedInstOperands,
     /*  88826 */     // GIR_Coverage, 18285,
     /*  88826 */     GIR_EraseRootFromParent_Done,
     /*  88827 */   // Label 1930: @88827
     /*  88827 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(88865), // Rule ID 18289 //
     /*  88832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /*  88840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88854 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14643:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRCPSSr_Int),
     /*  88857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88859 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88861 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88863 */     GIR_RootConstrainSelectedInstOperands,
     /*  88864 */     // GIR_Coverage, 18289,
     /*  88864 */     GIR_EraseRootFromParent_Done,
     /*  88865 */   // Label 1931: @88865
     /*  88865 */   GIM_Reject,
     /*  88866 */ // Label 1884: @88866
     /*  88866 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(95647),
     /*  88871 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  88874 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(88946), // Rule ID 3367 //
     /*  88879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  88882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  88887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88912 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88916 */     // MIs[0] src2
     /*  88916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  88919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88928 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13311:{ *:[iPTR] }, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  88928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rm),
     /*  88931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88933 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  88937 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  88939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88944 */     GIR_RootConstrainSelectedInstOperands,
     /*  88945 */     // GIR_Coverage, 3367,
     /*  88945 */     GIR_EraseRootFromParent_Done,
     /*  88946 */   // Label 1933: @88946
     /*  88946 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(89022), // Rule ID 16789 //
     /*  88951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  88954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  88959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  88972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  88976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  88980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88984 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88987 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88991 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89004 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14914:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Z128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rm),
     /*  89007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89011 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89020 */     GIR_RootConstrainSelectedInstOperands,
     /*  89021 */     // GIR_Coverage, 16789,
     /*  89021 */     GIR_EraseRootFromParent_Done,
     /*  89022 */   // Label 1934: @89022
     /*  89022 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(89098), // Rule ID 16791 //
     /*  89027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  89035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89060 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89063 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89067 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89080 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14915:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Z256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rm),
     /*  89083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89085 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89087 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89096 */     GIR_RootConstrainSelectedInstOperands,
     /*  89097 */     // GIR_Coverage, 16791,
     /*  89097 */     GIR_EraseRootFromParent_Done,
     /*  89098 */   // Label 1935: @89098
     /*  89098 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(89174), // Rule ID 16795 //
     /*  89103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  89111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89136 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89139 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89143 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89156 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14917:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Z128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rm),
     /*  89159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89161 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89172 */     GIR_RootConstrainSelectedInstOperands,
     /*  89173 */     // GIR_Coverage, 16795,
     /*  89173 */     GIR_EraseRootFromParent_Done,
     /*  89174 */   // Label 1936: @89174
     /*  89174 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(89250), // Rule ID 16797 //
     /*  89179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  89187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89212 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89215 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89219 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89232 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14918:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Z256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rm),
     /*  89235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89237 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89248 */     GIR_RootConstrainSelectedInstOperands,
     /*  89249 */     // GIR_Coverage, 16797,
     /*  89249 */     GIR_EraseRootFromParent_Done,
     /*  89250 */   // Label 1937: @89250
     /*  89250 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(89326), // Rule ID 3022 //
     /*  89255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  89263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89288 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89295 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89308 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14783:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrm),
     /*  89311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89313 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89324 */     GIR_RootConstrainSelectedInstOperands,
     /*  89325 */     // GIR_Coverage, 3022,
     /*  89325 */     GIR_EraseRootFromParent_Done,
     /*  89326 */   // Label 1938: @89326
     /*  89326 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(89402), // Rule ID 3024 //
     /*  89331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  89339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89364 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89384 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14787:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrm),
     /*  89387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89389 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89400 */     GIR_RootConstrainSelectedInstOperands,
     /*  89401 */     // GIR_Coverage, 3024,
     /*  89401 */     GIR_EraseRootFromParent_Done,
     /*  89402 */   // Label 1939: @89402
     /*  89402 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(89478), // Rule ID 3026 //
     /*  89407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  89415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89447 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89460 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14785:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrm),
     /*  89463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89465 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89467 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89476 */     GIR_RootConstrainSelectedInstOperands,
     /*  89477 */     // GIR_Coverage, 3026,
     /*  89477 */     GIR_EraseRootFromParent_Done,
     /*  89478 */   // Label 1940: @89478
     /*  89478 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(89554), // Rule ID 3028 //
     /*  89483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  89491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89536 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14767:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrm),
     /*  89539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89541 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89543 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89552 */     GIR_RootConstrainSelectedInstOperands,
     /*  89553 */     // GIR_Coverage, 3028,
     /*  89553 */     GIR_EraseRootFromParent_Done,
     /*  89554 */   // Label 1941: @89554
     /*  89554 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(89630), // Rule ID 3030 //
     /*  89559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  89567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89612 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14773:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrm),
     /*  89615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89617 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89628 */     GIR_RootConstrainSelectedInstOperands,
     /*  89629 */     // GIR_Coverage, 3030,
     /*  89629 */     GIR_EraseRootFromParent_Done,
     /*  89630 */   // Label 1942: @89630
     /*  89630 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(89706), // Rule ID 3046 //
     /*  89635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /*  89643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /*  89646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  89649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /*  89652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89668 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89671 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89675 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89688 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13674:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrm),
     /*  89691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89693 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89704 */     GIR_RootConstrainSelectedInstOperands,
     /*  89705 */     // GIR_Coverage, 3046,
     /*  89705 */     GIR_EraseRootFromParent_Done,
     /*  89706 */   // Label 1943: @89706
     /*  89706 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(89782), // Rule ID 3048 //
     /*  89711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /*  89719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  89722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  89725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  89728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89744 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89747 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89751 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89764 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13676:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrm),
     /*  89767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89769 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89780 */     GIR_RootConstrainSelectedInstOperands,
     /*  89781 */     // GIR_Coverage, 3048,
     /*  89781 */     GIR_EraseRootFromParent_Done,
     /*  89782 */   // Label 1944: @89782
     /*  89782 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(89858), // Rule ID 3050 //
     /*  89787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /*  89795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89840 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13675:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrm),
     /*  89843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89856 */     GIR_RootConstrainSelectedInstOperands,
     /*  89857 */     // GIR_Coverage, 3050,
     /*  89857 */     GIR_EraseRootFromParent_Done,
     /*  89858 */   // Label 1945: @89858
     /*  89858 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(89934), // Rule ID 3052 //
     /*  89863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /*  89871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  89874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  89877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  89880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89896 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89903 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89916 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13661:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrm),
     /*  89919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89921 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89923 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89932 */     GIR_RootConstrainSelectedInstOperands,
     /*  89933 */     // GIR_Coverage, 3052,
     /*  89933 */     GIR_EraseRootFromParent_Done,
     /*  89934 */   // Label 1946: @89934
     /*  89934 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(90010), // Rule ID 3054 //
     /*  89939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /*  89947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  89950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  89953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  89956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89992 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13664:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrm),
     /*  89995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89997 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90008 */     GIR_RootConstrainSelectedInstOperands,
     /*  90009 */     // GIR_Coverage, 3054,
     /*  90009 */     GIR_EraseRootFromParent_Done,
     /*  90010 */   // Label 1947: @90010
     /*  90010 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(90086), // Rule ID 3309 //
     /*  90015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  90023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  90032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90048 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90055 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90068 */     // (intrinsic_wo_chain:{ *:[i32] } 14741:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m8:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m8),
     /*  90071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90073 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90075 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90084 */     GIR_RootConstrainSelectedInstOperands,
     /*  90085 */     // GIR_Coverage, 3309,
     /*  90085 */     GIR_EraseRootFromParent_Done,
     /*  90086 */   // Label 1948: @90086
     /*  90086 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(90162), // Rule ID 3311 //
     /*  90091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  90099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  90108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90124 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90127 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90144 */     // (intrinsic_wo_chain:{ *:[i32] } 14739:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m16:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m16),
     /*  90147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90149 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90160 */     GIR_RootConstrainSelectedInstOperands,
     /*  90161 */     // GIR_Coverage, 3311,
     /*  90161 */     GIR_EraseRootFromParent_Done,
     /*  90162 */   // Label 1949: @90162
     /*  90162 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(90238), // Rule ID 3313 //
     /*  90167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  90175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90200 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90203 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90207 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90220 */     // (intrinsic_wo_chain:{ *:[i32] } 14740:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m32:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m32),
     /*  90223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90225 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90236 */     GIR_RootConstrainSelectedInstOperands,
     /*  90237 */     // GIR_Coverage, 3313,
     /*  90237 */     GIR_EraseRootFromParent_Done,
     /*  90238 */   // Label 1950: @90238
     /*  90238 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(90314), // Rule ID 3315 //
     /*  90243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  90251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  90260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90276 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90283 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90296 */     // (intrinsic_wo_chain:{ *:[i64] } 14742:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r64m64:{ *:[i64] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64m64),
     /*  90299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90301 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90312 */     GIR_RootConstrainSelectedInstOperands,
     /*  90313 */     // GIR_Coverage, 3315,
     /*  90313 */     GIR_EraseRootFromParent_Done,
     /*  90314 */   // Label 1951: @90314
     /*  90314 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(90390), // Rule ID 3317 //
     /*  90319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  90327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  90336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90352 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90355 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90359 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90372 */     // (intrinsic_wo_chain:{ *:[i32] } 14741:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m8_EVEX),
     /*  90375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90377 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90388 */     GIR_RootConstrainSelectedInstOperands,
     /*  90389 */     // GIR_Coverage, 3317,
     /*  90389 */     GIR_EraseRootFromParent_Done,
     /*  90390 */   // Label 1952: @90390
     /*  90390 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(90466), // Rule ID 3319 //
     /*  90395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  90403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  90412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90435 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90448 */     // (intrinsic_wo_chain:{ *:[i32] } 14739:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m16_EVEX),
     /*  90451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90453 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90464 */     GIR_RootConstrainSelectedInstOperands,
     /*  90465 */     // GIR_Coverage, 3319,
     /*  90465 */     GIR_EraseRootFromParent_Done,
     /*  90466 */   // Label 1953: @90466
     /*  90466 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(90542), // Rule ID 3321 //
     /*  90471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  90479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90524 */     // (intrinsic_wo_chain:{ *:[i32] } 14740:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m32_EVEX),
     /*  90527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90540 */     GIR_RootConstrainSelectedInstOperands,
     /*  90541 */     // GIR_Coverage, 3321,
     /*  90541 */     GIR_EraseRootFromParent_Done,
     /*  90542 */   // Label 1954: @90542
     /*  90542 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(90618), // Rule ID 3323 //
     /*  90547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  90555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  90564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90600 */     // (intrinsic_wo_chain:{ *:[i64] } 14742:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r64m64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64m64_EVEX),
     /*  90603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90616 */     GIR_RootConstrainSelectedInstOperands,
     /*  90617 */     // GIR_Coverage, 3323,
     /*  90617 */     GIR_EraseRootFromParent_Done,
     /*  90618 */   // Label 1955: @90618
     /*  90618 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(90694), // Rule ID 3339 //
     /*  90623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  90631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90663 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90676 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13304:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrm),
     /*  90679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90681 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90692 */     GIR_RootConstrainSelectedInstOperands,
     /*  90693 */     // GIR_Coverage, 3339,
     /*  90693 */     GIR_EraseRootFromParent_Done,
     /*  90694 */   // Label 1956: @90694
     /*  90694 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(90770), // Rule ID 3341 //
     /*  90699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  90707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90752 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13307:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrm),
     /*  90755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90768 */     GIR_RootConstrainSelectedInstOperands,
     /*  90769 */     // GIR_Coverage, 3341,
     /*  90769 */     GIR_EraseRootFromParent_Done,
     /*  90770 */   // Label 1957: @90770
     /*  90770 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(90846), // Rule ID 3343 //
     /*  90775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  90783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90808 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90811 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90815 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90828 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13298:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrm),
     /*  90831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90833 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90835 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90844 */     GIR_RootConstrainSelectedInstOperands,
     /*  90845 */     // GIR_Coverage, 3343,
     /*  90845 */     GIR_EraseRootFromParent_Done,
     /*  90846 */   // Label 1958: @90846
     /*  90846 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(90922), // Rule ID 3345 //
     /*  90851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  90859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90884 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90887 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90891 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90904 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13301:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrm),
     /*  90907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90909 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90920 */     GIR_RootConstrainSelectedInstOperands,
     /*  90921 */     // GIR_Coverage, 3345,
     /*  90921 */     GIR_EraseRootFromParent_Done,
     /*  90922 */   // Label 1959: @90922
     /*  90922 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(90998), // Rule ID 3347 //
     /*  90927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  90930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  90935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  90938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  90941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  90944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90960 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90963 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90967 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90980 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13305:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrm),
     /*  90983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90985 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90987 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90996 */     GIR_RootConstrainSelectedInstOperands,
     /*  90997 */     // GIR_Coverage, 3347,
     /*  90997 */     GIR_EraseRootFromParent_Done,
     /*  90998 */   // Label 1960: @90998
     /*  90998 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(91074), // Rule ID 3349 //
     /*  91003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  91011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91056 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13308:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrm),
     /*  91059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91061 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91072 */     GIR_RootConstrainSelectedInstOperands,
     /*  91073 */     // GIR_Coverage, 3349,
     /*  91073 */     GIR_EraseRootFromParent_Done,
     /*  91074 */   // Label 1961: @91074
     /*  91074 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(91150), // Rule ID 3351 //
     /*  91079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  91087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91132 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13299:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrm),
     /*  91135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91137 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91139 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91148 */     GIR_RootConstrainSelectedInstOperands,
     /*  91149 */     // GIR_Coverage, 3351,
     /*  91149 */     GIR_EraseRootFromParent_Done,
     /*  91150 */   // Label 1962: @91150
     /*  91150 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(91226), // Rule ID 3353 //
     /*  91155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  91163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91188 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91208 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13302:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrm),
     /*  91211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91213 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91224 */     GIR_RootConstrainSelectedInstOperands,
     /*  91225 */     // GIR_Coverage, 3353,
     /*  91225 */     GIR_EraseRootFromParent_Done,
     /*  91226 */   // Label 1963: @91226
     /*  91226 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(91302), // Rule ID 3564 //
     /*  91231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  91239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91271 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91284 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14914:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rm),
     /*  91287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91289 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91291 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91300 */     GIR_RootConstrainSelectedInstOperands,
     /*  91301 */     // GIR_Coverage, 3564,
     /*  91301 */     GIR_EraseRootFromParent_Done,
     /*  91302 */   // Label 1964: @91302
     /*  91302 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(91378), // Rule ID 3566 //
     /*  91307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  91315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  91318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  91321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  91324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91340 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91343 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91347 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91360 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14915:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Yrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrm),
     /*  91363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91365 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91367 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91376 */     GIR_RootConstrainSelectedInstOperands,
     /*  91377 */     // GIR_Coverage, 3566,
     /*  91377 */     GIR_EraseRootFromParent_Done,
     /*  91378 */   // Label 1965: @91378
     /*  91378 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(91454), // Rule ID 3568 //
     /*  91383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  91391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91436 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14917:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rm),
     /*  91439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91441 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91443 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91452 */     GIR_RootConstrainSelectedInstOperands,
     /*  91453 */     // GIR_Coverage, 3568,
     /*  91453 */     GIR_EraseRootFromParent_Done,
     /*  91454 */   // Label 1966: @91454
     /*  91454 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(91530), // Rule ID 3570 //
     /*  91459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  91467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  91470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  91473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  91476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91512 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14918:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Yrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrm),
     /*  91515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91517 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91528 */     GIR_RootConstrainSelectedInstOperands,
     /*  91529 */     // GIR_Coverage, 3570,
     /*  91529 */     GIR_EraseRootFromParent_Done,
     /*  91530 */   // Label 1967: @91530
     /*  91530 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(91606), // Rule ID 14060 //
     /*  91535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  91543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91588 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13304:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rm),
     /*  91591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91604 */     GIR_RootConstrainSelectedInstOperands,
     /*  91605 */     // GIR_Coverage, 14060,
     /*  91605 */     GIR_EraseRootFromParent_Done,
     /*  91606 */   // Label 1968: @91606
     /*  91606 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(91682), // Rule ID 14062 //
     /*  91611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  91619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91664 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13305:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rm),
     /*  91667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91669 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91680 */     GIR_RootConstrainSelectedInstOperands,
     /*  91681 */     // GIR_Coverage, 14062,
     /*  91681 */     GIR_EraseRootFromParent_Done,
     /*  91682 */   // Label 1969: @91682
     /*  91682 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(91758), // Rule ID 14064 //
     /*  91687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  91690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /*  91695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  91698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  91701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  91704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91720 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91727 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91740 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13306:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrm),
     /*  91743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91745 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91756 */     GIR_RootConstrainSelectedInstOperands,
     /*  91757 */     // GIR_Coverage, 14064,
     /*  91757 */     GIR_EraseRootFromParent_Done,
     /*  91758 */   // Label 1970: @91758
     /*  91758 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(91834), // Rule ID 14066 //
     /*  91763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  91771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91796 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91799 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91803 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91816 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13307:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rm),
     /*  91819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91832 */     GIR_RootConstrainSelectedInstOperands,
     /*  91833 */     // GIR_Coverage, 14066,
     /*  91833 */     GIR_EraseRootFromParent_Done,
     /*  91834 */   // Label 1971: @91834
     /*  91834 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(91910), // Rule ID 14068 //
     /*  91839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  91847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91872 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91875 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91879 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91892 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13308:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rm),
     /*  91895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91897 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91899 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91908 */     GIR_RootConstrainSelectedInstOperands,
     /*  91909 */     // GIR_Coverage, 14068,
     /*  91909 */     GIR_EraseRootFromParent_Done,
     /*  91910 */   // Label 1972: @91910
     /*  91910 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(91986), // Rule ID 14070 //
     /*  91915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  91918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /*  91923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  91926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  91929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  91932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91968 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13309:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrm),
     /*  91971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91973 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91984 */     GIR_RootConstrainSelectedInstOperands,
     /*  91985 */     // GIR_Coverage, 14070,
     /*  91985 */     GIR_EraseRootFromParent_Done,
     /*  91986 */   // Label 1973: @91986
     /*  91986 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(92062), // Rule ID 14072 //
     /*  91991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  91999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92024 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92027 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92031 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92044 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13298:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rm),
     /*  92047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92049 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92051 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92060 */     GIR_RootConstrainSelectedInstOperands,
     /*  92061 */     // GIR_Coverage, 14072,
     /*  92061 */     GIR_EraseRootFromParent_Done,
     /*  92062 */   // Label 1974: @92062
     /*  92062 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(92138), // Rule ID 14074 //
     /*  92067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  92075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92120 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13299:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rm),
     /*  92123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92136 */     GIR_RootConstrainSelectedInstOperands,
     /*  92137 */     // GIR_Coverage, 14074,
     /*  92137 */     GIR_EraseRootFromParent_Done,
     /*  92138 */   // Label 1975: @92138
     /*  92138 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(92214), // Rule ID 14076 //
     /*  92143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /*  92151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92176 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92183 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92196 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13300:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrm),
     /*  92199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92212 */     GIR_RootConstrainSelectedInstOperands,
     /*  92213 */     // GIR_Coverage, 14076,
     /*  92213 */     GIR_EraseRootFromParent_Done,
     /*  92214 */   // Label 1976: @92214
     /*  92214 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(92290), // Rule ID 14078 //
     /*  92219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  92227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92259 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92272 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13301:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rm),
     /*  92275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92277 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92279 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92288 */     GIR_RootConstrainSelectedInstOperands,
     /*  92289 */     // GIR_Coverage, 14078,
     /*  92289 */     GIR_EraseRootFromParent_Done,
     /*  92290 */   // Label 1977: @92290
     /*  92290 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(92366), // Rule ID 14080 //
     /*  92295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  92303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92328 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92331 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92335 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92348 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13302:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rm),
     /*  92351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92353 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92364 */     GIR_RootConstrainSelectedInstOperands,
     /*  92365 */     // GIR_Coverage, 14080,
     /*  92365 */     GIR_EraseRootFromParent_Done,
     /*  92366 */   // Label 1978: @92366
     /*  92366 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(92442), // Rule ID 14082 //
     /*  92371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /*  92379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92404 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92411 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92424 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13303:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrm),
     /*  92427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92431 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92440 */     GIR_RootConstrainSelectedInstOperands,
     /*  92441 */     // GIR_Coverage, 14082,
     /*  92441 */     GIR_EraseRootFromParent_Done,
     /*  92442 */   // Label 1979: @92442
     /*  92442 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(92518), // Rule ID 16793 //
     /*  92447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  92450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /*  92455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  92458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  92461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  92464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92480 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92500 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14916:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Zrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrm),
     /*  92503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92505 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92507 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92516 */     GIR_RootConstrainSelectedInstOperands,
     /*  92517 */     // GIR_Coverage, 16793,
     /*  92517 */     GIR_EraseRootFromParent_Done,
     /*  92518 */   // Label 1980: @92518
     /*  92518 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(92594), // Rule ID 16799 //
     /*  92523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  92526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /*  92531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  92534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  92537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  92540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92576 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14919:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Zrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrm),
     /*  92579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92581 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92583 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92592 */     GIR_RootConstrainSelectedInstOperands,
     /*  92593 */     // GIR_Coverage, 16799,
     /*  92593 */     GIR_EraseRootFromParent_Done,
     /*  92594 */   // Label 1981: @92594
     /*  92594 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(92635), // Rule ID 3366 //
     /*  92599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  92602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  92607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92621 */     // MIs[0] src2
     /*  92621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  92624 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13311:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  92624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rr),
     /*  92627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92629 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92631 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92633 */     GIR_RootConstrainSelectedInstOperands,
     /*  92634 */     // GIR_Coverage, 3366,
     /*  92634 */     GIR_EraseRootFromParent_Done,
     /*  92635 */   // Label 1982: @92635
     /*  92635 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(92676), // Rule ID 3368 //
     /*  92640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  92643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  92648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92662 */     // MIs[0] src2
     /*  92662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  92665 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13311:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (AESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  92665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESKEYGENASSIST128rr),
     /*  92668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92670 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92672 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92674 */     GIR_RootConstrainSelectedInstOperands,
     /*  92675 */     // GIR_Coverage, 3368,
     /*  92675 */     GIR_EraseRootFromParent_Done,
     /*  92676 */   // Label 1983: @92676
     /*  92676 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(92721), // Rule ID 16788 //
     /*  92681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  92689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92710 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14914:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  92710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rr),
     /*  92713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92715 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92717 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92719 */     GIR_RootConstrainSelectedInstOperands,
     /*  92720 */     // GIR_Coverage, 16788,
     /*  92720 */     GIR_EraseRootFromParent_Done,
     /*  92721 */   // Label 1984: @92721
     /*  92721 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(92766), // Rule ID 16790 //
     /*  92726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  92734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  92737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  92740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  92743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92755 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14915:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  92755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rr),
     /*  92758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92760 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92762 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92764 */     GIR_RootConstrainSelectedInstOperands,
     /*  92765 */     // GIR_Coverage, 16790,
     /*  92765 */     GIR_EraseRootFromParent_Done,
     /*  92766 */   // Label 1985: @92766
     /*  92766 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(92811), // Rule ID 16794 //
     /*  92771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  92779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92800 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14917:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  92800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rr),
     /*  92803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92805 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92807 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92809 */     GIR_RootConstrainSelectedInstOperands,
     /*  92810 */     // GIR_Coverage, 16794,
     /*  92810 */     GIR_EraseRootFromParent_Done,
     /*  92811 */   // Label 1986: @92811
     /*  92811 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(92856), // Rule ID 16796 //
     /*  92816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  92824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  92827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  92830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  92833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92845 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14918:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  92845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rr),
     /*  92848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92850 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92852 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92854 */     GIR_RootConstrainSelectedInstOperands,
     /*  92855 */     // GIR_Coverage, 16796,
     /*  92855 */     GIR_EraseRootFromParent_Done,
     /*  92856 */   // Label 1987: @92856
     /*  92856 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(92901), // Rule ID 3021 //
     /*  92861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  92864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  92869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  92872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  92878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92890 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14783:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  92890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrr),
     /*  92893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92895 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92897 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92899 */     GIR_RootConstrainSelectedInstOperands,
     /*  92900 */     // GIR_Coverage, 3021,
     /*  92900 */     GIR_EraseRootFromParent_Done,
     /*  92901 */   // Label 1988: @92901
     /*  92901 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(92946), // Rule ID 3023 //
     /*  92906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  92909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  92914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  92917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  92923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92935 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14787:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  92935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrr),
     /*  92938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92940 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92942 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92944 */     GIR_RootConstrainSelectedInstOperands,
     /*  92945 */     // GIR_Coverage, 3023,
     /*  92945 */     GIR_EraseRootFromParent_Done,
     /*  92946 */   // Label 1989: @92946
     /*  92946 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(92991), // Rule ID 3025 //
     /*  92951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  92954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  92959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92980 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14785:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  92980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrr),
     /*  92983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92985 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92987 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92989 */     GIR_RootConstrainSelectedInstOperands,
     /*  92990 */     // GIR_Coverage, 3025,
     /*  92990 */     GIR_EraseRootFromParent_Done,
     /*  92991 */   // Label 1990: @92991
     /*  92991 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(93036), // Rule ID 3027 //
     /*  92996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  92999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  93004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93025 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14767:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrr),
     /*  93028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93030 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93032 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93034 */     GIR_RootConstrainSelectedInstOperands,
     /*  93035 */     // GIR_Coverage, 3027,
     /*  93035 */     GIR_EraseRootFromParent_Done,
     /*  93036 */   // Label 1991: @93036
     /*  93036 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(93081), // Rule ID 3029 //
     /*  93041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  93049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93070 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14773:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrr),
     /*  93073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93075 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93077 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93079 */     GIR_RootConstrainSelectedInstOperands,
     /*  93080 */     // GIR_Coverage, 3029,
     /*  93080 */     GIR_EraseRootFromParent_Done,
     /*  93081 */   // Label 1992: @93081
     /*  93081 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(93126), // Rule ID 3045 //
     /*  93086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /*  93094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /*  93097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  93100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /*  93103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93115 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13674:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSIGNBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  93115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrr),
     /*  93118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93120 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93122 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93124 */     GIR_RootConstrainSelectedInstOperands,
     /*  93125 */     // GIR_Coverage, 3045,
     /*  93125 */     GIR_EraseRootFromParent_Done,
     /*  93126 */   // Label 1993: @93126
     /*  93126 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(93171), // Rule ID 3047 //
     /*  93131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /*  93139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93160 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13676:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSIGNWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrr),
     /*  93163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93165 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93167 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93169 */     GIR_RootConstrainSelectedInstOperands,
     /*  93170 */     // GIR_Coverage, 3047,
     /*  93170 */     GIR_EraseRootFromParent_Done,
     /*  93171 */   // Label 1994: @93171
     /*  93171 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(93216), // Rule ID 3049 //
     /*  93176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /*  93184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  93187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  93190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  93193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93205 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13675:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSIGNDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  93205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrr),
     /*  93208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93210 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93212 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93214 */     GIR_RootConstrainSelectedInstOperands,
     /*  93215 */     // GIR_Coverage, 3049,
     /*  93215 */     GIR_EraseRootFromParent_Done,
     /*  93216 */   // Label 1995: @93216
     /*  93216 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(93261), // Rule ID 3051 //
     /*  93221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /*  93229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93250 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13661:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrr),
     /*  93253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93255 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93257 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93259 */     GIR_RootConstrainSelectedInstOperands,
     /*  93260 */     // GIR_Coverage, 3051,
     /*  93260 */     GIR_EraseRootFromParent_Done,
     /*  93261 */   // Label 1996: @93261
     /*  93261 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(93306), // Rule ID 3053 //
     /*  93266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /*  93274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93295 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13664:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrr),
     /*  93298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93300 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93302 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93304 */     GIR_RootConstrainSelectedInstOperands,
     /*  93305 */     // GIR_Coverage, 3053,
     /*  93305 */     GIR_EraseRootFromParent_Done,
     /*  93306 */   // Label 1997: @93306
     /*  93306 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(93351), // Rule ID 3063 //
     /*  93311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  93319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  93328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93340 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14783:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  93340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNBrr),
     /*  93343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93345 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93347 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93349 */     GIR_RootConstrainSelectedInstOperands,
     /*  93350 */     // GIR_Coverage, 3063,
     /*  93350 */     GIR_EraseRootFromParent_Done,
     /*  93351 */   // Label 1998: @93351
     /*  93351 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(93396), // Rule ID 3065 //
     /*  93356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  93364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93385 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14787:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNWrr),
     /*  93388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93390 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93392 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93394 */     GIR_RootConstrainSelectedInstOperands,
     /*  93395 */     // GIR_Coverage, 3065,
     /*  93395 */     GIR_EraseRootFromParent_Done,
     /*  93396 */   // Label 1999: @93396
     /*  93396 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(93441), // Rule ID 3067 //
     /*  93401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  93409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93430 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14785:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNDrr),
     /*  93433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93435 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93437 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93439 */     GIR_RootConstrainSelectedInstOperands,
     /*  93440 */     // GIR_Coverage, 3067,
     /*  93440 */     GIR_EraseRootFromParent_Done,
     /*  93441 */   // Label 2000: @93441
     /*  93441 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(93486), // Rule ID 3071 //
     /*  93446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  93454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93475 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14767:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHADDSWrr),
     /*  93478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93480 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93482 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93484 */     GIR_RootConstrainSelectedInstOperands,
     /*  93485 */     // GIR_Coverage, 3071,
     /*  93485 */     GIR_EraseRootFromParent_Done,
     /*  93486 */   // Label 2001: @93486
     /*  93486 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(93531), // Rule ID 3073 //
     /*  93491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  93499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93520 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14773:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHSUBSWrr),
     /*  93523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93525 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93527 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93529 */     GIR_RootConstrainSelectedInstOperands,
     /*  93530 */     // GIR_Coverage, 3073,
     /*  93530 */     GIR_EraseRootFromParent_Done,
     /*  93531 */   // Label 2002: @93531
     /*  93531 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(93576), // Rule ID 3308 //
     /*  93536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  93544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  93553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  93565 */     // (intrinsic_wo_chain:{ *:[i32] } 14741:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  93565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8),
     /*  93568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93570 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93572 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93574 */     GIR_RootConstrainSelectedInstOperands,
     /*  93575 */     // GIR_Coverage, 3308,
     /*  93575 */     GIR_EraseRootFromParent_Done,
     /*  93576 */   // Label 2003: @93576
     /*  93576 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(93621), // Rule ID 3310 //
     /*  93581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  93589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  93598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  93610 */     // (intrinsic_wo_chain:{ *:[i32] } 14739:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  93610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16),
     /*  93613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93615 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93617 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93619 */     GIR_RootConstrainSelectedInstOperands,
     /*  93620 */     // GIR_Coverage, 3310,
     /*  93620 */     GIR_EraseRootFromParent_Done,
     /*  93621 */   // Label 2004: @93621
     /*  93621 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(93666), // Rule ID 3312 //
     /*  93626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  93634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93655 */     // (intrinsic_wo_chain:{ *:[i32] } 14740:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  93655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32),
     /*  93658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93660 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93662 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93664 */     GIR_RootConstrainSelectedInstOperands,
     /*  93665 */     // GIR_Coverage, 3312,
     /*  93665 */     GIR_EraseRootFromParent_Done,
     /*  93666 */   // Label 2005: @93666
     /*  93666 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(93711), // Rule ID 3314 //
     /*  93671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  93679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93700 */     // (intrinsic_wo_chain:{ *:[i64] } 14742:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  93700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64),
     /*  93703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93705 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93707 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93709 */     GIR_RootConstrainSelectedInstOperands,
     /*  93710 */     // GIR_Coverage, 3314,
     /*  93710 */     GIR_EraseRootFromParent_Done,
     /*  93711 */   // Label 2006: @93711
     /*  93711 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(93756), // Rule ID 3316 //
     /*  93716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  93724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  93733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  93745 */     // (intrinsic_wo_chain:{ *:[i32] } 14741:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  93745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8_EVEX),
     /*  93748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93750 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93752 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93754 */     GIR_RootConstrainSelectedInstOperands,
     /*  93755 */     // GIR_Coverage, 3316,
     /*  93755 */     GIR_EraseRootFromParent_Done,
     /*  93756 */   // Label 2007: @93756
     /*  93756 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(93801), // Rule ID 3318 //
     /*  93761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  93769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  93778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  93790 */     // (intrinsic_wo_chain:{ *:[i32] } 14739:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  93790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16_EVEX),
     /*  93793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93797 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93799 */     GIR_RootConstrainSelectedInstOperands,
     /*  93800 */     // GIR_Coverage, 3318,
     /*  93800 */     GIR_EraseRootFromParent_Done,
     /*  93801 */   // Label 2008: @93801
     /*  93801 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(93846), // Rule ID 3320 //
     /*  93806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  93814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93835 */     // (intrinsic_wo_chain:{ *:[i32] } 14740:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  93835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32_EVEX),
     /*  93838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93840 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93842 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93844 */     GIR_RootConstrainSelectedInstOperands,
     /*  93845 */     // GIR_Coverage, 3320,
     /*  93845 */     GIR_EraseRootFromParent_Done,
     /*  93846 */   // Label 2009: @93846
     /*  93846 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(93891), // Rule ID 3322 //
     /*  93851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  93859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93880 */     // (intrinsic_wo_chain:{ *:[i64] } 14742:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  93880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64_EVEX),
     /*  93883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93885 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93887 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93889 */     GIR_RootConstrainSelectedInstOperands,
     /*  93890 */     // GIR_Coverage, 3322,
     /*  93890 */     GIR_EraseRootFromParent_Done,
     /*  93891 */   // Label 2010: @93891
     /*  93891 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(93936), // Rule ID 3326 //
     /*  93896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  93899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1nexte),
     /*  93904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93925 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14611:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1NEXTErr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1NEXTErr),
     /*  93928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93930 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93932 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93934 */     GIR_RootConstrainSelectedInstOperands,
     /*  93935 */     // GIR_Coverage, 3326,
     /*  93935 */     GIR_EraseRootFromParent_Done,
     /*  93936 */   // Label 2011: @93936
     /*  93936 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(93981), // Rule ID 3328 //
     /*  93941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  93944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg1),
     /*  93949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93970 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14609:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG1rr),
     /*  93973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93975 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93977 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93979 */     GIR_RootConstrainSelectedInstOperands,
     /*  93980 */     // GIR_Coverage, 3328,
     /*  93980 */     GIR_EraseRootFromParent_Done,
     /*  93981 */   // Label 2012: @93981
     /*  93981 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(94026), // Rule ID 3330 //
     /*  93986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  93989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg2),
     /*  93994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94015 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14610:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG2rr),
     /*  94018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94020 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94022 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94024 */     GIR_RootConstrainSelectedInstOperands,
     /*  94025 */     // GIR_Coverage, 3330,
     /*  94025 */     GIR_EraseRootFromParent_Done,
     /*  94026 */   // Label 2013: @94026
     /*  94026 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(94071), // Rule ID 3334 //
     /*  94031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg1),
     /*  94039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94060 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14613:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG1rr),
     /*  94063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94065 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94067 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94069 */     GIR_RootConstrainSelectedInstOperands,
     /*  94070 */     // GIR_Coverage, 3334,
     /*  94070 */     GIR_EraseRootFromParent_Done,
     /*  94071 */   // Label 2014: @94071
     /*  94071 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(94116), // Rule ID 3336 //
     /*  94076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg2),
     /*  94084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94105 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14614:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG2rr),
     /*  94108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94110 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94112 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94114 */     GIR_RootConstrainSelectedInstOperands,
     /*  94115 */     // GIR_Coverage, 3336,
     /*  94115 */     GIR_EraseRootFromParent_Done,
     /*  94116 */   // Label 2015: @94116
     /*  94116 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(94161), // Rule ID 3338 //
     /*  94121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  94129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94150 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13304:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrr),
     /*  94153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94155 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94157 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94159 */     GIR_RootConstrainSelectedInstOperands,
     /*  94160 */     // GIR_Coverage, 3338,
     /*  94160 */     GIR_EraseRootFromParent_Done,
     /*  94161 */   // Label 2016: @94161
     /*  94161 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(94206), // Rule ID 3340 //
     /*  94166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  94174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94195 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13307:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrr),
     /*  94198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94200 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94202 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94204 */     GIR_RootConstrainSelectedInstOperands,
     /*  94205 */     // GIR_Coverage, 3340,
     /*  94205 */     GIR_EraseRootFromParent_Done,
     /*  94206 */   // Label 2017: @94206
     /*  94206 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(94251), // Rule ID 3342 //
     /*  94211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  94219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94240 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13298:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrr),
     /*  94243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94245 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94247 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94249 */     GIR_RootConstrainSelectedInstOperands,
     /*  94250 */     // GIR_Coverage, 3342,
     /*  94250 */     GIR_EraseRootFromParent_Done,
     /*  94251 */   // Label 2018: @94251
     /*  94251 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(94296), // Rule ID 3344 //
     /*  94256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  94264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94285 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13301:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrr),
     /*  94288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94292 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94294 */     GIR_RootConstrainSelectedInstOperands,
     /*  94295 */     // GIR_Coverage, 3344,
     /*  94295 */     GIR_EraseRootFromParent_Done,
     /*  94296 */   // Label 2019: @94296
     /*  94296 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(94341), // Rule ID 3346 //
     /*  94301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  94309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94330 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13305:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrr),
     /*  94333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94335 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94337 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94339 */     GIR_RootConstrainSelectedInstOperands,
     /*  94340 */     // GIR_Coverage, 3346,
     /*  94340 */     GIR_EraseRootFromParent_Done,
     /*  94341 */   // Label 2020: @94341
     /*  94341 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(94386), // Rule ID 3348 //
     /*  94346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  94354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94375 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13308:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrr),
     /*  94378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94380 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94382 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94384 */     GIR_RootConstrainSelectedInstOperands,
     /*  94385 */     // GIR_Coverage, 3348,
     /*  94385 */     GIR_EraseRootFromParent_Done,
     /*  94386 */   // Label 2021: @94386
     /*  94386 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(94431), // Rule ID 3350 //
     /*  94391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  94399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94420 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13299:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrr),
     /*  94423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94427 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94429 */     GIR_RootConstrainSelectedInstOperands,
     /*  94430 */     // GIR_Coverage, 3350,
     /*  94430 */     GIR_EraseRootFromParent_Done,
     /*  94431 */   // Label 2022: @94431
     /*  94431 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(94476), // Rule ID 3352 //
     /*  94436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  94444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94465 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13302:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrr),
     /*  94468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94470 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94472 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94474 */     GIR_RootConstrainSelectedInstOperands,
     /*  94475 */     // GIR_Coverage, 3352,
     /*  94475 */     GIR_EraseRootFromParent_Done,
     /*  94476 */   // Label 2023: @94476
     /*  94476 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(94521), // Rule ID 3354 //
     /*  94481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  94489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94510 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13304:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCrr),
     /*  94513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94517 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94519 */     GIR_RootConstrainSelectedInstOperands,
     /*  94520 */     // GIR_Coverage, 3354,
     /*  94520 */     GIR_EraseRootFromParent_Done,
     /*  94521 */   // Label 2024: @94521
     /*  94521 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(94566), // Rule ID 3356 //
     /*  94526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  94534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94555 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13307:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCLASTrr),
     /*  94558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94560 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94562 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94564 */     GIR_RootConstrainSelectedInstOperands,
     /*  94565 */     // GIR_Coverage, 3356,
     /*  94565 */     GIR_EraseRootFromParent_Done,
     /*  94566 */   // Label 2025: @94566
     /*  94566 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(94611), // Rule ID 3358 //
     /*  94571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  94579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94600 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13298:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECrr),
     /*  94603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94607 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94609 */     GIR_RootConstrainSelectedInstOperands,
     /*  94610 */     // GIR_Coverage, 3358,
     /*  94610 */     GIR_EraseRootFromParent_Done,
     /*  94611 */   // Label 2026: @94611
     /*  94611 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(94656), // Rule ID 3360 //
     /*  94616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  94624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94645 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13301:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECLASTrr),
     /*  94648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94650 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94652 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94654 */     GIR_RootConstrainSelectedInstOperands,
     /*  94655 */     // GIR_Coverage, 3360,
     /*  94655 */     GIR_EraseRootFromParent_Done,
     /*  94656 */   // Label 2027: @94656
     /*  94656 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(94701), // Rule ID 3377 //
     /*  94661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /*  94664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_extrq),
     /*  94669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94690 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14757:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)  =>  (EXTRQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)
     /*  94690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::EXTRQ),
     /*  94693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  94697 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /*  94699 */     GIR_RootConstrainSelectedInstOperands,
     /*  94700 */     // GIR_Coverage, 3377,
     /*  94700 */     GIR_EraseRootFromParent_Done,
     /*  94701 */   // Label 2028: @94701
     /*  94701 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(94746), // Rule ID 3379 //
     /*  94706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /*  94709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_insertq),
     /*  94714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94735 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14759:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)  =>  (INSERTQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)
     /*  94735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INSERTQ),
     /*  94738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94740 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  94742 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /*  94744 */     GIR_RootConstrainSelectedInstOperands,
     /*  94745 */     // GIR_Coverage, 3379,
     /*  94745 */     GIR_EraseRootFromParent_Done,
     /*  94746 */   // Label 2029: @94746
     /*  94746 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(94791), // Rule ID 3554 //
     /*  94751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  94754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg1),
     /*  94759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94780 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14908:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VSHA512MSG1rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG1rr),
     /*  94783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94785 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94787 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94789 */     GIR_RootConstrainSelectedInstOperands,
     /*  94790 */     // GIR_Coverage, 3554,
     /*  94790 */     GIR_EraseRootFromParent_Done,
     /*  94791 */   // Label 2030: @94791
     /*  94791 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(94836), // Rule ID 3555 //
     /*  94796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  94799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg2),
     /*  94804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94825 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14909:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VSHA512MSG2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG2rr),
     /*  94828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94830 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94832 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94834 */     GIR_RootConstrainSelectedInstOperands,
     /*  94835 */     // GIR_Coverage, 3555,
     /*  94835 */     GIR_EraseRootFromParent_Done,
     /*  94836 */   // Label 2031: @94836
     /*  94836 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(94881), // Rule ID 3563 //
     /*  94841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  94844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  94849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94870 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14914:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rr),
     /*  94873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94875 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94877 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94879 */     GIR_RootConstrainSelectedInstOperands,
     /*  94880 */     // GIR_Coverage, 3563,
     /*  94880 */     GIR_EraseRootFromParent_Done,
     /*  94881 */   // Label 2032: @94881
     /*  94881 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(94926), // Rule ID 3565 //
     /*  94886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  94889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  94894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  94897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  94900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  94903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94915 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14915:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  94915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrr),
     /*  94918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94920 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94922 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94924 */     GIR_RootConstrainSelectedInstOperands,
     /*  94925 */     // GIR_Coverage, 3565,
     /*  94925 */     GIR_EraseRootFromParent_Done,
     /*  94926 */   // Label 2033: @94926
     /*  94926 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(94971), // Rule ID 3567 //
     /*  94931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  94934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  94939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94960 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14917:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rr),
     /*  94963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94965 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94967 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94969 */     GIR_RootConstrainSelectedInstOperands,
     /*  94970 */     // GIR_Coverage, 3567,
     /*  94970 */     GIR_EraseRootFromParent_Done,
     /*  94971 */   // Label 2034: @94971
     /*  94971 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(95016), // Rule ID 3569 //
     /*  94976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  94979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  94984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  94987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  94990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  94993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95005 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14918:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  95005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrr),
     /*  95008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95010 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95012 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95014 */     GIR_RootConstrainSelectedInstOperands,
     /*  95015 */     // GIR_Coverage, 3569,
     /*  95015 */     GIR_EraseRootFromParent_Done,
     /*  95016 */   // Label 2035: @95016
     /*  95016 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(95061), // Rule ID 14059 //
     /*  95021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  95029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95050 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13304:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rr),
     /*  95053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95055 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95057 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95059 */     GIR_RootConstrainSelectedInstOperands,
     /*  95060 */     // GIR_Coverage, 14059,
     /*  95060 */     GIR_EraseRootFromParent_Done,
     /*  95061 */   // Label 2036: @95061
     /*  95061 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(95106), // Rule ID 14061 //
     /*  95066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  95074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95095 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13305:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rr),
     /*  95098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95100 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95102 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95104 */     GIR_RootConstrainSelectedInstOperands,
     /*  95105 */     // GIR_Coverage, 14061,
     /*  95105 */     GIR_EraseRootFromParent_Done,
     /*  95106 */   // Label 2037: @95106
     /*  95106 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(95151), // Rule ID 14063 //
     /*  95111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /*  95119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95140 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13306:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrr),
     /*  95143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95145 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95147 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95149 */     GIR_RootConstrainSelectedInstOperands,
     /*  95150 */     // GIR_Coverage, 14063,
     /*  95150 */     GIR_EraseRootFromParent_Done,
     /*  95151 */   // Label 2038: @95151
     /*  95151 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(95196), // Rule ID 14065 //
     /*  95156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  95164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95185 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13307:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rr),
     /*  95188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95190 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95192 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95194 */     GIR_RootConstrainSelectedInstOperands,
     /*  95195 */     // GIR_Coverage, 14065,
     /*  95195 */     GIR_EraseRootFromParent_Done,
     /*  95196 */   // Label 2039: @95196
     /*  95196 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(95241), // Rule ID 14067 //
     /*  95201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  95209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95230 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13308:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rr),
     /*  95233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95235 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95237 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95239 */     GIR_RootConstrainSelectedInstOperands,
     /*  95240 */     // GIR_Coverage, 14067,
     /*  95240 */     GIR_EraseRootFromParent_Done,
     /*  95241 */   // Label 2040: @95241
     /*  95241 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(95286), // Rule ID 14069 //
     /*  95246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /*  95254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95275 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13309:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrr),
     /*  95278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95280 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95282 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95284 */     GIR_RootConstrainSelectedInstOperands,
     /*  95285 */     // GIR_Coverage, 14069,
     /*  95285 */     GIR_EraseRootFromParent_Done,
     /*  95286 */   // Label 2041: @95286
     /*  95286 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(95331), // Rule ID 14071 //
     /*  95291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  95299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95320 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13298:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rr),
     /*  95323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95325 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95327 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95329 */     GIR_RootConstrainSelectedInstOperands,
     /*  95330 */     // GIR_Coverage, 14071,
     /*  95330 */     GIR_EraseRootFromParent_Done,
     /*  95331 */   // Label 2042: @95331
     /*  95331 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(95376), // Rule ID 14073 //
     /*  95336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  95344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95365 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13299:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rr),
     /*  95368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95370 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95372 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95374 */     GIR_RootConstrainSelectedInstOperands,
     /*  95375 */     // GIR_Coverage, 14073,
     /*  95375 */     GIR_EraseRootFromParent_Done,
     /*  95376 */   // Label 2043: @95376
     /*  95376 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(95421), // Rule ID 14075 //
     /*  95381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /*  95389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95410 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13300:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrr),
     /*  95413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95415 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95417 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95419 */     GIR_RootConstrainSelectedInstOperands,
     /*  95420 */     // GIR_Coverage, 14075,
     /*  95420 */     GIR_EraseRootFromParent_Done,
     /*  95421 */   // Label 2044: @95421
     /*  95421 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(95466), // Rule ID 14077 //
     /*  95426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  95434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95455 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13301:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rr),
     /*  95458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95460 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95462 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95464 */     GIR_RootConstrainSelectedInstOperands,
     /*  95465 */     // GIR_Coverage, 14077,
     /*  95465 */     GIR_EraseRootFromParent_Done,
     /*  95466 */   // Label 2045: @95466
     /*  95466 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(95511), // Rule ID 14079 //
     /*  95471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  95479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95500 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13302:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rr),
     /*  95503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95505 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95507 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95509 */     GIR_RootConstrainSelectedInstOperands,
     /*  95510 */     // GIR_Coverage, 14079,
     /*  95510 */     GIR_EraseRootFromParent_Done,
     /*  95511 */   // Label 2046: @95511
     /*  95511 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(95556), // Rule ID 14081 //
     /*  95516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /*  95524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95545 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13303:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrr),
     /*  95548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95550 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95552 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95554 */     GIR_RootConstrainSelectedInstOperands,
     /*  95555 */     // GIR_Coverage, 14081,
     /*  95555 */     GIR_EraseRootFromParent_Done,
     /*  95556 */   // Label 2047: @95556
     /*  95556 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(95601), // Rule ID 16792 //
     /*  95561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  95564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /*  95569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  95572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  95575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  95578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95590 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14916:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4KEY4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  95590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrr),
     /*  95593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95595 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95597 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95599 */     GIR_RootConstrainSelectedInstOperands,
     /*  95600 */     // GIR_Coverage, 16792,
     /*  95600 */     GIR_EraseRootFromParent_Done,
     /*  95601 */   // Label 2048: @95601
     /*  95601 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(95646), // Rule ID 16798 //
     /*  95606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  95609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /*  95614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  95617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  95620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  95623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95635 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14919:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4RNDS4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  95635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrr),
     /*  95638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95640 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95642 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95644 */     GIR_RootConstrainSelectedInstOperands,
     /*  95645 */     // GIR_Coverage, 16798,
     /*  95645 */     GIR_EraseRootFromParent_Done,
     /*  95646 */   // Label 2049: @95646
     /*  95646 */   GIM_Reject,
     /*  95647 */ // Label 1932: @95647
     /*  95647 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(100233),
     /*  95652 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  95655 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(95736), // Rule ID 23531 //
     /*  95660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  95668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95689 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95692 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95696 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95704 */     // MIs[0] src3
     /*  95704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95716 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14726:{ *:[iPTR] }, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrmi:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrmi),
     /*  95719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95721 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  95723 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95727 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95734 */     GIR_RootConstrainSelectedInstOperands,
     /*  95735 */     // GIR_Coverage, 23531,
     /*  95735 */     GIR_EraseRootFromParent_Done,
     /*  95736 */   // Label 2051: @95736
     /*  95736 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(95817), // Rule ID 23532 //
     /*  95741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  95749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95770 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95773 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95777 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95785 */     // MIs[0] src3
     /*  95785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95797 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14725:{ *:[iPTR] }, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrmi:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrmi),
     /*  95800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95802 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  95804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95808 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95815 */     GIR_RootConstrainSelectedInstOperands,
     /*  95816 */     // GIR_Coverage, 23532,
     /*  95816 */     GIR_EraseRootFromParent_Done,
     /*  95817 */   // Label 2052: @95817
     /*  95817 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(95898), // Rule ID 23533 //
     /*  95822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  95830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  95833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  95836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  95839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95858 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95866 */     // MIs[0] src3
     /*  95866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95878 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13336:{ *:[iPTR] }, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrmi:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrmi),
     /*  95881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95883 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  95885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95889 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95896 */     GIR_RootConstrainSelectedInstOperands,
     /*  95897 */     // GIR_Coverage, 23533,
     /*  95897 */     GIR_EraseRootFromParent_Done,
     /*  95898 */   // Label 2053: @95898
     /*  95898 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(95979), // Rule ID 3253 //
     /*  95903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  95911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  95932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95936 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95939 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95943 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95947 */     // MIs[0] src3
     /*  95947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95959 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14726:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrmi:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrmi),
     /*  95962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95964 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95970 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95977 */     GIR_RootConstrainSelectedInstOperands,
     /*  95978 */     // GIR_Coverage, 3253,
     /*  95978 */     GIR_EraseRootFromParent_Done,
     /*  95979 */   // Label 2054: @95979
     /*  95979 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(96060), // Rule ID 3255 //
     /*  95984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  95992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96017 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96020 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96024 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96028 */     // MIs[0] src3
     /*  96028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96040 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14725:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrmi:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrmi),
     /*  96043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96045 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96047 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96051 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96058 */     GIR_RootConstrainSelectedInstOperands,
     /*  96059 */     // GIR_Coverage, 3255,
     /*  96059 */     GIR_EraseRootFromParent_Done,
     /*  96060 */   // Label 2055: @96060
     /*  96060 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(96141), // Rule ID 3257 //
     /*  96065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  96073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  96076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  96079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  96082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96098 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96101 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96105 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96109 */     // MIs[0] src3
     /*  96109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96121 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13336:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrmi:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrmi),
     /*  96124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96126 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96128 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96132 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96139 */     GIR_RootConstrainSelectedInstOperands,
     /*  96140 */     // GIR_Coverage, 3257,
     /*  96140 */     GIR_EraseRootFromParent_Done,
     /*  96141 */   // Label 2056: @96141
     /*  96141 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(96222), // Rule ID 3373 //
     /*  96146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /*  96149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  96154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96179 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96182 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96186 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96190 */     // MIs[0] src3
     /*  96190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96202 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14577:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrmi:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrmi),
     /*  96205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96207 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96213 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96220 */     GIR_RootConstrainSelectedInstOperands,
     /*  96221 */     // GIR_Coverage, 3373,
     /*  96221 */     GIR_EraseRootFromParent_Done,
     /*  96222 */   // Label 2057: @96222
     /*  96222 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(96303), // Rule ID 3375 //
     /*  96227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /*  96230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  96235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  96238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  96241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  96244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96260 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96271 */     // MIs[0] src3
     /*  96271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96283 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14578:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrmi:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrmi),
     /*  96286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96288 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96290 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96294 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96301 */     GIR_RootConstrainSelectedInstOperands,
     /*  96302 */     // GIR_Coverage, 3375,
     /*  96302 */     GIR_EraseRootFromParent_Done,
     /*  96303 */   // Label 2058: @96303
     /*  96303 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(96384), // Rule ID 14084 //
     /*  96308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /*  96311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /*  96316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  96319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  96322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  96325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  96329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  96333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96341 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96344 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96348 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96352 */     // MIs[0] src3
     /*  96352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96364 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14579:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrmi:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrmi),
     /*  96367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96369 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96371 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96375 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96382 */     GIR_RootConstrainSelectedInstOperands,
     /*  96383 */     // GIR_Coverage, 14084,
     /*  96383 */     GIR_EraseRootFromParent_Done,
     /*  96384 */   // Label 2059: @96384
     /*  96384 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(96465), // Rule ID 14086 //
     /*  96389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  96392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  96397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  96410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  96414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96422 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96429 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96433 */     // MIs[0] src3
     /*  96433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96445 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14577:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rmi:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rmi),
     /*  96448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96450 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96452 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96456 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96463 */     GIR_RootConstrainSelectedInstOperands,
     /*  96464 */     // GIR_Coverage, 14086,
     /*  96464 */     GIR_EraseRootFromParent_Done,
     /*  96465 */   // Label 2060: @96465
     /*  96465 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(96546), // Rule ID 14088 //
     /*  96470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  96473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  96478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  96481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  96484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  96487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  96491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  96495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96503 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96506 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96510 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96514 */     // MIs[0] src3
     /*  96514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96526 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14578:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rmi:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rmi),
     /*  96529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96531 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96537 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96544 */     GIR_RootConstrainSelectedInstOperands,
     /*  96545 */     // GIR_Coverage, 14088,
     /*  96545 */     GIR_EraseRootFromParent_Done,
     /*  96546 */   // Label 2061: @96546
     /*  96546 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(96631), // Rule ID 23333 //
     /*  96551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  96559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96583 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96586 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96590 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96611 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14971:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrm),
     /*  96614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96616 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96618 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96622 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96629 */     GIR_RootConstrainSelectedInstOperands,
     /*  96630 */     // GIR_Coverage, 23333,
     /*  96630 */     GIR_EraseRootFromParent_Done,
     /*  96631 */   // Label 2062: @96631
     /*  96631 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(96716), // Rule ID 23334 //
     /*  96636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  96644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96668 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96671 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96675 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96696 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14970:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrm),
     /*  96699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96701 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96707 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96714 */     GIR_RootConstrainSelectedInstOperands,
     /*  96715 */     // GIR_Coverage, 23334,
     /*  96715 */     GIR_EraseRootFromParent_Done,
     /*  96716 */   // Label 2063: @96716
     /*  96716 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(96801), // Rule ID 23335 //
     /*  96721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  96729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  96741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96781 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14969:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  96781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrm),
     /*  96784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96786 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96788 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96792 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96799 */     GIR_RootConstrainSelectedInstOperands,
     /*  96800 */     // GIR_Coverage, 23335,
     /*  96800 */     GIR_EraseRootFromParent_Done,
     /*  96801 */   // Label 2064: @96801
     /*  96801 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(96886), // Rule ID 23336 //
     /*  96806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  96814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96838 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96841 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96845 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96866 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14968:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrm),
     /*  96869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96871 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96877 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96884 */     GIR_RootConstrainSelectedInstOperands,
     /*  96885 */     // GIR_Coverage, 23336,
     /*  96885 */     GIR_EraseRootFromParent_Done,
     /*  96886 */   // Label 2065: @96886
     /*  96886 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(96971), // Rule ID 23337 //
     /*  96891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  96899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  96911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96923 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96926 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96930 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96951 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14967:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  96951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrm),
     /*  96954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96956 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96958 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96962 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96969 */     GIR_RootConstrainSelectedInstOperands,
     /*  96970 */     // GIR_Coverage, 23337,
     /*  96970 */     GIR_EraseRootFromParent_Done,
     /*  96971 */   // Label 2066: @96971
     /*  96971 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(97056), // Rule ID 23338 //
     /*  96976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  96984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97008 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97015 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97036 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14966:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrm),
     /*  97039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97041 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97047 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97054 */     GIR_RootConstrainSelectedInstOperands,
     /*  97055 */     // GIR_Coverage, 23338,
     /*  97055 */     GIR_EraseRootFromParent_Done,
     /*  97056 */   // Label 2067: @97056
     /*  97056 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(97141), // Rule ID 23339 //
     /*  97061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  97069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97093 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97096 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97100 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97121 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14965:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrm),
     /*  97124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97126 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97128 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97132 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97139 */     GIR_RootConstrainSelectedInstOperands,
     /*  97140 */     // GIR_Coverage, 23339,
     /*  97140 */     GIR_EraseRootFromParent_Done,
     /*  97141 */   // Label 2068: @97141
     /*  97141 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(97226), // Rule ID 23340 //
     /*  97146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  97154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97178 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97206 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14964:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrm),
     /*  97209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97211 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97213 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97217 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97224 */     GIR_RootConstrainSelectedInstOperands,
     /*  97225 */     // GIR_Coverage, 23340,
     /*  97225 */     GIR_EraseRootFromParent_Done,
     /*  97226 */   // Label 2069: @97226
     /*  97226 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(97311), // Rule ID 23341 //
     /*  97231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  97239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97263 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97266 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97270 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97291 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14963:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrm),
     /*  97294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97296 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97298 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97302 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97309 */     GIR_RootConstrainSelectedInstOperands,
     /*  97310 */     // GIR_Coverage, 23341,
     /*  97310 */     GIR_EraseRootFromParent_Done,
     /*  97311 */   // Label 2070: @97311
     /*  97311 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(97396), // Rule ID 23342 //
     /*  97316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  97324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97376 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14962:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrm),
     /*  97379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97381 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97383 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97387 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97394 */     GIR_RootConstrainSelectedInstOperands,
     /*  97395 */     // GIR_Coverage, 23342,
     /*  97395 */     GIR_EraseRootFromParent_Done,
     /*  97396 */   // Label 2071: @97396
     /*  97396 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(97481), // Rule ID 23343 //
     /*  97401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  97409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97433 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97461 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14961:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrm),
     /*  97464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97466 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97472 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97479 */     GIR_RootConstrainSelectedInstOperands,
     /*  97480 */     // GIR_Coverage, 23343,
     /*  97480 */     GIR_EraseRootFromParent_Done,
     /*  97481 */   // Label 2072: @97481
     /*  97481 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(97566), // Rule ID 23344 //
     /*  97486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  97494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97518 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97525 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97546 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14960:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrm),
     /*  97549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97551 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97553 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97557 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97564 */     GIR_RootConstrainSelectedInstOperands,
     /*  97565 */     // GIR_Coverage, 23344,
     /*  97565 */     GIR_EraseRootFromParent_Done,
     /*  97566 */   // Label 2073: @97566
     /*  97566 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(97651), // Rule ID 1619 //
     /*  97571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  97579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97607 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97610 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97614 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97631 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14971:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrm),
     /*  97634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97642 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97649 */     GIR_RootConstrainSelectedInstOperands,
     /*  97650 */     // GIR_Coverage, 1619,
     /*  97650 */     GIR_EraseRootFromParent_Done,
     /*  97651 */   // Label 2074: @97651
     /*  97651 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(97736), // Rule ID 1621 //
     /*  97656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  97664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97692 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97695 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97699 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97716 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14970:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrm),
     /*  97719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97721 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97723 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97727 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97734 */     GIR_RootConstrainSelectedInstOperands,
     /*  97735 */     // GIR_Coverage, 1621,
     /*  97735 */     GIR_EraseRootFromParent_Done,
     /*  97736 */   // Label 2075: @97736
     /*  97736 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(97821), // Rule ID 1623 //
     /*  97741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  97749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  97761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97777 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97784 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97801 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14969:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  97801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrm),
     /*  97804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97806 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97808 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97812 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97819 */     GIR_RootConstrainSelectedInstOperands,
     /*  97820 */     // GIR_Coverage, 1623,
     /*  97820 */     GIR_EraseRootFromParent_Done,
     /*  97821 */   // Label 2076: @97821
     /*  97821 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(97906), // Rule ID 1625 //
     /*  97826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  97834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97862 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97865 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97869 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97886 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14968:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrm),
     /*  97889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97891 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97897 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97904 */     GIR_RootConstrainSelectedInstOperands,
     /*  97905 */     // GIR_Coverage, 1625,
     /*  97905 */     GIR_EraseRootFromParent_Done,
     /*  97906 */   // Label 2077: @97906
     /*  97906 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(97991), // Rule ID 1627 //
     /*  97911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  97919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  97931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97947 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97950 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97954 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97971 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14967:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  97971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrm),
     /*  97974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97978 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97982 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97989 */     GIR_RootConstrainSelectedInstOperands,
     /*  97990 */     // GIR_Coverage, 1627,
     /*  97990 */     GIR_EraseRootFromParent_Done,
     /*  97991 */   // Label 2078: @97991
     /*  97991 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(98076), // Rule ID 1629 //
     /*  97996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  98004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98035 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98039 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98056 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14966:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrm),
     /*  98059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98061 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98067 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98074 */     GIR_RootConstrainSelectedInstOperands,
     /*  98075 */     // GIR_Coverage, 1629,
     /*  98075 */     GIR_EraseRootFromParent_Done,
     /*  98076 */   // Label 2079: @98076
     /*  98076 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(98161), // Rule ID 1631 //
     /*  98081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  98089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98117 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98124 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98141 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14965:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrm),
     /*  98144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98146 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98148 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98152 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98159 */     GIR_RootConstrainSelectedInstOperands,
     /*  98160 */     // GIR_Coverage, 1631,
     /*  98160 */     GIR_EraseRootFromParent_Done,
     /*  98161 */   // Label 2080: @98161
     /*  98161 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(98246), // Rule ID 1633 //
     /*  98166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  98174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98209 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98226 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14964:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrm),
     /*  98229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98231 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98233 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98237 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98244 */     GIR_RootConstrainSelectedInstOperands,
     /*  98245 */     // GIR_Coverage, 1633,
     /*  98245 */     GIR_EraseRootFromParent_Done,
     /*  98246 */   // Label 2081: @98246
     /*  98246 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(98331), // Rule ID 1635 //
     /*  98251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  98259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98287 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98290 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98294 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98311 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14963:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrm),
     /*  98314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98316 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98318 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98322 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98329 */     GIR_RootConstrainSelectedInstOperands,
     /*  98330 */     // GIR_Coverage, 1635,
     /*  98330 */     GIR_EraseRootFromParent_Done,
     /*  98331 */   // Label 2082: @98331
     /*  98331 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(98416), // Rule ID 1637 //
     /*  98336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  98344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98372 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98396 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14962:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrm),
     /*  98399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98401 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98407 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98414 */     GIR_RootConstrainSelectedInstOperands,
     /*  98415 */     // GIR_Coverage, 1637,
     /*  98415 */     GIR_EraseRootFromParent_Done,
     /*  98416 */   // Label 2083: @98416
     /*  98416 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(98501), // Rule ID 1639 //
     /*  98421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  98429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98457 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98460 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98464 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98481 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14961:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrm),
     /*  98484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98486 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98488 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98492 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98499 */     GIR_RootConstrainSelectedInstOperands,
     /*  98500 */     // GIR_Coverage, 1639,
     /*  98500 */     GIR_EraseRootFromParent_Done,
     /*  98501 */   // Label 2084: @98501
     /*  98501 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(98586), // Rule ID 1641 //
     /*  98506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  98514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98542 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98545 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98549 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98566 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14960:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrm),
     /*  98569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98571 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98577 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98584 */     GIR_RootConstrainSelectedInstOperands,
     /*  98585 */     // GIR_Coverage, 1641,
     /*  98585 */     GIR_EraseRootFromParent_Done,
     /*  98586 */   // Label 2085: @98586
     /*  98586 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(98671), // Rule ID 3558 //
     /*  98591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  98594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /*  98599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  98627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98631 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98634 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98638 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98651 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14911:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM3MSG1rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /*  98651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rm),
     /*  98654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98656 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98658 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  98664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98669 */     GIR_RootConstrainSelectedInstOperands,
     /*  98670 */     // GIR_Coverage, 3558,
     /*  98670 */     GIR_EraseRootFromParent_Done,
     /*  98671 */   // Label 2086: @98671
     /*  98671 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(98756), // Rule ID 3560 //
     /*  98676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  98679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /*  98684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  98712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98723 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98736 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14912:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM3MSG2rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /*  98736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rm),
     /*  98739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98743 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  98749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98754 */     GIR_RootConstrainSelectedInstOperands,
     /*  98755 */     // GIR_Coverage, 3560,
     /*  98755 */     GIR_EraseRootFromParent_Done,
     /*  98756 */   // Label 2087: @98756
     /*  98756 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(98806), // Rule ID 3252 //
     /*  98761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  98764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  98769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98790 */     // MIs[0] src3
     /*  98790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98793 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14726:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrri),
     /*  98796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98798 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98800 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98802 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98804 */     GIR_RootConstrainSelectedInstOperands,
     /*  98805 */     // GIR_Coverage, 3252,
     /*  98805 */     GIR_EraseRootFromParent_Done,
     /*  98806 */   // Label 2088: @98806
     /*  98806 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(98856), // Rule ID 3254 //
     /*  98811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  98814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  98819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98840 */     // MIs[0] src3
     /*  98840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98843 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14725:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrri),
     /*  98846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98848 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98850 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98852 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98854 */     GIR_RootConstrainSelectedInstOperands,
     /*  98855 */     // GIR_Coverage, 3254,
     /*  98855 */     GIR_EraseRootFromParent_Done,
     /*  98856 */   // Label 2089: @98856
     /*  98856 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(98906), // Rule ID 3256 //
     /*  98861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  98864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  98869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  98872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  98875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  98878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  98882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  98886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  98890 */     // MIs[0] src3
     /*  98890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98893 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13336:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrri:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrri),
     /*  98896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98898 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98900 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98902 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98904 */     GIR_RootConstrainSelectedInstOperands,
     /*  98905 */     // GIR_Coverage, 3256,
     /*  98905 */     GIR_EraseRootFromParent_Done,
     /*  98906 */   // Label 2090: @98906
     /*  98906 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(98956), // Rule ID 3262 //
     /*  98911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  98914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  98919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98940 */     // MIs[0] src3
     /*  98940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98943 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14726:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPSrri),
     /*  98946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98948 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98950 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98952 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98954 */     GIR_RootConstrainSelectedInstOperands,
     /*  98955 */     // GIR_Coverage, 3262,
     /*  98955 */     GIR_EraseRootFromParent_Done,
     /*  98956 */   // Label 2091: @98956
     /*  98956 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(99006), // Rule ID 3264 //
     /*  98961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  98964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  98969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98990 */     // MIs[0] src3
     /*  98990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98993 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14725:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPDrri),
     /*  98996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98998 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99000 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99002 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99004 */     GIR_RootConstrainSelectedInstOperands,
     /*  99005 */     // GIR_Coverage, 3264,
     /*  99005 */     GIR_EraseRootFromParent_Done,
     /*  99006 */   // Label 2092: @99006
     /*  99006 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(99056), // Rule ID 3324 //
     /*  99011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  99014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1rnds4),
     /*  99019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99040 */     // MIs[0] src3
     /*  99040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99043 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14612:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (SHA1RNDS4rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1RNDS4rri),
     /*  99046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99048 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99050 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99052 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99054 */     GIR_RootConstrainSelectedInstOperands,
     /*  99055 */     // GIR_Coverage, 3324,
     /*  99055 */     GIR_EraseRootFromParent_Done,
     /*  99056 */   // Label 2093: @99056
     /*  99056 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(99106), // Rule ID 3370 //
     /*  99061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPCLMUL_NoAVX),
     /*  99064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99090 */     // MIs[0] src3
     /*  99090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99093 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14577:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (PCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PCLMULQDQrri),
     /*  99096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99098 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99100 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99102 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99104 */     GIR_RootConstrainSelectedInstOperands,
     /*  99105 */     // GIR_Coverage, 3370,
     /*  99105 */     GIR_EraseRootFromParent_Done,
     /*  99106 */   // Label 2094: @99106
     /*  99106 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(99156), // Rule ID 3372 //
     /*  99111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /*  99114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99140 */     // MIs[0] src3
     /*  99140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99143 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14577:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrri),
     /*  99146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99150 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99152 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99154 */     GIR_RootConstrainSelectedInstOperands,
     /*  99155 */     // GIR_Coverage, 3372,
     /*  99155 */     GIR_EraseRootFromParent_Done,
     /*  99156 */   // Label 2095: @99156
     /*  99156 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(99206), // Rule ID 3374 //
     /*  99161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /*  99164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  99169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  99172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  99175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  99178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99190 */     // MIs[0] src3
     /*  99190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99193 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14578:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrri:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrri),
     /*  99196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99198 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99200 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99202 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99204 */     GIR_RootConstrainSelectedInstOperands,
     /*  99205 */     // GIR_Coverage, 3374,
     /*  99205 */     GIR_EraseRootFromParent_Done,
     /*  99206 */   // Label 2096: @99206
     /*  99206 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(99256), // Rule ID 14083 //
     /*  99211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /*  99214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /*  99219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  99222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  99225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  99228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99240 */     // MIs[0] src3
     /*  99240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99243 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14579:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrri),
     /*  99246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99248 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99250 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99252 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99254 */     GIR_RootConstrainSelectedInstOperands,
     /*  99255 */     // GIR_Coverage, 14083,
     /*  99255 */     GIR_EraseRootFromParent_Done,
     /*  99256 */   // Label 2097: @99256
     /*  99256 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(99306), // Rule ID 14085 //
     /*  99261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  99264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99290 */     // MIs[0] src3
     /*  99290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99293 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14577:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rri),
     /*  99296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99298 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99300 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99302 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99304 */     GIR_RootConstrainSelectedInstOperands,
     /*  99305 */     // GIR_Coverage, 14085,
     /*  99305 */     GIR_EraseRootFromParent_Done,
     /*  99306 */   // Label 2098: @99306
     /*  99306 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(99356), // Rule ID 14087 //
     /*  99311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  99314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  99319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  99322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  99325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  99328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99340 */     // MIs[0] src3
     /*  99340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99343 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14578:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rri),
     /*  99346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99348 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99350 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99352 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99354 */     GIR_RootConstrainSelectedInstOperands,
     /*  99355 */     // GIR_Coverage, 14087,
     /*  99355 */     GIR_EraseRootFromParent_Done,
     /*  99356 */   // Label 2099: @99356
     /*  99356 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(99410), // Rule ID 1618 //
     /*  99361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  99369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99397 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14971:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrr),
     /*  99400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99402 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99404 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99406 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99408 */     GIR_RootConstrainSelectedInstOperands,
     /*  99409 */     // GIR_Coverage, 1618,
     /*  99409 */     GIR_EraseRootFromParent_Done,
     /*  99410 */   // Label 2100: @99410
     /*  99410 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(99464), // Rule ID 1620 //
     /*  99415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  99423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99451 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14970:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrr),
     /*  99454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99456 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99458 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99460 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99462 */     GIR_RootConstrainSelectedInstOperands,
     /*  99463 */     // GIR_Coverage, 1620,
     /*  99463 */     GIR_EraseRootFromParent_Done,
     /*  99464 */   // Label 2101: @99464
     /*  99464 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(99518), // Rule ID 1622 //
     /*  99469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  99477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  99480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  99489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99505 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14969:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  99505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*  99508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99510 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99512 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99514 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99516 */     GIR_RootConstrainSelectedInstOperands,
     /*  99517 */     // GIR_Coverage, 1622,
     /*  99517 */     GIR_EraseRootFromParent_Done,
     /*  99518 */   // Label 2102: @99518
     /*  99518 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(99572), // Rule ID 1624 //
     /*  99523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  99531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99559 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14968:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrr),
     /*  99562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99566 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99568 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99570 */     GIR_RootConstrainSelectedInstOperands,
     /*  99571 */     // GIR_Coverage, 1624,
     /*  99571 */     GIR_EraseRootFromParent_Done,
     /*  99572 */   // Label 2103: @99572
     /*  99572 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(99626), // Rule ID 1626 //
     /*  99577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  99585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  99588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  99597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99613 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14967:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  99613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrr),
     /*  99616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99618 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99620 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99622 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99624 */     GIR_RootConstrainSelectedInstOperands,
     /*  99625 */     // GIR_Coverage, 1626,
     /*  99625 */     GIR_EraseRootFromParent_Done,
     /*  99626 */   // Label 2104: @99626
     /*  99626 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(99680), // Rule ID 1628 //
     /*  99631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  99639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99667 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14966:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrr),
     /*  99670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99672 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99674 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99676 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99678 */     GIR_RootConstrainSelectedInstOperands,
     /*  99679 */     // GIR_Coverage, 1628,
     /*  99679 */     GIR_EraseRootFromParent_Done,
     /*  99680 */   // Label 2105: @99680
     /*  99680 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(99734), // Rule ID 1630 //
     /*  99685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  99693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99721 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14965:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrr),
     /*  99724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99726 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99728 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99730 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99732 */     GIR_RootConstrainSelectedInstOperands,
     /*  99733 */     // GIR_Coverage, 1630,
     /*  99733 */     GIR_EraseRootFromParent_Done,
     /*  99734 */   // Label 2106: @99734
     /*  99734 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(99788), // Rule ID 1632 //
     /*  99739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  99747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99775 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14964:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrr),
     /*  99778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99780 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99782 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99784 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99786 */     GIR_RootConstrainSelectedInstOperands,
     /*  99787 */     // GIR_Coverage, 1632,
     /*  99787 */     GIR_EraseRootFromParent_Done,
     /*  99788 */   // Label 2107: @99788
     /*  99788 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(99842), // Rule ID 1634 //
     /*  99793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  99801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99829 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14963:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrr),
     /*  99832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99834 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99836 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99838 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99840 */     GIR_RootConstrainSelectedInstOperands,
     /*  99841 */     // GIR_Coverage, 1634,
     /*  99841 */     GIR_EraseRootFromParent_Done,
     /*  99842 */   // Label 2108: @99842
     /*  99842 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(99896), // Rule ID 1636 //
     /*  99847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  99855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99883 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14962:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrr),
     /*  99886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99888 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99890 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99892 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99894 */     GIR_RootConstrainSelectedInstOperands,
     /*  99895 */     // GIR_Coverage, 1636,
     /*  99895 */     GIR_EraseRootFromParent_Done,
     /*  99896 */   // Label 2109: @99896
     /*  99896 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(99950), // Rule ID 1638 //
     /*  99901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  99909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99937 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14961:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrr),
     /*  99940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99942 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99944 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99946 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99948 */     GIR_RootConstrainSelectedInstOperands,
     /*  99949 */     // GIR_Coverage, 1638,
     /*  99949 */     GIR_EraseRootFromParent_Done,
     /*  99950 */   // Label 2110: @99950
     /*  99950 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(100004), // Rule ID 1640 //
     /*  99955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  99963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99991 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14960:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*  99994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99996 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99998 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100000 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100002 */     GIR_RootConstrainSelectedInstOperands,
     /* 100003 */     // GIR_Coverage, 1640,
     /* 100003 */     GIR_EraseRootFromParent_Done,
     /* 100004 */   // Label 2111: @100004
     /* 100004 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(100070), // Rule ID 3332 //
     /* 100009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 100012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256rnds2),
     /* 100017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100045 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14615:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, XMM0:{ *:[v4i32] })  =>  (SHA256RNDS2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 100045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100049 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100055 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XMM0
     /* 100059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256RNDS2rr),
     /* 100062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100064 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100066 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100068 */     GIR_RootConstrainSelectedInstOperands,
     /* 100069 */     // GIR_Coverage, 3332,
     /* 100069 */     GIR_EraseRootFromParent_Done,
     /* 100070 */   // Label 2112: @100070
     /* 100070 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(100124), // Rule ID 3556 //
     /* 100075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /* 100078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512rnds2),
     /* 100083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 100086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 100089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 100092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 100095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100111 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14910:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VSHA512RNDS2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 100111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512RNDS2rr),
     /* 100114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100118 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100120 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100122 */     GIR_RootConstrainSelectedInstOperands,
     /* 100123 */     // GIR_Coverage, 3556,
     /* 100123 */     GIR_EraseRootFromParent_Done,
     /* 100124 */   // Label 2113: @100124
     /* 100124 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(100178), // Rule ID 3557 //
     /* 100129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /* 100137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100165 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14911:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rr),
     /* 100168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100170 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100172 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100174 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100176 */     GIR_RootConstrainSelectedInstOperands,
     /* 100177 */     // GIR_Coverage, 3557,
     /* 100177 */     GIR_EraseRootFromParent_Done,
     /* 100178 */   // Label 2114: @100178
     /* 100178 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(100232), // Rule ID 3559 //
     /* 100183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /* 100191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100219 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14912:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rr),
     /* 100222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100226 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100228 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100230 */     GIR_RootConstrainSelectedInstOperands,
     /* 100231 */     // GIR_Coverage, 3559,
     /* 100231 */     GIR_EraseRootFromParent_Done,
     /* 100232 */   // Label 2115: @100232
     /* 100232 */   GIM_Reject,
     /* 100233 */ // Label 2050: @100233
     /* 100233 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(100362),
     /* 100238 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 100241 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3rnds2),
     /* 100246 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100252 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100255 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100266 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100270 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(100331), // Rule ID 3562 //
     /* 100275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 100282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 100286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 100293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 100297 */     // MIs[0] src4
     /* 100297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 100300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100309 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14913:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rmi:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3, (timm:{ *:[i32] }):$src4)
     /* 100309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rmi),
     /* 100312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100314 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100316 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100318 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 100322 */     GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /* 100324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 100329 */     GIR_RootConstrainSelectedInstOperands,
     /* 100330 */     // GIR_Coverage, 3562,
     /* 100330 */     GIR_EraseRootFromParent_Done,
     /* 100331 */   // Label 2117: @100331
     /* 100331 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(100361), // Rule ID 3561 //
     /* 100336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100343 */     // MIs[0] src4
     /* 100343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 100346 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14913:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)
     /* 100346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rri),
     /* 100349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100351 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100353 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100355 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100357 */     GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /* 100359 */     GIR_RootConstrainSelectedInstOperands,
     /* 100360 */     // GIR_Coverage, 3561,
     /* 100360 */     GIR_EraseRootFromParent_Done,
     /* 100361 */   // Label 2118: @100361
     /* 100361 */   GIM_Reject,
     /* 100362 */ // Label 2116: @100362
     /* 100362 */ GIM_Reject,
     /* 100363 */ // Label 18: @100363
     /* 100363 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(100922),
     /* 100368 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 100371 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(100393), // Rule ID 149 //
     /* 100376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSERIALIZE),
     /* 100379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_serialize),
     /* 100384 */     // (intrinsic_void 14607:{ *:[iPTR] })  =>  (SERIALIZE)
     /* 100384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SERIALIZE),
     /* 100387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100391 */     GIR_RootConstrainSelectedInstOperands,
     /* 100392 */     // GIR_Coverage, 149,
     /* 100392 */     GIR_EraseRootFromParent_Done,
     /* 100393 */   // Label 2120: @100393
     /* 100393 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(100415), // Rule ID 150 //
     /* 100398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 100401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsusldtrk),
     /* 100406 */     // (intrinsic_void 14995:{ *:[iPTR] })  =>  (XSUSLDTRK)
     /* 100406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSUSLDTRK),
     /* 100409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100413 */     GIR_RootConstrainSelectedInstOperands,
     /* 100414 */     // GIR_Coverage, 150,
     /* 100414 */     GIR_EraseRootFromParent_Done,
     /* 100415 */   // Label 2121: @100415
     /* 100415 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(100437), // Rule ID 151 //
     /* 100420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 100423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xresldtrk),
     /* 100428 */     // (intrinsic_void 14981:{ *:[iPTR] })  =>  (XRESLDTRK)
     /* 100428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRESLDTRK),
     /* 100431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100435 */     GIR_RootConstrainSelectedInstOperands,
     /* 100436 */     // GIR_Coverage, 151,
     /* 100436 */     GIR_EraseRootFromParent_Done,
     /* 100437 */   // Label 2122: @100437
     /* 100437 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(100459), // Rule ID 152 //
     /* 100442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 100445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clui),
     /* 100450 */     // (intrinsic_void 14465:{ *:[iPTR] })  =>  (CLUI)
     /* 100450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLUI),
     /* 100453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100457 */     GIR_RootConstrainSelectedInstOperands,
     /* 100458 */     // GIR_Coverage, 152,
     /* 100458 */     GIR_EraseRootFromParent_Done,
     /* 100459 */   // Label 2123: @100459
     /* 100459 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(100481), // Rule ID 153 //
     /* 100464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 100467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_stui),
     /* 100472 */     // (intrinsic_void 14789:{ *:[iPTR] })  =>  (STUI)
     /* 100472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STUI),
     /* 100475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100479 */     GIR_RootConstrainSelectedInstOperands,
     /* 100480 */     // GIR_Coverage, 153,
     /* 100480 */     GIR_EraseRootFromParent_Done,
     /* 100481 */   // Label 2124: @100481
     /* 100481 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(100500), // Rule ID 2509 //
     /* 100486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_pause),
     /* 100491 */     // (intrinsic_void 14684:{ *:[iPTR] })  =>  (PAUSE)
     /* 100491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PAUSE),
     /* 100494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100498 */     GIR_RootConstrainSelectedInstOperands,
     /* 100499 */     // GIR_Coverage, 2509,
     /* 100499 */     GIR_EraseRootFromParent_Done,
     /* 100500 */   // Label 2125: @100500
     /* 100500 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(100522), // Rule ID 2510 //
     /* 100505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE1),
     /* 100508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_sfence),
     /* 100513 */     // (intrinsic_void 14646:{ *:[iPTR] })  =>  (SFENCE)
     /* 100513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SFENCE),
     /* 100516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100520 */     GIR_RootConstrainSelectedInstOperands,
     /* 100521 */     // GIR_Coverage, 2510,
     /* 100521 */     GIR_EraseRootFromParent_Done,
     /* 100522 */   // Label 2126: @100522
     /* 100522 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(100544), // Rule ID 2511 //
     /* 100527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE2),
     /* 100530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_lfence),
     /* 100535 */     // (intrinsic_void 14673:{ *:[iPTR] })  =>  (LFENCE)
     /* 100535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LFENCE),
     /* 100538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100542 */     GIR_RootConstrainSelectedInstOperands,
     /* 100543 */     // GIR_Coverage, 2511,
     /* 100543 */     GIR_EraseRootFromParent_Done,
     /* 100544 */   // Label 2127: @100544
     /* 100544 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(100566), // Rule ID 2512 //
     /* 100549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMFence),
     /* 100552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_mfence),
     /* 100557 */     // (intrinsic_void 14677:{ *:[iPTR] })  =>  (MFENCE)
     /* 100557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MFENCE),
     /* 100560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100564 */     GIR_RootConstrainSelectedInstOperands,
     /* 100565 */     // GIR_Coverage, 2512,
     /* 100565 */     GIR_EraseRootFromParent_Done,
     /* 100566 */   // Label 2128: @100566
     /* 100566 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(100632), // Rule ID 3426 //
     /* 100571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroall),
     /* 100579 */     // (intrinsic_void 13379:{ *:[iPTR] })  =>  (VZEROALL)
     /* 100579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROALL),
     /* 100582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 100585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 100588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 100591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 100594 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 100597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 100600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 100603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 100606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 100609 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 100612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 100615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 100618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 100621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 100624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 100627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 100630 */     GIR_RootConstrainSelectedInstOperands,
     /* 100631 */     // GIR_Coverage, 3426,
     /* 100631 */     GIR_EraseRootFromParent_Done,
     /* 100632 */   // Label 2129: @100632
     /* 100632 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(100698), // Rule ID 3427 //
     /* 100637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroupper),
     /* 100645 */     // (intrinsic_void 13380:{ *:[iPTR] })  =>  (VZEROUPPER)
     /* 100645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROUPPER),
     /* 100648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 100651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 100654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 100657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 100660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 100663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 100666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 100669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 100672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 100675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 100678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 100681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 100684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 100687 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 100690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 100693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 100696 */     GIR_RootConstrainSelectedInstOperands,
     /* 100697 */     // GIR_Coverage, 3427,
     /* 100697 */     GIR_EraseRootFromParent_Done,
     /* 100698 */   // Label 2130: @100698
     /* 100698 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(100768), // Rule ID 16801 //
     /* 100703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMMX),
     /* 100706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mmx_emms),
     /* 100711 */     // (intrinsic_void 14500:{ *:[iPTR] })  =>  (MMX_EMMS:{ *:[x86mmx] })
     /* 100711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MMX_EMMS),
     /* 100714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM0*/0,
     /* 100717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM1*/1,
     /* 100720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM2*/2,
     /* 100723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM3*/3,
     /* 100726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM4*/4,
     /* 100729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM5*/5,
     /* 100732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM6*/6,
     /* 100735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM7*/7,
     /* 100738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST0*/8,
     /* 100741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST1*/9,
     /* 100744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST2*/10,
     /* 100747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST3*/11,
     /* 100750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST4*/12,
     /* 100753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST5*/13,
     /* 100756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST6*/14,
     /* 100759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST7*/15,
     /* 100762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100766 */     GIR_RootConstrainSelectedInstOperands,
     /* 100767 */     // GIR_Coverage, 16801,
     /* 100767 */     GIR_EraseRootFromParent_Done,
     /* 100768 */   // Label 2131: @100768
     /* 100768 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(100790), // Rule ID 16984 //
     /* 100773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 100776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xend),
     /* 100781 */     // (intrinsic_void 14933:{ *:[iPTR] })  =>  (XEND)
     /* 100781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XEND),
     /* 100784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100788 */     GIR_RootConstrainSelectedInstOperands,
     /* 100789 */     // GIR_Coverage, 16984,
     /* 100789 */     GIR_EraseRootFromParent_Done,
     /* 100790 */   // Label 2132: @100790
     /* 100790 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(100836), // Rule ID 16996 //
     /* 100795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 100798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilerelease),
     /* 100803 */     // (intrinsic_void 14859:{ *:[iPTR] })  =>  (TILERELEASE:{ *:[x86amx] })
     /* 100803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TILERELEASE),
     /* 100806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 100809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 100812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 100815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 100818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 100821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 100824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 100827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 100830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100834 */     GIR_RootConstrainSelectedInstOperands,
     /* 100835 */     // GIR_Coverage, 16996,
     /* 100835 */     GIR_EraseRootFromParent_Done,
     /* 100836 */   // Label 2133: @100836
     /* 100836 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(100855), // Rule ID 17085 //
     /* 100841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbinvd),
     /* 100846 */     // (intrinsic_void 14920:{ *:[iPTR] })  =>  (WBINVD)
     /* 100846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBINVD),
     /* 100849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100853 */     GIR_RootConstrainSelectedInstOperands,
     /* 100854 */     // GIR_Coverage, 17085,
     /* 100854 */     GIR_EraseRootFromParent_Done,
     /* 100855 */   // Label 2134: @100855
     /* 100855 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(100877), // Rule ID 17086 //
     /* 100860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWBNOINVD),
     /* 100863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbnoinvd),
     /* 100868 */     // (intrinsic_void 14921:{ *:[iPTR] })  =>  (WBNOINVD)
     /* 100868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBNOINVD),
     /* 100871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100875 */     GIR_RootConstrainSelectedInstOperands,
     /* 100876 */     // GIR_Coverage, 17086,
     /* 100876 */     GIR_EraseRootFromParent_Done,
     /* 100877 */   // Label 2135: @100877
     /* 100877 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(100899), // Rule ID 17091 //
     /* 100882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_saveprevssp),
     /* 100887 */     // (intrinsic_void 14602:{ *:[iPTR] })  =>  (SAVEPREVSSP)
     /* 100887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAVEPREVSSP),
     /* 100890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 100893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100897 */     GIR_RootConstrainSelectedInstOperands,
     /* 100898 */     // GIR_Coverage, 17091,
     /* 100898 */     GIR_EraseRootFromParent_Done,
     /* 100899 */   // Label 2136: @100899
     /* 100899 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(100921), // Rule ID 17101 //
     /* 100904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_setssbsy),
     /* 100909 */     // (intrinsic_void 14608:{ *:[iPTR] })  =>  (SETSSBSY)
     /* 100909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SETSSBSY),
     /* 100912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 100915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100919 */     GIR_RootConstrainSelectedInstOperands,
     /* 100920 */     // GIR_Coverage, 17101,
     /* 100920 */     GIR_EraseRootFromParent_Done,
     /* 100921 */   // Label 2137: @100921
     /* 100921 */   GIM_Reject,
     /* 100922 */ // Label 2119: @100922
     /* 100922 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(102810),
     /* 100927 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 100930 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(100988), // Rule ID 17129 //
     /* 100935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 100938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 100943 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 100946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 100954 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 100961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 100965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100974 */     // (intrinsic_void 14582:{ *:[iPTR] }, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (PTWRITE64m addr:{ *:[iPTR] }:$dst)
     /* 100974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64m),
     /* 100977 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 100981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 100986 */     GIR_RootConstrainSelectedInstOperands,
     /* 100987 */     // GIR_Coverage, 17129,
     /* 100987 */     GIR_EraseRootFromParent_Done,
     /* 100988 */   // Label 2139: @100988
     /* 100988 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(101046), // Rule ID 17128 //
     /* 100993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 100996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 101001 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 101012 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101015 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 101019 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 101023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101032 */     // (intrinsic_void 14581:{ *:[iPTR] }, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (PTWRITEm addr:{ *:[iPTR] }:$dst)
     /* 101032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEm),
     /* 101035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 101044 */     GIR_RootConstrainSelectedInstOperands,
     /* 101045 */     // GIR_Coverage, 17128,
     /* 101045 */     GIR_EraseRootFromParent_Done,
     /* 101046 */   // Label 2140: @101046
     /* 101046 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(101083), // Rule ID 162 //
     /* 101051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLFLUSHOPT),
     /* 101054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clflushopt),
     /* 101059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101070 */     // (intrinsic_void 14463:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLFLUSHOPT addr:{ *:[iPTR] }:$src)
     /* 101070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLFLUSHOPT),
     /* 101073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101081 */     GIR_RootConstrainSelectedInstOperands,
     /* 101082 */     // GIR_Coverage, 162,
     /* 101082 */     GIR_EraseRootFromParent_Done,
     /* 101083 */   // Label 2141: @101083
     /* 101083 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(101120), // Rule ID 163 //
     /* 101088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLWB),
     /* 101091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clwb),
     /* 101096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101107 */     // (intrinsic_void 14466:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLWB addr:{ *:[iPTR] }:$src)
     /* 101107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLWB),
     /* 101110 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101118 */     GIR_RootConstrainSelectedInstOperands,
     /* 101119 */     // GIR_Coverage, 163,
     /* 101119 */     GIR_EraseRootFromParent_Done,
     /* 101120 */   // Label 2142: @101120
     /* 101120 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(101157), // Rule ID 164 //
     /* 101125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLDEMOTE),
     /* 101128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_cldemote),
     /* 101133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101144 */     // (intrinsic_void 14462:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLDEMOTE addr:{ *:[iPTR] }:$src)
     /* 101144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLDEMOTE),
     /* 101147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101155 */     GIR_RootConstrainSelectedInstOperands,
     /* 101156 */     // GIR_Coverage, 164,
     /* 101156 */     GIR_EraseRootFromParent_Done,
     /* 101157 */   // Label 2143: @101157
     /* 101157 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(101194), // Rule ID 169 //
     /* 101162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS),
     /* 101165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_prefetchrs),
     /* 101170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101181 */     // (intrinsic_void 14580:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (PREFETCHRST2 addr:{ *:[iPTR] }:$src)
     /* 101181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHRST2),
     /* 101184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101192 */     GIR_RootConstrainSelectedInstOperands,
     /* 101193 */     // GIR_Coverage, 169,
     /* 101193 */     GIR_EraseRootFromParent_Done,
     /* 101194 */   // Label 2144: @101194
     /* 101194 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(101231), // Rule ID 1132 //
     /* 101199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR),
     /* 101202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxsave),
     /* 101207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101218 */     // (intrinsic_void 14486:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (FXSAVE addr:{ *:[iPTR] }:$dst)
     /* 101218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXSAVE),
     /* 101221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101229 */     GIR_RootConstrainSelectedInstOperands,
     /* 101230 */     // GIR_Coverage, 1132,
     /* 101230 */     GIR_EraseRootFromParent_Done,
     /* 101231 */   // Label 2145: @101231
     /* 101231 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(101268), // Rule ID 1133 //
     /* 101236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR_In64BitMode),
     /* 101239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxsave64),
     /* 101244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101255 */     // (intrinsic_void 14487:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (FXSAVE64 addr:{ *:[iPTR] }:$dst)
     /* 101255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXSAVE64),
     /* 101258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101266 */     GIR_RootConstrainSelectedInstOperands,
     /* 101267 */     // GIR_Coverage, 1133,
     /* 101267 */     GIR_EraseRootFromParent_Done,
     /* 101268 */   // Label 2146: @101268
     /* 101268 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(101311), // Rule ID 1134 //
     /* 101273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR),
     /* 101276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxrstor),
     /* 101281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101292 */     // (intrinsic_void 14484:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (FXRSTOR:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 101292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXRSTOR),
     /* 101295 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 101302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPCW*/1,
     /* 101305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101309 */     GIR_RootConstrainSelectedInstOperands,
     /* 101310 */     // GIR_Coverage, 1134,
     /* 101310 */     GIR_EraseRootFromParent_Done,
     /* 101311 */   // Label 2147: @101311
     /* 101311 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(101354), // Rule ID 1135 //
     /* 101316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR_In64BitMode),
     /* 101319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxrstor64),
     /* 101324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101335 */     // (intrinsic_void 14485:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (FXRSTOR64:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 101335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXRSTOR64),
     /* 101338 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 101345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPCW*/1,
     /* 101348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101352 */     GIR_RootConstrainSelectedInstOperands,
     /* 101353 */     // GIR_Coverage, 1135,
     /* 101353 */     GIR_EraseRootFromParent_Done,
     /* 101354 */   // Label 2148: @101354
     /* 101354 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(101391), // Rule ID 2508 //
     /* 101359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLFLUSH),
     /* 101362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_clflush),
     /* 101367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101378 */     // (intrinsic_void 14654:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLFLUSH addr:{ *:[iPTR] }:$src)
     /* 101378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLFLUSH),
     /* 101381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101389 */     GIR_RootConstrainSelectedInstOperands,
     /* 101390 */     // GIR_Coverage, 2508,
     /* 101390 */     GIR_EraseRootFromParent_Done,
     /* 101391 */   // Label 2149: @101391
     /* 101391 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(101431), // Rule ID 2513 //
     /* 101396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 101399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_ldmxcsr),
     /* 101404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101415 */     // (intrinsic_void 14635:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDMXCSR addr:{ *:[iPTR] }:$src)
     /* 101415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDMXCSR),
     /* 101418 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MXCSR*/0,
     /* 101425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101429 */     GIR_RootConstrainSelectedInstOperands,
     /* 101430 */     // GIR_Coverage, 2513,
     /* 101430 */     GIR_EraseRootFromParent_Done,
     /* 101431 */   // Label 2150: @101431
     /* 101431 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(101468), // Rule ID 2514 //
     /* 101436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 101439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_stmxcsr),
     /* 101444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101455 */     // (intrinsic_void 14647:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (VSTMXCSR addr:{ *:[iPTR] }:$dst)
     /* 101455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSTMXCSR),
     /* 101458 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101466 */     GIR_RootConstrainSelectedInstOperands,
     /* 101467 */     // GIR_Coverage, 2514,
     /* 101467 */     GIR_EraseRootFromParent_Done,
     /* 101468 */   // Label 2151: @101468
     /* 101468 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(101505), // Rule ID 2515 //
     /* 101473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_ldmxcsr),
     /* 101478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101489 */     // (intrinsic_void 14635:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDMXCSR addr:{ *:[iPTR] }:$src)
     /* 101489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDMXCSR),
     /* 101492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MXCSR*/0,
     /* 101499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101503 */     GIR_RootConstrainSelectedInstOperands,
     /* 101504 */     // GIR_Coverage, 2515,
     /* 101504 */     GIR_EraseRootFromParent_Done,
     /* 101505 */   // Label 2152: @101505
     /* 101505 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(101539), // Rule ID 2516 //
     /* 101510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_stmxcsr),
     /* 101515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101526 */     // (intrinsic_void 14647:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (STMXCSR addr:{ *:[iPTR] }:$dst)
     /* 101526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STMXCSR),
     /* 101529 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101537 */     GIR_RootConstrainSelectedInstOperands,
     /* 101538 */     // GIR_Coverage, 2516,
     /* 101538 */     GIR_EraseRootFromParent_Done,
     /* 101539 */   // Label 2153: @101539
     /* 101539 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(101600), // Rule ID 16992 //
     /* 101544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode_NoEGPR),
     /* 101547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ldtilecfg),
     /* 101552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101563 */     // (intrinsic_void 14492:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDTILECFG:{ *:[x86amx] } addr:{ *:[iPTR] }:$src)
     /* 101563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDTILECFG),
     /* 101566 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101598 */     GIR_RootConstrainSelectedInstOperands,
     /* 101599 */     // GIR_Coverage, 16992,
     /* 101599 */     GIR_EraseRootFromParent_Done,
     /* 101600 */   // Label 2154: @101600
     /* 101600 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(101637), // Rule ID 16993 //
     /* 101605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode_NoEGPR),
     /* 101608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sttilecfg),
     /* 101613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101624 */     // (intrinsic_void 14788:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (STTILECFG addr:{ *:[iPTR] }:$src)
     /* 101624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STTILECFG),
     /* 101627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101635 */     GIR_RootConstrainSelectedInstOperands,
     /* 101636 */     // GIR_Coverage, 16993,
     /* 101636 */     GIR_EraseRootFromParent_Done,
     /* 101637 */   // Label 2155: @101637
     /* 101637 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(101698), // Rule ID 16994 //
     /* 101642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_HasEGPR_In64BitMode),
     /* 101645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ldtilecfg),
     /* 101650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101661 */     // (intrinsic_void 14492:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDTILECFG_EVEX:{ *:[x86amx] } addr:{ *:[iPTR] }:$src)
     /* 101661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDTILECFG_EVEX),
     /* 101664 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101696 */     GIR_RootConstrainSelectedInstOperands,
     /* 101697 */     // GIR_Coverage, 16994,
     /* 101697 */     GIR_EraseRootFromParent_Done,
     /* 101698 */   // Label 2156: @101698
     /* 101698 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(101735), // Rule ID 16995 //
     /* 101703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_HasEGPR_In64BitMode),
     /* 101706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sttilecfg),
     /* 101711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101722 */     // (intrinsic_void 14788:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (STTILECFG_EVEX addr:{ *:[iPTR] }:$src)
     /* 101722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STTILECFG_EVEX),
     /* 101725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101733 */     GIR_RootConstrainSelectedInstOperands,
     /* 101734 */     // GIR_Coverage, 16995,
     /* 101734 */     GIR_EraseRootFromParent_Done,
     /* 101735 */   // Label 2157: @101735
     /* 101735 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(101772), // Rule ID 17092 //
     /* 101740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_rstorssp),
     /* 101745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101756 */     // (intrinsic_void 14601:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (RSTORSSP addr:{ *:[iPTR] }:$src)
     /* 101756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSTORSSP),
     /* 101759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101770 */     GIR_RootConstrainSelectedInstOperands,
     /* 101771 */     // GIR_Coverage, 17092,
     /* 101771 */     GIR_EraseRootFromParent_Done,
     /* 101772 */   // Label 2158: @101772
     /* 101772 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(101809), // Rule ID 17102 //
     /* 101777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clrssbsy),
     /* 101782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101793 */     // (intrinsic_void 14464:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLRSSBSY addr:{ *:[iPTR] }:$src)
     /* 101793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLRSSBSY),
     /* 101796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101807 */     GIR_RootConstrainSelectedInstOperands,
     /* 101808 */     // GIR_Coverage, 17102,
     /* 101808 */     GIR_EraseRootFromParent_Done,
     /* 101809 */   // Label 2159: @101809
     /* 101809 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(101839), // Rule ID 17074 //
     /* 101814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 101819 */     // MIs[0] Operand 1
     /* 101819 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(3),
     /* 101830 */     // (intrinsic_void 14490:{ *:[iPTR] }, 3:{ *:[i8] })  =>  (INT3)
     /* 101830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 101833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101837 */     GIR_RootConstrainSelectedInstOperands,
     /* 101838 */     // GIR_Coverage, 17074,
     /* 101838 */     GIR_EraseRootFromParent_Done,
     /* 101839 */   // Label 2160: @101839
     /* 101839 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(101866), // Rule ID 16986 //
     /* 101844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 101847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xabort),
     /* 101852 */     // MIs[0] imm
     /* 101852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 101855 */     // (intrinsic_void 14931:{ *:[iPTR] }, (timm:{ *:[i8] }):$imm)  =>  (XABORT (timm:{ *:[i8] }):$imm)
     /* 101855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XABORT),
     /* 101858 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 101860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101864 */     GIR_RootConstrainSelectedInstOperands,
     /* 101865 */     // GIR_Coverage, 16986,
     /* 101865 */     GIR_EraseRootFromParent_Done,
     /* 101866 */   // Label 2161: @101866
     /* 101866 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(101893), // Rule ID 16998 //
     /* 101871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 101874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilezero),
     /* 101879 */     // MIs[0] src
     /* 101879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 101882 */     // (intrinsic_void 14862:{ *:[iPTR] }, (timm:{ *:[i8] }):$src)  =>  (PTILEZERO (timm:{ *:[i8] }):$src)
     /* 101882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEZERO),
     /* 101885 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 101887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101891 */     GIR_RootConstrainSelectedInstOperands,
     /* 101892 */     // GIR_Coverage, 16998,
     /* 101892 */     GIR_EraseRootFromParent_Done,
     /* 101893 */   // Label 2162: @101893
     /* 101893 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(101917), // Rule ID 17076 //
     /* 101898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 101903 */     // MIs[0] trap
     /* 101903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 101906 */     // (intrinsic_void 14490:{ *:[iPTR] }, (timm:{ *:[i8] }):$trap)  =>  (INT (timm:{ *:[i8] }):$trap)
     /* 101906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 101909 */     GIR_RootToRootCopy, /*OpIdx*/1, // trap
     /* 101911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101915 */     GIR_RootConstrainSelectedInstOperands,
     /* 101916 */     // GIR_Coverage, 17076,
     /* 101916 */     GIR_EraseRootFromParent_Done,
     /* 101917 */   // Label 2163: @101917
     /* 101917 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(101951), // Rule ID 1 //
     /* 101922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 101925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u32),
     /* 101930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 101937 */     // (intrinsic_w_chain:{ *:[i32] } 14476:{ *:[iPTR] })  =>  (RDFLAGS32:{ *:[i32] }:{ *:[i32] })
     /* 101937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS32),
     /* 101940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 101945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101949 */     GIR_RootConstrainSelectedInstOperands,
     /* 101950 */     // GIR_Coverage, 1,
     /* 101950 */     GIR_EraseRootFromParent_Done,
     /* 101951 */   // Label 2164: @101951
     /* 101951 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(101985), // Rule ID 2 //
     /* 101956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 101959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u64),
     /* 101964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 101967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 101971 */     // (intrinsic_w_chain:{ *:[i64] } 14477:{ *:[iPTR] })  =>  (RDFLAGS64:{ *:[i64] }:{ *:[i32] })
     /* 101971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS64),
     /* 101974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 101979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101983 */     GIR_RootConstrainSelectedInstOperands,
     /* 101984 */     // GIR_Coverage, 2,
     /* 101984 */     GIR_EraseRootFromParent_Done,
     /* 101985 */   // Label 2165: @101985
     /* 101985 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(102016), // Rule ID 115 //
     /* 101990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 101993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 101998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102005 */     // (intrinsic_w_chain:{ *:[i32] } 14616:{ *:[iPTR] })  =>  (SLWPCB:{ *:[i32] })
     /* 102005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB),
     /* 102008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102014 */     GIR_RootConstrainSelectedInstOperands,
     /* 102015 */     // GIR_Coverage, 115,
     /* 102015 */     GIR_EraseRootFromParent_Done,
     /* 102016 */   // Label 2166: @102016
     /* 102016 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(102047), // Rule ID 117 //
     /* 102021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 102029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102036 */     // (intrinsic_w_chain:{ *:[i64] } 14616:{ *:[iPTR] })  =>  (SLWPCB64:{ *:[i64] })
     /* 102036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB64),
     /* 102039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102045 */     GIR_RootConstrainSelectedInstOperands,
     /* 102046 */     // GIR_Coverage, 117,
     /* 102046 */     GIR_EraseRootFromParent_Done,
     /* 102047 */   // Label 2167: @102047
     /* 102047 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(102078), // Rule ID 16983 //
     /* 102052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 102055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xbegin),
     /* 102060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102067 */     // (intrinsic_w_chain:{ *:[i32] } 14932:{ *:[iPTR] })  =>  (XBEGIN:{ *:[i32] })
     /* 102067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XBEGIN),
     /* 102070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102076 */     GIR_RootConstrainSelectedInstOperands,
     /* 102077 */     // GIR_Coverage, 16983,
     /* 102077 */     GIR_EraseRootFromParent_Done,
     /* 102078 */   // Label 2168: @102078
     /* 102078 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(102109), // Rule ID 17118 //
     /* 102083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_32),
     /* 102091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102098 */     // (intrinsic_w_chain:{ *:[i32] } 14583:{ *:[iPTR] })  =>  (RDFSBASE:{ *:[i32] })
     /* 102098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE),
     /* 102101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102107 */     GIR_RootConstrainSelectedInstOperands,
     /* 102108 */     // GIR_Coverage, 17118,
     /* 102108 */     GIR_EraseRootFromParent_Done,
     /* 102109 */   // Label 2169: @102109
     /* 102109 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(102140), // Rule ID 17119 //
     /* 102114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_64),
     /* 102122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102129 */     // (intrinsic_w_chain:{ *:[i64] } 14584:{ *:[iPTR] })  =>  (RDFSBASE64:{ *:[i64] })
     /* 102129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE64),
     /* 102132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102138 */     GIR_RootConstrainSelectedInstOperands,
     /* 102139 */     // GIR_Coverage, 17119,
     /* 102139 */     GIR_EraseRootFromParent_Done,
     /* 102140 */   // Label 2170: @102140
     /* 102140 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(102171), // Rule ID 17120 //
     /* 102145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_32),
     /* 102153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102160 */     // (intrinsic_w_chain:{ *:[i32] } 14585:{ *:[iPTR] })  =>  (RDGSBASE:{ *:[i32] })
     /* 102160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE),
     /* 102163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102169 */     GIR_RootConstrainSelectedInstOperands,
     /* 102170 */     // GIR_Coverage, 17120,
     /* 102170 */     GIR_EraseRootFromParent_Done,
     /* 102171 */   // Label 2171: @102171
     /* 102171 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(102202), // Rule ID 17121 //
     /* 102176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_64),
     /* 102184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102191 */     // (intrinsic_w_chain:{ *:[i64] } 14586:{ *:[iPTR] })  =>  (RDGSBASE64:{ *:[i64] })
     /* 102191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE64),
     /* 102194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102200 */     GIR_RootConstrainSelectedInstOperands,
     /* 102201 */     // GIR_Coverage, 17121,
     /* 102201 */     GIR_EraseRootFromParent_Done,
     /* 102202 */   // Label 2172: @102202
     /* 102202 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(102233), // Rule ID 17127 //
     /* 102207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_Not64BitMode),
     /* 102210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 102215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102222 */     // (intrinsic_w_chain:{ *:[i32] } 14587:{ *:[iPTR] })  =>  (RDPID32:{ *:[i32] })
     /* 102222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDPID32),
     /* 102225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102231 */     GIR_RootConstrainSelectedInstOperands,
     /* 102232 */     // GIR_Coverage, 17127,
     /* 102232 */     GIR_EraseRootFromParent_Done,
     /* 102233 */   // Label 2173: @102233
     /* 102233 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(102290), // Rule ID 22380 //
     /* 102238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_In64BitMode),
     /* 102241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 102246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102253 */     // (intrinsic_w_chain:{ *:[i32] } 14587:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (RDPID64:{ *:[i64] }), sub_32bit:{ *:[i32] })
     /* 102253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 102256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::RDPID64),
     /* 102260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102272 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_32bit),
     /* 102279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 102284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 102289 */     // GIR_Coverage, 22380,
     /* 102289 */     GIR_EraseRootFromParent_Done,
     /* 102290 */   // Label 2174: @102290
     /* 102290 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(102330), // Rule ID 3 //
     /* 102295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 102298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u32),
     /* 102303 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102310 */     // (intrinsic_void 14478:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFLAGS32:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 102310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS32),
     /* 102313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 102318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 102321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 102324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102328 */     GIR_RootConstrainSelectedInstOperands,
     /* 102329 */     // GIR_Coverage, 3,
     /* 102329 */     GIR_EraseRootFromParent_Done,
     /* 102330 */   // Label 2175: @102330
     /* 102330 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(102370), // Rule ID 4 //
     /* 102335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 102338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u64),
     /* 102343 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102350 */     // (intrinsic_void 14479:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFLAGS64:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 102350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS64),
     /* 102353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::RSP*/0,
     /* 102358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 102361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 102364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102368 */     GIR_RootConstrainSelectedInstOperands,
     /* 102369 */     // GIR_Coverage, 4,
     /* 102369 */     GIR_EraseRootFromParent_Done,
     /* 102370 */   // Label 2176: @102370
     /* 102370 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(102401), // Rule ID 154 //
     /* 102375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 102378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_senduipi),
     /* 102383 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102390 */     // (intrinsic_void 14606:{ *:[iPTR] }, GR64:{ *:[i64] }:$arg)  =>  (SENDUIPI GR64:{ *:[i64] }:$arg)
     /* 102390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SENDUIPI),
     /* 102393 */     GIR_RootToRootCopy, /*OpIdx*/1, // arg
     /* 102395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102399 */     GIR_RootConstrainSelectedInstOperands,
     /* 102400 */     // GIR_Coverage, 154,
     /* 102400 */     GIR_EraseRootFromParent_Done,
     /* 102401 */   // Label 2177: @102401
     /* 102401 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(102432), // Rule ID 17087 //
     /* 102406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspd),
     /* 102411 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102418 */     // (intrinsic_void 14488:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (INCSSPD GR32:{ *:[i32] }:$src)
     /* 102418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPD),
     /* 102421 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102430 */     GIR_RootConstrainSelectedInstOperands,
     /* 102431 */     // GIR_Coverage, 17087,
     /* 102431 */     GIR_EraseRootFromParent_Done,
     /* 102432 */   // Label 2178: @102432
     /* 102432 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(102463), // Rule ID 17088 //
     /* 102437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspq),
     /* 102442 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102449 */     // (intrinsic_void 14489:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (INCSSPQ GR64:{ *:[i64] }:$src)
     /* 102449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPQ),
     /* 102452 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102461 */     GIR_RootConstrainSelectedInstOperands,
     /* 102462 */     // GIR_Coverage, 17088,
     /* 102462 */     GIR_EraseRootFromParent_Done,
     /* 102463 */   // Label 2179: @102463
     /* 102463 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(102494), // Rule ID 17122 //
     /* 102468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_32),
     /* 102476 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102483 */     // (intrinsic_void 14922:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFSBASE GR32:{ *:[i32] }:$src)
     /* 102483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE),
     /* 102486 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102492 */     GIR_RootConstrainSelectedInstOperands,
     /* 102493 */     // GIR_Coverage, 17122,
     /* 102493 */     GIR_EraseRootFromParent_Done,
     /* 102494 */   // Label 2180: @102494
     /* 102494 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(102525), // Rule ID 17123 //
     /* 102499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_64),
     /* 102507 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102514 */     // (intrinsic_void 14923:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFSBASE64 GR64:{ *:[i64] }:$src)
     /* 102514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE64),
     /* 102517 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102523 */     GIR_RootConstrainSelectedInstOperands,
     /* 102524 */     // GIR_Coverage, 17123,
     /* 102524 */     GIR_EraseRootFromParent_Done,
     /* 102525 */   // Label 2181: @102525
     /* 102525 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(102556), // Rule ID 17124 //
     /* 102530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_32),
     /* 102538 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102545 */     // (intrinsic_void 14924:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRGSBASE GR32:{ *:[i32] }:$src)
     /* 102545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE),
     /* 102548 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102554 */     GIR_RootConstrainSelectedInstOperands,
     /* 102555 */     // GIR_Coverage, 17124,
     /* 102555 */     GIR_EraseRootFromParent_Done,
     /* 102556 */   // Label 2182: @102556
     /* 102556 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(102587), // Rule ID 17125 //
     /* 102561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_64),
     /* 102569 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102576 */     // (intrinsic_void 14925:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRGSBASE64 GR64:{ *:[i64] }:$src)
     /* 102576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE64),
     /* 102579 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102585 */     GIR_RootConstrainSelectedInstOperands,
     /* 102586 */     // GIR_Coverage, 17125,
     /* 102586 */     GIR_EraseRootFromParent_Done,
     /* 102587 */   // Label 2183: @102587
     /* 102587 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(102618), // Rule ID 17130 //
     /* 102592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 102595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 102600 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102607 */     // (intrinsic_void 14581:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst)  =>  (PTWRITEr GR32:{ *:[i32] }:$dst)
     /* 102607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEr),
     /* 102610 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 102612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102616 */     GIR_RootConstrainSelectedInstOperands,
     /* 102617 */     // GIR_Coverage, 17130,
     /* 102617 */     GIR_EraseRootFromParent_Done,
     /* 102618 */   // Label 2184: @102618
     /* 102618 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(102649), // Rule ID 17131 //
     /* 102623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 102626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 102631 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102638 */     // (intrinsic_void 14582:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst)  =>  (PTWRITE64r GR64:{ *:[i64] }:$dst)
     /* 102638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64r),
     /* 102641 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 102643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102647 */     GIR_RootConstrainSelectedInstOperands,
     /* 102648 */     // GIR_Coverage, 17131,
     /* 102648 */     GIR_EraseRootFromParent_Done,
     /* 102649 */   // Label 2185: @102649
     /* 102649 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(102681), // Rule ID 114 //
     /* 102654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 102662 */     // MIs[0] src
     /* 102662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 102666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102670 */     // (intrinsic_void 14494:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (LLWPCB GR32:{ *:[i32] }:$src)
     /* 102670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB),
     /* 102673 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102679 */     GIR_RootConstrainSelectedInstOperands,
     /* 102680 */     // GIR_Coverage, 114,
     /* 102680 */     GIR_EraseRootFromParent_Done,
     /* 102681 */   // Label 2186: @102681
     /* 102681 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(102713), // Rule ID 116 //
     /* 102686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 102694 */     // MIs[0] src
     /* 102694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102702 */     // (intrinsic_void 14494:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (LLWPCB64 GR64:{ *:[i64] }:$src)
     /* 102702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB64),
     /* 102705 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102711 */     GIR_RootConstrainSelectedInstOperands,
     /* 102712 */     // GIR_Coverage, 116,
     /* 102712 */     GIR_EraseRootFromParent_Done,
     /* 102713 */   // Label 2187: @102713
     /* 102713 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(102745), // Rule ID 126 //
     /* 102718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_Not64BitMode),
     /* 102721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102726 */     // MIs[0] src
     /* 102726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/16,
     /* 102730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 102734 */     // (intrinsic_void 14879:{ *:[iPTR] }, GR16:{ *:[i16] }:$src)  =>  (UMONITOR16 GR16:{ *:[i16] }:$src)
     /* 102734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR16),
     /* 102737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102743 */     GIR_RootConstrainSelectedInstOperands,
     /* 102744 */     // GIR_Coverage, 126,
     /* 102744 */     GIR_EraseRootFromParent_Done,
     /* 102745 */   // Label 2188: @102745
     /* 102745 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(102777), // Rule ID 127 //
     /* 102750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG),
     /* 102753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102758 */     // MIs[0] src
     /* 102758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 102762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102766 */     // (intrinsic_void 14879:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (UMONITOR32 GR32:{ *:[i32] }:$src)
     /* 102766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR32),
     /* 102769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102775 */     GIR_RootConstrainSelectedInstOperands,
     /* 102776 */     // GIR_Coverage, 127,
     /* 102776 */     GIR_EraseRootFromParent_Done,
     /* 102777 */   // Label 2189: @102777
     /* 102777 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(102809), // Rule ID 128 //
     /* 102782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_In64BitMode),
     /* 102785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102790 */     // MIs[0] src
     /* 102790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102798 */     // (intrinsic_void 14879:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (UMONITOR64 GR64:{ *:[i64] }:$src)
     /* 102798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR64),
     /* 102801 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102807 */     GIR_RootConstrainSelectedInstOperands,
     /* 102808 */     // GIR_Coverage, 128,
     /* 102808 */     GIR_EraseRootFromParent_Done,
     /* 102809 */   // Label 2190: @102809
     /* 102809 */   GIM_Reject,
     /* 102810 */ // Label 2138: @102810
     /* 102810 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(105804),
     /* 102815 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 102818 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(102864), // Rule ID 165 //
     /* 102823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 102826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsqi),
     /* 102831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 102834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 102838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102849 */     // (intrinsic_w_chain:{ *:[i8] } 14574:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /* 102849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS8rm),
     /* 102852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102862 */     GIR_RootConstrainSelectedInstOperands,
     /* 102863 */     // GIR_Coverage, 165,
     /* 102863 */     GIR_EraseRootFromParent_Done,
     /* 102864 */   // Label 2192: @102864
     /* 102864 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(102910), // Rule ID 166 //
     /* 102869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 102872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrshi),
     /* 102877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 102880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 102884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102895 */     // (intrinsic_w_chain:{ *:[i16] } 14573:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 102895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS16rm),
     /* 102898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102900 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102908 */     GIR_RootConstrainSelectedInstOperands,
     /* 102909 */     // GIR_Coverage, 166,
     /* 102909 */     GIR_EraseRootFromParent_Done,
     /* 102910 */   // Label 2193: @102910
     /* 102910 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(102956), // Rule ID 167 //
     /* 102915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 102918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrssi),
     /* 102923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102941 */     // (intrinsic_w_chain:{ *:[i32] } 14575:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 102941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS32rm),
     /* 102944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102946 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102954 */     GIR_RootConstrainSelectedInstOperands,
     /* 102955 */     // GIR_Coverage, 167,
     /* 102955 */     GIR_EraseRootFromParent_Done,
     /* 102956 */   // Label 2194: @102956
     /* 102956 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(103002), // Rule ID 168 //
     /* 102961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 102964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsdi),
     /* 102969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102987 */     // (intrinsic_w_chain:{ *:[i64] } 14572:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 102987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS64rm),
     /* 102990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103000 */     GIR_RootConstrainSelectedInstOperands,
     /* 103001 */     // GIR_Coverage, 168,
     /* 103001 */     GIR_EraseRootFromParent_Done,
     /* 103002 */   // Label 2195: @103002
     /* 103002 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(103048), // Rule ID 170 //
     /* 103007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsqi),
     /* 103015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 103018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 103022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103033 */     // (intrinsic_w_chain:{ *:[i8] } 14574:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS8rm_EVEX:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /* 103033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS8rm_EVEX),
     /* 103036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103038 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103046 */     GIR_RootConstrainSelectedInstOperands,
     /* 103047 */     // GIR_Coverage, 170,
     /* 103047 */     GIR_EraseRootFromParent_Done,
     /* 103048 */   // Label 2196: @103048
     /* 103048 */   GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(103094), // Rule ID 171 //
     /* 103053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrshi),
     /* 103061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 103064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 103068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103079 */     // (intrinsic_w_chain:{ *:[i16] } 14573:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS16rm_EVEX:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 103079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS16rm_EVEX),
     /* 103082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103092 */     GIR_RootConstrainSelectedInstOperands,
     /* 103093 */     // GIR_Coverage, 171,
     /* 103093 */     GIR_EraseRootFromParent_Done,
     /* 103094 */   // Label 2197: @103094
     /* 103094 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(103140), // Rule ID 172 //
     /* 103099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrssi),
     /* 103107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 103110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 103114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103125 */     // (intrinsic_w_chain:{ *:[i32] } 14575:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 103125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS32rm_EVEX),
     /* 103128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103138 */     GIR_RootConstrainSelectedInstOperands,
     /* 103139 */     // GIR_Coverage, 172,
     /* 103139 */     GIR_EraseRootFromParent_Done,
     /* 103140 */   // Label 2198: @103140
     /* 103140 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(103186), // Rule ID 173 //
     /* 103145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsdi),
     /* 103153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 103156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 103160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103171 */     // (intrinsic_w_chain:{ *:[i64] } 14572:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 103171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS64rm_EVEX),
     /* 103174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103184 */     GIR_RootConstrainSelectedInstOperands,
     /* 103185 */     // GIR_Coverage, 173,
     /* 103185 */     GIR_EraseRootFromParent_Done,
     /* 103186 */   // Label 2199: @103186
     /* 103186 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(103232), // Rule ID 2950 //
     /* 103191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 103194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse3_ldu_dq),
     /* 103199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103217 */     // (intrinsic_w_chain:{ *:[v16i8] } 14720:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDDQUrm),
     /* 103220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103230 */     GIR_RootConstrainSelectedInstOperands,
     /* 103231 */     // GIR_Coverage, 2950,
     /* 103231 */     GIR_EraseRootFromParent_Done,
     /* 103232 */   // Label 2200: @103232
     /* 103232 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(103278), // Rule ID 2951 //
     /* 103237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 103240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_ldu_dq_256),
     /* 103245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 103248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103263 */     // (intrinsic_w_chain:{ *:[v32i8] } 13341:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDDQUYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 103263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDDQUYrm),
     /* 103266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103268 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103276 */     GIR_RootConstrainSelectedInstOperands,
     /* 103277 */     // GIR_Coverage, 2951,
     /* 103277 */     GIR_EraseRootFromParent_Done,
     /* 103278 */   // Label 2201: @103278
     /* 103278 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(103324), // Rule ID 2952 //
     /* 103283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE3),
     /* 103286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse3_ldu_dq),
     /* 103291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103309 */     // (intrinsic_w_chain:{ *:[v16i8] } 14720:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDDQUrm),
     /* 103312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103314 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103322 */     GIR_RootConstrainSelectedInstOperands,
     /* 103323 */     // GIR_Coverage, 2952,
     /* 103323 */     GIR_EraseRootFromParent_Done,
     /* 103324 */   // Label 2202: @103324
     /* 103324 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(103370), // Rule ID 3542 //
     /* 103329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnebf162ps128),
     /* 103337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103355 */     // (intrinsic_w_chain:{ *:[v4f32] } 14883:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNEBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNEBF162PSrm),
     /* 103358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103368 */     GIR_RootConstrainSelectedInstOperands,
     /* 103369 */     // GIR_Coverage, 3542,
     /* 103369 */     GIR_EraseRootFromParent_Done,
     /* 103370 */   // Label 2203: @103370
     /* 103370 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(103416), // Rule ID 3543 //
     /* 103375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnebf162ps256),
     /* 103383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103401 */     // (intrinsic_w_chain:{ *:[v8f32] } 14884:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNEBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNEBF162PSYrm),
     /* 103404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103406 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103414 */     GIR_RootConstrainSelectedInstOperands,
     /* 103415 */     // GIR_Coverage, 3543,
     /* 103415 */     GIR_EraseRootFromParent_Done,
     /* 103416 */   // Label 2204: @103416
     /* 103416 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(103462), // Rule ID 3544 //
     /* 103421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnesh2ps128),
     /* 103429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103447 */     // (intrinsic_w_chain:{ *:[v4f32] } 14885:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNESH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNESH2PSrm),
     /* 103450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103452 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103460 */     GIR_RootConstrainSelectedInstOperands,
     /* 103461 */     // GIR_Coverage, 3544,
     /* 103461 */     GIR_EraseRootFromParent_Done,
     /* 103462 */   // Label 2205: @103462
     /* 103462 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(103508), // Rule ID 3545 //
     /* 103467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnesh2ps256),
     /* 103475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103493 */     // (intrinsic_w_chain:{ *:[v8f32] } 14886:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNESH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNESH2PSYrm),
     /* 103496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103506 */     GIR_RootConstrainSelectedInstOperands,
     /* 103507 */     // GIR_Coverage, 3545,
     /* 103507 */     GIR_EraseRootFromParent_Done,
     /* 103508 */   // Label 2206: @103508
     /* 103508 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(103554), // Rule ID 3546 //
     /* 103513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneebf162ps128),
     /* 103521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103539 */     // (intrinsic_w_chain:{ *:[v4f32] } 14887:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEBF162PSrm),
     /* 103542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103544 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103552 */     GIR_RootConstrainSelectedInstOperands,
     /* 103553 */     // GIR_Coverage, 3546,
     /* 103553 */     GIR_EraseRootFromParent_Done,
     /* 103554 */   // Label 2207: @103554
     /* 103554 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(103600), // Rule ID 3547 //
     /* 103559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneebf162ps256),
     /* 103567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103585 */     // (intrinsic_w_chain:{ *:[v8f32] } 14888:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEBF162PSYrm),
     /* 103588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103590 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103598 */     GIR_RootConstrainSelectedInstOperands,
     /* 103599 */     // GIR_Coverage, 3547,
     /* 103599 */     GIR_EraseRootFromParent_Done,
     /* 103600 */   // Label 2208: @103600
     /* 103600 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(103646), // Rule ID 3548 //
     /* 103605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneeph2ps128),
     /* 103613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103631 */     // (intrinsic_w_chain:{ *:[v4f32] } 14889:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEPH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEPH2PSrm),
     /* 103634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103636 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103644 */     GIR_RootConstrainSelectedInstOperands,
     /* 103645 */     // GIR_Coverage, 3548,
     /* 103645 */     GIR_EraseRootFromParent_Done,
     /* 103646 */   // Label 2209: @103646
     /* 103646 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(103692), // Rule ID 3549 //
     /* 103651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneeph2ps256),
     /* 103659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103677 */     // (intrinsic_w_chain:{ *:[v8f32] } 14890:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEPH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEPH2PSYrm),
     /* 103680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103682 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103690 */     GIR_RootConstrainSelectedInstOperands,
     /* 103691 */     // GIR_Coverage, 3549,
     /* 103691 */     GIR_EraseRootFromParent_Done,
     /* 103692 */   // Label 2210: @103692
     /* 103692 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(103738), // Rule ID 3550 //
     /* 103697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneobf162ps128),
     /* 103705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103723 */     // (intrinsic_w_chain:{ *:[v4f32] } 14891:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOBF162PSrm),
     /* 103726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103728 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103736 */     GIR_RootConstrainSelectedInstOperands,
     /* 103737 */     // GIR_Coverage, 3550,
     /* 103737 */     GIR_EraseRootFromParent_Done,
     /* 103738 */   // Label 2211: @103738
     /* 103738 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(103784), // Rule ID 3551 //
     /* 103743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneobf162ps256),
     /* 103751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103769 */     // (intrinsic_w_chain:{ *:[v8f32] } 14892:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOBF162PSYrm),
     /* 103772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103782 */     GIR_RootConstrainSelectedInstOperands,
     /* 103783 */     // GIR_Coverage, 3551,
     /* 103783 */     GIR_EraseRootFromParent_Done,
     /* 103784 */   // Label 2212: @103784
     /* 103784 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(103830), // Rule ID 3552 //
     /* 103789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneoph2ps128),
     /* 103797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103815 */     // (intrinsic_w_chain:{ *:[v4f32] } 14893:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOPH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOPH2PSrm),
     /* 103818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103820 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103828 */     GIR_RootConstrainSelectedInstOperands,
     /* 103829 */     // GIR_Coverage, 3552,
     /* 103829 */     GIR_EraseRootFromParent_Done,
     /* 103830 */   // Label 2213: @103830
     /* 103830 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(103876), // Rule ID 3553 //
     /* 103835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneoph2ps256),
     /* 103843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103861 */     // (intrinsic_w_chain:{ *:[v8f32] } 14894:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOPH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOPH2PSYrm),
     /* 103864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103874 */     GIR_RootConstrainSelectedInstOperands,
     /* 103875 */     // GIR_Coverage, 3553,
     /* 103875 */     GIR_EraseRootFromParent_Done,
     /* 103876 */   // Label 2214: @103876
     /* 103876 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(103922), // Rule ID 16752 //
     /* 103881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 103884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb512),
     /* 103889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v64s8,
     /* 103892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 103896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103907 */     // (intrinsic_w_chain:{ *:[v64i8] } 13597:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /* 103907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZm),
     /* 103910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103920 */     GIR_RootConstrainSelectedInstOperands,
     /* 103921 */     // GIR_Coverage, 16752,
     /* 103921 */     GIR_EraseRootFromParent_Done,
     /* 103922 */   // Label 2215: @103922
     /* 103922 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(103968), // Rule ID 16755 //
     /* 103927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 103930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb128),
     /* 103935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 103942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103953 */     // (intrinsic_w_chain:{ *:[v16i8] } 13595:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZ128m:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZ128m),
     /* 103956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103958 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103966 */     GIR_RootConstrainSelectedInstOperands,
     /* 103967 */     // GIR_Coverage, 16755,
     /* 103967 */     GIR_EraseRootFromParent_Done,
     /* 103968 */   // Label 2216: @103968
     /* 103968 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(104014), // Rule ID 16758 //
     /* 103973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 103976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb256),
     /* 103981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 103984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 103988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103999 */     // (intrinsic_w_chain:{ *:[v32i8] } 13596:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZ256m:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 103999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZ256m),
     /* 104002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104012 */     GIR_RootConstrainSelectedInstOperands,
     /* 104013 */     // GIR_Coverage, 16758,
     /* 104013 */     GIR_EraseRootFromParent_Done,
     /* 104014 */   // Label 2217: @104014
     /* 104014 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(104060), // Rule ID 16761 //
     /* 104019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw512),
     /* 104027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 104030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104045 */     // (intrinsic_w_chain:{ *:[v32i16] } 13606:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 104045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZm),
     /* 104048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104050 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104058 */     GIR_RootConstrainSelectedInstOperands,
     /* 104059 */     // GIR_Coverage, 16761,
     /* 104059 */     GIR_EraseRootFromParent_Done,
     /* 104060 */   // Label 2218: @104060
     /* 104060 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(104106), // Rule ID 16764 //
     /* 104065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw128),
     /* 104073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 104076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104091 */     // (intrinsic_w_chain:{ *:[v8i16] } 13604:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZ128m:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /* 104091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZ128m),
     /* 104094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104096 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104104 */     GIR_RootConstrainSelectedInstOperands,
     /* 104105 */     // GIR_Coverage, 16764,
     /* 104105 */     GIR_EraseRootFromParent_Done,
     /* 104106 */   // Label 2219: @104106
     /* 104106 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(104152), // Rule ID 16767 //
     /* 104111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw256),
     /* 104119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 104122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104137 */     // (intrinsic_w_chain:{ *:[v16i16] } 13605:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZ256m:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 104137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZ256m),
     /* 104140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104150 */     GIR_RootConstrainSelectedInstOperands,
     /* 104151 */     // GIR_Coverage, 16767,
     /* 104151 */     GIR_EraseRootFromParent_Done,
     /* 104152 */   // Label 2220: @104152
     /* 104152 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(104198), // Rule ID 16770 //
     /* 104157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd512),
     /* 104165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 104168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104183 */     // (intrinsic_w_chain:{ *:[v16i32] } 13600:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 104183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZm),
     /* 104186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104196 */     GIR_RootConstrainSelectedInstOperands,
     /* 104197 */     // GIR_Coverage, 16770,
     /* 104197 */     GIR_EraseRootFromParent_Done,
     /* 104198 */   // Label 2221: @104198
     /* 104198 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(104244), // Rule ID 16773 //
     /* 104203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd128),
     /* 104211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 104214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104229 */     // (intrinsic_w_chain:{ *:[v4i32] } 13598:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZ128m:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 104229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZ128m),
     /* 104232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104242 */     GIR_RootConstrainSelectedInstOperands,
     /* 104243 */     // GIR_Coverage, 16773,
     /* 104243 */     GIR_EraseRootFromParent_Done,
     /* 104244 */   // Label 2222: @104244
     /* 104244 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(104290), // Rule ID 16776 //
     /* 104249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd256),
     /* 104257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 104260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104275 */     // (intrinsic_w_chain:{ *:[v8i32] } 13599:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZ256m:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 104275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZ256m),
     /* 104278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104288 */     GIR_RootConstrainSelectedInstOperands,
     /* 104289 */     // GIR_Coverage, 16776,
     /* 104289 */     GIR_EraseRootFromParent_Done,
     /* 104290 */   // Label 2223: @104290
     /* 104290 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(104336), // Rule ID 16779 //
     /* 104295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq512),
     /* 104303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 104306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104321 */     // (intrinsic_w_chain:{ *:[v8i64] } 13603:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 104321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZm),
     /* 104324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104334 */     GIR_RootConstrainSelectedInstOperands,
     /* 104335 */     // GIR_Coverage, 16779,
     /* 104335 */     GIR_EraseRootFromParent_Done,
     /* 104336 */   // Label 2224: @104336
     /* 104336 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(104382), // Rule ID 16782 //
     /* 104341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq128),
     /* 104349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 104352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104367 */     // (intrinsic_w_chain:{ *:[v2i64] } 13601:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZ128m:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /* 104367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZ128m),
     /* 104370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104372 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104380 */     GIR_RootConstrainSelectedInstOperands,
     /* 104381 */     // GIR_Coverage, 16782,
     /* 104381 */     GIR_EraseRootFromParent_Done,
     /* 104382 */   // Label 2225: @104382
     /* 104382 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(104428), // Rule ID 16785 //
     /* 104387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq256),
     /* 104395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 104398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104413 */     // (intrinsic_w_chain:{ *:[v4i64] } 13602:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZ256m:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 104413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZ256m),
     /* 104416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104418 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104426 */     GIR_RootConstrainSelectedInstOperands,
     /* 104427 */     // GIR_Coverage, 16785,
     /* 104427 */     GIR_EraseRootFromParent_Done,
     /* 104428 */   // Label 2226: @104428
     /* 104428 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(104474), // Rule ID 17093 //
     /* 104433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssd),
     /* 104441 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104459 */     // (intrinsic_void 14927:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSD addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSD),
     /* 104462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104466 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104472 */     GIR_RootConstrainSelectedInstOperands,
     /* 104473 */     // GIR_Coverage, 17093,
     /* 104473 */     GIR_EraseRootFromParent_Done,
     /* 104474 */   // Label 2227: @104474
     /* 104474 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(104520), // Rule ID 17094 //
     /* 104479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssq),
     /* 104487 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104505 */     // (intrinsic_void 14928:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSQ addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSQ),
     /* 104508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104512 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104518 */     GIR_RootConstrainSelectedInstOperands,
     /* 104519 */     // GIR_Coverage, 17094,
     /* 104519 */     GIR_EraseRootFromParent_Done,
     /* 104520 */   // Label 2228: @104520
     /* 104520 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(104566), // Rule ID 17095 //
     /* 104525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussd),
     /* 104533 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104551 */     // (intrinsic_void 14929:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSD addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSD),
     /* 104554 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104558 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104564 */     GIR_RootConstrainSelectedInstOperands,
     /* 104565 */     // GIR_Coverage, 17095,
     /* 104565 */     GIR_EraseRootFromParent_Done,
     /* 104566 */   // Label 2229: @104566
     /* 104566 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(104612), // Rule ID 17096 //
     /* 104571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussq),
     /* 104579 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104597 */     // (intrinsic_void 14930:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSQ addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSQ),
     /* 104600 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104604 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104610 */     GIR_RootConstrainSelectedInstOperands,
     /* 104611 */     // GIR_Coverage, 17096,
     /* 104611 */     GIR_EraseRootFromParent_Done,
     /* 104612 */   // Label 2230: @104612
     /* 104612 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(104658), // Rule ID 17097 //
     /* 104617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssd),
     /* 104625 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104643 */     // (intrinsic_void 14927:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSD_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSD_EVEX),
     /* 104646 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104650 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104656 */     GIR_RootConstrainSelectedInstOperands,
     /* 104657 */     // GIR_Coverage, 17097,
     /* 104657 */     GIR_EraseRootFromParent_Done,
     /* 104658 */   // Label 2231: @104658
     /* 104658 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(104704), // Rule ID 17098 //
     /* 104663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssq),
     /* 104671 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104689 */     // (intrinsic_void 14928:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSQ_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSQ_EVEX),
     /* 104692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104696 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104702 */     GIR_RootConstrainSelectedInstOperands,
     /* 104703 */     // GIR_Coverage, 17098,
     /* 104703 */     GIR_EraseRootFromParent_Done,
     /* 104704 */   // Label 2232: @104704
     /* 104704 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(104750), // Rule ID 17099 //
     /* 104709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussd),
     /* 104717 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104735 */     // (intrinsic_void 14929:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSD_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSD_EVEX),
     /* 104738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104742 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104748 */     GIR_RootConstrainSelectedInstOperands,
     /* 104749 */     // GIR_Coverage, 17099,
     /* 104749 */     GIR_EraseRootFromParent_Done,
     /* 104750 */   // Label 2233: @104750
     /* 104750 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(104796), // Rule ID 17100 //
     /* 104755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussq),
     /* 104763 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104781 */     // (intrinsic_void 14930:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSQ_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSQ_EVEX),
     /* 104784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104788 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104794 */     GIR_RootConstrainSelectedInstOperands,
     /* 104795 */     // GIR_Coverage, 17100,
     /* 104795 */     GIR_EraseRootFromParent_Done,
     /* 104796 */   // Label 2234: @104796
     /* 104796 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(104842), // Rule ID 17126 //
     /* 104801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasINVPCID_Not64BitMode),
     /* 104804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 104809 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104827 */     // (intrinsic_void 14491:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID32 GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 104827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID32),
     /* 104830 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 104832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 104836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104840 */     GIR_RootConstrainSelectedInstOperands,
     /* 104841 */     // GIR_Coverage, 17126,
     /* 104841 */     GIR_EraseRootFromParent_Done,
     /* 104842 */   // Label 2235: @104842
     /* 104842 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(104934), // Rule ID 22378 //
     /* 104847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasINVPCID_NoEGPR),
     /* 104850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 104855 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104873 */     // (intrinsic_void 14491:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID64 (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1), sub_32bit:{ *:[i32] }), addr:{ *:[iPTR] }:$src2)
     /* 104873 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104876 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 104880 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104885 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 104889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104903 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104906 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104909 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/6,
     /* 104912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 104917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 104922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID64),
     /* 104925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 104932 */     GIR_RootConstrainSelectedInstOperands,
     /* 104933 */     // GIR_Coverage, 22378,
     /* 104933 */     GIR_EraseRootFromParent_Done,
     /* 104934 */   // Label 2236: @104934
     /* 104934 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(105026), // Rule ID 22379 //
     /* 104939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasINVPCID),
     /* 104942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 104947 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104965 */     // (intrinsic_void 14491:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID64_EVEX (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1), sub_32bit:{ *:[i32] }), addr:{ *:[iPTR] }:$src2)
     /* 104965 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104968 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 104972 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104977 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 104981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104995 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104998 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105001 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/6,
     /* 105004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 105009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 105014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID64_EVEX),
     /* 105017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105020 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105024 */     GIR_RootConstrainSelectedInstOperands,
     /* 105025 */     // GIR_Coverage, 22379,
     /* 105025 */     GIR_EraseRootFromParent_Done,
     /* 105026 */   // Label 2237: @105026
     /* 105026 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(105072), // Rule ID 131 //
     /* 105031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIRI_NoEGPR),
     /* 105034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore32),
     /* 105039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105057 */     // (intrinsic_void 14470:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)  =>  (MOVDIRI32 addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 105057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI32),
     /* 105060 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105064 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105070 */     GIR_RootConstrainSelectedInstOperands,
     /* 105071 */     // GIR_Coverage, 131,
     /* 105071 */     GIR_EraseRootFromParent_Done,
     /* 105072 */   // Label 2238: @105072
     /* 105072 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(105118), // Rule ID 132 //
     /* 105077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIRI_In64BitMode_NoEGPR),
     /* 105080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore64),
     /* 105085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105103 */     // (intrinsic_void 14471:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)  =>  (MOVDIRI64 addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 105103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI64),
     /* 105106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105110 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105116 */     GIR_RootConstrainSelectedInstOperands,
     /* 105117 */     // GIR_Coverage, 132,
     /* 105117 */     GIR_EraseRootFromParent_Done,
     /* 105118 */   // Label 2239: @105118
     /* 105118 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(105164), // Rule ID 133 //
     /* 105123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIRI_In64BitMode),
     /* 105126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore32),
     /* 105131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105149 */     // (intrinsic_void 14470:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)  =>  (MOVDIRI32_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 105149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI32_EVEX),
     /* 105152 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105162 */     GIR_RootConstrainSelectedInstOperands,
     /* 105163 */     // GIR_Coverage, 133,
     /* 105163 */     GIR_EraseRootFromParent_Done,
     /* 105164 */   // Label 2240: @105164
     /* 105164 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(105210), // Rule ID 134 //
     /* 105169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIRI_In64BitMode),
     /* 105172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore64),
     /* 105177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105195 */     // (intrinsic_void 14471:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)  =>  (MOVDIRI64_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 105195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI64_EVEX),
     /* 105198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105202 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105208 */     GIR_RootConstrainSelectedInstOperands,
     /* 105209 */     // GIR_Coverage, 134,
     /* 105209 */     GIR_EraseRootFromParent_Done,
     /* 105210 */   // Label 2241: @105210
     /* 105210 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(105257), // Rule ID 135 //
     /* 105215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIR64B_NoEGPR),
     /* 105218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105223 */     // MIs[0] dst
     /* 105223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 105227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105242 */     // (intrinsic_void 14571:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B32 GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B32),
     /* 105245 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105247 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105255 */     GIR_RootConstrainSelectedInstOperands,
     /* 105256 */     // GIR_Coverage, 135,
     /* 105256 */     GIR_EraseRootFromParent_Done,
     /* 105257 */   // Label 2242: @105257
     /* 105257 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(105304), // Rule ID 136 //
     /* 105262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIR64B_In64BitMode_NoEGPR),
     /* 105265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105270 */     // MIs[0] dst
     /* 105270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105289 */     // (intrinsic_void 14571:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B64 GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B64),
     /* 105292 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105294 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105302 */     GIR_RootConstrainSelectedInstOperands,
     /* 105303 */     // GIR_Coverage, 136,
     /* 105303 */     GIR_EraseRootFromParent_Done,
     /* 105304 */   // Label 2243: @105304
     /* 105304 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(105351), // Rule ID 137 //
     /* 105309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode),
     /* 105312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105317 */     // MIs[0] dst
     /* 105317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 105321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105336 */     // (intrinsic_void 14571:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B32_EVEX GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B32_EVEX),
     /* 105339 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105349 */     GIR_RootConstrainSelectedInstOperands,
     /* 105350 */     // GIR_Coverage, 137,
     /* 105350 */     GIR_EraseRootFromParent_Done,
     /* 105351 */   // Label 2244: @105351
     /* 105351 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(105398), // Rule ID 138 //
     /* 105356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode),
     /* 105359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105364 */     // MIs[0] dst
     /* 105364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105383 */     // (intrinsic_void 14571:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B64_EVEX GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B64_EVEX),
     /* 105386 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105388 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105396 */     GIR_RootConstrainSelectedInstOperands,
     /* 105397 */     // GIR_Coverage, 138,
     /* 105397 */     GIR_EraseRootFromParent_Done,
     /* 105398 */   // Label 2245: @105398
     /* 105398 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(105430), // Rule ID 17024 //
     /* 105403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTRANSPOSE_In64BitMode),
     /* 105406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttransposed),
     /* 105411 */     // MIs[0] dst
     /* 105411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 105414 */     // MIs[0] src
     /* 105414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105417 */     // (intrinsic_void 14877:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTTRANSPOSED (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 105417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTRANSPOSED),
     /* 105420 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105422 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105428 */     GIR_RootConstrainSelectedInstOperands,
     /* 105429 */     // GIR_Coverage, 17024,
     /* 105429 */     GIR_EraseRootFromParent_Done,
     /* 105430 */   // Label 2246: @105430
     /* 105430 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(105462), // Rule ID 17036 //
     /* 105435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 105438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtfp16),
     /* 105443 */     // MIs[0] dst
     /* 105443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 105446 */     // MIs[0] src
     /* 105446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105449 */     // (intrinsic_void 14816:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTCONJTFP16 (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 105449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTFP16),
     /* 105452 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105454 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105460 */     GIR_RootConstrainSelectedInstOperands,
     /* 105461 */     // GIR_Coverage, 17036,
     /* 105461 */     GIR_EraseRootFromParent_Done,
     /* 105462 */   // Label 2247: @105462
     /* 105462 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(105505), // Rule ID 17151 //
     /* 105467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::asan_check_memaccess),
     /* 105472 */     // MIs[0] addr
     /* 105472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64PLTSafeRegClassID),
     /* 105480 */     // MIs[0] accessinfo
     /* 105480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105483 */     // (intrinsic_void 9:{ *:[iPTR] }, GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)  =>  (ASAN_CHECK_MEMACCESS:{ *:[i64] } GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)
     /* 105483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ASAN_CHECK_MEMACCESS),
     /* 105486 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 105488 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 105490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R10*/0,
     /* 105493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R11*/1,
     /* 105496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/2,
     /* 105499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105503 */     GIR_RootConstrainSelectedInstOperands,
     /* 105504 */     // GIR_Coverage, 17151,
     /* 105504 */     GIR_EraseRootFromParent_Done,
     /* 105505 */   // Label 2248: @105505
     /* 105505 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(105545), // Rule ID 17077 //
     /* 105510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 105513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 105518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105532 */     // (intrinsic_w_chain:{ *:[i64] } 14881:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr),
     /* 105535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105543 */     GIR_RootConstrainSelectedInstOperands,
     /* 105544 */     // GIR_Coverage, 17077,
     /* 105544 */     GIR_EraseRootFromParent_Done,
     /* 105545 */   // Label 2249: @105545
     /* 105545 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(105585), // Rule ID 17081 //
     /* 105550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 105553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 105558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105572 */     // (intrinsic_w_chain:{ *:[i64] } 14881:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr_EVEX),
     /* 105575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105577 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105583 */     GIR_RootConstrainSelectedInstOperands,
     /* 105584 */     // GIR_Coverage, 17081,
     /* 105584 */     GIR_EraseRootFromParent_Done,
     /* 105585 */   // Label 2250: @105585
     /* 105585 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(105622), // Rule ID 17089 //
     /* 105590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspd),
     /* 105595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 105598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105609 */     // (intrinsic_w_chain:{ *:[i32] } 14597:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (RDSSPD:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 105609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPD),
     /* 105612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105614 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105620 */     GIR_RootConstrainSelectedInstOperands,
     /* 105621 */     // GIR_Coverage, 17089,
     /* 105621 */     GIR_EraseRootFromParent_Done,
     /* 105622 */   // Label 2251: @105622
     /* 105622 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(105659), // Rule ID 17090 //
     /* 105627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspq),
     /* 105632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105646 */     // (intrinsic_w_chain:{ *:[i64] } 14598:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (RDSSPQ:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPQ),
     /* 105649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105651 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105657 */     GIR_RootConstrainSelectedInstOperands,
     /* 105658 */     // GIR_Coverage, 17090,
     /* 105658 */     GIR_EraseRootFromParent_Done,
     /* 105659 */   // Label 2252: @105659
     /* 105659 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(105723), // Rule ID 3085 //
     /* 105664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 105667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse3_mwait),
     /* 105672 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 105682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 105686 */     // (intrinsic_void 14722:{ *:[iPTR] }, ECX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (MWAITrr)
     /* 105686 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105690 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105696 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EAX
     /* 105700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105704 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105710 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 105714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITrr),
     /* 105717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105721 */     GIR_RootConstrainSelectedInstOperands,
     /* 105722 */     // GIR_Coverage, 3085,
     /* 105722 */     GIR_EraseRootFromParent_Done,
     /* 105723 */   // Label 2253: @105723
     /* 105723 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(105763), // Rule ID 17079 //
     /* 105728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 105731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 105736 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105750 */     // (intrinsic_void 14882:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 105750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr),
     /* 105753 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105755 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 105757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105761 */     GIR_RootConstrainSelectedInstOperands,
     /* 105762 */     // GIR_Coverage, 17079,
     /* 105762 */     GIR_EraseRootFromParent_Done,
     /* 105763 */   // Label 2254: @105763
     /* 105763 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(105803), // Rule ID 17083 //
     /* 105768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 105771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 105776 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105790 */     // (intrinsic_void 14882:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr_EVEX GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 105790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr_EVEX),
     /* 105793 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 105797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105801 */     GIR_RootConstrainSelectedInstOperands,
     /* 105802 */     // GIR_Coverage, 17083,
     /* 105802 */     GIR_EraseRootFromParent_Done,
     /* 105803 */   // Label 2255: @105803
     /* 105803 */   GIM_Reject,
     /* 105804 */ // Label 2191: @105804
     /* 105804 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(109349),
     /* 105809 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 105812 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(105884), // Rule ID 123 //
     /* 105817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 105820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 105825 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105843 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105846 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105850 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 105854 */     // MIs[0] cntl
     /* 105854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 105857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105866 */     // (intrinsic_void 14498:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rmi GR32:{ *:[i32] }:$src0, addr:{ *:[iPTR] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 105866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rmi),
     /* 105869 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 105871 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 105875 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 105877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105882 */     GIR_RootConstrainSelectedInstOperands,
     /* 105883 */     // GIR_Coverage, 123,
     /* 105883 */     GIR_EraseRootFromParent_Done,
     /* 105884 */   // Label 2257: @105884
     /* 105884 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(105956), // Rule ID 125 //
     /* 105889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 105892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 105897 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105915 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105918 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105922 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 105926 */     // MIs[0] cntl
     /* 105926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 105929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105938 */     // (intrinsic_void 14499:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rmi GR64:{ *:[i64] }:$src0, addr:{ *:[iPTR] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 105938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rmi),
     /* 105941 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 105943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 105947 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 105949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105954 */     GIR_RootConstrainSelectedInstOperands,
     /* 105955 */     // GIR_Coverage, 125,
     /* 105955 */     GIR_EraseRootFromParent_Done,
     /* 105956 */   // Label 2258: @105956
     /* 105956 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(106011), // Rule ID 3386 //
     /* 105961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 105964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_ps),
     /* 105969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 105972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 105975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105994 */     // (intrinsic_w_chain:{ *:[v4f32] } 13344:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src1)  =>  (VMASKMOVPSrm:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 105994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSrm),
     /* 105997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105999 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106001 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106009 */     GIR_RootConstrainSelectedInstOperands,
     /* 106010 */     // GIR_Coverage, 3386,
     /* 106010 */     GIR_EraseRootFromParent_Done,
     /* 106011 */   // Label 2259: @106011
     /* 106011 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(106066), // Rule ID 3387 //
     /* 106016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_ps_256),
     /* 106024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 106027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106049 */     // (intrinsic_w_chain:{ *:[v8f32] } 13345:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8i32] }:$src1)  =>  (VMASKMOVPSYrm:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSYrm),
     /* 106052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106054 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106064 */     GIR_RootConstrainSelectedInstOperands,
     /* 106065 */     // GIR_Coverage, 3387,
     /* 106065 */     GIR_EraseRootFromParent_Done,
     /* 106066 */   // Label 2260: @106066
     /* 106066 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(106121), // Rule ID 3390 //
     /* 106071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_pd),
     /* 106079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 106082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106104 */     // (intrinsic_w_chain:{ *:[v2f64] } 13342:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src1)  =>  (VMASKMOVPDrm:{ *:[v2f64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDrm),
     /* 106107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106109 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106111 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106119 */     GIR_RootConstrainSelectedInstOperands,
     /* 106120 */     // GIR_Coverage, 3390,
     /* 106120 */     GIR_EraseRootFromParent_Done,
     /* 106121 */   // Label 2261: @106121
     /* 106121 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(106176), // Rule ID 3391 //
     /* 106126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_pd_256),
     /* 106134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 106137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106159 */     // (intrinsic_w_chain:{ *:[v4f64] } 13343:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4i64] }:$src1)  =>  (VMASKMOVPDYrm:{ *:[v4f64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDYrm),
     /* 106162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106164 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106174 */     GIR_RootConstrainSelectedInstOperands,
     /* 106175 */     // GIR_Coverage, 3391,
     /* 106175 */     GIR_EraseRootFromParent_Done,
     /* 106176 */   // Label 2262: @106176
     /* 106176 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(106231), // Rule ID 3464 //
     /* 106181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_d),
     /* 106189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 106192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106214 */     // (intrinsic_w_chain:{ *:[v4i32] } 13642:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src1)  =>  (VPMASKMOVDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDrm),
     /* 106217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106219 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106229 */     GIR_RootConstrainSelectedInstOperands,
     /* 106230 */     // GIR_Coverage, 3464,
     /* 106230 */     GIR_EraseRootFromParent_Done,
     /* 106231 */   // Label 2263: @106231
     /* 106231 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(106286), // Rule ID 3465 //
     /* 106236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_d_256),
     /* 106244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 106247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106269 */     // (intrinsic_w_chain:{ *:[v8i32] } 13643:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8i32] }:$src1)  =>  (VPMASKMOVDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDYrm),
     /* 106272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106274 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106284 */     GIR_RootConstrainSelectedInstOperands,
     /* 106285 */     // GIR_Coverage, 3465,
     /* 106285 */     GIR_EraseRootFromParent_Done,
     /* 106286 */   // Label 2264: @106286
     /* 106286 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(106341), // Rule ID 3468 //
     /* 106291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_q),
     /* 106299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 106302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106324 */     // (intrinsic_w_chain:{ *:[v2i64] } 13644:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src1)  =>  (VPMASKMOVQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQrm),
     /* 106327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106329 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106339 */     GIR_RootConstrainSelectedInstOperands,
     /* 106340 */     // GIR_Coverage, 3468,
     /* 106340 */     GIR_EraseRootFromParent_Done,
     /* 106341 */   // Label 2265: @106341
     /* 106341 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(106396), // Rule ID 3469 //
     /* 106346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_q_256),
     /* 106354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 106357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106379 */     // (intrinsic_w_chain:{ *:[v4i64] } 13645:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4i64] }:$src1)  =>  (VPMASKMOVQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQYrm),
     /* 106382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106384 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106386 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106394 */     GIR_RootConstrainSelectedInstOperands,
     /* 106395 */     // GIR_Coverage, 3469,
     /* 106395 */     GIR_EraseRootFromParent_Done,
     /* 106396 */   // Label 2266: @106396
     /* 106396 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(106451), // Rule ID 3388 //
     /* 106401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_ps),
     /* 106409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 106412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106434 */     // (intrinsic_void 13348:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMASKMOVPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 106434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSmr),
     /* 106437 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106441 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106443 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106449 */     GIR_RootConstrainSelectedInstOperands,
     /* 106450 */     // GIR_Coverage, 3388,
     /* 106450 */     GIR_EraseRootFromParent_Done,
     /* 106451 */   // Label 2267: @106451
     /* 106451 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(106506), // Rule ID 3389 //
     /* 106456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_ps_256),
     /* 106464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 106467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106489 */     // (intrinsic_void 13349:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMASKMOVPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 106489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSYmr),
     /* 106492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106496 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106498 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106504 */     GIR_RootConstrainSelectedInstOperands,
     /* 106505 */     // GIR_Coverage, 3389,
     /* 106505 */     GIR_EraseRootFromParent_Done,
     /* 106506 */   // Label 2268: @106506
     /* 106506 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(106561), // Rule ID 3392 //
     /* 106511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_pd),
     /* 106519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 106522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106544 */     // (intrinsic_void 13346:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMASKMOVPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 106544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDmr),
     /* 106547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106553 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106559 */     GIR_RootConstrainSelectedInstOperands,
     /* 106560 */     // GIR_Coverage, 3392,
     /* 106560 */     GIR_EraseRootFromParent_Done,
     /* 106561 */   // Label 2269: @106561
     /* 106561 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(106616), // Rule ID 3393 //
     /* 106566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_pd_256),
     /* 106574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 106577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106599 */     // (intrinsic_void 13347:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMASKMOVPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 106599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDYmr),
     /* 106602 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106606 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106608 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106614 */     GIR_RootConstrainSelectedInstOperands,
     /* 106615 */     // GIR_Coverage, 3393,
     /* 106615 */     GIR_EraseRootFromParent_Done,
     /* 106616 */   // Label 2270: @106616
     /* 106616 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(106671), // Rule ID 3466 //
     /* 106621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_d),
     /* 106629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 106632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106654 */     // (intrinsic_void 13646:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMASKMOVDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 106654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDmr),
     /* 106657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106661 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106663 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106669 */     GIR_RootConstrainSelectedInstOperands,
     /* 106670 */     // GIR_Coverage, 3466,
     /* 106670 */     GIR_EraseRootFromParent_Done,
     /* 106671 */   // Label 2271: @106671
     /* 106671 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(106726), // Rule ID 3467 //
     /* 106676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_d_256),
     /* 106684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 106687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106709 */     // (intrinsic_void 13647:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMASKMOVDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 106709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDYmr),
     /* 106712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106716 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106718 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106724 */     GIR_RootConstrainSelectedInstOperands,
     /* 106725 */     // GIR_Coverage, 3467,
     /* 106725 */     GIR_EraseRootFromParent_Done,
     /* 106726 */   // Label 2272: @106726
     /* 106726 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(106781), // Rule ID 3470 //
     /* 106731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_q),
     /* 106739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 106742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106764 */     // (intrinsic_void 13648:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPMASKMOVQmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 106764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQmr),
     /* 106767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106771 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106773 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106779 */     GIR_RootConstrainSelectedInstOperands,
     /* 106780 */     // GIR_Coverage, 3470,
     /* 106780 */     GIR_EraseRootFromParent_Done,
     /* 106781 */   // Label 2273: @106781
     /* 106781 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(106836), // Rule ID 3471 //
     /* 106786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_q_256),
     /* 106794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 106797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106819 */     // (intrinsic_void 13649:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPMASKMOVQYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 106819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQYmr),
     /* 106822 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106826 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106828 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106834 */     GIR_RootConstrainSelectedInstOperands,
     /* 106835 */     // GIR_Coverage, 3471,
     /* 106835 */     GIR_EraseRootFromParent_Done,
     /* 106836 */   // Label 2274: @106836
     /* 106836 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(106915), // Rule ID 17104 //
     /* 106841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE),
     /* 106844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsave),
     /* 106849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106874 */     // (intrinsic_void 14986:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVE addr:{ *:[iPTR] }:$dst)
     /* 106874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106878 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106884 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 106888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106892 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 106902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVE),
     /* 106905 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106913 */     GIR_RootConstrainSelectedInstOperands,
     /* 106914 */     // GIR_Coverage, 17104,
     /* 106914 */     GIR_EraseRootFromParent_Done,
     /* 106915 */   // Label 2275: @106915
     /* 106915 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(106994), // Rule ID 17105 //
     /* 106920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 106923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsave64),
     /* 106928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106953 */     // (intrinsic_void 14987:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVE64 addr:{ *:[iPTR] }:$dst)
     /* 106953 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106957 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 106967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106971 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 106981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVE64),
     /* 106984 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106992 */     GIR_RootConstrainSelectedInstOperands,
     /* 106993 */     // GIR_Coverage, 17105,
     /* 106993 */     GIR_EraseRootFromParent_Done,
     /* 106994 */   // Label 2276: @106994
     /* 106994 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(107073), // Rule ID 17106 //
     /* 106999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE),
     /* 107002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstor),
     /* 107007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107032 */     // (intrinsic_void 14982:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTOR addr:{ *:[iPTR] }:$dst)
     /* 107032 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107036 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107042 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107050 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTOR),
     /* 107063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107071 */     GIR_RootConstrainSelectedInstOperands,
     /* 107072 */     // GIR_Coverage, 17106,
     /* 107072 */     GIR_EraseRootFromParent_Done,
     /* 107073 */   // Label 2277: @107073
     /* 107073 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(107152), // Rule ID 17107 //
     /* 107078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstor64),
     /* 107086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107111 */     // (intrinsic_void 14983:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTOR64 addr:{ *:[iPTR] }:$dst)
     /* 107111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107115 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107121 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107129 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTOR64),
     /* 107142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107150 */     GIR_RootConstrainSelectedInstOperands,
     /* 107151 */     // GIR_Coverage, 17107,
     /* 107151 */     GIR_EraseRootFromParent_Done,
     /* 107152 */   // Label 2278: @107152
     /* 107152 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(107231), // Rule ID 17108 //
     /* 107157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEOPT),
     /* 107160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaveopt),
     /* 107165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107190 */     // (intrinsic_void 14990:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEOPT addr:{ *:[iPTR] }:$dst)
     /* 107190 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107194 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107200 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107208 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEOPT),
     /* 107221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107229 */     GIR_RootConstrainSelectedInstOperands,
     /* 107230 */     // GIR_Coverage, 17108,
     /* 107230 */     GIR_EraseRootFromParent_Done,
     /* 107231 */   // Label 2279: @107231
     /* 107231 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(107310), // Rule ID 17109 //
     /* 107236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEOPT_In64BitMode),
     /* 107239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaveopt64),
     /* 107244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107269 */     // (intrinsic_void 14991:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEOPT64 addr:{ *:[iPTR] }:$dst)
     /* 107269 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107273 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107287 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107293 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEOPT64),
     /* 107300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107308 */     GIR_RootConstrainSelectedInstOperands,
     /* 107309 */     // GIR_Coverage, 17109,
     /* 107309 */     GIR_EraseRootFromParent_Done,
     /* 107310 */   // Label 2280: @107310
     /* 107310 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(107389), // Rule ID 17110 //
     /* 107315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEC),
     /* 107318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsavec),
     /* 107323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107348 */     // (intrinsic_void 14988:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEC addr:{ *:[iPTR] }:$dst)
     /* 107348 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107352 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107358 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107366 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEC),
     /* 107379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107387 */     GIR_RootConstrainSelectedInstOperands,
     /* 107388 */     // GIR_Coverage, 17110,
     /* 107388 */     GIR_EraseRootFromParent_Done,
     /* 107389 */   // Label 2281: @107389
     /* 107389 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(107468), // Rule ID 17111 //
     /* 107394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEC_In64BitMode),
     /* 107397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsavec64),
     /* 107402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107427 */     // (intrinsic_void 14989:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEC64 addr:{ *:[iPTR] }:$dst)
     /* 107427 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107431 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107437 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107445 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107451 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEC64),
     /* 107458 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107466 */     GIR_RootConstrainSelectedInstOperands,
     /* 107467 */     // GIR_Coverage, 17111,
     /* 107467 */     GIR_EraseRootFromParent_Done,
     /* 107468 */   // Label 2282: @107468
     /* 107468 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(107547), // Rule ID 17112 //
     /* 107473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES),
     /* 107476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaves),
     /* 107481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107506 */     // (intrinsic_void 14992:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVES addr:{ *:[iPTR] }:$dst)
     /* 107506 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107510 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107516 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107524 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVES),
     /* 107537 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107545 */     GIR_RootConstrainSelectedInstOperands,
     /* 107546 */     // GIR_Coverage, 17112,
     /* 107546 */     GIR_EraseRootFromParent_Done,
     /* 107547 */   // Label 2283: @107547
     /* 107547 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(107626), // Rule ID 17113 //
     /* 107552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaves64),
     /* 107560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107585 */     // (intrinsic_void 14993:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVES64 addr:{ *:[iPTR] }:$dst)
     /* 107585 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107589 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107595 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107603 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107609 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVES64),
     /* 107616 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107624 */     GIR_RootConstrainSelectedInstOperands,
     /* 107625 */     // GIR_Coverage, 17113,
     /* 107625 */     GIR_EraseRootFromParent_Done,
     /* 107626 */   // Label 2284: @107626
     /* 107626 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(107705), // Rule ID 17114 //
     /* 107631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES),
     /* 107634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstors),
     /* 107639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107664 */     // (intrinsic_void 14984:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTORS addr:{ *:[iPTR] }:$dst)
     /* 107664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107668 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107674 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107682 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTORS),
     /* 107695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107703 */     GIR_RootConstrainSelectedInstOperands,
     /* 107704 */     // GIR_Coverage, 17114,
     /* 107704 */     GIR_EraseRootFromParent_Done,
     /* 107705 */   // Label 2285: @107705
     /* 107705 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(107784), // Rule ID 17115 //
     /* 107710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES_In64BitMode),
     /* 107713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstors64),
     /* 107718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107743 */     // (intrinsic_void 14985:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTORS64 addr:{ *:[iPTR] }:$dst)
     /* 107743 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107747 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107753 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107761 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107767 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTORS64),
     /* 107774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107782 */     GIR_RootConstrainSelectedInstOperands,
     /* 107783 */     // GIR_Coverage, 17115,
     /* 107783 */     GIR_EraseRootFromParent_Done,
     /* 107784 */   // Label 2286: @107784
     /* 107784 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(107821), // Rule ID 17003 //
     /* 107789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 107792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbssd),
     /* 107797 */     // MIs[0] src1
     /* 107797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107800 */     // MIs[0] src2
     /* 107800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107803 */     // MIs[0] src3
     /* 107803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107806 */     // (intrinsic_void 14834:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSSD),
     /* 107809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107811 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107813 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107819 */     GIR_RootConstrainSelectedInstOperands,
     /* 107820 */     // GIR_Coverage, 17003,
     /* 107820 */     GIR_EraseRootFromParent_Done,
     /* 107821 */   // Label 2287: @107821
     /* 107821 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(107858), // Rule ID 17004 //
     /* 107826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 107829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbsud),
     /* 107834 */     // MIs[0] src1
     /* 107834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107837 */     // MIs[0] src2
     /* 107837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107840 */     // MIs[0] src3
     /* 107840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107843 */     // (intrinsic_void 14836:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSUD),
     /* 107846 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107848 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107850 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107856 */     GIR_RootConstrainSelectedInstOperands,
     /* 107857 */     // GIR_Coverage, 17004,
     /* 107857 */     GIR_EraseRootFromParent_Done,
     /* 107858 */   // Label 2288: @107858
     /* 107858 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(107895), // Rule ID 17005 //
     /* 107863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 107866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbusd),
     /* 107871 */     // MIs[0] src1
     /* 107871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107874 */     // MIs[0] src2
     /* 107874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107877 */     // MIs[0] src3
     /* 107877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107880 */     // (intrinsic_void 14838:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUSD),
     /* 107883 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107885 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107887 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107893 */     GIR_RootConstrainSelectedInstOperands,
     /* 107894 */     // GIR_Coverage, 17005,
     /* 107894 */     GIR_EraseRootFromParent_Done,
     /* 107895 */   // Label 2289: @107895
     /* 107895 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(107932), // Rule ID 17006 //
     /* 107900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 107903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbuud),
     /* 107908 */     // MIs[0] src1
     /* 107908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107911 */     // MIs[0] src2
     /* 107911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107914 */     // MIs[0] src3
     /* 107914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107917 */     // (intrinsic_void 14840:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUUD),
     /* 107920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107922 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107924 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107930 */     GIR_RootConstrainSelectedInstOperands,
     /* 107931 */     // GIR_Coverage, 17006,
     /* 107931 */     GIR_EraseRootFromParent_Done,
     /* 107932 */   // Label 2290: @107932
     /* 107932 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(107969), // Rule ID 17008 //
     /* 107937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_In64BitMode),
     /* 107940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf16ps),
     /* 107945 */     // MIs[0] src1
     /* 107945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107948 */     // MIs[0] src2
     /* 107948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107951 */     // MIs[0] src3
     /* 107951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107954 */     // (intrinsic_void 14828:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF16PS),
     /* 107957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107961 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107967 */     GIR_RootConstrainSelectedInstOperands,
     /* 107968 */     // GIR_Coverage, 17008,
     /* 107968 */     GIR_EraseRootFromParent_Done,
     /* 107969 */   // Label 2291: @107969
     /* 107969 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(108006), // Rule ID 17010 //
     /* 107974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_In64BitMode),
     /* 107977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpfp16ps),
     /* 107982 */     // MIs[0] src1
     /* 107982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107985 */     // MIs[0] src2
     /* 107985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107988 */     // MIs[0] src3
     /* 107988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107991 */     // (intrinsic_void 14842:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPFP16PS),
     /* 107994 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107996 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107998 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108004 */     GIR_RootConstrainSelectedInstOperands,
     /* 108005 */     // GIR_Coverage, 17010,
     /* 108005 */     GIR_EraseRootFromParent_Done,
     /* 108006 */   // Label 2292: @108006
     /* 108006 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(108043), // Rule ID 17013 //
     /* 108011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 108014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmimfp16ps),
     /* 108019 */     // MIs[0] src1
     /* 108019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108022 */     // MIs[0] src2
     /* 108022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108025 */     // MIs[0] src3
     /* 108025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108028 */     // (intrinsic_void 14810:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMIMFP16PS),
     /* 108031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108033 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108035 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108041 */     GIR_RootConstrainSelectedInstOperands,
     /* 108042 */     // GIR_Coverage, 17013,
     /* 108042 */     GIR_EraseRootFromParent_Done,
     /* 108043 */   // Label 2293: @108043
     /* 108043 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(108080), // Rule ID 17014 //
     /* 108048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 108051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmrlfp16ps),
     /* 108056 */     // MIs[0] src1
     /* 108056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108059 */     // MIs[0] src2
     /* 108059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108062 */     // MIs[0] src3
     /* 108062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108065 */     // (intrinsic_void 14812:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMRLFP16PS),
     /* 108068 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108070 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108072 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108078 */     GIR_RootConstrainSelectedInstOperands,
     /* 108079 */     // GIR_Coverage, 17014,
     /* 108079 */     GIR_EraseRootFromParent_Done,
     /* 108080 */   // Label 2294: @108080
     /* 108080 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(108117), // Rule ID 17015 //
     /* 108085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf8ps),
     /* 108093 */     // MIs[0] src1
     /* 108093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108096 */     // MIs[0] src2
     /* 108096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108099 */     // MIs[0] src3
     /* 108099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108102 */     // (intrinsic_void 14830:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF8PS),
     /* 108105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108107 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108109 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108115 */     GIR_RootConstrainSelectedInstOperands,
     /* 108116 */     // GIR_Coverage, 17015,
     /* 108116 */     GIR_EraseRootFromParent_Done,
     /* 108117 */   // Label 2295: @108117
     /* 108117 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(108154), // Rule ID 17016 //
     /* 108122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbhf8ps),
     /* 108130 */     // MIs[0] src1
     /* 108130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108133 */     // MIs[0] src2
     /* 108133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108136 */     // MIs[0] src3
     /* 108136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108139 */     // (intrinsic_void 14832:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBHF8PS),
     /* 108142 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108144 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108146 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108152 */     GIR_RootConstrainSelectedInstOperands,
     /* 108153 */     // GIR_Coverage, 17016,
     /* 108153 */     GIR_EraseRootFromParent_Done,
     /* 108154 */   // Label 2296: @108154
     /* 108154 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(108191), // Rule ID 17017 //
     /* 108159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphbf8ps),
     /* 108167 */     // MIs[0] src1
     /* 108167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108170 */     // MIs[0] src2
     /* 108170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108173 */     // MIs[0] src3
     /* 108173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108176 */     // (intrinsic_void 14844:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHBF8PS),
     /* 108179 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108183 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108189 */     GIR_RootConstrainSelectedInstOperands,
     /* 108190 */     // GIR_Coverage, 17017,
     /* 108190 */     GIR_EraseRootFromParent_Done,
     /* 108191 */   // Label 2297: @108191
     /* 108191 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(108228), // Rule ID 17018 //
     /* 108196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphf8ps),
     /* 108204 */     // MIs[0] src1
     /* 108204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108207 */     // MIs[0] src2
     /* 108207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108210 */     // MIs[0] src3
     /* 108210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108213 */     // (intrinsic_void 14846:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHF8PS),
     /* 108216 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108220 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108226 */     GIR_RootConstrainSelectedInstOperands,
     /* 108227 */     // GIR_Coverage, 17018,
     /* 108227 */     GIR_EraseRootFromParent_Done,
     /* 108228 */   // Label 2298: @108228
     /* 108228 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(108265), // Rule ID 17026 //
     /* 108233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode),
     /* 108236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpbf16ps),
     /* 108241 */     // MIs[0] src1
     /* 108241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108244 */     // MIs[0] src2
     /* 108244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108247 */     // MIs[0] src3
     /* 108247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108250 */     // (intrinsic_void 14871:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPBF16PS),
     /* 108253 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108255 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108257 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108263 */     GIR_RootConstrainSelectedInstOperands,
     /* 108264 */     // GIR_Coverage, 17026,
     /* 108264 */     GIR_EraseRootFromParent_Done,
     /* 108265 */   // Label 2299: @108265
     /* 108265 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(108302), // Rule ID 17028 //
     /* 108270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode),
     /* 108273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpfp16ps),
     /* 108278 */     // MIs[0] src1
     /* 108278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108281 */     // MIs[0] src2
     /* 108281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108284 */     // MIs[0] src3
     /* 108284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108287 */     // (intrinsic_void 14873:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPFP16PS),
     /* 108290 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108292 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108294 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108300 */     GIR_RootConstrainSelectedInstOperands,
     /* 108301 */     // GIR_Coverage, 17028,
     /* 108301 */     GIR_EraseRootFromParent_Done,
     /* 108302 */   // Label 2300: @108302
     /* 108302 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(108339), // Rule ID 17033 //
     /* 108307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmimfp16ps),
     /* 108315 */     // MIs[0] src1
     /* 108315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108318 */     // MIs[0] src2
     /* 108318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108321 */     // MIs[0] src3
     /* 108321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108324 */     // (intrinsic_void 14867:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMIMFP16PS),
     /* 108327 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108329 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108331 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108337 */     GIR_RootConstrainSelectedInstOperands,
     /* 108338 */     // GIR_Coverage, 17033,
     /* 108338 */     GIR_EraseRootFromParent_Done,
     /* 108339 */   // Label 2301: @108339
     /* 108339 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(108376), // Rule ID 17034 //
     /* 108344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmrlfp16ps),
     /* 108352 */     // MIs[0] src1
     /* 108352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108355 */     // MIs[0] src2
     /* 108355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108358 */     // MIs[0] src3
     /* 108358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108361 */     // (intrinsic_void 14869:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMRLFP16PS),
     /* 108364 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108366 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108368 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108374 */     GIR_RootConstrainSelectedInstOperands,
     /* 108375 */     // GIR_Coverage, 17034,
     /* 108375 */     GIR_EraseRootFromParent_Done,
     /* 108376 */   // Label 2302: @108376
     /* 108376 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(108413), // Rule ID 17035 //
     /* 108381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtcmmimfp16ps),
     /* 108389 */     // MIs[0] src1
     /* 108389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108392 */     // MIs[0] src2
     /* 108392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108395 */     // MIs[0] src3
     /* 108395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108398 */     // (intrinsic_void 14814:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCONJTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTCMMIMFP16PS),
     /* 108401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108403 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108405 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108411 */     GIR_RootConstrainSelectedInstOperands,
     /* 108412 */     // GIR_Coverage, 17035,
     /* 108412 */     GIR_EraseRootFromParent_Done,
     /* 108413 */   // Label 2303: @108413
     /* 108413 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(108450), // Rule ID 17054 //
     /* 108418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_In64BitMode),
     /* 108421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tmmultf32ps),
     /* 108426 */     // MIs[0] src1
     /* 108426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108429 */     // MIs[0] src2
     /* 108429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108432 */     // MIs[0] src3
     /* 108432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108435 */     // (intrinsic_void 14864:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTMMULTF32PS),
     /* 108438 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108440 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108442 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108448 */     GIR_RootConstrainSelectedInstOperands,
     /* 108449 */     // GIR_Coverage, 17054,
     /* 108449 */     GIR_EraseRootFromParent_Done,
     /* 108450 */   // Label 2304: @108450
     /* 108450 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(108487), // Rule ID 17056 //
     /* 108455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode),
     /* 108458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttmmultf32ps),
     /* 108463 */     // MIs[0] src1
     /* 108463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108466 */     // MIs[0] src2
     /* 108466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108469 */     // MIs[0] src3
     /* 108469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108472 */     // (intrinsic_void 14875:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTMMULTF32PS),
     /* 108475 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108477 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108479 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108485 */     GIR_RootConstrainSelectedInstOperands,
     /* 108486 */     // GIR_Coverage, 17056,
     /* 108486 */     GIR_EraseRootFromParent_Done,
     /* 108487 */   // Label 2305: @108487
     /* 108487 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(108540), // Rule ID 17037 //
     /* 108492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 108500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108510 */     // MIs[0] src1
     /* 108510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108521 */     // MIs[1] Operand 1
     /* 108521 */     // No operand predicates
     /* 108521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108523 */     // (intrinsic_w_chain:{ *:[v16f32] } 14818:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWD2PSrri:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrri),
     /* 108526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108528 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108538 */     GIR_RootConstrainSelectedInstOperands,
     /* 108539 */     // GIR_Coverage, 17037,
     /* 108539 */     GIR_EraseRootFromParent_Done,
     /* 108540 */   // Label 2306: @108540
     /* 108540 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(108593), // Rule ID 17046 //
     /* 108545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 108553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108563 */     // MIs[0] src1
     /* 108563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108574 */     // MIs[1] Operand 1
     /* 108574 */     // No operand predicates
     /* 108574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108576 */     // (intrinsic_w_chain:{ *:[v32f16] } 14824:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHHrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrri),
     /* 108579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108581 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108591 */     GIR_RootConstrainSelectedInstOperands,
     /* 108592 */     // GIR_Coverage, 17046,
     /* 108592 */     GIR_EraseRootFromParent_Done,
     /* 108593 */   // Label 2307: @108593
     /* 108593 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(108646), // Rule ID 17048 //
     /* 108598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 108606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108616 */     // MIs[0] src1
     /* 108616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108627 */     // MIs[1] Operand 1
     /* 108627 */     // No operand predicates
     /* 108627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108629 */     // (intrinsic_w_chain:{ *:[v32f16] } 14826:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHLrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrri),
     /* 108632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108634 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108644 */     GIR_RootConstrainSelectedInstOperands,
     /* 108645 */     // GIR_Coverage, 17048,
     /* 108645 */     GIR_EraseRootFromParent_Done,
     /* 108646 */   // Label 2308: @108646
     /* 108646 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(108699), // Rule ID 17049 //
     /* 108651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 108659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108669 */     // MIs[0] src1
     /* 108669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108680 */     // MIs[1] Operand 1
     /* 108680 */     // No operand predicates
     /* 108680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108682 */     // (intrinsic_w_chain:{ *:[v16i32] } 14857:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTILEMOVROWrri:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrri),
     /* 108685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108687 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108697 */     GIR_RootConstrainSelectedInstOperands,
     /* 108698 */     // GIR_Coverage, 17049,
     /* 108698 */     GIR_EraseRootFromParent_Done,
     /* 108699 */   // Label 2309: @108699
     /* 108699 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(108744), // Rule ID 17038 //
     /* 108704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 108712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108722 */     // MIs[0] src1
     /* 108722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108729 */     // (intrinsic_w_chain:{ *:[v16f32] } 14818:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWD2PSrre:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrre),
     /* 108732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108734 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108736 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108742 */     GIR_RootConstrainSelectedInstOperands,
     /* 108743 */     // GIR_Coverage, 17038,
     /* 108743 */     GIR_EraseRootFromParent_Done,
     /* 108744 */   // Label 2310: @108744
     /* 108744 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(108789), // Rule ID 17045 //
     /* 108749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 108757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108767 */     // MIs[0] src1
     /* 108767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108774 */     // (intrinsic_w_chain:{ *:[v32f16] } 14824:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHHrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrre),
     /* 108777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108781 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108787 */     GIR_RootConstrainSelectedInstOperands,
     /* 108788 */     // GIR_Coverage, 17045,
     /* 108788 */     GIR_EraseRootFromParent_Done,
     /* 108789 */   // Label 2311: @108789
     /* 108789 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(108834), // Rule ID 17047 //
     /* 108794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 108802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108812 */     // MIs[0] src1
     /* 108812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108819 */     // (intrinsic_w_chain:{ *:[v32f16] } 14826:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHLrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrre),
     /* 108822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108824 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108826 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108832 */     GIR_RootConstrainSelectedInstOperands,
     /* 108833 */     // GIR_Coverage, 17047,
     /* 108833 */     GIR_EraseRootFromParent_Done,
     /* 108834 */   // Label 2312: @108834
     /* 108834 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(108879), // Rule ID 17050 //
     /* 108839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 108847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108857 */     // MIs[0] src1
     /* 108857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108864 */     // (intrinsic_w_chain:{ *:[v16i32] } 14857:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTILEMOVROWrre:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrre),
     /* 108867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108869 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108871 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108877 */     GIR_RootConstrainSelectedInstOperands,
     /* 108878 */     // GIR_Coverage, 17050,
     /* 108878 */     GIR_EraseRootFromParent_Done,
     /* 108879 */   // Label 2313: @108879
     /* 108879 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(108924), // Rule ID 122 //
     /* 108884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 108887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 108892 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108906 */     // MIs[0] cntl
     /* 108906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108909 */     // (intrinsic_void 14498:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rri GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 108909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rri),
     /* 108912 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 108914 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108916 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 108918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108922 */     GIR_RootConstrainSelectedInstOperands,
     /* 108923 */     // GIR_Coverage, 122,
     /* 108923 */     GIR_EraseRootFromParent_Done,
     /* 108924 */   // Label 2314: @108924
     /* 108924 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(108969), // Rule ID 124 //
     /* 108929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 108932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 108937 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 108947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108951 */     // MIs[0] cntl
     /* 108951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108954 */     // (intrinsic_void 14499:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rri GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 108954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rri),
     /* 108957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 108959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108961 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 108963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108967 */     GIR_RootConstrainSelectedInstOperands,
     /* 108968 */     // GIR_Coverage, 124,
     /* 108968 */     GIR_EraseRootFromParent_Done,
     /* 108969 */   // Label 2315: @108969
     /* 108969 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(109051), // Rule ID 17103 //
     /* 108974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsetbv),
     /* 108979 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 108992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 108996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 109000 */     // (intrinsic_void 14994:{ *:[iPTR] }, ECX:{ *:[i32] }, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSETBV)
     /* 109000 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109004 */     GIR_AddRegister, /*InsnID*/3, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109010 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 109014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109018 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109024 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 109028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109032 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 109042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSETBV),
     /* 109045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109049 */     GIR_RootConstrainSelectedInstOperands,
     /* 109050 */     // GIR_Coverage, 17103,
     /* 109050 */     GIR_EraseRootFromParent_Done,
     /* 109051 */   // Label 2316: @109051
     /* 109051 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(109100), // Rule ID 17292 //
     /* 109056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMWAITX),
     /* 109059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mwaitx),
     /* 109064 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109085 */     // (intrinsic_void 14576:{ *:[iPTR] }, GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)  =>  (MWAITX GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)
     /* 109085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITX),
     /* 109088 */     GIR_RootToRootCopy, /*OpIdx*/1, // ecx
     /* 109090 */     GIR_RootToRootCopy, /*OpIdx*/2, // eax
     /* 109092 */     GIR_RootToRootCopy, /*OpIdx*/3, // ebx
     /* 109094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109098 */     GIR_RootConstrainSelectedInstOperands,
     /* 109099 */     // GIR_Coverage, 17292,
     /* 109099 */     GIR_EraseRootFromParent_Done,
     /* 109100 */   // Label 2317: @109100
     /* 109100 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(109162), // Rule ID 2902 //
     /* 109105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_In64BitMode),
     /* 109108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109113 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109127 */     // MIs[0] Operand 3
     /* 109127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 109131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109135 */     // (intrinsic_void 14674:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (VMASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109139 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 109149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU64),
     /* 109152 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109154 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109160 */     GIR_RootConstrainSelectedInstOperands,
     /* 109161 */     // GIR_Coverage, 2902,
     /* 109161 */     GIR_EraseRootFromParent_Done,
     /* 109162 */   // Label 2318: @109162
     /* 109162 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(109224), // Rule ID 2903 //
     /* 109167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 109170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109175 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109189 */     // MIs[0] Operand 3
     /* 109189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 109193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109197 */     // (intrinsic_void 14674:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (VMASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109201 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109207 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 109211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU),
     /* 109214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109216 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109222 */     GIR_RootConstrainSelectedInstOperands,
     /* 109223 */     // GIR_Coverage, 2903,
     /* 109223 */     GIR_EraseRootFromParent_Done,
     /* 109224 */   // Label 2319: @109224
     /* 109224 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(109286), // Rule ID 2904 //
     /* 109229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseSSE2),
     /* 109232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109237 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109251 */     // MIs[0] Operand 3
     /* 109251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 109255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109259 */     // (intrinsic_void 14674:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (MASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109263 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 109273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU64),
     /* 109276 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109278 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109284 */     GIR_RootConstrainSelectedInstOperands,
     /* 109285 */     // GIR_Coverage, 2904,
     /* 109285 */     GIR_EraseRootFromParent_Done,
     /* 109286 */   // Label 2320: @109286
     /* 109286 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(109348), // Rule ID 2905 //
     /* 109291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 109294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109299 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109313 */     // MIs[0] Operand 3
     /* 109313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 109317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109321 */     // (intrinsic_void 14674:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (MASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109325 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 109335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU),
     /* 109338 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109340 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109346 */     GIR_RootConstrainSelectedInstOperands,
     /* 109347 */     // GIR_Coverage, 2905,
     /* 109347 */     GIR_EraseRootFromParent_Done,
     /* 109348 */   // Label 2321: @109348
     /* 109348 */   GIM_Reject,
     /* 109349 */ // Label 2256: @109349
     /* 109349 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(109437), // Rule ID 16987 //
     /* 109354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasKL),
     /* 109357 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 109360 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_loadiwkey),
     /* 109365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 109371 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 109374 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 109377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109385 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109389 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 109393 */   // (intrinsic_void 14495:{ *:[iPTR] }, XMM0:{ *:[v2i64] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, EAX:{ *:[i32] })  =>  (LOADIWKEY:{ *:[i32] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 109393 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109397 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109403 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // EAX
     /* 109407 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109411 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109417 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // XMM0
     /* 109421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LOADIWKEY),
     /* 109424 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109426 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109428 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 109431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109435 */   GIR_RootConstrainSelectedInstOperands,
     /* 109436 */   // GIR_Coverage, 16987,
     /* 109436 */   GIR_EraseRootFromParent_Done,
     /* 109437 */ // Label 2322: @109437
     /* 109437 */ GIM_Reject,
     /* 109438 */ // Label 19: @109438
     /* 109438 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2326*/ GIMT_Encode4(109872),
     /* 109449 */ /*GILLT_s16*//*Label 2323*/ GIMT_Encode4(109461),
     /* 109453 */ /*GILLT_s32*//*Label 2324*/ GIMT_Encode4(109519),
     /* 109457 */ /*GILLT_s64*//*Label 2325*/ GIMT_Encode4(109694),
     /* 109461 */ // Label 2323: @109461
     /* 109461 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(109518), // Rule ID 22587 //
     /* 109466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109477 */   // (anyext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 109477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109489 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109500 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 109507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 109512 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 109517 */   // GIR_Coverage, 22587,
     /* 109517 */   GIR_EraseRootFromParent_Done,
     /* 109518 */ // Label 2327: @109518
     /* 109518 */ GIM_Reject,
     /* 109519 */ // Label 2324: @109519
     /* 109519 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(109565), // Rule ID 19436 //
     /* 109524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109531 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109535 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109539 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 109543 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 109548 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109550 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] })
     /* 109550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109555 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109559 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109564 */   // GIR_Coverage, 19436,
     /* 109564 */   GIR_EraseRootFromParent_Done,
     /* 109565 */ // Label 2328: @109565
     /* 109565 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(109611), // Rule ID 19439 //
     /* 109570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109577 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109581 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109585 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 109589 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 109594 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109596 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] })
     /* 109596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109601 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109605 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109610 */   // GIR_Coverage, 19439,
     /* 109610 */   GIR_EraseRootFromParent_Done,
     /* 109611 */ // Label 2329: @109611
     /* 109611 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(109634), // Rule ID 22588 //
     /* 109616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109627 */   // (anyext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 109627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109632 */   GIR_RootConstrainSelectedInstOperands,
     /* 109633 */   // GIR_Coverage, 22588,
     /* 109633 */   GIR_Done,
     /* 109634 */ // Label 2330: @109634
     /* 109634 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(109693), // Rule ID 22589 //
     /* 109639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109650 */   // (anyext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })
     /* 109650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109672 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 109677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 109692 */   // GIR_Coverage, 22589,
     /* 109692 */   GIR_EraseRootFromParent_Done,
     /* 109693 */ // Label 2331: @109693
     /* 109693 */ GIM_Reject,
     /* 109694 */ // Label 2325: @109694
     /* 109694 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(109753), // Rule ID 22590 //
     /* 109699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109710 */   // (anyext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 109710 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109713 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109717 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109722 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109736 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 109742 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 109747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 109752 */   // GIR_Coverage, 22590,
     /* 109752 */   GIR_EraseRootFromParent_Done,
     /* 109753 */ // Label 2332: @109753
     /* 109753 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(109812), // Rule ID 22591 //
     /* 109758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109769 */   // (anyext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 109769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 109776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109781 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109795 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 109801 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 109806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 109811 */   // GIR_Coverage, 22591,
     /* 109811 */   GIR_EraseRootFromParent_Done,
     /* 109812 */ // Label 2333: @109812
     /* 109812 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(109871), // Rule ID 22592 //
     /* 109817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109828 */   // (anyext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR32:{ *:[i32] }:$src, sub_32bit:{ *:[i32] })
     /* 109828 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109831 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109835 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109847 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109850 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 109855 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 109860 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64RegClassID),
     /* 109865 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 109870 */   // GIR_Coverage, 22592,
     /* 109870 */   GIR_EraseRootFromParent_Done,
     /* 109871 */ // Label 2334: @109871
     /* 109871 */ GIM_Reject,
     /* 109872 */ // Label 2326: @109872
     /* 109872 */ GIM_Reject,
     /* 109873 */ // Label 20: @109873
     /* 109873 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 2343*/ GIMT_Encode4(110961),
     /* 109884 */ /*GILLT_s8*//*Label 2335*/ GIMT_Encode4(109968),
     /* 109888 */ /*GILLT_s16*//*Label 2336*/ GIMT_Encode4(110252), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109920 */ /*GILLT_v4s32*//*Label 2337*/ GIMT_Encode4(110291), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109932 */ /*GILLT_v8s16*//*Label 2338*/ GIMT_Encode4(110431),
     /* 109936 */ /*GILLT_v8s32*//*Label 2339*/ GIMT_Encode4(110594), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109948 */ /*GILLT_v16s8*//*Label 2340*/ GIMT_Encode4(110621),
     /* 109952 */ /*GILLT_v16s16*//*Label 2341*/ GIMT_Encode4(110907), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109964 */ /*GILLT_v32s8*//*Label 2342*/ GIMT_Encode4(110934),
     /* 109968 */ // Label 2335: @109968
     /* 109968 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(110043), // Rule ID 19431 //
     /* 109973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109988 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 109992 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 109997 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109999 */   // (trunc:{ *:[i8] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 109999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110011 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 110015 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 110020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110025 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110032 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110042 */   // GIR_Coverage, 19431,
     /* 110042 */   GIR_EraseRootFromParent_Done,
     /* 110043 */ // Label 2344: @110043
     /* 110043 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(110106), // Rule ID 22649 //
     /* 110048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 110051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110062 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } GR32:{ *:[i32] }:$src, GR32_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110074 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110078 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 110083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110088 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110095 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110100 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 110105 */   // GIR_Coverage, 22649,
     /* 110105 */   GIR_EraseRootFromParent_Done,
     /* 110106 */ // Label 2345: @110106
     /* 110106 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(110169), // Rule ID 22650 //
     /* 110111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 110114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110125 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i16] } GR16:{ *:[i16] }:$src, GR16_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110137 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110141 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 110146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110151 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110163 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 110168 */   // GIR_Coverage, 22650,
     /* 110168 */   GIR_EraseRootFromParent_Done,
     /* 110169 */ // Label 2346: @110169
     /* 110169 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(110210), // Rule ID 22654 //
     /* 110174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 110177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110188 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] })
     /* 110188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110193 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 110199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110209 */   // GIR_Coverage, 22654,
     /* 110209 */   GIR_EraseRootFromParent_Done,
     /* 110210 */ // Label 2347: @110210
     /* 110210 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(110251), // Rule ID 22655 //
     /* 110215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 110218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110229 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })
     /* 110229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110234 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 110240 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 110250 */   // GIR_Coverage, 22655,
     /* 110250 */   GIR_EraseRootFromParent_Done,
     /* 110251 */ // Label 2348: @110251
     /* 110251 */ GIM_Reject,
     /* 110252 */ // Label 2336: @110252
     /* 110252 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(110290), // Rule ID 22648 //
     /* 110257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110268 */   // (trunc:{ *:[i16] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] })
     /* 110268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110273 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 110279 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 110284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110289 */   // GIR_Coverage, 22648,
     /* 110289 */   GIR_EraseRootFromParent_Done,
     /* 110290 */ // Label 2349: @110290
     /* 110290 */ GIM_Reject,
     /* 110291 */ // Label 2337: @110291
     /* 110291 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(110430),
     /* 110296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 110299 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(110322), // Rule ID 12261 //
     /* 110304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 110307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110315 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (VPMOVQDZ256rr:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)
     /* 110315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZ256rr),
     /* 110320 */     GIR_RootConstrainSelectedInstOperands,
     /* 110321 */     // GIR_Coverage, 12261,
     /* 110321 */     GIR_Done,
     /* 110322 */   // Label 2351: @110322
     /* 110322 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(110429), // Rule ID 21556 //
     /* 110327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 110330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110338 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPMOVQDZrr:{ *:[v8i32] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110338 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 110341 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110345 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110352 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 110355 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110359 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110364 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110367 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110371 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 110392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 110396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110401 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110411 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110428 */     // GIR_Coverage, 21556,
     /* 110428 */     GIR_EraseRootFromParent_Done,
     /* 110429 */   // Label 2352: @110429
     /* 110429 */   GIM_Reject,
     /* 110430 */ // Label 2350: @110430
     /* 110430 */ GIM_Reject,
     /* 110431 */ // Label 2338: @110431
     /* 110431 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(110457), // Rule ID 12237 //
     /* 110436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 110442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110450 */   // (trunc:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQWZrr:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)
     /* 110450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQWZrr),
     /* 110455 */   GIR_RootConstrainSelectedInstOperands,
     /* 110456 */   // GIR_Coverage, 12237,
     /* 110456 */   GIR_Done,
     /* 110457 */ // Label 2353: @110457
     /* 110457 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(110483), // Rule ID 12315 //
     /* 110462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 110465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 110468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110476 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)
     /* 110476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 110481 */   GIR_RootConstrainSelectedInstOperands,
     /* 110482 */   // GIR_Coverage, 12315,
     /* 110482 */   GIR_Done,
     /* 110483 */ // Label 2354: @110483
     /* 110483 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(110593), // Rule ID 21555 //
     /* 110488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 110491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 110494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110502 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPMOVDWZrr:{ *:[v16i16] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110502 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 110505 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110509 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110516 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 110519 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110523 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110528 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110531 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110535 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110538 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110543 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110548 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110553 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 110556 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 110560 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110565 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110575 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110582 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110587 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110592 */   // GIR_Coverage, 21555,
     /* 110592 */   GIR_EraseRootFromParent_Done,
     /* 110593 */ // Label 2355: @110593
     /* 110593 */ GIM_Reject,
     /* 110594 */ // Label 2339: @110594
     /* 110594 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(110620), // Rule ID 12264 //
     /* 110599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 110605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110613 */   // (trunc:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQDZrr:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)
     /* 110613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 110618 */   GIR_RootConstrainSelectedInstOperands,
     /* 110619 */   // GIR_Coverage, 12264,
     /* 110619 */   GIR_Done,
     /* 110620 */ // Label 2356: @110620
     /* 110620 */ GIM_Reject,
     /* 110621 */ // Label 2340: @110621
     /* 110621 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(110697), // Rule ID 21649 //
     /* 110626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 110629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110636 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110640 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 110644 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110647 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 110651 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 110655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110657 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 110664 */   // (trunc:{ *:[v16i8] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src))
     /* 110664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 110667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrm),
     /* 110671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110676 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /* 110680 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110695 */   GIR_RootConstrainSelectedInstOperands,
     /* 110696 */   // GIR_Coverage, 21649,
     /* 110696 */   GIR_EraseRootFromParent_Done,
     /* 110697 */ // Label 2357: @110697
     /* 110697 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(110723), // Rule ID 12291 //
     /* 110702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 110708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110716 */   // (trunc:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)
     /* 110716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110721 */   GIR_RootConstrainSelectedInstOperands,
     /* 110722 */   // GIR_Coverage, 12291,
     /* 110722 */   GIR_Done,
     /* 110723 */ // Label 2358: @110723
     /* 110723 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(110749), // Rule ID 12342 //
     /* 110728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 110731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110742 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVWBZ256rr:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)
     /* 110742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZ256rr),
     /* 110747 */   GIR_RootConstrainSelectedInstOperands,
     /* 110748 */   // GIR_Coverage, 12342,
     /* 110748 */   GIR_Done,
     /* 110749 */ // Label 2359: @110749
     /* 110749 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(110859), // Rule ID 21557 //
     /* 110754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 110757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110768 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPMOVWBZrr:{ *:[v32i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110768 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 110771 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110775 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110782 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 110785 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110789 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110794 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110797 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110801 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110804 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110809 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110814 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 110822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 110826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110831 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110841 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110858 */   // GIR_Coverage, 21557,
     /* 110858 */   GIR_EraseRootFromParent_Done,
     /* 110859 */ // Label 2360: @110859
     /* 110859 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(110906), // Rule ID 21648 //
     /* 110864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 110867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110878 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src))
     /* 110878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 110881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 110885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110890 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110904 */   GIR_RootConstrainSelectedInstOperands,
     /* 110905 */   // GIR_Coverage, 21648,
     /* 110905 */   GIR_EraseRootFromParent_Done,
     /* 110906 */ // Label 2361: @110906
     /* 110906 */ GIM_Reject,
     /* 110907 */ // Label 2341: @110907
     /* 110907 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(110933), // Rule ID 12318 //
     /* 110912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 110918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110926 */   // (trunc:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)
     /* 110926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 110931 */   GIR_RootConstrainSelectedInstOperands,
     /* 110932 */   // GIR_Coverage, 12318,
     /* 110932 */   GIR_Done,
     /* 110933 */ // Label 2362: @110933
     /* 110933 */ GIM_Reject,
     /* 110934 */ // Label 2342: @110934
     /* 110934 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(110960), // Rule ID 12345 //
     /* 110939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 110942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 110945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110953 */   // (trunc:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)  =>  (VPMOVWBZrr:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)
     /* 110953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 110958 */   GIR_RootConstrainSelectedInstOperands,
     /* 110959 */   // GIR_Coverage, 12345,
     /* 110959 */   GIR_Done,
     /* 110960 */ // Label 2363: @110960
     /* 110960 */ GIM_Reject,
     /* 110961 */ // Label 2343: @110961
     /* 110961 */ GIM_Reject,
     /* 110962 */ // Label 21: @110962
     /* 110962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2368*/ GIMT_Encode4(111567),
     /* 110973 */ /*GILLT_s8*//*Label 2364*/ GIMT_Encode4(110989),
     /* 110977 */ /*GILLT_s16*//*Label 2365*/ GIMT_Encode4(111071),
     /* 110981 */ /*GILLT_s32*//*Label 2366*/ GIMT_Encode4(111271),
     /* 110985 */ /*GILLT_s64*//*Label 2367*/ GIMT_Encode4(111413),
     /* 110989 */ // Label 2364: @110989
     /* 110989 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(111070),
     /* 110994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110998 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(111054), // Rule ID 22383 //
     /* 111003 */     // MIs[0] Operand 1
     /* 111003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111014 */     // 0:{ *:[i8] }  =>  (EXTRACT_SUBREG:{ *:[i8] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 111014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111026 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111036 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 111043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 111048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111053 */     // GIR_Coverage, 22383,
     /* 111053 */     GIR_EraseRootFromParent_Done,
     /* 111054 */   // Label 2370: @111054
     /* 111054 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(111069), // Rule ID 19 //
     /* 111059 */     // MIs[0] Operand 1
     /* 111059 */     // No operand predicates
     /* 111059 */     // (imm:{ *:[i8] }):$src  =>  (MOV8ri:{ *:[i8] } (imm:{ *:[i8] }):$src)
     /* 111059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8ri),
     /* 111062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111067 */     GIR_RootConstrainSelectedInstOperands,
     /* 111068 */     // GIR_Coverage, 19,
     /* 111068 */     GIR_EraseRootFromParent_Done,
     /* 111069 */   // Label 2371: @111069
     /* 111069 */   GIM_Reject,
     /* 111070 */ // Label 2369: @111070
     /* 111070 */ GIM_Reject,
     /* 111071 */ // Label 2365: @111071
     /* 111071 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(111270),
     /* 111076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 111080 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(111136), // Rule ID 22384 //
     /* 111085 */     // MIs[0] Operand 1
     /* 111085 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111096 */     // 0:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111108 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111118 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111135 */     // GIR_Coverage, 22384,
     /* 111135 */     GIR_EraseRootFromParent_Done,
     /* 111136 */   // Label 2373: @111136
     /* 111136 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(111195), // Rule ID 22386 //
     /* 111141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111144 */     // MIs[0] Operand 1
     /* 111144 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 111155 */     // 1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 111162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111167 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111177 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111194 */     // GIR_Coverage, 22386,
     /* 111194 */     GIR_EraseRootFromParent_Done,
     /* 111195 */   // Label 2374: @111195
     /* 111195 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(111254), // Rule ID 22387 //
     /* 111200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111203 */     // MIs[0] Operand 1
     /* 111203 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 111214 */     // -1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r_1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 111221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111226 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111236 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111253 */     // GIR_Coverage, 22387,
     /* 111253 */     GIR_EraseRootFromParent_Done,
     /* 111254 */   // Label 2375: @111254
     /* 111254 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(111269), // Rule ID 20 //
     /* 111259 */     // MIs[0] Operand 1
     /* 111259 */     // No operand predicates
     /* 111259 */     // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] } (imm:{ *:[i16] }):$src)
     /* 111259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16ri),
     /* 111262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111267 */     GIR_RootConstrainSelectedInstOperands,
     /* 111268 */     // GIR_Coverage, 20,
     /* 111268 */     GIR_EraseRootFromParent_Done,
     /* 111269 */   // Label 2376: @111269
     /* 111269 */   GIM_Reject,
     /* 111270 */ // Label 2372: @111270
     /* 111270 */ GIM_Reject,
     /* 111271 */ // Label 2366: @111271
     /* 111271 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(111301), // Rule ID 17152 //
     /* 111276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111280 */   // MIs[0] Operand 1
     /* 111280 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111291 */   // 0:{ *:[i32] }  =>  (MOV32r0:{ *:[i32] }:{ *:[i32] })
     /* 111291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111296 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111299 */   GIR_RootConstrainSelectedInstOperands,
     /* 111300 */   // GIR_Coverage, 17152,
     /* 111300 */   GIR_EraseRootFromParent_Done,
     /* 111301 */ // Label 2377: @111301
     /* 111301 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(111334), // Rule ID 17153 //
     /* 111306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111313 */   // MIs[0] Operand 1
     /* 111313 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 111324 */   // 1:{ *:[i32] }  =>  (MOV32r1:{ *:[i32] }:{ *:[i32] })
     /* 111324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 111327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111329 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111332 */   GIR_RootConstrainSelectedInstOperands,
     /* 111333 */   // GIR_Coverage, 17153,
     /* 111333 */   GIR_EraseRootFromParent_Done,
     /* 111334 */ // Label 2378: @111334
     /* 111334 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(111367), // Rule ID 17154 //
     /* 111339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111346 */   // MIs[0] Operand 1
     /* 111346 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 111357 */   // -1:{ *:[i32] }  =>  (MOV32r_1:{ *:[i32] }:{ *:[i32] })
     /* 111357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 111360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111362 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111365 */   GIR_RootConstrainSelectedInstOperands,
     /* 111366 */   // GIR_Coverage, 17154,
     /* 111366 */   GIR_EraseRootFromParent_Done,
     /* 111367 */ // Label 2379: @111367
     /* 111367 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(111393), // Rule ID 17155 //
     /* 111372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 111375 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immSExt8),
     /* 111379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111383 */   // MIs[0] Operand 1
     /* 111383 */   // No operand predicates
     /* 111383 */   // (imm:{ *:[i32] })<<P:Predicate_i32immSExt8>>:$src  =>  (MOV32ImmSExti8:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 111383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ImmSExti8),
     /* 111386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111388 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111391 */   GIR_RootConstrainSelectedInstOperands,
     /* 111392 */   // GIR_Coverage, 17155,
     /* 111392 */   GIR_EraseRootFromParent_Done,
     /* 111393 */ // Label 2380: @111393
     /* 111393 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(111412), // Rule ID 21 //
     /* 111398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111402 */   // MIs[0] Operand 1
     /* 111402 */   // No operand predicates
     /* 111402 */   // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 111402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri),
     /* 111405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111407 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111410 */   GIR_RootConstrainSelectedInstOperands,
     /* 111411 */   // GIR_Coverage, 21,
     /* 111411 */   GIR_EraseRootFromParent_Done,
     /* 111412 */ // Label 2381: @111412
     /* 111412 */ GIM_Reject,
     /* 111413 */ // Label 2367: @111413
     /* 111413 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(111475), // Rule ID 22385 //
     /* 111418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111422 */   // MIs[0] Operand 1
     /* 111422 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111433 */   // 0:{ *:[i64] }  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_32bit:{ *:[i32] })
     /* 111433 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111436 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111440 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111445 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 111464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 111469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 111474 */   // GIR_Coverage, 22385,
     /* 111474 */   GIR_EraseRootFromParent_Done,
     /* 111475 */ // Label 2382: @111475
     /* 111475 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(111501), // Rule ID 17156 //
     /* 111480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 111483 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt8),
     /* 111487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111491 */   // MIs[0] Operand 1
     /* 111491 */   // No operand predicates
     /* 111491 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt8>>:$src  =>  (MOV64ImmSExti8:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ImmSExti8),
     /* 111494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111496 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111499 */   GIR_RootConstrainSelectedInstOperands,
     /* 111500 */   // GIR_Coverage, 17156,
     /* 111500 */   GIR_EraseRootFromParent_Done,
     /* 111501 */ // Label 2383: @111501
     /* 111501 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(111524), // Rule ID 17157 //
     /* 111506 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immZExt32),
     /* 111510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111514 */   // MIs[0] Operand 1
     /* 111514 */   // No operand predicates
     /* 111514 */   // (imm:{ *:[i64] })<<P:Predicate_i64immZExt32>>:$src  =>  (MOV32ri64:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri64),
     /* 111517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111519 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111522 */   GIR_RootConstrainSelectedInstOperands,
     /* 111523 */   // GIR_Coverage, 17157,
     /* 111523 */   GIR_EraseRootFromParent_Done,
     /* 111524 */ // Label 2384: @111524
     /* 111524 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(111547), // Rule ID 22 //
     /* 111529 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 111533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111537 */   // MIs[0] Operand 1
     /* 111537 */   // No operand predicates
     /* 111537 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src  =>  (MOV64ri32:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri32),
     /* 111540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111542 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111545 */   GIR_RootConstrainSelectedInstOperands,
     /* 111546 */   // GIR_Coverage, 22,
     /* 111546 */   GIR_EraseRootFromParent_Done,
     /* 111547 */ // Label 2385: @111547
     /* 111547 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(111566), // Rule ID 23 //
     /* 111552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111556 */   // MIs[0] Operand 1
     /* 111556 */   // No operand predicates
     /* 111556 */   // (imm:{ *:[i64] }):$src  =>  (MOV64ri:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri),
     /* 111559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111561 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111564 */   GIR_RootConstrainSelectedInstOperands,
     /* 111565 */   // GIR_Coverage, 23,
     /* 111565 */   GIR_EraseRootFromParent_Done,
     /* 111566 */ // Label 2386: @111566
     /* 111566 */ GIM_Reject,
     /* 111567 */ // Label 2368: @111567
     /* 111567 */ GIM_Reject,
     /* 111568 */ // Label 22: @111568
     /* 111568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 2390*/ GIMT_Encode4(112020),
     /* 111579 */ /*GILLT_s32*//*Label 2387*/ GIMT_Encode4(111591),
     /* 111583 */ /*GILLT_s64*//*Label 2388*/ GIMT_Encode4(111736),
     /* 111587 */ /*GILLT_s80*//*Label 2389*/ GIMT_Encode4(111881),
     /* 111591 */ // Label 2387: @111591
     /* 111591 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(111617), // Rule ID 1115 //
     /* 111596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111599 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111607 */   // MIs[0] Operand 1
     /* 111607 */   // No operand predicates
     /* 111607 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (LD_Fp032:{ *:[f32] }:{ *:[i16] })
     /* 111607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 111610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111612 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111615 */   GIR_RootConstrainSelectedInstOperands,
     /* 111616 */   // GIR_Coverage, 1115,
     /* 111616 */   GIR_EraseRootFromParent_Done,
     /* 111617 */ // Label 2391: @111617
     /* 111617 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(111643), // Rule ID 1116 //
     /* 111622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111625 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111633 */   // MIs[0] Operand 1
     /* 111633 */   // No operand predicates
     /* 111633 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm1>>  =>  (LD_Fp132:{ *:[f32] }:{ *:[i16] })
     /* 111633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 111636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111638 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111641 */   GIR_RootConstrainSelectedInstOperands,
     /* 111642 */   // GIR_Coverage, 1116,
     /* 111642 */   GIR_EraseRootFromParent_Done,
     /* 111643 */ // Label 2392: @111643
     /* 111643 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(111689), // Rule ID 17719 //
     /* 111648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111651 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 111655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111659 */   // MIs[0] Operand 1
     /* 111659 */   // No operand predicates
     /* 111659 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp032:{ *:[f32] }:{ *:[i16] }))
     /* 111659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 111666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111671 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 111679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111684 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111687 */   GIR_RootConstrainSelectedInstOperands,
     /* 111688 */   // GIR_Coverage, 17719,
     /* 111688 */   GIR_EraseRootFromParent_Done,
     /* 111689 */ // Label 2393: @111689
     /* 111689 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(111735), // Rule ID 17720 //
     /* 111694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111697 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 111701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111705 */   // MIs[0] Operand 1
     /* 111705 */   // No operand predicates
     /* 111705 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp132:{ *:[f32] }:{ *:[i16] }))
     /* 111705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 111712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111717 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 111725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111730 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111733 */   GIR_RootConstrainSelectedInstOperands,
     /* 111734 */   // GIR_Coverage, 17720,
     /* 111734 */   GIR_EraseRootFromParent_Done,
     /* 111735 */ // Label 2394: @111735
     /* 111735 */ GIM_Reject,
     /* 111736 */ // Label 2388: @111736
     /* 111736 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(111762), // Rule ID 1117 //
     /* 111741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111744 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111752 */   // MIs[0] Operand 1
     /* 111752 */   // No operand predicates
     /* 111752 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (LD_Fp064:{ *:[f64] }:{ *:[i16] })
     /* 111752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 111755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111757 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111760 */   GIR_RootConstrainSelectedInstOperands,
     /* 111761 */   // GIR_Coverage, 1117,
     /* 111761 */   GIR_EraseRootFromParent_Done,
     /* 111762 */ // Label 2395: @111762
     /* 111762 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(111788), // Rule ID 1118 //
     /* 111767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111770 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111778 */   // MIs[0] Operand 1
     /* 111778 */   // No operand predicates
     /* 111778 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm1>>  =>  (LD_Fp164:{ *:[f64] }:{ *:[i16] })
     /* 111778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 111781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111783 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111786 */   GIR_RootConstrainSelectedInstOperands,
     /* 111787 */   // GIR_Coverage, 1118,
     /* 111787 */   GIR_EraseRootFromParent_Done,
     /* 111788 */ // Label 2396: @111788
     /* 111788 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(111834), // Rule ID 17721 //
     /* 111793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111796 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 111800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111804 */   // MIs[0] Operand 1
     /* 111804 */   // No operand predicates
     /* 111804 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp064:{ *:[f64] }:{ *:[i16] }))
     /* 111804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 111811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111816 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 111824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111826 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111829 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111832 */   GIR_RootConstrainSelectedInstOperands,
     /* 111833 */   // GIR_Coverage, 17721,
     /* 111833 */   GIR_EraseRootFromParent_Done,
     /* 111834 */ // Label 2397: @111834
     /* 111834 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(111880), // Rule ID 17722 //
     /* 111839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111842 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 111846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111850 */   // MIs[0] Operand 1
     /* 111850 */   // No operand predicates
     /* 111850 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp164:{ *:[f64] }:{ *:[i16] }))
     /* 111850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111853 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 111857 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111862 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 111870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111875 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111878 */   GIR_RootConstrainSelectedInstOperands,
     /* 111879 */   // GIR_Coverage, 17722,
     /* 111879 */   GIR_EraseRootFromParent_Done,
     /* 111880 */ // Label 2398: @111880
     /* 111880 */ GIM_Reject,
     /* 111881 */ // Label 2389: @111881
     /* 111881 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(111907), // Rule ID 1119 //
     /* 111886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 111889 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 111897 */   // MIs[0] Operand 1
     /* 111897 */   // No operand predicates
     /* 111897 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm0>>  =>  (LD_Fp080:{ *:[f80] }:{ *:[i16] })
     /* 111897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 111900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111902 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111905 */   GIR_RootConstrainSelectedInstOperands,
     /* 111906 */   // GIR_Coverage, 1119,
     /* 111906 */   GIR_EraseRootFromParent_Done,
     /* 111907 */ // Label 2399: @111907
     /* 111907 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(111933), // Rule ID 1120 //
     /* 111912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 111915 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 111923 */   // MIs[0] Operand 1
     /* 111923 */   // No operand predicates
     /* 111923 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm1>>  =>  (LD_Fp180:{ *:[f80] }:{ *:[i16] })
     /* 111923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 111926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111928 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111931 */   GIR_RootConstrainSelectedInstOperands,
     /* 111932 */   // GIR_Coverage, 1120,
     /* 111932 */   GIR_EraseRootFromParent_Done,
     /* 111933 */ // Label 2400: @111933
     /* 111933 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(111976), // Rule ID 17723 //
     /* 111938 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 111942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 111946 */   // MIs[0] Operand 1
     /* 111946 */   // No operand predicates
     /* 111946 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp080:{ *:[f80] }:{ *:[i16] }))
     /* 111946 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 111949 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 111953 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111958 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 111966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111971 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111974 */   GIR_RootConstrainSelectedInstOperands,
     /* 111975 */   // GIR_Coverage, 17723,
     /* 111975 */   GIR_EraseRootFromParent_Done,
     /* 111976 */ // Label 2401: @111976
     /* 111976 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(112019), // Rule ID 17724 //
     /* 111981 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 111985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 111989 */   // MIs[0] Operand 1
     /* 111989 */   // No operand predicates
     /* 111989 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp180:{ *:[f80] }:{ *:[i16] }))
     /* 111989 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 111992 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 111996 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112001 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 112009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112014 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112017 */   GIR_RootConstrainSelectedInstOperands,
     /* 112018 */   // GIR_Coverage, 17724,
     /* 112018 */   GIR_EraseRootFromParent_Done,
     /* 112019 */ // Label 2402: @112019
     /* 112019 */ GIM_Reject,
     /* 112020 */ // Label 2390: @112020
     /* 112020 */ GIM_Reject,
     /* 112021 */ // Label 23: @112021
     /* 112021 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 2418*/ GIMT_Encode4(113692),
     /* 112032 */ /*GILLT_s16*//*Label 2403*/ GIMT_Encode4(112124),
     /* 112036 */ /*GILLT_s32*//*Label 2404*/ GIMT_Encode4(112182),
     /* 112040 */ /*GILLT_s64*//*Label 2405*/ GIMT_Encode4(112229), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112056 */ /*GILLT_v2s64*//*Label 2406*/ GIMT_Encode4(112302), GIMT_Encode4(0),
     /* 112064 */ /*GILLT_v4s32*//*Label 2407*/ GIMT_Encode4(112329),
     /* 112068 */ /*GILLT_v4s64*//*Label 2408*/ GIMT_Encode4(112356), GIMT_Encode4(0),
     /* 112076 */ /*GILLT_v8s16*//*Label 2409*/ GIMT_Encode4(112553),
     /* 112080 */ /*GILLT_v8s32*//*Label 2410*/ GIMT_Encode4(112622),
     /* 112084 */ /*GILLT_v8s64*//*Label 2411*/ GIMT_Encode4(112819), GIMT_Encode4(0),
     /* 112092 */ /*GILLT_v16s8*//*Label 2412*/ GIMT_Encode4(113016),
     /* 112096 */ /*GILLT_v16s16*//*Label 2413*/ GIMT_Encode4(113085),
     /* 112100 */ /*GILLT_v16s32*//*Label 2414*/ GIMT_Encode4(113329), GIMT_Encode4(0),
     /* 112108 */ /*GILLT_v32s8*//*Label 2415*/ GIMT_Encode4(113526),
     /* 112112 */ /*GILLT_v32s16*//*Label 2416*/ GIMT_Encode4(113553), GIMT_Encode4(0),
     /* 112120 */ /*GILLT_v64s8*//*Label 2417*/ GIMT_Encode4(113665),
     /* 112124 */ // Label 2403: @112124
     /* 112124 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(112181), // Rule ID 22644 //
     /* 112129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112140 */   // (sext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 112140 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112143 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 112147 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112152 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112163 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 112170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 112175 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 112180 */   // GIR_Coverage, 22644,
     /* 112180 */   GIR_EraseRootFromParent_Done,
     /* 112181 */ // Label 2419: @112181
     /* 112181 */ GIM_Reject,
     /* 112182 */ // Label 2404: @112182
     /* 112182 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(112205), // Rule ID 614 //
     /* 112187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112198 */   // (sext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 112198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 112203 */   GIR_RootConstrainSelectedInstOperands,
     /* 112204 */   // GIR_Coverage, 614,
     /* 112204 */   GIR_Done,
     /* 112205 */ // Label 2420: @112205
     /* 112205 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(112228), // Rule ID 616 //
     /* 112210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112221 */   // (sext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVSX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 112221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 112226 */   GIR_RootConstrainSelectedInstOperands,
     /* 112227 */   // GIR_Coverage, 616,
     /* 112227 */   GIR_Done,
     /* 112228 */ // Label 2421: @112228
     /* 112228 */ GIM_Reject,
     /* 112229 */ // Label 2405: @112229
     /* 112229 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(112252), // Rule ID 622 //
     /* 112234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112245 */   // (sext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (MOVSX64rr8:{ *:[i64] } GR8:{ *:[i8] }:$src)
     /* 112245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr8),
     /* 112250 */   GIR_RootConstrainSelectedInstOperands,
     /* 112251 */   // GIR_Coverage, 622,
     /* 112251 */   GIR_Done,
     /* 112252 */ // Label 2422: @112252
     /* 112252 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(112275), // Rule ID 624 //
     /* 112257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112268 */   // (sext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (MOVSX64rr16:{ *:[i64] } GR16:{ *:[i16] }:$src)
     /* 112268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr16),
     /* 112273 */   GIR_RootConstrainSelectedInstOperands,
     /* 112274 */   // GIR_Coverage, 624,
     /* 112274 */   GIR_Done,
     /* 112275 */ // Label 2423: @112275
     /* 112275 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(112301), // Rule ID 626 //
     /* 112280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 112283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 112286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112294 */   // (sext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (MOVSX64rr32:{ *:[i64] } GR32:{ *:[i32] }:$src)
     /* 112294 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr32),
     /* 112299 */   GIR_RootConstrainSelectedInstOperands,
     /* 112300 */   // GIR_Coverage, 626,
     /* 112300 */   GIR_Done,
     /* 112301 */ // Label 2424: @112301
     /* 112301 */ GIM_Reject,
     /* 112302 */ // Label 2406: @112302
     /* 112302 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(112328), // Rule ID 12593 //
     /* 112307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 112313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 112321 */   // (sext:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)  =>  (VPMOVM2QZ128rk:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)
     /* 112321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ128rk),
     /* 112326 */   GIR_RootConstrainSelectedInstOperands,
     /* 112327 */   // GIR_Coverage, 12593,
     /* 112327 */   GIR_Done,
     /* 112328 */ // Label 2425: @112328
     /* 112328 */ GIM_Reject,
     /* 112329 */ // Label 2407: @112329
     /* 112329 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(112355), // Rule ID 12590 //
     /* 112334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 112340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 112348 */   // (sext:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2DZ128rk:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)
     /* 112348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ128rk),
     /* 112353 */   GIR_RootConstrainSelectedInstOperands,
     /* 112354 */   // GIR_Coverage, 12590,
     /* 112354 */   GIR_Done,
     /* 112355 */ // Label 2426: @112355
     /* 112355 */ GIM_Reject,
     /* 112356 */ // Label 2408: @112356
     /* 112356 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(112415), // Rule ID 18389 //
     /* 112361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112371 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112375 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112379 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112382 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112386 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112390 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112392 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112399 */   // (sext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 112399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrm),
     /* 112402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112404 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112408 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112413 */   GIR_RootConstrainSelectedInstOperands,
     /* 112414 */   // GIR_Coverage, 18389,
     /* 112414 */   GIR_EraseRootFromParent_Done,
     /* 112415 */ // Label 2427: @112415
     /* 112415 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(112474), // Rule ID 21584 //
     /* 112420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 112423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112430 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112434 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112438 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112441 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112445 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112449 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112451 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112458 */   // (sext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 112458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rm),
     /* 112461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112463 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112467 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112472 */   GIR_RootConstrainSelectedInstOperands,
     /* 112473 */   // GIR_Coverage, 21584,
     /* 112473 */   GIR_EraseRootFromParent_Done,
     /* 112474 */ // Label 2428: @112474
     /* 112474 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(112500), // Rule ID 12570 //
     /* 112479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 112482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112493 */   // (sext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 112493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rr),
     /* 112498 */   GIR_RootConstrainSelectedInstOperands,
     /* 112499 */   // GIR_Coverage, 12570,
     /* 112499 */   GIR_Done,
     /* 112500 */ // Label 2429: @112500
     /* 112500 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(112526), // Rule ID 12592 //
     /* 112505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 112511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 112519 */   // (sext:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2QZ256rk:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)
     /* 112519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ256rk),
     /* 112524 */   GIR_RootConstrainSelectedInstOperands,
     /* 112525 */   // GIR_Coverage, 12592,
     /* 112525 */   GIR_Done,
     /* 112526 */ // Label 2430: @112526
     /* 112526 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(112552), // Rule ID 18377 //
     /* 112531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 112545 */   // (sext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 112545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrr),
     /* 112550 */   GIR_RootConstrainSelectedInstOperands,
     /* 112551 */   // GIR_Coverage, 18377,
     /* 112551 */   GIR_Done,
     /* 112552 */ // Label 2431: @112552
     /* 112552 */ GIM_Reject,
     /* 112553 */ // Label 2409: @112553
     /* 112553 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(112621),
     /* 112558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 112561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 112569 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(112584), // Rule ID 12587 //
     /* 112574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 112577 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2WZ128rk:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)
     /* 112577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ128rk),
     /* 112582 */     GIR_RootConstrainSelectedInstOperands,
     /* 112583 */     // GIR_Coverage, 12587,
     /* 112583 */     GIR_Done,
     /* 112584 */   // Label 2433: @112584
     /* 112584 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(112620), // Rule ID 21660 //
     /* 112589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX_NoBWI),
     /* 112592 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src))
     /* 112592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 112595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 112599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 112613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112618 */     GIR_RootConstrainSelectedInstOperands,
     /* 112619 */     // GIR_Coverage, 21660,
     /* 112619 */     GIR_EraseRootFromParent_Done,
     /* 112620 */   // Label 2434: @112620
     /* 112620 */   GIM_Reject,
     /* 112621 */ // Label 2432: @112621
     /* 112621 */ GIM_Reject,
     /* 112622 */ // Label 2410: @112622
     /* 112622 */ GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(112681), // Rule ID 18385 //
     /* 112627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112637 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112641 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112645 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112648 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112652 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112656 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112658 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112665 */   // (sext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 112665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrm),
     /* 112668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112670 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112674 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112679 */   GIR_RootConstrainSelectedInstOperands,
     /* 112680 */   // GIR_Coverage, 18385,
     /* 112680 */   GIR_EraseRootFromParent_Done,
     /* 112681 */ // Label 2435: @112681
     /* 112681 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(112740), // Rule ID 21583 //
     /* 112686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 112689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112696 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112704 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112707 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112711 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112715 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112717 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112724 */   // (sext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 112724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rm),
     /* 112727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112729 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112733 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112738 */   GIR_RootConstrainSelectedInstOperands,
     /* 112739 */   // GIR_Coverage, 21583,
     /* 112739 */   GIR_EraseRootFromParent_Done,
     /* 112740 */ // Label 2436: @112740
     /* 112740 */ GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(112766), // Rule ID 12534 //
     /* 112745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 112748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112759 */   // (sext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 112759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rr),
     /* 112764 */   GIR_RootConstrainSelectedInstOperands,
     /* 112765 */   // GIR_Coverage, 12534,
     /* 112765 */   GIR_Done,
     /* 112766 */ // Label 2437: @112766
     /* 112766 */ GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(112792), // Rule ID 12589 //
     /* 112771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 112777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 112785 */   // (sext:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)
     /* 112785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 112790 */   GIR_RootConstrainSelectedInstOperands,
     /* 112791 */   // GIR_Coverage, 12589,
     /* 112791 */   GIR_Done,
     /* 112792 */ // Label 2438: @112792
     /* 112792 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(112818), // Rule ID 18375 //
     /* 112797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 112811 */   // (sext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 112811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrr),
     /* 112816 */   GIR_RootConstrainSelectedInstOperands,
     /* 112817 */   // GIR_Coverage, 18375,
     /* 112817 */   GIR_Done,
     /* 112818 */ // Label 2439: @112818
     /* 112818 */ GIM_Reject,
     /* 112819 */ // Label 2411: @112819
     /* 112819 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(112878), // Rule ID 21588 //
     /* 112824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112842 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112845 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112849 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112853 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112855 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112862 */   // (sext:{ *:[v8i64] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 112862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrm),
     /* 112865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112867 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112876 */   GIR_RootConstrainSelectedInstOperands,
     /* 112877 */   // GIR_Coverage, 21588,
     /* 112877 */   GIR_EraseRootFromParent_Done,
     /* 112878 */ // Label 2440: @112878
     /* 112878 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(112937), // Rule ID 21589 //
     /* 112883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 112889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112893 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112897 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112901 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112904 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112908 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112912 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112914 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112921 */   // (sext:{ *:[v8i64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 112921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrm),
     /* 112924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112926 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112930 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112935 */   GIR_RootConstrainSelectedInstOperands,
     /* 112936 */   // GIR_Coverage, 21589,
     /* 112936 */   GIR_EraseRootFromParent_Done,
     /* 112937 */ // Label 2441: @112937
     /* 112937 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(112963), // Rule ID 12558 //
     /* 112942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112956 */   // (sext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 112956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrr),
     /* 112961 */   GIR_RootConstrainSelectedInstOperands,
     /* 112962 */   // GIR_Coverage, 12558,
     /* 112962 */   GIR_Done,
     /* 112963 */ // Label 2442: @112963
     /* 112963 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(112989), // Rule ID 12576 //
     /* 112968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 112974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112982 */   // (sext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVSXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 112982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrr),
     /* 112987 */   GIR_RootConstrainSelectedInstOperands,
     /* 112988 */   // GIR_Coverage, 12576,
     /* 112988 */   GIR_Done,
     /* 112989 */ // Label 2443: @112989
     /* 112989 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(113015), // Rule ID 12591 //
     /* 112994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 112997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 113000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 113008 */   // (sext:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2QZrk:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)
     /* 113008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZrk),
     /* 113013 */   GIR_RootConstrainSelectedInstOperands,
     /* 113014 */   // GIR_Coverage, 12591,
     /* 113014 */   GIR_Done,
     /* 113015 */ // Label 2444: @113015
     /* 113015 */ GIM_Reject,
     /* 113016 */ // Label 2412: @113016
     /* 113016 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(113084),
     /* 113021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113032 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(113047), // Rule ID 12584 //
     /* 113037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113040 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2BZ128rk:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)
     /* 113040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ128rk),
     /* 113045 */     GIR_RootConstrainSelectedInstOperands,
     /* 113046 */     // GIR_Coverage, 12584,
     /* 113046 */     GIR_Done,
     /* 113047 */   // Label 2446: @113047
     /* 113047 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(113083), // Rule ID 21658 //
     /* 113052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 113055 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 113055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 113058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113067 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 113076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113081 */     GIR_RootConstrainSelectedInstOperands,
     /* 113082 */     // GIR_Coverage, 21658,
     /* 113082 */     GIR_EraseRootFromParent_Done,
     /* 113083 */   // Label 2447: @113083
     /* 113083 */   GIM_Reject,
     /* 113084 */ // Label 2445: @113084
     /* 113084 */ GIM_Reject,
     /* 113085 */ // Label 2413: @113085
     /* 113085 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(113144), // Rule ID 18379 //
     /* 113090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 113093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113100 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113104 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113108 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113111 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113115 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113119 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113121 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113128 */   // (sext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 113128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrm),
     /* 113131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113133 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113137 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113142 */   GIR_RootConstrainSelectedInstOperands,
     /* 113143 */   // GIR_Coverage, 18379,
     /* 113143 */   GIR_EraseRootFromParent_Done,
     /* 113144 */ // Label 2448: @113144
     /* 113144 */ GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(113203), // Rule ID 21582 //
     /* 113149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113159 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113163 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113167 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113170 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113174 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113178 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113180 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113187 */   // (sext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 113187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rm),
     /* 113190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113192 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113196 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113201 */   GIR_RootConstrainSelectedInstOperands,
     /* 113202 */   // GIR_Coverage, 21582,
     /* 113202 */   GIR_EraseRootFromParent_Done,
     /* 113203 */ // Label 2449: @113203
     /* 113203 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(113229), // Rule ID 12480 //
     /* 113208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113222 */   // (sext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 113222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rr),
     /* 113227 */   GIR_RootConstrainSelectedInstOperands,
     /* 113228 */   // GIR_Coverage, 12480,
     /* 113228 */   GIR_Done,
     /* 113229 */ // Label 2450: @113229
     /* 113229 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(113255), // Rule ID 12586 //
     /* 113234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113248 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2WZ256rk:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)
     /* 113248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ256rk),
     /* 113253 */   GIR_RootConstrainSelectedInstOperands,
     /* 113254 */   // GIR_Coverage, 12586,
     /* 113254 */   GIR_Done,
     /* 113255 */ // Label 2451: @113255
     /* 113255 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(113281), // Rule ID 18372 //
     /* 113260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 113263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 113274 */   // (sext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 113274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrr),
     /* 113279 */   GIR_RootConstrainSelectedInstOperands,
     /* 113280 */   // GIR_Coverage, 18372,
     /* 113280 */   GIR_Done,
     /* 113281 */ // Label 2452: @113281
     /* 113281 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(113328), // Rule ID 21659 //
     /* 113286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 113289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113300 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 113300 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 113303 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113307 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113312 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 113321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113326 */   GIR_RootConstrainSelectedInstOperands,
     /* 113327 */   // GIR_Coverage, 21659,
     /* 113327 */   GIR_EraseRootFromParent_Done,
     /* 113328 */ // Label 2453: @113328
     /* 113328 */ GIM_Reject,
     /* 113329 */ // Label 2414: @113329
     /* 113329 */ GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(113388), // Rule ID 21586 //
     /* 113334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113344 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113348 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113352 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113355 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113359 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113363 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113365 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113372 */   // (sext:{ *:[v16i32] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 113372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrm),
     /* 113375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113377 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113381 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113386 */   GIR_RootConstrainSelectedInstOperands,
     /* 113387 */   // GIR_Coverage, 21586,
     /* 113387 */   GIR_EraseRootFromParent_Done,
     /* 113388 */ // Label 2454: @113388
     /* 113388 */ GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(113447), // Rule ID 21587 //
     /* 113393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 113399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113403 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113407 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113411 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113414 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113418 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113422 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113424 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113431 */   // (sext:{ *:[v16i32] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 113431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrm),
     /* 113434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113436 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113445 */   GIR_RootConstrainSelectedInstOperands,
     /* 113446 */   // GIR_Coverage, 21587,
     /* 113446 */   GIR_EraseRootFromParent_Done,
     /* 113447 */ // Label 2455: @113447
     /* 113447 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(113473), // Rule ID 12504 //
     /* 113452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113466 */   // (sext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 113466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrr),
     /* 113471 */   GIR_RootConstrainSelectedInstOperands,
     /* 113472 */   // GIR_Coverage, 12504,
     /* 113472 */   GIR_Done,
     /* 113473 */ // Label 2456: @113473
     /* 113473 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(113499), // Rule ID 12540 //
     /* 113478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 113484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113492 */   // (sext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVSXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 113492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrr),
     /* 113497 */   GIR_RootConstrainSelectedInstOperands,
     /* 113498 */   // GIR_Coverage, 12540,
     /* 113498 */   GIR_Done,
     /* 113499 */ // Label 2457: @113499
     /* 113499 */ GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(113525), // Rule ID 12588 //
     /* 113504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 113507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113518 */   // (sext:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)
     /* 113518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113523 */   GIR_RootConstrainSelectedInstOperands,
     /* 113524 */   // GIR_Coverage, 12588,
     /* 113524 */   GIR_Done,
     /* 113525 */ // Label 2458: @113525
     /* 113525 */ GIM_Reject,
     /* 113526 */ // Label 2415: @113526
     /* 113526 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(113552), // Rule ID 12583 //
     /* 113531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 113537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 113545 */   // (sext:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2BZ256rk:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)
     /* 113545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ256rk),
     /* 113550 */   GIR_RootConstrainSelectedInstOperands,
     /* 113551 */   // GIR_Coverage, 12583,
     /* 113551 */   GIR_Done,
     /* 113552 */ // Label 2459: @113552
     /* 113552 */ GIM_Reject,
     /* 113553 */ // Label 2416: @113553
     /* 113553 */ GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(113612), // Rule ID 21585 //
     /* 113558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 113564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113568 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113572 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113576 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113579 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113583 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113587 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113589 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113596 */   // (sext:{ *:[v32i16] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 113596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrm),
     /* 113599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113601 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113605 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113610 */   GIR_RootConstrainSelectedInstOperands,
     /* 113611 */   // GIR_Coverage, 21585,
     /* 113611 */   GIR_EraseRootFromParent_Done,
     /* 113612 */ // Label 2460: @113612
     /* 113612 */ GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(113638), // Rule ID 12486 //
     /* 113617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 113623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113631 */   // (sext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVSXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 113631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrr),
     /* 113636 */   GIR_RootConstrainSelectedInstOperands,
     /* 113637 */   // GIR_Coverage, 12486,
     /* 113637 */   GIR_Done,
     /* 113638 */ // Label 2461: @113638
     /* 113638 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(113664), // Rule ID 12585 //
     /* 113643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 113649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 113657 */   // (sext:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2WZrk:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)
     /* 113657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZrk),
     /* 113662 */   GIR_RootConstrainSelectedInstOperands,
     /* 113663 */   // GIR_Coverage, 12585,
     /* 113663 */   GIR_Done,
     /* 113664 */ // Label 2462: @113664
     /* 113664 */ GIM_Reject,
     /* 113665 */ // Label 2417: @113665
     /* 113665 */ GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(113691), // Rule ID 12582 //
     /* 113670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 113676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 113684 */   // (sext:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)  =>  (VPMOVM2BZrk:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)
     /* 113684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZrk),
     /* 113689 */   GIR_RootConstrainSelectedInstOperands,
     /* 113690 */   // GIR_Coverage, 12582,
     /* 113690 */   GIR_Done,
     /* 113691 */ // Label 2463: @113691
     /* 113691 */ GIM_Reject,
     /* 113692 */ // Label 2418: @113692
     /* 113692 */ GIM_Reject,
     /* 113693 */ // Label 24: @113693
     /* 113693 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2466*/ GIMT_Encode4(113934),
     /* 113704 */ /*GILLT_s16*//*Label 2464*/ GIMT_Encode4(113712),
     /* 113708 */ /*GILLT_s32*//*Label 2465*/ GIMT_Encode4(113808),
     /* 113712 */ // Label 2464: @113712
     /* 113712 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(113807), // Rule ID 22640 //
     /* 113717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113728 */   // MIs[0] Operand 2
     /* 113728 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 113739 */   // (sext_inreg:{ *:[i16] } GR16:{ *:[i16] }:$src, i8:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /* 113739 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 113742 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113746 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113751 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 113757 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 113762 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 113767 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113770 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 113774 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113779 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 113782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113789 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 113796 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 113801 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 113806 */   // GIR_Coverage, 22640,
     /* 113806 */   GIR_EraseRootFromParent_Done,
     /* 113807 */ // Label 2467: @113807
     /* 113807 */ GIM_Reject,
     /* 113808 */ // Label 2465: @113808
     /* 113808 */ GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(113933),
     /* 113813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 113820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 113824 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(113878), // Rule ID 22638 //
     /* 113829 */     // MIs[0] Operand 2
     /* 113829 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 113840 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (MOVSX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] }))
     /* 113840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113852 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 113858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 113863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 113868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 113871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113876 */     GIR_RootConstrainSelectedInstOperands,
     /* 113877 */     // GIR_Coverage, 22638,
     /* 113877 */     GIR_EraseRootFromParent_Done,
     /* 113878 */   // Label 2469: @113878
     /* 113878 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(113932), // Rule ID 22639 //
     /* 113883 */     // MIs[0] Operand 2
     /* 113883 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 113894 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] }))
     /* 113894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 113897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113906 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 113912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 113917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 113922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 113925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113930 */     GIR_RootConstrainSelectedInstOperands,
     /* 113931 */     // GIR_Coverage, 22639,
     /* 113931 */     GIR_EraseRootFromParent_Done,
     /* 113932 */   // Label 2470: @113932
     /* 113932 */   GIM_Reject,
     /* 113933 */ // Label 2468: @113933
     /* 113933 */ GIM_Reject,
     /* 113934 */ // Label 2466: @113934
     /* 113934 */ GIM_Reject,
     /* 113935 */ // Label 25: @113935
     /* 113935 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2480*/ GIMT_Encode4(115918),
     /* 113946 */ /*GILLT_s16*//*Label 2471*/ GIMT_Encode4(114030),
     /* 113950 */ /*GILLT_s32*//*Label 2472*/ GIMT_Encode4(114088),
     /* 113954 */ /*GILLT_s64*//*Label 2473*/ GIMT_Encode4(114440), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113982 */ /*GILLT_v4s64*//*Label 2474*/ GIMT_Encode4(114987), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113994 */ /*GILLT_v8s32*//*Label 2475*/ GIMT_Encode4(115155),
     /* 113998 */ /*GILLT_v8s64*//*Label 2476*/ GIMT_Encode4(115323), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114010 */ /*GILLT_v16s16*//*Label 2477*/ GIMT_Encode4(115494),
     /* 114014 */ /*GILLT_v16s32*//*Label 2478*/ GIMT_Encode4(115662), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114026 */ /*GILLT_v32s16*//*Label 2479*/ GIMT_Encode4(115833),
     /* 114030 */ // Label 2471: @114030
     /* 114030 */ GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(114087), // Rule ID 22646 //
     /* 114035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114046 */   // (zext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 114046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114058 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114069 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 114076 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 114081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114086 */   // GIR_Coverage, 22646,
     /* 114086 */   GIR_EraseRootFromParent_Done,
     /* 114087 */ // Label 2481: @114087
     /* 114087 */ GIM_Reject,
     /* 114088 */ // Label 2472: @114088
     /* 114088 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(114211), // Rule ID 22970 //
     /* 114093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114111 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114115 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114119 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114123 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114127 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114130 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 114134 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 114138 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 114142 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114146 */   // MIs[3] Operand 1
     /* 114146 */   // No operand predicates
     /* 114146 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 114148 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114155 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rmi),
     /* 114162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114167 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src1
     /* 114171 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // src2
     /* 114174 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114177 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 114184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114210 */   // GIR_Coverage, 22970,
     /* 114210 */   GIR_EraseRootFromParent_Done,
     /* 114211 */ // Label 2482: @114211
     /* 114211 */ GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(114306), // Rule ID 22969 //
     /* 114216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114226 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114230 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114234 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114238 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114242 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114247 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114251 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114255 */   // MIs[2] Operand 1
     /* 114255 */   // No operand predicates
     /* 114255 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114257 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114257 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114260 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 114264 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114269 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 114273 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 114276 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114305 */   // GIR_Coverage, 22969,
     /* 114305 */   GIR_EraseRootFromParent_Done,
     /* 114306 */ // Label 2483: @114306
     /* 114306 */ GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(114348), // Rule ID 19434 //
     /* 114311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114318 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114322 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114326 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 114330 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 114335 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114337 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src)
     /* 114337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 114340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114342 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114346 */   GIR_RootConstrainSelectedInstOperands,
     /* 114347 */   // GIR_Coverage, 19434,
     /* 114347 */   GIR_EraseRootFromParent_Done,
     /* 114348 */ // Label 2484: @114348
     /* 114348 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(114393), // Rule ID 19437 //
     /* 114353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 114356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114363 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114367 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114371 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 114375 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 114380 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114382 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src)
     /* 114382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 114385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114387 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114391 */   GIR_RootConstrainSelectedInstOperands,
     /* 114392 */   // GIR_Coverage, 19437,
     /* 114392 */   GIR_EraseRootFromParent_Done,
     /* 114393 */ // Label 2485: @114393
     /* 114393 */ GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(114416), // Rule ID 618 //
     /* 114398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114409 */   // (zext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 114409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114414 */   GIR_RootConstrainSelectedInstOperands,
     /* 114415 */   // GIR_Coverage, 618,
     /* 114415 */   GIR_Done,
     /* 114416 */ // Label 2486: @114416
     /* 114416 */ GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(114439), // Rule ID 620 //
     /* 114421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114432 */   // (zext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 114432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 114437 */   GIR_RootConstrainSelectedInstOperands,
     /* 114438 */   // GIR_Coverage, 620,
     /* 114438 */   GIR_Done,
     /* 114439 */ // Label 2487: @114439
     /* 114439 */ GIM_Reject,
     /* 114440 */ // Label 2473: @114440
     /* 114440 */ GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(114563), // Rule ID 22972 //
     /* 114445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114455 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114459 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114463 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114467 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114471 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114475 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114479 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114482 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 114486 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 114490 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 114494 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114498 */   // MIs[3] Operand 1
     /* 114498 */   // No operand predicates
     /* 114498 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 114500 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114507 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114507 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114510 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rmi),
     /* 114514 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114519 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src1
     /* 114523 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // src2
     /* 114526 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114529 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 114536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114557 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114562 */   // GIR_Coverage, 22972,
     /* 114562 */   GIR_EraseRootFromParent_Done,
     /* 114563 */ // Label 2488: @114563
     /* 114563 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(114658), // Rule ID 22971 //
     /* 114568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114586 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114590 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114594 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114599 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114603 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114607 */   // MIs[2] Operand 1
     /* 114607 */   // No operand predicates
     /* 114607 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114609 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114609 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114612 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 114616 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114621 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 114625 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 114628 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114652 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114657 */   // GIR_Coverage, 22971,
     /* 114657 */   GIR_EraseRootFromParent_Done,
     /* 114658 */ // Label 2489: @114658
     /* 114658 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(114732), // Rule ID 19435 //
     /* 114663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114670 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114674 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114678 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 114682 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 114687 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114689 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src), sub_32bit:{ *:[i32] })
     /* 114689 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114692 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 114696 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114701 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114721 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114731 */   // GIR_Coverage, 19435,
     /* 114731 */   GIR_EraseRootFromParent_Done,
     /* 114732 */ // Label 2490: @114732
     /* 114732 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(114809), // Rule ID 19438 //
     /* 114737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 114740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114747 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114751 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114755 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 114759 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 114764 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114766 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src), sub_32bit:{ *:[i32] })
     /* 114766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 114773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114778 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114792 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114803 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114808 */   // GIR_Coverage, 19438,
     /* 114808 */   GIR_EraseRootFromParent_Done,
     /* 114809 */ // Label 2491: @114809
     /* 114809 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(114868), // Rule ID 17589 //
     /* 114814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114825 */   // (zext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 114825 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114828 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114832 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114837 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114857 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114862 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114867 */   // GIR_Coverage, 17589,
     /* 114867 */   GIR_EraseRootFromParent_Done,
     /* 114868 */ // Label 2492: @114868
     /* 114868 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(114927), // Rule ID 17591 //
     /* 114873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114884 */   // (zext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 114884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 114891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114896 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114910 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114916 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114926 */   // GIR_Coverage, 17591,
     /* 114926 */   GIR_EraseRootFromParent_Done,
     /* 114927 */ // Label 2493: @114927
     /* 114927 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(114986), // Rule ID 17593 //
     /* 114932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114943 */   // (zext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src), sub_32bit:{ *:[i32] })
     /* 114943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 114950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114955 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114975 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114980 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114985 */   // GIR_Coverage, 17593,
     /* 114985 */   GIR_EraseRootFromParent_Done,
     /* 114986 */ // Label 2494: @114986
     /* 114986 */ GIM_Reject,
     /* 114987 */ // Label 2474: @114987
     /* 114987 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(115154),
     /* 114992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114995 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(115051), // Rule ID 18412 //
     /* 115000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115015 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115018 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115022 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115035 */     // (zext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 115035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrm),
     /* 115038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115040 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115049 */     GIR_RootConstrainSelectedInstOperands,
     /* 115050 */     // GIR_Coverage, 18412,
     /* 115050 */     GIR_EraseRootFromParent_Done,
     /* 115051 */   // Label 2496: @115051
     /* 115051 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(115107), // Rule ID 21617 //
     /* 115056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 115059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115071 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115091 */     // (zext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 115091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rm),
     /* 115094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115096 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115105 */     GIR_RootConstrainSelectedInstOperands,
     /* 115106 */     // GIR_Coverage, 21617,
     /* 115106 */     GIR_EraseRootFromParent_Done,
     /* 115107 */   // Label 2497: @115107
     /* 115107 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(115130), // Rule ID 12462 //
     /* 115112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 115115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115123 */     // (zext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 115123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rr),
     /* 115128 */     GIR_RootConstrainSelectedInstOperands,
     /* 115129 */     // GIR_Coverage, 12462,
     /* 115129 */     GIR_Done,
     /* 115130 */   // Label 2498: @115130
     /* 115130 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(115153), // Rule ID 18400 //
     /* 115135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115146 */     // (zext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 115146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrr),
     /* 115151 */     GIR_RootConstrainSelectedInstOperands,
     /* 115152 */     // GIR_Coverage, 18400,
     /* 115152 */     GIR_Done,
     /* 115153 */   // Label 2499: @115153
     /* 115153 */   GIM_Reject,
     /* 115154 */ // Label 2495: @115154
     /* 115154 */ GIM_Reject,
     /* 115155 */ // Label 2475: @115155
     /* 115155 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(115322),
     /* 115160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115163 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(115219), // Rule ID 18408 //
     /* 115168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115183 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115190 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115203 */     // (zext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 115203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrm),
     /* 115206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115217 */     GIR_RootConstrainSelectedInstOperands,
     /* 115218 */     // GIR_Coverage, 18408,
     /* 115218 */     GIR_EraseRootFromParent_Done,
     /* 115219 */   // Label 2501: @115219
     /* 115219 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(115275), // Rule ID 21616 //
     /* 115224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 115227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115239 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115242 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115246 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115259 */     // (zext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 115259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rm),
     /* 115262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115273 */     GIR_RootConstrainSelectedInstOperands,
     /* 115274 */     // GIR_Coverage, 21616,
     /* 115274 */     GIR_EraseRootFromParent_Done,
     /* 115275 */   // Label 2502: @115275
     /* 115275 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(115298), // Rule ID 12426 //
     /* 115280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 115283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115291 */     // (zext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 115291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rr),
     /* 115296 */     GIR_RootConstrainSelectedInstOperands,
     /* 115297 */     // GIR_Coverage, 12426,
     /* 115297 */     GIR_Done,
     /* 115298 */   // Label 2503: @115298
     /* 115298 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(115321), // Rule ID 18398 //
     /* 115303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115314 */     // (zext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 115314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrr),
     /* 115319 */     GIR_RootConstrainSelectedInstOperands,
     /* 115320 */     // GIR_Coverage, 18398,
     /* 115320 */     GIR_Done,
     /* 115321 */   // Label 2504: @115321
     /* 115321 */   GIM_Reject,
     /* 115322 */ // Label 2500: @115322
     /* 115322 */ GIM_Reject,
     /* 115323 */ // Label 2476: @115323
     /* 115323 */ GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(115382), // Rule ID 21621 //
     /* 115328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115338 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115342 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115346 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115349 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115353 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115357 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115359 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115366 */   // (zext:{ *:[v8i64] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 115366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrm),
     /* 115369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115371 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115375 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115380 */   GIR_RootConstrainSelectedInstOperands,
     /* 115381 */   // GIR_Coverage, 21621,
     /* 115381 */   GIR_EraseRootFromParent_Done,
     /* 115382 */ // Label 2505: @115382
     /* 115382 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(115441), // Rule ID 21622 //
     /* 115387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 115393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115405 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115408 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115412 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115416 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115418 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115425 */   // (zext:{ *:[v8i64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 115425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrm),
     /* 115428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115430 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115434 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115439 */   GIR_RootConstrainSelectedInstOperands,
     /* 115440 */   // GIR_Coverage, 21622,
     /* 115440 */   GIR_EraseRootFromParent_Done,
     /* 115441 */ // Label 2506: @115441
     /* 115441 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(115467), // Rule ID 12450 //
     /* 115446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115460 */   // (zext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 115460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrr),
     /* 115465 */   GIR_RootConstrainSelectedInstOperands,
     /* 115466 */   // GIR_Coverage, 12450,
     /* 115466 */   GIR_Done,
     /* 115467 */ // Label 2507: @115467
     /* 115467 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(115493), // Rule ID 12468 //
     /* 115472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 115478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115486 */   // (zext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVZXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 115486 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrr),
     /* 115491 */   GIR_RootConstrainSelectedInstOperands,
     /* 115492 */   // GIR_Coverage, 12468,
     /* 115492 */   GIR_Done,
     /* 115493 */ // Label 2508: @115493
     /* 115493 */ GIM_Reject,
     /* 115494 */ // Label 2477: @115494
     /* 115494 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(115661),
     /* 115499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115502 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(115558), // Rule ID 18402 //
     /* 115507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 115510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115529 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115542 */     // (zext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 115542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrm),
     /* 115545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115556 */     GIR_RootConstrainSelectedInstOperands,
     /* 115557 */     // GIR_Coverage, 18402,
     /* 115557 */     GIR_EraseRootFromParent_Done,
     /* 115558 */   // Label 2510: @115558
     /* 115558 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(115614), // Rule ID 21615 //
     /* 115563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 115566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115578 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115585 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115598 */     // (zext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 115598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rm),
     /* 115601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115612 */     GIR_RootConstrainSelectedInstOperands,
     /* 115613 */     // GIR_Coverage, 21615,
     /* 115613 */     GIR_EraseRootFromParent_Done,
     /* 115614 */   // Label 2511: @115614
     /* 115614 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(115637), // Rule ID 12372 //
     /* 115619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 115622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115630 */     // (zext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 115630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rr),
     /* 115635 */     GIR_RootConstrainSelectedInstOperands,
     /* 115636 */     // GIR_Coverage, 12372,
     /* 115636 */     GIR_Done,
     /* 115637 */   // Label 2512: @115637
     /* 115637 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(115660), // Rule ID 18395 //
     /* 115642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 115645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115653 */     // (zext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 115653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrr),
     /* 115658 */     GIR_RootConstrainSelectedInstOperands,
     /* 115659 */     // GIR_Coverage, 18395,
     /* 115659 */     GIR_Done,
     /* 115660 */   // Label 2513: @115660
     /* 115660 */   GIM_Reject,
     /* 115661 */ // Label 2509: @115661
     /* 115661 */ GIM_Reject,
     /* 115662 */ // Label 2478: @115662
     /* 115662 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(115721), // Rule ID 21619 //
     /* 115667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115677 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115681 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115685 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115688 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115692 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115696 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115698 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115705 */   // (zext:{ *:[v16i32] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 115705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrm),
     /* 115708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115710 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115719 */   GIR_RootConstrainSelectedInstOperands,
     /* 115720 */   // GIR_Coverage, 21619,
     /* 115720 */   GIR_EraseRootFromParent_Done,
     /* 115721 */ // Label 2514: @115721
     /* 115721 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(115780), // Rule ID 21620 //
     /* 115726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 115732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115736 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115740 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115744 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115747 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115751 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115755 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115757 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115764 */   // (zext:{ *:[v16i32] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 115764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrm),
     /* 115767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115769 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115773 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115778 */   GIR_RootConstrainSelectedInstOperands,
     /* 115779 */   // GIR_Coverage, 21620,
     /* 115779 */   GIR_EraseRootFromParent_Done,
     /* 115780 */ // Label 2515: @115780
     /* 115780 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(115806), // Rule ID 12396 //
     /* 115785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115799 */   // (zext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 115799 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrr),
     /* 115804 */   GIR_RootConstrainSelectedInstOperands,
     /* 115805 */   // GIR_Coverage, 12396,
     /* 115805 */   GIR_Done,
     /* 115806 */ // Label 2516: @115806
     /* 115806 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(115832), // Rule ID 12432 //
     /* 115811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 115817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115825 */   // (zext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 115825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 115830 */   GIR_RootConstrainSelectedInstOperands,
     /* 115831 */   // GIR_Coverage, 12432,
     /* 115831 */   GIR_Done,
     /* 115832 */ // Label 2517: @115832
     /* 115832 */ GIM_Reject,
     /* 115833 */ // Label 2479: @115833
     /* 115833 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(115917),
     /* 115838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 115841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115845 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(115897), // Rule ID 21618 //
     /* 115850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 115853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115861 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115864 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115868 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115881 */     // (zext:{ *:[v32i16] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 115881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrm),
     /* 115884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115886 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115895 */     GIR_RootConstrainSelectedInstOperands,
     /* 115896 */     // GIR_Coverage, 21618,
     /* 115896 */     GIR_EraseRootFromParent_Done,
     /* 115897 */   // Label 2519: @115897
     /* 115897 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(115916), // Rule ID 12378 //
     /* 115902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 115905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115909 */     // (zext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVZXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 115909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrr),
     /* 115914 */     GIR_RootConstrainSelectedInstOperands,
     /* 115915 */     // GIR_Coverage, 12378,
     /* 115915 */     GIR_Done,
     /* 115916 */   // Label 2520: @115916
     /* 115916 */   GIM_Reject,
     /* 115917 */ // Label 2518: @115917
     /* 115917 */ GIM_Reject,
     /* 115918 */ // Label 2480: @115918
     /* 115918 */ GIM_Reject,
     /* 115919 */ // Label 26: @115919
     /* 115919 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2525*/ GIMT_Encode4(118202),
     /* 115930 */ /*GILLT_s8*//*Label 2521*/ GIMT_Encode4(115946),
     /* 115934 */ /*GILLT_s16*//*Label 2522*/ GIMT_Encode4(116321),
     /* 115938 */ /*GILLT_s32*//*Label 2523*/ GIMT_Encode4(116696),
     /* 115942 */ /*GILLT_s64*//*Label 2524*/ GIMT_Encode4(117449),
     /* 115946 */ // Label 2521: @115946
     /* 115946 */ GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(116320),
     /* 115951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 115954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 115957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 115961 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(116028), // Rule ID 672 //
     /* 115966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 115969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115977 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115980 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115984 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 115988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 115992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115996 */     // MIs[2] Operand 1
     /* 115996 */     // No operand predicates
     /* 115996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116005 */     // (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SHL8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mi_ND),
     /* 116008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116026 */     GIR_RootConstrainSelectedInstOperands,
     /* 116027 */     // GIR_Coverage, 672,
     /* 116027 */     GIR_EraseRootFromParent_Done,
     /* 116028 */   // Label 2527: @116028
     /* 116028 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(116101), // Rule ID 688 //
     /* 116033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116044 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116047 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116051 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 116055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116068 */     // (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SHL8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116072 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mCL_ND),
     /* 116085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116087 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116099 */     GIR_RootConstrainSelectedInstOperands,
     /* 116100 */     // GIR_Coverage, 688,
     /* 116100 */     GIR_EraseRootFromParent_Done,
     /* 116101 */   // Label 2528: @116101
     /* 116101 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(116131), // Rule ID 22671 //
     /* 116106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116117 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 116117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /* 116120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116124 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116129 */     GIR_RootConstrainSelectedInstOperands,
     /* 116130 */     // GIR_Coverage, 22671,
     /* 116130 */     GIR_EraseRootFromParent_Done,
     /* 116131 */   // Label 2529: @116131
     /* 116131 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(116161), // Rule ID 22675 //
     /* 116136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 116139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116147 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 116147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /* 116150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116152 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116154 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116159 */     GIR_RootConstrainSelectedInstOperands,
     /* 116160 */     // GIR_Coverage, 22675,
     /* 116160 */     GIR_EraseRootFromParent_Done,
     /* 116161 */   // Label 2530: @116161
     /* 116161 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(116198), // Rule ID 660 //
     /* 116166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116181 */     // MIs[1] Operand 1
     /* 116181 */     // No operand predicates
     /* 116181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116183 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri),
     /* 116186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116188 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116196 */     GIR_RootConstrainSelectedInstOperands,
     /* 116197 */     // GIR_Coverage, 660,
     /* 116197 */     GIR_EraseRootFromParent_Done,
     /* 116198 */   // Label 2531: @116198
     /* 116198 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(116235), // Rule ID 664 //
     /* 116203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116218 */     // MIs[1] Operand 1
     /* 116218 */     // No operand predicates
     /* 116218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116220 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri_ND),
     /* 116223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116225 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116233 */     GIR_RootConstrainSelectedInstOperands,
     /* 116234 */     // GIR_Coverage, 664,
     /* 116234 */     GIR_EraseRootFromParent_Done,
     /* 116235 */   // Label 2532: @116235
     /* 116235 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(116277), // Rule ID 676 //
     /* 116240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116251 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 116251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116255 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL),
     /* 116268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116275 */     GIR_RootConstrainSelectedInstOperands,
     /* 116276 */     // GIR_Coverage, 676,
     /* 116276 */     GIR_EraseRootFromParent_Done,
     /* 116277 */   // Label 2533: @116277
     /* 116277 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(116319), // Rule ID 680 //
     /* 116282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116293 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 116293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116297 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116303 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL_ND),
     /* 116310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116312 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116317 */     GIR_RootConstrainSelectedInstOperands,
     /* 116318 */     // GIR_Coverage, 680,
     /* 116318 */     GIR_EraseRootFromParent_Done,
     /* 116319 */   // Label 2534: @116319
     /* 116319 */   GIM_Reject,
     /* 116320 */ // Label 2526: @116320
     /* 116320 */ GIM_Reject,
     /* 116321 */ // Label 2522: @116321
     /* 116321 */ GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(116695),
     /* 116326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116336 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(116403), // Rule ID 673 //
     /* 116341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116352 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116359 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 116363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116371 */     // MIs[2] Operand 1
     /* 116371 */     // No operand predicates
     /* 116371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116380 */     // (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SHL16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mi_ND),
     /* 116383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116401 */     GIR_RootConstrainSelectedInstOperands,
     /* 116402 */     // GIR_Coverage, 673,
     /* 116402 */     GIR_EraseRootFromParent_Done,
     /* 116403 */   // Label 2536: @116403
     /* 116403 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(116476), // Rule ID 689 //
     /* 116408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116419 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116422 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116426 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 116430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116443 */     // (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SHL16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116447 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mCL_ND),
     /* 116460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116474 */     GIR_RootConstrainSelectedInstOperands,
     /* 116475 */     // GIR_Coverage, 689,
     /* 116475 */     GIR_EraseRootFromParent_Done,
     /* 116476 */   // Label 2537: @116476
     /* 116476 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(116506), // Rule ID 22672 //
     /* 116481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116492 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 116492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /* 116495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116497 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116504 */     GIR_RootConstrainSelectedInstOperands,
     /* 116505 */     // GIR_Coverage, 22672,
     /* 116505 */     GIR_EraseRootFromParent_Done,
     /* 116506 */   // Label 2538: @116506
     /* 116506 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(116536), // Rule ID 22676 //
     /* 116511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 116514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116522 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 116522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /* 116525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116527 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116529 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116534 */     GIR_RootConstrainSelectedInstOperands,
     /* 116535 */     // GIR_Coverage, 22676,
     /* 116535 */     GIR_EraseRootFromParent_Done,
     /* 116536 */   // Label 2539: @116536
     /* 116536 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(116573), // Rule ID 661 //
     /* 116541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116556 */     // MIs[1] Operand 1
     /* 116556 */     // No operand predicates
     /* 116556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116558 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri),
     /* 116561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116563 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116571 */     GIR_RootConstrainSelectedInstOperands,
     /* 116572 */     // GIR_Coverage, 661,
     /* 116572 */     GIR_EraseRootFromParent_Done,
     /* 116573 */   // Label 2540: @116573
     /* 116573 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(116610), // Rule ID 665 //
     /* 116578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116593 */     // MIs[1] Operand 1
     /* 116593 */     // No operand predicates
     /* 116593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116595 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri_ND),
     /* 116598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116600 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116608 */     GIR_RootConstrainSelectedInstOperands,
     /* 116609 */     // GIR_Coverage, 665,
     /* 116609 */     GIR_EraseRootFromParent_Done,
     /* 116610 */   // Label 2541: @116610
     /* 116610 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(116652), // Rule ID 677 //
     /* 116615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116626 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 116626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116630 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL),
     /* 116643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116650 */     GIR_RootConstrainSelectedInstOperands,
     /* 116651 */     // GIR_Coverage, 677,
     /* 116651 */     GIR_EraseRootFromParent_Done,
     /* 116652 */   // Label 2542: @116652
     /* 116652 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(116694), // Rule ID 681 //
     /* 116657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116668 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 116668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116672 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL_ND),
     /* 116685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116692 */     GIR_RootConstrainSelectedInstOperands,
     /* 116693 */     // GIR_Coverage, 681,
     /* 116693 */     GIR_EraseRootFromParent_Done,
     /* 116694 */   // Label 2543: @116694
     /* 116694 */   GIM_Reject,
     /* 116695 */ // Label 2535: @116695
     /* 116695 */ GIM_Reject,
     /* 116696 */ // Label 2523: @116696
     /* 116696 */ GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(117448),
     /* 116701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116711 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(116778), // Rule ID 674 //
     /* 116716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116727 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116730 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116734 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116746 */     // MIs[2] Operand 1
     /* 116746 */     // No operand predicates
     /* 116746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116755 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SHL32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mi_ND),
     /* 116758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116760 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116776 */     GIR_RootConstrainSelectedInstOperands,
     /* 116777 */     // GIR_Coverage, 674,
     /* 116777 */     GIR_EraseRootFromParent_Done,
     /* 116778 */   // Label 2545: @116778
     /* 116778 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(116851), // Rule ID 690 //
     /* 116783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116801 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116818 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHL32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116822 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mCL_ND),
     /* 116835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116849 */     GIR_RootConstrainSelectedInstOperands,
     /* 116850 */     // GIR_Coverage, 690,
     /* 116850 */     GIR_EraseRootFromParent_Done,
     /* 116851 */   // Label 2546: @116851
     /* 116851 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(116961), // Rule ID 17671 //
     /* 116856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 116859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116867 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116874 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116891 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 116891 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116894 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116898 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116917 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 116924 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 116927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 116932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 116937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 116942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rm),
     /* 116945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116959 */     GIR_RootConstrainSelectedInstOperands,
     /* 116960 */     // GIR_Coverage, 17671,
     /* 116960 */     GIR_EraseRootFromParent_Done,
     /* 116961 */   // Label 2547: @116961
     /* 116961 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(117071), // Rule ID 17703 //
     /* 116966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 116969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116977 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116980 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116984 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117001 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117001 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117004 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117008 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117027 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117034 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rm_EVEX),
     /* 117055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117057 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117069 */     GIR_RootConstrainSelectedInstOperands,
     /* 117070 */     // GIR_Coverage, 17703,
     /* 117070 */     GIR_EraseRootFromParent_Done,
     /* 117071 */   // Label 2548: @117071
     /* 117071 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(117101), // Rule ID 22673 //
     /* 117076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117087 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 117087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /* 117090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117094 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117099 */     GIR_RootConstrainSelectedInstOperands,
     /* 117100 */     // GIR_Coverage, 22673,
     /* 117100 */     GIR_EraseRootFromParent_Done,
     /* 117101 */   // Label 2549: @117101
     /* 117101 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(117131), // Rule ID 22677 //
     /* 117106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 117109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117117 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 117117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /* 117120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117124 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117129 */     GIR_RootConstrainSelectedInstOperands,
     /* 117130 */     // GIR_Coverage, 22677,
     /* 117130 */     GIR_EraseRootFromParent_Done,
     /* 117131 */   // Label 2550: @117131
     /* 117131 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(117168), // Rule ID 662 //
     /* 117136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117151 */     // MIs[1] Operand 1
     /* 117151 */     // No operand predicates
     /* 117151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117153 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri),
     /* 117156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117166 */     GIR_RootConstrainSelectedInstOperands,
     /* 117167 */     // GIR_Coverage, 662,
     /* 117167 */     GIR_EraseRootFromParent_Done,
     /* 117168 */   // Label 2551: @117168
     /* 117168 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(117205), // Rule ID 666 //
     /* 117173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117188 */     // MIs[1] Operand 1
     /* 117188 */     // No operand predicates
     /* 117188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117190 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri_ND),
     /* 117193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117203 */     GIR_RootConstrainSelectedInstOperands,
     /* 117204 */     // GIR_Coverage, 666,
     /* 117204 */     GIR_EraseRootFromParent_Done,
     /* 117205 */   // Label 2552: @117205
     /* 117205 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(117284), // Rule ID 17667 //
     /* 117210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117221 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117221 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117224 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117228 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117247 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117254 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr),
     /* 117275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117277 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117282 */     GIR_RootConstrainSelectedInstOperands,
     /* 117283 */     // GIR_Coverage, 17667,
     /* 117283 */     GIR_EraseRootFromParent_Done,
     /* 117284 */   // Label 2553: @117284
     /* 117284 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(117363), // Rule ID 17699 //
     /* 117289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117300 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117300 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117303 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117307 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117333 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr_EVEX),
     /* 117354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117356 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117361 */     GIR_RootConstrainSelectedInstOperands,
     /* 117362 */     // GIR_Coverage, 17699,
     /* 117362 */     GIR_EraseRootFromParent_Done,
     /* 117363 */   // Label 2554: @117363
     /* 117363 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(117405), // Rule ID 678 //
     /* 117368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117379 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 117379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117383 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117389 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL),
     /* 117396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117398 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117403 */     GIR_RootConstrainSelectedInstOperands,
     /* 117404 */     // GIR_Coverage, 678,
     /* 117404 */     GIR_EraseRootFromParent_Done,
     /* 117405 */   // Label 2555: @117405
     /* 117405 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(117447), // Rule ID 682 //
     /* 117410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117421 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 117421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117425 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117431 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL_ND),
     /* 117438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117440 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117445 */     GIR_RootConstrainSelectedInstOperands,
     /* 117446 */     // GIR_Coverage, 682,
     /* 117446 */     GIR_EraseRootFromParent_Done,
     /* 117447 */   // Label 2556: @117447
     /* 117447 */   GIM_Reject,
     /* 117448 */ // Label 2544: @117448
     /* 117448 */ GIM_Reject,
     /* 117449 */ // Label 2524: @117449
     /* 117449 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(118201),
     /* 117454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 117460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117464 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(117531), // Rule ID 675 //
     /* 117469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117480 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 117495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117499 */     // MIs[2] Operand 1
     /* 117499 */     // No operand predicates
     /* 117499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117508 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SHL64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mi_ND),
     /* 117511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 117520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117529 */     GIR_RootConstrainSelectedInstOperands,
     /* 117530 */     // GIR_Coverage, 675,
     /* 117530 */     GIR_EraseRootFromParent_Done,
     /* 117531 */   // Label 2558: @117531
     /* 117531 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(117604), // Rule ID 691 //
     /* 117536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117547 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117550 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117554 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117571 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHL64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 117571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117575 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117581 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mCL_ND),
     /* 117588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117590 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117594 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117602 */     GIR_RootConstrainSelectedInstOperands,
     /* 117603 */     // GIR_Coverage, 691,
     /* 117603 */     GIR_EraseRootFromParent_Done,
     /* 117604 */   // Label 2559: @117604
     /* 117604 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(117714), // Rule ID 17672 //
     /* 117609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117620 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117644 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rm),
     /* 117698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117712 */     GIR_RootConstrainSelectedInstOperands,
     /* 117713 */     // GIR_Coverage, 17672,
     /* 117713 */     GIR_EraseRootFromParent_Done,
     /* 117714 */   // Label 2560: @117714
     /* 117714 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(117824), // Rule ID 17704 //
     /* 117719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117730 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117733 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117754 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117754 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117757 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117761 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117780 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117783 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117787 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rm_EVEX),
     /* 117808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117822 */     GIR_RootConstrainSelectedInstOperands,
     /* 117823 */     // GIR_Coverage, 17704,
     /* 117823 */     GIR_EraseRootFromParent_Done,
     /* 117824 */   // Label 2561: @117824
     /* 117824 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(117854), // Rule ID 22674 //
     /* 117829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117840 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 117840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /* 117843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117845 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117847 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117852 */     GIR_RootConstrainSelectedInstOperands,
     /* 117853 */     // GIR_Coverage, 22674,
     /* 117853 */     GIR_EraseRootFromParent_Done,
     /* 117854 */   // Label 2562: @117854
     /* 117854 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(117884), // Rule ID 22678 //
     /* 117859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 117862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117870 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 117870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /* 117873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117875 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117882 */     GIR_RootConstrainSelectedInstOperands,
     /* 117883 */     // GIR_Coverage, 22678,
     /* 117883 */     GIR_EraseRootFromParent_Done,
     /* 117884 */   // Label 2563: @117884
     /* 117884 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(117921), // Rule ID 663 //
     /* 117889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117904 */     // MIs[1] Operand 1
     /* 117904 */     // No operand predicates
     /* 117904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117906 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri),
     /* 117909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117911 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117919 */     GIR_RootConstrainSelectedInstOperands,
     /* 117920 */     // GIR_Coverage, 663,
     /* 117920 */     GIR_EraseRootFromParent_Done,
     /* 117921 */   // Label 2564: @117921
     /* 117921 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(117958), // Rule ID 667 //
     /* 117926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117941 */     // MIs[1] Operand 1
     /* 117941 */     // No operand predicates
     /* 117941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117943 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri_ND),
     /* 117946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117948 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117956 */     GIR_RootConstrainSelectedInstOperands,
     /* 117957 */     // GIR_Coverage, 667,
     /* 117957 */     GIR_EraseRootFromParent_Done,
     /* 117958 */   // Label 2565: @117958
     /* 117958 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(118037), // Rule ID 17668 //
     /* 117963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117974 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117977 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117981 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118000 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118003 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118007 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr),
     /* 118028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118030 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118035 */     GIR_RootConstrainSelectedInstOperands,
     /* 118036 */     // GIR_Coverage, 17668,
     /* 118036 */     GIR_EraseRootFromParent_Done,
     /* 118037 */   // Label 2566: @118037
     /* 118037 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(118116), // Rule ID 17700 //
     /* 118042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 118045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118053 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 118053 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 118056 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118060 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118079 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118086 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr_EVEX),
     /* 118107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118109 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118114 */     GIR_RootConstrainSelectedInstOperands,
     /* 118115 */     // GIR_Coverage, 17700,
     /* 118115 */     GIR_EraseRootFromParent_Done,
     /* 118116 */   // Label 2567: @118116
     /* 118116 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(118158), // Rule ID 679 //
     /* 118121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118132 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 118132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118136 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL),
     /* 118149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118151 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118156 */     GIR_RootConstrainSelectedInstOperands,
     /* 118157 */     // GIR_Coverage, 679,
     /* 118157 */     GIR_EraseRootFromParent_Done,
     /* 118158 */   // Label 2568: @118158
     /* 118158 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(118200), // Rule ID 683 //
     /* 118163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118174 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 118174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118178 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL_ND),
     /* 118191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118193 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118198 */     GIR_RootConstrainSelectedInstOperands,
     /* 118199 */     // GIR_Coverage, 683,
     /* 118199 */     GIR_EraseRootFromParent_Done,
     /* 118200 */   // Label 2569: @118200
     /* 118200 */   GIM_Reject,
     /* 118201 */ // Label 2557: @118201
     /* 118201 */ GIM_Reject,
     /* 118202 */ // Label 2525: @118202
     /* 118202 */ GIM_Reject,
     /* 118203 */ // Label 27: @118203
     /* 118203 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2574*/ GIMT_Encode4(120246),
     /* 118214 */ /*GILLT_s8*//*Label 2570*/ GIMT_Encode4(118230),
     /* 118218 */ /*GILLT_s16*//*Label 2571*/ GIMT_Encode4(118545),
     /* 118222 */ /*GILLT_s32*//*Label 2572*/ GIMT_Encode4(118860),
     /* 118226 */ /*GILLT_s64*//*Label 2573*/ GIMT_Encode4(119553),
     /* 118230 */ // Label 2570: @118230
     /* 118230 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(118544),
     /* 118235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 118238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118245 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(118312), // Rule ID 704 //
     /* 118250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118261 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118264 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118268 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 118272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118280 */     // MIs[2] Operand 1
     /* 118280 */     // No operand predicates
     /* 118280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118289 */     // (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SHR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mi_ND),
     /* 118292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118294 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118310 */     GIR_RootConstrainSelectedInstOperands,
     /* 118311 */     // GIR_Coverage, 704,
     /* 118311 */     GIR_EraseRootFromParent_Done,
     /* 118312 */   // Label 2576: @118312
     /* 118312 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(118385), // Rule ID 720 //
     /* 118317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118328 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118335 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 118339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118352 */     // (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SHR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118356 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mCL_ND),
     /* 118369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118371 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118383 */     GIR_RootConstrainSelectedInstOperands,
     /* 118384 */     // GIR_Coverage, 720,
     /* 118384 */     GIR_EraseRootFromParent_Done,
     /* 118385 */   // Label 2577: @118385
     /* 118385 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(118422), // Rule ID 692 //
     /* 118390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118405 */     // MIs[1] Operand 1
     /* 118405 */     // No operand predicates
     /* 118405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118407 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri),
     /* 118410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118420 */     GIR_RootConstrainSelectedInstOperands,
     /* 118421 */     // GIR_Coverage, 692,
     /* 118421 */     GIR_EraseRootFromParent_Done,
     /* 118422 */   // Label 2578: @118422
     /* 118422 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(118459), // Rule ID 696 //
     /* 118427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118442 */     // MIs[1] Operand 1
     /* 118442 */     // No operand predicates
     /* 118442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118444 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri_ND),
     /* 118447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118449 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118457 */     GIR_RootConstrainSelectedInstOperands,
     /* 118458 */     // GIR_Coverage, 696,
     /* 118458 */     GIR_EraseRootFromParent_Done,
     /* 118459 */   // Label 2579: @118459
     /* 118459 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(118501), // Rule ID 708 //
     /* 118464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118475 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 118475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118479 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL),
     /* 118492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118494 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118499 */     GIR_RootConstrainSelectedInstOperands,
     /* 118500 */     // GIR_Coverage, 708,
     /* 118500 */     GIR_EraseRootFromParent_Done,
     /* 118501 */   // Label 2580: @118501
     /* 118501 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(118543), // Rule ID 712 //
     /* 118506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118517 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 118517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118521 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118527 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL_ND),
     /* 118534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118536 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118541 */     GIR_RootConstrainSelectedInstOperands,
     /* 118542 */     // GIR_Coverage, 712,
     /* 118542 */     GIR_EraseRootFromParent_Done,
     /* 118543 */   // Label 2581: @118543
     /* 118543 */   GIM_Reject,
     /* 118544 */ // Label 2575: @118544
     /* 118544 */ GIM_Reject,
     /* 118545 */ // Label 2571: @118545
     /* 118545 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(118859),
     /* 118550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 118553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118560 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(118627), // Rule ID 705 //
     /* 118565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118583 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 118587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118595 */     // MIs[2] Operand 1
     /* 118595 */     // No operand predicates
     /* 118595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118604 */     // (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SHR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mi_ND),
     /* 118607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118625 */     GIR_RootConstrainSelectedInstOperands,
     /* 118626 */     // GIR_Coverage, 705,
     /* 118626 */     GIR_EraseRootFromParent_Done,
     /* 118627 */   // Label 2583: @118627
     /* 118627 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(118700), // Rule ID 721 //
     /* 118632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118643 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118646 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118650 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 118654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118667 */     // (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SHR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118671 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mCL_ND),
     /* 118684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118686 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118698 */     GIR_RootConstrainSelectedInstOperands,
     /* 118699 */     // GIR_Coverage, 721,
     /* 118699 */     GIR_EraseRootFromParent_Done,
     /* 118700 */   // Label 2584: @118700
     /* 118700 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(118737), // Rule ID 693 //
     /* 118705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118720 */     // MIs[1] Operand 1
     /* 118720 */     // No operand predicates
     /* 118720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118722 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri),
     /* 118725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118727 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118735 */     GIR_RootConstrainSelectedInstOperands,
     /* 118736 */     // GIR_Coverage, 693,
     /* 118736 */     GIR_EraseRootFromParent_Done,
     /* 118737 */   // Label 2585: @118737
     /* 118737 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(118774), // Rule ID 697 //
     /* 118742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118757 */     // MIs[1] Operand 1
     /* 118757 */     // No operand predicates
     /* 118757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118759 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri_ND),
     /* 118762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118764 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118772 */     GIR_RootConstrainSelectedInstOperands,
     /* 118773 */     // GIR_Coverage, 697,
     /* 118773 */     GIR_EraseRootFromParent_Done,
     /* 118774 */   // Label 2586: @118774
     /* 118774 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(118816), // Rule ID 709 //
     /* 118779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118790 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 118790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118794 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118800 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL),
     /* 118807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118814 */     GIR_RootConstrainSelectedInstOperands,
     /* 118815 */     // GIR_Coverage, 709,
     /* 118815 */     GIR_EraseRootFromParent_Done,
     /* 118816 */   // Label 2587: @118816
     /* 118816 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(118858), // Rule ID 713 //
     /* 118821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118832 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 118832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118836 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL_ND),
     /* 118849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118851 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118856 */     GIR_RootConstrainSelectedInstOperands,
     /* 118857 */     // GIR_Coverage, 713,
     /* 118857 */     GIR_EraseRootFromParent_Done,
     /* 118858 */   // Label 2588: @118858
     /* 118858 */   GIM_Reject,
     /* 118859 */ // Label 2582: @118859
     /* 118859 */ GIM_Reject,
     /* 118860 */ // Label 2572: @118860
     /* 118860 */ GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(119552),
     /* 118865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 118875 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(118942), // Rule ID 706 //
     /* 118880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118891 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118894 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118898 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 118902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118910 */     // MIs[2] Operand 1
     /* 118910 */     // No operand predicates
     /* 118910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118919 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SHR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mi_ND),
     /* 118922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118924 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118940 */     GIR_RootConstrainSelectedInstOperands,
     /* 118941 */     // GIR_Coverage, 706,
     /* 118941 */     GIR_EraseRootFromParent_Done,
     /* 118942 */   // Label 2590: @118942
     /* 118942 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(119015), // Rule ID 722 //
     /* 118947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118958 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118965 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 118969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118982 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118986 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mCL_ND),
     /* 118999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119001 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119013 */     GIR_RootConstrainSelectedInstOperands,
     /* 119014 */     // GIR_Coverage, 722,
     /* 119014 */     GIR_EraseRootFromParent_Done,
     /* 119015 */   // Label 2591: @119015
     /* 119015 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(119125), // Rule ID 17663 //
     /* 119020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119031 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119034 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119038 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119055 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119055 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119058 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119062 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119081 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119088 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rm),
     /* 119109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119111 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119123 */     GIR_RootConstrainSelectedInstOperands,
     /* 119124 */     // GIR_Coverage, 17663,
     /* 119124 */     GIR_EraseRootFromParent_Done,
     /* 119125 */   // Label 2592: @119125
     /* 119125 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(119235), // Rule ID 17695 //
     /* 119130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119141 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119148 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119165 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119165 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119168 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119172 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119191 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119198 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rm_EVEX),
     /* 119219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119233 */     GIR_RootConstrainSelectedInstOperands,
     /* 119234 */     // GIR_Coverage, 17695,
     /* 119234 */     GIR_EraseRootFromParent_Done,
     /* 119235 */   // Label 2593: @119235
     /* 119235 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(119272), // Rule ID 694 //
     /* 119240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119255 */     // MIs[1] Operand 1
     /* 119255 */     // No operand predicates
     /* 119255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119257 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri),
     /* 119260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119262 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119270 */     GIR_RootConstrainSelectedInstOperands,
     /* 119271 */     // GIR_Coverage, 694,
     /* 119271 */     GIR_EraseRootFromParent_Done,
     /* 119272 */   // Label 2594: @119272
     /* 119272 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(119309), // Rule ID 698 //
     /* 119277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119292 */     // MIs[1] Operand 1
     /* 119292 */     // No operand predicates
     /* 119292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119294 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri_ND),
     /* 119297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119299 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119307 */     GIR_RootConstrainSelectedInstOperands,
     /* 119308 */     // GIR_Coverage, 698,
     /* 119308 */     GIR_EraseRootFromParent_Done,
     /* 119309 */   // Label 2595: @119309
     /* 119309 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(119388), // Rule ID 17659 //
     /* 119314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119325 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119325 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119328 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119332 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119351 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119358 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr),
     /* 119379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119381 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119386 */     GIR_RootConstrainSelectedInstOperands,
     /* 119387 */     // GIR_Coverage, 17659,
     /* 119387 */     GIR_EraseRootFromParent_Done,
     /* 119388 */   // Label 2596: @119388
     /* 119388 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(119467), // Rule ID 17691 //
     /* 119393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119404 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119404 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119407 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119411 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119430 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119433 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119437 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr_EVEX),
     /* 119458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119465 */     GIR_RootConstrainSelectedInstOperands,
     /* 119466 */     // GIR_Coverage, 17691,
     /* 119466 */     GIR_EraseRootFromParent_Done,
     /* 119467 */   // Label 2597: @119467
     /* 119467 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(119509), // Rule ID 710 //
     /* 119472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119483 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 119483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119487 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL),
     /* 119500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119507 */     GIR_RootConstrainSelectedInstOperands,
     /* 119508 */     // GIR_Coverage, 710,
     /* 119508 */     GIR_EraseRootFromParent_Done,
     /* 119509 */   // Label 2598: @119509
     /* 119509 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(119551), // Rule ID 714 //
     /* 119514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119525 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 119525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119529 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119535 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL_ND),
     /* 119542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119544 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119549 */     GIR_RootConstrainSelectedInstOperands,
     /* 119550 */     // GIR_Coverage, 714,
     /* 119550 */     GIR_EraseRootFromParent_Done,
     /* 119551 */   // Label 2599: @119551
     /* 119551 */   GIM_Reject,
     /* 119552 */ // Label 2589: @119552
     /* 119552 */ GIM_Reject,
     /* 119553 */ // Label 2573: @119553
     /* 119553 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(120245),
     /* 119558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 119564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119568 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(119635), // Rule ID 707 //
     /* 119573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119603 */     // MIs[2] Operand 1
     /* 119603 */     // No operand predicates
     /* 119603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119612 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SHR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mi_ND),
     /* 119615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119617 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 119624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119633 */     GIR_RootConstrainSelectedInstOperands,
     /* 119634 */     // GIR_Coverage, 707,
     /* 119634 */     GIR_EraseRootFromParent_Done,
     /* 119635 */   // Label 2601: @119635
     /* 119635 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(119708), // Rule ID 723 //
     /* 119640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119651 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119654 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119658 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119675 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 119675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119679 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mCL_ND),
     /* 119692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119694 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119706 */     GIR_RootConstrainSelectedInstOperands,
     /* 119707 */     // GIR_Coverage, 723,
     /* 119707 */     GIR_EraseRootFromParent_Done,
     /* 119708 */   // Label 2602: @119708
     /* 119708 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(119818), // Rule ID 17664 //
     /* 119713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119748 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119774 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119777 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119781 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rm),
     /* 119802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119816 */     GIR_RootConstrainSelectedInstOperands,
     /* 119817 */     // GIR_Coverage, 17664,
     /* 119817 */     GIR_EraseRootFromParent_Done,
     /* 119818 */   // Label 2603: @119818
     /* 119818 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(119928), // Rule ID 17696 //
     /* 119823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119834 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119837 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119841 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119858 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119858 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119861 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119865 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119884 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119891 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rm_EVEX),
     /* 119912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119914 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119926 */     GIR_RootConstrainSelectedInstOperands,
     /* 119927 */     // GIR_Coverage, 17696,
     /* 119927 */     GIR_EraseRootFromParent_Done,
     /* 119928 */   // Label 2604: @119928
     /* 119928 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(119965), // Rule ID 695 //
     /* 119933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119948 */     // MIs[1] Operand 1
     /* 119948 */     // No operand predicates
     /* 119948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119950 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri),
     /* 119953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119955 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119963 */     GIR_RootConstrainSelectedInstOperands,
     /* 119964 */     // GIR_Coverage, 695,
     /* 119964 */     GIR_EraseRootFromParent_Done,
     /* 119965 */   // Label 2605: @119965
     /* 119965 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(120002), // Rule ID 699 //
     /* 119970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119985 */     // MIs[1] Operand 1
     /* 119985 */     // No operand predicates
     /* 119985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119987 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri_ND),
     /* 119990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119992 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120000 */     GIR_RootConstrainSelectedInstOperands,
     /* 120001 */     // GIR_Coverage, 699,
     /* 120001 */     GIR_EraseRootFromParent_Done,
     /* 120002 */   // Label 2606: @120002
     /* 120002 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(120081), // Rule ID 17660 //
     /* 120007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 120010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120018 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120018 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120021 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120025 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120044 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr),
     /* 120072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120074 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120079 */     GIR_RootConstrainSelectedInstOperands,
     /* 120080 */     // GIR_Coverage, 17660,
     /* 120080 */     GIR_EraseRootFromParent_Done,
     /* 120081 */   // Label 2607: @120081
     /* 120081 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(120160), // Rule ID 17692 //
     /* 120086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 120089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120097 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120097 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120100 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120104 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120123 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120130 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr_EVEX),
     /* 120151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120153 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120158 */     GIR_RootConstrainSelectedInstOperands,
     /* 120159 */     // GIR_Coverage, 17692,
     /* 120159 */     GIR_EraseRootFromParent_Done,
     /* 120160 */   // Label 2608: @120160
     /* 120160 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(120202), // Rule ID 711 //
     /* 120165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120176 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 120176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120180 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL),
     /* 120193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120200 */     GIR_RootConstrainSelectedInstOperands,
     /* 120201 */     // GIR_Coverage, 711,
     /* 120201 */     GIR_EraseRootFromParent_Done,
     /* 120202 */   // Label 2609: @120202
     /* 120202 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(120244), // Rule ID 715 //
     /* 120207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120218 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 120218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120222 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL_ND),
     /* 120235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120237 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120242 */     GIR_RootConstrainSelectedInstOperands,
     /* 120243 */     // GIR_Coverage, 715,
     /* 120243 */     GIR_EraseRootFromParent_Done,
     /* 120244 */   // Label 2610: @120244
     /* 120244 */   GIM_Reject,
     /* 120245 */ // Label 2600: @120245
     /* 120245 */ GIM_Reject,
     /* 120246 */ // Label 2574: @120246
     /* 120246 */ GIM_Reject,
     /* 120247 */ // Label 28: @120247
     /* 120247 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2615*/ GIMT_Encode4(122290),
     /* 120258 */ /*GILLT_s8*//*Label 2611*/ GIMT_Encode4(120274),
     /* 120262 */ /*GILLT_s16*//*Label 2612*/ GIMT_Encode4(120589),
     /* 120266 */ /*GILLT_s32*//*Label 2613*/ GIMT_Encode4(120904),
     /* 120270 */ /*GILLT_s64*//*Label 2614*/ GIMT_Encode4(121597),
     /* 120274 */ // Label 2611: @120274
     /* 120274 */ GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(120588),
     /* 120279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 120282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120289 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(120356), // Rule ID 736 //
     /* 120294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120305 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120308 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120312 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 120316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120324 */     // MIs[2] Operand 1
     /* 120324 */     // No operand predicates
     /* 120324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120333 */     // (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SAR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mi_ND),
     /* 120336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120338 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120354 */     GIR_RootConstrainSelectedInstOperands,
     /* 120355 */     // GIR_Coverage, 736,
     /* 120355 */     GIR_EraseRootFromParent_Done,
     /* 120356 */   // Label 2617: @120356
     /* 120356 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(120429), // Rule ID 752 //
     /* 120361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120372 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120375 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120379 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 120383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120396 */     // (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SAR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 120396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120400 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mCL_ND),
     /* 120413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120415 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120427 */     GIR_RootConstrainSelectedInstOperands,
     /* 120428 */     // GIR_Coverage, 752,
     /* 120428 */     GIR_EraseRootFromParent_Done,
     /* 120429 */   // Label 2618: @120429
     /* 120429 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(120466), // Rule ID 724 //
     /* 120434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120449 */     // MIs[1] Operand 1
     /* 120449 */     // No operand predicates
     /* 120449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120451 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri),
     /* 120454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120456 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120464 */     GIR_RootConstrainSelectedInstOperands,
     /* 120465 */     // GIR_Coverage, 724,
     /* 120465 */     GIR_EraseRootFromParent_Done,
     /* 120466 */   // Label 2619: @120466
     /* 120466 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(120503), // Rule ID 728 //
     /* 120471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120486 */     // MIs[1] Operand 1
     /* 120486 */     // No operand predicates
     /* 120486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120488 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri_ND),
     /* 120491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120493 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120501 */     GIR_RootConstrainSelectedInstOperands,
     /* 120502 */     // GIR_Coverage, 728,
     /* 120502 */     GIR_EraseRootFromParent_Done,
     /* 120503 */   // Label 2620: @120503
     /* 120503 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(120545), // Rule ID 740 //
     /* 120508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120519 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 120519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120523 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL),
     /* 120536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120538 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120543 */     GIR_RootConstrainSelectedInstOperands,
     /* 120544 */     // GIR_Coverage, 740,
     /* 120544 */     GIR_EraseRootFromParent_Done,
     /* 120545 */   // Label 2621: @120545
     /* 120545 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(120587), // Rule ID 744 //
     /* 120550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120561 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 120561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120565 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL_ND),
     /* 120578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120580 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120585 */     GIR_RootConstrainSelectedInstOperands,
     /* 120586 */     // GIR_Coverage, 744,
     /* 120586 */     GIR_EraseRootFromParent_Done,
     /* 120587 */   // Label 2622: @120587
     /* 120587 */   GIM_Reject,
     /* 120588 */ // Label 2616: @120588
     /* 120588 */ GIM_Reject,
     /* 120589 */ // Label 2612: @120589
     /* 120589 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(120903),
     /* 120594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120604 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(120671), // Rule ID 737 //
     /* 120609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120620 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120623 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120627 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 120631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120639 */     // MIs[2] Operand 1
     /* 120639 */     // No operand predicates
     /* 120639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120648 */     // (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SAR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mi_ND),
     /* 120651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120653 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120669 */     GIR_RootConstrainSelectedInstOperands,
     /* 120670 */     // GIR_Coverage, 737,
     /* 120670 */     GIR_EraseRootFromParent_Done,
     /* 120671 */   // Label 2624: @120671
     /* 120671 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(120744), // Rule ID 753 //
     /* 120676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120687 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120690 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120694 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 120698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120711 */     // (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SAR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 120711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120715 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mCL_ND),
     /* 120728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120730 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120742 */     GIR_RootConstrainSelectedInstOperands,
     /* 120743 */     // GIR_Coverage, 753,
     /* 120743 */     GIR_EraseRootFromParent_Done,
     /* 120744 */   // Label 2625: @120744
     /* 120744 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(120781), // Rule ID 725 //
     /* 120749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120764 */     // MIs[1] Operand 1
     /* 120764 */     // No operand predicates
     /* 120764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120766 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri),
     /* 120769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120771 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120779 */     GIR_RootConstrainSelectedInstOperands,
     /* 120780 */     // GIR_Coverage, 725,
     /* 120780 */     GIR_EraseRootFromParent_Done,
     /* 120781 */   // Label 2626: @120781
     /* 120781 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(120818), // Rule ID 729 //
     /* 120786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120801 */     // MIs[1] Operand 1
     /* 120801 */     // No operand predicates
     /* 120801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120803 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri_ND),
     /* 120806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120808 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120816 */     GIR_RootConstrainSelectedInstOperands,
     /* 120817 */     // GIR_Coverage, 729,
     /* 120817 */     GIR_EraseRootFromParent_Done,
     /* 120818 */   // Label 2627: @120818
     /* 120818 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(120860), // Rule ID 741 //
     /* 120823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120834 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 120834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120838 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL),
     /* 120851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120853 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120858 */     GIR_RootConstrainSelectedInstOperands,
     /* 120859 */     // GIR_Coverage, 741,
     /* 120859 */     GIR_EraseRootFromParent_Done,
     /* 120860 */   // Label 2628: @120860
     /* 120860 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(120902), // Rule ID 745 //
     /* 120865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120876 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 120876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120880 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL_ND),
     /* 120893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120895 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120900 */     GIR_RootConstrainSelectedInstOperands,
     /* 120901 */     // GIR_Coverage, 745,
     /* 120901 */     GIR_EraseRootFromParent_Done,
     /* 120902 */   // Label 2629: @120902
     /* 120902 */   GIM_Reject,
     /* 120903 */ // Label 2623: @120903
     /* 120903 */ GIM_Reject,
     /* 120904 */ // Label 2613: @120904
     /* 120904 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(121596),
     /* 120909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 120919 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(120986), // Rule ID 738 //
     /* 120924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120935 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120938 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120942 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 120946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120954 */     // MIs[2] Operand 1
     /* 120954 */     // No operand predicates
     /* 120954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120963 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SAR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mi_ND),
     /* 120966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120968 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120984 */     GIR_RootConstrainSelectedInstOperands,
     /* 120985 */     // GIR_Coverage, 738,
     /* 120985 */     GIR_EraseRootFromParent_Done,
     /* 120986 */   // Label 2631: @120986
     /* 120986 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(121059), // Rule ID 754 //
     /* 120991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121009 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121026 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SAR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 121026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121030 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mCL_ND),
     /* 121043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121057 */     GIR_RootConstrainSelectedInstOperands,
     /* 121058 */     // GIR_Coverage, 754,
     /* 121058 */     GIR_EraseRootFromParent_Done,
     /* 121059 */   // Label 2632: @121059
     /* 121059 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(121169), // Rule ID 17655 //
     /* 121064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121075 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121082 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121099 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SARX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121125 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121132 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rm),
     /* 121153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121167 */     GIR_RootConstrainSelectedInstOperands,
     /* 121168 */     // GIR_Coverage, 17655,
     /* 121168 */     GIR_EraseRootFromParent_Done,
     /* 121169 */   // Label 2633: @121169
     /* 121169 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(121279), // Rule ID 17687 //
     /* 121174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121185 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121192 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121209 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SARX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121209 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121212 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121216 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121235 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121242 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rm_EVEX),
     /* 121263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121277 */     GIR_RootConstrainSelectedInstOperands,
     /* 121278 */     // GIR_Coverage, 17687,
     /* 121278 */     GIR_EraseRootFromParent_Done,
     /* 121279 */   // Label 2634: @121279
     /* 121279 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(121316), // Rule ID 726 //
     /* 121284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121299 */     // MIs[1] Operand 1
     /* 121299 */     // No operand predicates
     /* 121299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121301 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri),
     /* 121304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121306 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121314 */     GIR_RootConstrainSelectedInstOperands,
     /* 121315 */     // GIR_Coverage, 726,
     /* 121315 */     GIR_EraseRootFromParent_Done,
     /* 121316 */   // Label 2635: @121316
     /* 121316 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(121353), // Rule ID 730 //
     /* 121321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121336 */     // MIs[1] Operand 1
     /* 121336 */     // No operand predicates
     /* 121336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121338 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri_ND),
     /* 121341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121343 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121351 */     GIR_RootConstrainSelectedInstOperands,
     /* 121352 */     // GIR_Coverage, 730,
     /* 121352 */     GIR_EraseRootFromParent_Done,
     /* 121353 */   // Label 2636: @121353
     /* 121353 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(121432), // Rule ID 17651 //
     /* 121358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121369 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121369 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121372 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121376 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121395 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121402 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr),
     /* 121423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121425 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121430 */     GIR_RootConstrainSelectedInstOperands,
     /* 121431 */     // GIR_Coverage, 17651,
     /* 121431 */     GIR_EraseRootFromParent_Done,
     /* 121432 */   // Label 2637: @121432
     /* 121432 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(121511), // Rule ID 17683 //
     /* 121437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121448 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121448 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121451 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121455 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121474 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121481 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr_EVEX),
     /* 121502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121504 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121509 */     GIR_RootConstrainSelectedInstOperands,
     /* 121510 */     // GIR_Coverage, 17683,
     /* 121510 */     GIR_EraseRootFromParent_Done,
     /* 121511 */   // Label 2638: @121511
     /* 121511 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(121553), // Rule ID 742 //
     /* 121516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121527 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 121527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121531 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121537 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL),
     /* 121544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121546 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121551 */     GIR_RootConstrainSelectedInstOperands,
     /* 121552 */     // GIR_Coverage, 742,
     /* 121552 */     GIR_EraseRootFromParent_Done,
     /* 121553 */   // Label 2639: @121553
     /* 121553 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(121595), // Rule ID 746 //
     /* 121558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121569 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 121569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121573 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL_ND),
     /* 121586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121588 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121593 */     GIR_RootConstrainSelectedInstOperands,
     /* 121594 */     // GIR_Coverage, 746,
     /* 121594 */     GIR_EraseRootFromParent_Done,
     /* 121595 */   // Label 2640: @121595
     /* 121595 */   GIM_Reject,
     /* 121596 */ // Label 2630: @121596
     /* 121596 */ GIM_Reject,
     /* 121597 */ // Label 2614: @121597
     /* 121597 */ GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(122289),
     /* 121602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 121605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 121608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121612 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(121679), // Rule ID 739 //
     /* 121617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121647 */     // MIs[2] Operand 1
     /* 121647 */     // No operand predicates
     /* 121647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121656 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SAR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mi_ND),
     /* 121659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 121668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121677 */     GIR_RootConstrainSelectedInstOperands,
     /* 121678 */     // GIR_Coverage, 739,
     /* 121678 */     GIR_EraseRootFromParent_Done,
     /* 121679 */   // Label 2642: @121679
     /* 121679 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(121752), // Rule ID 755 //
     /* 121684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121695 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121698 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121702 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121719 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SAR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 121719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121723 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mCL_ND),
     /* 121736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121750 */     GIR_RootConstrainSelectedInstOperands,
     /* 121751 */     // GIR_Coverage, 755,
     /* 121751 */     GIR_EraseRootFromParent_Done,
     /* 121752 */   // Label 2643: @121752
     /* 121752 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(121862), // Rule ID 17656 //
     /* 121757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121768 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121771 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121775 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121792 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SARX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121792 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121795 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121799 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 121809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121818 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rm),
     /* 121846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121860 */     GIR_RootConstrainSelectedInstOperands,
     /* 121861 */     // GIR_Coverage, 17656,
     /* 121861 */     GIR_EraseRootFromParent_Done,
     /* 121862 */   // Label 2644: @121862
     /* 121862 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(121972), // Rule ID 17688 //
     /* 121867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121878 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121881 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121885 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121902 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SARX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121902 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121905 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121909 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 121919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121928 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121935 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rm_EVEX),
     /* 121956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121958 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121970 */     GIR_RootConstrainSelectedInstOperands,
     /* 121971 */     // GIR_Coverage, 17688,
     /* 121971 */     GIR_EraseRootFromParent_Done,
     /* 121972 */   // Label 2645: @121972
     /* 121972 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(122009), // Rule ID 727 //
     /* 121977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121992 */     // MIs[1] Operand 1
     /* 121992 */     // No operand predicates
     /* 121992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121994 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri),
     /* 121997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 122004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122007 */     GIR_RootConstrainSelectedInstOperands,
     /* 122008 */     // GIR_Coverage, 727,
     /* 122008 */     GIR_EraseRootFromParent_Done,
     /* 122009 */   // Label 2646: @122009
     /* 122009 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(122046), // Rule ID 731 //
     /* 122014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 122025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122029 */     // MIs[1] Operand 1
     /* 122029 */     // No operand predicates
     /* 122029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122031 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 122031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri_ND),
     /* 122034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122036 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 122041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122044 */     GIR_RootConstrainSelectedInstOperands,
     /* 122045 */     // GIR_Coverage, 731,
     /* 122045 */     GIR_EraseRootFromParent_Done,
     /* 122046 */   // Label 2647: @122046
     /* 122046 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(122125), // Rule ID 17652 //
     /* 122051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 122054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122062 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122095 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr),
     /* 122116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122118 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122123 */     GIR_RootConstrainSelectedInstOperands,
     /* 122124 */     // GIR_Coverage, 17652,
     /* 122124 */     GIR_EraseRootFromParent_Done,
     /* 122125 */   // Label 2648: @122125
     /* 122125 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(122204), // Rule ID 17684 //
     /* 122130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 122133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122141 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122141 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122144 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122148 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122167 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122174 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr_EVEX),
     /* 122195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122197 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122202 */     GIR_RootConstrainSelectedInstOperands,
     /* 122203 */     // GIR_Coverage, 17684,
     /* 122203 */     GIR_EraseRootFromParent_Done,
     /* 122204 */   // Label 2649: @122204
     /* 122204 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(122246), // Rule ID 743 //
     /* 122209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122220 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 122220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122224 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 122234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL),
     /* 122237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122239 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122244 */     GIR_RootConstrainSelectedInstOperands,
     /* 122245 */     // GIR_Coverage, 743,
     /* 122245 */     GIR_EraseRootFromParent_Done,
     /* 122246 */   // Label 2650: @122246
     /* 122246 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(122288), // Rule ID 747 //
     /* 122251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122262 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 122262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122266 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 122276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL_ND),
     /* 122279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122281 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122286 */     GIR_RootConstrainSelectedInstOperands,
     /* 122287 */     // GIR_Coverage, 747,
     /* 122287 */     GIR_EraseRootFromParent_Done,
     /* 122288 */   // Label 2651: @122288
     /* 122288 */   GIM_Reject,
     /* 122289 */ // Label 2641: @122289
     /* 122289 */ GIM_Reject,
     /* 122290 */ // Label 2615: @122290
     /* 122290 */ GIM_Reject,
     /* 122291 */ // Label 29: @122291
     /* 122291 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2654*/ GIMT_Encode4(123018),
     /* 122302 */ /*GILLT_s32*//*Label 2652*/ GIMT_Encode4(122310),
     /* 122306 */ /*GILLT_s64*//*Label 2653*/ GIMT_Encode4(122664),
     /* 122310 */ // Label 2652: @122310
     /* 122310 */ GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(122663),
     /* 122315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122328 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(122401), // Rule ID 839 //
     /* 122333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122344 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122347 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122351 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 122355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122367 */     // MIs[2] Operand 1
     /* 122367 */     // No operand predicates
     /* 122367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122376 */     // (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32mri8_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mri8_ND),
     /* 122379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122399 */     GIR_RootConstrainSelectedInstOperands,
     /* 122400 */     // GIR_Coverage, 839,
     /* 122400 */     GIR_EraseRootFromParent_Done,
     /* 122401 */   // Label 2656: @122401
     /* 122401 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(122480), // Rule ID 842 //
     /* 122406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122417 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122420 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122424 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 122428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122445 */     // (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32mrCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122449 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mrCL_ND),
     /* 122462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122464 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122468 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122478 */     GIR_RootConstrainSelectedInstOperands,
     /* 122479 */     // GIR_Coverage, 842,
     /* 122479 */     GIR_EraseRootFromParent_Done,
     /* 122480 */   // Label 2657: @122480
     /* 122480 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(122523), // Rule ID 821 //
     /* 122485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122504 */     // MIs[1] Operand 1
     /* 122504 */     // No operand predicates
     /* 122504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122506 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8),
     /* 122509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122511 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122513 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122521 */     GIR_RootConstrainSelectedInstOperands,
     /* 122522 */     // GIR_Coverage, 821,
     /* 122522 */     GIR_EraseRootFromParent_Done,
     /* 122523 */   // Label 2658: @122523
     /* 122523 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(122566), // Rule ID 827 //
     /* 122528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122547 */     // MIs[1] Operand 1
     /* 122547 */     // No operand predicates
     /* 122547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122549 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8_ND),
     /* 122552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122554 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122564 */     GIR_RootConstrainSelectedInstOperands,
     /* 122565 */     // GIR_Coverage, 827,
     /* 122565 */     GIR_EraseRootFromParent_Done,
     /* 122566 */   // Label 2659: @122566
     /* 122566 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(122614), // Rule ID 824 //
     /* 122571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122586 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122590 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL),
     /* 122603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122605 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122607 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122609 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122612 */     GIR_RootConstrainSelectedInstOperands,
     /* 122613 */     // GIR_Coverage, 824,
     /* 122613 */     GIR_EraseRootFromParent_Done,
     /* 122614 */   // Label 2660: @122614
     /* 122614 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(122662), // Rule ID 830 //
     /* 122619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122634 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122638 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL_ND),
     /* 122651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122655 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122660 */     GIR_RootConstrainSelectedInstOperands,
     /* 122661 */     // GIR_Coverage, 830,
     /* 122661 */     GIR_EraseRootFromParent_Done,
     /* 122662 */   // Label 2661: @122662
     /* 122662 */   GIM_Reject,
     /* 122663 */ // Label 2655: @122663
     /* 122663 */ GIM_Reject,
     /* 122664 */ // Label 2653: @122664
     /* 122664 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(123017),
     /* 122669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 122672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 122675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122682 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(122755), // Rule ID 840 //
     /* 122687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122698 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122701 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122705 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122721 */     // MIs[2] Operand 1
     /* 122721 */     // No operand predicates
     /* 122721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122730 */     // (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64mri8_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mri8_ND),
     /* 122733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122735 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122739 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122753 */     GIR_RootConstrainSelectedInstOperands,
     /* 122754 */     // GIR_Coverage, 840,
     /* 122754 */     GIR_EraseRootFromParent_Done,
     /* 122755 */   // Label 2663: @122755
     /* 122755 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(122834), // Rule ID 843 //
     /* 122760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122771 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122774 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122778 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122799 */     // (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64mrCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 122799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122803 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mrCL_ND),
     /* 122816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122822 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122832 */     GIR_RootConstrainSelectedInstOperands,
     /* 122833 */     // GIR_Coverage, 843,
     /* 122833 */     GIR_EraseRootFromParent_Done,
     /* 122834 */   // Label 2664: @122834
     /* 122834 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(122877), // Rule ID 822 //
     /* 122839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122858 */     // MIs[1] Operand 1
     /* 122858 */     // No operand predicates
     /* 122858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122860 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8),
     /* 122863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122865 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122867 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122875 */     GIR_RootConstrainSelectedInstOperands,
     /* 122876 */     // GIR_Coverage, 822,
     /* 122876 */     GIR_EraseRootFromParent_Done,
     /* 122877 */   // Label 2665: @122877
     /* 122877 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(122920), // Rule ID 828 //
     /* 122882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122901 */     // MIs[1] Operand 1
     /* 122901 */     // No operand predicates
     /* 122901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122903 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8_ND),
     /* 122906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122908 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122910 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122918 */     GIR_RootConstrainSelectedInstOperands,
     /* 122919 */     // GIR_Coverage, 828,
     /* 122919 */     GIR_EraseRootFromParent_Done,
     /* 122920 */   // Label 2666: @122920
     /* 122920 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(122968), // Rule ID 825 //
     /* 122925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122940 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 122940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122944 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL),
     /* 122957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122959 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122961 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122966 */     GIR_RootConstrainSelectedInstOperands,
     /* 122967 */     // GIR_Coverage, 825,
     /* 122967 */     GIR_EraseRootFromParent_Done,
     /* 122968 */   // Label 2667: @122968
     /* 122968 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(123016), // Rule ID 831 //
     /* 122973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122988 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 122988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122992 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL_ND),
     /* 123005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123014 */     GIR_RootConstrainSelectedInstOperands,
     /* 123015 */     // GIR_Coverage, 831,
     /* 123015 */     GIR_EraseRootFromParent_Done,
     /* 123016 */   // Label 2668: @123016
     /* 123016 */   GIM_Reject,
     /* 123017 */ // Label 2662: @123017
     /* 123017 */ GIM_Reject,
     /* 123018 */ // Label 2654: @123018
     /* 123018 */ GIM_Reject,
     /* 123019 */ // Label 30: @123019
     /* 123019 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2671*/ GIMT_Encode4(123706),
     /* 123030 */ /*GILLT_s32*//*Label 2669*/ GIMT_Encode4(123038),
     /* 123034 */ /*GILLT_s64*//*Label 2670*/ GIMT_Encode4(123372),
     /* 123038 */ // Label 2669: @123038
     /* 123038 */ GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(123371),
     /* 123043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 123046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 123049 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 123052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123060 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(123129), // Rule ID 863 //
     /* 123065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123076 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123079 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123083 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 123087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 123091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123095 */     // MIs[2] Operand 1
     /* 123095 */     // No operand predicates
     /* 123095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123104 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src3)  =>  (SHRD32mri8_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mri8_ND),
     /* 123107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123109 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 123118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123127 */     GIR_RootConstrainSelectedInstOperands,
     /* 123128 */     // GIR_Coverage, 863,
     /* 123128 */     GIR_EraseRootFromParent_Done,
     /* 123129 */   // Label 2673: @123129
     /* 123129 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(123204), // Rule ID 866 //
     /* 123134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123145 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123148 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123152 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 123156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123169 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHRD32mrCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123173 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123179 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mrCL_ND),
     /* 123186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123192 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123202 */     GIR_RootConstrainSelectedInstOperands,
     /* 123203 */     // GIR_Coverage, 866,
     /* 123203 */     GIR_EraseRootFromParent_Done,
     /* 123204 */   // Label 2674: @123204
     /* 123204 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(123243), // Rule ID 845 //
     /* 123209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123224 */     // MIs[1] Operand 1
     /* 123224 */     // No operand predicates
     /* 123224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123226 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8),
     /* 123229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123231 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123233 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123241 */     GIR_RootConstrainSelectedInstOperands,
     /* 123242 */     // GIR_Coverage, 845,
     /* 123242 */     GIR_EraseRootFromParent_Done,
     /* 123243 */   // Label 2675: @123243
     /* 123243 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(123282), // Rule ID 851 //
     /* 123248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123263 */     // MIs[1] Operand 1
     /* 123263 */     // No operand predicates
     /* 123263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123265 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8_ND),
     /* 123268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123270 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123272 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123280 */     GIR_RootConstrainSelectedInstOperands,
     /* 123281 */     // GIR_Coverage, 851,
     /* 123281 */     GIR_EraseRootFromParent_Done,
     /* 123282 */   // Label 2676: @123282
     /* 123282 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(123326), // Rule ID 848 //
     /* 123287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123298 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123302 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL),
     /* 123315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123317 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123324 */     GIR_RootConstrainSelectedInstOperands,
     /* 123325 */     // GIR_Coverage, 848,
     /* 123325 */     GIR_EraseRootFromParent_Done,
     /* 123326 */   // Label 2677: @123326
     /* 123326 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(123370), // Rule ID 854 //
     /* 123331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123342 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123346 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123352 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL_ND),
     /* 123359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123361 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123368 */     GIR_RootConstrainSelectedInstOperands,
     /* 123369 */     // GIR_Coverage, 854,
     /* 123369 */     GIR_EraseRootFromParent_Done,
     /* 123370 */   // Label 2678: @123370
     /* 123370 */   GIM_Reject,
     /* 123371 */ // Label 2672: @123371
     /* 123371 */ GIM_Reject,
     /* 123372 */ // Label 2670: @123372
     /* 123372 */ GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(123705),
     /* 123377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 123380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 123383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 123386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123394 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(123463), // Rule ID 864 //
     /* 123399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123410 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123413 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 123417 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 123425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123429 */     // MIs[2] Operand 1
     /* 123429 */     // No operand predicates
     /* 123429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123438 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src3)  =>  (SHRD64mri8_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mri8_ND),
     /* 123441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123443 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 123452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123461 */     GIR_RootConstrainSelectedInstOperands,
     /* 123462 */     // GIR_Coverage, 864,
     /* 123462 */     GIR_EraseRootFromParent_Done,
     /* 123463 */   // Label 2680: @123463
     /* 123463 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(123538), // Rule ID 867 //
     /* 123468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123479 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123482 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 123486 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123503 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHRD64mrCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123507 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123513 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mrCL_ND),
     /* 123520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123522 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123526 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123536 */     GIR_RootConstrainSelectedInstOperands,
     /* 123537 */     // GIR_Coverage, 867,
     /* 123537 */     GIR_EraseRootFromParent_Done,
     /* 123538 */   // Label 2681: @123538
     /* 123538 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(123577), // Rule ID 846 //
     /* 123543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123558 */     // MIs[1] Operand 1
     /* 123558 */     // No operand predicates
     /* 123558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123560 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8),
     /* 123563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123565 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123567 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123575 */     GIR_RootConstrainSelectedInstOperands,
     /* 123576 */     // GIR_Coverage, 846,
     /* 123576 */     GIR_EraseRootFromParent_Done,
     /* 123577 */   // Label 2682: @123577
     /* 123577 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(123616), // Rule ID 852 //
     /* 123582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123597 */     // MIs[1] Operand 1
     /* 123597 */     // No operand predicates
     /* 123597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123599 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8_ND),
     /* 123602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123604 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123606 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123614 */     GIR_RootConstrainSelectedInstOperands,
     /* 123615 */     // GIR_Coverage, 852,
     /* 123615 */     GIR_EraseRootFromParent_Done,
     /* 123616 */   // Label 2683: @123616
     /* 123616 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(123660), // Rule ID 849 //
     /* 123621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123632 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123636 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL),
     /* 123649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123651 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123658 */     GIR_RootConstrainSelectedInstOperands,
     /* 123659 */     // GIR_Coverage, 849,
     /* 123659 */     GIR_EraseRootFromParent_Done,
     /* 123660 */   // Label 2684: @123660
     /* 123660 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(123704), // Rule ID 855 //
     /* 123665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123676 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123680 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL_ND),
     /* 123693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123697 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123702 */     GIR_RootConstrainSelectedInstOperands,
     /* 123703 */     // GIR_Coverage, 855,
     /* 123703 */     GIR_EraseRootFromParent_Done,
     /* 123704 */   // Label 2685: @123704
     /* 123704 */   GIM_Reject,
     /* 123705 */ // Label 2679: @123705
     /* 123705 */ GIM_Reject,
     /* 123706 */ // Label 2671: @123706
     /* 123706 */ GIM_Reject,
     /* 123707 */ // Label 31: @123707
     /* 123707 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 2696*/ GIMT_Encode4(127204),
     /* 123718 */ /*GILLT_s8*//*Label 2686*/ GIMT_Encode4(123794),
     /* 123722 */ /*GILLT_s16*//*Label 2687*/ GIMT_Encode4(124224),
     /* 123726 */ /*GILLT_s32*//*Label 2688*/ GIMT_Encode4(124654),
     /* 123730 */ /*GILLT_s64*//*Label 2689*/ GIMT_Encode4(125317), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123746 */ /*GILLT_v2s64*//*Label 2690*/ GIMT_Encode4(125980), GIMT_Encode4(0),
     /* 123754 */ /*GILLT_v4s32*//*Label 2691*/ GIMT_Encode4(126247),
     /* 123758 */ /*GILLT_v4s64*//*Label 2692*/ GIMT_Encode4(126514), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123770 */ /*GILLT_v8s32*//*Label 2693*/ GIMT_Encode4(126765),
     /* 123774 */ /*GILLT_v8s64*//*Label 2694*/ GIMT_Encode4(127016), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123790 */ /*GILLT_v16s32*//*Label 2695*/ GIMT_Encode4(127110),
     /* 123794 */ // Label 2686: @123794
     /* 123794 */ GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(124223),
     /* 123799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 123802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 123805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 123809 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(123868), // Rule ID 17623 //
     /* 123814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 123817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123825 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123832 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 123836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 123840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123849 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] })  =>  (ROL8m1_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 123849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8m1_ND),
     /* 123852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 123858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123866 */     GIR_RootConstrainSelectedInstOperands,
     /* 123867 */     // GIR_Coverage, 17623,
     /* 123867 */     GIR_EraseRootFromParent_Done,
     /* 123868 */   // Label 2698: @123868
     /* 123868 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(123935), // Rule ID 800 //
     /* 123873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123884 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123887 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123891 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 123895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 123899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123903 */     // MIs[2] Operand 1
     /* 123903 */     // No operand predicates
     /* 123903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123912 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (ROR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 123912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mi_ND),
     /* 123915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123917 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 123924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123933 */     GIR_RootConstrainSelectedInstOperands,
     /* 123934 */     // GIR_Coverage, 800,
     /* 123934 */     GIR_EraseRootFromParent_Done,
     /* 123935 */   // Label 2699: @123935
     /* 123935 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(124008), // Rule ID 816 //
     /* 123940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123951 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123954 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123958 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 123962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123975 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (ROR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 123975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123979 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 123989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mCL_ND),
     /* 123992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124006 */     GIR_RootConstrainSelectedInstOperands,
     /* 124007 */     // GIR_Coverage, 816,
     /* 124007 */     GIR_EraseRootFromParent_Done,
     /* 124008 */   // Label 2700: @124008
     /* 124008 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(124036), // Rule ID 17599 //
     /* 124013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124024 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1),
     /* 124027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124029 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124034 */     GIR_RootConstrainSelectedInstOperands,
     /* 124035 */     // GIR_Coverage, 17599,
     /* 124035 */     GIR_EraseRootFromParent_Done,
     /* 124036 */   // Label 2701: @124036
     /* 124036 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(124064), // Rule ID 17607 //
     /* 124041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124052 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1_ND),
     /* 124055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124062 */     GIR_RootConstrainSelectedInstOperands,
     /* 124063 */     // GIR_Coverage, 17607,
     /* 124063 */     GIR_EraseRootFromParent_Done,
     /* 124064 */   // Label 2702: @124064
     /* 124064 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(124101), // Rule ID 788 //
     /* 124069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124084 */     // MIs[1] Operand 1
     /* 124084 */     // No operand predicates
     /* 124084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124086 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri),
     /* 124089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124091 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124099 */     GIR_RootConstrainSelectedInstOperands,
     /* 124100 */     // GIR_Coverage, 788,
     /* 124100 */     GIR_EraseRootFromParent_Done,
     /* 124101 */   // Label 2703: @124101
     /* 124101 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(124138), // Rule ID 792 //
     /* 124106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124121 */     // MIs[1] Operand 1
     /* 124121 */     // No operand predicates
     /* 124121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124123 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri_ND),
     /* 124126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124128 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124136 */     GIR_RootConstrainSelectedInstOperands,
     /* 124137 */     // GIR_Coverage, 792,
     /* 124137 */     GIR_EraseRootFromParent_Done,
     /* 124138 */   // Label 2704: @124138
     /* 124138 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(124180), // Rule ID 804 //
     /* 124143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124154 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124158 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124164 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL),
     /* 124171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124173 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124178 */     GIR_RootConstrainSelectedInstOperands,
     /* 124179 */     // GIR_Coverage, 804,
     /* 124179 */     GIR_EraseRootFromParent_Done,
     /* 124180 */   // Label 2705: @124180
     /* 124180 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(124222), // Rule ID 808 //
     /* 124185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124196 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124200 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL_ND),
     /* 124213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124215 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124220 */     GIR_RootConstrainSelectedInstOperands,
     /* 124221 */     // GIR_Coverage, 808,
     /* 124221 */     GIR_EraseRootFromParent_Done,
     /* 124222 */   // Label 2706: @124222
     /* 124222 */   GIM_Reject,
     /* 124223 */ // Label 2697: @124223
     /* 124223 */ GIM_Reject,
     /* 124224 */ // Label 2687: @124224
     /* 124224 */ GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(124653),
     /* 124229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 124232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124239 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(124298), // Rule ID 17624 //
     /* 124244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124255 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124258 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124262 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124279 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] })  =>  (ROL16m1_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16m1_ND),
     /* 124282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124296 */     GIR_RootConstrainSelectedInstOperands,
     /* 124297 */     // GIR_Coverage, 17624,
     /* 124297 */     GIR_EraseRootFromParent_Done,
     /* 124298 */   // Label 2708: @124298
     /* 124298 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(124365), // Rule ID 801 //
     /* 124303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124314 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124317 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124321 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124333 */     // MIs[2] Operand 1
     /* 124333 */     // No operand predicates
     /* 124333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124342 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (ROR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mi_ND),
     /* 124345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124363 */     GIR_RootConstrainSelectedInstOperands,
     /* 124364 */     // GIR_Coverage, 801,
     /* 124364 */     GIR_EraseRootFromParent_Done,
     /* 124365 */   // Label 2709: @124365
     /* 124365 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(124438), // Rule ID 817 //
     /* 124370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124381 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124388 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124405 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (ROR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 124405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124409 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124415 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mCL_ND),
     /* 124422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124424 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124436 */     GIR_RootConstrainSelectedInstOperands,
     /* 124437 */     // GIR_Coverage, 817,
     /* 124437 */     GIR_EraseRootFromParent_Done,
     /* 124438 */   // Label 2710: @124438
     /* 124438 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(124466), // Rule ID 17600 //
     /* 124443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124454 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1),
     /* 124457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124464 */     GIR_RootConstrainSelectedInstOperands,
     /* 124465 */     // GIR_Coverage, 17600,
     /* 124465 */     GIR_EraseRootFromParent_Done,
     /* 124466 */   // Label 2711: @124466
     /* 124466 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(124494), // Rule ID 17608 //
     /* 124471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124482 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1_ND),
     /* 124485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124487 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124492 */     GIR_RootConstrainSelectedInstOperands,
     /* 124493 */     // GIR_Coverage, 17608,
     /* 124493 */     GIR_EraseRootFromParent_Done,
     /* 124494 */   // Label 2712: @124494
     /* 124494 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(124531), // Rule ID 789 //
     /* 124499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124514 */     // MIs[1] Operand 1
     /* 124514 */     // No operand predicates
     /* 124514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124516 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri),
     /* 124519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124521 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124529 */     GIR_RootConstrainSelectedInstOperands,
     /* 124530 */     // GIR_Coverage, 789,
     /* 124530 */     GIR_EraseRootFromParent_Done,
     /* 124531 */   // Label 2713: @124531
     /* 124531 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(124568), // Rule ID 793 //
     /* 124536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124551 */     // MIs[1] Operand 1
     /* 124551 */     // No operand predicates
     /* 124551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124553 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri_ND),
     /* 124556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124558 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124566 */     GIR_RootConstrainSelectedInstOperands,
     /* 124567 */     // GIR_Coverage, 793,
     /* 124567 */     GIR_EraseRootFromParent_Done,
     /* 124568 */   // Label 2714: @124568
     /* 124568 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(124610), // Rule ID 805 //
     /* 124573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124584 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124588 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL),
     /* 124601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124603 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124608 */     GIR_RootConstrainSelectedInstOperands,
     /* 124609 */     // GIR_Coverage, 805,
     /* 124609 */     GIR_EraseRootFromParent_Done,
     /* 124610 */   // Label 2715: @124610
     /* 124610 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(124652), // Rule ID 809 //
     /* 124615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124626 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124630 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL_ND),
     /* 124643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124650 */     GIR_RootConstrainSelectedInstOperands,
     /* 124651 */     // GIR_Coverage, 809,
     /* 124651 */     GIR_EraseRootFromParent_Done,
     /* 124652 */   // Label 2716: @124652
     /* 124652 */   GIM_Reject,
     /* 124653 */ // Label 2707: @124653
     /* 124653 */ GIM_Reject,
     /* 124654 */ // Label 2688: @124654
     /* 124654 */ GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(125316),
     /* 124659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 124662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124669 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(124728), // Rule ID 17625 //
     /* 124674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124685 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124688 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124692 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 124700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124709 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] })  =>  (ROL32m1_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32m1_ND),
     /* 124712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124714 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124726 */     GIR_RootConstrainSelectedInstOperands,
     /* 124727 */     // GIR_Coverage, 17625,
     /* 124727 */     GIR_EraseRootFromParent_Done,
     /* 124728 */   // Label 2718: @124728
     /* 124728 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(124795), // Rule ID 802 //
     /* 124733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124744 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124747 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124751 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124763 */     // MIs[2] Operand 1
     /* 124763 */     // No operand predicates
     /* 124763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124772 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (ROR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mi_ND),
     /* 124775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124793 */     GIR_RootConstrainSelectedInstOperands,
     /* 124794 */     // GIR_Coverage, 802,
     /* 124794 */     GIR_EraseRootFromParent_Done,
     /* 124795 */   // Label 2719: @124795
     /* 124795 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(124859), // Rule ID 17647 //
     /* 124800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 124803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124811 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124814 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124818 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124830 */     // MIs[2] Operand 1
     /* 124830 */     // No operand predicates
     /* 124830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124839 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 124839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32mi),
     /* 124842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124844 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 124851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124857 */     GIR_RootConstrainSelectedInstOperands,
     /* 124858 */     // GIR_Coverage, 17647,
     /* 124858 */     GIR_EraseRootFromParent_Done,
     /* 124859 */   // Label 2720: @124859
     /* 124859 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(124923), // Rule ID 17679 //
     /* 124864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 124867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124875 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124882 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124894 */     // MIs[2] Operand 1
     /* 124894 */     // No operand predicates
     /* 124894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124903 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX32mi_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 124903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32mi_EVEX),
     /* 124906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124908 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 124915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124921 */     GIR_RootConstrainSelectedInstOperands,
     /* 124922 */     // GIR_Coverage, 17679,
     /* 124922 */     GIR_EraseRootFromParent_Done,
     /* 124923 */   // Label 2721: @124923
     /* 124923 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(124996), // Rule ID 818 //
     /* 124928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124939 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124942 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124946 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124963 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (ROR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 124963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124967 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mCL_ND),
     /* 124980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124982 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124986 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124994 */     GIR_RootConstrainSelectedInstOperands,
     /* 124995 */     // GIR_Coverage, 818,
     /* 124995 */     GIR_EraseRootFromParent_Done,
     /* 124996 */   // Label 2722: @124996
     /* 124996 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(125030), // Rule ID 17643 //
     /* 125001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125016 */     // MIs[1] Operand 1
     /* 125016 */     // No operand predicates
     /* 125016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125018 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri),
     /* 125021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125023 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125028 */     GIR_RootConstrainSelectedInstOperands,
     /* 125029 */     // GIR_Coverage, 17643,
     /* 125029 */     GIR_EraseRootFromParent_Done,
     /* 125030 */   // Label 2723: @125030
     /* 125030 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(125064), // Rule ID 17675 //
     /* 125035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125050 */     // MIs[1] Operand 1
     /* 125050 */     // No operand predicates
     /* 125050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125052 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri_EVEX),
     /* 125055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125062 */     GIR_RootConstrainSelectedInstOperands,
     /* 125063 */     // GIR_Coverage, 17675,
     /* 125063 */     GIR_EraseRootFromParent_Done,
     /* 125064 */   // Label 2724: @125064
     /* 125064 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(125101), // Rule ID 870 //
     /* 125069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 125072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125084 */     // MIs[1] Operand 1
     /* 125084 */     // No operand predicates
     /* 125084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125086 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 125086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT32ri),
     /* 125089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125091 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125099 */     GIR_RootConstrainSelectedInstOperands,
     /* 125100 */     // GIR_Coverage, 870,
     /* 125100 */     GIR_EraseRootFromParent_Done,
     /* 125101 */   // Label 2725: @125101
     /* 125101 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(125129), // Rule ID 17601 //
     /* 125106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 125117 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1),
     /* 125120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125127 */     GIR_RootConstrainSelectedInstOperands,
     /* 125128 */     // GIR_Coverage, 17601,
     /* 125128 */     GIR_EraseRootFromParent_Done,
     /* 125129 */   // Label 2726: @125129
     /* 125129 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(125157), // Rule ID 17609 //
     /* 125134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 125145 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1_ND),
     /* 125148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125150 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125155 */     GIR_RootConstrainSelectedInstOperands,
     /* 125156 */     // GIR_Coverage, 17609,
     /* 125156 */     GIR_EraseRootFromParent_Done,
     /* 125157 */   // Label 2727: @125157
     /* 125157 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(125194), // Rule ID 790 //
     /* 125162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125177 */     // MIs[1] Operand 1
     /* 125177 */     // No operand predicates
     /* 125177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125179 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri),
     /* 125182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125184 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125192 */     GIR_RootConstrainSelectedInstOperands,
     /* 125193 */     // GIR_Coverage, 790,
     /* 125193 */     GIR_EraseRootFromParent_Done,
     /* 125194 */   // Label 2728: @125194
     /* 125194 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(125231), // Rule ID 794 //
     /* 125199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125214 */     // MIs[1] Operand 1
     /* 125214 */     // No operand predicates
     /* 125214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125216 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri_ND),
     /* 125219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125221 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125229 */     GIR_RootConstrainSelectedInstOperands,
     /* 125230 */     // GIR_Coverage, 794,
     /* 125230 */     GIR_EraseRootFromParent_Done,
     /* 125231 */   // Label 2729: @125231
     /* 125231 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(125273), // Rule ID 806 //
     /* 125236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125247 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125251 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125257 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL),
     /* 125264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125266 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125271 */     GIR_RootConstrainSelectedInstOperands,
     /* 125272 */     // GIR_Coverage, 806,
     /* 125272 */     GIR_EraseRootFromParent_Done,
     /* 125273 */   // Label 2730: @125273
     /* 125273 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(125315), // Rule ID 810 //
     /* 125278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125289 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125293 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125299 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL_ND),
     /* 125306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125308 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125310 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125313 */     GIR_RootConstrainSelectedInstOperands,
     /* 125314 */     // GIR_Coverage, 810,
     /* 125314 */     GIR_EraseRootFromParent_Done,
     /* 125315 */   // Label 2731: @125315
     /* 125315 */   GIM_Reject,
     /* 125316 */ // Label 2717: @125316
     /* 125316 */ GIM_Reject,
     /* 125317 */ // Label 2689: @125317
     /* 125317 */ GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(125979),
     /* 125322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 125325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 125328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125332 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(125391), // Rule ID 17626 //
     /* 125337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 125363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125372 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] })  =>  (ROL64m1_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 125372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64m1_ND),
     /* 125375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125377 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125389 */     GIR_RootConstrainSelectedInstOperands,
     /* 125390 */     // GIR_Coverage, 17626,
     /* 125390 */     GIR_EraseRootFromParent_Done,
     /* 125391 */   // Label 2733: @125391
     /* 125391 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(125458), // Rule ID 803 //
     /* 125396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125407 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125410 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125414 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125426 */     // MIs[2] Operand 1
     /* 125426 */     // No operand predicates
     /* 125426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125435 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (ROR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mi_ND),
     /* 125438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 125447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125456 */     GIR_RootConstrainSelectedInstOperands,
     /* 125457 */     // GIR_Coverage, 803,
     /* 125457 */     GIR_EraseRootFromParent_Done,
     /* 125458 */   // Label 2734: @125458
     /* 125458 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(125522), // Rule ID 17648 //
     /* 125463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125493 */     // MIs[2] Operand 1
     /* 125493 */     // No operand predicates
     /* 125493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125502 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX64mi:{ *:[i64] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64mi),
     /* 125505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125507 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125520 */     GIR_RootConstrainSelectedInstOperands,
     /* 125521 */     // GIR_Coverage, 17648,
     /* 125521 */     GIR_EraseRootFromParent_Done,
     /* 125522 */   // Label 2735: @125522
     /* 125522 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(125586), // Rule ID 17680 //
     /* 125527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125545 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125557 */     // MIs[2] Operand 1
     /* 125557 */     // No operand predicates
     /* 125557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125566 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX64mi_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64mi_EVEX),
     /* 125569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125584 */     GIR_RootConstrainSelectedInstOperands,
     /* 125585 */     // GIR_Coverage, 17680,
     /* 125585 */     GIR_EraseRootFromParent_Done,
     /* 125586 */   // Label 2736: @125586
     /* 125586 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(125659), // Rule ID 819 //
     /* 125591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125602 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125605 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125609 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125626 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (ROR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 125626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125630 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mCL_ND),
     /* 125643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125645 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125657 */     GIR_RootConstrainSelectedInstOperands,
     /* 125658 */     // GIR_Coverage, 819,
     /* 125658 */     GIR_EraseRootFromParent_Done,
     /* 125659 */   // Label 2737: @125659
     /* 125659 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(125693), // Rule ID 17644 //
     /* 125664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125679 */     // MIs[1] Operand 1
     /* 125679 */     // No operand predicates
     /* 125679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125681 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri),
     /* 125684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125686 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125691 */     GIR_RootConstrainSelectedInstOperands,
     /* 125692 */     // GIR_Coverage, 17644,
     /* 125692 */     GIR_EraseRootFromParent_Done,
     /* 125693 */   // Label 2738: @125693
     /* 125693 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(125727), // Rule ID 17676 //
     /* 125698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125713 */     // MIs[1] Operand 1
     /* 125713 */     // No operand predicates
     /* 125713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125715 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri_EVEX),
     /* 125718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125720 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125725 */     GIR_RootConstrainSelectedInstOperands,
     /* 125726 */     // GIR_Coverage, 17676,
     /* 125726 */     GIR_EraseRootFromParent_Done,
     /* 125727 */   // Label 2739: @125727
     /* 125727 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(125764), // Rule ID 871 //
     /* 125732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 125735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125747 */     // MIs[1] Operand 1
     /* 125747 */     // No operand predicates
     /* 125747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125749 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 125749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT64ri),
     /* 125752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125754 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125762 */     GIR_RootConstrainSelectedInstOperands,
     /* 125763 */     // GIR_Coverage, 871,
     /* 125763 */     GIR_EraseRootFromParent_Done,
     /* 125764 */   // Label 2740: @125764
     /* 125764 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(125792), // Rule ID 17602 //
     /* 125769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 125780 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1),
     /* 125783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125785 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125790 */     GIR_RootConstrainSelectedInstOperands,
     /* 125791 */     // GIR_Coverage, 17602,
     /* 125791 */     GIR_EraseRootFromParent_Done,
     /* 125792 */   // Label 2741: @125792
     /* 125792 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(125820), // Rule ID 17610 //
     /* 125797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 125808 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1_ND),
     /* 125811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125813 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125818 */     GIR_RootConstrainSelectedInstOperands,
     /* 125819 */     // GIR_Coverage, 17610,
     /* 125819 */     GIR_EraseRootFromParent_Done,
     /* 125820 */   // Label 2742: @125820
     /* 125820 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(125857), // Rule ID 791 //
     /* 125825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125840 */     // MIs[1] Operand 1
     /* 125840 */     // No operand predicates
     /* 125840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125842 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri),
     /* 125845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125847 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125855 */     GIR_RootConstrainSelectedInstOperands,
     /* 125856 */     // GIR_Coverage, 791,
     /* 125856 */     GIR_EraseRootFromParent_Done,
     /* 125857 */   // Label 2743: @125857
     /* 125857 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(125894), // Rule ID 795 //
     /* 125862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125877 */     // MIs[1] Operand 1
     /* 125877 */     // No operand predicates
     /* 125877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125879 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri_ND),
     /* 125882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125884 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125892 */     GIR_RootConstrainSelectedInstOperands,
     /* 125893 */     // GIR_Coverage, 795,
     /* 125893 */     GIR_EraseRootFromParent_Done,
     /* 125894 */   // Label 2744: @125894
     /* 125894 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(125936), // Rule ID 807 //
     /* 125899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125910 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125914 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL),
     /* 125927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125929 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125934 */     GIR_RootConstrainSelectedInstOperands,
     /* 125935 */     // GIR_Coverage, 807,
     /* 125935 */     GIR_EraseRootFromParent_Done,
     /* 125936 */   // Label 2745: @125936
     /* 125936 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(125978), // Rule ID 811 //
     /* 125941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125952 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125956 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL_ND),
     /* 125969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125971 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125976 */     GIR_RootConstrainSelectedInstOperands,
     /* 125977 */     // GIR_Coverage, 811,
     /* 125977 */     GIR_EraseRootFromParent_Done,
     /* 125978 */   // Label 2746: @125978
     /* 125978 */   GIM_Reject,
     /* 125979 */ // Label 2732: @125979
     /* 125979 */ GIM_Reject,
     /* 125980 */ // Label 2690: @125980
     /* 125980 */ GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(126246),
     /* 125985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 125988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 125991 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(126053), // Rule ID 8004 //
     /* 125996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 125999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126015 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126018 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126022 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126035 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rm),
     /* 126038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126040 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126042 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126051 */     GIR_RootConstrainSelectedInstOperands,
     /* 126052 */     // GIR_Coverage, 8004,
     /* 126052 */     GIR_EraseRootFromParent_Done,
     /* 126053 */   // Label 2748: @126053
     /* 126053 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(126080), // Rule ID 8001 //
     /* 126058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126073 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPRORVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 126073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rr),
     /* 126078 */     GIR_RootConstrainSelectedInstOperands,
     /* 126079 */     // GIR_Coverage, 8001,
     /* 126079 */     GIR_Done,
     /* 126080 */   // Label 2749: @126080
     /* 126080 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(126245), // Rule ID 20803 //
     /* 126085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 126092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126100 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 126100 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 126103 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126107 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126114 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 126117 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126121 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126126 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126129 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126133 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 126136 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126141 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126146 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126151 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 126154 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126158 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126165 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 126168 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126172 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126177 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126180 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126184 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 126187 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126192 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126197 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 126205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 126209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126214 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126217 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126227 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 126234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 126239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126244 */     // GIR_Coverage, 20803,
     /* 126244 */     GIR_EraseRootFromParent_Done,
     /* 126245 */   // Label 2750: @126245
     /* 126245 */   GIM_Reject,
     /* 126246 */ // Label 2747: @126246
     /* 126246 */ GIM_Reject,
     /* 126247 */ // Label 2691: @126247
     /* 126247 */ GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(126513),
     /* 126252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 126258 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(126320), // Rule ID 7977 //
     /* 126263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126282 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126285 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126289 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126302 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rm),
     /* 126305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126307 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126309 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126318 */     GIR_RootConstrainSelectedInstOperands,
     /* 126319 */     // GIR_Coverage, 7977,
     /* 126319 */     GIR_EraseRootFromParent_Done,
     /* 126320 */   // Label 2752: @126320
     /* 126320 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(126347), // Rule ID 7974 //
     /* 126325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126340 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPRORVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 126340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rr),
     /* 126345 */     GIR_RootConstrainSelectedInstOperands,
     /* 126346 */     // GIR_Coverage, 7974,
     /* 126346 */     GIR_Done,
     /* 126347 */   // Label 2753: @126347
     /* 126347 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(126512), // Rule ID 20805 //
     /* 126352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 126359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126367 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 126367 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 126370 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126374 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126381 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 126384 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126388 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126393 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126396 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126400 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 126403 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126408 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126413 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126418 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 126421 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126425 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126432 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 126435 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126439 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126444 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126447 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126451 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 126454 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126459 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126464 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 126472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 126476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126481 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126484 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126494 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 126501 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 126506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126511 */     // GIR_Coverage, 20805,
     /* 126511 */     GIR_EraseRootFromParent_Done,
     /* 126512 */   // Label 2754: @126512
     /* 126512 */   GIM_Reject,
     /* 126513 */ // Label 2751: @126513
     /* 126513 */ GIM_Reject,
     /* 126514 */ // Label 2692: @126514
     /* 126514 */ GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(126764),
     /* 126519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 126522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 126525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126533 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(126587), // Rule ID 7995 //
     /* 126538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126549 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126552 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126556 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126569 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rm),
     /* 126572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126574 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126585 */     GIR_RootConstrainSelectedInstOperands,
     /* 126586 */     // GIR_Coverage, 7995,
     /* 126586 */     GIR_EraseRootFromParent_Done,
     /* 126587 */   // Label 2756: @126587
     /* 126587 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(126606), // Rule ID 7992 //
     /* 126592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126599 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPRORVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 126599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rr),
     /* 126604 */     GIR_RootConstrainSelectedInstOperands,
     /* 126605 */     // GIR_Coverage, 7992,
     /* 126605 */     GIR_Done,
     /* 126606 */   // Label 2757: @126606
     /* 126606 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(126763), // Rule ID 20804 //
     /* 126611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126618 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 126618 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 126621 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126625 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126632 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 126635 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126639 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126644 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126647 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126651 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 126654 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126659 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126664 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126669 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 126672 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126676 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126683 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 126686 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126690 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126695 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126698 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126702 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 126705 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126710 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126715 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 126723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 126727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126732 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126735 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126745 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 126752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126762 */     // GIR_Coverage, 20804,
     /* 126762 */     GIR_EraseRootFromParent_Done,
     /* 126763 */   // Label 2758: @126763
     /* 126763 */   GIM_Reject,
     /* 126764 */ // Label 2755: @126764
     /* 126764 */ GIM_Reject,
     /* 126765 */ // Label 2693: @126765
     /* 126765 */ GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(127015),
     /* 126770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 126773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 126776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126784 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(126838), // Rule ID 7968 //
     /* 126789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126820 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rm),
     /* 126823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126836 */     GIR_RootConstrainSelectedInstOperands,
     /* 126837 */     // GIR_Coverage, 7968,
     /* 126837 */     GIR_EraseRootFromParent_Done,
     /* 126838 */   // Label 2760: @126838
     /* 126838 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(126857), // Rule ID 7965 //
     /* 126843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126850 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPRORVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 126850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rr),
     /* 126855 */     GIR_RootConstrainSelectedInstOperands,
     /* 126856 */     // GIR_Coverage, 7965,
     /* 126856 */     GIR_Done,
     /* 126857 */   // Label 2761: @126857
     /* 126857 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(127014), // Rule ID 20806 //
     /* 126862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126869 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 126869 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 126872 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126876 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126883 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 126886 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126890 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126895 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126898 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126902 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 126905 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126910 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126915 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126920 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 126923 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126927 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 126937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126946 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126949 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126953 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 126956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126961 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126966 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 126974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 126978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126983 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126986 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126996 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 127003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 127008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 127013 */     // GIR_Coverage, 20806,
     /* 127013 */     GIR_EraseRootFromParent_Done,
     /* 127014 */   // Label 2762: @127014
     /* 127014 */   GIM_Reject,
     /* 127015 */ // Label 2759: @127015
     /* 127015 */ GIM_Reject,
     /* 127016 */ // Label 2694: @127016
     /* 127016 */ GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(127109),
     /* 127021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 127024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 127027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127035 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(127089), // Rule ID 7986 //
     /* 127040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127051 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127054 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127058 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127071 */     // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrm),
     /* 127074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127076 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127087 */     GIR_RootConstrainSelectedInstOperands,
     /* 127088 */     // GIR_Coverage, 7986,
     /* 127088 */     GIR_EraseRootFromParent_Done,
     /* 127089 */   // Label 2764: @127089
     /* 127089 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(127108), // Rule ID 7983 //
     /* 127094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127101 */     // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPRORVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 127101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 127106 */     GIR_RootConstrainSelectedInstOperands,
     /* 127107 */     // GIR_Coverage, 7983,
     /* 127107 */     GIR_Done,
     /* 127108 */   // Label 2765: @127108
     /* 127108 */   GIM_Reject,
     /* 127109 */ // Label 2763: @127109
     /* 127109 */ GIM_Reject,
     /* 127110 */ // Label 2695: @127110
     /* 127110 */ GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(127203),
     /* 127115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 127118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 127121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127129 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(127183), // Rule ID 7959 //
     /* 127134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127145 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127148 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127152 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127165 */     // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrm),
     /* 127168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127170 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127181 */     GIR_RootConstrainSelectedInstOperands,
     /* 127182 */     // GIR_Coverage, 7959,
     /* 127182 */     GIR_EraseRootFromParent_Done,
     /* 127183 */   // Label 2767: @127183
     /* 127183 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(127202), // Rule ID 7956 //
     /* 127188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127195 */     // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPRORVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 127195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 127200 */     GIR_RootConstrainSelectedInstOperands,
     /* 127201 */     // GIR_Coverage, 7956,
     /* 127201 */     GIR_Done,
     /* 127202 */   // Label 2768: @127202
     /* 127202 */   GIM_Reject,
     /* 127203 */ // Label 2766: @127203
     /* 127203 */ GIM_Reject,
     /* 127204 */ // Label 2696: @127204
     /* 127204 */ GIM_Reject,
     /* 127205 */ // Label 32: @127205
     /* 127205 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 2781*/ GIMT_Encode4(130924),
     /* 127216 */ /*GILLT_s8*//*Label 2769*/ GIMT_Encode4(127292),
     /* 127220 */ /*GILLT_s16*//*Label 2770*/ GIMT_Encode4(127722),
     /* 127224 */ /*GILLT_s32*//*Label 2771*/ GIMT_Encode4(128152),
     /* 127228 */ /*GILLT_s64*//*Label 2772*/ GIMT_Encode4(128619), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127244 */ /*GILLT_v2s64*//*Label 2773*/ GIMT_Encode4(129086), GIMT_Encode4(0),
     /* 127252 */ /*GILLT_v4s32*//*Label 2774*/ GIMT_Encode4(129504),
     /* 127256 */ /*GILLT_v4s64*//*Label 2775*/ GIMT_Encode4(129922), GIMT_Encode4(0),
     /* 127264 */ /*GILLT_v8s16*//*Label 2776*/ GIMT_Encode4(130173),
     /* 127268 */ /*GILLT_v8s32*//*Label 2777*/ GIMT_Encode4(130329),
     /* 127272 */ /*GILLT_v8s64*//*Label 2778*/ GIMT_Encode4(130580), GIMT_Encode4(0),
     /* 127280 */ /*GILLT_v16s8*//*Label 2779*/ GIMT_Encode4(130674), GIMT_Encode4(0),
     /* 127288 */ /*GILLT_v16s32*//*Label 2780*/ GIMT_Encode4(130830),
     /* 127292 */ // Label 2769: @127292
     /* 127292 */ GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(127721),
     /* 127297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 127300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 127303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127307 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(127366), // Rule ID 17619 //
     /* 127312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127323 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127326 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127330 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127347 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] })  =>  (ROR8m1_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 127347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8m1_ND),
     /* 127350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 127356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127364 */     GIR_RootConstrainSelectedInstOperands,
     /* 127365 */     // GIR_Coverage, 17619,
     /* 127365 */     GIR_EraseRootFromParent_Done,
     /* 127366 */   // Label 2783: @127366
     /* 127366 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(127433), // Rule ID 768 //
     /* 127371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127382 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127385 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127389 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 127397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127401 */     // MIs[2] Operand 1
     /* 127401 */     // No operand predicates
     /* 127401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 127403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127410 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (ROL8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mi_ND),
     /* 127413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127415 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 127422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 127431 */     GIR_RootConstrainSelectedInstOperands,
     /* 127432 */     // GIR_Coverage, 768,
     /* 127432 */     GIR_EraseRootFromParent_Done,
     /* 127433 */   // Label 2784: @127433
     /* 127433 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(127506), // Rule ID 784 //
     /* 127438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127449 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127452 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127456 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127473 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (ROL8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 127473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127477 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127483 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mCL_ND),
     /* 127490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127504 */     GIR_RootConstrainSelectedInstOperands,
     /* 127505 */     // GIR_Coverage, 784,
     /* 127505 */     GIR_EraseRootFromParent_Done,
     /* 127506 */   // Label 2785: @127506
     /* 127506 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(127534), // Rule ID 17595 //
     /* 127511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127522 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1),
     /* 127525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127527 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127532 */     GIR_RootConstrainSelectedInstOperands,
     /* 127533 */     // GIR_Coverage, 17595,
     /* 127533 */     GIR_EraseRootFromParent_Done,
     /* 127534 */   // Label 2786: @127534
     /* 127534 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(127562), // Rule ID 17603 //
     /* 127539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127550 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1_ND),
     /* 127553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127555 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127560 */     GIR_RootConstrainSelectedInstOperands,
     /* 127561 */     // GIR_Coverage, 17603,
     /* 127561 */     GIR_EraseRootFromParent_Done,
     /* 127562 */   // Label 2787: @127562
     /* 127562 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(127599), // Rule ID 756 //
     /* 127567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127582 */     // MIs[1] Operand 1
     /* 127582 */     // No operand predicates
     /* 127582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127584 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri),
     /* 127587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127589 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127594 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127597 */     GIR_RootConstrainSelectedInstOperands,
     /* 127598 */     // GIR_Coverage, 756,
     /* 127598 */     GIR_EraseRootFromParent_Done,
     /* 127599 */   // Label 2788: @127599
     /* 127599 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(127636), // Rule ID 760 //
     /* 127604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127619 */     // MIs[1] Operand 1
     /* 127619 */     // No operand predicates
     /* 127619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127621 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri_ND),
     /* 127624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127626 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127634 */     GIR_RootConstrainSelectedInstOperands,
     /* 127635 */     // GIR_Coverage, 760,
     /* 127635 */     GIR_EraseRootFromParent_Done,
     /* 127636 */   // Label 2789: @127636
     /* 127636 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(127678), // Rule ID 772 //
     /* 127641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127652 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127656 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL),
     /* 127669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127671 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127676 */     GIR_RootConstrainSelectedInstOperands,
     /* 127677 */     // GIR_Coverage, 772,
     /* 127677 */     GIR_EraseRootFromParent_Done,
     /* 127678 */   // Label 2790: @127678
     /* 127678 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(127720), // Rule ID 776 //
     /* 127683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127694 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127698 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL_ND),
     /* 127711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127718 */     GIR_RootConstrainSelectedInstOperands,
     /* 127719 */     // GIR_Coverage, 776,
     /* 127719 */     GIR_EraseRootFromParent_Done,
     /* 127720 */   // Label 2791: @127720
     /* 127720 */   GIM_Reject,
     /* 127721 */ // Label 2782: @127721
     /* 127721 */ GIM_Reject,
     /* 127722 */ // Label 2770: @127722
     /* 127722 */ GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(128151),
     /* 127727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 127730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 127733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127737 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(127796), // Rule ID 17620 //
     /* 127742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127756 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127760 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 127764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 127768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127777 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] })  =>  (ROR16m1_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 127777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16m1_ND),
     /* 127780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127782 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 127786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127794 */     GIR_RootConstrainSelectedInstOperands,
     /* 127795 */     // GIR_Coverage, 17620,
     /* 127795 */     GIR_EraseRootFromParent_Done,
     /* 127796 */   // Label 2793: @127796
     /* 127796 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(127863), // Rule ID 769 //
     /* 127801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127815 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127819 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 127823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 127827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127831 */     // MIs[2] Operand 1
     /* 127831 */     // No operand predicates
     /* 127831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 127833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127840 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (ROL16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mi_ND),
     /* 127843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 127852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 127861 */     GIR_RootConstrainSelectedInstOperands,
     /* 127862 */     // GIR_Coverage, 769,
     /* 127862 */     GIR_EraseRootFromParent_Done,
     /* 127863 */   // Label 2794: @127863
     /* 127863 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(127936), // Rule ID 785 //
     /* 127868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127879 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127882 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127886 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 127890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127903 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (ROL16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 127903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127907 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mCL_ND),
     /* 127920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127934 */     GIR_RootConstrainSelectedInstOperands,
     /* 127935 */     // GIR_Coverage, 785,
     /* 127935 */     GIR_EraseRootFromParent_Done,
     /* 127936 */   // Label 2795: @127936
     /* 127936 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(127964), // Rule ID 17596 //
     /* 127941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 127952 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 127952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1),
     /* 127955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127962 */     GIR_RootConstrainSelectedInstOperands,
     /* 127963 */     // GIR_Coverage, 17596,
     /* 127963 */     GIR_EraseRootFromParent_Done,
     /* 127964 */   // Label 2796: @127964
     /* 127964 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(127992), // Rule ID 17604 //
     /* 127969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 127980 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 127980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1_ND),
     /* 127983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127985 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127990 */     GIR_RootConstrainSelectedInstOperands,
     /* 127991 */     // GIR_Coverage, 17604,
     /* 127991 */     GIR_EraseRootFromParent_Done,
     /* 127992 */   // Label 2797: @127992
     /* 127992 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(128029), // Rule ID 757 //
     /* 127997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128012 */     // MIs[1] Operand 1
     /* 128012 */     // No operand predicates
     /* 128012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128014 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 128017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128019 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128027 */     GIR_RootConstrainSelectedInstOperands,
     /* 128028 */     // GIR_Coverage, 757,
     /* 128028 */     GIR_EraseRootFromParent_Done,
     /* 128029 */   // Label 2798: @128029
     /* 128029 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(128066), // Rule ID 761 //
     /* 128034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128049 */     // MIs[1] Operand 1
     /* 128049 */     // No operand predicates
     /* 128049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128051 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri_ND),
     /* 128054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128056 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128064 */     GIR_RootConstrainSelectedInstOperands,
     /* 128065 */     // GIR_Coverage, 761,
     /* 128065 */     GIR_EraseRootFromParent_Done,
     /* 128066 */   // Label 2799: @128066
     /* 128066 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(128108), // Rule ID 773 //
     /* 128071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128082 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128086 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL),
     /* 128099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128101 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128106 */     GIR_RootConstrainSelectedInstOperands,
     /* 128107 */     // GIR_Coverage, 773,
     /* 128107 */     GIR_EraseRootFromParent_Done,
     /* 128108 */   // Label 2800: @128108
     /* 128108 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(128150), // Rule ID 777 //
     /* 128113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128124 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128128 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL_ND),
     /* 128141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128143 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128148 */     GIR_RootConstrainSelectedInstOperands,
     /* 128149 */     // GIR_Coverage, 777,
     /* 128149 */     GIR_EraseRootFromParent_Done,
     /* 128150 */   // Label 2801: @128150
     /* 128150 */   GIM_Reject,
     /* 128151 */ // Label 2792: @128151
     /* 128151 */ GIM_Reject,
     /* 128152 */ // Label 2771: @128152
     /* 128152 */ GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(128618),
     /* 128157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 128163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128167 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(128226), // Rule ID 17621 //
     /* 128172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128183 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128186 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128190 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128207 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] })  =>  (ROR32m1_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 128207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32m1_ND),
     /* 128210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128224 */     GIR_RootConstrainSelectedInstOperands,
     /* 128225 */     // GIR_Coverage, 17621,
     /* 128225 */     GIR_EraseRootFromParent_Done,
     /* 128226 */   // Label 2803: @128226
     /* 128226 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(128293), // Rule ID 770 //
     /* 128231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128242 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128245 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128249 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128261 */     // MIs[2] Operand 1
     /* 128261 */     // No operand predicates
     /* 128261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128270 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (ROL32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mi_ND),
     /* 128273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128291 */     GIR_RootConstrainSelectedInstOperands,
     /* 128292 */     // GIR_Coverage, 770,
     /* 128292 */     GIR_EraseRootFromParent_Done,
     /* 128293 */   // Label 2804: @128293
     /* 128293 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(128366), // Rule ID 786 //
     /* 128298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128309 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128312 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128316 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128333 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (ROL32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 128333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128337 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mCL_ND),
     /* 128350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128364 */     GIR_RootConstrainSelectedInstOperands,
     /* 128365 */     // GIR_Coverage, 786,
     /* 128365 */     GIR_EraseRootFromParent_Done,
     /* 128366 */   // Label 2805: @128366
     /* 128366 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(128403), // Rule ID 868 //
     /* 128371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 128374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128386 */     // MIs[1] Operand 1
     /* 128386 */     // No operand predicates
     /* 128386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128388 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 128388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT32ri),
     /* 128391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128393 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 128398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128401 */     GIR_RootConstrainSelectedInstOperands,
     /* 128402 */     // GIR_Coverage, 868,
     /* 128402 */     GIR_EraseRootFromParent_Done,
     /* 128403 */   // Label 2806: @128403
     /* 128403 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(128431), // Rule ID 17597 //
     /* 128408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128419 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1),
     /* 128422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128424 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128429 */     GIR_RootConstrainSelectedInstOperands,
     /* 128430 */     // GIR_Coverage, 17597,
     /* 128430 */     GIR_EraseRootFromParent_Done,
     /* 128431 */   // Label 2807: @128431
     /* 128431 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(128459), // Rule ID 17605 //
     /* 128436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128447 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1_ND),
     /* 128450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128452 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128457 */     GIR_RootConstrainSelectedInstOperands,
     /* 128458 */     // GIR_Coverage, 17605,
     /* 128458 */     GIR_EraseRootFromParent_Done,
     /* 128459 */   // Label 2808: @128459
     /* 128459 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(128496), // Rule ID 758 //
     /* 128464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128479 */     // MIs[1] Operand 1
     /* 128479 */     // No operand predicates
     /* 128479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128481 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri),
     /* 128484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128486 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128494 */     GIR_RootConstrainSelectedInstOperands,
     /* 128495 */     // GIR_Coverage, 758,
     /* 128495 */     GIR_EraseRootFromParent_Done,
     /* 128496 */   // Label 2809: @128496
     /* 128496 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(128533), // Rule ID 762 //
     /* 128501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128516 */     // MIs[1] Operand 1
     /* 128516 */     // No operand predicates
     /* 128516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128518 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri_ND),
     /* 128521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128523 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128531 */     GIR_RootConstrainSelectedInstOperands,
     /* 128532 */     // GIR_Coverage, 762,
     /* 128532 */     GIR_EraseRootFromParent_Done,
     /* 128533 */   // Label 2810: @128533
     /* 128533 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(128575), // Rule ID 774 //
     /* 128538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128549 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128553 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL),
     /* 128566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128568 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128573 */     GIR_RootConstrainSelectedInstOperands,
     /* 128574 */     // GIR_Coverage, 774,
     /* 128574 */     GIR_EraseRootFromParent_Done,
     /* 128575 */   // Label 2811: @128575
     /* 128575 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(128617), // Rule ID 778 //
     /* 128580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128591 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128595 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL_ND),
     /* 128608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128610 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128615 */     GIR_RootConstrainSelectedInstOperands,
     /* 128616 */     // GIR_Coverage, 778,
     /* 128616 */     GIR_EraseRootFromParent_Done,
     /* 128617 */   // Label 2812: @128617
     /* 128617 */   GIM_Reject,
     /* 128618 */ // Label 2802: @128618
     /* 128618 */ GIM_Reject,
     /* 128619 */ // Label 2772: @128619
     /* 128619 */ GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(129085),
     /* 128624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 128630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128634 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(128693), // Rule ID 17622 //
     /* 128639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 128665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128674 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] })  =>  (ROR64m1_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 128674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64m1_ND),
     /* 128677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128691 */     GIR_RootConstrainSelectedInstOperands,
     /* 128692 */     // GIR_Coverage, 17622,
     /* 128692 */     GIR_EraseRootFromParent_Done,
     /* 128693 */   // Label 2814: @128693
     /* 128693 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(128760), // Rule ID 771 //
     /* 128698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128709 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128712 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128716 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128728 */     // MIs[2] Operand 1
     /* 128728 */     // No operand predicates
     /* 128728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128737 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (ROL64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mi_ND),
     /* 128740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128742 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128758 */     GIR_RootConstrainSelectedInstOperands,
     /* 128759 */     // GIR_Coverage, 771,
     /* 128759 */     GIR_EraseRootFromParent_Done,
     /* 128760 */   // Label 2815: @128760
     /* 128760 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(128833), // Rule ID 787 //
     /* 128765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128776 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128800 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (ROL64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 128800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128804 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mCL_ND),
     /* 128817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128831 */     GIR_RootConstrainSelectedInstOperands,
     /* 128832 */     // GIR_Coverage, 787,
     /* 128832 */     GIR_EraseRootFromParent_Done,
     /* 128833 */   // Label 2816: @128833
     /* 128833 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(128870), // Rule ID 869 //
     /* 128838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 128841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128853 */     // MIs[1] Operand 1
     /* 128853 */     // No operand predicates
     /* 128853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128855 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 128855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT64ri),
     /* 128858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 128865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128868 */     GIR_RootConstrainSelectedInstOperands,
     /* 128869 */     // GIR_Coverage, 869,
     /* 128869 */     GIR_EraseRootFromParent_Done,
     /* 128870 */   // Label 2817: @128870
     /* 128870 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(128898), // Rule ID 17598 //
     /* 128875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 128886 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 128886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1),
     /* 128889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128891 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128896 */     GIR_RootConstrainSelectedInstOperands,
     /* 128897 */     // GIR_Coverage, 17598,
     /* 128897 */     GIR_EraseRootFromParent_Done,
     /* 128898 */   // Label 2818: @128898
     /* 128898 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(128926), // Rule ID 17606 //
     /* 128903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 128914 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 128914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1_ND),
     /* 128917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128919 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128924 */     GIR_RootConstrainSelectedInstOperands,
     /* 128925 */     // GIR_Coverage, 17606,
     /* 128925 */     GIR_EraseRootFromParent_Done,
     /* 128926 */   // Label 2819: @128926
     /* 128926 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(128963), // Rule ID 759 //
     /* 128931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128946 */     // MIs[1] Operand 1
     /* 128946 */     // No operand predicates
     /* 128946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128948 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri),
     /* 128951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128961 */     GIR_RootConstrainSelectedInstOperands,
     /* 128962 */     // GIR_Coverage, 759,
     /* 128962 */     GIR_EraseRootFromParent_Done,
     /* 128963 */   // Label 2820: @128963
     /* 128963 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(129000), // Rule ID 763 //
     /* 128968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128983 */     // MIs[1] Operand 1
     /* 128983 */     // No operand predicates
     /* 128983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128985 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri_ND),
     /* 128988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128990 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128998 */     GIR_RootConstrainSelectedInstOperands,
     /* 128999 */     // GIR_Coverage, 763,
     /* 128999 */     GIR_EraseRootFromParent_Done,
     /* 129000 */   // Label 2821: @129000
     /* 129000 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(129042), // Rule ID 775 //
     /* 129005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 129008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 129016 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129020 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL),
     /* 129033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129035 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129040 */     GIR_RootConstrainSelectedInstOperands,
     /* 129041 */     // GIR_Coverage, 775,
     /* 129041 */     GIR_EraseRootFromParent_Done,
     /* 129042 */   // Label 2822: @129042
     /* 129042 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(129084), // Rule ID 779 //
     /* 129047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 129050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 129058 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129062 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL_ND),
     /* 129075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129077 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129082 */     GIR_RootConstrainSelectedInstOperands,
     /* 129083 */     // GIR_Coverage, 779,
     /* 129083 */     GIR_EraseRootFromParent_Done,
     /* 129084 */   // Label 2823: @129084
     /* 129084 */   GIM_Reject,
     /* 129085 */ // Label 2813: @129085
     /* 129085 */ GIM_Reject,
     /* 129086 */ // Label 2773: @129086
     /* 129086 */ GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(129503),
     /* 129091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 129094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 129097 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(129159), // Rule ID 1582 //
     /* 129102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129117 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129124 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129141 */     // (rotl:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQmr:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 129141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTQmr),
     /* 129144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129150 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 129152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129157 */     GIR_RootConstrainSelectedInstOperands,
     /* 129158 */     // GIR_Coverage, 1582,
     /* 129158 */     GIR_EraseRootFromParent_Done,
     /* 129159 */   // Label 2825: @129159
     /* 129159 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(129221), // Rule ID 1581 //
     /* 129164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129183 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129190 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129203 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTQrm),
     /* 129206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129208 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129219 */     GIR_RootConstrainSelectedInstOperands,
     /* 129220 */     // GIR_Coverage, 1581,
     /* 129220 */     GIR_EraseRootFromParent_Done,
     /* 129221 */   // Label 2826: @129221
     /* 129221 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(129283), // Rule ID 8058 //
     /* 129226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129265 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rm),
     /* 129268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129281 */     GIR_RootConstrainSelectedInstOperands,
     /* 129282 */     // GIR_Coverage, 8058,
     /* 129282 */     GIR_EraseRootFromParent_Done,
     /* 129283 */   // Label 2827: @129283
     /* 129283 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(129310), // Rule ID 1580 //
     /* 129288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129303 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 129303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTQrr),
     /* 129308 */     GIR_RootConstrainSelectedInstOperands,
     /* 129309 */     // GIR_Coverage, 1580,
     /* 129309 */     GIR_Done,
     /* 129310 */   // Label 2828: @129310
     /* 129310 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(129337), // Rule ID 8055 //
     /* 129315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129330 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPROLVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 129330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rr),
     /* 129335 */     GIR_RootConstrainSelectedInstOperands,
     /* 129336 */     // GIR_Coverage, 8055,
     /* 129336 */     GIR_Done,
     /* 129337 */   // Label 2829: @129337
     /* 129337 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(129502), // Rule ID 20795 //
     /* 129342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 129349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129357 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 129357 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 129360 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129364 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 129371 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 129374 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129378 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129383 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 129386 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 129390 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 129393 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129398 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129403 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129408 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 129411 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129415 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 129425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129434 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 129437 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 129441 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 129444 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129449 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129454 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 129462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 129466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129471 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129474 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 129477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129484 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 129491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 129496 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129501 */     // GIR_Coverage, 20795,
     /* 129501 */     GIR_EraseRootFromParent_Done,
     /* 129502 */   // Label 2830: @129502
     /* 129502 */   GIM_Reject,
     /* 129503 */ // Label 2824: @129503
     /* 129503 */ GIM_Reject,
     /* 129504 */ // Label 2774: @129504
     /* 129504 */ GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(129921),
     /* 129509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129515 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(129577), // Rule ID 1579 //
     /* 129520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129535 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129538 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129542 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129559 */     // (rotl:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDmr:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 129559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTDmr),
     /* 129562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129564 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129568 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 129570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129575 */     GIR_RootConstrainSelectedInstOperands,
     /* 129576 */     // GIR_Coverage, 1579,
     /* 129576 */     GIR_EraseRootFromParent_Done,
     /* 129577 */   // Label 2832: @129577
     /* 129577 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(129639), // Rule ID 1578 //
     /* 129582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129601 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129604 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129608 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129621 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTDrm),
     /* 129624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129626 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129628 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129637 */     GIR_RootConstrainSelectedInstOperands,
     /* 129638 */     // GIR_Coverage, 1578,
     /* 129638 */     GIR_EraseRootFromParent_Done,
     /* 129639 */   // Label 2833: @129639
     /* 129639 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(129701), // Rule ID 8031 //
     /* 129644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129663 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129670 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129683 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rm),
     /* 129686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129688 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129690 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129699 */     GIR_RootConstrainSelectedInstOperands,
     /* 129700 */     // GIR_Coverage, 8031,
     /* 129700 */     GIR_EraseRootFromParent_Done,
     /* 129701 */   // Label 2834: @129701
     /* 129701 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(129728), // Rule ID 1577 //
     /* 129706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129721 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 129721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTDrr),
     /* 129726 */     GIR_RootConstrainSelectedInstOperands,
     /* 129727 */     // GIR_Coverage, 1577,
     /* 129727 */     GIR_Done,
     /* 129728 */   // Label 2835: @129728
     /* 129728 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(129755), // Rule ID 8028 //
     /* 129733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129748 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPROLVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 129748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rr),
     /* 129753 */     GIR_RootConstrainSelectedInstOperands,
     /* 129754 */     // GIR_Coverage, 8028,
     /* 129754 */     GIR_Done,
     /* 129755 */   // Label 2836: @129755
     /* 129755 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(129920), // Rule ID 20797 //
     /* 129760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 129767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129775 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 129775 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 129778 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129782 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 129789 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 129792 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129796 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129801 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 129804 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 129808 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 129811 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129816 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129821 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 129829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 129843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129852 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 129855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 129859 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 129862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 129880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 129884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 129895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129902 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 129909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 129914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129919 */     // GIR_Coverage, 20797,
     /* 129919 */     GIR_EraseRootFromParent_Done,
     /* 129920 */   // Label 2837: @129920
     /* 129920 */   GIM_Reject,
     /* 129921 */ // Label 2831: @129921
     /* 129921 */ GIM_Reject,
     /* 129922 */ // Label 2775: @129922
     /* 129922 */ GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(130172),
     /* 129927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 129930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 129933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 129937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 129941 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(129995), // Rule ID 8049 //
     /* 129946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129957 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129964 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129977 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rm),
     /* 129980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129982 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129984 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129993 */     GIR_RootConstrainSelectedInstOperands,
     /* 129994 */     // GIR_Coverage, 8049,
     /* 129994 */     GIR_EraseRootFromParent_Done,
     /* 129995 */   // Label 2839: @129995
     /* 129995 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(130014), // Rule ID 8046 //
     /* 130000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130007 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPROLVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 130007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rr),
     /* 130012 */     GIR_RootConstrainSelectedInstOperands,
     /* 130013 */     // GIR_Coverage, 8046,
     /* 130013 */     GIR_Done,
     /* 130014 */   // Label 2840: @130014
     /* 130014 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(130171), // Rule ID 20796 //
     /* 130019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 130022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130026 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 130026 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 130029 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130033 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 130040 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 130043 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130047 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130052 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130055 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130059 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 130062 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130067 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130072 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130077 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 130080 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130084 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 130094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130103 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130106 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130110 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 130113 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130118 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130123 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 130131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 130135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130140 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130143 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 130160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130170 */     // GIR_Coverage, 20796,
     /* 130170 */     GIR_EraseRootFromParent_Done,
     /* 130171 */   // Label 2841: @130171
     /* 130171 */   GIM_Reject,
     /* 130172 */ // Label 2838: @130172
     /* 130172 */ GIM_Reject,
     /* 130173 */ // Label 2776: @130173
     /* 130173 */ GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(130328),
     /* 130178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 130184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130188 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(130246), // Rule ID 1585 //
     /* 130193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130211 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130228 */     // (rotl:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWmr:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 130228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTWmr),
     /* 130231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130233 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 130237 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 130239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130244 */     GIR_RootConstrainSelectedInstOperands,
     /* 130245 */     // GIR_Coverage, 1585,
     /* 130245 */     GIR_EraseRootFromParent_Done,
     /* 130246 */   // Label 2843: @130246
     /* 130246 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(130304), // Rule ID 1584 //
     /* 130251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130266 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130273 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130286 */     // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTWrm),
     /* 130289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130302 */     GIR_RootConstrainSelectedInstOperands,
     /* 130303 */     // GIR_Coverage, 1584,
     /* 130303 */     GIR_EraseRootFromParent_Done,
     /* 130304 */   // Label 2844: @130304
     /* 130304 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(130327), // Rule ID 1583 //
     /* 130309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130320 */     // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 130320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTWrr),
     /* 130325 */     GIR_RootConstrainSelectedInstOperands,
     /* 130326 */     // GIR_Coverage, 1583,
     /* 130326 */     GIR_Done,
     /* 130327 */   // Label 2845: @130327
     /* 130327 */   GIM_Reject,
     /* 130328 */ // Label 2842: @130328
     /* 130328 */ GIM_Reject,
     /* 130329 */ // Label 2777: @130329
     /* 130329 */ GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(130579),
     /* 130334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 130337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 130340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130348 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(130402), // Rule ID 8022 //
     /* 130353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130364 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130384 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rm),
     /* 130387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130400 */     GIR_RootConstrainSelectedInstOperands,
     /* 130401 */     // GIR_Coverage, 8022,
     /* 130401 */     GIR_EraseRootFromParent_Done,
     /* 130402 */   // Label 2847: @130402
     /* 130402 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(130421), // Rule ID 8019 //
     /* 130407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130414 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPROLVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 130414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rr),
     /* 130419 */     GIR_RootConstrainSelectedInstOperands,
     /* 130420 */     // GIR_Coverage, 8019,
     /* 130420 */     GIR_Done,
     /* 130421 */   // Label 2848: @130421
     /* 130421 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(130578), // Rule ID 20798 //
     /* 130426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 130429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130433 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 130433 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 130436 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130440 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 130447 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 130450 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130454 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130459 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130462 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130466 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 130469 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130474 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130479 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130484 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 130487 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130491 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130498 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 130501 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130505 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130510 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130513 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130517 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 130520 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130525 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130530 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 130538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 130542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130547 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130550 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130560 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 130567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130577 */     // GIR_Coverage, 20798,
     /* 130577 */     GIR_EraseRootFromParent_Done,
     /* 130578 */   // Label 2849: @130578
     /* 130578 */   GIM_Reject,
     /* 130579 */ // Label 2846: @130579
     /* 130579 */ GIM_Reject,
     /* 130580 */ // Label 2778: @130580
     /* 130580 */ GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(130673),
     /* 130585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 130588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 130591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130599 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(130653), // Rule ID 8040 //
     /* 130604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130615 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130622 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130635 */     // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrm),
     /* 130638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130640 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130642 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130651 */     GIR_RootConstrainSelectedInstOperands,
     /* 130652 */     // GIR_Coverage, 8040,
     /* 130652 */     GIR_EraseRootFromParent_Done,
     /* 130653 */   // Label 2851: @130653
     /* 130653 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(130672), // Rule ID 8037 //
     /* 130658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130665 */     // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPROLVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 130665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 130670 */     GIR_RootConstrainSelectedInstOperands,
     /* 130671 */     // GIR_Coverage, 8037,
     /* 130671 */     GIR_Done,
     /* 130672 */   // Label 2852: @130672
     /* 130672 */   GIM_Reject,
     /* 130673 */ // Label 2850: @130673
     /* 130673 */ GIM_Reject,
     /* 130674 */ // Label 2779: @130674
     /* 130674 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(130829),
     /* 130679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 130682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 130685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130689 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(130747), // Rule ID 1576 //
     /* 130694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130705 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130708 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130712 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130729 */     // (rotl:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBmr:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 130729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTBmr),
     /* 130732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130734 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 130738 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 130740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130745 */     GIR_RootConstrainSelectedInstOperands,
     /* 130746 */     // GIR_Coverage, 1576,
     /* 130746 */     GIR_EraseRootFromParent_Done,
     /* 130747 */   // Label 2854: @130747
     /* 130747 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(130805), // Rule ID 1575 //
     /* 130752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130767 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130770 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130774 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130787 */     // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTBrm),
     /* 130790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130792 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130794 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130803 */     GIR_RootConstrainSelectedInstOperands,
     /* 130804 */     // GIR_Coverage, 1575,
     /* 130804 */     GIR_EraseRootFromParent_Done,
     /* 130805 */   // Label 2855: @130805
     /* 130805 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(130828), // Rule ID 1574 //
     /* 130810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130821 */     // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 130821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTBrr),
     /* 130826 */     GIR_RootConstrainSelectedInstOperands,
     /* 130827 */     // GIR_Coverage, 1574,
     /* 130827 */     GIR_Done,
     /* 130828 */   // Label 2856: @130828
     /* 130828 */   GIM_Reject,
     /* 130829 */ // Label 2853: @130829
     /* 130829 */ GIM_Reject,
     /* 130830 */ // Label 2780: @130830
     /* 130830 */ GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(130923),
     /* 130835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 130838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 130841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130849 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(130903), // Rule ID 8013 //
     /* 130854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130865 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130868 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130872 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130885 */     // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrm),
     /* 130888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130890 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130901 */     GIR_RootConstrainSelectedInstOperands,
     /* 130902 */     // GIR_Coverage, 8013,
     /* 130902 */     GIR_EraseRootFromParent_Done,
     /* 130903 */   // Label 2858: @130903
     /* 130903 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(130922), // Rule ID 8010 //
     /* 130908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130915 */     // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPROLVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 130915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 130920 */     GIR_RootConstrainSelectedInstOperands,
     /* 130921 */     // GIR_Coverage, 8010,
     /* 130921 */     GIR_Done,
     /* 130922 */   // Label 2859: @130922
     /* 130922 */   GIM_Reject,
     /* 130923 */ // Label 2857: @130923
     /* 130923 */ GIM_Reject,
     /* 130924 */ // Label 2781: @130924
     /* 130924 */ GIM_Reject,
     /* 130925 */ // Label 33: @130925
     /* 130925 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(24), /*)*//*default:*//*Label 2866*/ GIMT_Encode4(132581),
     /* 130936 */ /*GILLT_v2s1*//*Label 2860*/ GIMT_Encode4(131004), GIMT_Encode4(0),
     /* 130944 */ /*GILLT_v4s1*//*Label 2861*/ GIMT_Encode4(131165), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130956 */ /*GILLT_v8s1*//*Label 2862*/ GIMT_Encode4(131512), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130972 */ /*GILLT_v16s1*//*Label 2863*/ GIMT_Encode4(131909), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130988 */ /*GILLT_v32s1*//*Label 2864*/ GIMT_Encode4(132306), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131000 */ /*GILLT_v64s1*//*Label 2865*/ GIMT_Encode4(132530),
     /* 131004 */ // Label 2860: @131004
     /* 131004 */ GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(131164),
     /* 131009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 131012 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 131015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 131019 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131024 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131028 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(131059), // Rule ID 12605 //
     /* 131033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131040 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131046 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131050 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ128kr:{ *:[v2i1] } VR128X:{ *:[v2i64] }:$src)
     /* 131050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ128kr),
     /* 131053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131055 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131057 */     GIR_RootConstrainSelectedInstOperands,
     /* 131058 */     // GIR_Coverage, 12605,
     /* 131058 */     GIR_EraseRootFromParent_Done,
     /* 131059 */   // Label 2868: @131059
     /* 131059 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(131163), // Rule ID 21657 //
     /* 131064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131071 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131077 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131081 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), VK2:{ *:[i32] })
     /* 131081 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 131084 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131088 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131095 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 131098 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131102 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131107 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131110 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131114 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131127 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 131135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131144 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 131162 */     // GIR_Coverage, 21657,
     /* 131162 */     GIR_EraseRootFromParent_Done,
     /* 131163 */   // Label 2869: @131163
     /* 131163 */   GIM_Reject,
     /* 131164 */ // Label 2867: @131164
     /* 131164 */ GIM_Reject,
     /* 131165 */ // Label 2861: @131165
     /* 131165 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(131215), // Rule ID 12602 //
     /* 131170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 131176 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 131179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131183 */   // MIs[0] Operand 1
     /* 131183 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131188 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131192 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131198 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131200 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131204 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131206 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ128kr:{ *:[v4i1] } VR128X:{ *:[v4i32] }:$src)
     /* 131206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ128kr),
     /* 131209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131211 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131213 */   GIR_RootConstrainSelectedInstOperands,
     /* 131214 */   // GIR_Coverage, 12602,
     /* 131214 */   GIR_EraseRootFromParent_Done,
     /* 131215 */ // Label 2870: @131215
     /* 131215 */ GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(131265), // Rule ID 12604 //
     /* 131220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 131226 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 131229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131233 */   // MIs[0] Operand 1
     /* 131233 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131238 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131242 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131248 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131250 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131254 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131256 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ256kr:{ *:[v4i1] } VR256X:{ *:[v4i64] }:$src)
     /* 131256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ256kr),
     /* 131259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131261 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131263 */   GIR_RootConstrainSelectedInstOperands,
     /* 131264 */   // GIR_Coverage, 12604,
     /* 131264 */   GIR_EraseRootFromParent_Done,
     /* 131265 */ // Label 2871: @131265
     /* 131265 */ GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(131388), // Rule ID 21655 //
     /* 131270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 131276 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 131279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131283 */   // MIs[0] Operand 1
     /* 131283 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131288 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131292 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131298 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131300 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131304 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131306 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 131306 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 131309 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131313 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131320 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 131323 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131327 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131332 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131335 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131339 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131342 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131347 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131352 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 131360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 131364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131369 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131382 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 131387 */   // GIR_Coverage, 21655,
     /* 131387 */   GIR_EraseRootFromParent_Done,
     /* 131388 */ // Label 2872: @131388
     /* 131388 */ GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(131511), // Rule ID 21656 //
     /* 131393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 131399 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 131402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131406 */   // MIs[0] Operand 1
     /* 131406 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131411 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131415 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131421 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131423 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131427 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131429 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 131429 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 131432 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131436 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131443 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 131446 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131450 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131455 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131458 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131462 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 131465 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131470 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131475 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 131480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 131483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131492 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 131510 */   // GIR_Coverage, 21656,
     /* 131510 */   GIR_EraseRootFromParent_Done,
     /* 131511 */ // Label 2873: @131511
     /* 131511 */ GIM_Reject,
     /* 131512 */ // Label 2862: @131512
     /* 131512 */ GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(131562), // Rule ID 12599 //
     /* 131517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 131523 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 131526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131530 */   // MIs[0] Operand 1
     /* 131530 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131535 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131539 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131545 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131547 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131551 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131553 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ128kr:{ *:[v8i1] } VR128X:{ *:[v8i16] }:$src)
     /* 131553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ128kr),
     /* 131556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131558 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131560 */   GIR_RootConstrainSelectedInstOperands,
     /* 131561 */   // GIR_Coverage, 12599,
     /* 131561 */   GIR_EraseRootFromParent_Done,
     /* 131562 */ // Label 2874: @131562
     /* 131562 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(131612), // Rule ID 12601 //
     /* 131567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 131573 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 131576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131580 */   // MIs[0] Operand 1
     /* 131580 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131589 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131595 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131597 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131603 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ256kr:{ *:[v8i1] } VR256X:{ *:[v8i32] }:$src)
     /* 131603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ256kr),
     /* 131606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131608 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131610 */   GIR_RootConstrainSelectedInstOperands,
     /* 131611 */   // GIR_Coverage, 12601,
     /* 131611 */   GIR_EraseRootFromParent_Done,
     /* 131612 */ // Label 2875: @131612
     /* 131612 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(131662), // Rule ID 12603 //
     /* 131617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 131620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 131623 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 131626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131630 */   // MIs[0] Operand 1
     /* 131630 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131635 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131639 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131645 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131647 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131651 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131653 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZkr:{ *:[v8i1] } VR512:{ *:[v8i64] }:$src)
     /* 131653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131658 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131660 */   GIR_RootConstrainSelectedInstOperands,
     /* 131661 */   // GIR_Coverage, 12603,
     /* 131661 */   GIR_EraseRootFromParent_Done,
     /* 131662 */ // Label 2876: @131662
     /* 131662 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(131785), // Rule ID 21653 //
     /* 131667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 131670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 131673 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 131676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131680 */   // MIs[0] Operand 1
     /* 131680 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131685 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131689 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131695 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131697 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131703 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 131703 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 131706 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131710 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131717 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 131720 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131724 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131729 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131732 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131736 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131739 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131744 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131749 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 131757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 131761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131766 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 131784 */   // GIR_Coverage, 21653,
     /* 131784 */   GIR_EraseRootFromParent_Done,
     /* 131785 */ // Label 2877: @131785
     /* 131785 */ GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(131908), // Rule ID 21654 //
     /* 131790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 131796 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 131799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131803 */   // MIs[0] Operand 1
     /* 131803 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131808 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131812 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131818 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131820 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131826 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 131826 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 131829 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131833 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131840 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 131843 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131847 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131852 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131855 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131859 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 131862 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131867 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131872 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 131877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 131880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 131884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131889 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 131907 */   // GIR_Coverage, 21654,
     /* 131907 */   GIR_EraseRootFromParent_Done,
     /* 131908 */ // Label 2878: @131908
     /* 131908 */ GIM_Reject,
     /* 131909 */ // Label 2863: @131909
     /* 131909 */ GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(131959), // Rule ID 12596 //
     /* 131914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 131920 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 131923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 131927 */   // MIs[0] Operand 1
     /* 131927 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131932 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131936 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131942 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131944 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131948 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131950 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ128kr:{ *:[v16i1] } VR128X:{ *:[v16i8] }:$src)
     /* 131950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ128kr),
     /* 131953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131955 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131957 */   GIR_RootConstrainSelectedInstOperands,
     /* 131958 */   // GIR_Coverage, 12596,
     /* 131958 */   GIR_EraseRootFromParent_Done,
     /* 131959 */ // Label 2879: @131959
     /* 131959 */ GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(132009), // Rule ID 12598 //
     /* 131964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 131970 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 131973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 131977 */   // MIs[0] Operand 1
     /* 131977 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131982 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131986 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131992 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131994 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131998 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132000 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ256kr:{ *:[v16i1] } VR256X:{ *:[v16i16] }:$src)
     /* 132000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ256kr),
     /* 132003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132005 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132007 */   GIR_RootConstrainSelectedInstOperands,
     /* 132008 */   // GIR_Coverage, 12598,
     /* 132008 */   GIR_EraseRootFromParent_Done,
     /* 132009 */ // Label 2880: @132009
     /* 132009 */ GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(132059), // Rule ID 12600 //
     /* 132014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 132017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 132020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 132023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132027 */   // MIs[0] Operand 1
     /* 132027 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132036 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132042 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132044 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132050 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZkr:{ *:[v16i1] } VR512:{ *:[v16i32] }:$src)
     /* 132050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 132053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132055 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132057 */   GIR_RootConstrainSelectedInstOperands,
     /* 132058 */   // GIR_Coverage, 12600,
     /* 132058 */   GIR_EraseRootFromParent_Done,
     /* 132059 */ // Label 2881: @132059
     /* 132059 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(132182), // Rule ID 21651 //
     /* 132064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 132070 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 132073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132077 */   // MIs[0] Operand 1
     /* 132077 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132082 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132086 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132092 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132094 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132098 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132100 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 132100 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 132103 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132107 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132112 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132114 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 132117 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132121 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132126 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132129 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132133 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 132136 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132141 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132146 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132151 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 132154 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132158 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132163 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132176 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 132181 */   // GIR_Coverage, 21651,
     /* 132181 */   GIR_EraseRootFromParent_Done,
     /* 132182 */ // Label 2882: @132182
     /* 132182 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(132305), // Rule ID 21652 //
     /* 132187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 132193 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 132196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132200 */   // MIs[0] Operand 1
     /* 132200 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132205 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132209 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132215 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132217 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132223 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 132223 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 132226 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132230 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132237 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 132240 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132244 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132249 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132252 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132256 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132259 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132264 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132269 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132274 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 132277 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 132281 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132286 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132296 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132299 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 132304 */   // GIR_Coverage, 21652,
     /* 132304 */   GIR_EraseRootFromParent_Done,
     /* 132305 */ // Label 2883: @132305
     /* 132305 */ GIM_Reject,
     /* 132306 */ // Label 2864: @132306
     /* 132306 */ GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(132356), // Rule ID 12595 //
     /* 132311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 132314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 132317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 132320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132324 */   // MIs[0] Operand 1
     /* 132324 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132329 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132333 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132339 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132341 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132345 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132347 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ256kr:{ *:[v32i1] } VR256X:{ *:[v32i8] }:$src)
     /* 132347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ256kr),
     /* 132350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132352 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132354 */   GIR_RootConstrainSelectedInstOperands,
     /* 132355 */   // GIR_Coverage, 12595,
     /* 132355 */   GIR_EraseRootFromParent_Done,
     /* 132356 */ // Label 2884: @132356
     /* 132356 */ GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(132406), // Rule ID 12597 //
     /* 132361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 132364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 132367 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 132370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132374 */   // MIs[0] Operand 1
     /* 132374 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132379 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132383 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132389 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132391 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132395 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132397 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i16] }, VR512:{ *:[v32i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZkr:{ *:[v32i1] } VR512:{ *:[v32i16] }:$src)
     /* 132397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 132400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132402 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132404 */   GIR_RootConstrainSelectedInstOperands,
     /* 132405 */   // GIR_Coverage, 12597,
     /* 132405 */   GIR_EraseRootFromParent_Done,
     /* 132406 */ // Label 2885: @132406
     /* 132406 */ GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(132529), // Rule ID 21650 //
     /* 132411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 132417 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 132420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132424 */   // MIs[0] Operand 1
     /* 132424 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132429 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132433 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132439 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132441 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132445 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132447 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] })), VK32:{ *:[i32] })
     /* 132447 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 132450 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132454 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132461 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 132464 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132468 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132473 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132476 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132480 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132483 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132488 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132493 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 132501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132510 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 132528 */   // GIR_Coverage, 21650,
     /* 132528 */   GIR_EraseRootFromParent_Done,
     /* 132529 */ // Label 2886: @132529
     /* 132529 */ GIM_Reject,
     /* 132530 */ // Label 2865: @132530
     /* 132530 */ GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(132580), // Rule ID 12594 //
     /* 132535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 132538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 132541 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 132544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 132548 */   // MIs[0] Operand 1
     /* 132548 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132553 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132557 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132563 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132565 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132569 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132571 */   // (setcc:{ *:[v64i1] } immAllZerosV:{ *:[v64i8] }, VR512:{ *:[v64i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZkr:{ *:[v64i1] } VR512:{ *:[v64i8] }:$src)
     /* 132571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132576 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132578 */   GIR_RootConstrainSelectedInstOperands,
     /* 132579 */   // GIR_Coverage, 12594,
     /* 132579 */   GIR_EraseRootFromParent_Done,
     /* 132580 */ // Label 2887: @132580
     /* 132580 */ GIM_Reject,
     /* 132581 */ // Label 2866: @132581
     /* 132581 */ GIM_Reject,
     /* 132582 */ // Label 34: @132582
     /* 132582 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2900*/ GIMT_Encode4(140247),
     /* 132593 */ /*GILLT_v2s64*//*Label 2888*/ GIMT_Encode4(132661), GIMT_Encode4(0),
     /* 132601 */ /*GILLT_v4s32*//*Label 2889*/ GIMT_Encode4(133525),
     /* 132605 */ /*GILLT_v4s64*//*Label 2890*/ GIMT_Encode4(134389), GIMT_Encode4(0),
     /* 132613 */ /*GILLT_v8s16*//*Label 2891*/ GIMT_Encode4(135169),
     /* 132617 */ /*GILLT_v8s32*//*Label 2892*/ GIMT_Encode4(136327),
     /* 132621 */ /*GILLT_v8s64*//*Label 2893*/ GIMT_Encode4(137107), GIMT_Encode4(0),
     /* 132629 */ /*GILLT_v16s8*//*Label 2894*/ GIMT_Encode4(137488),
     /* 132633 */ /*GILLT_v16s16*//*Label 2895*/ GIMT_Encode4(137928),
     /* 132637 */ /*GILLT_v16s32*//*Label 2896*/ GIMT_Encode4(138998), GIMT_Encode4(0),
     /* 132645 */ /*GILLT_v32s8*//*Label 2897*/ GIMT_Encode4(139339),
     /* 132649 */ /*GILLT_v32s16*//*Label 2898*/ GIMT_Encode4(139743), GIMT_Encode4(0),
     /* 132657 */ /*GILLT_v64s8*//*Label 2899*/ GIMT_Encode4(140161),
     /* 132661 */ // Label 2888: @132661
     /* 132661 */ GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(133524),
     /* 132666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 132669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 132672 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 132675 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(132720), // Rule ID 4488 //
     /* 132680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132699 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132705 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132709 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src, immAllZerosV:{ *:[v2f64] })  =>  (VMOVAPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 132709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrkz),
     /* 132712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132714 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132716 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 132718 */     GIR_RootConstrainSelectedInstOperands,
     /* 132719 */     // GIR_Coverage, 4488,
     /* 132719 */     GIR_EraseRootFromParent_Done,
     /* 132720 */   // Label 2902: @132720
     /* 132720 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(132765), // Rule ID 4542 //
     /* 132725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132744 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132750 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132754 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src, immAllZerosV:{ *:[v2i64] })  =>  (VMOVDQA64Z128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 132754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrkz),
     /* 132757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132759 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132761 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 132763 */     GIR_RootConstrainSelectedInstOperands,
     /* 132764 */     // GIR_Coverage, 4542,
     /* 132764 */     GIR_EraseRootFromParent_Done,
     /* 132765 */   // Label 2903: @132765
     /* 132765 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(132914), // Rule ID 19776 //
     /* 132770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 132773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 132777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132789 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132795 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132799 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, immAllZerosV:{ *:[v2f64] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 132799 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 132802 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132806 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 132813 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 132816 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132820 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132825 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 132828 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 132832 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 132835 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132840 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132845 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132850 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 132853 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132857 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132862 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 132866 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 132871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 132874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 132878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132883 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132886 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 132889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132896 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 132903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 132908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132913 */     // GIR_Coverage, 19776,
     /* 132913 */     GIR_EraseRootFromParent_Done,
     /* 132914 */   // Label 2904: @132914
     /* 132914 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(133063), // Rule ID 19778 //
     /* 132919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 132922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 132926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132938 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132944 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132948 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, immAllZerosV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 132948 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 132951 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132955 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 132962 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 132965 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132969 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132974 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 132977 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 132981 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 132984 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132989 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132994 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 133002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133011 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 133027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133035 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133045 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133062 */     // GIR_Coverage, 19778,
     /* 133062 */     GIR_EraseRootFromParent_Done,
     /* 133063 */   // Label 2905: @133063
     /* 133063 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(133100), // Rule ID 4490 //
     /* 133068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133087 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (VMOVAPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1)
     /* 133087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrk),
     /* 133090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133092 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133094 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133098 */     GIR_RootConstrainSelectedInstOperands,
     /* 133099 */     // GIR_Coverage, 4490,
     /* 133099 */     GIR_EraseRootFromParent_Done,
     /* 133100 */   // Label 2906: @133100
     /* 133100 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(133137), // Rule ID 4544 //
     /* 133105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133124 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (VMOVDQA64Z128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1)
     /* 133124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrk),
     /* 133127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133129 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133131 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133135 */     GIR_RootConstrainSelectedInstOperands,
     /* 133136 */     // GIR_Coverage, 4544,
     /* 133136 */     GIR_EraseRootFromParent_Done,
     /* 133137 */   // Label 2907: @133137
     /* 133137 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(133330), // Rule ID 19775 //
     /* 133142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133161 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133161 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 133164 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133168 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 133175 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 133178 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133182 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133187 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 133190 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133194 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 133197 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133202 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133207 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133212 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 133215 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133219 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133224 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133228 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133233 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133236 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133240 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133247 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 133250 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133254 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133259 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133262 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 133266 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 133269 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133274 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133279 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 133291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133296 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133299 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 133302 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 133305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133312 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133329 */     // GIR_Coverage, 19775,
     /* 133329 */     GIR_EraseRootFromParent_Done,
     /* 133330 */   // Label 2908: @133330
     /* 133330 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(133523), // Rule ID 19777 //
     /* 133335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133354 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133354 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 133357 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133361 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 133368 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 133371 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133375 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133380 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 133383 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133387 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 133390 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133395 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133400 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133405 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 133408 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133412 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133417 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133421 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133426 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133429 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133433 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133440 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 133443 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133447 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133452 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133455 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 133459 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 133462 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133467 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133472 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 133484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133489 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133492 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 133495 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 133498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133505 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133512 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133522 */     // GIR_Coverage, 19777,
     /* 133522 */     GIR_EraseRootFromParent_Done,
     /* 133523 */   // Label 2909: @133523
     /* 133523 */   GIM_Reject,
     /* 133524 */ // Label 2901: @133524
     /* 133524 */ GIM_Reject,
     /* 133525 */ // Label 2889: @133525
     /* 133525 */ GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(134388),
     /* 133530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 133533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 133536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 133539 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(133584), // Rule ID 4470 //
     /* 133544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133563 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133569 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133573 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src, immAllZerosV:{ *:[v4f32] })  =>  (VMOVAPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 133573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrkz),
     /* 133576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133578 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133580 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133582 */     GIR_RootConstrainSelectedInstOperands,
     /* 133583 */     // GIR_Coverage, 4470,
     /* 133583 */     GIR_EraseRootFromParent_Done,
     /* 133584 */   // Label 2911: @133584
     /* 133584 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(133629), // Rule ID 4528 //
     /* 133589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133608 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133614 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133618 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src, immAllZerosV:{ *:[v4i32] })  =>  (VMOVDQA32Z128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 133618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrkz),
     /* 133621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133623 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133627 */     GIR_RootConstrainSelectedInstOperands,
     /* 133628 */     // GIR_Coverage, 4528,
     /* 133628 */     GIR_EraseRootFromParent_Done,
     /* 133629 */   // Label 2912: @133629
     /* 133629 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(133778), // Rule ID 19768 //
     /* 133634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133653 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133659 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133663 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, immAllZerosV:{ *:[v4f32] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133663 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 133666 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133670 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133677 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 133680 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133684 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133689 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133692 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133696 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133699 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133704 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133709 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133714 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 133717 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133721 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133726 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133730 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 133735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 133738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 133742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133747 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133750 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133760 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133777 */     // GIR_Coverage, 19768,
     /* 133777 */     GIR_EraseRootFromParent_Done,
     /* 133778 */   // Label 2913: @133778
     /* 133778 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(133927), // Rule ID 19770 //
     /* 133783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133802 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133808 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133812 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, immAllZerosV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133812 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 133815 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133819 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 133829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133838 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133841 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133845 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133848 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133853 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133858 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133863 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 133866 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133870 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133879 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 133884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 133887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 133891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133896 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133899 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133926 */     // GIR_Coverage, 19770,
     /* 133926 */     GIR_EraseRootFromParent_Done,
     /* 133927 */   // Label 2914: @133927
     /* 133927 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(133964), // Rule ID 4472 //
     /* 133932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133951 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (VMOVAPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1)
     /* 133951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrk),
     /* 133954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133956 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133958 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133960 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133962 */     GIR_RootConstrainSelectedInstOperands,
     /* 133963 */     // GIR_Coverage, 4472,
     /* 133963 */     GIR_EraseRootFromParent_Done,
     /* 133964 */   // Label 2915: @133964
     /* 133964 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(134001), // Rule ID 4529 //
     /* 133969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133988 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (VMOVDQA32Z128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1)
     /* 133988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrk),
     /* 133991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133993 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133995 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133997 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133999 */     GIR_RootConstrainSelectedInstOperands,
     /* 134000 */     // GIR_Coverage, 4529,
     /* 134000 */     GIR_EraseRootFromParent_Done,
     /* 134001 */   // Label 2916: @134001
     /* 134001 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(134194), // Rule ID 19767 //
     /* 134006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 134013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134025 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134025 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 134028 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134032 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134039 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 134042 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134046 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134051 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134054 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134058 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 134061 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134066 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134071 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134076 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 134079 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134083 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134088 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134092 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134097 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134100 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134104 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134111 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 134114 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134118 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134123 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134130 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 134133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134138 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134143 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 134155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134160 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134163 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134166 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134176 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134193 */     // GIR_Coverage, 19767,
     /* 134193 */     GIR_EraseRootFromParent_Done,
     /* 134194 */   // Label 2917: @134194
     /* 134194 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(134387), // Rule ID 19769 //
     /* 134199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 134206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134218 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134218 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 134221 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134225 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134232 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 134235 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134239 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134244 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134247 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134251 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 134254 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134259 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134264 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134269 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 134272 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134276 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134281 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134285 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134290 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134293 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134297 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134304 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 134307 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134311 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134316 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134319 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134323 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 134326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134331 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134336 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 134348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134353 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134356 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134359 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134369 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134386 */     // GIR_Coverage, 19769,
     /* 134386 */     GIR_EraseRootFromParent_Done,
     /* 134387 */   // Label 2918: @134387
     /* 134387 */   GIM_Reject,
     /* 134388 */ // Label 2910: @134388
     /* 134388 */ GIM_Reject,
     /* 134389 */ // Label 2890: @134389
     /* 134389 */ GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(135168),
     /* 134394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 134397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 134400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 134403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134415 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(134448), // Rule ID 4483 //
     /* 134420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134427 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134433 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134437 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src, immAllZerosV:{ *:[v4f64] })  =>  (VMOVAPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 134437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrkz),
     /* 134440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134442 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134444 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 134446 */     GIR_RootConstrainSelectedInstOperands,
     /* 134447 */     // GIR_Coverage, 4483,
     /* 134447 */     GIR_EraseRootFromParent_Done,
     /* 134448 */   // Label 2920: @134448
     /* 134448 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(134481), // Rule ID 4537 //
     /* 134453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134460 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134466 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134470 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src, immAllZerosV:{ *:[v4i64] })  =>  (VMOVDQA64Z256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 134470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrkz),
     /* 134473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134475 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134477 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 134479 */     GIR_RootConstrainSelectedInstOperands,
     /* 134480 */     // GIR_Coverage, 4537,
     /* 134480 */     GIR_EraseRootFromParent_Done,
     /* 134481 */   // Label 2921: @134481
     /* 134481 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(134618), // Rule ID 19780 //
     /* 134486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134493 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134499 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134503 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, immAllZerosV:{ *:[v4f64] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134503 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 134506 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134510 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134517 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134520 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134524 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134529 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134532 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134536 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 134539 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134544 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134549 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 134557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134566 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 134582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134590 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134600 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134617 */     // GIR_Coverage, 19780,
     /* 134617 */     GIR_EraseRootFromParent_Done,
     /* 134618 */   // Label 2922: @134618
     /* 134618 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(134755), // Rule ID 19782 //
     /* 134623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134630 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134636 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134640 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, immAllZerosV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134640 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 134643 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134647 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134654 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134657 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134661 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134666 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134669 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134673 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 134676 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134681 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134686 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134691 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 134694 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134698 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134703 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134707 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 134719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134727 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134737 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134754 */     // GIR_Coverage, 19782,
     /* 134754 */     GIR_EraseRootFromParent_Done,
     /* 134755 */   // Label 2923: @134755
     /* 134755 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(134780), // Rule ID 4485 //
     /* 134760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134767 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (VMOVAPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1)
     /* 134767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrk),
     /* 134770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134772 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134774 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134776 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134778 */     GIR_RootConstrainSelectedInstOperands,
     /* 134779 */     // GIR_Coverage, 4485,
     /* 134779 */     GIR_EraseRootFromParent_Done,
     /* 134780 */   // Label 2924: @134780
     /* 134780 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(134805), // Rule ID 4539 //
     /* 134785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134792 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (VMOVDQA64Z256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1)
     /* 134792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrk),
     /* 134795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134797 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134799 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134801 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134803 */     GIR_RootConstrainSelectedInstOperands,
     /* 134804 */     // GIR_Coverage, 4539,
     /* 134804 */     GIR_EraseRootFromParent_Done,
     /* 134805 */   // Label 2925: @134805
     /* 134805 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(134986), // Rule ID 19779 //
     /* 134810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134817 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134817 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 134820 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134824 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134831 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 134834 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134838 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134843 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134846 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134850 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 134853 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134858 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134863 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134868 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 134871 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134875 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134880 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134884 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134889 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134892 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134896 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134903 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 134906 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134910 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134915 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134918 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134922 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 134925 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134930 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134935 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 134947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134952 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134955 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134968 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134985 */     // GIR_Coverage, 19779,
     /* 134985 */     GIR_EraseRootFromParent_Done,
     /* 134986 */   // Label 2926: @134986
     /* 134986 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(135167), // Rule ID 19781 //
     /* 134991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134998 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134998 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 135001 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135005 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 135012 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 135015 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135019 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135024 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 135027 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135031 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 135034 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135039 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135044 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135049 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 135052 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135056 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135061 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135065 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135070 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 135073 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135077 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135084 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 135087 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135091 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135096 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 135099 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 135103 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 135106 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135111 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135116 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 135124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 135128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135133 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135136 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 135139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 135142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135149 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 135156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135166 */     // GIR_Coverage, 19781,
     /* 135166 */     GIR_EraseRootFromParent_Done,
     /* 135167 */   // Label 2927: @135167
     /* 135167 */   GIM_Reject,
     /* 135168 */ // Label 2919: @135168
     /* 135168 */ GIM_Reject,
     /* 135169 */ // Label 2891: @135169
     /* 135169 */ GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(136326),
     /* 135174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 135177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 135180 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 135183 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(135262), // Rule ID 19866 //
     /* 135188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135207 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135214 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135218 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 135222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 135226 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135232 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 135234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135243 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rmkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmkz),
     /* 135246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135248 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135260 */     GIR_RootConstrainSelectedInstOperands,
     /* 135261 */     // GIR_Coverage, 19866,
     /* 135261 */     GIR_EraseRootFromParent_Done,
     /* 135262 */   // Label 2929: @135262
     /* 135262 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(135337), // Rule ID 19868 //
     /* 135267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 135301 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135307 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 135309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135318 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rmkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmkz),
     /* 135321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135323 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135325 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135335 */     GIR_RootConstrainSelectedInstOperands,
     /* 135336 */     // GIR_Coverage, 19868,
     /* 135336 */     GIR_EraseRootFromParent_Done,
     /* 135337 */   // Label 2930: @135337
     /* 135337 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(135409), // Rule ID 19865 //
     /* 135342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135361 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135364 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135368 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135372 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 135376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135389 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rmk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmk),
     /* 135392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135394 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135396 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135398 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135407 */     GIR_RootConstrainSelectedInstOperands,
     /* 135408 */     // GIR_Coverage, 19865,
     /* 135408 */     GIR_EraseRootFromParent_Done,
     /* 135409 */   // Label 2931: @135409
     /* 135409 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(135477), // Rule ID 19867 //
     /* 135414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135433 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135457 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rmk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmk),
     /* 135460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135462 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135464 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135466 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135475 */     GIR_RootConstrainSelectedInstOperands,
     /* 135476 */     // GIR_Coverage, 19867,
     /* 135476 */     GIR_EraseRootFromParent_Done,
     /* 135477 */   // Label 2932: @135477
     /* 135477 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(135522), // Rule ID 4570 //
     /* 135482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135501 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135507 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135511 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src, immAllZerosV:{ *:[v8i16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 135511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 135514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135516 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135518 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 135520 */     GIR_RootConstrainSelectedInstOperands,
     /* 135521 */     // GIR_Coverage, 4570,
     /* 135521 */     GIR_EraseRootFromParent_Done,
     /* 135522 */   // Label 2933: @135522
     /* 135522 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(135671), // Rule ID 19788 //
     /* 135527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135546 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135552 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135556 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, immAllZerosV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135556 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 135559 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135563 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135570 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135573 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135577 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135582 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135585 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135589 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 135592 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135597 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135602 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135607 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 135610 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135614 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135619 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135623 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 135631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 135635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135640 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135643 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 135646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 135660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 135665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135670 */     // GIR_Coverage, 19788,
     /* 135670 */     GIR_EraseRootFromParent_Done,
     /* 135671 */   // Label 2934: @135671
     /* 135671 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(135820), // Rule ID 19792 //
     /* 135676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135695 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135701 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135705 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135705 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 135708 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135712 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135719 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135722 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135726 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135731 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135734 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135738 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 135741 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135746 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135751 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135756 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 135759 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135763 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135768 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135772 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 135780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 135784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135789 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135792 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 135795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135802 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 135809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 135814 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135819 */     // GIR_Coverage, 19792,
     /* 135819 */     GIR_EraseRootFromParent_Done,
     /* 135820 */   // Label 2935: @135820
     /* 135820 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(135865), // Rule ID 19864 //
     /* 135825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135844 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135850 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135854 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 135854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 135857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135859 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135861 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 135863 */     GIR_RootConstrainSelectedInstOperands,
     /* 135864 */     // GIR_Coverage, 19864,
     /* 135864 */     GIR_EraseRootFromParent_Done,
     /* 135865 */   // Label 2936: @135865
     /* 135865 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(135902), // Rule ID 4571 //
     /* 135870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135889 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1)
     /* 135889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 135892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135894 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135896 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135898 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 135900 */     GIR_RootConstrainSelectedInstOperands,
     /* 135901 */     // GIR_Coverage, 4571,
     /* 135901 */     GIR_EraseRootFromParent_Done,
     /* 135902 */   // Label 2937: @135902
     /* 135902 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(136095), // Rule ID 19787 //
     /* 135907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135926 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135926 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 135929 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135933 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 135940 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 135943 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135947 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135952 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 135955 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135959 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 135962 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135967 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135972 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135977 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 135980 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135984 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135989 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135993 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135998 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 136001 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136005 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136012 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 136015 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136019 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136024 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136027 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136031 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 136034 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136039 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 136052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 136056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136061 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136064 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136067 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136077 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136094 */     // GIR_Coverage, 19787,
     /* 136094 */     GIR_EraseRootFromParent_Done,
     /* 136095 */   // Label 2938: @136095
     /* 136095 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(136288), // Rule ID 19791 //
     /* 136100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 136103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 136107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136119 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 136119 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 136122 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136126 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136133 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 136136 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136140 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136145 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136148 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136152 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 136155 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136160 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136165 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136170 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 136173 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136177 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136182 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136186 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 136191 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 136194 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136198 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136205 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 136208 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136212 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136217 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136220 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136224 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 136227 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136232 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136237 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 136245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 136249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136254 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136257 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136260 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136270 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136287 */     // GIR_Coverage, 19791,
     /* 136287 */     GIR_EraseRootFromParent_Done,
     /* 136288 */   // Label 2939: @136288
     /* 136288 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(136325), // Rule ID 19863 //
     /* 136293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 136296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136312 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 136312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 136315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136317 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136319 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136321 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136323 */     GIR_RootConstrainSelectedInstOperands,
     /* 136324 */     // GIR_Coverage, 19863,
     /* 136324 */     GIR_EraseRootFromParent_Done,
     /* 136325 */   // Label 2940: @136325
     /* 136325 */   GIM_Reject,
     /* 136326 */ // Label 2928: @136326
     /* 136326 */ GIM_Reject,
     /* 136327 */ // Label 2892: @136327
     /* 136327 */ GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(137106),
     /* 136332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 136335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 136338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 136341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136353 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(136386), // Rule ID 4465 //
     /* 136358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136365 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136371 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136375 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src, immAllZerosV:{ *:[v8f32] })  =>  (VMOVAPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 136375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrkz),
     /* 136378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136380 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136382 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 136384 */     GIR_RootConstrainSelectedInstOperands,
     /* 136385 */     // GIR_Coverage, 4465,
     /* 136385 */     GIR_EraseRootFromParent_Done,
     /* 136386 */   // Label 2942: @136386
     /* 136386 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(136419), // Rule ID 4524 //
     /* 136391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136398 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136404 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136408 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src, immAllZerosV:{ *:[v8i32] })  =>  (VMOVDQA32Z256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 136408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrkz),
     /* 136411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136413 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136415 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 136417 */     GIR_RootConstrainSelectedInstOperands,
     /* 136418 */     // GIR_Coverage, 4524,
     /* 136418 */     GIR_EraseRootFromParent_Done,
     /* 136419 */   // Label 2943: @136419
     /* 136419 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(136556), // Rule ID 19772 //
     /* 136424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136431 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136437 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136441 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, immAllZerosV:{ *:[v8f32] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136441 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 136444 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136448 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136455 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136458 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136462 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136467 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 136470 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136474 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 136477 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136482 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136487 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136492 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 136495 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136499 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136504 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136508 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 136520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136525 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136528 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136538 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136555 */     // GIR_Coverage, 19772,
     /* 136555 */     GIR_EraseRootFromParent_Done,
     /* 136556 */   // Label 2944: @136556
     /* 136556 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(136693), // Rule ID 19774 //
     /* 136561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136568 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136574 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136578 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, immAllZerosV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136578 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 136581 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136585 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136592 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136595 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136599 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136604 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 136607 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136611 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 136614 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136619 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136624 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136629 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 136632 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136636 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136641 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136645 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 136657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136662 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136665 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136675 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136692 */     // GIR_Coverage, 19774,
     /* 136692 */     GIR_EraseRootFromParent_Done,
     /* 136693 */   // Label 2945: @136693
     /* 136693 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(136718), // Rule ID 4467 //
     /* 136698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136705 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (VMOVAPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1)
     /* 136705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrk),
     /* 136708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136710 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136712 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136714 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136716 */     GIR_RootConstrainSelectedInstOperands,
     /* 136717 */     // GIR_Coverage, 4467,
     /* 136717 */     GIR_EraseRootFromParent_Done,
     /* 136718 */   // Label 2946: @136718
     /* 136718 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(136743), // Rule ID 4525 //
     /* 136723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136730 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (VMOVDQA32Z256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1)
     /* 136730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrk),
     /* 136733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136735 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136737 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136739 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136741 */     GIR_RootConstrainSelectedInstOperands,
     /* 136742 */     // GIR_Coverage, 4525,
     /* 136742 */     GIR_EraseRootFromParent_Done,
     /* 136743 */   // Label 2947: @136743
     /* 136743 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(136924), // Rule ID 19771 //
     /* 136748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136755 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136755 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 136758 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136762 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136769 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 136772 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136776 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136781 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136784 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136788 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 136791 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136796 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136801 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136806 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 136809 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136813 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136818 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136822 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136827 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136830 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136834 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136841 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 136844 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136848 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136853 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136856 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136860 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 136863 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136868 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 136885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136890 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136896 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136906 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136923 */     // GIR_Coverage, 19771,
     /* 136923 */     GIR_EraseRootFromParent_Done,
     /* 136924 */   // Label 2948: @136924
     /* 136924 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(137105), // Rule ID 19773 //
     /* 136929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136936 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136936 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 136939 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136943 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136950 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 136953 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136957 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136962 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136965 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136969 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 136972 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136977 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136982 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136987 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 136990 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136994 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136999 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137003 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137008 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 137011 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137015 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 137025 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137029 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137034 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137037 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 137041 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 137044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 137062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 137066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137071 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137074 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 137077 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 137080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137087 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 137094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137104 */     // GIR_Coverage, 19773,
     /* 137104 */     GIR_EraseRootFromParent_Done,
     /* 137105 */   // Label 2949: @137105
     /* 137105 */   GIM_Reject,
     /* 137106 */ // Label 2941: @137106
     /* 137106 */ GIM_Reject,
     /* 137107 */ // Label 2893: @137107
     /* 137107 */ GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(137487),
     /* 137112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 137115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 137118 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 137121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137125 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(137194), // Rule ID 19765 //
     /* 137130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 137138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 137142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 137146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 137151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 137155 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137161 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 137163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 137167 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137173 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 137175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137179 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 137181 */     // (vselect:{ *:[v8i64] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i1] }), immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 137181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 137190 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 137192 */     GIR_RootConstrainSelectedInstOperands,
     /* 137193 */     // GIR_Coverage, 19765,
     /* 137193 */     GIR_EraseRootFromParent_Done,
     /* 137194 */   // Label 2951: @137194
     /* 137194 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(137241), // Rule ID 3598 //
     /* 137199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137210 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137216 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 137218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 137222 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137228 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 137230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 137232 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i64] }, immAllZerosV:{ *:[v8i64] })  =>  (AVX512_512_SEXT_MASK_64:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask)
     /* 137232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_64),
     /* 137235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137237 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137239 */     GIR_RootConstrainSelectedInstOperands,
     /* 137240 */     // GIR_Coverage, 3598,
     /* 137240 */     GIR_EraseRootFromParent_Done,
     /* 137241 */   // Label 2952: @137241
     /* 137241 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(137338), // Rule ID 19763 //
     /* 137246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137254 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137260 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137268 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$mask, VK16:{ *:[i32] })), VK8:{ *:[i32] }), VR512:{ *:[v8i64] }:$src)
     /* 137268 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 137271 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137275 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137280 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137284 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 137289 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 137292 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 137296 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137301 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 137309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137318 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 137326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137334 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 137336 */     GIR_RootConstrainSelectedInstOperands,
     /* 137337 */     // GIR_Coverage, 19763,
     /* 137337 */     GIR_EraseRootFromParent_Done,
     /* 137338 */   // Label 2953: @137338
     /* 137338 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(137379), // Rule ID 4478 //
     /* 137343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137358 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137364 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137368 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src, immAllZerosV:{ *:[v8f64] })  =>  (VMOVAPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 137368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 137371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137373 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137375 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137377 */     GIR_RootConstrainSelectedInstOperands,
     /* 137378 */     // GIR_Coverage, 4478,
     /* 137378 */     GIR_EraseRootFromParent_Done,
     /* 137379 */   // Label 2954: @137379
     /* 137379 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(137420), // Rule ID 4532 //
     /* 137384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137399 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137405 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137409 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src, immAllZerosV:{ *:[v8i64] })  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 137409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137414 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137416 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137418 */     GIR_RootConstrainSelectedInstOperands,
     /* 137419 */     // GIR_Coverage, 4532,
     /* 137419 */     GIR_EraseRootFromParent_Done,
     /* 137420 */   // Label 2955: @137420
     /* 137420 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(137453), // Rule ID 4480 //
     /* 137425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137440 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src0)  =>  (VMOVAPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1)
     /* 137440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 137443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137445 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137447 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137449 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137451 */     GIR_RootConstrainSelectedInstOperands,
     /* 137452 */     // GIR_Coverage, 4480,
     /* 137452 */     GIR_EraseRootFromParent_Done,
     /* 137453 */   // Label 2956: @137453
     /* 137453 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(137486), // Rule ID 4534 //
     /* 137458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137473 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src0)  =>  (VMOVDQA64Zrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1)
     /* 137473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 137476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137478 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137480 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137482 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137484 */     GIR_RootConstrainSelectedInstOperands,
     /* 137485 */     // GIR_Coverage, 4534,
     /* 137485 */     GIR_EraseRootFromParent_Done,
     /* 137486 */   // Label 2957: @137486
     /* 137486 */   GIM_Reject,
     /* 137487 */ // Label 2950: @137487
     /* 137487 */ GIM_Reject,
     /* 137488 */ // Label 2894: @137488
     /* 137488 */ GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(137927),
     /* 137493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 137496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 137499 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 137502 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(137547), // Rule ID 4558 //
     /* 137507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137526 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137532 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137536 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src, immAllZerosV:{ *:[v16i8] })  =>  (VMOVDQU8Z128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 137536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrkz),
     /* 137539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137541 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137543 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137545 */     GIR_RootConstrainSelectedInstOperands,
     /* 137546 */     // GIR_Coverage, 4558,
     /* 137546 */     GIR_EraseRootFromParent_Done,
     /* 137547 */   // Label 2959: @137547
     /* 137547 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(137696), // Rule ID 19784 //
     /* 137552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 137559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137571 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137577 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137581 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, immAllZerosV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 137581 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 137584 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137588 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137595 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 137598 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137602 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137607 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 137610 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137614 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 137617 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137622 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137627 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 137632 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 137635 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137639 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137644 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 137653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 137656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 137660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137665 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137668 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 137671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137678 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 137685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 137690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137695 */     // GIR_Coverage, 19784,
     /* 137695 */     GIR_EraseRootFromParent_Done,
     /* 137696 */   // Label 2960: @137696
     /* 137696 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(137733), // Rule ID 4559 //
     /* 137701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137720 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (VMOVDQU8Z128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1)
     /* 137720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrk),
     /* 137723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137725 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137727 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137729 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137731 */     GIR_RootConstrainSelectedInstOperands,
     /* 137732 */     // GIR_Coverage, 4559,
     /* 137732 */     GIR_EraseRootFromParent_Done,
     /* 137733 */   // Label 2961: @137733
     /* 137733 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(137926), // Rule ID 19783 //
     /* 137738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 137745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137757 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 137757 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 137760 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137764 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 137771 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 137774 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137778 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137783 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 137786 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137790 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 137793 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137798 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137803 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 137808 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 137811 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137815 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137820 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137824 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 137829 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 137832 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137836 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 137846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137855 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 137862 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 137865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 137880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 137883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 137887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137895 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 137898 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 137901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137908 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 137915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 137920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137925 */     // GIR_Coverage, 19783,
     /* 137925 */     GIR_EraseRootFromParent_Done,
     /* 137926 */   // Label 2962: @137926
     /* 137926 */   GIM_Reject,
     /* 137927 */ // Label 2958: @137927
     /* 137927 */ GIM_Reject,
     /* 137928 */ // Label 2895: @137928
     /* 137928 */ GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(138997),
     /* 137933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 137936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 137939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 137942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 137946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137950 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(138021), // Rule ID 19856 //
     /* 137955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 137966 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137969 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 137973 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 137977 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 137981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 137985 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137991 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 137993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 137995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138002 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rmkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmkz),
     /* 138005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138007 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138019 */     GIR_RootConstrainSelectedInstOperands,
     /* 138020 */     // GIR_Coverage, 19856,
     /* 138020 */     GIR_EraseRootFromParent_Done,
     /* 138021 */   // Label 2964: @138021
     /* 138021 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(138088), // Rule ID 19858 //
     /* 138026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138037 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 138052 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138058 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 138060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138069 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rmkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmkz),
     /* 138072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138074 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138086 */     GIR_RootConstrainSelectedInstOperands,
     /* 138087 */     // GIR_Coverage, 19858,
     /* 138087 */     GIR_EraseRootFromParent_Done,
     /* 138088 */   // Label 2965: @138088
     /* 138088 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(138152), // Rule ID 19855 //
     /* 138093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138115 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 138119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138132 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rmk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmk),
     /* 138135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138137 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138139 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138150 */     GIR_RootConstrainSelectedInstOperands,
     /* 138151 */     // GIR_Coverage, 19855,
     /* 138151 */     GIR_EraseRootFromParent_Done,
     /* 138152 */   // Label 2966: @138152
     /* 138152 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(138212), // Rule ID 19857 //
     /* 138157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138168 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138171 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138175 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138192 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rmk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmk),
     /* 138195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138197 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138199 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138201 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138210 */     GIR_RootConstrainSelectedInstOperands,
     /* 138211 */     // GIR_Coverage, 19857,
     /* 138211 */     GIR_EraseRootFromParent_Done,
     /* 138212 */   // Label 2967: @138212
     /* 138212 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(138249), // Rule ID 4566 //
     /* 138217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138228 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138234 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138238 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src, immAllZerosV:{ *:[v16i16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 138238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 138241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138243 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138245 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 138247 */     GIR_RootConstrainSelectedInstOperands,
     /* 138248 */     // GIR_Coverage, 4566,
     /* 138248 */     GIR_EraseRootFromParent_Done,
     /* 138249 */   // Label 2968: @138249
     /* 138249 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(138390), // Rule ID 19790 //
     /* 138254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138265 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138271 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138275 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, immAllZerosV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138275 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 138278 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138282 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138289 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138292 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138296 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138301 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 138304 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138308 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 138311 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138316 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138321 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138326 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 138329 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138333 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138338 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138342 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 138354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138359 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138362 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 138365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138372 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138379 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138389 */     // GIR_Coverage, 19790,
     /* 138389 */     GIR_EraseRootFromParent_Done,
     /* 138390 */   // Label 2969: @138390
     /* 138390 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(138531), // Rule ID 19794 //
     /* 138395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138406 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138412 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138416 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138416 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 138419 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138423 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138430 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138433 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138437 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138442 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 138445 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138449 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 138452 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138457 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138462 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 138470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138479 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138483 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 138495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138500 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 138506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138513 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138530 */     // GIR_Coverage, 19794,
     /* 138530 */     GIR_EraseRootFromParent_Done,
     /* 138531 */   // Label 2970: @138531
     /* 138531 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(138568), // Rule ID 19854 //
     /* 138536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138547 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138553 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138557 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 138557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 138560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138562 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138566 */     GIR_RootConstrainSelectedInstOperands,
     /* 138567 */     // GIR_Coverage, 19854,
     /* 138567 */     GIR_EraseRootFromParent_Done,
     /* 138568 */   // Label 2971: @138568
     /* 138568 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(138597), // Rule ID 4567 //
     /* 138573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138584 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1)
     /* 138584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 138587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138589 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138591 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138595 */     GIR_RootConstrainSelectedInstOperands,
     /* 138596 */     // GIR_Coverage, 4567,
     /* 138596 */     GIR_EraseRootFromParent_Done,
     /* 138597 */   // Label 2972: @138597
     /* 138597 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(138782), // Rule ID 19789 //
     /* 138602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138613 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138613 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 138616 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138620 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 138627 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 138630 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138634 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138639 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 138642 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138646 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 138649 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138654 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138659 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138664 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 138667 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138671 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138676 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138680 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138685 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138688 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138692 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138699 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 138702 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138706 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138711 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138714 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 138718 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 138721 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138726 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138731 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 138743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138748 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138751 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 138754 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 138757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138764 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138781 */     // GIR_Coverage, 19789,
     /* 138781 */     GIR_EraseRootFromParent_Done,
     /* 138782 */   // Label 2973: @138782
     /* 138782 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(138967), // Rule ID 19793 //
     /* 138787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138798 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138798 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 138801 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138805 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 138812 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 138815 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138819 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138824 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 138827 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138831 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 138834 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138839 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138844 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138849 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 138852 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138856 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138861 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138865 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138870 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138873 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138877 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138884 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 138887 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138891 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138896 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138899 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 138903 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 138906 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138911 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138916 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 138928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138933 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138936 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 138939 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 138942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138949 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138966 */     // GIR_Coverage, 19793,
     /* 138966 */     GIR_EraseRootFromParent_Done,
     /* 138967 */   // Label 2974: @138967
     /* 138967 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(138996), // Rule ID 19853 //
     /* 138972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138983 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 138983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 138986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138988 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138990 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138994 */     GIR_RootConstrainSelectedInstOperands,
     /* 138995 */     // GIR_Coverage, 19853,
     /* 138995 */     GIR_EraseRootFromParent_Done,
     /* 138996 */   // Label 2975: @138996
     /* 138996 */   GIM_Reject,
     /* 138997 */ // Label 2963: @138997
     /* 138997 */ GIM_Reject,
     /* 138998 */ // Label 2896: @138998
     /* 138998 */ GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(139338),
     /* 139003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 139006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 139009 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 139012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139016 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(139085), // Rule ID 19766 //
     /* 139021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 139029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 139033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 139037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 139042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 139046 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139052 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 139054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 139058 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139064 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 139066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 139072 */     // (vselect:{ *:[v16i32] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i1] }), immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 139072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 139081 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 139083 */     GIR_RootConstrainSelectedInstOperands,
     /* 139084 */     // GIR_Coverage, 19766,
     /* 139084 */     GIR_EraseRootFromParent_Done,
     /* 139085 */   // Label 2977: @139085
     /* 139085 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(139132), // Rule ID 3597 //
     /* 139090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139101 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139107 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 139109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 139113 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139119 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 139121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139123 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i32] }, immAllZerosV:{ *:[v16i32] })  =>  (AVX512_512_SEXT_MASK_32:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask)
     /* 139123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_32),
     /* 139126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139128 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139130 */     GIR_RootConstrainSelectedInstOperands,
     /* 139131 */     // GIR_Coverage, 3597,
     /* 139131 */     GIR_EraseRootFromParent_Done,
     /* 139132 */   // Label 2978: @139132
     /* 139132 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(139189), // Rule ID 19764 //
     /* 139137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139145 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139151 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139159 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } (KNOTWkk:{ *:[v16i1] } VK16WM:{ *:[v16i1] }:$mask), VR512:{ *:[v16i32] }:$src)
     /* 139159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 139162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 139166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139185 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 139187 */     GIR_RootConstrainSelectedInstOperands,
     /* 139188 */     // GIR_Coverage, 19764,
     /* 139188 */     GIR_EraseRootFromParent_Done,
     /* 139189 */   // Label 2979: @139189
     /* 139189 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(139230), // Rule ID 4460 //
     /* 139194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139209 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139215 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139219 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src, immAllZerosV:{ *:[v16f32] })  =>  (VMOVAPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 139219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 139222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139224 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139226 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139228 */     GIR_RootConstrainSelectedInstOperands,
     /* 139229 */     // GIR_Coverage, 4460,
     /* 139229 */     GIR_EraseRootFromParent_Done,
     /* 139230 */   // Label 2980: @139230
     /* 139230 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(139271), // Rule ID 4520 //
     /* 139235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139250 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139256 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139260 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src, immAllZerosV:{ *:[v16i32] })  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 139260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139265 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139267 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139269 */     GIR_RootConstrainSelectedInstOperands,
     /* 139270 */     // GIR_Coverage, 4520,
     /* 139270 */     GIR_EraseRootFromParent_Done,
     /* 139271 */   // Label 2981: @139271
     /* 139271 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(139304), // Rule ID 4462 //
     /* 139276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139291 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src0)  =>  (VMOVAPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1)
     /* 139291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 139294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139296 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139298 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139300 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139302 */     GIR_RootConstrainSelectedInstOperands,
     /* 139303 */     // GIR_Coverage, 4462,
     /* 139303 */     GIR_EraseRootFromParent_Done,
     /* 139304 */   // Label 2982: @139304
     /* 139304 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(139337), // Rule ID 4521 //
     /* 139309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139324 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src0)  =>  (VMOVDQA32Zrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1)
     /* 139324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 139327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139329 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139331 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139333 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139335 */     GIR_RootConstrainSelectedInstOperands,
     /* 139336 */     // GIR_Coverage, 4521,
     /* 139336 */     GIR_EraseRootFromParent_Done,
     /* 139337 */   // Label 2983: @139337
     /* 139337 */   GIM_Reject,
     /* 139338 */ // Label 2976: @139338
     /* 139338 */ GIM_Reject,
     /* 139339 */ // Label 2897: @139339
     /* 139339 */ GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(139742),
     /* 139344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 139347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 139350 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 139353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139365 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(139398), // Rule ID 4554 //
     /* 139370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139377 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139383 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139387 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src, immAllZerosV:{ *:[v32i8] })  =>  (VMOVDQU8Z256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 139387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrkz),
     /* 139390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139392 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139394 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139396 */     GIR_RootConstrainSelectedInstOperands,
     /* 139397 */     // GIR_Coverage, 4554,
     /* 139397 */     GIR_EraseRootFromParent_Done,
     /* 139398 */   // Label 2985: @139398
     /* 139398 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(139535), // Rule ID 19786 //
     /* 139403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139410 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139416 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139420 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, immAllZerosV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139420 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 139423 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139427 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139434 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 139437 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139441 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139446 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 139449 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139453 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 139456 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139461 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139466 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139471 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 139474 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139478 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139487 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 139492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 139495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 139499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139504 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139507 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 139510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139517 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139534 */     // GIR_Coverage, 19786,
     /* 139534 */     GIR_EraseRootFromParent_Done,
     /* 139535 */   // Label 2986: @139535
     /* 139535 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(139560), // Rule ID 4555 //
     /* 139540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139547 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (VMOVDQU8Z256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1)
     /* 139547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrk),
     /* 139550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139552 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139554 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139558 */     GIR_RootConstrainSelectedInstOperands,
     /* 139559 */     // GIR_Coverage, 4555,
     /* 139559 */     GIR_EraseRootFromParent_Done,
     /* 139560 */   // Label 2987: @139560
     /* 139560 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(139741), // Rule ID 19785 //
     /* 139565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139572 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139572 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 139575 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139579 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 139586 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 139589 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139593 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139598 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 139601 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139605 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 139608 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139613 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139618 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139623 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 139626 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139630 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139635 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139639 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 139644 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 139647 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139651 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139658 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 139661 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139665 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139670 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 139673 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 139677 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 139680 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139690 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 139698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 139702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139707 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139710 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 139713 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 139716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139723 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139740 */     // GIR_Coverage, 19785,
     /* 139740 */     GIR_EraseRootFromParent_Done,
     /* 139741 */   // Label 2988: @139741
     /* 139741 */   GIM_Reject,
     /* 139742 */ // Label 2984: @139742
     /* 139742 */ GIM_Reject,
     /* 139743 */ // Label 2898: @139743
     /* 139743 */ GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(140160),
     /* 139748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 139751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 139754 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 139757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139765 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(139836), // Rule ID 19846 //
     /* 139770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139781 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139788 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139792 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 139796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 139800 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139806 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 139808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139817 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrmkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 139817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmkz),
     /* 139820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139822 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139824 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 139828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 139834 */     GIR_RootConstrainSelectedInstOperands,
     /* 139835 */     // GIR_Coverage, 19846,
     /* 139835 */     GIR_EraseRootFromParent_Done,
     /* 139836 */   // Label 2990: @139836
     /* 139836 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(139903), // Rule ID 19848 //
     /* 139841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139852 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139855 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139859 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 139867 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139873 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 139875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139884 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrmkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 139884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmkz),
     /* 139887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139889 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139891 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 139895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 139901 */     GIR_RootConstrainSelectedInstOperands,
     /* 139902 */     // GIR_Coverage, 19848,
     /* 139902 */     GIR_EraseRootFromParent_Done,
     /* 139903 */   // Label 2991: @139903
     /* 139903 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(139967), // Rule ID 19845 //
     /* 139908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139919 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139922 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139926 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139930 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 139934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139947 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrmk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 139947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmk),
     /* 139950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139952 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139954 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139956 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 139960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139965 */     GIR_RootConstrainSelectedInstOperands,
     /* 139966 */     // GIR_Coverage, 19845,
     /* 139966 */     GIR_EraseRootFromParent_Done,
     /* 139967 */   // Label 2992: @139967
     /* 139967 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(140027), // Rule ID 19847 //
     /* 139972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139983 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139990 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140007 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrmk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmk),
     /* 140010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140012 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140014 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140025 */     GIR_RootConstrainSelectedInstOperands,
     /* 140026 */     // GIR_Coverage, 19847,
     /* 140026 */     GIR_EraseRootFromParent_Done,
     /* 140027 */   // Label 2993: @140027
     /* 140027 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(140064), // Rule ID 4562 //
     /* 140032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140043 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140049 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140053 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src, immAllZerosV:{ *:[v32i16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 140053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 140056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140058 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140060 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 140062 */     GIR_RootConstrainSelectedInstOperands,
     /* 140063 */     // GIR_Coverage, 4562,
     /* 140063 */     GIR_EraseRootFromParent_Done,
     /* 140064 */   // Label 2994: @140064
     /* 140064 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(140101), // Rule ID 19844 //
     /* 140069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140080 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140086 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140090 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 140090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 140093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140095 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140097 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140099 */     GIR_RootConstrainSelectedInstOperands,
     /* 140100 */     // GIR_Coverage, 19844,
     /* 140100 */     GIR_EraseRootFromParent_Done,
     /* 140101 */   // Label 2995: @140101
     /* 140101 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(140130), // Rule ID 4563 //
     /* 140106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140117 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1)
     /* 140117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 140120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140122 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140124 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140126 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140128 */     GIR_RootConstrainSelectedInstOperands,
     /* 140129 */     // GIR_Coverage, 4563,
     /* 140129 */     GIR_EraseRootFromParent_Done,
     /* 140130 */   // Label 2996: @140130
     /* 140130 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(140159), // Rule ID 19843 //
     /* 140135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140146 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 140146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 140149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140151 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140153 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140155 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140157 */     GIR_RootConstrainSelectedInstOperands,
     /* 140158 */     // GIR_Coverage, 19843,
     /* 140158 */     GIR_EraseRootFromParent_Done,
     /* 140159 */   // Label 2997: @140159
     /* 140159 */   GIM_Reject,
     /* 140160 */ // Label 2989: @140160
     /* 140160 */ GIM_Reject,
     /* 140161 */ // Label 2899: @140161
     /* 140161 */ GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(140246),
     /* 140166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 140169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 140172 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 140175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 140183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140187 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(140220), // Rule ID 4550 //
     /* 140192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140199 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140205 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140209 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src, immAllZerosV:{ *:[v64i8] })  =>  (VMOVDQU8Zrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 140209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 140212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140214 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 140218 */     GIR_RootConstrainSelectedInstOperands,
     /* 140219 */     // GIR_Coverage, 4550,
     /* 140219 */     GIR_EraseRootFromParent_Done,
     /* 140220 */   // Label 2999: @140220
     /* 140220 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(140245), // Rule ID 4551 //
     /* 140225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140232 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src0)  =>  (VMOVDQU8Zrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src0, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1)
     /* 140232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 140235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140237 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140239 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140241 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140243 */     GIR_RootConstrainSelectedInstOperands,
     /* 140244 */     // GIR_Coverage, 4551,
     /* 140244 */     GIR_EraseRootFromParent_Done,
     /* 140245 */   // Label 3000: @140245
     /* 140245 */   GIM_Reject,
     /* 140246 */ // Label 2998: @140246
     /* 140246 */ GIM_Reject,
     /* 140247 */ // Label 2900: @140247
     /* 140247 */ GIM_Reject,
     /* 140248 */ // Label 35: @140248
     /* 140248 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 3004*/ GIMT_Encode4(141112),
     /* 140259 */ /*GILLT_v8s16*//*Label 3001*/ GIMT_Encode4(140299), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 140279 */ /*GILLT_v16s16*//*Label 3002*/ GIMT_Encode4(140641), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 140295 */ /*GILLT_v32s16*//*Label 3003*/ GIMT_Encode4(140956),
     /* 140299 */ // Label 3001: @140299
     /* 140299 */ GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(140640),
     /* 140304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 140307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140310 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(140372), // Rule ID 23453 //
     /* 140315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140330 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140333 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140337 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140354 */     // (mulhu:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULHUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrm),
     /* 140357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140359 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140361 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140370 */     GIR_RootConstrainSelectedInstOperands,
     /* 140371 */     // GIR_Coverage, 23453,
     /* 140371 */     GIR_EraseRootFromParent_Done,
     /* 140372 */   // Label 3006: @140372
     /* 140372 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(140434), // Rule ID 23843 //
     /* 140377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140392 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140395 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140399 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140416 */     // (mulhu:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULHUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rm),
     /* 140419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140421 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140432 */     GIR_RootConstrainSelectedInstOperands,
     /* 140433 */     // GIR_Coverage, 23843,
     /* 140433 */     GIR_EraseRootFromParent_Done,
     /* 140434 */   // Label 3007: @140434
     /* 140434 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(140496), // Rule ID 2576 //
     /* 140439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140458 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140461 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140465 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140478 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrm),
     /* 140481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140483 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140485 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140494 */     GIR_RootConstrainSelectedInstOperands,
     /* 140495 */     // GIR_Coverage, 2576,
     /* 140495 */     GIR_EraseRootFromParent_Done,
     /* 140496 */   // Label 3008: @140496
     /* 140496 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(140558), // Rule ID 5061 //
     /* 140501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140520 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140523 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140527 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140540 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rm),
     /* 140543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140545 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140556 */     GIR_RootConstrainSelectedInstOperands,
     /* 140557 */     // GIR_Coverage, 5061,
     /* 140557 */     GIR_EraseRootFromParent_Done,
     /* 140558 */   // Label 3009: @140558
     /* 140558 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(140585), // Rule ID 2575 //
     /* 140563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140578 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrr),
     /* 140583 */     GIR_RootConstrainSelectedInstOperands,
     /* 140584 */     // GIR_Coverage, 2575,
     /* 140584 */     GIR_Done,
     /* 140585 */   // Label 3010: @140585
     /* 140585 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(140612), // Rule ID 2577 //
     /* 140590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 140593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140605 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHUWrr),
     /* 140610 */     GIR_RootConstrainSelectedInstOperands,
     /* 140611 */     // GIR_Coverage, 2577,
     /* 140611 */     GIR_Done,
     /* 140612 */   // Label 3011: @140612
     /* 140612 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(140639), // Rule ID 5058 //
     /* 140617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140632 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 140632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rr),
     /* 140637 */     GIR_RootConstrainSelectedInstOperands,
     /* 140638 */     // GIR_Coverage, 5058,
     /* 140638 */     GIR_Done,
     /* 140639 */   // Label 3012: @140639
     /* 140639 */   GIM_Reject,
     /* 140640 */ // Label 3005: @140640
     /* 140640 */ GIM_Reject,
     /* 140641 */ // Label 3002: @140641
     /* 140641 */ GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(140955),
     /* 140646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 140649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 140652 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(140714), // Rule ID 23455 //
     /* 140657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140672 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140679 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140696 */     // (mulhu:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULHUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrm),
     /* 140699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140712 */     GIR_RootConstrainSelectedInstOperands,
     /* 140713 */     // GIR_Coverage, 23455,
     /* 140713 */     GIR_EraseRootFromParent_Done,
     /* 140714 */   // Label 3014: @140714
     /* 140714 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(140776), // Rule ID 23840 //
     /* 140719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140734 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140737 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140741 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140758 */     // (mulhu:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULHUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rm),
     /* 140761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140763 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140765 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140774 */     GIR_RootConstrainSelectedInstOperands,
     /* 140775 */     // GIR_Coverage, 23840,
     /* 140775 */     GIR_EraseRootFromParent_Done,
     /* 140776 */   // Label 3015: @140776
     /* 140776 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(140838), // Rule ID 2580 //
     /* 140781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140820 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrm),
     /* 140823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140836 */     GIR_RootConstrainSelectedInstOperands,
     /* 140837 */     // GIR_Coverage, 2580,
     /* 140837 */     GIR_EraseRootFromParent_Done,
     /* 140838 */   // Label 3016: @140838
     /* 140838 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(140900), // Rule ID 5055 //
     /* 140843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140862 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140865 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140869 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140882 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rm),
     /* 140885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140887 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140898 */     GIR_RootConstrainSelectedInstOperands,
     /* 140899 */     // GIR_Coverage, 5055,
     /* 140899 */     GIR_EraseRootFromParent_Done,
     /* 140900 */   // Label 3017: @140900
     /* 140900 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(140927), // Rule ID 2579 //
     /* 140905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140920 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 140920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrr),
     /* 140925 */     GIR_RootConstrainSelectedInstOperands,
     /* 140926 */     // GIR_Coverage, 2579,
     /* 140926 */     GIR_Done,
     /* 140927 */   // Label 3018: @140927
     /* 140927 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(140954), // Rule ID 5052 //
     /* 140932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140947 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 140947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rr),
     /* 140952 */     GIR_RootConstrainSelectedInstOperands,
     /* 140953 */     // GIR_Coverage, 5052,
     /* 140953 */     GIR_Done,
     /* 140954 */   // Label 3019: @140954
     /* 140954 */   GIM_Reject,
     /* 140955 */ // Label 3013: @140955
     /* 140955 */ GIM_Reject,
     /* 140956 */ // Label 3003: @140956
     /* 140956 */ GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(141111),
     /* 140961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 140964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 140967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140971 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(141029), // Rule ID 23837 //
     /* 140976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140987 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140990 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140994 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141011 */     // (mulhu:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULHUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrm),
     /* 141014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141016 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141027 */     GIR_RootConstrainSelectedInstOperands,
     /* 141028 */     // GIR_Coverage, 23837,
     /* 141028 */     GIR_EraseRootFromParent_Done,
     /* 141029 */   // Label 3021: @141029
     /* 141029 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(141087), // Rule ID 5049 //
     /* 141034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141049 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141052 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141056 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141069 */     // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrm),
     /* 141072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141074 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141085 */     GIR_RootConstrainSelectedInstOperands,
     /* 141086 */     // GIR_Coverage, 5049,
     /* 141086 */     GIR_EraseRootFromParent_Done,
     /* 141087 */   // Label 3022: @141087
     /* 141087 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(141110), // Rule ID 5046 //
     /* 141092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141103 */     // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 141103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrr),
     /* 141108 */     GIR_RootConstrainSelectedInstOperands,
     /* 141109 */     // GIR_Coverage, 5046,
     /* 141109 */     GIR_Done,
     /* 141110 */   // Label 3023: @141110
     /* 141110 */   GIM_Reject,
     /* 141111 */ // Label 3020: @141111
     /* 141111 */ GIM_Reject,
     /* 141112 */ // Label 3004: @141112
     /* 141112 */ GIM_Reject,
     /* 141113 */ // Label 36: @141113
     /* 141113 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 3027*/ GIMT_Encode4(141977),
     /* 141124 */ /*GILLT_v8s16*//*Label 3024*/ GIMT_Encode4(141164), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 141144 */ /*GILLT_v16s16*//*Label 3025*/ GIMT_Encode4(141506), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 141160 */ /*GILLT_v32s16*//*Label 3026*/ GIMT_Encode4(141821),
     /* 141164 */ // Label 3024: @141164
     /* 141164 */ GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(141505),
     /* 141169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 141172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141175 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(141237), // Rule ID 23456 //
     /* 141180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141219 */     // (mulhs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULHWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWrm),
     /* 141222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141235 */     GIR_RootConstrainSelectedInstOperands,
     /* 141236 */     // GIR_Coverage, 23456,
     /* 141236 */     GIR_EraseRootFromParent_Done,
     /* 141237 */   // Label 3029: @141237
     /* 141237 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(141299), // Rule ID 23834 //
     /* 141242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141257 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141260 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141264 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141281 */     // (mulhs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULHWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rm),
     /* 141284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141286 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141288 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141297 */     GIR_RootConstrainSelectedInstOperands,
     /* 141298 */     // GIR_Coverage, 23834,
     /* 141298 */     GIR_EraseRootFromParent_Done,
     /* 141299 */   // Label 3030: @141299
     /* 141299 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(141361), // Rule ID 2582 //
     /* 141304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141323 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141326 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141330 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141343 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWrm),
     /* 141346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141348 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141350 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141359 */     GIR_RootConstrainSelectedInstOperands,
     /* 141360 */     // GIR_Coverage, 2582,
     /* 141360 */     GIR_EraseRootFromParent_Done,
     /* 141361 */   // Label 3031: @141361
     /* 141361 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(141423), // Rule ID 5043 //
     /* 141366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141385 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141405 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rm),
     /* 141408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141410 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141421 */     GIR_RootConstrainSelectedInstOperands,
     /* 141422 */     // GIR_Coverage, 5043,
     /* 141422 */     GIR_EraseRootFromParent_Done,
     /* 141423 */   // Label 3032: @141423
     /* 141423 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(141450), // Rule ID 2581 //
     /* 141428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141443 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 141443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWrr),
     /* 141448 */     GIR_RootConstrainSelectedInstOperands,
     /* 141449 */     // GIR_Coverage, 2581,
     /* 141449 */     GIR_Done,
     /* 141450 */   // Label 3033: @141450
     /* 141450 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(141477), // Rule ID 2583 //
     /* 141455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 141458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141470 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 141470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHWrr),
     /* 141475 */     GIR_RootConstrainSelectedInstOperands,
     /* 141476 */     // GIR_Coverage, 2583,
     /* 141476 */     GIR_Done,
     /* 141477 */   // Label 3034: @141477
     /* 141477 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(141504), // Rule ID 5040 //
     /* 141482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141497 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 141497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rr),
     /* 141502 */     GIR_RootConstrainSelectedInstOperands,
     /* 141503 */     // GIR_Coverage, 5040,
     /* 141503 */     GIR_Done,
     /* 141504 */   // Label 3035: @141504
     /* 141504 */   GIM_Reject,
     /* 141505 */ // Label 3028: @141505
     /* 141505 */ GIM_Reject,
     /* 141506 */ // Label 3025: @141506
     /* 141506 */ GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(141820),
     /* 141511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 141514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 141517 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(141579), // Rule ID 23458 //
     /* 141522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141537 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141540 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141544 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141561 */     // (mulhs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULHWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrm),
     /* 141564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141568 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141577 */     GIR_RootConstrainSelectedInstOperands,
     /* 141578 */     // GIR_Coverage, 23458,
     /* 141578 */     GIR_EraseRootFromParent_Done,
     /* 141579 */   // Label 3037: @141579
     /* 141579 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(141641), // Rule ID 23831 //
     /* 141584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141599 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141606 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141623 */     // (mulhs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULHWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rm),
     /* 141626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141628 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141630 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141639 */     GIR_RootConstrainSelectedInstOperands,
     /* 141640 */     // GIR_Coverage, 23831,
     /* 141640 */     GIR_EraseRootFromParent_Done,
     /* 141641 */   // Label 3038: @141641
     /* 141641 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(141703), // Rule ID 2586 //
     /* 141646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141665 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141668 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141672 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141685 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrm),
     /* 141688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141690 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141701 */     GIR_RootConstrainSelectedInstOperands,
     /* 141702 */     // GIR_Coverage, 2586,
     /* 141702 */     GIR_EraseRootFromParent_Done,
     /* 141703 */   // Label 3039: @141703
     /* 141703 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(141765), // Rule ID 5037 //
     /* 141708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141727 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141730 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141734 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141747 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rm),
     /* 141750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141752 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141763 */     GIR_RootConstrainSelectedInstOperands,
     /* 141764 */     // GIR_Coverage, 5037,
     /* 141764 */     GIR_EraseRootFromParent_Done,
     /* 141765 */   // Label 3040: @141765
     /* 141765 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(141792), // Rule ID 2585 //
     /* 141770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141785 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 141785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrr),
     /* 141790 */     GIR_RootConstrainSelectedInstOperands,
     /* 141791 */     // GIR_Coverage, 2585,
     /* 141791 */     GIR_Done,
     /* 141792 */   // Label 3041: @141792
     /* 141792 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(141819), // Rule ID 5034 //
     /* 141797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141812 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 141812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rr),
     /* 141817 */     GIR_RootConstrainSelectedInstOperands,
     /* 141818 */     // GIR_Coverage, 5034,
     /* 141818 */     GIR_Done,
     /* 141819 */   // Label 3042: @141819
     /* 141819 */   GIM_Reject,
     /* 141820 */ // Label 3036: @141820
     /* 141820 */ GIM_Reject,
     /* 141821 */ // Label 3026: @141821
     /* 141821 */ GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(141976),
     /* 141826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 141829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 141832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141836 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(141894), // Rule ID 23828 //
     /* 141841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141852 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141855 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141859 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141876 */     // (mulhs:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULHWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrm),
     /* 141879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141881 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141892 */     GIR_RootConstrainSelectedInstOperands,
     /* 141893 */     // GIR_Coverage, 23828,
     /* 141893 */     GIR_EraseRootFromParent_Done,
     /* 141894 */   // Label 3044: @141894
     /* 141894 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(141952), // Rule ID 5031 //
     /* 141899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141914 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141917 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141921 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141934 */     // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrm),
     /* 141937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141939 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141950 */     GIR_RootConstrainSelectedInstOperands,
     /* 141951 */     // GIR_Coverage, 5031,
     /* 141951 */     GIR_EraseRootFromParent_Done,
     /* 141952 */   // Label 3045: @141952
     /* 141952 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(141975), // Rule ID 5028 //
     /* 141957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141968 */     // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 141968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrr),
     /* 141973 */     GIR_RootConstrainSelectedInstOperands,
     /* 141974 */     // GIR_Coverage, 5028,
     /* 141974 */     GIR_Done,
     /* 141975 */   // Label 3046: @141975
     /* 141975 */   GIM_Reject,
     /* 141976 */ // Label 3043: @141976
     /* 141976 */ GIM_Reject,
     /* 141977 */ // Label 3027: @141977
     /* 141977 */ GIM_Reject,
     /* 141978 */ // Label 37: @141978
     /* 141978 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3053*/ GIMT_Encode4(143663),
     /* 141989 */ /*GILLT_v8s16*//*Label 3047*/ GIMT_Encode4(142037), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 142005 */ /*GILLT_v16s8*//*Label 3048*/ GIMT_Encode4(142379),
     /* 142009 */ /*GILLT_v16s16*//*Label 3049*/ GIMT_Encode4(142721), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 142021 */ /*GILLT_v32s8*//*Label 3050*/ GIMT_Encode4(143036),
     /* 142025 */ /*GILLT_v32s16*//*Label 3051*/ GIMT_Encode4(143351), GIMT_Encode4(0),
     /* 142033 */ /*GILLT_v64s8*//*Label 3052*/ GIMT_Encode4(143507),
     /* 142037 */ // Label 3047: @142037
     /* 142037 */ GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(142378),
     /* 142042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 142045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142048 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(142110), // Rule ID 23447 //
     /* 142053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142068 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142075 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142092 */     // (uaddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrm),
     /* 142095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142097 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142099 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142108 */     GIR_RootConstrainSelectedInstOperands,
     /* 142109 */     // GIR_Coverage, 23447,
     /* 142109 */     GIR_EraseRootFromParent_Done,
     /* 142110 */   // Label 3055: @142110
     /* 142110 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(142172), // Rule ID 23771 //
     /* 142115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142130 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142137 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142154 */     // (uaddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rm),
     /* 142157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142159 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142161 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142170 */     GIR_RootConstrainSelectedInstOperands,
     /* 142171 */     // GIR_Coverage, 23771,
     /* 142171 */     GIR_EraseRootFromParent_Done,
     /* 142172 */   // Label 3056: @142172
     /* 142172 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(142234), // Rule ID 2564 //
     /* 142177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142196 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142199 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142203 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142216 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrm),
     /* 142219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142221 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142232 */     GIR_RootConstrainSelectedInstOperands,
     /* 142233 */     // GIR_Coverage, 2564,
     /* 142233 */     GIR_EraseRootFromParent_Done,
     /* 142234 */   // Label 3057: @142234
     /* 142234 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(142296), // Rule ID 4899 //
     /* 142239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142258 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142261 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142265 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142278 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rm),
     /* 142281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142283 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142285 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142294 */     GIR_RootConstrainSelectedInstOperands,
     /* 142295 */     // GIR_Coverage, 4899,
     /* 142295 */     GIR_EraseRootFromParent_Done,
     /* 142296 */   // Label 3058: @142296
     /* 142296 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(142323), // Rule ID 2563 //
     /* 142301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142316 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 142316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrr),
     /* 142321 */     GIR_RootConstrainSelectedInstOperands,
     /* 142322 */     // GIR_Coverage, 2563,
     /* 142322 */     GIR_Done,
     /* 142323 */   // Label 3059: @142323
     /* 142323 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(142350), // Rule ID 2565 //
     /* 142328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 142331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142343 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 142343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSWrr),
     /* 142348 */     GIR_RootConstrainSelectedInstOperands,
     /* 142349 */     // GIR_Coverage, 2565,
     /* 142349 */     GIR_Done,
     /* 142350 */   // Label 3060: @142350
     /* 142350 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(142377), // Rule ID 4896 //
     /* 142355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142370 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 142370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rr),
     /* 142375 */     GIR_RootConstrainSelectedInstOperands,
     /* 142376 */     // GIR_Coverage, 4896,
     /* 142376 */     GIR_Done,
     /* 142377 */   // Label 3061: @142377
     /* 142377 */   GIM_Reject,
     /* 142378 */ // Label 3054: @142378
     /* 142378 */ GIM_Reject,
     /* 142379 */ // Label 3048: @142379
     /* 142379 */ GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(142720),
     /* 142384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 142387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142390 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(142452), // Rule ID 23444 //
     /* 142395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142410 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142413 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142417 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142434 */     // (uaddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrm),
     /* 142437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142439 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142450 */     GIR_RootConstrainSelectedInstOperands,
     /* 142451 */     // GIR_Coverage, 23444,
     /* 142451 */     GIR_EraseRootFromParent_Done,
     /* 142452 */   // Label 3063: @142452
     /* 142452 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(142514), // Rule ID 23780 //
     /* 142457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142496 */     // (uaddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rm),
     /* 142499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142501 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142503 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142512 */     GIR_RootConstrainSelectedInstOperands,
     /* 142513 */     // GIR_Coverage, 23780,
     /* 142513 */     GIR_EraseRootFromParent_Done,
     /* 142514 */   // Label 3064: @142514
     /* 142514 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(142576), // Rule ID 2558 //
     /* 142519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142545 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142558 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrm),
     /* 142561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142563 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142565 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142574 */     GIR_RootConstrainSelectedInstOperands,
     /* 142575 */     // GIR_Coverage, 2558,
     /* 142575 */     GIR_EraseRootFromParent_Done,
     /* 142576 */   // Label 3065: @142576
     /* 142576 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(142638), // Rule ID 4917 //
     /* 142581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142620 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rm),
     /* 142623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142625 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142636 */     GIR_RootConstrainSelectedInstOperands,
     /* 142637 */     // GIR_Coverage, 4917,
     /* 142637 */     GIR_EraseRootFromParent_Done,
     /* 142638 */   // Label 3066: @142638
     /* 142638 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(142665), // Rule ID 2557 //
     /* 142643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142658 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 142658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrr),
     /* 142663 */     GIR_RootConstrainSelectedInstOperands,
     /* 142664 */     // GIR_Coverage, 2557,
     /* 142664 */     GIR_Done,
     /* 142665 */   // Label 3067: @142665
     /* 142665 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(142692), // Rule ID 2559 //
     /* 142670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 142673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142685 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 142685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSBrr),
     /* 142690 */     GIR_RootConstrainSelectedInstOperands,
     /* 142691 */     // GIR_Coverage, 2559,
     /* 142691 */     GIR_Done,
     /* 142692 */   // Label 3068: @142692
     /* 142692 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(142719), // Rule ID 4914 //
     /* 142697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142712 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 142712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rr),
     /* 142717 */     GIR_RootConstrainSelectedInstOperands,
     /* 142718 */     // GIR_Coverage, 4914,
     /* 142718 */     GIR_Done,
     /* 142719 */   // Label 3069: @142719
     /* 142719 */   GIM_Reject,
     /* 142720 */ // Label 3062: @142720
     /* 142720 */ GIM_Reject,
     /* 142721 */ // Label 3049: @142721
     /* 142721 */ GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(143035),
     /* 142726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 142729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 142732 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(142794), // Rule ID 23449 //
     /* 142737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142752 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142755 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142759 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142776 */     // (uaddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrm),
     /* 142779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142781 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142792 */     GIR_RootConstrainSelectedInstOperands,
     /* 142793 */     // GIR_Coverage, 23449,
     /* 142793 */     GIR_EraseRootFromParent_Done,
     /* 142794 */   // Label 3071: @142794
     /* 142794 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(142856), // Rule ID 23768 //
     /* 142799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142814 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142817 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142821 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142838 */     // (uaddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rm),
     /* 142841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142843 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142854 */     GIR_RootConstrainSelectedInstOperands,
     /* 142855 */     // GIR_Coverage, 23768,
     /* 142855 */     GIR_EraseRootFromParent_Done,
     /* 142856 */   // Label 3072: @142856
     /* 142856 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(142918), // Rule ID 2568 //
     /* 142861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142887 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142900 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrm),
     /* 142903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142916 */     GIR_RootConstrainSelectedInstOperands,
     /* 142917 */     // GIR_Coverage, 2568,
     /* 142917 */     GIR_EraseRootFromParent_Done,
     /* 142918 */   // Label 3073: @142918
     /* 142918 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(142980), // Rule ID 4893 //
     /* 142923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142942 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142962 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rm),
     /* 142965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142969 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142978 */     GIR_RootConstrainSelectedInstOperands,
     /* 142979 */     // GIR_Coverage, 4893,
     /* 142979 */     GIR_EraseRootFromParent_Done,
     /* 142980 */   // Label 3074: @142980
     /* 142980 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(143007), // Rule ID 2567 //
     /* 142985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143000 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 143000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrr),
     /* 143005 */     GIR_RootConstrainSelectedInstOperands,
     /* 143006 */     // GIR_Coverage, 2567,
     /* 143006 */     GIR_Done,
     /* 143007 */   // Label 3075: @143007
     /* 143007 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(143034), // Rule ID 4890 //
     /* 143012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143027 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 143027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rr),
     /* 143032 */     GIR_RootConstrainSelectedInstOperands,
     /* 143033 */     // GIR_Coverage, 4890,
     /* 143033 */     GIR_Done,
     /* 143034 */   // Label 3076: @143034
     /* 143034 */   GIM_Reject,
     /* 143035 */ // Label 3070: @143035
     /* 143035 */ GIM_Reject,
     /* 143036 */ // Label 3050: @143036
     /* 143036 */ GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(143350),
     /* 143041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 143044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 143047 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(143109), // Rule ID 23446 //
     /* 143052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143067 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143070 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143091 */     // (uaddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrm),
     /* 143094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143107 */     GIR_RootConstrainSelectedInstOperands,
     /* 143108 */     // GIR_Coverage, 23446,
     /* 143108 */     GIR_EraseRootFromParent_Done,
     /* 143109 */   // Label 3078: @143109
     /* 143109 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(143171), // Rule ID 23777 //
     /* 143114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143129 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143136 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143153 */     // (uaddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rm),
     /* 143156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143158 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143169 */     GIR_RootConstrainSelectedInstOperands,
     /* 143170 */     // GIR_Coverage, 23777,
     /* 143170 */     GIR_EraseRootFromParent_Done,
     /* 143171 */   // Label 3079: @143171
     /* 143171 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(143233), // Rule ID 2562 //
     /* 143176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143215 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrm),
     /* 143218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143231 */     GIR_RootConstrainSelectedInstOperands,
     /* 143232 */     // GIR_Coverage, 2562,
     /* 143232 */     GIR_EraseRootFromParent_Done,
     /* 143233 */   // Label 3080: @143233
     /* 143233 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(143295), // Rule ID 4911 //
     /* 143238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143257 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143260 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143264 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143277 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rm),
     /* 143280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143282 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143293 */     GIR_RootConstrainSelectedInstOperands,
     /* 143294 */     // GIR_Coverage, 4911,
     /* 143294 */     GIR_EraseRootFromParent_Done,
     /* 143295 */   // Label 3081: @143295
     /* 143295 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(143322), // Rule ID 2561 //
     /* 143300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143315 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 143315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrr),
     /* 143320 */     GIR_RootConstrainSelectedInstOperands,
     /* 143321 */     // GIR_Coverage, 2561,
     /* 143321 */     GIR_Done,
     /* 143322 */   // Label 3082: @143322
     /* 143322 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(143349), // Rule ID 4908 //
     /* 143327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143342 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 143342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rr),
     /* 143347 */     GIR_RootConstrainSelectedInstOperands,
     /* 143348 */     // GIR_Coverage, 4908,
     /* 143348 */     GIR_Done,
     /* 143349 */   // Label 3083: @143349
     /* 143349 */   GIM_Reject,
     /* 143350 */ // Label 3077: @143350
     /* 143350 */ GIM_Reject,
     /* 143351 */ // Label 3051: @143351
     /* 143351 */ GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(143506),
     /* 143356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 143359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 143362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143366 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(143424), // Rule ID 23765 //
     /* 143371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143382 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143385 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143389 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143406 */     // (uaddsat:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrm),
     /* 143409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143411 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143413 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143422 */     GIR_RootConstrainSelectedInstOperands,
     /* 143423 */     // GIR_Coverage, 23765,
     /* 143423 */     GIR_EraseRootFromParent_Done,
     /* 143424 */   // Label 3085: @143424
     /* 143424 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(143482), // Rule ID 4887 //
     /* 143429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143444 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143447 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143464 */     // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrm),
     /* 143467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143480 */     GIR_RootConstrainSelectedInstOperands,
     /* 143481 */     // GIR_Coverage, 4887,
     /* 143481 */     GIR_EraseRootFromParent_Done,
     /* 143482 */   // Label 3086: @143482
     /* 143482 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(143505), // Rule ID 4884 //
     /* 143487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143498 */     // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 143498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrr),
     /* 143503 */     GIR_RootConstrainSelectedInstOperands,
     /* 143504 */     // GIR_Coverage, 4884,
     /* 143504 */     GIR_Done,
     /* 143505 */   // Label 3087: @143505
     /* 143505 */   GIM_Reject,
     /* 143506 */ // Label 3084: @143506
     /* 143506 */ GIM_Reject,
     /* 143507 */ // Label 3052: @143507
     /* 143507 */ GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(143662),
     /* 143512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 143515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 143518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143522 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(143580), // Rule ID 23774 //
     /* 143527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143545 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143562 */     // (uaddsat:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrm),
     /* 143565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143567 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143578 */     GIR_RootConstrainSelectedInstOperands,
     /* 143579 */     // GIR_Coverage, 23774,
     /* 143579 */     GIR_EraseRootFromParent_Done,
     /* 143580 */   // Label 3089: @143580
     /* 143580 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(143638), // Rule ID 4905 //
     /* 143585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143620 */     // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrm),
     /* 143623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143625 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143636 */     GIR_RootConstrainSelectedInstOperands,
     /* 143637 */     // GIR_Coverage, 4905,
     /* 143637 */     GIR_EraseRootFromParent_Done,
     /* 143638 */   // Label 3090: @143638
     /* 143638 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(143661), // Rule ID 4902 //
     /* 143643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143654 */     // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 143654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrr),
     /* 143659 */     GIR_RootConstrainSelectedInstOperands,
     /* 143660 */     // GIR_Coverage, 4902,
     /* 143660 */     GIR_Done,
     /* 143661 */   // Label 3091: @143661
     /* 143661 */   GIM_Reject,
     /* 143662 */ // Label 3088: @143662
     /* 143662 */ GIM_Reject,
     /* 143663 */ // Label 3053: @143663
     /* 143663 */ GIM_Reject,
     /* 143664 */ // Label 38: @143664
     /* 143664 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3098*/ GIMT_Encode4(145349),
     /* 143675 */ /*GILLT_v8s16*//*Label 3092*/ GIMT_Encode4(143723), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 143691 */ /*GILLT_v16s8*//*Label 3093*/ GIMT_Encode4(144065),
     /* 143695 */ /*GILLT_v16s16*//*Label 3094*/ GIMT_Encode4(144407), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 143707 */ /*GILLT_v32s8*//*Label 3095*/ GIMT_Encode4(144722),
     /* 143711 */ /*GILLT_v32s16*//*Label 3096*/ GIMT_Encode4(145037), GIMT_Encode4(0),
     /* 143719 */ /*GILLT_v64s8*//*Label 3097*/ GIMT_Encode4(145193),
     /* 143723 */ // Label 3092: @143723
     /* 143723 */ GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(144064),
     /* 143728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 143731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143734 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(143796), // Rule ID 23441 //
     /* 143739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143754 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143757 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143761 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143778 */     // (saddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWrm),
     /* 143781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143783 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143794 */     GIR_RootConstrainSelectedInstOperands,
     /* 143795 */     // GIR_Coverage, 23441,
     /* 143795 */     GIR_EraseRootFromParent_Done,
     /* 143796 */   // Label 3100: @143796
     /* 143796 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(143858), // Rule ID 23753 //
     /* 143801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143816 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143819 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143823 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143840 */     // (saddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rm),
     /* 143843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143856 */     GIR_RootConstrainSelectedInstOperands,
     /* 143857 */     // GIR_Coverage, 23753,
     /* 143857 */     GIR_EraseRootFromParent_Done,
     /* 143858 */   // Label 3101: @143858
     /* 143858 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(143920), // Rule ID 2552 //
     /* 143863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143882 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143885 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143889 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143902 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWrm),
     /* 143905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143907 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143918 */     GIR_RootConstrainSelectedInstOperands,
     /* 143919 */     // GIR_Coverage, 2552,
     /* 143919 */     GIR_EraseRootFromParent_Done,
     /* 143920 */   // Label 3102: @143920
     /* 143920 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(143982), // Rule ID 4827 //
     /* 143925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143944 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143964 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rm),
     /* 143967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143969 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143971 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143980 */     GIR_RootConstrainSelectedInstOperands,
     /* 143981 */     // GIR_Coverage, 4827,
     /* 143981 */     GIR_EraseRootFromParent_Done,
     /* 143982 */   // Label 3103: @143982
     /* 143982 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(144009), // Rule ID 2551 //
     /* 143987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144002 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 144002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWrr),
     /* 144007 */     GIR_RootConstrainSelectedInstOperands,
     /* 144008 */     // GIR_Coverage, 2551,
     /* 144008 */     GIR_Done,
     /* 144009 */   // Label 3104: @144009
     /* 144009 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(144036), // Rule ID 2553 //
     /* 144014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 144017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144029 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 144029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSWrr),
     /* 144034 */     GIR_RootConstrainSelectedInstOperands,
     /* 144035 */     // GIR_Coverage, 2553,
     /* 144035 */     GIR_Done,
     /* 144036 */   // Label 3105: @144036
     /* 144036 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(144063), // Rule ID 4824 //
     /* 144041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144056 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 144056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rr),
     /* 144061 */     GIR_RootConstrainSelectedInstOperands,
     /* 144062 */     // GIR_Coverage, 4824,
     /* 144062 */     GIR_Done,
     /* 144063 */   // Label 3106: @144063
     /* 144063 */   GIM_Reject,
     /* 144064 */ // Label 3099: @144064
     /* 144064 */ GIM_Reject,
     /* 144065 */ // Label 3093: @144065
     /* 144065 */ GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(144406),
     /* 144070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 144073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144076 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(144138), // Rule ID 23438 //
     /* 144081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144096 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144099 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144103 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144120 */     // (saddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBrm),
     /* 144123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144136 */     GIR_RootConstrainSelectedInstOperands,
     /* 144137 */     // GIR_Coverage, 23438,
     /* 144137 */     GIR_EraseRootFromParent_Done,
     /* 144138 */   // Label 3108: @144138
     /* 144138 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(144200), // Rule ID 23762 //
     /* 144143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144158 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144165 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144182 */     // (saddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rm),
     /* 144185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144187 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144189 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144198 */     GIR_RootConstrainSelectedInstOperands,
     /* 144199 */     // GIR_Coverage, 23762,
     /* 144199 */     GIR_EraseRootFromParent_Done,
     /* 144200 */   // Label 3109: @144200
     /* 144200 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(144262), // Rule ID 2546 //
     /* 144205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144224 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144227 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144244 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBrm),
     /* 144247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144249 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144251 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144260 */     GIR_RootConstrainSelectedInstOperands,
     /* 144261 */     // GIR_Coverage, 2546,
     /* 144261 */     GIR_EraseRootFromParent_Done,
     /* 144262 */   // Label 3110: @144262
     /* 144262 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(144324), // Rule ID 4845 //
     /* 144267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144306 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rm),
     /* 144309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144311 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144313 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144322 */     GIR_RootConstrainSelectedInstOperands,
     /* 144323 */     // GIR_Coverage, 4845,
     /* 144323 */     GIR_EraseRootFromParent_Done,
     /* 144324 */   // Label 3111: @144324
     /* 144324 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(144351), // Rule ID 2545 //
     /* 144329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144344 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 144344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBrr),
     /* 144349 */     GIR_RootConstrainSelectedInstOperands,
     /* 144350 */     // GIR_Coverage, 2545,
     /* 144350 */     GIR_Done,
     /* 144351 */   // Label 3112: @144351
     /* 144351 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(144378), // Rule ID 2547 //
     /* 144356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 144359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144371 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 144371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSBrr),
     /* 144376 */     GIR_RootConstrainSelectedInstOperands,
     /* 144377 */     // GIR_Coverage, 2547,
     /* 144377 */     GIR_Done,
     /* 144378 */   // Label 3113: @144378
     /* 144378 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(144405), // Rule ID 4842 //
     /* 144383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144398 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 144398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rr),
     /* 144403 */     GIR_RootConstrainSelectedInstOperands,
     /* 144404 */     // GIR_Coverage, 4842,
     /* 144404 */     GIR_Done,
     /* 144405 */   // Label 3114: @144405
     /* 144405 */   GIM_Reject,
     /* 144406 */ // Label 3107: @144406
     /* 144406 */ GIM_Reject,
     /* 144407 */ // Label 3094: @144407
     /* 144407 */ GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(144721),
     /* 144412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 144415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 144418 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(144480), // Rule ID 23443 //
     /* 144423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144438 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144445 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144462 */     // (saddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrm),
     /* 144465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144467 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144478 */     GIR_RootConstrainSelectedInstOperands,
     /* 144479 */     // GIR_Coverage, 23443,
     /* 144479 */     GIR_EraseRootFromParent_Done,
     /* 144480 */   // Label 3116: @144480
     /* 144480 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(144542), // Rule ID 23750 //
     /* 144485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144503 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144507 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144524 */     // (saddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rm),
     /* 144527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144540 */     GIR_RootConstrainSelectedInstOperands,
     /* 144541 */     // GIR_Coverage, 23750,
     /* 144541 */     GIR_EraseRootFromParent_Done,
     /* 144542 */   // Label 3117: @144542
     /* 144542 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(144604), // Rule ID 2556 //
     /* 144547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144566 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144569 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144573 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144586 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrm),
     /* 144589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144591 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144593 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144602 */     GIR_RootConstrainSelectedInstOperands,
     /* 144603 */     // GIR_Coverage, 2556,
     /* 144603 */     GIR_EraseRootFromParent_Done,
     /* 144604 */   // Label 3118: @144604
     /* 144604 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(144666), // Rule ID 4821 //
     /* 144609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144648 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rm),
     /* 144651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144655 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144664 */     GIR_RootConstrainSelectedInstOperands,
     /* 144665 */     // GIR_Coverage, 4821,
     /* 144665 */     GIR_EraseRootFromParent_Done,
     /* 144666 */   // Label 3119: @144666
     /* 144666 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(144693), // Rule ID 2555 //
     /* 144671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144686 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 144686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrr),
     /* 144691 */     GIR_RootConstrainSelectedInstOperands,
     /* 144692 */     // GIR_Coverage, 2555,
     /* 144692 */     GIR_Done,
     /* 144693 */   // Label 3120: @144693
     /* 144693 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(144720), // Rule ID 4818 //
     /* 144698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144713 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 144713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rr),
     /* 144718 */     GIR_RootConstrainSelectedInstOperands,
     /* 144719 */     // GIR_Coverage, 4818,
     /* 144719 */     GIR_Done,
     /* 144720 */   // Label 3121: @144720
     /* 144720 */   GIM_Reject,
     /* 144721 */ // Label 3115: @144721
     /* 144721 */ GIM_Reject,
     /* 144722 */ // Label 3095: @144722
     /* 144722 */ GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(145036),
     /* 144727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 144730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 144733 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(144795), // Rule ID 23440 //
     /* 144738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144777 */     // (saddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrm),
     /* 144780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144782 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144793 */     GIR_RootConstrainSelectedInstOperands,
     /* 144794 */     // GIR_Coverage, 23440,
     /* 144794 */     GIR_EraseRootFromParent_Done,
     /* 144795 */   // Label 3123: @144795
     /* 144795 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(144857), // Rule ID 23759 //
     /* 144800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144815 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144822 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144839 */     // (saddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rm),
     /* 144842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144844 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144846 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144855 */     GIR_RootConstrainSelectedInstOperands,
     /* 144856 */     // GIR_Coverage, 23759,
     /* 144856 */     GIR_EraseRootFromParent_Done,
     /* 144857 */   // Label 3124: @144857
     /* 144857 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(144919), // Rule ID 2550 //
     /* 144862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144881 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144884 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144888 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144901 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrm),
     /* 144904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144906 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144908 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144917 */     GIR_RootConstrainSelectedInstOperands,
     /* 144918 */     // GIR_Coverage, 2550,
     /* 144918 */     GIR_EraseRootFromParent_Done,
     /* 144919 */   // Label 3125: @144919
     /* 144919 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(144981), // Rule ID 4839 //
     /* 144924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144943 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144950 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144963 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rm),
     /* 144966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144979 */     GIR_RootConstrainSelectedInstOperands,
     /* 144980 */     // GIR_Coverage, 4839,
     /* 144980 */     GIR_EraseRootFromParent_Done,
     /* 144981 */   // Label 3126: @144981
     /* 144981 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(145008), // Rule ID 2549 //
     /* 144986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145001 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 145001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrr),
     /* 145006 */     GIR_RootConstrainSelectedInstOperands,
     /* 145007 */     // GIR_Coverage, 2549,
     /* 145007 */     GIR_Done,
     /* 145008 */   // Label 3127: @145008
     /* 145008 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(145035), // Rule ID 4836 //
     /* 145013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145028 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 145028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rr),
     /* 145033 */     GIR_RootConstrainSelectedInstOperands,
     /* 145034 */     // GIR_Coverage, 4836,
     /* 145034 */     GIR_Done,
     /* 145035 */   // Label 3128: @145035
     /* 145035 */   GIM_Reject,
     /* 145036 */ // Label 3122: @145036
     /* 145036 */ GIM_Reject,
     /* 145037 */ // Label 3096: @145037
     /* 145037 */ GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(145192),
     /* 145042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 145045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 145048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145052 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(145110), // Rule ID 23747 //
     /* 145057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145068 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145075 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145092 */     // (saddsat:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrm),
     /* 145095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145097 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145099 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145108 */     GIR_RootConstrainSelectedInstOperands,
     /* 145109 */     // GIR_Coverage, 23747,
     /* 145109 */     GIR_EraseRootFromParent_Done,
     /* 145110 */   // Label 3130: @145110
     /* 145110 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(145168), // Rule ID 4815 //
     /* 145115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145130 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145137 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145150 */     // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrm),
     /* 145153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145155 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145166 */     GIR_RootConstrainSelectedInstOperands,
     /* 145167 */     // GIR_Coverage, 4815,
     /* 145167 */     GIR_EraseRootFromParent_Done,
     /* 145168 */   // Label 3131: @145168
     /* 145168 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(145191), // Rule ID 4812 //
     /* 145173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145184 */     // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 145184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrr),
     /* 145189 */     GIR_RootConstrainSelectedInstOperands,
     /* 145190 */     // GIR_Coverage, 4812,
     /* 145190 */     GIR_Done,
     /* 145191 */   // Label 3132: @145191
     /* 145191 */   GIM_Reject,
     /* 145192 */ // Label 3129: @145192
     /* 145192 */ GIM_Reject,
     /* 145193 */ // Label 3097: @145193
     /* 145193 */ GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(145348),
     /* 145198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 145201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 145204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145208 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(145266), // Rule ID 23756 //
     /* 145213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145224 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145227 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145248 */     // (saddsat:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrm),
     /* 145251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145255 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145264 */     GIR_RootConstrainSelectedInstOperands,
     /* 145265 */     // GIR_Coverage, 23756,
     /* 145265 */     GIR_EraseRootFromParent_Done,
     /* 145266 */   // Label 3134: @145266
     /* 145266 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(145324), // Rule ID 4833 //
     /* 145271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145306 */     // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrm),
     /* 145309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145311 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145313 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145322 */     GIR_RootConstrainSelectedInstOperands,
     /* 145323 */     // GIR_Coverage, 4833,
     /* 145323 */     GIR_EraseRootFromParent_Done,
     /* 145324 */   // Label 3135: @145324
     /* 145324 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(145347), // Rule ID 4830 //
     /* 145329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145340 */     // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 145340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrr),
     /* 145345 */     GIR_RootConstrainSelectedInstOperands,
     /* 145346 */     // GIR_Coverage, 4830,
     /* 145346 */     GIR_Done,
     /* 145347 */   // Label 3136: @145347
     /* 145347 */   GIM_Reject,
     /* 145348 */ // Label 3133: @145348
     /* 145348 */ GIM_Reject,
     /* 145349 */ // Label 3098: @145349
     /* 145349 */ GIM_Reject,
     /* 145350 */ // Label 39: @145350
     /* 145350 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3143*/ GIMT_Encode4(146415),
     /* 145361 */ /*GILLT_v8s16*//*Label 3137*/ GIMT_Encode4(145409), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 145377 */ /*GILLT_v16s8*//*Label 3138*/ GIMT_Encode4(145627),
     /* 145381 */ /*GILLT_v16s16*//*Label 3139*/ GIMT_Encode4(145845), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 145393 */ /*GILLT_v32s8*//*Label 3140*/ GIMT_Encode4(146036),
     /* 145397 */ /*GILLT_v32s16*//*Label 3141*/ GIMT_Encode4(146227), GIMT_Encode4(0),
     /* 145405 */ /*GILLT_v64s8*//*Label 3142*/ GIMT_Encode4(146321),
     /* 145409 */ // Label 3137: @145409
     /* 145409 */ GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(145626),
     /* 145414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 145417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145420 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(145482), // Rule ID 2630 //
     /* 145425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145444 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145447 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145464 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrm),
     /* 145467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145480 */     GIR_RootConstrainSelectedInstOperands,
     /* 145481 */     // GIR_Coverage, 2630,
     /* 145481 */     GIR_EraseRootFromParent_Done,
     /* 145482 */   // Label 3145: @145482
     /* 145482 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(145544), // Rule ID 4935 //
     /* 145487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145506 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145513 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145526 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rm),
     /* 145529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145542 */     GIR_RootConstrainSelectedInstOperands,
     /* 145543 */     // GIR_Coverage, 4935,
     /* 145543 */     GIR_EraseRootFromParent_Done,
     /* 145544 */   // Label 3146: @145544
     /* 145544 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(145571), // Rule ID 2629 //
     /* 145549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145564 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 145564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrr),
     /* 145569 */     GIR_RootConstrainSelectedInstOperands,
     /* 145570 */     // GIR_Coverage, 2629,
     /* 145570 */     GIR_Done,
     /* 145571 */   // Label 3147: @145571
     /* 145571 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(145598), // Rule ID 2631 //
     /* 145576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 145579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145591 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 145591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSWrr),
     /* 145596 */     GIR_RootConstrainSelectedInstOperands,
     /* 145597 */     // GIR_Coverage, 2631,
     /* 145597 */     GIR_Done,
     /* 145598 */   // Label 3148: @145598
     /* 145598 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(145625), // Rule ID 4932 //
     /* 145603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145618 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 145618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rr),
     /* 145623 */     GIR_RootConstrainSelectedInstOperands,
     /* 145624 */     // GIR_Coverage, 4932,
     /* 145624 */     GIR_Done,
     /* 145625 */   // Label 3149: @145625
     /* 145625 */   GIM_Reject,
     /* 145626 */ // Label 3144: @145626
     /* 145626 */ GIM_Reject,
     /* 145627 */ // Label 3138: @145627
     /* 145627 */ GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(145844),
     /* 145632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 145635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145638 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(145700), // Rule ID 2624 //
     /* 145643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145662 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145665 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145669 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145682 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrm),
     /* 145685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145698 */     GIR_RootConstrainSelectedInstOperands,
     /* 145699 */     // GIR_Coverage, 2624,
     /* 145699 */     GIR_EraseRootFromParent_Done,
     /* 145700 */   // Label 3151: @145700
     /* 145700 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(145762), // Rule ID 4953 //
     /* 145705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145744 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rm),
     /* 145747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145749 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145760 */     GIR_RootConstrainSelectedInstOperands,
     /* 145761 */     // GIR_Coverage, 4953,
     /* 145761 */     GIR_EraseRootFromParent_Done,
     /* 145762 */   // Label 3152: @145762
     /* 145762 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(145789), // Rule ID 2623 //
     /* 145767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145782 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 145782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrr),
     /* 145787 */     GIR_RootConstrainSelectedInstOperands,
     /* 145788 */     // GIR_Coverage, 2623,
     /* 145788 */     GIR_Done,
     /* 145789 */   // Label 3153: @145789
     /* 145789 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(145816), // Rule ID 2625 //
     /* 145794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 145797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145809 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 145809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSBrr),
     /* 145814 */     GIR_RootConstrainSelectedInstOperands,
     /* 145815 */     // GIR_Coverage, 2625,
     /* 145815 */     GIR_Done,
     /* 145816 */   // Label 3154: @145816
     /* 145816 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(145843), // Rule ID 4950 //
     /* 145821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145836 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 145836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rr),
     /* 145841 */     GIR_RootConstrainSelectedInstOperands,
     /* 145842 */     // GIR_Coverage, 4950,
     /* 145842 */     GIR_Done,
     /* 145843 */   // Label 3155: @145843
     /* 145843 */   GIM_Reject,
     /* 145844 */ // Label 3150: @145844
     /* 145844 */ GIM_Reject,
     /* 145845 */ // Label 3139: @145845
     /* 145845 */ GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(146035),
     /* 145850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 145853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 145856 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(145918), // Rule ID 2634 //
     /* 145861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145887 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145900 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrm),
     /* 145903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145916 */     GIR_RootConstrainSelectedInstOperands,
     /* 145917 */     // GIR_Coverage, 2634,
     /* 145917 */     GIR_EraseRootFromParent_Done,
     /* 145918 */   // Label 3157: @145918
     /* 145918 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(145980), // Rule ID 4929 //
     /* 145923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145942 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145962 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rm),
     /* 145965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145969 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145978 */     GIR_RootConstrainSelectedInstOperands,
     /* 145979 */     // GIR_Coverage, 4929,
     /* 145979 */     GIR_EraseRootFromParent_Done,
     /* 145980 */   // Label 3158: @145980
     /* 145980 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(146007), // Rule ID 2633 //
     /* 145985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146000 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 146000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrr),
     /* 146005 */     GIR_RootConstrainSelectedInstOperands,
     /* 146006 */     // GIR_Coverage, 2633,
     /* 146006 */     GIR_Done,
     /* 146007 */   // Label 3159: @146007
     /* 146007 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(146034), // Rule ID 4926 //
     /* 146012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146027 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 146027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rr),
     /* 146032 */     GIR_RootConstrainSelectedInstOperands,
     /* 146033 */     // GIR_Coverage, 4926,
     /* 146033 */     GIR_Done,
     /* 146034 */   // Label 3160: @146034
     /* 146034 */   GIM_Reject,
     /* 146035 */ // Label 3156: @146035
     /* 146035 */ GIM_Reject,
     /* 146036 */ // Label 3140: @146036
     /* 146036 */ GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(146226),
     /* 146041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 146044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 146047 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(146109), // Rule ID 2628 //
     /* 146052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146071 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146091 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrm),
     /* 146094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146096 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146107 */     GIR_RootConstrainSelectedInstOperands,
     /* 146108 */     // GIR_Coverage, 2628,
     /* 146108 */     GIR_EraseRootFromParent_Done,
     /* 146109 */   // Label 3162: @146109
     /* 146109 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(146171), // Rule ID 4947 //
     /* 146114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146133 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146140 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146153 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rm),
     /* 146156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146169 */     GIR_RootConstrainSelectedInstOperands,
     /* 146170 */     // GIR_Coverage, 4947,
     /* 146170 */     GIR_EraseRootFromParent_Done,
     /* 146171 */   // Label 3163: @146171
     /* 146171 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(146198), // Rule ID 2627 //
     /* 146176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146191 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 146191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrr),
     /* 146196 */     GIR_RootConstrainSelectedInstOperands,
     /* 146197 */     // GIR_Coverage, 2627,
     /* 146197 */     GIR_Done,
     /* 146198 */   // Label 3164: @146198
     /* 146198 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(146225), // Rule ID 4944 //
     /* 146203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146218 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 146218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rr),
     /* 146223 */     GIR_RootConstrainSelectedInstOperands,
     /* 146224 */     // GIR_Coverage, 4944,
     /* 146224 */     GIR_Done,
     /* 146225 */   // Label 3165: @146225
     /* 146225 */   GIM_Reject,
     /* 146226 */ // Label 3161: @146226
     /* 146226 */ GIM_Reject,
     /* 146227 */ // Label 3141: @146227
     /* 146227 */ GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(146320),
     /* 146232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 146235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 146238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146246 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(146300), // Rule ID 4923 //
     /* 146251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146262 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146269 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146282 */     // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrm),
     /* 146285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146287 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146298 */     GIR_RootConstrainSelectedInstOperands,
     /* 146299 */     // GIR_Coverage, 4923,
     /* 146299 */     GIR_EraseRootFromParent_Done,
     /* 146300 */   // Label 3167: @146300
     /* 146300 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(146319), // Rule ID 4920 //
     /* 146305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146312 */     // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 146312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrr),
     /* 146317 */     GIR_RootConstrainSelectedInstOperands,
     /* 146318 */     // GIR_Coverage, 4920,
     /* 146318 */     GIR_Done,
     /* 146319 */   // Label 3168: @146319
     /* 146319 */   GIM_Reject,
     /* 146320 */ // Label 3166: @146320
     /* 146320 */ GIM_Reject,
     /* 146321 */ // Label 3142: @146321
     /* 146321 */ GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(146414),
     /* 146326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 146329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 146332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146340 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(146394), // Rule ID 4941 //
     /* 146345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146376 */     // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrm),
     /* 146379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146381 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146383 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146392 */     GIR_RootConstrainSelectedInstOperands,
     /* 146393 */     // GIR_Coverage, 4941,
     /* 146393 */     GIR_EraseRootFromParent_Done,
     /* 146394 */   // Label 3170: @146394
     /* 146394 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(146413), // Rule ID 4938 //
     /* 146399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146406 */     // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 146406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrr),
     /* 146411 */     GIR_RootConstrainSelectedInstOperands,
     /* 146412 */     // GIR_Coverage, 4938,
     /* 146412 */     GIR_Done,
     /* 146413 */   // Label 3171: @146413
     /* 146413 */   GIM_Reject,
     /* 146414 */ // Label 3169: @146414
     /* 146414 */ GIM_Reject,
     /* 146415 */ // Label 3143: @146415
     /* 146415 */ GIM_Reject,
     /* 146416 */ // Label 40: @146416
     /* 146416 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3178*/ GIMT_Encode4(147481),
     /* 146427 */ /*GILLT_v8s16*//*Label 3172*/ GIMT_Encode4(146475), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 146443 */ /*GILLT_v16s8*//*Label 3173*/ GIMT_Encode4(146693),
     /* 146447 */ /*GILLT_v16s16*//*Label 3174*/ GIMT_Encode4(146911), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 146459 */ /*GILLT_v32s8*//*Label 3175*/ GIMT_Encode4(147102),
     /* 146463 */ /*GILLT_v32s16*//*Label 3176*/ GIMT_Encode4(147293), GIMT_Encode4(0),
     /* 146471 */ /*GILLT_v64s8*//*Label 3177*/ GIMT_Encode4(147387),
     /* 146475 */ // Label 3172: @146475
     /* 146475 */ GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(146692),
     /* 146480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146486 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(146548), // Rule ID 2618 //
     /* 146491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146510 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146517 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146530 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrm),
     /* 146533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146537 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146546 */     GIR_RootConstrainSelectedInstOperands,
     /* 146547 */     // GIR_Coverage, 2618,
     /* 146547 */     GIR_EraseRootFromParent_Done,
     /* 146548 */   // Label 3180: @146548
     /* 146548 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(146610), // Rule ID 4863 //
     /* 146553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146592 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rm),
     /* 146595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146597 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146608 */     GIR_RootConstrainSelectedInstOperands,
     /* 146609 */     // GIR_Coverage, 4863,
     /* 146609 */     GIR_EraseRootFromParent_Done,
     /* 146610 */   // Label 3181: @146610
     /* 146610 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(146637), // Rule ID 2617 //
     /* 146615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146630 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 146630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrr),
     /* 146635 */     GIR_RootConstrainSelectedInstOperands,
     /* 146636 */     // GIR_Coverage, 2617,
     /* 146636 */     GIR_Done,
     /* 146637 */   // Label 3182: @146637
     /* 146637 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(146664), // Rule ID 2619 //
     /* 146642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 146645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146657 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 146657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSWrr),
     /* 146662 */     GIR_RootConstrainSelectedInstOperands,
     /* 146663 */     // GIR_Coverage, 2619,
     /* 146663 */     GIR_Done,
     /* 146664 */   // Label 3183: @146664
     /* 146664 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(146691), // Rule ID 4860 //
     /* 146669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146684 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 146684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rr),
     /* 146689 */     GIR_RootConstrainSelectedInstOperands,
     /* 146690 */     // GIR_Coverage, 4860,
     /* 146690 */     GIR_Done,
     /* 146691 */   // Label 3184: @146691
     /* 146691 */   GIM_Reject,
     /* 146692 */ // Label 3179: @146692
     /* 146692 */ GIM_Reject,
     /* 146693 */ // Label 3173: @146693
     /* 146693 */ GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(146910),
     /* 146698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 146701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146704 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(146766), // Rule ID 2612 //
     /* 146709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146735 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146748 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrm),
     /* 146751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146753 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146755 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146764 */     GIR_RootConstrainSelectedInstOperands,
     /* 146765 */     // GIR_Coverage, 2612,
     /* 146765 */     GIR_EraseRootFromParent_Done,
     /* 146766 */   // Label 3186: @146766
     /* 146766 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(146828), // Rule ID 4881 //
     /* 146771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146790 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146810 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rm),
     /* 146813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146815 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146826 */     GIR_RootConstrainSelectedInstOperands,
     /* 146827 */     // GIR_Coverage, 4881,
     /* 146827 */     GIR_EraseRootFromParent_Done,
     /* 146828 */   // Label 3187: @146828
     /* 146828 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(146855), // Rule ID 2611 //
     /* 146833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146848 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 146848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrr),
     /* 146853 */     GIR_RootConstrainSelectedInstOperands,
     /* 146854 */     // GIR_Coverage, 2611,
     /* 146854 */     GIR_Done,
     /* 146855 */   // Label 3188: @146855
     /* 146855 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(146882), // Rule ID 2613 //
     /* 146860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 146863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146875 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 146875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSBrr),
     /* 146880 */     GIR_RootConstrainSelectedInstOperands,
     /* 146881 */     // GIR_Coverage, 2613,
     /* 146881 */     GIR_Done,
     /* 146882 */   // Label 3189: @146882
     /* 146882 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(146909), // Rule ID 4878 //
     /* 146887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146902 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 146902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rr),
     /* 146907 */     GIR_RootConstrainSelectedInstOperands,
     /* 146908 */     // GIR_Coverage, 4878,
     /* 146908 */     GIR_Done,
     /* 146909 */   // Label 3190: @146909
     /* 146909 */   GIM_Reject,
     /* 146910 */ // Label 3185: @146910
     /* 146910 */ GIM_Reject,
     /* 146911 */ // Label 3174: @146911
     /* 146911 */ GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(147101),
     /* 146916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 146919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 146922 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(146984), // Rule ID 2622 //
     /* 146927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146946 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146953 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146966 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrm),
     /* 146969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146971 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146982 */     GIR_RootConstrainSelectedInstOperands,
     /* 146983 */     // GIR_Coverage, 2622,
     /* 146983 */     GIR_EraseRootFromParent_Done,
     /* 146984 */   // Label 3192: @146984
     /* 146984 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(147046), // Rule ID 4857 //
     /* 146989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147008 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147015 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147028 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rm),
     /* 147031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147033 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147044 */     GIR_RootConstrainSelectedInstOperands,
     /* 147045 */     // GIR_Coverage, 4857,
     /* 147045 */     GIR_EraseRootFromParent_Done,
     /* 147046 */   // Label 3193: @147046
     /* 147046 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(147073), // Rule ID 2621 //
     /* 147051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147066 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 147066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrr),
     /* 147071 */     GIR_RootConstrainSelectedInstOperands,
     /* 147072 */     // GIR_Coverage, 2621,
     /* 147072 */     GIR_Done,
     /* 147073 */   // Label 3194: @147073
     /* 147073 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(147100), // Rule ID 4854 //
     /* 147078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147093 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 147093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rr),
     /* 147098 */     GIR_RootConstrainSelectedInstOperands,
     /* 147099 */     // GIR_Coverage, 4854,
     /* 147099 */     GIR_Done,
     /* 147100 */   // Label 3195: @147100
     /* 147100 */   GIM_Reject,
     /* 147101 */ // Label 3191: @147101
     /* 147101 */ GIM_Reject,
     /* 147102 */ // Label 3175: @147102
     /* 147102 */ GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(147292),
     /* 147107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 147110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 147113 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(147175), // Rule ID 2616 //
     /* 147118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147157 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrm),
     /* 147160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147162 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147173 */     GIR_RootConstrainSelectedInstOperands,
     /* 147174 */     // GIR_Coverage, 2616,
     /* 147174 */     GIR_EraseRootFromParent_Done,
     /* 147175 */   // Label 3197: @147175
     /* 147175 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(147237), // Rule ID 4875 //
     /* 147180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147199 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147202 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147206 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147219 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rm),
     /* 147222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147224 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147235 */     GIR_RootConstrainSelectedInstOperands,
     /* 147236 */     // GIR_Coverage, 4875,
     /* 147236 */     GIR_EraseRootFromParent_Done,
     /* 147237 */   // Label 3198: @147237
     /* 147237 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(147264), // Rule ID 2615 //
     /* 147242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147257 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 147257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrr),
     /* 147262 */     GIR_RootConstrainSelectedInstOperands,
     /* 147263 */     // GIR_Coverage, 2615,
     /* 147263 */     GIR_Done,
     /* 147264 */   // Label 3199: @147264
     /* 147264 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(147291), // Rule ID 4872 //
     /* 147269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147284 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 147284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rr),
     /* 147289 */     GIR_RootConstrainSelectedInstOperands,
     /* 147290 */     // GIR_Coverage, 4872,
     /* 147290 */     GIR_Done,
     /* 147291 */   // Label 3200: @147291
     /* 147291 */   GIM_Reject,
     /* 147292 */ // Label 3196: @147292
     /* 147292 */ GIM_Reject,
     /* 147293 */ // Label 3176: @147293
     /* 147293 */ GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(147386),
     /* 147298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 147301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 147304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147312 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(147366), // Rule ID 4851 //
     /* 147317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147328 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147331 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147335 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147348 */     // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrm),
     /* 147351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147364 */     GIR_RootConstrainSelectedInstOperands,
     /* 147365 */     // GIR_Coverage, 4851,
     /* 147365 */     GIR_EraseRootFromParent_Done,
     /* 147366 */   // Label 3202: @147366
     /* 147366 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(147385), // Rule ID 4848 //
     /* 147371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147378 */     // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 147378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrr),
     /* 147383 */     GIR_RootConstrainSelectedInstOperands,
     /* 147384 */     // GIR_Coverage, 4848,
     /* 147384 */     GIR_Done,
     /* 147385 */   // Label 3203: @147385
     /* 147385 */   GIM_Reject,
     /* 147386 */ // Label 3201: @147386
     /* 147386 */ GIM_Reject,
     /* 147387 */ // Label 3177: @147387
     /* 147387 */ GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(147480),
     /* 147392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 147395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 147398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147406 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(147460), // Rule ID 4869 //
     /* 147411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147422 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147429 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147442 */     // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrm),
     /* 147445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147458 */     GIR_RootConstrainSelectedInstOperands,
     /* 147459 */     // GIR_Coverage, 4869,
     /* 147459 */     GIR_EraseRootFromParent_Done,
     /* 147460 */   // Label 3205: @147460
     /* 147460 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(147479), // Rule ID 4866 //
     /* 147465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147472 */     // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 147472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrr),
     /* 147477 */     GIR_RootConstrainSelectedInstOperands,
     /* 147478 */     // GIR_Coverage, 4866,
     /* 147478 */     GIR_Done,
     /* 147479 */   // Label 3206: @147479
     /* 147479 */   GIM_Reject,
     /* 147480 */ // Label 3204: @147480
     /* 147480 */ GIM_Reject,
     /* 147481 */ // Label 3178: @147481
     /* 147481 */ GIM_Reject,
     /* 147482 */ // Label 41: @147482
     /* 147482 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3220*/ GIMT_Encode4(152631),
     /* 147493 */ /*GILLT_s16*//*Label 3207*/ GIMT_Encode4(147577),
     /* 147497 */ /*GILLT_s32*//*Label 3208*/ GIMT_Encode4(147737),
     /* 147501 */ /*GILLT_s64*//*Label 3209*/ GIMT_Encode4(148874),
     /* 147505 */ /*GILLT_s80*//*Label 3210*/ GIMT_Encode4(150155), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147517 */ /*GILLT_v2s64*//*Label 3211*/ GIMT_Encode4(150477), GIMT_Encode4(0),
     /* 147525 */ /*GILLT_v4s32*//*Label 3212*/ GIMT_Encode4(150831),
     /* 147529 */ /*GILLT_v4s64*//*Label 3213*/ GIMT_Encode4(151185), GIMT_Encode4(0),
     /* 147537 */ /*GILLT_v8s16*//*Label 3214*/ GIMT_Encode4(151508),
     /* 147541 */ /*GILLT_v8s32*//*Label 3215*/ GIMT_Encode4(151668),
     /* 147545 */ /*GILLT_v8s64*//*Label 3216*/ GIMT_Encode4(151991), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147557 */ /*GILLT_v16s16*//*Label 3217*/ GIMT_Encode4(152151),
     /* 147561 */ /*GILLT_v16s32*//*Label 3218*/ GIMT_Encode4(152311), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147573 */ /*GILLT_v32s16*//*Label 3219*/ GIMT_Encode4(152471),
     /* 147577 */ // Label 3207: @147577
     /* 147577 */ GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(147736),
     /* 147582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 147585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147592 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(147650), // Rule ID 24247 //
     /* 147597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147632 */     // (fadd:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 147635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147637 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147639 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147648 */     GIR_RootConstrainSelectedInstOperands,
     /* 147649 */     // GIR_Coverage, 24247,
     /* 147649 */     GIR_EraseRootFromParent_Done,
     /* 147650 */   // Label 3222: @147650
     /* 147650 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(147708), // Rule ID 5954 //
     /* 147655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147670 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147673 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147677 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147690 */     // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 147693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147706 */     GIR_RootConstrainSelectedInstOperands,
     /* 147707 */     // GIR_Coverage, 5954,
     /* 147707 */     GIR_EraseRootFromParent_Done,
     /* 147708 */   // Label 3223: @147708
     /* 147708 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(147735), // Rule ID 5952 //
     /* 147713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147724 */     // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 147724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 147729 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 147733 */     GIR_RootConstrainSelectedInstOperands,
     /* 147734 */     // GIR_Coverage, 5952,
     /* 147734 */     GIR_Done,
     /* 147735 */   // Label 3224: @147735
     /* 147735 */   GIM_Reject,
     /* 147736 */ // Label 3221: @147736
     /* 147736 */ GIM_Reject,
     /* 147737 */ // Label 3208: @147737
     /* 147737 */ GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(148873),
     /* 147742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 147745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147748 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(147830), // Rule ID 26015 //
     /* 147753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 147756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147780 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 147787 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147794 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 147798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 147804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147811 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 147814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147816 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 147828 */     GIR_RootConstrainSelectedInstOperands,
     /* 147829 */     // GIR_Coverage, 26015,
     /* 147829 */     GIR_EraseRootFromParent_Done,
     /* 147830 */   // Label 3226: @147830
     /* 147830 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(147912), // Rule ID 26016 //
     /* 147835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 147838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147862 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147865 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 147869 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147876 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 147880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 147886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147893 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 147896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147898 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147900 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 147910 */     GIR_RootConstrainSelectedInstOperands,
     /* 147911 */     // GIR_Coverage, 26016,
     /* 147911 */     GIR_EraseRootFromParent_Done,
     /* 147912 */   // Label 3227: @147912
     /* 147912 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(147994), // Rule ID 26017 //
     /* 147917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 147920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 147924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147944 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 147951 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147958 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 147962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 147966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 147968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147975 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 147978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147982 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 147992 */     GIR_RootConstrainSelectedInstOperands,
     /* 147993 */     // GIR_Coverage, 26017,
     /* 147993 */     GIR_EraseRootFromParent_Done,
     /* 147994 */   // Label 3228: @147994
     /* 147994 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(148076), // Rule ID 22466 //
     /* 147999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148030 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148033 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148037 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148044 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148057 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148064 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148074 */     GIR_RootConstrainSelectedInstOperands,
     /* 148075 */     // GIR_Coverage, 22466,
     /* 148075 */     GIR_EraseRootFromParent_Done,
     /* 148076 */   // Label 3229: @148076
     /* 148076 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(148158), // Rule ID 22467 //
     /* 148081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148112 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148119 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148126 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148139 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148156 */     GIR_RootConstrainSelectedInstOperands,
     /* 148157 */     // GIR_Coverage, 22467,
     /* 148157 */     GIR_EraseRootFromParent_Done,
     /* 148158 */   // Label 3230: @148158
     /* 148158 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(148240), // Rule ID 22468 //
     /* 148163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148194 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148201 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148208 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148221 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148226 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148228 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148238 */     GIR_RootConstrainSelectedInstOperands,
     /* 148239 */     // GIR_Coverage, 22468,
     /* 148239 */     GIR_EraseRootFromParent_Done,
     /* 148240 */   // Label 3231: @148240
     /* 148240 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(148305), // Rule ID 23234 //
     /* 148245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148260 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148284 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 148287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148289 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148291 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148303 */     GIR_RootConstrainSelectedInstOperands,
     /* 148304 */     // GIR_Coverage, 23234,
     /* 148304 */     GIR_EraseRootFromParent_Done,
     /* 148305 */   // Label 3232: @148305
     /* 148305 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(148367), // Rule ID 23379 //
     /* 148310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148325 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148328 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148349 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148356 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148365 */     GIR_RootConstrainSelectedInstOperands,
     /* 148366 */     // GIR_Coverage, 23379,
     /* 148366 */     GIR_EraseRootFromParent_Done,
     /* 148367 */   // Label 3233: @148367
     /* 148367 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(148429), // Rule ID 23383 //
     /* 148372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148387 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148411 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148416 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148418 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148427 */     GIR_RootConstrainSelectedInstOperands,
     /* 148428 */     // GIR_Coverage, 23383,
     /* 148428 */     GIR_EraseRootFromParent_Done,
     /* 148429 */   // Label 3234: @148429
     /* 148429 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(148491), // Rule ID 24243 //
     /* 148434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148449 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148452 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148456 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148473 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148478 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148480 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148489 */     GIR_RootConstrainSelectedInstOperands,
     /* 148490 */     // GIR_Coverage, 24243,
     /* 148490 */     GIR_EraseRootFromParent_Done,
     /* 148491 */   // Label 3235: @148491
     /* 148491 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(148556), // Rule ID 910 //
     /* 148496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148515 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148518 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148522 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148535 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 148538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148540 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148542 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148554 */     GIR_RootConstrainSelectedInstOperands,
     /* 148555 */     // GIR_Coverage, 910,
     /* 148555 */     GIR_EraseRootFromParent_Done,
     /* 148556 */   // Label 3236: @148556
     /* 148556 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(148618), // Rule ID 2160 //
     /* 148561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148600 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148605 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148616 */     GIR_RootConstrainSelectedInstOperands,
     /* 148617 */     // GIR_Coverage, 2160,
     /* 148617 */     GIR_EraseRootFromParent_Done,
     /* 148618 */   // Label 3237: @148618
     /* 148618 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(148680), // Rule ID 2168 //
     /* 148623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148662 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148678 */     GIR_RootConstrainSelectedInstOperands,
     /* 148679 */     // GIR_Coverage, 2168,
     /* 148679 */     GIR_EraseRootFromParent_Done,
     /* 148680 */   // Label 3238: @148680
     /* 148680 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(148742), // Rule ID 5916 //
     /* 148685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148704 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148707 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148711 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148724 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148729 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148740 */     GIR_RootConstrainSelectedInstOperands,
     /* 148741 */     // GIR_Coverage, 5916,
     /* 148741 */     GIR_EraseRootFromParent_Done,
     /* 148742 */   // Label 3239: @148742
     /* 148742 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(148779), // Rule ID 886 //
     /* 148747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148762 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 148762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 148767 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 148773 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 148777 */     GIR_RootConstrainSelectedInstOperands,
     /* 148778 */     // GIR_Coverage, 886,
     /* 148778 */     GIR_Done,
     /* 148779 */   // Label 3240: @148779
     /* 148779 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(148810), // Rule ID 2158 //
     /* 148784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148799 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 148799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 148804 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 148808 */     GIR_RootConstrainSelectedInstOperands,
     /* 148809 */     // GIR_Coverage, 2158,
     /* 148809 */     GIR_Done,
     /* 148810 */   // Label 3241: @148810
     /* 148810 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(148841), // Rule ID 2166 //
     /* 148815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148830 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 148830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 148835 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 148839 */     GIR_RootConstrainSelectedInstOperands,
     /* 148840 */     // GIR_Coverage, 2166,
     /* 148840 */     GIR_Done,
     /* 148841 */   // Label 3242: @148841
     /* 148841 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(148872), // Rule ID 5914 //
     /* 148846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148861 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 148861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 148866 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 148870 */     GIR_RootConstrainSelectedInstOperands,
     /* 148871 */     // GIR_Coverage, 5914,
     /* 148871 */     GIR_Done,
     /* 148872 */   // Label 3243: @148872
     /* 148872 */   GIM_Reject,
     /* 148873 */ // Label 3225: @148873
     /* 148873 */ GIM_Reject,
     /* 148874 */ // Label 3209: @148874
     /* 148874 */ GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(150154),
     /* 148879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 148882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148885 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(148967), // Rule ID 26018 //
     /* 148890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 148909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148917 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148920 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148924 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 148931 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148948 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 148951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148965 */     GIR_RootConstrainSelectedInstOperands,
     /* 148966 */     // GIR_Coverage, 26018,
     /* 148966 */     GIR_EraseRootFromParent_Done,
     /* 148967 */   // Label 3245: @148967
     /* 148967 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(149049), // Rule ID 26019 //
     /* 148972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 148991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148999 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149002 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149006 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149013 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149030 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149035 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149037 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149047 */     GIR_RootConstrainSelectedInstOperands,
     /* 149048 */     // GIR_Coverage, 26019,
     /* 149048 */     GIR_EraseRootFromParent_Done,
     /* 149049 */   // Label 3246: @149049
     /* 149049 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(149131), // Rule ID 26020 //
     /* 149054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149081 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149084 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149088 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149095 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149105 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149112 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149117 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149129 */     GIR_RootConstrainSelectedInstOperands,
     /* 149130 */     // GIR_Coverage, 26020,
     /* 149130 */     GIR_EraseRootFromParent_Done,
     /* 149131 */   // Label 3247: @149131
     /* 149131 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(149213), // Rule ID 22469 //
     /* 149136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149167 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149174 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149181 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149194 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149201 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149211 */     GIR_RootConstrainSelectedInstOperands,
     /* 149212 */     // GIR_Coverage, 22469,
     /* 149212 */     GIR_EraseRootFromParent_Done,
     /* 149213 */   // Label 3248: @149213
     /* 149213 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(149295), // Rule ID 22470 //
     /* 149218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149249 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149256 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149263 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149269 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149276 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149281 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149293 */     GIR_RootConstrainSelectedInstOperands,
     /* 149294 */     // GIR_Coverage, 22470,
     /* 149294 */     GIR_EraseRootFromParent_Done,
     /* 149295 */   // Label 3249: @149295
     /* 149295 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(149377), // Rule ID 22471 //
     /* 149300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149331 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149338 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149345 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149351 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149358 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149375 */     GIR_RootConstrainSelectedInstOperands,
     /* 149376 */     // GIR_Coverage, 22471,
     /* 149376 */     GIR_EraseRootFromParent_Done,
     /* 149377 */   // Label 3250: @149377
     /* 149377 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(149442), // Rule ID 23236 //
     /* 149382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149397 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149400 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149404 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149421 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 149424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149426 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149428 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149440 */     GIR_RootConstrainSelectedInstOperands,
     /* 149441 */     // GIR_Coverage, 23236,
     /* 149441 */     GIR_EraseRootFromParent_Done,
     /* 149442 */   // Label 3251: @149442
     /* 149442 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(149514), // Rule ID 23238 //
     /* 149447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149462 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149465 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149469 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149476 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149493 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 149496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149498 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149512 */     GIR_RootConstrainSelectedInstOperands,
     /* 149513 */     // GIR_Coverage, 23238,
     /* 149513 */     GIR_EraseRootFromParent_Done,
     /* 149514 */   // Label 3252: @149514
     /* 149514 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(149576), // Rule ID 23381 //
     /* 149519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149534 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149537 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149541 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149558 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149563 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149565 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149574 */     GIR_RootConstrainSelectedInstOperands,
     /* 149575 */     // GIR_Coverage, 23381,
     /* 149575 */     GIR_EraseRootFromParent_Done,
     /* 149576 */   // Label 3253: @149576
     /* 149576 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(149638), // Rule ID 23385 //
     /* 149581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 149584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149596 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149599 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149603 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149620 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149636 */     GIR_RootConstrainSelectedInstOperands,
     /* 149637 */     // GIR_Coverage, 23385,
     /* 149637 */     GIR_EraseRootFromParent_Done,
     /* 149638 */   // Label 3254: @149638
     /* 149638 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(149700), // Rule ID 24245 //
     /* 149643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149658 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149661 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149665 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149682 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149687 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149698 */     GIR_RootConstrainSelectedInstOperands,
     /* 149699 */     // GIR_Coverage, 24245,
     /* 149699 */     GIR_EraseRootFromParent_Done,
     /* 149700 */   // Label 3255: @149700
     /* 149700 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(149765), // Rule ID 912 //
     /* 149705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149744 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 149747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149749 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149763 */     GIR_RootConstrainSelectedInstOperands,
     /* 149764 */     // GIR_Coverage, 912,
     /* 149764 */     GIR_EraseRootFromParent_Done,
     /* 149765 */   // Label 3256: @149765
     /* 149765 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(149837), // Rule ID 914 //
     /* 149770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149789 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149792 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149796 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149803 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149816 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 149819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149835 */     GIR_RootConstrainSelectedInstOperands,
     /* 149836 */     // GIR_Coverage, 914,
     /* 149836 */     GIR_EraseRootFromParent_Done,
     /* 149837 */   // Label 3257: @149837
     /* 149837 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(149899), // Rule ID 2164 //
     /* 149842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149861 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149864 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149868 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149881 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149886 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149888 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149897 */     GIR_RootConstrainSelectedInstOperands,
     /* 149898 */     // GIR_Coverage, 2164,
     /* 149898 */     GIR_EraseRootFromParent_Done,
     /* 149899 */   // Label 3258: @149899
     /* 149899 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(149961), // Rule ID 2172 //
     /* 149904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 149907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149923 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149926 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149930 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149936 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149943 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149948 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149950 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149959 */     GIR_RootConstrainSelectedInstOperands,
     /* 149960 */     // GIR_Coverage, 2172,
     /* 149960 */     GIR_EraseRootFromParent_Done,
     /* 149961 */   // Label 3259: @149961
     /* 149961 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(150023), // Rule ID 5935 //
     /* 149966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149988 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149992 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150005 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 150008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150010 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150021 */     GIR_RootConstrainSelectedInstOperands,
     /* 150022 */     // GIR_Coverage, 5935,
     /* 150022 */     GIR_EraseRootFromParent_Done,
     /* 150023 */   // Label 3260: @150023
     /* 150023 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(150060), // Rule ID 888 //
     /* 150028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150043 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 150043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 150048 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 150054 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 150058 */     GIR_RootConstrainSelectedInstOperands,
     /* 150059 */     // GIR_Coverage, 888,
     /* 150059 */     GIR_Done,
     /* 150060 */   // Label 3261: @150060
     /* 150060 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(150091), // Rule ID 2162 //
     /* 150065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 150068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150080 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 150080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 150085 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150089 */     GIR_RootConstrainSelectedInstOperands,
     /* 150090 */     // GIR_Coverage, 2162,
     /* 150090 */     GIR_Done,
     /* 150091 */   // Label 3262: @150091
     /* 150091 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(150122), // Rule ID 2170 //
     /* 150096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150111 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 150111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 150116 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150120 */     GIR_RootConstrainSelectedInstOperands,
     /* 150121 */     // GIR_Coverage, 2170,
     /* 150121 */     GIR_Done,
     /* 150122 */   // Label 3263: @150122
     /* 150122 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(150153), // Rule ID 5933 //
     /* 150127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 150130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150142 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 150142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 150147 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150151 */     GIR_RootConstrainSelectedInstOperands,
     /* 150152 */     // GIR_Coverage, 5933,
     /* 150152 */     GIR_Done,
     /* 150153 */   // Label 3264: @150153
     /* 150153 */   GIM_Reject,
     /* 150154 */ // Label 3244: @150154
     /* 150154 */ GIM_Reject,
     /* 150155 */ // Label 3210: @150155
     /* 150155 */ GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(150476),
     /* 150160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 150163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 150166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150170 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(150238), // Rule ID 23240 //
     /* 150175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150189 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150193 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150200 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150217 */     // (fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 150220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150222 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150224 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150236 */     GIR_RootConstrainSelectedInstOperands,
     /* 150237 */     // GIR_Coverage, 23240,
     /* 150237 */     GIR_EraseRootFromParent_Done,
     /* 150238 */   // Label 3266: @150238
     /* 150238 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(150306), // Rule ID 23242 //
     /* 150243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150254 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150257 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150261 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 150268 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150285 */     // (fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 150288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150304 */     GIR_RootConstrainSelectedInstOperands,
     /* 150305 */     // GIR_Coverage, 23242,
     /* 150305 */     GIR_EraseRootFromParent_Done,
     /* 150306 */   // Label 3267: @150306
     /* 150306 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(150374), // Rule ID 916 //
     /* 150311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150326 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150329 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150333 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150340 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150353 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 150356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150372 */     GIR_RootConstrainSelectedInstOperands,
     /* 150373 */     // GIR_Coverage, 916,
     /* 150373 */     GIR_EraseRootFromParent_Done,
     /* 150374 */   // Label 3268: @150374
     /* 150374 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(150442), // Rule ID 918 //
     /* 150379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150394 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150397 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150401 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 150408 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150421 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 150424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150426 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150428 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150440 */     GIR_RootConstrainSelectedInstOperands,
     /* 150441 */     // GIR_Coverage, 918,
     /* 150441 */     GIR_EraseRootFromParent_Done,
     /* 150442 */   // Label 3269: @150442
     /* 150442 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(150475), // Rule ID 890 //
     /* 150447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150458 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 150458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 150463 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 150469 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 150473 */     GIR_RootConstrainSelectedInstOperands,
     /* 150474 */     // GIR_Coverage, 890,
     /* 150474 */     GIR_Done,
     /* 150475 */   // Label 3270: @150475
     /* 150475 */   GIM_Reject,
     /* 150476 */ // Label 3265: @150476
     /* 150476 */ GIM_Reject,
     /* 150477 */ // Label 3211: @150477
     /* 150477 */ GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(150830),
     /* 150482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 150485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150488 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(150550), // Rule ID 23369 //
     /* 150493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150532 */     // (fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 150535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150548 */     GIR_RootConstrainSelectedInstOperands,
     /* 150549 */     // GIR_Coverage, 23369,
     /* 150549 */     GIR_EraseRootFromParent_Done,
     /* 150550 */   // Label 3272: @150550
     /* 150550 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(150612), // Rule ID 24293 //
     /* 150555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150594 */     // (fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 150597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150599 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150610 */     GIR_RootConstrainSelectedInstOperands,
     /* 150611 */     // GIR_Coverage, 24293,
     /* 150611 */     GIR_EraseRootFromParent_Done,
     /* 150612 */   // Label 3273: @150612
     /* 150612 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(150674), // Rule ID 2140 //
     /* 150617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150656 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 150659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150672 */     GIR_RootConstrainSelectedInstOperands,
     /* 150673 */     // GIR_Coverage, 2140,
     /* 150673 */     GIR_EraseRootFromParent_Done,
     /* 150674 */   // Label 3274: @150674
     /* 150674 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(150736), // Rule ID 6308 //
     /* 150679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150698 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150701 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150705 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150718 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 150721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150723 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150734 */     GIR_RootConstrainSelectedInstOperands,
     /* 150735 */     // GIR_Coverage, 6308,
     /* 150735 */     GIR_EraseRootFromParent_Done,
     /* 150736 */   // Label 3275: @150736
     /* 150736 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(150767), // Rule ID 2138 //
     /* 150741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150756 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 150756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 150761 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150765 */     GIR_RootConstrainSelectedInstOperands,
     /* 150766 */     // GIR_Coverage, 2138,
     /* 150766 */     GIR_Done,
     /* 150767 */   // Label 3276: @150767
     /* 150767 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(150798), // Rule ID 2154 //
     /* 150772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150787 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 150787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 150792 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150796 */     GIR_RootConstrainSelectedInstOperands,
     /* 150797 */     // GIR_Coverage, 2154,
     /* 150797 */     GIR_Done,
     /* 150798 */   // Label 3277: @150798
     /* 150798 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(150829), // Rule ID 6304 //
     /* 150803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150818 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 150818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 150823 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150827 */     GIR_RootConstrainSelectedInstOperands,
     /* 150828 */     // GIR_Coverage, 6304,
     /* 150828 */     GIR_Done,
     /* 150829 */   // Label 3278: @150829
     /* 150829 */   GIM_Reject,
     /* 150830 */ // Label 3271: @150830
     /* 150830 */ GIM_Reject,
     /* 150831 */ // Label 3212: @150831
     /* 150831 */ GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(151184),
     /* 150836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150842 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(150904), // Rule ID 23367 //
     /* 150847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150862 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150865 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150869 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150886 */     // (fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 150889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150891 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150902 */     GIR_RootConstrainSelectedInstOperands,
     /* 150903 */     // GIR_Coverage, 23367,
     /* 150903 */     GIR_EraseRootFromParent_Done,
     /* 150904 */   // Label 3280: @150904
     /* 150904 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(150966), // Rule ID 24277 //
     /* 150909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150924 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150927 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150931 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150948 */     // (fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 150951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150964 */     GIR_RootConstrainSelectedInstOperands,
     /* 150965 */     // GIR_Coverage, 24277,
     /* 150965 */     GIR_EraseRootFromParent_Done,
     /* 150966 */   // Label 3281: @150966
     /* 150966 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(151028), // Rule ID 2136 //
     /* 150971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150990 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150997 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151010 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 151013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151015 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151026 */     GIR_RootConstrainSelectedInstOperands,
     /* 151027 */     // GIR_Coverage, 2136,
     /* 151027 */     GIR_EraseRootFromParent_Done,
     /* 151028 */   // Label 3282: @151028
     /* 151028 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(151090), // Rule ID 6284 //
     /* 151033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151052 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151059 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151072 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 151075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151077 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151079 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151088 */     GIR_RootConstrainSelectedInstOperands,
     /* 151089 */     // GIR_Coverage, 6284,
     /* 151089 */     GIR_EraseRootFromParent_Done,
     /* 151090 */   // Label 3283: @151090
     /* 151090 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(151121), // Rule ID 2134 //
     /* 151095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151110 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 151110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 151115 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151119 */     GIR_RootConstrainSelectedInstOperands,
     /* 151120 */     // GIR_Coverage, 2134,
     /* 151120 */     GIR_Done,
     /* 151121 */   // Label 3284: @151121
     /* 151121 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(151152), // Rule ID 2150 //
     /* 151126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 151129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151141 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 151141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 151146 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151150 */     GIR_RootConstrainSelectedInstOperands,
     /* 151151 */     // GIR_Coverage, 2150,
     /* 151151 */     GIR_Done,
     /* 151152 */   // Label 3285: @151152
     /* 151152 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(151183), // Rule ID 6280 //
     /* 151157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151172 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 151172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 151177 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151181 */     GIR_RootConstrainSelectedInstOperands,
     /* 151182 */     // GIR_Coverage, 6280,
     /* 151182 */     GIR_Done,
     /* 151183 */   // Label 3286: @151183
     /* 151183 */   GIM_Reject,
     /* 151184 */ // Label 3279: @151184
     /* 151184 */ GIM_Reject,
     /* 151185 */ // Label 3213: @151185
     /* 151185 */ GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(151507),
     /* 151190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 151193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 151196 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(151258), // Rule ID 23373 //
     /* 151201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151216 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151223 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151240 */     // (fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 151243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151245 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151247 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151256 */     GIR_RootConstrainSelectedInstOperands,
     /* 151257 */     // GIR_Coverage, 23373,
     /* 151257 */     GIR_EraseRootFromParent_Done,
     /* 151258 */   // Label 3288: @151258
     /* 151258 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(151320), // Rule ID 24301 //
     /* 151263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151278 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151285 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151302 */     // (fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 151305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151307 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151309 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151318 */     GIR_RootConstrainSelectedInstOperands,
     /* 151319 */     // GIR_Coverage, 24301,
     /* 151319 */     GIR_EraseRootFromParent_Done,
     /* 151320 */   // Label 3289: @151320
     /* 151320 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(151382), // Rule ID 2148 //
     /* 151325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151344 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151347 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151351 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151364 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 151367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151369 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151371 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151380 */     GIR_RootConstrainSelectedInstOperands,
     /* 151381 */     // GIR_Coverage, 2148,
     /* 151381 */     GIR_EraseRootFromParent_Done,
     /* 151382 */   // Label 3290: @151382
     /* 151382 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(151444), // Rule ID 6320 //
     /* 151387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151406 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151409 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151413 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151426 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 151429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151431 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151433 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151442 */     GIR_RootConstrainSelectedInstOperands,
     /* 151443 */     // GIR_Coverage, 6320,
     /* 151443 */     GIR_EraseRootFromParent_Done,
     /* 151444 */   // Label 3291: @151444
     /* 151444 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(151475), // Rule ID 2146 //
     /* 151449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151464 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 151464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 151469 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151473 */     GIR_RootConstrainSelectedInstOperands,
     /* 151474 */     // GIR_Coverage, 2146,
     /* 151474 */     GIR_Done,
     /* 151475 */   // Label 3292: @151475
     /* 151475 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(151506), // Rule ID 6316 //
     /* 151480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151495 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 151495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 151500 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151504 */     GIR_RootConstrainSelectedInstOperands,
     /* 151505 */     // GIR_Coverage, 6316,
     /* 151505 */     GIR_Done,
     /* 151506 */   // Label 3293: @151506
     /* 151506 */   GIM_Reject,
     /* 151507 */ // Label 3287: @151507
     /* 151507 */ GIM_Reject,
     /* 151508 */ // Label 3214: @151508
     /* 151508 */ GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(151667),
     /* 151513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 151519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151523 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(151581), // Rule ID 24317 //
     /* 151528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 151531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151539 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151542 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151546 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151563 */     // (fadd:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 151566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151568 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151579 */     GIR_RootConstrainSelectedInstOperands,
     /* 151580 */     // GIR_Coverage, 24317,
     /* 151580 */     GIR_EraseRootFromParent_Done,
     /* 151581 */   // Label 3295: @151581
     /* 151581 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(151639), // Rule ID 6344 //
     /* 151586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 151589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151601 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151604 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151608 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151621 */     // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 151624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151626 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151628 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151637 */     GIR_RootConstrainSelectedInstOperands,
     /* 151638 */     // GIR_Coverage, 6344,
     /* 151638 */     GIR_EraseRootFromParent_Done,
     /* 151639 */   // Label 3296: @151639
     /* 151639 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(151666), // Rule ID 6340 //
     /* 151644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 151647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151655 */     // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 151655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 151660 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151664 */     GIR_RootConstrainSelectedInstOperands,
     /* 151665 */     // GIR_Coverage, 6340,
     /* 151665 */     GIR_Done,
     /* 151666 */   // Label 3297: @151666
     /* 151666 */   GIM_Reject,
     /* 151667 */ // Label 3294: @151667
     /* 151667 */ GIM_Reject,
     /* 151668 */ // Label 3215: @151668
     /* 151668 */ GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(151990),
     /* 151673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 151676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 151679 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(151741), // Rule ID 23371 //
     /* 151684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151699 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151702 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151706 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151723 */     // (fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 151726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151728 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151730 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151739 */     GIR_RootConstrainSelectedInstOperands,
     /* 151740 */     // GIR_Coverage, 23371,
     /* 151740 */     GIR_EraseRootFromParent_Done,
     /* 151741 */   // Label 3299: @151741
     /* 151741 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(151803), // Rule ID 24285 //
     /* 151746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151785 */     // (fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 151788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151790 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151801 */     GIR_RootConstrainSelectedInstOperands,
     /* 151802 */     // GIR_Coverage, 24285,
     /* 151802 */     GIR_EraseRootFromParent_Done,
     /* 151803 */   // Label 3300: @151803
     /* 151803 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(151865), // Rule ID 2144 //
     /* 151808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151827 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151830 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151834 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151847 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 151850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151852 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151863 */     GIR_RootConstrainSelectedInstOperands,
     /* 151864 */     // GIR_Coverage, 2144,
     /* 151864 */     GIR_EraseRootFromParent_Done,
     /* 151865 */   // Label 3301: @151865
     /* 151865 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(151927), // Rule ID 6296 //
     /* 151870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151889 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151892 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151896 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151909 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 151912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151914 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151916 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151925 */     GIR_RootConstrainSelectedInstOperands,
     /* 151926 */     // GIR_Coverage, 6296,
     /* 151926 */     GIR_EraseRootFromParent_Done,
     /* 151927 */   // Label 3302: @151927
     /* 151927 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(151958), // Rule ID 2142 //
     /* 151932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151947 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 151947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 151952 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151956 */     GIR_RootConstrainSelectedInstOperands,
     /* 151957 */     // GIR_Coverage, 2142,
     /* 151957 */     GIR_Done,
     /* 151958 */   // Label 3303: @151958
     /* 151958 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(151989), // Rule ID 6292 //
     /* 151963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151978 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 151978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 151983 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151987 */     GIR_RootConstrainSelectedInstOperands,
     /* 151988 */     // GIR_Coverage, 6292,
     /* 151988 */     GIR_Done,
     /* 151989 */   // Label 3304: @151989
     /* 151989 */   GIM_Reject,
     /* 151990 */ // Label 3298: @151990
     /* 151990 */ GIM_Reject,
     /* 151991 */ // Label 3216: @151991
     /* 151991 */ GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(152150),
     /* 151996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 151999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 152002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152006 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(152064), // Rule ID 24269 //
     /* 152011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152022 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152025 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152029 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152046 */     // (fadd:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 152049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152051 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152062 */     GIR_RootConstrainSelectedInstOperands,
     /* 152063 */     // GIR_Coverage, 24269,
     /* 152063 */     GIR_EraseRootFromParent_Done,
     /* 152064 */   // Label 3306: @152064
     /* 152064 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(152122), // Rule ID 6272 //
     /* 152069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152084 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152087 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152091 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152104 */     // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 152107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152109 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152111 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152120 */     GIR_RootConstrainSelectedInstOperands,
     /* 152121 */     // GIR_Coverage, 6272,
     /* 152121 */     GIR_EraseRootFromParent_Done,
     /* 152122 */   // Label 3307: @152122
     /* 152122 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(152149), // Rule ID 6268 //
     /* 152127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152138 */     // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 152138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 152143 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152147 */     GIR_RootConstrainSelectedInstOperands,
     /* 152148 */     // GIR_Coverage, 6268,
     /* 152148 */     GIR_Done,
     /* 152149 */   // Label 3308: @152149
     /* 152149 */   GIM_Reject,
     /* 152150 */ // Label 3305: @152150
     /* 152150 */ GIM_Reject,
     /* 152151 */ // Label 3217: @152151
     /* 152151 */ GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(152310),
     /* 152156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 152159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 152162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152166 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(152224), // Rule ID 24325 //
     /* 152171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152206 */     // (fadd:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 152209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152211 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152213 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152222 */     GIR_RootConstrainSelectedInstOperands,
     /* 152223 */     // GIR_Coverage, 24325,
     /* 152223 */     GIR_EraseRootFromParent_Done,
     /* 152224 */   // Label 3310: @152224
     /* 152224 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(152282), // Rule ID 6356 //
     /* 152229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152244 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152247 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152251 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152264 */     // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 152267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152269 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152280 */     GIR_RootConstrainSelectedInstOperands,
     /* 152281 */     // GIR_Coverage, 6356,
     /* 152281 */     GIR_EraseRootFromParent_Done,
     /* 152282 */   // Label 3311: @152282
     /* 152282 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(152309), // Rule ID 6352 //
     /* 152287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152298 */     // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 152298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 152303 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152307 */     GIR_RootConstrainSelectedInstOperands,
     /* 152308 */     // GIR_Coverage, 6352,
     /* 152308 */     GIR_Done,
     /* 152309 */   // Label 3312: @152309
     /* 152309 */   GIM_Reject,
     /* 152310 */ // Label 3309: @152310
     /* 152310 */ GIM_Reject,
     /* 152311 */ // Label 3218: @152311
     /* 152311 */ GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(152470),
     /* 152316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 152319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 152322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152326 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(152384), // Rule ID 24261 //
     /* 152331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152342 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152345 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152349 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152366 */     // (fadd:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 152369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152371 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152373 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152382 */     GIR_RootConstrainSelectedInstOperands,
     /* 152383 */     // GIR_Coverage, 24261,
     /* 152383 */     GIR_EraseRootFromParent_Done,
     /* 152384 */   // Label 3314: @152384
     /* 152384 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(152442), // Rule ID 6260 //
     /* 152389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152404 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152411 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152424 */     // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 152427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152429 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152431 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152440 */     GIR_RootConstrainSelectedInstOperands,
     /* 152441 */     // GIR_Coverage, 6260,
     /* 152441 */     GIR_EraseRootFromParent_Done,
     /* 152442 */   // Label 3315: @152442
     /* 152442 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(152469), // Rule ID 6256 //
     /* 152447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152458 */     // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 152458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 152463 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152467 */     GIR_RootConstrainSelectedInstOperands,
     /* 152468 */     // GIR_Coverage, 6256,
     /* 152468 */     GIR_Done,
     /* 152469 */   // Label 3316: @152469
     /* 152469 */   GIM_Reject,
     /* 152470 */ // Label 3313: @152470
     /* 152470 */ GIM_Reject,
     /* 152471 */ // Label 3219: @152471
     /* 152471 */ GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(152630),
     /* 152476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 152479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 152482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152486 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(152544), // Rule ID 24309 //
     /* 152491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152502 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152505 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152509 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152526 */     // (fadd:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 152529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152531 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152542 */     GIR_RootConstrainSelectedInstOperands,
     /* 152543 */     // GIR_Coverage, 24309,
     /* 152543 */     GIR_EraseRootFromParent_Done,
     /* 152544 */   // Label 3318: @152544
     /* 152544 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(152602), // Rule ID 6332 //
     /* 152549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152564 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152567 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152584 */     // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 152587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152589 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152591 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152600 */     GIR_RootConstrainSelectedInstOperands,
     /* 152601 */     // GIR_Coverage, 6332,
     /* 152601 */     GIR_EraseRootFromParent_Done,
     /* 152602 */   // Label 3319: @152602
     /* 152602 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(152629), // Rule ID 6328 //
     /* 152607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152618 */     // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 152618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 152623 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152627 */     GIR_RootConstrainSelectedInstOperands,
     /* 152628 */     // GIR_Coverage, 6328,
     /* 152628 */     GIR_Done,
     /* 152629 */   // Label 3320: @152629
     /* 152629 */   GIM_Reject,
     /* 152630 */ // Label 3317: @152630
     /* 152630 */ GIM_Reject,
     /* 152631 */ // Label 3220: @152631
     /* 152631 */ GIM_Reject,
     /* 152632 */ // Label 42: @152632
     /* 152632 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3334*/ GIMT_Encode4(156049),
     /* 152643 */ /*GILLT_s16*//*Label 3321*/ GIMT_Encode4(152727),
     /* 152647 */ /*GILLT_s32*//*Label 3322*/ GIMT_Encode4(152825),
     /* 152651 */ /*GILLT_s64*//*Label 3323*/ GIMT_Encode4(153530),
     /* 152655 */ /*GILLT_s80*//*Label 3324*/ GIMT_Encode4(154379), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 152667 */ /*GILLT_v2s64*//*Label 3325*/ GIMT_Encode4(154701), GIMT_Encode4(0),
     /* 152675 */ /*GILLT_v4s32*//*Label 3326*/ GIMT_Encode4(154931),
     /* 152679 */ /*GILLT_v4s64*//*Label 3327*/ GIMT_Encode4(155161), GIMT_Encode4(0),
     /* 152687 */ /*GILLT_v8s16*//*Label 3328*/ GIMT_Encode4(155360),
     /* 152691 */ /*GILLT_v8s32*//*Label 3329*/ GIMT_Encode4(155458),
     /* 152695 */ /*GILLT_v8s64*//*Label 3330*/ GIMT_Encode4(155657), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 152707 */ /*GILLT_v16s16*//*Label 3331*/ GIMT_Encode4(155755),
     /* 152711 */ /*GILLT_v16s32*//*Label 3332*/ GIMT_Encode4(155853), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 152723 */ /*GILLT_v32s16*//*Label 3333*/ GIMT_Encode4(155951),
     /* 152727 */ // Label 3321: @152727
     /* 152727 */ GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(152824),
     /* 152732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 152735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 152738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 152742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 152746 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(152800), // Rule ID 6068 //
     /* 152751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152762 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152765 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152769 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152782 */     // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrm),
     /* 152785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152787 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152789 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152798 */     GIR_RootConstrainSelectedInstOperands,
     /* 152799 */     // GIR_Coverage, 6068,
     /* 152799 */     GIR_EraseRootFromParent_Done,
     /* 152800 */   // Label 3336: @152800
     /* 152800 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(152823), // Rule ID 6066 //
     /* 152805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 152812 */     // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 152812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 152817 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152821 */     GIR_RootConstrainSelectedInstOperands,
     /* 152822 */     // GIR_Coverage, 6066,
     /* 152822 */     GIR_Done,
     /* 152823 */   // Label 3337: @152823
     /* 152823 */   GIM_Reject,
     /* 152824 */ // Label 3335: @152824
     /* 152824 */ GIM_Reject,
     /* 152825 */ // Label 3322: @152825
     /* 152825 */ GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(153529),
     /* 152830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152836 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(152918), // Rule ID 22472 //
     /* 152841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 152844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 152860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 152864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152872 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152875 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 152879 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152886 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 152890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 152892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152899 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 152902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152904 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152906 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 152916 */     GIR_RootConstrainSelectedInstOperands,
     /* 152917 */     // GIR_Coverage, 22472,
     /* 152917 */     GIR_EraseRootFromParent_Done,
     /* 152918 */   // Label 3339: @152918
     /* 152918 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(153000), // Rule ID 22473 //
     /* 152923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 152926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 152942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 152946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152954 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 152961 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152968 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 152972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 152974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152981 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 152984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152986 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152988 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 152998 */     GIR_RootConstrainSelectedInstOperands,
     /* 152999 */     // GIR_Coverage, 22473,
     /* 152999 */     GIR_EraseRootFromParent_Done,
     /* 153000 */   // Label 3340: @153000
     /* 153000 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(153082), // Rule ID 22474 //
     /* 153005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 153028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153036 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153043 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153050 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153063 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 153066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153068 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153070 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153080 */     GIR_RootConstrainSelectedInstOperands,
     /* 153081 */     // GIR_Coverage, 22474,
     /* 153081 */     GIR_EraseRootFromParent_Done,
     /* 153082 */   // Label 3341: @153082
     /* 153082 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(153147), // Rule ID 954 //
     /* 153087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 153090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153102 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153105 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153109 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153126 */     // (fsub:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp32m),
     /* 153129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153131 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153133 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153145 */     GIR_RootConstrainSelectedInstOperands,
     /* 153146 */     // GIR_Coverage, 954,
     /* 153146 */     GIR_EraseRootFromParent_Done,
     /* 153147 */   // Label 3342: @153147
     /* 153147 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(153212), // Rule ID 932 //
     /* 153152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 153155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153171 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153178 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153191 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32m),
     /* 153194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153196 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153210 */     GIR_RootConstrainSelectedInstOperands,
     /* 153211 */     // GIR_Coverage, 932,
     /* 153211 */     GIR_EraseRootFromParent_Done,
     /* 153212 */   // Label 3343: @153212
     /* 153212 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(153274), // Rule ID 2240 //
     /* 153217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 153220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153236 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153239 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153243 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153256 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 153259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153261 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153263 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153272 */     GIR_RootConstrainSelectedInstOperands,
     /* 153273 */     // GIR_Coverage, 2240,
     /* 153273 */     GIR_EraseRootFromParent_Done,
     /* 153274 */   // Label 3344: @153274
     /* 153274 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(153336), // Rule ID 2248 //
     /* 153279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 153282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153298 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153305 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153318 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 153321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153323 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153325 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153334 */     GIR_RootConstrainSelectedInstOperands,
     /* 153335 */     // GIR_Coverage, 2248,
     /* 153335 */     GIR_EraseRootFromParent_Done,
     /* 153336 */   // Label 3345: @153336
     /* 153336 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(153398), // Rule ID 6030 //
     /* 153341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153360 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153367 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153380 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 153383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153385 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153387 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153396 */     GIR_RootConstrainSelectedInstOperands,
     /* 153397 */     // GIR_Coverage, 6030,
     /* 153397 */     GIR_EraseRootFromParent_Done,
     /* 153398 */   // Label 3346: @153398
     /* 153398 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(153435), // Rule ID 892 //
     /* 153403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 153406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 153418 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 153418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 153423 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 153429 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 153433 */     GIR_RootConstrainSelectedInstOperands,
     /* 153434 */     // GIR_Coverage, 892,
     /* 153434 */     GIR_Done,
     /* 153435 */   // Label 3347: @153435
     /* 153435 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(153466), // Rule ID 2238 //
     /* 153440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 153443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153455 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 153455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 153460 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153464 */     GIR_RootConstrainSelectedInstOperands,
     /* 153465 */     // GIR_Coverage, 2238,
     /* 153465 */     GIR_Done,
     /* 153466 */   // Label 3348: @153466
     /* 153466 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(153497), // Rule ID 2246 //
     /* 153471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 153474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153486 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 153486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 153491 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153495 */     GIR_RootConstrainSelectedInstOperands,
     /* 153496 */     // GIR_Coverage, 2246,
     /* 153496 */     GIR_Done,
     /* 153497 */   // Label 3349: @153497
     /* 153497 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(153528), // Rule ID 6028 //
     /* 153502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153517 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 153517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 153522 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153526 */     GIR_RootConstrainSelectedInstOperands,
     /* 153527 */     // GIR_Coverage, 6028,
     /* 153527 */     GIR_Done,
     /* 153528 */   // Label 3350: @153528
     /* 153528 */   GIM_Reject,
     /* 153529 */ // Label 3338: @153529
     /* 153529 */ GIM_Reject,
     /* 153530 */ // Label 3323: @153530
     /* 153530 */ GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(154378),
     /* 153535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 153538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153541 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(153623), // Rule ID 22475 //
     /* 153546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 153549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 153569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153577 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153580 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153584 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153591 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153604 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 153607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153609 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153621 */     GIR_RootConstrainSelectedInstOperands,
     /* 153622 */     // GIR_Coverage, 22475,
     /* 153622 */     GIR_EraseRootFromParent_Done,
     /* 153623 */   // Label 3352: @153623
     /* 153623 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(153705), // Rule ID 22476 //
     /* 153628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 153631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 153651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153659 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153662 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153666 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153673 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153686 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 153689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153691 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153693 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153703 */     GIR_RootConstrainSelectedInstOperands,
     /* 153704 */     // GIR_Coverage, 22476,
     /* 153704 */     GIR_EraseRootFromParent_Done,
     /* 153705 */   // Label 3353: @153705
     /* 153705 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(153787), // Rule ID 22477 //
     /* 153710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 153717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 153721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 153733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153741 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153744 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153748 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153755 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153768 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 153771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153773 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153775 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153785 */     GIR_RootConstrainSelectedInstOperands,
     /* 153786 */     // GIR_Coverage, 22477,
     /* 153786 */     GIR_EraseRootFromParent_Done,
     /* 153787 */   // Label 3354: @153787
     /* 153787 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(153852), // Rule ID 956 //
     /* 153792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 153795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153807 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153814 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153831 */     // (fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m),
     /* 153834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153836 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153838 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153850 */     GIR_RootConstrainSelectedInstOperands,
     /* 153851 */     // GIR_Coverage, 956,
     /* 153851 */     GIR_EraseRootFromParent_Done,
     /* 153852 */   // Label 3355: @153852
     /* 153852 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(153924), // Rule ID 958 //
     /* 153857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 153860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153872 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153875 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153879 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153903 */     // (fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m32),
     /* 153906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153908 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153922 */     GIR_RootConstrainSelectedInstOperands,
     /* 153923 */     // GIR_Coverage, 958,
     /* 153923 */     GIR_EraseRootFromParent_Done,
     /* 153924 */   // Label 3356: @153924
     /* 153924 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(153989), // Rule ID 934 //
     /* 153929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 153932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153968 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m),
     /* 153971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153973 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153987 */     GIR_RootConstrainSelectedInstOperands,
     /* 153988 */     // GIR_Coverage, 934,
     /* 153988 */     GIR_EraseRootFromParent_Done,
     /* 153989 */   // Label 3357: @153989
     /* 153989 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(154061), // Rule ID 936 //
     /* 153994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 153997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 154001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 154005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154013 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154016 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154020 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154027 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154040 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m32),
     /* 154043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154045 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154047 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154059 */     GIR_RootConstrainSelectedInstOperands,
     /* 154060 */     // GIR_Coverage, 936,
     /* 154060 */     GIR_EraseRootFromParent_Done,
     /* 154061 */   // Label 3358: @154061
     /* 154061 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(154123), // Rule ID 2244 //
     /* 154066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154085 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154092 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154105 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 154108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154110 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154112 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154121 */     GIR_RootConstrainSelectedInstOperands,
     /* 154122 */     // GIR_Coverage, 2244,
     /* 154122 */     GIR_EraseRootFromParent_Done,
     /* 154123 */   // Label 3359: @154123
     /* 154123 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(154185), // Rule ID 2252 //
     /* 154128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 154131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154147 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154150 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154154 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154167 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 154170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154172 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154183 */     GIR_RootConstrainSelectedInstOperands,
     /* 154184 */     // GIR_Coverage, 2252,
     /* 154184 */     GIR_EraseRootFromParent_Done,
     /* 154185 */   // Label 3360: @154185
     /* 154185 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(154247), // Rule ID 6049 //
     /* 154190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154209 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154216 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154229 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 154232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154234 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154236 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154245 */     GIR_RootConstrainSelectedInstOperands,
     /* 154246 */     // GIR_Coverage, 6049,
     /* 154246 */     GIR_EraseRootFromParent_Done,
     /* 154247 */   // Label 3361: @154247
     /* 154247 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(154284), // Rule ID 894 //
     /* 154252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 154255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 154259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 154263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 154267 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 154267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 154272 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 154278 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 154282 */     GIR_RootConstrainSelectedInstOperands,
     /* 154283 */     // GIR_Coverage, 894,
     /* 154283 */     GIR_Done,
     /* 154284 */   // Label 3362: @154284
     /* 154284 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(154315), // Rule ID 2242 //
     /* 154289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154304 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 154304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 154309 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154313 */     GIR_RootConstrainSelectedInstOperands,
     /* 154314 */     // GIR_Coverage, 2242,
     /* 154314 */     GIR_Done,
     /* 154315 */   // Label 3363: @154315
     /* 154315 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(154346), // Rule ID 2250 //
     /* 154320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 154323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154335 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 154335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 154340 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154344 */     GIR_RootConstrainSelectedInstOperands,
     /* 154345 */     // GIR_Coverage, 2250,
     /* 154345 */     GIR_Done,
     /* 154346 */   // Label 3364: @154346
     /* 154346 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(154377), // Rule ID 6047 //
     /* 154351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154366 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 154366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 154371 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154375 */     GIR_RootConstrainSelectedInstOperands,
     /* 154376 */     // GIR_Coverage, 6047,
     /* 154376 */     GIR_Done,
     /* 154377 */   // Label 3365: @154377
     /* 154377 */   GIM_Reject,
     /* 154378 */ // Label 3351: @154378
     /* 154378 */ GIM_Reject,
     /* 154379 */ // Label 3324: @154379
     /* 154379 */ GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(154700),
     /* 154384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 154387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 154390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154394 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(154462), // Rule ID 960 //
     /* 154399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 154402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154410 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154413 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154417 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154424 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154441 */     // (fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m32),
     /* 154444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154446 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154448 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154460 */     GIR_RootConstrainSelectedInstOperands,
     /* 154461 */     // GIR_Coverage, 960,
     /* 154461 */     GIR_EraseRootFromParent_Done,
     /* 154462 */   // Label 3367: @154462
     /* 154462 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(154530), // Rule ID 962 //
     /* 154467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 154470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154478 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154481 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154485 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154492 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154509 */     // (fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m64),
     /* 154512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154514 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154528 */     GIR_RootConstrainSelectedInstOperands,
     /* 154529 */     // GIR_Coverage, 962,
     /* 154529 */     GIR_EraseRootFromParent_Done,
     /* 154530 */   // Label 3368: @154530
     /* 154530 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(154598), // Rule ID 938 //
     /* 154535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 154538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154550 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154553 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154557 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154564 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154577 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m32),
     /* 154580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154582 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154584 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154596 */     GIR_RootConstrainSelectedInstOperands,
     /* 154597 */     // GIR_Coverage, 938,
     /* 154597 */     GIR_EraseRootFromParent_Done,
     /* 154598 */   // Label 3369: @154598
     /* 154598 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(154666), // Rule ID 940 //
     /* 154603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 154606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154618 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154621 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154625 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154632 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154645 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (SUB_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m64),
     /* 154648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154650 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154652 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154664 */     GIR_RootConstrainSelectedInstOperands,
     /* 154665 */     // GIR_Coverage, 940,
     /* 154665 */     GIR_EraseRootFromParent_Done,
     /* 154666 */   // Label 3370: @154666
     /* 154666 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(154699), // Rule ID 896 //
     /* 154671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 154674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154682 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 154682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 154687 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 154693 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 154697 */     GIR_RootConstrainSelectedInstOperands,
     /* 154698 */     // GIR_Coverage, 896,
     /* 154698 */     GIR_Done,
     /* 154699 */   // Label 3371: @154699
     /* 154699 */   GIM_Reject,
     /* 154700 */ // Label 3366: @154700
     /* 154700 */ GIM_Reject,
     /* 154701 */ // Label 3325: @154701
     /* 154701 */ GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(154930),
     /* 154706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 154709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154712 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(154774), // Rule ID 2220 //
     /* 154717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154736 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154739 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154743 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154756 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDrm),
     /* 154759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154761 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154772 */     GIR_RootConstrainSelectedInstOperands,
     /* 154773 */     // GIR_Coverage, 2220,
     /* 154773 */     GIR_EraseRootFromParent_Done,
     /* 154774 */   // Label 3373: @154774
     /* 154774 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(154836), // Rule ID 6542 //
     /* 154779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 154782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154798 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154818 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rm),
     /* 154821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154834 */     GIR_RootConstrainSelectedInstOperands,
     /* 154835 */     // GIR_Coverage, 6542,
     /* 154835 */     GIR_EraseRootFromParent_Done,
     /* 154836 */   // Label 3374: @154836
     /* 154836 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(154867), // Rule ID 2218 //
     /* 154841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154856 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 154856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 154861 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154865 */     GIR_RootConstrainSelectedInstOperands,
     /* 154866 */     // GIR_Coverage, 2218,
     /* 154866 */     GIR_Done,
     /* 154867 */   // Label 3375: @154867
     /* 154867 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(154898), // Rule ID 2234 //
     /* 154872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 154875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154887 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 154887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 154892 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154896 */     GIR_RootConstrainSelectedInstOperands,
     /* 154897 */     // GIR_Coverage, 2234,
     /* 154897 */     GIR_Done,
     /* 154898 */   // Label 3376: @154898
     /* 154898 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(154929), // Rule ID 6538 //
     /* 154903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 154906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154918 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 154918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 154923 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154927 */     GIR_RootConstrainSelectedInstOperands,
     /* 154928 */     // GIR_Coverage, 6538,
     /* 154928 */     GIR_Done,
     /* 154929 */   // Label 3377: @154929
     /* 154929 */   GIM_Reject,
     /* 154930 */ // Label 3372: @154930
     /* 154930 */ GIM_Reject,
     /* 154931 */ // Label 3326: @154931
     /* 154931 */ GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(155160),
     /* 154936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154942 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(155004), // Rule ID 2216 //
     /* 154947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154966 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154969 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154973 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154986 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSrm),
     /* 154989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154991 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154993 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155002 */     GIR_RootConstrainSelectedInstOperands,
     /* 155003 */     // GIR_Coverage, 2216,
     /* 155003 */     GIR_EraseRootFromParent_Done,
     /* 155004 */   // Label 3379: @155004
     /* 155004 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(155066), // Rule ID 6518 //
     /* 155009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155028 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155031 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155035 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155048 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rm),
     /* 155051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155053 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155055 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155064 */     GIR_RootConstrainSelectedInstOperands,
     /* 155065 */     // GIR_Coverage, 6518,
     /* 155065 */     GIR_EraseRootFromParent_Done,
     /* 155066 */   // Label 3380: @155066
     /* 155066 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(155097), // Rule ID 2214 //
     /* 155071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 155074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 155078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 155082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 155086 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 155086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 155091 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155095 */     GIR_RootConstrainSelectedInstOperands,
     /* 155096 */     // GIR_Coverage, 2214,
     /* 155096 */     GIR_Done,
     /* 155097 */   // Label 3381: @155097
     /* 155097 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(155128), // Rule ID 2230 //
     /* 155102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 155105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 155109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 155113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 155117 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 155117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 155122 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155126 */     GIR_RootConstrainSelectedInstOperands,
     /* 155127 */     // GIR_Coverage, 2230,
     /* 155127 */     GIR_Done,
     /* 155128 */   // Label 3382: @155128
     /* 155128 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(155159), // Rule ID 6514 //
     /* 155133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155148 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 155148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 155153 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155157 */     GIR_RootConstrainSelectedInstOperands,
     /* 155158 */     // GIR_Coverage, 6514,
     /* 155158 */     GIR_Done,
     /* 155159 */   // Label 3383: @155159
     /* 155159 */   GIM_Reject,
     /* 155160 */ // Label 3378: @155160
     /* 155160 */ GIM_Reject,
     /* 155161 */ // Label 3327: @155161
     /* 155161 */ GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(155359),
     /* 155166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 155169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 155172 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(155234), // Rule ID 2228 //
     /* 155177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 155180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155196 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155199 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155203 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155216 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrm),
     /* 155219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155221 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155232 */     GIR_RootConstrainSelectedInstOperands,
     /* 155233 */     // GIR_Coverage, 2228,
     /* 155233 */     GIR_EraseRootFromParent_Done,
     /* 155234 */   // Label 3385: @155234
     /* 155234 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(155296), // Rule ID 6554 //
     /* 155239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155258 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155261 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155265 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155278 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rm),
     /* 155281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155283 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155285 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155294 */     GIR_RootConstrainSelectedInstOperands,
     /* 155295 */     // GIR_Coverage, 6554,
     /* 155295 */     GIR_EraseRootFromParent_Done,
     /* 155296 */   // Label 3386: @155296
     /* 155296 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(155327), // Rule ID 2226 //
     /* 155301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 155304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155316 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 155316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 155321 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155325 */     GIR_RootConstrainSelectedInstOperands,
     /* 155326 */     // GIR_Coverage, 2226,
     /* 155326 */     GIR_Done,
     /* 155327 */   // Label 3387: @155327
     /* 155327 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(155358), // Rule ID 6550 //
     /* 155332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155347 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 155347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 155352 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155356 */     GIR_RootConstrainSelectedInstOperands,
     /* 155357 */     // GIR_Coverage, 6550,
     /* 155357 */     GIR_Done,
     /* 155358 */   // Label 3388: @155358
     /* 155358 */   GIM_Reject,
     /* 155359 */ // Label 3384: @155359
     /* 155359 */ GIM_Reject,
     /* 155360 */ // Label 3328: @155360
     /* 155360 */ GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(155457),
     /* 155365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 155371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155379 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(155433), // Rule ID 6578 //
     /* 155384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 155387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155395 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155415 */     // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rm),
     /* 155418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155431 */     GIR_RootConstrainSelectedInstOperands,
     /* 155432 */     // GIR_Coverage, 6578,
     /* 155432 */     GIR_EraseRootFromParent_Done,
     /* 155433 */   // Label 3390: @155433
     /* 155433 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(155456), // Rule ID 6574 //
     /* 155438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 155441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 155445 */     // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 155445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 155450 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155454 */     GIR_RootConstrainSelectedInstOperands,
     /* 155455 */     // GIR_Coverage, 6574,
     /* 155455 */     GIR_Done,
     /* 155456 */   // Label 3391: @155456
     /* 155456 */   GIM_Reject,
     /* 155457 */ // Label 3389: @155457
     /* 155457 */ GIM_Reject,
     /* 155458 */ // Label 3329: @155458
     /* 155458 */ GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(155656),
     /* 155463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 155466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 155469 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(155531), // Rule ID 2224 //
     /* 155474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 155477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155493 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155496 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155500 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155513 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrm),
     /* 155516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155520 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155529 */     GIR_RootConstrainSelectedInstOperands,
     /* 155530 */     // GIR_Coverage, 2224,
     /* 155530 */     GIR_EraseRootFromParent_Done,
     /* 155531 */   // Label 3393: @155531
     /* 155531 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(155593), // Rule ID 6530 //
     /* 155536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155555 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155558 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155562 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155568 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155575 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rm),
     /* 155578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155580 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155582 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155591 */     GIR_RootConstrainSelectedInstOperands,
     /* 155592 */     // GIR_Coverage, 6530,
     /* 155592 */     GIR_EraseRootFromParent_Done,
     /* 155593 */   // Label 3394: @155593
     /* 155593 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(155624), // Rule ID 2222 //
     /* 155598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 155601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155613 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 155613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 155618 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155622 */     GIR_RootConstrainSelectedInstOperands,
     /* 155623 */     // GIR_Coverage, 2222,
     /* 155623 */     GIR_Done,
     /* 155624 */   // Label 3395: @155624
     /* 155624 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(155655), // Rule ID 6526 //
     /* 155629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155644 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 155644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 155649 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155653 */     GIR_RootConstrainSelectedInstOperands,
     /* 155654 */     // GIR_Coverage, 6526,
     /* 155654 */     GIR_Done,
     /* 155655 */   // Label 3396: @155655
     /* 155655 */   GIM_Reject,
     /* 155656 */ // Label 3392: @155656
     /* 155656 */ GIM_Reject,
     /* 155657 */ // Label 3330: @155657
     /* 155657 */ GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(155754),
     /* 155662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 155665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 155668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155676 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(155730), // Rule ID 6506 //
     /* 155681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155692 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155695 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155699 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155712 */     // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrm),
     /* 155715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155717 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155719 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155728 */     GIR_RootConstrainSelectedInstOperands,
     /* 155729 */     // GIR_Coverage, 6506,
     /* 155729 */     GIR_EraseRootFromParent_Done,
     /* 155730 */   // Label 3398: @155730
     /* 155730 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(155753), // Rule ID 6502 //
     /* 155735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155742 */     // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 155742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 155747 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155751 */     GIR_RootConstrainSelectedInstOperands,
     /* 155752 */     // GIR_Coverage, 6502,
     /* 155752 */     GIR_Done,
     /* 155753 */   // Label 3399: @155753
     /* 155753 */   GIM_Reject,
     /* 155754 */ // Label 3397: @155754
     /* 155754 */ GIM_Reject,
     /* 155755 */ // Label 3331: @155755
     /* 155755 */ GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(155852),
     /* 155760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 155763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 155766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155774 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(155828), // Rule ID 6590 //
     /* 155779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 155782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155790 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155810 */     // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rm),
     /* 155813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155815 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155826 */     GIR_RootConstrainSelectedInstOperands,
     /* 155827 */     // GIR_Coverage, 6590,
     /* 155827 */     GIR_EraseRootFromParent_Done,
     /* 155828 */   // Label 3401: @155828
     /* 155828 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(155851), // Rule ID 6586 //
     /* 155833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 155836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155840 */     // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 155840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 155845 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155849 */     GIR_RootConstrainSelectedInstOperands,
     /* 155850 */     // GIR_Coverage, 6586,
     /* 155850 */     GIR_Done,
     /* 155851 */   // Label 3402: @155851
     /* 155851 */   GIM_Reject,
     /* 155852 */ // Label 3400: @155852
     /* 155852 */ GIM_Reject,
     /* 155853 */ // Label 3332: @155853
     /* 155853 */ GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(155950),
     /* 155858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 155861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 155864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155872 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(155926), // Rule ID 6494 //
     /* 155877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155908 */     // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrm),
     /* 155911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155913 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155924 */     GIR_RootConstrainSelectedInstOperands,
     /* 155925 */     // GIR_Coverage, 6494,
     /* 155925 */     GIR_EraseRootFromParent_Done,
     /* 155926 */   // Label 3404: @155926
     /* 155926 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(155949), // Rule ID 6490 //
     /* 155931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155938 */     // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 155938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 155943 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155947 */     GIR_RootConstrainSelectedInstOperands,
     /* 155948 */     // GIR_Coverage, 6490,
     /* 155948 */     GIR_Done,
     /* 155949 */   // Label 3405: @155949
     /* 155949 */   GIM_Reject,
     /* 155950 */ // Label 3403: @155950
     /* 155950 */ GIM_Reject,
     /* 155951 */ // Label 3333: @155951
     /* 155951 */ GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(156048),
     /* 155956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 155959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 155962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155970 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(156024), // Rule ID 6566 //
     /* 155975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 155978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155986 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155989 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155993 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156006 */     // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrm),
     /* 156009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156011 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156013 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156022 */     GIR_RootConstrainSelectedInstOperands,
     /* 156023 */     // GIR_Coverage, 6566,
     /* 156023 */     GIR_EraseRootFromParent_Done,
     /* 156024 */   // Label 3407: @156024
     /* 156024 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(156047), // Rule ID 6562 //
     /* 156029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 156032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 156036 */     // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 156036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 156041 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156045 */     GIR_RootConstrainSelectedInstOperands,
     /* 156046 */     // GIR_Coverage, 6562,
     /* 156046 */     GIR_Done,
     /* 156047 */   // Label 3408: @156047
     /* 156047 */   GIM_Reject,
     /* 156048 */ // Label 3406: @156048
     /* 156048 */ GIM_Reject,
     /* 156049 */ // Label 3334: @156049
     /* 156049 */ GIM_Reject,
     /* 156050 */ // Label 43: @156050
     /* 156050 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3422*/ GIMT_Encode4(161199),
     /* 156061 */ /*GILLT_s16*//*Label 3409*/ GIMT_Encode4(156145),
     /* 156065 */ /*GILLT_s32*//*Label 3410*/ GIMT_Encode4(156305),
     /* 156069 */ /*GILLT_s64*//*Label 3411*/ GIMT_Encode4(157442),
     /* 156073 */ /*GILLT_s80*//*Label 3412*/ GIMT_Encode4(158723), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 156085 */ /*GILLT_v2s64*//*Label 3413*/ GIMT_Encode4(159045), GIMT_Encode4(0),
     /* 156093 */ /*GILLT_v4s32*//*Label 3414*/ GIMT_Encode4(159399),
     /* 156097 */ /*GILLT_v4s64*//*Label 3415*/ GIMT_Encode4(159753), GIMT_Encode4(0),
     /* 156105 */ /*GILLT_v8s16*//*Label 3416*/ GIMT_Encode4(160076),
     /* 156109 */ /*GILLT_v8s32*//*Label 3417*/ GIMT_Encode4(160236),
     /* 156113 */ /*GILLT_v8s64*//*Label 3418*/ GIMT_Encode4(160559), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 156125 */ /*GILLT_v16s16*//*Label 3419*/ GIMT_Encode4(160719),
     /* 156129 */ /*GILLT_v16s32*//*Label 3420*/ GIMT_Encode4(160879), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 156141 */ /*GILLT_v32s16*//*Label 3421*/ GIMT_Encode4(161039),
     /* 156145 */ // Label 3409: @156145
     /* 156145 */ GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(156304),
     /* 156150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 156153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 156160 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(156218), // Rule ID 24253 //
     /* 156165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 156168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156176 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156183 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 156191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156200 */     // (fmul:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 156203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156205 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156216 */     GIR_RootConstrainSelectedInstOperands,
     /* 156217 */     // GIR_Coverage, 24253,
     /* 156217 */     GIR_EraseRootFromParent_Done,
     /* 156218 */   // Label 3424: @156218
     /* 156218 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(156276), // Rule ID 6011 //
     /* 156223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 156226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 156230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156238 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156245 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156258 */     // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 156261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156263 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156274 */     GIR_RootConstrainSelectedInstOperands,
     /* 156275 */     // GIR_Coverage, 6011,
     /* 156275 */     GIR_EraseRootFromParent_Done,
     /* 156276 */   // Label 3425: @156276
     /* 156276 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(156303), // Rule ID 6009 //
     /* 156281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 156284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 156288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 156292 */     // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 156292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 156297 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156301 */     GIR_RootConstrainSelectedInstOperands,
     /* 156302 */     // GIR_Coverage, 6009,
     /* 156302 */     GIR_Done,
     /* 156303 */   // Label 3426: @156303
     /* 156303 */   GIM_Reject,
     /* 156304 */ // Label 3423: @156304
     /* 156304 */ GIM_Reject,
     /* 156305 */ // Label 3410: @156305
     /* 156305 */ GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(157441),
     /* 156310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 156313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156316 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(156398), // Rule ID 26021 //
     /* 156321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156348 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 156355 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156362 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156379 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 156382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156384 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156386 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156396 */     GIR_RootConstrainSelectedInstOperands,
     /* 156397 */     // GIR_Coverage, 26021,
     /* 156397 */     GIR_EraseRootFromParent_Done,
     /* 156398 */   // Label 3428: @156398
     /* 156398 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(156480), // Rule ID 26022 //
     /* 156403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 156406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156430 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 156437 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156444 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156461 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 156464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156466 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156478 */     GIR_RootConstrainSelectedInstOperands,
     /* 156479 */     // GIR_Coverage, 26022,
     /* 156479 */     GIR_EraseRootFromParent_Done,
     /* 156480 */   // Label 3429: @156480
     /* 156480 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(156562), // Rule ID 26023 //
     /* 156485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 156488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156512 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 156519 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156526 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156543 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 156546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156548 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156550 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156560 */     GIR_RootConstrainSelectedInstOperands,
     /* 156561 */     // GIR_Coverage, 26023,
     /* 156561 */     GIR_EraseRootFromParent_Done,
     /* 156562 */   // Label 3430: @156562
     /* 156562 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(156644), // Rule ID 22478 //
     /* 156567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156598 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 156605 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156612 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156625 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 156628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156630 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156632 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156642 */     GIR_RootConstrainSelectedInstOperands,
     /* 156643 */     // GIR_Coverage, 22478,
     /* 156643 */     GIR_EraseRootFromParent_Done,
     /* 156644 */   // Label 3431: @156644
     /* 156644 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(156726), // Rule ID 22479 //
     /* 156649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 156652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156680 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 156687 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156694 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156707 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 156710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156712 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156714 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156724 */     GIR_RootConstrainSelectedInstOperands,
     /* 156725 */     // GIR_Coverage, 22479,
     /* 156725 */     GIR_EraseRootFromParent_Done,
     /* 156726 */   // Label 3432: @156726
     /* 156726 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(156808), // Rule ID 22480 //
     /* 156731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 156734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156762 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156765 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 156769 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156776 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156789 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 156792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156794 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156806 */     GIR_RootConstrainSelectedInstOperands,
     /* 156807 */     // GIR_Coverage, 22480,
     /* 156807 */     GIR_EraseRootFromParent_Done,
     /* 156808 */   // Label 3433: @156808
     /* 156808 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(156873), // Rule ID 23256 //
     /* 156813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 156816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 156820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156835 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 156843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156852 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 156855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156857 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156859 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156871 */     GIR_RootConstrainSelectedInstOperands,
     /* 156872 */     // GIR_Coverage, 23256,
     /* 156872 */     GIR_EraseRootFromParent_Done,
     /* 156873 */   // Label 3434: @156873
     /* 156873 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(156935), // Rule ID 23399 //
     /* 156878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 156881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156893 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156900 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156917 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 156920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156922 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156924 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156933 */     GIR_RootConstrainSelectedInstOperands,
     /* 156934 */     // GIR_Coverage, 23399,
     /* 156934 */     GIR_EraseRootFromParent_Done,
     /* 156935 */   // Label 3435: @156935
     /* 156935 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(156997), // Rule ID 23403 //
     /* 156940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156955 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156962 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156979 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 156982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156986 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156995 */     GIR_RootConstrainSelectedInstOperands,
     /* 156996 */     // GIR_Coverage, 23403,
     /* 156996 */     GIR_EraseRootFromParent_Done,
     /* 156997 */   // Label 3436: @156997
     /* 156997 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(157059), // Rule ID 24249 //
     /* 157002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157017 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157020 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157024 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157041 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 157044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157046 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157048 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157057 */     GIR_RootConstrainSelectedInstOperands,
     /* 157058 */     // GIR_Coverage, 24249,
     /* 157058 */     GIR_EraseRootFromParent_Done,
     /* 157059 */   // Label 3437: @157059
     /* 157059 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(157124), // Rule ID 976 //
     /* 157064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 157067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 157071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 157075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157083 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157086 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157090 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157103 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 157106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157108 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157110 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 157117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157122 */     GIR_RootConstrainSelectedInstOperands,
     /* 157123 */     // GIR_Coverage, 976,
     /* 157123 */     GIR_EraseRootFromParent_Done,
     /* 157124 */   // Label 3438: @157124
     /* 157124 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(157186), // Rule ID 2200 //
     /* 157129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 157132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157148 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157155 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157168 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 157171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157173 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157175 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157184 */     GIR_RootConstrainSelectedInstOperands,
     /* 157185 */     // GIR_Coverage, 2200,
     /* 157185 */     GIR_EraseRootFromParent_Done,
     /* 157186 */   // Label 3439: @157186
     /* 157186 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(157248), // Rule ID 2208 //
     /* 157191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 157194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157210 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157213 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157217 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157230 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 157233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157235 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157237 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157246 */     GIR_RootConstrainSelectedInstOperands,
     /* 157247 */     // GIR_Coverage, 2208,
     /* 157247 */     GIR_EraseRootFromParent_Done,
     /* 157248 */   // Label 3440: @157248
     /* 157248 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(157310), // Rule ID 5973 //
     /* 157253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157272 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157275 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157279 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157292 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 157295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157297 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157299 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157308 */     GIR_RootConstrainSelectedInstOperands,
     /* 157309 */     // GIR_Coverage, 5973,
     /* 157309 */     GIR_EraseRootFromParent_Done,
     /* 157310 */   // Label 3441: @157310
     /* 157310 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(157347), // Rule ID 898 //
     /* 157315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 157318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 157322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 157326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 157330 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 157330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 157335 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 157341 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 157345 */     GIR_RootConstrainSelectedInstOperands,
     /* 157346 */     // GIR_Coverage, 898,
     /* 157346 */     GIR_Done,
     /* 157347 */   // Label 3442: @157347
     /* 157347 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(157378), // Rule ID 2198 //
     /* 157352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 157355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157367 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 157367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 157372 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157376 */     GIR_RootConstrainSelectedInstOperands,
     /* 157377 */     // GIR_Coverage, 2198,
     /* 157377 */     GIR_Done,
     /* 157378 */   // Label 3443: @157378
     /* 157378 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(157409), // Rule ID 2206 //
     /* 157383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 157386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 157398 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 157398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 157403 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157407 */     GIR_RootConstrainSelectedInstOperands,
     /* 157408 */     // GIR_Coverage, 2206,
     /* 157408 */     GIR_Done,
     /* 157409 */   // Label 3444: @157409
     /* 157409 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(157440), // Rule ID 5971 //
     /* 157414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 157429 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 157429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 157434 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157438 */     GIR_RootConstrainSelectedInstOperands,
     /* 157439 */     // GIR_Coverage, 5971,
     /* 157439 */     GIR_Done,
     /* 157440 */   // Label 3445: @157440
     /* 157440 */   GIM_Reject,
     /* 157441 */ // Label 3427: @157441
     /* 157441 */ GIM_Reject,
     /* 157442 */ // Label 3411: @157442
     /* 157442 */ GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(158722),
     /* 157447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 157450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157453 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(157535), // Rule ID 26024 //
     /* 157458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 157461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157485 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 157492 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157499 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157516 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 157519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157533 */     GIR_RootConstrainSelectedInstOperands,
     /* 157534 */     // GIR_Coverage, 26024,
     /* 157534 */     GIR_EraseRootFromParent_Done,
     /* 157535 */   // Label 3447: @157535
     /* 157535 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(157617), // Rule ID 26025 //
     /* 157540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 157543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157567 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157570 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 157574 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157581 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157598 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 157601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157603 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157605 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157615 */     GIR_RootConstrainSelectedInstOperands,
     /* 157616 */     // GIR_Coverage, 26025,
     /* 157616 */     GIR_EraseRootFromParent_Done,
     /* 157617 */   // Label 3448: @157617
     /* 157617 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(157699), // Rule ID 26026 //
     /* 157622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157649 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 157656 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157663 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157680 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 157683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157685 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157697 */     GIR_RootConstrainSelectedInstOperands,
     /* 157698 */     // GIR_Coverage, 26026,
     /* 157698 */     GIR_EraseRootFromParent_Done,
     /* 157699 */   // Label 3449: @157699
     /* 157699 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(157781), // Rule ID 22481 //
     /* 157704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 157707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157735 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157738 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 157742 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157749 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157755 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157762 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 157765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157767 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157769 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157779 */     GIR_RootConstrainSelectedInstOperands,
     /* 157780 */     // GIR_Coverage, 22481,
     /* 157780 */     GIR_EraseRootFromParent_Done,
     /* 157781 */   // Label 3450: @157781
     /* 157781 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(157863), // Rule ID 22482 //
     /* 157786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 157789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157817 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157820 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 157824 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157831 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157844 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 157847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157849 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157861 */     GIR_RootConstrainSelectedInstOperands,
     /* 157862 */     // GIR_Coverage, 22482,
     /* 157862 */     GIR_EraseRootFromParent_Done,
     /* 157863 */   // Label 3451: @157863
     /* 157863 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(157945), // Rule ID 22483 //
     /* 157868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157899 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157902 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 157906 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157913 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157926 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 157929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157931 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157933 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157943 */     GIR_RootConstrainSelectedInstOperands,
     /* 157944 */     // GIR_Coverage, 22483,
     /* 157944 */     GIR_EraseRootFromParent_Done,
     /* 157945 */   // Label 3452: @157945
     /* 157945 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(158010), // Rule ID 23258 //
     /* 157950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 157953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157965 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157968 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157972 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157989 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 157992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157994 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157996 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158008 */     GIR_RootConstrainSelectedInstOperands,
     /* 158009 */     // GIR_Coverage, 23258,
     /* 158009 */     GIR_EraseRootFromParent_Done,
     /* 158010 */   // Label 3453: @158010
     /* 158010 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(158082), // Rule ID 23260 //
     /* 158015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 158018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158030 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158033 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158037 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158061 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 158064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158066 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158068 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158080 */     GIR_RootConstrainSelectedInstOperands,
     /* 158081 */     // GIR_Coverage, 23260,
     /* 158081 */     GIR_EraseRootFromParent_Done,
     /* 158082 */   // Label 3454: @158082
     /* 158082 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(158144), // Rule ID 23401 //
     /* 158087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158102 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158105 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158109 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158126 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 158129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158131 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158133 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158142 */     GIR_RootConstrainSelectedInstOperands,
     /* 158143 */     // GIR_Coverage, 23401,
     /* 158143 */     GIR_EraseRootFromParent_Done,
     /* 158144 */   // Label 3455: @158144
     /* 158144 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(158206), // Rule ID 23405 //
     /* 158149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 158152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158164 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158171 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158188 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 158191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158193 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158204 */     GIR_RootConstrainSelectedInstOperands,
     /* 158205 */     // GIR_Coverage, 23405,
     /* 158205 */     GIR_EraseRootFromParent_Done,
     /* 158206 */   // Label 3456: @158206
     /* 158206 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(158268), // Rule ID 24251 //
     /* 158211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158226 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158229 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158233 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158250 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 158253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158255 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158257 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158266 */     GIR_RootConstrainSelectedInstOperands,
     /* 158267 */     // GIR_Coverage, 24251,
     /* 158267 */     GIR_EraseRootFromParent_Done,
     /* 158268 */   // Label 3457: @158268
     /* 158268 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(158333), // Rule ID 978 //
     /* 158273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 158276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158292 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158312 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 158315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158317 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158331 */     GIR_RootConstrainSelectedInstOperands,
     /* 158332 */     // GIR_Coverage, 978,
     /* 158332 */     GIR_EraseRootFromParent_Done,
     /* 158333 */   // Label 3458: @158333
     /* 158333 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(158405), // Rule ID 980 //
     /* 158338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 158341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158357 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158360 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158364 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158384 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 158387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158403 */     GIR_RootConstrainSelectedInstOperands,
     /* 158404 */     // GIR_Coverage, 980,
     /* 158404 */     GIR_EraseRootFromParent_Done,
     /* 158405 */   // Label 3459: @158405
     /* 158405 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(158467), // Rule ID 2204 //
     /* 158410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158429 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158432 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158436 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158449 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 158452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158454 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158465 */     GIR_RootConstrainSelectedInstOperands,
     /* 158466 */     // GIR_Coverage, 2204,
     /* 158466 */     GIR_EraseRootFromParent_Done,
     /* 158467 */   // Label 3460: @158467
     /* 158467 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(158529), // Rule ID 2212 //
     /* 158472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 158475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158491 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158498 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158511 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 158514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158516 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158527 */     GIR_RootConstrainSelectedInstOperands,
     /* 158528 */     // GIR_Coverage, 2212,
     /* 158528 */     GIR_EraseRootFromParent_Done,
     /* 158529 */   // Label 3461: @158529
     /* 158529 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(158591), // Rule ID 5992 //
     /* 158534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158553 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158556 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158560 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158573 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 158576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158578 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158580 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158589 */     GIR_RootConstrainSelectedInstOperands,
     /* 158590 */     // GIR_Coverage, 5992,
     /* 158590 */     GIR_EraseRootFromParent_Done,
     /* 158591 */   // Label 3462: @158591
     /* 158591 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(158628), // Rule ID 900 //
     /* 158596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 158599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 158611 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 158611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 158616 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 158622 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 158626 */     GIR_RootConstrainSelectedInstOperands,
     /* 158627 */     // GIR_Coverage, 900,
     /* 158627 */     GIR_Done,
     /* 158628 */   // Label 3463: @158628
     /* 158628 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(158659), // Rule ID 2202 //
     /* 158633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158648 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 158648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 158653 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158657 */     GIR_RootConstrainSelectedInstOperands,
     /* 158658 */     // GIR_Coverage, 2202,
     /* 158658 */     GIR_Done,
     /* 158659 */   // Label 3464: @158659
     /* 158659 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(158690), // Rule ID 2210 //
     /* 158664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 158667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158679 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 158679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 158684 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158688 */     GIR_RootConstrainSelectedInstOperands,
     /* 158689 */     // GIR_Coverage, 2210,
     /* 158689 */     GIR_Done,
     /* 158690 */   // Label 3465: @158690
     /* 158690 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(158721), // Rule ID 5990 //
     /* 158695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158710 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 158710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 158715 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158719 */     GIR_RootConstrainSelectedInstOperands,
     /* 158720 */     // GIR_Coverage, 5990,
     /* 158720 */     GIR_Done,
     /* 158721 */   // Label 3466: @158721
     /* 158721 */   GIM_Reject,
     /* 158722 */ // Label 3446: @158722
     /* 158722 */ GIM_Reject,
     /* 158723 */ // Label 3412: @158723
     /* 158723 */ GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(159044),
     /* 158728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 158731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 158734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158738 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(158806), // Rule ID 23262 //
     /* 158743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158754 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158757 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158761 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158785 */     // (fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 158788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158790 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158804 */     GIR_RootConstrainSelectedInstOperands,
     /* 158805 */     // GIR_Coverage, 23262,
     /* 158805 */     GIR_EraseRootFromParent_Done,
     /* 158806 */   // Label 3468: @158806
     /* 158806 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(158874), // Rule ID 23264 //
     /* 158811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158822 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158825 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158829 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158853 */     // (fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 158856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158858 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158872 */     GIR_RootConstrainSelectedInstOperands,
     /* 158873 */     // GIR_Coverage, 23264,
     /* 158873 */     GIR_EraseRootFromParent_Done,
     /* 158874 */   // Label 3469: @158874
     /* 158874 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(158942), // Rule ID 982 //
     /* 158879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158894 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158897 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158901 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158908 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158921 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 158924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158926 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158940 */     GIR_RootConstrainSelectedInstOperands,
     /* 158941 */     // GIR_Coverage, 982,
     /* 158941 */     GIR_EraseRootFromParent_Done,
     /* 158942 */   // Label 3470: @158942
     /* 158942 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(159010), // Rule ID 984 //
     /* 158947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158962 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158965 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158969 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158976 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158989 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 158992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158994 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158996 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 159003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159008 */     GIR_RootConstrainSelectedInstOperands,
     /* 159009 */     // GIR_Coverage, 984,
     /* 159009 */     GIR_EraseRootFromParent_Done,
     /* 159010 */   // Label 3471: @159010
     /* 159010 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(159043), // Rule ID 902 //
     /* 159015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 159018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 159022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 159026 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 159026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 159031 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 159037 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 159041 */     GIR_RootConstrainSelectedInstOperands,
     /* 159042 */     // GIR_Coverage, 902,
     /* 159042 */     GIR_Done,
     /* 159043 */   // Label 3472: @159043
     /* 159043 */   GIM_Reject,
     /* 159044 */ // Label 3467: @159044
     /* 159044 */ GIM_Reject,
     /* 159045 */ // Label 3413: @159045
     /* 159045 */ GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(159398),
     /* 159050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159056 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(159118), // Rule ID 23389 //
     /* 159061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159076 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159079 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159083 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159100 */     // (fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 159103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159107 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159116 */     GIR_RootConstrainSelectedInstOperands,
     /* 159117 */     // GIR_Coverage, 23389,
     /* 159117 */     GIR_EraseRootFromParent_Done,
     /* 159118 */   // Label 3474: @159118
     /* 159118 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(159180), // Rule ID 24365 //
     /* 159123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159138 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159141 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159145 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159162 */     // (fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 159165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159167 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159169 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159178 */     GIR_RootConstrainSelectedInstOperands,
     /* 159179 */     // GIR_Coverage, 24365,
     /* 159179 */     GIR_EraseRootFromParent_Done,
     /* 159180 */   // Label 3475: @159180
     /* 159180 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(159242), // Rule ID 2180 //
     /* 159185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159211 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159224 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 159227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159229 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159240 */     GIR_RootConstrainSelectedInstOperands,
     /* 159241 */     // GIR_Coverage, 2180,
     /* 159241 */     GIR_EraseRootFromParent_Done,
     /* 159242 */   // Label 3476: @159242
     /* 159242 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(159304), // Rule ID 6425 //
     /* 159247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159266 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159273 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159286 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 159289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159302 */     GIR_RootConstrainSelectedInstOperands,
     /* 159303 */     // GIR_Coverage, 6425,
     /* 159303 */     GIR_EraseRootFromParent_Done,
     /* 159304 */   // Label 3477: @159304
     /* 159304 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(159335), // Rule ID 2178 //
     /* 159309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159324 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 159324 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 159329 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159333 */     GIR_RootConstrainSelectedInstOperands,
     /* 159334 */     // GIR_Coverage, 2178,
     /* 159334 */     GIR_Done,
     /* 159335 */   // Label 3478: @159335
     /* 159335 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(159366), // Rule ID 2194 //
     /* 159340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 159343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159355 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 159355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 159360 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159364 */     GIR_RootConstrainSelectedInstOperands,
     /* 159365 */     // GIR_Coverage, 2194,
     /* 159365 */     GIR_Done,
     /* 159366 */   // Label 3479: @159366
     /* 159366 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(159397), // Rule ID 6421 //
     /* 159371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159386 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 159386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 159391 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159395 */     GIR_RootConstrainSelectedInstOperands,
     /* 159396 */     // GIR_Coverage, 6421,
     /* 159396 */     GIR_Done,
     /* 159397 */   // Label 3480: @159397
     /* 159397 */   GIM_Reject,
     /* 159398 */ // Label 3473: @159398
     /* 159398 */ GIM_Reject,
     /* 159399 */ // Label 3414: @159399
     /* 159399 */ GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(159752),
     /* 159404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159410 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(159472), // Rule ID 23387 //
     /* 159415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159454 */     // (fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 159457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159459 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159470 */     GIR_RootConstrainSelectedInstOperands,
     /* 159471 */     // GIR_Coverage, 23387,
     /* 159471 */     GIR_EraseRootFromParent_Done,
     /* 159472 */   // Label 3482: @159472
     /* 159472 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(159534), // Rule ID 24349 //
     /* 159477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159516 */     // (fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 159519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159532 */     GIR_RootConstrainSelectedInstOperands,
     /* 159533 */     // GIR_Coverage, 24349,
     /* 159533 */     GIR_EraseRootFromParent_Done,
     /* 159534 */   // Label 3483: @159534
     /* 159534 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(159596), // Rule ID 2176 //
     /* 159539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159558 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159561 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159565 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159578 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 159581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159583 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159585 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159594 */     GIR_RootConstrainSelectedInstOperands,
     /* 159595 */     // GIR_Coverage, 2176,
     /* 159595 */     GIR_EraseRootFromParent_Done,
     /* 159596 */   // Label 3484: @159596
     /* 159596 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(159658), // Rule ID 6401 //
     /* 159601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159620 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159640 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 159643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159656 */     GIR_RootConstrainSelectedInstOperands,
     /* 159657 */     // GIR_Coverage, 6401,
     /* 159657 */     GIR_EraseRootFromParent_Done,
     /* 159658 */   // Label 3485: @159658
     /* 159658 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(159689), // Rule ID 2174 //
     /* 159663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159678 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 159678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 159683 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159687 */     GIR_RootConstrainSelectedInstOperands,
     /* 159688 */     // GIR_Coverage, 2174,
     /* 159688 */     GIR_Done,
     /* 159689 */   // Label 3486: @159689
     /* 159689 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(159720), // Rule ID 2190 //
     /* 159694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159709 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 159709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 159714 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159718 */     GIR_RootConstrainSelectedInstOperands,
     /* 159719 */     // GIR_Coverage, 2190,
     /* 159719 */     GIR_Done,
     /* 159720 */   // Label 3487: @159720
     /* 159720 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(159751), // Rule ID 6397 //
     /* 159725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159740 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 159740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 159745 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159749 */     GIR_RootConstrainSelectedInstOperands,
     /* 159750 */     // GIR_Coverage, 6397,
     /* 159750 */     GIR_Done,
     /* 159751 */   // Label 3488: @159751
     /* 159751 */   GIM_Reject,
     /* 159752 */ // Label 3481: @159752
     /* 159752 */ GIM_Reject,
     /* 159753 */ // Label 3415: @159753
     /* 159753 */ GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(160075),
     /* 159758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 159761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 159764 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(159826), // Rule ID 23393 //
     /* 159769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159808 */     // (fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 159811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159824 */     GIR_RootConstrainSelectedInstOperands,
     /* 159825 */     // GIR_Coverage, 23393,
     /* 159825 */     GIR_EraseRootFromParent_Done,
     /* 159826 */   // Label 3490: @159826
     /* 159826 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(159888), // Rule ID 24373 //
     /* 159831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159849 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159853 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159870 */     // (fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 159873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159875 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159886 */     GIR_RootConstrainSelectedInstOperands,
     /* 159887 */     // GIR_Coverage, 24373,
     /* 159887 */     GIR_EraseRootFromParent_Done,
     /* 159888 */   // Label 3491: @159888
     /* 159888 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(159950), // Rule ID 2188 //
     /* 159893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159912 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159915 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159919 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159932 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 159935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159937 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159948 */     GIR_RootConstrainSelectedInstOperands,
     /* 159949 */     // GIR_Coverage, 2188,
     /* 159949 */     GIR_EraseRootFromParent_Done,
     /* 159950 */   // Label 3492: @159950
     /* 159950 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(160012), // Rule ID 6437 //
     /* 159955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159994 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 159997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160001 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160010 */     GIR_RootConstrainSelectedInstOperands,
     /* 160011 */     // GIR_Coverage, 6437,
     /* 160011 */     GIR_EraseRootFromParent_Done,
     /* 160012 */   // Label 3493: @160012
     /* 160012 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(160043), // Rule ID 2186 //
     /* 160017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 160020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160032 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 160032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 160037 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160041 */     GIR_RootConstrainSelectedInstOperands,
     /* 160042 */     // GIR_Coverage, 2186,
     /* 160042 */     GIR_Done,
     /* 160043 */   // Label 3494: @160043
     /* 160043 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(160074), // Rule ID 6433 //
     /* 160048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 160051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160063 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 160063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 160068 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160072 */     GIR_RootConstrainSelectedInstOperands,
     /* 160073 */     // GIR_Coverage, 6433,
     /* 160073 */     GIR_Done,
     /* 160074 */   // Label 3495: @160074
     /* 160074 */   GIM_Reject,
     /* 160075 */ // Label 3489: @160075
     /* 160075 */ GIM_Reject,
     /* 160076 */ // Label 3416: @160076
     /* 160076 */ GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(160235),
     /* 160081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 160091 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(160149), // Rule ID 24389 //
     /* 160096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 160122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160131 */     // (fmul:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 160134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160136 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160138 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160147 */     GIR_RootConstrainSelectedInstOperands,
     /* 160148 */     // GIR_Coverage, 24389,
     /* 160148 */     GIR_EraseRootFromParent_Done,
     /* 160149 */   // Label 3497: @160149
     /* 160149 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(160207), // Rule ID 6461 //
     /* 160154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 160161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160169 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160172 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160176 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160189 */     // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 160192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160194 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160196 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160205 */     GIR_RootConstrainSelectedInstOperands,
     /* 160206 */     // GIR_Coverage, 6461,
     /* 160206 */     GIR_EraseRootFromParent_Done,
     /* 160207 */   // Label 3498: @160207
     /* 160207 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(160234), // Rule ID 6457 //
     /* 160212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 160219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 160223 */     // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 160223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 160228 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160232 */     GIR_RootConstrainSelectedInstOperands,
     /* 160233 */     // GIR_Coverage, 6457,
     /* 160233 */     GIR_Done,
     /* 160234 */   // Label 3499: @160234
     /* 160234 */   GIM_Reject,
     /* 160235 */ // Label 3496: @160235
     /* 160235 */ GIM_Reject,
     /* 160236 */ // Label 3417: @160236
     /* 160236 */ GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(160558),
     /* 160241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 160244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 160247 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(160309), // Rule ID 23391 //
     /* 160252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 160255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160267 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160270 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160274 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160291 */     // (fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 160294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160296 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160298 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160307 */     GIR_RootConstrainSelectedInstOperands,
     /* 160308 */     // GIR_Coverage, 23391,
     /* 160308 */     GIR_EraseRootFromParent_Done,
     /* 160309 */   // Label 3501: @160309
     /* 160309 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(160371), // Rule ID 24357 //
     /* 160314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 160317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160329 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160332 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160336 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160353 */     // (fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 160356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160358 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160369 */     GIR_RootConstrainSelectedInstOperands,
     /* 160370 */     // GIR_Coverage, 24357,
     /* 160370 */     GIR_EraseRootFromParent_Done,
     /* 160371 */   // Label 3502: @160371
     /* 160371 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(160433), // Rule ID 2184 //
     /* 160376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 160379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160395 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160415 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 160418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160431 */     GIR_RootConstrainSelectedInstOperands,
     /* 160432 */     // GIR_Coverage, 2184,
     /* 160432 */     GIR_EraseRootFromParent_Done,
     /* 160433 */   // Label 3503: @160433
     /* 160433 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(160495), // Rule ID 6413 //
     /* 160438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 160441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160457 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160460 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160464 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160477 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 160480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160482 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160484 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160493 */     GIR_RootConstrainSelectedInstOperands,
     /* 160494 */     // GIR_Coverage, 6413,
     /* 160494 */     GIR_EraseRootFromParent_Done,
     /* 160495 */   // Label 3504: @160495
     /* 160495 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(160526), // Rule ID 2182 //
     /* 160500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 160503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 160515 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 160515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 160520 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160524 */     GIR_RootConstrainSelectedInstOperands,
     /* 160525 */     // GIR_Coverage, 2182,
     /* 160525 */     GIR_Done,
     /* 160526 */   // Label 3505: @160526
     /* 160526 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(160557), // Rule ID 6409 //
     /* 160531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 160534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160546 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 160546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 160551 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160555 */     GIR_RootConstrainSelectedInstOperands,
     /* 160556 */     // GIR_Coverage, 6409,
     /* 160556 */     GIR_Done,
     /* 160557 */   // Label 3506: @160557
     /* 160557 */   GIM_Reject,
     /* 160558 */ // Label 3500: @160558
     /* 160558 */ GIM_Reject,
     /* 160559 */ // Label 3418: @160559
     /* 160559 */ GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(160718),
     /* 160564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 160567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 160570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160574 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(160632), // Rule ID 24341 //
     /* 160579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160614 */     // (fmul:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 160617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160619 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160630 */     GIR_RootConstrainSelectedInstOperands,
     /* 160631 */     // GIR_Coverage, 24341,
     /* 160631 */     GIR_EraseRootFromParent_Done,
     /* 160632 */   // Label 3508: @160632
     /* 160632 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(160690), // Rule ID 6389 //
     /* 160637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160652 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160672 */     // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 160675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160688 */     GIR_RootConstrainSelectedInstOperands,
     /* 160689 */     // GIR_Coverage, 6389,
     /* 160689 */     GIR_EraseRootFromParent_Done,
     /* 160690 */   // Label 3509: @160690
     /* 160690 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(160717), // Rule ID 6385 //
     /* 160695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160706 */     // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 160706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 160711 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160715 */     GIR_RootConstrainSelectedInstOperands,
     /* 160716 */     // GIR_Coverage, 6385,
     /* 160716 */     GIR_Done,
     /* 160717 */   // Label 3510: @160717
     /* 160717 */   GIM_Reject,
     /* 160718 */ // Label 3507: @160718
     /* 160718 */ GIM_Reject,
     /* 160719 */ // Label 3419: @160719
     /* 160719 */ GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(160878),
     /* 160724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 160727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 160730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160734 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(160792), // Rule ID 24397 //
     /* 160739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160750 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160753 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160757 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160774 */     // (fmul:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 160777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160781 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160790 */     GIR_RootConstrainSelectedInstOperands,
     /* 160791 */     // GIR_Coverage, 24397,
     /* 160791 */     GIR_EraseRootFromParent_Done,
     /* 160792 */   // Label 3512: @160792
     /* 160792 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(160850), // Rule ID 6473 //
     /* 160797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160832 */     // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 160835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160837 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160848 */     GIR_RootConstrainSelectedInstOperands,
     /* 160849 */     // GIR_Coverage, 6473,
     /* 160849 */     GIR_EraseRootFromParent_Done,
     /* 160850 */   // Label 3513: @160850
     /* 160850 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(160877), // Rule ID 6469 //
     /* 160855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160866 */     // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 160866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 160871 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160875 */     GIR_RootConstrainSelectedInstOperands,
     /* 160876 */     // GIR_Coverage, 6469,
     /* 160876 */     GIR_Done,
     /* 160877 */   // Label 3514: @160877
     /* 160877 */   GIM_Reject,
     /* 160878 */ // Label 3511: @160878
     /* 160878 */ GIM_Reject,
     /* 160879 */ // Label 3420: @160879
     /* 160879 */ GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(161038),
     /* 160884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 160887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 160890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160894 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(160952), // Rule ID 24333 //
     /* 160899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160910 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160913 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160917 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160934 */     // (fmul:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 160937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160939 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160950 */     GIR_RootConstrainSelectedInstOperands,
     /* 160951 */     // GIR_Coverage, 24333,
     /* 160951 */     GIR_EraseRootFromParent_Done,
     /* 160952 */   // Label 3516: @160952
     /* 160952 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(161010), // Rule ID 6377 //
     /* 160957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160992 */     // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 160995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160997 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161008 */     GIR_RootConstrainSelectedInstOperands,
     /* 161009 */     // GIR_Coverage, 6377,
     /* 161009 */     GIR_EraseRootFromParent_Done,
     /* 161010 */   // Label 3517: @161010
     /* 161010 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(161037), // Rule ID 6373 //
     /* 161015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 161018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161026 */     // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 161026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 161031 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161035 */     GIR_RootConstrainSelectedInstOperands,
     /* 161036 */     // GIR_Coverage, 6373,
     /* 161036 */     GIR_Done,
     /* 161037 */   // Label 3518: @161037
     /* 161037 */   GIM_Reject,
     /* 161038 */ // Label 3515: @161038
     /* 161038 */ GIM_Reject,
     /* 161039 */ // Label 3421: @161039
     /* 161039 */ GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(161198),
     /* 161044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 161047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 161050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161054 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(161112), // Rule ID 24381 //
     /* 161059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161070 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161094 */     // (fmul:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 161097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161099 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161110 */     GIR_RootConstrainSelectedInstOperands,
     /* 161111 */     // GIR_Coverage, 24381,
     /* 161111 */     GIR_EraseRootFromParent_Done,
     /* 161112 */   // Label 3520: @161112
     /* 161112 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(161170), // Rule ID 6449 //
     /* 161117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161139 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161152 */     // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 161155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161168 */     GIR_RootConstrainSelectedInstOperands,
     /* 161169 */     // GIR_Coverage, 6449,
     /* 161169 */     GIR_EraseRootFromParent_Done,
     /* 161170 */   // Label 3521: @161170
     /* 161170 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(161197), // Rule ID 6445 //
     /* 161175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 161186 */     // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 161186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 161191 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161195 */     GIR_RootConstrainSelectedInstOperands,
     /* 161196 */     // GIR_Coverage, 6445,
     /* 161196 */     GIR_Done,
     /* 161197 */   // Label 3522: @161197
     /* 161197 */   GIM_Reject,
     /* 161198 */ // Label 3519: @161198
     /* 161198 */ GIM_Reject,
     /* 161199 */ // Label 3422: @161199
     /* 161199 */ GIM_Reject,
     /* 161200 */ // Label 44: @161200
     /* 161200 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3535*/ GIMT_Encode4(167187),
     /* 161211 */ /*GILLT_s16*//*Label 3523*/ GIMT_Encode4(161295),
     /* 161215 */ /*GILLT_s32*//*Label 3524*/ GIMT_Encode4(161540),
     /* 161219 */ /*GILLT_s64*//*Label 3525*/ GIMT_Encode4(162277), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 161235 */ /*GILLT_v2s64*//*Label 3526*/ GIMT_Encode4(163014), GIMT_Encode4(0),
     /* 161243 */ /*GILLT_v4s32*//*Label 3527*/ GIMT_Encode4(163751),
     /* 161247 */ /*GILLT_v4s64*//*Label 3528*/ GIMT_Encode4(164488), GIMT_Encode4(0),
     /* 161255 */ /*GILLT_v8s16*//*Label 3529*/ GIMT_Encode4(165225),
     /* 161259 */ /*GILLT_v8s32*//*Label 3530*/ GIMT_Encode4(165470),
     /* 161263 */ /*GILLT_v8s64*//*Label 3531*/ GIMT_Encode4(166207), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 161275 */ /*GILLT_v16s16*//*Label 3532*/ GIMT_Encode4(166452),
     /* 161279 */ /*GILLT_v16s32*//*Label 3533*/ GIMT_Encode4(166697), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 161291 */ /*GILLT_v32s16*//*Label 3534*/ GIMT_Encode4(166942),
     /* 161295 */ // Label 3523: @161295
     /* 161295 */ GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(161539),
     /* 161300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 161303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161306 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 161309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161313 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(161377), // Rule ID 10157 //
     /* 161318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161329 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161332 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161336 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161357 */     // (fma:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VFMADD132SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SHZm),
     /* 161360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161362 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161364 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 161366 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161375 */     GIR_RootConstrainSelectedInstOperands,
     /* 161376 */     // GIR_Coverage, 10157,
     /* 161376 */     GIR_EraseRootFromParent_Done,
     /* 161377 */   // Label 3537: @161377
     /* 161377 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(161441), // Rule ID 10155 //
     /* 161382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161397 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161400 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161404 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161421 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VFMADD231SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SHZm),
     /* 161424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161426 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 161428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161430 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161439 */     GIR_RootConstrainSelectedInstOperands,
     /* 161440 */     // GIR_Coverage, 10155,
     /* 161440 */     GIR_EraseRootFromParent_Done,
     /* 161441 */   // Label 3538: @161441
     /* 161441 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(161505), // Rule ID 10152 //
     /* 161446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161465 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161485 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZm),
     /* 161488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161490 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161492 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161494 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161503 */     GIR_RootConstrainSelectedInstOperands,
     /* 161504 */     // GIR_Coverage, 10152,
     /* 161504 */     GIR_EraseRootFromParent_Done,
     /* 161505 */   // Label 3539: @161505
     /* 161505 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(161538), // Rule ID 10150 //
     /* 161510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 161513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 161525 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 161525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 161528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161530 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161532 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161534 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 161536 */     GIR_RootConstrainSelectedInstOperands,
     /* 161537 */     // GIR_Coverage, 10150,
     /* 161537 */     GIR_EraseRootFromParent_Done,
     /* 161538 */   // Label 3540: @161538
     /* 161538 */   GIM_Reject,
     /* 161539 */ // Label 3536: @161539
     /* 161539 */ GIM_Reject,
     /* 161540 */ // Label 3524: @161540
     /* 161540 */ GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(162276),
     /* 161545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 161548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161551 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161554 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(161622), // Rule ID 1303 //
     /* 161559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 161562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161602 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VFMADD132SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSm),
     /* 161605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161607 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161609 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 161611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161620 */     GIR_RootConstrainSelectedInstOperands,
     /* 161621 */     // GIR_Coverage, 1303,
     /* 161621 */     GIR_EraseRootFromParent_Done,
     /* 161622 */   // Label 3542: @161622
     /* 161622 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(161690), // Rule ID 10139 //
     /* 161627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 161630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161670 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VFMADD132SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSZm),
     /* 161673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161675 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161677 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 161679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161688 */     GIR_RootConstrainSelectedInstOperands,
     /* 161689 */     // GIR_Coverage, 10139,
     /* 161689 */     GIR_EraseRootFromParent_Done,
     /* 161690 */   // Label 3543: @161690
     /* 161690 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(161758), // Rule ID 23278 //
     /* 161695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 161698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161710 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161713 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161717 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161738 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 161738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 161741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161743 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161749 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 161751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161756 */     GIR_RootConstrainSelectedInstOperands,
     /* 161757 */     // GIR_Coverage, 23278,
     /* 161757 */     GIR_EraseRootFromParent_Done,
     /* 161758 */   // Label 3544: @161758
     /* 161758 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(161826), // Rule ID 1301 //
     /* 161763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 161766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161782 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161785 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161789 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161806 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VFMADD231SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSm),
     /* 161809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161811 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 161813 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161824 */     GIR_RootConstrainSelectedInstOperands,
     /* 161825 */     // GIR_Coverage, 1301,
     /* 161825 */     GIR_EraseRootFromParent_Done,
     /* 161826 */   // Label 3545: @161826
     /* 161826 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(161894), // Rule ID 1365 //
     /* 161831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 161834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161850 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161853 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161857 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161874 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 161874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 161877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161879 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161885 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 161887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161892 */     GIR_RootConstrainSelectedInstOperands,
     /* 161893 */     // GIR_Coverage, 1365,
     /* 161893 */     GIR_EraseRootFromParent_Done,
     /* 161894 */   // Label 3546: @161894
     /* 161894 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(161962), // Rule ID 10137 //
     /* 161899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 161902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161942 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VFMADD231SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSZm),
     /* 161945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161947 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 161949 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161960 */     GIR_RootConstrainSelectedInstOperands,
     /* 161961 */     // GIR_Coverage, 10137,
     /* 161961 */     GIR_EraseRootFromParent_Done,
     /* 161962 */   // Label 3547: @161962
     /* 161962 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(162030), // Rule ID 1299 //
     /* 161967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 161970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161990 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161997 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162010 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSm),
     /* 162013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162015 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162017 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162019 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162028 */     GIR_RootConstrainSelectedInstOperands,
     /* 162029 */     // GIR_Coverage, 1299,
     /* 162029 */     GIR_EraseRootFromParent_Done,
     /* 162030 */   // Label 3548: @162030
     /* 162030 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(162098), // Rule ID 1363 //
     /* 162035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162078 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSS4rm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rm),
     /* 162081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162085 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 162087 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162096 */     GIR_RootConstrainSelectedInstOperands,
     /* 162097 */     // GIR_Coverage, 1363,
     /* 162097 */     GIR_EraseRootFromParent_Done,
     /* 162098 */   // Label 3549: @162098
     /* 162098 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(162166), // Rule ID 10134 //
     /* 162103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162126 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162129 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162133 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162139 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162146 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZm),
     /* 162149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162151 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162153 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162164 */     GIR_RootConstrainSelectedInstOperands,
     /* 162165 */     // GIR_Coverage, 10134,
     /* 162165 */     GIR_EraseRootFromParent_Done,
     /* 162166 */   // Label 3550: @162166
     /* 162166 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(162203), // Rule ID 1297 //
     /* 162171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 162174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162190 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 162190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 162193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162197 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162199 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162201 */     GIR_RootConstrainSelectedInstOperands,
     /* 162202 */     // GIR_Coverage, 1297,
     /* 162202 */     GIR_EraseRootFromParent_Done,
     /* 162203 */   // Label 3551: @162203
     /* 162203 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(162238), // Rule ID 1361 //
     /* 162208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 162227 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 162227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 162232 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162236 */     GIR_RootConstrainSelectedInstOperands,
     /* 162237 */     // GIR_Coverage, 1361,
     /* 162237 */     GIR_Done,
     /* 162238 */   // Label 3552: @162238
     /* 162238 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(162275), // Rule ID 10132 //
     /* 162243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 162262 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 162262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 162265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162267 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162269 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162271 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162273 */     GIR_RootConstrainSelectedInstOperands,
     /* 162274 */     // GIR_Coverage, 10132,
     /* 162274 */     GIR_EraseRootFromParent_Done,
     /* 162275 */   // Label 3553: @162275
     /* 162275 */   GIM_Reject,
     /* 162276 */ // Label 3541: @162276
     /* 162276 */ GIM_Reject,
     /* 162277 */ // Label 3525: @162277
     /* 162277 */ GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(163013),
     /* 162282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162288 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 162291 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(162359), // Rule ID 1311 //
     /* 162296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 162299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162311 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162314 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162318 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162339 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VFMADD132SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDm),
     /* 162342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162344 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162346 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 162348 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162357 */     GIR_RootConstrainSelectedInstOperands,
     /* 162358 */     // GIR_Coverage, 1311,
     /* 162358 */     GIR_EraseRootFromParent_Done,
     /* 162359 */   // Label 3555: @162359
     /* 162359 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(162427), // Rule ID 10148 //
     /* 162364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162379 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162382 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162407 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VFMADD132SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDZm),
     /* 162410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162412 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162414 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 162416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162425 */     GIR_RootConstrainSelectedInstOperands,
     /* 162426 */     // GIR_Coverage, 10148,
     /* 162426 */     GIR_EraseRootFromParent_Done,
     /* 162427 */   // Label 3556: @162427
     /* 162427 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(162495), // Rule ID 23306 //
     /* 162432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162447 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162450 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162454 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162475 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 162475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 162478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162480 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162486 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162493 */     GIR_RootConstrainSelectedInstOperands,
     /* 162494 */     // GIR_Coverage, 23306,
     /* 162494 */     GIR_EraseRootFromParent_Done,
     /* 162495 */   // Label 3557: @162495
     /* 162495 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(162563), // Rule ID 1309 //
     /* 162500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 162503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162519 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162522 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162526 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162543 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VFMADD231SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDm),
     /* 162546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162548 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 162550 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162552 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162561 */     GIR_RootConstrainSelectedInstOperands,
     /* 162562 */     // GIR_Coverage, 1309,
     /* 162562 */     GIR_EraseRootFromParent_Done,
     /* 162563 */   // Label 3558: @162563
     /* 162563 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(162631), // Rule ID 1449 //
     /* 162568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162587 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162594 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162611 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 162611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 162614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162616 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162618 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162622 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162629 */     GIR_RootConstrainSelectedInstOperands,
     /* 162630 */     // GIR_Coverage, 1449,
     /* 162630 */     GIR_EraseRootFromParent_Done,
     /* 162631 */   // Label 3559: @162631
     /* 162631 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(162699), // Rule ID 10146 //
     /* 162636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162655 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162658 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162662 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162672 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162679 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VFMADD231SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDZm),
     /* 162682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162684 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 162686 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162688 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162697 */     GIR_RootConstrainSelectedInstOperands,
     /* 162698 */     // GIR_Coverage, 10146,
     /* 162698 */     GIR_EraseRootFromParent_Done,
     /* 162699 */   // Label 3560: @162699
     /* 162699 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(162767), // Rule ID 1307 //
     /* 162704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 162707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162727 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162730 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162734 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162747 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDm),
     /* 162750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162752 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162754 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162756 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162765 */     GIR_RootConstrainSelectedInstOperands,
     /* 162766 */     // GIR_Coverage, 1307,
     /* 162766 */     GIR_EraseRootFromParent_Done,
     /* 162767 */   // Label 3561: @162767
     /* 162767 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(162835), // Rule ID 1447 //
     /* 162772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162795 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162802 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162815 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSD4rm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rm),
     /* 162818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162820 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162822 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 162824 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162833 */     GIR_RootConstrainSelectedInstOperands,
     /* 162834 */     // GIR_Coverage, 1447,
     /* 162834 */     GIR_EraseRootFromParent_Done,
     /* 162835 */   // Label 3562: @162835
     /* 162835 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(162903), // Rule ID 10143 //
     /* 162840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162863 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162866 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162883 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZm),
     /* 162886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162888 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162890 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162901 */     GIR_RootConstrainSelectedInstOperands,
     /* 162902 */     // GIR_Coverage, 10143,
     /* 162902 */     GIR_EraseRootFromParent_Done,
     /* 162903 */   // Label 3563: @162903
     /* 162903 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(162940), // Rule ID 1305 //
     /* 162908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 162911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162927 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 162927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 162930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162932 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162934 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162936 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162938 */     GIR_RootConstrainSelectedInstOperands,
     /* 162939 */     // GIR_Coverage, 1305,
     /* 162939 */     GIR_EraseRootFromParent_Done,
     /* 162940 */   // Label 3564: @162940
     /* 162940 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(162975), // Rule ID 1445 //
     /* 162945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162964 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 162964 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 162969 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162973 */     GIR_RootConstrainSelectedInstOperands,
     /* 162974 */     // GIR_Coverage, 1445,
     /* 162974 */     GIR_Done,
     /* 162975 */   // Label 3565: @162975
     /* 162975 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(163012), // Rule ID 10141 //
     /* 162980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162999 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 162999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 163002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163006 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163008 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163010 */     GIR_RootConstrainSelectedInstOperands,
     /* 163011 */     // GIR_Coverage, 10141,
     /* 163011 */     GIR_EraseRootFromParent_Done,
     /* 163012 */   // Label 3566: @163012
     /* 163012 */   GIM_Reject,
     /* 163013 */ // Label 3554: @163013
     /* 163013 */ GIM_Reject,
     /* 163014 */ // Label 3526: @163014
     /* 163014 */ GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(163750),
     /* 163019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163028 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(163096), // Rule ID 1191 //
     /* 163033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163048 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163055 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163076 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDm),
     /* 163079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163083 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163094 */     GIR_RootConstrainSelectedInstOperands,
     /* 163095 */     // GIR_Coverage, 1191,
     /* 163095 */     GIR_EraseRootFromParent_Done,
     /* 163096 */   // Label 3568: @163096
     /* 163096 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(163164), // Rule ID 9680 //
     /* 163101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163116 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163119 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163123 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163144 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ128m),
     /* 163147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163149 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163151 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163153 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163162 */     GIR_RootConstrainSelectedInstOperands,
     /* 163163 */     // GIR_Coverage, 9680,
     /* 163163 */     GIR_EraseRootFromParent_Done,
     /* 163164 */   // Label 3569: @163164
     /* 163164 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(163232), // Rule ID 23314 //
     /* 163169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163184 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163187 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163191 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163212 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 163212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 163215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163223 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163230 */     GIR_RootConstrainSelectedInstOperands,
     /* 163231 */     // GIR_Coverage, 23314,
     /* 163231 */     GIR_EraseRootFromParent_Done,
     /* 163232 */   // Label 3570: @163232
     /* 163232 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(163300), // Rule ID 1189 //
     /* 163237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163263 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163280 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDm),
     /* 163283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163285 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 163287 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163298 */     GIR_RootConstrainSelectedInstOperands,
     /* 163299 */     // GIR_Coverage, 1189,
     /* 163299 */     GIR_EraseRootFromParent_Done,
     /* 163300 */   // Label 3571: @163300
     /* 163300 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(163368), // Rule ID 1473 //
     /* 163305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163324 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163327 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163348 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 163348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 163351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163359 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163366 */     GIR_RootConstrainSelectedInstOperands,
     /* 163367 */     // GIR_Coverage, 1473,
     /* 163367 */     GIR_EraseRootFromParent_Done,
     /* 163368 */   // Label 3572: @163368
     /* 163368 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(163436), // Rule ID 9140 //
     /* 163373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163392 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163395 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163399 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163416 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ128m),
     /* 163419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163421 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 163423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163425 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163434 */     GIR_RootConstrainSelectedInstOperands,
     /* 163435 */     // GIR_Coverage, 9140,
     /* 163435 */     GIR_EraseRootFromParent_Done,
     /* 163436 */   // Label 3573: @163436
     /* 163436 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(163504), // Rule ID 1187 //
     /* 163441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163464 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163471 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163484 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDm),
     /* 163487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163489 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163502 */     GIR_RootConstrainSelectedInstOperands,
     /* 163503 */     // GIR_Coverage, 1187,
     /* 163503 */     GIR_EraseRootFromParent_Done,
     /* 163504 */   // Label 3574: @163504
     /* 163504 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(163572), // Rule ID 1471 //
     /* 163509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163532 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163552 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4rm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rm),
     /* 163555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163557 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163559 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 163561 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163570 */     GIR_RootConstrainSelectedInstOperands,
     /* 163571 */     // GIR_Coverage, 1471,
     /* 163571 */     GIR_EraseRootFromParent_Done,
     /* 163572 */   // Label 3575: @163572
     /* 163572 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(163640), // Rule ID 8513 //
     /* 163577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163620 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128m),
     /* 163623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163629 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163638 */     GIR_RootConstrainSelectedInstOperands,
     /* 163639 */     // GIR_Coverage, 8513,
     /* 163639 */     GIR_EraseRootFromParent_Done,
     /* 163640 */   // Label 3576: @163640
     /* 163640 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(163677), // Rule ID 1185 //
     /* 163645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163664 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 163664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 163667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163669 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163671 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163673 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163675 */     GIR_RootConstrainSelectedInstOperands,
     /* 163676 */     // GIR_Coverage, 1185,
     /* 163676 */     GIR_EraseRootFromParent_Done,
     /* 163677 */   // Label 3577: @163677
     /* 163677 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(163712), // Rule ID 1469 //
     /* 163682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163701 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 163701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 163706 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163710 */     GIR_RootConstrainSelectedInstOperands,
     /* 163711 */     // GIR_Coverage, 1469,
     /* 163711 */     GIR_Done,
     /* 163712 */   // Label 3578: @163712
     /* 163712 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(163749), // Rule ID 8509 //
     /* 163717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163736 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 163736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 163739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163745 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163747 */     GIR_RootConstrainSelectedInstOperands,
     /* 163748 */     // GIR_Coverage, 8509,
     /* 163748 */     GIR_EraseRootFromParent_Done,
     /* 163749 */   // Label 3579: @163749
     /* 163749 */   GIM_Reject,
     /* 163750 */ // Label 3567: @163750
     /* 163750 */ GIM_Reject,
     /* 163751 */ // Label 3527: @163751
     /* 163751 */ GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(164487),
     /* 163756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163762 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163765 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(163833), // Rule ID 1143 //
     /* 163770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163813 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSm),
     /* 163816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163818 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163820 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163822 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163831 */     GIR_RootConstrainSelectedInstOperands,
     /* 163832 */     // GIR_Coverage, 1143,
     /* 163832 */     GIR_EraseRootFromParent_Done,
     /* 163833 */   // Label 3581: @163833
     /* 163833 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(163901), // Rule ID 9648 //
     /* 163838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163853 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163856 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163860 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163881 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ128m),
     /* 163884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163886 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163888 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163890 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163899 */     GIR_RootConstrainSelectedInstOperands,
     /* 163900 */     // GIR_Coverage, 9648,
     /* 163900 */     GIR_EraseRootFromParent_Done,
     /* 163901 */   // Label 3582: @163901
     /* 163901 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(163969), // Rule ID 23286 //
     /* 163906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163921 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163924 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163928 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163949 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 163949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 163952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163956 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163960 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163967 */     GIR_RootConstrainSelectedInstOperands,
     /* 163968 */     // GIR_Coverage, 23286,
     /* 163968 */     GIR_EraseRootFromParent_Done,
     /* 163969 */   // Label 3583: @163969
     /* 163969 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(164037), // Rule ID 1141 //
     /* 163974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163993 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163996 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164000 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164017 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSm),
     /* 164020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164022 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164026 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164035 */     GIR_RootConstrainSelectedInstOperands,
     /* 164036 */     // GIR_Coverage, 1141,
     /* 164036 */     GIR_EraseRootFromParent_Done,
     /* 164037 */   // Label 3584: @164037
     /* 164037 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(164105), // Rule ID 1389 //
     /* 164042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164061 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164064 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164068 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164085 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 164085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 164088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164090 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164092 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164096 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164103 */     GIR_RootConstrainSelectedInstOperands,
     /* 164104 */     // GIR_Coverage, 1389,
     /* 164104 */     GIR_EraseRootFromParent_Done,
     /* 164105 */   // Label 3585: @164105
     /* 164105 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(164173), // Rule ID 9108 //
     /* 164110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164129 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164136 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164153 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ128m),
     /* 164156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164158 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164160 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164171 */     GIR_RootConstrainSelectedInstOperands,
     /* 164172 */     // GIR_Coverage, 9108,
     /* 164172 */     GIR_EraseRootFromParent_Done,
     /* 164173 */   // Label 3586: @164173
     /* 164173 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(164241), // Rule ID 1139 //
     /* 164178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164201 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164204 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164208 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164221 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSm),
     /* 164224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164226 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164228 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164230 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164239 */     GIR_RootConstrainSelectedInstOperands,
     /* 164240 */     // GIR_Coverage, 1139,
     /* 164240 */     GIR_EraseRootFromParent_Done,
     /* 164241 */   // Label 3587: @164241
     /* 164241 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(164309), // Rule ID 1387 //
     /* 164246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164269 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164272 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164276 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164289 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4rm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rm),
     /* 164292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164294 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164296 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 164298 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164307 */     GIR_RootConstrainSelectedInstOperands,
     /* 164308 */     // GIR_Coverage, 1387,
     /* 164308 */     GIR_EraseRootFromParent_Done,
     /* 164309 */   // Label 3588: @164309
     /* 164309 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(164377), // Rule ID 8474 //
     /* 164314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164337 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164340 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164344 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164357 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128m),
     /* 164360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164362 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164364 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164366 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164375 */     GIR_RootConstrainSelectedInstOperands,
     /* 164376 */     // GIR_Coverage, 8474,
     /* 164376 */     GIR_EraseRootFromParent_Done,
     /* 164377 */   // Label 3589: @164377
     /* 164377 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(164414), // Rule ID 1137 //
     /* 164382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164401 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 164401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 164404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164406 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164408 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164410 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164412 */     GIR_RootConstrainSelectedInstOperands,
     /* 164413 */     // GIR_Coverage, 1137,
     /* 164413 */     GIR_EraseRootFromParent_Done,
     /* 164414 */   // Label 3590: @164414
     /* 164414 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(164449), // Rule ID 1385 //
     /* 164419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 164438 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 164438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 164443 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 164447 */     GIR_RootConstrainSelectedInstOperands,
     /* 164448 */     // GIR_Coverage, 1385,
     /* 164448 */     GIR_Done,
     /* 164449 */   // Label 3591: @164449
     /* 164449 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(164486), // Rule ID 8470 //
     /* 164454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164473 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 164473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 164476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164478 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164480 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164482 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164484 */     GIR_RootConstrainSelectedInstOperands,
     /* 164485 */     // GIR_Coverage, 8470,
     /* 164485 */     GIR_EraseRootFromParent_Done,
     /* 164486 */   // Label 3592: @164486
     /* 164486 */   GIM_Reject,
     /* 164487 */ // Label 3580: @164487
     /* 164487 */ GIM_Reject,
     /* 164488 */ // Label 3528: @164488
     /* 164488 */ GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(165224),
     /* 164493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 164496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 164499 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 164502 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(164570), // Rule ID 1199 //
     /* 164507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164529 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164550 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDYm),
     /* 164553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164555 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164557 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164559 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164568 */     GIR_RootConstrainSelectedInstOperands,
     /* 164569 */     // GIR_Coverage, 1199,
     /* 164569 */     GIR_EraseRootFromParent_Done,
     /* 164570 */   // Label 3594: @164570
     /* 164570 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(164638), // Rule ID 9670 //
     /* 164575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164618 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ256m),
     /* 164621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164623 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164625 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164636 */     GIR_RootConstrainSelectedInstOperands,
     /* 164637 */     // GIR_Coverage, 9670,
     /* 164637 */     GIR_EraseRootFromParent_Done,
     /* 164638 */   // Label 3595: @164638
     /* 164638 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(164706), // Rule ID 23316 //
     /* 164643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164658 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164661 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164665 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164686 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 164686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 164689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164691 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164693 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164697 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164704 */     GIR_RootConstrainSelectedInstOperands,
     /* 164705 */     // GIR_Coverage, 23316,
     /* 164705 */     GIR_EraseRootFromParent_Done,
     /* 164706 */   // Label 3596: @164706
     /* 164706 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(164774), // Rule ID 1197 //
     /* 164711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164730 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164733 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164754 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDYm),
     /* 164757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164759 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164761 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164772 */     GIR_RootConstrainSelectedInstOperands,
     /* 164773 */     // GIR_Coverage, 1197,
     /* 164773 */     GIR_EraseRootFromParent_Done,
     /* 164774 */   // Label 3597: @164774
     /* 164774 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(164842), // Rule ID 1479 //
     /* 164779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164798 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164822 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 164822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 164825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164827 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164833 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164840 */     GIR_RootConstrainSelectedInstOperands,
     /* 164841 */     // GIR_Coverage, 1479,
     /* 164841 */     GIR_EraseRootFromParent_Done,
     /* 164842 */   // Label 3598: @164842
     /* 164842 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(164910), // Rule ID 9130 //
     /* 164847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164866 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164869 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164873 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164890 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ256m),
     /* 164893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164895 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164897 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164899 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164908 */     GIR_RootConstrainSelectedInstOperands,
     /* 164909 */     // GIR_Coverage, 9130,
     /* 164909 */     GIR_EraseRootFromParent_Done,
     /* 164910 */   // Label 3599: @164910
     /* 164910 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(164978), // Rule ID 1195 //
     /* 164915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164938 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164941 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164945 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164958 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYm),
     /* 164961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164967 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164976 */     GIR_RootConstrainSelectedInstOperands,
     /* 164977 */     // GIR_Coverage, 1195,
     /* 164977 */     GIR_EraseRootFromParent_Done,
     /* 164978 */   // Label 3600: @164978
     /* 164978 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(165046), // Rule ID 1477 //
     /* 164983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165006 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165013 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165026 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4Yrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrm),
     /* 165029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165033 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 165035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165044 */     GIR_RootConstrainSelectedInstOperands,
     /* 165045 */     // GIR_Coverage, 1477,
     /* 165045 */     GIR_EraseRootFromParent_Done,
     /* 165046 */   // Label 3601: @165046
     /* 165046 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(165114), // Rule ID 8501 //
     /* 165051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165081 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165094 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256m),
     /* 165097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165099 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165101 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165103 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165112 */     GIR_RootConstrainSelectedInstOperands,
     /* 165113 */     // GIR_Coverage, 8501,
     /* 165113 */     GIR_EraseRootFromParent_Done,
     /* 165114 */   // Label 3602: @165114
     /* 165114 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(165151), // Rule ID 1193 //
     /* 165119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165138 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 165138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 165141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165143 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165145 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165147 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165149 */     GIR_RootConstrainSelectedInstOperands,
     /* 165150 */     // GIR_Coverage, 1193,
     /* 165150 */     GIR_EraseRootFromParent_Done,
     /* 165151 */   // Label 3603: @165151
     /* 165151 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(165186), // Rule ID 1475 //
     /* 165156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165175 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 165175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 165180 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 165184 */     GIR_RootConstrainSelectedInstOperands,
     /* 165185 */     // GIR_Coverage, 1475,
     /* 165185 */     GIR_Done,
     /* 165186 */   // Label 3604: @165186
     /* 165186 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(165223), // Rule ID 8497 //
     /* 165191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165210 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 165210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 165213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165215 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165217 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165219 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165221 */     GIR_RootConstrainSelectedInstOperands,
     /* 165222 */     // GIR_Coverage, 8497,
     /* 165222 */     GIR_EraseRootFromParent_Done,
     /* 165223 */   // Label 3605: @165223
     /* 165223 */   GIM_Reject,
     /* 165224 */ // Label 3593: @165224
     /* 165224 */ GIM_Reject,
     /* 165225 */ // Label 3529: @165225
     /* 165225 */ GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(165469),
     /* 165230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 165233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165236 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165243 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(165307), // Rule ID 9616 //
     /* 165248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 165251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165259 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165262 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165266 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165287 */     // (fma:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VFMADD132PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ128m),
     /* 165290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165292 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165294 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165305 */     GIR_RootConstrainSelectedInstOperands,
     /* 165306 */     // GIR_Coverage, 9616,
     /* 165306 */     GIR_EraseRootFromParent_Done,
     /* 165307 */   // Label 3607: @165307
     /* 165307 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(165371), // Rule ID 9076 //
     /* 165312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 165315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165327 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165330 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165334 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165351 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VFMADD231PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ128m),
     /* 165354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165356 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165369 */     GIR_RootConstrainSelectedInstOperands,
     /* 165370 */     // GIR_Coverage, 9076,
     /* 165370 */     GIR_EraseRootFromParent_Done,
     /* 165371 */   // Label 3608: @165371
     /* 165371 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(165435), // Rule ID 8435 //
     /* 165376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 165379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165395 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165415 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128m),
     /* 165418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165422 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165424 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165433 */     GIR_RootConstrainSelectedInstOperands,
     /* 165434 */     // GIR_Coverage, 8435,
     /* 165434 */     GIR_EraseRootFromParent_Done,
     /* 165435 */   // Label 3609: @165435
     /* 165435 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(165468), // Rule ID 8431 //
     /* 165440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 165443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165455 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 165455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 165458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165460 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165464 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165466 */     GIR_RootConstrainSelectedInstOperands,
     /* 165467 */     // GIR_Coverage, 8431,
     /* 165467 */     GIR_EraseRootFromParent_Done,
     /* 165468 */   // Label 3610: @165468
     /* 165468 */   GIM_Reject,
     /* 165469 */ // Label 3606: @165469
     /* 165469 */ GIM_Reject,
     /* 165470 */ // Label 3530: @165470
     /* 165470 */ GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(166206),
     /* 165475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 165478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 165481 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 165484 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(165552), // Rule ID 1151 //
     /* 165489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165532 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSYm),
     /* 165535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165539 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165550 */     GIR_RootConstrainSelectedInstOperands,
     /* 165551 */     // GIR_Coverage, 1151,
     /* 165551 */     GIR_EraseRootFromParent_Done,
     /* 165552 */   // Label 3612: @165552
     /* 165552 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(165620), // Rule ID 9638 //
     /* 165557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165600 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ256m),
     /* 165603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165607 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165618 */     GIR_RootConstrainSelectedInstOperands,
     /* 165619 */     // GIR_Coverage, 9638,
     /* 165619 */     GIR_EraseRootFromParent_Done,
     /* 165620 */   // Label 3613: @165620
     /* 165620 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(165688), // Rule ID 23288 //
     /* 165625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165640 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165643 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165647 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165668 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 165668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 165671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165673 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165679 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165686 */     GIR_RootConstrainSelectedInstOperands,
     /* 165687 */     // GIR_Coverage, 23288,
     /* 165687 */     GIR_EraseRootFromParent_Done,
     /* 165688 */   // Label 3614: @165688
     /* 165688 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(165756), // Rule ID 1149 //
     /* 165693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165712 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165736 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSYm),
     /* 165739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165741 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165754 */     GIR_RootConstrainSelectedInstOperands,
     /* 165755 */     // GIR_Coverage, 1149,
     /* 165755 */     GIR_EraseRootFromParent_Done,
     /* 165756 */   // Label 3615: @165756
     /* 165756 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(165824), // Rule ID 1395 //
     /* 165761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165780 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165787 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165804 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 165804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 165807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165815 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165822 */     GIR_RootConstrainSelectedInstOperands,
     /* 165823 */     // GIR_Coverage, 1395,
     /* 165823 */     GIR_EraseRootFromParent_Done,
     /* 165824 */   // Label 3616: @165824
     /* 165824 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(165892), // Rule ID 9098 //
     /* 165829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165855 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165872 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ256m),
     /* 165875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165877 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165879 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165890 */     GIR_RootConstrainSelectedInstOperands,
     /* 165891 */     // GIR_Coverage, 9098,
     /* 165891 */     GIR_EraseRootFromParent_Done,
     /* 165892 */   // Label 3617: @165892
     /* 165892 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(165960), // Rule ID 1147 //
     /* 165897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165940 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYm),
     /* 165943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165945 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165947 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165949 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165958 */     GIR_RootConstrainSelectedInstOperands,
     /* 165959 */     // GIR_Coverage, 1147,
     /* 165959 */     GIR_EraseRootFromParent_Done,
     /* 165960 */   // Label 3618: @165960
     /* 165960 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(166028), // Rule ID 1393 //
     /* 165965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165988 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165991 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165995 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166008 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4Yrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrm),
     /* 166011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166013 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166015 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 166017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166026 */     GIR_RootConstrainSelectedInstOperands,
     /* 166027 */     // GIR_Coverage, 1393,
     /* 166027 */     GIR_EraseRootFromParent_Done,
     /* 166028 */   // Label 3619: @166028
     /* 166028 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(166096), // Rule ID 8462 //
     /* 166033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166056 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166059 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166063 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166076 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256m),
     /* 166079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166094 */     GIR_RootConstrainSelectedInstOperands,
     /* 166095 */     // GIR_Coverage, 8462,
     /* 166095 */     GIR_EraseRootFromParent_Done,
     /* 166096 */   // Label 3620: @166096
     /* 166096 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(166133), // Rule ID 1145 //
     /* 166101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166120 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 166120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 166123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166127 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166129 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166131 */     GIR_RootConstrainSelectedInstOperands,
     /* 166132 */     // GIR_Coverage, 1145,
     /* 166132 */     GIR_EraseRootFromParent_Done,
     /* 166133 */   // Label 3621: @166133
     /* 166133 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(166168), // Rule ID 1391 //
     /* 166138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 166157 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 166157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 166162 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 166166 */     GIR_RootConstrainSelectedInstOperands,
     /* 166167 */     // GIR_Coverage, 1391,
     /* 166167 */     GIR_Done,
     /* 166168 */   // Label 3622: @166168
     /* 166168 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(166205), // Rule ID 8458 //
     /* 166173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166192 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 166192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 166195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166197 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166201 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166203 */     GIR_RootConstrainSelectedInstOperands,
     /* 166204 */     // GIR_Coverage, 8458,
     /* 166204 */     GIR_EraseRootFromParent_Done,
     /* 166205 */   // Label 3623: @166205
     /* 166205 */   GIM_Reject,
     /* 166206 */ // Label 3611: @166206
     /* 166206 */ GIM_Reject,
     /* 166207 */ // Label 3531: @166207
     /* 166207 */ GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(166451),
     /* 166212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 166215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 166218 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 166221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166225 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(166289), // Rule ID 9658 //
     /* 166230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166241 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166244 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166248 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166269 */     // (fma:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VFMADD132PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZm),
     /* 166272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166274 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166276 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166287 */     GIR_RootConstrainSelectedInstOperands,
     /* 166288 */     // GIR_Coverage, 9658,
     /* 166288 */     GIR_EraseRootFromParent_Done,
     /* 166289 */   // Label 3625: @166289
     /* 166289 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(166353), // Rule ID 9118 //
     /* 166294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166309 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166312 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166316 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166333 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VFMADD231PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZm),
     /* 166336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166338 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166340 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166342 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166351 */     GIR_RootConstrainSelectedInstOperands,
     /* 166352 */     // GIR_Coverage, 9118,
     /* 166352 */     GIR_EraseRootFromParent_Done,
     /* 166353 */   // Label 3626: @166353
     /* 166353 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(166417), // Rule ID 8486 //
     /* 166358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166377 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166397 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZm),
     /* 166400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166402 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166406 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166415 */     GIR_RootConstrainSelectedInstOperands,
     /* 166416 */     // GIR_Coverage, 8486,
     /* 166416 */     GIR_EraseRootFromParent_Done,
     /* 166417 */   // Label 3627: @166417
     /* 166417 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(166450), // Rule ID 8482 //
     /* 166422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166437 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 166437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 166440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166442 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166444 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166446 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166448 */     GIR_RootConstrainSelectedInstOperands,
     /* 166449 */     // GIR_Coverage, 8482,
     /* 166449 */     GIR_EraseRootFromParent_Done,
     /* 166450 */   // Label 3628: @166450
     /* 166450 */   GIM_Reject,
     /* 166451 */ // Label 3624: @166451
     /* 166451 */ GIM_Reject,
     /* 166452 */ // Label 3532: @166452
     /* 166452 */ GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(166696),
     /* 166457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 166460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 166463 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 166466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166470 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(166534), // Rule ID 9606 //
     /* 166475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 166478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166514 */     // (fma:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VFMADD132PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ256m),
     /* 166517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166519 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166521 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166532 */     GIR_RootConstrainSelectedInstOperands,
     /* 166533 */     // GIR_Coverage, 9606,
     /* 166533 */     GIR_EraseRootFromParent_Done,
     /* 166534 */   // Label 3630: @166534
     /* 166534 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(166598), // Rule ID 9066 //
     /* 166539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 166542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166554 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166561 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166578 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VFMADD231PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ256m),
     /* 166581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166583 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166585 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166587 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166596 */     GIR_RootConstrainSelectedInstOperands,
     /* 166597 */     // GIR_Coverage, 9066,
     /* 166597 */     GIR_EraseRootFromParent_Done,
     /* 166598 */   // Label 3631: @166598
     /* 166598 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(166662), // Rule ID 8423 //
     /* 166603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 166606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166622 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166625 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166629 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166642 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256m),
     /* 166645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166647 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166649 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166660 */     GIR_RootConstrainSelectedInstOperands,
     /* 166661 */     // GIR_Coverage, 8423,
     /* 166661 */     GIR_EraseRootFromParent_Done,
     /* 166662 */   // Label 3632: @166662
     /* 166662 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(166695), // Rule ID 8419 //
     /* 166667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 166670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166682 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 166682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 166685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166687 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166689 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166691 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166693 */     GIR_RootConstrainSelectedInstOperands,
     /* 166694 */     // GIR_Coverage, 8419,
     /* 166694 */     GIR_EraseRootFromParent_Done,
     /* 166695 */   // Label 3633: @166695
     /* 166695 */   GIM_Reject,
     /* 166696 */ // Label 3629: @166696
     /* 166696 */ GIM_Reject,
     /* 166697 */ // Label 3533: @166697
     /* 166697 */ GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(166941),
     /* 166702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 166705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 166708 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 166711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166715 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(166779), // Rule ID 9626 //
     /* 166720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166731 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166734 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166738 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166759 */     // (fma:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VFMADD132PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZm),
     /* 166762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166764 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166766 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166768 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166777 */     GIR_RootConstrainSelectedInstOperands,
     /* 166778 */     // GIR_Coverage, 9626,
     /* 166778 */     GIR_EraseRootFromParent_Done,
     /* 166779 */   // Label 3635: @166779
     /* 166779 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(166843), // Rule ID 9086 //
     /* 166784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166799 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166806 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166823 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VFMADD231PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZm),
     /* 166826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166828 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166830 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166841 */     GIR_RootConstrainSelectedInstOperands,
     /* 166842 */     // GIR_Coverage, 9086,
     /* 166842 */     GIR_EraseRootFromParent_Done,
     /* 166843 */   // Label 3636: @166843
     /* 166843 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(166907), // Rule ID 8447 //
     /* 166848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166867 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166870 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166874 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166887 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZm),
     /* 166890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166892 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166894 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166896 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166905 */     GIR_RootConstrainSelectedInstOperands,
     /* 166906 */     // GIR_Coverage, 8447,
     /* 166906 */     GIR_EraseRootFromParent_Done,
     /* 166907 */   // Label 3637: @166907
     /* 166907 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(166940), // Rule ID 8443 //
     /* 166912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166927 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 166927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 166930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166932 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166934 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166936 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166938 */     GIR_RootConstrainSelectedInstOperands,
     /* 166939 */     // GIR_Coverage, 8443,
     /* 166939 */     GIR_EraseRootFromParent_Done,
     /* 166940 */   // Label 3638: @166940
     /* 166940 */   GIM_Reject,
     /* 166941 */ // Label 3634: @166941
     /* 166941 */ GIM_Reject,
     /* 166942 */ // Label 3534: @166942
     /* 166942 */ GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(167186),
     /* 166947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 166950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 166953 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 166956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166960 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(167024), // Rule ID 9594 //
     /* 166965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 166968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166976 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166979 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166983 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167004 */     // (fma:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VFMADD132PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZm),
     /* 167007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167011 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 167013 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167022 */     GIR_RootConstrainSelectedInstOperands,
     /* 167023 */     // GIR_Coverage, 9594,
     /* 167023 */     GIR_EraseRootFromParent_Done,
     /* 167024 */   // Label 3640: @167024
     /* 167024 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(167088), // Rule ID 9054 //
     /* 167029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 167032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167044 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167051 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167068 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VFMADD231PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZm),
     /* 167071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167073 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 167075 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167077 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167086 */     GIR_RootConstrainSelectedInstOperands,
     /* 167087 */     // GIR_Coverage, 9054,
     /* 167087 */     GIR_EraseRootFromParent_Done,
     /* 167088 */   // Label 3641: @167088
     /* 167088 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(167152), // Rule ID 8408 //
     /* 167093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 167096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167132 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZm),
     /* 167135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167137 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167139 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167150 */     GIR_RootConstrainSelectedInstOperands,
     /* 167151 */     // GIR_Coverage, 8408,
     /* 167151 */     GIR_EraseRootFromParent_Done,
     /* 167152 */   // Label 3642: @167152
     /* 167152 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(167185), // Rule ID 8404 //
     /* 167157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 167160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 167172 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 167172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 167175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167177 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167179 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167181 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167183 */     GIR_RootConstrainSelectedInstOperands,
     /* 167184 */     // GIR_Coverage, 8404,
     /* 167184 */     GIR_EraseRootFromParent_Done,
     /* 167185 */   // Label 3643: @167185
     /* 167185 */   GIM_Reject,
     /* 167186 */ // Label 3639: @167186
     /* 167186 */ GIM_Reject,
     /* 167187 */ // Label 3535: @167187
     /* 167187 */ GIM_Reject,
     /* 167188 */ // Label 45: @167188
     /* 167188 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3657*/ GIMT_Encode4(170605),
     /* 167199 */ /*GILLT_s16*//*Label 3644*/ GIMT_Encode4(167283),
     /* 167203 */ /*GILLT_s32*//*Label 3645*/ GIMT_Encode4(167381),
     /* 167207 */ /*GILLT_s64*//*Label 3646*/ GIMT_Encode4(168086),
     /* 167211 */ /*GILLT_s80*//*Label 3647*/ GIMT_Encode4(168935), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 167223 */ /*GILLT_v2s64*//*Label 3648*/ GIMT_Encode4(169257), GIMT_Encode4(0),
     /* 167231 */ /*GILLT_v4s32*//*Label 3649*/ GIMT_Encode4(169487),
     /* 167235 */ /*GILLT_v4s64*//*Label 3650*/ GIMT_Encode4(169717), GIMT_Encode4(0),
     /* 167243 */ /*GILLT_v8s16*//*Label 3651*/ GIMT_Encode4(169916),
     /* 167247 */ /*GILLT_v8s32*//*Label 3652*/ GIMT_Encode4(170014),
     /* 167251 */ /*GILLT_v8s64*//*Label 3653*/ GIMT_Encode4(170213), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 167263 */ /*GILLT_v16s16*//*Label 3654*/ GIMT_Encode4(170311),
     /* 167267 */ /*GILLT_v16s32*//*Label 3655*/ GIMT_Encode4(170409), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 167279 */ /*GILLT_v32s16*//*Label 3656*/ GIMT_Encode4(170507),
     /* 167283 */ // Label 3644: @167283
     /* 167283 */ GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(167380),
     /* 167288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 167291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 167298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 167302 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(167356), // Rule ID 6125 //
     /* 167307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 167310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167318 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167338 */     // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrm),
     /* 167341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167343 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167354 */     GIR_RootConstrainSelectedInstOperands,
     /* 167355 */     // GIR_Coverage, 6125,
     /* 167355 */     GIR_EraseRootFromParent_Done,
     /* 167356 */   // Label 3659: @167356
     /* 167356 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(167379), // Rule ID 6123 //
     /* 167361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 167364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 167368 */     // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 167368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 167373 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 167377 */     GIR_RootConstrainSelectedInstOperands,
     /* 167378 */     // GIR_Coverage, 6123,
     /* 167378 */     GIR_Done,
     /* 167379 */   // Label 3660: @167379
     /* 167379 */   GIM_Reject,
     /* 167380 */ // Label 3658: @167380
     /* 167380 */ GIM_Reject,
     /* 167381 */ // Label 3645: @167381
     /* 167381 */ GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(168085),
     /* 167386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167392 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(167474), // Rule ID 22484 //
     /* 167397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 167400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 167416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 167424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167428 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 167435 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 167442 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 167446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 167448 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167455 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 167458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 167472 */     GIR_RootConstrainSelectedInstOperands,
     /* 167473 */     // GIR_Coverage, 22484,
     /* 167473 */     GIR_EraseRootFromParent_Done,
     /* 167474 */   // Label 3662: @167474
     /* 167474 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(167556), // Rule ID 22485 //
     /* 167479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 167482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 167498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 167506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167510 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 167517 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 167524 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 167528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 167530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167537 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 167540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167542 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167544 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 167554 */     GIR_RootConstrainSelectedInstOperands,
     /* 167555 */     // GIR_Coverage, 22485,
     /* 167555 */     GIR_EraseRootFromParent_Done,
     /* 167556 */   // Label 3663: @167556
     /* 167556 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(167638), // Rule ID 22486 //
     /* 167561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 167564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 167580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 167588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167592 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 167599 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 167606 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 167610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 167612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167619 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 167622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167624 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 167636 */     GIR_RootConstrainSelectedInstOperands,
     /* 167637 */     // GIR_Coverage, 22486,
     /* 167637 */     GIR_EraseRootFromParent_Done,
     /* 167638 */   // Label 3664: @167638
     /* 167638 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(167703), // Rule ID 1020 //
     /* 167643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 167646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167658 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167661 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167665 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167682 */     // (fdiv:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp32m),
     /* 167685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167687 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 167696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167701 */     GIR_RootConstrainSelectedInstOperands,
     /* 167702 */     // GIR_Coverage, 1020,
     /* 167702 */     GIR_EraseRootFromParent_Done,
     /* 167703 */   // Label 3665: @167703
     /* 167703 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(167768), // Rule ID 998 //
     /* 167708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 167711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167727 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167730 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167734 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167747 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32m),
     /* 167750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167752 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 167761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167766 */     GIR_RootConstrainSelectedInstOperands,
     /* 167767 */     // GIR_Coverage, 998,
     /* 167767 */     GIR_EraseRootFromParent_Done,
     /* 167768 */   // Label 3666: @167768
     /* 167768 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(167830), // Rule ID 2280 //
     /* 167773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 167776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167812 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 167815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167828 */     GIR_RootConstrainSelectedInstOperands,
     /* 167829 */     // GIR_Coverage, 2280,
     /* 167829 */     GIR_EraseRootFromParent_Done,
     /* 167830 */   // Label 3667: @167830
     /* 167830 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(167892), // Rule ID 2288 //
     /* 167835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 167838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167861 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167874 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 167877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167879 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167890 */     GIR_RootConstrainSelectedInstOperands,
     /* 167891 */     // GIR_Coverage, 2288,
     /* 167891 */     GIR_EraseRootFromParent_Done,
     /* 167892 */   // Label 3668: @167892
     /* 167892 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(167954), // Rule ID 6087 //
     /* 167897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 167900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167916 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167919 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167923 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167936 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 167939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167941 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167952 */     GIR_RootConstrainSelectedInstOperands,
     /* 167953 */     // GIR_Coverage, 6087,
     /* 167953 */     GIR_EraseRootFromParent_Done,
     /* 167954 */   // Label 3669: @167954
     /* 167954 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(167991), // Rule ID 904 //
     /* 167959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 167962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167974 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 167974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 167979 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 167985 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 167989 */     GIR_RootConstrainSelectedInstOperands,
     /* 167990 */     // GIR_Coverage, 904,
     /* 167990 */     GIR_Done,
     /* 167991 */   // Label 3670: @167991
     /* 167991 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(168022), // Rule ID 2278 //
     /* 167996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 167999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 168003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 168007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 168011 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 168011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 168016 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168020 */     GIR_RootConstrainSelectedInstOperands,
     /* 168021 */     // GIR_Coverage, 2278,
     /* 168021 */     GIR_Done,
     /* 168022 */   // Label 3671: @168022
     /* 168022 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(168053), // Rule ID 2286 //
     /* 168027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 168030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 168034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 168038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 168042 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 168042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 168047 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168051 */     GIR_RootConstrainSelectedInstOperands,
     /* 168052 */     // GIR_Coverage, 2286,
     /* 168052 */     GIR_Done,
     /* 168053 */   // Label 3672: @168053
     /* 168053 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(168084), // Rule ID 6085 //
     /* 168058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 168065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 168069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 168073 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 168073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 168078 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168082 */     GIR_RootConstrainSelectedInstOperands,
     /* 168083 */     // GIR_Coverage, 6085,
     /* 168083 */     GIR_Done,
     /* 168084 */   // Label 3673: @168084
     /* 168084 */   GIM_Reject,
     /* 168085 */ // Label 3661: @168085
     /* 168085 */ GIM_Reject,
     /* 168086 */ // Label 3646: @168086
     /* 168086 */ GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(168934),
     /* 168091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168097 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(168179), // Rule ID 22487 //
     /* 168102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 168105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 168121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 168125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 168129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168133 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 168136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 168140 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 168147 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 168151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 168153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168160 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 168163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 168177 */     GIR_RootConstrainSelectedInstOperands,
     /* 168178 */     // GIR_Coverage, 22487,
     /* 168178 */     GIR_EraseRootFromParent_Done,
     /* 168179 */   // Label 3675: @168179
     /* 168179 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(168261), // Rule ID 22488 //
     /* 168184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 168187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 168203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 168207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 168211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168215 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 168218 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 168222 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 168229 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 168233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 168235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168242 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 168245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168247 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168249 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 168259 */     GIR_RootConstrainSelectedInstOperands,
     /* 168260 */     // GIR_Coverage, 22488,
     /* 168260 */     GIR_EraseRootFromParent_Done,
     /* 168261 */   // Label 3676: @168261
     /* 168261 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(168343), // Rule ID 22489 //
     /* 168266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 168285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 168289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 168293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168297 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 168300 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 168304 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 168311 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 168315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 168317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168324 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 168327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168329 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 168341 */     GIR_RootConstrainSelectedInstOperands,
     /* 168342 */     // GIR_Coverage, 22489,
     /* 168342 */     GIR_EraseRootFromParent_Done,
     /* 168343 */   // Label 3677: @168343
     /* 168343 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(168408), // Rule ID 1022 //
     /* 168348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 168351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168363 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168366 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168370 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168387 */     // (fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m),
     /* 168390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168392 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168394 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 168401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168406 */     GIR_RootConstrainSelectedInstOperands,
     /* 168407 */     // GIR_Coverage, 1022,
     /* 168407 */     GIR_EraseRootFromParent_Done,
     /* 168408 */   // Label 3678: @168408
     /* 168408 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(168480), // Rule ID 1024 //
     /* 168413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 168416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168431 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168435 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 168442 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168459 */     // (fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m32),
     /* 168462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168464 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168466 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 168473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168478 */     GIR_RootConstrainSelectedInstOperands,
     /* 168479 */     // GIR_Coverage, 1024,
     /* 168479 */     GIR_EraseRootFromParent_Done,
     /* 168480 */   // Label 3679: @168480
     /* 168480 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(168545), // Rule ID 1000 //
     /* 168485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 168488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168524 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m),
     /* 168527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168529 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 168538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168543 */     GIR_RootConstrainSelectedInstOperands,
     /* 168544 */     // GIR_Coverage, 1000,
     /* 168544 */     GIR_EraseRootFromParent_Done,
     /* 168545 */   // Label 3680: @168545
     /* 168545 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(168617), // Rule ID 1002 //
     /* 168550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 168553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168569 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168572 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168576 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 168583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168596 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m32),
     /* 168599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168601 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 168610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168615 */     GIR_RootConstrainSelectedInstOperands,
     /* 168616 */     // GIR_Coverage, 1002,
     /* 168616 */     GIR_EraseRootFromParent_Done,
     /* 168617 */   // Label 3681: @168617
     /* 168617 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(168679), // Rule ID 2284 //
     /* 168622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 168625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168641 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168648 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168661 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 168664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168668 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168677 */     GIR_RootConstrainSelectedInstOperands,
     /* 168678 */     // GIR_Coverage, 2284,
     /* 168678 */     GIR_EraseRootFromParent_Done,
     /* 168679 */   // Label 3682: @168679
     /* 168679 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(168741), // Rule ID 2292 //
     /* 168684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 168687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168703 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168710 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168723 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 168726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168728 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168730 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168739 */     GIR_RootConstrainSelectedInstOperands,
     /* 168740 */     // GIR_Coverage, 2292,
     /* 168740 */     GIR_EraseRootFromParent_Done,
     /* 168741 */   // Label 3683: @168741
     /* 168741 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(168803), // Rule ID 6106 //
     /* 168746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168765 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168768 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168772 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168785 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 168788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168790 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168801 */     GIR_RootConstrainSelectedInstOperands,
     /* 168802 */     // GIR_Coverage, 6106,
     /* 168802 */     GIR_EraseRootFromParent_Done,
     /* 168803 */   // Label 3684: @168803
     /* 168803 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(168840), // Rule ID 906 //
     /* 168808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 168811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168823 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 168823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 168828 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 168834 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 168838 */     GIR_RootConstrainSelectedInstOperands,
     /* 168839 */     // GIR_Coverage, 906,
     /* 168839 */     GIR_Done,
     /* 168840 */   // Label 3685: @168840
     /* 168840 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(168871), // Rule ID 2282 //
     /* 168845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 168848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168860 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 168860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 168865 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168869 */     GIR_RootConstrainSelectedInstOperands,
     /* 168870 */     // GIR_Coverage, 2282,
     /* 168870 */     GIR_Done,
     /* 168871 */   // Label 3686: @168871
     /* 168871 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(168902), // Rule ID 2290 //
     /* 168876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 168879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168891 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 168891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 168896 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168900 */     GIR_RootConstrainSelectedInstOperands,
     /* 168901 */     // GIR_Coverage, 2290,
     /* 168901 */     GIR_Done,
     /* 168902 */   // Label 3687: @168902
     /* 168902 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(168933), // Rule ID 6104 //
     /* 168907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168922 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 168922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 168927 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168931 */     GIR_RootConstrainSelectedInstOperands,
     /* 168932 */     // GIR_Coverage, 6104,
     /* 168932 */     GIR_Done,
     /* 168933 */   // Label 3688: @168933
     /* 168933 */   GIM_Reject,
     /* 168934 */ // Label 3674: @168934
     /* 168934 */ GIM_Reject,
     /* 168935 */ // Label 3647: @168935
     /* 168935 */ GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(169256),
     /* 168940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 168943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 168946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 168950 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(169018), // Rule ID 1026 //
     /* 168955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 168958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168966 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168969 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168973 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 168980 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 168988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168997 */     // (fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m32),
     /* 169000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169002 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 169011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169016 */     GIR_RootConstrainSelectedInstOperands,
     /* 169017 */     // GIR_Coverage, 1026,
     /* 169017 */     GIR_EraseRootFromParent_Done,
     /* 169018 */   // Label 3690: @169018
     /* 169018 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(169086), // Rule ID 1028 //
     /* 169023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 169026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169034 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169037 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169041 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 169048 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 169056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169065 */     // (fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m64),
     /* 169068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169070 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169076 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 169079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169084 */     GIR_RootConstrainSelectedInstOperands,
     /* 169085 */     // GIR_Coverage, 1028,
     /* 169085 */     GIR_EraseRootFromParent_Done,
     /* 169086 */   // Label 3691: @169086
     /* 169086 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(169154), // Rule ID 1004 //
     /* 169091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 169094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 169098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169106 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169109 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169113 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 169120 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169133 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m32),
     /* 169136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169138 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169140 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 169147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169152 */     GIR_RootConstrainSelectedInstOperands,
     /* 169153 */     // GIR_Coverage, 1004,
     /* 169153 */     GIR_EraseRootFromParent_Done,
     /* 169154 */   // Label 3692: @169154
     /* 169154 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(169222), // Rule ID 1006 //
     /* 169159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 169162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 169166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169177 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169181 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 169188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169201 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (DIV_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m64),
     /* 169204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169206 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 169215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169220 */     GIR_RootConstrainSelectedInstOperands,
     /* 169221 */     // GIR_Coverage, 1006,
     /* 169221 */     GIR_EraseRootFromParent_Done,
     /* 169222 */   // Label 3693: @169222
     /* 169222 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(169255), // Rule ID 908 //
     /* 169227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 169230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 169234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 169238 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 169238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 169243 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 169249 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 169253 */     GIR_RootConstrainSelectedInstOperands,
     /* 169254 */     // GIR_Coverage, 908,
     /* 169254 */     GIR_Done,
     /* 169255 */   // Label 3694: @169255
     /* 169255 */   GIM_Reject,
     /* 169256 */ // Label 3689: @169256
     /* 169256 */ GIM_Reject,
     /* 169257 */ // Label 3648: @169257
     /* 169257 */ GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(169486),
     /* 169262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 169265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169268 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(169330), // Rule ID 2260 //
     /* 169273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169292 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169312 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDrm),
     /* 169315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169317 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169328 */     GIR_RootConstrainSelectedInstOperands,
     /* 169329 */     // GIR_Coverage, 2260,
     /* 169329 */     GIR_EraseRootFromParent_Done,
     /* 169330 */   // Label 3696: @169330
     /* 169330 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(169392), // Rule ID 6659 //
     /* 169335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169354 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169361 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169374 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rm),
     /* 169377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169379 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169390 */     GIR_RootConstrainSelectedInstOperands,
     /* 169391 */     // GIR_Coverage, 6659,
     /* 169391 */     GIR_EraseRootFromParent_Done,
     /* 169392 */   // Label 3697: @169392
     /* 169392 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(169423), // Rule ID 2258 //
     /* 169397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169412 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 169412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 169417 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169421 */     GIR_RootConstrainSelectedInstOperands,
     /* 169422 */     // GIR_Coverage, 2258,
     /* 169422 */     GIR_Done,
     /* 169423 */   // Label 3698: @169423
     /* 169423 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(169454), // Rule ID 2274 //
     /* 169428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 169431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169443 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 169443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 169448 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169452 */     GIR_RootConstrainSelectedInstOperands,
     /* 169453 */     // GIR_Coverage, 2274,
     /* 169453 */     GIR_Done,
     /* 169454 */   // Label 3699: @169454
     /* 169454 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(169485), // Rule ID 6655 //
     /* 169459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169474 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 169474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 169479 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169483 */     GIR_RootConstrainSelectedInstOperands,
     /* 169484 */     // GIR_Coverage, 6655,
     /* 169484 */     GIR_Done,
     /* 169485 */   // Label 3700: @169485
     /* 169485 */   GIM_Reject,
     /* 169486 */ // Label 3695: @169486
     /* 169486 */ GIM_Reject,
     /* 169487 */ // Label 3649: @169487
     /* 169487 */ GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(169716),
     /* 169492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 169495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169498 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(169560), // Rule ID 2256 //
     /* 169503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169529 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169542 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSrm),
     /* 169545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169547 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169549 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169558 */     GIR_RootConstrainSelectedInstOperands,
     /* 169559 */     // GIR_Coverage, 2256,
     /* 169559 */     GIR_EraseRootFromParent_Done,
     /* 169560 */   // Label 3702: @169560
     /* 169560 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(169622), // Rule ID 6635 //
     /* 169565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169604 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rm),
     /* 169607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169609 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169620 */     GIR_RootConstrainSelectedInstOperands,
     /* 169621 */     // GIR_Coverage, 6635,
     /* 169621 */     GIR_EraseRootFromParent_Done,
     /* 169622 */   // Label 3703: @169622
     /* 169622 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(169653), // Rule ID 2254 //
     /* 169627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169642 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 169642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 169647 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169651 */     GIR_RootConstrainSelectedInstOperands,
     /* 169652 */     // GIR_Coverage, 2254,
     /* 169652 */     GIR_Done,
     /* 169653 */   // Label 3704: @169653
     /* 169653 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(169684), // Rule ID 2270 //
     /* 169658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 169661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169673 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 169673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 169678 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169682 */     GIR_RootConstrainSelectedInstOperands,
     /* 169683 */     // GIR_Coverage, 2270,
     /* 169683 */     GIR_Done,
     /* 169684 */   // Label 3705: @169684
     /* 169684 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(169715), // Rule ID 6631 //
     /* 169689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169704 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 169704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 169709 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169713 */     GIR_RootConstrainSelectedInstOperands,
     /* 169714 */     // GIR_Coverage, 6631,
     /* 169714 */     GIR_Done,
     /* 169715 */   // Label 3706: @169715
     /* 169715 */   GIM_Reject,
     /* 169716 */ // Label 3701: @169716
     /* 169716 */ GIM_Reject,
     /* 169717 */ // Label 3650: @169717
     /* 169717 */ GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(169915),
     /* 169722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 169725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 169728 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(169790), // Rule ID 2268 //
     /* 169733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169752 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169755 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169759 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169772 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrm),
     /* 169775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169777 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169779 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169788 */     GIR_RootConstrainSelectedInstOperands,
     /* 169789 */     // GIR_Coverage, 2268,
     /* 169789 */     GIR_EraseRootFromParent_Done,
     /* 169790 */   // Label 3708: @169790
     /* 169790 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(169852), // Rule ID 6671 //
     /* 169795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169814 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169817 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169821 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169834 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rm),
     /* 169837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169839 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169841 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169850 */     GIR_RootConstrainSelectedInstOperands,
     /* 169851 */     // GIR_Coverage, 6671,
     /* 169851 */     GIR_EraseRootFromParent_Done,
     /* 169852 */   // Label 3709: @169852
     /* 169852 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(169883), // Rule ID 2266 //
     /* 169857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169872 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 169872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 169877 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169881 */     GIR_RootConstrainSelectedInstOperands,
     /* 169882 */     // GIR_Coverage, 2266,
     /* 169882 */     GIR_Done,
     /* 169883 */   // Label 3710: @169883
     /* 169883 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(169914), // Rule ID 6667 //
     /* 169888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169903 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 169903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 169908 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169912 */     GIR_RootConstrainSelectedInstOperands,
     /* 169913 */     // GIR_Coverage, 6667,
     /* 169913 */     GIR_Done,
     /* 169914 */   // Label 3711: @169914
     /* 169914 */   GIM_Reject,
     /* 169915 */ // Label 3707: @169915
     /* 169915 */ GIM_Reject,
     /* 169916 */ // Label 3651: @169916
     /* 169916 */ GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(170013),
     /* 169921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 169924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169935 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(169989), // Rule ID 6695 //
     /* 169940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169951 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169958 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169971 */     // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rm),
     /* 169974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169976 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169978 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169987 */     GIR_RootConstrainSelectedInstOperands,
     /* 169988 */     // GIR_Coverage, 6695,
     /* 169988 */     GIR_EraseRootFromParent_Done,
     /* 169989 */   // Label 3713: @169989
     /* 169989 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(170012), // Rule ID 6691 //
     /* 169994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 170001 */     // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 170001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 170006 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170010 */     GIR_RootConstrainSelectedInstOperands,
     /* 170011 */     // GIR_Coverage, 6691,
     /* 170011 */     GIR_Done,
     /* 170012 */   // Label 3714: @170012
     /* 170012 */   GIM_Reject,
     /* 170013 */ // Label 3712: @170013
     /* 170013 */ GIM_Reject,
     /* 170014 */ // Label 3652: @170014
     /* 170014 */ GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(170212),
     /* 170019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 170022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 170025 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(170087), // Rule ID 2264 //
     /* 170030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 170033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 170037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 170041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170049 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170052 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170056 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170069 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrm),
     /* 170072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170074 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170085 */     GIR_RootConstrainSelectedInstOperands,
     /* 170086 */     // GIR_Coverage, 2264,
     /* 170086 */     GIR_EraseRootFromParent_Done,
     /* 170087 */   // Label 3716: @170087
     /* 170087 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(170149), // Rule ID 6647 //
     /* 170092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 170095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170111 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170114 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170118 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170131 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rm),
     /* 170134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170136 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170138 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170147 */     GIR_RootConstrainSelectedInstOperands,
     /* 170148 */     // GIR_Coverage, 6647,
     /* 170148 */     GIR_EraseRootFromParent_Done,
     /* 170149 */   // Label 3717: @170149
     /* 170149 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(170180), // Rule ID 2262 //
     /* 170154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 170157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 170161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 170165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 170169 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 170169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 170174 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170178 */     GIR_RootConstrainSelectedInstOperands,
     /* 170179 */     // GIR_Coverage, 2262,
     /* 170179 */     GIR_Done,
     /* 170180 */   // Label 3718: @170180
     /* 170180 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(170211), // Rule ID 6643 //
     /* 170185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 170188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170200 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 170200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 170205 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170209 */     GIR_RootConstrainSelectedInstOperands,
     /* 170210 */     // GIR_Coverage, 6643,
     /* 170210 */     GIR_Done,
     /* 170211 */   // Label 3719: @170211
     /* 170211 */   GIM_Reject,
     /* 170212 */ // Label 3715: @170212
     /* 170212 */ GIM_Reject,
     /* 170213 */ // Label 3653: @170213
     /* 170213 */ GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(170310),
     /* 170218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 170221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 170224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170232 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(170286), // Rule ID 6623 //
     /* 170237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170248 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170255 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170268 */     // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrm),
     /* 170271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170284 */     GIR_RootConstrainSelectedInstOperands,
     /* 170285 */     // GIR_Coverage, 6623,
     /* 170285 */     GIR_EraseRootFromParent_Done,
     /* 170286 */   // Label 3721: @170286
     /* 170286 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(170309), // Rule ID 6619 //
     /* 170291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170298 */     // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 170298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 170303 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170307 */     GIR_RootConstrainSelectedInstOperands,
     /* 170308 */     // GIR_Coverage, 6619,
     /* 170308 */     GIR_Done,
     /* 170309 */   // Label 3722: @170309
     /* 170309 */   GIM_Reject,
     /* 170310 */ // Label 3720: @170310
     /* 170310 */ GIM_Reject,
     /* 170311 */ // Label 3654: @170311
     /* 170311 */ GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(170408),
     /* 170316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 170319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 170322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170330 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(170384), // Rule ID 6707 //
     /* 170335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 170338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170346 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170353 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170366 */     // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rm),
     /* 170369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170371 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170373 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170382 */     GIR_RootConstrainSelectedInstOperands,
     /* 170383 */     // GIR_Coverage, 6707,
     /* 170383 */     GIR_EraseRootFromParent_Done,
     /* 170384 */   // Label 3724: @170384
     /* 170384 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(170407), // Rule ID 6703 //
     /* 170389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 170392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170396 */     // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 170396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 170401 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170405 */     GIR_RootConstrainSelectedInstOperands,
     /* 170406 */     // GIR_Coverage, 6703,
     /* 170406 */     GIR_Done,
     /* 170407 */   // Label 3725: @170407
     /* 170407 */   GIM_Reject,
     /* 170408 */ // Label 3723: @170408
     /* 170408 */ GIM_Reject,
     /* 170409 */ // Label 3655: @170409
     /* 170409 */ GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(170506),
     /* 170414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 170417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 170420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170428 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(170482), // Rule ID 6611 //
     /* 170433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170444 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170447 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170464 */     // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrm),
     /* 170467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170480 */     GIR_RootConstrainSelectedInstOperands,
     /* 170481 */     // GIR_Coverage, 6611,
     /* 170481 */     GIR_EraseRootFromParent_Done,
     /* 170482 */   // Label 3727: @170482
     /* 170482 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(170505), // Rule ID 6607 //
     /* 170487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170494 */     // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 170494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 170499 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170503 */     GIR_RootConstrainSelectedInstOperands,
     /* 170504 */     // GIR_Coverage, 6607,
     /* 170504 */     GIR_Done,
     /* 170505 */   // Label 3728: @170505
     /* 170505 */   GIM_Reject,
     /* 170506 */ // Label 3726: @170506
     /* 170506 */ GIM_Reject,
     /* 170507 */ // Label 3656: @170507
     /* 170507 */ GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(170604),
     /* 170512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 170515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 170518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170526 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(170580), // Rule ID 6683 //
     /* 170531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 170534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170542 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170545 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170549 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170562 */     // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrm),
     /* 170565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170567 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170578 */     GIR_RootConstrainSelectedInstOperands,
     /* 170579 */     // GIR_Coverage, 6683,
     /* 170579 */     GIR_EraseRootFromParent_Done,
     /* 170580 */   // Label 3730: @170580
     /* 170580 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(170603), // Rule ID 6679 //
     /* 170585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 170588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170592 */     // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 170592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 170597 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170601 */     GIR_RootConstrainSelectedInstOperands,
     /* 170602 */     // GIR_Coverage, 6679,
     /* 170602 */     GIR_Done,
     /* 170603 */   // Label 3731: @170603
     /* 170603 */   GIM_Reject,
     /* 170604 */ // Label 3729: @170604
     /* 170604 */ GIM_Reject,
     /* 170605 */ // Label 3657: @170605
     /* 170605 */ GIM_Reject,
     /* 170606 */ // Label 46: @170606
     /* 170606 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 3735*/ GIMT_Encode4(170728),
     /* 170617 */ /*GILLT_s32*//*Label 3732*/ GIMT_Encode4(170629),
     /* 170621 */ /*GILLT_s64*//*Label 3733*/ GIMT_Encode4(170662),
     /* 170625 */ /*GILLT_s80*//*Label 3734*/ GIMT_Encode4(170695),
     /* 170629 */ // Label 3732: @170629
     /* 170629 */ GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(170661), // Rule ID 1041 //
     /* 170634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170648 */   // (fneg:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 170648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 170653 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 170659 */   GIR_RootConstrainSelectedInstOperands,
     /* 170660 */   // GIR_Coverage, 1041,
     /* 170660 */   GIR_Done,
     /* 170661 */ // Label 3736: @170661
     /* 170661 */ GIM_Reject,
     /* 170662 */ // Label 3733: @170662
     /* 170662 */ GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(170694), // Rule ID 1042 //
     /* 170667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 170670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 170677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 170681 */   // (fneg:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 170681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 170686 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 170692 */   GIR_RootConstrainSelectedInstOperands,
     /* 170693 */   // GIR_Coverage, 1042,
     /* 170693 */   GIR_Done,
     /* 170694 */ // Label 3737: @170694
     /* 170694 */ GIM_Reject,
     /* 170695 */ // Label 3734: @170695
     /* 170695 */ GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(170727), // Rule ID 1043 //
     /* 170700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 170703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 170706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 170710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 170714 */   // (fneg:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 170714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 170719 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 170725 */   GIR_RootConstrainSelectedInstOperands,
     /* 170726 */   // GIR_Coverage, 1043,
     /* 170726 */   GIR_Done,
     /* 170727 */ // Label 3738: @170727
     /* 170727 */ GIM_Reject,
     /* 170728 */ // Label 3735: @170728
     /* 170728 */ GIM_Reject,
     /* 170729 */ // Label 47: @170729
     /* 170729 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(20), /*)*//*default:*//*Label 3746*/ GIMT_Encode4(171660),
     /* 170740 */ /*GILLT_s32*//*Label 3739*/ GIMT_Encode4(170808),
     /* 170744 */ /*GILLT_s64*//*Label 3740*/ GIMT_Encode4(170929),
     /* 170748 */ /*GILLT_s80*//*Label 3741*/ GIMT_Encode4(171412), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 170772 */ /*GILLT_v4s64*//*Label 3742*/ GIMT_Encode4(171473), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 170784 */ /*GILLT_v8s32*//*Label 3743*/ GIMT_Encode4(171537),
     /* 170788 */ /*GILLT_v8s64*//*Label 3744*/ GIMT_Encode4(171568), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 170804 */ /*GILLT_v16s32*//*Label 3745*/ GIMT_Encode4(171629),
     /* 170808 */ // Label 3739: @170808
     /* 170808 */ GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(170928),
     /* 170813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 170816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170820 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(170889), // Rule ID 21203 //
     /* 170825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 170828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170836 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170856 */     // (fpextend:{ *:[f32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSH2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 170856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 170859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrm),
     /* 170873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170878 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 170882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170887 */     GIR_RootConstrainSelectedInstOperands,
     /* 170888 */     // GIR_Coverage, 21203,
     /* 170888 */     GIR_EraseRootFromParent_Done,
     /* 170889 */   // Label 3748: @170889
     /* 170889 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(170927), // Rule ID 21201 //
     /* 170894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 170897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 170901 */     // (fpextend:{ *:[f32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR16X:{ *:[f16] }:$src)
     /* 170901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 170904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrr),
     /* 170918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170923 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 170925 */     GIR_RootConstrainSelectedInstOperands,
     /* 170926 */     // GIR_Coverage, 21201,
     /* 170926 */     GIR_EraseRootFromParent_Done,
     /* 170927 */   // Label 3749: @170927
     /* 170927 */   GIM_Reject,
     /* 170928 */ // Label 3747: @170928
     /* 170928 */ GIM_Reject,
     /* 170929 */ // Label 3740: @170929
     /* 170929 */ GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(170988), // Rule ID 1893 //
     /* 170934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 170937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170944 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170952 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170955 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170959 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170963 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170965 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170972 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 170972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrm),
     /* 170975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170977 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 170981 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170986 */   GIR_RootConstrainSelectedInstOperands,
     /* 170987 */   // GIR_Coverage, 1893,
     /* 170987 */   GIR_EraseRootFromParent_Done,
     /* 170988 */ // Label 3750: @170988
     /* 170988 */ GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(171064), // Rule ID 18001 //
     /* 170993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 170996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171003 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171007 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171011 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171014 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171018 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171022 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171024 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171031 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 171031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrm),
     /* 171048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171053 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171057 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171062 */   GIR_RootConstrainSelectedInstOperands,
     /* 171063 */   // GIR_Coverage, 18001,
     /* 171063 */   GIR_EraseRootFromParent_Done,
     /* 171064 */ // Label 3751: @171064
     /* 171064 */ GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(171140), // Rule ID 21197 //
     /* 171069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 171072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171079 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171083 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171087 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171090 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171094 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171098 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171100 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171107 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 171107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrm),
     /* 171124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171129 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171133 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171138 */   GIR_RootConstrainSelectedInstOperands,
     /* 171139 */   // GIR_Coverage, 21197,
     /* 171139 */   GIR_EraseRootFromParent_Done,
     /* 171140 */ // Label 3752: @171140
     /* 171140 */ GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(171216), // Rule ID 21207 //
     /* 171145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 171148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 171151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171155 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171163 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171166 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171170 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171174 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171176 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171183 */   // (fpextend:{ *:[f64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSH2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 171183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrm),
     /* 171200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171202 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171205 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171214 */   GIR_RootConstrainSelectedInstOperands,
     /* 171215 */   // GIR_Coverage, 21207,
     /* 171215 */   GIR_EraseRootFromParent_Done,
     /* 171216 */ // Label 3753: @171216
     /* 171216 */ GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(171246), // Rule ID 1891 //
     /* 171221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171235 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SDrr:{ *:[f64] } FR32:{ *:[f32] }:$src)
     /* 171235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrr),
     /* 171240 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171244 */   GIR_RootConstrainSelectedInstOperands,
     /* 171245 */   // GIR_Coverage, 1891,
     /* 171245 */   GIR_Done,
     /* 171246 */ // Label 3754: @171246
     /* 171246 */ GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(171276), // Rule ID 17726 //
     /* 171251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 171254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 171265 */   // (fpextend:{ *:[f64] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP32:{ *:[f32] }:$src, RFP64:{ *:[i32] })
     /* 171265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 171275 */   // GIR_Coverage, 17726,
     /* 171275 */   GIR_Done,
     /* 171276 */ // Label 3755: @171276
     /* 171276 */ GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(171321), // Rule ID 17999 //
     /* 171281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171295 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32:{ *:[f32] }:$src)
     /* 171295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrr),
     /* 171312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171317 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171319 */   GIR_RootConstrainSelectedInstOperands,
     /* 171320 */   // GIR_Coverage, 17999,
     /* 171320 */   GIR_EraseRootFromParent_Done,
     /* 171321 */ // Label 3756: @171321
     /* 171321 */ GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(171366), // Rule ID 21195 //
     /* 171326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 171340 */   // (fpextend:{ *:[f64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32X:{ *:[f32] }:$src)
     /* 171340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrr),
     /* 171357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171359 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171362 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171364 */   GIR_RootConstrainSelectedInstOperands,
     /* 171365 */   // GIR_Coverage, 21195,
     /* 171365 */   GIR_EraseRootFromParent_Done,
     /* 171366 */ // Label 3757: @171366
     /* 171366 */ GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(171411), // Rule ID 21205 //
     /* 171371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 171377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 171385 */   // (fpextend:{ *:[f64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR16X:{ *:[f16] }:$src)
     /* 171385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrr),
     /* 171402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171404 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171407 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171409 */   GIR_RootConstrainSelectedInstOperands,
     /* 171410 */   // GIR_Coverage, 21205,
     /* 171410 */   GIR_EraseRootFromParent_Done,
     /* 171411 */ // Label 3758: @171411
     /* 171411 */ GIM_Reject,
     /* 171412 */ // Label 3741: @171412
     /* 171412 */ GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(171442), // Rule ID 17728 //
     /* 171417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 171420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 171427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 171431 */   // (fpextend:{ *:[f80] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP32:{ *:[f32] }:$src, RFP80:{ *:[i32] })
     /* 171431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171436 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 171441 */   // GIR_Coverage, 17728,
     /* 171441 */   GIR_Done,
     /* 171442 */ // Label 3759: @171442
     /* 171442 */ GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(171472), // Rule ID 17730 //
     /* 171447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 171457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171461 */   // (fpextend:{ *:[f80] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP64:{ *:[f64] }:$src, RFP80:{ *:[i32] })
     /* 171461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171466 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 171471 */   // GIR_Coverage, 17730,
     /* 171471 */   GIR_Done,
     /* 171472 */ // Label 3760: @171472
     /* 171472 */ GIM_Reject,
     /* 171473 */ // Label 3742: @171473
     /* 171473 */ GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(171536),
     /* 171478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171481 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(171508), // Rule ID 1934 //
     /* 171486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 171489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 171493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 171497 */     // (fpextend:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDYrr:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)
     /* 171497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDYrr),
     /* 171502 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171506 */     GIR_RootConstrainSelectedInstOperands,
     /* 171507 */     // GIR_Coverage, 1934,
     /* 171507 */     GIR_Done,
     /* 171508 */   // Label 3762: @171508
     /* 171508 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(171535), // Rule ID 10574 //
     /* 171513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 171516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 171520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 171524 */     // (fpextend:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)
     /* 171524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZ256rr),
     /* 171529 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171533 */     GIR_RootConstrainSelectedInstOperands,
     /* 171534 */     // GIR_Coverage, 10574,
     /* 171534 */     GIR_Done,
     /* 171535 */   // Label 3763: @171535
     /* 171535 */   GIM_Reject,
     /* 171536 */ // Label 3761: @171536
     /* 171536 */ GIM_Reject,
     /* 171537 */ // Label 3743: @171537
     /* 171537 */ GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(171567), // Rule ID 10637 //
     /* 171542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 171545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 171552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 171556 */   // (fpextend:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PSXZ256rr:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)
     /* 171556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZ256rr),
     /* 171561 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171565 */   GIR_RootConstrainSelectedInstOperands,
     /* 171566 */   // GIR_Coverage, 10637,
     /* 171566 */   GIR_Done,
     /* 171567 */ // Label 3764: @171567
     /* 171567 */ GIM_Reject,
     /* 171568 */ // Label 3744: @171568
     /* 171568 */ GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(171598), // Rule ID 10549 //
     /* 171573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 171579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 171583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 171587 */   // (fpextend:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)
     /* 171587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZrr),
     /* 171592 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171596 */   GIR_RootConstrainSelectedInstOperands,
     /* 171597 */   // GIR_Coverage, 10549,
     /* 171597 */   GIR_Done,
     /* 171598 */ // Label 3765: @171598
     /* 171598 */ GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(171628), // Rule ID 10663 //
     /* 171603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 171613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 171617 */   // (fpextend:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PDZrr:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)
     /* 171617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PDZrr),
     /* 171622 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171626 */   GIR_RootConstrainSelectedInstOperands,
     /* 171627 */   // GIR_Coverage, 10663,
     /* 171627 */   GIR_Done,
     /* 171628 */ // Label 3766: @171628
     /* 171628 */ GIM_Reject,
     /* 171629 */ // Label 3745: @171629
     /* 171629 */ GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(171659), // Rule ID 10612 //
     /* 171634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 171640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 171644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 171648 */   // (fpextend:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2PSXZrr:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)
     /* 171648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZrr),
     /* 171653 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171657 */   GIR_RootConstrainSelectedInstOperands,
     /* 171658 */   // GIR_Coverage, 10612,
     /* 171658 */   GIR_Done,
     /* 171659 */ // Label 3767: @171659
     /* 171659 */ GIM_Reject,
     /* 171660 */ // Label 3746: @171660
     /* 171660 */ GIM_Reject,
     /* 171661 */ // Label 48: @171661
     /* 171661 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 3771*/ GIMT_Encode4(172046),
     /* 171672 */ /*GILLT_s16*//*Label 3768*/ GIMT_Encode4(171684),
     /* 171676 */ /*GILLT_s32*//*Label 3769*/ GIMT_Encode4(171775),
     /* 171680 */ /*GILLT_s64*//*Label 3770*/ GIMT_Encode4(172015),
     /* 171684 */ // Label 3768: @171684
     /* 171684 */ GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(171729), // Rule ID 21209 //
     /* 171689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 171699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 171703 */   // (fpround:{ *:[f16] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR32X:{ *:[f32] }:$src)
     /* 171703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SHZrr),
     /* 171720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171725 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171727 */   GIR_RootConstrainSelectedInstOperands,
     /* 171728 */   // GIR_Coverage, 21209,
     /* 171728 */   GIR_EraseRootFromParent_Done,
     /* 171729 */ // Label 3772: @171729
     /* 171729 */ GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(171774), // Rule ID 21211 //
     /* 171734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 171744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171748 */   // (fpround:{ *:[f16] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR64X:{ *:[f64] }:$src)
     /* 171748 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171751 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171755 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SHZrr),
     /* 171765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171767 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171770 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171772 */   GIR_RootConstrainSelectedInstOperands,
     /* 171773 */   // GIR_Coverage, 21211,
     /* 171773 */   GIR_EraseRootFromParent_Done,
     /* 171774 */ // Label 3773: @171774
     /* 171774 */ GIM_Reject,
     /* 171775 */ // Label 3769: @171775
     /* 171775 */ GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(171834), // Rule ID 1881 //
     /* 171780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 171783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171790 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171794 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171798 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171801 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171805 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171809 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171811 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171818 */   // (fpround:{ *:[f32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 171818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrm),
     /* 171821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171823 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171827 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171832 */   GIR_RootConstrainSelectedInstOperands,
     /* 171833 */   // GIR_Coverage, 1881,
     /* 171833 */   GIR_EraseRootFromParent_Done,
     /* 171834 */ // Label 3774: @171834
     /* 171834 */ GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(171864), // Rule ID 1879 //
     /* 171839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171853 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SSrr:{ *:[f32] } FR64:{ *:[f64] }:$src)
     /* 171853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrr),
     /* 171858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171862 */   GIR_RootConstrainSelectedInstOperands,
     /* 171863 */   // GIR_Coverage, 1879,
     /* 171863 */   GIR_Done,
     /* 171864 */ // Label 3775: @171864
     /* 171864 */ GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(171894), // Rule ID 17732 //
     /* 171869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 171872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 171879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171883 */   // (fpround:{ *:[f32] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP64:{ *:[f64] }:$src, RFP32:{ *:[i32] })
     /* 171883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 171893 */   // GIR_Coverage, 17732,
     /* 171893 */   GIR_Done,
     /* 171894 */ // Label 3776: @171894
     /* 171894 */ GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(171924), // Rule ID 17734 //
     /* 171899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 171902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 171905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 171909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 171913 */   // (fpround:{ *:[f32] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP80:{ *:[f80] }:$src, RFP32:{ *:[i32] })
     /* 171913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171918 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 171923 */   // GIR_Coverage, 17734,
     /* 171923 */   GIR_Done,
     /* 171924 */ // Label 3777: @171924
     /* 171924 */ GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(171969), // Rule ID 17997 //
     /* 171929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171943 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64:{ *:[f64] }:$src)
     /* 171943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 171946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSrr),
     /* 171960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171965 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171967 */   GIR_RootConstrainSelectedInstOperands,
     /* 171968 */   // GIR_Coverage, 17997,
     /* 171968 */   GIR_EraseRootFromParent_Done,
     /* 171969 */ // Label 3778: @171969
     /* 171969 */ GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(172014), // Rule ID 21199 //
     /* 171974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 171984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171988 */   // (fpround:{ *:[f32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64X:{ *:[f64] }:$src)
     /* 171988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 171991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSZrr),
     /* 172005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172007 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 172010 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 172012 */   GIR_RootConstrainSelectedInstOperands,
     /* 172013 */   // GIR_Coverage, 21199,
     /* 172013 */   GIR_EraseRootFromParent_Done,
     /* 172014 */ // Label 3779: @172014
     /* 172014 */ GIM_Reject,
     /* 172015 */ // Label 3770: @172015
     /* 172015 */ GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(172045), // Rule ID 17736 //
     /* 172020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 172023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 172026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 172030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172034 */   // (fpround:{ *:[f64] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP80:{ *:[f80] }:$src, RFP64:{ *:[i32] })
     /* 172034 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 172044 */   // GIR_Coverage, 17736,
     /* 172044 */   GIR_Done,
     /* 172045 */ // Label 3780: @172045
     /* 172045 */ GIM_Reject,
     /* 172046 */ // Label 3771: @172046
     /* 172046 */ GIM_Reject,
     /* 172047 */ // Label 49: @172047
     /* 172047 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 3784*/ GIMT_Encode4(173427),
     /* 172058 */ /*GILLT_s32*//*Label 3781*/ GIMT_Encode4(172090),
     /* 172062 */ /*GILLT_s64*//*Label 3782*/ GIMT_Encode4(172714), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 172086 */ /*GILLT_v4s32*//*Label 3783*/ GIMT_Encode4(173338),
     /* 172090 */ // Label 3781: @172090
     /* 172090 */ GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(172149), // Rule ID 1741 //
     /* 172095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172105 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172109 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172113 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172116 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172120 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172124 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172126 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172133 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrm),
     /* 172136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172138 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172142 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172147 */   GIR_RootConstrainSelectedInstOperands,
     /* 172148 */   // GIR_Coverage, 1741,
     /* 172148 */   GIR_EraseRootFromParent_Done,
     /* 172149 */ // Label 3785: @172149
     /* 172149 */ GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(172208), // Rule ID 1749 //
     /* 172154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172164 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172168 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172172 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172175 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172179 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172183 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172185 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172192 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrm),
     /* 172195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172197 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172201 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172206 */   GIR_RootConstrainSelectedInstOperands,
     /* 172207 */   // GIR_Coverage, 1749,
     /* 172207 */   GIR_EraseRootFromParent_Done,
     /* 172208 */ // Label 3786: @172208
     /* 172208 */ GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(172267), // Rule ID 1765 //
     /* 172213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 172216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172231 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172234 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172238 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172242 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172244 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172251 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrm),
     /* 172254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172256 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172265 */   GIR_RootConstrainSelectedInstOperands,
     /* 172266 */   // GIR_Coverage, 1765,
     /* 172266 */   GIR_EraseRootFromParent_Done,
     /* 172267 */ // Label 3787: @172267
     /* 172267 */ GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(172326), // Rule ID 1773 //
     /* 172272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 172275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172282 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172286 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172290 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172293 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172297 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172301 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172303 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172310 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrm),
     /* 172313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172315 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172319 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172324 */   GIR_RootConstrainSelectedInstOperands,
     /* 172325 */   // GIR_Coverage, 1773,
     /* 172325 */   GIR_EraseRootFromParent_Done,
     /* 172326 */ // Label 3788: @172326
     /* 172326 */ GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(172385), // Rule ID 10362 //
     /* 172331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172341 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172345 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172349 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172352 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172356 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172360 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172362 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172369 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrm),
     /* 172372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172374 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172383 */   GIR_RootConstrainSelectedInstOperands,
     /* 172384 */   // GIR_Coverage, 10362,
     /* 172384 */   GIR_EraseRootFromParent_Done,
     /* 172385 */ // Label 3789: @172385
     /* 172385 */ GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(172444), // Rule ID 10380 //
     /* 172390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172400 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172404 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172408 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172411 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172415 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172419 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172421 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172428 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrm),
     /* 172431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172433 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172437 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172442 */   GIR_RootConstrainSelectedInstOperands,
     /* 172443 */   // GIR_Coverage, 10380,
     /* 172443 */   GIR_EraseRootFromParent_Done,
     /* 172444 */ // Label 3790: @172444
     /* 172444 */ GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(172503), // Rule ID 15170 //
     /* 172449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 172452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 172455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172467 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172470 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172474 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172478 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172480 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172487 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrm),
     /* 172490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172492 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172496 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172501 */   GIR_RootConstrainSelectedInstOperands,
     /* 172502 */   // GIR_Coverage, 15170,
     /* 172502 */   GIR_EraseRootFromParent_Done,
     /* 172503 */ // Label 3791: @172503
     /* 172503 */ GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(172533), // Rule ID 1739 //
     /* 172508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 172522 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 172522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrr),
     /* 172527 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172531 */   GIR_RootConstrainSelectedInstOperands,
     /* 172532 */   // GIR_Coverage, 1739,
     /* 172532 */   GIR_Done,
     /* 172533 */ // Label 3792: @172533
     /* 172533 */ GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(172563), // Rule ID 1747 //
     /* 172538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 172552 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 172552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrr),
     /* 172557 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172561 */   GIR_RootConstrainSelectedInstOperands,
     /* 172562 */   // GIR_Coverage, 1747,
     /* 172562 */   GIR_Done,
     /* 172563 */ // Label 3793: @172563
     /* 172563 */ GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(172593), // Rule ID 1763 //
     /* 172568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 172571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 172582 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 172582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrr),
     /* 172587 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172591 */   GIR_RootConstrainSelectedInstOperands,
     /* 172592 */   // GIR_Coverage, 1763,
     /* 172592 */   GIR_Done,
     /* 172593 */ // Label 3794: @172593
     /* 172593 */ GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(172623), // Rule ID 1771 //
     /* 172598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 172601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 172612 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 172612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrr),
     /* 172617 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172621 */   GIR_RootConstrainSelectedInstOperands,
     /* 172622 */   // GIR_Coverage, 1771,
     /* 172622 */   GIR_Done,
     /* 172623 */ // Label 3795: @172623
     /* 172623 */ GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(172653), // Rule ID 10360 //
     /* 172628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 172642 */   // (fp_to_sint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 172642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrr),
     /* 172647 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172651 */   GIR_RootConstrainSelectedInstOperands,
     /* 172652 */   // GIR_Coverage, 10360,
     /* 172652 */   GIR_Done,
     /* 172653 */ // Label 3796: @172653
     /* 172653 */ GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(172683), // Rule ID 10378 //
     /* 172658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 172672 */   // (fp_to_sint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 172672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrr),
     /* 172677 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172681 */   GIR_RootConstrainSelectedInstOperands,
     /* 172682 */   // GIR_Coverage, 10378,
     /* 172682 */   GIR_Done,
     /* 172683 */ // Label 3797: @172683
     /* 172683 */ GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(172713), // Rule ID 15168 //
     /* 172688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 172691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 172694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 172702 */   // (fp_to_sint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 172702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /* 172707 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172711 */   GIR_RootConstrainSelectedInstOperands,
     /* 172712 */   // GIR_Coverage, 15168,
     /* 172712 */   GIR_Done,
     /* 172713 */ // Label 3798: @172713
     /* 172713 */ GIM_Reject,
     /* 172714 */ // Label 3782: @172714
     /* 172714 */ GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(172773), // Rule ID 1745 //
     /* 172719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172729 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172733 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172737 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172740 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172744 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172750 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172757 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rm),
     /* 172760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172762 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172771 */   GIR_RootConstrainSelectedInstOperands,
     /* 172772 */   // GIR_Coverage, 1745,
     /* 172772 */   GIR_EraseRootFromParent_Done,
     /* 172773 */ // Label 3799: @172773
     /* 172773 */ GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(172832), // Rule ID 1753 //
     /* 172778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172788 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172792 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172796 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172799 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172803 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172807 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172809 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172816 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rm),
     /* 172819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172821 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172825 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172830 */   GIR_RootConstrainSelectedInstOperands,
     /* 172831 */   // GIR_Coverage, 1753,
     /* 172831 */   GIR_EraseRootFromParent_Done,
     /* 172832 */ // Label 3800: @172832
     /* 172832 */ GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(172891), // Rule ID 1769 //
     /* 172837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 172840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172847 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172855 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172858 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172862 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172866 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172868 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172875 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rm),
     /* 172878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172880 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172884 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172889 */   GIR_RootConstrainSelectedInstOperands,
     /* 172890 */   // GIR_Coverage, 1769,
     /* 172890 */   GIR_EraseRootFromParent_Done,
     /* 172891 */ // Label 3801: @172891
     /* 172891 */ GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(172950), // Rule ID 1777 //
     /* 172896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 172899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172906 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172914 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172917 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172921 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172927 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172934 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rm),
     /* 172937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172939 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172943 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172948 */   GIR_RootConstrainSelectedInstOperands,
     /* 172949 */   // GIR_Coverage, 1777,
     /* 172949 */   GIR_EraseRootFromParent_Done,
     /* 172950 */ // Label 3802: @172950
     /* 172950 */ GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(173009), // Rule ID 10371 //
     /* 172955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172973 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172976 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172980 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172986 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172993 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrm),
     /* 172996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172998 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173007 */   GIR_RootConstrainSelectedInstOperands,
     /* 173008 */   // GIR_Coverage, 10371,
     /* 173008 */   GIR_EraseRootFromParent_Done,
     /* 173009 */ // Label 3803: @173009
     /* 173009 */ GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(173068), // Rule ID 10389 //
     /* 173014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173024 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173028 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173032 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173035 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173039 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173045 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173052 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrm),
     /* 173055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173057 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173066 */   GIR_RootConstrainSelectedInstOperands,
     /* 173067 */   // GIR_Coverage, 10389,
     /* 173067 */   GIR_EraseRootFromParent_Done,
     /* 173068 */ // Label 3804: @173068
     /* 173068 */ GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(173127), // Rule ID 15179 //
     /* 173073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173083 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173091 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173094 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173098 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173102 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173104 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173111 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /* 173114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173116 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173120 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173125 */   GIR_RootConstrainSelectedInstOperands,
     /* 173126 */   // GIR_Coverage, 15179,
     /* 173126 */   GIR_EraseRootFromParent_Done,
     /* 173127 */ // Label 3805: @173127
     /* 173127 */ GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(173157), // Rule ID 1743 //
     /* 173132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 173135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 173146 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 173146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rr),
     /* 173151 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173155 */   GIR_RootConstrainSelectedInstOperands,
     /* 173156 */   // GIR_Coverage, 1743,
     /* 173156 */   GIR_Done,
     /* 173157 */ // Label 3806: @173157
     /* 173157 */ GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(173187), // Rule ID 1751 //
     /* 173162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 173165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 173176 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 173176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rr),
     /* 173181 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173185 */   GIR_RootConstrainSelectedInstOperands,
     /* 173186 */   // GIR_Coverage, 1751,
     /* 173186 */   GIR_Done,
     /* 173187 */ // Label 3807: @173187
     /* 173187 */ GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(173217), // Rule ID 1767 //
     /* 173192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 173195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 173206 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 173206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rr),
     /* 173211 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173215 */   GIR_RootConstrainSelectedInstOperands,
     /* 173216 */   // GIR_Coverage, 1767,
     /* 173216 */   GIR_Done,
     /* 173217 */ // Label 3808: @173217
     /* 173217 */ GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(173247), // Rule ID 1775 //
     /* 173222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 173225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 173236 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 173236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rr),
     /* 173241 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173245 */   GIR_RootConstrainSelectedInstOperands,
     /* 173246 */   // GIR_Coverage, 1775,
     /* 173246 */   GIR_Done,
     /* 173247 */ // Label 3809: @173247
     /* 173247 */ GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(173277), // Rule ID 10369 //
     /* 173252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 173266 */   // (fp_to_sint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 173266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrr),
     /* 173271 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173275 */   GIR_RootConstrainSelectedInstOperands,
     /* 173276 */   // GIR_Coverage, 10369,
     /* 173276 */   GIR_Done,
     /* 173277 */ // Label 3810: @173277
     /* 173277 */ GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(173307), // Rule ID 10387 //
     /* 173282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 173296 */   // (fp_to_sint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 173296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrr),
     /* 173301 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173305 */   GIR_RootConstrainSelectedInstOperands,
     /* 173306 */   // GIR_Coverage, 10387,
     /* 173306 */   GIR_Done,
     /* 173307 */ // Label 3811: @173307
     /* 173307 */ GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(173337), // Rule ID 15177 //
     /* 173312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 173326 */   // (fp_to_sint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 173326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /* 173331 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173335 */   GIR_RootConstrainSelectedInstOperands,
     /* 173336 */   // GIR_Coverage, 15177,
     /* 173336 */   GIR_Done,
     /* 173337 */ // Label 3812: @173337
     /* 173337 */ GIM_Reject,
     /* 173338 */ // Label 3783: @173338
     /* 173338 */ GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(173426),
     /* 173343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 173346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 173350 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(173402), // Rule ID 18053 //
     /* 173355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173373 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173386 */     // (fp_to_sint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTPD2DQYrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 173386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrm),
     /* 173389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173400 */     GIR_RootConstrainSelectedInstOperands,
     /* 173401 */     // GIR_Coverage, 18053,
     /* 173401 */     GIR_EraseRootFromParent_Done,
     /* 173402 */   // Label 3814: @173402
     /* 173402 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(173425), // Rule ID 18051 //
     /* 173407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173414 */     // (fp_to_sint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /* 173414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrr),
     /* 173419 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173423 */     GIR_RootConstrainSelectedInstOperands,
     /* 173424 */     // GIR_Coverage, 18051,
     /* 173424 */     GIR_Done,
     /* 173425 */   // Label 3815: @173425
     /* 173425 */   GIM_Reject,
     /* 173426 */ // Label 3813: @173426
     /* 173426 */ GIM_Reject,
     /* 173427 */ // Label 3784: @173427
     /* 173427 */ GIM_Reject,
     /* 173428 */ // Label 50: @173428
     /* 173428 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3818*/ GIMT_Encode4(173983),
     /* 173439 */ /*GILLT_s32*//*Label 3816*/ GIMT_Encode4(173447),
     /* 173443 */ /*GILLT_s64*//*Label 3817*/ GIMT_Encode4(173715),
     /* 173447 */ // Label 3816: @173447
     /* 173447 */ GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(173506), // Rule ID 10398 //
     /* 173452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173462 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173466 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173470 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173473 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173477 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173483 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173490 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 173490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrm),
     /* 173493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173495 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173499 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173504 */   GIR_RootConstrainSelectedInstOperands,
     /* 173505 */   // GIR_Coverage, 10398,
     /* 173505 */   GIR_EraseRootFromParent_Done,
     /* 173506 */ // Label 3819: @173506
     /* 173506 */ GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(173565), // Rule ID 10416 //
     /* 173511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173521 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173525 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173529 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173532 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173536 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173540 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173542 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173549 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 173549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrm),
     /* 173552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173554 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173558 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173563 */   GIR_RootConstrainSelectedInstOperands,
     /* 173564 */   // GIR_Coverage, 10416,
     /* 173564 */   GIR_EraseRootFromParent_Done,
     /* 173565 */ // Label 3820: @173565
     /* 173565 */ GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(173624), // Rule ID 15188 //
     /* 173570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173580 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173584 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173588 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173591 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173595 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173599 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173601 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173608 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 173608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrm),
     /* 173611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173613 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173617 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173622 */   GIR_RootConstrainSelectedInstOperands,
     /* 173623 */   // GIR_Coverage, 15188,
     /* 173623 */   GIR_EraseRootFromParent_Done,
     /* 173624 */ // Label 3821: @173624
     /* 173624 */ GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(173654), // Rule ID 10396 //
     /* 173629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 173643 */   // (fp_to_uint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 173643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrr),
     /* 173648 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173652 */   GIR_RootConstrainSelectedInstOperands,
     /* 173653 */   // GIR_Coverage, 10396,
     /* 173653 */   GIR_Done,
     /* 173654 */ // Label 3822: @173654
     /* 173654 */ GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(173684), // Rule ID 10414 //
     /* 173659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 173673 */   // (fp_to_uint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 173673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrr),
     /* 173678 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173682 */   GIR_RootConstrainSelectedInstOperands,
     /* 173683 */   // GIR_Coverage, 10414,
     /* 173683 */   GIR_Done,
     /* 173684 */ // Label 3823: @173684
     /* 173684 */ GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(173714), // Rule ID 15186 //
     /* 173689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 173703 */   // (fp_to_uint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 173703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrr),
     /* 173708 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173712 */   GIR_RootConstrainSelectedInstOperands,
     /* 173713 */   // GIR_Coverage, 15186,
     /* 173713 */   GIR_Done,
     /* 173714 */ // Label 3824: @173714
     /* 173714 */ GIM_Reject,
     /* 173715 */ // Label 3817: @173715
     /* 173715 */ GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(173774), // Rule ID 10407 //
     /* 173720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173730 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173734 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173738 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173741 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173745 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173749 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173751 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173758 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrm),
     /* 173761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173763 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173772 */   GIR_RootConstrainSelectedInstOperands,
     /* 173773 */   // GIR_Coverage, 10407,
     /* 173773 */   GIR_EraseRootFromParent_Done,
     /* 173774 */ // Label 3825: @173774
     /* 173774 */ GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(173833), // Rule ID 10425 //
     /* 173779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173797 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173800 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173804 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173810 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173817 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrm),
     /* 173820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173822 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173826 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173831 */   GIR_RootConstrainSelectedInstOperands,
     /* 173832 */   // GIR_Coverage, 10425,
     /* 173832 */   GIR_EraseRootFromParent_Done,
     /* 173833 */ // Label 3826: @173833
     /* 173833 */ GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(173892), // Rule ID 15197 //
     /* 173838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173848 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173856 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173859 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173863 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173867 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173869 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173876 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrm),
     /* 173879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173881 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173885 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173890 */   GIR_RootConstrainSelectedInstOperands,
     /* 173891 */   // GIR_Coverage, 15197,
     /* 173891 */   GIR_EraseRootFromParent_Done,
     /* 173892 */ // Label 3827: @173892
     /* 173892 */ GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(173922), // Rule ID 10405 //
     /* 173897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 173911 */   // (fp_to_uint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 173911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrr),
     /* 173916 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173920 */   GIR_RootConstrainSelectedInstOperands,
     /* 173921 */   // GIR_Coverage, 10405,
     /* 173921 */   GIR_Done,
     /* 173922 */ // Label 3828: @173922
     /* 173922 */ GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(173952), // Rule ID 10423 //
     /* 173927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 173941 */   // (fp_to_uint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 173941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrr),
     /* 173946 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173950 */   GIR_RootConstrainSelectedInstOperands,
     /* 173951 */   // GIR_Coverage, 10423,
     /* 173951 */   GIR_Done,
     /* 173952 */ // Label 3829: @173952
     /* 173952 */ GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(173982), // Rule ID 15195 //
     /* 173957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 173971 */   // (fp_to_uint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 173971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrr),
     /* 173976 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173980 */   GIR_RootConstrainSelectedInstOperands,
     /* 173981 */   // GIR_Coverage, 15195,
     /* 173981 */   GIR_Done,
     /* 173982 */ // Label 3830: @173982
     /* 173982 */ GIM_Reject,
     /* 173983 */ // Label 3818: @173983
     /* 173983 */ GIM_Reject,
     /* 173984 */ // Label 51: @173984
     /* 173984 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3843*/ GIMT_Encode4(177359),
     /* 173995 */ /*GILLT_s16*//*Label 3831*/ GIMT_Encode4(174079),
     /* 173999 */ /*GILLT_s32*//*Label 3832*/ GIMT_Encode4(174322),
     /* 174003 */ /*GILLT_s64*//*Label 3833*/ GIMT_Encode4(174985), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174019 */ /*GILLT_v2s64*//*Label 3834*/ GIMT_Encode4(175644), GIMT_Encode4(0),
     /* 174027 */ /*GILLT_v4s32*//*Label 3835*/ GIMT_Encode4(175733),
     /* 174031 */ /*GILLT_v4s64*//*Label 3836*/ GIMT_Encode4(176031), GIMT_Encode4(0),
     /* 174039 */ /*GILLT_v8s16*//*Label 3837*/ GIMT_Encode4(176291),
     /* 174043 */ /*GILLT_v8s32*//*Label 3838*/ GIMT_Encode4(176559),
     /* 174047 */ /*GILLT_v8s64*//*Label 3839*/ GIMT_Encode4(176827), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174059 */ /*GILLT_v16s16*//*Label 3840*/ GIMT_Encode4(177002),
     /* 174063 */ /*GILLT_v16s32*//*Label 3841*/ GIMT_Encode4(177181), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174075 */ /*GILLT_v32s16*//*Label 3842*/ GIMT_Encode4(177270),
     /* 174079 */ // Label 3831: @174079
     /* 174079 */ GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(174155), // Rule ID 22178 //
     /* 174084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174094 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174098 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174102 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174105 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174109 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174113 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174115 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174122 */   // (sint_to_fp:{ *:[f16] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 174122 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174125 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174129 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrm),
     /* 174139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174144 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174148 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174153 */   GIR_RootConstrainSelectedInstOperands,
     /* 174154 */   // GIR_Coverage, 22178,
     /* 174154 */   GIR_EraseRootFromParent_Done,
     /* 174155 */ // Label 3844: @174155
     /* 174155 */ GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(174231), // Rule ID 22176 //
     /* 174160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174178 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174181 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174185 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 174189 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174191 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174198 */   // (sint_to_fp:{ *:[f16] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 174198 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174201 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174205 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrm),
     /* 174215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174220 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174224 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174229 */   GIR_RootConstrainSelectedInstOperands,
     /* 174230 */   // GIR_Coverage, 22176,
     /* 174230 */   GIR_EraseRootFromParent_Done,
     /* 174231 */ // Label 3845: @174231
     /* 174231 */ GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(174276), // Rule ID 22180 //
     /* 174236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174250 */   // (sint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 174250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrr),
     /* 174267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174272 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174274 */   GIR_RootConstrainSelectedInstOperands,
     /* 174275 */   // GIR_Coverage, 22180,
     /* 174275 */   GIR_EraseRootFromParent_Done,
     /* 174276 */ // Label 3846: @174276
     /* 174276 */ GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(174321), // Rule ID 22182 //
     /* 174281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174295 */   // (sint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 174295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrr),
     /* 174312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174317 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174319 */   GIR_RootConstrainSelectedInstOperands,
     /* 174320 */   // GIR_Coverage, 22182,
     /* 174320 */   GIR_EraseRootFromParent_Done,
     /* 174321 */ // Label 3847: @174321
     /* 174321 */ GIM_Reject,
     /* 174322 */ // Label 3832: @174322
     /* 174322 */ GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(174381), // Rule ID 1793 //
     /* 174327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 174330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174337 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174341 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174345 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174348 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174352 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174356 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174358 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174365 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSI642SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 174365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrm),
     /* 174368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174370 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174374 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174379 */   GIR_RootConstrainSelectedInstOperands,
     /* 174380 */   // GIR_Coverage, 1793,
     /* 174380 */   GIR_EraseRootFromParent_Done,
     /* 174381 */ // Label 3848: @174381
     /* 174381 */ GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(174457), // Rule ID 17975 //
     /* 174386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174396 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174400 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174404 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174407 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174411 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174415 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174417 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174424 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SSrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 174424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrm),
     /* 174441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174446 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174455 */   GIR_RootConstrainSelectedInstOperands,
     /* 174456 */   // GIR_Coverage, 17975,
     /* 174456 */   GIR_EraseRootFromParent_Done,
     /* 174457 */ // Label 3849: @174457
     /* 174457 */ GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(174533), // Rule ID 21129 //
     /* 174462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174472 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174476 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174480 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174483 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174487 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174491 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174493 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174500 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 174500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrm),
     /* 174517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174522 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174526 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174531 */   GIR_RootConstrainSelectedInstOperands,
     /* 174532 */   // GIR_Coverage, 21129,
     /* 174532 */   GIR_EraseRootFromParent_Done,
     /* 174533 */ // Label 3850: @174533
     /* 174533 */ GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(174592), // Rule ID 1789 //
     /* 174538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 174541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174548 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174556 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174559 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174563 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 174567 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174569 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174576 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (CVTSI2SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 174576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrm),
     /* 174579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174581 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174585 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174590 */   GIR_RootConstrainSelectedInstOperands,
     /* 174591 */   // GIR_Coverage, 1789,
     /* 174591 */   GIR_EraseRootFromParent_Done,
     /* 174592 */ // Label 3851: @174592
     /* 174592 */ GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(174668), // Rule ID 17973 //
     /* 174597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174607 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174611 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174615 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174618 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174622 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 174626 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174628 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174635 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SSrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 174635 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174638 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174642 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrm),
     /* 174652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174657 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174661 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174666 */   GIR_RootConstrainSelectedInstOperands,
     /* 174667 */   // GIR_Coverage, 17973,
     /* 174667 */   GIR_EraseRootFromParent_Done,
     /* 174668 */ // Label 3852: @174668
     /* 174668 */ GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(174744), // Rule ID 21127 //
     /* 174673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174691 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174694 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174698 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 174702 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174704 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174711 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 174711 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174714 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174718 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrm),
     /* 174728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174733 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174742 */   GIR_RootConstrainSelectedInstOperands,
     /* 174743 */   // GIR_Coverage, 21127,
     /* 174743 */   GIR_EraseRootFromParent_Done,
     /* 174744 */ // Label 3853: @174744
     /* 174744 */ GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(174774), // Rule ID 1787 //
     /* 174749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 174752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174763 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 174763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrr),
     /* 174768 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174772 */   GIR_RootConstrainSelectedInstOperands,
     /* 174773 */   // GIR_Coverage, 1787,
     /* 174773 */   GIR_Done,
     /* 174774 */ // Label 3854: @174774
     /* 174774 */ GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(174804), // Rule ID 1791 //
     /* 174779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 174782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174793 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SSrr:{ *:[f32] } GR64:{ *:[i64] }:$src)
     /* 174793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrr),
     /* 174798 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174802 */   GIR_RootConstrainSelectedInstOperands,
     /* 174803 */   // GIR_Coverage, 1791,
     /* 174803 */   GIR_Done,
     /* 174804 */ // Label 3855: @174804
     /* 174804 */ GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(174849), // Rule ID 17981 //
     /* 174809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174823 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 174823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrr),
     /* 174840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174845 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174847 */   GIR_RootConstrainSelectedInstOperands,
     /* 174848 */   // GIR_Coverage, 17981,
     /* 174848 */   GIR_EraseRootFromParent_Done,
     /* 174849 */ // Label 3856: @174849
     /* 174849 */ GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(174894), // Rule ID 17983 //
     /* 174854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174868 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 174868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrr),
     /* 174885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174890 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174892 */   GIR_RootConstrainSelectedInstOperands,
     /* 174893 */   // GIR_Coverage, 17983,
     /* 174893 */   GIR_EraseRootFromParent_Done,
     /* 174894 */ // Label 3857: @174894
     /* 174894 */ GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(174939), // Rule ID 21135 //
     /* 174899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174913 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 174913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrr),
     /* 174930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174932 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174937 */   GIR_RootConstrainSelectedInstOperands,
     /* 174938 */   // GIR_Coverage, 21135,
     /* 174938 */   GIR_EraseRootFromParent_Done,
     /* 174939 */ // Label 3858: @174939
     /* 174939 */ GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(174984), // Rule ID 21137 //
     /* 174944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174958 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 174958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrr),
     /* 174975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174980 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174982 */   GIR_RootConstrainSelectedInstOperands,
     /* 174983 */   // GIR_Coverage, 21137,
     /* 174983 */   GIR_EraseRootFromParent_Done,
     /* 174984 */ // Label 3859: @174984
     /* 174984 */ GIM_Reject,
     /* 174985 */ // Label 3833: @174985
     /* 174985 */ GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(175044), // Rule ID 1801 //
     /* 174990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 174993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175000 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175004 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175008 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175011 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175015 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175019 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175021 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175028 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSI642SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 175028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrm),
     /* 175031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175033 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175042 */   GIR_RootConstrainSelectedInstOperands,
     /* 175043 */   // GIR_Coverage, 1801,
     /* 175043 */   GIR_EraseRootFromParent_Done,
     /* 175044 */ // Label 3860: @175044
     /* 175044 */ GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(175120), // Rule ID 17979 //
     /* 175049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175059 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175067 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175070 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175074 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175078 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175080 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175087 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 175087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrm),
     /* 175104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175109 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175113 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175118 */   GIR_RootConstrainSelectedInstOperands,
     /* 175119 */   // GIR_Coverage, 17979,
     /* 175119 */   GIR_EraseRootFromParent_Done,
     /* 175120 */ // Label 3861: @175120
     /* 175120 */ GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(175196), // Rule ID 21133 //
     /* 175125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175135 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175143 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175146 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175150 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175154 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175156 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175163 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 175163 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175166 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175170 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrm),
     /* 175180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175182 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175185 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175189 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175194 */   GIR_RootConstrainSelectedInstOperands,
     /* 175195 */   // GIR_Coverage, 21133,
     /* 175195 */   GIR_EraseRootFromParent_Done,
     /* 175196 */ // Label 3862: @175196
     /* 175196 */ GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(175255), // Rule ID 1797 //
     /* 175201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175211 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175215 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175219 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175222 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175226 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 175230 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175232 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175239 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (CVTSI2SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 175239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrm),
     /* 175242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175244 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175248 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175253 */   GIR_RootConstrainSelectedInstOperands,
     /* 175254 */   // GIR_Coverage, 1797,
     /* 175254 */   GIR_EraseRootFromParent_Done,
     /* 175255 */ // Label 3863: @175255
     /* 175255 */ GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(175331), // Rule ID 17977 //
     /* 175260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175270 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175274 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175278 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175281 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175285 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 175289 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175291 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175298 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 175298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrm),
     /* 175315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175320 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175324 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175329 */   GIR_RootConstrainSelectedInstOperands,
     /* 175330 */   // GIR_Coverage, 17977,
     /* 175330 */   GIR_EraseRootFromParent_Done,
     /* 175331 */ // Label 3864: @175331
     /* 175331 */ GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(175407), // Rule ID 21131 //
     /* 175336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175354 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175357 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175361 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 175365 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175367 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175374 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 175374 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175377 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175381 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrm),
     /* 175391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175396 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175400 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175405 */   GIR_RootConstrainSelectedInstOperands,
     /* 175406 */   // GIR_Coverage, 21131,
     /* 175406 */   GIR_EraseRootFromParent_Done,
     /* 175407 */ // Label 3865: @175407
     /* 175407 */ GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(175433), // Rule ID 1795 //
     /* 175412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175426 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SDrr:{ *:[f64] } GR32:{ *:[i32] }:$src)
     /* 175426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrr),
     /* 175431 */   GIR_RootConstrainSelectedInstOperands,
     /* 175432 */   // GIR_Coverage, 1795,
     /* 175432 */   GIR_Done,
     /* 175433 */ // Label 3866: @175433
     /* 175433 */ GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(175463), // Rule ID 1799 //
     /* 175438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 175452 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 175452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrr),
     /* 175457 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175461 */   GIR_RootConstrainSelectedInstOperands,
     /* 175462 */   // GIR_Coverage, 1799,
     /* 175462 */   GIR_Done,
     /* 175463 */ // Label 3867: @175463
     /* 175463 */ GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(175508), // Rule ID 17985 //
     /* 175468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175482 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 175482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrr),
     /* 175499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175504 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175506 */   GIR_RootConstrainSelectedInstOperands,
     /* 175507 */   // GIR_Coverage, 17985,
     /* 175507 */   GIR_EraseRootFromParent_Done,
     /* 175508 */ // Label 3868: @175508
     /* 175508 */ GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(175553), // Rule ID 17987 //
     /* 175513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 175527 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 175527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrr),
     /* 175544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175551 */   GIR_RootConstrainSelectedInstOperands,
     /* 175552 */   // GIR_Coverage, 17987,
     /* 175552 */   GIR_EraseRootFromParent_Done,
     /* 175553 */ // Label 3869: @175553
     /* 175553 */ GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(175598), // Rule ID 21139 //
     /* 175558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175572 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 175572 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175575 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175579 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrr),
     /* 175589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175594 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175596 */   GIR_RootConstrainSelectedInstOperands,
     /* 175597 */   // GIR_Coverage, 21139,
     /* 175597 */   GIR_EraseRootFromParent_Done,
     /* 175598 */ // Label 3870: @175598
     /* 175598 */ GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(175643), // Rule ID 21141 //
     /* 175603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 175617 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 175617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrr),
     /* 175634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175639 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175641 */   GIR_RootConstrainSelectedInstOperands,
     /* 175642 */   // GIR_Coverage, 21141,
     /* 175642 */   GIR_EraseRootFromParent_Done,
     /* 175643 */ // Label 3871: @175643
     /* 175643 */ GIM_Reject,
     /* 175644 */ // Label 3834: @175644
     /* 175644 */ GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(175732),
     /* 175649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175656 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(175708), // Rule ID 11378 //
     /* 175661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 175664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175672 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175679 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175692 */     // (sint_to_fp:{ *:[v2f64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 175692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rm),
     /* 175695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175706 */     GIR_RootConstrainSelectedInstOperands,
     /* 175707 */     // GIR_Coverage, 11378,
     /* 175707 */     GIR_EraseRootFromParent_Done,
     /* 175708 */   // Label 3873: @175708
     /* 175708 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(175731), // Rule ID 11374 //
     /* 175713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 175716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175720 */     // (sint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 175720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rr),
     /* 175725 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175729 */     GIR_RootConstrainSelectedInstOperands,
     /* 175730 */     // GIR_Coverage, 11374,
     /* 175730 */     GIR_Done,
     /* 175731 */   // Label 3874: @175731
     /* 175731 */   GIM_Reject,
     /* 175732 */ // Label 3872: @175732
     /* 175732 */ GIM_Reject,
     /* 175733 */ // Label 3835: @175733
     /* 175733 */ GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(175792), // Rule ID 1869 //
     /* 175738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 175741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175748 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175752 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175756 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175759 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175763 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175767 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175769 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175776 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 175776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrm),
     /* 175779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175781 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175785 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175790 */   GIR_RootConstrainSelectedInstOperands,
     /* 175791 */   // GIR_Coverage, 1869,
     /* 175791 */   GIR_EraseRootFromParent_Done,
     /* 175792 */ // Label 3875: @175792
     /* 175792 */ GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(175851), // Rule ID 10754 //
     /* 175797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 175800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175807 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175811 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175815 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175818 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175822 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175826 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175828 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175835 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 175835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rm),
     /* 175838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175840 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175849 */   GIR_RootConstrainSelectedInstOperands,
     /* 175850 */   // GIR_Coverage, 10754,
     /* 175850 */   GIR_EraseRootFromParent_Done,
     /* 175851 */ // Label 3876: @175851
     /* 175851 */ GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(175910), // Rule ID 11510 //
     /* 175856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 175859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 175862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175866 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175874 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175877 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175881 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175885 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175887 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175894 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PSZ256rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 175894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rm),
     /* 175897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175899 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175908 */   GIR_RootConstrainSelectedInstOperands,
     /* 175909 */   // GIR_Coverage, 11510,
     /* 175909 */   GIR_EraseRootFromParent_Done,
     /* 175910 */ // Label 3877: @175910
     /* 175910 */ GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(175940), // Rule ID 1867 //
     /* 175915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 175918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175929 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 175929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrr),
     /* 175934 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175938 */   GIR_RootConstrainSelectedInstOperands,
     /* 175939 */   // GIR_Coverage, 1867,
     /* 175939 */   GIR_Done,
     /* 175940 */ // Label 3878: @175940
     /* 175940 */ GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(175970), // Rule ID 1875 //
     /* 175945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175959 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (CVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 175959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTDQ2PSrr),
     /* 175964 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175968 */   GIR_RootConstrainSelectedInstOperands,
     /* 175969 */   // GIR_Coverage, 1875,
     /* 175969 */   GIR_Done,
     /* 175970 */ // Label 3879: @175970
     /* 175970 */ GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(176000), // Rule ID 10750 //
     /* 175975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 175978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175989 */   // (sint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 175989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rr),
     /* 175994 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175998 */   GIR_RootConstrainSelectedInstOperands,
     /* 175999 */   // GIR_Coverage, 10750,
     /* 175999 */   GIR_Done,
     /* 176000 */ // Label 3880: @176000
     /* 176000 */ GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(176030), // Rule ID 11506 //
     /* 176005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 176008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 176011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176019 */   // (sint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 176019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rr),
     /* 176024 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176028 */   GIR_RootConstrainSelectedInstOperands,
     /* 176029 */   // GIR_Coverage, 11506,
     /* 176029 */   GIR_Done,
     /* 176030 */ // Label 3881: @176030
     /* 176030 */ GIM_Reject,
     /* 176031 */ // Label 3836: @176031
     /* 176031 */ GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(176090), // Rule ID 1944 //
     /* 176036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176046 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176050 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176054 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176057 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176061 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176065 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176067 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176074 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 176074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrm),
     /* 176077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176079 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176088 */   GIR_RootConstrainSelectedInstOperands,
     /* 176089 */   // GIR_Coverage, 1944,
     /* 176089 */   GIR_EraseRootFromParent_Done,
     /* 176090 */ // Label 3882: @176090
     /* 176090 */ GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(176149), // Rule ID 10727 //
     /* 176095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 176098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176105 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176109 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176113 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176116 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176120 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176124 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176126 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176133 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 176133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rm),
     /* 176136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176138 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176142 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176147 */   GIR_RootConstrainSelectedInstOperands,
     /* 176148 */   // GIR_Coverage, 10727,
     /* 176148 */   GIR_EraseRootFromParent_Done,
     /* 176149 */ // Label 3883: @176149
     /* 176149 */ GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(176208), // Rule ID 11390 //
     /* 176154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 176157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 176160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176164 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176168 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176172 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176175 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176179 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176183 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176185 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176192 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 176192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rm),
     /* 176195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176197 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176201 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176206 */   GIR_RootConstrainSelectedInstOperands,
     /* 176207 */   // GIR_Coverage, 11390,
     /* 176207 */   GIR_EraseRootFromParent_Done,
     /* 176208 */ // Label 3884: @176208
     /* 176208 */ GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(176234), // Rule ID 1946 //
     /* 176213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 176227 */   // (sint_to_fp:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDYrr:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)
     /* 176227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrr),
     /* 176232 */   GIR_RootConstrainSelectedInstOperands,
     /* 176233 */   // GIR_Coverage, 1946,
     /* 176233 */   GIR_Done,
     /* 176234 */ // Label 3885: @176234
     /* 176234 */ GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(176260), // Rule ID 10723 //
     /* 176239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 176242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176253 */   // (sint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 176253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rr),
     /* 176258 */   GIR_RootConstrainSelectedInstOperands,
     /* 176259 */   // GIR_Coverage, 10723,
     /* 176259 */   GIR_Done,
     /* 176260 */ // Label 3886: @176260
     /* 176260 */ GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(176290), // Rule ID 11386 //
     /* 176265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 176268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 176271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176279 */   // (sint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 176279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rr),
     /* 176284 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176288 */   GIR_RootConstrainSelectedInstOperands,
     /* 176289 */   // GIR_Coverage, 11386,
     /* 176289 */   GIR_Done,
     /* 176290 */ // Label 3887: @176290
     /* 176290 */ GIM_Reject,
     /* 176291 */ // Label 3837: @176291
     /* 176291 */ GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(176350), // Rule ID 11456 //
     /* 176296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 176299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176306 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176314 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176317 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176321 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176325 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176327 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176334 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PHZ256rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 176334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rm),
     /* 176337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176339 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176348 */   GIR_RootConstrainSelectedInstOperands,
     /* 176349 */   // GIR_Coverage, 11456,
     /* 176349 */   GIR_EraseRootFromParent_Done,
     /* 176350 */ // Label 3888: @176350
     /* 176350 */ GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(176409), // Rule ID 14822 //
     /* 176355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 176358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176365 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176369 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176373 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176376 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176380 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176384 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176386 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176393 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 176393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rm),
     /* 176396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176398 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176402 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176407 */   GIR_RootConstrainSelectedInstOperands,
     /* 176408 */   // GIR_Coverage, 14822,
     /* 176408 */   GIR_EraseRootFromParent_Done,
     /* 176409 */ // Label 3889: @176409
     /* 176409 */ GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(176468), // Rule ID 15122 //
     /* 176414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176424 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176428 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176432 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176435 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176439 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176443 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176445 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176452 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PHZrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 176452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrm),
     /* 176455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176457 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176466 */   GIR_RootConstrainSelectedInstOperands,
     /* 176467 */   // GIR_Coverage, 15122,
     /* 176467 */   GIR_EraseRootFromParent_Done,
     /* 176468 */ // Label 3890: @176468
     /* 176468 */ GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(176498), // Rule ID 11452 //
     /* 176473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 176476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176487 */   // (sint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 176487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rr),
     /* 176492 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176496 */   GIR_RootConstrainSelectedInstOperands,
     /* 176497 */   // GIR_Coverage, 11452,
     /* 176497 */   GIR_Done,
     /* 176498 */ // Label 3891: @176498
     /* 176498 */ GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(176528), // Rule ID 14818 //
     /* 176503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 176506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176517 */   // (sint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 176517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rr),
     /* 176522 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176526 */   GIR_RootConstrainSelectedInstOperands,
     /* 176527 */   // GIR_Coverage, 14818,
     /* 176527 */   GIR_Done,
     /* 176528 */ // Label 3892: @176528
     /* 176528 */ GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(176558), // Rule ID 15118 //
     /* 176533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 176543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176547 */   // (sint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 176547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrr),
     /* 176552 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176556 */   GIR_RootConstrainSelectedInstOperands,
     /* 176557 */   // GIR_Coverage, 15118,
     /* 176557 */   GIR_Done,
     /* 176558 */ // Label 3893: @176558
     /* 176558 */ GIM_Reject,
     /* 176559 */ // Label 3838: @176559
     /* 176559 */ GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(176618), // Rule ID 1873 //
     /* 176564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176582 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176585 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176589 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176593 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176595 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176602 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 176602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrm),
     /* 176605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176607 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176611 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176616 */   GIR_RootConstrainSelectedInstOperands,
     /* 176617 */   // GIR_Coverage, 1873,
     /* 176617 */   GIR_EraseRootFromParent_Done,
     /* 176618 */ // Label 3894: @176618
     /* 176618 */ GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(176677), // Rule ID 10766 //
     /* 176623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 176626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176641 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176644 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176648 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176652 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176654 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176661 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 176661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rm),
     /* 176664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176666 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176670 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176675 */   GIR_RootConstrainSelectedInstOperands,
     /* 176676 */   // GIR_Coverage, 10766,
     /* 176676 */   GIR_EraseRootFromParent_Done,
     /* 176677 */ // Label 3895: @176677
     /* 176677 */ GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(176736), // Rule ID 11495 //
     /* 176682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 176685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176700 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176703 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176707 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176711 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176713 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176720 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PSZrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 176720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrm),
     /* 176723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176725 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176734 */   GIR_RootConstrainSelectedInstOperands,
     /* 176735 */   // GIR_Coverage, 11495,
     /* 176735 */   GIR_EraseRootFromParent_Done,
     /* 176736 */ // Label 3896: @176736
     /* 176736 */ GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(176766), // Rule ID 1871 //
     /* 176741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176755 */   // (sint_to_fp:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSYrr:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)
     /* 176755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrr),
     /* 176760 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176764 */   GIR_RootConstrainSelectedInstOperands,
     /* 176765 */   // GIR_Coverage, 1871,
     /* 176765 */   GIR_Done,
     /* 176766 */ // Label 3897: @176766
     /* 176766 */ GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(176796), // Rule ID 10762 //
     /* 176771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 176774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176785 */   // (sint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 176785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rr),
     /* 176790 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176794 */   GIR_RootConstrainSelectedInstOperands,
     /* 176795 */   // GIR_Coverage, 10762,
     /* 176795 */   GIR_Done,
     /* 176796 */ // Label 3898: @176796
     /* 176796 */ GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(176826), // Rule ID 11491 //
     /* 176801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 176804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176815 */   // (sint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 176815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrr),
     /* 176820 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176824 */   GIR_RootConstrainSelectedInstOperands,
     /* 176825 */   // GIR_Coverage, 11491,
     /* 176825 */   GIR_Done,
     /* 176826 */ // Label 3899: @176826
     /* 176826 */ GIM_Reject,
     /* 176827 */ // Label 3839: @176827
     /* 176827 */ GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(176886), // Rule ID 10703 //
     /* 176832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176850 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176853 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176857 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176861 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176863 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176870 */   // (sint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 176870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrm),
     /* 176873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176875 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176884 */   GIR_RootConstrainSelectedInstOperands,
     /* 176885 */   // GIR_Coverage, 10703,
     /* 176885 */   GIR_EraseRootFromParent_Done,
     /* 176886 */ // Label 3900: @176886
     /* 176886 */ GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(176945), // Rule ID 11363 //
     /* 176891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 176894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176901 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176909 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176912 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176916 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176922 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176929 */   // (sint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 176929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrm),
     /* 176932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176934 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176938 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176943 */   GIR_RootConstrainSelectedInstOperands,
     /* 176944 */   // GIR_Coverage, 11363,
     /* 176944 */   GIR_EraseRootFromParent_Done,
     /* 176945 */ // Label 3901: @176945
     /* 176945 */ GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(176971), // Rule ID 10699 //
     /* 176950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176964 */   // (sint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 176964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrr),
     /* 176969 */   GIR_RootConstrainSelectedInstOperands,
     /* 176970 */   // GIR_Coverage, 10699,
     /* 176970 */   GIR_Done,
     /* 176971 */ // Label 3902: @176971
     /* 176971 */ GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(177001), // Rule ID 11359 //
     /* 176976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 176979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176990 */   // (sint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 176990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrr),
     /* 176995 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176999 */   GIR_RootConstrainSelectedInstOperands,
     /* 177000 */   // GIR_Coverage, 11359,
     /* 177000 */   GIR_Done,
     /* 177001 */ // Label 3903: @177001
     /* 177001 */ GIM_Reject,
     /* 177002 */ // Label 3840: @177002
     /* 177002 */ GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(177061), // Rule ID 11441 //
     /* 177007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 177013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177025 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177028 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177032 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177036 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177038 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177045 */   // (sint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PHZrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 177045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrm),
     /* 177048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177050 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177054 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177059 */   GIR_RootConstrainSelectedInstOperands,
     /* 177060 */   // GIR_Coverage, 11441,
     /* 177060 */   GIR_EraseRootFromParent_Done,
     /* 177061 */ // Label 3904: @177061
     /* 177061 */ GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(177120), // Rule ID 14834 //
     /* 177066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 177069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 177072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177076 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177080 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177084 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177087 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177091 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177097 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177104 */   // (sint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 177104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rm),
     /* 177107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177109 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177113 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177118 */   GIR_RootConstrainSelectedInstOperands,
     /* 177119 */   // GIR_Coverage, 14834,
     /* 177119 */   GIR_EraseRootFromParent_Done,
     /* 177120 */ // Label 3905: @177120
     /* 177120 */ GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(177150), // Rule ID 11437 //
     /* 177125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 177131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 177139 */   // (sint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 177139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrr),
     /* 177144 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177148 */   GIR_RootConstrainSelectedInstOperands,
     /* 177149 */   // GIR_Coverage, 11437,
     /* 177149 */   GIR_Done,
     /* 177150 */ // Label 3906: @177150
     /* 177150 */ GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(177180), // Rule ID 14830 //
     /* 177155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 177158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 177161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177169 */   // (sint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 177169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rr),
     /* 177174 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177178 */   GIR_RootConstrainSelectedInstOperands,
     /* 177179 */   // GIR_Coverage, 14830,
     /* 177179 */   GIR_Done,
     /* 177180 */ // Label 3907: @177180
     /* 177180 */ GIM_Reject,
     /* 177181 */ // Label 3841: @177181
     /* 177181 */ GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(177269),
     /* 177186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 177189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 177193 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(177245), // Rule ID 10739 //
     /* 177198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177209 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177216 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177229 */     // (sint_to_fp:{ *:[v16f32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 177229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrm),
     /* 177232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177243 */     GIR_RootConstrainSelectedInstOperands,
     /* 177244 */     // GIR_Coverage, 10739,
     /* 177244 */     GIR_EraseRootFromParent_Done,
     /* 177245 */   // Label 3909: @177245
     /* 177245 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(177268), // Rule ID 10735 //
     /* 177250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 177257 */     // (sint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 177257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrr),
     /* 177262 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177266 */     GIR_RootConstrainSelectedInstOperands,
     /* 177267 */     // GIR_Coverage, 10735,
     /* 177267 */     GIR_Done,
     /* 177268 */   // Label 3910: @177268
     /* 177268 */   GIM_Reject,
     /* 177269 */ // Label 3908: @177269
     /* 177269 */ GIM_Reject,
     /* 177270 */ // Label 3842: @177270
     /* 177270 */ GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(177358),
     /* 177275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 177278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 177282 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(177334), // Rule ID 14807 //
     /* 177287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177298 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177305 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177318 */     // (sint_to_fp:{ *:[v32f16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 177318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrm),
     /* 177321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177332 */     GIR_RootConstrainSelectedInstOperands,
     /* 177333 */     // GIR_Coverage, 14807,
     /* 177333 */     GIR_EraseRootFromParent_Done,
     /* 177334 */   // Label 3912: @177334
     /* 177334 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(177357), // Rule ID 14803 //
     /* 177339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 177346 */     // (sint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 177346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrr),
     /* 177351 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177355 */     GIR_RootConstrainSelectedInstOperands,
     /* 177356 */     // GIR_Coverage, 14803,
     /* 177356 */     GIR_Done,
     /* 177357 */   // Label 3913: @177357
     /* 177357 */   GIM_Reject,
     /* 177358 */ // Label 3911: @177358
     /* 177358 */ GIM_Reject,
     /* 177359 */ // Label 3843: @177359
     /* 177359 */ GIM_Reject,
     /* 177360 */ // Label 52: @177360
     /* 177360 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3926*/ GIMT_Encode4(179606),
     /* 177371 */ /*GILLT_s16*//*Label 3914*/ GIMT_Encode4(177455),
     /* 177375 */ /*GILLT_s32*//*Label 3915*/ GIMT_Encode4(177698),
     /* 177379 */ /*GILLT_s64*//*Label 3916*/ GIMT_Encode4(177941), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177395 */ /*GILLT_v2s64*//*Label 3917*/ GIMT_Encode4(178184), GIMT_Encode4(0),
     /* 177403 */ /*GILLT_v4s32*//*Label 3918*/ GIMT_Encode4(178273),
     /* 177407 */ /*GILLT_v4s64*//*Label 3919*/ GIMT_Encode4(178452), GIMT_Encode4(0),
     /* 177415 */ /*GILLT_v8s16*//*Label 3920*/ GIMT_Encode4(178627),
     /* 177419 */ /*GILLT_v8s32*//*Label 3921*/ GIMT_Encode4(178895),
     /* 177423 */ /*GILLT_v8s64*//*Label 3922*/ GIMT_Encode4(179074), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177435 */ /*GILLT_v16s16*//*Label 3923*/ GIMT_Encode4(179249),
     /* 177439 */ /*GILLT_v16s32*//*Label 3924*/ GIMT_Encode4(179428), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177451 */ /*GILLT_v32s16*//*Label 3925*/ GIMT_Encode4(179517),
     /* 177455 */ // Label 3914: @177455
     /* 177455 */ GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(177531), // Rule ID 22186 //
     /* 177460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177470 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177474 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177478 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177481 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177485 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177489 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177491 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177498 */   // (uint_to_fp:{ *:[f16] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 177498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrm),
     /* 177515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177520 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177529 */   GIR_RootConstrainSelectedInstOperands,
     /* 177530 */   // GIR_Coverage, 22186,
     /* 177530 */   GIR_EraseRootFromParent_Done,
     /* 177531 */ // Label 3927: @177531
     /* 177531 */ GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(177607), // Rule ID 22184 //
     /* 177536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177546 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177554 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177557 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177561 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177567 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177574 */   // (uint_to_fp:{ *:[f16] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 177574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrm),
     /* 177591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177593 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177596 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177605 */   GIR_RootConstrainSelectedInstOperands,
     /* 177606 */   // GIR_Coverage, 22184,
     /* 177606 */   GIR_EraseRootFromParent_Done,
     /* 177607 */ // Label 3928: @177607
     /* 177607 */ GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(177652), // Rule ID 22188 //
     /* 177612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 177626 */   // (uint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 177626 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177629 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177633 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrr),
     /* 177643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177645 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177650 */   GIR_RootConstrainSelectedInstOperands,
     /* 177651 */   // GIR_Coverage, 22188,
     /* 177651 */   GIR_EraseRootFromParent_Done,
     /* 177652 */ // Label 3929: @177652
     /* 177652 */ GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(177697), // Rule ID 22190 //
     /* 177657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177671 */   // (uint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 177671 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177674 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177678 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrr),
     /* 177688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177690 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177693 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177695 */   GIR_RootConstrainSelectedInstOperands,
     /* 177696 */   // GIR_Coverage, 22190,
     /* 177696 */   GIR_EraseRootFromParent_Done,
     /* 177697 */ // Label 3930: @177697
     /* 177697 */ GIM_Reject,
     /* 177698 */ // Label 3915: @177698
     /* 177698 */ GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(177774), // Rule ID 21145 //
     /* 177703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177713 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177717 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177721 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177724 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177728 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177732 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177734 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177741 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrm),
     /* 177758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177763 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177772 */   GIR_RootConstrainSelectedInstOperands,
     /* 177773 */   // GIR_Coverage, 21145,
     /* 177773 */   GIR_EraseRootFromParent_Done,
     /* 177774 */ // Label 3931: @177774
     /* 177774 */ GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(177850), // Rule ID 21143 //
     /* 177779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177797 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177800 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177804 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177810 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177817 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177817 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177820 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177824 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrm),
     /* 177834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177839 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177843 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177848 */   GIR_RootConstrainSelectedInstOperands,
     /* 177849 */   // GIR_Coverage, 21143,
     /* 177849 */   GIR_EraseRootFromParent_Done,
     /* 177850 */ // Label 3932: @177850
     /* 177850 */ GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(177895), // Rule ID 21151 //
     /* 177855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 177869 */   // (uint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 177869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrr),
     /* 177886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177893 */   GIR_RootConstrainSelectedInstOperands,
     /* 177894 */   // GIR_Coverage, 21151,
     /* 177894 */   GIR_EraseRootFromParent_Done,
     /* 177895 */ // Label 3933: @177895
     /* 177895 */ GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(177940), // Rule ID 21153 //
     /* 177900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177914 */   // (uint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 177914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrr),
     /* 177931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177936 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177938 */   GIR_RootConstrainSelectedInstOperands,
     /* 177939 */   // GIR_Coverage, 21153,
     /* 177939 */   GIR_EraseRootFromParent_Done,
     /* 177940 */ // Label 3934: @177940
     /* 177940 */ GIM_Reject,
     /* 177941 */ // Label 3916: @177941
     /* 177941 */ GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(178017), // Rule ID 21149 //
     /* 177946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 177956 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177964 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177967 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177971 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177975 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177977 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177984 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 177984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrm),
     /* 178001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178006 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178010 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178015 */   GIR_RootConstrainSelectedInstOperands,
     /* 178016 */   // GIR_Coverage, 21149,
     /* 178016 */   GIR_EraseRootFromParent_Done,
     /* 178017 */ // Label 3935: @178017
     /* 178017 */ GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(178093), // Rule ID 21147 //
     /* 178022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178040 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178043 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178047 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 178051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178053 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178060 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrm),
     /* 178077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178082 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178086 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178091 */   GIR_RootConstrainSelectedInstOperands,
     /* 178092 */   // GIR_Coverage, 21147,
     /* 178092 */   GIR_EraseRootFromParent_Done,
     /* 178093 */ // Label 3936: @178093
     /* 178093 */ GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(178138), // Rule ID 21155 //
     /* 178098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178112 */   // (uint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 178112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrr),
     /* 178129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178131 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178134 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178136 */   GIR_RootConstrainSelectedInstOperands,
     /* 178137 */   // GIR_Coverage, 21155,
     /* 178137 */   GIR_EraseRootFromParent_Done,
     /* 178138 */ // Label 3937: @178138
     /* 178138 */ GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(178183), // Rule ID 21157 //
     /* 178143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178157 */   // (uint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 178157 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178160 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178164 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrr),
     /* 178174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178181 */   GIR_RootConstrainSelectedInstOperands,
     /* 178182 */   // GIR_Coverage, 21157,
     /* 178182 */   GIR_EraseRootFromParent_Done,
     /* 178183 */ // Label 3938: @178183
     /* 178183 */ GIM_Reject,
     /* 178184 */ // Label 3917: @178184
     /* 178184 */ GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(178272),
     /* 178189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178196 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(178248), // Rule ID 11417 //
     /* 178201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178212 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178215 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178219 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178232 */     // (uint_to_fp:{ *:[v2f64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 178232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rm),
     /* 178235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178237 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178246 */     GIR_RootConstrainSelectedInstOperands,
     /* 178247 */     // GIR_Coverage, 11417,
     /* 178247 */     GIR_EraseRootFromParent_Done,
     /* 178248 */   // Label 3940: @178248
     /* 178248 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(178271), // Rule ID 11413 //
     /* 178253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178260 */     // (uint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTUQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 178260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rr),
     /* 178265 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178269 */     GIR_RootConstrainSelectedInstOperands,
     /* 178270 */     // GIR_Coverage, 11413,
     /* 178270 */     GIR_Done,
     /* 178271 */   // Label 3941: @178271
     /* 178271 */   GIM_Reject,
     /* 178272 */ // Label 3939: @178272
     /* 178272 */ GIM_Reject,
     /* 178273 */ // Label 3918: @178273
     /* 178273 */ GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(178332), // Rule ID 10961 //
     /* 178278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 178281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178288 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178292 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178296 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178299 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178303 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178309 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178316 */   // (uint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 178316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rm),
     /* 178319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178321 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178325 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178330 */   GIR_RootConstrainSelectedInstOperands,
     /* 178331 */   // GIR_Coverage, 10961,
     /* 178331 */   GIR_EraseRootFromParent_Done,
     /* 178332 */ // Label 3942: @178332
     /* 178332 */ GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(178391), // Rule ID 11537 //
     /* 178337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 178343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178347 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178351 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178355 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178358 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178362 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178366 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178368 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178375 */   // (uint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PSZ256rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 178375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rm),
     /* 178378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178380 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178389 */   GIR_RootConstrainSelectedInstOperands,
     /* 178390 */   // GIR_Coverage, 11537,
     /* 178390 */   GIR_EraseRootFromParent_Done,
     /* 178391 */ // Label 3943: @178391
     /* 178391 */ GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(178421), // Rule ID 10957 //
     /* 178396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 178399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178410 */   // (uint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 178410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rr),
     /* 178415 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178419 */   GIR_RootConstrainSelectedInstOperands,
     /* 178420 */   // GIR_Coverage, 10957,
     /* 178420 */   GIR_Done,
     /* 178421 */ // Label 3944: @178421
     /* 178421 */ GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(178451), // Rule ID 11533 //
     /* 178426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 178432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178440 */   // (uint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 178440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rr),
     /* 178445 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178449 */   GIR_RootConstrainSelectedInstOperands,
     /* 178450 */   // GIR_Coverage, 11533,
     /* 178450 */   GIR_Done,
     /* 178451 */ // Label 3945: @178451
     /* 178451 */ GIM_Reject,
     /* 178452 */ // Label 3919: @178452
     /* 178452 */ GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(178511), // Rule ID 10934 //
     /* 178457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 178460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178475 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178478 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178482 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178486 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178488 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178495 */   // (uint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 178495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rm),
     /* 178498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178500 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178504 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178509 */   GIR_RootConstrainSelectedInstOperands,
     /* 178510 */   // GIR_Coverage, 10934,
     /* 178510 */   GIR_EraseRootFromParent_Done,
     /* 178511 */ // Label 3946: @178511
     /* 178511 */ GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(178570), // Rule ID 11429 //
     /* 178516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 178522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178526 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178530 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178534 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178537 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178541 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178545 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178547 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178554 */   // (uint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 178554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rm),
     /* 178557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178559 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178563 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178568 */   GIR_RootConstrainSelectedInstOperands,
     /* 178569 */   // GIR_Coverage, 11429,
     /* 178569 */   GIR_EraseRootFromParent_Done,
     /* 178570 */ // Label 3947: @178570
     /* 178570 */ GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(178596), // Rule ID 10930 //
     /* 178575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 178578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178589 */   // (uint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 178589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rr),
     /* 178594 */   GIR_RootConstrainSelectedInstOperands,
     /* 178595 */   // GIR_Coverage, 10930,
     /* 178595 */   GIR_Done,
     /* 178596 */ // Label 3948: @178596
     /* 178596 */ GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(178626), // Rule ID 11425 //
     /* 178601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 178607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178615 */   // (uint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 178615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rr),
     /* 178620 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178624 */   GIR_RootConstrainSelectedInstOperands,
     /* 178625 */   // GIR_Coverage, 11425,
     /* 178625 */   GIR_Done,
     /* 178626 */ // Label 3949: @178626
     /* 178626 */ GIM_Reject,
     /* 178627 */ // Label 3920: @178627
     /* 178627 */ GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(178686), // Rule ID 11483 //
     /* 178632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 178638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178642 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178646 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178650 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178653 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178657 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178661 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178663 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178670 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PHZ256rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 178670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rm),
     /* 178673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178675 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178679 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178684 */   GIR_RootConstrainSelectedInstOperands,
     /* 178685 */   // GIR_Coverage, 11483,
     /* 178685 */   GIR_EraseRootFromParent_Done,
     /* 178686 */ // Label 3950: @178686
     /* 178686 */ GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(178745), // Rule ID 14675 //
     /* 178691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178701 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178709 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178712 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178716 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178720 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178722 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178729 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 178729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rm),
     /* 178732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178734 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178738 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178743 */   GIR_RootConstrainSelectedInstOperands,
     /* 178744 */   // GIR_Coverage, 14675,
     /* 178744 */   GIR_EraseRootFromParent_Done,
     /* 178745 */ // Label 3951: @178745
     /* 178745 */ GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(178804), // Rule ID 15137 //
     /* 178750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 178753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 178756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178760 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178764 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178768 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178771 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178775 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178781 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178788 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PHZrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 178788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrm),
     /* 178791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178793 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178802 */   GIR_RootConstrainSelectedInstOperands,
     /* 178803 */   // GIR_Coverage, 15137,
     /* 178803 */   GIR_EraseRootFromParent_Done,
     /* 178804 */ // Label 3952: @178804
     /* 178804 */ GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(178834), // Rule ID 11479 //
     /* 178809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 178815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178823 */   // (uint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 178823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rr),
     /* 178828 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178832 */   GIR_RootConstrainSelectedInstOperands,
     /* 178833 */   // GIR_Coverage, 11479,
     /* 178833 */   GIR_Done,
     /* 178834 */ // Label 3953: @178834
     /* 178834 */ GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(178864), // Rule ID 14671 //
     /* 178839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178853 */   // (uint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTUW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 178853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rr),
     /* 178858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178862 */   GIR_RootConstrainSelectedInstOperands,
     /* 178863 */   // GIR_Coverage, 14671,
     /* 178863 */   GIR_Done,
     /* 178864 */ // Label 3954: @178864
     /* 178864 */ GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(178894), // Rule ID 15133 //
     /* 178869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 178872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 178875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178883 */   // (uint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 178883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrr),
     /* 178888 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178892 */   GIR_RootConstrainSelectedInstOperands,
     /* 178893 */   // GIR_Coverage, 15133,
     /* 178893 */   GIR_Done,
     /* 178894 */ // Label 3955: @178894
     /* 178894 */ GIM_Reject,
     /* 178895 */ // Label 3921: @178895
     /* 178895 */ GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(178954), // Rule ID 10973 //
     /* 178900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 178903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 178906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178910 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178914 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178918 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178921 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178925 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178929 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178931 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178938 */   // (uint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 178938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rm),
     /* 178941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178943 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178947 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178952 */   GIR_RootConstrainSelectedInstOperands,
     /* 178953 */   // GIR_Coverage, 10973,
     /* 178953 */   GIR_EraseRootFromParent_Done,
     /* 178954 */ // Label 3956: @178954
     /* 178954 */ GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(179013), // Rule ID 11522 //
     /* 178959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 178962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 178965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178969 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178973 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178977 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178980 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178984 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178988 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178990 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178997 */   // (uint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PSZrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 178997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrm),
     /* 179000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179002 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179006 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179011 */   GIR_RootConstrainSelectedInstOperands,
     /* 179012 */   // GIR_Coverage, 11522,
     /* 179012 */   GIR_EraseRootFromParent_Done,
     /* 179013 */ // Label 3957: @179013
     /* 179013 */ GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(179043), // Rule ID 10969 //
     /* 179018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179032 */   // (uint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 179032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rr),
     /* 179037 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179041 */   GIR_RootConstrainSelectedInstOperands,
     /* 179042 */   // GIR_Coverage, 10969,
     /* 179042 */   GIR_Done,
     /* 179043 */ // Label 3958: @179043
     /* 179043 */ GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(179073), // Rule ID 11518 //
     /* 179048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 179051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179062 */   // (uint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 179062 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrr),
     /* 179067 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179071 */   GIR_RootConstrainSelectedInstOperands,
     /* 179072 */   // GIR_Coverage, 11518,
     /* 179072 */   GIR_Done,
     /* 179073 */ // Label 3959: @179073
     /* 179073 */ GIM_Reject,
     /* 179074 */ // Label 3922: @179074
     /* 179074 */ GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(179133), // Rule ID 10910 //
     /* 179079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 179082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179089 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179093 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179097 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179100 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179104 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179108 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179110 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179117 */   // (uint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 179117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrm),
     /* 179120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179122 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179126 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179131 */   GIR_RootConstrainSelectedInstOperands,
     /* 179132 */   // GIR_Coverage, 10910,
     /* 179132 */   GIR_EraseRootFromParent_Done,
     /* 179133 */ // Label 3960: @179133
     /* 179133 */ GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(179192), // Rule ID 11402 //
     /* 179138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 179141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179156 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179159 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179163 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179167 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179169 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179176 */   // (uint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 179176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrm),
     /* 179179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179181 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179185 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179190 */   GIR_RootConstrainSelectedInstOperands,
     /* 179191 */   // GIR_Coverage, 11402,
     /* 179191 */   GIR_EraseRootFromParent_Done,
     /* 179192 */ // Label 3961: @179192
     /* 179192 */ GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(179218), // Rule ID 10906 //
     /* 179197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 179200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179211 */   // (uint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 179211 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrr),
     /* 179216 */   GIR_RootConstrainSelectedInstOperands,
     /* 179217 */   // GIR_Coverage, 10906,
     /* 179217 */   GIR_Done,
     /* 179218 */ // Label 3962: @179218
     /* 179218 */ GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(179248), // Rule ID 11398 //
     /* 179223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 179226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179237 */   // (uint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 179237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrr),
     /* 179242 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179246 */   GIR_RootConstrainSelectedInstOperands,
     /* 179247 */   // GIR_Coverage, 11398,
     /* 179247 */   GIR_Done,
     /* 179248 */ // Label 3963: @179248
     /* 179248 */ GIM_Reject,
     /* 179249 */ // Label 3923: @179249
     /* 179249 */ GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(179308), // Rule ID 11468 //
     /* 179254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 179260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179264 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179272 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179275 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179279 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179283 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179285 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179292 */   // (uint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PHZrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 179292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrm),
     /* 179295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179297 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179301 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179306 */   GIR_RootConstrainSelectedInstOperands,
     /* 179307 */   // GIR_Coverage, 11468,
     /* 179307 */   GIR_EraseRootFromParent_Done,
     /* 179308 */ // Label 3964: @179308
     /* 179308 */ GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(179367), // Rule ID 14687 //
     /* 179313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 179319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179331 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179334 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179338 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179342 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179344 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179351 */   // (uint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 179351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rm),
     /* 179354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179356 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179360 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179365 */   GIR_RootConstrainSelectedInstOperands,
     /* 179366 */   // GIR_Coverage, 14687,
     /* 179366 */   GIR_EraseRootFromParent_Done,
     /* 179367 */ // Label 3965: @179367
     /* 179367 */ GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(179397), // Rule ID 11464 //
     /* 179372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 179378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179386 */   // (uint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 179386 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrr),
     /* 179391 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179395 */   GIR_RootConstrainSelectedInstOperands,
     /* 179396 */   // GIR_Coverage, 11464,
     /* 179396 */   GIR_Done,
     /* 179397 */ // Label 3966: @179397
     /* 179397 */ GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(179427), // Rule ID 14683 //
     /* 179402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 179408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179416 */   // (uint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTUW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 179416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rr),
     /* 179421 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179425 */   GIR_RootConstrainSelectedInstOperands,
     /* 179426 */   // GIR_Coverage, 14683,
     /* 179426 */   GIR_Done,
     /* 179427 */ // Label 3967: @179427
     /* 179427 */ GIM_Reject,
     /* 179428 */ // Label 3924: @179428
     /* 179428 */ GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(179516),
     /* 179433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 179436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179440 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(179492), // Rule ID 10946 //
     /* 179445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 179448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179456 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179459 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179463 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179476 */     // (uint_to_fp:{ *:[v16f32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 179476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrm),
     /* 179479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179481 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179490 */     GIR_RootConstrainSelectedInstOperands,
     /* 179491 */     // GIR_Coverage, 10946,
     /* 179491 */     GIR_EraseRootFromParent_Done,
     /* 179492 */   // Label 3969: @179492
     /* 179492 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(179515), // Rule ID 10942 //
     /* 179497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 179500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179504 */     // (uint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 179504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrr),
     /* 179509 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179513 */     GIR_RootConstrainSelectedInstOperands,
     /* 179514 */     // GIR_Coverage, 10942,
     /* 179514 */     GIR_Done,
     /* 179515 */   // Label 3970: @179515
     /* 179515 */   GIM_Reject,
     /* 179516 */ // Label 3968: @179516
     /* 179516 */ GIM_Reject,
     /* 179517 */ // Label 3925: @179517
     /* 179517 */ GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(179605),
     /* 179522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 179525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179529 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(179581), // Rule ID 14660 //
     /* 179534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179545 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179552 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179565 */     // (uint_to_fp:{ *:[v32f16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 179565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrm),
     /* 179568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179579 */     GIR_RootConstrainSelectedInstOperands,
     /* 179580 */     // GIR_Coverage, 14660,
     /* 179580 */     GIR_EraseRootFromParent_Done,
     /* 179581 */   // Label 3972: @179581
     /* 179581 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(179604), // Rule ID 14656 //
     /* 179586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179593 */     // (uint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTUW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 179593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrr),
     /* 179598 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179602 */     GIR_RootConstrainSelectedInstOperands,
     /* 179603 */     // GIR_Coverage, 14656,
     /* 179603 */     GIR_Done,
     /* 179604 */   // Label 3973: @179604
     /* 179604 */   GIM_Reject,
     /* 179605 */ // Label 3971: @179605
     /* 179605 */ GIM_Reject,
     /* 179606 */ // Label 3926: @179606
     /* 179606 */ GIM_Reject,
     /* 179607 */ // Label 53: @179607
     /* 179607 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 3977*/ GIMT_Encode4(179729),
     /* 179618 */ /*GILLT_s32*//*Label 3974*/ GIMT_Encode4(179630),
     /* 179622 */ /*GILLT_s64*//*Label 3975*/ GIMT_Encode4(179663),
     /* 179626 */ /*GILLT_s80*//*Label 3976*/ GIMT_Encode4(179696),
     /* 179630 */ // Label 3974: @179630
     /* 179630 */ GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(179662), // Rule ID 1044 //
     /* 179635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 179638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 179641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 179645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 179649 */   // (fabs:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (ABS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 179649 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp32),
     /* 179654 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 179660 */   GIR_RootConstrainSelectedInstOperands,
     /* 179661 */   // GIR_Coverage, 1044,
     /* 179661 */   GIR_Done,
     /* 179662 */ // Label 3978: @179662
     /* 179662 */ GIM_Reject,
     /* 179663 */ // Label 3975: @179663
     /* 179663 */ GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(179695), // Rule ID 1045 //
     /* 179668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 179671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 179674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 179678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 179682 */   // (fabs:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (ABS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 179682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp64),
     /* 179687 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 179693 */   GIR_RootConstrainSelectedInstOperands,
     /* 179694 */   // GIR_Coverage, 1045,
     /* 179694 */   GIR_Done,
     /* 179695 */ // Label 3979: @179695
     /* 179695 */ GIM_Reject,
     /* 179696 */ // Label 3976: @179696
     /* 179696 */ GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(179728), // Rule ID 1046 //
     /* 179701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 179704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 179707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 179711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 179715 */   // (fabs:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (ABS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 179715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp80),
     /* 179720 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 179726 */   GIR_RootConstrainSelectedInstOperands,
     /* 179727 */   // GIR_Coverage, 1046,
     /* 179727 */   GIR_Done,
     /* 179728 */ // Label 3980: @179728
     /* 179728 */ GIM_Reject,
     /* 179729 */ // Label 3977: @179729
     /* 179729 */ GIM_Reject,
     /* 179730 */ // Label 54: @179730
     /* 179730 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 3993*/ GIMT_Encode4(183050),
     /* 179741 */ /*GILLT_v2s64*//*Label 3981*/ GIMT_Encode4(179809), GIMT_Encode4(0),
     /* 179749 */ /*GILLT_v4s32*//*Label 3982*/ GIMT_Encode4(180138),
     /* 179753 */ /*GILLT_v4s64*//*Label 3983*/ GIMT_Encode4(180480), GIMT_Encode4(0),
     /* 179761 */ /*GILLT_v8s16*//*Label 3984*/ GIMT_Encode4(180797),
     /* 179765 */ /*GILLT_v8s32*//*Label 3985*/ GIMT_Encode4(181139),
     /* 179769 */ /*GILLT_v8s64*//*Label 3986*/ GIMT_Encode4(181454), GIMT_Encode4(0),
     /* 179777 */ /*GILLT_v16s8*//*Label 3987*/ GIMT_Encode4(181610),
     /* 179781 */ /*GILLT_v16s16*//*Label 3988*/ GIMT_Encode4(181952),
     /* 179785 */ /*GILLT_v16s32*//*Label 3989*/ GIMT_Encode4(182267), GIMT_Encode4(0),
     /* 179793 */ /*GILLT_v32s8*//*Label 3990*/ GIMT_Encode4(182423),
     /* 179797 */ /*GILLT_v32s16*//*Label 3991*/ GIMT_Encode4(182738), GIMT_Encode4(0),
     /* 179805 */ /*GILLT_v64s8*//*Label 3992*/ GIMT_Encode4(182894),
     /* 179809 */ // Label 3981: @179809
     /* 179809 */ GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(180137),
     /* 179814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 179817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179820 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(179882), // Rule ID 24074 //
     /* 179825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179840 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179843 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179847 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179864 */     // (smin:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMINSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 179864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rm),
     /* 179867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179869 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 179871 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 179875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179880 */     GIR_RootConstrainSelectedInstOperands,
     /* 179881 */     // GIR_Coverage, 24074,
     /* 179881 */     GIR_EraseRootFromParent_Done,
     /* 179882 */   // Label 3995: @179882
     /* 179882 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(179944), // Rule ID 5589 //
     /* 179887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179906 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179909 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179913 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179926 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 179926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rm),
     /* 179929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179931 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 179933 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 179937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179942 */     GIR_RootConstrainSelectedInstOperands,
     /* 179943 */     // GIR_Coverage, 5589,
     /* 179943 */     GIR_EraseRootFromParent_Done,
     /* 179944 */   // Label 3996: @179944
     /* 179944 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(179971), // Rule ID 5586 //
     /* 179949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179964 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 179964 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rr),
     /* 179969 */     GIR_RootConstrainSelectedInstOperands,
     /* 179970 */     // GIR_Coverage, 5586,
     /* 179970 */     GIR_Done,
     /* 179971 */   // Label 3997: @179971
     /* 179971 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(180136), // Rule ID 20013 //
     /* 179976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 179979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 179983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179991 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 179991 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 179994 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 179998 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 180005 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 180008 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180012 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180017 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 180020 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 180024 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 180027 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 180032 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180037 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 180042 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 180045 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180049 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 180056 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 180059 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180063 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180068 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 180071 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 180075 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 180078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 180083 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180088 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 180093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 180096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 180100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180105 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 180108 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 180111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180118 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 180125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 180130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180135 */     // GIR_Coverage, 20013,
     /* 180135 */     GIR_EraseRootFromParent_Done,
     /* 180136 */   // Label 3998: @180136
     /* 180136 */   GIM_Reject,
     /* 180137 */ // Label 3994: @180137
     /* 180137 */ GIM_Reject,
     /* 180138 */ // Label 3982: @180138
     /* 180138 */ GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(180479),
     /* 180143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180149 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(180211), // Rule ID 23498 //
     /* 180154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 180157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180169 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180172 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180176 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180193 */     // (smin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMINSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDrm),
     /* 180196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180198 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180209 */     GIR_RootConstrainSelectedInstOperands,
     /* 180210 */     // GIR_Coverage, 23498,
     /* 180210 */     GIR_EraseRootFromParent_Done,
     /* 180211 */   // Label 4000: @180211
     /* 180211 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(180273), // Rule ID 24056 //
     /* 180216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180231 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180234 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180238 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180255 */     // (smin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMINSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rm),
     /* 180258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180260 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180262 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180271 */     GIR_RootConstrainSelectedInstOperands,
     /* 180272 */     // GIR_Coverage, 24056,
     /* 180272 */     GIR_EraseRootFromParent_Done,
     /* 180273 */   // Label 4001: @180273
     /* 180273 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(180335), // Rule ID 3185 //
     /* 180278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 180281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180297 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180300 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180304 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180310 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180317 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDrm),
     /* 180320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180322 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180324 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180333 */     GIR_RootConstrainSelectedInstOperands,
     /* 180334 */     // GIR_Coverage, 3185,
     /* 180334 */     GIR_EraseRootFromParent_Done,
     /* 180335 */   // Label 4002: @180335
     /* 180335 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(180397), // Rule ID 5562 //
     /* 180340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180359 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180362 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180366 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180379 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rm),
     /* 180382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180384 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180386 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180395 */     GIR_RootConstrainSelectedInstOperands,
     /* 180396 */     // GIR_Coverage, 5562,
     /* 180396 */     GIR_EraseRootFromParent_Done,
     /* 180397 */   // Label 4003: @180397
     /* 180397 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(180424), // Rule ID 3184 //
     /* 180402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 180405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180417 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 180417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDrr),
     /* 180422 */     GIR_RootConstrainSelectedInstOperands,
     /* 180423 */     // GIR_Coverage, 3184,
     /* 180423 */     GIR_Done,
     /* 180424 */   // Label 4004: @180424
     /* 180424 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(180451), // Rule ID 3222 //
     /* 180429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 180432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180444 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 180444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSDrr),
     /* 180449 */     GIR_RootConstrainSelectedInstOperands,
     /* 180450 */     // GIR_Coverage, 3222,
     /* 180450 */     GIR_Done,
     /* 180451 */   // Label 4005: @180451
     /* 180451 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(180478), // Rule ID 5559 //
     /* 180456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180471 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 180471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rr),
     /* 180476 */     GIR_RootConstrainSelectedInstOperands,
     /* 180477 */     // GIR_Coverage, 5559,
     /* 180477 */     GIR_Done,
     /* 180478 */   // Label 4006: @180478
     /* 180478 */   GIM_Reject,
     /* 180479 */ // Label 3999: @180479
     /* 180479 */ GIM_Reject,
     /* 180480 */ // Label 3983: @180480
     /* 180480 */ GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(180796),
     /* 180485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 180488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 180491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180495 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(180553), // Rule ID 24068 //
     /* 180500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180511 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180514 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180518 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180535 */     // (smin:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMINSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rm),
     /* 180538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180540 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180542 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180551 */     GIR_RootConstrainSelectedInstOperands,
     /* 180552 */     // GIR_Coverage, 24068,
     /* 180552 */     GIR_EraseRootFromParent_Done,
     /* 180553 */   // Label 4008: @180553
     /* 180553 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(180611), // Rule ID 5580 //
     /* 180558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180573 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180576 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180580 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180593 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rm),
     /* 180596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180598 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180600 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180609 */     GIR_RootConstrainSelectedInstOperands,
     /* 180610 */     // GIR_Coverage, 5580,
     /* 180610 */     GIR_EraseRootFromParent_Done,
     /* 180611 */   // Label 4009: @180611
     /* 180611 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(180634), // Rule ID 5577 //
     /* 180616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180627 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 180627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rr),
     /* 180632 */     GIR_RootConstrainSelectedInstOperands,
     /* 180633 */     // GIR_Coverage, 5577,
     /* 180633 */     GIR_Done,
     /* 180634 */   // Label 4010: @180634
     /* 180634 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(180795), // Rule ID 20011 //
     /* 180639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 180642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180650 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 180650 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 180653 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180657 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 180664 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 180667 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180671 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180676 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 180679 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 180683 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 180686 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 180691 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180696 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 180701 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 180704 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180708 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 180715 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 180718 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180722 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180727 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 180730 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 180734 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 180737 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 180742 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180747 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 180752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 180755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 180759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180764 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 180767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 180770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180777 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 180784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 180789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180794 */     // GIR_Coverage, 20011,
     /* 180794 */     GIR_EraseRootFromParent_Done,
     /* 180795 */   // Label 4011: @180795
     /* 180795 */   GIM_Reject,
     /* 180796 */ // Label 4007: @180796
     /* 180796 */ GIM_Reject,
     /* 180797 */ // Label 3984: @180797
     /* 180797 */ GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(181138),
     /* 180802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 180805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180808 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(180870), // Rule ID 23462 //
     /* 180813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 180816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180835 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180852 */     // (smin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMINSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWrm),
     /* 180855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180857 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180859 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180868 */     GIR_RootConstrainSelectedInstOperands,
     /* 180869 */     // GIR_Coverage, 23462,
     /* 180869 */     GIR_EraseRootFromParent_Done,
     /* 180870 */   // Label 4013: @180870
     /* 180870 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(180932), // Rule ID 24041 //
     /* 180875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 180878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180890 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180893 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180897 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180914 */     // (smin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMINSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rm),
     /* 180917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180919 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180921 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180930 */     GIR_RootConstrainSelectedInstOperands,
     /* 180931 */     // GIR_Coverage, 24041,
     /* 180931 */     GIR_EraseRootFromParent_Done,
     /* 180932 */   // Label 4014: @180932
     /* 180932 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(180994), // Rule ID 2642 //
     /* 180937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 180940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180956 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180963 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180976 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWrm),
     /* 180979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180981 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180983 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180992 */     GIR_RootConstrainSelectedInstOperands,
     /* 180993 */     // GIR_Coverage, 2642,
     /* 180993 */     GIR_EraseRootFromParent_Done,
     /* 180994 */   // Label 4015: @180994
     /* 180994 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(181056), // Rule ID 5538 //
     /* 180999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181018 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181021 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181025 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181038 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rm),
     /* 181041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181043 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181054 */     GIR_RootConstrainSelectedInstOperands,
     /* 181055 */     // GIR_Coverage, 5538,
     /* 181055 */     GIR_EraseRootFromParent_Done,
     /* 181056 */   // Label 4016: @181056
     /* 181056 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(181083), // Rule ID 2641 //
     /* 181061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 181064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181076 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 181076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWrr),
     /* 181081 */     GIR_RootConstrainSelectedInstOperands,
     /* 181082 */     // GIR_Coverage, 2641,
     /* 181082 */     GIR_Done,
     /* 181083 */   // Label 4017: @181083
     /* 181083 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(181110), // Rule ID 2643 //
     /* 181088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 181091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181103 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 181103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSWrr),
     /* 181108 */     GIR_RootConstrainSelectedInstOperands,
     /* 181109 */     // GIR_Coverage, 2643,
     /* 181109 */     GIR_Done,
     /* 181110 */   // Label 4018: @181110
     /* 181110 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(181137), // Rule ID 5535 //
     /* 181115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181130 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 181130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rr),
     /* 181135 */     GIR_RootConstrainSelectedInstOperands,
     /* 181136 */     // GIR_Coverage, 5535,
     /* 181136 */     GIR_Done,
     /* 181137 */   // Label 4019: @181137
     /* 181137 */   GIM_Reject,
     /* 181138 */ // Label 4012: @181138
     /* 181138 */ GIM_Reject,
     /* 181139 */ // Label 3985: @181139
     /* 181139 */ GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(181453),
     /* 181144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 181147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 181150 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(181212), // Rule ID 23507 //
     /* 181155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 181158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181170 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181177 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181194 */     // (smin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMINSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrm),
     /* 181197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181199 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181201 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181210 */     GIR_RootConstrainSelectedInstOperands,
     /* 181211 */     // GIR_Coverage, 23507,
     /* 181211 */     GIR_EraseRootFromParent_Done,
     /* 181212 */   // Label 4021: @181212
     /* 181212 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(181274), // Rule ID 24050 //
     /* 181217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 181220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181256 */     // (smin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMINSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rm),
     /* 181259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181263 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181272 */     GIR_RootConstrainSelectedInstOperands,
     /* 181273 */     // GIR_Coverage, 24050,
     /* 181273 */     GIR_EraseRootFromParent_Done,
     /* 181274 */   // Label 4022: @181274
     /* 181274 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(181336), // Rule ID 3203 //
     /* 181279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 181282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181298 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181305 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181318 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrm),
     /* 181321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181323 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181325 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181334 */     GIR_RootConstrainSelectedInstOperands,
     /* 181335 */     // GIR_Coverage, 3203,
     /* 181335 */     GIR_EraseRootFromParent_Done,
     /* 181336 */   // Label 4023: @181336
     /* 181336 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(181398), // Rule ID 5553 //
     /* 181341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 181344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181360 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181367 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181380 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rm),
     /* 181383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181385 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181387 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181396 */     GIR_RootConstrainSelectedInstOperands,
     /* 181397 */     // GIR_Coverage, 5553,
     /* 181397 */     GIR_EraseRootFromParent_Done,
     /* 181398 */   // Label 4024: @181398
     /* 181398 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(181425), // Rule ID 3202 //
     /* 181403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 181406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181418 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 181418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrr),
     /* 181423 */     GIR_RootConstrainSelectedInstOperands,
     /* 181424 */     // GIR_Coverage, 3202,
     /* 181424 */     GIR_Done,
     /* 181425 */   // Label 4025: @181425
     /* 181425 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(181452), // Rule ID 5550 //
     /* 181430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 181433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181445 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 181445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rr),
     /* 181450 */     GIR_RootConstrainSelectedInstOperands,
     /* 181451 */     // GIR_Coverage, 5550,
     /* 181451 */     GIR_Done,
     /* 181452 */   // Label 4026: @181452
     /* 181452 */   GIM_Reject,
     /* 181453 */ // Label 4020: @181453
     /* 181453 */ GIM_Reject,
     /* 181454 */ // Label 3986: @181454
     /* 181454 */ GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(181609),
     /* 181459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 181462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 181465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181469 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(181527), // Rule ID 24062 //
     /* 181474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181485 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181492 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181509 */     // (smin:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMINSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrm),
     /* 181512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181514 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181525 */     GIR_RootConstrainSelectedInstOperands,
     /* 181526 */     // GIR_Coverage, 24062,
     /* 181526 */     GIR_EraseRootFromParent_Done,
     /* 181527 */   // Label 4028: @181527
     /* 181527 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(181585), // Rule ID 5571 //
     /* 181532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181547 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181550 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181554 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181567 */     // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrm),
     /* 181570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181572 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181574 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181583 */     GIR_RootConstrainSelectedInstOperands,
     /* 181584 */     // GIR_Coverage, 5571,
     /* 181584 */     GIR_EraseRootFromParent_Done,
     /* 181585 */   // Label 4029: @181585
     /* 181585 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(181608), // Rule ID 5568 //
     /* 181590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181601 */     // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 181601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 181606 */     GIR_RootConstrainSelectedInstOperands,
     /* 181607 */     // GIR_Coverage, 5568,
     /* 181607 */     GIR_Done,
     /* 181608 */   // Label 4030: @181608
     /* 181608 */   GIM_Reject,
     /* 181609 */ // Label 4027: @181609
     /* 181609 */ GIM_Reject,
     /* 181610 */ // Label 3987: @181610
     /* 181610 */ GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(181951),
     /* 181615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 181618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 181621 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(181683), // Rule ID 23503 //
     /* 181626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 181629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181641 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181648 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181665 */     // (smin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMINSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBrm),
     /* 181668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181670 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181681 */     GIR_RootConstrainSelectedInstOperands,
     /* 181682 */     // GIR_Coverage, 23503,
     /* 181682 */     GIR_EraseRootFromParent_Done,
     /* 181683 */   // Label 4032: @181683
     /* 181683 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(181745), // Rule ID 24032 //
     /* 181688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181703 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181710 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181727 */     // (smin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMINSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rm),
     /* 181730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181732 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181734 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181743 */     GIR_RootConstrainSelectedInstOperands,
     /* 181744 */     // GIR_Coverage, 24032,
     /* 181744 */     GIR_EraseRootFromParent_Done,
     /* 181745 */   // Label 4033: @181745
     /* 181745 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(181807), // Rule ID 3195 //
     /* 181750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 181753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181769 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181776 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181789 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBrm),
     /* 181792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181794 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181805 */     GIR_RootConstrainSelectedInstOperands,
     /* 181806 */     // GIR_Coverage, 3195,
     /* 181806 */     GIR_EraseRootFromParent_Done,
     /* 181807 */   // Label 4034: @181807
     /* 181807 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(181869), // Rule ID 5520 //
     /* 181812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181831 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181838 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181851 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rm),
     /* 181854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181856 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181858 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181867 */     GIR_RootConstrainSelectedInstOperands,
     /* 181868 */     // GIR_Coverage, 5520,
     /* 181868 */     GIR_EraseRootFromParent_Done,
     /* 181869 */   // Label 4035: @181869
     /* 181869 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(181896), // Rule ID 3194 //
     /* 181874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 181877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181889 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 181889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBrr),
     /* 181894 */     GIR_RootConstrainSelectedInstOperands,
     /* 181895 */     // GIR_Coverage, 3194,
     /* 181895 */     GIR_Done,
     /* 181896 */   // Label 4036: @181896
     /* 181896 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(181923), // Rule ID 3220 //
     /* 181901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 181904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181916 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 181916 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSBrr),
     /* 181921 */     GIR_RootConstrainSelectedInstOperands,
     /* 181922 */     // GIR_Coverage, 3220,
     /* 181922 */     GIR_Done,
     /* 181923 */   // Label 4037: @181923
     /* 181923 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(181950), // Rule ID 5517 //
     /* 181928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181943 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 181943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rr),
     /* 181948 */     GIR_RootConstrainSelectedInstOperands,
     /* 181949 */     // GIR_Coverage, 5517,
     /* 181949 */     GIR_Done,
     /* 181950 */   // Label 4038: @181950
     /* 181950 */   GIM_Reject,
     /* 181951 */ // Label 4031: @181951
     /* 181951 */ GIM_Reject,
     /* 181952 */ // Label 3988: @181952
     /* 181952 */ GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(182266),
     /* 181957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 181960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 181963 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(182025), // Rule ID 23464 //
     /* 181968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 181971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181983 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181990 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182007 */     // (smin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMINSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrm),
     /* 182010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182012 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182014 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182023 */     GIR_RootConstrainSelectedInstOperands,
     /* 182024 */     // GIR_Coverage, 23464,
     /* 182024 */     GIR_EraseRootFromParent_Done,
     /* 182025 */   // Label 4040: @182025
     /* 182025 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(182087), // Rule ID 24038 //
     /* 182030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182069 */     // (smin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMINSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rm),
     /* 182072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182074 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182085 */     GIR_RootConstrainSelectedInstOperands,
     /* 182086 */     // GIR_Coverage, 24038,
     /* 182086 */     GIR_EraseRootFromParent_Done,
     /* 182087 */   // Label 4041: @182087
     /* 182087 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(182149), // Rule ID 2646 //
     /* 182092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 182095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182111 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182114 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182118 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182131 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrm),
     /* 182134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182136 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182138 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182147 */     GIR_RootConstrainSelectedInstOperands,
     /* 182148 */     // GIR_Coverage, 2646,
     /* 182148 */     GIR_EraseRootFromParent_Done,
     /* 182149 */   // Label 4042: @182149
     /* 182149 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(182211), // Rule ID 5532 //
     /* 182154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182173 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182176 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182180 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182193 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rm),
     /* 182196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182198 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182209 */     GIR_RootConstrainSelectedInstOperands,
     /* 182210 */     // GIR_Coverage, 5532,
     /* 182210 */     GIR_EraseRootFromParent_Done,
     /* 182211 */   // Label 4043: @182211
     /* 182211 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(182238), // Rule ID 2645 //
     /* 182216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 182219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182231 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 182231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrr),
     /* 182236 */     GIR_RootConstrainSelectedInstOperands,
     /* 182237 */     // GIR_Coverage, 2645,
     /* 182237 */     GIR_Done,
     /* 182238 */   // Label 4044: @182238
     /* 182238 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(182265), // Rule ID 5529 //
     /* 182243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182258 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 182258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rr),
     /* 182263 */     GIR_RootConstrainSelectedInstOperands,
     /* 182264 */     // GIR_Coverage, 5529,
     /* 182264 */     GIR_Done,
     /* 182265 */   // Label 4045: @182265
     /* 182265 */   GIM_Reject,
     /* 182266 */ // Label 4039: @182266
     /* 182266 */ GIM_Reject,
     /* 182267 */ // Label 3989: @182267
     /* 182267 */ GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(182422),
     /* 182272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 182275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 182278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182282 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(182340), // Rule ID 24044 //
     /* 182287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182298 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182305 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182322 */     // (smin:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMINSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrm),
     /* 182325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182327 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182329 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182338 */     GIR_RootConstrainSelectedInstOperands,
     /* 182339 */     // GIR_Coverage, 24044,
     /* 182339 */     GIR_EraseRootFromParent_Done,
     /* 182340 */   // Label 4047: @182340
     /* 182340 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(182398), // Rule ID 5544 //
     /* 182345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182360 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182367 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182380 */     // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrm),
     /* 182383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182385 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182387 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182396 */     GIR_RootConstrainSelectedInstOperands,
     /* 182397 */     // GIR_Coverage, 5544,
     /* 182397 */     GIR_EraseRootFromParent_Done,
     /* 182398 */   // Label 4048: @182398
     /* 182398 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(182421), // Rule ID 5541 //
     /* 182403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182414 */     // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 182414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrr),
     /* 182419 */     GIR_RootConstrainSelectedInstOperands,
     /* 182420 */     // GIR_Coverage, 5541,
     /* 182420 */     GIR_Done,
     /* 182421 */   // Label 4049: @182421
     /* 182421 */   GIM_Reject,
     /* 182422 */ // Label 4046: @182422
     /* 182422 */ GIM_Reject,
     /* 182423 */ // Label 3990: @182423
     /* 182423 */ GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(182737),
     /* 182428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 182431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 182434 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(182496), // Rule ID 23512 //
     /* 182439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 182442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182454 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182457 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182461 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182478 */     // (smin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMINSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrm),
     /* 182481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182483 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182485 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182494 */     GIR_RootConstrainSelectedInstOperands,
     /* 182495 */     // GIR_Coverage, 23512,
     /* 182495 */     GIR_EraseRootFromParent_Done,
     /* 182496 */   // Label 4051: @182496
     /* 182496 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(182558), // Rule ID 24029 //
     /* 182501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182540 */     // (smin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMINSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rm),
     /* 182543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182545 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182556 */     GIR_RootConstrainSelectedInstOperands,
     /* 182557 */     // GIR_Coverage, 24029,
     /* 182557 */     GIR_EraseRootFromParent_Done,
     /* 182558 */   // Label 4052: @182558
     /* 182558 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(182620), // Rule ID 3213 //
     /* 182563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 182566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182602 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrm),
     /* 182605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182618 */     GIR_RootConstrainSelectedInstOperands,
     /* 182619 */     // GIR_Coverage, 3213,
     /* 182619 */     GIR_EraseRootFromParent_Done,
     /* 182620 */   // Label 4053: @182620
     /* 182620 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(182682), // Rule ID 5514 //
     /* 182625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182664 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rm),
     /* 182667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182680 */     GIR_RootConstrainSelectedInstOperands,
     /* 182681 */     // GIR_Coverage, 5514,
     /* 182681 */     GIR_EraseRootFromParent_Done,
     /* 182682 */   // Label 4054: @182682
     /* 182682 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(182709), // Rule ID 3212 //
     /* 182687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 182690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182702 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 182702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrr),
     /* 182707 */     GIR_RootConstrainSelectedInstOperands,
     /* 182708 */     // GIR_Coverage, 3212,
     /* 182708 */     GIR_Done,
     /* 182709 */   // Label 4055: @182709
     /* 182709 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(182736), // Rule ID 5511 //
     /* 182714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182729 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 182729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rr),
     /* 182734 */     GIR_RootConstrainSelectedInstOperands,
     /* 182735 */     // GIR_Coverage, 5511,
     /* 182735 */     GIR_Done,
     /* 182736 */   // Label 4056: @182736
     /* 182736 */   GIM_Reject,
     /* 182737 */ // Label 4050: @182737
     /* 182737 */ GIM_Reject,
     /* 182738 */ // Label 3991: @182738
     /* 182738 */ GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(182893),
     /* 182743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 182746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 182749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182753 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(182811), // Rule ID 24035 //
     /* 182758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182769 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182776 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182793 */     // (smin:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMINSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrm),
     /* 182796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182798 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182809 */     GIR_RootConstrainSelectedInstOperands,
     /* 182810 */     // GIR_Coverage, 24035,
     /* 182810 */     GIR_EraseRootFromParent_Done,
     /* 182811 */   // Label 4058: @182811
     /* 182811 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(182869), // Rule ID 5526 //
     /* 182816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182831 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182838 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182851 */     // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrm),
     /* 182854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182856 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182858 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182867 */     GIR_RootConstrainSelectedInstOperands,
     /* 182868 */     // GIR_Coverage, 5526,
     /* 182868 */     GIR_EraseRootFromParent_Done,
     /* 182869 */   // Label 4059: @182869
     /* 182869 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(182892), // Rule ID 5523 //
     /* 182874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182885 */     // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 182885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrr),
     /* 182890 */     GIR_RootConstrainSelectedInstOperands,
     /* 182891 */     // GIR_Coverage, 5523,
     /* 182891 */     GIR_Done,
     /* 182892 */   // Label 4060: @182892
     /* 182892 */   GIM_Reject,
     /* 182893 */ // Label 4057: @182893
     /* 182893 */ GIM_Reject,
     /* 182894 */ // Label 3992: @182894
     /* 182894 */ GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(183049),
     /* 182899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 182902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 182905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182909 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(182967), // Rule ID 24026 //
     /* 182914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182925 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182928 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182932 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182949 */     // (smin:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMINSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrm),
     /* 182952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182956 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182965 */     GIR_RootConstrainSelectedInstOperands,
     /* 182966 */     // GIR_Coverage, 24026,
     /* 182966 */     GIR_EraseRootFromParent_Done,
     /* 182967 */   // Label 4062: @182967
     /* 182967 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(183025), // Rule ID 5508 //
     /* 182972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182987 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182990 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182994 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183007 */     // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrm),
     /* 183010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183012 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183014 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183023 */     GIR_RootConstrainSelectedInstOperands,
     /* 183024 */     // GIR_Coverage, 5508,
     /* 183024 */     GIR_EraseRootFromParent_Done,
     /* 183025 */   // Label 4063: @183025
     /* 183025 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(183048), // Rule ID 5505 //
     /* 183030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 183033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 183037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 183041 */     // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 183041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrr),
     /* 183046 */     GIR_RootConstrainSelectedInstOperands,
     /* 183047 */     // GIR_Coverage, 5505,
     /* 183047 */     GIR_Done,
     /* 183048 */   // Label 4064: @183048
     /* 183048 */   GIM_Reject,
     /* 183049 */ // Label 4061: @183049
     /* 183049 */ GIM_Reject,
     /* 183050 */ // Label 3993: @183050
     /* 183050 */ GIM_Reject,
     /* 183051 */ // Label 55: @183051
     /* 183051 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4077*/ GIMT_Encode4(186371),
     /* 183062 */ /*GILLT_v2s64*//*Label 4065*/ GIMT_Encode4(183130), GIMT_Encode4(0),
     /* 183070 */ /*GILLT_v4s32*//*Label 4066*/ GIMT_Encode4(183459),
     /* 183074 */ /*GILLT_v4s64*//*Label 4067*/ GIMT_Encode4(183801), GIMT_Encode4(0),
     /* 183082 */ /*GILLT_v8s16*//*Label 4068*/ GIMT_Encode4(184118),
     /* 183086 */ /*GILLT_v8s32*//*Label 4069*/ GIMT_Encode4(184460),
     /* 183090 */ /*GILLT_v8s64*//*Label 4070*/ GIMT_Encode4(184775), GIMT_Encode4(0),
     /* 183098 */ /*GILLT_v16s8*//*Label 4071*/ GIMT_Encode4(184931),
     /* 183102 */ /*GILLT_v16s16*//*Label 4072*/ GIMT_Encode4(185273),
     /* 183106 */ /*GILLT_v16s32*//*Label 4073*/ GIMT_Encode4(185588), GIMT_Encode4(0),
     /* 183114 */ /*GILLT_v32s8*//*Label 4074*/ GIMT_Encode4(185744),
     /* 183118 */ /*GILLT_v32s16*//*Label 4075*/ GIMT_Encode4(186059), GIMT_Encode4(0),
     /* 183126 */ /*GILLT_v64s8*//*Label 4076*/ GIMT_Encode4(186215),
     /* 183130 */ // Label 4065: @183130
     /* 183130 */ GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(183458),
     /* 183135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 183138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183141 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(183203), // Rule ID 23966 //
     /* 183146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183161 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183164 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183168 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183185 */     // (smax:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMAXSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rm),
     /* 183188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183190 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183201 */     GIR_RootConstrainSelectedInstOperands,
     /* 183202 */     // GIR_Coverage, 23966,
     /* 183202 */     GIR_EraseRootFromParent_Done,
     /* 183203 */   // Label 4079: @183203
     /* 183203 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(183265), // Rule ID 5409 //
     /* 183208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183227 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183230 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183234 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183247 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rm),
     /* 183250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183254 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183263 */     GIR_RootConstrainSelectedInstOperands,
     /* 183264 */     // GIR_Coverage, 5409,
     /* 183264 */     GIR_EraseRootFromParent_Done,
     /* 183265 */   // Label 4080: @183265
     /* 183265 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(183292), // Rule ID 5406 //
     /* 183270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183285 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 183285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rr),
     /* 183290 */     GIR_RootConstrainSelectedInstOperands,
     /* 183291 */     // GIR_Coverage, 5406,
     /* 183291 */     GIR_Done,
     /* 183292 */   // Label 4081: @183292
     /* 183292 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(183457), // Rule ID 20009 //
     /* 183297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 183300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 183304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183312 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 183312 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 183315 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183319 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 183326 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 183329 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183333 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183338 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 183341 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 183345 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 183348 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183353 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183358 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 183363 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 183366 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183370 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 183377 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 183380 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183384 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183389 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 183392 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 183396 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 183399 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183404 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183409 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 183414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 183417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 183421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183426 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 183429 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 183432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183439 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 183446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 183451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183456 */     // GIR_Coverage, 20009,
     /* 183456 */     GIR_EraseRootFromParent_Done,
     /* 183457 */   // Label 4082: @183457
     /* 183457 */   GIM_Reject,
     /* 183458 */ // Label 4078: @183458
     /* 183458 */ GIM_Reject,
     /* 183459 */ // Label 4066: @183459
     /* 183459 */ GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(183800),
     /* 183464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 183467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183470 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(183532), // Rule ID 23500 //
     /* 183475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183490 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183493 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183497 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183514 */     // (smax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMAXSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrm),
     /* 183517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183519 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183530 */     GIR_RootConstrainSelectedInstOperands,
     /* 183531 */     // GIR_Coverage, 23500,
     /* 183531 */     GIR_EraseRootFromParent_Done,
     /* 183532 */   // Label 4084: @183532
     /* 183532 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(183594), // Rule ID 23948 //
     /* 183537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183552 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183555 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183559 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183576 */     // (smax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMAXSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rm),
     /* 183579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183581 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183583 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183592 */     GIR_RootConstrainSelectedInstOperands,
     /* 183593 */     // GIR_Coverage, 23948,
     /* 183593 */     GIR_EraseRootFromParent_Done,
     /* 183594 */   // Label 4085: @183594
     /* 183594 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(183656), // Rule ID 3189 //
     /* 183599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183618 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183621 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183625 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183638 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrm),
     /* 183641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183643 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183645 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183654 */     GIR_RootConstrainSelectedInstOperands,
     /* 183655 */     // GIR_Coverage, 3189,
     /* 183655 */     GIR_EraseRootFromParent_Done,
     /* 183656 */   // Label 4086: @183656
     /* 183656 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(183718), // Rule ID 5382 //
     /* 183661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183680 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183687 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183700 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rm),
     /* 183703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183705 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183707 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183716 */     GIR_RootConstrainSelectedInstOperands,
     /* 183717 */     // GIR_Coverage, 5382,
     /* 183717 */     GIR_EraseRootFromParent_Done,
     /* 183718 */   // Label 4087: @183718
     /* 183718 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(183745), // Rule ID 3188 //
     /* 183723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183738 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 183738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrr),
     /* 183743 */     GIR_RootConstrainSelectedInstOperands,
     /* 183744 */     // GIR_Coverage, 3188,
     /* 183744 */     GIR_Done,
     /* 183745 */   // Label 4088: @183745
     /* 183745 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(183772), // Rule ID 3230 //
     /* 183750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 183753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183765 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 183765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSDrr),
     /* 183770 */     GIR_RootConstrainSelectedInstOperands,
     /* 183771 */     // GIR_Coverage, 3230,
     /* 183771 */     GIR_Done,
     /* 183772 */   // Label 4089: @183772
     /* 183772 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(183799), // Rule ID 5379 //
     /* 183777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183792 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 183792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rr),
     /* 183797 */     GIR_RootConstrainSelectedInstOperands,
     /* 183798 */     // GIR_Coverage, 5379,
     /* 183798 */     GIR_Done,
     /* 183799 */   // Label 4090: @183799
     /* 183799 */   GIM_Reject,
     /* 183800 */ // Label 4083: @183800
     /* 183800 */ GIM_Reject,
     /* 183801 */ // Label 4067: @183801
     /* 183801 */ GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(184117),
     /* 183806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 183809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 183812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183816 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(183874), // Rule ID 23960 //
     /* 183821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183832 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183835 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183839 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183856 */     // (smax:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMAXSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rm),
     /* 183859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183861 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183863 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183872 */     GIR_RootConstrainSelectedInstOperands,
     /* 183873 */     // GIR_Coverage, 23960,
     /* 183873 */     GIR_EraseRootFromParent_Done,
     /* 183874 */   // Label 4092: @183874
     /* 183874 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(183932), // Rule ID 5400 //
     /* 183879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183894 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183897 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183901 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183914 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rm),
     /* 183917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183919 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183921 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183930 */     GIR_RootConstrainSelectedInstOperands,
     /* 183931 */     // GIR_Coverage, 5400,
     /* 183931 */     GIR_EraseRootFromParent_Done,
     /* 183932 */   // Label 4093: @183932
     /* 183932 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(183955), // Rule ID 5397 //
     /* 183937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183948 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 183948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rr),
     /* 183953 */     GIR_RootConstrainSelectedInstOperands,
     /* 183954 */     // GIR_Coverage, 5397,
     /* 183954 */     GIR_Done,
     /* 183955 */   // Label 4094: @183955
     /* 183955 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(184116), // Rule ID 20007 //
     /* 183960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 183963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183971 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 183971 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 183974 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183978 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 183985 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 183988 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183992 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183997 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 184000 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 184004 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 184007 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 184012 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 184017 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 184022 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 184025 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184029 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 184036 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 184039 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184043 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184048 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 184051 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 184055 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 184058 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 184063 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 184068 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 184073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 184076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 184080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184085 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 184088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 184091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 184093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 184096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184098 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 184105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 184110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 184115 */     // GIR_Coverage, 20007,
     /* 184115 */     GIR_EraseRootFromParent_Done,
     /* 184116 */   // Label 4095: @184116
     /* 184116 */   GIM_Reject,
     /* 184117 */ // Label 4091: @184117
     /* 184117 */ GIM_Reject,
     /* 184118 */ // Label 4068: @184118
     /* 184118 */ GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(184459),
     /* 184123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 184126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 184129 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(184191), // Rule ID 23468 //
     /* 184134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184149 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184152 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184156 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184173 */     // (smax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMAXSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrm),
     /* 184176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184178 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184180 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184189 */     GIR_RootConstrainSelectedInstOperands,
     /* 184190 */     // GIR_Coverage, 23468,
     /* 184190 */     GIR_EraseRootFromParent_Done,
     /* 184191 */   // Label 4097: @184191
     /* 184191 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(184253), // Rule ID 23933 //
     /* 184196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184211 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184214 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184218 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184235 */     // (smax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMAXSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rm),
     /* 184238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184240 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184242 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184251 */     GIR_RootConstrainSelectedInstOperands,
     /* 184252 */     // GIR_Coverage, 23933,
     /* 184252 */     GIR_EraseRootFromParent_Done,
     /* 184253 */   // Label 4098: @184253
     /* 184253 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(184315), // Rule ID 2654 //
     /* 184258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184277 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184280 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184284 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184297 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrm),
     /* 184300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184302 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184313 */     GIR_RootConstrainSelectedInstOperands,
     /* 184314 */     // GIR_Coverage, 2654,
     /* 184314 */     GIR_EraseRootFromParent_Done,
     /* 184315 */   // Label 4099: @184315
     /* 184315 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(184377), // Rule ID 5358 //
     /* 184320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184339 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184342 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184346 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184359 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rm),
     /* 184362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184364 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184366 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184375 */     GIR_RootConstrainSelectedInstOperands,
     /* 184376 */     // GIR_Coverage, 5358,
     /* 184376 */     GIR_EraseRootFromParent_Done,
     /* 184377 */   // Label 4100: @184377
     /* 184377 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(184404), // Rule ID 2653 //
     /* 184382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184397 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 184397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrr),
     /* 184402 */     GIR_RootConstrainSelectedInstOperands,
     /* 184403 */     // GIR_Coverage, 2653,
     /* 184403 */     GIR_Done,
     /* 184404 */   // Label 4101: @184404
     /* 184404 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(184431), // Rule ID 2655 //
     /* 184409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 184412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184424 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 184424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSWrr),
     /* 184429 */     GIR_RootConstrainSelectedInstOperands,
     /* 184430 */     // GIR_Coverage, 2655,
     /* 184430 */     GIR_Done,
     /* 184431 */   // Label 4102: @184431
     /* 184431 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(184458), // Rule ID 5355 //
     /* 184436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184451 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 184451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rr),
     /* 184456 */     GIR_RootConstrainSelectedInstOperands,
     /* 184457 */     // GIR_Coverage, 5355,
     /* 184457 */     GIR_Done,
     /* 184458 */   // Label 4103: @184458
     /* 184458 */   GIM_Reject,
     /* 184459 */ // Label 4096: @184459
     /* 184459 */ GIM_Reject,
     /* 184460 */ // Label 4069: @184460
     /* 184460 */ GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(184774),
     /* 184465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 184468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 184471 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(184533), // Rule ID 23509 //
     /* 184476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184491 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184498 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184515 */     // (smax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMAXSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrm),
     /* 184518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184522 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184531 */     GIR_RootConstrainSelectedInstOperands,
     /* 184532 */     // GIR_Coverage, 23509,
     /* 184532 */     GIR_EraseRootFromParent_Done,
     /* 184533 */   // Label 4105: @184533
     /* 184533 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(184595), // Rule ID 23942 //
     /* 184538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184553 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184556 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184560 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184577 */     // (smax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMAXSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rm),
     /* 184580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184582 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184584 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184593 */     GIR_RootConstrainSelectedInstOperands,
     /* 184594 */     // GIR_Coverage, 23942,
     /* 184594 */     GIR_EraseRootFromParent_Done,
     /* 184595 */   // Label 4106: @184595
     /* 184595 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(184657), // Rule ID 3207 //
     /* 184600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184619 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184622 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184626 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184639 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrm),
     /* 184642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184644 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184646 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184655 */     GIR_RootConstrainSelectedInstOperands,
     /* 184656 */     // GIR_Coverage, 3207,
     /* 184656 */     GIR_EraseRootFromParent_Done,
     /* 184657 */   // Label 4107: @184657
     /* 184657 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(184719), // Rule ID 5373 //
     /* 184662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184681 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184688 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184701 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rm),
     /* 184704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184706 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184708 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184717 */     GIR_RootConstrainSelectedInstOperands,
     /* 184718 */     // GIR_Coverage, 5373,
     /* 184718 */     GIR_EraseRootFromParent_Done,
     /* 184719 */   // Label 4108: @184719
     /* 184719 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(184746), // Rule ID 3206 //
     /* 184724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184739 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 184739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrr),
     /* 184744 */     GIR_RootConstrainSelectedInstOperands,
     /* 184745 */     // GIR_Coverage, 3206,
     /* 184745 */     GIR_Done,
     /* 184746 */   // Label 4109: @184746
     /* 184746 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(184773), // Rule ID 5370 //
     /* 184751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184766 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 184766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rr),
     /* 184771 */     GIR_RootConstrainSelectedInstOperands,
     /* 184772 */     // GIR_Coverage, 5370,
     /* 184772 */     GIR_Done,
     /* 184773 */   // Label 4110: @184773
     /* 184773 */   GIM_Reject,
     /* 184774 */ // Label 4104: @184774
     /* 184774 */ GIM_Reject,
     /* 184775 */ // Label 4070: @184775
     /* 184775 */ GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(184930),
     /* 184780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 184783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 184786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184790 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(184848), // Rule ID 23954 //
     /* 184795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184806 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184809 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184813 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184830 */     // (smax:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMAXSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrm),
     /* 184833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184835 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184846 */     GIR_RootConstrainSelectedInstOperands,
     /* 184847 */     // GIR_Coverage, 23954,
     /* 184847 */     GIR_EraseRootFromParent_Done,
     /* 184848 */   // Label 4112: @184848
     /* 184848 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(184906), // Rule ID 5391 //
     /* 184853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184868 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184875 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184888 */     // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrm),
     /* 184891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184893 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184895 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184904 */     GIR_RootConstrainSelectedInstOperands,
     /* 184905 */     // GIR_Coverage, 5391,
     /* 184905 */     GIR_EraseRootFromParent_Done,
     /* 184906 */   // Label 4113: @184906
     /* 184906 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(184929), // Rule ID 5388 //
     /* 184911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184922 */     // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 184922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 184927 */     GIR_RootConstrainSelectedInstOperands,
     /* 184928 */     // GIR_Coverage, 5388,
     /* 184928 */     GIR_Done,
     /* 184929 */   // Label 4114: @184929
     /* 184929 */   GIM_Reject,
     /* 184930 */ // Label 4111: @184930
     /* 184930 */ GIM_Reject,
     /* 184931 */ // Label 4071: @184931
     /* 184931 */ GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(185272),
     /* 184936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 184939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 184942 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(185004), // Rule ID 23505 //
     /* 184947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184962 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184969 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184986 */     // (smax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMAXSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrm),
     /* 184989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184993 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185002 */     GIR_RootConstrainSelectedInstOperands,
     /* 185003 */     // GIR_Coverage, 23505,
     /* 185003 */     GIR_EraseRootFromParent_Done,
     /* 185004 */   // Label 4116: @185004
     /* 185004 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(185066), // Rule ID 23924 //
     /* 185009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185024 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185027 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185031 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185048 */     // (smax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMAXSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rm),
     /* 185051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185053 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185055 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185064 */     GIR_RootConstrainSelectedInstOperands,
     /* 185065 */     // GIR_Coverage, 23924,
     /* 185065 */     GIR_EraseRootFromParent_Done,
     /* 185066 */   // Label 4117: @185066
     /* 185066 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(185128), // Rule ID 3199 //
     /* 185071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 185074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185090 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185110 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrm),
     /* 185113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185115 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185117 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185126 */     GIR_RootConstrainSelectedInstOperands,
     /* 185127 */     // GIR_Coverage, 3199,
     /* 185127 */     GIR_EraseRootFromParent_Done,
     /* 185128 */   // Label 4118: @185128
     /* 185128 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(185190), // Rule ID 5340 //
     /* 185133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185152 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185159 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185172 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rm),
     /* 185175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185177 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185179 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185188 */     GIR_RootConstrainSelectedInstOperands,
     /* 185189 */     // GIR_Coverage, 5340,
     /* 185189 */     GIR_EraseRootFromParent_Done,
     /* 185190 */   // Label 4119: @185190
     /* 185190 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(185217), // Rule ID 3198 //
     /* 185195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 185198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185210 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 185210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrr),
     /* 185215 */     GIR_RootConstrainSelectedInstOperands,
     /* 185216 */     // GIR_Coverage, 3198,
     /* 185216 */     GIR_Done,
     /* 185217 */   // Label 4120: @185217
     /* 185217 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(185244), // Rule ID 3228 //
     /* 185222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 185225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185237 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 185237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSBrr),
     /* 185242 */     GIR_RootConstrainSelectedInstOperands,
     /* 185243 */     // GIR_Coverage, 3228,
     /* 185243 */     GIR_Done,
     /* 185244 */   // Label 4121: @185244
     /* 185244 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(185271), // Rule ID 5337 //
     /* 185249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185264 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 185264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rr),
     /* 185269 */     GIR_RootConstrainSelectedInstOperands,
     /* 185270 */     // GIR_Coverage, 5337,
     /* 185270 */     GIR_Done,
     /* 185271 */   // Label 4122: @185271
     /* 185271 */   GIM_Reject,
     /* 185272 */ // Label 4115: @185272
     /* 185272 */ GIM_Reject,
     /* 185273 */ // Label 4072: @185273
     /* 185273 */ GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(185587),
     /* 185278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 185281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 185284 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(185346), // Rule ID 23470 //
     /* 185289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185304 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185307 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185311 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185328 */     // (smax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMAXSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrm),
     /* 185331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185333 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185335 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185344 */     GIR_RootConstrainSelectedInstOperands,
     /* 185345 */     // GIR_Coverage, 23470,
     /* 185345 */     GIR_EraseRootFromParent_Done,
     /* 185346 */   // Label 4124: @185346
     /* 185346 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(185408), // Rule ID 23930 //
     /* 185351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185373 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185390 */     // (smax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMAXSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rm),
     /* 185393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185395 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185397 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185406 */     GIR_RootConstrainSelectedInstOperands,
     /* 185407 */     // GIR_Coverage, 23930,
     /* 185407 */     GIR_EraseRootFromParent_Done,
     /* 185408 */   // Label 4125: @185408
     /* 185408 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(185470), // Rule ID 2658 //
     /* 185413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185452 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrm),
     /* 185455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185468 */     GIR_RootConstrainSelectedInstOperands,
     /* 185469 */     // GIR_Coverage, 2658,
     /* 185469 */     GIR_EraseRootFromParent_Done,
     /* 185470 */   // Label 4126: @185470
     /* 185470 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(185532), // Rule ID 5352 //
     /* 185475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185514 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rm),
     /* 185517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185530 */     GIR_RootConstrainSelectedInstOperands,
     /* 185531 */     // GIR_Coverage, 5352,
     /* 185531 */     GIR_EraseRootFromParent_Done,
     /* 185532 */   // Label 4127: @185532
     /* 185532 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(185559), // Rule ID 2657 //
     /* 185537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185552 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 185552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrr),
     /* 185557 */     GIR_RootConstrainSelectedInstOperands,
     /* 185558 */     // GIR_Coverage, 2657,
     /* 185558 */     GIR_Done,
     /* 185559 */   // Label 4128: @185559
     /* 185559 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(185586), // Rule ID 5349 //
     /* 185564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185579 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 185579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rr),
     /* 185584 */     GIR_RootConstrainSelectedInstOperands,
     /* 185585 */     // GIR_Coverage, 5349,
     /* 185585 */     GIR_Done,
     /* 185586 */   // Label 4129: @185586
     /* 185586 */   GIM_Reject,
     /* 185587 */ // Label 4123: @185587
     /* 185587 */ GIM_Reject,
     /* 185588 */ // Label 4073: @185588
     /* 185588 */ GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(185743),
     /* 185593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 185596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 185599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185603 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(185661), // Rule ID 23936 //
     /* 185608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185619 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185622 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185626 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185643 */     // (smax:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMAXSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrm),
     /* 185646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185648 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185659 */     GIR_RootConstrainSelectedInstOperands,
     /* 185660 */     // GIR_Coverage, 23936,
     /* 185660 */     GIR_EraseRootFromParent_Done,
     /* 185661 */   // Label 4131: @185661
     /* 185661 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(185719), // Rule ID 5364 //
     /* 185666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185681 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185688 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185701 */     // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrm),
     /* 185704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185706 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185708 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185717 */     GIR_RootConstrainSelectedInstOperands,
     /* 185718 */     // GIR_Coverage, 5364,
     /* 185718 */     GIR_EraseRootFromParent_Done,
     /* 185719 */   // Label 4132: @185719
     /* 185719 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(185742), // Rule ID 5361 //
     /* 185724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185735 */     // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 185735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrr),
     /* 185740 */     GIR_RootConstrainSelectedInstOperands,
     /* 185741 */     // GIR_Coverage, 5361,
     /* 185741 */     GIR_Done,
     /* 185742 */   // Label 4133: @185742
     /* 185742 */   GIM_Reject,
     /* 185743 */ // Label 4130: @185743
     /* 185743 */ GIM_Reject,
     /* 185744 */ // Label 4074: @185744
     /* 185744 */ GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(186058),
     /* 185749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 185752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 185755 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(185817), // Rule ID 23514 //
     /* 185760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185775 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185778 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185799 */     // (smax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMAXSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrm),
     /* 185802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185804 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185806 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185815 */     GIR_RootConstrainSelectedInstOperands,
     /* 185816 */     // GIR_Coverage, 23514,
     /* 185816 */     GIR_EraseRootFromParent_Done,
     /* 185817 */   // Label 4135: @185817
     /* 185817 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(185879), // Rule ID 23921 //
     /* 185822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185837 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185844 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185861 */     // (smax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMAXSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rm),
     /* 185864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185866 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185877 */     GIR_RootConstrainSelectedInstOperands,
     /* 185878 */     // GIR_Coverage, 23921,
     /* 185878 */     GIR_EraseRootFromParent_Done,
     /* 185879 */   // Label 4136: @185879
     /* 185879 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(185941), // Rule ID 3217 //
     /* 185884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185903 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185910 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185923 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrm),
     /* 185926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185939 */     GIR_RootConstrainSelectedInstOperands,
     /* 185940 */     // GIR_Coverage, 3217,
     /* 185940 */     GIR_EraseRootFromParent_Done,
     /* 185941 */   // Label 4137: @185941
     /* 185941 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(186003), // Rule ID 5334 //
     /* 185946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185965 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185968 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185972 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185985 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rm),
     /* 185988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185990 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186001 */     GIR_RootConstrainSelectedInstOperands,
     /* 186002 */     // GIR_Coverage, 5334,
     /* 186002 */     GIR_EraseRootFromParent_Done,
     /* 186003 */   // Label 4138: @186003
     /* 186003 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(186030), // Rule ID 3216 //
     /* 186008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 186011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 186015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 186019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 186023 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 186023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrr),
     /* 186028 */     GIR_RootConstrainSelectedInstOperands,
     /* 186029 */     // GIR_Coverage, 3216,
     /* 186029 */     GIR_Done,
     /* 186030 */   // Label 4139: @186030
     /* 186030 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(186057), // Rule ID 5331 //
     /* 186035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 186038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186050 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 186050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rr),
     /* 186055 */     GIR_RootConstrainSelectedInstOperands,
     /* 186056 */     // GIR_Coverage, 5331,
     /* 186056 */     GIR_Done,
     /* 186057 */   // Label 4140: @186057
     /* 186057 */   GIM_Reject,
     /* 186058 */ // Label 4134: @186058
     /* 186058 */ GIM_Reject,
     /* 186059 */ // Label 4075: @186059
     /* 186059 */ GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(186214),
     /* 186064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 186067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 186070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186074 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(186132), // Rule ID 23927 //
     /* 186079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186090 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186114 */     // (smax:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMAXSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrm),
     /* 186117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186119 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186130 */     GIR_RootConstrainSelectedInstOperands,
     /* 186131 */     // GIR_Coverage, 23927,
     /* 186131 */     GIR_EraseRootFromParent_Done,
     /* 186132 */   // Label 4142: @186132
     /* 186132 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(186190), // Rule ID 5346 //
     /* 186137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186152 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186159 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186172 */     // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrm),
     /* 186175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186177 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186179 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186188 */     GIR_RootConstrainSelectedInstOperands,
     /* 186189 */     // GIR_Coverage, 5346,
     /* 186189 */     GIR_EraseRootFromParent_Done,
     /* 186190 */   // Label 4143: @186190
     /* 186190 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(186213), // Rule ID 5343 //
     /* 186195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186206 */     // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 186206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrr),
     /* 186211 */     GIR_RootConstrainSelectedInstOperands,
     /* 186212 */     // GIR_Coverage, 5343,
     /* 186212 */     GIR_Done,
     /* 186213 */   // Label 4144: @186213
     /* 186213 */   GIM_Reject,
     /* 186214 */ // Label 4141: @186214
     /* 186214 */ GIM_Reject,
     /* 186215 */ // Label 4076: @186215
     /* 186215 */ GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(186370),
     /* 186220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 186223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 186226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186230 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(186288), // Rule ID 23918 //
     /* 186235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186246 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186253 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186270 */     // (smax:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMAXSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrm),
     /* 186273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186277 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186286 */     GIR_RootConstrainSelectedInstOperands,
     /* 186287 */     // GIR_Coverage, 23918,
     /* 186287 */     GIR_EraseRootFromParent_Done,
     /* 186288 */   // Label 4146: @186288
     /* 186288 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(186346), // Rule ID 5328 //
     /* 186293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186315 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186328 */     // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrm),
     /* 186331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186333 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186335 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186344 */     GIR_RootConstrainSelectedInstOperands,
     /* 186345 */     // GIR_Coverage, 5328,
     /* 186345 */     GIR_EraseRootFromParent_Done,
     /* 186346 */   // Label 4147: @186346
     /* 186346 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(186369), // Rule ID 5325 //
     /* 186351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186362 */     // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 186362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrr),
     /* 186367 */     GIR_RootConstrainSelectedInstOperands,
     /* 186368 */     // GIR_Coverage, 5325,
     /* 186368 */     GIR_Done,
     /* 186369 */   // Label 4148: @186369
     /* 186369 */   GIM_Reject,
     /* 186370 */ // Label 4145: @186370
     /* 186370 */ GIM_Reject,
     /* 186371 */ // Label 4077: @186371
     /* 186371 */ GIM_Reject,
     /* 186372 */ // Label 56: @186372
     /* 186372 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4161*/ GIMT_Encode4(189692),
     /* 186383 */ /*GILLT_v2s64*//*Label 4149*/ GIMT_Encode4(186451), GIMT_Encode4(0),
     /* 186391 */ /*GILLT_v4s32*//*Label 4150*/ GIMT_Encode4(186780),
     /* 186395 */ /*GILLT_v4s64*//*Label 4151*/ GIMT_Encode4(187122), GIMT_Encode4(0),
     /* 186403 */ /*GILLT_v8s16*//*Label 4152*/ GIMT_Encode4(187439),
     /* 186407 */ /*GILLT_v8s32*//*Label 4153*/ GIMT_Encode4(187781),
     /* 186411 */ /*GILLT_v8s64*//*Label 4154*/ GIMT_Encode4(188096), GIMT_Encode4(0),
     /* 186419 */ /*GILLT_v16s8*//*Label 4155*/ GIMT_Encode4(188252),
     /* 186423 */ /*GILLT_v16s16*//*Label 4156*/ GIMT_Encode4(188594),
     /* 186427 */ /*GILLT_v16s32*//*Label 4157*/ GIMT_Encode4(188909), GIMT_Encode4(0),
     /* 186435 */ /*GILLT_v32s8*//*Label 4158*/ GIMT_Encode4(189065),
     /* 186439 */ /*GILLT_v32s16*//*Label 4159*/ GIMT_Encode4(189380), GIMT_Encode4(0),
     /* 186447 */ /*GILLT_v64s8*//*Label 4160*/ GIMT_Encode4(189536),
     /* 186451 */ // Label 4149: @186451
     /* 186451 */ GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(186779),
     /* 186456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 186459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186462 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(186524), // Rule ID 24128 //
     /* 186467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186485 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186489 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186506 */     // (umin:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMINUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rm),
     /* 186509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186511 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186522 */     GIR_RootConstrainSelectedInstOperands,
     /* 186523 */     // GIR_Coverage, 24128,
     /* 186523 */     GIR_EraseRootFromParent_Done,
     /* 186524 */   // Label 4163: @186524
     /* 186524 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(186586), // Rule ID 5679 //
     /* 186529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186568 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rm),
     /* 186571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186573 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186584 */     GIR_RootConstrainSelectedInstOperands,
     /* 186585 */     // GIR_Coverage, 5679,
     /* 186585 */     GIR_EraseRootFromParent_Done,
     /* 186586 */   // Label 4164: @186586
     /* 186586 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(186613), // Rule ID 5676 //
     /* 186591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186606 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 186606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rr),
     /* 186611 */     GIR_RootConstrainSelectedInstOperands,
     /* 186612 */     // GIR_Coverage, 5676,
     /* 186612 */     GIR_Done,
     /* 186613 */   // Label 4165: @186613
     /* 186613 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(186778), // Rule ID 20005 //
     /* 186618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 186621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 186625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186633 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 186633 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 186636 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186640 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 186647 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 186650 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186654 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186659 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 186662 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 186666 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 186669 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186674 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186679 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 186684 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 186687 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186691 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 186698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 186701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186710 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 186713 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 186717 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 186720 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186725 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186730 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 186735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 186738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 186742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186747 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 186750 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 186753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 186755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186760 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 186767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 186772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186777 */     // GIR_Coverage, 20005,
     /* 186777 */     GIR_EraseRootFromParent_Done,
     /* 186778 */   // Label 4166: @186778
     /* 186778 */   GIM_Reject,
     /* 186779 */ // Label 4162: @186779
     /* 186779 */ GIM_Reject,
     /* 186780 */ // Label 4150: @186780
     /* 186780 */ GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(187121),
     /* 186785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 186788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186791 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(186853), // Rule ID 23499 //
     /* 186796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186811 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186814 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186818 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186835 */     // (umin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMINUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDrm),
     /* 186838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186840 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186842 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186851 */     GIR_RootConstrainSelectedInstOperands,
     /* 186852 */     // GIR_Coverage, 23499,
     /* 186852 */     GIR_EraseRootFromParent_Done,
     /* 186853 */   // Label 4168: @186853
     /* 186853 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(186915), // Rule ID 24110 //
     /* 186858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186873 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186880 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186897 */     // (umin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMINUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rm),
     /* 186900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186902 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186904 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186913 */     GIR_RootConstrainSelectedInstOperands,
     /* 186914 */     // GIR_Coverage, 24110,
     /* 186914 */     GIR_EraseRootFromParent_Done,
     /* 186915 */   // Label 4169: @186915
     /* 186915 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(186977), // Rule ID 3187 //
     /* 186920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186939 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186946 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186959 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDrm),
     /* 186962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186975 */     GIR_RootConstrainSelectedInstOperands,
     /* 186976 */     // GIR_Coverage, 3187,
     /* 186976 */     GIR_EraseRootFromParent_Done,
     /* 186977 */   // Label 4170: @186977
     /* 186977 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(187039), // Rule ID 5652 //
     /* 186982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187001 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187004 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187008 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187021 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rm),
     /* 187024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187026 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187037 */     GIR_RootConstrainSelectedInstOperands,
     /* 187038 */     // GIR_Coverage, 5652,
     /* 187038 */     GIR_EraseRootFromParent_Done,
     /* 187039 */   // Label 4171: @187039
     /* 187039 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(187066), // Rule ID 3186 //
     /* 187044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 187047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187059 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 187059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDrr),
     /* 187064 */     GIR_RootConstrainSelectedInstOperands,
     /* 187065 */     // GIR_Coverage, 3186,
     /* 187065 */     GIR_Done,
     /* 187066 */   // Label 4172: @187066
     /* 187066 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(187093), // Rule ID 3224 //
     /* 187071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 187074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187086 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 187086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUDrr),
     /* 187091 */     GIR_RootConstrainSelectedInstOperands,
     /* 187092 */     // GIR_Coverage, 3224,
     /* 187092 */     GIR_Done,
     /* 187093 */   // Label 4173: @187093
     /* 187093 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(187120), // Rule ID 5649 //
     /* 187098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187113 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 187113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rr),
     /* 187118 */     GIR_RootConstrainSelectedInstOperands,
     /* 187119 */     // GIR_Coverage, 5649,
     /* 187119 */     GIR_Done,
     /* 187120 */   // Label 4174: @187120
     /* 187120 */   GIM_Reject,
     /* 187121 */ // Label 4167: @187121
     /* 187121 */ GIM_Reject,
     /* 187122 */ // Label 4151: @187122
     /* 187122 */ GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(187438),
     /* 187127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 187130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 187133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187137 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(187195), // Rule ID 24122 //
     /* 187142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187153 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187156 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187160 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187177 */     // (umin:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMINUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rm),
     /* 187180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187182 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187193 */     GIR_RootConstrainSelectedInstOperands,
     /* 187194 */     // GIR_Coverage, 24122,
     /* 187194 */     GIR_EraseRootFromParent_Done,
     /* 187195 */   // Label 4176: @187195
     /* 187195 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(187253), // Rule ID 5670 //
     /* 187200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187215 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187218 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187222 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187235 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rm),
     /* 187238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187240 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187242 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187251 */     GIR_RootConstrainSelectedInstOperands,
     /* 187252 */     // GIR_Coverage, 5670,
     /* 187252 */     GIR_EraseRootFromParent_Done,
     /* 187253 */   // Label 4177: @187253
     /* 187253 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(187276), // Rule ID 5667 //
     /* 187258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187269 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 187269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rr),
     /* 187274 */     GIR_RootConstrainSelectedInstOperands,
     /* 187275 */     // GIR_Coverage, 5667,
     /* 187275 */     GIR_Done,
     /* 187276 */   // Label 4178: @187276
     /* 187276 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(187437), // Rule ID 20003 //
     /* 187281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 187284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187292 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 187292 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 187295 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187299 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 187306 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 187309 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187313 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187318 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 187321 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 187325 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 187328 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 187333 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187338 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187343 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 187346 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187350 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 187357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 187360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187369 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 187372 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 187376 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 187379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 187384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187389 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 187397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 187401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187406 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 187409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 187412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 187414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187419 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 187426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187436 */     // GIR_Coverage, 20003,
     /* 187436 */     GIR_EraseRootFromParent_Done,
     /* 187437 */   // Label 4179: @187437
     /* 187437 */   GIM_Reject,
     /* 187438 */ // Label 4175: @187438
     /* 187438 */ GIM_Reject,
     /* 187439 */ // Label 4152: @187439
     /* 187439 */ GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(187780),
     /* 187444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 187447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187450 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(187512), // Rule ID 23504 //
     /* 187455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187470 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187473 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187477 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187494 */     // (umin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMINUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWrm),
     /* 187497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187499 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187510 */     GIR_RootConstrainSelectedInstOperands,
     /* 187511 */     // GIR_Coverage, 23504,
     /* 187511 */     GIR_EraseRootFromParent_Done,
     /* 187512 */   // Label 4181: @187512
     /* 187512 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(187574), // Rule ID 24095 //
     /* 187517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187532 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187556 */     // (umin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMINUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rm),
     /* 187559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187561 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187572 */     GIR_RootConstrainSelectedInstOperands,
     /* 187573 */     // GIR_Coverage, 24095,
     /* 187573 */     GIR_EraseRootFromParent_Done,
     /* 187574 */   // Label 4182: @187574
     /* 187574 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(187636), // Rule ID 3197 //
     /* 187579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187618 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWrm),
     /* 187621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187634 */     GIR_RootConstrainSelectedInstOperands,
     /* 187635 */     // GIR_Coverage, 3197,
     /* 187635 */     GIR_EraseRootFromParent_Done,
     /* 187636 */   // Label 4183: @187636
     /* 187636 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(187698), // Rule ID 5628 //
     /* 187641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187660 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187667 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187680 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rm),
     /* 187683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187685 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187696 */     GIR_RootConstrainSelectedInstOperands,
     /* 187697 */     // GIR_Coverage, 5628,
     /* 187697 */     GIR_EraseRootFromParent_Done,
     /* 187698 */   // Label 4184: @187698
     /* 187698 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(187725), // Rule ID 3196 //
     /* 187703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187718 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 187718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWrr),
     /* 187723 */     GIR_RootConstrainSelectedInstOperands,
     /* 187724 */     // GIR_Coverage, 3196,
     /* 187724 */     GIR_Done,
     /* 187725 */   // Label 4185: @187725
     /* 187725 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(187752), // Rule ID 3226 //
     /* 187730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 187733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187745 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 187745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUWrr),
     /* 187750 */     GIR_RootConstrainSelectedInstOperands,
     /* 187751 */     // GIR_Coverage, 3226,
     /* 187751 */     GIR_Done,
     /* 187752 */   // Label 4186: @187752
     /* 187752 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(187779), // Rule ID 5625 //
     /* 187757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187772 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 187772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rr),
     /* 187777 */     GIR_RootConstrainSelectedInstOperands,
     /* 187778 */     // GIR_Coverage, 5625,
     /* 187778 */     GIR_Done,
     /* 187779 */   // Label 4187: @187779
     /* 187779 */   GIM_Reject,
     /* 187780 */ // Label 4180: @187780
     /* 187780 */ GIM_Reject,
     /* 187781 */ // Label 4153: @187781
     /* 187781 */ GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(188095),
     /* 187786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 187789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 187792 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(187854), // Rule ID 23508 //
     /* 187797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187836 */     // (umin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMINUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrm),
     /* 187839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187841 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187843 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187852 */     GIR_RootConstrainSelectedInstOperands,
     /* 187853 */     // GIR_Coverage, 23508,
     /* 187853 */     GIR_EraseRootFromParent_Done,
     /* 187854 */   // Label 4189: @187854
     /* 187854 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(187916), // Rule ID 24104 //
     /* 187859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187874 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187877 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187881 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187898 */     // (umin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMINUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rm),
     /* 187901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187903 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187905 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187914 */     GIR_RootConstrainSelectedInstOperands,
     /* 187915 */     // GIR_Coverage, 24104,
     /* 187915 */     GIR_EraseRootFromParent_Done,
     /* 187916 */   // Label 4190: @187916
     /* 187916 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(187978), // Rule ID 3205 //
     /* 187921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187940 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187947 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187960 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrm),
     /* 187963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187967 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187976 */     GIR_RootConstrainSelectedInstOperands,
     /* 187977 */     // GIR_Coverage, 3205,
     /* 187977 */     GIR_EraseRootFromParent_Done,
     /* 187978 */   // Label 4191: @187978
     /* 187978 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(188040), // Rule ID 5643 //
     /* 187983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188009 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188022 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rm),
     /* 188025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188027 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188038 */     GIR_RootConstrainSelectedInstOperands,
     /* 188039 */     // GIR_Coverage, 5643,
     /* 188039 */     GIR_EraseRootFromParent_Done,
     /* 188040 */   // Label 4192: @188040
     /* 188040 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(188067), // Rule ID 3204 //
     /* 188045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 188048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188060 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 188060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrr),
     /* 188065 */     GIR_RootConstrainSelectedInstOperands,
     /* 188066 */     // GIR_Coverage, 3204,
     /* 188066 */     GIR_Done,
     /* 188067 */   // Label 4193: @188067
     /* 188067 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(188094), // Rule ID 5640 //
     /* 188072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 188075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188087 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 188087 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rr),
     /* 188092 */     GIR_RootConstrainSelectedInstOperands,
     /* 188093 */     // GIR_Coverage, 5640,
     /* 188093 */     GIR_Done,
     /* 188094 */   // Label 4194: @188094
     /* 188094 */   GIM_Reject,
     /* 188095 */ // Label 4188: @188095
     /* 188095 */ GIM_Reject,
     /* 188096 */ // Label 4154: @188096
     /* 188096 */ GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(188251),
     /* 188101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 188104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 188107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188111 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(188169), // Rule ID 24116 //
     /* 188116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188127 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188130 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188134 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188151 */     // (umin:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMINUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrm),
     /* 188154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188158 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188167 */     GIR_RootConstrainSelectedInstOperands,
     /* 188168 */     // GIR_Coverage, 24116,
     /* 188168 */     GIR_EraseRootFromParent_Done,
     /* 188169 */   // Label 4196: @188169
     /* 188169 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(188227), // Rule ID 5661 //
     /* 188174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188189 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188196 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188209 */     // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrm),
     /* 188212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188216 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188225 */     GIR_RootConstrainSelectedInstOperands,
     /* 188226 */     // GIR_Coverage, 5661,
     /* 188226 */     GIR_EraseRootFromParent_Done,
     /* 188227 */   // Label 4197: @188227
     /* 188227 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(188250), // Rule ID 5658 //
     /* 188232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188243 */     // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 188243 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 188248 */     GIR_RootConstrainSelectedInstOperands,
     /* 188249 */     // GIR_Coverage, 5658,
     /* 188249 */     GIR_Done,
     /* 188250 */   // Label 4198: @188250
     /* 188250 */   GIM_Reject,
     /* 188251 */ // Label 4195: @188251
     /* 188251 */ GIM_Reject,
     /* 188252 */ // Label 4155: @188252
     /* 188252 */ GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(188593),
     /* 188257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 188260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188263 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(188325), // Rule ID 23459 //
     /* 188268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188283 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188286 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188290 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188307 */     // (umin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMINUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBrm),
     /* 188310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188312 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188314 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188323 */     GIR_RootConstrainSelectedInstOperands,
     /* 188324 */     // GIR_Coverage, 23459,
     /* 188324 */     GIR_EraseRootFromParent_Done,
     /* 188325 */   // Label 4200: @188325
     /* 188325 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(188387), // Rule ID 24086 //
     /* 188330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188345 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188348 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188369 */     // (umin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMINUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rm),
     /* 188372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188374 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188376 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188385 */     GIR_RootConstrainSelectedInstOperands,
     /* 188386 */     // GIR_Coverage, 24086,
     /* 188386 */     GIR_EraseRootFromParent_Done,
     /* 188387 */   // Label 4201: @188387
     /* 188387 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(188449), // Rule ID 2636 //
     /* 188392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188411 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188414 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188418 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188431 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBrm),
     /* 188434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188436 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188438 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188447 */     GIR_RootConstrainSelectedInstOperands,
     /* 188448 */     // GIR_Coverage, 2636,
     /* 188448 */     GIR_EraseRootFromParent_Done,
     /* 188449 */   // Label 4202: @188449
     /* 188449 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(188511), // Rule ID 5610 //
     /* 188454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188473 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188480 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188493 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rm),
     /* 188496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188498 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188509 */     GIR_RootConstrainSelectedInstOperands,
     /* 188510 */     // GIR_Coverage, 5610,
     /* 188510 */     GIR_EraseRootFromParent_Done,
     /* 188511 */   // Label 4203: @188511
     /* 188511 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(188538), // Rule ID 2635 //
     /* 188516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188531 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 188531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBrr),
     /* 188536 */     GIR_RootConstrainSelectedInstOperands,
     /* 188537 */     // GIR_Coverage, 2635,
     /* 188537 */     GIR_Done,
     /* 188538 */   // Label 4204: @188538
     /* 188538 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(188565), // Rule ID 2637 //
     /* 188543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 188546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188558 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 188558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUBrr),
     /* 188563 */     GIR_RootConstrainSelectedInstOperands,
     /* 188564 */     // GIR_Coverage, 2637,
     /* 188564 */     GIR_Done,
     /* 188565 */   // Label 4205: @188565
     /* 188565 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(188592), // Rule ID 5607 //
     /* 188570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188585 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 188585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rr),
     /* 188590 */     GIR_RootConstrainSelectedInstOperands,
     /* 188591 */     // GIR_Coverage, 5607,
     /* 188591 */     GIR_Done,
     /* 188592 */   // Label 4206: @188592
     /* 188592 */   GIM_Reject,
     /* 188593 */ // Label 4199: @188593
     /* 188593 */ GIM_Reject,
     /* 188594 */ // Label 4156: @188594
     /* 188594 */ GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(188908),
     /* 188599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 188602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 188605 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(188667), // Rule ID 23513 //
     /* 188610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188625 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188628 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188632 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188649 */     // (umin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMINUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrm),
     /* 188652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188654 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188656 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188665 */     GIR_RootConstrainSelectedInstOperands,
     /* 188666 */     // GIR_Coverage, 23513,
     /* 188666 */     GIR_EraseRootFromParent_Done,
     /* 188667 */   // Label 4208: @188667
     /* 188667 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(188729), // Rule ID 24092 //
     /* 188672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188687 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188690 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188694 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188711 */     // (umin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMINUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rm),
     /* 188714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188716 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188718 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188727 */     GIR_RootConstrainSelectedInstOperands,
     /* 188728 */     // GIR_Coverage, 24092,
     /* 188728 */     GIR_EraseRootFromParent_Done,
     /* 188729 */   // Label 4209: @188729
     /* 188729 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(188791), // Rule ID 3215 //
     /* 188734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188773 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrm),
     /* 188776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188778 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188780 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188789 */     GIR_RootConstrainSelectedInstOperands,
     /* 188790 */     // GIR_Coverage, 3215,
     /* 188790 */     GIR_EraseRootFromParent_Done,
     /* 188791 */   // Label 4210: @188791
     /* 188791 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(188853), // Rule ID 5622 //
     /* 188796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188815 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188822 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188835 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rm),
     /* 188838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188840 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188842 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188851 */     GIR_RootConstrainSelectedInstOperands,
     /* 188852 */     // GIR_Coverage, 5622,
     /* 188852 */     GIR_EraseRootFromParent_Done,
     /* 188853 */   // Label 4211: @188853
     /* 188853 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(188880), // Rule ID 3214 //
     /* 188858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188873 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 188873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrr),
     /* 188878 */     GIR_RootConstrainSelectedInstOperands,
     /* 188879 */     // GIR_Coverage, 3214,
     /* 188879 */     GIR_Done,
     /* 188880 */   // Label 4212: @188880
     /* 188880 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(188907), // Rule ID 5619 //
     /* 188885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188900 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 188900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rr),
     /* 188905 */     GIR_RootConstrainSelectedInstOperands,
     /* 188906 */     // GIR_Coverage, 5619,
     /* 188906 */     GIR_Done,
     /* 188907 */   // Label 4213: @188907
     /* 188907 */   GIM_Reject,
     /* 188908 */ // Label 4207: @188908
     /* 188908 */ GIM_Reject,
     /* 188909 */ // Label 4157: @188909
     /* 188909 */ GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(189064),
     /* 188914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 188917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 188920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188924 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(188982), // Rule ID 24098 //
     /* 188929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188940 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188947 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188964 */     // (umin:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMINUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrm),
     /* 188967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188969 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188971 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188980 */     GIR_RootConstrainSelectedInstOperands,
     /* 188981 */     // GIR_Coverage, 24098,
     /* 188981 */     GIR_EraseRootFromParent_Done,
     /* 188982 */   // Label 4215: @188982
     /* 188982 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(189040), // Rule ID 5634 //
     /* 188987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189009 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189022 */     // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrm),
     /* 189025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189027 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189038 */     GIR_RootConstrainSelectedInstOperands,
     /* 189039 */     // GIR_Coverage, 5634,
     /* 189039 */     GIR_EraseRootFromParent_Done,
     /* 189040 */   // Label 4216: @189040
     /* 189040 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(189063), // Rule ID 5631 //
     /* 189045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 189048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189056 */     // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 189056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrr),
     /* 189061 */     GIR_RootConstrainSelectedInstOperands,
     /* 189062 */     // GIR_Coverage, 5631,
     /* 189062 */     GIR_Done,
     /* 189063 */   // Label 4217: @189063
     /* 189063 */   GIM_Reject,
     /* 189064 */ // Label 4214: @189064
     /* 189064 */ GIM_Reject,
     /* 189065 */ // Label 4158: @189065
     /* 189065 */ GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(189379),
     /* 189070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 189073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 189076 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(189138), // Rule ID 23461 //
     /* 189081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189096 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189099 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189103 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189120 */     // (umin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMINUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrm),
     /* 189123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189136 */     GIR_RootConstrainSelectedInstOperands,
     /* 189137 */     // GIR_Coverage, 23461,
     /* 189137 */     GIR_EraseRootFromParent_Done,
     /* 189138 */   // Label 4219: @189138
     /* 189138 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(189200), // Rule ID 24083 //
     /* 189143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189158 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189165 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189182 */     // (umin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMINUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rm),
     /* 189185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189187 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189189 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189198 */     GIR_RootConstrainSelectedInstOperands,
     /* 189199 */     // GIR_Coverage, 24083,
     /* 189199 */     GIR_EraseRootFromParent_Done,
     /* 189200 */   // Label 4220: @189200
     /* 189200 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(189262), // Rule ID 2640 //
     /* 189205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189224 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189227 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189244 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrm),
     /* 189247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189249 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189251 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189260 */     GIR_RootConstrainSelectedInstOperands,
     /* 189261 */     // GIR_Coverage, 2640,
     /* 189261 */     GIR_EraseRootFromParent_Done,
     /* 189262 */   // Label 4221: @189262
     /* 189262 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(189324), // Rule ID 5604 //
     /* 189267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189306 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rm),
     /* 189309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189311 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189313 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189322 */     GIR_RootConstrainSelectedInstOperands,
     /* 189323 */     // GIR_Coverage, 5604,
     /* 189323 */     GIR_EraseRootFromParent_Done,
     /* 189324 */   // Label 4222: @189324
     /* 189324 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(189351), // Rule ID 2639 //
     /* 189329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189344 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 189344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrr),
     /* 189349 */     GIR_RootConstrainSelectedInstOperands,
     /* 189350 */     // GIR_Coverage, 2639,
     /* 189350 */     GIR_Done,
     /* 189351 */   // Label 4223: @189351
     /* 189351 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(189378), // Rule ID 5601 //
     /* 189356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189371 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 189371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rr),
     /* 189376 */     GIR_RootConstrainSelectedInstOperands,
     /* 189377 */     // GIR_Coverage, 5601,
     /* 189377 */     GIR_Done,
     /* 189378 */   // Label 4224: @189378
     /* 189378 */   GIM_Reject,
     /* 189379 */ // Label 4218: @189379
     /* 189379 */ GIM_Reject,
     /* 189380 */ // Label 4159: @189380
     /* 189380 */ GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(189535),
     /* 189385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 189388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 189391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189395 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(189453), // Rule ID 24089 //
     /* 189400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189411 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189414 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189418 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189435 */     // (umin:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMINUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrm),
     /* 189438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189440 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189442 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189451 */     GIR_RootConstrainSelectedInstOperands,
     /* 189452 */     // GIR_Coverage, 24089,
     /* 189452 */     GIR_EraseRootFromParent_Done,
     /* 189453 */   // Label 4226: @189453
     /* 189453 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(189511), // Rule ID 5616 //
     /* 189458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189473 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189480 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189493 */     // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrm),
     /* 189496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189498 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189509 */     GIR_RootConstrainSelectedInstOperands,
     /* 189510 */     // GIR_Coverage, 5616,
     /* 189510 */     GIR_EraseRootFromParent_Done,
     /* 189511 */   // Label 4227: @189511
     /* 189511 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(189534), // Rule ID 5613 //
     /* 189516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189527 */     // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 189527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrr),
     /* 189532 */     GIR_RootConstrainSelectedInstOperands,
     /* 189533 */     // GIR_Coverage, 5613,
     /* 189533 */     GIR_Done,
     /* 189534 */   // Label 4228: @189534
     /* 189534 */   GIM_Reject,
     /* 189535 */ // Label 4225: @189535
     /* 189535 */ GIM_Reject,
     /* 189536 */ // Label 4160: @189536
     /* 189536 */ GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(189691),
     /* 189541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 189544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 189547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189551 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(189609), // Rule ID 24080 //
     /* 189556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189567 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189570 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189574 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189591 */     // (umin:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMINUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrm),
     /* 189594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189598 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189607 */     GIR_RootConstrainSelectedInstOperands,
     /* 189608 */     // GIR_Coverage, 24080,
     /* 189608 */     GIR_EraseRootFromParent_Done,
     /* 189609 */   // Label 4230: @189609
     /* 189609 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(189667), // Rule ID 5598 //
     /* 189614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189629 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189636 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189649 */     // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrm),
     /* 189652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189654 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189656 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189665 */     GIR_RootConstrainSelectedInstOperands,
     /* 189666 */     // GIR_Coverage, 5598,
     /* 189666 */     GIR_EraseRootFromParent_Done,
     /* 189667 */   // Label 4231: @189667
     /* 189667 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(189690), // Rule ID 5595 //
     /* 189672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189683 */     // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 189683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrr),
     /* 189688 */     GIR_RootConstrainSelectedInstOperands,
     /* 189689 */     // GIR_Coverage, 5595,
     /* 189689 */     GIR_Done,
     /* 189690 */   // Label 4232: @189690
     /* 189690 */   GIM_Reject,
     /* 189691 */ // Label 4229: @189691
     /* 189691 */ GIM_Reject,
     /* 189692 */ // Label 4161: @189692
     /* 189692 */ GIM_Reject,
     /* 189693 */ // Label 57: @189693
     /* 189693 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4245*/ GIMT_Encode4(193013),
     /* 189704 */ /*GILLT_v2s64*//*Label 4233*/ GIMT_Encode4(189772), GIMT_Encode4(0),
     /* 189712 */ /*GILLT_v4s32*//*Label 4234*/ GIMT_Encode4(190101),
     /* 189716 */ /*GILLT_v4s64*//*Label 4235*/ GIMT_Encode4(190443), GIMT_Encode4(0),
     /* 189724 */ /*GILLT_v8s16*//*Label 4236*/ GIMT_Encode4(190760),
     /* 189728 */ /*GILLT_v8s32*//*Label 4237*/ GIMT_Encode4(191102),
     /* 189732 */ /*GILLT_v8s64*//*Label 4238*/ GIMT_Encode4(191417), GIMT_Encode4(0),
     /* 189740 */ /*GILLT_v16s8*//*Label 4239*/ GIMT_Encode4(191573),
     /* 189744 */ /*GILLT_v16s16*//*Label 4240*/ GIMT_Encode4(191915),
     /* 189748 */ /*GILLT_v16s32*//*Label 4241*/ GIMT_Encode4(192230), GIMT_Encode4(0),
     /* 189756 */ /*GILLT_v32s8*//*Label 4242*/ GIMT_Encode4(192386),
     /* 189760 */ /*GILLT_v32s16*//*Label 4243*/ GIMT_Encode4(192701), GIMT_Encode4(0),
     /* 189768 */ /*GILLT_v64s8*//*Label 4244*/ GIMT_Encode4(192857),
     /* 189772 */ // Label 4233: @189772
     /* 189772 */ GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(190100),
     /* 189777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 189780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189783 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(189845), // Rule ID 24020 //
     /* 189788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189803 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189810 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189827 */     // (umax:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMAXUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rm),
     /* 189830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189832 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189843 */     GIR_RootConstrainSelectedInstOperands,
     /* 189844 */     // GIR_Coverage, 24020,
     /* 189844 */     GIR_EraseRootFromParent_Done,
     /* 189845 */   // Label 4247: @189845
     /* 189845 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(189907), // Rule ID 5499 //
     /* 189850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189869 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189876 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189889 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rm),
     /* 189892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189894 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189896 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189905 */     GIR_RootConstrainSelectedInstOperands,
     /* 189906 */     // GIR_Coverage, 5499,
     /* 189906 */     GIR_EraseRootFromParent_Done,
     /* 189907 */   // Label 4248: @189907
     /* 189907 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(189934), // Rule ID 5496 //
     /* 189912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189927 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 189927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rr),
     /* 189932 */     GIR_RootConstrainSelectedInstOperands,
     /* 189933 */     // GIR_Coverage, 5496,
     /* 189933 */     GIR_Done,
     /* 189934 */   // Label 4249: @189934
     /* 189934 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(190099), // Rule ID 20001 //
     /* 189939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 189942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 189946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189954 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 189954 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 189957 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189961 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 189968 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 189971 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189975 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189980 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 189983 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 189987 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 189990 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 189995 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190000 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 190005 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 190008 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190012 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 190019 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 190022 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190026 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190031 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 190034 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 190038 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 190041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190051 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 190056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 190059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 190063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190068 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 190071 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 190074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 190076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190081 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 190088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 190093 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190098 */     // GIR_Coverage, 20001,
     /* 190098 */     GIR_EraseRootFromParent_Done,
     /* 190099 */   // Label 4250: @190099
     /* 190099 */   GIM_Reject,
     /* 190100 */ // Label 4246: @190100
     /* 190100 */ GIM_Reject,
     /* 190101 */ // Label 4234: @190101
     /* 190101 */ GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(190442),
     /* 190106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 190109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190112 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(190174), // Rule ID 23501 //
     /* 190117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190139 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190156 */     // (umax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMAXUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrm),
     /* 190159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190161 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190172 */     GIR_RootConstrainSelectedInstOperands,
     /* 190173 */     // GIR_Coverage, 23501,
     /* 190173 */     GIR_EraseRootFromParent_Done,
     /* 190174 */   // Label 4252: @190174
     /* 190174 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(190236), // Rule ID 24002 //
     /* 190179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190201 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190218 */     // (umax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMAXUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rm),
     /* 190221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190223 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190225 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190234 */     GIR_RootConstrainSelectedInstOperands,
     /* 190235 */     // GIR_Coverage, 24002,
     /* 190235 */     GIR_EraseRootFromParent_Done,
     /* 190236 */   // Label 4253: @190236
     /* 190236 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(190298), // Rule ID 3191 //
     /* 190241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190260 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190280 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrm),
     /* 190283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190285 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190287 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190296 */     GIR_RootConstrainSelectedInstOperands,
     /* 190297 */     // GIR_Coverage, 3191,
     /* 190297 */     GIR_EraseRootFromParent_Done,
     /* 190298 */   // Label 4254: @190298
     /* 190298 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(190360), // Rule ID 5472 //
     /* 190303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190325 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190329 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190342 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rm),
     /* 190345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190347 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190349 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190358 */     GIR_RootConstrainSelectedInstOperands,
     /* 190359 */     // GIR_Coverage, 5472,
     /* 190359 */     GIR_EraseRootFromParent_Done,
     /* 190360 */   // Label 4255: @190360
     /* 190360 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(190387), // Rule ID 3190 //
     /* 190365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190380 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 190380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrr),
     /* 190385 */     GIR_RootConstrainSelectedInstOperands,
     /* 190386 */     // GIR_Coverage, 3190,
     /* 190386 */     GIR_Done,
     /* 190387 */   // Label 4256: @190387
     /* 190387 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(190414), // Rule ID 3232 //
     /* 190392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 190395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190407 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 190407 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUDrr),
     /* 190412 */     GIR_RootConstrainSelectedInstOperands,
     /* 190413 */     // GIR_Coverage, 3232,
     /* 190413 */     GIR_Done,
     /* 190414 */   // Label 4257: @190414
     /* 190414 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(190441), // Rule ID 5469 //
     /* 190419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190434 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 190434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rr),
     /* 190439 */     GIR_RootConstrainSelectedInstOperands,
     /* 190440 */     // GIR_Coverage, 5469,
     /* 190440 */     GIR_Done,
     /* 190441 */   // Label 4258: @190441
     /* 190441 */   GIM_Reject,
     /* 190442 */ // Label 4251: @190442
     /* 190442 */ GIM_Reject,
     /* 190443 */ // Label 4235: @190443
     /* 190443 */ GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(190759),
     /* 190448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 190451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 190454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190458 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(190516), // Rule ID 24014 //
     /* 190463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190498 */     // (umax:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMAXUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rm),
     /* 190501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190503 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190514 */     GIR_RootConstrainSelectedInstOperands,
     /* 190515 */     // GIR_Coverage, 24014,
     /* 190515 */     GIR_EraseRootFromParent_Done,
     /* 190516 */   // Label 4260: @190516
     /* 190516 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(190574), // Rule ID 5490 //
     /* 190521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190556 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rm),
     /* 190559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190572 */     GIR_RootConstrainSelectedInstOperands,
     /* 190573 */     // GIR_Coverage, 5490,
     /* 190573 */     GIR_EraseRootFromParent_Done,
     /* 190574 */   // Label 4261: @190574
     /* 190574 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(190597), // Rule ID 5487 //
     /* 190579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190590 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 190590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rr),
     /* 190595 */     GIR_RootConstrainSelectedInstOperands,
     /* 190596 */     // GIR_Coverage, 5487,
     /* 190596 */     GIR_Done,
     /* 190597 */   // Label 4262: @190597
     /* 190597 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(190758), // Rule ID 19999 //
     /* 190602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 190605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190613 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 190613 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 190616 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190620 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 190627 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 190630 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190634 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190639 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 190642 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 190646 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 190649 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190654 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190659 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190664 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 190667 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190671 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 190678 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 190681 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190685 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190690 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 190693 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 190697 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 190700 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190705 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190710 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 190718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 190722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190727 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 190730 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 190733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 190735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190740 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 190747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190757 */     // GIR_Coverage, 19999,
     /* 190757 */     GIR_EraseRootFromParent_Done,
     /* 190758 */   // Label 4263: @190758
     /* 190758 */   GIM_Reject,
     /* 190759 */ // Label 4259: @190759
     /* 190759 */ GIM_Reject,
     /* 190760 */ // Label 4236: @190760
     /* 190760 */ GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(191101),
     /* 190765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 190768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190771 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(190833), // Rule ID 23506 //
     /* 190776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190791 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190794 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190798 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190815 */     // (umax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMAXUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrm),
     /* 190818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190820 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190822 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190831 */     GIR_RootConstrainSelectedInstOperands,
     /* 190832 */     // GIR_Coverage, 23506,
     /* 190832 */     GIR_EraseRootFromParent_Done,
     /* 190833 */   // Label 4265: @190833
     /* 190833 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(190895), // Rule ID 23987 //
     /* 190838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190853 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190856 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190860 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190877 */     // (umax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMAXUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rm),
     /* 190880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190882 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190893 */     GIR_RootConstrainSelectedInstOperands,
     /* 190894 */     // GIR_Coverage, 23987,
     /* 190894 */     GIR_EraseRootFromParent_Done,
     /* 190895 */   // Label 4266: @190895
     /* 190895 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(190957), // Rule ID 3201 //
     /* 190900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190919 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190922 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190926 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190939 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrm),
     /* 190942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190944 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190946 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190955 */     GIR_RootConstrainSelectedInstOperands,
     /* 190956 */     // GIR_Coverage, 3201,
     /* 190956 */     GIR_EraseRootFromParent_Done,
     /* 190957 */   // Label 4267: @190957
     /* 190957 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(191019), // Rule ID 5448 //
     /* 190962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190981 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190984 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190988 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191001 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rm),
     /* 191004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191006 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191008 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191017 */     GIR_RootConstrainSelectedInstOperands,
     /* 191018 */     // GIR_Coverage, 5448,
     /* 191018 */     GIR_EraseRootFromParent_Done,
     /* 191019 */   // Label 4268: @191019
     /* 191019 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(191046), // Rule ID 3200 //
     /* 191024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191039 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 191039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrr),
     /* 191044 */     GIR_RootConstrainSelectedInstOperands,
     /* 191045 */     // GIR_Coverage, 3200,
     /* 191045 */     GIR_Done,
     /* 191046 */   // Label 4269: @191046
     /* 191046 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(191073), // Rule ID 3234 //
     /* 191051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 191054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191066 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 191066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUWrr),
     /* 191071 */     GIR_RootConstrainSelectedInstOperands,
     /* 191072 */     // GIR_Coverage, 3234,
     /* 191072 */     GIR_Done,
     /* 191073 */   // Label 4270: @191073
     /* 191073 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(191100), // Rule ID 5445 //
     /* 191078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191093 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 191093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rr),
     /* 191098 */     GIR_RootConstrainSelectedInstOperands,
     /* 191099 */     // GIR_Coverage, 5445,
     /* 191099 */     GIR_Done,
     /* 191100 */   // Label 4271: @191100
     /* 191100 */   GIM_Reject,
     /* 191101 */ // Label 4264: @191101
     /* 191101 */ GIM_Reject,
     /* 191102 */ // Label 4237: @191102
     /* 191102 */ GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(191416),
     /* 191107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 191110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 191113 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(191175), // Rule ID 23510 //
     /* 191118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191133 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191140 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191157 */     // (umax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMAXUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrm),
     /* 191160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191173 */     GIR_RootConstrainSelectedInstOperands,
     /* 191174 */     // GIR_Coverage, 23510,
     /* 191174 */     GIR_EraseRootFromParent_Done,
     /* 191175 */   // Label 4273: @191175
     /* 191175 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(191237), // Rule ID 23996 //
     /* 191180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191219 */     // (umax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMAXUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rm),
     /* 191222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191235 */     GIR_RootConstrainSelectedInstOperands,
     /* 191236 */     // GIR_Coverage, 23996,
     /* 191236 */     GIR_EraseRootFromParent_Done,
     /* 191237 */   // Label 4274: @191237
     /* 191237 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(191299), // Rule ID 3209 //
     /* 191242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191261 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191264 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191268 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191281 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrm),
     /* 191284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191286 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191288 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191297 */     GIR_RootConstrainSelectedInstOperands,
     /* 191298 */     // GIR_Coverage, 3209,
     /* 191298 */     GIR_EraseRootFromParent_Done,
     /* 191299 */   // Label 4275: @191299
     /* 191299 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(191361), // Rule ID 5463 //
     /* 191304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191323 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191326 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191330 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191343 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rm),
     /* 191346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191348 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191350 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191359 */     GIR_RootConstrainSelectedInstOperands,
     /* 191360 */     // GIR_Coverage, 5463,
     /* 191360 */     GIR_EraseRootFromParent_Done,
     /* 191361 */   // Label 4276: @191361
     /* 191361 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(191388), // Rule ID 3208 //
     /* 191366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191381 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 191381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrr),
     /* 191386 */     GIR_RootConstrainSelectedInstOperands,
     /* 191387 */     // GIR_Coverage, 3208,
     /* 191387 */     GIR_Done,
     /* 191388 */   // Label 4277: @191388
     /* 191388 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(191415), // Rule ID 5460 //
     /* 191393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191408 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 191408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rr),
     /* 191413 */     GIR_RootConstrainSelectedInstOperands,
     /* 191414 */     // GIR_Coverage, 5460,
     /* 191414 */     GIR_Done,
     /* 191415 */   // Label 4278: @191415
     /* 191415 */   GIM_Reject,
     /* 191416 */ // Label 4272: @191416
     /* 191416 */ GIM_Reject,
     /* 191417 */ // Label 4238: @191417
     /* 191417 */ GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(191572),
     /* 191422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 191425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 191428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191432 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(191490), // Rule ID 24008 //
     /* 191437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191455 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191472 */     // (umax:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMAXUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrm),
     /* 191475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191477 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191488 */     GIR_RootConstrainSelectedInstOperands,
     /* 191489 */     // GIR_Coverage, 24008,
     /* 191489 */     GIR_EraseRootFromParent_Done,
     /* 191490 */   // Label 4280: @191490
     /* 191490 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(191548), // Rule ID 5481 //
     /* 191495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191510 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191517 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191530 */     // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrm),
     /* 191533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191537 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191546 */     GIR_RootConstrainSelectedInstOperands,
     /* 191547 */     // GIR_Coverage, 5481,
     /* 191547 */     GIR_EraseRootFromParent_Done,
     /* 191548 */   // Label 4281: @191548
     /* 191548 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(191571), // Rule ID 5478 //
     /* 191553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191564 */     // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 191564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 191569 */     GIR_RootConstrainSelectedInstOperands,
     /* 191570 */     // GIR_Coverage, 5478,
     /* 191570 */     GIR_Done,
     /* 191571 */   // Label 4282: @191571
     /* 191571 */   GIM_Reject,
     /* 191572 */ // Label 4279: @191572
     /* 191572 */ GIM_Reject,
     /* 191573 */ // Label 4239: @191573
     /* 191573 */ GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(191914),
     /* 191578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 191581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191584 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(191646), // Rule ID 23465 //
     /* 191589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191604 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191607 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191611 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191628 */     // (umax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMAXUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrm),
     /* 191631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191633 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191644 */     GIR_RootConstrainSelectedInstOperands,
     /* 191645 */     // GIR_Coverage, 23465,
     /* 191645 */     GIR_EraseRootFromParent_Done,
     /* 191646 */   // Label 4284: @191646
     /* 191646 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(191708), // Rule ID 23978 //
     /* 191651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191690 */     // (umax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMAXUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rm),
     /* 191693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191706 */     GIR_RootConstrainSelectedInstOperands,
     /* 191707 */     // GIR_Coverage, 23978,
     /* 191707 */     GIR_EraseRootFromParent_Done,
     /* 191708 */   // Label 4285: @191708
     /* 191708 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(191770), // Rule ID 2648 //
     /* 191713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191752 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrm),
     /* 191755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191757 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191768 */     GIR_RootConstrainSelectedInstOperands,
     /* 191769 */     // GIR_Coverage, 2648,
     /* 191769 */     GIR_EraseRootFromParent_Done,
     /* 191770 */   // Label 4286: @191770
     /* 191770 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(191832), // Rule ID 5430 //
     /* 191775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191814 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rm),
     /* 191817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191830 */     GIR_RootConstrainSelectedInstOperands,
     /* 191831 */     // GIR_Coverage, 5430,
     /* 191831 */     GIR_EraseRootFromParent_Done,
     /* 191832 */   // Label 4287: @191832
     /* 191832 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(191859), // Rule ID 2647 //
     /* 191837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191852 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 191852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrr),
     /* 191857 */     GIR_RootConstrainSelectedInstOperands,
     /* 191858 */     // GIR_Coverage, 2647,
     /* 191858 */     GIR_Done,
     /* 191859 */   // Label 4288: @191859
     /* 191859 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(191886), // Rule ID 2649 //
     /* 191864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 191867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191879 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 191879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUBrr),
     /* 191884 */     GIR_RootConstrainSelectedInstOperands,
     /* 191885 */     // GIR_Coverage, 2649,
     /* 191885 */     GIR_Done,
     /* 191886 */   // Label 4289: @191886
     /* 191886 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(191913), // Rule ID 5427 //
     /* 191891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191906 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 191906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rr),
     /* 191911 */     GIR_RootConstrainSelectedInstOperands,
     /* 191912 */     // GIR_Coverage, 5427,
     /* 191912 */     GIR_Done,
     /* 191913 */   // Label 4290: @191913
     /* 191913 */   GIM_Reject,
     /* 191914 */ // Label 4283: @191914
     /* 191914 */ GIM_Reject,
     /* 191915 */ // Label 4240: @191915
     /* 191915 */ GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(192229),
     /* 191920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 191923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 191926 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(191988), // Rule ID 23515 //
     /* 191931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 191934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191946 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191953 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191970 */     // (umax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMAXUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrm),
     /* 191973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191975 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191977 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191986 */     GIR_RootConstrainSelectedInstOperands,
     /* 191987 */     // GIR_Coverage, 23515,
     /* 191987 */     GIR_EraseRootFromParent_Done,
     /* 191988 */   // Label 4292: @191988
     /* 191988 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(192050), // Rule ID 23984 //
     /* 191993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192008 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192015 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192032 */     // (umax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMAXUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rm),
     /* 192035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192037 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192039 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192048 */     GIR_RootConstrainSelectedInstOperands,
     /* 192049 */     // GIR_Coverage, 23984,
     /* 192049 */     GIR_EraseRootFromParent_Done,
     /* 192050 */   // Label 4293: @192050
     /* 192050 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(192112), // Rule ID 3219 //
     /* 192055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192081 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192094 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrm),
     /* 192097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192110 */     GIR_RootConstrainSelectedInstOperands,
     /* 192111 */     // GIR_Coverage, 3219,
     /* 192111 */     GIR_EraseRootFromParent_Done,
     /* 192112 */   // Label 4294: @192112
     /* 192112 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(192174), // Rule ID 5442 //
     /* 192117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192136 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192139 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192143 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192156 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rm),
     /* 192159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192172 */     GIR_RootConstrainSelectedInstOperands,
     /* 192173 */     // GIR_Coverage, 5442,
     /* 192173 */     GIR_EraseRootFromParent_Done,
     /* 192174 */   // Label 4295: @192174
     /* 192174 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(192201), // Rule ID 3218 //
     /* 192179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192194 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 192194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrr),
     /* 192199 */     GIR_RootConstrainSelectedInstOperands,
     /* 192200 */     // GIR_Coverage, 3218,
     /* 192200 */     GIR_Done,
     /* 192201 */   // Label 4296: @192201
     /* 192201 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(192228), // Rule ID 5439 //
     /* 192206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192221 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 192221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rr),
     /* 192226 */     GIR_RootConstrainSelectedInstOperands,
     /* 192227 */     // GIR_Coverage, 5439,
     /* 192227 */     GIR_Done,
     /* 192228 */   // Label 4297: @192228
     /* 192228 */   GIM_Reject,
     /* 192229 */ // Label 4291: @192229
     /* 192229 */ GIM_Reject,
     /* 192230 */ // Label 4241: @192230
     /* 192230 */ GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(192385),
     /* 192235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 192238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 192241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192245 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(192303), // Rule ID 23990 //
     /* 192250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192261 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192264 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192268 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192285 */     // (umax:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMAXUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrm),
     /* 192288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192301 */     GIR_RootConstrainSelectedInstOperands,
     /* 192302 */     // GIR_Coverage, 23990,
     /* 192302 */     GIR_EraseRootFromParent_Done,
     /* 192303 */   // Label 4299: @192303
     /* 192303 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(192361), // Rule ID 5454 //
     /* 192308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192323 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192326 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192330 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192343 */     // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrm),
     /* 192346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192348 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192350 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192359 */     GIR_RootConstrainSelectedInstOperands,
     /* 192360 */     // GIR_Coverage, 5454,
     /* 192360 */     GIR_EraseRootFromParent_Done,
     /* 192361 */   // Label 4300: @192361
     /* 192361 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(192384), // Rule ID 5451 //
     /* 192366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192377 */     // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 192377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrr),
     /* 192382 */     GIR_RootConstrainSelectedInstOperands,
     /* 192383 */     // GIR_Coverage, 5451,
     /* 192383 */     GIR_Done,
     /* 192384 */   // Label 4301: @192384
     /* 192384 */   GIM_Reject,
     /* 192385 */ // Label 4298: @192385
     /* 192385 */ GIM_Reject,
     /* 192386 */ // Label 4242: @192386
     /* 192386 */ GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(192700),
     /* 192391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 192394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 192397 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(192459), // Rule ID 23467 //
     /* 192402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192417 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192420 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192424 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192441 */     // (umax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMAXUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrm),
     /* 192444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192446 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192448 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192457 */     GIR_RootConstrainSelectedInstOperands,
     /* 192458 */     // GIR_Coverage, 23467,
     /* 192458 */     GIR_EraseRootFromParent_Done,
     /* 192459 */   // Label 4303: @192459
     /* 192459 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(192521), // Rule ID 23975 //
     /* 192464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192479 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192482 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192486 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192503 */     // (umax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMAXUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rm),
     /* 192506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192519 */     GIR_RootConstrainSelectedInstOperands,
     /* 192520 */     // GIR_Coverage, 23975,
     /* 192520 */     GIR_EraseRootFromParent_Done,
     /* 192521 */   // Label 4304: @192521
     /* 192521 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(192583), // Rule ID 2652 //
     /* 192526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192545 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192552 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192565 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrm),
     /* 192568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192570 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192572 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192581 */     GIR_RootConstrainSelectedInstOperands,
     /* 192582 */     // GIR_Coverage, 2652,
     /* 192582 */     GIR_EraseRootFromParent_Done,
     /* 192583 */   // Label 4305: @192583
     /* 192583 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(192645), // Rule ID 5424 //
     /* 192588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192607 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192610 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192614 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192627 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rm),
     /* 192630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192632 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192634 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192643 */     GIR_RootConstrainSelectedInstOperands,
     /* 192644 */     // GIR_Coverage, 5424,
     /* 192644 */     GIR_EraseRootFromParent_Done,
     /* 192645 */   // Label 4306: @192645
     /* 192645 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(192672), // Rule ID 2651 //
     /* 192650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192665 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 192665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrr),
     /* 192670 */     GIR_RootConstrainSelectedInstOperands,
     /* 192671 */     // GIR_Coverage, 2651,
     /* 192671 */     GIR_Done,
     /* 192672 */   // Label 4307: @192672
     /* 192672 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(192699), // Rule ID 5421 //
     /* 192677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192692 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 192692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rr),
     /* 192697 */     GIR_RootConstrainSelectedInstOperands,
     /* 192698 */     // GIR_Coverage, 5421,
     /* 192698 */     GIR_Done,
     /* 192699 */   // Label 4308: @192699
     /* 192699 */   GIM_Reject,
     /* 192700 */ // Label 4302: @192700
     /* 192700 */ GIM_Reject,
     /* 192701 */ // Label 4243: @192701
     /* 192701 */ GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(192856),
     /* 192706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 192709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 192712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192716 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(192774), // Rule ID 23981 //
     /* 192721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192756 */     // (umax:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMAXUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrm),
     /* 192759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192761 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192772 */     GIR_RootConstrainSelectedInstOperands,
     /* 192773 */     // GIR_Coverage, 23981,
     /* 192773 */     GIR_EraseRootFromParent_Done,
     /* 192774 */   // Label 4310: @192774
     /* 192774 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(192832), // Rule ID 5436 //
     /* 192779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192814 */     // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrm),
     /* 192817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192830 */     GIR_RootConstrainSelectedInstOperands,
     /* 192831 */     // GIR_Coverage, 5436,
     /* 192831 */     GIR_EraseRootFromParent_Done,
     /* 192832 */   // Label 4311: @192832
     /* 192832 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(192855), // Rule ID 5433 //
     /* 192837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192848 */     // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 192848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrr),
     /* 192853 */     GIR_RootConstrainSelectedInstOperands,
     /* 192854 */     // GIR_Coverage, 5433,
     /* 192854 */     GIR_Done,
     /* 192855 */   // Label 4312: @192855
     /* 192855 */   GIM_Reject,
     /* 192856 */ // Label 4309: @192856
     /* 192856 */ GIM_Reject,
     /* 192857 */ // Label 4244: @192857
     /* 192857 */ GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(193012),
     /* 192862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 192865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 192868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192872 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(192930), // Rule ID 23972 //
     /* 192877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192912 */     // (umax:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMAXUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrm),
     /* 192915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192917 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192919 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192928 */     GIR_RootConstrainSelectedInstOperands,
     /* 192929 */     // GIR_Coverage, 23972,
     /* 192929 */     GIR_EraseRootFromParent_Done,
     /* 192930 */   // Label 4314: @192930
     /* 192930 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(192988), // Rule ID 5418 //
     /* 192935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192957 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192970 */     // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrm),
     /* 192973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192975 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192977 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192986 */     GIR_RootConstrainSelectedInstOperands,
     /* 192987 */     // GIR_Coverage, 5418,
     /* 192987 */     GIR_EraseRootFromParent_Done,
     /* 192988 */   // Label 4315: @192988
     /* 192988 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(193011), // Rule ID 5415 //
     /* 192993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 193000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 193004 */     // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 193004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrr),
     /* 193009 */     GIR_RootConstrainSelectedInstOperands,
     /* 193010 */     // GIR_Coverage, 5415,
     /* 193010 */     GIR_Done,
     /* 193011 */   // Label 4316: @193011
     /* 193011 */   GIM_Reject,
     /* 193012 */ // Label 4313: @193012
     /* 193012 */ GIM_Reject,
     /* 193013 */ // Label 4245: @193013
     /* 193013 */ GIM_Reject,
     /* 193014 */ // Label 58: @193014
     /* 193014 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4329*/ GIMT_Encode4(194894),
     /* 193025 */ /*GILLT_v2s64*//*Label 4317*/ GIMT_Encode4(193093), GIMT_Encode4(0),
     /* 193033 */ /*GILLT_v4s32*//*Label 4318*/ GIMT_Encode4(193289),
     /* 193037 */ /*GILLT_v4s64*//*Label 4319*/ GIMT_Encode4(193480), GIMT_Encode4(0),
     /* 193045 */ /*GILLT_v8s16*//*Label 4320*/ GIMT_Encode4(193668),
     /* 193049 */ /*GILLT_v8s32*//*Label 4321*/ GIMT_Encode4(193859),
     /* 193053 */ /*GILLT_v8s64*//*Label 4322*/ GIMT_Encode4(194027), GIMT_Encode4(0),
     /* 193061 */ /*GILLT_v16s8*//*Label 4323*/ GIMT_Encode4(194112),
     /* 193065 */ /*GILLT_v16s16*//*Label 4324*/ GIMT_Encode4(194303),
     /* 193069 */ /*GILLT_v16s32*//*Label 4325*/ GIMT_Encode4(194471), GIMT_Encode4(0),
     /* 193077 */ /*GILLT_v32s8*//*Label 4326*/ GIMT_Encode4(194556),
     /* 193081 */ /*GILLT_v32s16*//*Label 4327*/ GIMT_Encode4(194724), GIMT_Encode4(0),
     /* 193089 */ /*GILLT_v64s8*//*Label 4328*/ GIMT_Encode4(194809),
     /* 193093 */ // Label 4317: @193093
     /* 193093 */ GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(193288),
     /* 193098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193101 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(193157), // Rule ID 13266 //
     /* 193106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193121 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193124 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193128 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193141 */     // (abs:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 193141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rm),
     /* 193144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193155 */     GIR_RootConstrainSelectedInstOperands,
     /* 193156 */     // GIR_Coverage, 13266,
     /* 193156 */     GIR_EraseRootFromParent_Done,
     /* 193157 */   // Label 4331: @193157
     /* 193157 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(193180), // Rule ID 13263 //
     /* 193162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193173 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPABSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 193173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rr),
     /* 193178 */     GIR_RootConstrainSelectedInstOperands,
     /* 193179 */     // GIR_Coverage, 13263,
     /* 193179 */     GIR_Done,
     /* 193180 */   // Label 4332: @193180
     /* 193180 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(193287), // Rule ID 21823 //
     /* 193185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 193188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 193192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193196 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 193196 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 193199 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193203 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 193210 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 193213 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193217 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193222 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 193225 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 193229 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 193232 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193237 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193242 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 193247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 193250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 193254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193259 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 193262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 193264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 193267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193269 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 193276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 193281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193286 */     // GIR_Coverage, 21823,
     /* 193286 */     GIR_EraseRootFromParent_Done,
     /* 193287 */   // Label 4333: @193287
     /* 193287 */   GIM_Reject,
     /* 193288 */ // Label 4330: @193288
     /* 193288 */ GIM_Reject,
     /* 193289 */ // Label 4318: @193289
     /* 193289 */ GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(193479),
     /* 193294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193297 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(193353), // Rule ID 2994 //
     /* 193302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193317 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193324 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193337 */     // (abs:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 193337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDrm),
     /* 193340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193342 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 193346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193351 */     GIR_RootConstrainSelectedInstOperands,
     /* 193352 */     // GIR_Coverage, 2994,
     /* 193352 */     GIR_EraseRootFromParent_Done,
     /* 193353 */   // Label 4335: @193353
     /* 193353 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(193409), // Rule ID 13293 //
     /* 193358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193373 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193376 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193380 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193393 */     // (abs:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 193393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rm),
     /* 193396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193398 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193407 */     GIR_RootConstrainSelectedInstOperands,
     /* 193408 */     // GIR_Coverage, 13293,
     /* 193408 */     GIR_EraseRootFromParent_Done,
     /* 193409 */   // Label 4336: @193409
     /* 193409 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(193432), // Rule ID 2993 //
     /* 193414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193425 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (VPABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 193425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDrr),
     /* 193430 */     GIR_RootConstrainSelectedInstOperands,
     /* 193431 */     // GIR_Coverage, 2993,
     /* 193431 */     GIR_Done,
     /* 193432 */   // Label 4337: @193432
     /* 193432 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(193455), // Rule ID 3005 //
     /* 193437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 193440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193448 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (PABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 193448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSDrr),
     /* 193453 */     GIR_RootConstrainSelectedInstOperands,
     /* 193454 */     // GIR_Coverage, 3005,
     /* 193454 */     GIR_Done,
     /* 193455 */   // Label 4338: @193455
     /* 193455 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(193478), // Rule ID 13290 //
     /* 193460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193471 */     // (abs:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPABSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 193471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rr),
     /* 193476 */     GIR_RootConstrainSelectedInstOperands,
     /* 193477 */     // GIR_Coverage, 13290,
     /* 193477 */     GIR_Done,
     /* 193478 */   // Label 4339: @193478
     /* 193478 */   GIM_Reject,
     /* 193479 */ // Label 4334: @193479
     /* 193479 */ GIM_Reject,
     /* 193480 */ // Label 4319: @193480
     /* 193480 */ GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(193667),
     /* 193485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 193488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193492 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(193544), // Rule ID 13257 //
     /* 193497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193528 */     // (abs:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 193528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rm),
     /* 193531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193542 */     GIR_RootConstrainSelectedInstOperands,
     /* 193543 */     // GIR_Coverage, 13257,
     /* 193543 */     GIR_EraseRootFromParent_Done,
     /* 193544 */   // Label 4341: @193544
     /* 193544 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(193563), // Rule ID 13254 //
     /* 193549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193556 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPABSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 193556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rr),
     /* 193561 */     GIR_RootConstrainSelectedInstOperands,
     /* 193562 */     // GIR_Coverage, 13254,
     /* 193562 */     GIR_Done,
     /* 193563 */   // Label 4342: @193563
     /* 193563 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(193666), // Rule ID 21822 //
     /* 193568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 193571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193575 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 193575 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 193578 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193582 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 193589 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 193592 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193596 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193601 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 193604 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 193608 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 193611 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193616 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193621 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 193626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 193629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 193633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193638 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 193641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 193643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 193646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193648 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 193655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 193660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193665 */     // GIR_Coverage, 21822,
     /* 193665 */     GIR_EraseRootFromParent_Done,
     /* 193666 */   // Label 4343: @193666
     /* 193666 */   GIM_Reject,
     /* 193667 */ // Label 4340: @193667
     /* 193667 */ GIM_Reject,
     /* 193668 */ // Label 4320: @193668
     /* 193668 */ GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(193858),
     /* 193673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 193676 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(193732), // Rule ID 2992 //
     /* 193681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 193684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193696 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193699 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193703 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193716 */     // (abs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /* 193716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWrm),
     /* 193719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 193725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193730 */     GIR_RootConstrainSelectedInstOperands,
     /* 193731 */     // GIR_Coverage, 2992,
     /* 193731 */     GIR_EraseRootFromParent_Done,
     /* 193732 */   // Label 4345: @193732
     /* 193732 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(193788), // Rule ID 13314 //
     /* 193737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 193740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193752 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193755 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193759 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193772 */     // (abs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)
     /* 193772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rm),
     /* 193775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193786 */     GIR_RootConstrainSelectedInstOperands,
     /* 193787 */     // GIR_Coverage, 13314,
     /* 193787 */     GIR_EraseRootFromParent_Done,
     /* 193788 */   // Label 4346: @193788
     /* 193788 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(193811), // Rule ID 2991 //
     /* 193793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 193796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193804 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (VPABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 193804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWrr),
     /* 193809 */     GIR_RootConstrainSelectedInstOperands,
     /* 193810 */     // GIR_Coverage, 2991,
     /* 193810 */     GIR_Done,
     /* 193811 */   // Label 4347: @193811
     /* 193811 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(193834), // Rule ID 3003 //
     /* 193816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 193819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193827 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (PABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 193827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSWrr),
     /* 193832 */     GIR_RootConstrainSelectedInstOperands,
     /* 193833 */     // GIR_Coverage, 3003,
     /* 193833 */     GIR_Done,
     /* 193834 */   // Label 4348: @193834
     /* 193834 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(193857), // Rule ID 13311 //
     /* 193839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 193842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193850 */     // (abs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPABSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 193850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rr),
     /* 193855 */     GIR_RootConstrainSelectedInstOperands,
     /* 193856 */     // GIR_Coverage, 13311,
     /* 193856 */     GIR_Done,
     /* 193857 */   // Label 4349: @193857
     /* 193857 */   GIM_Reject,
     /* 193858 */ // Label 4344: @193858
     /* 193858 */ GIM_Reject,
     /* 193859 */ // Label 4321: @193859
     /* 193859 */ GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(194026),
     /* 193864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 193867 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(193923), // Rule ID 3000 //
     /* 193872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 193875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 193879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193887 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193890 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193894 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193907 */     // (abs:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 193907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDYrm),
     /* 193910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 193916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193921 */     GIR_RootConstrainSelectedInstOperands,
     /* 193922 */     // GIR_Coverage, 3000,
     /* 193922 */     GIR_EraseRootFromParent_Done,
     /* 193923 */   // Label 4351: @193923
     /* 193923 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(193979), // Rule ID 13284 //
     /* 193928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193943 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193950 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193963 */     // (abs:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 193963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rm),
     /* 193966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193968 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193977 */     GIR_RootConstrainSelectedInstOperands,
     /* 193978 */     // GIR_Coverage, 13284,
     /* 193978 */     GIR_EraseRootFromParent_Done,
     /* 193979 */   // Label 4352: @193979
     /* 193979 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(194002), // Rule ID 2999 //
     /* 193984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 193987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 193991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 193995 */     // (abs:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)  =>  (VPABSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)
     /* 193995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDYrr),
     /* 194000 */     GIR_RootConstrainSelectedInstOperands,
     /* 194001 */     // GIR_Coverage, 2999,
     /* 194001 */     GIR_Done,
     /* 194002 */   // Label 4353: @194002
     /* 194002 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(194025), // Rule ID 13281 //
     /* 194007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 194010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194018 */     // (abs:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPABSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 194018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rr),
     /* 194023 */     GIR_RootConstrainSelectedInstOperands,
     /* 194024 */     // GIR_Coverage, 13281,
     /* 194024 */     GIR_Done,
     /* 194025 */   // Label 4354: @194025
     /* 194025 */   GIM_Reject,
     /* 194026 */ // Label 4350: @194026
     /* 194026 */ GIM_Reject,
     /* 194027 */ // Label 4322: @194027
     /* 194027 */ GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(194111),
     /* 194032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 194035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194039 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(194091), // Rule ID 13248 //
     /* 194044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194055 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194058 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194062 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194075 */     // (abs:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 194075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZrm),
     /* 194078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194080 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194089 */     GIR_RootConstrainSelectedInstOperands,
     /* 194090 */     // GIR_Coverage, 13248,
     /* 194090 */     GIR_EraseRootFromParent_Done,
     /* 194091 */   // Label 4356: @194091
     /* 194091 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(194110), // Rule ID 13245 //
     /* 194096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194103 */     // (abs:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPABSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 194103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 194108 */     GIR_RootConstrainSelectedInstOperands,
     /* 194109 */     // GIR_Coverage, 13245,
     /* 194109 */     GIR_Done,
     /* 194110 */   // Label 4357: @194110
     /* 194110 */   GIM_Reject,
     /* 194111 */ // Label 4355: @194111
     /* 194111 */ GIM_Reject,
     /* 194112 */ // Label 4323: @194112
     /* 194112 */ GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(194302),
     /* 194117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 194120 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(194176), // Rule ID 2990 //
     /* 194125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194147 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194160 */     // (abs:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 194160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBrm),
     /* 194163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 194169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194174 */     GIR_RootConstrainSelectedInstOperands,
     /* 194175 */     // GIR_Coverage, 2990,
     /* 194175 */     GIR_EraseRootFromParent_Done,
     /* 194176 */   // Label 4359: @194176
     /* 194176 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(194232), // Rule ID 13332 //
     /* 194181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194196 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194199 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194203 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194216 */     // (abs:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZ128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)
     /* 194216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rm),
     /* 194219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194230 */     GIR_RootConstrainSelectedInstOperands,
     /* 194231 */     // GIR_Coverage, 13332,
     /* 194231 */     GIR_EraseRootFromParent_Done,
     /* 194232 */   // Label 4360: @194232
     /* 194232 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(194255), // Rule ID 2989 //
     /* 194237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194248 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (VPABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 194248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBrr),
     /* 194253 */     GIR_RootConstrainSelectedInstOperands,
     /* 194254 */     // GIR_Coverage, 2989,
     /* 194254 */     GIR_Done,
     /* 194255 */   // Label 4361: @194255
     /* 194255 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(194278), // Rule ID 3001 //
     /* 194260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 194263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194271 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (PABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 194271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSBrr),
     /* 194276 */     GIR_RootConstrainSelectedInstOperands,
     /* 194277 */     // GIR_Coverage, 3001,
     /* 194277 */     GIR_Done,
     /* 194278 */   // Label 4362: @194278
     /* 194278 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(194301), // Rule ID 13329 //
     /* 194283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194294 */     // (abs:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPABSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 194294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rr),
     /* 194299 */     GIR_RootConstrainSelectedInstOperands,
     /* 194300 */     // GIR_Coverage, 13329,
     /* 194300 */     GIR_Done,
     /* 194301 */   // Label 4363: @194301
     /* 194301 */   GIM_Reject,
     /* 194302 */ // Label 4358: @194302
     /* 194302 */ GIM_Reject,
     /* 194303 */ // Label 4324: @194303
     /* 194303 */ GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(194470),
     /* 194308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 194311 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(194367), // Rule ID 2998 //
     /* 194316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 194319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194331 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194338 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194351 */     // (abs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 194351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWYrm),
     /* 194354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194356 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 194360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194365 */     GIR_RootConstrainSelectedInstOperands,
     /* 194366 */     // GIR_Coverage, 2998,
     /* 194366 */     GIR_EraseRootFromParent_Done,
     /* 194367 */   // Label 4365: @194367
     /* 194367 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(194423), // Rule ID 13308 //
     /* 194372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194387 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194407 */     // (abs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)
     /* 194407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rm),
     /* 194410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194421 */     GIR_RootConstrainSelectedInstOperands,
     /* 194422 */     // GIR_Coverage, 13308,
     /* 194422 */     GIR_EraseRootFromParent_Done,
     /* 194423 */   // Label 4366: @194423
     /* 194423 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(194446), // Rule ID 2997 //
     /* 194428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 194431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194439 */     // (abs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)  =>  (VPABSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)
     /* 194439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWYrr),
     /* 194444 */     GIR_RootConstrainSelectedInstOperands,
     /* 194445 */     // GIR_Coverage, 2997,
     /* 194445 */     GIR_Done,
     /* 194446 */   // Label 4367: @194446
     /* 194446 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(194469), // Rule ID 13305 //
     /* 194451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194462 */     // (abs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPABSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 194462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rr),
     /* 194467 */     GIR_RootConstrainSelectedInstOperands,
     /* 194468 */     // GIR_Coverage, 13305,
     /* 194468 */     GIR_Done,
     /* 194469 */   // Label 4368: @194469
     /* 194469 */   GIM_Reject,
     /* 194470 */ // Label 4364: @194470
     /* 194470 */ GIM_Reject,
     /* 194471 */ // Label 4325: @194471
     /* 194471 */ GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(194555),
     /* 194476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 194479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194483 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(194535), // Rule ID 13275 //
     /* 194488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194499 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194502 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194506 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194519 */     // (abs:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 194519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZrm),
     /* 194522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194524 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194533 */     GIR_RootConstrainSelectedInstOperands,
     /* 194534 */     // GIR_Coverage, 13275,
     /* 194534 */     GIR_EraseRootFromParent_Done,
     /* 194535 */   // Label 4370: @194535
     /* 194535 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(194554), // Rule ID 13272 //
     /* 194540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194547 */     // (abs:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPABSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 194547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZrr),
     /* 194552 */     GIR_RootConstrainSelectedInstOperands,
     /* 194553 */     // GIR_Coverage, 13272,
     /* 194553 */     GIR_Done,
     /* 194554 */   // Label 4371: @194554
     /* 194554 */   GIM_Reject,
     /* 194555 */ // Label 4369: @194555
     /* 194555 */ GIM_Reject,
     /* 194556 */ // Label 4326: @194556
     /* 194556 */ GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(194723),
     /* 194561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 194564 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(194620), // Rule ID 2996 //
     /* 194569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 194572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194604 */     // (abs:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 194604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBYrm),
     /* 194607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 194613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194618 */     GIR_RootConstrainSelectedInstOperands,
     /* 194619 */     // GIR_Coverage, 2996,
     /* 194619 */     GIR_EraseRootFromParent_Done,
     /* 194620 */   // Label 4373: @194620
     /* 194620 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(194676), // Rule ID 13326 //
     /* 194625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194640 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194643 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194647 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194660 */     // (abs:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZ256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)
     /* 194660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rm),
     /* 194663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194665 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194674 */     GIR_RootConstrainSelectedInstOperands,
     /* 194675 */     // GIR_Coverage, 13326,
     /* 194675 */     GIR_EraseRootFromParent_Done,
     /* 194676 */   // Label 4374: @194676
     /* 194676 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(194699), // Rule ID 2995 //
     /* 194681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 194684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194692 */     // (abs:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)  =>  (VPABSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)
     /* 194692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBYrr),
     /* 194697 */     GIR_RootConstrainSelectedInstOperands,
     /* 194698 */     // GIR_Coverage, 2995,
     /* 194698 */     GIR_Done,
     /* 194699 */   // Label 4375: @194699
     /* 194699 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(194722), // Rule ID 13323 //
     /* 194704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194715 */     // (abs:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPABSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 194715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rr),
     /* 194720 */     GIR_RootConstrainSelectedInstOperands,
     /* 194721 */     // GIR_Coverage, 13323,
     /* 194721 */     GIR_Done,
     /* 194722 */   // Label 4376: @194722
     /* 194722 */   GIM_Reject,
     /* 194723 */ // Label 4372: @194723
     /* 194723 */ GIM_Reject,
     /* 194724 */ // Label 4327: @194724
     /* 194724 */ GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(194808),
     /* 194729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 194732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194736 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(194788), // Rule ID 13302 //
     /* 194741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 194744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194752 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194755 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194759 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194772 */     // (abs:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)
     /* 194772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZrm),
     /* 194775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194786 */     GIR_RootConstrainSelectedInstOperands,
     /* 194787 */     // GIR_Coverage, 13302,
     /* 194787 */     GIR_EraseRootFromParent_Done,
     /* 194788 */   // Label 4378: @194788
     /* 194788 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(194807), // Rule ID 13299 //
     /* 194793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 194796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194800 */     // (abs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPABSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 194800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZrr),
     /* 194805 */     GIR_RootConstrainSelectedInstOperands,
     /* 194806 */     // GIR_Coverage, 13299,
     /* 194806 */     GIR_Done,
     /* 194807 */   // Label 4379: @194807
     /* 194807 */   GIM_Reject,
     /* 194808 */ // Label 4377: @194808
     /* 194808 */ GIM_Reject,
     /* 194809 */ // Label 4328: @194809
     /* 194809 */ GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(194893),
     /* 194814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 194817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194821 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(194873), // Rule ID 13320 //
     /* 194826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 194829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194837 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194844 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194857 */     // (abs:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)
     /* 194857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZrm),
     /* 194860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194871 */     GIR_RootConstrainSelectedInstOperands,
     /* 194872 */     // GIR_Coverage, 13320,
     /* 194872 */     GIR_EraseRootFromParent_Done,
     /* 194873 */   // Label 4381: @194873
     /* 194873 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(194892), // Rule ID 13317 //
     /* 194878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 194881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194885 */     // (abs:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPABSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 194885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZrr),
     /* 194890 */     GIR_RootConstrainSelectedInstOperands,
     /* 194891 */     // GIR_Coverage, 13317,
     /* 194891 */     GIR_Done,
     /* 194892 */   // Label 4382: @194892
     /* 194892 */   GIM_Reject,
     /* 194893 */ // Label 4380: @194893
     /* 194893 */ GIM_Reject,
     /* 194894 */ // Label 4329: @194894
     /* 194894 */ GIM_Reject,
     /* 194895 */ // Label 59: @194895
     /* 194895 */ GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(194910), // Rule ID 630 //
     /* 194900 */   // MIs[0] dst
     /* 194900 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 194903 */   // (br (bb:{ *:[Other] }):$dst)  =>  (JMP_1 (bb:{ *:[Other] }):$dst)
     /* 194903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::JMP_1),
     /* 194908 */   GIR_RootConstrainSelectedInstOperands,
     /* 194909 */   // GIR_Coverage, 630,
     /* 194909 */   GIR_Done,
     /* 194910 */ // Label 4383: @194910
     /* 194910 */ GIM_Reject,
     /* 194911 */ // Label 60: @194911
     /* 194911 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(22), /*)*//*default:*//*Label 4398*/ GIMT_Encode4(197839),
     /* 194922 */ /*GILLT_s1*//*Label 4384*/ GIMT_Encode4(195010), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 194950 */ /*GILLT_v2s1*//*Label 4385*/ GIMT_Encode4(195251),
     /* 194954 */ /*GILLT_v2s64*//*Label 4386*/ GIMT_Encode4(195452),
     /* 194958 */ /*GILLT_v4s1*//*Label 4387*/ GIMT_Encode4(195933),
     /* 194962 */ /*GILLT_v4s32*//*Label 4388*/ GIMT_Encode4(196094),
     /* 194966 */ /*GILLT_v4s64*//*Label 4389*/ GIMT_Encode4(196575),
     /* 194970 */ /*GILLT_v8s1*//*Label 4390*/ GIMT_Encode4(196658),
     /* 194974 */ /*GILLT_v8s16*//*Label 4391*/ GIMT_Encode4(196779),
     /* 194978 */ /*GILLT_v8s32*//*Label 4392*/ GIMT_Encode4(197260), GIMT_Encode4(0),
     /* 194986 */ /*GILLT_v16s1*//*Label 4393*/ GIMT_Encode4(197343),
     /* 194990 */ /*GILLT_v16s8*//*Label 4394*/ GIMT_Encode4(197424),
     /* 194994 */ /*GILLT_v16s16*//*Label 4395*/ GIMT_Encode4(197665), GIMT_Encode4(0),
     /* 195002 */ /*GILLT_v32s1*//*Label 4396*/ GIMT_Encode4(197748),
     /* 195006 */ /*GILLT_v32s8*//*Label 4397*/ GIMT_Encode4(197789),
     /* 195010 */ // Label 4384: @195010
     /* 195010 */ GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(195050), // Rule ID 19601 //
     /* 195015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 195018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 195022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 195026 */   // MIs[0] Operand 2
     /* 195026 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195037 */   // (extract_subvector:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, VK1:{ *:[i32] })
     /* 195037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195042 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195044 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 195049 */   // GIR_Coverage, 19601,
     /* 195049 */   GIR_EraseRootFromParent_Done,
     /* 195050 */ // Label 4399: @195050
     /* 195050 */ GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(195090), // Rule ID 19603 //
     /* 195055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 195058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 195062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 195066 */   // MIs[0] Operand 2
     /* 195066 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195077 */   // (extract_subvector:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, VK1:{ *:[i32] })
     /* 195077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195082 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195084 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 195089 */   // GIR_Coverage, 19603,
     /* 195089 */   GIR_EraseRootFromParent_Done,
     /* 195090 */ // Label 4400: @195090
     /* 195090 */ GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(195130), // Rule ID 19605 //
     /* 195095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 195098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 195102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 195106 */   // MIs[0] Operand 2
     /* 195106 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195117 */   // (extract_subvector:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, VK1:{ *:[i32] })
     /* 195117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195122 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195124 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 195129 */   // GIR_Coverage, 19605,
     /* 195129 */   GIR_EraseRootFromParent_Done,
     /* 195130 */ // Label 4401: @195130
     /* 195130 */ GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(195170), // Rule ID 19607 //
     /* 195135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 195138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 195142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 195146 */   // MIs[0] Operand 2
     /* 195146 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195157 */   // (extract_subvector:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, VK1:{ *:[i32] })
     /* 195157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195162 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 195169 */   // GIR_Coverage, 19607,
     /* 195169 */   GIR_EraseRootFromParent_Done,
     /* 195170 */ // Label 4402: @195170
     /* 195170 */ GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(195210), // Rule ID 19609 //
     /* 195175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 195178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 195182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 195186 */   // MIs[0] Operand 2
     /* 195186 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195197 */   // (extract_subvector:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, VK1:{ *:[i32] })
     /* 195197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195202 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 195209 */   // GIR_Coverage, 19609,
     /* 195209 */   GIR_EraseRootFromParent_Done,
     /* 195210 */ // Label 4403: @195210
     /* 195210 */ GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(195250), // Rule ID 19611 //
     /* 195215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 195218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 195222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 195226 */   // MIs[0] Operand 2
     /* 195226 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195237 */   // (extract_subvector:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, VK1:{ *:[i32] })
     /* 195237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195242 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195244 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 195249 */   // GIR_Coverage, 19611,
     /* 195249 */   GIR_EraseRootFromParent_Done,
     /* 195250 */ // Label 4404: @195250
     /* 195250 */ GIM_Reject,
     /* 195251 */ // Label 4385: @195251
     /* 195251 */ GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(195291), // Rule ID 19613 //
     /* 195256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 195259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 195263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 195267 */   // MIs[0] Operand 2
     /* 195267 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195278 */   // (extract_subvector:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, VK2:{ *:[i32] })
     /* 195278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195285 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 195290 */   // GIR_Coverage, 19613,
     /* 195290 */   GIR_EraseRootFromParent_Done,
     /* 195291 */ // Label 4405: @195291
     /* 195291 */ GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(195331), // Rule ID 19615 //
     /* 195296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 195299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 195303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 195307 */   // MIs[0] Operand 2
     /* 195307 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195318 */   // (extract_subvector:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, VK2:{ *:[i32] })
     /* 195318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195323 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195325 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 195330 */   // GIR_Coverage, 19615,
     /* 195330 */   GIR_EraseRootFromParent_Done,
     /* 195331 */ // Label 4406: @195331
     /* 195331 */ GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(195371), // Rule ID 19617 //
     /* 195336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 195339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 195343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 195347 */   // MIs[0] Operand 2
     /* 195347 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195358 */   // (extract_subvector:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, VK2:{ *:[i32] })
     /* 195358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 195370 */   // GIR_Coverage, 19617,
     /* 195370 */   GIR_EraseRootFromParent_Done,
     /* 195371 */ // Label 4407: @195371
     /* 195371 */ GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(195411), // Rule ID 19619 //
     /* 195376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 195379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 195383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 195387 */   // MIs[0] Operand 2
     /* 195387 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195398 */   // (extract_subvector:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, VK2:{ *:[i32] })
     /* 195398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195403 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 195410 */   // GIR_Coverage, 19619,
     /* 195410 */   GIR_EraseRootFromParent_Done,
     /* 195411 */ // Label 4408: @195411
     /* 195411 */ GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(195451), // Rule ID 19621 //
     /* 195416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 195419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 195423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 195427 */   // MIs[0] Operand 2
     /* 195427 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195438 */   // (extract_subvector:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, VK2:{ *:[i32] })
     /* 195438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195443 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195445 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 195450 */   // GIR_Coverage, 19621,
     /* 195450 */   GIR_EraseRootFromParent_Done,
     /* 195451 */ // Label 4409: @195451
     /* 195451 */ GIM_Reject,
     /* 195452 */ // Label 4386: @195452
     /* 195452 */ GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(195523), // Rule ID 19052 //
     /* 195457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 195460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195471 */   // MIs[0] Operand 2
     /* 195471 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 195482 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 195485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195494 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195500 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195505 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 195513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195521 */   GIR_RootConstrainSelectedInstOperands,
     /* 195522 */   // GIR_Coverage, 19052,
     /* 195522 */   GIR_EraseRootFromParent_Done,
     /* 195523 */ // Label 4410: @195523
     /* 195523 */ GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(195594), // Rule ID 19053 //
     /* 195528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 195531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195542 */   // MIs[0] Operand 2
     /* 195542 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 195553 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195553 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 195556 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195560 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195565 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195571 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 195584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195592 */   GIR_RootConstrainSelectedInstOperands,
     /* 195593 */   // GIR_Coverage, 19053,
     /* 195593 */   GIR_EraseRootFromParent_Done,
     /* 195594 */ // Label 4411: @195594
     /* 195594 */ GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(195665), // Rule ID 19059 //
     /* 195599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 195602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195613 */   // MIs[0] Operand 2
     /* 195613 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 195624 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 195627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195636 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195642 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195647 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 195655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195657 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195663 */   GIR_RootConstrainSelectedInstOperands,
     /* 195664 */   // GIR_Coverage, 19059,
     /* 195664 */   GIR_EraseRootFromParent_Done,
     /* 195665 */ // Label 4412: @195665
     /* 195665 */ GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(195736), // Rule ID 19060 //
     /* 195670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 195673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195684 */   // MIs[0] Operand 2
     /* 195684 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 195695 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195695 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 195698 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195702 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195707 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195713 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195718 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 195726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195734 */   GIR_RootConstrainSelectedInstOperands,
     /* 195735 */   // GIR_Coverage, 19060,
     /* 195735 */   GIR_EraseRootFromParent_Done,
     /* 195736 */ // Label 4413: @195736
     /* 195736 */ GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(195785), // Rule ID 23004 //
     /* 195741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 195744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 195748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195752 */   // MIs[0] Operand 2
     /* 195752 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195763 */   // (extract_subvector:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, sub_xmm:{ *:[i32] })
     /* 195763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195768 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195774 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 195779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 195784 */   // GIR_Coverage, 23004,
     /* 195784 */   GIR_EraseRootFromParent_Done,
     /* 195785 */ // Label 4414: @195785
     /* 195785 */ GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(195834), // Rule ID 23007 //
     /* 195790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 195793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 195797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195801 */   // MIs[0] Operand 2
     /* 195801 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195812 */   // (extract_subvector:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, sub_xmm:{ *:[i32] })
     /* 195812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195817 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195823 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 195828 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 195833 */   // GIR_Coverage, 23007,
     /* 195833 */   GIR_EraseRootFromParent_Done,
     /* 195834 */ // Label 4415: @195834
     /* 195834 */ GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(195883), // Rule ID 23025 //
     /* 195839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 195846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195850 */   // MIs[0] Operand 2
     /* 195850 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195861 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, sub_xmm:{ *:[i32] })
     /* 195861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195866 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195872 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 195877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195882 */   // GIR_Coverage, 23025,
     /* 195882 */   GIR_EraseRootFromParent_Done,
     /* 195883 */ // Label 4416: @195883
     /* 195883 */ GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(195932), // Rule ID 23028 //
     /* 195888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 195895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195899 */   // MIs[0] Operand 2
     /* 195899 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195910 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, sub_xmm:{ *:[i32] })
     /* 195910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195915 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 195926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195931 */   // GIR_Coverage, 23028,
     /* 195931 */   GIR_EraseRootFromParent_Done,
     /* 195932 */ // Label 4417: @195932
     /* 195932 */ GIM_Reject,
     /* 195933 */ // Label 4387: @195933
     /* 195933 */ GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(195973), // Rule ID 19623 //
     /* 195938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 195941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 195945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 195949 */   // MIs[0] Operand 2
     /* 195949 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195960 */   // (extract_subvector:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, VK4:{ *:[i32] })
     /* 195960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195965 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 195972 */   // GIR_Coverage, 19623,
     /* 195972 */   GIR_EraseRootFromParent_Done,
     /* 195973 */ // Label 4418: @195973
     /* 195973 */ GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(196013), // Rule ID 19625 //
     /* 195978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 195981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 195985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 195989 */   // MIs[0] Operand 2
     /* 195989 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196000 */   // (extract_subvector:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, VK4:{ *:[i32] })
     /* 196000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196005 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 196012 */   // GIR_Coverage, 19625,
     /* 196012 */   GIR_EraseRootFromParent_Done,
     /* 196013 */ // Label 4419: @196013
     /* 196013 */ GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(196053), // Rule ID 19627 //
     /* 196018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 196021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 196025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 196029 */   // MIs[0] Operand 2
     /* 196029 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196040 */   // (extract_subvector:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, VK4:{ *:[i32] })
     /* 196040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196045 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 196052 */   // GIR_Coverage, 19627,
     /* 196052 */   GIR_EraseRootFromParent_Done,
     /* 196053 */ // Label 4420: @196053
     /* 196053 */ GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(196093), // Rule ID 19629 //
     /* 196058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 196061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 196065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 196069 */   // MIs[0] Operand 2
     /* 196069 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196080 */   // (extract_subvector:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, VK4:{ *:[i32] })
     /* 196080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196085 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196087 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 196092 */   // GIR_Coverage, 19629,
     /* 196092 */   GIR_EraseRootFromParent_Done,
     /* 196093 */ // Label 4421: @196093
     /* 196093 */ GIM_Reject,
     /* 196094 */ // Label 4388: @196094
     /* 196094 */ GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(196165), // Rule ID 19054 //
     /* 196099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 196102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196113 */   // MIs[0] Operand 2
     /* 196113 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 196124 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 196127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196136 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196142 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196147 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 196155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196157 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196163 */   GIR_RootConstrainSelectedInstOperands,
     /* 196164 */   // GIR_Coverage, 19054,
     /* 196164 */   GIR_EraseRootFromParent_Done,
     /* 196165 */ // Label 4422: @196165
     /* 196165 */ GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(196236), // Rule ID 19055 //
     /* 196170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 196173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196184 */   // MIs[0] Operand 2
     /* 196184 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 196195 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 196198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196207 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196213 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196218 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 196226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196228 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196234 */   GIR_RootConstrainSelectedInstOperands,
     /* 196235 */   // GIR_Coverage, 19055,
     /* 196235 */   GIR_EraseRootFromParent_Done,
     /* 196236 */ // Label 4423: @196236
     /* 196236 */ GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(196307), // Rule ID 19061 //
     /* 196241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 196244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196255 */   // MIs[0] Operand 2
     /* 196255 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 196266 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 196269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196278 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196284 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196289 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 196297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196305 */   GIR_RootConstrainSelectedInstOperands,
     /* 196306 */   // GIR_Coverage, 19061,
     /* 196306 */   GIR_EraseRootFromParent_Done,
     /* 196307 */ // Label 4424: @196307
     /* 196307 */ GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(196378), // Rule ID 19062 //
     /* 196312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 196315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196326 */   // MIs[0] Operand 2
     /* 196326 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 196337 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196337 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 196340 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196344 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196349 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196355 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196360 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 196368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196376 */   GIR_RootConstrainSelectedInstOperands,
     /* 196377 */   // GIR_Coverage, 19062,
     /* 196377 */   GIR_EraseRootFromParent_Done,
     /* 196378 */ // Label 4425: @196378
     /* 196378 */ GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(196427), // Rule ID 22998 //
     /* 196383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 196386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 196390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 196394 */   // MIs[0] Operand 2
     /* 196394 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196405 */   // (extract_subvector:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, sub_xmm:{ *:[i32] })
     /* 196405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196410 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 196421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 196426 */   // GIR_Coverage, 22998,
     /* 196426 */   GIR_EraseRootFromParent_Done,
     /* 196427 */ // Label 4426: @196427
     /* 196427 */ GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(196476), // Rule ID 23001 //
     /* 196432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 196435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 196439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 196443 */   // MIs[0] Operand 2
     /* 196443 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196454 */   // (extract_subvector:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, sub_xmm:{ *:[i32] })
     /* 196454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196459 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196465 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 196470 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 196475 */   // GIR_Coverage, 23001,
     /* 196475 */   GIR_EraseRootFromParent_Done,
     /* 196476 */ // Label 4427: @196476
     /* 196476 */ GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(196525), // Rule ID 23019 //
     /* 196481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 196488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196492 */   // MIs[0] Operand 2
     /* 196492 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196503 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, sub_xmm:{ *:[i32] })
     /* 196503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196508 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196514 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 196519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196524 */   // GIR_Coverage, 23019,
     /* 196524 */   GIR_EraseRootFromParent_Done,
     /* 196525 */ // Label 4428: @196525
     /* 196525 */ GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(196574), // Rule ID 23022 //
     /* 196530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 196537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196541 */   // MIs[0] Operand 2
     /* 196541 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196552 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, sub_xmm:{ *:[i32] })
     /* 196552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196557 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196563 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 196568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196573 */   // GIR_Coverage, 23022,
     /* 196573 */   GIR_EraseRootFromParent_Done,
     /* 196574 */ // Label 4429: @196574
     /* 196574 */ GIM_Reject,
     /* 196575 */ // Label 4389: @196575
     /* 196575 */ GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(196657),
     /* 196580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 196583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 196587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196591 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196602 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(196629), // Rule ID 23046 //
     /* 196607 */     // (extract_subvector:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] })
     /* 196607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196612 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196628 */     // GIR_Coverage, 23046,
     /* 196628 */     GIR_EraseRootFromParent_Done,
     /* 196629 */   // Label 4431: @196629
     /* 196629 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(196656), // Rule ID 23049 //
     /* 196634 */     // (extract_subvector:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] })
     /* 196634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196639 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196655 */     // GIR_Coverage, 23049,
     /* 196655 */     GIR_EraseRootFromParent_Done,
     /* 196656 */   // Label 4432: @196656
     /* 196656 */   GIM_Reject,
     /* 196657 */ // Label 4430: @196657
     /* 196657 */ GIM_Reject,
     /* 196658 */ // Label 4390: @196658
     /* 196658 */ GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(196698), // Rule ID 19631 //
     /* 196663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 196666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 196670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 196674 */   // MIs[0] Operand 2
     /* 196674 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196685 */   // (extract_subvector:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, VK8:{ *:[i32] })
     /* 196685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196690 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196692 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 196697 */   // GIR_Coverage, 19631,
     /* 196697 */   GIR_EraseRootFromParent_Done,
     /* 196698 */ // Label 4433: @196698
     /* 196698 */ GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(196738), // Rule ID 19633 //
     /* 196703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 196706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 196710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 196714 */   // MIs[0] Operand 2
     /* 196714 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196725 */   // (extract_subvector:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, VK8:{ *:[i32] })
     /* 196725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196730 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196732 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 196737 */   // GIR_Coverage, 19633,
     /* 196737 */   GIR_EraseRootFromParent_Done,
     /* 196738 */ // Label 4434: @196738
     /* 196738 */ GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(196778), // Rule ID 19635 //
     /* 196743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 196746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 196750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 196754 */   // MIs[0] Operand 2
     /* 196754 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196765 */   // (extract_subvector:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, VK8:{ *:[i32] })
     /* 196765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196770 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 196777 */   // GIR_Coverage, 19635,
     /* 196777 */   GIR_EraseRootFromParent_Done,
     /* 196778 */ // Label 4435: @196778
     /* 196778 */ GIM_Reject,
     /* 196779 */ // Label 4391: @196779
     /* 196779 */ GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(196850), // Rule ID 19056 //
     /* 196784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 196787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 196790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196798 */   // MIs[0] Operand 2
     /* 196798 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 196809 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 196812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196821 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196827 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196832 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 196840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196848 */   GIR_RootConstrainSelectedInstOperands,
     /* 196849 */   // GIR_Coverage, 19056,
     /* 196849 */   GIR_EraseRootFromParent_Done,
     /* 196850 */ // Label 4436: @196850
     /* 196850 */ GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(196921), // Rule ID 19057 //
     /* 196855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 196858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 196861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196869 */   // MIs[0] Operand 2
     /* 196869 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 196880 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 196883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196892 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196898 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196903 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 196911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196919 */   GIR_RootConstrainSelectedInstOperands,
     /* 196920 */   // GIR_Coverage, 19057,
     /* 196920 */   GIR_EraseRootFromParent_Done,
     /* 196921 */ // Label 4437: @196921
     /* 196921 */ GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(196992), // Rule ID 19063 //
     /* 196926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 196929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 196932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196940 */   // MIs[0] Operand 2
     /* 196940 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 196951 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 196954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196963 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196969 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196974 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 196982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196984 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196990 */   GIR_RootConstrainSelectedInstOperands,
     /* 196991 */   // GIR_Coverage, 19063,
     /* 196991 */   GIR_EraseRootFromParent_Done,
     /* 196992 */ // Label 4438: @196992
     /* 196992 */ GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(197063), // Rule ID 19064 //
     /* 196997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 197000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 197003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197011 */   // MIs[0] Operand 2
     /* 197011 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 197022 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 197022 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 197025 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197029 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197034 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197040 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197045 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 197053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 197058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197061 */   GIR_RootConstrainSelectedInstOperands,
     /* 197062 */   // GIR_Coverage, 19064,
     /* 197062 */   GIR_EraseRootFromParent_Done,
     /* 197063 */ // Label 4439: @197063
     /* 197063 */ GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(197112), // Rule ID 23010 //
     /* 197068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 197071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 197075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197079 */   // MIs[0] Operand 2
     /* 197079 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197090 */   // (extract_subvector:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, sub_xmm:{ *:[i32] })
     /* 197090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197095 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 197106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 197111 */   // GIR_Coverage, 23010,
     /* 197111 */   GIR_EraseRootFromParent_Done,
     /* 197112 */ // Label 4440: @197112
     /* 197112 */ GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(197161), // Rule ID 23016 //
     /* 197117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 197120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 197124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197128 */   // MIs[0] Operand 2
     /* 197128 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197139 */   // (extract_subvector:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, sub_xmm:{ *:[i32] })
     /* 197139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197144 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197150 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 197155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 197160 */   // GIR_Coverage, 23016,
     /* 197160 */   GIR_EraseRootFromParent_Done,
     /* 197161 */ // Label 4441: @197161
     /* 197161 */ GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(197210), // Rule ID 23031 //
     /* 197166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 197169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 197173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197177 */   // MIs[0] Operand 2
     /* 197177 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197188 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, sub_xmm:{ *:[i32] })
     /* 197188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197193 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 197204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197209 */   // GIR_Coverage, 23031,
     /* 197209 */   GIR_EraseRootFromParent_Done,
     /* 197210 */ // Label 4442: @197210
     /* 197210 */ GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(197259), // Rule ID 23037 //
     /* 197215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 197218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 197222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197226 */   // MIs[0] Operand 2
     /* 197226 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197237 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, sub_xmm:{ *:[i32] })
     /* 197237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197242 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197248 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 197253 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197258 */   // GIR_Coverage, 23037,
     /* 197258 */   GIR_EraseRootFromParent_Done,
     /* 197259 */ // Label 4443: @197259
     /* 197259 */ GIM_Reject,
     /* 197260 */ // Label 4392: @197260
     /* 197260 */ GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(197342),
     /* 197265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 197268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197276 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197287 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(197314), // Rule ID 23040 //
     /* 197292 */     // (extract_subvector:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] })
     /* 197292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197297 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197313 */     // GIR_Coverage, 23040,
     /* 197313 */     GIR_EraseRootFromParent_Done,
     /* 197314 */   // Label 4445: @197314
     /* 197314 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(197341), // Rule ID 23043 //
     /* 197319 */     // (extract_subvector:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] })
     /* 197319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197324 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197340 */     // GIR_Coverage, 23043,
     /* 197340 */     GIR_EraseRootFromParent_Done,
     /* 197341 */   // Label 4446: @197341
     /* 197341 */   GIM_Reject,
     /* 197342 */ // Label 4444: @197342
     /* 197342 */ GIM_Reject,
     /* 197343 */ // Label 4393: @197343
     /* 197343 */ GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(197383), // Rule ID 19637 //
     /* 197348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 197351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 197355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 197359 */   // MIs[0] Operand 2
     /* 197359 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197370 */   // (extract_subvector:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, VK16:{ *:[i32] })
     /* 197370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197375 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197377 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 197382 */   // GIR_Coverage, 19637,
     /* 197382 */   GIR_EraseRootFromParent_Done,
     /* 197383 */ // Label 4447: @197383
     /* 197383 */ GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(197423), // Rule ID 19639 //
     /* 197388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 197391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 197395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 197399 */   // MIs[0] Operand 2
     /* 197399 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197410 */   // (extract_subvector:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, VK16:{ *:[i32] })
     /* 197410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197415 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 197422 */   // GIR_Coverage, 19639,
     /* 197422 */   GIR_EraseRootFromParent_Done,
     /* 197423 */ // Label 4448: @197423
     /* 197423 */ GIM_Reject,
     /* 197424 */ // Label 4394: @197424
     /* 197424 */ GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(197495), // Rule ID 19058 //
     /* 197429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 197432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 197435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197443 */   // MIs[0] Operand 2
     /* 197443 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 197454 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 197454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 197457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197466 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197472 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197477 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 197485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 197490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197493 */   GIR_RootConstrainSelectedInstOperands,
     /* 197494 */   // GIR_Coverage, 19058,
     /* 197494 */   GIR_EraseRootFromParent_Done,
     /* 197495 */ // Label 4449: @197495
     /* 197495 */ GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(197566), // Rule ID 19065 //
     /* 197500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 197503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 197506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197514 */   // MIs[0] Operand 2
     /* 197514 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 197525 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 197525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 197528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197537 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197543 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197548 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 197556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197558 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 197561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197564 */   GIR_RootConstrainSelectedInstOperands,
     /* 197565 */   // GIR_Coverage, 19065,
     /* 197565 */   GIR_EraseRootFromParent_Done,
     /* 197566 */ // Label 4450: @197566
     /* 197566 */ GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(197615), // Rule ID 23013 //
     /* 197571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 197574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 197578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197582 */   // MIs[0] Operand 2
     /* 197582 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197593 */   // (extract_subvector:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, sub_xmm:{ *:[i32] })
     /* 197593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197598 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197604 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 197609 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 197614 */   // GIR_Coverage, 23013,
     /* 197614 */   GIR_EraseRootFromParent_Done,
     /* 197615 */ // Label 4451: @197615
     /* 197615 */ GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(197664), // Rule ID 23034 //
     /* 197620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 197623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 197627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197631 */   // MIs[0] Operand 2
     /* 197631 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197642 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, sub_xmm:{ *:[i32] })
     /* 197642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197647 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197653 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 197658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197663 */   // GIR_Coverage, 23034,
     /* 197663 */   GIR_EraseRootFromParent_Done,
     /* 197664 */ // Label 4452: @197664
     /* 197664 */ GIM_Reject,
     /* 197665 */ // Label 4395: @197665
     /* 197665 */ GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(197747),
     /* 197670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 197673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197681 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197692 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(197719), // Rule ID 23052 //
     /* 197697 */     // (extract_subvector:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] })
     /* 197697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197702 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197718 */     // GIR_Coverage, 23052,
     /* 197718 */     GIR_EraseRootFromParent_Done,
     /* 197719 */   // Label 4454: @197719
     /* 197719 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(197746), // Rule ID 23058 //
     /* 197724 */     // (extract_subvector:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] })
     /* 197724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197729 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197745 */     // GIR_Coverage, 23058,
     /* 197745 */     GIR_EraseRootFromParent_Done,
     /* 197746 */   // Label 4455: @197746
     /* 197746 */   GIM_Reject,
     /* 197747 */ // Label 4453: @197747
     /* 197747 */ GIM_Reject,
     /* 197748 */ // Label 4396: @197748
     /* 197748 */ GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(197788), // Rule ID 19641 //
     /* 197753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 197756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 197760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 197764 */   // MIs[0] Operand 2
     /* 197764 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197775 */   // (extract_subvector:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, VK32:{ *:[i32] })
     /* 197775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197782 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 197787 */   // GIR_Coverage, 19641,
     /* 197787 */   GIR_EraseRootFromParent_Done,
     /* 197788 */ // Label 4456: @197788
     /* 197788 */ GIM_Reject,
     /* 197789 */ // Label 4397: @197789
     /* 197789 */ GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(197838), // Rule ID 23055 //
     /* 197794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 197797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197805 */   // MIs[0] Operand 2
     /* 197805 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197816 */   // (extract_subvector:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] })
     /* 197816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197821 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197827 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197832 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197837 */   // GIR_Coverage, 23055,
     /* 197837 */   GIR_EraseRootFromParent_Done,
     /* 197838 */ // Label 4457: @197838
     /* 197838 */ GIM_Reject,
     /* 197839 */ // Label 4398: @197839
     /* 197839 */ GIM_Reject,
     /* 197840 */ // Label 61: @197840
     /* 197840 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4470*/ GIMT_Encode4(199821),
     /* 197851 */ /*GILLT_v2s64*//*Label 4458*/ GIMT_Encode4(197919), GIMT_Encode4(0),
     /* 197859 */ /*GILLT_v4s32*//*Label 4459*/ GIMT_Encode4(198121),
     /* 197863 */ /*GILLT_v4s64*//*Label 4460*/ GIMT_Encode4(198323), GIMT_Encode4(0),
     /* 197871 */ /*GILLT_v8s16*//*Label 4461*/ GIMT_Encode4(198525),
     /* 197875 */ /*GILLT_v8s32*//*Label 4462*/ GIMT_Encode4(198640),
     /* 197879 */ /*GILLT_v8s64*//*Label 4463*/ GIMT_Encode4(198842), GIMT_Encode4(0),
     /* 197887 */ /*GILLT_v16s8*//*Label 4464*/ GIMT_Encode4(199044),
     /* 197891 */ /*GILLT_v16s16*//*Label 4465*/ GIMT_Encode4(199159),
     /* 197895 */ /*GILLT_v16s32*//*Label 4466*/ GIMT_Encode4(199274), GIMT_Encode4(0),
     /* 197903 */ /*GILLT_v32s8*//*Label 4467*/ GIMT_Encode4(199476),
     /* 197907 */ /*GILLT_v32s16*//*Label 4468*/ GIMT_Encode4(199591), GIMT_Encode4(0),
     /* 197915 */ /*GILLT_v64s8*//*Label 4469*/ GIMT_Encode4(199706),
     /* 197919 */ // Label 4458: @197919
     /* 197919 */ GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(198120),
     /* 197924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 197927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 197930 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 197945 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(197978), // Rule ID 21695 //
     /* 197950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197957 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 197963 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 197965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197967 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2i64] })  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 197967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 197970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197972 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197974 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197976 */     GIR_RootConstrainSelectedInstOperands,
     /* 197977 */     // GIR_Coverage, 21695,
     /* 197977 */     GIR_EraseRootFromParent_Done,
     /* 197978 */   // Label 4472: @197978
     /* 197978 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(198011), // Rule ID 21731 //
     /* 197983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197990 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 197996 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 197998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198000 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2f64] })  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 198000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 198003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198005 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198009 */     GIR_RootConstrainSelectedInstOperands,
     /* 198010 */     // GIR_Coverage, 21731,
     /* 198010 */     GIR_EraseRootFromParent_Done,
     /* 198011 */   // Label 4473: @198011
     /* 198011 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(198040), // Rule ID 21694 //
     /* 198016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198029 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2i64] }))  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 198029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 198032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198034 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198036 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198038 */     GIR_RootConstrainSelectedInstOperands,
     /* 198039 */     // GIR_Coverage, 21694,
     /* 198039 */     GIR_EraseRootFromParent_Done,
     /* 198040 */   // Label 4474: @198040
     /* 198040 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(198069), // Rule ID 21730 //
     /* 198045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198058 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2f64] }))  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 198058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 198061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198063 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198065 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198067 */     GIR_RootConstrainSelectedInstOperands,
     /* 198068 */     // GIR_Coverage, 21730,
     /* 198068 */     GIR_EraseRootFromParent_Done,
     /* 198069 */   // Label 4475: @198069
     /* 198069 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(198094), // Rule ID 21696 //
     /* 198074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198081 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$passthru)  =>  (VPCOMPRESSQZ128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 198081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrk),
     /* 198084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198086 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198088 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198090 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198092 */     GIR_RootConstrainSelectedInstOperands,
     /* 198093 */     // GIR_Coverage, 21696,
     /* 198093 */     GIR_EraseRootFromParent_Done,
     /* 198094 */   // Label 4476: @198094
     /* 198094 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(198119), // Rule ID 21732 //
     /* 198099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198106 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$passthru)  =>  (VCOMPRESSPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 198106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrk),
     /* 198109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198111 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198113 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198115 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198117 */     GIR_RootConstrainSelectedInstOperands,
     /* 198118 */     // GIR_Coverage, 21732,
     /* 198118 */     GIR_EraseRootFromParent_Done,
     /* 198119 */   // Label 4477: @198119
     /* 198119 */   GIM_Reject,
     /* 198120 */ // Label 4471: @198120
     /* 198120 */ GIM_Reject,
     /* 198121 */ // Label 4459: @198121
     /* 198121 */ GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(198322),
     /* 198126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 198132 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 198147 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(198180), // Rule ID 21677 //
     /* 198152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198159 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198165 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198169 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i32] })  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 198169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 198172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198174 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198176 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198178 */     GIR_RootConstrainSelectedInstOperands,
     /* 198179 */     // GIR_Coverage, 21677,
     /* 198179 */     GIR_EraseRootFromParent_Done,
     /* 198180 */   // Label 4479: @198180
     /* 198180 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(198213), // Rule ID 21713 //
     /* 198185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198192 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198198 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198202 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f32] })  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 198202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 198205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198207 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198209 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198211 */     GIR_RootConstrainSelectedInstOperands,
     /* 198212 */     // GIR_Coverage, 21713,
     /* 198212 */     GIR_EraseRootFromParent_Done,
     /* 198213 */   // Label 4480: @198213
     /* 198213 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(198242), // Rule ID 21676 //
     /* 198218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198231 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i32] }))  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 198231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 198234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198236 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198238 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198240 */     GIR_RootConstrainSelectedInstOperands,
     /* 198241 */     // GIR_Coverage, 21676,
     /* 198241 */     GIR_EraseRootFromParent_Done,
     /* 198242 */   // Label 4481: @198242
     /* 198242 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(198271), // Rule ID 21712 //
     /* 198247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198260 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f32] }))  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 198260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 198263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198265 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198267 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198269 */     GIR_RootConstrainSelectedInstOperands,
     /* 198270 */     // GIR_Coverage, 21712,
     /* 198270 */     GIR_EraseRootFromParent_Done,
     /* 198271 */   // Label 4482: @198271
     /* 198271 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(198296), // Rule ID 21678 //
     /* 198276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198283 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$passthru)  =>  (VPCOMPRESSDZ128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 198283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrk),
     /* 198286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198288 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198290 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198292 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198294 */     GIR_RootConstrainSelectedInstOperands,
     /* 198295 */     // GIR_Coverage, 21678,
     /* 198295 */     GIR_EraseRootFromParent_Done,
     /* 198296 */   // Label 4483: @198296
     /* 198296 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(198321), // Rule ID 21714 //
     /* 198301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198308 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$passthru)  =>  (VCOMPRESSPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 198308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrk),
     /* 198311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198313 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198315 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198317 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198319 */     GIR_RootConstrainSelectedInstOperands,
     /* 198320 */     // GIR_Coverage, 21714,
     /* 198320 */     GIR_EraseRootFromParent_Done,
     /* 198321 */   // Label 4484: @198321
     /* 198321 */   GIM_Reject,
     /* 198322 */ // Label 4478: @198322
     /* 198322 */ GIM_Reject,
     /* 198323 */ // Label 4460: @198323
     /* 198323 */ GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(198524),
     /* 198328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 198331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 198334 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 198337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 198349 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(198382), // Rule ID 21689 //
     /* 198354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198361 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198367 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198371 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i64] })  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 198371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 198374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198376 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198380 */     GIR_RootConstrainSelectedInstOperands,
     /* 198381 */     // GIR_Coverage, 21689,
     /* 198381 */     GIR_EraseRootFromParent_Done,
     /* 198382 */   // Label 4486: @198382
     /* 198382 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(198415), // Rule ID 21725 //
     /* 198387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198394 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198400 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198404 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f64] })  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 198404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 198407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198409 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198411 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198413 */     GIR_RootConstrainSelectedInstOperands,
     /* 198414 */     // GIR_Coverage, 21725,
     /* 198414 */     GIR_EraseRootFromParent_Done,
     /* 198415 */   // Label 4487: @198415
     /* 198415 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(198444), // Rule ID 21688 //
     /* 198420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198433 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i64] }))  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 198433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 198436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198438 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198440 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198442 */     GIR_RootConstrainSelectedInstOperands,
     /* 198443 */     // GIR_Coverage, 21688,
     /* 198443 */     GIR_EraseRootFromParent_Done,
     /* 198444 */   // Label 4488: @198444
     /* 198444 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(198473), // Rule ID 21724 //
     /* 198449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198462 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f64] }))  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 198462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 198465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198467 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198471 */     GIR_RootConstrainSelectedInstOperands,
     /* 198472 */     // GIR_Coverage, 21724,
     /* 198472 */     GIR_EraseRootFromParent_Done,
     /* 198473 */   // Label 4489: @198473
     /* 198473 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(198498), // Rule ID 21690 //
     /* 198478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198485 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$passthru)  =>  (VPCOMPRESSQZ256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 198485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrk),
     /* 198488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198490 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198492 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198494 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198496 */     GIR_RootConstrainSelectedInstOperands,
     /* 198497 */     // GIR_Coverage, 21690,
     /* 198497 */     GIR_EraseRootFromParent_Done,
     /* 198498 */   // Label 4490: @198498
     /* 198498 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(198523), // Rule ID 21726 //
     /* 198503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198510 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$passthru)  =>  (VCOMPRESSPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 198510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrk),
     /* 198513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198515 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198517 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198521 */     GIR_RootConstrainSelectedInstOperands,
     /* 198522 */     // GIR_Coverage, 21726,
     /* 198522 */     GIR_EraseRootFromParent_Done,
     /* 198523 */   // Label 4491: @198523
     /* 198523 */   GIM_Reject,
     /* 198524 */ // Label 4485: @198524
     /* 198524 */ GIM_Reject,
     /* 198525 */ // Label 4461: @198525
     /* 198525 */ GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(198639),
     /* 198530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 198536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 198551 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(198584), // Rule ID 22097 //
     /* 198556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198563 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198569 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198573 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i16] })  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 198573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 198576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198578 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198580 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198582 */     GIR_RootConstrainSelectedInstOperands,
     /* 198583 */     // GIR_Coverage, 22097,
     /* 198583 */     GIR_EraseRootFromParent_Done,
     /* 198584 */   // Label 4493: @198584
     /* 198584 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(198613), // Rule ID 22096 //
     /* 198589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198602 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i16] }))  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 198602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 198605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198607 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198609 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198611 */     GIR_RootConstrainSelectedInstOperands,
     /* 198612 */     // GIR_Coverage, 22096,
     /* 198612 */     GIR_EraseRootFromParent_Done,
     /* 198613 */   // Label 4494: @198613
     /* 198613 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(198638), // Rule ID 22098 //
     /* 198618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198625 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$passthru)  =>  (VPCOMPRESSWZ128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 198625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrk),
     /* 198628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198630 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198632 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198634 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198636 */     GIR_RootConstrainSelectedInstOperands,
     /* 198637 */     // GIR_Coverage, 22098,
     /* 198637 */     GIR_EraseRootFromParent_Done,
     /* 198638 */   // Label 4495: @198638
     /* 198638 */   GIM_Reject,
     /* 198639 */ // Label 4492: @198639
     /* 198639 */ GIM_Reject,
     /* 198640 */ // Label 4462: @198640
     /* 198640 */ GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(198841),
     /* 198645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 198648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 198651 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 198654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 198666 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(198699), // Rule ID 21671 //
     /* 198671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198678 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198684 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198688 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i32] })  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 198688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 198691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198693 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198697 */     GIR_RootConstrainSelectedInstOperands,
     /* 198698 */     // GIR_Coverage, 21671,
     /* 198698 */     GIR_EraseRootFromParent_Done,
     /* 198699 */   // Label 4497: @198699
     /* 198699 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(198732), // Rule ID 21707 //
     /* 198704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198721 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f32] })  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 198721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 198724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198726 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198728 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198730 */     GIR_RootConstrainSelectedInstOperands,
     /* 198731 */     // GIR_Coverage, 21707,
     /* 198731 */     GIR_EraseRootFromParent_Done,
     /* 198732 */   // Label 4498: @198732
     /* 198732 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(198761), // Rule ID 21670 //
     /* 198737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198750 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i32] }))  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 198750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 198753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198755 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198757 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198759 */     GIR_RootConstrainSelectedInstOperands,
     /* 198760 */     // GIR_Coverage, 21670,
     /* 198760 */     GIR_EraseRootFromParent_Done,
     /* 198761 */   // Label 4499: @198761
     /* 198761 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(198790), // Rule ID 21706 //
     /* 198766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198779 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f32] }))  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 198779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 198782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198784 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198786 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198788 */     GIR_RootConstrainSelectedInstOperands,
     /* 198789 */     // GIR_Coverage, 21706,
     /* 198789 */     GIR_EraseRootFromParent_Done,
     /* 198790 */   // Label 4500: @198790
     /* 198790 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(198815), // Rule ID 21672 //
     /* 198795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198802 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$passthru)  =>  (VPCOMPRESSDZ256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 198802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrk),
     /* 198805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198807 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198809 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198813 */     GIR_RootConstrainSelectedInstOperands,
     /* 198814 */     // GIR_Coverage, 21672,
     /* 198814 */     GIR_EraseRootFromParent_Done,
     /* 198815 */   // Label 4501: @198815
     /* 198815 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(198840), // Rule ID 21708 //
     /* 198820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198827 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$passthru)  =>  (VCOMPRESSPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 198827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrk),
     /* 198830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198832 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198834 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198836 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198838 */     GIR_RootConstrainSelectedInstOperands,
     /* 198839 */     // GIR_Coverage, 21708,
     /* 198839 */     GIR_EraseRootFromParent_Done,
     /* 198840 */   // Label 4502: @198840
     /* 198840 */   GIM_Reject,
     /* 198841 */ // Label 4496: @198841
     /* 198841 */ GIM_Reject,
     /* 198842 */ // Label 4463: @198842
     /* 198842 */ GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(199043),
     /* 198847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 198853 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 198856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 198868 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(198901), // Rule ID 21683 //
     /* 198873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198880 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198886 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198890 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] })  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 198890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 198893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198895 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198897 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198899 */     GIR_RootConstrainSelectedInstOperands,
     /* 198900 */     // GIR_Coverage, 21683,
     /* 198900 */     GIR_EraseRootFromParent_Done,
     /* 198901 */   // Label 4504: @198901
     /* 198901 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(198934), // Rule ID 21719 //
     /* 198906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198913 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198919 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198923 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f64] })  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 198923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 198926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198928 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198930 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198932 */     GIR_RootConstrainSelectedInstOperands,
     /* 198933 */     // GIR_Coverage, 21719,
     /* 198933 */     GIR_EraseRootFromParent_Done,
     /* 198934 */   // Label 4505: @198934
     /* 198934 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(198963), // Rule ID 21682 //
     /* 198939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198952 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i64] }))  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 198952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 198955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198957 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198959 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198961 */     GIR_RootConstrainSelectedInstOperands,
     /* 198962 */     // GIR_Coverage, 21682,
     /* 198962 */     GIR_EraseRootFromParent_Done,
     /* 198963 */   // Label 4506: @198963
     /* 198963 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(198992), // Rule ID 21718 //
     /* 198968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198981 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f64] }))  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 198981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 198984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198986 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198988 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198990 */     GIR_RootConstrainSelectedInstOperands,
     /* 198991 */     // GIR_Coverage, 21718,
     /* 198991 */     GIR_EraseRootFromParent_Done,
     /* 198992 */   // Label 4507: @198992
     /* 198992 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(199017), // Rule ID 21684 //
     /* 198997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199004 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$passthru)  =>  (VPCOMPRESSQZrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 199004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrk),
     /* 199007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199009 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199011 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199013 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199015 */     GIR_RootConstrainSelectedInstOperands,
     /* 199016 */     // GIR_Coverage, 21684,
     /* 199016 */     GIR_EraseRootFromParent_Done,
     /* 199017 */   // Label 4508: @199017
     /* 199017 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(199042), // Rule ID 21720 //
     /* 199022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199029 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$passthru)  =>  (VCOMPRESSPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 199029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrk),
     /* 199032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199034 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199036 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199038 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199040 */     GIR_RootConstrainSelectedInstOperands,
     /* 199041 */     // GIR_Coverage, 21720,
     /* 199041 */     GIR_EraseRootFromParent_Done,
     /* 199042 */   // Label 4509: @199042
     /* 199042 */   GIM_Reject,
     /* 199043 */ // Label 4503: @199043
     /* 199043 */ GIM_Reject,
     /* 199044 */ // Label 4464: @199044
     /* 199044 */ GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(199158),
     /* 199049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 199052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 199055 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 199058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 199062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 199066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 199070 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(199103), // Rule ID 22079 //
     /* 199075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199082 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199088 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199092 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i8] })  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 199092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 199095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199097 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199101 */     GIR_RootConstrainSelectedInstOperands,
     /* 199102 */     // GIR_Coverage, 22079,
     /* 199102 */     GIR_EraseRootFromParent_Done,
     /* 199103 */   // Label 4511: @199103
     /* 199103 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(199132), // Rule ID 22078 //
     /* 199108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199121 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i8] }))  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 199121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 199124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199126 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199128 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199130 */     GIR_RootConstrainSelectedInstOperands,
     /* 199131 */     // GIR_Coverage, 22078,
     /* 199131 */     GIR_EraseRootFromParent_Done,
     /* 199132 */   // Label 4512: @199132
     /* 199132 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(199157), // Rule ID 22080 //
     /* 199137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 199144 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$passthru)  =>  (VPCOMPRESSBZ128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 199144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrk),
     /* 199147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199149 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199151 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199153 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199155 */     GIR_RootConstrainSelectedInstOperands,
     /* 199156 */     // GIR_Coverage, 22080,
     /* 199156 */     GIR_EraseRootFromParent_Done,
     /* 199157 */   // Label 4513: @199157
     /* 199157 */   GIM_Reject,
     /* 199158 */ // Label 4510: @199158
     /* 199158 */ GIM_Reject,
     /* 199159 */ // Label 4465: @199159
     /* 199159 */ GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(199273),
     /* 199164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 199167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 199170 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 199173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 199185 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(199218), // Rule ID 22091 //
     /* 199190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199207 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i16] })  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 199207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 199210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199212 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199216 */     GIR_RootConstrainSelectedInstOperands,
     /* 199217 */     // GIR_Coverage, 22091,
     /* 199217 */     GIR_EraseRootFromParent_Done,
     /* 199218 */   // Label 4515: @199218
     /* 199218 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(199247), // Rule ID 22090 //
     /* 199223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199236 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i16] }))  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 199236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 199239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199241 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199245 */     GIR_RootConstrainSelectedInstOperands,
     /* 199246 */     // GIR_Coverage, 22090,
     /* 199246 */     GIR_EraseRootFromParent_Done,
     /* 199247 */   // Label 4516: @199247
     /* 199247 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(199272), // Rule ID 22092 //
     /* 199252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199259 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$passthru)  =>  (VPCOMPRESSWZ256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 199259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrk),
     /* 199262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199264 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199266 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199268 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199270 */     GIR_RootConstrainSelectedInstOperands,
     /* 199271 */     // GIR_Coverage, 22092,
     /* 199271 */     GIR_EraseRootFromParent_Done,
     /* 199272 */   // Label 4517: @199272
     /* 199272 */   GIM_Reject,
     /* 199273 */ // Label 4514: @199273
     /* 199273 */ GIM_Reject,
     /* 199274 */ // Label 4466: @199274
     /* 199274 */ GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(199475),
     /* 199279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 199285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 199288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 199300 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(199333), // Rule ID 21665 //
     /* 199305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199312 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199318 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199322 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] })  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 199322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 199325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199327 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199329 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199331 */     GIR_RootConstrainSelectedInstOperands,
     /* 199332 */     // GIR_Coverage, 21665,
     /* 199332 */     GIR_EraseRootFromParent_Done,
     /* 199333 */   // Label 4519: @199333
     /* 199333 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(199366), // Rule ID 21701 //
     /* 199338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199345 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199351 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199355 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16f32] })  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 199355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 199358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199360 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199362 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199364 */     GIR_RootConstrainSelectedInstOperands,
     /* 199365 */     // GIR_Coverage, 21701,
     /* 199365 */     GIR_EraseRootFromParent_Done,
     /* 199366 */   // Label 4520: @199366
     /* 199366 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(199395), // Rule ID 21664 //
     /* 199371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199384 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i32] }))  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 199384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 199387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199389 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199393 */     GIR_RootConstrainSelectedInstOperands,
     /* 199394 */     // GIR_Coverage, 21664,
     /* 199394 */     GIR_EraseRootFromParent_Done,
     /* 199395 */   // Label 4521: @199395
     /* 199395 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(199424), // Rule ID 21700 //
     /* 199400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199413 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16f32] }))  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 199413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 199416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199418 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199422 */     GIR_RootConstrainSelectedInstOperands,
     /* 199423 */     // GIR_Coverage, 21700,
     /* 199423 */     GIR_EraseRootFromParent_Done,
     /* 199424 */   // Label 4522: @199424
     /* 199424 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(199449), // Rule ID 21666 //
     /* 199429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199436 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$passthru)  =>  (VPCOMPRESSDZrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 199436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrk),
     /* 199439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199441 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199443 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199445 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199447 */     GIR_RootConstrainSelectedInstOperands,
     /* 199448 */     // GIR_Coverage, 21666,
     /* 199448 */     GIR_EraseRootFromParent_Done,
     /* 199449 */   // Label 4523: @199449
     /* 199449 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(199474), // Rule ID 21702 //
     /* 199454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 199457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199461 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$passthru)  =>  (VCOMPRESSPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 199461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrk),
     /* 199464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199466 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199468 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199472 */     GIR_RootConstrainSelectedInstOperands,
     /* 199473 */     // GIR_Coverage, 21702,
     /* 199473 */     GIR_EraseRootFromParent_Done,
     /* 199474 */   // Label 4524: @199474
     /* 199474 */   GIM_Reject,
     /* 199475 */ // Label 4518: @199475
     /* 199475 */ GIM_Reject,
     /* 199476 */ // Label 4467: @199476
     /* 199476 */ GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(199590),
     /* 199481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 199484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 199487 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 199490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 199502 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(199535), // Rule ID 22073 //
     /* 199507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199514 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199520 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199524 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i8] })  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 199524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 199527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199529 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199533 */     GIR_RootConstrainSelectedInstOperands,
     /* 199534 */     // GIR_Coverage, 22073,
     /* 199534 */     GIR_EraseRootFromParent_Done,
     /* 199535 */   // Label 4526: @199535
     /* 199535 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(199564), // Rule ID 22072 //
     /* 199540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199553 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i8] }))  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 199553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 199556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199558 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199560 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199562 */     GIR_RootConstrainSelectedInstOperands,
     /* 199563 */     // GIR_Coverage, 22072,
     /* 199563 */     GIR_EraseRootFromParent_Done,
     /* 199564 */   // Label 4527: @199564
     /* 199564 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(199589), // Rule ID 22074 //
     /* 199569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 199572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199576 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$passthru)  =>  (VPCOMPRESSBZ256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 199576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrk),
     /* 199579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199581 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199583 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199585 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199587 */     GIR_RootConstrainSelectedInstOperands,
     /* 199588 */     // GIR_Coverage, 22074,
     /* 199588 */     GIR_EraseRootFromParent_Done,
     /* 199589 */   // Label 4528: @199589
     /* 199589 */   GIM_Reject,
     /* 199590 */ // Label 4525: @199590
     /* 199590 */ GIM_Reject,
     /* 199591 */ // Label 4468: @199591
     /* 199591 */ GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(199705),
     /* 199596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 199599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 199602 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 199605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 199617 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(199650), // Rule ID 22085 //
     /* 199622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199629 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199635 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199639 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i16] })  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 199639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 199642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199644 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199648 */     GIR_RootConstrainSelectedInstOperands,
     /* 199649 */     // GIR_Coverage, 22085,
     /* 199649 */     GIR_EraseRootFromParent_Done,
     /* 199650 */   // Label 4530: @199650
     /* 199650 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(199679), // Rule ID 22084 //
     /* 199655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199668 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i16] }))  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 199668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 199671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199673 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199677 */     GIR_RootConstrainSelectedInstOperands,
     /* 199678 */     // GIR_Coverage, 22084,
     /* 199678 */     GIR_EraseRootFromParent_Done,
     /* 199679 */   // Label 4531: @199679
     /* 199679 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(199704), // Rule ID 22086 //
     /* 199684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199691 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$passthru)  =>  (VPCOMPRESSWZrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 199691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrk),
     /* 199694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199696 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199698 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199700 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199702 */     GIR_RootConstrainSelectedInstOperands,
     /* 199703 */     // GIR_Coverage, 22086,
     /* 199703 */     GIR_EraseRootFromParent_Done,
     /* 199704 */   // Label 4532: @199704
     /* 199704 */   GIM_Reject,
     /* 199705 */ // Label 4529: @199705
     /* 199705 */ GIM_Reject,
     /* 199706 */ // Label 4469: @199706
     /* 199706 */ GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(199820),
     /* 199711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 199714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 199717 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 199720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 199732 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(199765), // Rule ID 22067 //
     /* 199737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199744 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199750 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199754 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, immAllZerosV:{ *:[v64i8] })  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 199754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 199757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199759 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199761 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199763 */     GIR_RootConstrainSelectedInstOperands,
     /* 199764 */     // GIR_Coverage, 22067,
     /* 199764 */     GIR_EraseRootFromParent_Done,
     /* 199765 */   // Label 4534: @199765
     /* 199765 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(199794), // Rule ID 22066 //
     /* 199770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199783 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, (undef:{ *:[v64i8] }))  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 199783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 199786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199788 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199790 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199792 */     GIR_RootConstrainSelectedInstOperands,
     /* 199793 */     // GIR_Coverage, 22066,
     /* 199793 */     GIR_EraseRootFromParent_Done,
     /* 199794 */   // Label 4535: @199794
     /* 199794 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(199819), // Rule ID 22068 //
     /* 199799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199806 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$passthru)  =>  (VPCOMPRESSBZrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$passthru, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 199806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrk),
     /* 199809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199811 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199813 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199815 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199817 */     GIR_RootConstrainSelectedInstOperands,
     /* 199818 */     // GIR_Coverage, 22068,
     /* 199818 */     GIR_EraseRootFromParent_Done,
     /* 199819 */   // Label 4536: @199819
     /* 199819 */   GIM_Reject,
     /* 199820 */ // Label 4533: @199820
     /* 199820 */ GIM_Reject,
     /* 199821 */ // Label 4470: @199821
     /* 199821 */ GIM_Reject,
     /* 199822 */ // Label 62: @199822
     /* 199822 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4540*/ GIMT_Encode4(200127),
     /* 199833 */ /*GILLT_s16*//*Label 4537*/ GIMT_Encode4(199845),
     /* 199837 */ /*GILLT_s32*//*Label 4538*/ GIMT_Encode4(199939),
     /* 199841 */ /*GILLT_s64*//*Label 4539*/ GIMT_Encode4(200033),
     /* 199845 */ // Label 4537: @199845
     /* 199845 */ GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(199938),
     /* 199850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 199853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 199857 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(199912), // Rule ID 77 //
     /* 199862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 199865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 199869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 199873 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 199876 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 199880 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 199884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 199893 */     // (cttz:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (TZCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 199893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT16rm),
     /* 199896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199898 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 199902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 199905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 199910 */     GIR_RootConstrainSelectedInstOperands,
     /* 199911 */     // GIR_Coverage, 77,
     /* 199911 */     GIR_EraseRootFromParent_Done,
     /* 199912 */   // Label 4542: @199912
     /* 199912 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(199937), // Rule ID 76 //
     /* 199917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 199920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 199924 */     // (cttz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (TZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 199924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT16rr),
     /* 199929 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 199935 */     GIR_RootConstrainSelectedInstOperands,
     /* 199936 */     // GIR_Coverage, 76,
     /* 199936 */     GIR_Done,
     /* 199937 */   // Label 4543: @199937
     /* 199937 */   GIM_Reject,
     /* 199938 */ // Label 4541: @199938
     /* 199938 */ GIM_Reject,
     /* 199939 */ // Label 4538: @199939
     /* 199939 */ GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(200032),
     /* 199944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 199947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 199951 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(200006), // Rule ID 79 //
     /* 199956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 199959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 199963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 199967 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 199970 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 199974 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 199978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 199987 */     // (cttz:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (TZCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 199987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT32rm),
     /* 199990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 199996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 199999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200004 */     GIR_RootConstrainSelectedInstOperands,
     /* 200005 */     // GIR_Coverage, 79,
     /* 200005 */     GIR_EraseRootFromParent_Done,
     /* 200006 */   // Label 4545: @200006
     /* 200006 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(200031), // Rule ID 78 //
     /* 200011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 200014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 200018 */     // (cttz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (TZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 200018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT32rr),
     /* 200023 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200029 */     GIR_RootConstrainSelectedInstOperands,
     /* 200030 */     // GIR_Coverage, 78,
     /* 200030 */     GIR_Done,
     /* 200031 */   // Label 4546: @200031
     /* 200031 */   GIM_Reject,
     /* 200032 */ // Label 4544: @200032
     /* 200032 */ GIM_Reject,
     /* 200033 */ // Label 4539: @200033
     /* 200033 */ GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(200126),
     /* 200038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 200041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200045 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(200100), // Rule ID 81 //
     /* 200050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 200053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200061 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200064 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200068 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200081 */     // (cttz:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (TZCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 200081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT64rm),
     /* 200084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200098 */     GIR_RootConstrainSelectedInstOperands,
     /* 200099 */     // GIR_Coverage, 81,
     /* 200099 */     GIR_EraseRootFromParent_Done,
     /* 200100 */   // Label 4548: @200100
     /* 200100 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(200125), // Rule ID 80 //
     /* 200105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 200108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200112 */     // (cttz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (TZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 200112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT64rr),
     /* 200117 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200123 */     GIR_RootConstrainSelectedInstOperands,
     /* 200124 */     // GIR_Coverage, 80,
     /* 200124 */     GIR_Done,
     /* 200125 */   // Label 4549: @200125
     /* 200125 */   GIM_Reject,
     /* 200126 */ // Label 4547: @200126
     /* 200126 */ GIM_Reject,
     /* 200127 */ // Label 4540: @200127
     /* 200127 */ GIM_Reject,
     /* 200128 */ // Label 63: @200128
     /* 200128 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4553*/ GIMT_Encode4(200514),
     /* 200139 */ /*GILLT_s16*//*Label 4550*/ GIMT_Encode4(200151),
     /* 200143 */ /*GILLT_s32*//*Label 4551*/ GIMT_Encode4(200272),
     /* 200147 */ /*GILLT_s64*//*Label 4552*/ GIMT_Encode4(200393),
     /* 200151 */ // Label 4550: @200151
     /* 200151 */ GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(200271),
     /* 200156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 200159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 200163 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(200232), // Rule ID 22982 //
     /* 200168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200176 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200179 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200183 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 200187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200196 */     // (cttz_zero_undef:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (BSF16rm:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), addr:{ *:[iPTR] }:$src)
     /* 200196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 200199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rm),
     /* 200213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200218 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 200222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200230 */     GIR_RootConstrainSelectedInstOperands,
     /* 200231 */     // GIR_Coverage, 22982,
     /* 200231 */     GIR_EraseRootFromParent_Done,
     /* 200232 */   // Label 4555: @200232
     /* 200232 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(200270), // Rule ID 22979 //
     /* 200237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 200241 */     // (cttz_zero_undef:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (BSF16rr:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), GR16:{ *:[i16] }:$src)
     /* 200241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 200244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rr),
     /* 200258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200263 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200268 */     GIR_RootConstrainSelectedInstOperands,
     /* 200269 */     // GIR_Coverage, 22979,
     /* 200269 */     GIR_EraseRootFromParent_Done,
     /* 200270 */   // Label 4556: @200270
     /* 200270 */   GIM_Reject,
     /* 200271 */ // Label 4554: @200271
     /* 200271 */ GIM_Reject,
     /* 200272 */ // Label 4551: @200272
     /* 200272 */ GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(200392),
     /* 200277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 200280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 200284 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(200353), // Rule ID 22983 //
     /* 200289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200297 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200300 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200304 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 200308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200310 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200317 */     // (cttz_zero_undef:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (BSF32rm:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), addr:{ *:[iPTR] }:$src)
     /* 200317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 200320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rm),
     /* 200334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 200343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200351 */     GIR_RootConstrainSelectedInstOperands,
     /* 200352 */     // GIR_Coverage, 22983,
     /* 200352 */     GIR_EraseRootFromParent_Done,
     /* 200353 */   // Label 4558: @200353
     /* 200353 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(200391), // Rule ID 22980 //
     /* 200358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 200362 */     // (cttz_zero_undef:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSF32rr:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR32:{ *:[i32] }:$src)
     /* 200362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 200365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rr),
     /* 200379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200384 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200389 */     GIR_RootConstrainSelectedInstOperands,
     /* 200390 */     // GIR_Coverage, 22980,
     /* 200390 */     GIR_EraseRootFromParent_Done,
     /* 200391 */   // Label 4559: @200391
     /* 200391 */   GIM_Reject,
     /* 200392 */ // Label 4557: @200392
     /* 200392 */ GIM_Reject,
     /* 200393 */ // Label 4552: @200393
     /* 200393 */ GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(200513),
     /* 200398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 200401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200405 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(200474), // Rule ID 22984 //
     /* 200410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200418 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200421 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200425 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200438 */     // (cttz_zero_undef:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (BSF64rm:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), addr:{ *:[iPTR] }:$src)
     /* 200438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 200441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rm),
     /* 200455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200460 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 200464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200472 */     GIR_RootConstrainSelectedInstOperands,
     /* 200473 */     // GIR_Coverage, 22984,
     /* 200473 */     GIR_EraseRootFromParent_Done,
     /* 200474 */   // Label 4561: @200474
     /* 200474 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(200512), // Rule ID 22981 //
     /* 200479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200483 */     // (cttz_zero_undef:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSF64rr:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), GR64:{ *:[i64] }:$src)
     /* 200483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 200486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rr),
     /* 200500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200505 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200510 */     GIR_RootConstrainSelectedInstOperands,
     /* 200511 */     // GIR_Coverage, 22981,
     /* 200511 */     GIR_EraseRootFromParent_Done,
     /* 200512 */   // Label 4562: @200512
     /* 200512 */   GIM_Reject,
     /* 200513 */ // Label 4560: @200513
     /* 200513 */ GIM_Reject,
     /* 200514 */ // Label 4553: @200514
     /* 200514 */ GIM_Reject,
     /* 200515 */ // Label 64: @200515
     /* 200515 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(20), /*)*//*default:*//*Label 4572*/ GIMT_Encode4(201818),
     /* 200526 */ /*GILLT_s16*//*Label 4563*/ GIMT_Encode4(200598),
     /* 200530 */ /*GILLT_s32*//*Label 4564*/ GIMT_Encode4(200692),
     /* 200534 */ /*GILLT_s64*//*Label 4565*/ GIMT_Encode4(200786), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 200550 */ /*GILLT_v2s64*//*Label 4566*/ GIMT_Encode4(200880), GIMT_Encode4(0),
     /* 200558 */ /*GILLT_v4s32*//*Label 4567*/ GIMT_Encode4(201076),
     /* 200562 */ /*GILLT_v4s64*//*Label 4568*/ GIMT_Encode4(201272), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 200574 */ /*GILLT_v8s32*//*Label 4569*/ GIMT_Encode4(201460),
     /* 200578 */ /*GILLT_v8s64*//*Label 4570*/ GIMT_Encode4(201648), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 200594 */ /*GILLT_v16s32*//*Label 4571*/ GIMT_Encode4(201733),
     /* 200598 */ // Label 4563: @200598
     /* 200598 */ GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(200691),
     /* 200603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 200606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 200610 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(200665), // Rule ID 71 //
     /* 200615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200626 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200629 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200633 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 200637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200646 */     // (ctlz:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (LZCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 200646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT16rm),
     /* 200649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200663 */     GIR_RootConstrainSelectedInstOperands,
     /* 200664 */     // GIR_Coverage, 71,
     /* 200664 */     GIR_EraseRootFromParent_Done,
     /* 200665 */   // Label 4574: @200665
     /* 200665 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(200690), // Rule ID 70 //
     /* 200670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 200677 */     // (ctlz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (LZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 200677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT16rr),
     /* 200682 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200688 */     GIR_RootConstrainSelectedInstOperands,
     /* 200689 */     // GIR_Coverage, 70,
     /* 200689 */     GIR_Done,
     /* 200690 */   // Label 4575: @200690
     /* 200690 */   GIM_Reject,
     /* 200691 */ // Label 4573: @200691
     /* 200691 */ GIM_Reject,
     /* 200692 */ // Label 4564: @200692
     /* 200692 */ GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(200785),
     /* 200697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 200700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 200704 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(200759), // Rule ID 73 //
     /* 200709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200720 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200723 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200727 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 200731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200740 */     // (ctlz:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (LZCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 200740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT32rm),
     /* 200743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200757 */     GIR_RootConstrainSelectedInstOperands,
     /* 200758 */     // GIR_Coverage, 73,
     /* 200758 */     GIR_EraseRootFromParent_Done,
     /* 200759 */   // Label 4577: @200759
     /* 200759 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(200784), // Rule ID 72 //
     /* 200764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 200771 */     // (ctlz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (LZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 200771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT32rr),
     /* 200776 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200782 */     GIR_RootConstrainSelectedInstOperands,
     /* 200783 */     // GIR_Coverage, 72,
     /* 200783 */     GIR_Done,
     /* 200784 */   // Label 4578: @200784
     /* 200784 */   GIM_Reject,
     /* 200785 */ // Label 4576: @200785
     /* 200785 */ GIM_Reject,
     /* 200786 */ // Label 4565: @200786
     /* 200786 */ GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(200879),
     /* 200791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 200794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200798 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(200853), // Rule ID 75 //
     /* 200803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200814 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200817 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200821 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200834 */     // (ctlz:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LZCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 200834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT64rm),
     /* 200837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200851 */     GIR_RootConstrainSelectedInstOperands,
     /* 200852 */     // GIR_Coverage, 75,
     /* 200852 */     GIR_EraseRootFromParent_Done,
     /* 200853 */   // Label 4580: @200853
     /* 200853 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(200878), // Rule ID 74 //
     /* 200858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200865 */     // (ctlz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (LZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 200865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT64rr),
     /* 200870 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200876 */     GIR_RootConstrainSelectedInstOperands,
     /* 200877 */     // GIR_Coverage, 74,
     /* 200877 */     GIR_Done,
     /* 200878 */   // Label 4581: @200878
     /* 200878 */   GIM_Reject,
     /* 200879 */ // Label 4579: @200879
     /* 200879 */ GIM_Reject,
     /* 200880 */ // Label 4566: @200880
     /* 200880 */ GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(201075),
     /* 200885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200888 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(200944), // Rule ID 13356 //
     /* 200893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 200896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200908 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200911 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200915 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200928 */     // (ctlz:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 200928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rm),
     /* 200931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200933 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200942 */     GIR_RootConstrainSelectedInstOperands,
     /* 200943 */     // GIR_Coverage, 13356,
     /* 200943 */     GIR_EraseRootFromParent_Done,
     /* 200944 */   // Label 4583: @200944
     /* 200944 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(200967), // Rule ID 13353 //
     /* 200949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 200952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200960 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPLZCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 200960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rr),
     /* 200965 */     GIR_RootConstrainSelectedInstOperands,
     /* 200966 */     // GIR_Coverage, 13353,
     /* 200966 */     GIR_Done,
     /* 200967 */   // Label 4584: @200967
     /* 200967 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(201074), // Rule ID 21825 //
     /* 200972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 200975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200983 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 200983 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 200986 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200990 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 200997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 201000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201009 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 201012 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 201016 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 201019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 201024 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201029 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 201034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 201037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 201041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201046 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 201049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 201051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201056 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 201063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 201068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201073 */     // GIR_Coverage, 21825,
     /* 201073 */     GIR_EraseRootFromParent_Done,
     /* 201074 */   // Label 4585: @201074
     /* 201074 */   GIM_Reject,
     /* 201075 */ // Label 4582: @201075
     /* 201075 */ GIM_Reject,
     /* 201076 */ // Label 4567: @201076
     /* 201076 */ GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(201271),
     /* 201081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201084 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(201140), // Rule ID 13383 //
     /* 201089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 201092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201124 */     // (ctlz:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 201124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rm),
     /* 201127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201129 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201138 */     GIR_RootConstrainSelectedInstOperands,
     /* 201139 */     // GIR_Coverage, 13383,
     /* 201139 */     GIR_EraseRootFromParent_Done,
     /* 201140 */   // Label 4587: @201140
     /* 201140 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(201163), // Rule ID 13380 //
     /* 201145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 201148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201156 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPLZCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 201156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rr),
     /* 201161 */     GIR_RootConstrainSelectedInstOperands,
     /* 201162 */     // GIR_Coverage, 13380,
     /* 201162 */     GIR_Done,
     /* 201163 */   // Label 4588: @201163
     /* 201163 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(201270), // Rule ID 21827 //
     /* 201168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 201171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 201175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201179 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 201179 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 201182 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201186 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 201193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 201196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201205 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 201208 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 201212 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 201215 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 201220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 201230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 201233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 201237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201242 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 201245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 201247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201252 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 201259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 201264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201269 */     // GIR_Coverage, 21827,
     /* 201269 */     GIR_EraseRootFromParent_Done,
     /* 201270 */   // Label 4589: @201270
     /* 201270 */   GIM_Reject,
     /* 201271 */ // Label 4586: @201271
     /* 201271 */ GIM_Reject,
     /* 201272 */ // Label 4568: @201272
     /* 201272 */ GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(201459),
     /* 201277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 201280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201284 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(201336), // Rule ID 13347 //
     /* 201289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 201292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201320 */     // (ctlz:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 201320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rm),
     /* 201323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201325 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201334 */     GIR_RootConstrainSelectedInstOperands,
     /* 201335 */     // GIR_Coverage, 13347,
     /* 201335 */     GIR_EraseRootFromParent_Done,
     /* 201336 */   // Label 4591: @201336
     /* 201336 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(201355), // Rule ID 13344 //
     /* 201341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 201344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201348 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPLZCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 201348 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rr),
     /* 201353 */     GIR_RootConstrainSelectedInstOperands,
     /* 201354 */     // GIR_Coverage, 13344,
     /* 201354 */     GIR_Done,
     /* 201355 */   // Label 4592: @201355
     /* 201355 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(201458), // Rule ID 21824 //
     /* 201360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 201363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201367 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 201367 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 201370 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201374 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 201381 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 201384 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201388 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201393 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 201396 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 201400 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 201403 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 201408 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201413 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 201421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 201425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201430 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 201433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 201435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201440 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 201447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201457 */     // GIR_Coverage, 21824,
     /* 201457 */     GIR_EraseRootFromParent_Done,
     /* 201458 */   // Label 4593: @201458
     /* 201458 */   GIM_Reject,
     /* 201459 */ // Label 4590: @201459
     /* 201459 */ GIM_Reject,
     /* 201460 */ // Label 4569: @201460
     /* 201460 */ GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(201647),
     /* 201465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 201468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201472 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(201524), // Rule ID 13374 //
     /* 201477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 201480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201508 */     // (ctlz:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 201508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rm),
     /* 201511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201522 */     GIR_RootConstrainSelectedInstOperands,
     /* 201523 */     // GIR_Coverage, 13374,
     /* 201523 */     GIR_EraseRootFromParent_Done,
     /* 201524 */   // Label 4595: @201524
     /* 201524 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(201543), // Rule ID 13371 //
     /* 201529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 201532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201536 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPLZCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 201536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rr),
     /* 201541 */     GIR_RootConstrainSelectedInstOperands,
     /* 201542 */     // GIR_Coverage, 13371,
     /* 201542 */     GIR_Done,
     /* 201543 */   // Label 4596: @201543
     /* 201543 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(201646), // Rule ID 21826 //
     /* 201548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 201551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201555 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 201555 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 201558 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201562 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 201569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 201572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201581 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 201584 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 201588 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 201591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 201596 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 201609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 201613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 201621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 201623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201628 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 201635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201645 */     // GIR_Coverage, 21826,
     /* 201645 */     GIR_EraseRootFromParent_Done,
     /* 201646 */   // Label 4597: @201646
     /* 201646 */   GIM_Reject,
     /* 201647 */ // Label 4594: @201647
     /* 201647 */ GIM_Reject,
     /* 201648 */ // Label 4570: @201648
     /* 201648 */ GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(201732),
     /* 201653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 201656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201660 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(201712), // Rule ID 13338 //
     /* 201665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 201668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201676 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201679 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201696 */     // (ctlz:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 201696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrm),
     /* 201699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201710 */     GIR_RootConstrainSelectedInstOperands,
     /* 201711 */     // GIR_Coverage, 13338,
     /* 201711 */     GIR_EraseRootFromParent_Done,
     /* 201712 */   // Label 4599: @201712
     /* 201712 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(201731), // Rule ID 13335 //
     /* 201717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 201720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201724 */     // (ctlz:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPLZCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 201724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 201729 */     GIR_RootConstrainSelectedInstOperands,
     /* 201730 */     // GIR_Coverage, 13335,
     /* 201730 */     GIR_Done,
     /* 201731 */   // Label 4600: @201731
     /* 201731 */   GIM_Reject,
     /* 201732 */ // Label 4598: @201732
     /* 201732 */ GIM_Reject,
     /* 201733 */ // Label 4571: @201733
     /* 201733 */ GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(201817),
     /* 201738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 201741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201745 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(201797), // Rule ID 13365 //
     /* 201750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 201753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201781 */     // (ctlz:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 201781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrm),
     /* 201784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201786 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201795 */     GIR_RootConstrainSelectedInstOperands,
     /* 201796 */     // GIR_Coverage, 13365,
     /* 201796 */     GIR_EraseRootFromParent_Done,
     /* 201797 */   // Label 4602: @201797
     /* 201797 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(201816), // Rule ID 13362 //
     /* 201802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 201805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201809 */     // (ctlz:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPLZCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 201809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 201814 */     GIR_RootConstrainSelectedInstOperands,
     /* 201815 */     // GIR_Coverage, 13362,
     /* 201815 */     GIR_Done,
     /* 201816 */   // Label 4603: @201816
     /* 201816 */   GIM_Reject,
     /* 201817 */ // Label 4601: @201817
     /* 201817 */ GIM_Reject,
     /* 201818 */ // Label 4572: @201818
     /* 201818 */ GIM_Reject,
     /* 201819 */ // Label 65: @201819
     /* 201819 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 4619*/ GIMT_Encode4(204080),
     /* 201830 */ /*GILLT_s16*//*Label 4604*/ GIMT_Encode4(201922),
     /* 201834 */ /*GILLT_s32*//*Label 4605*/ GIMT_Encode4(202016),
     /* 201838 */ /*GILLT_s64*//*Label 4606*/ GIMT_Encode4(202110), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 201854 */ /*GILLT_v2s64*//*Label 4607*/ GIMT_Encode4(202204), GIMT_Encode4(0),
     /* 201862 */ /*GILLT_v4s32*//*Label 4608*/ GIMT_Encode4(202400),
     /* 201866 */ /*GILLT_v4s64*//*Label 4609*/ GIMT_Encode4(202596), GIMT_Encode4(0),
     /* 201874 */ /*GILLT_v8s16*//*Label 4610*/ GIMT_Encode4(202784),
     /* 201878 */ /*GILLT_v8s32*//*Label 4611*/ GIMT_Encode4(202980),
     /* 201882 */ /*GILLT_v8s64*//*Label 4612*/ GIMT_Encode4(203168), GIMT_Encode4(0),
     /* 201890 */ /*GILLT_v16s8*//*Label 4613*/ GIMT_Encode4(203253),
     /* 201894 */ /*GILLT_v16s16*//*Label 4614*/ GIMT_Encode4(203449),
     /* 201898 */ /*GILLT_v16s32*//*Label 4615*/ GIMT_Encode4(203637), GIMT_Encode4(0),
     /* 201906 */ /*GILLT_v32s8*//*Label 4616*/ GIMT_Encode4(203722),
     /* 201910 */ /*GILLT_v32s16*//*Label 4617*/ GIMT_Encode4(203910), GIMT_Encode4(0),
     /* 201918 */ /*GILLT_v64s8*//*Label 4618*/ GIMT_Encode4(203995),
     /* 201922 */ // Label 4604: @201922
     /* 201922 */ GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(202015),
     /* 201927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 201930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 201934 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(201989), // Rule ID 3175 //
     /* 201939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 201942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201953 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201957 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 201961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201970 */     // (ctpop:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (POPCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 201970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT16rm),
     /* 201973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 201982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201987 */     GIR_RootConstrainSelectedInstOperands,
     /* 201988 */     // GIR_Coverage, 3175,
     /* 201988 */     GIR_EraseRootFromParent_Done,
     /* 201989 */   // Label 4621: @201989
     /* 201989 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(202014), // Rule ID 3174 //
     /* 201994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 201997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 202001 */     // (ctpop:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (POPCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 202001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT16rr),
     /* 202006 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 202012 */     GIR_RootConstrainSelectedInstOperands,
     /* 202013 */     // GIR_Coverage, 3174,
     /* 202013 */     GIR_Done,
     /* 202014 */   // Label 4622: @202014
     /* 202014 */   GIM_Reject,
     /* 202015 */ // Label 4620: @202015
     /* 202015 */ GIM_Reject,
     /* 202016 */ // Label 4605: @202016
     /* 202016 */ GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(202109),
     /* 202021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 202024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 202028 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(202083), // Rule ID 3177 //
     /* 202033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 202036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202044 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202047 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202051 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 202055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202064 */     // (ctpop:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (POPCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 202064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT32rm),
     /* 202067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202069 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 202076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202081 */     GIR_RootConstrainSelectedInstOperands,
     /* 202082 */     // GIR_Coverage, 3177,
     /* 202082 */     GIR_EraseRootFromParent_Done,
     /* 202083 */   // Label 4624: @202083
     /* 202083 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(202108), // Rule ID 3176 //
     /* 202088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 202091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 202095 */     // (ctpop:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (POPCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 202095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT32rr),
     /* 202100 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 202106 */     GIR_RootConstrainSelectedInstOperands,
     /* 202107 */     // GIR_Coverage, 3176,
     /* 202107 */     GIR_Done,
     /* 202108 */   // Label 4625: @202108
     /* 202108 */   GIM_Reject,
     /* 202109 */ // Label 4623: @202109
     /* 202109 */ GIM_Reject,
     /* 202110 */ // Label 4606: @202110
     /* 202110 */ GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(202203),
     /* 202115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 202118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 202122 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(202177), // Rule ID 3179 //
     /* 202127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 202130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202138 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202141 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202145 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202158 */     // (ctpop:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (POPCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 202158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT64rm),
     /* 202161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 202170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202175 */     GIR_RootConstrainSelectedInstOperands,
     /* 202176 */     // GIR_Coverage, 3179,
     /* 202176 */     GIR_EraseRootFromParent_Done,
     /* 202177 */   // Label 4627: @202177
     /* 202177 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(202202), // Rule ID 3178 //
     /* 202182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 202185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 202189 */     // (ctpop:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (POPCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 202189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT64rr),
     /* 202194 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 202200 */     GIR_RootConstrainSelectedInstOperands,
     /* 202201 */     // GIR_Coverage, 3178,
     /* 202201 */     GIR_Done,
     /* 202202 */   // Label 4628: @202202
     /* 202202 */   GIM_Reject,
     /* 202203 */ // Label 4626: @202203
     /* 202203 */ GIM_Reject,
     /* 202204 */ // Label 4607: @202204
     /* 202204 */ GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(202399),
     /* 202209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202212 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(202268), // Rule ID 13464 //
     /* 202217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202252 */     // (ctpop:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 202252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rm),
     /* 202255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202257 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202266 */     GIR_RootConstrainSelectedInstOperands,
     /* 202267 */     // GIR_Coverage, 13464,
     /* 202267 */     GIR_EraseRootFromParent_Done,
     /* 202268 */   // Label 4630: @202268
     /* 202268 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(202291), // Rule ID 13461 //
     /* 202273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202284 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPOPCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 202284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rr),
     /* 202289 */     GIR_RootConstrainSelectedInstOperands,
     /* 202290 */     // GIR_Coverage, 13461,
     /* 202290 */     GIR_Done,
     /* 202291 */   // Label 4631: @202291
     /* 202291 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(202398), // Rule ID 21829 //
     /* 202296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 202299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 202303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202307 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 202307 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 202310 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202314 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202321 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 202324 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202328 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202333 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202336 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202340 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 202343 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202353 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 202358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 202365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202380 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 202387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 202392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202397 */     // GIR_Coverage, 21829,
     /* 202397 */     GIR_EraseRootFromParent_Done,
     /* 202398 */   // Label 4632: @202398
     /* 202398 */   GIM_Reject,
     /* 202399 */ // Label 4629: @202399
     /* 202399 */ GIM_Reject,
     /* 202400 */ // Label 4608: @202400
     /* 202400 */ GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(202595),
     /* 202405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 202408 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(202464), // Rule ID 13491 //
     /* 202413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202435 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202448 */     // (ctpop:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 202448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rm),
     /* 202451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202453 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202462 */     GIR_RootConstrainSelectedInstOperands,
     /* 202463 */     // GIR_Coverage, 13491,
     /* 202463 */     GIR_EraseRootFromParent_Done,
     /* 202464 */   // Label 4634: @202464
     /* 202464 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(202487), // Rule ID 13488 //
     /* 202469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202480 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPOPCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 202480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rr),
     /* 202485 */     GIR_RootConstrainSelectedInstOperands,
     /* 202486 */     // GIR_Coverage, 13488,
     /* 202486 */     GIR_Done,
     /* 202487 */   // Label 4635: @202487
     /* 202487 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(202594), // Rule ID 21831 //
     /* 202492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 202495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 202499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202503 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 202503 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 202506 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202510 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202517 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 202520 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202524 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202529 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202532 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202536 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 202539 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202544 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202549 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 202554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 202561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202566 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202576 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 202583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 202588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202593 */     // GIR_Coverage, 21831,
     /* 202593 */     GIR_EraseRootFromParent_Done,
     /* 202594 */   // Label 4636: @202594
     /* 202594 */   GIM_Reject,
     /* 202595 */ // Label 4633: @202595
     /* 202595 */ GIM_Reject,
     /* 202596 */ // Label 4609: @202596
     /* 202596 */ GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(202783),
     /* 202601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 202604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202608 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(202660), // Rule ID 13455 //
     /* 202613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202644 */     // (ctpop:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 202644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rm),
     /* 202647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202649 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202658 */     GIR_RootConstrainSelectedInstOperands,
     /* 202659 */     // GIR_Coverage, 13455,
     /* 202659 */     GIR_EraseRootFromParent_Done,
     /* 202660 */   // Label 4638: @202660
     /* 202660 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(202679), // Rule ID 13452 //
     /* 202665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202672 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPOPCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 202672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rr),
     /* 202677 */     GIR_RootConstrainSelectedInstOperands,
     /* 202678 */     // GIR_Coverage, 13452,
     /* 202678 */     GIR_Done,
     /* 202679 */   // Label 4639: @202679
     /* 202679 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(202782), // Rule ID 21828 //
     /* 202684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 202687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202691 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 202691 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 202694 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202698 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 202708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202717 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202720 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202724 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 202727 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202732 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202737 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 202742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 202749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202754 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202764 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 202771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 202776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202781 */     // GIR_Coverage, 21828,
     /* 202781 */     GIR_EraseRootFromParent_Done,
     /* 202782 */   // Label 4640: @202782
     /* 202782 */   GIM_Reject,
     /* 202783 */ // Label 4637: @202783
     /* 202783 */ GIM_Reject,
     /* 202784 */ // Label 4610: @202784
     /* 202784 */ GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(202979),
     /* 202789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202792 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(202848), // Rule ID 14518 //
     /* 202797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 202800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202832 */     // (ctpop:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)
     /* 202832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rm),
     /* 202835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202846 */     GIR_RootConstrainSelectedInstOperands,
     /* 202847 */     // GIR_Coverage, 14518,
     /* 202847 */     GIR_EraseRootFromParent_Done,
     /* 202848 */   // Label 4642: @202848
     /* 202848 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(202871), // Rule ID 14515 //
     /* 202853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 202856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202864 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPOPCNTWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 202864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rr),
     /* 202869 */     GIR_RootConstrainSelectedInstOperands,
     /* 202870 */     // GIR_Coverage, 14515,
     /* 202870 */     GIR_Done,
     /* 202871 */   // Label 4643: @202871
     /* 202871 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(202978), // Rule ID 22138 //
     /* 202876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 202879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 202883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202887 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 202887 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 202890 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202894 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202901 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 202904 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202908 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202913 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202916 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202920 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 202923 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202928 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 202938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 202945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202950 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202960 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 202967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 202972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202977 */     // GIR_Coverage, 22138,
     /* 202977 */     GIR_EraseRootFromParent_Done,
     /* 202978 */   // Label 4644: @202978
     /* 202978 */   GIM_Reject,
     /* 202979 */ // Label 4641: @202979
     /* 202979 */ GIM_Reject,
     /* 202980 */ // Label 4611: @202980
     /* 202980 */ GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(203167),
     /* 202985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 202988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202992 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(203044), // Rule ID 13482 //
     /* 202997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 203000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203008 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203015 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203028 */     // (ctpop:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 203028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rm),
     /* 203031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203033 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203042 */     GIR_RootConstrainSelectedInstOperands,
     /* 203043 */     // GIR_Coverage, 13482,
     /* 203043 */     GIR_EraseRootFromParent_Done,
     /* 203044 */   // Label 4646: @203044
     /* 203044 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(203063), // Rule ID 13479 //
     /* 203049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 203052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203056 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPOPCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 203056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rr),
     /* 203061 */     GIR_RootConstrainSelectedInstOperands,
     /* 203062 */     // GIR_Coverage, 13479,
     /* 203062 */     GIR_Done,
     /* 203063 */   // Label 4647: @203063
     /* 203063 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(203166), // Rule ID 21830 //
     /* 203068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 203071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203075 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 203075 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 203078 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203082 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 203089 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 203092 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203096 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203101 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 203104 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 203108 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 203111 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 203116 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203121 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 203129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 203133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203138 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 203141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 203146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203148 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 203155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203165 */     // GIR_Coverage, 21830,
     /* 203165 */     GIR_EraseRootFromParent_Done,
     /* 203166 */   // Label 4648: @203166
     /* 203166 */   GIM_Reject,
     /* 203167 */ // Label 4645: @203167
     /* 203167 */ GIM_Reject,
     /* 203168 */ // Label 4612: @203168
     /* 203168 */ GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(203252),
     /* 203173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 203176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203180 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(203232), // Rule ID 13446 //
     /* 203185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 203188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203196 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203199 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203203 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203216 */     // (ctpop:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 203216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrm),
     /* 203219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203230 */     GIR_RootConstrainSelectedInstOperands,
     /* 203231 */     // GIR_Coverage, 13446,
     /* 203231 */     GIR_EraseRootFromParent_Done,
     /* 203232 */   // Label 4650: @203232
     /* 203232 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(203251), // Rule ID 13443 //
     /* 203237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 203240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203244 */     // (ctpop:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPOPCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 203244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 203249 */     GIR_RootConstrainSelectedInstOperands,
     /* 203250 */     // GIR_Coverage, 13443,
     /* 203250 */     GIR_Done,
     /* 203251 */   // Label 4651: @203251
     /* 203251 */   GIM_Reject,
     /* 203252 */ // Label 4649: @203252
     /* 203252 */ GIM_Reject,
     /* 203253 */ // Label 4613: @203253
     /* 203253 */ GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(203448),
     /* 203258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 203261 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(203317), // Rule ID 14500 //
     /* 203266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 203273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203281 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203284 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203288 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203301 */     // (ctpop:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZ128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)
     /* 203301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rm),
     /* 203304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203315 */     GIR_RootConstrainSelectedInstOperands,
     /* 203316 */     // GIR_Coverage, 14500,
     /* 203316 */     GIR_EraseRootFromParent_Done,
     /* 203317 */   // Label 4653: @203317
     /* 203317 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(203340), // Rule ID 14497 //
     /* 203322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 203329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 203333 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPOPCNTBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 203333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rr),
     /* 203338 */     GIR_RootConstrainSelectedInstOperands,
     /* 203339 */     // GIR_Coverage, 14497,
     /* 203339 */     GIR_Done,
     /* 203340 */   // Label 4654: @203340
     /* 203340 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(203447), // Rule ID 22136 //
     /* 203345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 203348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 203352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 203356 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 203356 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 203359 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203363 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 203370 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 203373 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203377 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203382 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 203385 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 203389 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 203392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 203397 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203402 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 203407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 203410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 203414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203419 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 203422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 203427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203429 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 203436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 203441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203446 */     // GIR_Coverage, 22136,
     /* 203446 */     GIR_EraseRootFromParent_Done,
     /* 203447 */   // Label 4655: @203447
     /* 203447 */   GIM_Reject,
     /* 203448 */ // Label 4652: @203448
     /* 203448 */ GIM_Reject,
     /* 203449 */ // Label 4614: @203449
     /* 203449 */ GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(203636),
     /* 203454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 203457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203461 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(203513), // Rule ID 14512 //
     /* 203466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203477 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203480 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203484 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203497 */     // (ctpop:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)
     /* 203497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rm),
     /* 203500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203502 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203511 */     GIR_RootConstrainSelectedInstOperands,
     /* 203512 */     // GIR_Coverage, 14512,
     /* 203512 */     GIR_EraseRootFromParent_Done,
     /* 203513 */   // Label 4657: @203513
     /* 203513 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(203532), // Rule ID 14509 //
     /* 203518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203525 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPOPCNTWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 203525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rr),
     /* 203530 */     GIR_RootConstrainSelectedInstOperands,
     /* 203531 */     // GIR_Coverage, 14509,
     /* 203531 */     GIR_Done,
     /* 203532 */   // Label 4658: @203532
     /* 203532 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(203635), // Rule ID 22137 //
     /* 203537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 203540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203544 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 203544 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 203547 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203551 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 203558 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 203561 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203565 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203570 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 203573 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 203577 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 203580 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 203585 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203590 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 203598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 203602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203607 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 203610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 203615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203617 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 203624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203634 */     // GIR_Coverage, 22137,
     /* 203634 */     GIR_EraseRootFromParent_Done,
     /* 203635 */   // Label 4659: @203635
     /* 203635 */   GIM_Reject,
     /* 203636 */ // Label 4656: @203636
     /* 203636 */ GIM_Reject,
     /* 203637 */ // Label 4615: @203637
     /* 203637 */ GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(203721),
     /* 203642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 203645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203649 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(203701), // Rule ID 13473 //
     /* 203654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 203657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203665 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203668 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203672 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203685 */     // (ctpop:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 203685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrm),
     /* 203688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203690 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203699 */     GIR_RootConstrainSelectedInstOperands,
     /* 203700 */     // GIR_Coverage, 13473,
     /* 203700 */     GIR_EraseRootFromParent_Done,
     /* 203701 */   // Label 4661: @203701
     /* 203701 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(203720), // Rule ID 13470 //
     /* 203706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 203709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203713 */     // (ctpop:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPOPCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 203713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 203718 */     GIR_RootConstrainSelectedInstOperands,
     /* 203719 */     // GIR_Coverage, 13470,
     /* 203719 */     GIR_Done,
     /* 203720 */   // Label 4662: @203720
     /* 203720 */   GIM_Reject,
     /* 203721 */ // Label 4660: @203721
     /* 203721 */ GIM_Reject,
     /* 203722 */ // Label 4616: @203722
     /* 203722 */ GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(203909),
     /* 203727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 203730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203734 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(203786), // Rule ID 14494 //
     /* 203739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203750 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203753 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203757 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203770 */     // (ctpop:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZ256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)
     /* 203770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rm),
     /* 203773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203775 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203784 */     GIR_RootConstrainSelectedInstOperands,
     /* 203785 */     // GIR_Coverage, 14494,
     /* 203785 */     GIR_EraseRootFromParent_Done,
     /* 203786 */   // Label 4664: @203786
     /* 203786 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(203805), // Rule ID 14491 //
     /* 203791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203798 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPOPCNTBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 203798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rr),
     /* 203803 */     GIR_RootConstrainSelectedInstOperands,
     /* 203804 */     // GIR_Coverage, 14491,
     /* 203804 */     GIR_Done,
     /* 203805 */   // Label 4665: @203805
     /* 203805 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(203908), // Rule ID 22135 //
     /* 203810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 203813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203817 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 203817 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 203820 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203824 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 203831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 203834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203843 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 203846 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 203850 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 203853 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 203858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203863 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 203871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 203875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203880 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 203883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 203888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203890 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 203897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203907 */     // GIR_Coverage, 22135,
     /* 203907 */     GIR_EraseRootFromParent_Done,
     /* 203908 */   // Label 4666: @203908
     /* 203908 */   GIM_Reject,
     /* 203909 */ // Label 4663: @203909
     /* 203909 */ GIM_Reject,
     /* 203910 */ // Label 4617: @203910
     /* 203910 */ GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(203994),
     /* 203915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 203918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203922 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(203974), // Rule ID 14506 //
     /* 203927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 203930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203938 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203941 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203945 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203958 */     // (ctpop:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)
     /* 203958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrm),
     /* 203961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203963 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203972 */     GIR_RootConstrainSelectedInstOperands,
     /* 203973 */     // GIR_Coverage, 14506,
     /* 203973 */     GIR_EraseRootFromParent_Done,
     /* 203974 */   // Label 4668: @203974
     /* 203974 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(203993), // Rule ID 14503 //
     /* 203979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 203982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203986 */     // (ctpop:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPOPCNTWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 203986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 203991 */     GIR_RootConstrainSelectedInstOperands,
     /* 203992 */     // GIR_Coverage, 14503,
     /* 203992 */     GIR_Done,
     /* 203993 */   // Label 4669: @203993
     /* 203993 */   GIM_Reject,
     /* 203994 */ // Label 4667: @203994
     /* 203994 */ GIM_Reject,
     /* 203995 */ // Label 4618: @203995
     /* 203995 */ GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(204079),
     /* 204000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 204003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 204007 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(204059), // Rule ID 14488 //
     /* 204012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 204015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204023 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204030 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204043 */     // (ctpop:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)
     /* 204043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrm),
     /* 204046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204048 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204057 */     GIR_RootConstrainSelectedInstOperands,
     /* 204058 */     // GIR_Coverage, 14488,
     /* 204058 */     GIR_EraseRootFromParent_Done,
     /* 204059 */   // Label 4671: @204059
     /* 204059 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(204078), // Rule ID 14485 //
     /* 204064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 204067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 204071 */     // (ctpop:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPOPCNTBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 204071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 204076 */     GIR_RootConstrainSelectedInstOperands,
     /* 204077 */     // GIR_Coverage, 14485,
     /* 204077 */     GIR_Done,
     /* 204078 */   // Label 4672: @204078
     /* 204078 */   GIM_Reject,
     /* 204079 */ // Label 4670: @204079
     /* 204079 */ GIM_Reject,
     /* 204080 */ // Label 4619: @204080
     /* 204080 */ GIM_Reject,
     /* 204081 */ // Label 66: @204081
     /* 204081 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4676*/ GIMT_Encode4(204580),
     /* 204092 */ /*GILLT_s16*//*Label 4673*/ GIMT_Encode4(204104),
     /* 204096 */ /*GILLT_s32*//*Label 4674*/ GIMT_Encode4(204268),
     /* 204100 */ /*GILLT_s64*//*Label 4675*/ GIMT_Encode4(204424),
     /* 204104 */ // Label 4673: @204104
     /* 204104 */ GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(204267),
     /* 204109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 204112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 204116 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(204168), // Rule ID 49 //
     /* 204121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 204124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204135 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204139 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 204143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204152 */     // (bswap:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (MOVBE16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /* 204152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16rm),
     /* 204155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204166 */     GIR_RootConstrainSelectedInstOperands,
     /* 204167 */     // GIR_Coverage, 49,
     /* 204167 */     GIR_EraseRootFromParent_Done,
     /* 204168 */   // Label 4678: @204168
     /* 204168 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(204220), // Rule ID 55 //
     /* 204173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 204176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204184 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204191 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 204195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204204 */     // (bswap:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (MOVBE16rm_EVEX:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /* 204204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16rm_EVEX),
     /* 204207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204218 */     GIR_RootConstrainSelectedInstOperands,
     /* 204219 */     // GIR_Coverage, 55,
     /* 204219 */     GIR_EraseRootFromParent_Done,
     /* 204220 */   // Label 4679: @204220
     /* 204220 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(204239), // Rule ID 61 //
     /* 204225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 204228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 204232 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (MOVBE16rr:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /* 204232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE16rr),
     /* 204237 */     GIR_RootConstrainSelectedInstOperands,
     /* 204238 */     // GIR_Coverage, 61,
     /* 204238 */     GIR_Done,
     /* 204239 */   // Label 4680: @204239
     /* 204239 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(204266), // Rule ID 22985 //
     /* 204244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE),
     /* 204247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 204251 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src, 8:{ *:[i8] })
     /* 204251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 204254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204256 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 204258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 204261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 204264 */     GIR_RootConstrainSelectedInstOperands,
     /* 204265 */     // GIR_Coverage, 22985,
     /* 204265 */     GIR_EraseRootFromParent_Done,
     /* 204266 */   // Label 4681: @204266
     /* 204266 */   GIM_Reject,
     /* 204267 */ // Label 4677: @204267
     /* 204267 */ GIM_Reject,
     /* 204268 */ // Label 4674: @204268
     /* 204268 */ GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(204423),
     /* 204273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 204276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 204280 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(204332), // Rule ID 51 //
     /* 204285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 204288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204296 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204303 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 204307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204316 */     // (bswap:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (MOVBE32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 204316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32rm),
     /* 204319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204330 */     GIR_RootConstrainSelectedInstOperands,
     /* 204331 */     // GIR_Coverage, 51,
     /* 204331 */     GIR_EraseRootFromParent_Done,
     /* 204332 */   // Label 4683: @204332
     /* 204332 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(204384), // Rule ID 57 //
     /* 204337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 204340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204351 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204355 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 204359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204368 */     // (bswap:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (MOVBE32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 204368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32rm_EVEX),
     /* 204371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204373 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204382 */     GIR_RootConstrainSelectedInstOperands,
     /* 204383 */     // GIR_Coverage, 57,
     /* 204383 */     GIR_EraseRootFromParent_Done,
     /* 204384 */   // Label 4684: @204384
     /* 204384 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(204403), // Rule ID 5 //
     /* 204389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 204392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 204396 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSWAP32r:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 204396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP32r),
     /* 204401 */     GIR_RootConstrainSelectedInstOperands,
     /* 204402 */     // GIR_Coverage, 5,
     /* 204402 */     GIR_Done,
     /* 204403 */   // Label 4685: @204403
     /* 204403 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(204422), // Rule ID 62 //
     /* 204408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 204411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 204415 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (MOVBE32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 204415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE32rr),
     /* 204420 */     GIR_RootConstrainSelectedInstOperands,
     /* 204421 */     // GIR_Coverage, 62,
     /* 204421 */     GIR_Done,
     /* 204422 */   // Label 4686: @204422
     /* 204422 */   GIM_Reject,
     /* 204423 */ // Label 4682: @204423
     /* 204423 */ GIM_Reject,
     /* 204424 */ // Label 4675: @204424
     /* 204424 */ GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(204579),
     /* 204429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 204432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 204436 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(204488), // Rule ID 53 //
     /* 204441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 204444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204472 */     // (bswap:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MOVBE64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /* 204472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64rm),
     /* 204475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204486 */     GIR_RootConstrainSelectedInstOperands,
     /* 204487 */     // GIR_Coverage, 53,
     /* 204487 */     GIR_EraseRootFromParent_Done,
     /* 204488 */   // Label 4688: @204488
     /* 204488 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(204540), // Rule ID 59 //
     /* 204493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 204496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204524 */     // (bswap:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MOVBE64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /* 204524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64rm_EVEX),
     /* 204527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204529 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204538 */     GIR_RootConstrainSelectedInstOperands,
     /* 204539 */     // GIR_Coverage, 59,
     /* 204539 */     GIR_EraseRootFromParent_Done,
     /* 204540 */   // Label 4689: @204540
     /* 204540 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(204559), // Rule ID 6 //
     /* 204545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 204548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 204552 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSWAP64r:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 204552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP64r),
     /* 204557 */     GIR_RootConstrainSelectedInstOperands,
     /* 204558 */     // GIR_Coverage, 6,
     /* 204558 */     GIR_Done,
     /* 204559 */   // Label 4690: @204559
     /* 204559 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(204578), // Rule ID 63 //
     /* 204564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 204567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 204571 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (MOVBE64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /* 204571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE64rr),
     /* 204576 */     GIR_RootConstrainSelectedInstOperands,
     /* 204577 */     // GIR_Coverage, 63,
     /* 204577 */     GIR_Done,
     /* 204578 */   // Label 4691: @204578
     /* 204578 */   GIM_Reject,
     /* 204579 */ // Label 4687: @204579
     /* 204579 */ GIM_Reject,
     /* 204580 */ // Label 4676: @204580
     /* 204580 */ GIM_Reject,
     /* 204581 */ // Label 67: @204581
     /* 204581 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4705*/ GIMT_Encode4(206749),
     /* 204592 */ /*GILLT_s16*//*Label 4692*/ GIMT_Encode4(204676),
     /* 204596 */ /*GILLT_s32*//*Label 4693*/ GIMT_Encode4(204797),
     /* 204600 */ /*GILLT_s64*//*Label 4694*/ GIMT_Encode4(205153),
     /* 204604 */ /*GILLT_s80*//*Label 4695*/ GIMT_Encode4(205509), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 204616 */ /*GILLT_v2s64*//*Label 4696*/ GIMT_Encode4(205546), GIMT_Encode4(0),
     /* 204624 */ /*GILLT_v4s32*//*Label 4697*/ GIMT_Encode4(205749),
     /* 204628 */ /*GILLT_v4s64*//*Label 4698*/ GIMT_Encode4(205952), GIMT_Encode4(0),
     /* 204636 */ /*GILLT_v8s16*//*Label 4699*/ GIMT_Encode4(206128),
     /* 204640 */ /*GILLT_v8s32*//*Label 4700*/ GIMT_Encode4(206217),
     /* 204644 */ /*GILLT_v8s64*//*Label 4701*/ GIMT_Encode4(206393), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 204656 */ /*GILLT_v16s16*//*Label 4702*/ GIMT_Encode4(206482),
     /* 204660 */ /*GILLT_v16s32*//*Label 4703*/ GIMT_Encode4(206571), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 204672 */ /*GILLT_v32s16*//*Label 4704*/ GIMT_Encode4(206660),
     /* 204676 */ // Label 4692: @204676
     /* 204676 */ GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(204796),
     /* 204681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 204684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 204688 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(204757), // Rule ID 21420 //
     /* 204693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 204696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204704 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204707 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204711 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204724 */     // (fsqrt:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSHZm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 204724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 204727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZm),
     /* 204741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204746 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 204750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204755 */     GIR_RootConstrainSelectedInstOperands,
     /* 204756 */     // GIR_Coverage, 21420,
     /* 204756 */     GIR_EraseRootFromParent_Done,
     /* 204757 */   // Label 4707: @204757
     /* 204757 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(204795), // Rule ID 21418 //
     /* 204762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 204765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 204769 */     // (fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 204769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 204772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 204786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204791 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 204793 */     GIR_RootConstrainSelectedInstOperands,
     /* 204794 */     // GIR_Coverage, 21418,
     /* 204794 */     GIR_EraseRootFromParent_Done,
     /* 204795 */   // Label 4708: @204795
     /* 204795 */   GIM_Reject,
     /* 204796 */ // Label 4706: @204796
     /* 204796 */ GIM_Reject,
     /* 204797 */ // Label 4693: @204797
     /* 204797 */ GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(205152),
     /* 204802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 204805 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(204861), // Rule ID 2448 //
     /* 204810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE1),
     /* 204813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 204817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204825 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204828 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204832 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204838 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204845 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSSm:{ *:[f32] } addr:{ *:[iPTR] }:$src1)
     /* 204845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSSm),
     /* 204848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204859 */     GIR_RootConstrainSelectedInstOperands,
     /* 204860 */     // GIR_Coverage, 2448,
     /* 204860 */     GIR_EraseRootFromParent_Done,
     /* 204861 */   // Label 4710: @204861
     /* 204861 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(204934), // Rule ID 18276 //
     /* 204866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 204869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 204873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204881 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204884 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204888 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204901 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 204901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 204904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSm),
     /* 204918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204923 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 204927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204932 */     GIR_RootConstrainSelectedInstOperands,
     /* 204933 */     // GIR_Coverage, 18276,
     /* 204933 */     GIR_EraseRootFromParent_Done,
     /* 204934 */   // Label 4711: @204934
     /* 204934 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(205007), // Rule ID 21424 //
     /* 204939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 204942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 204946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204954 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204974 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSZm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 204974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 204977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZm),
     /* 204991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204996 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205005 */     GIR_RootConstrainSelectedInstOperands,
     /* 205006 */     // GIR_Coverage, 21424,
     /* 205006 */     GIR_EraseRootFromParent_Done,
     /* 205007 */   // Label 4712: @205007
     /* 205007 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(205040), // Rule ID 1048 //
     /* 205012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 205015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 205019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 205023 */     // (fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 205023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 205028 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 205034 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 205038 */     GIR_RootConstrainSelectedInstOperands,
     /* 205039 */     // GIR_Coverage, 1048,
     /* 205039 */     GIR_Done,
     /* 205040 */   // Label 4713: @205040
     /* 205040 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(205067), // Rule ID 2446 //
     /* 205045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 205048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 205052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 205056 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 205056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 205061 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205065 */     GIR_RootConstrainSelectedInstOperands,
     /* 205066 */     // GIR_Coverage, 2446,
     /* 205066 */     GIR_Done,
     /* 205067 */   // Label 4714: @205067
     /* 205067 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(205109), // Rule ID 18274 //
     /* 205072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 205075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 205079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 205083 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 205083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 205086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 205100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 205107 */     GIR_RootConstrainSelectedInstOperands,
     /* 205108 */     // GIR_Coverage, 18274,
     /* 205108 */     GIR_EraseRootFromParent_Done,
     /* 205109 */   // Label 4715: @205109
     /* 205109 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(205151), // Rule ID 21422 //
     /* 205114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 205117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 205121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 205125 */     // (fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 205125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 205128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 205142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205147 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 205149 */     GIR_RootConstrainSelectedInstOperands,
     /* 205150 */     // GIR_Coverage, 21422,
     /* 205150 */     GIR_EraseRootFromParent_Done,
     /* 205151 */   // Label 4716: @205151
     /* 205151 */   GIM_Reject,
     /* 205152 */ // Label 4709: @205152
     /* 205152 */ GIM_Reject,
     /* 205153 */ // Label 4694: @205153
     /* 205153 */ GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(205508),
     /* 205158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 205161 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(205217), // Rule ID 2464 //
     /* 205166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 205169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 205173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205201 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSDm:{ *:[f64] } addr:{ *:[iPTR] }:$src1)
     /* 205201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSDm),
     /* 205204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205206 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205215 */     GIR_RootConstrainSelectedInstOperands,
     /* 205216 */     // GIR_Coverage, 2464,
     /* 205216 */     GIR_EraseRootFromParent_Done,
     /* 205217 */   // Label 4718: @205217
     /* 205217 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(205290), // Rule ID 18280 //
     /* 205222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 205225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 205229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205237 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205240 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205244 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205257 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 205257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 205260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDm),
     /* 205274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205279 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205288 */     GIR_RootConstrainSelectedInstOperands,
     /* 205289 */     // GIR_Coverage, 18280,
     /* 205289 */     GIR_EraseRootFromParent_Done,
     /* 205290 */   // Label 4719: @205290
     /* 205290 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(205363), // Rule ID 21428 //
     /* 205295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 205298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 205302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205310 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205313 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205317 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205330 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDZm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 205330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 205333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZm),
     /* 205347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205361 */     GIR_RootConstrainSelectedInstOperands,
     /* 205362 */     // GIR_Coverage, 21428,
     /* 205362 */     GIR_EraseRootFromParent_Done,
     /* 205363 */   // Label 4720: @205363
     /* 205363 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(205396), // Rule ID 1050 //
     /* 205368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 205371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 205375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 205379 */     // (fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 205379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 205384 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 205390 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 205394 */     GIR_RootConstrainSelectedInstOperands,
     /* 205395 */     // GIR_Coverage, 1050,
     /* 205395 */     GIR_Done,
     /* 205396 */   // Label 4721: @205396
     /* 205396 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(205423), // Rule ID 2462 //
     /* 205401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 205404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 205408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 205412 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 205412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 205417 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205421 */     GIR_RootConstrainSelectedInstOperands,
     /* 205422 */     // GIR_Coverage, 2462,
     /* 205422 */     GIR_Done,
     /* 205423 */   // Label 4722: @205423
     /* 205423 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(205465), // Rule ID 18278 //
     /* 205428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 205431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 205435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 205439 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 205439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 205442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 205456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 205463 */     GIR_RootConstrainSelectedInstOperands,
     /* 205464 */     // GIR_Coverage, 18278,
     /* 205464 */     GIR_EraseRootFromParent_Done,
     /* 205465 */   // Label 4723: @205465
     /* 205465 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(205507), // Rule ID 21426 //
     /* 205470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 205473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 205477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 205481 */     // (fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 205481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 205484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 205498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 205503 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 205505 */     GIR_RootConstrainSelectedInstOperands,
     /* 205506 */     // GIR_Coverage, 21426,
     /* 205506 */     GIR_EraseRootFromParent_Done,
     /* 205507 */   // Label 4724: @205507
     /* 205507 */   GIM_Reject,
     /* 205508 */ // Label 4717: @205508
     /* 205508 */ GIM_Reject,
     /* 205509 */ // Label 4695: @205509
     /* 205509 */ GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(205545), // Rule ID 1052 //
     /* 205514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 205517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 205520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 205524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 205528 */   // (fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 205528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 205533 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 205539 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 205543 */   GIR_RootConstrainSelectedInstOperands,
     /* 205544 */   // GIR_Coverage, 1052,
     /* 205544 */   GIR_Done,
     /* 205545 */ // Label 4725: @205545
     /* 205545 */ GIM_Reject,
     /* 205546 */ // Label 4696: @205546
     /* 205546 */ GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(205748),
     /* 205551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 205554 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(205610), // Rule ID 2468 //
     /* 205559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205594 */     // (fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 205594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDm),
     /* 205597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205608 */     GIR_RootConstrainSelectedInstOperands,
     /* 205609 */     // GIR_Coverage, 2468,
     /* 205609 */     GIR_EraseRootFromParent_Done,
     /* 205610 */   // Label 4727: @205610
     /* 205610 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(205666), // Rule ID 12086 //
     /* 205615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205650 */     // (fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ128m:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 205650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128m),
     /* 205653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205655 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205664 */     GIR_RootConstrainSelectedInstOperands,
     /* 205665 */     // GIR_Coverage, 12086,
     /* 205665 */     GIR_EraseRootFromParent_Done,
     /* 205666 */   // Label 4728: @205666
     /* 205666 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(205693), // Rule ID 2466 //
     /* 205671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205682 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 205682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 205687 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205691 */     GIR_RootConstrainSelectedInstOperands,
     /* 205692 */     // GIR_Coverage, 2466,
     /* 205692 */     GIR_Done,
     /* 205693 */   // Label 4729: @205693
     /* 205693 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(205720), // Rule ID 2474 //
     /* 205698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 205701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205709 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 205709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 205714 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205718 */     GIR_RootConstrainSelectedInstOperands,
     /* 205719 */     // GIR_Coverage, 2474,
     /* 205719 */     GIR_Done,
     /* 205720 */   // Label 4730: @205720
     /* 205720 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(205747), // Rule ID 12082 //
     /* 205725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205736 */     // (fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 205736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 205741 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205745 */     GIR_RootConstrainSelectedInstOperands,
     /* 205746 */     // GIR_Coverage, 12082,
     /* 205746 */     GIR_Done,
     /* 205747 */   // Label 4731: @205747
     /* 205747 */   GIM_Reject,
     /* 205748 */ // Label 4726: @205748
     /* 205748 */ GIM_Reject,
     /* 205749 */ // Label 4697: @205749
     /* 205749 */ GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(205951),
     /* 205754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205757 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(205813), // Rule ID 2452 //
     /* 205762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205777 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205784 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205797 */     // (fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 205797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSm),
     /* 205800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205802 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205811 */     GIR_RootConstrainSelectedInstOperands,
     /* 205812 */     // GIR_Coverage, 2452,
     /* 205812 */     GIR_EraseRootFromParent_Done,
     /* 205813 */   // Label 4733: @205813
     /* 205813 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(205869), // Rule ID 12062 //
     /* 205818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205833 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205840 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205853 */     // (fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ128m:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 205853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128m),
     /* 205856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205858 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205867 */     GIR_RootConstrainSelectedInstOperands,
     /* 205868 */     // GIR_Coverage, 12062,
     /* 205868 */     GIR_EraseRootFromParent_Done,
     /* 205869 */   // Label 4734: @205869
     /* 205869 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(205896), // Rule ID 2450 //
     /* 205874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205885 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 205885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 205890 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205894 */     GIR_RootConstrainSelectedInstOperands,
     /* 205895 */     // GIR_Coverage, 2450,
     /* 205895 */     GIR_Done,
     /* 205896 */   // Label 4735: @205896
     /* 205896 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(205923), // Rule ID 2458 //
     /* 205901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 205904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205912 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 205912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 205917 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205921 */     GIR_RootConstrainSelectedInstOperands,
     /* 205922 */     // GIR_Coverage, 2458,
     /* 205922 */     GIR_Done,
     /* 205923 */   // Label 4736: @205923
     /* 205923 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(205950), // Rule ID 12058 //
     /* 205928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205939 */     // (fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 205939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 205944 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205948 */     GIR_RootConstrainSelectedInstOperands,
     /* 205949 */     // GIR_Coverage, 12058,
     /* 205949 */     GIR_Done,
     /* 205950 */   // Label 4737: @205950
     /* 205950 */   GIM_Reject,
     /* 205951 */ // Label 4732: @205951
     /* 205951 */ GIM_Reject,
     /* 205952 */ // Label 4698: @205952
     /* 205952 */ GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(206127),
     /* 205957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 205960 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(206016), // Rule ID 2472 //
     /* 205965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 205972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205980 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205983 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205987 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206000 */     // (fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDYm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 206000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYm),
     /* 206003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206014 */     GIR_RootConstrainSelectedInstOperands,
     /* 206015 */     // GIR_Coverage, 2472,
     /* 206015 */     GIR_EraseRootFromParent_Done,
     /* 206016 */   // Label 4739: @206016
     /* 206016 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(206072), // Rule ID 12098 //
     /* 206021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 206024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206056 */     // (fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ256m:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 206056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256m),
     /* 206059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206061 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206070 */     GIR_RootConstrainSelectedInstOperands,
     /* 206071 */     // GIR_Coverage, 12098,
     /* 206071 */     GIR_EraseRootFromParent_Done,
     /* 206072 */   // Label 4740: @206072
     /* 206072 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(206099), // Rule ID 2470 //
     /* 206077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 206080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 206084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 206088 */     // (fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 206088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 206093 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206097 */     GIR_RootConstrainSelectedInstOperands,
     /* 206098 */     // GIR_Coverage, 2470,
     /* 206098 */     GIR_Done,
     /* 206099 */   // Label 4741: @206099
     /* 206099 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(206126), // Rule ID 12094 //
     /* 206104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 206107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206115 */     // (fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 206115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 206120 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206124 */     GIR_RootConstrainSelectedInstOperands,
     /* 206125 */     // GIR_Coverage, 12094,
     /* 206125 */     GIR_Done,
     /* 206126 */   // Label 4742: @206126
     /* 206126 */   GIM_Reject,
     /* 206127 */ // Label 4738: @206127
     /* 206127 */ GIM_Reject,
     /* 206128 */ // Label 4699: @206128
     /* 206128 */ GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(206216),
     /* 206133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 206136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206140 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(206192), // Rule ID 12014 //
     /* 206145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 206148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206156 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206159 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206163 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206176 */     // (fsqrt:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ128m:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 206176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128m),
     /* 206179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206181 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206190 */     GIR_RootConstrainSelectedInstOperands,
     /* 206191 */     // GIR_Coverage, 12014,
     /* 206191 */     GIR_EraseRootFromParent_Done,
     /* 206192 */   // Label 4744: @206192
     /* 206192 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(206215), // Rule ID 12010 //
     /* 206197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 206200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206204 */     // (fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 206204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 206209 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206213 */     GIR_RootConstrainSelectedInstOperands,
     /* 206214 */     // GIR_Coverage, 12010,
     /* 206214 */     GIR_Done,
     /* 206215 */   // Label 4745: @206215
     /* 206215 */   GIM_Reject,
     /* 206216 */ // Label 4743: @206216
     /* 206216 */ GIM_Reject,
     /* 206217 */ // Label 4700: @206217
     /* 206217 */ GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(206392),
     /* 206222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 206225 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(206281), // Rule ID 2456 //
     /* 206230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 206233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 206237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206265 */     // (fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSYm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 206265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYm),
     /* 206268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206279 */     GIR_RootConstrainSelectedInstOperands,
     /* 206280 */     // GIR_Coverage, 2456,
     /* 206280 */     GIR_EraseRootFromParent_Done,
     /* 206281 */   // Label 4747: @206281
     /* 206281 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(206337), // Rule ID 12074 //
     /* 206286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 206289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206301 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206304 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206308 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206321 */     // (fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ256m:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 206321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256m),
     /* 206324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206335 */     GIR_RootConstrainSelectedInstOperands,
     /* 206336 */     // GIR_Coverage, 12074,
     /* 206336 */     GIR_EraseRootFromParent_Done,
     /* 206337 */   // Label 4748: @206337
     /* 206337 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(206364), // Rule ID 2454 //
     /* 206342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 206345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 206349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 206353 */     // (fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 206353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 206358 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206362 */     GIR_RootConstrainSelectedInstOperands,
     /* 206363 */     // GIR_Coverage, 2454,
     /* 206363 */     GIR_Done,
     /* 206364 */   // Label 4749: @206364
     /* 206364 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(206391), // Rule ID 12070 //
     /* 206369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 206372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206380 */     // (fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 206380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 206385 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206389 */     GIR_RootConstrainSelectedInstOperands,
     /* 206390 */     // GIR_Coverage, 12070,
     /* 206390 */     GIR_Done,
     /* 206391 */   // Label 4750: @206391
     /* 206391 */   GIM_Reject,
     /* 206392 */ // Label 4746: @206392
     /* 206392 */ GIM_Reject,
     /* 206393 */ // Label 4701: @206393
     /* 206393 */ GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(206481),
     /* 206398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 206401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206405 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(206457), // Rule ID 12050 //
     /* 206410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 206413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206421 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206424 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206428 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206441 */     // (fsqrt:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 206441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZm),
     /* 206444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206446 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206455 */     GIR_RootConstrainSelectedInstOperands,
     /* 206456 */     // GIR_Coverage, 12050,
     /* 206456 */     GIR_EraseRootFromParent_Done,
     /* 206457 */   // Label 4752: @206457
     /* 206457 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(206480), // Rule ID 12046 //
     /* 206462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 206465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206469 */     // (fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 206469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 206474 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206478 */     GIR_RootConstrainSelectedInstOperands,
     /* 206479 */     // GIR_Coverage, 12046,
     /* 206479 */     GIR_Done,
     /* 206480 */   // Label 4753: @206480
     /* 206480 */   GIM_Reject,
     /* 206481 */ // Label 4751: @206481
     /* 206481 */ GIM_Reject,
     /* 206482 */ // Label 4702: @206482
     /* 206482 */ GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(206570),
     /* 206487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 206490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206494 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(206546), // Rule ID 12026 //
     /* 206499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 206502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206510 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206517 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206530 */     // (fsqrt:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ256m:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 206530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256m),
     /* 206533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206535 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206544 */     GIR_RootConstrainSelectedInstOperands,
     /* 206545 */     // GIR_Coverage, 12026,
     /* 206545 */     GIR_EraseRootFromParent_Done,
     /* 206546 */   // Label 4755: @206546
     /* 206546 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(206569), // Rule ID 12022 //
     /* 206551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 206554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206558 */     // (fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 206558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 206563 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206567 */     GIR_RootConstrainSelectedInstOperands,
     /* 206568 */     // GIR_Coverage, 12022,
     /* 206568 */     GIR_Done,
     /* 206569 */   // Label 4756: @206569
     /* 206569 */   GIM_Reject,
     /* 206570 */ // Label 4754: @206570
     /* 206570 */ GIM_Reject,
     /* 206571 */ // Label 4703: @206571
     /* 206571 */ GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(206659),
     /* 206576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 206579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206583 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(206635), // Rule ID 12038 //
     /* 206588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 206591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206599 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206606 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206619 */     // (fsqrt:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 206619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZm),
     /* 206622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206624 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206633 */     GIR_RootConstrainSelectedInstOperands,
     /* 206634 */     // GIR_Coverage, 12038,
     /* 206634 */     GIR_EraseRootFromParent_Done,
     /* 206635 */   // Label 4758: @206635
     /* 206635 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(206658), // Rule ID 12034 //
     /* 206640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 206643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206647 */     // (fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 206647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 206652 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206656 */     GIR_RootConstrainSelectedInstOperands,
     /* 206657 */     // GIR_Coverage, 12034,
     /* 206657 */     GIR_Done,
     /* 206658 */   // Label 4759: @206658
     /* 206658 */   GIM_Reject,
     /* 206659 */ // Label 4757: @206659
     /* 206659 */ GIM_Reject,
     /* 206660 */ // Label 4704: @206660
     /* 206660 */ GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(206748),
     /* 206665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 206668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206672 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(206724), // Rule ID 12002 //
     /* 206677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206688 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206691 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206695 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206708 */     // (fsqrt:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 206708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZm),
     /* 206711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206713 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206722 */     GIR_RootConstrainSelectedInstOperands,
     /* 206723 */     // GIR_Coverage, 12002,
     /* 206723 */     GIR_EraseRootFromParent_Done,
     /* 206724 */   // Label 4761: @206724
     /* 206724 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(206747), // Rule ID 11998 //
     /* 206729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206736 */     // (fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 206736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 206741 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206745 */     GIR_RootConstrainSelectedInstOperands,
     /* 206746 */     // GIR_Coverage, 11998,
     /* 206746 */     GIR_Done,
     /* 206747 */   // Label 4762: @206747
     /* 206747 */   GIM_Reject,
     /* 206748 */ // Label 4760: @206748
     /* 206748 */ GIM_Reject,
     /* 206749 */ // Label 4705: @206749
     /* 206749 */ GIM_Reject,
     /* 206750 */ // Label 68: @206750
     /* 206750 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4776*/ GIMT_Encode4(210915),
     /* 206761 */ /*GILLT_s16*//*Label 4763*/ GIMT_Encode4(206845),
     /* 206765 */ /*GILLT_s32*//*Label 4764*/ GIMT_Encode4(207005),
     /* 206769 */ /*GILLT_s64*//*Label 4765*/ GIMT_Encode4(207650),
     /* 206773 */ /*GILLT_s80*//*Label 4766*/ GIMT_Encode4(208439), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 206785 */ /*GILLT_v2s64*//*Label 4767*/ GIMT_Encode4(208761), GIMT_Encode4(0),
     /* 206793 */ /*GILLT_v4s32*//*Label 4768*/ GIMT_Encode4(209115),
     /* 206797 */ /*GILLT_v4s64*//*Label 4769*/ GIMT_Encode4(209469), GIMT_Encode4(0),
     /* 206805 */ /*GILLT_v8s16*//*Label 4770*/ GIMT_Encode4(209792),
     /* 206809 */ /*GILLT_v8s32*//*Label 4771*/ GIMT_Encode4(209952),
     /* 206813 */ /*GILLT_v8s64*//*Label 4772*/ GIMT_Encode4(210275), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 206825 */ /*GILLT_v16s16*//*Label 4773*/ GIMT_Encode4(210435),
     /* 206829 */ /*GILLT_v16s32*//*Label 4774*/ GIMT_Encode4(210595), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 206841 */ /*GILLT_v32s16*//*Label 4775*/ GIMT_Encode4(210755),
     /* 206845 */ // Label 4763: @206845
     /* 206845 */ GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(207004),
     /* 206850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 206853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 206856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206860 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(206918), // Rule ID 24246 //
     /* 206865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206876 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206879 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206900 */     // (strict_fadd:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 206903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206905 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 206907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206916 */     GIR_RootConstrainSelectedInstOperands,
     /* 206917 */     // GIR_Coverage, 24246,
     /* 206917 */     GIR_EraseRootFromParent_Done,
     /* 206918 */   // Label 4778: @206918
     /* 206918 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(206976), // Rule ID 5953 //
     /* 206923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206938 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206941 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206945 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206958 */     // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 206961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206963 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 206965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206974 */     GIR_RootConstrainSelectedInstOperands,
     /* 206975 */     // GIR_Coverage, 5953,
     /* 206975 */     GIR_EraseRootFromParent_Done,
     /* 206976 */   // Label 4779: @206976
     /* 206976 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(207003), // Rule ID 5951 //
     /* 206981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206992 */     // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 206992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 206997 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 207001 */     GIR_RootConstrainSelectedInstOperands,
     /* 207002 */     // GIR_Coverage, 5951,
     /* 207002 */     GIR_Done,
     /* 207003 */   // Label 4780: @207003
     /* 207003 */   GIM_Reject,
     /* 207004 */ // Label 4777: @207004
     /* 207004 */ GIM_Reject,
     /* 207005 */ // Label 4764: @207005
     /* 207005 */ GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(207649),
     /* 207010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 207013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207016 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(207081), // Rule ID 23233 //
     /* 207021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 207024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207060 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 207063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207065 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207067 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207079 */     GIR_RootConstrainSelectedInstOperands,
     /* 207080 */     // GIR_Coverage, 23233,
     /* 207080 */     GIR_EraseRootFromParent_Done,
     /* 207081 */   // Label 4782: @207081
     /* 207081 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(207143), // Rule ID 23378 //
     /* 207086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 207089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207101 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207104 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207108 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207125 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 207128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207130 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207141 */     GIR_RootConstrainSelectedInstOperands,
     /* 207142 */     // GIR_Coverage, 23378,
     /* 207142 */     GIR_EraseRootFromParent_Done,
     /* 207143 */   // Label 4783: @207143
     /* 207143 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(207205), // Rule ID 23382 //
     /* 207148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 207151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207163 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207166 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207170 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207187 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 207190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207192 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207203 */     GIR_RootConstrainSelectedInstOperands,
     /* 207204 */     // GIR_Coverage, 23382,
     /* 207204 */     GIR_EraseRootFromParent_Done,
     /* 207205 */   // Label 4784: @207205
     /* 207205 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(207267), // Rule ID 24242 //
     /* 207210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 207213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207225 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207228 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207232 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207249 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 207252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207254 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207265 */     GIR_RootConstrainSelectedInstOperands,
     /* 207266 */     // GIR_Coverage, 24242,
     /* 207266 */     GIR_EraseRootFromParent_Done,
     /* 207267 */   // Label 4785: @207267
     /* 207267 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(207332), // Rule ID 909 //
     /* 207272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 207275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207291 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207294 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207298 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207311 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 207314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207316 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207318 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207330 */     GIR_RootConstrainSelectedInstOperands,
     /* 207331 */     // GIR_Coverage, 909,
     /* 207331 */     GIR_EraseRootFromParent_Done,
     /* 207332 */   // Label 4786: @207332
     /* 207332 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(207394), // Rule ID 2159 //
     /* 207337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 207340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207376 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 207379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207381 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207383 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207392 */     GIR_RootConstrainSelectedInstOperands,
     /* 207393 */     // GIR_Coverage, 2159,
     /* 207393 */     GIR_EraseRootFromParent_Done,
     /* 207394 */   // Label 4787: @207394
     /* 207394 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(207456), // Rule ID 2167 //
     /* 207399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 207402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207418 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207421 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207425 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207438 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 207441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207443 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207445 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207454 */     GIR_RootConstrainSelectedInstOperands,
     /* 207455 */     // GIR_Coverage, 2167,
     /* 207455 */     GIR_EraseRootFromParent_Done,
     /* 207456 */   // Label 4788: @207456
     /* 207456 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(207518), // Rule ID 5915 //
     /* 207461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 207464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207480 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207500 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 207503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207505 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207507 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207516 */     GIR_RootConstrainSelectedInstOperands,
     /* 207517 */     // GIR_Coverage, 5915,
     /* 207517 */     GIR_EraseRootFromParent_Done,
     /* 207518 */   // Label 4789: @207518
     /* 207518 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(207555), // Rule ID 885 //
     /* 207523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 207526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 207538 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 207538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 207543 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 207549 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 207553 */     GIR_RootConstrainSelectedInstOperands,
     /* 207554 */     // GIR_Coverage, 885,
     /* 207554 */     GIR_Done,
     /* 207555 */   // Label 4790: @207555
     /* 207555 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(207586), // Rule ID 2157 //
     /* 207560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 207563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207575 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 207575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 207580 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 207584 */     GIR_RootConstrainSelectedInstOperands,
     /* 207585 */     // GIR_Coverage, 2157,
     /* 207585 */     GIR_Done,
     /* 207586 */   // Label 4791: @207586
     /* 207586 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(207617), // Rule ID 2165 //
     /* 207591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 207594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 207606 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 207606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 207611 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 207615 */     GIR_RootConstrainSelectedInstOperands,
     /* 207616 */     // GIR_Coverage, 2165,
     /* 207616 */     GIR_Done,
     /* 207617 */   // Label 4792: @207617
     /* 207617 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(207648), // Rule ID 5913 //
     /* 207622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 207625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 207637 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 207637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 207642 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 207646 */     GIR_RootConstrainSelectedInstOperands,
     /* 207647 */     // GIR_Coverage, 5913,
     /* 207647 */     GIR_Done,
     /* 207648 */   // Label 4793: @207648
     /* 207648 */   GIM_Reject,
     /* 207649 */ // Label 4781: @207649
     /* 207649 */ GIM_Reject,
     /* 207650 */ // Label 4765: @207650
     /* 207650 */ GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(208438),
     /* 207655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 207658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207661 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(207726), // Rule ID 23235 //
     /* 207666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 207669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207681 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207688 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207705 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 207708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207710 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207724 */     GIR_RootConstrainSelectedInstOperands,
     /* 207725 */     // GIR_Coverage, 23235,
     /* 207725 */     GIR_EraseRootFromParent_Done,
     /* 207726 */   // Label 4795: @207726
     /* 207726 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(207798), // Rule ID 23237 //
     /* 207731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 207734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207746 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207749 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207753 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 207760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207777 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 207780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207782 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207796 */     GIR_RootConstrainSelectedInstOperands,
     /* 207797 */     // GIR_Coverage, 23237,
     /* 207797 */     GIR_EraseRootFromParent_Done,
     /* 207798 */   // Label 4796: @207798
     /* 207798 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(207860), // Rule ID 23380 //
     /* 207803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 207806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207818 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207821 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207825 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207842 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 207845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207847 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207849 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207858 */     GIR_RootConstrainSelectedInstOperands,
     /* 207859 */     // GIR_Coverage, 23380,
     /* 207859 */     GIR_EraseRootFromParent_Done,
     /* 207860 */   // Label 4797: @207860
     /* 207860 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(207922), // Rule ID 23384 //
     /* 207865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 207868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207887 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207904 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 207907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207909 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207920 */     GIR_RootConstrainSelectedInstOperands,
     /* 207921 */     // GIR_Coverage, 23384,
     /* 207921 */     GIR_EraseRootFromParent_Done,
     /* 207922 */   // Label 4798: @207922
     /* 207922 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(207984), // Rule ID 24244 //
     /* 207927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 207930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 207934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207942 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 207957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207966 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 207969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207982 */     GIR_RootConstrainSelectedInstOperands,
     /* 207983 */     // GIR_Coverage, 24244,
     /* 207983 */     GIR_EraseRootFromParent_Done,
     /* 207984 */   // Label 4799: @207984
     /* 207984 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(208049), // Rule ID 911 //
     /* 207989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 207992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208008 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208015 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208028 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 208031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208033 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208047 */     GIR_RootConstrainSelectedInstOperands,
     /* 208048 */     // GIR_Coverage, 911,
     /* 208048 */     GIR_EraseRootFromParent_Done,
     /* 208049 */   // Label 4800: @208049
     /* 208049 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(208121), // Rule ID 913 //
     /* 208054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 208057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208073 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208076 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208080 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 208087 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208100 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 208103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208107 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208119 */     GIR_RootConstrainSelectedInstOperands,
     /* 208120 */     // GIR_Coverage, 913,
     /* 208120 */     GIR_EraseRootFromParent_Done,
     /* 208121 */   // Label 4801: @208121
     /* 208121 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(208183), // Rule ID 2163 //
     /* 208126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 208129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208145 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208148 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208152 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208165 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 208168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208170 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208181 */     GIR_RootConstrainSelectedInstOperands,
     /* 208182 */     // GIR_Coverage, 2163,
     /* 208182 */     GIR_EraseRootFromParent_Done,
     /* 208183 */   // Label 4802: @208183
     /* 208183 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(208245), // Rule ID 2171 //
     /* 208188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 208191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208207 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208214 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208227 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 208230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208232 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208243 */     GIR_RootConstrainSelectedInstOperands,
     /* 208244 */     // GIR_Coverage, 2171,
     /* 208244 */     GIR_EraseRootFromParent_Done,
     /* 208245 */   // Label 4803: @208245
     /* 208245 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(208307), // Rule ID 5934 //
     /* 208250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 208253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208269 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208272 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208276 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208289 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 208292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208294 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208305 */     GIR_RootConstrainSelectedInstOperands,
     /* 208306 */     // GIR_Coverage, 5934,
     /* 208306 */     GIR_EraseRootFromParent_Done,
     /* 208307 */   // Label 4804: @208307
     /* 208307 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(208344), // Rule ID 887 //
     /* 208312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 208315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208327 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 208327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 208332 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208338 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208342 */     GIR_RootConstrainSelectedInstOperands,
     /* 208343 */     // GIR_Coverage, 887,
     /* 208343 */     GIR_Done,
     /* 208344 */   // Label 4805: @208344
     /* 208344 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(208375), // Rule ID 2161 //
     /* 208349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 208352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208364 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 208364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 208369 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208373 */     GIR_RootConstrainSelectedInstOperands,
     /* 208374 */     // GIR_Coverage, 2161,
     /* 208374 */     GIR_Done,
     /* 208375 */   // Label 4806: @208375
     /* 208375 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(208406), // Rule ID 2169 //
     /* 208380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 208383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208395 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 208395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 208400 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208404 */     GIR_RootConstrainSelectedInstOperands,
     /* 208405 */     // GIR_Coverage, 2169,
     /* 208405 */     GIR_Done,
     /* 208406 */   // Label 4807: @208406
     /* 208406 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(208437), // Rule ID 5932 //
     /* 208411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 208414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208426 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 208426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 208431 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208435 */     GIR_RootConstrainSelectedInstOperands,
     /* 208436 */     // GIR_Coverage, 5932,
     /* 208436 */     GIR_Done,
     /* 208437 */   // Label 4808: @208437
     /* 208437 */   GIM_Reject,
     /* 208438 */ // Label 4794: @208438
     /* 208438 */ GIM_Reject,
     /* 208439 */ // Label 4766: @208439
     /* 208439 */ GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(208760),
     /* 208444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 208447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 208450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208454 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(208522), // Rule ID 23239 //
     /* 208459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208470 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208473 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208477 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 208484 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208501 */     // (strict_fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 208504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208506 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208520 */     GIR_RootConstrainSelectedInstOperands,
     /* 208521 */     // GIR_Coverage, 23239,
     /* 208521 */     GIR_EraseRootFromParent_Done,
     /* 208522 */   // Label 4810: @208522
     /* 208522 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(208590), // Rule ID 23241 //
     /* 208527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208541 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208545 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 208552 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208569 */     // (strict_fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 208572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208574 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208588 */     GIR_RootConstrainSelectedInstOperands,
     /* 208589 */     // GIR_Coverage, 23241,
     /* 208589 */     GIR_EraseRootFromParent_Done,
     /* 208590 */   // Label 4811: @208590
     /* 208590 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(208658), // Rule ID 915 //
     /* 208595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208610 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208613 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208617 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 208624 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208637 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 208640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208642 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208644 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208656 */     GIR_RootConstrainSelectedInstOperands,
     /* 208657 */     // GIR_Coverage, 915,
     /* 208657 */     GIR_EraseRootFromParent_Done,
     /* 208658 */   // Label 4812: @208658
     /* 208658 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(208726), // Rule ID 917 //
     /* 208663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208678 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208681 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208685 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 208692 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208705 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 208708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208710 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208724 */     GIR_RootConstrainSelectedInstOperands,
     /* 208725 */     // GIR_Coverage, 917,
     /* 208725 */     GIR_EraseRootFromParent_Done,
     /* 208726 */   // Label 4813: @208726
     /* 208726 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(208759), // Rule ID 889 //
     /* 208731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208742 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 208742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 208747 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208753 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208757 */     GIR_RootConstrainSelectedInstOperands,
     /* 208758 */     // GIR_Coverage, 889,
     /* 208758 */     GIR_Done,
     /* 208759 */   // Label 4814: @208759
     /* 208759 */   GIM_Reject,
     /* 208760 */ // Label 4809: @208760
     /* 208760 */ GIM_Reject,
     /* 208761 */ // Label 4767: @208761
     /* 208761 */ GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(209114),
     /* 208766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 208772 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(208834), // Rule ID 23368 //
     /* 208777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208816 */     // (strict_fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 208819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208832 */     GIR_RootConstrainSelectedInstOperands,
     /* 208833 */     // GIR_Coverage, 23368,
     /* 208833 */     GIR_EraseRootFromParent_Done,
     /* 208834 */   // Label 4816: @208834
     /* 208834 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(208896), // Rule ID 24292 //
     /* 208839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 208842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208861 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208878 */     // (strict_fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 208881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208894 */     GIR_RootConstrainSelectedInstOperands,
     /* 208895 */     // GIR_Coverage, 24292,
     /* 208895 */     GIR_EraseRootFromParent_Done,
     /* 208896 */   // Label 4817: @208896
     /* 208896 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(208958), // Rule ID 2139 //
     /* 208901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208940 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 208943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208956 */     GIR_RootConstrainSelectedInstOperands,
     /* 208957 */     // GIR_Coverage, 2139,
     /* 208957 */     GIR_EraseRootFromParent_Done,
     /* 208958 */   // Label 4818: @208958
     /* 208958 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(209020), // Rule ID 6307 //
     /* 208963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 208966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208982 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208985 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208989 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209002 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 209005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209018 */     GIR_RootConstrainSelectedInstOperands,
     /* 209019 */     // GIR_Coverage, 6307,
     /* 209019 */     GIR_EraseRootFromParent_Done,
     /* 209020 */   // Label 4819: @209020
     /* 209020 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(209051), // Rule ID 2137 //
     /* 209025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209040 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 209040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 209045 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209049 */     GIR_RootConstrainSelectedInstOperands,
     /* 209050 */     // GIR_Coverage, 2137,
     /* 209050 */     GIR_Done,
     /* 209051 */   // Label 4820: @209051
     /* 209051 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(209082), // Rule ID 2153 //
     /* 209056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 209059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209071 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 209071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 209076 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209080 */     GIR_RootConstrainSelectedInstOperands,
     /* 209081 */     // GIR_Coverage, 2153,
     /* 209081 */     GIR_Done,
     /* 209082 */   // Label 4821: @209082
     /* 209082 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(209113), // Rule ID 6303 //
     /* 209087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209102 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 209102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 209107 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209111 */     GIR_RootConstrainSelectedInstOperands,
     /* 209112 */     // GIR_Coverage, 6303,
     /* 209112 */     GIR_Done,
     /* 209113 */   // Label 4822: @209113
     /* 209113 */   GIM_Reject,
     /* 209114 */ // Label 4815: @209114
     /* 209114 */ GIM_Reject,
     /* 209115 */ // Label 4768: @209115
     /* 209115 */ GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(209468),
     /* 209120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209126 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(209188), // Rule ID 23366 //
     /* 209131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209146 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209153 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209170 */     // (strict_fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 209173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209175 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209177 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209186 */     GIR_RootConstrainSelectedInstOperands,
     /* 209187 */     // GIR_Coverage, 23366,
     /* 209187 */     GIR_EraseRootFromParent_Done,
     /* 209188 */   // Label 4824: @209188
     /* 209188 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(209250), // Rule ID 24276 //
     /* 209193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209208 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209211 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209215 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209232 */     // (strict_fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 209235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209237 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209248 */     GIR_RootConstrainSelectedInstOperands,
     /* 209249 */     // GIR_Coverage, 24276,
     /* 209249 */     GIR_EraseRootFromParent_Done,
     /* 209250 */   // Label 4825: @209250
     /* 209250 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(209312), // Rule ID 2135 //
     /* 209255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209274 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209277 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209281 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209294 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 209297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209299 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209310 */     GIR_RootConstrainSelectedInstOperands,
     /* 209311 */     // GIR_Coverage, 2135,
     /* 209311 */     GIR_EraseRootFromParent_Done,
     /* 209312 */   // Label 4826: @209312
     /* 209312 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(209374), // Rule ID 6283 //
     /* 209317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209336 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209339 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209356 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 209359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209372 */     GIR_RootConstrainSelectedInstOperands,
     /* 209373 */     // GIR_Coverage, 6283,
     /* 209373 */     GIR_EraseRootFromParent_Done,
     /* 209374 */   // Label 4827: @209374
     /* 209374 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(209405), // Rule ID 2133 //
     /* 209379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209394 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 209394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 209399 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209403 */     GIR_RootConstrainSelectedInstOperands,
     /* 209404 */     // GIR_Coverage, 2133,
     /* 209404 */     GIR_Done,
     /* 209405 */   // Label 4828: @209405
     /* 209405 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(209436), // Rule ID 2149 //
     /* 209410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 209413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209425 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 209425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 209430 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209434 */     GIR_RootConstrainSelectedInstOperands,
     /* 209435 */     // GIR_Coverage, 2149,
     /* 209435 */     GIR_Done,
     /* 209436 */   // Label 4829: @209436
     /* 209436 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(209467), // Rule ID 6279 //
     /* 209441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209456 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 209456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 209461 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209465 */     GIR_RootConstrainSelectedInstOperands,
     /* 209466 */     // GIR_Coverage, 6279,
     /* 209466 */     GIR_Done,
     /* 209467 */   // Label 4830: @209467
     /* 209467 */   GIM_Reject,
     /* 209468 */ // Label 4823: @209468
     /* 209468 */ GIM_Reject,
     /* 209469 */ // Label 4769: @209469
     /* 209469 */ GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(209791),
     /* 209474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 209477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 209480 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(209542), // Rule ID 23372 //
     /* 209485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209503 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209507 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209524 */     // (strict_fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 209527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209540 */     GIR_RootConstrainSelectedInstOperands,
     /* 209541 */     // GIR_Coverage, 23372,
     /* 209541 */     GIR_EraseRootFromParent_Done,
     /* 209542 */   // Label 4832: @209542
     /* 209542 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(209604), // Rule ID 24300 //
     /* 209547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209586 */     // (strict_fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 209589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209591 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209593 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209602 */     GIR_RootConstrainSelectedInstOperands,
     /* 209603 */     // GIR_Coverage, 24300,
     /* 209603 */     GIR_EraseRootFromParent_Done,
     /* 209604 */   // Label 4833: @209604
     /* 209604 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(209666), // Rule ID 2147 //
     /* 209609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209648 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 209651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209655 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209664 */     GIR_RootConstrainSelectedInstOperands,
     /* 209665 */     // GIR_Coverage, 2147,
     /* 209665 */     GIR_EraseRootFromParent_Done,
     /* 209666 */   // Label 4834: @209666
     /* 209666 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(209728), // Rule ID 6319 //
     /* 209671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209690 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209693 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209697 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209710 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 209713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209717 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209726 */     GIR_RootConstrainSelectedInstOperands,
     /* 209727 */     // GIR_Coverage, 6319,
     /* 209727 */     GIR_EraseRootFromParent_Done,
     /* 209728 */   // Label 4835: @209728
     /* 209728 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(209759), // Rule ID 2145 //
     /* 209733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209748 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 209748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 209753 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209757 */     GIR_RootConstrainSelectedInstOperands,
     /* 209758 */     // GIR_Coverage, 2145,
     /* 209758 */     GIR_Done,
     /* 209759 */   // Label 4836: @209759
     /* 209759 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(209790), // Rule ID 6315 //
     /* 209764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209779 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 209779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 209784 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209788 */     GIR_RootConstrainSelectedInstOperands,
     /* 209789 */     // GIR_Coverage, 6315,
     /* 209789 */     GIR_Done,
     /* 209790 */   // Label 4837: @209790
     /* 209790 */   GIM_Reject,
     /* 209791 */ // Label 4831: @209791
     /* 209791 */ GIM_Reject,
     /* 209792 */ // Label 4770: @209792
     /* 209792 */ GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(209951),
     /* 209797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 209800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 209803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209807 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(209865), // Rule ID 24316 //
     /* 209812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209823 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209830 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209847 */     // (strict_fadd:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 209850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209852 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209863 */     GIR_RootConstrainSelectedInstOperands,
     /* 209864 */     // GIR_Coverage, 24316,
     /* 209864 */     GIR_EraseRootFromParent_Done,
     /* 209865 */   // Label 4839: @209865
     /* 209865 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(209923), // Rule ID 6343 //
     /* 209870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209885 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209892 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209905 */     // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 209908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209910 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209921 */     GIR_RootConstrainSelectedInstOperands,
     /* 209922 */     // GIR_Coverage, 6343,
     /* 209922 */     GIR_EraseRootFromParent_Done,
     /* 209923 */   // Label 4840: @209923
     /* 209923 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(209950), // Rule ID 6339 //
     /* 209928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209939 */     // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 209939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 209944 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209948 */     GIR_RootConstrainSelectedInstOperands,
     /* 209949 */     // GIR_Coverage, 6339,
     /* 209949 */     GIR_Done,
     /* 209950 */   // Label 4841: @209950
     /* 209950 */   GIM_Reject,
     /* 209951 */ // Label 4838: @209951
     /* 209951 */ GIM_Reject,
     /* 209952 */ // Label 4771: @209952
     /* 209952 */ GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(210274),
     /* 209957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 209960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 209963 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(210025), // Rule ID 23370 //
     /* 209968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209983 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209990 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210007 */     // (strict_fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 210010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210012 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210014 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210023 */     GIR_RootConstrainSelectedInstOperands,
     /* 210024 */     // GIR_Coverage, 23370,
     /* 210024 */     GIR_EraseRootFromParent_Done,
     /* 210025 */   // Label 4843: @210025
     /* 210025 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(210087), // Rule ID 24284 //
     /* 210030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 210033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210069 */     // (strict_fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 210072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210074 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210085 */     GIR_RootConstrainSelectedInstOperands,
     /* 210086 */     // GIR_Coverage, 24284,
     /* 210086 */     GIR_EraseRootFromParent_Done,
     /* 210087 */   // Label 4844: @210087
     /* 210087 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(210149), // Rule ID 2143 //
     /* 210092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 210095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 210099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 210103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210111 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210114 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210118 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210131 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 210134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210136 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210138 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210147 */     GIR_RootConstrainSelectedInstOperands,
     /* 210148 */     // GIR_Coverage, 2143,
     /* 210148 */     GIR_EraseRootFromParent_Done,
     /* 210149 */   // Label 4845: @210149
     /* 210149 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(210211), // Rule ID 6295 //
     /* 210154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 210157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210173 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210176 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210180 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210193 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 210196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210198 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210209 */     GIR_RootConstrainSelectedInstOperands,
     /* 210210 */     // GIR_Coverage, 6295,
     /* 210210 */     GIR_EraseRootFromParent_Done,
     /* 210211 */   // Label 4846: @210211
     /* 210211 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(210242), // Rule ID 2141 //
     /* 210216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 210219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 210223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 210227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 210231 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 210231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 210236 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210240 */     GIR_RootConstrainSelectedInstOperands,
     /* 210241 */     // GIR_Coverage, 2141,
     /* 210241 */     GIR_Done,
     /* 210242 */   // Label 4847: @210242
     /* 210242 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(210273), // Rule ID 6291 //
     /* 210247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 210250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210262 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 210262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 210267 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210271 */     GIR_RootConstrainSelectedInstOperands,
     /* 210272 */     // GIR_Coverage, 6291,
     /* 210272 */     GIR_Done,
     /* 210273 */   // Label 4848: @210273
     /* 210273 */   GIM_Reject,
     /* 210274 */ // Label 4842: @210274
     /* 210274 */ GIM_Reject,
     /* 210275 */ // Label 4772: @210275
     /* 210275 */ GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(210434),
     /* 210280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 210283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 210286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210290 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(210348), // Rule ID 24268 //
     /* 210295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210330 */     // (strict_fadd:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 210333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210335 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210337 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210346 */     GIR_RootConstrainSelectedInstOperands,
     /* 210347 */     // GIR_Coverage, 24268,
     /* 210347 */     GIR_EraseRootFromParent_Done,
     /* 210348 */   // Label 4850: @210348
     /* 210348 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(210406), // Rule ID 6271 //
     /* 210353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210368 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210375 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210388 */     // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 210391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210393 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210395 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210404 */     GIR_RootConstrainSelectedInstOperands,
     /* 210405 */     // GIR_Coverage, 6271,
     /* 210405 */     GIR_EraseRootFromParent_Done,
     /* 210406 */   // Label 4851: @210406
     /* 210406 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(210433), // Rule ID 6267 //
     /* 210411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210422 */     // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 210422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 210427 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210431 */     GIR_RootConstrainSelectedInstOperands,
     /* 210432 */     // GIR_Coverage, 6267,
     /* 210432 */     GIR_Done,
     /* 210433 */   // Label 4852: @210433
     /* 210433 */   GIM_Reject,
     /* 210434 */ // Label 4849: @210434
     /* 210434 */ GIM_Reject,
     /* 210435 */ // Label 4773: @210435
     /* 210435 */ GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(210594),
     /* 210440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 210443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 210446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210450 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(210508), // Rule ID 24324 //
     /* 210455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 210458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210490 */     // (strict_fadd:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 210493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210495 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210506 */     GIR_RootConstrainSelectedInstOperands,
     /* 210507 */     // GIR_Coverage, 24324,
     /* 210507 */     GIR_EraseRootFromParent_Done,
     /* 210508 */   // Label 4854: @210508
     /* 210508 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(210566), // Rule ID 6355 //
     /* 210513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 210516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210528 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210531 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210535 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210548 */     // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 210551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210553 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210564 */     GIR_RootConstrainSelectedInstOperands,
     /* 210565 */     // GIR_Coverage, 6355,
     /* 210565 */     GIR_EraseRootFromParent_Done,
     /* 210566 */   // Label 4855: @210566
     /* 210566 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(210593), // Rule ID 6351 //
     /* 210571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 210574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 210582 */     // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 210582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 210587 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210591 */     GIR_RootConstrainSelectedInstOperands,
     /* 210592 */     // GIR_Coverage, 6351,
     /* 210592 */     GIR_Done,
     /* 210593 */   // Label 4856: @210593
     /* 210593 */   GIM_Reject,
     /* 210594 */ // Label 4853: @210594
     /* 210594 */ GIM_Reject,
     /* 210595 */ // Label 4774: @210595
     /* 210595 */ GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(210754),
     /* 210600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 210603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 210606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210610 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(210668), // Rule ID 24260 //
     /* 210615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210626 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210629 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210633 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210650 */     // (strict_fadd:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 210653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210655 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210666 */     GIR_RootConstrainSelectedInstOperands,
     /* 210667 */     // GIR_Coverage, 24260,
     /* 210667 */     GIR_EraseRootFromParent_Done,
     /* 210668 */   // Label 4858: @210668
     /* 210668 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(210726), // Rule ID 6259 //
     /* 210673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210688 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210691 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210695 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210708 */     // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 210711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210715 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210724 */     GIR_RootConstrainSelectedInstOperands,
     /* 210725 */     // GIR_Coverage, 6259,
     /* 210725 */     GIR_EraseRootFromParent_Done,
     /* 210726 */   // Label 4859: @210726
     /* 210726 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(210753), // Rule ID 6255 //
     /* 210731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210742 */     // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 210742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 210747 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210751 */     GIR_RootConstrainSelectedInstOperands,
     /* 210752 */     // GIR_Coverage, 6255,
     /* 210752 */     GIR_Done,
     /* 210753 */   // Label 4860: @210753
     /* 210753 */   GIM_Reject,
     /* 210754 */ // Label 4857: @210754
     /* 210754 */ GIM_Reject,
     /* 210755 */ // Label 4775: @210755
     /* 210755 */ GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(210914),
     /* 210760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 210763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 210766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210770 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(210828), // Rule ID 24308 //
     /* 210775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210810 */     // (strict_fadd:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 210813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210826 */     GIR_RootConstrainSelectedInstOperands,
     /* 210827 */     // GIR_Coverage, 24308,
     /* 210827 */     GIR_EraseRootFromParent_Done,
     /* 210828 */   // Label 4862: @210828
     /* 210828 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(210886), // Rule ID 6331 //
     /* 210833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210855 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210868 */     // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 210871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210875 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210884 */     GIR_RootConstrainSelectedInstOperands,
     /* 210885 */     // GIR_Coverage, 6331,
     /* 210885 */     GIR_EraseRootFromParent_Done,
     /* 210886 */   // Label 4863: @210886
     /* 210886 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(210913), // Rule ID 6327 //
     /* 210891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210902 */     // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 210902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 210907 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210911 */     GIR_RootConstrainSelectedInstOperands,
     /* 210912 */     // GIR_Coverage, 6327,
     /* 210912 */     GIR_Done,
     /* 210913 */   // Label 4864: @210913
     /* 210913 */   GIM_Reject,
     /* 210914 */ // Label 4861: @210914
     /* 210914 */ GIM_Reject,
     /* 210915 */ // Label 4776: @210915
     /* 210915 */ GIM_Reject,
     /* 210916 */ // Label 69: @210916
     /* 210916 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4878*/ GIMT_Encode4(213841),
     /* 210927 */ /*GILLT_s16*//*Label 4865*/ GIMT_Encode4(211011),
     /* 210931 */ /*GILLT_s32*//*Label 4866*/ GIMT_Encode4(211109),
     /* 210935 */ /*GILLT_s64*//*Label 4867*/ GIMT_Encode4(211568),
     /* 210939 */ /*GILLT_s80*//*Label 4868*/ GIMT_Encode4(212171), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210951 */ /*GILLT_v2s64*//*Label 4869*/ GIMT_Encode4(212493), GIMT_Encode4(0),
     /* 210959 */ /*GILLT_v4s32*//*Label 4870*/ GIMT_Encode4(212723),
     /* 210963 */ /*GILLT_v4s64*//*Label 4871*/ GIMT_Encode4(212953), GIMT_Encode4(0),
     /* 210971 */ /*GILLT_v8s16*//*Label 4872*/ GIMT_Encode4(213152),
     /* 210975 */ /*GILLT_v8s32*//*Label 4873*/ GIMT_Encode4(213250),
     /* 210979 */ /*GILLT_v8s64*//*Label 4874*/ GIMT_Encode4(213449), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210991 */ /*GILLT_v16s16*//*Label 4875*/ GIMT_Encode4(213547),
     /* 210995 */ /*GILLT_v16s32*//*Label 4876*/ GIMT_Encode4(213645), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 211007 */ /*GILLT_v32s16*//*Label 4877*/ GIMT_Encode4(213743),
     /* 211011 */ // Label 4865: @211011
     /* 211011 */ GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(211108),
     /* 211016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 211019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 211022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 211026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 211030 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(211084), // Rule ID 6067 //
     /* 211035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 211038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211046 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211049 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211053 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211059 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211066 */     // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrm),
     /* 211069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211071 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211082 */     GIR_RootConstrainSelectedInstOperands,
     /* 211083 */     // GIR_Coverage, 6067,
     /* 211083 */     GIR_EraseRootFromParent_Done,
     /* 211084 */   // Label 4880: @211084
     /* 211084 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(211107), // Rule ID 6065 //
     /* 211089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 211092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 211096 */     // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 211096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 211101 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211105 */     GIR_RootConstrainSelectedInstOperands,
     /* 211106 */     // GIR_Coverage, 6065,
     /* 211106 */     GIR_Done,
     /* 211107 */   // Label 4881: @211107
     /* 211107 */   GIM_Reject,
     /* 211108 */ // Label 4879: @211108
     /* 211108 */ GIM_Reject,
     /* 211109 */ // Label 4866: @211109
     /* 211109 */ GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(211567),
     /* 211114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 211117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211120 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(211185), // Rule ID 953 //
     /* 211125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 211128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211147 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211164 */     // (strict_fsub:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp32m),
     /* 211167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211183 */     GIR_RootConstrainSelectedInstOperands,
     /* 211184 */     // GIR_Coverage, 953,
     /* 211184 */     GIR_EraseRootFromParent_Done,
     /* 211185 */   // Label 4883: @211185
     /* 211185 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(211250), // Rule ID 931 //
     /* 211190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 211193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211209 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211216 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211229 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32m),
     /* 211232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211234 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211236 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211248 */     GIR_RootConstrainSelectedInstOperands,
     /* 211249 */     // GIR_Coverage, 931,
     /* 211249 */     GIR_EraseRootFromParent_Done,
     /* 211250 */   // Label 4884: @211250
     /* 211250 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(211312), // Rule ID 2239 //
     /* 211255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211274 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211277 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211281 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211294 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 211297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211299 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211310 */     GIR_RootConstrainSelectedInstOperands,
     /* 211311 */     // GIR_Coverage, 2239,
     /* 211311 */     GIR_EraseRootFromParent_Done,
     /* 211312 */   // Label 4885: @211312
     /* 211312 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(211374), // Rule ID 2247 //
     /* 211317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 211320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211336 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211339 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211356 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 211359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211372 */     GIR_RootConstrainSelectedInstOperands,
     /* 211373 */     // GIR_Coverage, 2247,
     /* 211373 */     GIR_EraseRootFromParent_Done,
     /* 211374 */   // Label 4886: @211374
     /* 211374 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(211436), // Rule ID 6029 //
     /* 211379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211398 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211405 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211418 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 211421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211425 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211434 */     GIR_RootConstrainSelectedInstOperands,
     /* 211435 */     // GIR_Coverage, 6029,
     /* 211435 */     GIR_EraseRootFromParent_Done,
     /* 211436 */   // Label 4887: @211436
     /* 211436 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(211473), // Rule ID 891 //
     /* 211441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 211444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211456 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 211456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 211461 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 211467 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 211471 */     GIR_RootConstrainSelectedInstOperands,
     /* 211472 */     // GIR_Coverage, 891,
     /* 211472 */     GIR_Done,
     /* 211473 */   // Label 4888: @211473
     /* 211473 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(211504), // Rule ID 2237 //
     /* 211478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211493 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 211493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 211498 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211502 */     GIR_RootConstrainSelectedInstOperands,
     /* 211503 */     // GIR_Coverage, 2237,
     /* 211503 */     GIR_Done,
     /* 211504 */   // Label 4889: @211504
     /* 211504 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(211535), // Rule ID 2245 //
     /* 211509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 211512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211524 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 211524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 211529 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211533 */     GIR_RootConstrainSelectedInstOperands,
     /* 211534 */     // GIR_Coverage, 2245,
     /* 211534 */     GIR_Done,
     /* 211535 */   // Label 4890: @211535
     /* 211535 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(211566), // Rule ID 6027 //
     /* 211540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211555 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 211555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 211560 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211564 */     GIR_RootConstrainSelectedInstOperands,
     /* 211565 */     // GIR_Coverage, 6027,
     /* 211565 */     GIR_Done,
     /* 211566 */   // Label 4891: @211566
     /* 211566 */   GIM_Reject,
     /* 211567 */ // Label 4882: @211567
     /* 211567 */ GIM_Reject,
     /* 211568 */ // Label 4867: @211568
     /* 211568 */ GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(212170),
     /* 211573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 211576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211579 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(211644), // Rule ID 955 //
     /* 211584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211599 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211606 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211623 */     // (strict_fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m),
     /* 211626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211628 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211630 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211642 */     GIR_RootConstrainSelectedInstOperands,
     /* 211643 */     // GIR_Coverage, 955,
     /* 211643 */     GIR_EraseRootFromParent_Done,
     /* 211644 */   // Label 4893: @211644
     /* 211644 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(211716), // Rule ID 957 //
     /* 211649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211664 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211667 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211671 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211678 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211695 */     // (strict_fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m32),
     /* 211698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211700 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211702 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211714 */     GIR_RootConstrainSelectedInstOperands,
     /* 211715 */     // GIR_Coverage, 957,
     /* 211715 */     GIR_EraseRootFromParent_Done,
     /* 211716 */   // Label 4894: @211716
     /* 211716 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(211781), // Rule ID 933 //
     /* 211721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211740 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211747 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211760 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m),
     /* 211763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211765 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211779 */     GIR_RootConstrainSelectedInstOperands,
     /* 211780 */     // GIR_Coverage, 933,
     /* 211780 */     GIR_EraseRootFromParent_Done,
     /* 211781 */   // Label 4895: @211781
     /* 211781 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(211853), // Rule ID 935 //
     /* 211786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211805 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211808 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211812 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211832 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m32),
     /* 211835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211837 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211851 */     GIR_RootConstrainSelectedInstOperands,
     /* 211852 */     // GIR_Coverage, 935,
     /* 211852 */     GIR_EraseRootFromParent_Done,
     /* 211853 */   // Label 4896: @211853
     /* 211853 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(211915), // Rule ID 2243 //
     /* 211858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211877 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211880 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211884 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211897 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 211900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211902 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211904 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211913 */     GIR_RootConstrainSelectedInstOperands,
     /* 211914 */     // GIR_Coverage, 2243,
     /* 211914 */     GIR_EraseRootFromParent_Done,
     /* 211915 */   // Label 4897: @211915
     /* 211915 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(211977), // Rule ID 2251 //
     /* 211920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 211923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211939 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211946 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211959 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 211962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211975 */     GIR_RootConstrainSelectedInstOperands,
     /* 211976 */     // GIR_Coverage, 2251,
     /* 211976 */     GIR_EraseRootFromParent_Done,
     /* 211977 */   // Label 4898: @211977
     /* 211977 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(212039), // Rule ID 6048 //
     /* 211982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212001 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212004 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212008 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212021 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 212024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212026 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212037 */     GIR_RootConstrainSelectedInstOperands,
     /* 212038 */     // GIR_Coverage, 6048,
     /* 212038 */     GIR_EraseRootFromParent_Done,
     /* 212039 */   // Label 4899: @212039
     /* 212039 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(212076), // Rule ID 893 //
     /* 212044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 212047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212059 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 212059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 212064 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 212070 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 212074 */     GIR_RootConstrainSelectedInstOperands,
     /* 212075 */     // GIR_Coverage, 893,
     /* 212075 */     GIR_Done,
     /* 212076 */   // Label 4900: @212076
     /* 212076 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(212107), // Rule ID 2241 //
     /* 212081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 212084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212096 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 212096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 212101 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212105 */     GIR_RootConstrainSelectedInstOperands,
     /* 212106 */     // GIR_Coverage, 2241,
     /* 212106 */     GIR_Done,
     /* 212107 */   // Label 4901: @212107
     /* 212107 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(212138), // Rule ID 2249 //
     /* 212112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 212115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212127 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 212127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 212132 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212136 */     GIR_RootConstrainSelectedInstOperands,
     /* 212137 */     // GIR_Coverage, 2249,
     /* 212137 */     GIR_Done,
     /* 212138 */   // Label 4902: @212138
     /* 212138 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(212169), // Rule ID 6046 //
     /* 212143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 212146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212158 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 212158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 212163 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212167 */     GIR_RootConstrainSelectedInstOperands,
     /* 212168 */     // GIR_Coverage, 6046,
     /* 212168 */     GIR_Done,
     /* 212169 */   // Label 4903: @212169
     /* 212169 */   GIM_Reject,
     /* 212170 */ // Label 4892: @212170
     /* 212170 */ GIM_Reject,
     /* 212171 */ // Label 4868: @212171
     /* 212171 */ GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(212492),
     /* 212176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 212179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 212182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212186 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(212254), // Rule ID 959 //
     /* 212191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212205 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212209 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212216 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212233 */     // (strict_fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m32),
     /* 212236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212238 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212240 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212252 */     GIR_RootConstrainSelectedInstOperands,
     /* 212253 */     // GIR_Coverage, 959,
     /* 212253 */     GIR_EraseRootFromParent_Done,
     /* 212254 */   // Label 4905: @212254
     /* 212254 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(212322), // Rule ID 961 //
     /* 212259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212270 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212273 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212277 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 212284 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212301 */     // (strict_fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m64),
     /* 212304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212306 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212308 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212320 */     GIR_RootConstrainSelectedInstOperands,
     /* 212321 */     // GIR_Coverage, 961,
     /* 212321 */     GIR_EraseRootFromParent_Done,
     /* 212322 */   // Label 4906: @212322
     /* 212322 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(212390), // Rule ID 937 //
     /* 212327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212342 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212345 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212349 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212356 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212369 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m32),
     /* 212372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212374 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212376 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212388 */     GIR_RootConstrainSelectedInstOperands,
     /* 212389 */     // GIR_Coverage, 937,
     /* 212389 */     GIR_EraseRootFromParent_Done,
     /* 212390 */   // Label 4907: @212390
     /* 212390 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(212458), // Rule ID 939 //
     /* 212395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212410 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212413 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212417 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 212424 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212437 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (SUB_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m64),
     /* 212440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212442 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212444 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212448 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212456 */     GIR_RootConstrainSelectedInstOperands,
     /* 212457 */     // GIR_Coverage, 939,
     /* 212457 */     GIR_EraseRootFromParent_Done,
     /* 212458 */   // Label 4908: @212458
     /* 212458 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(212491), // Rule ID 895 //
     /* 212463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212474 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 212474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 212479 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 212485 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 212489 */     GIR_RootConstrainSelectedInstOperands,
     /* 212490 */     // GIR_Coverage, 895,
     /* 212490 */     GIR_Done,
     /* 212491 */   // Label 4909: @212491
     /* 212491 */   GIM_Reject,
     /* 212492 */ // Label 4904: @212492
     /* 212492 */ GIM_Reject,
     /* 212493 */ // Label 4869: @212493
     /* 212493 */ GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(212722),
     /* 212498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 212501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 212504 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(212566), // Rule ID 2219 //
     /* 212509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212528 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212531 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212535 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212548 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDrm),
     /* 212551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212553 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212564 */     GIR_RootConstrainSelectedInstOperands,
     /* 212565 */     // GIR_Coverage, 2219,
     /* 212565 */     GIR_EraseRootFromParent_Done,
     /* 212566 */   // Label 4911: @212566
     /* 212566 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(212628), // Rule ID 6541 //
     /* 212571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212610 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rm),
     /* 212613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212615 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212617 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212626 */     GIR_RootConstrainSelectedInstOperands,
     /* 212627 */     // GIR_Coverage, 6541,
     /* 212627 */     GIR_EraseRootFromParent_Done,
     /* 212628 */   // Label 4912: @212628
     /* 212628 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(212659), // Rule ID 2217 //
     /* 212633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212648 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 212648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 212653 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212657 */     GIR_RootConstrainSelectedInstOperands,
     /* 212658 */     // GIR_Coverage, 2217,
     /* 212658 */     GIR_Done,
     /* 212659 */   // Label 4913: @212659
     /* 212659 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(212690), // Rule ID 2233 //
     /* 212664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 212667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212679 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 212679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 212684 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212688 */     GIR_RootConstrainSelectedInstOperands,
     /* 212689 */     // GIR_Coverage, 2233,
     /* 212689 */     GIR_Done,
     /* 212690 */   // Label 4914: @212690
     /* 212690 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(212721), // Rule ID 6537 //
     /* 212695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212710 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 212710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 212715 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212719 */     GIR_RootConstrainSelectedInstOperands,
     /* 212720 */     // GIR_Coverage, 6537,
     /* 212720 */     GIR_Done,
     /* 212721 */   // Label 4915: @212721
     /* 212721 */   GIM_Reject,
     /* 212722 */ // Label 4910: @212722
     /* 212722 */ GIM_Reject,
     /* 212723 */ // Label 4870: @212723
     /* 212723 */ GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(212952),
     /* 212728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 212731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 212734 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(212796), // Rule ID 2215 //
     /* 212739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212778 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSrm),
     /* 212781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212794 */     GIR_RootConstrainSelectedInstOperands,
     /* 212795 */     // GIR_Coverage, 2215,
     /* 212795 */     GIR_EraseRootFromParent_Done,
     /* 212796 */   // Label 4917: @212796
     /* 212796 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(212858), // Rule ID 6517 //
     /* 212801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212840 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rm),
     /* 212843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212845 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212856 */     GIR_RootConstrainSelectedInstOperands,
     /* 212857 */     // GIR_Coverage, 6517,
     /* 212857 */     GIR_EraseRootFromParent_Done,
     /* 212858 */   // Label 4918: @212858
     /* 212858 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(212889), // Rule ID 2213 //
     /* 212863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212878 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 212878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 212883 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212887 */     GIR_RootConstrainSelectedInstOperands,
     /* 212888 */     // GIR_Coverage, 2213,
     /* 212888 */     GIR_Done,
     /* 212889 */   // Label 4919: @212889
     /* 212889 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(212920), // Rule ID 2229 //
     /* 212894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 212897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212909 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 212909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 212914 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212918 */     GIR_RootConstrainSelectedInstOperands,
     /* 212919 */     // GIR_Coverage, 2229,
     /* 212919 */     GIR_Done,
     /* 212920 */   // Label 4920: @212920
     /* 212920 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(212951), // Rule ID 6513 //
     /* 212925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212940 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 212940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 212945 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212949 */     GIR_RootConstrainSelectedInstOperands,
     /* 212950 */     // GIR_Coverage, 6513,
     /* 212950 */     GIR_Done,
     /* 212951 */   // Label 4921: @212951
     /* 212951 */   GIM_Reject,
     /* 212952 */ // Label 4916: @212952
     /* 212952 */ GIM_Reject,
     /* 212953 */ // Label 4871: @212953
     /* 212953 */ GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(213151),
     /* 212958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 212961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 212964 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(213026), // Rule ID 2227 //
     /* 212969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212988 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212991 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212995 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213008 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrm),
     /* 213011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213013 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213015 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213024 */     GIR_RootConstrainSelectedInstOperands,
     /* 213025 */     // GIR_Coverage, 2227,
     /* 213025 */     GIR_EraseRootFromParent_Done,
     /* 213026 */   // Label 4923: @213026
     /* 213026 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(213088), // Rule ID 6553 //
     /* 213031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213050 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213053 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213057 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213070 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rm),
     /* 213073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213075 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213077 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213086 */     GIR_RootConstrainSelectedInstOperands,
     /* 213087 */     // GIR_Coverage, 6553,
     /* 213087 */     GIR_EraseRootFromParent_Done,
     /* 213088 */   // Label 4924: @213088
     /* 213088 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(213119), // Rule ID 2225 //
     /* 213093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213108 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 213108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 213113 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213117 */     GIR_RootConstrainSelectedInstOperands,
     /* 213118 */     // GIR_Coverage, 2225,
     /* 213118 */     GIR_Done,
     /* 213119 */   // Label 4925: @213119
     /* 213119 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(213150), // Rule ID 6549 //
     /* 213124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213139 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 213139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 213144 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213148 */     GIR_RootConstrainSelectedInstOperands,
     /* 213149 */     // GIR_Coverage, 6549,
     /* 213149 */     GIR_Done,
     /* 213150 */   // Label 4926: @213150
     /* 213150 */   GIM_Reject,
     /* 213151 */ // Label 4922: @213151
     /* 213151 */ GIM_Reject,
     /* 213152 */ // Label 4872: @213152
     /* 213152 */ GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(213249),
     /* 213157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 213160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 213163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213171 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(213225), // Rule ID 6577 //
     /* 213176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213187 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213194 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213207 */     // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rm),
     /* 213210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213212 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213214 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213223 */     GIR_RootConstrainSelectedInstOperands,
     /* 213224 */     // GIR_Coverage, 6577,
     /* 213224 */     GIR_EraseRootFromParent_Done,
     /* 213225 */   // Label 4928: @213225
     /* 213225 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(213248), // Rule ID 6573 //
     /* 213230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213237 */     // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 213237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 213242 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213246 */     GIR_RootConstrainSelectedInstOperands,
     /* 213247 */     // GIR_Coverage, 6573,
     /* 213247 */     GIR_Done,
     /* 213248 */   // Label 4929: @213248
     /* 213248 */   GIM_Reject,
     /* 213249 */ // Label 4927: @213249
     /* 213249 */ GIM_Reject,
     /* 213250 */ // Label 4873: @213250
     /* 213250 */ GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(213448),
     /* 213255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 213258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 213261 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(213323), // Rule ID 2223 //
     /* 213266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213285 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213288 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213292 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213305 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrm),
     /* 213308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213310 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213312 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213321 */     GIR_RootConstrainSelectedInstOperands,
     /* 213322 */     // GIR_Coverage, 2223,
     /* 213322 */     GIR_EraseRootFromParent_Done,
     /* 213323 */   // Label 4931: @213323
     /* 213323 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(213385), // Rule ID 6529 //
     /* 213328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213347 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213350 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213354 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213367 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rm),
     /* 213370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213372 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213374 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213383 */     GIR_RootConstrainSelectedInstOperands,
     /* 213384 */     // GIR_Coverage, 6529,
     /* 213384 */     GIR_EraseRootFromParent_Done,
     /* 213385 */   // Label 4932: @213385
     /* 213385 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(213416), // Rule ID 2221 //
     /* 213390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213405 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 213405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 213410 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213414 */     GIR_RootConstrainSelectedInstOperands,
     /* 213415 */     // GIR_Coverage, 2221,
     /* 213415 */     GIR_Done,
     /* 213416 */   // Label 4933: @213416
     /* 213416 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(213447), // Rule ID 6525 //
     /* 213421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213436 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 213436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 213441 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213445 */     GIR_RootConstrainSelectedInstOperands,
     /* 213446 */     // GIR_Coverage, 6525,
     /* 213446 */     GIR_Done,
     /* 213447 */   // Label 4934: @213447
     /* 213447 */   GIM_Reject,
     /* 213448 */ // Label 4930: @213448
     /* 213448 */ GIM_Reject,
     /* 213449 */ // Label 4874: @213449
     /* 213449 */ GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(213546),
     /* 213454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 213457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 213460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213468 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(213522), // Rule ID 6505 //
     /* 213473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 213476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213484 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213491 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213504 */     // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrm),
     /* 213507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213509 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213520 */     GIR_RootConstrainSelectedInstOperands,
     /* 213521 */     // GIR_Coverage, 6505,
     /* 213521 */     GIR_EraseRootFromParent_Done,
     /* 213522 */   // Label 4936: @213522
     /* 213522 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(213545), // Rule ID 6501 //
     /* 213527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 213530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213534 */     // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 213534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 213539 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213543 */     GIR_RootConstrainSelectedInstOperands,
     /* 213544 */     // GIR_Coverage, 6501,
     /* 213544 */     GIR_Done,
     /* 213545 */   // Label 4937: @213545
     /* 213545 */   GIM_Reject,
     /* 213546 */ // Label 4935: @213546
     /* 213546 */ GIM_Reject,
     /* 213547 */ // Label 4875: @213547
     /* 213547 */ GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(213644),
     /* 213552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 213555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 213558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213566 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(213620), // Rule ID 6589 //
     /* 213571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213602 */     // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rm),
     /* 213605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213618 */     GIR_RootConstrainSelectedInstOperands,
     /* 213619 */     // GIR_Coverage, 6589,
     /* 213619 */     GIR_EraseRootFromParent_Done,
     /* 213620 */   // Label 4939: @213620
     /* 213620 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(213643), // Rule ID 6585 //
     /* 213625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213632 */     // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 213632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 213637 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213641 */     GIR_RootConstrainSelectedInstOperands,
     /* 213642 */     // GIR_Coverage, 6585,
     /* 213642 */     GIR_Done,
     /* 213643 */   // Label 4940: @213643
     /* 213643 */   GIM_Reject,
     /* 213644 */ // Label 4938: @213644
     /* 213644 */ GIM_Reject,
     /* 213645 */ // Label 4876: @213645
     /* 213645 */ GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(213742),
     /* 213650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 213653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 213656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213664 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(213718), // Rule ID 6493 //
     /* 213669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 213672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213680 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213687 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213700 */     // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrm),
     /* 213703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213705 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213707 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213716 */     GIR_RootConstrainSelectedInstOperands,
     /* 213717 */     // GIR_Coverage, 6493,
     /* 213717 */     GIR_EraseRootFromParent_Done,
     /* 213718 */   // Label 4942: @213718
     /* 213718 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(213741), // Rule ID 6489 //
     /* 213723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 213726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213730 */     // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 213730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 213735 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213739 */     GIR_RootConstrainSelectedInstOperands,
     /* 213740 */     // GIR_Coverage, 6489,
     /* 213740 */     GIR_Done,
     /* 213741 */   // Label 4943: @213741
     /* 213741 */   GIM_Reject,
     /* 213742 */ // Label 4941: @213742
     /* 213742 */ GIM_Reject,
     /* 213743 */ // Label 4877: @213743
     /* 213743 */ GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(213840),
     /* 213748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 213751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 213754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213762 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(213816), // Rule ID 6565 //
     /* 213767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 213770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213778 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213781 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213785 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213798 */     // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrm),
     /* 213801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213803 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213805 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213814 */     GIR_RootConstrainSelectedInstOperands,
     /* 213815 */     // GIR_Coverage, 6565,
     /* 213815 */     GIR_EraseRootFromParent_Done,
     /* 213816 */   // Label 4945: @213816
     /* 213816 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(213839), // Rule ID 6561 //
     /* 213821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 213824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213828 */     // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 213828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 213833 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213837 */     GIR_RootConstrainSelectedInstOperands,
     /* 213838 */     // GIR_Coverage, 6561,
     /* 213838 */     GIR_Done,
     /* 213839 */   // Label 4946: @213839
     /* 213839 */   GIM_Reject,
     /* 213840 */ // Label 4944: @213840
     /* 213840 */ GIM_Reject,
     /* 213841 */ // Label 4878: @213841
     /* 213841 */ GIM_Reject,
     /* 213842 */ // Label 70: @213842
     /* 213842 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4960*/ GIMT_Encode4(218007),
     /* 213853 */ /*GILLT_s16*//*Label 4947*/ GIMT_Encode4(213937),
     /* 213857 */ /*GILLT_s32*//*Label 4948*/ GIMT_Encode4(214097),
     /* 213861 */ /*GILLT_s64*//*Label 4949*/ GIMT_Encode4(214742),
     /* 213865 */ /*GILLT_s80*//*Label 4950*/ GIMT_Encode4(215531), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 213877 */ /*GILLT_v2s64*//*Label 4951*/ GIMT_Encode4(215853), GIMT_Encode4(0),
     /* 213885 */ /*GILLT_v4s32*//*Label 4952*/ GIMT_Encode4(216207),
     /* 213889 */ /*GILLT_v4s64*//*Label 4953*/ GIMT_Encode4(216561), GIMT_Encode4(0),
     /* 213897 */ /*GILLT_v8s16*//*Label 4954*/ GIMT_Encode4(216884),
     /* 213901 */ /*GILLT_v8s32*//*Label 4955*/ GIMT_Encode4(217044),
     /* 213905 */ /*GILLT_v8s64*//*Label 4956*/ GIMT_Encode4(217367), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 213917 */ /*GILLT_v16s16*//*Label 4957*/ GIMT_Encode4(217527),
     /* 213921 */ /*GILLT_v16s32*//*Label 4958*/ GIMT_Encode4(217687), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 213933 */ /*GILLT_v32s16*//*Label 4959*/ GIMT_Encode4(217847),
     /* 213937 */ // Label 4947: @213937
     /* 213937 */ GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(214096),
     /* 213942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 213945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 213948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 213952 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(214010), // Rule ID 24252 //
     /* 213957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 213960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213968 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213971 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213975 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 213983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213992 */     // (strict_fmul:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 213995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213997 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214008 */     GIR_RootConstrainSelectedInstOperands,
     /* 214009 */     // GIR_Coverage, 24252,
     /* 214009 */     GIR_EraseRootFromParent_Done,
     /* 214010 */   // Label 4962: @214010
     /* 214010 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(214068), // Rule ID 6010 //
     /* 214015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 214022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214030 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214033 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214037 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214050 */     // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 214053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214055 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214057 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214066 */     GIR_RootConstrainSelectedInstOperands,
     /* 214067 */     // GIR_Coverage, 6010,
     /* 214067 */     GIR_EraseRootFromParent_Done,
     /* 214068 */   // Label 4963: @214068
     /* 214068 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(214095), // Rule ID 6008 //
     /* 214073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 214080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 214084 */     // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 214084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 214089 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214093 */     GIR_RootConstrainSelectedInstOperands,
     /* 214094 */     // GIR_Coverage, 6008,
     /* 214094 */     GIR_Done,
     /* 214095 */   // Label 4964: @214095
     /* 214095 */   GIM_Reject,
     /* 214096 */ // Label 4961: @214096
     /* 214096 */ GIM_Reject,
     /* 214097 */ // Label 4948: @214097
     /* 214097 */ GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(214741),
     /* 214102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 214105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 214108 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(214173), // Rule ID 23255 //
     /* 214113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 214116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214128 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214131 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214135 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214152 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 214155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214157 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214171 */     GIR_RootConstrainSelectedInstOperands,
     /* 214172 */     // GIR_Coverage, 23255,
     /* 214172 */     GIR_EraseRootFromParent_Done,
     /* 214173 */   // Label 4966: @214173
     /* 214173 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(214235), // Rule ID 23398 //
     /* 214178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 214181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214193 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214196 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214200 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214217 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 214220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214222 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214224 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214233 */     GIR_RootConstrainSelectedInstOperands,
     /* 214234 */     // GIR_Coverage, 23398,
     /* 214234 */     GIR_EraseRootFromParent_Done,
     /* 214235 */   // Label 4967: @214235
     /* 214235 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(214297), // Rule ID 23402 //
     /* 214240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 214243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214255 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214258 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214262 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214279 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 214282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214286 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214295 */     GIR_RootConstrainSelectedInstOperands,
     /* 214296 */     // GIR_Coverage, 23402,
     /* 214296 */     GIR_EraseRootFromParent_Done,
     /* 214297 */   // Label 4968: @214297
     /* 214297 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(214359), // Rule ID 24248 //
     /* 214302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214317 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214324 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214341 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 214344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214346 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214348 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214357 */     GIR_RootConstrainSelectedInstOperands,
     /* 214358 */     // GIR_Coverage, 24248,
     /* 214358 */     GIR_EraseRootFromParent_Done,
     /* 214359 */   // Label 4969: @214359
     /* 214359 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(214424), // Rule ID 975 //
     /* 214364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 214367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214383 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214386 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214390 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214403 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 214406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214408 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214422 */     GIR_RootConstrainSelectedInstOperands,
     /* 214423 */     // GIR_Coverage, 975,
     /* 214423 */     GIR_EraseRootFromParent_Done,
     /* 214424 */   // Label 4970: @214424
     /* 214424 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(214486), // Rule ID 2199 //
     /* 214429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 214432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214455 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214468 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 214471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214473 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214484 */     GIR_RootConstrainSelectedInstOperands,
     /* 214485 */     // GIR_Coverage, 2199,
     /* 214485 */     GIR_EraseRootFromParent_Done,
     /* 214486 */   // Label 4971: @214486
     /* 214486 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(214548), // Rule ID 2207 //
     /* 214491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 214494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214510 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214517 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214530 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 214533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214537 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214546 */     GIR_RootConstrainSelectedInstOperands,
     /* 214547 */     // GIR_Coverage, 2207,
     /* 214547 */     GIR_EraseRootFromParent_Done,
     /* 214548 */   // Label 4972: @214548
     /* 214548 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(214610), // Rule ID 5972 //
     /* 214553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214592 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 214595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214597 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214608 */     GIR_RootConstrainSelectedInstOperands,
     /* 214609 */     // GIR_Coverage, 5972,
     /* 214609 */     GIR_EraseRootFromParent_Done,
     /* 214610 */   // Label 4973: @214610
     /* 214610 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(214647), // Rule ID 897 //
     /* 214615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 214618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 214630 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 214630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 214635 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 214641 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 214645 */     GIR_RootConstrainSelectedInstOperands,
     /* 214646 */     // GIR_Coverage, 897,
     /* 214646 */     GIR_Done,
     /* 214647 */   // Label 4974: @214647
     /* 214647 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(214678), // Rule ID 2197 //
     /* 214652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 214655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214667 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 214667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 214672 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214676 */     GIR_RootConstrainSelectedInstOperands,
     /* 214677 */     // GIR_Coverage, 2197,
     /* 214677 */     GIR_Done,
     /* 214678 */   // Label 4975: @214678
     /* 214678 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(214709), // Rule ID 2205 //
     /* 214683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 214686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214698 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 214698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 214703 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214707 */     GIR_RootConstrainSelectedInstOperands,
     /* 214708 */     // GIR_Coverage, 2205,
     /* 214708 */     GIR_Done,
     /* 214709 */   // Label 4976: @214709
     /* 214709 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(214740), // Rule ID 5970 //
     /* 214714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214729 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 214729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 214734 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214738 */     GIR_RootConstrainSelectedInstOperands,
     /* 214739 */     // GIR_Coverage, 5970,
     /* 214739 */     GIR_Done,
     /* 214740 */   // Label 4977: @214740
     /* 214740 */   GIM_Reject,
     /* 214741 */ // Label 4965: @214741
     /* 214741 */ GIM_Reject,
     /* 214742 */ // Label 4949: @214742
     /* 214742 */ GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(215530),
     /* 214747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 214750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214753 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(214818), // Rule ID 23257 //
     /* 214758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 214761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214773 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214776 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214780 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214797 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 214800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214802 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214816 */     GIR_RootConstrainSelectedInstOperands,
     /* 214817 */     // GIR_Coverage, 23257,
     /* 214817 */     GIR_EraseRootFromParent_Done,
     /* 214818 */   // Label 4979: @214818
     /* 214818 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(214890), // Rule ID 23259 //
     /* 214823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 214826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214838 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214841 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214845 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 214852 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214869 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 214872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214874 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214888 */     GIR_RootConstrainSelectedInstOperands,
     /* 214889 */     // GIR_Coverage, 23259,
     /* 214889 */     GIR_EraseRootFromParent_Done,
     /* 214890 */   // Label 4980: @214890
     /* 214890 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(214952), // Rule ID 23400 //
     /* 214895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 214898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214910 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214913 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214917 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214934 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 214937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214939 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214950 */     GIR_RootConstrainSelectedInstOperands,
     /* 214951 */     // GIR_Coverage, 23400,
     /* 214951 */     GIR_EraseRootFromParent_Done,
     /* 214952 */   // Label 4981: @214952
     /* 214952 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(215014), // Rule ID 23404 //
     /* 214957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 214960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214996 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 214999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215001 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215003 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215012 */     GIR_RootConstrainSelectedInstOperands,
     /* 215013 */     // GIR_Coverage, 23404,
     /* 215013 */     GIR_EraseRootFromParent_Done,
     /* 215014 */   // Label 4982: @215014
     /* 215014 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(215076), // Rule ID 24250 //
     /* 215019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 215022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215034 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215037 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215041 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215058 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 215061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215063 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215065 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215074 */     GIR_RootConstrainSelectedInstOperands,
     /* 215075 */     // GIR_Coverage, 24250,
     /* 215075 */     GIR_EraseRootFromParent_Done,
     /* 215076 */   // Label 4983: @215076
     /* 215076 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(215141), // Rule ID 977 //
     /* 215081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 215084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215120 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 215123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215125 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215139 */     GIR_RootConstrainSelectedInstOperands,
     /* 215140 */     // GIR_Coverage, 977,
     /* 215140 */     GIR_EraseRootFromParent_Done,
     /* 215141 */   // Label 4984: @215141
     /* 215141 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(215213), // Rule ID 979 //
     /* 215146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 215149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215165 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215168 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215172 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215179 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215192 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 215195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215197 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215211 */     GIR_RootConstrainSelectedInstOperands,
     /* 215212 */     // GIR_Coverage, 979,
     /* 215212 */     GIR_EraseRootFromParent_Done,
     /* 215213 */   // Label 4985: @215213
     /* 215213 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(215275), // Rule ID 2203 //
     /* 215218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 215221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215237 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215240 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215244 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215257 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 215260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215262 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215273 */     GIR_RootConstrainSelectedInstOperands,
     /* 215274 */     // GIR_Coverage, 2203,
     /* 215274 */     GIR_EraseRootFromParent_Done,
     /* 215275 */   // Label 4986: @215275
     /* 215275 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(215337), // Rule ID 2211 //
     /* 215280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 215283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215299 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215302 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215306 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215319 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 215322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215324 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215335 */     GIR_RootConstrainSelectedInstOperands,
     /* 215336 */     // GIR_Coverage, 2211,
     /* 215336 */     GIR_EraseRootFromParent_Done,
     /* 215337 */   // Label 4987: @215337
     /* 215337 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(215399), // Rule ID 5991 //
     /* 215342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 215345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215361 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215364 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215368 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215381 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 215384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215386 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215388 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215397 */     GIR_RootConstrainSelectedInstOperands,
     /* 215398 */     // GIR_Coverage, 5991,
     /* 215398 */     GIR_EraseRootFromParent_Done,
     /* 215399 */   // Label 4988: @215399
     /* 215399 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(215436), // Rule ID 899 //
     /* 215404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 215407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215419 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 215419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 215424 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 215430 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 215434 */     GIR_RootConstrainSelectedInstOperands,
     /* 215435 */     // GIR_Coverage, 899,
     /* 215435 */     GIR_Done,
     /* 215436 */   // Label 4989: @215436
     /* 215436 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(215467), // Rule ID 2201 //
     /* 215441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 215444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215456 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 215456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 215461 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215465 */     GIR_RootConstrainSelectedInstOperands,
     /* 215466 */     // GIR_Coverage, 2201,
     /* 215466 */     GIR_Done,
     /* 215467 */   // Label 4990: @215467
     /* 215467 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(215498), // Rule ID 2209 //
     /* 215472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 215475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 215487 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 215487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 215492 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215496 */     GIR_RootConstrainSelectedInstOperands,
     /* 215497 */     // GIR_Coverage, 2209,
     /* 215497 */     GIR_Done,
     /* 215498 */   // Label 4991: @215498
     /* 215498 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(215529), // Rule ID 5989 //
     /* 215503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 215506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 215518 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 215518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 215523 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215527 */     GIR_RootConstrainSelectedInstOperands,
     /* 215528 */     // GIR_Coverage, 5989,
     /* 215528 */     GIR_Done,
     /* 215529 */   // Label 4992: @215529
     /* 215529 */   GIM_Reject,
     /* 215530 */ // Label 4978: @215530
     /* 215530 */ GIM_Reject,
     /* 215531 */ // Label 4950: @215531
     /* 215531 */ GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(215852),
     /* 215536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 215539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 215542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215546 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(215614), // Rule ID 23261 //
     /* 215551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215565 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215569 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215576 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215593 */     // (strict_fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 215596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215598 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215600 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215612 */     GIR_RootConstrainSelectedInstOperands,
     /* 215613 */     // GIR_Coverage, 23261,
     /* 215613 */     GIR_EraseRootFromParent_Done,
     /* 215614 */   // Label 4994: @215614
     /* 215614 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(215682), // Rule ID 23263 //
     /* 215619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215633 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215637 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 215644 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215661 */     // (strict_fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 215664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215666 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215668 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215680 */     GIR_RootConstrainSelectedInstOperands,
     /* 215681 */     // GIR_Coverage, 23263,
     /* 215681 */     GIR_EraseRootFromParent_Done,
     /* 215682 */   // Label 4995: @215682
     /* 215682 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(215750), // Rule ID 981 //
     /* 215687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215702 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215705 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215709 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215716 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215729 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 215732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215734 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215748 */     GIR_RootConstrainSelectedInstOperands,
     /* 215749 */     // GIR_Coverage, 981,
     /* 215749 */     GIR_EraseRootFromParent_Done,
     /* 215750 */   // Label 4996: @215750
     /* 215750 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(215818), // Rule ID 983 //
     /* 215755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215770 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215773 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215777 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 215784 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215797 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 215800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215802 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215816 */     GIR_RootConstrainSelectedInstOperands,
     /* 215817 */     // GIR_Coverage, 983,
     /* 215817 */     GIR_EraseRootFromParent_Done,
     /* 215818 */   // Label 4997: @215818
     /* 215818 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(215851), // Rule ID 901 //
     /* 215823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215834 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 215834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 215839 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 215845 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 215849 */     GIR_RootConstrainSelectedInstOperands,
     /* 215850 */     // GIR_Coverage, 901,
     /* 215850 */     GIR_Done,
     /* 215851 */   // Label 4998: @215851
     /* 215851 */   GIM_Reject,
     /* 215852 */ // Label 4993: @215852
     /* 215852 */ GIM_Reject,
     /* 215853 */ // Label 4951: @215853
     /* 215853 */ GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(216206),
     /* 215858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215864 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(215926), // Rule ID 23388 //
     /* 215869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 215872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215884 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215887 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215891 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215908 */     // (strict_fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 215911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215913 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215924 */     GIR_RootConstrainSelectedInstOperands,
     /* 215925 */     // GIR_Coverage, 23388,
     /* 215925 */     GIR_EraseRootFromParent_Done,
     /* 215926 */   // Label 5000: @215926
     /* 215926 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(215988), // Rule ID 24364 //
     /* 215931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 215934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215946 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215953 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215970 */     // (strict_fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 215973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215975 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215977 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215986 */     GIR_RootConstrainSelectedInstOperands,
     /* 215987 */     // GIR_Coverage, 24364,
     /* 215987 */     GIR_EraseRootFromParent_Done,
     /* 215988 */   // Label 5001: @215988
     /* 215988 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(216050), // Rule ID 2179 //
     /* 215993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 215996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216012 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216019 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216032 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 216035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216039 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216048 */     GIR_RootConstrainSelectedInstOperands,
     /* 216049 */     // GIR_Coverage, 2179,
     /* 216049 */     GIR_EraseRootFromParent_Done,
     /* 216050 */   // Label 5002: @216050
     /* 216050 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(216112), // Rule ID 6424 //
     /* 216055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216081 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216094 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 216097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216110 */     GIR_RootConstrainSelectedInstOperands,
     /* 216111 */     // GIR_Coverage, 6424,
     /* 216111 */     GIR_EraseRootFromParent_Done,
     /* 216112 */   // Label 5003: @216112
     /* 216112 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(216143), // Rule ID 2177 //
     /* 216117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216132 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 216132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 216137 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216141 */     GIR_RootConstrainSelectedInstOperands,
     /* 216142 */     // GIR_Coverage, 2177,
     /* 216142 */     GIR_Done,
     /* 216143 */   // Label 5004: @216143
     /* 216143 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(216174), // Rule ID 2193 //
     /* 216148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 216151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216163 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 216163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 216168 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216172 */     GIR_RootConstrainSelectedInstOperands,
     /* 216173 */     // GIR_Coverage, 2193,
     /* 216173 */     GIR_Done,
     /* 216174 */   // Label 5005: @216174
     /* 216174 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(216205), // Rule ID 6420 //
     /* 216179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216194 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 216194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 216199 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216203 */     GIR_RootConstrainSelectedInstOperands,
     /* 216204 */     // GIR_Coverage, 6420,
     /* 216204 */     GIR_Done,
     /* 216205 */   // Label 5006: @216205
     /* 216205 */   GIM_Reject,
     /* 216206 */ // Label 4999: @216206
     /* 216206 */ GIM_Reject,
     /* 216207 */ // Label 4952: @216207
     /* 216207 */ GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(216560),
     /* 216212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216218 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(216280), // Rule ID 23386 //
     /* 216223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216238 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216245 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216262 */     // (strict_fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 216265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216267 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216269 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216278 */     GIR_RootConstrainSelectedInstOperands,
     /* 216279 */     // GIR_Coverage, 23386,
     /* 216279 */     GIR_EraseRootFromParent_Done,
     /* 216280 */   // Label 5008: @216280
     /* 216280 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(216342), // Rule ID 24348 //
     /* 216285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216324 */     // (strict_fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 216327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216329 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216340 */     GIR_RootConstrainSelectedInstOperands,
     /* 216341 */     // GIR_Coverage, 24348,
     /* 216341 */     GIR_EraseRootFromParent_Done,
     /* 216342 */   // Label 5009: @216342
     /* 216342 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(216404), // Rule ID 2175 //
     /* 216347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216373 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216386 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 216389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216393 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216402 */     GIR_RootConstrainSelectedInstOperands,
     /* 216403 */     // GIR_Coverage, 2175,
     /* 216403 */     GIR_EraseRootFromParent_Done,
     /* 216404 */   // Label 5010: @216404
     /* 216404 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(216466), // Rule ID 6400 //
     /* 216409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216435 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216448 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 216451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216453 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216464 */     GIR_RootConstrainSelectedInstOperands,
     /* 216465 */     // GIR_Coverage, 6400,
     /* 216465 */     GIR_EraseRootFromParent_Done,
     /* 216466 */   // Label 5011: @216466
     /* 216466 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(216497), // Rule ID 2173 //
     /* 216471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216486 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 216486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 216491 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216495 */     GIR_RootConstrainSelectedInstOperands,
     /* 216496 */     // GIR_Coverage, 2173,
     /* 216496 */     GIR_Done,
     /* 216497 */   // Label 5012: @216497
     /* 216497 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(216528), // Rule ID 2189 //
     /* 216502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 216505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 216517 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 216517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 216522 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216526 */     GIR_RootConstrainSelectedInstOperands,
     /* 216527 */     // GIR_Coverage, 2189,
     /* 216527 */     GIR_Done,
     /* 216528 */   // Label 5013: @216528
     /* 216528 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(216559), // Rule ID 6396 //
     /* 216533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216548 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 216548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 216553 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216557 */     GIR_RootConstrainSelectedInstOperands,
     /* 216558 */     // GIR_Coverage, 6396,
     /* 216558 */     GIR_Done,
     /* 216559 */   // Label 5014: @216559
     /* 216559 */   GIM_Reject,
     /* 216560 */ // Label 5007: @216560
     /* 216560 */ GIM_Reject,
     /* 216561 */ // Label 4953: @216561
     /* 216561 */ GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(216883),
     /* 216566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 216569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 216572 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(216634), // Rule ID 23392 //
     /* 216577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216616 */     // (strict_fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 216619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216621 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216632 */     GIR_RootConstrainSelectedInstOperands,
     /* 216633 */     // GIR_Coverage, 23392,
     /* 216633 */     GIR_EraseRootFromParent_Done,
     /* 216634 */   // Label 5016: @216634
     /* 216634 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(216696), // Rule ID 24372 //
     /* 216639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216654 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216661 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216678 */     // (strict_fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 216681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216683 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216685 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216694 */     GIR_RootConstrainSelectedInstOperands,
     /* 216695 */     // GIR_Coverage, 24372,
     /* 216695 */     GIR_EraseRootFromParent_Done,
     /* 216696 */   // Label 5017: @216696
     /* 216696 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(216758), // Rule ID 2187 //
     /* 216701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216720 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216727 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216740 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 216743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216745 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216756 */     GIR_RootConstrainSelectedInstOperands,
     /* 216757 */     // GIR_Coverage, 2187,
     /* 216757 */     GIR_EraseRootFromParent_Done,
     /* 216758 */   // Label 5018: @216758
     /* 216758 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(216820), // Rule ID 6436 //
     /* 216763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216782 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216785 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216789 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216802 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 216805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216818 */     GIR_RootConstrainSelectedInstOperands,
     /* 216819 */     // GIR_Coverage, 6436,
     /* 216819 */     GIR_EraseRootFromParent_Done,
     /* 216820 */   // Label 5019: @216820
     /* 216820 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(216851), // Rule ID 2185 //
     /* 216825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216840 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 216840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 216845 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216849 */     GIR_RootConstrainSelectedInstOperands,
     /* 216850 */     // GIR_Coverage, 2185,
     /* 216850 */     GIR_Done,
     /* 216851 */   // Label 5020: @216851
     /* 216851 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(216882), // Rule ID 6432 //
     /* 216856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216871 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 216871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 216876 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216880 */     GIR_RootConstrainSelectedInstOperands,
     /* 216881 */     // GIR_Coverage, 6432,
     /* 216881 */     GIR_Done,
     /* 216882 */   // Label 5021: @216882
     /* 216882 */   GIM_Reject,
     /* 216883 */ // Label 5015: @216883
     /* 216883 */ GIM_Reject,
     /* 216884 */ // Label 4954: @216884
     /* 216884 */ GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(217043),
     /* 216889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 216892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216899 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(216957), // Rule ID 24388 //
     /* 216904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 216907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216915 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216918 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216922 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216939 */     // (strict_fmul:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 216942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216944 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216946 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216955 */     GIR_RootConstrainSelectedInstOperands,
     /* 216956 */     // GIR_Coverage, 24388,
     /* 216956 */     GIR_EraseRootFromParent_Done,
     /* 216957 */   // Label 5023: @216957
     /* 216957 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(217015), // Rule ID 6460 //
     /* 216962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 216965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216977 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216980 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216984 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216997 */     // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 217000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217002 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217013 */     GIR_RootConstrainSelectedInstOperands,
     /* 217014 */     // GIR_Coverage, 6460,
     /* 217014 */     GIR_EraseRootFromParent_Done,
     /* 217015 */   // Label 5024: @217015
     /* 217015 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(217042), // Rule ID 6456 //
     /* 217020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 217023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217031 */     // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 217031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 217036 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217040 */     GIR_RootConstrainSelectedInstOperands,
     /* 217041 */     // GIR_Coverage, 6456,
     /* 217041 */     GIR_Done,
     /* 217042 */   // Label 5025: @217042
     /* 217042 */   GIM_Reject,
     /* 217043 */ // Label 5022: @217043
     /* 217043 */ GIM_Reject,
     /* 217044 */ // Label 4955: @217044
     /* 217044 */ GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(217366),
     /* 217049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 217052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 217055 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(217117), // Rule ID 23390 //
     /* 217060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217075 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217082 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217099 */     // (strict_fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 217102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217115 */     GIR_RootConstrainSelectedInstOperands,
     /* 217116 */     // GIR_Coverage, 23390,
     /* 217116 */     GIR_EraseRootFromParent_Done,
     /* 217117 */   // Label 5027: @217117
     /* 217117 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(217179), // Rule ID 24356 //
     /* 217122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217161 */     // (strict_fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 217164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217166 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217168 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217177 */     GIR_RootConstrainSelectedInstOperands,
     /* 217178 */     // GIR_Coverage, 24356,
     /* 217178 */     GIR_EraseRootFromParent_Done,
     /* 217179 */   // Label 5028: @217179
     /* 217179 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(217241), // Rule ID 2183 //
     /* 217184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217203 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217206 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217210 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217223 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 217226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217228 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217230 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217239 */     GIR_RootConstrainSelectedInstOperands,
     /* 217240 */     // GIR_Coverage, 2183,
     /* 217240 */     GIR_EraseRootFromParent_Done,
     /* 217241 */   // Label 5029: @217241
     /* 217241 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(217303), // Rule ID 6412 //
     /* 217246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217265 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217285 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 217288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217290 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217301 */     GIR_RootConstrainSelectedInstOperands,
     /* 217302 */     // GIR_Coverage, 6412,
     /* 217302 */     GIR_EraseRootFromParent_Done,
     /* 217303 */   // Label 5030: @217303
     /* 217303 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(217334), // Rule ID 2181 //
     /* 217308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217323 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 217323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 217328 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217332 */     GIR_RootConstrainSelectedInstOperands,
     /* 217333 */     // GIR_Coverage, 2181,
     /* 217333 */     GIR_Done,
     /* 217334 */   // Label 5031: @217334
     /* 217334 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(217365), // Rule ID 6408 //
     /* 217339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217354 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 217354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 217359 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217363 */     GIR_RootConstrainSelectedInstOperands,
     /* 217364 */     // GIR_Coverage, 6408,
     /* 217364 */     GIR_Done,
     /* 217365 */   // Label 5032: @217365
     /* 217365 */   GIM_Reject,
     /* 217366 */ // Label 5026: @217366
     /* 217366 */ GIM_Reject,
     /* 217367 */ // Label 4956: @217367
     /* 217367 */ GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(217526),
     /* 217372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 217375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 217378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217382 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(217440), // Rule ID 24340 //
     /* 217387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217398 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217405 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217422 */     // (strict_fmul:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 217425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217427 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217438 */     GIR_RootConstrainSelectedInstOperands,
     /* 217439 */     // GIR_Coverage, 24340,
     /* 217439 */     GIR_EraseRootFromParent_Done,
     /* 217440 */   // Label 5034: @217440
     /* 217440 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(217498), // Rule ID 6388 //
     /* 217445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217467 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217480 */     // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 217483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217485 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217487 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217496 */     GIR_RootConstrainSelectedInstOperands,
     /* 217497 */     // GIR_Coverage, 6388,
     /* 217497 */     GIR_EraseRootFromParent_Done,
     /* 217498 */   // Label 5035: @217498
     /* 217498 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(217525), // Rule ID 6384 //
     /* 217503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217514 */     // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 217514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 217519 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217523 */     GIR_RootConstrainSelectedInstOperands,
     /* 217524 */     // GIR_Coverage, 6384,
     /* 217524 */     GIR_Done,
     /* 217525 */   // Label 5036: @217525
     /* 217525 */   GIM_Reject,
     /* 217526 */ // Label 5033: @217526
     /* 217526 */ GIM_Reject,
     /* 217527 */ // Label 4957: @217527
     /* 217527 */ GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(217686),
     /* 217532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 217535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 217538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217542 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(217600), // Rule ID 24396 //
     /* 217547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 217550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217558 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217561 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217565 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217582 */     // (strict_fmul:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 217585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217587 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217598 */     GIR_RootConstrainSelectedInstOperands,
     /* 217599 */     // GIR_Coverage, 24396,
     /* 217599 */     GIR_EraseRootFromParent_Done,
     /* 217600 */   // Label 5038: @217600
     /* 217600 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(217658), // Rule ID 6472 //
     /* 217605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 217608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217620 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217640 */     // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 217643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217656 */     GIR_RootConstrainSelectedInstOperands,
     /* 217657 */     // GIR_Coverage, 6472,
     /* 217657 */     GIR_EraseRootFromParent_Done,
     /* 217658 */   // Label 5039: @217658
     /* 217658 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(217685), // Rule ID 6468 //
     /* 217663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 217666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217674 */     // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 217674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 217679 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217683 */     GIR_RootConstrainSelectedInstOperands,
     /* 217684 */     // GIR_Coverage, 6468,
     /* 217684 */     GIR_Done,
     /* 217685 */   // Label 5040: @217685
     /* 217685 */   GIM_Reject,
     /* 217686 */ // Label 5037: @217686
     /* 217686 */ GIM_Reject,
     /* 217687 */ // Label 4958: @217687
     /* 217687 */ GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(217846),
     /* 217692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 217695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 217698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217702 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(217760), // Rule ID 24332 //
     /* 217707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217718 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217725 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217742 */     // (strict_fmul:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 217745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217749 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217758 */     GIR_RootConstrainSelectedInstOperands,
     /* 217759 */     // GIR_Coverage, 24332,
     /* 217759 */     GIR_EraseRootFromParent_Done,
     /* 217760 */   // Label 5042: @217760
     /* 217760 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(217818), // Rule ID 6376 //
     /* 217765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217780 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217787 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217800 */     // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 217803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217805 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217807 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217816 */     GIR_RootConstrainSelectedInstOperands,
     /* 217817 */     // GIR_Coverage, 6376,
     /* 217817 */     GIR_EraseRootFromParent_Done,
     /* 217818 */   // Label 5043: @217818
     /* 217818 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(217845), // Rule ID 6372 //
     /* 217823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217834 */     // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 217834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 217839 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217843 */     GIR_RootConstrainSelectedInstOperands,
     /* 217844 */     // GIR_Coverage, 6372,
     /* 217844 */     GIR_Done,
     /* 217845 */   // Label 5044: @217845
     /* 217845 */   GIM_Reject,
     /* 217846 */ // Label 5041: @217846
     /* 217846 */ GIM_Reject,
     /* 217847 */ // Label 4959: @217847
     /* 217847 */ GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(218006),
     /* 217852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 217855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 217858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217862 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(217920), // Rule ID 24380 //
     /* 217867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 217870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217878 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217881 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217885 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217902 */     // (strict_fmul:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 217905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217907 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217918 */     GIR_RootConstrainSelectedInstOperands,
     /* 217919 */     // GIR_Coverage, 24380,
     /* 217919 */     GIR_EraseRootFromParent_Done,
     /* 217920 */   // Label 5046: @217920
     /* 217920 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(217978), // Rule ID 6448 //
     /* 217925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 217928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217940 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217947 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217960 */     // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 217963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217967 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217976 */     GIR_RootConstrainSelectedInstOperands,
     /* 217977 */     // GIR_Coverage, 6448,
     /* 217977 */     GIR_EraseRootFromParent_Done,
     /* 217978 */   // Label 5047: @217978
     /* 217978 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(218005), // Rule ID 6444 //
     /* 217983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 217986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217994 */     // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 217994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 217999 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218003 */     GIR_RootConstrainSelectedInstOperands,
     /* 218004 */     // GIR_Coverage, 6444,
     /* 218004 */     GIR_Done,
     /* 218005 */   // Label 5048: @218005
     /* 218005 */   GIM_Reject,
     /* 218006 */ // Label 5045: @218006
     /* 218006 */ GIM_Reject,
     /* 218007 */ // Label 4960: @218007
     /* 218007 */ GIM_Reject,
     /* 218008 */ // Label 71: @218008
     /* 218008 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5062*/ GIMT_Encode4(220933),
     /* 218019 */ /*GILLT_s16*//*Label 5049*/ GIMT_Encode4(218103),
     /* 218023 */ /*GILLT_s32*//*Label 5050*/ GIMT_Encode4(218201),
     /* 218027 */ /*GILLT_s64*//*Label 5051*/ GIMT_Encode4(218660),
     /* 218031 */ /*GILLT_s80*//*Label 5052*/ GIMT_Encode4(219263), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218043 */ /*GILLT_v2s64*//*Label 5053*/ GIMT_Encode4(219585), GIMT_Encode4(0),
     /* 218051 */ /*GILLT_v4s32*//*Label 5054*/ GIMT_Encode4(219815),
     /* 218055 */ /*GILLT_v4s64*//*Label 5055*/ GIMT_Encode4(220045), GIMT_Encode4(0),
     /* 218063 */ /*GILLT_v8s16*//*Label 5056*/ GIMT_Encode4(220244),
     /* 218067 */ /*GILLT_v8s32*//*Label 5057*/ GIMT_Encode4(220342),
     /* 218071 */ /*GILLT_v8s64*//*Label 5058*/ GIMT_Encode4(220541), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218083 */ /*GILLT_v16s16*//*Label 5059*/ GIMT_Encode4(220639),
     /* 218087 */ /*GILLT_v16s32*//*Label 5060*/ GIMT_Encode4(220737), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218099 */ /*GILLT_v32s16*//*Label 5061*/ GIMT_Encode4(220835),
     /* 218103 */ // Label 5049: @218103
     /* 218103 */ GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(218200),
     /* 218108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 218111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 218114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218122 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(218176), // Rule ID 6124 //
     /* 218127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218138 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218141 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218145 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218158 */     // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrm),
     /* 218161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218163 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218174 */     GIR_RootConstrainSelectedInstOperands,
     /* 218175 */     // GIR_Coverage, 6124,
     /* 218175 */     GIR_EraseRootFromParent_Done,
     /* 218176 */   // Label 5064: @218176
     /* 218176 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(218199), // Rule ID 6122 //
     /* 218181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218188 */     // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 218188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 218193 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218197 */     GIR_RootConstrainSelectedInstOperands,
     /* 218198 */     // GIR_Coverage, 6122,
     /* 218198 */     GIR_Done,
     /* 218199 */   // Label 5065: @218199
     /* 218199 */   GIM_Reject,
     /* 218200 */ // Label 5063: @218200
     /* 218200 */ GIM_Reject,
     /* 218201 */ // Label 5050: @218201
     /* 218201 */ GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(218659),
     /* 218206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 218209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218212 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(218277), // Rule ID 1019 //
     /* 218217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 218220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218256 */     // (strict_fdiv:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp32m),
     /* 218259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218263 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218275 */     GIR_RootConstrainSelectedInstOperands,
     /* 218276 */     // GIR_Coverage, 1019,
     /* 218276 */     GIR_EraseRootFromParent_Done,
     /* 218277 */   // Label 5067: @218277
     /* 218277 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(218342), // Rule ID 997 //
     /* 218282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 218285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218301 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218304 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218308 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218321 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32m),
     /* 218324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218326 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218328 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218340 */     GIR_RootConstrainSelectedInstOperands,
     /* 218341 */     // GIR_Coverage, 997,
     /* 218341 */     GIR_EraseRootFromParent_Done,
     /* 218342 */   // Label 5068: @218342
     /* 218342 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(218404), // Rule ID 2279 //
     /* 218347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 218350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218373 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218386 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 218389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218393 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218402 */     GIR_RootConstrainSelectedInstOperands,
     /* 218403 */     // GIR_Coverage, 2279,
     /* 218403 */     GIR_EraseRootFromParent_Done,
     /* 218404 */   // Label 5069: @218404
     /* 218404 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(218466), // Rule ID 2287 //
     /* 218409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 218412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218435 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218448 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 218451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218453 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218464 */     GIR_RootConstrainSelectedInstOperands,
     /* 218465 */     // GIR_Coverage, 2287,
     /* 218465 */     GIR_EraseRootFromParent_Done,
     /* 218466 */   // Label 5070: @218466
     /* 218466 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(218528), // Rule ID 6086 //
     /* 218471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 218478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 218482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218490 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218493 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218497 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218510 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 218513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218515 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218517 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218526 */     GIR_RootConstrainSelectedInstOperands,
     /* 218527 */     // GIR_Coverage, 6086,
     /* 218527 */     GIR_EraseRootFromParent_Done,
     /* 218528 */   // Label 5071: @218528
     /* 218528 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(218565), // Rule ID 903 //
     /* 218533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 218536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218548 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 218548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 218553 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 218559 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 218563 */     GIR_RootConstrainSelectedInstOperands,
     /* 218564 */     // GIR_Coverage, 903,
     /* 218564 */     GIR_Done,
     /* 218565 */   // Label 5072: @218565
     /* 218565 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(218596), // Rule ID 2277 //
     /* 218570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 218573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218585 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 218585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 218590 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218594 */     GIR_RootConstrainSelectedInstOperands,
     /* 218595 */     // GIR_Coverage, 2277,
     /* 218595 */     GIR_Done,
     /* 218596 */   // Label 5073: @218596
     /* 218596 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(218627), // Rule ID 2285 //
     /* 218601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 218604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 218616 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 218616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 218621 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218625 */     GIR_RootConstrainSelectedInstOperands,
     /* 218626 */     // GIR_Coverage, 2285,
     /* 218626 */     GIR_Done,
     /* 218627 */   // Label 5074: @218627
     /* 218627 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(218658), // Rule ID 6084 //
     /* 218632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 218639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 218643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 218647 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 218647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 218652 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218656 */     GIR_RootConstrainSelectedInstOperands,
     /* 218657 */     // GIR_Coverage, 6084,
     /* 218657 */     GIR_Done,
     /* 218658 */   // Label 5075: @218658
     /* 218658 */   GIM_Reject,
     /* 218659 */ // Label 5066: @218659
     /* 218659 */ GIM_Reject,
     /* 218660 */ // Label 5051: @218660
     /* 218660 */ GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(219262),
     /* 218665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 218668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218671 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(218736), // Rule ID 1021 //
     /* 218676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218691 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218694 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218698 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218715 */     // (strict_fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m),
     /* 218718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218720 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218722 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218734 */     GIR_RootConstrainSelectedInstOperands,
     /* 218735 */     // GIR_Coverage, 1021,
     /* 218735 */     GIR_EraseRootFromParent_Done,
     /* 218736 */   // Label 5077: @218736
     /* 218736 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(218808), // Rule ID 1023 //
     /* 218741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218756 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218759 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218763 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 218770 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218787 */     // (strict_fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m32),
     /* 218790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218792 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218794 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218806 */     GIR_RootConstrainSelectedInstOperands,
     /* 218807 */     // GIR_Coverage, 1023,
     /* 218807 */     GIR_EraseRootFromParent_Done,
     /* 218808 */   // Label 5078: @218808
     /* 218808 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(218873), // Rule ID 999 //
     /* 218813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218832 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218835 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218839 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218852 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m),
     /* 218855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218857 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218859 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218871 */     GIR_RootConstrainSelectedInstOperands,
     /* 218872 */     // GIR_Coverage, 999,
     /* 218872 */     GIR_EraseRootFromParent_Done,
     /* 218873 */   // Label 5079: @218873
     /* 218873 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(218945), // Rule ID 1001 //
     /* 218878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218897 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218900 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218904 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 218911 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218924 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m32),
     /* 218927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218929 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218943 */     GIR_RootConstrainSelectedInstOperands,
     /* 218944 */     // GIR_Coverage, 1001,
     /* 218944 */     GIR_EraseRootFromParent_Done,
     /* 218945 */   // Label 5080: @218945
     /* 218945 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(219007), // Rule ID 2283 //
     /* 218950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 218953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218969 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218972 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218976 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218989 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 218992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218994 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218996 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219005 */     GIR_RootConstrainSelectedInstOperands,
     /* 219006 */     // GIR_Coverage, 2283,
     /* 219006 */     GIR_EraseRootFromParent_Done,
     /* 219007 */   // Label 5081: @219007
     /* 219007 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(219069), // Rule ID 2291 //
     /* 219012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 219015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219031 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219034 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219038 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219051 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 219054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219056 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219058 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219067 */     GIR_RootConstrainSelectedInstOperands,
     /* 219068 */     // GIR_Coverage, 2291,
     /* 219068 */     GIR_EraseRootFromParent_Done,
     /* 219069 */   // Label 5082: @219069
     /* 219069 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(219131), // Rule ID 6105 //
     /* 219074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 219081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 219085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219093 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219096 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219100 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219113 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 219116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219118 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219120 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219129 */     GIR_RootConstrainSelectedInstOperands,
     /* 219130 */     // GIR_Coverage, 6105,
     /* 219130 */     GIR_EraseRootFromParent_Done,
     /* 219131 */   // Label 5083: @219131
     /* 219131 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(219168), // Rule ID 905 //
     /* 219136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 219139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219151 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 219151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 219156 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 219162 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 219166 */     GIR_RootConstrainSelectedInstOperands,
     /* 219167 */     // GIR_Coverage, 905,
     /* 219167 */     GIR_Done,
     /* 219168 */   // Label 5084: @219168
     /* 219168 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(219199), // Rule ID 2281 //
     /* 219173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 219176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219188 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 219188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 219193 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219197 */     GIR_RootConstrainSelectedInstOperands,
     /* 219198 */     // GIR_Coverage, 2281,
     /* 219198 */     GIR_Done,
     /* 219199 */   // Label 5085: @219199
     /* 219199 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(219230), // Rule ID 2289 //
     /* 219204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 219207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 219219 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 219219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 219224 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219228 */     GIR_RootConstrainSelectedInstOperands,
     /* 219229 */     // GIR_Coverage, 2289,
     /* 219229 */     GIR_Done,
     /* 219230 */   // Label 5086: @219230
     /* 219230 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(219261), // Rule ID 6103 //
     /* 219235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 219242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 219246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 219250 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 219250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 219255 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219259 */     GIR_RootConstrainSelectedInstOperands,
     /* 219260 */     // GIR_Coverage, 6103,
     /* 219260 */     GIR_Done,
     /* 219261 */   // Label 5087: @219261
     /* 219261 */   GIM_Reject,
     /* 219262 */ // Label 5076: @219262
     /* 219262 */ GIM_Reject,
     /* 219263 */ // Label 5052: @219263
     /* 219263 */ GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(219584),
     /* 219268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 219271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 219274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219278 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(219346), // Rule ID 1025 //
     /* 219283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 219286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219297 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219301 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 219308 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219325 */     // (strict_fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m32),
     /* 219328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219330 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219344 */     GIR_RootConstrainSelectedInstOperands,
     /* 219345 */     // GIR_Coverage, 1025,
     /* 219345 */     GIR_EraseRootFromParent_Done,
     /* 219346 */   // Label 5089: @219346
     /* 219346 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(219414), // Rule ID 1027 //
     /* 219351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 219354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219362 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219365 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219369 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 219376 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219393 */     // (strict_fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m64),
     /* 219396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219398 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219400 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219412 */     GIR_RootConstrainSelectedInstOperands,
     /* 219413 */     // GIR_Coverage, 1027,
     /* 219413 */     GIR_EraseRootFromParent_Done,
     /* 219414 */   // Label 5090: @219414
     /* 219414 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(219482), // Rule ID 1003 //
     /* 219419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 219422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219434 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219437 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219441 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 219448 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219461 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m32),
     /* 219464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219466 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219480 */     GIR_RootConstrainSelectedInstOperands,
     /* 219481 */     // GIR_Coverage, 1003,
     /* 219481 */     GIR_EraseRootFromParent_Done,
     /* 219482 */   // Label 5091: @219482
     /* 219482 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(219550), // Rule ID 1005 //
     /* 219487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 219490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219502 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219505 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219509 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 219516 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219529 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (DIV_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m64),
     /* 219532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219536 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219548 */     GIR_RootConstrainSelectedInstOperands,
     /* 219549 */     // GIR_Coverage, 1005,
     /* 219549 */     GIR_EraseRootFromParent_Done,
     /* 219550 */   // Label 5092: @219550
     /* 219550 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(219583), // Rule ID 907 //
     /* 219555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 219558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 219566 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 219566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 219571 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 219577 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 219581 */     GIR_RootConstrainSelectedInstOperands,
     /* 219582 */     // GIR_Coverage, 907,
     /* 219582 */     GIR_Done,
     /* 219583 */   // Label 5093: @219583
     /* 219583 */   GIM_Reject,
     /* 219584 */ // Label 5088: @219584
     /* 219584 */ GIM_Reject,
     /* 219585 */ // Label 5053: @219585
     /* 219585 */ GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(219814),
     /* 219590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 219596 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(219658), // Rule ID 2259 //
     /* 219601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219620 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219640 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDrm),
     /* 219643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219656 */     GIR_RootConstrainSelectedInstOperands,
     /* 219657 */     // GIR_Coverage, 2259,
     /* 219657 */     GIR_EraseRootFromParent_Done,
     /* 219658 */   // Label 5095: @219658
     /* 219658 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(219720), // Rule ID 6658 //
     /* 219663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219682 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219685 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219689 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219702 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rm),
     /* 219705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219707 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219718 */     GIR_RootConstrainSelectedInstOperands,
     /* 219719 */     // GIR_Coverage, 6658,
     /* 219719 */     GIR_EraseRootFromParent_Done,
     /* 219720 */   // Label 5096: @219720
     /* 219720 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(219751), // Rule ID 2257 //
     /* 219725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219740 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 219740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 219745 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219749 */     GIR_RootConstrainSelectedInstOperands,
     /* 219750 */     // GIR_Coverage, 2257,
     /* 219750 */     GIR_Done,
     /* 219751 */   // Label 5097: @219751
     /* 219751 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(219782), // Rule ID 2273 //
     /* 219756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 219759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219771 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 219771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 219776 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219780 */     GIR_RootConstrainSelectedInstOperands,
     /* 219781 */     // GIR_Coverage, 2273,
     /* 219781 */     GIR_Done,
     /* 219782 */   // Label 5098: @219782
     /* 219782 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(219813), // Rule ID 6654 //
     /* 219787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219802 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 219802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 219807 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219811 */     GIR_RootConstrainSelectedInstOperands,
     /* 219812 */     // GIR_Coverage, 6654,
     /* 219812 */     GIR_Done,
     /* 219813 */   // Label 5099: @219813
     /* 219813 */   GIM_Reject,
     /* 219814 */ // Label 5094: @219814
     /* 219814 */ GIM_Reject,
     /* 219815 */ // Label 5054: @219815
     /* 219815 */ GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(220044),
     /* 219820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219826 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(219888), // Rule ID 2255 //
     /* 219831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219850 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219853 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219857 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219870 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSrm),
     /* 219873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219875 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219886 */     GIR_RootConstrainSelectedInstOperands,
     /* 219887 */     // GIR_Coverage, 2255,
     /* 219887 */     GIR_EraseRootFromParent_Done,
     /* 219888 */   // Label 5101: @219888
     /* 219888 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(219950), // Rule ID 6634 //
     /* 219893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219912 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219915 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219919 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219932 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rm),
     /* 219935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219937 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219948 */     GIR_RootConstrainSelectedInstOperands,
     /* 219949 */     // GIR_Coverage, 6634,
     /* 219949 */     GIR_EraseRootFromParent_Done,
     /* 219950 */   // Label 5102: @219950
     /* 219950 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(219981), // Rule ID 2253 //
     /* 219955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219970 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 219970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 219975 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219979 */     GIR_RootConstrainSelectedInstOperands,
     /* 219980 */     // GIR_Coverage, 2253,
     /* 219980 */     GIR_Done,
     /* 219981 */   // Label 5103: @219981
     /* 219981 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(220012), // Rule ID 2269 //
     /* 219986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 219989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 220001 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 220001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 220006 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220010 */     GIR_RootConstrainSelectedInstOperands,
     /* 220011 */     // GIR_Coverage, 2269,
     /* 220011 */     GIR_Done,
     /* 220012 */   // Label 5104: @220012
     /* 220012 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(220043), // Rule ID 6630 //
     /* 220017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 220020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 220024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 220028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 220032 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 220032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 220037 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220041 */     GIR_RootConstrainSelectedInstOperands,
     /* 220042 */     // GIR_Coverage, 6630,
     /* 220042 */     GIR_Done,
     /* 220043 */   // Label 5105: @220043
     /* 220043 */   GIM_Reject,
     /* 220044 */ // Label 5100: @220044
     /* 220044 */ GIM_Reject,
     /* 220045 */ // Label 5055: @220045
     /* 220045 */ GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(220243),
     /* 220050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 220053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 220056 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(220118), // Rule ID 2267 //
     /* 220061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 220064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220080 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220083 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220087 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220100 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrm),
     /* 220103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220107 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220116 */     GIR_RootConstrainSelectedInstOperands,
     /* 220117 */     // GIR_Coverage, 2267,
     /* 220117 */     GIR_EraseRootFromParent_Done,
     /* 220118 */   // Label 5107: @220118
     /* 220118 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(220180), // Rule ID 6670 //
     /* 220123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 220126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220142 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220145 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220149 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220162 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rm),
     /* 220165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220167 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220169 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220178 */     GIR_RootConstrainSelectedInstOperands,
     /* 220179 */     // GIR_Coverage, 6670,
     /* 220179 */     GIR_EraseRootFromParent_Done,
     /* 220180 */   // Label 5108: @220180
     /* 220180 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(220211), // Rule ID 2265 //
     /* 220185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 220188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220200 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 220200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 220205 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220209 */     GIR_RootConstrainSelectedInstOperands,
     /* 220210 */     // GIR_Coverage, 2265,
     /* 220210 */     GIR_Done,
     /* 220211 */   // Label 5109: @220211
     /* 220211 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(220242), // Rule ID 6666 //
     /* 220216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 220219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220231 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 220231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 220236 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220240 */     GIR_RootConstrainSelectedInstOperands,
     /* 220241 */     // GIR_Coverage, 6666,
     /* 220241 */     GIR_Done,
     /* 220242 */   // Label 5110: @220242
     /* 220242 */   GIM_Reject,
     /* 220243 */ // Label 5106: @220243
     /* 220243 */ GIM_Reject,
     /* 220244 */ // Label 5056: @220244
     /* 220244 */ GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(220341),
     /* 220249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 220255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 220259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 220263 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(220317), // Rule ID 6694 //
     /* 220268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 220271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220279 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220282 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220286 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220299 */     // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rm),
     /* 220302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220304 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220315 */     GIR_RootConstrainSelectedInstOperands,
     /* 220316 */     // GIR_Coverage, 6694,
     /* 220316 */     GIR_EraseRootFromParent_Done,
     /* 220317 */   // Label 5112: @220317
     /* 220317 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(220340), // Rule ID 6690 //
     /* 220322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 220325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 220329 */     // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 220329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 220334 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220338 */     GIR_RootConstrainSelectedInstOperands,
     /* 220339 */     // GIR_Coverage, 6690,
     /* 220339 */     GIR_Done,
     /* 220340 */   // Label 5113: @220340
     /* 220340 */   GIM_Reject,
     /* 220341 */ // Label 5111: @220341
     /* 220341 */ GIM_Reject,
     /* 220342 */ // Label 5057: @220342
     /* 220342 */ GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(220540),
     /* 220347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 220350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 220353 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(220415), // Rule ID 2263 //
     /* 220358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 220361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220377 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220397 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrm),
     /* 220400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220402 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220413 */     GIR_RootConstrainSelectedInstOperands,
     /* 220414 */     // GIR_Coverage, 2263,
     /* 220414 */     GIR_EraseRootFromParent_Done,
     /* 220415 */   // Label 5115: @220415
     /* 220415 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(220477), // Rule ID 6646 //
     /* 220420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 220423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220439 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220442 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220446 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220459 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rm),
     /* 220462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220464 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220466 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220475 */     GIR_RootConstrainSelectedInstOperands,
     /* 220476 */     // GIR_Coverage, 6646,
     /* 220476 */     GIR_EraseRootFromParent_Done,
     /* 220477 */   // Label 5116: @220477
     /* 220477 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(220508), // Rule ID 2261 //
     /* 220482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 220485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 220497 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 220497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 220502 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220506 */     GIR_RootConstrainSelectedInstOperands,
     /* 220507 */     // GIR_Coverage, 2261,
     /* 220507 */     GIR_Done,
     /* 220508 */   // Label 5117: @220508
     /* 220508 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(220539), // Rule ID 6642 //
     /* 220513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 220516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220528 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 220528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 220533 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220537 */     GIR_RootConstrainSelectedInstOperands,
     /* 220538 */     // GIR_Coverage, 6642,
     /* 220538 */     GIR_Done,
     /* 220539 */   // Label 5118: @220539
     /* 220539 */   GIM_Reject,
     /* 220540 */ // Label 5114: @220540
     /* 220540 */ GIM_Reject,
     /* 220541 */ // Label 5058: @220541
     /* 220541 */ GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(220638),
     /* 220546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 220549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 220552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220560 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(220614), // Rule ID 6622 //
     /* 220565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220596 */     // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrm),
     /* 220599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220601 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220612 */     GIR_RootConstrainSelectedInstOperands,
     /* 220613 */     // GIR_Coverage, 6622,
     /* 220613 */     GIR_EraseRootFromParent_Done,
     /* 220614 */   // Label 5120: @220614
     /* 220614 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(220637), // Rule ID 6618 //
     /* 220619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220626 */     // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 220626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 220631 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220635 */     GIR_RootConstrainSelectedInstOperands,
     /* 220636 */     // GIR_Coverage, 6618,
     /* 220636 */     GIR_Done,
     /* 220637 */   // Label 5121: @220637
     /* 220637 */   GIM_Reject,
     /* 220638 */ // Label 5119: @220638
     /* 220638 */ GIM_Reject,
     /* 220639 */ // Label 5059: @220639
     /* 220639 */ GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(220736),
     /* 220644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 220647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 220650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220658 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(220712), // Rule ID 6706 //
     /* 220663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 220666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220674 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220677 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220681 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220694 */     // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rm),
     /* 220697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220710 */     GIR_RootConstrainSelectedInstOperands,
     /* 220711 */     // GIR_Coverage, 6706,
     /* 220711 */     GIR_EraseRootFromParent_Done,
     /* 220712 */   // Label 5123: @220712
     /* 220712 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(220735), // Rule ID 6702 //
     /* 220717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 220720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220724 */     // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 220724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 220729 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220733 */     GIR_RootConstrainSelectedInstOperands,
     /* 220734 */     // GIR_Coverage, 6702,
     /* 220734 */     GIR_Done,
     /* 220735 */   // Label 5124: @220735
     /* 220735 */   GIM_Reject,
     /* 220736 */ // Label 5122: @220736
     /* 220736 */ GIM_Reject,
     /* 220737 */ // Label 5060: @220737
     /* 220737 */ GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(220834),
     /* 220742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 220745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 220748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220756 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(220810), // Rule ID 6610 //
     /* 220761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220772 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220779 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220792 */     // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrm),
     /* 220795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220797 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220799 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220808 */     GIR_RootConstrainSelectedInstOperands,
     /* 220809 */     // GIR_Coverage, 6610,
     /* 220809 */     GIR_EraseRootFromParent_Done,
     /* 220810 */   // Label 5126: @220810
     /* 220810 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(220833), // Rule ID 6606 //
     /* 220815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220822 */     // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 220822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 220827 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220831 */     GIR_RootConstrainSelectedInstOperands,
     /* 220832 */     // GIR_Coverage, 6606,
     /* 220832 */     GIR_Done,
     /* 220833 */   // Label 5127: @220833
     /* 220833 */   GIM_Reject,
     /* 220834 */ // Label 5125: @220834
     /* 220834 */ GIM_Reject,
     /* 220835 */ // Label 5061: @220835
     /* 220835 */ GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(220932),
     /* 220840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 220843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 220846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220854 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(220908), // Rule ID 6682 //
     /* 220859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 220862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220870 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220877 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220890 */     // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrm),
     /* 220893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220895 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220897 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220906 */     GIR_RootConstrainSelectedInstOperands,
     /* 220907 */     // GIR_Coverage, 6682,
     /* 220907 */     GIR_EraseRootFromParent_Done,
     /* 220908 */   // Label 5129: @220908
     /* 220908 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(220931), // Rule ID 6678 //
     /* 220913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 220916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220920 */     // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 220920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 220925 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220929 */     GIR_RootConstrainSelectedInstOperands,
     /* 220930 */     // GIR_Coverage, 6678,
     /* 220930 */     GIR_Done,
     /* 220931 */   // Label 5130: @220931
     /* 220931 */   GIM_Reject,
     /* 220932 */ // Label 5128: @220932
     /* 220932 */ GIM_Reject,
     /* 220933 */ // Label 5062: @220933
     /* 220933 */ GIM_Reject,
     /* 220934 */ // Label 72: @220934
     /* 220934 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5143*/ GIMT_Encode4(226921),
     /* 220945 */ /*GILLT_s16*//*Label 5131*/ GIMT_Encode4(221029),
     /* 220949 */ /*GILLT_s32*//*Label 5132*/ GIMT_Encode4(221274),
     /* 220953 */ /*GILLT_s64*//*Label 5133*/ GIMT_Encode4(222011), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 220969 */ /*GILLT_v2s64*//*Label 5134*/ GIMT_Encode4(222748), GIMT_Encode4(0),
     /* 220977 */ /*GILLT_v4s32*//*Label 5135*/ GIMT_Encode4(223485),
     /* 220981 */ /*GILLT_v4s64*//*Label 5136*/ GIMT_Encode4(224222), GIMT_Encode4(0),
     /* 220989 */ /*GILLT_v8s16*//*Label 5137*/ GIMT_Encode4(224959),
     /* 220993 */ /*GILLT_v8s32*//*Label 5138*/ GIMT_Encode4(225204),
     /* 220997 */ /*GILLT_v8s64*//*Label 5139*/ GIMT_Encode4(225941), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 221009 */ /*GILLT_v16s16*//*Label 5140*/ GIMT_Encode4(226186),
     /* 221013 */ /*GILLT_v16s32*//*Label 5141*/ GIMT_Encode4(226431), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 221025 */ /*GILLT_v32s16*//*Label 5142*/ GIMT_Encode4(226676),
     /* 221029 */ // Label 5131: @221029
     /* 221029 */ GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(221273),
     /* 221034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 221037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 221040 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 221043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221047 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(221111), // Rule ID 10156 //
     /* 221052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 221055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221063 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221066 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221070 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221091 */     // (strict_fma:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VFMADD132SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SHZm),
     /* 221094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221098 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 221100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221109 */     GIR_RootConstrainSelectedInstOperands,
     /* 221110 */     // GIR_Coverage, 10156,
     /* 221110 */     GIR_EraseRootFromParent_Done,
     /* 221111 */   // Label 5145: @221111
     /* 221111 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(221175), // Rule ID 10154 //
     /* 221116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 221119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221131 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221134 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221138 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221155 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VFMADD231SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SHZm),
     /* 221158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221160 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 221162 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221173 */     GIR_RootConstrainSelectedInstOperands,
     /* 221174 */     // GIR_Coverage, 10154,
     /* 221174 */     GIR_EraseRootFromParent_Done,
     /* 221175 */   // Label 5146: @221175
     /* 221175 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(221239), // Rule ID 10151 //
     /* 221180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 221183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221199 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221202 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221206 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221219 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZm),
     /* 221222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221226 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221228 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221237 */     GIR_RootConstrainSelectedInstOperands,
     /* 221238 */     // GIR_Coverage, 10151,
     /* 221238 */     GIR_EraseRootFromParent_Done,
     /* 221239 */   // Label 5147: @221239
     /* 221239 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(221272), // Rule ID 10149 //
     /* 221244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 221247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 221259 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 221259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 221262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221264 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221266 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221268 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 221270 */     GIR_RootConstrainSelectedInstOperands,
     /* 221271 */     // GIR_Coverage, 10149,
     /* 221271 */     GIR_EraseRootFromParent_Done,
     /* 221272 */   // Label 5148: @221272
     /* 221272 */   GIM_Reject,
     /* 221273 */ // Label 5144: @221273
     /* 221273 */ GIM_Reject,
     /* 221274 */ // Label 5132: @221274
     /* 221274 */ GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(222010),
     /* 221279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 221282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 221285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 221288 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(221356), // Rule ID 1302 //
     /* 221293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221315 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221336 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VFMADD132SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSm),
     /* 221339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221341 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221343 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 221345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221354 */     GIR_RootConstrainSelectedInstOperands,
     /* 221355 */     // GIR_Coverage, 1302,
     /* 221355 */     GIR_EraseRootFromParent_Done,
     /* 221356 */   // Label 5150: @221356
     /* 221356 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(221424), // Rule ID 10138 //
     /* 221361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221376 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221379 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221383 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221404 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VFMADD132SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSZm),
     /* 221407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221409 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221411 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 221413 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221422 */     GIR_RootConstrainSelectedInstOperands,
     /* 221423 */     // GIR_Coverage, 10138,
     /* 221423 */     GIR_EraseRootFromParent_Done,
     /* 221424 */   // Label 5151: @221424
     /* 221424 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(221492), // Rule ID 23277 //
     /* 221429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221444 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221447 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221472 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 221472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 221475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221477 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221483 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 221485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221490 */     GIR_RootConstrainSelectedInstOperands,
     /* 221491 */     // GIR_Coverage, 23277,
     /* 221491 */     GIR_EraseRootFromParent_Done,
     /* 221492 */   // Label 5152: @221492
     /* 221492 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(221560), // Rule ID 1300 //
     /* 221497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221540 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VFMADD231SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSm),
     /* 221543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221545 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 221547 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221549 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221558 */     GIR_RootConstrainSelectedInstOperands,
     /* 221559 */     // GIR_Coverage, 1300,
     /* 221559 */     GIR_EraseRootFromParent_Done,
     /* 221560 */   // Label 5153: @221560
     /* 221560 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(221628), // Rule ID 1364 //
     /* 221565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221608 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 221608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 221611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221613 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221619 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 221621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221626 */     GIR_RootConstrainSelectedInstOperands,
     /* 221627 */     // GIR_Coverage, 1364,
     /* 221627 */     GIR_EraseRootFromParent_Done,
     /* 221628 */   // Label 5154: @221628
     /* 221628 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(221696), // Rule ID 10136 //
     /* 221633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221652 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221676 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VFMADD231SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSZm),
     /* 221679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221681 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 221683 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221685 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221694 */     GIR_RootConstrainSelectedInstOperands,
     /* 221695 */     // GIR_Coverage, 10136,
     /* 221695 */     GIR_EraseRootFromParent_Done,
     /* 221696 */   // Label 5155: @221696
     /* 221696 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(221764), // Rule ID 1298 //
     /* 221701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221744 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSm),
     /* 221747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221749 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221751 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221762 */     GIR_RootConstrainSelectedInstOperands,
     /* 221763 */     // GIR_Coverage, 1298,
     /* 221763 */     GIR_EraseRootFromParent_Done,
     /* 221764 */   // Label 5156: @221764
     /* 221764 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(221832), // Rule ID 1362 //
     /* 221769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221812 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSS4rm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rm),
     /* 221815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221819 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 221821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221830 */     GIR_RootConstrainSelectedInstOperands,
     /* 221831 */     // GIR_Coverage, 1362,
     /* 221831 */     GIR_EraseRootFromParent_Done,
     /* 221832 */   // Label 5157: @221832
     /* 221832 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(221900), // Rule ID 10133 //
     /* 221837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221860 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221863 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221867 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221880 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZm),
     /* 221883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221885 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221887 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221898 */     GIR_RootConstrainSelectedInstOperands,
     /* 221899 */     // GIR_Coverage, 10133,
     /* 221899 */     GIR_EraseRootFromParent_Done,
     /* 221900 */   // Label 5158: @221900
     /* 221900 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(221937), // Rule ID 1296 //
     /* 221905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221924 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 221924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 221927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221929 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221931 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221933 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 221935 */     GIR_RootConstrainSelectedInstOperands,
     /* 221936 */     // GIR_Coverage, 1296,
     /* 221936 */     GIR_EraseRootFromParent_Done,
     /* 221937 */   // Label 5159: @221937
     /* 221937 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(221972), // Rule ID 1360 //
     /* 221942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221961 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 221961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 221966 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 221970 */     GIR_RootConstrainSelectedInstOperands,
     /* 221971 */     // GIR_Coverage, 1360,
     /* 221971 */     GIR_Done,
     /* 221972 */   // Label 5160: @221972
     /* 221972 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(222009), // Rule ID 10131 //
     /* 221977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221996 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 221996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 221999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222001 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222003 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222005 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222007 */     GIR_RootConstrainSelectedInstOperands,
     /* 222008 */     // GIR_Coverage, 10131,
     /* 222008 */     GIR_EraseRootFromParent_Done,
     /* 222009 */   // Label 5161: @222009
     /* 222009 */   GIM_Reject,
     /* 222010 */ // Label 5149: @222010
     /* 222010 */ GIM_Reject,
     /* 222011 */ // Label 5133: @222011
     /* 222011 */ GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(222747),
     /* 222016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 222019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 222022 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 222025 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(222093), // Rule ID 1310 //
     /* 222030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 222033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222073 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VFMADD132SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDm),
     /* 222076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222078 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222080 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 222082 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222091 */     GIR_RootConstrainSelectedInstOperands,
     /* 222092 */     // GIR_Coverage, 1310,
     /* 222092 */     GIR_EraseRootFromParent_Done,
     /* 222093 */   // Label 5163: @222093
     /* 222093 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(222161), // Rule ID 10147 //
     /* 222098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 222101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222113 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222120 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222141 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VFMADD132SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDZm),
     /* 222144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222146 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222148 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 222150 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222159 */     GIR_RootConstrainSelectedInstOperands,
     /* 222160 */     // GIR_Coverage, 10147,
     /* 222160 */     GIR_EraseRootFromParent_Done,
     /* 222161 */   // Label 5164: @222161
     /* 222161 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(222229), // Rule ID 23305 //
     /* 222166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 222169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222209 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 222209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 222212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222214 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222216 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222220 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222227 */     GIR_RootConstrainSelectedInstOperands,
     /* 222228 */     // GIR_Coverage, 23305,
     /* 222228 */     GIR_EraseRootFromParent_Done,
     /* 222229 */   // Label 5165: @222229
     /* 222229 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(222297), // Rule ID 1308 //
     /* 222234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 222237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222253 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222277 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VFMADD231SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDm),
     /* 222280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222282 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 222284 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222286 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222295 */     GIR_RootConstrainSelectedInstOperands,
     /* 222296 */     // GIR_Coverage, 1308,
     /* 222296 */     GIR_EraseRootFromParent_Done,
     /* 222297 */   // Label 5166: @222297
     /* 222297 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(222365), // Rule ID 1448 //
     /* 222302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 222305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222321 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222324 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222328 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222345 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 222345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 222348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222356 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222363 */     GIR_RootConstrainSelectedInstOperands,
     /* 222364 */     // GIR_Coverage, 1448,
     /* 222364 */     GIR_EraseRootFromParent_Done,
     /* 222365 */   // Label 5167: @222365
     /* 222365 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(222433), // Rule ID 10145 //
     /* 222370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 222373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222389 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222392 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222396 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222413 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VFMADD231SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDZm),
     /* 222416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222418 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 222420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222431 */     GIR_RootConstrainSelectedInstOperands,
     /* 222432 */     // GIR_Coverage, 10145,
     /* 222432 */     GIR_EraseRootFromParent_Done,
     /* 222433 */   // Label 5168: @222433
     /* 222433 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(222501), // Rule ID 1306 //
     /* 222438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 222441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 222457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222461 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222464 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222468 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222481 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDm),
     /* 222484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222486 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222490 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222499 */     GIR_RootConstrainSelectedInstOperands,
     /* 222500 */     // GIR_Coverage, 1306,
     /* 222500 */     GIR_EraseRootFromParent_Done,
     /* 222501 */   // Label 5169: @222501
     /* 222501 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(222569), // Rule ID 1446 //
     /* 222506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 222509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 222525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222529 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222532 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222536 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222549 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSD4rm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rm),
     /* 222552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222554 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 222558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222567 */     GIR_RootConstrainSelectedInstOperands,
     /* 222568 */     // GIR_Coverage, 1446,
     /* 222568 */     GIR_EraseRootFromParent_Done,
     /* 222569 */   // Label 5170: @222569
     /* 222569 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(222637), // Rule ID 10142 //
     /* 222574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 222577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 222593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222597 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222600 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222604 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222617 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZm),
     /* 222620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222622 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222624 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222635 */     GIR_RootConstrainSelectedInstOperands,
     /* 222636 */     // GIR_Coverage, 10142,
     /* 222636 */     GIR_EraseRootFromParent_Done,
     /* 222637 */   // Label 5171: @222637
     /* 222637 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(222674), // Rule ID 1304 //
     /* 222642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 222645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222661 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 222661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 222664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222666 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222668 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222670 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222672 */     GIR_RootConstrainSelectedInstOperands,
     /* 222673 */     // GIR_Coverage, 1304,
     /* 222673 */     GIR_EraseRootFromParent_Done,
     /* 222674 */   // Label 5172: @222674
     /* 222674 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(222709), // Rule ID 1444 //
     /* 222679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 222682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222698 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 222698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 222703 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222707 */     GIR_RootConstrainSelectedInstOperands,
     /* 222708 */     // GIR_Coverage, 1444,
     /* 222708 */     GIR_Done,
     /* 222709 */   // Label 5173: @222709
     /* 222709 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(222746), // Rule ID 10140 //
     /* 222714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 222717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222733 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 222733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 222736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222738 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222740 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222742 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222744 */     GIR_RootConstrainSelectedInstOperands,
     /* 222745 */     // GIR_Coverage, 10140,
     /* 222745 */     GIR_EraseRootFromParent_Done,
     /* 222746 */   // Label 5174: @222746
     /* 222746 */   GIM_Reject,
     /* 222747 */ // Label 5162: @222747
     /* 222747 */ GIM_Reject,
     /* 222748 */ // Label 5134: @222748
     /* 222748 */ GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(223484),
     /* 222753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 222756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 222759 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 222762 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(222830), // Rule ID 1190 //
     /* 222767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 222770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222782 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222785 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222789 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222810 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDm),
     /* 222813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222817 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 222819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222828 */     GIR_RootConstrainSelectedInstOperands,
     /* 222829 */     // GIR_Coverage, 1190,
     /* 222829 */     GIR_EraseRootFromParent_Done,
     /* 222830 */   // Label 5176: @222830
     /* 222830 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(222898), // Rule ID 9679 //
     /* 222835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222850 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222853 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222857 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222878 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ128m),
     /* 222881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222885 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 222887 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222896 */     GIR_RootConstrainSelectedInstOperands,
     /* 222897 */     // GIR_Coverage, 9679,
     /* 222897 */     GIR_EraseRootFromParent_Done,
     /* 222898 */   // Label 5177: @222898
     /* 222898 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(222966), // Rule ID 23313 //
     /* 222903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 222906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222946 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 222946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 222949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222951 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222957 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222964 */     GIR_RootConstrainSelectedInstOperands,
     /* 222965 */     // GIR_Coverage, 23313,
     /* 222965 */     GIR_EraseRootFromParent_Done,
     /* 222966 */   // Label 5178: @222966
     /* 222966 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(223034), // Rule ID 1188 //
     /* 222971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 222974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222990 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222997 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223014 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDm),
     /* 223017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223019 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 223021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223023 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223032 */     GIR_RootConstrainSelectedInstOperands,
     /* 223033 */     // GIR_Coverage, 1188,
     /* 223033 */     GIR_EraseRootFromParent_Done,
     /* 223034 */   // Label 5179: @223034
     /* 223034 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(223102), // Rule ID 1472 //
     /* 223039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223082 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 223082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 223085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223089 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223093 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223100 */     GIR_RootConstrainSelectedInstOperands,
     /* 223101 */     // GIR_Coverage, 1472,
     /* 223101 */     GIR_EraseRootFromParent_Done,
     /* 223102 */   // Label 5180: @223102
     /* 223102 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(223170), // Rule ID 9139 //
     /* 223107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223126 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223129 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223133 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223150 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ128m),
     /* 223153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223155 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 223157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223168 */     GIR_RootConstrainSelectedInstOperands,
     /* 223169 */     // GIR_Coverage, 9139,
     /* 223169 */     GIR_EraseRootFromParent_Done,
     /* 223170 */   // Label 5181: @223170
     /* 223170 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(223238), // Rule ID 1186 //
     /* 223175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 223194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223198 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223201 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223205 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223218 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDm),
     /* 223221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223223 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223225 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223236 */     GIR_RootConstrainSelectedInstOperands,
     /* 223237 */     // GIR_Coverage, 1186,
     /* 223237 */     GIR_EraseRootFromParent_Done,
     /* 223238 */   // Label 5182: @223238
     /* 223238 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(223306), // Rule ID 1470 //
     /* 223243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 223262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223266 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223273 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223286 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4rm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rm),
     /* 223289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223293 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 223295 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223304 */     GIR_RootConstrainSelectedInstOperands,
     /* 223305 */     // GIR_Coverage, 1470,
     /* 223305 */     GIR_EraseRootFromParent_Done,
     /* 223306 */   // Label 5183: @223306
     /* 223306 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(223374), // Rule ID 8512 //
     /* 223311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 223330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223334 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223337 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223341 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223354 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128m),
     /* 223357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223359 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223372 */     GIR_RootConstrainSelectedInstOperands,
     /* 223373 */     // GIR_Coverage, 8512,
     /* 223373 */     GIR_EraseRootFromParent_Done,
     /* 223374 */   // Label 5184: @223374
     /* 223374 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(223411), // Rule ID 1184 //
     /* 223379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223398 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 223398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 223401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223403 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223405 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223407 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223409 */     GIR_RootConstrainSelectedInstOperands,
     /* 223410 */     // GIR_Coverage, 1184,
     /* 223410 */     GIR_EraseRootFromParent_Done,
     /* 223411 */   // Label 5185: @223411
     /* 223411 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(223446), // Rule ID 1468 //
     /* 223416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223435 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 223435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 223440 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223444 */     GIR_RootConstrainSelectedInstOperands,
     /* 223445 */     // GIR_Coverage, 1468,
     /* 223445 */     GIR_Done,
     /* 223446 */   // Label 5186: @223446
     /* 223446 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(223483), // Rule ID 8508 //
     /* 223451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223470 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 223470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 223473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223479 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223481 */     GIR_RootConstrainSelectedInstOperands,
     /* 223482 */     // GIR_Coverage, 8508,
     /* 223482 */     GIR_EraseRootFromParent_Done,
     /* 223483 */   // Label 5187: @223483
     /* 223483 */   GIM_Reject,
     /* 223484 */ // Label 5175: @223484
     /* 223484 */ GIM_Reject,
     /* 223485 */ // Label 5135: @223485
     /* 223485 */ GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(224221),
     /* 223490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 223493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 223496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 223499 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(223567), // Rule ID 1142 //
     /* 223504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223519 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223522 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223526 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223547 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSm),
     /* 223550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223552 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223554 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 223556 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223565 */     GIR_RootConstrainSelectedInstOperands,
     /* 223566 */     // GIR_Coverage, 1142,
     /* 223566 */     GIR_EraseRootFromParent_Done,
     /* 223567 */   // Label 5189: @223567
     /* 223567 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(223635), // Rule ID 9647 //
     /* 223572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223587 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223594 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223608 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223615 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ128m),
     /* 223618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223620 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223622 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 223624 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223633 */     GIR_RootConstrainSelectedInstOperands,
     /* 223634 */     // GIR_Coverage, 9647,
     /* 223634 */     GIR_EraseRootFromParent_Done,
     /* 223635 */   // Label 5190: @223635
     /* 223635 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(223703), // Rule ID 23285 //
     /* 223640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223655 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223658 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223662 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223683 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 223683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 223686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223688 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223690 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223694 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223701 */     GIR_RootConstrainSelectedInstOperands,
     /* 223702 */     // GIR_Coverage, 23285,
     /* 223702 */     GIR_EraseRootFromParent_Done,
     /* 223703 */   // Label 5191: @223703
     /* 223703 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(223771), // Rule ID 1140 //
     /* 223708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223727 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223730 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223734 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223751 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSm),
     /* 223754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223756 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 223758 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223760 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223769 */     GIR_RootConstrainSelectedInstOperands,
     /* 223770 */     // GIR_Coverage, 1140,
     /* 223770 */     GIR_EraseRootFromParent_Done,
     /* 223771 */   // Label 5192: @223771
     /* 223771 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(223839), // Rule ID 1388 //
     /* 223776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223795 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223802 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223819 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 223819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 223822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223824 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223826 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223830 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223837 */     GIR_RootConstrainSelectedInstOperands,
     /* 223838 */     // GIR_Coverage, 1388,
     /* 223838 */     GIR_EraseRootFromParent_Done,
     /* 223839 */   // Label 5193: @223839
     /* 223839 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(223907), // Rule ID 9107 //
     /* 223844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223863 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223866 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223887 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ128m),
     /* 223890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223892 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 223894 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223896 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223905 */     GIR_RootConstrainSelectedInstOperands,
     /* 223906 */     // GIR_Coverage, 9107,
     /* 223906 */     GIR_EraseRootFromParent_Done,
     /* 223907 */   // Label 5194: @223907
     /* 223907 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(223975), // Rule ID 1138 //
     /* 223912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 223931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223935 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223938 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223942 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223955 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSm),
     /* 223958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223960 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223973 */     GIR_RootConstrainSelectedInstOperands,
     /* 223974 */     // GIR_Coverage, 1138,
     /* 223974 */     GIR_EraseRootFromParent_Done,
     /* 223975 */   // Label 5195: @223975
     /* 223975 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(224043), // Rule ID 1386 //
     /* 223980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 223999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224003 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224010 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224023 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4rm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rm),
     /* 224026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224028 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224030 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 224032 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224041 */     GIR_RootConstrainSelectedInstOperands,
     /* 224042 */     // GIR_Coverage, 1386,
     /* 224042 */     GIR_EraseRootFromParent_Done,
     /* 224043 */   // Label 5196: @224043
     /* 224043 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(224111), // Rule ID 8473 //
     /* 224048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224071 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224091 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128m),
     /* 224094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224098 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224109 */     GIR_RootConstrainSelectedInstOperands,
     /* 224110 */     // GIR_Coverage, 8473,
     /* 224110 */     GIR_EraseRootFromParent_Done,
     /* 224111 */   // Label 5197: @224111
     /* 224111 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(224148), // Rule ID 1136 //
     /* 224116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224135 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 224135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 224138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224140 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224142 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224144 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224146 */     GIR_RootConstrainSelectedInstOperands,
     /* 224147 */     // GIR_Coverage, 1136,
     /* 224147 */     GIR_EraseRootFromParent_Done,
     /* 224148 */   // Label 5198: @224148
     /* 224148 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(224183), // Rule ID 1384 //
     /* 224153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 224172 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 224172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 224177 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224181 */     GIR_RootConstrainSelectedInstOperands,
     /* 224182 */     // GIR_Coverage, 1384,
     /* 224182 */     GIR_Done,
     /* 224183 */   // Label 5199: @224183
     /* 224183 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(224220), // Rule ID 8469 //
     /* 224188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224207 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 224207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 224210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224212 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224216 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224218 */     GIR_RootConstrainSelectedInstOperands,
     /* 224219 */     // GIR_Coverage, 8469,
     /* 224219 */     GIR_EraseRootFromParent_Done,
     /* 224220 */   // Label 5200: @224220
     /* 224220 */   GIM_Reject,
     /* 224221 */ // Label 5188: @224221
     /* 224221 */ GIM_Reject,
     /* 224222 */ // Label 5136: @224222
     /* 224222 */ GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(224958),
     /* 224227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 224230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 224233 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 224236 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(224304), // Rule ID 1198 //
     /* 224241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224263 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224284 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDYm),
     /* 224287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224289 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224291 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 224293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224302 */     GIR_RootConstrainSelectedInstOperands,
     /* 224303 */     // GIR_Coverage, 1198,
     /* 224303 */     GIR_EraseRootFromParent_Done,
     /* 224304 */   // Label 5202: @224304
     /* 224304 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(224372), // Rule ID 9669 //
     /* 224309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224324 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224327 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224352 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ256m),
     /* 224355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224357 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224359 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 224361 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224370 */     GIR_RootConstrainSelectedInstOperands,
     /* 224371 */     // GIR_Coverage, 9669,
     /* 224371 */     GIR_EraseRootFromParent_Done,
     /* 224372 */   // Label 5203: @224372
     /* 224372 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(224440), // Rule ID 23315 //
     /* 224377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224392 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224395 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224399 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224420 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 224420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 224423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224427 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224431 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224438 */     GIR_RootConstrainSelectedInstOperands,
     /* 224439 */     // GIR_Coverage, 23315,
     /* 224439 */     GIR_EraseRootFromParent_Done,
     /* 224440 */   // Label 5204: @224440
     /* 224440 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(224508), // Rule ID 1196 //
     /* 224445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224464 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224471 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224488 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDYm),
     /* 224491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224493 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 224495 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224506 */     GIR_RootConstrainSelectedInstOperands,
     /* 224507 */     // GIR_Coverage, 1196,
     /* 224507 */     GIR_EraseRootFromParent_Done,
     /* 224508 */   // Label 5205: @224508
     /* 224508 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(224576), // Rule ID 1478 //
     /* 224513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224532 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224556 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 224556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 224559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224567 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224574 */     GIR_RootConstrainSelectedInstOperands,
     /* 224575 */     // GIR_Coverage, 1478,
     /* 224575 */     GIR_EraseRootFromParent_Done,
     /* 224576 */   // Label 5206: @224576
     /* 224576 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(224644), // Rule ID 9129 //
     /* 224581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224624 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ256m),
     /* 224627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224629 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 224631 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224642 */     GIR_RootConstrainSelectedInstOperands,
     /* 224643 */     // GIR_Coverage, 9129,
     /* 224643 */     GIR_EraseRootFromParent_Done,
     /* 224644 */   // Label 5207: @224644
     /* 224644 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(224712), // Rule ID 1194 //
     /* 224649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224672 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224679 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224692 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYm),
     /* 224695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224697 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224710 */     GIR_RootConstrainSelectedInstOperands,
     /* 224711 */     // GIR_Coverage, 1194,
     /* 224711 */     GIR_EraseRootFromParent_Done,
     /* 224712 */   // Label 5208: @224712
     /* 224712 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(224780), // Rule ID 1476 //
     /* 224717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224740 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224747 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224760 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4Yrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrm),
     /* 224763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224765 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224767 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 224769 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224778 */     GIR_RootConstrainSelectedInstOperands,
     /* 224779 */     // GIR_Coverage, 1476,
     /* 224779 */     GIR_EraseRootFromParent_Done,
     /* 224780 */   // Label 5209: @224780
     /* 224780 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(224848), // Rule ID 8500 //
     /* 224785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224808 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224811 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224815 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224828 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256m),
     /* 224831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224833 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224835 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224846 */     GIR_RootConstrainSelectedInstOperands,
     /* 224847 */     // GIR_Coverage, 8500,
     /* 224847 */     GIR_EraseRootFromParent_Done,
     /* 224848 */   // Label 5210: @224848
     /* 224848 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(224885), // Rule ID 1192 //
     /* 224853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224872 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 224872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 224875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224877 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224879 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224881 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224883 */     GIR_RootConstrainSelectedInstOperands,
     /* 224884 */     // GIR_Coverage, 1192,
     /* 224884 */     GIR_EraseRootFromParent_Done,
     /* 224885 */   // Label 5211: @224885
     /* 224885 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(224920), // Rule ID 1474 //
     /* 224890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224909 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 224909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 224914 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224918 */     GIR_RootConstrainSelectedInstOperands,
     /* 224919 */     // GIR_Coverage, 1474,
     /* 224919 */     GIR_Done,
     /* 224920 */   // Label 5212: @224920
     /* 224920 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(224957), // Rule ID 8496 //
     /* 224925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224944 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 224944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 224947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224949 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224951 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224953 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224955 */     GIR_RootConstrainSelectedInstOperands,
     /* 224956 */     // GIR_Coverage, 8496,
     /* 224956 */     GIR_EraseRootFromParent_Done,
     /* 224957 */   // Label 5213: @224957
     /* 224957 */   GIM_Reject,
     /* 224958 */ // Label 5201: @224958
     /* 224958 */ GIM_Reject,
     /* 224959 */ // Label 5137: @224959
     /* 224959 */ GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(225203),
     /* 224964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 224967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 224970 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 224973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224977 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(225041), // Rule ID 9615 //
     /* 224982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 224985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224993 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224996 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225000 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225021 */     // (strict_fma:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VFMADD132PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ128m),
     /* 225024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225028 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 225030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225039 */     GIR_RootConstrainSelectedInstOperands,
     /* 225040 */     // GIR_Coverage, 9615,
     /* 225040 */     GIR_EraseRootFromParent_Done,
     /* 225041 */   // Label 5215: @225041
     /* 225041 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(225105), // Rule ID 9075 //
     /* 225046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 225049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225061 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225064 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225068 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225085 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VFMADD231PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ128m),
     /* 225088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225090 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 225092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225103 */     GIR_RootConstrainSelectedInstOperands,
     /* 225104 */     // GIR_Coverage, 9075,
     /* 225104 */     GIR_EraseRootFromParent_Done,
     /* 225105 */   // Label 5216: @225105
     /* 225105 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(225169), // Rule ID 8434 //
     /* 225110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 225113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225129 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225136 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225149 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128m),
     /* 225152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225154 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225156 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225158 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225167 */     GIR_RootConstrainSelectedInstOperands,
     /* 225168 */     // GIR_Coverage, 8434,
     /* 225168 */     GIR_EraseRootFromParent_Done,
     /* 225169 */   // Label 5217: @225169
     /* 225169 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(225202), // Rule ID 8430 //
     /* 225174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 225177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225189 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 225189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 225192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225194 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225196 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225198 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225200 */     GIR_RootConstrainSelectedInstOperands,
     /* 225201 */     // GIR_Coverage, 8430,
     /* 225201 */     GIR_EraseRootFromParent_Done,
     /* 225202 */   // Label 5218: @225202
     /* 225202 */   GIM_Reject,
     /* 225203 */ // Label 5214: @225203
     /* 225203 */ GIM_Reject,
     /* 225204 */ // Label 5138: @225204
     /* 225204 */ GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(225940),
     /* 225209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 225212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 225215 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 225218 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(225286), // Rule ID 1150 //
     /* 225223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 225226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225238 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225245 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225266 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSYm),
     /* 225269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225271 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225273 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 225275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225284 */     GIR_RootConstrainSelectedInstOperands,
     /* 225285 */     // GIR_Coverage, 1150,
     /* 225285 */     GIR_EraseRootFromParent_Done,
     /* 225286 */   // Label 5220: @225286
     /* 225286 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(225354), // Rule ID 9637 //
     /* 225291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 225294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225334 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ256m),
     /* 225337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225339 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225341 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 225343 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225352 */     GIR_RootConstrainSelectedInstOperands,
     /* 225353 */     // GIR_Coverage, 9637,
     /* 225353 */     GIR_EraseRootFromParent_Done,
     /* 225354 */   // Label 5221: @225354
     /* 225354 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(225422), // Rule ID 23287 //
     /* 225359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 225362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225374 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225381 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225402 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 225402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 225405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225407 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225409 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225413 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225420 */     GIR_RootConstrainSelectedInstOperands,
     /* 225421 */     // GIR_Coverage, 23287,
     /* 225421 */     GIR_EraseRootFromParent_Done,
     /* 225422 */   // Label 5222: @225422
     /* 225422 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(225490), // Rule ID 1148 //
     /* 225427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 225430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225446 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225470 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSYm),
     /* 225473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225475 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 225477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225488 */     GIR_RootConstrainSelectedInstOperands,
     /* 225489 */     // GIR_Coverage, 1148,
     /* 225489 */     GIR_EraseRootFromParent_Done,
     /* 225490 */   // Label 5223: @225490
     /* 225490 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(225558), // Rule ID 1394 //
     /* 225495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 225498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225538 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 225538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 225541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225543 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225545 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225549 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225556 */     GIR_RootConstrainSelectedInstOperands,
     /* 225557 */     // GIR_Coverage, 1394,
     /* 225557 */     GIR_EraseRootFromParent_Done,
     /* 225558 */   // Label 5224: @225558
     /* 225558 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(225626), // Rule ID 9097 //
     /* 225563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 225566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225606 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ256m),
     /* 225609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225611 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 225613 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225624 */     GIR_RootConstrainSelectedInstOperands,
     /* 225625 */     // GIR_Coverage, 9097,
     /* 225625 */     GIR_EraseRootFromParent_Done,
     /* 225626 */   // Label 5225: @225626
     /* 225626 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(225694), // Rule ID 1146 //
     /* 225631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 225634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225654 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225661 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225674 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYm),
     /* 225677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225679 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225681 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225692 */     GIR_RootConstrainSelectedInstOperands,
     /* 225693 */     // GIR_Coverage, 1146,
     /* 225693 */     GIR_EraseRootFromParent_Done,
     /* 225694 */   // Label 5226: @225694
     /* 225694 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(225762), // Rule ID 1392 //
     /* 225699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 225702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225722 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225729 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225742 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4Yrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrm),
     /* 225745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225747 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225749 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 225751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225760 */     GIR_RootConstrainSelectedInstOperands,
     /* 225761 */     // GIR_Coverage, 1392,
     /* 225761 */     GIR_EraseRootFromParent_Done,
     /* 225762 */   // Label 5227: @225762
     /* 225762 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(225830), // Rule ID 8461 //
     /* 225767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 225770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225790 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225810 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256m),
     /* 225813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225828 */     GIR_RootConstrainSelectedInstOperands,
     /* 225829 */     // GIR_Coverage, 8461,
     /* 225829 */     GIR_EraseRootFromParent_Done,
     /* 225830 */   // Label 5228: @225830
     /* 225830 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(225867), // Rule ID 1144 //
     /* 225835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 225838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225854 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 225854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 225857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225859 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225861 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225863 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225865 */     GIR_RootConstrainSelectedInstOperands,
     /* 225866 */     // GIR_Coverage, 1144,
     /* 225866 */     GIR_EraseRootFromParent_Done,
     /* 225867 */   // Label 5229: @225867
     /* 225867 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(225902), // Rule ID 1390 //
     /* 225872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 225875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225891 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 225891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 225896 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 225900 */     GIR_RootConstrainSelectedInstOperands,
     /* 225901 */     // GIR_Coverage, 1390,
     /* 225901 */     GIR_Done,
     /* 225902 */   // Label 5230: @225902
     /* 225902 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(225939), // Rule ID 8457 //
     /* 225907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 225910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225926 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 225926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 225929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225931 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225933 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225935 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225937 */     GIR_RootConstrainSelectedInstOperands,
     /* 225938 */     // GIR_Coverage, 8457,
     /* 225938 */     GIR_EraseRootFromParent_Done,
     /* 225939 */   // Label 5231: @225939
     /* 225939 */   GIM_Reject,
     /* 225940 */ // Label 5219: @225940
     /* 225940 */ GIM_Reject,
     /* 225941 */ // Label 5139: @225941
     /* 225941 */ GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(226185),
     /* 225946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 225949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 225952 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 225955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225959 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(226023), // Rule ID 9657 //
     /* 225964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225975 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225978 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225982 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226003 */     // (strict_fma:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VFMADD132PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZm),
     /* 226006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226008 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226010 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 226012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226021 */     GIR_RootConstrainSelectedInstOperands,
     /* 226022 */     // GIR_Coverage, 9657,
     /* 226022 */     GIR_EraseRootFromParent_Done,
     /* 226023 */   // Label 5233: @226023
     /* 226023 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(226087), // Rule ID 9117 //
     /* 226028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226043 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226046 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226067 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VFMADD231PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZm),
     /* 226070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226072 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 226074 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226085 */     GIR_RootConstrainSelectedInstOperands,
     /* 226086 */     // GIR_Coverage, 9117,
     /* 226086 */     GIR_EraseRootFromParent_Done,
     /* 226087 */   // Label 5234: @226087
     /* 226087 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(226151), // Rule ID 8485 //
     /* 226092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 226107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226111 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226114 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226118 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226131 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZm),
     /* 226134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226136 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226138 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226140 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226149 */     GIR_RootConstrainSelectedInstOperands,
     /* 226150 */     // GIR_Coverage, 8485,
     /* 226150 */     GIR_EraseRootFromParent_Done,
     /* 226151 */   // Label 5235: @226151
     /* 226151 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(226184), // Rule ID 8481 //
     /* 226156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226171 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 226171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 226174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226176 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226178 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226180 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 226182 */     GIR_RootConstrainSelectedInstOperands,
     /* 226183 */     // GIR_Coverage, 8481,
     /* 226183 */     GIR_EraseRootFromParent_Done,
     /* 226184 */   // Label 5236: @226184
     /* 226184 */   GIM_Reject,
     /* 226185 */ // Label 5232: @226185
     /* 226185 */ GIM_Reject,
     /* 226186 */ // Label 5140: @226186
     /* 226186 */ GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(226430),
     /* 226191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 226194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 226197 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 226200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226204 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(226268), // Rule ID 9605 //
     /* 226209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226220 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226223 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226227 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226248 */     // (strict_fma:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VFMADD132PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ256m),
     /* 226251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226255 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 226257 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226266 */     GIR_RootConstrainSelectedInstOperands,
     /* 226267 */     // GIR_Coverage, 9605,
     /* 226267 */     GIR_EraseRootFromParent_Done,
     /* 226268 */   // Label 5238: @226268
     /* 226268 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(226332), // Rule ID 9065 //
     /* 226273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226288 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226295 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226312 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VFMADD231PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ256m),
     /* 226315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226317 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 226319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226330 */     GIR_RootConstrainSelectedInstOperands,
     /* 226331 */     // GIR_Coverage, 9065,
     /* 226331 */     GIR_EraseRootFromParent_Done,
     /* 226332 */   // Label 5239: @226332
     /* 226332 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(226396), // Rule ID 8422 //
     /* 226337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 226352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226376 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256m),
     /* 226379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226381 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226394 */     GIR_RootConstrainSelectedInstOperands,
     /* 226395 */     // GIR_Coverage, 8422,
     /* 226395 */     GIR_EraseRootFromParent_Done,
     /* 226396 */   // Label 5240: @226396
     /* 226396 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(226429), // Rule ID 8418 //
     /* 226401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226416 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 226416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 226419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226421 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226425 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 226427 */     GIR_RootConstrainSelectedInstOperands,
     /* 226428 */     // GIR_Coverage, 8418,
     /* 226428 */     GIR_EraseRootFromParent_Done,
     /* 226429 */   // Label 5241: @226429
     /* 226429 */   GIM_Reject,
     /* 226430 */ // Label 5237: @226430
     /* 226430 */ GIM_Reject,
     /* 226431 */ // Label 5141: @226431
     /* 226431 */ GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(226675),
     /* 226436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 226439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 226442 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 226445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226449 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(226513), // Rule ID 9625 //
     /* 226454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226465 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226493 */     // (strict_fma:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VFMADD132PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZm),
     /* 226496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226498 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226500 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 226502 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226511 */     GIR_RootConstrainSelectedInstOperands,
     /* 226512 */     // GIR_Coverage, 9625,
     /* 226512 */     GIR_EraseRootFromParent_Done,
     /* 226513 */   // Label 5243: @226513
     /* 226513 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(226577), // Rule ID 9085 //
     /* 226518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226533 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226536 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226540 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226557 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VFMADD231PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZm),
     /* 226560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226562 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 226564 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226566 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226575 */     GIR_RootConstrainSelectedInstOperands,
     /* 226576 */     // GIR_Coverage, 9085,
     /* 226576 */     GIR_EraseRootFromParent_Done,
     /* 226577 */   // Label 5244: @226577
     /* 226577 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(226641), // Rule ID 8446 //
     /* 226582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 226597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226601 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226604 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226608 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226621 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZm),
     /* 226624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226626 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226628 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226630 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226639 */     GIR_RootConstrainSelectedInstOperands,
     /* 226640 */     // GIR_Coverage, 8446,
     /* 226640 */     GIR_EraseRootFromParent_Done,
     /* 226641 */   // Label 5245: @226641
     /* 226641 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(226674), // Rule ID 8442 //
     /* 226646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226661 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 226661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 226664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226666 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226668 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226670 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 226672 */     GIR_RootConstrainSelectedInstOperands,
     /* 226673 */     // GIR_Coverage, 8442,
     /* 226673 */     GIR_EraseRootFromParent_Done,
     /* 226674 */   // Label 5246: @226674
     /* 226674 */   GIM_Reject,
     /* 226675 */ // Label 5242: @226675
     /* 226675 */ GIM_Reject,
     /* 226676 */ // Label 5142: @226676
     /* 226676 */ GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(226920),
     /* 226681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 226684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 226687 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 226690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226694 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(226758), // Rule ID 9593 //
     /* 226699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226710 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226713 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226717 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226738 */     // (strict_fma:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VFMADD132PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZm),
     /* 226741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226743 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226745 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 226747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226756 */     GIR_RootConstrainSelectedInstOperands,
     /* 226757 */     // GIR_Coverage, 9593,
     /* 226757 */     GIR_EraseRootFromParent_Done,
     /* 226758 */   // Label 5248: @226758
     /* 226758 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(226822), // Rule ID 9053 //
     /* 226763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226778 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226781 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226785 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226802 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VFMADD231PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZm),
     /* 226805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226807 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 226809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226820 */     GIR_RootConstrainSelectedInstOperands,
     /* 226821 */     // GIR_Coverage, 9053,
     /* 226821 */     GIR_EraseRootFromParent_Done,
     /* 226822 */   // Label 5249: @226822
     /* 226822 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(226886), // Rule ID 8407 //
     /* 226827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 226842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226849 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226853 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226866 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZm),
     /* 226869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226871 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226875 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226884 */     GIR_RootConstrainSelectedInstOperands,
     /* 226885 */     // GIR_Coverage, 8407,
     /* 226885 */     GIR_EraseRootFromParent_Done,
     /* 226886 */   // Label 5250: @226886
     /* 226886 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(226919), // Rule ID 8403 //
     /* 226891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226906 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 226906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 226909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226911 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226913 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226915 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 226917 */     GIR_RootConstrainSelectedInstOperands,
     /* 226918 */     // GIR_Coverage, 8403,
     /* 226918 */     GIR_EraseRootFromParent_Done,
     /* 226919 */   // Label 5251: @226919
     /* 226919 */   GIM_Reject,
     /* 226920 */ // Label 5247: @226920
     /* 226920 */ GIM_Reject,
     /* 226921 */ // Label 5143: @226921
     /* 226921 */ GIM_Reject,
     /* 226922 */ // Label 73: @226922
     /* 226922 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5265*/ GIMT_Encode4(229090),
     /* 226933 */ /*GILLT_s16*//*Label 5252*/ GIMT_Encode4(227017),
     /* 226937 */ /*GILLT_s32*//*Label 5253*/ GIMT_Encode4(227138),
     /* 226941 */ /*GILLT_s64*//*Label 5254*/ GIMT_Encode4(227494),
     /* 226945 */ /*GILLT_s80*//*Label 5255*/ GIMT_Encode4(227850), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 226957 */ /*GILLT_v2s64*//*Label 5256*/ GIMT_Encode4(227887), GIMT_Encode4(0),
     /* 226965 */ /*GILLT_v4s32*//*Label 5257*/ GIMT_Encode4(228090),
     /* 226969 */ /*GILLT_v4s64*//*Label 5258*/ GIMT_Encode4(228293), GIMT_Encode4(0),
     /* 226977 */ /*GILLT_v8s16*//*Label 5259*/ GIMT_Encode4(228469),
     /* 226981 */ /*GILLT_v8s32*//*Label 5260*/ GIMT_Encode4(228558),
     /* 226985 */ /*GILLT_v8s64*//*Label 5261*/ GIMT_Encode4(228734), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 226997 */ /*GILLT_v16s16*//*Label 5262*/ GIMT_Encode4(228823),
     /* 227001 */ /*GILLT_v16s32*//*Label 5263*/ GIMT_Encode4(228912), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 227013 */ /*GILLT_v32s16*//*Label 5264*/ GIMT_Encode4(229001),
     /* 227017 */ // Label 5252: @227017
     /* 227017 */ GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(227137),
     /* 227022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 227025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227029 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(227098), // Rule ID 21419 //
     /* 227034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 227037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227065 */     // (strict_fsqrt:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSHZm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 227065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 227068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZm),
     /* 227082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227087 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227096 */     GIR_RootConstrainSelectedInstOperands,
     /* 227097 */     // GIR_Coverage, 21419,
     /* 227097 */     GIR_EraseRootFromParent_Done,
     /* 227098 */   // Label 5267: @227098
     /* 227098 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(227136), // Rule ID 21417 //
     /* 227103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227110 */     // (strict_fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 227110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 227113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 227127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 227134 */     GIR_RootConstrainSelectedInstOperands,
     /* 227135 */     // GIR_Coverage, 21417,
     /* 227135 */     GIR_EraseRootFromParent_Done,
     /* 227136 */   // Label 5268: @227136
     /* 227136 */   GIM_Reject,
     /* 227137 */ // Label 5266: @227137
     /* 227137 */ GIM_Reject,
     /* 227138 */ // Label 5253: @227138
     /* 227138 */ GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(227493),
     /* 227143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 227146 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(227202), // Rule ID 2447 //
     /* 227151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE1),
     /* 227154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227186 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSSm:{ *:[f32] } addr:{ *:[iPTR] }:$src1)
     /* 227186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSSm),
     /* 227189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227191 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 227195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227200 */     GIR_RootConstrainSelectedInstOperands,
     /* 227201 */     // GIR_Coverage, 2447,
     /* 227201 */     GIR_EraseRootFromParent_Done,
     /* 227202 */   // Label 5270: @227202
     /* 227202 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(227275), // Rule ID 18275 //
     /* 227207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 227210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227222 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227242 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 227242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSm),
     /* 227259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227273 */     GIR_RootConstrainSelectedInstOperands,
     /* 227274 */     // GIR_Coverage, 18275,
     /* 227274 */     GIR_EraseRootFromParent_Done,
     /* 227275 */   // Label 5271: @227275
     /* 227275 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(227348), // Rule ID 21423 //
     /* 227280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 227283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227315 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSZm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 227315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZm),
     /* 227332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227337 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227346 */     GIR_RootConstrainSelectedInstOperands,
     /* 227347 */     // GIR_Coverage, 21423,
     /* 227347 */     GIR_EraseRootFromParent_Done,
     /* 227348 */   // Label 5272: @227348
     /* 227348 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(227381), // Rule ID 1047 //
     /* 227353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 227356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 227360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 227364 */     // (strict_fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 227364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 227369 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 227375 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 227379 */     GIR_RootConstrainSelectedInstOperands,
     /* 227380 */     // GIR_Coverage, 1047,
     /* 227380 */     GIR_Done,
     /* 227381 */   // Label 5273: @227381
     /* 227381 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(227408), // Rule ID 2445 //
     /* 227386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 227389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227397 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 227397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 227402 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227406 */     GIR_RootConstrainSelectedInstOperands,
     /* 227407 */     // GIR_Coverage, 2445,
     /* 227407 */     GIR_Done,
     /* 227408 */   // Label 5274: @227408
     /* 227408 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(227450), // Rule ID 18273 //
     /* 227413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 227416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227424 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 227424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 227441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227446 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 227448 */     GIR_RootConstrainSelectedInstOperands,
     /* 227449 */     // GIR_Coverage, 18273,
     /* 227449 */     GIR_EraseRootFromParent_Done,
     /* 227450 */   // Label 5275: @227450
     /* 227450 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(227492), // Rule ID 21421 //
     /* 227455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227466 */     // (strict_fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 227466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 227483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 227490 */     GIR_RootConstrainSelectedInstOperands,
     /* 227491 */     // GIR_Coverage, 21421,
     /* 227491 */     GIR_EraseRootFromParent_Done,
     /* 227492 */   // Label 5276: @227492
     /* 227492 */   GIM_Reject,
     /* 227493 */ // Label 5269: @227493
     /* 227493 */ GIM_Reject,
     /* 227494 */ // Label 5254: @227494
     /* 227494 */ GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(227849),
     /* 227499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 227502 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(227558), // Rule ID 2463 //
     /* 227507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 227510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227529 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227542 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSDm:{ *:[f64] } addr:{ *:[iPTR] }:$src1)
     /* 227542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSDm),
     /* 227545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 227551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227556 */     GIR_RootConstrainSelectedInstOperands,
     /* 227557 */     // GIR_Coverage, 2463,
     /* 227557 */     GIR_EraseRootFromParent_Done,
     /* 227558 */   // Label 5278: @227558
     /* 227558 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(227631), // Rule ID 18279 //
     /* 227563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 227566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227578 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227585 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227598 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 227598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 227601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDm),
     /* 227615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227620 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227629 */     GIR_RootConstrainSelectedInstOperands,
     /* 227630 */     // GIR_Coverage, 18279,
     /* 227630 */     GIR_EraseRootFromParent_Done,
     /* 227631 */   // Label 5279: @227631
     /* 227631 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(227704), // Rule ID 21427 //
     /* 227636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 227639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 227643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227651 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227654 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227658 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227671 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDZm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 227671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 227674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZm),
     /* 227688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227693 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227702 */     GIR_RootConstrainSelectedInstOperands,
     /* 227703 */     // GIR_Coverage, 21427,
     /* 227703 */     GIR_EraseRootFromParent_Done,
     /* 227704 */   // Label 5280: @227704
     /* 227704 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(227737), // Rule ID 1049 //
     /* 227709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 227712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 227716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 227720 */     // (strict_fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 227720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 227725 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 227731 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 227735 */     GIR_RootConstrainSelectedInstOperands,
     /* 227736 */     // GIR_Coverage, 1049,
     /* 227736 */     GIR_Done,
     /* 227737 */   // Label 5281: @227737
     /* 227737 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(227764), // Rule ID 2461 //
     /* 227742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 227745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227753 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 227753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 227758 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227762 */     GIR_RootConstrainSelectedInstOperands,
     /* 227763 */     // GIR_Coverage, 2461,
     /* 227763 */     GIR_Done,
     /* 227764 */   // Label 5282: @227764
     /* 227764 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(227806), // Rule ID 18277 //
     /* 227769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 227772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227780 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 227780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 227783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 227797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227802 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 227804 */     GIR_RootConstrainSelectedInstOperands,
     /* 227805 */     // GIR_Coverage, 18277,
     /* 227805 */     GIR_EraseRootFromParent_Done,
     /* 227806 */   // Label 5283: @227806
     /* 227806 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(227848), // Rule ID 21425 //
     /* 227811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 227818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 227822 */     // (strict_fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 227822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 227825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 227839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227844 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 227846 */     GIR_RootConstrainSelectedInstOperands,
     /* 227847 */     // GIR_Coverage, 21425,
     /* 227847 */     GIR_EraseRootFromParent_Done,
     /* 227848 */   // Label 5284: @227848
     /* 227848 */   GIM_Reject,
     /* 227849 */ // Label 5277: @227849
     /* 227849 */ GIM_Reject,
     /* 227850 */ // Label 5255: @227850
     /* 227850 */ GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(227886), // Rule ID 1051 //
     /* 227855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 227858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 227861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 227865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 227869 */   // (strict_fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 227869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 227874 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 227880 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 227884 */   GIR_RootConstrainSelectedInstOperands,
     /* 227885 */   // GIR_Coverage, 1051,
     /* 227885 */   GIR_Done,
     /* 227886 */ // Label 5285: @227886
     /* 227886 */ GIM_Reject,
     /* 227887 */ // Label 5256: @227887
     /* 227887 */ GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(228089),
     /* 227892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 227895 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(227951), // Rule ID 2467 //
     /* 227900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 227903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 227907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227915 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227918 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227922 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227935 */     // (strict_fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 227935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDm),
     /* 227938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227949 */     GIR_RootConstrainSelectedInstOperands,
     /* 227950 */     // GIR_Coverage, 2467,
     /* 227950 */     GIR_EraseRootFromParent_Done,
     /* 227951 */   // Label 5287: @227951
     /* 227951 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(228007), // Rule ID 12085 //
     /* 227956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 227959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 227963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227971 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227974 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227978 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227991 */     // (strict_fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ128m:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 227991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128m),
     /* 227994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227996 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228005 */     GIR_RootConstrainSelectedInstOperands,
     /* 228006 */     // GIR_Coverage, 12085,
     /* 228006 */     GIR_EraseRootFromParent_Done,
     /* 228007 */   // Label 5288: @228007
     /* 228007 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(228034), // Rule ID 2465 //
     /* 228012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228023 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 228023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 228028 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228032 */     GIR_RootConstrainSelectedInstOperands,
     /* 228033 */     // GIR_Coverage, 2465,
     /* 228033 */     GIR_Done,
     /* 228034 */   // Label 5289: @228034
     /* 228034 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(228061), // Rule ID 2473 //
     /* 228039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 228042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228050 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 228050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 228055 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228059 */     GIR_RootConstrainSelectedInstOperands,
     /* 228060 */     // GIR_Coverage, 2473,
     /* 228060 */     GIR_Done,
     /* 228061 */   // Label 5290: @228061
     /* 228061 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(228088), // Rule ID 12081 //
     /* 228066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228077 */     // (strict_fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 228077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 228082 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228086 */     GIR_RootConstrainSelectedInstOperands,
     /* 228087 */     // GIR_Coverage, 12081,
     /* 228087 */     GIR_Done,
     /* 228088 */   // Label 5291: @228088
     /* 228088 */   GIM_Reject,
     /* 228089 */ // Label 5286: @228089
     /* 228089 */ GIM_Reject,
     /* 228090 */ // Label 5257: @228090
     /* 228090 */ GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(228292),
     /* 228095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 228098 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(228154), // Rule ID 2451 //
     /* 228103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228118 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228121 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228125 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228138 */     // (strict_fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 228138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSm),
     /* 228141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228143 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228152 */     GIR_RootConstrainSelectedInstOperands,
     /* 228153 */     // GIR_Coverage, 2451,
     /* 228153 */     GIR_EraseRootFromParent_Done,
     /* 228154 */   // Label 5293: @228154
     /* 228154 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(228210), // Rule ID 12061 //
     /* 228159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228194 */     // (strict_fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ128m:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 228194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128m),
     /* 228197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228208 */     GIR_RootConstrainSelectedInstOperands,
     /* 228209 */     // GIR_Coverage, 12061,
     /* 228209 */     GIR_EraseRootFromParent_Done,
     /* 228210 */   // Label 5294: @228210
     /* 228210 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(228237), // Rule ID 2449 //
     /* 228215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228226 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 228226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 228231 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228235 */     GIR_RootConstrainSelectedInstOperands,
     /* 228236 */     // GIR_Coverage, 2449,
     /* 228236 */     GIR_Done,
     /* 228237 */   // Label 5295: @228237
     /* 228237 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(228264), // Rule ID 2457 //
     /* 228242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 228245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 228253 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 228253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 228258 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228262 */     GIR_RootConstrainSelectedInstOperands,
     /* 228263 */     // GIR_Coverage, 2457,
     /* 228263 */     GIR_Done,
     /* 228264 */   // Label 5296: @228264
     /* 228264 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(228291), // Rule ID 12057 //
     /* 228269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228280 */     // (strict_fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 228280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 228285 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228289 */     GIR_RootConstrainSelectedInstOperands,
     /* 228290 */     // GIR_Coverage, 12057,
     /* 228290 */     GIR_Done,
     /* 228291 */   // Label 5297: @228291
     /* 228291 */   GIM_Reject,
     /* 228292 */ // Label 5292: @228292
     /* 228292 */ GIM_Reject,
     /* 228293 */ // Label 5258: @228293
     /* 228293 */ GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(228468),
     /* 228298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 228301 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(228357), // Rule ID 2471 //
     /* 228306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228321 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228324 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228328 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228341 */     // (strict_fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDYm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 228341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYm),
     /* 228344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228355 */     GIR_RootConstrainSelectedInstOperands,
     /* 228356 */     // GIR_Coverage, 2471,
     /* 228356 */     GIR_EraseRootFromParent_Done,
     /* 228357 */   // Label 5299: @228357
     /* 228357 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(228413), // Rule ID 12097 //
     /* 228362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228377 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228397 */     // (strict_fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ256m:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 228397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256m),
     /* 228400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228411 */     GIR_RootConstrainSelectedInstOperands,
     /* 228412 */     // GIR_Coverage, 12097,
     /* 228412 */     GIR_EraseRootFromParent_Done,
     /* 228413 */   // Label 5300: @228413
     /* 228413 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(228440), // Rule ID 2469 //
     /* 228418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228429 */     // (strict_fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 228429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 228434 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228438 */     GIR_RootConstrainSelectedInstOperands,
     /* 228439 */     // GIR_Coverage, 2469,
     /* 228439 */     GIR_Done,
     /* 228440 */   // Label 5301: @228440
     /* 228440 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(228467), // Rule ID 12093 //
     /* 228445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228456 */     // (strict_fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 228456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 228461 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228465 */     GIR_RootConstrainSelectedInstOperands,
     /* 228466 */     // GIR_Coverage, 12093,
     /* 228466 */     GIR_Done,
     /* 228467 */   // Label 5302: @228467
     /* 228467 */   GIM_Reject,
     /* 228468 */ // Label 5298: @228468
     /* 228468 */ GIM_Reject,
     /* 228469 */ // Label 5259: @228469
     /* 228469 */ GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(228557),
     /* 228474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 228477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228481 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(228533), // Rule ID 12013 //
     /* 228486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 228489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228497 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228500 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228504 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228517 */     // (strict_fsqrt:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ128m:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 228517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128m),
     /* 228520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228522 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228531 */     GIR_RootConstrainSelectedInstOperands,
     /* 228532 */     // GIR_Coverage, 12013,
     /* 228532 */     GIR_EraseRootFromParent_Done,
     /* 228533 */   // Label 5304: @228533
     /* 228533 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(228556), // Rule ID 12009 //
     /* 228538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 228541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 228545 */     // (strict_fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 228545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 228550 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228554 */     GIR_RootConstrainSelectedInstOperands,
     /* 228555 */     // GIR_Coverage, 12009,
     /* 228555 */     GIR_Done,
     /* 228556 */   // Label 5305: @228556
     /* 228556 */   GIM_Reject,
     /* 228557 */ // Label 5303: @228557
     /* 228557 */ GIM_Reject,
     /* 228558 */ // Label 5260: @228558
     /* 228558 */ GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(228733),
     /* 228563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 228566 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(228622), // Rule ID 2455 //
     /* 228571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228586 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228606 */     // (strict_fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSYm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 228606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYm),
     /* 228609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228620 */     GIR_RootConstrainSelectedInstOperands,
     /* 228621 */     // GIR_Coverage, 2455,
     /* 228621 */     GIR_EraseRootFromParent_Done,
     /* 228622 */   // Label 5307: @228622
     /* 228622 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(228678), // Rule ID 12073 //
     /* 228627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228662 */     // (strict_fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ256m:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 228662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256m),
     /* 228665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228667 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228676 */     GIR_RootConstrainSelectedInstOperands,
     /* 228677 */     // GIR_Coverage, 12073,
     /* 228677 */     GIR_EraseRootFromParent_Done,
     /* 228678 */   // Label 5308: @228678
     /* 228678 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(228705), // Rule ID 2453 //
     /* 228683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228694 */     // (strict_fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 228694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 228699 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228703 */     GIR_RootConstrainSelectedInstOperands,
     /* 228704 */     // GIR_Coverage, 2453,
     /* 228704 */     GIR_Done,
     /* 228705 */   // Label 5309: @228705
     /* 228705 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(228732), // Rule ID 12069 //
     /* 228710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228721 */     // (strict_fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 228721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 228726 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228730 */     GIR_RootConstrainSelectedInstOperands,
     /* 228731 */     // GIR_Coverage, 12069,
     /* 228731 */     GIR_Done,
     /* 228732 */   // Label 5310: @228732
     /* 228732 */   GIM_Reject,
     /* 228733 */ // Label 5306: @228733
     /* 228733 */ GIM_Reject,
     /* 228734 */ // Label 5261: @228734
     /* 228734 */ GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(228822),
     /* 228739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 228742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228746 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(228798), // Rule ID 12049 //
     /* 228751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228762 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228765 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228769 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228782 */     // (strict_fsqrt:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 228782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZm),
     /* 228785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228787 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228796 */     GIR_RootConstrainSelectedInstOperands,
     /* 228797 */     // GIR_Coverage, 12049,
     /* 228797 */     GIR_EraseRootFromParent_Done,
     /* 228798 */   // Label 5312: @228798
     /* 228798 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(228821), // Rule ID 12045 //
     /* 228803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228810 */     // (strict_fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 228810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 228815 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228819 */     GIR_RootConstrainSelectedInstOperands,
     /* 228820 */     // GIR_Coverage, 12045,
     /* 228820 */     GIR_Done,
     /* 228821 */   // Label 5313: @228821
     /* 228821 */   GIM_Reject,
     /* 228822 */ // Label 5311: @228822
     /* 228822 */ GIM_Reject,
     /* 228823 */ // Label 5262: @228823
     /* 228823 */ GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(228911),
     /* 228828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 228831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228835 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(228887), // Rule ID 12025 //
     /* 228840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 228843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228858 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228871 */     // (strict_fsqrt:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ256m:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 228871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256m),
     /* 228874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228885 */     GIR_RootConstrainSelectedInstOperands,
     /* 228886 */     // GIR_Coverage, 12025,
     /* 228886 */     GIR_EraseRootFromParent_Done,
     /* 228887 */   // Label 5315: @228887
     /* 228887 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(228910), // Rule ID 12021 //
     /* 228892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 228895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228899 */     // (strict_fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 228899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 228904 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228908 */     GIR_RootConstrainSelectedInstOperands,
     /* 228909 */     // GIR_Coverage, 12021,
     /* 228909 */     GIR_Done,
     /* 228910 */   // Label 5316: @228910
     /* 228910 */   GIM_Reject,
     /* 228911 */ // Label 5314: @228911
     /* 228911 */ GIM_Reject,
     /* 228912 */ // Label 5263: @228912
     /* 228912 */ GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(229000),
     /* 228917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 228920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228924 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(228976), // Rule ID 12037 //
     /* 228929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228940 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228947 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228960 */     // (strict_fsqrt:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 228960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZm),
     /* 228963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228974 */     GIR_RootConstrainSelectedInstOperands,
     /* 228975 */     // GIR_Coverage, 12037,
     /* 228975 */     GIR_EraseRootFromParent_Done,
     /* 228976 */   // Label 5318: @228976
     /* 228976 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(228999), // Rule ID 12033 //
     /* 228981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228988 */     // (strict_fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 228988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 228993 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228997 */     GIR_RootConstrainSelectedInstOperands,
     /* 228998 */     // GIR_Coverage, 12033,
     /* 228998 */     GIR_Done,
     /* 228999 */   // Label 5319: @228999
     /* 228999 */   GIM_Reject,
     /* 229000 */ // Label 5317: @229000
     /* 229000 */ GIM_Reject,
     /* 229001 */ // Label 5264: @229001
     /* 229001 */ GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(229089),
     /* 229006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 229009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 229013 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(229065), // Rule ID 12001 //
     /* 229018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 229021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229029 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229032 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229036 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229049 */     // (strict_fsqrt:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 229049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZm),
     /* 229052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 229058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229063 */     GIR_RootConstrainSelectedInstOperands,
     /* 229064 */     // GIR_Coverage, 12001,
     /* 229064 */     GIR_EraseRootFromParent_Done,
     /* 229065 */   // Label 5321: @229065
     /* 229065 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(229088), // Rule ID 11997 //
     /* 229070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 229073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 229077 */     // (strict_fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 229077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 229082 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 229086 */     GIR_RootConstrainSelectedInstOperands,
     /* 229087 */     // GIR_Coverage, 11997,
     /* 229087 */     GIR_Done,
     /* 229088 */   // Label 5322: @229088
     /* 229088 */   GIM_Reject,
     /* 229089 */ // Label 5320: @229089
     /* 229089 */ GIM_Reject,
     /* 229090 */ // Label 5265: @229090
     /* 229090 */ GIM_Reject,
     /* 229091 */ // Label 74: @229091
     /* 229091 */ GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(229103), // Rule ID 17073 //
     /* 229096 */   // (trap)  =>  (TRAP)
     /* 229096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TRAP),
     /* 229101 */   GIR_RootConstrainSelectedInstOperands,
     /* 229102 */   // GIR_Coverage, 17073,
     /* 229102 */   GIR_Done,
     /* 229103 */ // Label 5323: @229103
     /* 229103 */ GIM_Reject,
     /* 229104 */ // Label 75: @229104
     /* 229104 */ GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(229119), // Rule ID 22376 //
     /* 229109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotPS),
     /* 229112 */   // (debugtrap)  =>  (INT3)
     /* 229112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 229117 */   GIR_RootConstrainSelectedInstOperands,
     /* 229118 */   // GIR_Coverage, 22376,
     /* 229118 */   GIR_Done,
     /* 229119 */ // Label 5324: @229119
     /* 229119 */ GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(229139), // Rule ID 22377 //
     /* 229124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsPS),
     /* 229127 */   // (debugtrap)  =>  (INT 65:{ *:[i8] })
     /* 229127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 229130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/65,
     /* 229133 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229137 */   GIR_RootConstrainSelectedInstOperands,
     /* 229138 */   // GIR_Coverage, 22377,
     /* 229138 */   GIR_EraseRootFromParent_Done,
     /* 229139 */ // Label 5325: @229139
     /* 229139 */ GIM_Reject,
     /* 229140 */ // Label 76: @229140
     /* 229140 */ GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(229155), // Rule ID 17075 //
     /* 229145 */   // MIs[0] kind
     /* 229145 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 229148 */   // (ubsantrap (timm:{ *:[i32] }):$kind)  =>  (UBSAN_UD1 (timm:{ *:[i32] }):$kind)
     /* 229148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::UBSAN_UD1),
     /* 229153 */   GIR_RootConstrainSelectedInstOperands,
     /* 229154 */   // GIR_Coverage, 17075,
     /* 229154 */   GIR_Done,
     /* 229155 */ // Label 5326: @229155
     /* 229155 */ GIM_Reject,
     /* 229156 */ // Label 77: @229156
     /* 229156 */ GIM_Reject,
     /* 229157 */ }; // Size: 229157 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
